let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
const {
  prefix
} = settings;

/**
 * Callout.
 *
 * @mixin c4d-callout
 */
const C4DCalloutMixin = base => {
  class CalloutMixin extends base {
    render() {
      return html(_t || (_t = _`
        <div class="${0}--callout__column">
          <div class="${0}--callout__content">
            ${0}
          </div>
        </div>
      `), prefix, prefix,
      /* Declaring this mixin as it extends \`LitElement\` seems to cause a TS error
      // @ts-ignore */
      super.render());
    }
  }
  return CalloutMixin;
};
export default C4DCalloutMixin;
//# sourceMappingURL=callout.js.map
