/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Expressive button.
 *
 * @element c4d-button-expressive
 * @csspart button - The button. Usage `c4d-button-expressive::part(button)`
 * @csspart hidden-paragraph - The hidden paragraph that contains the link. Usage `c4d-button-expressive::part(hidden-paragraph)`
 * @csspart hidden-span - The span inside of the hidden paragraph. Usage `c4d-button-expressive::part(hidden-span)`
 */
declare class C4DButtonExpressive extends Component<ComponentProps> {}
export default C4DButtonExpressive;
