/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired when there is a user gesture to run the action.
   */
  onRequestAdditionalVideoData?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Button.
 *
 * @element c4d-button
 * @csspart button - The button. Usage: `c4d-button::part(button)`
 * @csspart hidden-paragraph - The hidden paragraph that contains the link. Usage: `c4d-button::part(hidden-paragraph)`
 * @csspart hidden-icon-span - The span element inside the hidden paragraph. Usage: `c4d-button::part(hidden-icon-span)`
 * @csspart visually-hidden-span - The visually hidden span element for accessibility. Usage: `c4d-button::part(visually-hidden-span)`
 */
declare class C4DButton extends Component<ComponentProps> {}
export default C4DButton;
