/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Callout Quote.
 *
 * @element c4d-callout-quote
 * @csspart  column - The colunm housing the callout content. Usage: 'c4d-callout-quote::part(column)'
 * @csspart  content - The quote content. Usage: 'c4d-callout-quote::part(content)'
 * @csspart  container - The quote container . Usage: 'c4d-callout-quote::part(container)'
 * @csspart  wrapper - The quote wrapper. Usage: 'c4d-callout-quote::part(wrapper)'
 */
declare class C4DCalloutQuote extends Component<ComponentProps> {}
export default C4DCalloutQuote;
