/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Card section offset.
 *
 * @element c4d-card-section-offset
 * @slot heading - The heading content.
 * @slot action - The text-cta content.
 * @slot card-group - The L shaped card group content.
 * @csspart content - The text cta content. Usage: `c4d-card-section-offset::part(content)`
 */
declare class C4DCardSectionOffset extends Component<ComponentProps> {}
export default C4DCardSectionOffset;
