/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired when the video title is updated
   */
  onVideoTitleUpdated?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Carousel.
 *
 * @element c4d-carousel
 * @csspart prev-button - The button to go to the previous page. Usage: `c4d-carousel::part(prev-button)`
 * @csspart next-button - The button to go to the next page. Usage: `c4d-carousel::part(next-button)`
 * @csspart region - The component container. Usage: `c4d-carousel::part(region)`
 * @csspart title - The title. Usage `c4d-carousel::part(title)`
 * @csspart scroll-container - Container for the scrolling elements. Usage: `c4d-carousel::part(scroll-container)`
 * @csspart contents - The scrolling elements. Usage: `c4d-carousel::part(contents)`
 * @csspart navigation - The navigation controls. Usage: `c4d-carousel::part(navigation)`
 * @csspart status - The navigation status. Usage: `c4d-carousel::part(status)`
 * @csspart visually-hidden - The span element used to hide content from view and keep it accessible for assistive technologies. Usage: `c4d-button::part(visually-hidden)`
 */
declare class C4DCarousel extends Component<ComponentProps> {}
export default C4DCarousel;
