/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/* TODO: Figure out how to define a mixin type supporting abstract class*/
/**
 * Content block.
 *
 * @element c4d-content-block
 * @slot heading - The heading content.
 * @slot copy - The copy content.
 * @slot media - The media content.
 * @slot footer - The footer (CTA) content.
 * @slot complementary - The complementary (aside) content.
 * @csspart body - The body. Usage: `c4d-content-block::part(body)`
 * @csspart footer - The footer. Usage: `c4d-content-block::part(footer)`
 * @csspart content-layout - The content wrapper. Usage: `c4d-content-block::part(content-layout)`
 * @abstract
 */
declare class C4DContentBlock extends Component<ComponentProps> {}
export default C4DContentBlock;
