/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * A component to present content in a row orientation with featured
 * media beneath.
 *
 * @element c4d-content-item-row-media-featured
 * @csspart row--eyebrow - The eyebrow. Usage: `c4d-contenr-item-row-media-featured::part(row--eyebrow)`
 * @csspart col--body - The body. Usage: `c4d-contenr-item-row-media-featured::part(col--body)`
 * @csspart row--media - The media. Usage: `c4d-contenr-item-row-media-featured::part(row--media)`
 */
declare class C4DContentItemRowMediaFeatured
  extends Component<ComponentProps> {}
export default C4DContentItemRowMediaFeatured;
