/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * A component to present content in a row orientation with media.
 *
 * @element c4d-content-item-row-media
 * @csspart col--eyebrow - the column eyebrow. Usage. `c4d-content-item-row-media::part(col--eyebrow)`
 * @csspart col--media - thecontent column media. Usage. `c4d-content-item-row-media::part(col--media)`
 * @csspart row--media - the content row media. Usage. `c4d-content-item-row-media::part(row--media)`
 * @csspart
 */
declare class C4DContentItemRowMedia extends Component<ComponentProps> {}
export default C4DContentItemRowMedia;
