/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * A component to present a content in a row orientation.
 *
 * @element c4d-content-item-row
 * @csspart heading-wrapper - The heading wrapper. Usage:  `c4d-content-item-row::part(eading-wrapper)`
 * @csspart content-wrapper - The content wrapper. Usage:  `c4d-content-item-row::part(content-wrapper)`
 * @csspart body-wrapper - The body wrapper. Usage:  `c4d-content-item-row::part(body-wrapper)`
 * @csspart col - Selector for all columns. Usage:  `c4d-content-item-row::part(col)`
 */
declare class C4DContentItemRow extends Component<ComponentProps> {}
export default C4DContentItemRow;
