/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Content item.
 *
 * @element c4d-content-item
 * @slot media - The media content.
 * @slot heading - The heading content.
 * @slot footer - The footer (CTA) content.
 * @csspart statistics - The element. Usage: `c4d-content-item::part(statistics)`
 * @csspart media - The media content. Usage: `c4d-content-item::part(media)`
 * @csspart cta - The footer CTA. Usage: `c4d-content-item::part(cta)`
 * @csspart heading - The heading content. Usage: `c4d-content-item::part(heading)`
 * @csspart body - The body content. Usage: `c4d-content-item::part(body)`
 */
declare class C4DContentItem extends Component<ComponentProps> {}
export default C4DContentItem;
