/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * The Content Section component for use with cardSection
 *
 * @element c4d-content-section
 * @slot heading - Section heading
 * @csspart layout - The component wrapper. Usage: `c4d-content-section::part(layout)`
 * @csspart leading - The leading. Usage: `c4d-content-section::part(leading)`
 * @csspart body - The body. Usage: `c4d-content-section::part(body)`
 */
declare class C4DContentSection extends Component<ComponentProps> {}
export default C4DContentSection;
