/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * The CTA BLOCK pattern
 *
 * @element c4d-cta-block
 * @slot heading - The text heading.
 * @slot action - The CTA Buttons.
 * @csspart cta - The CTA Usage: `c4d-cta-block::part(cta)`
 * @csspart helper-wrapper - The help text wrapper. Usage: `c4d-cta-block::part(helper-wrapper)`
 * @csspart content-item-wrapper - The Content item wrapper Usage: `c4d-cta-block::part(content-item-wrapper)`
 * @csspart body - The body Usage: `c4d-cta-block::part(body)`
 * @csspart copy - The copy. Usage: `c4d-cta-block::part(copy)`
 * @csspart link-list - The Link list. Usage: `c4d-cta-block::part(link-list)`
 */
declare class C4DCTABlock extends Component<ComponentProps> {}
export default C4DCTABlock;
