/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired when the video title is updated
   */
  onVideoTitleUpdated?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Card CTA.
 *
 * @element c4d-card-cta
 * @csspart heading - The heading content. Usage: `c4d-card-cta::part(heading)`
 */
declare class C4DCardCTA extends Component<ComponentProps> {}
export default C4DCardCTA;
