/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { CTA_TYPE } from '././defs.js';
import { descriptor as parentDescriptor } from '../card/card.js';
import { propTypes as parentPropTypes } from '../card/card.js';
export { default as CustomElement } from '../../components/cta/card-cta.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onVideoTitleUpdated: {
    event: ''.concat(c4dPrefix, '-card-cta-video-title-updated'),
  },
});
export var propTypes = {
  /**
   * The name of the custom event fired when the video title is updated
   */
  onVideoTitleUpdated: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-card-cta'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
