/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired when there is a user gesture to run the action.
   */
  onRequestAdditionalVideoData?: (event: CustomEvent) => void;
  /**
   * The event handler for the custom event fired when there is a user gesture to run the action.
   */
  onUpdateButtonGroup?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * CTA component
 *
 * @element c4d-cta
 * @csspart cta - Targets all styles. Usage: `c4d-cta::part(cta)`
 * @csspart cta--feature - Tagets the Feature style. Usage: `c4d-cta::part(cta--feature)`
 * @csspart cta--card - Tagets the Card style. Usage: `c4d-cta::part(cta--card)`
 * @csspart cta--card-link - Tagets the Card-link style. Usage: `c4d-cta::part(cta--card-link)`
 * @csspart cta--text - Tagets the Text style. Usage: `c4d-cta::part(cta--text)`
 * @csspart cta--button - Tagets the buttton style. Usage: `c4d-cta::part(cta--button)`
 */
declare class C4DCTAHead extends Component<ComponentProps> {}
export default C4DCTAHead;
