/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired after the lightbox is closed upon a user gesture.
   */
  onCloseLightbox?: (event: CustomEvent) => void;
  /**
   * The event handler for the custom event fired when there is a user gesture to run the action.
   */
  onRequestVideoData?: (event: CustomEvent) => void;
  /**
   * The event handler for the custom event fired when there is a user gesture to run the action.
   */
  onRunAction?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Component that handles video CTAs in app.
 *
 * @element c4d-video-cta-composite
 */
declare class C4DVideoCTAComposite extends Component<ComponentProps> {}
export default C4DVideoCTAComposite;
