/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { default as CustomElement } from '../../components/cta/video-cta-composite.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = {
  onCloseLightbox: {
    event: ''.concat(c4dPrefix, '-expressive-modal-closed'),
  },
  onRequestVideoData: {
    event: ''.concat(c4dPrefix, '-cta-request-video-data'),
  },
  onRunAction: {
    event: ''.concat(c4dPrefix, '-cta-run-action'),
  },
};
export var propTypes = {
  /**
   * The name of the custom event fired after the lightbox is closed upon a user gesture.
   */
  onCloseLightbox: PropTypes.func,
  /**
   * The name of the custom event fired when there is a user gesture to run the action.
   */
  onRequestVideoData: PropTypes.func,
  /**
   * The name of the custom event fired when there is a user gesture to run the action.
   */
  onRunAction: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-video-cta-composite'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
