/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { default as CustomElement } from '../../components/expressive-modal/expressive-modal.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = {
  onBeforeClose: {
    event: ''.concat(c4dPrefix, '-expressive-modal-beingclosed'),
  },
  onClose: {
    event: ''.concat(c4dPrefix, '-expressive-modal-closed'),
  },
};
export var propTypes = {
  /**
   * The name of the custom event fired before this modal is being closed upon a user gesture.
   * Cancellation of this event stops the user-initiated action of closing this modal.
   */
  onBeforeClose: PropTypes.func,
  /**
   * The name of the custom event fired after this modal is closed upon a user gesture.
   */
  onClose: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-expressive-modal'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
