/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Feature Section.
 *
 * @element c4d-feature-section
 * @csspart grid - All grid itens. Usage: `c4d-feature-section::part(grid)`
 * @csspart grid--wrapper - The grid Wrapper. Usage: `c4d-feature-section::part(grid--wrapper)`
 * @csspart grid--body - Thw grid body. Usage: `c4d-feature-section::part(grid--body)`
 * @csspart row - All row items. Usage: `c4d-feature-section::part(row)`
 * @csspart row--container -  The row container. Usage: `c4d-feature-section::part(row--container)`
 * @csspart row--body -  The row body. Usage: `c4d-feature-section::part(row--body)`
 * @csspart col -  All column itens. Usage: `c4d-feature-section::part(col)`
 * @csspart col--body-wrapper - The column wrapper. Usage: `c4d-feature-section::part(col--body-wrapper)`
 * @csspart col--body -  The column body. Usage: `c4d-feature-section::part(col--body)`
 * @csspart col--image - The column image. Usage: `c4d-feature-section::part(col--image)`
 */
declare class C4DFeatureSection extends Component<ComponentProps> {}
export default C4DFeatureSection;
