/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { descriptor as parentDescriptor } from '@carbon/web-components/es/components-react/accordion/accordion-item.js';
import { propTypes as parentPropTypes } from '@carbon/web-components/es/components-react/accordion/accordion-item.js';
export { default as CustomElement } from '../../components/filter-panel/filter-group-item.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onViewAll: {
    event: ''.concat(c4dPrefix, '-filter-group-view-all-toggle'),
  },
});
export var propTypes = {
  /**
   * The name of the event that fires when the view all button is toggled.
   */
  onViewAll: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-filter-group-item'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
