/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The name of the event that fires upon checkbox is selected
   */
  onChange?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Filter Panel Checkbox
 *
 * @element c4d-filter-panel-checkbox
 * @fires c4d-checkbox-select - The custom event fired after this changebox changes its checked state.
 */
declare class C4DFilterPanelCheckbox extends Component<ComponentProps> {}
export default C4DFilterPanelCheckbox;
