/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { descriptor as parentDescriptor } from '@carbon/web-components/es/components-react/checkbox/checkbox.js';
import { propTypes as parentPropTypes } from '@carbon/web-components/es/components-react/checkbox/checkbox.js';
export { default as CustomElement } from '../../components/filter-panel/filter-panel-checkbox.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onChange: {
    event: ''.concat(c4dPrefix, '-checkbox-select'),
  },
});
export var propTypes = {
  /**
   * The name of the event that fires upon checkbox is selected
   */
  onChange: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-filter-panel-checkbox'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
