/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired upon selecting the title
   */
  onInputSelect?: (event: CustomEvent) => void;
  /**
   * The event handler for the custom event fired after the search content is changed upon a user gesture.
   */
  onContentStateChange?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * The container of the input select.
 *
 * @element c4d-filter-panel-input-select
 */
declare class C4DFilterPanelInputSelect extends Component<ComponentProps> {}
export default C4DFilterPanelInputSelect;
