/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { default as CustomElement } from '../../components/filter-panel/filter-panel-input-select.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = {
  onInputSelect: {
    event: ''.concat(c4dPrefix, '-filter-panel-input-select-title'),
  },
  onContentStateChange: {
    event: ''.concat(c4dPrefix, '-filter-panel-input-select'),
  },
};
export var propTypes = {
  /**
   * The name of the custom event fired upon selecting the title
   */
  onInputSelect: PropTypes.func,
  /**
   * The name of the custom event fired after the search content is changed upon a user gesture.
   */
  onContentStateChange: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-filter-panel-input-select'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
