/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { descriptor as parentDescriptor } from '../expressive-modal/expressive-modal.js';
import { propTypes as parentPropTypes } from '../expressive-modal/expressive-modal.js';
export { default as CustomElement } from '../../components/filter-panel/filter-panel-modal.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onBeforeClose: {
    event: ''.concat(prefix, '-modal-beingclosed'),
  },
  onSelectionClear: {
    event: ''.concat(c4dPrefix, '-selection-clear'),
  },
});
export var propTypes = {
  /**
   * The name of the custom event fired upon the modal being closed
   */
  onBeforeClose: PropTypes.func,
  /**
   * The name of the custom event captured upon cleared selections
   */
  onSelectionClear: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-filter-panel-modal'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
