/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired to clear selections
   */
  onSelectionClear?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * The filter panel.
 *
 * @element c4d-filter-panel
 * @csspart section - The filter panel section. Usage: `c4d-filter-panel::part(section)`
 * @csspart heading-clear - Contains the filter heading an the button. Usage: `c4d-filter-panel::part(heading-clear)`
 * @csspart filter-heading - The heading. Usage: `c4d-filter-panel::part(filter-heading)`
 * @csspart button-clear - The button. Usage: `c4d-filter-panel::part(button-clear)`
 * @csspart container - The button inner container. Usage: `c4d-filter-panel::part(container)`
 * @csspart icon - The button icon. Usage: `c4d-filter-panel::part(icon)`
 */
declare class C4DFilterPanel extends Component<ComponentProps> {}
export default C4DFilterPanel;
