/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { default as CustomElement } from '../../components/footer/footer-composite.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = {
  onCloseModal: {
    event: ''.concat(c4dPrefix, '-expressive-modal-closed'),
  },
};
export var propTypes = {
  /**
   * The name of the custom event fired after this modal is closed upon a user gesture.
   */
  onCloseModal: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-footer-composite'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
