/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Global banner
 *
 * @element c4d-global-banner
 * @csspart container - Targets all container elements. Usage: `c4d-global-banner::part(container)`
 * @csspart container--static - Container for Static type. Usage: `c4d-global-banner::part(container--static)`
 * @csspart container--link - Container for Link type. Usage: `c4d-global-banner::part(container--link)`
 * @csspart content - The content. Usage: `c4d-global-banner::part(content)`
 * @csspart image-container -  The image container. Usage: `c4d-global-banner::part(image-container)`
 * @csspart text-container - The text container. Usage: `c4d-global-banner::part(text-container)`
 * @csspart cta-container - The CTA container. Usage: `c4d-global-banner::part(cta-container)`
 * @csspart icon - The icon. Usage: `c4d-global-banner::part(icon)`
 */
declare class C4DGlobalBanner extends Component<ComponentProps> {}
export default C4DGlobalBanner;
