/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * LeadSpace Block Component.
 *
 * @element c4d-leadspace-block
 * @csspart content-layout - The outer wrapper. Usage: c4d-leadpsace-block::part(content-layout)
 * @csspart content-body - The inner wrapper. Usage: c4d-leadpsace-block::part(content-body)
 * @csspart hr - The horizontal rule. Usage: c4d-leadpsace-block::part(hr)
 */
declare class C4DLeadSpaceBlock extends Component<ComponentProps> {}
export default C4DLeadSpaceBlock;
