/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Leadspace with Search
 *
 * @element c4d-leadspace-with-search
 * @csspart content-layout - The content container. Usage: `c4d-leadspace-with-search::part(content-layout)`
 * @csspart content-layout-body - The content container body. Usage: `c4d-leadspace-with-search::part(content-layout-body)`
 * @csspart search-container - The search container. Usage: `c4d-leadspace-with-search::part(search-container)`
 * @csspart search-container-inner - The search container inner content. Usage: `c4d-leadspace-with-search::part(search-container-inner)`
 * @csspart sticky-header - The sticky header container. Usage: `c4d-leadspace-with-search::part(sticky-header)`
 */
declare class C4DLeadspaceWithSearch extends Component<ComponentProps> {}
export default C4DLeadspaceWithSearch;
