/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Component that renders leaving IBM modal component.
 *
 * @element c4d-leaving-ibm-composite
 * @csspart modal - The modal container. Usage `c4d-leaving-ibm-composite::part(modal)`
 * @csspart header - The header. Usage `c4d-leaving-ibm-composite::part(header)`
 * @csspart button - The close button.  Usage `c4d-leaving-ibm-composite::part(close-button)`
 * @csspart heading - The modal title. Usage `c4d-leaving-ibm-composite::part(heading)`
 * @csspart body - The modal body. Usage `c4d-leaving-ibm-composite::part(body)`
 * @csspart supplemental - The modal supplemental. Usage `c4d-leaving-ibm-composite::part(supplemental)`
 * @csspart footer - The modal footer. Usage `c4d-leaving-ibm-composite::part(footer)`
 */
declare class C4DLeavingIbmComposite extends Component<ComponentProps> {}
export default C4DLeavingIbmComposite;
