/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired after the modal is closed upon a user gesture.
   */
  onCloseModal?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Component that renders lightbox media viewer for video from its metadata, etc.
 *
 * @element c4d-lightbox-video-player-composite
 */
declare class C4DLightboxVideoPlayerComposite
  extends Component<ComponentProps> {}
export default C4DLightboxVideoPlayerComposite;
