/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Link list.
 *
 * @element c4d-link-list
 * @slot heading - The heading content.
 * @csspart grid - The outer wrapper. Usage `c4d-link-list-section::part(grid)`
 * @csspart row - The inner wrapper. Usage `c4d-link-list-section::part(row)`
 * @csspart heading - The heading's column container. Usage `c4d-link-list-section::part(heading)`
 * @csspart children - The link-list's column container. Usage `c4d-link-list-section::part(children)`
 */
declare class C4DLinkListSection extends Component<ComponentProps> {}
export default C4DLinkListSection;
