/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Link with icon.
 *
 * @element c4d-link-with-icon
 * @slot icon - The icon.
 * @slot icon-left - The CTA icon to place at the left.
 * @csspart span - The span element. Usage: `c4d-lightbox-video-player::part(span)`
 */
declare class C4DLinkWithIcon extends Component<ComponentProps> {}
export default C4DLinkWithIcon;
