/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Logo grid.
 *
 * @element c4d-logo-grid
 * @csspart content-wrapper - The wrapper. Usage: 'c4d-logo-grid::part(content-wrapper)'
 * @csspart content-body - The content body. Usage: 'c4d-logo-grid::part(content-body)'
 * @csspart content - The content. Usage 'c4d-logo-grid::part(content)'
 * @csspart footer-container - The footer container. Usage: 'c4d-logo-grid::part(footer-containe)'
 * @csspart footer - The footer. Usage: 'c4d-logo-grid::part(footer)'
 * @csspart hr - The horizontal rule. Usage: 'c4d-logo-grid::part(hr)'
 */
declare class C4DLogoGrid extends Component<ComponentProps> {}
export default C4DLogoGrid;
