/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Markdown content.
 *
 * @element c4d-markdown
 * @csspart link - The custom link element. Usage: `c4d-markdown::part(link)`
 * @csspart ordered-list - The ordered list element. Usage: `c4d-markdown::part(ordered-list)`
 * @csspart unordered-list - The unordered list element. Usage: `c4d-markdown::part(unordered-list)`
 * @csspart list - The list element. Usage: `c4d-markdown::part(list)`
 * @csspart list-item - The list item element. Usage: `c4d-markdown::part(list-item)`
 */
declare class C4DMarkdown extends Component<ComponentProps> {}
export default C4DMarkdown;
