/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Masthead.
 *
 * @element c4d-masthead
 * @csspart l0 - The Masthead L0. Usage: `c4d-masthead::part(l0)`
 * @csspart header - The header. Usage: `c4d-masthead::part(header)`
 * @csspart header-search - The header search. Usage: `c4d-masthead::part(header-search)`
 * @csspart header-nav-container - The header nav container. Usage: `c4d-masthead::part(header-nav-container)`
 * @slot brand - The left hand area.
 * @slot nav - The nav content.
 * @slot profile - The right hand area.
 */
declare class C4DMasthead extends Component<ComponentProps> {}
export default C4DMasthead;
