/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Pictogram item.
 *
 * @element c4d-pictogram-item
 * @slot pictogram - The pictogram content.
 * @slot heading - The heading content.
 * @slot footer - The footer (CTA) content.
 * @csspart item-row - An item row. Usage `c4d-pictogram-item: :part(item-row)`
 * @csspart wrapper - The wrapper. Usage `c4d-pictogram-item: :part(wrapper)`
 * @csspart pictogram - A pictogram. Usage `c4d-pictogram-item: :part(pictogram)`
 * @csspart content - The content. Usage `c4d-pictogram-item: :part(content)`
 * @csspart content-item - The content item. Usage `c4d-pictogram-item: :part(content-item)`
 */
declare class C4DPictogramItem extends Component<ComponentProps> {}
export default C4DPictogramItem;
