/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Quote.
 *
 * @element c4d-quote
 * @slot copy - The copy content.
 * @slot footer - The footer (CTA) content.
 * @slot source-heading - The heading content of the quote source.
 * @slot source-copy - The copy content of the quote source.
 * @slot source-bottom-copy - The copy content of the quote source placed at the bottom.
 * @csspart mark - Quote mark. Usage `c4d-quote::part(mark)`
 * @csspart mark--opening - Opening quote mark. Usage `c4d-quote::part(mark--opening)`
 * @csspart mark--closing - Closing quote mark. Usage `c4d-quote::part(mark--closing)`
 * @csspart copy - Quote body copy. Usage `c4d-quote::part(copy)`
 * @csspart source - Quote source slot. Usage `c4d-quote::part(source)`
 * @csspart footer - Quote footer. Usage `c4d-quote::part(footer)`
 * @csspart container - Quote container. Usage `c4d-quote::part(container)`
 * @csspart wrapper - Quote wrapper. Usage `c4d-quote::part(wrapper)`
 * @csspart hr - Horizontal rule. Usage `c4d-quote::part(wrapper)`
 * @csspart bubble-pointer-svg - The bubble quote variation pointer. Usage `c4d-quote::part(bubble-pointer-svg)`
 * @csspart bubble-pointer-fill-svg - The fill color of the pointer. Usage `c4d-quote::part(bubble-pointer-fill-svg)`
 * @csspart bubble-pointer-stroke-svg - The stroke color of the pointer. Usage `c4d-quote::part(bubble-pointer-stroke-svg)`
 */
declare class C4DQuote extends Component<ComponentProps> {}
export default C4DQuote;
