/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Scoped search dropdown - mobile version.
 * The dropdown to scope the search suggestions in mobile
 *
 * @element c4d-scoped-search-dropdown-mobile
 * @internal
 * @csspart select-option - An option in the select list. Usage `c4d-scoped-search-dropdown-mobile::part(select-option)`
 * @csspart select-optgroup - An optgroup in the select list. Usage `c4d-scoped-search-dropdown-mobile::part(select-optgroup)`
 * @csspart helper-text - The helper text. Usage `c4d-scoped-search-dropdown-mobile::part(helper-text)`
 * @csspart form-requirement - The message that appears on invalid input. Usage `c4d-scoped-search-dropdown-mobile::part(form-requirement)`
 * @csspart label-text - The label text. Usage `c4d-scoped-search-dropdown-mobile::part(label-text)`
 * @csspart select-input-wrapper - The select input wrapper. Usage `c4d-scoped-search-dropdown-mobile::part(select-input-wrapper)`
 * @csspart select-input - The input selector. Usage `c4d-scoped-search-dropdown-mobile::part(select-input)`
 */
declare class C4DScopedSearchDropdownMobile extends Component<ComponentProps> {}
export default C4DScopedSearchDropdownMobile;
