/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event captured to retrieve the new search scope.
   */
  onSelect?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * Dropdown component to change search scope.
 *
 * @element c4d-scoped-search-dropdown
 * @fires cds-select-selected - The custom event fired after the the dropdown value is changed upon a user gesture.
 */
declare class C4DScopedSearchDropdown extends Component<ComponentProps> {}
export default C4DScopedSearchDropdown;
