/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { DROPDOWN_TYPE } from '@carbon/web-components/es/components/dropdown/dropdown.js';
export { DROPDOWN_COLOR_SCHEME, DROPDOWN_SIZE } from '../footer/defs.js';
import { descriptor as parentDescriptor } from '@carbon/web-components/es/components-react/dropdown/dropdown.js';
import { propTypes as parentPropTypes } from '@carbon/web-components/es/components-react/dropdown/dropdown.js';
export { default as CustomElement } from '../../components/search-with-typeahead/scoped-search-dropdown.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onSelect: {
    event: ''.concat(prefix, '-select-selected'),
  },
});
export var propTypes = {
  /**
   * The name of the custom event captured to retrieve the new search scope.
   */
  onSelect: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-scoped-search-dropdown'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
