/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Search result item in masthead.
 *
 * @element c4d-search-with-typeahead-item
 * @csspart item item-highlighted - The highlighted item. Usage `c4d-search-with-typeahead-item::part(item item-highlighted)`
 * @csspart item-container - The item container. Usage `c4d-search-with-typeahead-item::part(item-container)`
 */
declare class C4DSearchWithTypeaheadItem extends Component<ComponentProps> {}
export default C4DSearchWithTypeaheadItem;
