/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { descriptor as parentDescriptor } from '@carbon/web-components/es/components-react/dropdown/dropdown.js';
import { propTypes as parentPropTypes } from '@carbon/web-components/es/components-react/dropdown/dropdown.js';
export { default as CustomElement } from '../../components/search-with-typeahead/search-with-typeahead.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onBeforeRedirect: {
    event: ''.concat(c4dPrefix, '-search-with-typeahead-beingredirected'),
  },
  onInput: {
    event: ''.concat(c4dPrefix, '-search-with-typeahead-input'),
  },
  onSelectScope: {
    event: ''.concat(prefix, '-select-selected'),
  },
  onCustomResults: {
    event: ''.concat(c4dPrefix, '-custom-typeahead-api-results'),
  },
  onToggle: {
    event: ''.concat(c4dPrefix, '-search-with-typeahead-toggled'),
  },
});
export var propTypes = {
  /**
   * The name of the custom event fired before the page is being redirected to the search result page.
   * Cancellation of this event stops the user-initiated action of redirection.
   */
  onBeforeRedirect: PropTypes.func,
  /**
   * The name of the custom event fired after the search content is changed upon a user gesture.
   */
  onInput: PropTypes.func,
  /**
   * The name of the custom event captured to retrieve the new search scope.
   */
  onSelectScope: PropTypes.func,
  /**
   * The name of the custom event captured to retrieve the custom typeahead API results.
   */
  onCustomResults: PropTypes.func,
  /**
   * The name of the custom event fired after this search box is toggled upon a user gesture.
   */
  onToggle: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-search-with-typeahead'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
