/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * StructuredListCell
 *
 * @element c4d-structured-list-cell
 * @csspart icon-text-container - Text wrapping element. Usage `c4d-structured-list-cell::part(icon-text)`
 * @csspart icon-text - Descriptive text of the cell. Usage `c4d-structured-list-cell::part(icon-text)`
 * @csspart tag - Tags of the cell. Usage `c4d-structured-list-cell::part(tag)`
 * @csspart icon - An icon. Usage `c4d-structured-list-cell::part(icon)`
 * @csspart tooltip - CDSTooltip. Usage `c4d-structured-list-cell::part(icon)`
 */
declare class C4DStructuredListCell extends Component<ComponentProps> {}
export default C4DStructuredListCell;
