/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  [prop: string]: unknown;
}
/**
 * Table of contents.
 *
 * @element c4d-table-of-contents
 * @csspart list - The menu list. Usage `c4d-table-of-contents::part(list)`
 * @csspart list-item - The menu items. Usage `c4d-table-of-contents::part(list-item)`
 * @csspart list-item--active - The menu items as active. Usage `c4d-table-of-contents::part(list-item--active)`
 * @csspart link - The links under TOC. Usage `c4d-table-of-contents::part(link)`
 * @csspart container - The container. Usage `c4d-table-of-contents::part(container)`
 * @csspart table - The table UI. Usage `c4d-table-of-contents::part(table)`
 * @csspart heading - The headings. Usage `c4d-table-of-contents::part(heading)`
 * @csspart prev-button - The previous button. Usage `c4d-table-of-contents::part(prev-button)`
 * @csspart item-container - The item container. Usage `c4d-table-of-contents::part(item-container)`
 * @csspart content - The content. Usage `c4d-table-of-contents::part(content)`
 * @csspart sub-content-right - The right side content. Usage `c4d-table-of-contents::part(sub-content-right)`
 * @csspart sub-content-left - The left side content. Usage `c4d-table-of-contents::part(sub-content-left)`
 * @csspart next-button - The next button. Usage `c4d-table-of-contents::part(next-button)`
 * @csspart content-table - The content table. Usage `c4d-table-of-contents::part(content-table)`
 * @csspart wrapper - The wrapper. Usage `c4d-table-of-contents::part(wrapper)`
 * @slot heading - The heading content.
 * @slot menu-rule - The menu rule.
 */
declare class C4DTableOfContents extends Component<ComponentProps> {}
export default C4DTableOfContents;
