/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * An event that fires whenever the tab's selected state changes.
   */
  onTabSelected?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * A tab within a tabbed layout.
 *
 * @element c4d-tab
 */
declare class C4DTab extends Component<ComponentProps> {}
export default C4DTab;
