/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Component } from 'react';
export interface ComponentProps {
  /**
   * The event handler for the custom event fired before a tab is selected upon a user gesture.
   * Cancellation of this event stops changing the user-initiated selection.
   */
  onBeforeSelect?: (event: CustomEvent) => void;
  /**
   * The event handler for the custom event fired after a a tab is selected upon a user gesture.
   */
  onSelect?: (event: CustomEvent) => void;
  [prop: string]: unknown;
}
/**
 * A component to present content inside a tabbed layout.
 *
 * @element c4d-tabs-extended
 */
declare class C4DTabsExtended extends Component<ComponentProps> {}
export default C4DTabsExtended;
