/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { descriptor as parentDescriptor } from '@carbon/web-components/es/components-react/tabs/tabs.js';
import { propTypes as parentPropTypes } from '@carbon/web-components/es/components-react/tabs/tabs.js';
export { default as CustomElement } from '../../components/tabs-extended/tabs-extended.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = Object.assign({}, parentDescriptor, {
  onBeforeSelect: {
    event: ''.concat(c4dPrefix, '-tabs-beingselected'),
  },
  onSelect: {
    event: ''.concat(c4dPrefix, '-tabs-selected'),
  },
});
export var propTypes = {
  /**
   * The name of the custom event fired before a tab is selected upon a user gesture.
   * Cancellation of this event stops changing the user-initiated selection.
   */
  onBeforeSelect: PropTypes.func,
  /**
   * The name of the custom event fired after a a tab is selected upon a user gesture.
   */
  onSelect: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-tabs-extended'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
