/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
export { default as CustomElement } from '../../components/video-player/video-player-composite.js';
import createReactCustomElementType from '@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js';
import PropTypes from 'prop-types';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
var prefix = settings.prefix;
var c4dPrefix = settings.stablePrefix;
export var descriptor = {
  onContentStateChange: {
    event: ''.concat(c4dPrefix, '-video-player-content-state-changed'),
  },
  onPlaybackStateChange: {
    event: ''.concat(c4dPrefix, '-video-player-playback-state-changed'),
  },
  onTogglePlayback: {
    event: ''.concat(c4dPrefix, '-video-player-toggle-playback'),
  },
};
export var propTypes = {
  /**
   * The name of the custom event fired after video content state is changed upon a user gesture.
   */
  onContentStateChange: PropTypes.func,
  /**
   * The name of the custom event fired requesting playback state change.
   */
  onPlaybackStateChange: PropTypes.func,
  /**
   * The name of the custom event fired requesting to toggle playback.
   */
  onTogglePlayback: PropTypes.func,
};
const Component = createReactCustomElementType(
  ''.concat(c4dPrefix, '-video-player-composite'),
  descriptor
);
Component.propTypes = propTypes;
export default Component;
