import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././button-group.css.js";
import C4DButton from "../button/button.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Button group item.
 *
 * @element c4d-button-group-item
 */
let C4DButtonGroupItem = _decorate([customElement(`${c4dPrefix}-button-group-item`)], function (_initialize, _C4DButton) {
  class C4DButtonGroupItem extends _C4DButton {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DButtonGroupItem,
    d: [{
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--button-group-item`;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DButtonGroupItem, "connectedCallback", this, 3)([]);
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'listitem');
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DButton);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DButtonGroupItem;
//# sourceMappingURL=button-group-item.js.map
