import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././callout-quote.css.js";
import C4DCalloutMixin from "../../component-mixins/callout/callout.js";
import C4DQuote from "../quote/quote.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import { property } from 'lit/decorators.js';
import { COLOR_SCHEME } from "../../component-mixins/callout/defs.js";
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Callout Quote.
 *
 * @element c4d-callout-quote
 * @csspart  column - The colunm housing the callout content. Usage: 'c4d-callout-quote::part(column)'
 * @csspart  content - The quote content. Usage: 'c4d-callout-quote::part(content)'
 * @csspart  container - The quote container . Usage: 'c4d-callout-quote::part(container)'
 * @csspart  wrapper - The quote wrapper. Usage: 'c4d-callout-quote::part(wrapper)'
 */
let C4DCalloutQuote = _decorate([customElement(`${c4dPrefix}-callout-quote`)], function (_initialize, _C4DCalloutMixin) {
  class C4DCalloutQuote extends _C4DCalloutMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCalloutQuote,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'color-scheme'
      })],
      key: "colorScheme",
      value() {
        return COLOR_SCHEME.REGULAR;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * The color-scheme type.
       */

      function updated(changedProperties) {
        _superPropGet(C4DCalloutQuote, "updated", this, 3)([changedProperties]);
        const linkWithIcon = this.querySelector(this.constructor.selectorLinkWithIcon);
        linkWithIcon ? linkWithIcon.colorScheme = this.colorScheme : '';
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <div class="${0}--callout__column" part="column">
        <div class="${0}--callout__content" part="content">
          <div class="${0}--quote__container" part="container">
            <div class="${0}--quote__wrapper" part="wrapper">
              ${0}${0}${0}
            </div>
          </div>
        </div>
      </div>
    `), prefix, prefix, prefix, prefix, this._renderQuote(), this._renderSource(), this._renderFooter());
      }

      /**
       * A selector that will return the child link-with-icon.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorLinkWithIcon",
      value: function () {
        return `${c4dPrefix}-callout-link-with-icon`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--callout-quote`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DCalloutMixin(C4DQuote));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCalloutQuote;
//# sourceMappingURL=callout-quote.js.map
