import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { css } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import DDSContentBlockCopy from "../content-block/content-block-copy.js";
import { COLOR_SCHEME } from "../../component-mixins/callout/defs.js";
import styles from "././callout-with-media.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The copy content of callout with media.
 *
 * @element c4d-callout-with-media-copy
 */
let C4DCalloutWithMediaCopy = _decorate([customElement(`${c4dPrefix}-callout-with-media-copy`)], function (_initialize, _DDSContentBlockCopy) {
  class C4DCalloutWithMediaCopy extends _DDSContentBlockCopy {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCalloutWithMediaCopy,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'color-scheme'
      })],
      key: "colorScheme",
      value() {
        return COLOR_SCHEME.REGULAR;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * The color-scheme type.
       */

      function () {
        return `${c4dPrefix}--callout-with-media-copy`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DCalloutWithMediaCopy, "styles", this), styles);
      }
    }]
  };
}, DDSContentBlockCopy);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCalloutWithMediaCopy;
//# sourceMappingURL=callout-with-media-copy.js.map
