/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DImage from '../image/image';
import { COLOR_SCHEME } from '../../component-mixins/callout/defs';
/**
 * Callout with media image.
 *
 * @element c4d-callout-with-media-image
 */
declare class C4DCalloutWithMediaImage extends C4DImage {
    /**
     * The color-scheme type.
     */
    colorScheme: COLOR_SCHEME;
    /**
     * The shadow slot this video container should be in.
     */
    slot: string;
    static styles: any;
}
export default C4DCalloutWithMediaImage;

//# sourceMappingURL=callout-with-media-image.d.ts.map
