/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DVideoPlayerContainer from '../video-player/video-player-container';
import { COLOR_SCHEME } from '../../component-mixins/callout/defs';
/**
 * Callout with media video.
 *
 * @element c4d-callout-with-media-video
 */
declare class C4DCalloutWithMediaVideo extends C4DVideoPlayerContainer {
    /**
     * The color-scheme type.
     */
    colorScheme: COLOR_SCHEME;
    /**
     * The shadow slot this video container should be in.
     */
    slot: string;
    static styles: any;
}
export default C4DCalloutWithMediaVideo;

//# sourceMappingURL=callout-with-media-video.d.ts.map
