import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././callout-with-media.css.js";
import C4DVideoPlayerContainer from "../video-player/video-player-container.js";
import { COLOR_SCHEME } from "../../component-mixins/callout/defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Callout with media video.
 *
 * @element c4d-callout-with-media-video
 */
let C4DCalloutWithMediaVideo = _decorate([customElement(`${c4dPrefix}-callout-with-media-video`)], function (_initialize, _C4DVideoPlayerContai) {
  class C4DCalloutWithMediaVideo extends _C4DVideoPlayerContai {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCalloutWithMediaVideo,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'color-scheme'
      })],
      key: "colorScheme",
      value() {
        return COLOR_SCHEME.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'media';
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DVideoPlayerContainer);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCalloutWithMediaVideo;
//# sourceMappingURL=callout-with-media-video.js.map
