import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././callout-with-media.css.js";
import C4DCalloutMixin from "../../component-mixins/callout/callout.js";
import C4DContentBlock from "../content-block/content-block.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import { property } from 'lit/decorators.js';
import { COLOR_SCHEME } from "../../component-mixins/callout/defs.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Callout Data.
 *
 * @element c4d-callout-data
 */
let C4DCalloutWithMedia = _decorate([customElement(`${c4dPrefix}-callout-with-media`)], function (_initialize, _C4DCalloutMixin) {
  class C4DCalloutWithMedia extends _C4DCalloutMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCalloutWithMedia,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'color-scheme'
      })],
      key: "colorScheme",
      value() {
        return COLOR_SCHEME.REGULAR;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * The color-scheme type.
       */

      function updated(changedProperties) {
        _superPropGet(C4DCalloutWithMedia, "updated", this, 3)([changedProperties]);
        const copy = this.querySelector(this.constructor.selectorCopy);
        const image = this.querySelector(this.constructor.selectorImage);
        const video = this.querySelector(this.constructor.selectorVideo);
        copy ? copy.colorScheme = this.colorScheme : '';
        image ? image.colorScheme = this.colorScheme : '';
        video ? video.colorScheme = this.colorScheme : '';
      }

      /**
       * A selector that will return the child image.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorImage",
      value: function () {
        return `${c4dPrefix}-callout-with-media-image`;
      }

      /**
       * A selector that will return the child video.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorVideo",
      value: function () {
        return `${c4dPrefix}-callout-with-media-video`;
      }

      /**
       * A selector that will return the child copy.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorCopy",
      value: function () {
        return `${c4dPrefix}-callout-with-media-copy`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--callout-with-media`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DCalloutMixin(StableSelectorMixin(C4DContentBlock)));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCalloutWithMedia;
//# sourceMappingURL=callout-with-media.js.map
