/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DCardLinkCTA from '../cta/card-link-cta';
/**
 * Card Group Card Link item.
 *
 * @element c4d-card-group-card-link-item
 */
declare class C4DCardGroupCardLinkItem extends C4DCardLinkCTA {
    /**
     * `true` if the card group is using border.
     */
    border: boolean;
    /**
     * `true` if the card group item is empty.
     */
    empty: boolean;
    /**
     * `true` if the card group item has the same background color as the pattern container.
     */
    patternBackground: boolean;
    static get stableSelector(): string;
    /**
     * A selector that will return the child footer.
     */
    static get selectorFooter(): string;
    static styles: any;
}
export default C4DCardGroupCardLinkItem;

//# sourceMappingURL=card-group-card-link-item.d.ts.map
