/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DCard from '../card/card';
import { GRID_MODE } from './defs';
/**
 * Card Group item.
 *
 * @element c4d-card-group-item
 */
declare class C4DCardGroupItem extends C4DCard {
    /**
     * `true` if the card group item is empty.
     */
    empty: boolean;
    /**
     * The inherited grid mode the card group item lives within.
     * Condensed (1px) | Narrow (16px) | Default(32px).
     */
    gridMode: GRID_MODE;
    static get stableSelector(): string;
    updated(changedProperties: any): void;
    /**
     * A selector that will return the child footer.
     */
    static get selectorFooter(): string;
    static styles: any;
}
export default C4DCardGroupItem;

//# sourceMappingURL=card-group-item.d.ts.map
