import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DCard from "../card/card.js";
import styles from "././card-group.css.js";
import { GRID_MODE } from "./defs.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Card Group item.
 *
 * @element c4d-card-group-item
 */
let C4DCardGroupItem = _decorate([customElement(`${c4dPrefix}-card-group-item`)], function (_initialize, _C4DCard) {
  class C4DCardGroupItem extends _C4DCard {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCardGroupItem,
    d: [{
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "empty",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'grid-mode',
        reflect: true
      })],
      key: "gridMode",
      value() {
        return GRID_MODE.DEFAULT;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * `true` if the card group item is empty.
       */

      /**
       * The inherited grid mode the card group item lives within.
       * Condensed (1px) | Narrow (16px) | Default(32px).
       */

      function () {
        return `${c4dPrefix}--card-group-item`;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet(C4DCardGroupItem, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('ctaType')) {
          var _this$shadowRoot;
          (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || (_this$shadowRoot = _this$shadowRoot.querySelector('c4d-image')) === null || _this$shadowRoot === void 0 || _this$shadowRoot.setAttribute('card-group-item', '');
        }
      }

      /**
       * A selector that will return the child footer.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorFooter",
      value: function () {
        return `${c4dPrefix}-card-footer`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DCard);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCardGroupItem;
//# sourceMappingURL=card-group-item.js.map
