import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DCardHeading from "../card/card-heading.js";
import styles from "././card-link.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Card Link Heading.
 *
 * @element c4d-card-link-heading
 */
let C4DCardLinkHeading = _decorate([customElement(`${c4dPrefix}-card-link-heading`)], function (_initialize, _C4DCardHeading) {
  class C4DCardLinkHeading extends _C4DCardHeading {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCardLinkHeading,
    d: [{
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--card-link-heading`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DCardHeading);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCardLinkHeading;
//# sourceMappingURL=card-link-heading.js.map
