import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DCard from "../card/card.js";
import styles from "././card-link.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Card Link.
 *
 * @element c4d-card-link
 */
let C4DCardLink = _decorate([customElement(`${c4dPrefix}-card-link`)], function (_initialize, _C4DCard) {
  class C4DCardLink extends _C4DCard {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCardLink,
    d: [{
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * `true` to disable the card link.
       */

      function updated(changedProperties) {
        _superPropGet(C4DCardLink, "updated", this, 3)([changedProperties]);
        const {
          _linkNode: linkNode
        } = this;
        if (linkNode) {
          linkNode.classList.add(`${prefix}--card__CTA`);
          if (changedProperties.has('disabled')) {
            const {
              disabled
            } = this;
            linkNode.classList.toggle(`${prefix}--card__CTA--disabled`, disabled);
          }
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--card-link`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DCard);
console.warn('The card-link component has been deprecated in favor of the card (link variant) component. ' + 'See card documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCardLink;
//# sourceMappingURL=card-link.js.map
