import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentBlock from "../content-block/content-block.js";
import styles from "././card-section-offset.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Card section offset.
 *
 * @element c4d-card-section-offset
 * @slot heading - The heading content.
 * @slot action - The text-cta content.
 * @slot card-group - The L shaped card group content.
 * @csspart content - The text cta content. Usage: `c4d-card-section-offset::part(content)`
 */
let C4DCardSectionOffset = _decorate([customElement(`${c4dPrefix}-card-section-offset`)], function (_initialize, _StableSelectorMixin) {
  class C4DCardSectionOffset extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCardSectionOffset,
    d: [{
      kind: "method",
      key: "_handleSlotChangeCardGroup",
      value: function _handleSlotChangeCardGroup(event) {
        const childItems = event.target.assignedNodes();
        childItems.filter(elem => {
          if (elem.matches(this.constructor.cardGroupSelector) && elem.querySelectorAll(`${c4dPrefix}-card-group-item`).length === 3) {
            var _this$querySelector;
            const emptyCard = document.createElement(`${c4dPrefix}-card-group-item`);
            emptyCard.setAttribute('empty', '');
            (_this$querySelector = this.querySelector(`${c4dPrefix}-card-group`)) === null || _this$querySelector === void 0 || _this$querySelector.prepend(emptyCard);
            return true;
          }
          this.querySelector(`${c4dPrefix}-card-group`).innerHTML = '';
          return false;
        });
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <slot name="image-top"></slot>
      <div class="${0}--card-section-offset__content" part="content">
        ${0}
        <slot name="action"></slot>
      </div>
      <slot
        name="card-group"
        @slotchange="${0}"></slot>
      <slot name="image-bottom"></slot>
    `), prefix, this._renderHeading(), this._handleSlotChangeCardGroup);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--card-section-offset`;
      }
    }, {
      kind: "get",
      static: true,
      key: "cardGroupSelector",
      value: function () {
        return `${c4dPrefix}-card-group`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t2 || (_t2 = _`
      ${0}${0}
    `), _superPropGet(C4DCardSectionOffset, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentBlock));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCardSectionOffset;
//# sourceMappingURL=card-section-offset.js.map
