import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2025
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentBlock from "../content-block/content-block.js";
import styles from "././content-block-cards.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content block cards.
 *
 * @element c4d-content-block-cards
 */
let C4DContentBlockCards = _decorate([customElement(`${c4dPrefix}-content-block-cards`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockCards extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockCards,
    d: [{
      kind: "method",
      key: "_getContainerClasses",
      value:
      /**
       * The CSS class list for the container (grid) node.
       */
      // eslint-disable-next-line class-methods-use-this
      function _getContainerClasses() {
        return `${prefix}--content-layout ${prefix}--content-layout--card-group`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-cards`;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DContentBlockCards, "connectedCallback", this, 3)([]);
        window.onload = () => {
          var _this$shadowRoot;
          const hasLogoClass = this.classList.contains('media-type__logo');
          const slot = (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector('slot:not([name])');
          if (slot && hasLogoClass) {
            slot === null || slot === void 0 || slot.assignedElements().forEach(element => {
              element.classList.add('media-type-block-cards__logo');
            });
          }
        };
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockCards, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentBlock));
console.warn('The content-block-cards component has been deprecated in favor of the content-section/block and card-group component. ' + 'See content-section/block and card-group documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentBlockCards;
//# sourceMappingURL=content-block-cards.js.map
