import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentItemHeading from "../content-item/content-item-heading.js";
import styles from "././content-block-headlines.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The heading content in content item.
 *
 * @element c4d-content-block-headlines-heading
 */
let C4DContentBlockHeadlinesHeading = _decorate([customElement(`${c4dPrefix}-content-block-headlines-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockHeadlinesHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockHeadlinesHeading,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'heading';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The shadow slot this logo UI should be in.
       */

      function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-headlines__heading`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DContentItemHeading));
export default C4DContentBlockHeadlinesHeading;
//# sourceMappingURL=content-block-headlines-heading.js.map
