import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentItem from "../content-item/content-item.js";
import styles from "././content-block-headlines.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content Block Headlines item
 *
 * @element c4d-content-block-headlines-item
 * @csspart heading - The heading element within the content block headlines item. Usage: `c4d-content-block-headlines-item::part(heading)`
 * @csspart copy - The paragraph element containing the copy text in the content block headlines item. Usage: `c4d-content-block-headlines-item::part(copy)`
 */
let C4DContentBlockHeadlinesItem = _decorate([customElement(`${c4dPrefix}-content-block-headlines-item`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockHeadlinesItem extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockHeadlinesItem,
    d: [{
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <h4 class="cds--content-block-headlines__heading" part="heading">
        <slot name="heading"></slot>
      </h4>
      <p class="cds--content-block-headlines__copy" part="copy">
        <slot name="copy"></slot>
      </p>
      <slot name="footer"></slot>
    `));
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t2 || (_t2 = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockHeadlinesItem, "styles", this), styles);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-headlines-item`;
      }
    }]
  };
}, StableSelectorMixin(C4DContentItem));
export default C4DContentBlockHeadlinesItem;
//# sourceMappingURL=content-block-headlines-item.js.map
