import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentBlock from "../content-block/content-block.js";
import styles from "././content-block-headlines.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content Block Headlines
 *
 * @element c4d-content-block-headlines
 */
let C4DContentBlockHeadlines = _decorate([customElement(`${c4dPrefix}-content-block-headlines`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockHeadlines extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockHeadlines,
    d: [{
      kind: "method",
      key: "_getContainerClasses",
      value:
      /**
       * The CSS class list for the container (grid) node.
       */
      // eslint-disable-next-line class-methods-use-this
      function _getContainerClasses() {
        return `${prefix}--content-layout ${prefix}--content-layout--with-headlines ${prefix}--layout--border`;
      }
    }, {
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        const {
          _hasContent: hasContent,
          _handleSlotChange: handleSlotChange
        } = this;
        return html(_t || (_t = _`
      <div
        ?hidden="${0}"
        class="${0}--content-block-headlines__item-container">
        <slot @slotchange="${0}"></slot>
      </div>
    `), !hasContent, prefix, handleSlotChange);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-headlines`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t2 || (_t2 = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockHeadlines, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentBlock));
export default C4DContentBlockHeadlines;
//# sourceMappingURL=content-block-headlines.js.map
