/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DContentGroup from '../content-group/content-group';
import '../horizontal-rule/horizontal-rule';
/**
 * Horizontal version of content group.
 *
 * @element c4d-content-block-horizontal
 * @csspart hr - The horizontal rule element that appears when the border property is true. Usage: `c4d-content-block-horizontal::part(hr)`
 */
declare class C4DContentBlockHorizontal extends C4DContentGroup {
    border: boolean;
    render(): import("lit-html").TemplateResult<1>;
    static get stableSelector(): string;
    static get styles(): import("lit").CSSResult;
}
export default C4DContentBlockHorizontal;

//# sourceMappingURL=content-block-horizontal.d.ts.map
