import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DContentGroup from "../content-group/content-group.js";
import "../horizontal-rule/horizontal-rule.js";
import styles from "././content-block-horizontal.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Horizontal version of content group.
 *
 * @element c4d-content-block-horizontal
 * @csspart hr - The horizontal rule element that appears when the border property is true. Usage: `c4d-content-block-horizontal::part(hr)`
 */
let C4DContentBlockHorizontal = _decorate([customElement(`${c4dPrefix}-content-block-horizontal`)], function (_initialize, _C4DContentGroup) {
  class C4DContentBlockHorizontal extends _C4DContentGroup {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockHorizontal,
    d: [{
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true,
        attribute: 'border'
      })],
      key: "border",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      ${0}
      ${0}
    `), _superPropGet(C4DContentBlockHorizontal, "render", this, 3)([]), this.border ? html(_t2 || (_t2 = _` <c4d-hr part="hr"></c4d-hr> `)) : '');
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-horizontal`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t3 || (_t3 = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockHorizontal, "styles", this), styles);
      }
    }]
  };
}, C4DContentGroup);
console.warn('The content-block-horizontal component has been deprecated in favor of the content-section/block and content item horizontal component. ' + 'See content-section/block and content item horizontal documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentBlockHorizontal;
//# sourceMappingURL=content-block-horizontal.js.map
