import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././content-block-media.css.js";
import C4DContentGroup from "../content-group/content-group.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content block media.
 *
 * @element c4d-content-block-media-content
 */
let C4DContentBlockMediaContent = _decorate([customElement(`${c4dPrefix}-content-block-media-content`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockMediaContent extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockMediaContent,
    d: [{
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        const {
          _hasContent: hasContent,
          _hasMedia: hasMedia
        } = this;
        // Moves media content out of `<div class="cds--content-block__children">`
        return html(_t || (_t = _`
      ${0}
      <div
        ?hidden="${0}"
        class="${0}--content-block__children">
        ${0}
      </div>
    `), this._renderMedia(), !hasContent && !hasMedia, prefix, this._renderContent());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-media-content`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t2 || (_t2 = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockMediaContent, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentGroup));
console.warn('The content-block-media-content component has been deprecated in favor of the content-section/block content component. ' + 'See content-section/block documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentBlockMediaContent;
//# sourceMappingURL=content-block-media-content.js.map
