import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentGroup from "../content-group/content-group.js";
import styles from "././content-block-segmented.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content block segmented item.
 *
 * @element c4d-content-block-segmented-item
 */
let C4DContentBlockSegmentedItem = _decorate([customElement(`${c4dPrefix}-content-block-segmented-item`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockSegmentedItem extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockSegmentedItem,
    d: [{
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        return html(_t || (_t = _` ${0}${0} `), this._renderContent(), this._renderMedia());
      }
    }, {
      kind: "method",
      key: "_renderMedia",
      value: function _renderMedia() {
        const {
          _hasMedia: hasMedia,
          _handleSlotChange: handleSlotChange
        } = this;
        return html(_t2 || (_t2 = _`
      <div
        ?hidden="${0}"
        class="${0}--content-block-segmented__media">
        <slot name="media" @slotchange="${0}"></slot>
      </div>
    `), !hasMedia, prefix, handleSlotChange);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-segmented-item`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t3 || (_t3 = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockSegmentedItem, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentGroup));
console.warn('The content-block-segmented-item component has been deprecated in favor of the content-block component. ' + 'See content-block documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentBlockSegmentedItem;
//# sourceMappingURL=content-block-segmented-item.js.map
