import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { classMap } from 'lit/directives/class-map.js';
import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DContentBlock, { CONTENT_BLOCK_COMPLEMENTARY_STYLE_SCHEME } from "../content-block/content-block.js";
import styles from "././content-block-segmented.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Simple version of content block.
 *
 * @element c4d-content-block-segmented
 */
let C4DContentBlockSegmented = _decorate([customElement(`${c4dPrefix}-content-block-segmented`)], function (_initialize, _C4DContentBlock) {
  class C4DContentBlockSegmented extends _C4DContentBlock {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockSegmented,
    d: [{
      kind: "method",
      key: "_getContainerClasses",
      value: function _getContainerClasses() {
        const {
          complementaryStyleScheme,
          _hasComplementary: hasComplementary,
          _hasContent: hasContent,
          _hasCopy: hasCopy,
          _hasHeading: hasHeading,
          _hasMedia: hasMedia
        } = this;
        return classMap({
          [`${prefix}--content-layout`]: true,
          [`${prefix}--content-layout--with-complementary`]: hasComplementary,
          [`${c4dPrefix}-ce--content-layout--with-adjacent-heading-content`]: hasHeading && hasContent && !hasCopy && !hasMedia,
          [`${prefix}--layout--border`]: complementaryStyleScheme === CONTENT_BLOCK_COMPLEMENTARY_STYLE_SCHEME.WITH_BORDER
        });
      }
    }, {
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        return html(_t || (_t = _` ${0}${0} `), this._renderMedia(), this._renderContent());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-block-segmented`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t2 || (_t2 = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockSegmented, "styles", this), styles);
      }
    }]
  };
}, C4DContentBlock);
console.warn('The content-block-segmented component has been deprecated in favor of the content-section/block and a variety of group components. ' + 'See content-section/block documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentBlockSegmented;
//# sourceMappingURL=content-block-segmented.js.map
