import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DMarkdown from "../markdown/markdown.js";
import { CONTENT_BLOCK_COPY_SIZE } from "./defs.js";
import "./content-block-paragraph.js";
import styles from "././content-block.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
export { CONTENT_BLOCK_COPY_SIZE };
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The copy content of content block.
 *
 * @element c4d-content-block-copy
 * @csspart content-block-paragraph - The paragraph element within the content block. Usage: `c4d-content-block-copy::part(content-block-paragraph)`
 */
let C4DContentBlockCopy = _decorate([customElement(`${c4dPrefix}-content-block-copy`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentBlockCopy extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentBlockCopy,
    d: [{
      kind: "get",
      key: "_customTags",
      value: function () {
        const tags = new Set(_superPropGet(C4DContentBlockCopy, "_customTags", this, 1));
        tags.add(`${c4dPrefix}-content-block-paragraph`);
        return tags;
      }
    }, {
      kind: "get",
      key: "_renderer",
      value: function () {
        this.childNodes.forEach(node => {
          if (node.nodeType === Node.TEXT_NODE) {
            this.removeChild(node);
          }
        });
        return Object.assign(_superPropGet(C4DContentBlockCopy, "_renderer", this, 1), {
          paragraph(text) {
            return `<${c4dPrefix}-content-block-paragraph part="content-block-paragraph">${text}</${c4dPrefix}-content-block-paragraph>`;
          }
        });
      }

      /**
       * The default slot for all content-block-copy use cases.
       * The content size.
       */
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "size",
      value() {
        return CONTENT_BLOCK_COPY_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'copy';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * The shadow slot this copy content should be in.
       */
      function () {
        return `${c4dPrefix}--content-block__copy`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DContentBlockCopy, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DMarkdown));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentBlockCopy;
//# sourceMappingURL=content-block-copy.js.map
