import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DCard from "../card/card.js";
import styles from "././content-group-cards.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content Group Card item.
 *
 * @element c4d-content-group-card-item
 */
let C4DContentGroupCardsItem = _decorate([customElement(`${c4dPrefix}-content-group-cards-item`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentGroupCardsItem extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentGroupCardsItem,
    d: [{
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-group-cards-item`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DCard));
console.warn('The content-group-cards-item component has been deprecated in favor of the content-section/block and the card group component. ' + 'See content-section/block and card-group documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentGroupCardsItem;
//# sourceMappingURL=content-group-cards-item.js.map
