/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { TemplateResult } from 'lit';
import C4DContentGroup from '../content-group/content-group';
/**
 * Content group cards.
 *
 * @element c4d-content-group-cards
 * @csspart children - The Element container. Usage: `c4d-content-group-cards::part(children)`
 * @csspart cards-group - The cards group grid. Usage: `c4d-content-group-cards::part(cards-group)`
 * @csspart cards-row - The cards group row. Usage: `c4d-content-group-cards::part(cards-row)`
 */
declare class C4DContentGroupCards extends C4DContentGroup {
    protected _renderInnerBody(): TemplateResult | string | void;
    static get stableSelector(): string;
    static get styles(): import("lit").CSSResult;
}
export default C4DContentGroupCards;

//# sourceMappingURL=content-group-cards.d.ts.map
