import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DContentGroup from "../content-group/content-group.js";
import styles from "././content-group-cards.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content group cards.
 *
 * @element c4d-content-group-cards
 * @csspart children - The Element container. Usage: `c4d-content-group-cards::part(children)`
 * @csspart cards-group - The cards group grid. Usage: `c4d-content-group-cards::part(cards-group)`
 * @csspart cards-row - The cards group row. Usage: `c4d-content-group-cards::part(cards-row)`
 */
let C4DContentGroupCards = _decorate([customElement(`${c4dPrefix}-content-group-cards`)], function (_initialize, _C4DContentGroup) {
  class C4DContentGroupCards extends _C4DContentGroup {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentGroupCards,
    d: [{
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        const {
          _hasContent: hasContent,
          _hasMedia: hasMedia
        } = this;
        return html(_t || (_t = _`
      <div
        part="children"
        ?hidden="${0}"
        class="${0}--content-group__children ${0}--content-group__col">
        <div
          part="cards-group"
          class="${0}--content-group-cards-group ${0}--grid--condensed">
          <div part="cards-row" class="${0}--content-group-cards__row">
            ${0}${0}
          </div>
        </div>
      </div>
    `), !hasContent && !hasMedia, prefix, prefix, prefix, prefix, prefix, this._renderContent(), this._renderMedia());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-group-cards`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t2 || (_t2 = _`
      ${0}${0}
    `), _superPropGet(C4DContentGroupCards, "styles", this), styles);
      }
    }]
  };
}, C4DContentGroup);
console.warn('The content-group-cards component has been deprecated in favor of the content-section/block and the card group component. ' + 'See content-section/block and card-group documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentGroupCards;
//# sourceMappingURL=content-group-cards.js.map
