import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DMarkdown from "../markdown/markdown.js";
import "./content-group-paragraph.js";
import styles from "././content-group.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The copy content in content group.
 *
 * @element c4d-content-group-copy
 * @csspart paragraph - The paragraph element within the content group copy. Usage: `c4d-content-group-copy::part(paragraph)`
 */
let C4DContentGroupCopy = _decorate([customElement(`${c4dPrefix}-content-group-copy`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentGroupCopy extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentGroupCopy,
    d: [{
      kind: "get",
      key: "_customTags",
      value: function () {
        const tags = new Set(_superPropGet(C4DContentGroupCopy, "_customTags", this, 1));
        tags.add(`${c4dPrefix}-content-group-paragraph`);
        return tags;
      }
    }, {
      kind: "get",
      key: "_renderer",
      value: function () {
        return Object.assign(_superPropGet(C4DContentGroupCopy, "_renderer", this, 1), {
          paragraph(text) {
            return `<${c4dPrefix}-content-group-paragraph part="paragraph">${text}</${c4dPrefix}-content-group-paragraph>`;
          }
        });
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        this.childNodes.forEach(node => {
          if (node.nodeType === Node.TEXT_NODE) {
            this.removeChild(node);
          }
        });
      }

      /**
       * The shadow slot this copy content should be in.
       */
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'copy';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-group__copy`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DMarkdown));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentGroupCopy;
//# sourceMappingURL=content-group-copy.js.map
