import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html, render } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././content-group.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The heading content in content group.
 *
 * @element c4d-content-group-heading
 * @csspart heading - The Heading. Usage: `c4d-content-group-heading::part(heading)`
 */
let C4DContentGroupHeading = _decorate([customElement(`${c4dPrefix}-content-group-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentGroupHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentGroupHeading,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'heading';
      }
    }, {
      kind: "method",
      key: "_renderHeading",
      value:
      /**
       * The shadow slot this logo UI should be in.
       */

      /**
       * Render the heading tag into the light DOM of this component.
       */
      function _renderHeading() {
        const template = document.createElement('template');
        template.innerHTML = `<h3>${this.innerHTML.trim()}</h3>`;
        this.innerHTML = '';
        const heading = template.content.firstChild;
        render(html(_t || (_t = _`${0}`), heading), this);
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'heading');
        }
        if (!this.hasAttribute('aria-level')) {
          this.setAttribute('aria-level', '3');
        }
        _superPropGet(C4DContentGroupHeading, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        this._renderHeading();
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t2 || (_t2 = _`<slot></slot>`));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-group__heading`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentGroupHeading;
//# sourceMappingURL=content-group-heading.js.map
