import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DContentBlock from "../content-block/content-block.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././content-group.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Content group.
 *
 * @abstract
 */
let C4DContentGroup = _decorate([customElement(`${c4dPrefix}-content-group`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentGroup extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentGroup,
    d: [{
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        return html(_t || (_t = _` ${0}${0} `), this._renderMedia(), this._renderContent());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-group`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DContentBlock));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentGroup;
//# sourceMappingURL=content-group.js.map
