import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DContentItemCopy from "../content-item/content-item-copy.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././content-item-row-media.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The copy content of content item row with media.
 *
 * @element c4d-content-item-row-media-copy
 */
let C4DContentItemRowMediaCopy = _decorate([customElement(`${c4dPrefix}-content-item-row-media-copy`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentItemRowMediaCopy extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentItemRowMediaCopy,
    d: [{
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-item-row-media-copy`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DContentItemCopy));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentItemRowMediaCopy;
//# sourceMappingURL=content-item-row-media-copy.js.map
