import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DVideoPlayerContainer from "../video-player/video-player-container.js";
import styles from "././content-item-row-media.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The video content in row content item with media.
 *
 * @element c4d-content-item-row-media-video
 */
let C4DContentItemRowMediaVideo = _decorate([customElement(`${c4dPrefix}-content-item-row-media-video`)], function (_initialize, _C4DVideoPlayerContai) {
  class C4DContentItemRowMediaVideo extends _C4DVideoPlayerContai {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentItemRowMediaVideo,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'media';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The shadow slot this video should be in.
       */

      function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-item-row-media-video`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DVideoPlayerContainer);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentItemRowMediaVideo;
//# sourceMappingURL=content-item-row-media-video.js.map
