import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { css } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DMarkdown from "../markdown/markdown.js";
import "./content-item-paragraph.js";
import styles from "././content-item.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The copy content of content item.
 *
 * @element c4d-content-item-copy
 * @csspart paragraph - The paragraph element within the content item copy. Usage: `c4d-content-item-copy::part(paragraph)`
 */
let C4DContentItemCopy = _decorate([customElement(`${c4dPrefix}-content-item-copy`)], function (_initialize, _StableSelectorMixin) {
  class C4DContentItemCopy extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DContentItemCopy,
    d: [{
      kind: "get",
      key: "_customTags",
      value: function () {
        const tags = new Set(_superPropGet(C4DContentItemCopy, "_customTags", this, 1));
        tags.add(`${c4dPrefix}-content-item-paragraph`);
        return tags;
      }
    }, {
      kind: "get",
      key: "_renderer",
      value: function () {
        this.childNodes.forEach(node => {
          if (node.nodeType === Node.TEXT_NODE) {
            this.removeChild(node);
          }
        });
        return Object.assign(_superPropGet(C4DContentItemCopy, "_renderer", this, 1), {
          paragraph(text) {
            return `<${c4dPrefix}-content-item-paragraph part="paragraph">${text}</${c4dPrefix}-content-item-paragraph>`;
          }
        });
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--content-item__copy`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DContentItemCopy, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DMarkdown));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DContentItemCopy;
//# sourceMappingURL=content-item-copy.js.map
