import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import { property } from 'lit/decorators.js';
import parseAspectRatio from '@carbon/ibmdotcom-utilities/es/utilities/parseAspectRatio/parseAspectRatio.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././cta-section.css.js";
import C4DContentSection from "../content-section/content-section.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The CTA SECTION pattern
 *
 * @element c4d-cta-section
 */
let C4DCTASection = _decorate([customElement(`${c4dPrefix}-cta-section`)], function (_initialize, _StableSelectorMixin) {
  class C4DCTASection extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCTASection,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'logo-ratio'
      })],
      key: "logoRatio",
      value: void 0
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        const {
          logoRatio
        } = this;
        if (changedProperties.has('logoRatio')) {
          if (logoRatio) {
            const [w, h] = parseAspectRatio(logoRatio);
            this.style.setProperty('--logo-ratio', `${w}/${h}`);
          } else {
            this.style.removeProperty('--logo-ratio');
          }
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--cta-section`;
      }
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DCTASection, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentSection));
console.warn('The cta-section component has been deprecated in favor of the content-section/block and content-item components. ' + 'See content-section/block amd content-item documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DCTASection;
//# sourceMappingURL=cta-section.js.map
