import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import store from '../../internal/vendor/@carbon/ibmdotcom-services-store/store.js';
import { C4DVideoPlayerContainerMixin, mapStateToProps, mapDispatchToProps } from "../video-player/video-player-container.js";
import ConnectMixin from "../../globals/mixins/connect.js";
import C4DVideoCTAComposite from "./video-cta-composite.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The Redux state used for `<c4d-cta-container>`.
 */

/**
 * The properties for `<c4d-cta-container>` from Redux state.
 */

/**
 * The Redux actions used for `<c4d-cta-container>.
 */
/**
 * Container component for CTA.
 *
 * @element c4d-cta-container
 */
let C4DVideoCTAContainer = _decorate([customElement(`${c4dPrefix}-video-cta-container`)], function (_initialize, _ConnectMixin) {
  class C4DVideoCTAContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DVideoCTAContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps, mapDispatchToProps)(C4DVideoPlayerContainerMixin(C4DVideoCTAComposite)));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DVideoCTAContainer;
//# sourceMappingURL=video-cta-container.js.map
