import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import pickBy from 'lodash-es/pickBy.js';
import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { globalInit } from '@carbon/ibmdotcom-services/es/services/global/global.js';
import { UNAUTHENTICATED_STATUS } from "../../internal/vendor/@carbon/ibmdotcom-services-store/types/profileAPI.js";
import "../footer/footer-composite.js";
import "./dotcom-shell.js";
import styles from "././dotcom-shell.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Component that renders dotcom shell from links, etc. data.
 *
 * @element c4d-dotcom-shell-composite
 * @csspart shell - The root element of the dotcom shell. Usage: `c4d-dotcom-shell-composite::part(shell)`
 */
let C4DDotcomShellComposite = _decorate([customElement(`${c4dPrefix}-dotcom-shell-composite`)], function (_initialize, _LitElement) {
  class C4DDotcomShellComposite extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DDotcomShellComposite,
    d: [{
      kind: "field",
      key: "_footerRenderRoot",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_mastheadRenderRoot",
      value() {
        return null;
      }
    }, {
      kind: "method",
      key: "_createFooterRenderRoot",
      value:
      /**
       * The render target of the footer contents.
       */

      /**
       * The render target of the masthead contents.
       */

      /**
       * The masthead element.
       */

      /**
       * @returns The render root of the footer contents.
       */
      function _createFooterRenderRoot() {
        var _this$parentNode;
        const footer = this.ownerDocument.createElement(`${c4dPrefix}-footer-composite`);
        (_this$parentNode = this.parentNode) === null || _this$parentNode === void 0 || _this$parentNode.insertBefore(footer, this.nextSibling);
        return footer;
      }

      /**
       * @returns The render root of the masthead contents.
       */
    }, {
      kind: "method",
      key: "_createMastheadRenderRoot",
      value: function _createMastheadRenderRoot() {
        var _this$parentNode2;
        const masthead = this.ownerDocument.createElement(`${c4dPrefix}-masthead-container`);
        (_this$parentNode2 = this.parentNode) === null || _this$parentNode2 === void 0 || _this$parentNode2.insertBefore(masthead, this);
        return masthead;
      }

      /**
       * The placeholder for `loadLocaleList()` Redux action that may be mixed in. This goes to footer.
       *
       * @internal
       */

      /**
       * The placeholder for `loadSearchResults()` Redux action that may be mixed in. This goes to masthead.
       *
       * @internal
       */

      /**
       * The placeholder for `loadTranslation()` Redux action that will be mixed in. This goes to masthead and footer.
       *
       * @internal
       */

      /**
       * The placeholder for `loadUserStatus()` Redux action that will be mixed in. This goes to masthead.
       *
       * @internal
       */

      /**
       * The placeholder for `setLanguage()` Redux action that will be mixed in. This goes to masthead.
       *
       * @internal
       */
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'has-profile'
      })],
      key: "hasProfile",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'has-search'
      })],
      key: "hasSearch",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'has-banner'
      })],
      key: "hasBanner",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'activate-search'
      })],
      key: "activateSearch",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "authenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'custom-typeahead-api',
        type: Boolean
      })],
      key: "customTypeaheadAPI",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'platform'
      })],
      key: "platform",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'platform-url'
      })],
      key: "platformUrl",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'clear-selection-label'
      })],
      key: "clearSelectionLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "collatorCountryName",
      value() {
        return new Intl.Collator();
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "currentSearchResults",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Number,
        attribute: 'input-timeout'
      })],
      key: "inputTimeout",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "footerLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'lang-display'
      })],
      key: "langDisplay",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'language-selector-label'
      })],
      key: "languageSelectorLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-language'
      })],
      key: "selectedLanguage",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "langList",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "legalLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "localeList",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'masthead-assistive-text'
      })],
      key: "mastheadAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'menu-bar-assistive-text'
      })],
      key: "menuBarAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'menu-button-assistive-text-active'
      })],
      key: "menuButtonAssistiveTextActive",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'menu-button-assistive-text-inactive'
      })],
      key: "menuButtonAssistiveTextInactive",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'footer-size'
      })],
      key: "footerSize",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true,
        attribute: 'open-search-dropdown'
      })],
      key: "openSearchDropdown",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "unauthenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "l1Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "navLinks",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "l0Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "scopeParameters",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "searchPlaceholder",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'user-status'
      })],
      key: "userStatus",
      value() {
        return UNAUTHENTICATED_STATUS;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value:
      /**
       * `true` if there is a profile.
       */
      /**
       * `true` if there is a search.
       */
      /**
       * `true` if there is a global banner.
       */
      /**
       * `true` to activate the search box. This goes to masthead.
       */
      /**
       * The profile items for authenticated state. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The boolean to enable custom typeahead API.
       */
      /**
       * The platform name. This goes to masthead.
       */
      /**
       * The platform url.
       */
      /**
       * The clear button label for language selector.
       *
       * @internal
       */
      /**
       * The g11n collator to use for sorting contry names. This goes to footer.
       */
      /**
       * The search results to show in the UI. This goes to masthead.
       * The data typically comes from our search service and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * `true` to omit the locale switcher button.
       */
      /**
       * The throttle timeout to run query upon user input. This goes to masthead.
       */
      /**
       * The footer links. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The language to show in the UI. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The placeholder label for language selector.
       *
       * @internal
       */
      /**
       * The initial selected language in the selector.
       *
       * @internal
       */
      /**
       * The language used for query. This goes to masthead and footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * Placeholder list of languages to populate language selector
       *
       * @internal
       */
      /**
       * The legal nav links. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The locale list. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The `aria-label` attribute for the top-level container. This goes to masthead.
       */
      /**
       * The `aria-label` attribute for the menu bar UI. This goes to masthead.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state. This goes to masthead.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state. This goes to masthead.
       */
      /**
       * The English title of the selected nav item.
       */
      /**
       * Footer size. This goes to footer.
       */
      /**
       * `true` to open the search dropdown.. This goes to masthead.
       * The data typically comes from our search service and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The profile items for unauthenticated state. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * Data for l1.
       */
      /**
       * The navigation links. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       *
       * @deprecated Use l0Data instead.
       */
      /**
       * The navigation links. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The parameters passed to the search-with-typeahead for search scope
       */
      /**
       * Value to display when the input has an empty `value`.
       */
      /**
       * The user authentication status. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      // eslint-disable-next-line class-methods-use-this
      function firstUpdated() {
        globalInit();
      }
    }, {
      kind: "method",
      key: "update",
      value: function update(changedProperties) {
        _superPropGet(C4DDotcomShellComposite, "update", this, 3)([changedProperties]);
        if (!this._mastheadRenderRoot) {
          this._mastheadRenderRoot = this._createMastheadRenderRoot();
        }
        const {
          activateSearch,
          authenticatedProfileItems,
          platform,
          platformUrl,
          collatorCountryName,
          currentSearchResults,
          customTypeaheadAPI,
          clearSelectionLabel,
          disableLocaleButton,
          mastheadAssistiveText,
          menuBarAssistiveText,
          menuButtonAssistiveTextActive,
          menuButtonAssistiveTextInactive,
          unauthenticatedProfileItems,
          inputTimeout,
          l1Data,
          language,
          languageSelectorLabel,
          langDisplay,
          langList,
          legalLinks,
          localeList,
          footerLinks,
          footerSize,
          openSearchDropdown,
          navLinks,
          l0Data,
          hasProfile,
          hasSearch,
          searchPlaceholder,
          scopeParameters,
          selectedLanguage,
          selectedMenuItem,
          userStatus,
          _setLanguage,
          _loadLocaleList,
          _loadTranslation,
          _loadUserStatus,
          _loadSearchResults
        } = this;
        Object.assign(this._mastheadRenderRoot, pickBy({
          activateSearch,
          authenticatedProfileItems,
          platform,
          platformUrl,
          currentSearchResults,
          customTypeaheadAPI,
          mastheadAssistiveText,
          menuBarAssistiveText,
          menuButtonAssistiveTextActive,
          menuButtonAssistiveTextInactive,
          unauthenticatedProfileItems,
          inputTimeout,
          l1Data,
          language,
          navLinks,
          l0Data,
          hasProfile,
          hasSearch,
          searchPlaceholder,
          scopeParameters,
          openSearchDropdown,
          selectedMenuItem,
          userStatus,
          _loadSearchResults,
          _loadTranslation,
          _loadUserStatus,
          _setLanguage
        }, value => value !== undefined));
        if (!this._footerRenderRoot) {
          this._footerRenderRoot = this._createFooterRenderRoot();
        }
        Object.assign(this._footerRenderRoot, pickBy({
          clearSelectionLabel,
          collatorCountryName,
          disableLocaleButton,
          language,
          languageSelectorLabel,
          langDisplay,
          langList,
          legalLinks,
          links: footerLinks,
          localeList,
          selectedLanguage,
          size: footerSize,
          _loadLocaleList,
          _loadTranslation,
          _setLanguage
        }, value => value !== undefined));
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet(C4DDotcomShellComposite, "updated", this, 3)([changedProperties]);

        // moving global banner outside of dotcom shell if placed within
        if (this.querySelector(`${c4dPrefix}-global-banner`)) {
          var _this$ownerDocument$q;
          (_this$ownerDocument$q = this.ownerDocument.querySelector(`${c4dPrefix}-masthead-container`)) === null || _this$ownerDocument$q === void 0 || _this$ownerDocument$q.before(this.querySelector(`${c4dPrefix}-global-banner`));
        }
        if (this.ownerDocument.querySelector(`${c4dPrefix}-global-banner`)) {
          var _this$_masthead;
          this.hasBanner = true;
          (_this$_masthead = this._masthead) === null || _this$_masthead === void 0 || _this$_masthead.setAttribute('with-banner', '');
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <c4d-dotcom-shell part="shell">
        <slot></slot>
      </c4d-dotcom-shell>
    `));
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, LitElement);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DDotcomShellComposite;
//# sourceMappingURL=dotcom-shell-composite.js.map
