import _decorate from "@babel/runtime/helpers/esm/decorate";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import ConnectMixin from "../../globals/mixins/connect.js";
import store from '../../internal/vendor/@carbon/ibmdotcom-services-store/store.js';
import { mapStateToProps as mapStateToPropsFooter, mapDispatchToProps as mapDispatchToPropsFooter } from "../footer/footer-container.js";
import { mapStateToProps as mapStateToPropsMasthead, mapDispatchToProps as mapDispatchToPropsMasthead } from "../masthead/masthead-container.js";
import C4DDotcomShellComposite from "./dotcom-shell-composite.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The Redux state used for `<c4d-dotcom-shell-container>`.
 */

/**
 * The properties for `<c4d-dotcom-shell-container>` from Redux state.
 */

/**
 * The Redux actions used for `<c4d-dotcom-shell-container>`.
 */

/**
 * @param state The Redux state for dotcom shell.
 * @returns The converted version of the given state, tailored for `<c4d-dotcomshell-container>`.
 */
export function mapStateToProps(state, self) {
  const footerProps = mapStateToPropsFooter(state);
  return _objectSpread(_objectSpread({}, mapStateToPropsMasthead(state, self)), Object.keys(footerProps).reduce((acc, key) => {
    acc[key !== 'links' ? key : 'footerLinks'] = footerProps[key];
    return acc;
  }, {}));
}

/**
 * @param dispatch The Redux `dispatch()` API.
 * @returns The methods in `<c4d-dotcomshell-container>` to dispatch Redux actions.
 */
export function mapDispatchToProps(dispatch) {
  return _objectSpread(_objectSpread({}, mapDispatchToPropsMasthead(dispatch)), mapDispatchToPropsFooter(dispatch));
}

/**
 * Container component for dotcom shell.
 *
 * @element c4d-dotcom-shell-container
 */
let C4DDotcomShellContainer = _decorate([customElement(`${c4dPrefix}-dotcom-shell-container`)], function (_initialize, _ConnectMixin) {
  class C4DDotcomShellContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DDotcomShellContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps, mapDispatchToProps)(C4DDotcomShellComposite));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DDotcomShellContainer;
//# sourceMappingURL=dotcom-shell-container.js.map
