import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DCardFooter from "../card/card-footer.js";
import styles from "././feature-card.css.js";
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Feature card footer.
 *
 * @element c4d-feature-card-footer
 */
let C4DFeatureCardFooter = _decorate([customElement(`${c4dPrefix}-feature-card-footer`)], function (_initialize, _C4DCardFooter) {
  class C4DFeatureCardFooter extends _C4DCardFooter {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFeatureCardFooter,
    d: [{
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet(C4DFeatureCardFooter, "updated", this, 3)([changedProperties]);
        const {
          _linkNode: linkNode
        } = this;
        if (linkNode) {
          linkNode.classList.remove(`${prefix}--link-with-icon`);
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DCardFooter);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DFeatureCardFooter;
//# sourceMappingURL=feature-card-footer.js.map
