import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2025
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DFeatureCard from "../feature-card/feature-card.js";
import "../image/image.js";
import styles from "././feature-section.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { COLOR_SCHEME, MEDIA_ALIGNMENT } from "./defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Feature Section.
 *
 * @element c4d-feature-section
 * @csspart grid - All grid itens. Usage: `c4d-feature-section::part(grid)`
 * @csspart grid--wrapper - The grid Wrapper. Usage: `c4d-feature-section::part(grid--wrapper)`
 * @csspart grid--body - Thw grid body. Usage: `c4d-feature-section::part(grid--body)`
 * @csspart row - All row items. Usage: `c4d-feature-section::part(row)`
 * @csspart row--container -  The row container. Usage: `c4d-feature-section::part(row--container)`
 * @csspart row--body -  The row body. Usage: `c4d-feature-section::part(row--body)`
 * @csspart col -  All column itens. Usage: `c4d-feature-section::part(col)`
 * @csspart col--body-wrapper - The column wrapper. Usage: `c4d-feature-section::part(col--body-wrapper)`
 * @csspart col--body -  The column body. Usage: `c4d-feature-section::part(col--body)`
 * @csspart col--image - The column image. Usage: `c4d-feature-section::part(col--image)`
 */
let C4DFeatureSection = _decorate([customElement(`${c4dPrefix}-feature-section`)], function (_initialize, _StableSelectorMixin) {
  class C4DFeatureSection extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFeatureSection,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'color-scheme',
        reflect: true
      })],
      key: "colorScheme",
      value() {
        return COLOR_SCHEME.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'media-alignment',
        reflect: true
      })],
      key: "mediaAlignment",
      value() {
        return MEDIA_ALIGNMENT.RIGHT;
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Color scheme type (regular (default) | inverse | cyan | purple )
       */

      function render() {
        return html(_t || (_t = _`
      ${0}
    `), this.mediaAlignment === MEDIA_ALIGNMENT.LEFT ? html(_t2 || (_t2 = _`
            <div
              class="${0}--grid ${0}--feature-section"
              part="grid grid--wrapper">
              <div
                class="${0}--row ${0}--feature-section__container"
                part="row row--container">
                <div
                  class="${0}--col-sm-4 ${0}--col-md-8 ${0}--col-lg-8 ${0}--feature-section__image"
                  part="col col--image">
                  <slot name="image"></slot>
                </div>
                <div
                  class="${0}--col-sm-4 ${0}--col-md-8 ${0}--col-lg-8 ${0}--feature-section__body"
                  part="col col--body-wrapper">
                  <div class="${0}--grid" part="grid grid--body">
                    <div class="${0}--row" part="row row--body">
                      <div
                        class="${0}--col-sm-4 ${0}--col-md-6 ${0}--col-lg-12"
                        part="col col--body">
                        <slot name="eyebrow"></slot>
                        <slot name="heading"></slot>
                        <slot name="copy"></slot>
                      </div>
                    </div>
                  </div>
                  <slot name="footer"></slot>
                </div>
              </div>
            </div>
          `), prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix) : html(_t3 || (_t3 = _`
            <div
              class="${0}--grid ${0}--feature-section"
              part="grid grid--wrapper">
              <div
                class="${0}--row ${0}--feature-section__container"
                part="row row--container">
                <div
                  class="${0}--col-sm-4 ${0}--col-md-8 ${0}--col-lg-8 ${0}--feature-section__body"
                  part="col col--body-wrapper">
                  <div class="${0}--grid" part="grid grid--body">
                    <div class="${0}--row" part="row row--body">
                      <div
                        class="${0}--col-sm-4 ${0}--col-md-6 ${0}--col-lg-12"
                        part="col col--body">
                        <slot name="eyebrow"></slot>
                        <slot name="heading"></slot>
                        <slot name="copy"></slot>
                      </div>
                    </div>
                  </div>
                </div>
                <div
                  class="${0}--col-sm-4 ${0}--col-md-8 ${0}--col-lg-8 ${0}--feature-section__image"
                  part="col col--image">
                  <slot name="image"></slot>
                  <slot name="footer"></slot>
                </div>
              </div>
            </div>
          `), prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix, prefix));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--feature-section`;
      }
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t4 || (_t4 = _`
      ${0}${0}
    `), _superPropGet(C4DFeatureSection, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DFeatureCard));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DFeatureSection;
//# sourceMappingURL=feature-section.js.map
