import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import CDSAccordion from '@carbon/web-components/es/components/accordion/accordion.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import "./filter-panel-input-select.js";
import styles from "././filter-panel.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Filter group renders the entire accordion group.
 *
 * @element c4d-filter-group
 */
let C4DFilterGroup = _decorate([customElement(`${c4dPrefix}-filter-group`)], function (_initialize, _StableSelectorMixin) {
  class C4DFilterGroup extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFilterGroup,
    d: [{
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * Extends CDSAccordion component
       */
      function () {
        return `${c4dPrefix}-filter-group`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(CDSAccordion));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DFilterGroup;
//# sourceMappingURL=filter-group.js.map
