import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././filter-panel.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The heading content of filter panel.
 *
 * @element c4d-filter-panel-heading
 */
let C4DFilterPanelHeading = _decorate([customElement(`${c4dPrefix}-filter-panel-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DFilterPanelHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFilterPanelHeading,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'heading';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The shadow slot this heading content should be in.
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'heading');
        }
        if (!this.hasAttribute('aria-level')) {
          this.setAttribute('aria-level', '1');
        }
        _superPropGet(C4DFilterPanelHeading, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "field",
      key: "_handleSlotChange",
      value() {
        return () => {
          const {
            eventChange
          } = this.constructor;
          this.dispatchEvent(new CustomEvent(eventChange, {
            bubbles: true,
            cancelable: true,
            composed: true
          }));
        };
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot @slotchange=${0}></slot> `), this._handleSlotChange);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--filter-panel-heading`;
      }

      /**
       * The event name when this element changes.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventChange",
      value: function () {
        return `${c4dPrefix}-filter-panel-heading-change`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DFilterPanelHeading;
//# sourceMappingURL=filter-panel-heading.js.map
