import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import Close from '@carbon/web-components/es/icons/close/16.js';
import FocusMixin from '@carbon/web-components/es/globals/mixins/focus.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././filter-panel.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * The input select inner dropdown.
 *
 * @element c4d-filter-panel-input-select-item
 * @csspart icon - The icon. `c4d-filter-panel-input-select-item::part(icon)`
 */
let C4DFilterPanelInputSelectItem = _decorate([customElement(`${c4dPrefix}-filter-panel-input-select-item`)], function (_initialize, _FocusMixin) {
  class C4DFilterPanelInputSelectItem extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFilterPanelInputSelectItem,
    d: [{
      kind: "field",
      decorators: [property()],
      key: "_title",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "selected",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "value",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * Property for the input select item value
       */

      /**
       * sets the input select dropdown to unselected
       */

      /**
       * Property for setting the value to a string.
       */

      /**
       * Handles `slotchange` event.
       *
       * @param event The event.
       * @param event.target The event target.
       */
      function _handleSlotChange({
        target
      }) {
        this._title = target.assignedNodes()[0].textContent;
        this.setAttribute('aria-label', `${this._title}, ${this.selected ? 'selected' : 'unselected'}`);
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('tabindex')) {
          this.setAttribute('tabindex', '0');
        }
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'button');
        }
        _superPropGet(C4DFilterPanelInputSelectItem, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('selected')) {
          this.setAttribute('aria-selected', `${String(Boolean(this.selected))}`);
          this.setAttribute('aria-label', `${this._title}, ${this.selected ? 'selected' : 'unselected'}`);
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <slot @slotchange=${0}></slot>
      <div class="${0}--close__icon" part="icon">
        ${0}
      </div>
    `), this._handleSlotChange, prefix, this.selected ? Close() : null);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}-filter-panel-input-select-item`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, FocusMixin(StableSelectorMixin(LitElement)));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DFilterPanelInputSelectItem;
//# sourceMappingURL=filter-panel-input-select-item.js.map
