import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6,
  _t7,
  _t8,
  _t9,
  _t10,
  _t11,
  _t12,
  _t13,
  _t14;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property, state } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import HostListenerMixin from '@carbon/web-components/es/globals/mixins/host-listener.js';
import LocaleAPI from '@carbon/ibmdotcom-services/es/services/Locale/Locale.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import MediaQueryMixin, { MQBreakpoints, MQDirs } from "../../component-mixins/media-query/media-query.js";
import HybridRenderMixin from "../../globals/mixins/hybrid-render.js";
import ModalRenderMixin from "../../globals/mixins/modal-render.js";
import { globalInit } from '@carbon/ibmdotcom-services/es/services/global/global.js';
import { FOOTER_SIZE } from "./footer.js";
import { DROPDOWN_SIZE } from "./combo-box.js";
// Above import is interface-only ref and thus code won't be brought into the build
// Above import is interface-only ref and thus code won't be brought into the build
// Above import is interface-only ref and thus code won't be brought into the build
import "./footer.js";
// Above import is interface-only ref and thus code won't be brought into the build
// Above import is interface-only ref and thus code won't be brought into the build
// Above import is interface-only ref and thus code won't be brought into the build
import "../locale-modal/locale-modal-composite.js";
import "./footer-logo.js";
import "./footer-nav.js";
import "./footer-nav-group.js";
import "./footer-nav-item.js";
import "./locale-button.js";
import "./legal-nav.js";
import "./legal-nav-item.js";
import "./legal-nav-cookie-preferences-placeholder.js";
import "./language-selector-desktop.js";
import "./language-selector-mobile.js";
import '@carbon/web-components/es/components/combo-box/combo-box-item.js';
import '@carbon/web-components/es/components/select/select-item.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import { moderate02 } from '@carbon/motion';
const {
  stablePrefix: c4dPrefix
} = settings;

// Delay matches the CSS animation timing for fadein/out of modal.
const delay = parseInt(moderate02, 10);

/**
 * Component that rendres footer from inks data.
 *
 * @element c4d-footer-composite
 */
let C4DFooterComposite = _decorate([customElement(`${c4dPrefix}-footer-composite`)], function (_initialize, _MediaQueryMixin) {
  class C4DFooterComposite extends _MediaQueryMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterComposite,
    d: [{
      kind: "method",
      key: "_handleClickLocaleButton",
      value:
      /**
       * Handles `click` event on the locale button.
       */
      async function _handleClickLocaleButton() {
        this.openLocaleModal = true;

        // Set 'open' attribute after modal is in dom so CSS can fade it in.
        this.updateComplete.then(() => {
          var _this$modalRenderRoot;
          const composite = (_this$modalRenderRoot = this.modalRenderRoot) === null || _this$modalRenderRoot === void 0 ? void 0 : _this$modalRenderRoot.querySelector(`${c4dPrefix}-locale-modal-composite`);
          composite === null || composite === void 0 || composite.setAttribute('open', '');
        });
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_isMobile",
      value() {
        return this.carbonBreakpoints.lg.matches;
      }
    }, {
      kind: "method",
      key: "mediaQueryCallbackMaxLG",
      value: function mediaQueryCallbackMaxLG() {
        this._isMobile = this.carbonBreakpoints.lg.matches;
      }

      /**
       * Handles `c4d-expressive-modal-closed` event on the locale modal.
       */
    }, {
      kind: "field",
      decorators: [HostListener('document:eventCloseModal')],
      key: "_handleCloseModal",
      value() {
        return event => {
          if (this.modalRenderRoot.contains(event.target)) {
            // Timeout here ensures the modal closing animation is visible.
            setTimeout(() => {
              this.openLocaleModal = false;
            }, delay);
          }
        };
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "buttonLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "navLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'clear-selection-label'
      })],
      key: "clearSelectionLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "collatorCountryName",
      value() {
        return new Intl.Collator();
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "langList",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'lang-display'
      })],
      key: "langDisplay",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'language-selector-label'
      })],
      key: "languageSelectorLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-language'
      })],
      key: "selectedLanguage",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "legalLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "adjunctLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "links",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "localeList",
      value: void 0
    }, {
      kind: "field",
      key: "modalTriggerProps",
      value() {
        return ['openLocaleModal', 'localeList'];
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'open-locale-modal'
      })],
      key: "openLocaleModal",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "size",
      value: void 0
    }, {
      kind: "method",
      key: "getLangDisplay",
      value:
      /**
       * The placeholder for `loadLocaleList()` Redux action that may be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `loadTranslation()` Redux action that may be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `setLanguage()` Redux action that may be mixed in.
       *
       * @internal
       */
      /**
       * The aria-label to use for the locale-button
       */
      /**
       * The aria-label to use for the legal-nav
       */
      /**
       * The clear button label for language selector.
       *
       * @internal
       */
      /**
       * The g11n collator to use for sorting contry names.
       */
      /**
       * `true` to omit the locale switcher button.
       */
      /**
       * The language used for query.
       */
      /**
       * Placeholder list of languages to populate language selector
       *
       * @internal
       */
      /**
       * The language to show in the UI.
       */
      /**
       * The placeholder label for language selector.
       *
       * @internal
       */
      /**
       * The initial selected language in the selector.
       *
       * @internal
       */
      /**
       * The legal nav links.
       */
      /**
       * The adjunct links.
       */
      /**
       * The footer links.
       */
      /**
       * The locale list.
       */
      /**
       * @inheritdoc
       */
      /**
       * `true` to open the locale modal.
       */
      /**
       * Footer size.
       */
      // eslint-disable-next-line class-methods-use-this
      async function getLangDisplay() {
        const response = await LocaleAPI.getLangDisplay();
        return response;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$_loadTranslatio;
        const {
          language
        } = this;
        globalInit();
        if (language) {
          var _this$_setLanguage;
          (_this$_setLanguage = this._setLanguage) === null || _this$_setLanguage === void 0 || _this$_setLanguage.call(this, language);
        }
        (_this$_loadTranslatio = this._loadTranslation) === null || _this$_loadTranslatio === void 0 || _this$_loadTranslatio.call(this, language);
        this.getLangDisplay().then(res => {
          this.langDisplay = res;
        });
        _superPropGet(C4DFooterComposite, "firstUpdated", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('language')) {
          const {
            language
          } = this;
          if (language) {
            var _this$_setLanguage2, _this$_loadTranslatio2;
            (_this$_setLanguage2 = this._setLanguage) === null || _this$_setLanguage2 === void 0 || _this$_setLanguage2.call(this, language);
            (_this$_loadTranslatio2 = this._loadTranslation) === null || _this$_loadTranslatio2 === void 0 || _this$_loadTranslatio2.call(this, language).catch(() => {}); // The error is logged in the Redux store
          }
        }
      }

      /**
       * @returns The locale modal.
       */
    }, {
      kind: "method",
      key: "renderModal",
      value: function renderModal() {
        const {
          collatorCountryName,
          langDisplay,
          language,
          localeList,
          openLocaleModal,
          _loadLocaleList: loadLocaleList
        } = this;
        return openLocaleModal ? html(_t || (_t = _`
          <c4d-locale-modal-composite
            lang-display="${0}"
            language="${0}"
            .collatorCountryName="${0}"
            .localeList="${0}"
            ._loadLocaleList="${0}">
          </c4d-locale-modal-composite>
        `), ifDefined(langDisplay), ifDefined(language), ifDefined(collatorCountryName), ifDefined(localeList), ifDefined(loadLocaleList)) : html(_t2 || (_t2 = _``));
      }
    }, {
      kind: "method",
      key: "renderLanguageSelector",
      value: function renderLanguageSelector(slot = 'language-selector') {
        const {
          clearSelectionLabel,
          _isMobile: isMobile,
          langList,
          languageSelectorLabel,
          selectedLanguage,
          size
        } = this;
        const dropdownSize = size === FOOTER_SIZE.MICRO ? DROPDOWN_SIZE.MICRO : DROPDOWN_SIZE.LARGE;
        return isMobile ? html(_t3 || (_t3 = _`
          <c4d-language-selector-mobile
            size="${0}"
            slot="${0}"
            value="${0}"
            placeholder="${0}">
            ${0}
          </c4d-language-selector-mobile>
        `), dropdownSize, slot, selectedLanguage, selectedLanguage, langList === null || langList === void 0 ? void 0 : langList.map(language => html(_t4 || (_t4 = _`
                <cds-select-item
                  label="${0}"
                  value="${0}"
                  lang="${0}"
                  >${0}</cds-select-item
                >
              `), ifDefined(language.text), ifDefined(language.text), ifDefined(language.id), ifDefined(language.text)))) : html(_t5 || (_t5 = _`
          <c4d-language-selector-desktop
            size="${0}"
            slot="${0}"
            trigger-content="${0}"
            label-text="${0}"
            label="${0}"
            value="${0}"
            clear-selection-label="${0}">
            ${0}
          </c4d-language-selector-desktop>
        `), dropdownSize, slot, languageSelectorLabel, languageSelectorLabel, languageSelectorLabel, selectedLanguage, clearSelectionLabel, langList === null || langList === void 0 ? void 0 : langList.map(language => html(_t6 || (_t6 = _`
                <cds-combo-box-item
                  value="${0}"
                  lang="${0}"
                  >${0}</cds-combo-box-item
                >
              `), ifDefined(language.text), ifDefined(language.id), ifDefined(language.text))));
      }
    }, {
      kind: "method",
      key: "renderLocaleButton",
      value: function renderLocaleButton(slot = 'locale-button') {
        const {
          buttonLabel,
          _handleClickLocaleButton: handleClickLocaleButton,
          langDisplay,
          size
        } = this;
        return html(_t7 || (_t7 = _`
      <c4d-locale-button
        buttonLabel="${0}"
        size="${0}"
        slot="${0}"
        @click="${0}"
        >${0}</c4d-locale-button
      >
    `), ifDefined(buttonLabel), size, slot, handleClickLocaleButton.bind(this), langDisplay);
      }
    }, {
      kind: "method",
      key: "renderLightDOM",
      value: function renderLightDOM() {
        const {
          disableLocaleButton,
          langList,
          size,
          links,
          legalLinks,
          adjunctLinks,
          navLabel
        } = this;
        return html(_t8 || (_t8 = _`
      <c4d-footer
        size="${0}"
        ?disable-locale-button="${0}">
        <c4d-footer-logo></c4d-footer-logo>
        ${0}
        ${0}
        ${0}

        <c4d-legal-nav
          size="${0}"
          navLabel="${0}">
          <c4d-footer-logo
            size="${0}"
            ?disable-locale-button="${0}"></c4d-footer-logo>
          ${0}
          ${0}
          <c4d-legal-nav-cookie-preferences-placeholder></c4d-legal-nav-cookie-preferences-placeholder>
          ${0}
          ${0}
        </c4d-legal-nav>
      </c4d-footer>
    `), ifDefined(size), ifDefined(disableLocaleButton), size !== FOOTER_SIZE.MICRO && size !== FOOTER_SIZE.SHORT ? html(_t9 || (_t9 = _` <c4d-footer-nav
              ?disable-locale-button="${0}">
              ${0}
              ${0}
              ${0}
            </c4d-footer-nav>`), ifDefined(disableLocaleButton), links === null || links === void 0 ? void 0 : links.map(({
          title: groupTitle,
          links: groupLinks
        }) => html(_t10 || (_t10 = _`
                  <c4d-footer-nav-group title-text="${0}">
                    ${0}
                  </c4d-footer-nav-group>
                `), ifDefined(groupTitle), groupLinks === null || groupLinks === void 0 ? void 0 : groupLinks.map(({
          title,
          url
        }) => html(_t11 || (_t11 = _`
                        <c4d-footer-nav-item href="${0}"
                          >${0}</c4d-footer-nav-item
                        >
                      `), ifDefined(url), title)))), !langList && !disableLocaleButton ? this.renderLocaleButton() : ``, langList && !disableLocaleButton ? this.renderLanguageSelector() : ``) : ``, (size === FOOTER_SIZE.SHORT || size === FOOTER_SIZE.MICRO) && !langList && !disableLocaleButton ? this.renderLocaleButton() : ``, (size === FOOTER_SIZE.SHORT || size === FOOTER_SIZE.MICRO) && langList && !disableLocaleButton ? this.renderLanguageSelector() : ``, ifDefined(size), ifDefined(navLabel), ifDefined(size), disableLocaleButton, legalLinks === null || legalLinks === void 0 ? void 0 : legalLinks.map(({
          title,
          url,
          titleEnglish
        }) => html(_t12 || (_t12 = _`
              <c4d-legal-nav-item
                autoid="${0}"
                href="${0}"
                >${0}</c4d-legal-nav-item
              >
            `), ifDefined(titleEnglish), ifDefined(url), title)), size !== FOOTER_SIZE.MICRO ? adjunctLinks === null || adjunctLinks === void 0 ? void 0 : adjunctLinks.map(({
          title,
          url,
          titleEnglish
        }) => html(_t13 || (_t13 = _`
                  <c4d-legal-nav-item
                    autoid="${0}"
                    href="${0}"
                    slot="adjunct-links">
                    ${0}
                  </c4d-legal-nav-item>
                `), ifDefined(titleEnglish), ifDefined(url), title)) : ``, size === FOOTER_SIZE.MICRO && !langList && !disableLocaleButton ? this.renderLocaleButton('locale') : ``, size === FOOTER_SIZE.MICRO && langList && !disableLocaleButton ? this.renderLanguageSelector('locale') : ``);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t14 || (_t14 = _` <slot></slot> `));
      }

      /**
       * The name of the custom event fired after this modal is closed upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventCloseModal",
      value: function () {
        return `${c4dPrefix}-expressive-modal-closed`;
      }
    }]
  };
}, MediaQueryMixin(ModalRenderMixin(HybridRenderMixin(HostListenerMixin(LitElement))), {
  [MQBreakpoints.LG]: MQDirs.MAX
}));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DFooterComposite;
//# sourceMappingURL=footer-composite.js.map
