import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html, LitElement } from 'lit';
import { property } from 'lit/decorators.js';
import FocusMixin from '@carbon/web-components/es/globals/mixins/focus.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import IBM8BarLogoH65White from '../../../es/icons/IBM-8bar-logo--h65-white.js';
import IBM8BarLogoH23White from '../../../es/icons/IBM-8bar-logo--h23-white.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { FOOTER_SIZE } from "./footer.js";
import styles from "././footer.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The IBM logo UI in footer.
 *
 * @element c4d-footer-logo
 */
let C4DFooterLogo = _decorate([customElement(`${c4dPrefix}-footer-logo`)], function (_initialize, _StableSelectorMixin) {
  class C4DFooterLogo extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterLogo,
    d: [{
      kind: "field",
      decorators: [property()],
      key: "href",
      value() {
        return 'https://www.ibm.com/';
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "size",
      value() {
        return FOOTER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'brand';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Link `href`.
       */

      /**
       * Size property used for applying classes
       */

      /**
       * The shadow slot this logo UI should be in.
       */

      function render() {
        const {
          href,
          size
        } = this;
        return html(_t || (_t = _`
      <a
        part="logo-link"
        class="${0}--footer-logo__link"
        aria-label="IBM logo"
        href="${0}">
        ${0}
        <slot></slot>
      </a>
    `), c4dPrefix, ifDefined(href), size !== FOOTER_SIZE.MICRO ? IBM8BarLogoH65White() : IBM8BarLogoH23White());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--footer-logo`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread(_objectSpread({}, LitElement.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(FocusMixin(LitElement)));
export default C4DFooterLogo;
//# sourceMappingURL=footer-logo.js.map
