import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import CDSLink from '@carbon/web-components/es/components/link/link.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././footer.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Footer nav item.
 *
 * @element c4d-footer-nav-item
 */
let C4DFooterNavItem = _decorate([customElement(`${c4dPrefix}-footer-nav-item`)], function (_initialize, _CDSLink) {
  class C4DFooterNavItem extends _CDSLink {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterNavItem,
    d: [{
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        const {
          titleText
        } = this;
        return html(_t || (_t = _` <slot>${0}</slot> `), titleText);
      }

      /**
       * The title.
       */
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'title-text'
      })],
      key: "titleText",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'listitem');
        }
        _superPropGet(C4DFooterNavItem, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated() {
        const {
          _linkNode: linkNode
        } = this;
        if (linkNode) {
          linkNode.classList.add(`${prefix}--footer__link`);
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSLink);
export default C4DFooterNavItem;
//# sourceMappingURL=footer-nav-item.js.map
