import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././footer.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Footer nav.
 *
 * @element c4d-footer-nav
 * @csspart nav-container - The nav container. Usage: `c4d-footer-nav::part(nav-container)`
 */
let C4DFooterNav = _decorate([customElement(`${c4dPrefix}-footer-nav`)], function (_initialize, _StableSelectorMixin) {
  class C4DFooterNav extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterNav,
    d: [{
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'navigation');
        }
        if (!this.hasAttribute('aria-label')) {
          this.setAttribute('aria-label', 'Footer navigation');
        }
        _superPropGet(C4DFooterNav, "connectedCallback", this, 3)([]);
      }

      /**
       * Update the CSS selectors depending on the locale button being rendered or not.
       */
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          disableLocaleButton
        } = this;
        const classes = {
          [`${prefix}--footer-nav__container`]: true,
          [`${prefix}--accordion`]: true,
          [`${prefix}--footer-nav__locale-button--disabled`]: disableLocaleButton
        };
        return html(_t || (_t = _`
      <ul part="nav-container" class=${0}>
        <slot></slot>
        <slot name="locale-button"></slot>
        <slot name="language-selector"></slot>
      </ul>
    `), classMap(classes));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--footer-nav`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
export default C4DFooterNav;
//# sourceMappingURL=footer-nav.js.map
