import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import EarthFilled16 from '@carbon/web-components/es/icons/earth--filled/16.js';
import FocusMixin from '@carbon/web-components/es/globals/mixins/focus.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { FOOTER_SIZE } from "./footer.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././footer.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Locale button.
 *
 * @element c4d-locale-button
 */
let C4DLocaleButton = _decorate([customElement(`${c4dPrefix}-locale-button`)], function (_initialize, _StableSelectorMixin) {
  class C4DLocaleButton extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLocaleButton,
    d: [{
      kind: "field",
      decorators: [property()],
      key: "buttonLabel",
      value() {
        return 'Select geographic area';
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "size",
      value() {
        return FOOTER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'locale-button';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Button label for accessibility.
       */

      /**
       * Size property to apply different styles.
       */

      /**
       * The shadow slot this locale button should be in.
       */

      function render() {
        const {
          buttonLabel
        } = this;
        return html(_t || (_t = _`
      <button
        part="locale-button"
        id="button"
        class="${0}--btn ${0}--btn--tertiary ${0}--locale-btn"
        aria-label="${0}">
        <slot></slot>
        ${0}
      </button>
    `), prefix, prefix, c4dPrefix, ifDefined(buttonLabel), EarthFilled16());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--locale-btn`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread(_objectSpread({}, LitElement.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(FocusMixin(LitElement)));
export default C4DLocaleButton;
//# sourceMappingURL=locale-button.js.map
