import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././global-banner.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DMarkdown from "../markdown/markdown.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The paragraph content in the global banner
 *
 * @element c4d-global-banner-copy
 */
let C4DGlobalBannerCopy = _decorate([customElement(`${c4dPrefix}-global-banner-copy`)], function (_initialize, _StableSelectorMixin) {
  class C4DGlobalBannerCopy extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DGlobalBannerCopy,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'copy';
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$querySelector;
        (_this$querySelector = this.querySelector('p')) === null || _this$querySelector === void 0 || _this$querySelector.setAttribute('style', 'all:unset;');
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}-global-banner-copy`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DMarkdown));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DGlobalBannerCopy;
//# sourceMappingURL=global-banner-copy.js.map
