import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentGroup from "../content-group/content-group.js";
import styles from "././in-page-banner.css.js";
import { COLOR_SCHEME } from "./defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * In Page Banner.
 *
 * @element c4d-in-page-banner
 */
let C4DInPageBanner = _decorate([customElement(`${c4dPrefix}-in-page-banner`)], function (_initialize, _StableSelectorMixin) {
  class C4DInPageBanner extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DInPageBanner,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'color-scheme',
        reflect: true
      })],
      key: "colorScheme",
      value() {
        return COLOR_SCHEME.REGULAR;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * Color scheme type (regular (default) | layer | cyan | purple )
       */

      function () {
        return `${c4dPrefix}--in-page-banner`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DInPageBanner, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentGroup));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DInPageBanner;
//# sourceMappingURL=in-page-banner.js.map
