/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { TemplateResult } from 'lit';
import C4DContentBlock from '../content-block/content-block';
/**
 * LeadSpace Block content Component.
 *
 * @element c4d-leadspace-block-content
 * @csspart children - The wrapper around child items. Usage: c4d-leadspace-block-content::part(children)
 */
declare class C4DLeadSpaceBlockContent extends C4DContentBlock {
    protected _renderInnerBody(): TemplateResult | string | void;
    connectedCallback(): void;
    render(): TemplateResult<1>;
    static get stableSelector(): string;
    static get styles(): import("lit").CSSResult;
}
export default C4DLeadSpaceBlockContent;

//# sourceMappingURL=leadspace-block-content.d.ts.map
