import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DContentBlock from "../content-block/content-block.js";
import styles from "././leadspace-block.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * LeadSpace Block content Component.
 *
 * @element c4d-leadspace-block-content
 * @csspart children - The wrapper around child items. Usage: c4d-leadspace-block-content::part(children)
 */
let C4DLeadSpaceBlockContent = _decorate([customElement(`${c4dPrefix}-leadspace-block-content`)], function (_initialize, _C4DContentBlock) {
  class C4DLeadSpaceBlockContent extends _C4DContentBlock {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeadSpaceBlockContent,
    d: [{
      kind: "method",
      key: "_renderInnerBody",
      value: function _renderInnerBody() {
        const {
          _hasContent: hasContent,
          _hasMedia: hasMedia
        } = this;
        return html(_t || (_t = _`
      <div
        ?hidden="${0}"
        class="${0}--content-block__children"
        part="children">
        ${0}${0}
      </div>
    `), !hasContent && !hasMedia, prefix, this._renderMedia(), this._renderContent());
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        /**
         * ensure link list heading is aria level 3 so that the headings in
         * leadspace block are hierarchical for accessibility purposes
         */
        const linkListHeading = this.querySelector('c4d-link-list-heading');
        if (linkListHeading) {
          linkListHeading.setAttribute('aria-level', '3');
        }
        _superPropGet(C4DLeadSpaceBlockContent, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t2 || (_t2 = _`
      <slot name="heading"></slot>
      ${0}
    `), this._renderBody());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--leadspace-block-content`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t3 || (_t3 = _`
      ${0}${0}
    `), _superPropGet(C4DLeadSpaceBlockContent, "styles", this), styles);
      }
    }]
  };
}, C4DContentBlock);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLeadSpaceBlockContent;
//# sourceMappingURL=leadspace-block-content.js.map
