import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DLeadspaceHeading from "../leadspace/leadspace-heading.js";
import styles from "././leadspace-block.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Heading content in leadspace block.
 *
 * @element c4d-leadspace-block-heading
 */
let C4DLeadspaceBlockHeading = _decorate([customElement(`${c4dPrefix}-leadspace-block-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DLeadspaceBlockHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeadspaceBlockHeading,
    d: [{
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--leadspace-block__heading`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DLeadspaceHeading));
console.warn('The leadspace-block-heading component has been deprecated in favor of leadspace-heading. ' + 'See leadspace-block documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLeadspaceBlockHeading;
//# sourceMappingURL=leadspace-block-heading.js.map
