import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././leadspace-with-search.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DContentBlockParagraph from "../content-block/content-block-paragraph.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Copy in the content section of Leadspace with search
 *
 * @element c4d-leadspace-with-search-copy
 */
let C4DLeadspaceWithSearchCopy = _decorate([customElement(`${c4dPrefix}-leadspace-with-search-copy`)], function (_initialize, _StableSelectorMixin) {
  class C4DLeadspaceWithSearchCopy extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeadspaceWithSearchCopy,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'copy';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * The shadow slot the content should be in.
       */

      function () {
        return `${c4dPrefix}--leadspace-with-search-content-copy`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DLeadspaceWithSearchCopy, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DContentBlockParagraph));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLeadspaceWithSearchCopy;
//# sourceMappingURL=leadspace-with-search-copy.js.map
