import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import CDSBreadcrumbLink from '@carbon/web-components/es/components/breadcrumb/breadcrumb-link.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././leadspace.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Breadcrumb link.
 *
 * @element c4d-breadcrumb-link
 */
let C4DBreadcrumbLink = _decorate([customElement(`${c4dPrefix}-breadcrumb-link`)], function (_initialize, _StableSelectorMixin) {
  class C4DBreadcrumbLink extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DBreadcrumbLink,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(CDSBreadcrumbLink));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DBreadcrumbLink;
//# sourceMappingURL=breadcrumb-link.js.map
