import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././leadspace.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The heading content of leadspace.
 *
 * @element c4d-leadspace-heading
 */
let C4DLeadspaceHeading = _decorate([customElement(`${c4dPrefix}-leadspace-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DLeadspaceHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeadspaceHeading,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'heading';
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "highlight",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'type-style'
      })],
      key: "typeStyle",
      value() {
        return 'display-01';
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "content",
      value: void 0
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The shadow slot this heading content should be in.
       */

      /**
       * The shadow slot this heading content should be in.
       */

      /**
       * The type style that can be used for the heading.
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'heading');
        }
        if (!this.hasAttribute('aria-level')) {
          this.setAttribute('aria-level', '1');
        }
        _superPropGet(C4DLeadspaceHeading, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        const textContent = this.innerText;
        const h1 = document.createElement('h1');
        h1.textContent = textContent;
        if (changedProperties.has('highlight') && this.highlight) {
          const index = textContent.indexOf(this.highlight);
          if (index !== -1) {
            const beforeSubstring = textContent.substring(0, index);
            const modifiedText = document.createElement('span');
            modifiedText.textContent = this.highlight;
            const afterSubstring = textContent.substring(index + this.highlight.length);
            this.replaceChildren(beforeSubstring, modifiedText, afterSubstring, h1);
          }
        } else {
          this.replaceChildren(textContent, h1);
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--leadspace-heading`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLeadspaceHeading;
//# sourceMappingURL=leadspace-heading.js.map
