/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { bindActionCreators } from 'redux';
import { loadTranslation } from '../../internal/vendor/@carbon/ibmdotcom-services-store/actions/translateAPI.js';
import { setLanguage } from '../../internal/vendor/@carbon/ibmdotcom-services-store/actions/localeAPI.js';

/**
 * The Redux state used for `<c4d-leaving-ibm-container>`.
 */

/**
 * The properties for `<c4d-leaving-ibm-container>` from Redux state.
 */

/**
 * The Redux actions used for `<c4d-leaving-ibm-container>`.
 */

/**
 * @param state The Redux state for leaving ibm component.
 * @returns The converted version of the given state, tailored for `<c4d-leaving-ibm-container>`.
 */
export function mapStateToProps(state) {
  var _translations$languag, _translations$languag2;
  const {
    localeAPI,
    translateAPI
  } = state;
  const {
    language
  } = localeAPI !== null && localeAPI !== void 0 ? localeAPI : {};
  const {
    translations
  } = translateAPI !== null && translateAPI !== void 0 ? translateAPI : {};
  return {
    leavingIbmCopy: !language ? undefined : translations === null || translations === void 0 || (_translations$languag = translations[language]) === null || _translations$languag === void 0 ? void 0 : _translations$languag.leaving,
    leavingIbmButtonLabel: !language ? undefined : translations === null || translations === void 0 || (_translations$languag2 = translations[language]) === null || _translations$languag2 === void 0 || (_translations$languag2 = _translations$languag2.misc) === null || _translations$languag2 === void 0 ? void 0 : _translations$languag2.continueText
  };
}

/**
 * @param dispatch The Redux `dispatch()` API.
 * @returns The methods in `<c4d-masthead-container>` to dispatch Redux actions.
 */
export function mapDispatchToProps(dispatch) {
  return bindActionCreators({
    _setLanguage: setLanguage,
    _loadTranslation: loadTranslation
  }, dispatch // TS definition of `bindActionCreators()` seems to have no templated `Dispatch`
  );
}
//# sourceMappingURL=leaving-ibm-connect.js.map
