import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import store from '../../internal/vendor/@carbon/ibmdotcom-services-store/store.js';
import ConnectMixin from "../../globals/mixins/connect.js";
import { mapStateToProps, mapDispatchToProps } from "./leaving-ibm-connect.js";
import C4DLeavingIbmComposite from "./leaving-ibm-composite.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Container component for masthead search.
 *
 * @element c4d-leaving-ibm-container
 */
let C4DLeavingIbmContainer = _decorate([customElement(`${c4dPrefix}-leaving-ibm-container`)], function (_initialize, _ConnectMixin) {
  class C4DLeavingIbmContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeavingIbmContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps, mapDispatchToProps)(C4DLeavingIbmComposite));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLeavingIbmContainer;
//# sourceMappingURL=leaving-ibm-container.js.map
