import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import CDSModal, { MODAL_SIZE } from '@carbon/web-components/es/components/modal/modal.js';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././leaving-ibm.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Leaving IBM Modal.
 *
 * @element c4d-leaving-ibm-modal
 */
let C4DLeavingIbmModal = _decorate([customElement(`${c4dPrefix}-leaving-ibm-modal`)], function (_initialize, _StableSelectorMixin) {
  class C4DLeavingIbmModal extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeavingIbmModal,
    d: [{
      kind: "field",
      key: "_uniqueId",
      value() {
        return `__${c4dPrefix}-leaving-ibm-modal__${Math.random().toString(36).slice(2)}`;
      }
    }, {
      kind: "field",
      decorators: [HostListener('shadowRoot:slotchange')],
      key: "_handleShadowRootSlotChange",
      value() {
        return event => {
          const {
            selectorHeading
          } = this.constructor;
          if (!this.hasAttribute('aria-labelledby')) {
            const headingNode = event.target.assignedNodes().reduce((acc, node) => {
              var _matches, _ref;
              if ((_matches = (_ref = node).matches) !== null && _matches !== void 0 && _matches.call(_ref, selectorHeading)) {
                acc.push(node);
              } else {
                var _querySelectorAll, _querySelectorAll2, _ref2;
                acc.push(...((_querySelectorAll = (_querySelectorAll2 = (_ref2 = node).querySelectorAll) === null || _querySelectorAll2 === void 0 ? void 0 : _querySelectorAll2.call(_ref2, selectorHeading)) !== null && _querySelectorAll !== void 0 ? _querySelectorAll : []));
              }
              return acc;
            }, [])[0];
            if (headingNode) {
              if (!headingNode.id) {
                const {
                  id,
                  _uniqueId: uniqueId
                } = this;
                headingNode.id = id || uniqueId;
              }
              if (headingNode.id) {
                this.setAttribute('aria-labelledby', headingNode.id);
              }
            }
          }
        };
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "size",
      value() {
        return MODAL_SIZE.SMALL;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The unique ID for ID ref.
       */

      /**
       * Handles `slotchange` event.
       *
       * @param event The event.
       */

      /**
       * Modal size.
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'dialog');
        }
        _superPropGet(C4DLeavingIbmModal, "connectedCallback", this, 3)([]);
      }

      /**
       * A selector selecting the heading.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorHeading",
      value: function () {
        return `${c4dPrefix}-leaving-ibm-modal-heading`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: // `styles` here is a `CSSResult` generated by custom WebPack loader
      function () {
        return `${c4dPrefix}--leaving-ibm-modal`;
      }
    }]
  };
}, StableSelectorMixin(CDSModal));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLeavingIbmModal;
//# sourceMappingURL=leaving-ibm-modal.js.map
