import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _2 = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import on from '@carbon/web-components/es/globals/mixins/on.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import ModalRenderMixin from "../../globals/mixins/modal-render.js";
import C4DVideoPlayerComposite from "../video-player/video-player-composite.js";
import "../expressive-modal/expressive-modal.js";
import "../expressive-modal/expressive-modal-close-button.js";
import { VIDEO_PLAYER_CONTENT_STATE, VIDEO_PLAYER_PLAYING_MODE } from "../video-player/video-player.js";
import "./lightbox-video-player.js";
import styles from "././lightbox-media-viewer.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Component that renders lightbox media viewer for video from its metadata, etc.
 *
 * @element c4d-lightbox-video-player-composite
 */
let C4DLightboxVideoPlayerComposite = _decorate([customElement(`${c4dPrefix}-lightbox-video-player-composite`)], function (_initialize, _ModalRenderMixin) {
  class C4DLightboxVideoPlayerComposite extends _ModalRenderMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLightboxVideoPlayerComposite,
    d: [{
      kind: "field",
      key: "_hCloseModal",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_handleAriaAndHiddenState",
      value() {
        return () => {
          const {
            _videoPlayer: videoPlayer
          } = this;
          const iFrame = videoPlayer === null || videoPlayer === void 0 ? void 0 : videoPlayer.querySelector('iframe');

          // Handles edge case where screen reader still reads video title within iFrame
          try {
            if (this.open) {
              var _iFrame$contentWindow;
              iFrame === null || iFrame === void 0 || (_iFrame$contentWindow = iFrame.contentWindow) === null || _iFrame$contentWindow === void 0 || (_iFrame$contentWindow = _iFrame$contentWindow.document.querySelector('.topBarContainer')) === null || _iFrame$contentWindow === void 0 || _iFrame$contentWindow.removeAttribute('aria-hidden');
            } else {
              var _iFrame$contentWindow2;
              iFrame === null || iFrame === void 0 || (_iFrame$contentWindow2 = iFrame.contentWindow) === null || _iFrame$contentWindow2 === void 0 || (_iFrame$contentWindow2 = _iFrame$contentWindow2.document.querySelector('.topBarContainer')) === null || _iFrame$contentWindow2 === void 0 || _iFrame$contentWindow2.setAttribute('aria-hidden', 'true');
            }
          } catch (error) {
            // eslint-disable-next-line no-console
            console.log('Failed to access element in iframe');
            throw error;
          }
          const {
            selectorEmbeddedVideoContainer
          } = this.constructor;
          const elems = Array.prototype.slice.call(videoPlayer === null || videoPlayer === void 0 ? void 0 : videoPlayer.querySelectorAll(selectorEmbeddedVideoContainer));
          elems.forEach(element => {
            element.toggleAttribute('hidden', element.dataset.videoId !== this.videoId);
          });
        };
      }
    }, {
      kind: "field",
      key: "_handleCloseModal",
      value() {
        return () => {
          const {
            embeddedVideos = {},
            videoId
          } = this;
          const {
            [videoId]: currentEmbeddedVideo
          } = embeddedVideos;
          if (currentEmbeddedVideo) {
            currentEmbeddedVideo.sendNotification('doStop');
          }
          this.open = false;
          this._handleAriaAndHiddenState();
        };
      }
    }, {
      kind: "method",
      key: "_handleContentStateChange",
      value:
      /**
       * The handle for the listener of `${c4dPrefix}-expressive-modal-closed` event.
       */

      /**
       * Handles aria state depending on the modal's state.
       */

      /**
       * The handler of `${c4dPrefix}-expressive-modal-closed` event from `<c4d-expressive-modal>`.
       */

      // eslint-disable-next-line class-methods-use-this, @typescript-eslint/no-unused-vars
      function _handleContentStateChange(_) {}
    }, {
      kind: "field",
      decorators: [HostListener('document:eventContentStateChange')],
      key: "_handleContentStateChangeDocument",
      value() {
        return event => {
          const {
            contentState,
            playingMode,
            videoId: requestedVideoId,
            name,
            customVideoDescription
          } = event.detail;
          if (this.videoCtaLightBox === false) {
            this.videoId = requestedVideoId;
            const {
              videoId
            } = this;
            if (contentState === VIDEO_PLAYER_CONTENT_STATE.VIDEO && videoId === requestedVideoId && playingMode === VIDEO_PLAYER_PLAYING_MODE.LIGHTBOX) {
              this.customVideoName = name;
              this.open = true;
              this.customVideoDescription = customVideoDescription;
            }
          }
        };
      }
    }, {
      kind: "get",
      key: "_videoPlayer",
      value:
      /**
       * The video player.
       */
      function () {
        var _this$modalRenderRoot, _this$modalRenderRoot2;
        const {
          selectorVideoPlayer
        } = this.constructor;
        return (_this$modalRenderRoot = this.modalRenderRoot) === null || _this$modalRenderRoot === void 0 || (_this$modalRenderRoot2 = _this$modalRenderRoot.querySelector) === null || _this$modalRenderRoot2 === void 0 ? void 0 : _this$modalRenderRoot2.call(_this$modalRenderRoot, selectorVideoPlayer);
      }

      /**
       * `true` if the modal should be open.
       */
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "open",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'custom-video-name'
      })],
      key: "customVideoName",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'custom-video-description'
      })],
      key: "customVideoDescription",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'video-cta-lightbox'
      })],
      key: "videoCtaLightBox",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       *
       */
      /**
       *
       */
      /**
       * `true` if the modal is rendered for video cta component.
       */
      function connectedCallback() {
        _superPropGet(C4DLightboxVideoPlayerComposite, "connectedCallback", this, 3)([]);
        this.modalRenderRoot = this.createModalRenderRoot(); // Creates modal render root up-front to hook the event listener
        // Manually hooks the event listeners on the modal render root to make the event names configurable
        this._hCloseModal = on(this.modalRenderRoot, this.constructor.eventCloseModal, this._handleCloseModal);
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        if (this._hCloseModal) {
          this._hCloseModal = this._hCloseModal.release();
        }
        _superPropGet(C4DLightboxVideoPlayerComposite, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('open') || changedProperties.has('videoId')) {
          const {
            open,
            videoId
          } = this;
          this._activateEmbeddedVideo(!open ? '' : videoId);
          if (videoId) {
            var _this$_loadVideoData;
            (_this$_loadVideoData = this._loadVideoData) === null || _this$_loadVideoData === void 0 || _this$_loadVideoData.call(this, videoId);
            if (open) {
              var _this$_embedMedia;
              (_this$_embedMedia = this._embedMedia) === null || _this$_embedMedia === void 0 || _this$_embedMedia.call(this, videoId);
              this._handleAriaAndHiddenState();
            }
          }
        }
      }
    }, {
      kind: "method",
      key: "renderLightDOM",
      value: function renderLightDOM() {
        // In this class we render that in modal instead of in light DOM.
        // Overriding `.renderLightDOM()` here
        // to prevent the parent `<c4d-video-player-composite>` from rendering `<c4d-video-player>` in light DOM.
        return html(_t || (_t = _2``));
      }
    }, {
      kind: "method",
      key: "renderModal",
      value: function renderModal() {
        const {
          formatCaption,
          formatDuration,
          customVideoName,
          hideCaption,
          open,
          mediaData = {},
          videoId,
          customVideoDescription
        } = this;
        const {
          [videoId]: currentVideoData = {}
        } = mediaData;
        const {
          description,
          duration,
          name
        } = currentVideoData;
        const videoName = customVideoName || name;
        const videoDescription = customVideoDescription || description;
        return html(_t2 || (_t2 = _2`
      <c4d-expressive-modal
        ?open="${0}"
        expressive-size="full-width"
        mode="lightbox"
        part="modal">
        <c4d-expressive-modal-close-button
          part="close-button"></c4d-expressive-modal-close-button>
        <c4d-lightbox-video-player
          description="${0}"
          duration="${0}"
          name="${0}"
          ?hide-caption="${0}"
          .formatCaption="${0}"
          .formatDuration="${0}"
          part="lightbox-video-player">
        </c4d-lightbox-video-player>
      </c4d-expressive-modal>
    `), open, ifDefined(videoDescription), ifDefined(duration), ifDefined(videoName), hideCaption, ifDefined(formatCaption), ifDefined(formatDuration));
      }

      /**
       * A selector selecting the video player component.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorVideoPlayer",
      value: function () {
        return `${c4dPrefix}-lightbox-video-player`;
      }

      /**
       * The name of the custom event fired after the modal is closed upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventCloseModal",
      value: function () {
        return `${c4dPrefix}-expressive-modal-closed`;
      }

      /**
       * A selector selecting the container DOM elements for embedding video.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorEmbeddedVideoContainer",
      value: function () {
        return '[data-video-id]';
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, ModalRenderMixin(C4DVideoPlayerComposite));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLightboxVideoPlayerComposite;
//# sourceMappingURL=lightbox-video-player-composite.js.map
