import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import store from '../../internal/vendor/@carbon/ibmdotcom-services-store/store.js';
import ConnectMixin from "../../globals/mixins/connect.js";
import { C4DVideoPlayerContainerMixin, mapStateToProps, mapDispatchToProps } from "../video-player/video-player-container.js";
import C4DLightboxVideoPlayerComposite from "./lightbox-video-player-composite.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Container component for lightbox media viewer, works with video data.
 *
 * @element c4d-lightbox-video-player-container
 */
let C4DLightboxVideoPlayerContainer = _decorate([customElement(`${c4dPrefix}-lightbox-video-player-container`)], function (_initialize, _ConnectMixin) {
  class C4DLightboxVideoPlayerContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLightboxVideoPlayerContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps, mapDispatchToProps)(C4DVideoPlayerContainerMixin(C4DLightboxVideoPlayerComposite)));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLightboxVideoPlayerContainer;
//# sourceMappingURL=lightbox-video-player-container.js.map
