/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DLinkWithIcon from '../link-with-icon/link-with-icon';
import { LINK_LIST_ITEM_TYPE } from './defs';
/**
 * Link list item.
 *
 * @element c4d-link-list-item
 */
declare class C4DLinkListItem extends C4DLinkWithIcon {
    /**
     * Defines the style of the link-list-item: `default` or `end`
     */
    type: LINK_LIST_ITEM_TYPE;
    /**
     * Positions the icon inline with text when `true`
     */
    iconInline: boolean;
    connectedCallback(): void;
    static get stableSelector(): string;
    static get styles(): import("lit").CSSResult;
}
export default C4DLinkListItem;

//# sourceMappingURL=link-list-item.d.ts.map
