import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DLinkWithIcon from "../link-with-icon/link-with-icon.js";
import styles from "././link-list.css.js";
import { LINK_LIST_ITEM_TYPE } from "./defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Link list item.
 *
 * @element c4d-link-list-item
 */
let C4DLinkListItem = _decorate([customElement(`${c4dPrefix}-link-list-item`)], function (_initialize, _C4DLinkWithIcon) {
  class C4DLinkListItem extends _C4DLinkWithIcon {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLinkListItem,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "type",
      value() {
        return LINK_LIST_ITEM_TYPE.DEFAULT;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean
      })],
      key: "iconInline",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * Defines the style of the link-list-item: `default` or `end`
       */

      /**
       * Positions the icon inline with text when `true`
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'listitem');
        }
        _superPropGet(C4DLinkListItem, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--link-list-item`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DLinkListItem, "styles", this), styles);
      }
    }]
  };
}, C4DLinkWithIcon);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLinkListItem;
//# sourceMappingURL=link-list-item.js.map
