/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import CDSLink from '@carbon/web-components/es/components/link/link.js';
/**
 * Locale item.
 *
 * @element c4d-locale-item
 * @csspart country - the country text container. Usage: `c4d-locale-item::part(country)`
 * @csspart language - the language text container. Usage: `c4d-locale-item::part(language)`
 */
declare class C4DLocaleItem extends CDSLink {
    /**
     * The country.
     */
    country: string;
    /**
     * The language.
     */
    language: string;
    /**
     * The locale ID.
     */
    locale: string;
    /**
     * The region the country is in.
     */
    region: string;
    /**
     * Element's role for assistive technologies
     */
    role: string;
    /**
     * method to handle when country/region has been selected
     * sets the ipcInfo cookie with selected locale
     */
    _handleClick(): void;
    /**
     * @returns The inner content.
     */
    _renderInner(): import("lit-html").TemplateResult<1>;
    static styles: any;
}
export default C4DLocaleItem;

//# sourceMappingURL=locale-item.d.ts.map
