/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DCard from '../card/card';
/**
 * Region item.
 *
 * @element c4d-region-item
 * @csspart button - Targets all buttons  - Usage: `c4d-region-item::part(button)`
 * @csspart button--disabled - The disabled button - Usage: `c4d-region-item::part(button--disabled)`
 * @csspart button--enabled - The enabled button - Usage: `:c4d-region-item:part(button--enabled)`
 * @csspart content- Targets all content wrappers - Usage: `c4d-region-item::part(content)`
 * @csspart disabled-content - The disabled content wrapper - Usage: `c4d-region-item::part(disabled-content)`
 * @csspart enabled-content - The enabled content wrapper - Usage: `:c4d-region-item:part(enabled-content)`
 */
declare class C4DRegionItem extends C4DCard {
    /**
     * `true` if this region has no countries.
     */
    disabled: boolean;
    /**
     * The region name.
     */
    name: string;
    protected _cardClasses: import("lit-html/directive").DirectiveResult<typeof import("lit-html/directives/class-map").ClassMapDirective>;
    /**
     * @returns The disabled link content.
     */
    protected _renderDisabledLink(): import("lit-html").TemplateResult<1>;
    render(): import("lit-html").TemplateResult<1>;
    updated(changedProperties: any): void;
    static get styles(): import("lit").CSSResult;
}
export default C4DRegionItem;

//# sourceMappingURL=region-item.d.ts.map
