import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html, css } from 'lit';
import { classMap } from 'lit/directives/class-map.js';
import { property } from 'lit/decorators.js';
import C4DCard from "../card/card.js";
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././locale-modal.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Region item.
 *
 * @element c4d-region-item
 * @csspart button - Targets all buttons  - Usage: `c4d-region-item::part(button)`
 * @csspart button--disabled - The disabled button - Usage: `c4d-region-item::part(button--disabled)`
 * @csspart button--enabled - The enabled button - Usage: `:c4d-region-item:part(button--enabled)`
 * @csspart content- Targets all content wrappers - Usage: `c4d-region-item::part(content)`
 * @csspart disabled-content - The disabled content wrapper - Usage: `c4d-region-item::part(disabled-content)`
 * @csspart enabled-content - The enabled content wrapper - Usage: `:c4d-region-item:part(enabled-content)`
 */
let C4DRegionItem = _decorate([customElement(`${c4dPrefix}-region-item`)], function (_initialize, _C4DCard) {
  class C4DRegionItem extends _C4DCard {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DRegionItem,
    d: [{
      kind: "field",
      decorators: [property({
        type: Boolean
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "name",
      value() {
        return '';
      }
    }, {
      kind: "field",
      key: "_cardClasses",
      value() {
        return classMap({
          [`${prefix}--tile`]: true,
          [`${prefix}--card`]: true,
          [`${prefix}--tile--clickable`]: true,
          [`${prefix}--card--link`]: true
        });
      }
    }, {
      kind: "method",
      key: "_renderDisabledLink",
      value:
      /**
       * `true` if this region has no countries.
       */

      /**
       * The region name.
       */

      /**
       * @returns The disabled link content.
       */
      function _renderDisabledLink() {
        const {
          _classes: classes,
          _cardClasses: cardClasses
        } = this;
        return html(_t || (_t = _`
      <button
        id="link"
        class="${0}"
        disabled
        type="button"
        part="button button--disabled">
        <div class="${0}" part="content disabled-content">
          ${0}
        </div>
      </button>
    `), classes, cardClasses, this._renderInner());
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _classes: classes,
          disabled,
          _cardClasses: cardClasses
        } = this;
        return disabled ? this._renderDisabledLink() : html(_t2 || (_t2 = _`
          <button
            id="link"
            class="${0}"
            type="button"
            part="button button--enabled">
            <div class="${0}" part="content enabled-content">
              ${0}
            </div>
          </button>
        `), classes, cardClasses, this._renderInner());
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('name')) {
          const {
            name
          } = this;
          this.dataset.autoId = `${c4dPrefix}--locale-modal__geo-btn-${name}`;
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t3 || (_t3 = _`
      ${0}${0}
    `), _superPropGet(C4DRegionItem, "styles", this), styles);
      }
    }]
  };
}, C4DCard);
export default C4DRegionItem;
//# sourceMappingURL=region-item.js.map
