import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././logo-grid.css.js";
import C4DImage from "../image/image.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Logo-grid-item.
 *
 * @element c4d-logo-grid-item
 * @csspart logo - the logo container - Usage: `4d-logo-grid-item::part(logo)`
 */
let C4DLogoGridItem = _decorate([customElement(`${c4dPrefix}-logo-grid-item`)], function (_initialize, _StableSelectorMixin) {
  class C4DLogoGridItem extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLogoGridItem,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      // `styles` here is a `CSSResult` generated by custom WebPack loader

      function () {
        return `${c4dPrefix}--logo-grid-item`;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <div class="cds--logo-grid__logo" part="logo">${0}</div>
    `), _superPropGet(C4DLogoGridItem, "render", this, 3)([]));
      }
    }]
  };
}, StableSelectorMixin(C4DImage));
console.warn('The logo-grid-item component has been deprecated in favor of the content-section/block and image-group component. ' +
//TODO confirm new image-group or images in grid
'See content-section/block and image-group documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLogoGridItem;
//# sourceMappingURL=logo-grid-item.js.map
