import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { css } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././logo-grid.css.js";
import C4DCardLink from "../card-link/card-link.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Logo-grid-link.
 *
 * @element c4d-logo-grid-link
 */
let C4DLogoGridLink = _decorate([customElement(`${c4dPrefix}-logo-grid-link`)], function (_initialize, _StableSelectorMixin) {
  class C4DLogoGridLink extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLogoGridLink,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'footer';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * The shadow slot this link should be in.
       */

      function () {
        return `${c4dPrefix}--logo-grid-link`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DLogoGridLink, "styles", this), styles);
      }
    }]
  };
}, StableSelectorMixin(C4DCardLink));
console.warn('The logo-grid-link component has been deprecated in favor of the content-section/block and image-group component. ' +
//TODO confirm new image-group or images in grid
'See content-section/block and image-group documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DLogoGridLink;
//# sourceMappingURL=logo-grid-link.js.map
