import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { unsafeHTML } from 'lit/directives/unsafe-html.js';
import { LitElement, html, render } from 'lit';
import { property } from 'lit/decorators.js';
import '@carbon/web-components/es/components/link/link.js';
import '@carbon/web-components/es/components/list/ordered-list.js';
import '@carbon/web-components/es/components/list/unordered-list.js';
import '@carbon/web-components/es/components/list/list-item.js';
import markdownToHtml from '@carbon/ibmdotcom-utilities/es/utilities/markdownToHtml/markdownToHtml.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././markdown.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Markdown content.
 *
 * @element c4d-markdown
 * @csspart link - The custom link element. Usage: `c4d-markdown::part(link)`
 * @csspart ordered-list - The ordered list element. Usage: `c4d-markdown::part(ordered-list)`
 * @csspart unordered-list - The unordered list element. Usage: `c4d-markdown::part(unordered-list)`
 * @csspart list - The list element. Usage: `c4d-markdown::part(list)`
 * @csspart list-item - The list item element. Usage: `c4d-markdown::part(list-item)`
 */
let C4DMarkdown = _decorate([customElement(`${c4dPrefix}-markdown`)], function (_initialize, _LitElement) {
  class C4DMarkdown extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMarkdown,
    d: [{
      kind: "field",
      key: "_hasRendered",
      value() {
        return false;
      }
    }, {
      kind: "get",
      key: "_customTags",
      value:
      /**
       * `true` if the first rendering has happened.
       */

      /**
       * The list of custom element tags that is rendered by our custom renderer.
       */
      // eslint-disable-next-line class-methods-use-this
      function () {
        return new Set([`${prefix}-link`, `${prefix}-ordered-list`, `${prefix}-unordered-list`, `${prefix}-list-item`]);
      }

      /**
       * The custom renderer for the markup parser.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "get",
      key: "_renderer",
      value: function () {
        return {
          link(href, title, text) {
            return `<${prefix}-link href="${href}" size="lg" ${title ? `title="${title}"` : ''} part="link">${text}</${prefix}-link>`;
          },
          list(body, ordered) {
            const tag = `${prefix}-${ordered ? 'ordered' : 'unordered'}-list`;
            return `<${tag} part="${ordered ? 'list ordered-list' : 'list unordered-list'}">${body}</${tag}>`;
          },
          listitem(text) {
            return `<${prefix}-list-item part="list-item">${text}</${prefix}-list-item>`;
          }
        };
      }

      /**
       * The markdown content.
       */
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "content",
      value: void 0
    }, {
      kind: "method",
      key: "update",
      value: function update(changedProperties) {
        _superPropGet(C4DMarkdown, "update", this, 3)([changedProperties]);
        const {
          content,
          _customTags: customTags,
          textContent,
          _hasRendered: hasRendered,
          _renderer: renderer
        } = this;
        if (!hasRendered && !this.firstElementChild) {
          const lightDOMTemplateResult = html(_t || (_t = _`
        ${0}
      `), unsafeHTML(markdownToHtml(content !== null && content !== void 0 ? content : hasRendered ? '' : textContent, {
            customTags,
            renderer
          })));
          this._hasRendered = true;
          this.innerText = ''; // avoid text rendering twice
          render(lightDOMTemplateResult, this);
        }
        this.querySelectorAll('cds-ordered-list, cds-unordered-list').forEach(e => {
          e.setAttribute('isExpressive', '');
        });
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t2 || (_t2 = _` <slot></slot> `));
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, LitElement);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DMarkdown;
//# sourceMappingURL=markdown.js.map
