/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { LitElement } from 'lit';
/**
 * MegaMenu Category Group Description.
 *
 * @element c4d-megamenu-category-group-desc
 * @csspart heading - The h2 element of the left navigation menu category heading. Usage: `c4d-left-nav-menu-category-heading::part(heading)`
 * @csspart heading-link - The link element of the left navigation menu category heading. Usage: `c4d-left-nav-menu-category-heading::part(heading-link)`
 * @csspart container - The side navigation heading container. Usage: `c4d-left-nav-menu-category-heading::part(container)`
 * @csspart description - The description container within the side navigation heading. Usage: `c4d-left-nav-menu-category-heading::part(description)`
 */
declare class C4DLeftNavMenuCategoryHeading extends LitElement {
    headingText?: string;
    url?: string;
    boostSize?: boolean;
    updated(changedProperties: any): void;
    _renderHeading(): import("lit-html").TemplateResult<1>;
    render(): import("lit-html").TemplateResult<1>;
    static styles: any;
}
export default C4DLeftNavMenuCategoryHeading;

//# sourceMappingURL=left-nav-menu-category-heading.d.ts.map
