import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { classMap } from 'lit/directives/class-map.js';
import { html } from 'lit';
import { property } from 'lit/decorators.js';
import ArrowRight16 from '@carbon/web-components/es/icons/arrow--right/16.js';
import ArrowLeft16 from '@carbon/web-components/es/icons/arrow--left/16.js';
import CDSSideNavMenuItem from '@carbon/web-components/es/components/ui-shell/side-nav-menu-item.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Masthead left nav submenu item.
 *
 * @element c4d-left-nav-menu-item
 * @csspart link - The link. Usage `c4d-left-nav-menu-item(link)`
 * @csspart title - The title. Usage `c4d-left-nav-menu-item(title)`
 */
let C4DLeftNavMenuItem = _decorate([customElement(`${c4dPrefix}-left-nav-menu-item`)], function (_initialize, _CDSSideNavMenuItem) {
  class C4DLeftNavMenuItem extends _CDSSideNavMenuItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeftNavMenuItem,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'is-heading'
      })],
      key: "isHeading",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'is-view-all'
      })],
      key: "isViewAll",
      value: void 0
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet(C4DLeftNavMenuItem, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('isHeading')) {
          this.classList.toggle(`${prefix}--side-nav__group-header`, this.isHeading);
        }
        if (changedProperties.has('isViewAll')) {
          this.classList.toggle(`${prefix}--side-nav__group-view-all`, this.isViewAll);
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          active,
          href,
          title,
          isHeading,
          isViewAll
        } = this;
        const isRTL = document.dir.toLowerCase() === 'rtl';
        const Arrow = isRTL ? ArrowLeft16 : ArrowRight16;
        const linkClasses = classMap({
          [`${prefix}--side-nav__link`]: true,
          [`${prefix}--side-nav__link--current`]: active
        });
        return href ? html(_t || (_t = _`
          <a
            part="link"
            class="${0}"
            href="${0}"
            data-attribute1="headerNav"
            data-attribute2="FlatItem"
            data-attribute3="${0}">
            <span part="title" class="${0}--side-nav__link-text">
              <slot>${0}</slot>
              ${0}
            </span>
          </a>
        `), linkClasses, href, title, prefix, title, isHeading || isViewAll ? Arrow() : '') : html(_t2 || (_t2 = _`
          <span part="link" class="${0}">
            <span part="title" class="${0}--side-nav__link-text">
              <slot>${0}</slot>
            </span>
          </span>
        `), linkClasses, prefix, title);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSSideNavMenuItem);
export default C4DLeftNavMenuItem;
//# sourceMappingURL=left-nav-menu-item.js.map
