/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import CDSHeaderName from '@carbon/web-components/es/components/ui-shell/header-name.js';
/**
 * The brand name UI in left nav.
 *
 * @element c4d-left-nav-name
 * @csspart side-nav-submenu - The side navigation submenu. Usage: `c4d-left-nav-name::part(side-nav-submenu)`
 * @csspart side-nav-name-prefix - The prefix for the side navigation name. Usage: `c4d-left-nav-name::part(side-nav-name-prefix)`
 */
declare class C4DLeftNavName extends CDSHeaderName {
    /**
     * Set slot name property.
     */
    slot: string;
    connectedCallback(): void;
    render(): import("lit-html").TemplateResult<1>;
    static styles: any;
}
export default C4DLeftNavName;

//# sourceMappingURL=left-nav-name.d.ts.map
