import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import CDSHeaderName from '@carbon/web-components/es/components/ui-shell/header-name.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import C4DLeftNav from "./left-nav.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * The brand name UI in left nav.
 *
 * @element c4d-left-nav-name
 * @csspart side-nav-submenu - The side navigation submenu. Usage: `c4d-left-nav-name::part(side-nav-submenu)`
 * @csspart side-nav-name-prefix - The prefix for the side navigation name. Usage: `c4d-left-nav-name::part(side-nav-name-prefix)`
 */
let C4DLeftNavName = _decorate([customElement(`${c4dPrefix}-left-nav-name`)], function (_initialize, _CDSHeaderName) {
  class C4DLeftNavName extends _CDSHeaderName {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeftNavName,
    d: [{
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'slot',
        reflect: true
      })],
      key: "slot",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * Set slot name property.
       */

      function connectedCallback() {
        _superPropGet(C4DLeftNavName, "connectedCallback", this, 3)([]);
        if (this.parentElement instanceof C4DLeftNav) {
          this.slot = 'platform-id';
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          href,
          prefix: namePrefix
        } = this;
        const namePrefixPart = !namePrefix ? undefined : html(_t || (_t = _`
          <span
            class="${0}--header__name--prefix"
            part="side-nav-name-prefix"
            >${0}</span
          >&nbsp;
        `), prefix, namePrefix);
        return html(_t2 || (_t2 = _`
      <a
        part="side-nav-submenu"
        class="${0}--side-nav__submenu ${0}--side-nav__submenu-platform"
        href="${0}">
        ${0}
        <slot></slot>
      </a>
    `), prefix, prefix, ifDefined(href), namePrefixPart);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSHeaderName);
export default C4DLeftNavName;
//# sourceMappingURL=left-nav-name.js.map
