import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import styles from "././masthead.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Left nav overlay.
 *
 * @element c4d-left-nav-overlay
 */
let C4DLeftNavOverlay = _decorate([customElement(`${c4dPrefix}-left-nav-overlay`)], function (_initialize, _LitElement) {
  class C4DLeftNavOverlay extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeftNavOverlay,
    d: [{
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * `true` if this overlay should represent its active state.
       */

      function connectedCallback() {
        _superPropGet(C4DLeftNavOverlay, "connectedCallback", this, 3)([]);
        if (this.closest('[dir]')) {
          this.dir = this.closest('[dir]').dir;
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, LitElement);
export default C4DLeftNavOverlay;
//# sourceMappingURL=left-nav-overlay.js.map
