import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2024
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */

import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { html, LitElement } from 'lit';
import { property, state } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import ShoppingCart20 from '@carbon/web-components/es/icons/shopping--cart/20.js';
import styles from "././masthead.css.js";
import LocaleAPI from '@carbon/ibmdotcom-services/es/services/Locale/Locale.js';
import SAPCommerceAPI from '@carbon/ibmdotcom-services/es/services/SAPCommerce/SAPCommerce.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * The Cart icon in the masthead.
 *
 * @element c4d-masthead-cart
 * @csspart cart-link - The masthead cart link. Usage: `c4d-masthead-cart::part(cart-link)`
 */
let C4DMastheadCart = _decorate([customElement(`${c4dPrefix}-masthead-cart`)], function (_initialize, _StableSelectorMixin) {
  class C4DMastheadCart extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadCart,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'link-label'
      })],
      key: "linkLabel",
      value() {
        return 'Cart';
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "hasActiveCart",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "locale",
      value() {
        return {
          lc: 'en',
          cc: 'us'
        };
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The `aria-label` attribute for the link.
       */

      /**
       * Tracks whether the user has an active cart to control the display.
       */

      /**
       * Store the locale. Defaults to en-us.
       */

      function connectedCallback() {
        _superPropGet(C4DMastheadCart, "connectedCallback", this, 3)([]);
        // Check the relevant cookie for whether the user has an active cart.
        this.hasActiveCart = SAPCommerceAPI.hasActiveCart();
        // Fetch the locale for the page.
        LocaleAPI.getLocale().then(locale => {
          this.locale = locale;
        });
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet(C4DMastheadCart, "updated", this, 3)([changedProperties]);
        const {
          hasActiveCart
        } = this;
        if (changedProperties.has('hasActiveCart')) {
          this.hidden = !hasActiveCart;
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          linkLabel,
          locale: {
            cc,
            lc
          }
        } = this;
        return html(_t || (_t = _`
      <a
        part="cart-link"
        href="/store/${0}/${0}/checkout"
        class="${0}--header__menu-item ${0}--header__menu-title"
        aria-label="${0}"
        >${0}</a
      >
    `), lc, cc, prefix, prefix, linkLabel, ShoppingCart20());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--masthead-cart`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
export default C4DMastheadCart;
//# sourceMappingURL=masthead-cart.js.map
