import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6,
  _t7,
  _t8,
  _t9,
  _t10,
  _t11,
  _t12,
  _t13,
  _t14,
  _t15,
  _t16,
  _t17,
  _t18,
  _t19,
  _t20,
  _t21,
  _t22,
  _t23,
  _t24,
  _t25,
  _t26,
  _t27,
  _t28,
  _t29,
  _t30,
  _t31,
  _t32,
  _t33,
  _t34,
  _t35,
  _t36,
  _t37,
  _t38,
  _t39;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { state, property, query } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import ArrowRight16 from '@carbon/web-components/es/icons/arrow--right/16.js';
import ArrowLeft16 from '@carbon/web-components/es/icons/arrow--left/16.js';
import Wikis from '@carbon/web-components/es/icons/wikis/20.js';
import ifNonEmpty from '@carbon/web-components/es/globals/directives/if-non-empty.js';
import { unsafeSVG } from 'lit/directives/unsafe-svg.js';
import root from 'window-or-global';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import HostListenerMixin from '@carbon/web-components/es/globals/mixins/host-listener.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { globalInit } from '@carbon/ibmdotcom-services/es/services/global/global.js';
import MastheadLogoAPI from '@carbon/ibmdotcom-services/es/services/MastheadLogo/MastheadLogo.js';
import { UNAUTHENTICATED_STATUS, CLOUD_UNAUTHENTICATED_STATUS, MASTHEAD_AUTH_METHOD } from '../../internal/vendor/@carbon/ibmdotcom-services-store/types/profileAPI.js';
import { MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME } from "./megamenu-right-navigation.js";
import { C4D_CUSTOM_PROFILE_LOGIN } from "../../globals/internal/feature-flags.js";
import C4DMastheadLogo from "./masthead-logo.js";
import C4DMegaMenuTabs from "./megamenu-tabs.js";
import C4DMegamenuTopNavMenu from "./megamenu-top-nav-menu.js";
import C4DMastheadL1 from "./masthead-l1.js";
import "./masthead.js";
import "./masthead-l1.js";
import "./masthead-l1-cta.js";
import "./masthead-l1-name.js";
import "./masthead-menu-button.js";
import "./masthead-contact.js";
import "./masthead-global-bar.js";
import "./masthead-profile.js";
import "./masthead-profile-item.js";
import "./masthead-cart.js";
import "./megamenu.js";
import "./megamenu-heading.js";
import "./megamenu-top-nav-menu.js";
import "./skip-to-content.js";
import "./top-nav.js";
import "./top-nav-l1.js";
import "./top-nav-name.js";
import "./top-nav-item.js";
import "./top-nav-menu.js";
import "./top-nav-menu-item.js";
import "./left-nav.js";
import "../search-with-typeahead/search-with-typeahead.js";
import "../search-with-typeahead/search-with-typeahead-item.js";
import styles from "././masthead.css.js";
import { MEGAMENU_LAYOUT_SCHEME } from "./defs.js";
import layoutBreakpoint from "./masthead-breakpoint.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DMastheadMenuButton from "./masthead-menu-button.js";
const {
  stablePrefix: c4dPrefix,
  prefix
} = settings;

/**
 * Globally-scoped Contact Module variable.
 *
 * @see https://github.ibm.com/live-advisor/cm-app
 */
/**
 * Component that renders masthead from links, etc. data.
 *
 * @element c4d-masthead-composite
 * @csspart view-all -  Targets all view-all elements. Usage: `c4d-masthead-composite::part(view-all)`
 * @csspart view-all-left -  Targets the view all left. Usage: `c4d-masthead-composite::part(view-all-left)`
 * @csspart view-all-right -  Targets the view all right. Usage: `c4d-masthead-composite::part(view-all-right)`
 * @csspart view-all-bottom -  Targets the view all bottom. Usage: `c4d-masthead-composite::part(view-all-bottom)`
 * @csspart l0-view-all-products-arrow -  Targets the view all products arrow icon. Usage: `c4d-masthead-composite::part(l0-view-all-products-arrow)`
 */
let C4DMastheadComposite = _decorate([customElement(`${c4dPrefix}-masthead-composite`)], function (_initialize, _HostListenerMixin) {
  class C4DMastheadComposite extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadComposite,
    d: [{
      kind: "method",
      key: "_renderL1",
      value:
      /**
       * Renders L1 menu based on l1Data & screen width.
       *
       * @returns {TemplateResult | undefined}
       */
      function _renderL1() {
        const {
          l1Data,
          selectedMenuItemL1
        } = this;
        const {
          cta
        } = (l1Data === null || l1Data === void 0 ? void 0 : l1Data.actions) || {};
        return !l1Data ? undefined : html(_t || (_t = _`
          <c4d-masthead-l1
            slot="masthead-l1"
            .l1Data=${0}
            selected-menu-item=${0}>
            ${0}
          </c4d-masthead-l1>
        `), l1Data, selectedMenuItemL1 || '', cta ? C4DMastheadL1.renderL1Cta(cta) : '');
      }

      /**
       * Renders masthead logo
       *
       * @returns {TemplateResult} A template fragment representing the logo.
       */
    }, {
      kind: "method",
      key: "_renderLogo",
      value: function _renderLogo() {
        if (!this.logoData) {
          return html(_t2 || (_t2 = _`
        <c4d-masthead-logo
          ?hide-logo="${0}"></c4d-masthead-logo>
      `), this.activateSearch);
        }
        const useAlternateLogo = MastheadLogoAPI.setMastheadLogo(this.logoData);
        const {
          tooltip,
          svg,
          href
        } = this.logoData;
        return html(_t3 || (_t3 = _`
      <c4d-masthead-logo
        ?hide-logo="${0}"
        ?hasTooltip="${0}"
        aria-label="${0}"
        href="${0}"
        >${0}</c4d-masthead-logo
      >
    `), this.activateSearch, tooltip, ifDefined(tooltip), href || C4DMastheadLogo.hrefDefault, useAlternateLogo ? unsafeSVG(svg) : '');
      }

      /**
       * Render MegaMenu content
       *
       * @param menu megamenu data object
       * @param _parentKey parent key
       * @param layout layout selection to render the megamenu with
       * @returns {TemplateResult} A template fragment representing a megamenu.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderMegaMenu",
      value: function _renderMegaMenu(menu, _parentKey, layout = MEGAMENU_LAYOUT_SCHEME.LIST) {
        const {
          _megamenuRenderMap
        } = this;
        if (_megamenuRenderMap.has(layout)) {
          return _megamenuRenderMap.get(layout)(menu, _parentKey);
        }
        return this._renderMegaMenuListing(menu, _parentKey);
      }
    }, {
      kind: "get",
      key: "ArrowIcon",
      value: function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? ArrowLeft16 : ArrowRight16;
      }

      /**
       *  Render MegaMenu content in tabbed layout.
       *
       * @param menu megamenu data object
       * @param _parentKey key that identifies parent nav item
       * @returns {TemplateResult} A template fragment representing a tabbed megamenu.
       */
    }, {
      kind: "method",
      key: "_renderMegaMenuTabbed",
      value: function _renderMegaMenuTabbed(menu, _parentKey) {
        var _activeMenuItem$headi;
        const {
          viewAll,
          sections
        } = menu;
        const sortedMenuItems = [];
        sections.forEach((section, i) => {
          return sortedMenuItems.push(_objectSpread(_objectSpread({}, section), {}, {
            itemKey: `${_parentKey}-${i}`
          }));
        });
        const activeMenuItem = this._activeMegamenuTabKey ? sortedMenuItems.find(item => item.itemKey === this._activeMegamenuTabKey) : sortedMenuItems[0];
        return html(_t4 || (_t4 = _`
      <c4d-megamenu layout="${0}">
        <c4d-megamenu-left-navigation>
          <c4d-megamenu-tabs
            value="${0}">
            ${0}
          </c4d-megamenu-tabs>
          ${0}
        </c4d-megamenu-left-navigation>
        ${0}
      </c4d-megamenu>
    `), MEGAMENU_LAYOUT_SCHEME.TAB, ifNonEmpty(activeMenuItem === null || activeMenuItem === void 0 || (_activeMenuItem$headi = activeMenuItem.heading) === null || _activeMenuItem$headi === void 0 ? void 0 : _activeMenuItem$headi.title), sortedMenuItems.map(item => {
          var _item$heading;
          return item !== null && item !== void 0 && (_item$heading = item.heading) !== null && _item$heading !== void 0 && _item$heading.title ? html(_t5 || (_t5 = _`
                    <c4d-megamenu-tab
                      id="tab-${0}"
                      target="panel-${0}"
                      value="${0}">
                      ${0}
                    </c4d-megamenu-tab>
                  `), item.itemKey, item.itemKey, item.heading.title, item.heading.title) : '';
        }), viewAll !== null && viewAll !== void 0 && viewAll.url && viewAll !== null && viewAll !== void 0 && viewAll.title ? html(_t6 || (_t6 = _`
                <c4d-megamenu-link-with-icon
                  href="${0}"
                  part="view-all view-all-left"
                  slot="view-all">
                  <span>${0}</span>${0}
                </c4d-megamenu-link-with-icon>
              `), viewAll.url, viewAll.title, this.ArrowIcon({
          slot: 'icon',
          part: 'l0-view-all-products-arrow'
        })) : null, this._renderMegamenuTabPanel(activeMenuItem));
      }

      /**
       * Render individual tabpanel in a tabbed megamenu.
       *
       * @param menuItem menuItem data object
       * @returns {TemplateResult} A template fragment representing a megamenu tabpanel.
       */
    }, {
      kind: "method",
      key: "_renderMegamenuTabPanel",
      value: function _renderMegamenuTabPanel(menuItem) {
        const {
          itemKey,
          groups,
          heading,
          viewAll: itemViewAll
        } = menuItem;
        return html(_t7 || (_t7 = _`
      <div
        id="panel-${0}"
        role="tabpanel"
        aria-labelledby="tab-${0}">
        <c4d-megamenu-right-navigation
          class="${0}--masthead__tabpanel-child"
          style-scheme="${0}">
          ${0}
          ${0}
          ${0}
        </c4d-megamenu-right-navigation>
      </div>
    `), itemKey, itemKey, c4dPrefix, MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.HAS_SIDEBAR, heading !== null && heading !== void 0 && heading.title ? html(_t8 || (_t8 = _`
                <c4d-megamenu-heading
                  href="${0}"
                  title="${0}"
                  slot="heading">
                  ${0}
                </c4d-megamenu-heading>
              `), ifNonEmpty(heading === null || heading === void 0 ? void 0 : heading.url), heading === null || heading === void 0 ? void 0 : heading.title, heading === null || heading === void 0 ? void 0 : heading.description) : '', groups ? groups.map((group, i) => this._renderMegapanelLinkGroup(group, {
          autoid: `panel-${itemKey}-${i}`
        })) : '', itemViewAll !== null && itemViewAll !== void 0 && itemViewAll.url && itemViewAll !== null && itemViewAll !== void 0 && itemViewAll.title ? html(_t9 || (_t9 = _`
                <c4d-megamenu-link-with-icon
                  href="${0}"
                  part="view-all view-all-right"
                  slot="view-all">
                  <span>${0}</span>${0}
                </c4d-megamenu-link-with-icon>
              `), itemViewAll.url, itemViewAll.title, this.ArrowIcon({
          slot: 'icon'
        })) : null);
      }

      /**
       * Render MegaMenu content in listing layout.
       *
       * @param menu megamenu data object
       * @param _parentKey key that identifies parent nav item
       * @returns {TemplateResult} A template fragment representing a listing megamenu.
       */
      // eslint-disable-next-line
    }, {
      kind: "method",
      key: "_renderMegaMenuListing",
      value: function _renderMegaMenuListing(menu, _parentKey) {
        const megapanel = menu.sections[0];
        const {
          heading
        } = megapanel;
        const {
          viewAll,
          highlights
        } = menu;
        return html(_t10 || (_t10 = _`
      <c4d-megamenu layout="${0}">
        ${0}
        <c4d-megamenu-right-navigation
          style-scheme="${0}">
          ${0}
          ${0}
          ${0}
        </c4d-megamenu-right-navigation>
        ${0}
      </c4d-megamenu>
    `), MEGAMENU_LAYOUT_SCHEME.LIST, highlights ? html(_t11 || (_t11 = _`
              <c4d-megamenu-left-navigation>
                ${0}
              </c4d-megamenu-left-navigation>
            `), highlights.map((group, i) => this._renderMegapanelLinkGroup(group, {
          headingLevel: 2,
          autoid: `${c4dPrefix}--masthead__l0-nav-list${i}`
        }))) : null, highlights ? MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.HAS_SIDEBAR : MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.FULL, heading && !highlights ? html(_t12 || (_t12 = _`
                <c4d-megamenu-heading
                  href="${0}"
                  title="${0}"
                  slot="heading">
                  ${0}
                </c4d-megamenu-heading>
              `), ifNonEmpty(heading.url), ifNonEmpty(heading.title), heading.description) : '', megapanel.groups.map((group, i) => this._renderMegapanelLinkGroup(group, {
          headingLevel: heading ? 3 : 2,
          autoid: `${c4dPrefix}--masthead__l0-nav-list${i + (highlights ? highlights.length : 0)}`
        })), viewAll !== null && viewAll !== void 0 && viewAll.url && viewAll !== null && viewAll !== void 0 && viewAll.title ? html(_t13 || (_t13 = _`
                <c4d-megamenu-link-with-icon
                  href="${0}"
                  part="view-all view-all-right"
                  slot="view-all">
                  <span>${0}</span>${0}
                </c4d-megamenu-link-with-icon>
              `), viewAll.url, viewAll.title, this.ArrowIcon({
          slot: 'icon'
        })) : null, viewAll !== null && viewAll !== void 0 && viewAll.url && viewAll !== null && viewAll !== void 0 && viewAll.title ? html(_t14 || (_t14 = _`
              <c4d-megamenu-link-with-icon
                href="${0}"
                part="view-all view-all-bottom">
                <span>${0}</span>${0}
              </c4d-megamenu-link-with-icon>
            `), viewAll.url, viewAll.title, this.ArrowIcon({
          slot: 'icon'
        })) : null);
      }

      /**
       * Render a Megapanel link group.
       *
       * @param group megamenu link group
       * @returns {TemplateResult} A template fragment representing a megapanel link group.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderMegapanelLinkGroup",
      value: function _renderMegapanelLinkGroup(group, options = {
        headingLevel: 3
      }) {
        const {
          links,
          heading
        } = group;
        const {
          headingLevel,
          autoid
        } = options;
        return html(_t15 || (_t15 = _`
      <c4d-megamenu-category-group data-autoid="${0}">
        ${0}
        ${0}
      </c4d-megamenu-category-group>
    `), ifNonEmpty(autoid), heading !== null && heading !== void 0 && heading.title ? html(_t16 || (_t16 = _`
              <c4d-megamenu-category-heading
                title="${0}"
                href="${0}"
                slot="heading"
                heading-level="${0}">
                ${0}
              </c4d-megamenu-category-heading>
            `), heading.title, ifNonEmpty(heading === null || heading === void 0 ? void 0 : heading.url), ifNonEmpty(headingLevel), heading === null || heading === void 0 ? void 0 : heading.description) : '', links && links.map((link, i) => {
          const linkAutoId = autoid ? `${autoid}-item${i}` : null;
          if (link !== null && link !== void 0 && link.description) {
            return html(_t17 || (_t17 = _`
              <c4d-megamenu-category-link
                title="${0}"
                href="${0}"
                data-autoid="${0}">
                ${0}
              </c4d-megamenu-category-link>
            `), link === null || link === void 0 ? void 0 : link.title, ifNonEmpty(link === null || link === void 0 ? void 0 : link.url), ifNonEmpty(linkAutoId), link === null || link === void 0 ? void 0 : link.description);
          }
          return html(_t18 || (_t18 = _`
            <c4d-megamenu-category-link
              href="${0}"
              data-autoid="${0}">
              ${0}
            </c4d-megamenu-category-link>
          `), ifNonEmpty(link === null || link === void 0 ? void 0 : link.url), ifNonEmpty(linkAutoId), link === null || link === void 0 ? void 0 : link.title);
        }));
      }

      /**
       * Renders the left nav menus sections
       *
       * @param object heading heading of menu section
       * @param object.menuItems menu items
       * @param object.heading heading heading of menu section
       * @param object.isSubmenu determines whether menu section is a submenu section
       * @param object.showBackButton Determines whether to show back button
       * @param object.sectionTitle title of menu section
       * @param object.sectionUrl section title url of menu section
       * @param object.sectionId id of menu section
       * @returns {TemplateResult} A template fragment representing the left nav menu
       *   sections.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderLeftNavMenuSections",
      value: function _renderLeftNavMenuSections({
        menuItems,
        heading,
        isSubmenu = false,
        showBackButton = false,
        sectionTitle = '',
        sectionUrl = '',
        sectionId = ''
      }) {
        const items = menuItems === null || menuItems === void 0 ? void 0 : menuItems.map(elem => {
          var _elem$isHeading, _elem$isViewAll;
          if (elem.menu) {
            return html(_t19 || (_t19 = _`
          <c4d-left-nav-menu
            ?last-highlighted=${0}
            panel-id=${0}
            ?active="${0}"
            title="${0}"
            data-autoid="${0}">
          </c4d-left-nav-menu>
        `), elem.lastHighlightedItem, elem.panelId, elem.selected, elem.title, elem.autoid);
          }
          return html(_t20 || (_t20 = _`
        <c4d-left-nav-menu-item
          ?last-highlighted=${0}
          ?active="${0}"
          href="${0}"
          title="${0}"
          data-autoid="${0}"
          .isHeading=${0}
          .isViewAll=${0}></c4d-left-nav-menu-item>
      `), elem.lastHighlightedItem, elem.selected, elem.url, elem.title, elem.autoid, (_elem$isHeading = elem.isHeading) !== null && _elem$isHeading !== void 0 ? _elem$isHeading : false, (_elem$isViewAll = elem.isViewAll) !== null && _elem$isViewAll !== void 0 ? _elem$isViewAll : false);
        });
        if (heading) {
          if (typeof heading === 'string') {
            items.unshift(html(_t21 || (_t21 = _`
            <c4d-left-nav-menu-category-heading
              title="${0}"></c4d-left-nav-menu-category-heading>
          `), heading));
          } else {
            const {
              title,
              description,
              url
            } = heading;
            items.unshift(html(_t22 || (_t22 = _`
            <c4d-left-nav-menu-category-heading
              .boostSize=${0}
              title="${0}"
              url="${0}">
              ${0}
            </c4d-left-nav-menu-category-heading>
          `), true, title, ifDefined(url), description !== null && description !== void 0 ? description : ''));
          }
        }
        return html(_t23 || (_t23 = _`
      <c4d-left-nav-menu-section
        section-id="${0}"
        ?is-submenu=${0}
        title=${0}
        titleUrl=${0}
        ?show-back-button=${0}>
        ${0}
      </c4d-left-nav-menu-section>
    `), sectionId, ifDefined(isSubmenu), ifDefined(sectionTitle), ifDefined(sectionUrl), ifDefined(showBackButton), items);
      }

      /**
       * checks if menu item's children url match the current url path, if so return the menu item and its children
       *
       * @returns {object} selectedItems
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_selectedLeftNavItems",
      value: function _selectedLeftNavItems() {
        const {
          currentUrlPath
        } = this;
        let matchFound = false;
        const selectedItems = {
          level0: '',
          level1: '',
          level2: ''
        };
        return ({
          menu: _menu = [{
            url: '',
            megapanelContent: {
              quickLinks: {
                links: [{
                  url: ''
                }]
              }
            }
          }],
          key: _key = '',
          parentItemUrl: _parentItemUrl = ''
        }) => {
          if (!matchFound) {
            if (_parentItemUrl === currentUrlPath) {
              selectedItems.level0 = `${_key}`;
              matchFound = true;
            }
            // check if child url matches current url path
            else {
              for (let i = 0; i < (_menu === null || _menu === void 0 ? void 0 : _menu.length); i++) {
                var _menu$i;
                if (((_menu$i = _menu[i]) === null || _menu$i === void 0 ? void 0 : _menu$i.url) === currentUrlPath) {
                  selectedItems.level0 = `${_key}`;
                  selectedItems.level1 = `${_key}-${i}`;
                  matchFound = true;
                  break;
                } else {
                  var _menu$i2;
                  const links = (_menu$i2 = _menu[i]) === null || _menu$i2 === void 0 || (_menu$i2 = _menu$i2.megapanelContent) === null || _menu$i2 === void 0 || (_menu$i2 = _menu$i2.quickLinks) === null || _menu$i2 === void 0 ? void 0 : _menu$i2.links;
                  for (let k = 0; k < (links === null || links === void 0 ? void 0 : links.length); k++) {
                    var _links$k;
                    if (((_links$k = links[k]) === null || _links$k === void 0 ? void 0 : _links$k.url) === currentUrlPath) {
                      selectedItems.level0 = `${_key}`;
                      selectedItems.level1 = `${_key}-${i}`;
                      selectedItems.level2 = `${_key}-${i}-${k}`;
                      matchFound = true;
                      break;
                    }
                  }
                }
              }
            }
            this._hasAutoSelectedItems = matchFound;
            return selectedItems;
          }
          return selectedItems;
        };
      }

      /**
       * Renders the left nav menus
       *
       * @param menuItems The options.
       * @param autoid Base autoid to be applied to the menu items
       * @returns {TemplateResult} A template fragment representing the left nav.
       */
    }, {
      kind: "method",
      key: "_renderLeftNav",
      value: function _renderLeftNav() {
        const {
          platform
        } = this;
        const menu = [];
        const menuItems = this.getL0Data();
        const autoid = `${c4dPrefix}--masthead__l0`;
        const level0Items = menuItems === null || menuItems === void 0 ? void 0 : menuItems.map((elem, i) => {
          // Instantiate bucket for first level submenus.
          const level1Items = [];

          // If it's a "simple" menu, no megapanels.
          if ((elem === null || elem === void 0 ? void 0 : elem.submenu) instanceof Array) {
            elem.submenu.forEach((link, j) => {
              level1Items.push({
                title: link.title,
                url: link.url,
                autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                lastHighlightedItem: false,
                panelId: `${i}, ${j}`,
                menu: false,
                selected: false
              });
            });
            if (level1Items.length !== 0) {
              menu.push(this._renderLeftNavMenuSections({
                menuItems: level1Items,
                isSubmenu: true,
                showBackButton: true,
                sectionTitle: elem.title,
                sectionUrl: elem.url,
                sectionId: `${i}, -1`,
                heading: elem.title
              }));
            }
          }

          // If it's a megapanel.
          const submenu = elem.submenu;
          if (submenu !== null && submenu !== void 0 && submenu.sections) {
            // Check if other types of links exist.
            const highlightedItems = (submenu === null || submenu === void 0 ? void 0 : submenu.highlights) || [];
            const viewAll = submenu === null || submenu === void 0 ? void 0 : submenu.viewAll;

            // 1. Add highlighted items to top of menu.
            if (highlightedItems.length !== 0) {
              highlightedItems.forEach((highlight, j) => {
                const {
                  heading,
                  links
                } = highlight;
                const lastHighlighted = j + 1 === highlightedItems.length;
                if (heading) {
                  level1Items.push({
                    title: heading.title,
                    url: heading.url,
                    autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                    lastHighlightedItem: lastHighlighted,
                    panelId: `${i}, ${j}`,
                    menu: false,
                    selected: false,
                    isHeading: true
                  });
                }
                if (links) {
                  links.forEach((link, k) => {
                    level1Items.push({
                      title: link.title,
                      url: link.url,
                      autoid: `${autoid}--sidenav--nav${i}-list${j}-item${k}`,
                      lastHighlightedItem: lastHighlighted,
                      panelId: `${i}, ${j}`,
                      menu: false,
                      selected: false
                    });
                  });
                }
              });
            }

            /**
             * 2. Add megamenu links to menu.
             *
             * `sections`' length implies a tabbed or listing megamenu, which must
             * be handled in different ways and have slightly different content
             * requirements.
             */
            if (submenu.sections.length > 1) {
              submenu.sections.map((item, j) => {
                const {
                  heading,
                  groups
                } = item;
                const lastHighlighted = j + 1 === highlightedItems.length;
                const level2Items = [];
                groups.forEach((linkGroup, k) => {
                  const {
                    heading: groupHeading,
                    links
                  } = linkGroup;
                  if (groupHeading) {
                    level2Items.push({
                      title: groupHeading.title,
                      url: groupHeading.url,
                      autoid: `${autoid}--sidenav--nav${i}-list${j}-heading${k}`,
                      selected: false,
                      isHeading: true
                    });
                  }
                  if (links) {
                    links.forEach((link, l) => {
                      level2Items.push({
                        title: link.title,
                        url: link.url,
                        autoid: `${autoid}--sidenav--nav${i}-list${j}-heading${k}-item${l}`,
                        selected: false
                      });
                    });
                  }
                });
                if (level2Items.length !== 0) {
                  menu.push(this._renderLeftNavMenuSections({
                    menuItems: level2Items,
                    isSubmenu: true,
                    showBackButton: true,
                    sectionTitle: heading === null || heading === void 0 ? void 0 : heading.title,
                    sectionUrl: heading === null || heading === void 0 ? void 0 : heading.url,
                    sectionId: `${i}, ${j}`,
                    heading
                  }));
                }
                return level1Items.push({
                  title: heading.title,
                  // headings are required in tabbed layout
                  url: heading === null || heading === void 0 ? void 0 : heading.url,
                  autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                  lastHighlightedItem: lastHighlighted,
                  panelId: `${i}, ${j}`,
                  selected: false,
                  menu: groups && groups.length !== 0
                });
              });
            } else {
              submenu.sections[0].groups.forEach((group, j) => {
                const {
                  heading,
                  links
                } = group;
                const lastHighlighted = j + 1 === highlightedItems.length;
                if (heading) {
                  level1Items.push({
                    title: heading.title,
                    url: heading.url,
                    lastHighlightedItem: lastHighlighted,
                    panelId: `${i}, ${j}`,
                    autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                    menu: false,
                    selected: false,
                    isHeading: true
                  });
                }
                if (links) {
                  links.forEach((link, k) => {
                    level1Items.push({
                      title: link.title,
                      url: link.url,
                      lastHighlightedItem: lastHighlighted,
                      panelId: `${i}, ${j}, ${k}`,
                      autoid: `${autoid}--sidenav--nav${i}-list${j}-item${k}`,
                      menu: false,
                      selected: false
                    });
                  });
                }
              });
            }

            // 3. Add view all link to bottom of menu.
            if (viewAll) {
              level1Items.push({
                title: viewAll.title,
                url: viewAll.url,
                lastHighlightedItem: false,
                panelId: `${i}`,
                autoid: `${autoid}--sidenav--nav${i}-list${level1Items.length}`,
                menu: false,
                selected: false,
                isViewAll: true
              });
            }
            if (level1Items.length !== 0) {
              const isNotFaceted = submenu.sections.length === 1;
              const megapanelHeading = submenu.sections[0].heading;
              const heading = isNotFaceted && !!megapanelHeading ? megapanelHeading : elem.title;
              menu.push(this._renderLeftNavMenuSections({
                menuItems: level1Items,
                isSubmenu: true,
                showBackButton: true,
                sectionTitle: elem.title,
                sectionUrl: elem.url,
                sectionId: `${i}, -1`,
                heading
              }));
            }
          }
          return {
            title: elem.title,
            titleEnglish: elem.titleEnglish,
            url: elem === null || elem === void 0 ? void 0 : elem.url,
            menu: Boolean(elem === null || elem === void 0 ? void 0 : elem.submenu),
            panelId: `${i}, -1`,
            autoid: `${autoid}--sidenav--nav${i}`,
            selected: false
          };
        });
        return html(_t24 || (_t24 = _`
      <c4d-left-nav-overlay></c4d-left-nav-overlay>
      <c4d-left-nav>
        ${0}
        ${0}
        ${0}
      </c4d-left-nav>
    `), !platform ? undefined : html(_t25 || (_t25 = _`
              <c4d-left-nav-name href="${0}">
                ${0}
              </c4d-left-nav-name>
            `), ifNonEmpty(this._getPlatformUrl()), platform), this._renderLeftNavMenuSections({
          menuItems: level0Items,
          sectionId: '-1, -1',
          heading: false
        }), menu);
      }

      /**
       * Renders the mobile menu button.
       *
       * @returns {TemplateResult} A template fragment representing the menu button.
       */
    }, {
      kind: "method",
      key: "_renderMenuButton",
      value: function _renderMenuButton() {
        const {
          activateSearch,
          menuButtonAssistiveTextActive,
          menuButtonAssistiveTextInactive
        } = this;
        return html(_t26 || (_t26 = _`
      <c4d-masthead-menu-button
        button-label-active="${0}"
        button-label-inactive="${0}"
        ?hide-menu-button="${0}">
      </c4d-masthead-menu-button>
    `), ifNonEmpty(menuButtonAssistiveTextActive), ifNonEmpty(menuButtonAssistiveTextInactive), activateSearch);
      }

      /**
       * Checks if there is a child item in the menu section that matches current
       * url and returns true for first valid result.
       *
       * @param menuItem a top level L0 menu item
       * @returns boolean
       */
    }, {
      kind: "method",
      key: "_isActiveMenuItem",
      value: function _isActiveMenuItem(menuItem) {
        const {
          currentUrlPath
        } = this;
        const {
          submenu
        } = menuItem;
        let matchFound = false;
        if (!submenu) {
          matchFound = (menuItem === null || menuItem === void 0 ? void 0 : menuItem.url) === currentUrlPath;
        } else if (submenu instanceof Array) {
          matchFound = Boolean(submenu.find(link => link.url === currentUrlPath));
        } else if (submenu.sections) {
          const {
            highlights,
            viewAll,
            sections
          } = submenu;
          const flattenedLinks = [];
          const flattenLinkGroup = group => {
            const links = [];
            if (group.heading) {
              links.push(group.heading);
            }
            if (group.links) {
              group.links.forEach(link => {
                links.push(link);
              });
            }
            return links;
          };

          // Flatten all data into array of BasicLinks.
          if (highlights) {
            highlights.forEach(highlight => {
              flattenedLinks.push(...flattenLinkGroup(highlight));
            });
          }
          if (sections.length > 0) {
            sections.forEach(section => {
              if (section.heading) {
                flattenedLinks.push(section.heading);
              }
              section.groups.forEach(group => {
                flattenedLinks.push(...flattenLinkGroup(group));
              });
            });
          }
          if (viewAll) {
            flattenedLinks.push(viewAll);
          }

          // Check flattened list for matching URL.
          matchFound = Boolean(flattenedLinks.find(link => link.url === currentUrlPath));
        }
        return matchFound;
      }

      /**
       * Renders the top navigation bar.
       *
       * @returns {TemplateResult} A template fragment representing the top nav.
       */
    }, {
      kind: "method",
      key: "_renderTopNav",
      value: function _renderTopNav() {
        const {
          selectedMenuItem,
          menuBarAssistiveText,
          activateSearch
        } = this;
        return !this.getL0Data() ? undefined : html(_t27 || (_t27 = _`
          <c4d-top-nav
            selected-menu-item=${0}
            menu-bar-label="${0}"
            ?hideNav="${0}">
            ${0}
          </c4d-top-nav>
        `), selectedMenuItem, ifNonEmpty(menuBarAssistiveText), activateSearch, this.getL0Data().map((link, i) => {
          return this._renderNavItem(link, i, `${c4dPrefix}--masthead__l0`);
        }));
      }

      /**
       * Renders a nav item.
       *
       * @param item The item to render
       * @param i The index of the item in a series
       * @param autoid The unique id to assign to the item
       * @returns {TemplateResult} A template fragment representing a nav item.
       */
    }, {
      kind: "method",
      key: "_renderNavItem",
      value: function _renderNavItem(item, i, autoid) {
        const {
          selectedMenuItem,
          currentUrlPath,
          _activeMegamenuIndex
        } = this;
        const {
          submenu,
          title,
          titleEnglish,
          url
        } = item;
        let selected;
        if (selectedMenuItem) {
          var _titleEnglish$trim, _selectedMenuItem$tri;
          selected = (titleEnglish === null || titleEnglish === void 0 || (_titleEnglish$trim = titleEnglish.trim()) === null || _titleEnglish$trim === void 0 ? void 0 : _titleEnglish$trim.toLowerCase()) === (selectedMenuItem === null || selectedMenuItem === void 0 || (_selectedMenuItem$tri = selectedMenuItem.trim()) === null || _selectedMenuItem$tri === void 0 ? void 0 : _selectedMenuItem$tri.toLowerCase());
        } else {
          selected = this._isActiveMenuItem(item);
        }
        if (submenu instanceof Array) {
          return html(_t28 || (_t28 = _`
        <c4d-top-nav-menu
          ?active="${0}"
          menu-label="${0}"
          trigger-content="${0}"
          data-autoid="${0}-nav--nav${0}">
          ${0}
        </c4d-top-nav-menu>
      `), selected, title, title, autoid, i, submenu.map(({
            title: linkTitle,
            url: linkUrl
          }, j) => html(_t29 || (_t29 = _`
                <c4d-top-nav-menu-item
                  ?active="${0}"
                  href="${0}"
                  title="${0}"
                  data-autoid="${0}-nav--subnav-col${0}-item${0}"></c4d-top-nav-menu-item>
              `), selectedMenuItem ? selected : linkUrl === currentUrlPath, ifDefined(linkUrl), linkTitle, autoid, i, j)));
        }
        if (submenu !== null && submenu !== void 0 && submenu.sections) {
          const layout = submenu.sections.length > 1 ? MEGAMENU_LAYOUT_SCHEME.TAB : MEGAMENU_LAYOUT_SCHEME.LIST;

          // Render nav menu, but only render megamenu if it is active.
          return html(_t30 || (_t30 = _`
        <c4d-megamenu-top-nav-menu
          ?active="${0}"
          menu-label="${0}"
          trigger-content="${0}"
          data-autoid="${0}-nav--nav${0}"
          .menuIndex=${0}>
          ${0}
        </c4d-megamenu-top-nav-menu>
      `), selected, title, title, autoid, i, i, _activeMegamenuIndex === i ? this._renderMegaMenu(submenu, i, layout) : null);
        }

        // Fallback render as simple link.
        return html(_t31 || (_t31 = _`
      <c4d-top-nav-item
        ?active="${0}"
        href="${0}"
        title="${0}"
        data-autoid="${0}-nav--nav${0}"></c4d-top-nav-item>
    `), selectedMenuItem ? selected : url === currentUrlPath, ifDefined(url), title, autoid, i);
      }

      /**
       * Sets the active megamenu upon user interaction.
       *
       * @param event The event.
       */
    }, {
      kind: "field",
      decorators: [HostListener(C4DMegamenuTopNavMenu.eventMegaMenuToggled)],
      key: "_loadMegamenu",
      value() {
        return event => {
          const {
            detail: {
              active,
              resolveFn,
              index: menuIndex
            }
          } = event;

          // Open a megamenu by updating state to trigger a re-render. This also closes
          // any previously opened megamenu.
          if (active && menuIndex !== undefined) {
            var _this$contactModuleAp;
            this._activeMegamenuIndex = menuIndex;

            // Close the Contact Module upon opening megamenu.
            (_this$contactModuleAp = this.contactModuleApp) === null || _this$contactModuleAp === void 0 || _this$contactModuleAp.minimize();

            // Set positioning property upon opening megamenu.
            this._setCustomPropertyL0BottomEdge();
          }

          // If clicking the same nav item to close megamenu, reset state to prune its
          // markup from the DOM.
          if (!active && menuIndex === this._activeMegamenuIndex) {
            this._activeMegamenuIndex = undefined;
          }

          // Reset active tab when closing any megamenu.
          if (!active && this._activeMegamenuTabKey) {
            this._activeMegamenuTabKey = undefined;
          }
          resolveFn();
        };
      }
    }, {
      kind: "method",
      decorators: [HostListener(C4DMastheadL1.dropDownToggleEvent)],
      key: "_handleL1DropdownToggle",
      value: function _handleL1DropdownToggle({
        detail
      }) {
        const {
          isOpen
        } = detail;
        if (isOpen) {
          var _this$contactModuleAp2;
          (_this$contactModuleAp2 = this.contactModuleApp) === null || _this$contactModuleAp2 === void 0 || _this$contactModuleAp2.minimize();
        }
      }

      /**
       * Sets the active megamenu tabpanel upon user interaction.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      decorators: [HostListener(C4DMegaMenuTabs.eventBeforeSelect)],
      key: "_loadMegamenuTabPanel",
      value: function _loadMegamenuTabPanel(event) {
        const {
          detail
        } = event;
        const panelId = detail.item.id.split('tab-')[1];
        this._activeMegamenuTabKey = panelId;
      }

      /**
       * Stores a reference of the globally-scoped CM_APP object within the masthead.
       */
    }, {
      kind: "field",
      decorators: [HostListener('document:cm-app-ready')],
      key: "_getContactModuleReference",
      value() {
        return () => {
          // @ts-ignore: CM_APP will definitely exist if this event is fired
          this.contactModuleApp = window.CM_APP;
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener(C4DMastheadMenuButton.eventToggle)],
      key: "_handleMenuButtonToggle",
      value() {
        return event => {
          var _event$detail;
          if ((_event$detail = event.detail) !== null && _event$detail !== void 0 && _event$detail.active) {
            this._setCustomPropertyL0BottomEdge();
          }
        };
      }
    }, {
      kind: "method",
      key: "_setCustomPropertyL0BottomEdge",
      value:
      /**
       * Performs actions on left nav button toggle.
       */
      /**
       * Sets a CSS value for the position of the L0's bottom edge.
       */
      function _setCustomPropertyL0BottomEdge() {
        var _this$mastheadRef;
        const mastheadL0 = (_this$mastheadRef = this.mastheadRef) === null || _this$mastheadRef === void 0 ? void 0 : _this$mastheadRef.shadowRoot.querySelector(`.${prefix}--masthead__l0`);
        if (mastheadL0) {
          this.style.setProperty(this.constructor.customPropertyL0BottomEdge, `${mastheadL0.getBoundingClientRect().bottom}px`);
        }
      }

      /**
       * Gets localized platform URL.
       *
       * @returns {string} A URL.
       */
    }, {
      kind: "method",
      key: "_getPlatformUrl",
      value: function _getPlatformUrl() {
        const {
          language,
          platformUrl
        } = this;
        const formattedLang = language === null || language === void 0 ? void 0 : language.toLowerCase().replace(/-(.*)/, m => m.toUpperCase());
        let url = platformUrl;
        if (platformUrl && formattedLang) {
          if (typeof platformUrl === 'object' && Object.prototype.hasOwnProperty.call(platformUrl, formattedLang)) {
            url = platformUrl[formattedLang].url || platformUrl;
          }
        }
        return url;
      }

      /**
       * Renders the platform title.
       *
       * @returns {TemplateResult} A template fragment representing the platform title.
       */
    }, {
      kind: "method",
      key: "_renderPlatformTitle",
      value: function _renderPlatformTitle() {
        const {
          l1Data,
          platform
        } = this;
        return !platform || l1Data ? undefined : html(_t32 || (_t32 = _`
          <c4d-top-nav-name href="${0}">
            ${0}
          </c4d-top-nav-name>
        `), ifDefined(this._getPlatformUrl()), platform);
      }

      /**
       * Renders the masthead search.
       *
       * @returns {TemplateResult} A template fragment representing the search bar.
       */
    }, {
      kind: "method",
      key: "_renderSearch",
      value: function _renderSearch() {
        const {
          activateSearch,
          currentSearchResults,
          customTypeaheadAPI,
          hasSearch,
          initialSearchTerm,
          inputTimeout,
          language,
          openSearchDropdown,
          scopeParameters,
          searchPlaceholder
        } = this;
        return hasSearch === 'false' ? '' : html(_t33 || (_t33 = _`
          <c4d-search-with-typeahead
            ?active="${0}"
            .currentSearchResults="${0}"
            ?custom-typeahead-api="${0}"
            initial-search-term="${0}"
            input-timeout="${0}"
            language="${0}"
            ?open="${0}"
            placeholder="${0}"
            .scopeParameters="${0}"
            ?searchOpenOnload="${0}"></c4d-search-with-typeahead>
        `), activateSearch, ifDefined(currentSearchResults), ifDefined(customTypeaheadAPI), ifDefined(initialSearchTerm), inputTimeout, ifDefined(language), openSearchDropdown, ifDefined(searchPlaceholder), ifDefined(scopeParameters), activateSearch);
      }

      /**
       * Renders the contact button.
       *
       * @returns {TemplateResult} A template fragment representing the contact button.
       */
    }, {
      kind: "method",
      key: "_renderContact",
      value: function _renderContact() {
        const {
          contactUsButton,
          hasContact
        } = this;
        return hasContact === 'false' ? undefined : html(_t34 || (_t34 = _`
          <c4d-masthead-contact
            data-ibm-contact="contact-link"
            trigger-label="${0}"></c4d-masthead-contact>
        `), ifDefined(contactUsButton === null || contactUsButton === void 0 ? void 0 : contactUsButton.title));
      }
    }, {
      kind: "method",
      key: "_renderLanguageSelector",
      value: function _renderLanguageSelector() {
        const {
          hasLanguageSelector
        } = this;
        return hasLanguageSelector === 'false' ? undefined : html(_t35 || (_t35 = _`
          <div class="earth-language-icon" part="earth-l0-icon">
            ${0}
          </div>
        `), Wikis({
          part: 'earth-l0-svg'
        }));
      }
    }, {
      kind: "method",
      key: "_renderCart",
      value: function _renderCart() {
        const {
          hasCart,
          cartLabel
        } = this;
        return hasCart ? html(_t36 || (_t36 = _`<c4d-masthead-cart link-label="${0}"></c4d-masthead-cart>`), cartLabel) : undefined;
      }

      /**
       * Gets the appropriate profile items for the current masthead state.
       *
       * @returns An array of profile items or undefined.
       */
    }, {
      kind: "method",
      key: "_getProfileItems",
      value: function _getProfileItems() {
        const {
          customProfileLogin,
          userIsAuthenticated,
          authenticatedProfileItems,
          unauthenticatedProfileItems
        } = this;
        let profileItems;
        if (C4D_CUSTOM_PROFILE_LOGIN && customProfileLogin && !userIsAuthenticated) {
          profileItems = unauthenticatedProfileItems === null || unauthenticatedProfileItems === void 0 ? void 0 : unauthenticatedProfileItems.map(item => {
            if ((item === null || item === void 0 ? void 0 : item.id) === 'signin') {
              return _objectSpread(_objectSpread({}, item), {}, {
                url: customProfileLogin
              });
            }
            return item;
          });
        } else {
          profileItems = userIsAuthenticated ? authenticatedProfileItems : unauthenticatedProfileItems;
        }
        return profileItems;
      }

      /**
       * Renders the profile menu.
       *
       * @returns {TemplateResult} A template fragment representing the profile menu.
       */
    }, {
      kind: "method",
      key: "_renderProfileMenu",
      value: function _renderProfileMenu() {
        var _this$_getProfileItem;
        const {
          hasProfile,
          userIsAuthenticated
        } = this;
        return hasProfile === 'false' ? '' : html(_t37 || (_t37 = _`
          <c4d-masthead-profile ?authenticated="${0}">
            ${0}
          </c4d-masthead-profile>
        `), userIsAuthenticated, (_this$_getProfileItem = this._getProfileItems()) === null || _this$_getProfileItem === void 0 ? void 0 : _this$_getProfileItem.map(({
          title,
          url
        }) => html(_t38 || (_t38 = _`
                  <c4d-masthead-profile-item href="${0}">
                    ${0}
                  </c4d-masthead-profile-item>
                `), ifDefined(url), title)));
      }

      /**
       * Whether or not a nav item has automatically been designated as "selected".
       *
       * @internal
       */
    }, {
      kind: "field",
      key: "_hasAutoSelectedItems",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "_isMobileVersion",
      value() {
        return layoutBreakpoint.matches;
      }
    }, {
      kind: "field",
      key: "_megamenuRenderMap",
      value() {
        return new Map([[MEGAMENU_LAYOUT_SCHEME.LIST, this._renderMegaMenuListing.bind(this)], [MEGAMENU_LAYOUT_SCHEME.TAB, this._renderMegaMenuTabbed.bind(this)]]);
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_activeMegamenuIndex",
      value: void 0
    }, {
      kind: "field",
      decorators: [state()],
      key: "_activeMegamenuTabKey",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        reflect: true,
        attribute: 'has-profile'
      })],
      key: "hasProfile",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        reflect: true,
        attribute: 'has-search'
      })],
      key: "hasSearch",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'activate-search'
      })],
      key: "activateSearch",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'search-open-on-load'
      })],
      key: "searchOpenOnload",
      value() {
        return this.activateSearch;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'initial-search-term',
        reflect: true
      })],
      key: "initialSearchTerm",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "authenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "contactUsButton",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "platform",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "platformUrl",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "currentSearchResults",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "currentUrlPath",
      value() {
        var _root$location;
        return (_root$location = root.location) === null || _root$location === void 0 ? void 0 : _root$location.href;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'custom-profile-login'
      })],
      key: "customProfileLogin",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'custom-typeahead-api',
        type: Boolean
      })],
      key: "customTypeaheadAPI",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'masthead-assistive-text'
      })],
      key: "mastheadAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'menu-bar-assistive-text'
      })],
      key: "menuBarAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'skip-to-content-text'
      })],
      key: "skipToContentText",
      value() {
        return 'Skip to content';
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'skip-to-content-href'
      })],
      key: "skipToContentHref",
      value() {
        return '#main-content';
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'menu-button-assistive-text-active'
      })],
      key: "menuButtonAssistiveTextActive",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'menu-button-assistive-text-inactive'
      })],
      key: "menuButtonAssistiveTextInactive",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "scopeParameters",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-menu-item-l1'
      })],
      key: "selectedMenuItemL1",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "unauthenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'data-endpoint'
      })],
      key: "dataEndpoint",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Number,
        attribute: 'input-timeout'
      })],
      key: "inputTimeout",
      value() {
        return 200;
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "logoData",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "navLinks",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "l0Data",
      value: void 0
    }, {
      kind: "method",
      key: "getL0Data",
      value:
      /**
       * Whether the nav should load as `left-nav` or `top-nav`
       */
      /**
       * The placeholder for `loadTranslation()` Redux action that will be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `loadUserStatus()` Redux action that will be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `setLanguage()` Redux action that will be mixed in.
       *
       * @internal
       */
      /**
       * Map of megamenu layout options to corresponding render methods.
       *
       * @internal
       */
      /**
       * The index of a megamenu that should be visible.
       */
      /**
       * The index of a megamenu's tabpanel that should be visible.
       */
      /**
       * `true` if there is a profile.
       */
      /**
       * `true` if there is a search.
       */
      /**
       * `true` to activate the search box.
       */
      /**
       * `true` sets search to active when page loads.
       */
      /**
       * Sets a default query in the masthead's search input.
       */
      /**
       * The profile items for authenticated state.
       */
      /**
       * Text for Contact us button
       */
      /**
       * The platform name.
       */
      /**
       * The platform url. Accepts both a string or an object with a specific URL for each locale.
       */
      /**
       * The search results to show in the UI.
       */
      /**
       * The custom profile login link.
       */
      /**
       * The boolean to use a custom search API.
       */
      /**
       * The `aria-label` attribute for the top-level container.
       */
      /**
       * The `aria-label` attribute for the menu bar UI.
       */
      /**
       * The skip-to-content link text.
       */
      /**
       * The skip-to-content href.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state.
       */
      /**
       * The parameters passed to the search-with-typeahead for search scope
       */
      /**
       * The English title of the selected nav item.
       */
      /**
       * The English title of the selected nav item in the L1.
       */
      /**
       * The profile items for unauthenticated state.
       */
      /**
       * Specify translation endpoint if not using default c4d endpoint.
       */
      /**
       * The throttle timeout to run query upon user input.
       */
      /**
       * The language used for query.
       */
      /**
       * Logo data
       */
      /**
       * The navigation links.
       *
       * @deprecated This property name is ambiguous. Use the l0Data prop instead.
       */
      /**
       * Data for l0.
       */
      /**
       * Temporary getter to fetch data until navLinks prop is phased out.
       */
      function getL0Data() {
        const {
          l0Data,
          navLinks
        } = this;
        if (navLinks) {
          console.warn(`Warning: ${c4dPrefix}-masthead's "navLinks" property is deprecated. Use "l0Data" property instead.`);
        }
        return l0Data || navLinks;
      }

      /**
       * Data for l1.
       */
    }, {
      kind: "field",
      decorators: [property({
        attribute: false
      })],
      key: "l1Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true,
        attribute: 'open-search-dropdown'
      })],
      key: "openSearchDropdown",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "searchPlaceholder",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        reflect: true,
        attribute: 'has-contact'
      })],
      key: "hasContact",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        reflect: true,
        attribute: 'has-language-selector'
      })],
      key: "hasLanguageSelector",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true,
        attribute: 'has-cart'
      })],
      key: "hasCart",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        reflect: true,
        attribute: 'cart-label'
      })],
      key: "cartLabel",
      value() {
        return 'Cart';
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'auth-method'
      })],
      key: "authMethod",
      value() {
        return MASTHEAD_AUTH_METHOD.DEFAULT;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'user-status'
      })],
      key: "userStatus",
      value() {
        return this.authMethod === MASTHEAD_AUTH_METHOD.DEFAULT ? UNAUTHENTICATED_STATUS : CLOUD_UNAUTHENTICATED_STATUS;
      }
    }, {
      kind: "get",
      key: "userIsAuthenticated",
      value:
      /**
       * `true` to open the search dropdown.
       */
      /**
       * Value to display when the input has an empty `value`.
       */
      /**
       * `true` if Contact us should be shown.
       */
      /**
       * `true` if Language Selector should be shown.
       */
      /**
       * `true` if Cart should be shown.
       */
      /**
       * Label for the cart icon.
       */
      /**
       * The selected authentication method, either `profile-api` (default), `cookie`, or `docs-api`.
       */
      /**
       * The user authentication status.
       */
      function () {
        const {
          userStatus
        } = this;
        return userStatus !== UNAUTHENTICATED_STATUS && userStatus !== CLOUD_UNAUTHENTICATED_STATUS;
      }

      /**
       * A reference to the c4d-masthead element.
       */
    }, {
      kind: "field",
      decorators: [query(`${c4dPrefix}-masthead`)],
      key: "mastheadRef",
      value: void 0
    }, {
      kind: "field",
      key: "_heightResizeObserver",
      value() {
        return new ResizeObserver(this._resizeObserverCallback.bind(this));
      }
    }, {
      kind: "method",
      key: "_resizeObserverCallback",
      value:
      /**
       * Resize observer to trigger container height recalculations.
       *
       * @private
       */
      /**
       * Prevents resize observer from blocking main thread.
       */
      /**
       * Throttled callback for _heightResizeObserver.
       */
      function _resizeObserverCallback() {
        clearTimeout(this._resizeObserverThrottle);
        this._resizeObserverThrottle = setTimeout(this._setContainerHeight.bind(this), 100);
      }

      /**
       * Sets root element's height equal to the height of the fixed masthead elements.
       */
    }, {
      kind: "method",
      key: "_setContainerHeight",
      value: function _setContainerHeight() {
        const {
          mastheadRef
        } = this;
        if (mastheadRef) {
          this.style.display = 'block';
          this.style.height = `${mastheadRef.getBoundingClientRect().height}px`;
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$_loadTranslatio;
        const {
          language,
          dataEndpoint
        } = this;
        globalInit();
        if (language) {
          var _this$_setLanguage;
          (_this$_setLanguage = this._setLanguage) === null || _this$_setLanguage === void 0 || _this$_setLanguage.call(this, language);
        }
        (_this$_loadTranslatio = this._loadTranslation) === null || _this$_loadTranslatio === void 0 || _this$_loadTranslatio.call(this, language, dataEndpoint).catch(() => {}); // The error is logged in the Redux store
        if (this.userStatus === UNAUTHENTICATED_STATUS) {
          var _this$_loadUserStatus;
          (_this$_loadUserStatus = this._loadUserStatus) === null || _this$_loadUserStatus === void 0 || _this$_loadUserStatus.call(this, this.authMethod);
        }

        // This is a temp fix until we figure out why we can't set styles to the :host(c4d-masthead-container) in stylesheets
        this.style.zIndex = '900';
        this.style.position = 'relative';

        // Allows conditional rendering of left/top navs.
        layoutBreakpoint.addEventListener('change', () => {
          this._isMobileVersion = layoutBreakpoint.matches;
          this.requestUpdate();
        });

        // Keep render root's height in sync with c4d-masthead.
        this._heightResizeObserver.observe(this.mastheadRef);
        const mastheadHasLanguageSelector = this.querySelector('c4d-masthead[has-language-selector]');
        if (mastheadHasLanguageSelector) {
          this.hasLanguageSelector = 'true';
        } else {
          this.hasLanguageSelector = 'false';
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('language') || changedProperties.has('dataEndpoint')) {
          const {
            language,
            dataEndpoint
          } = this;
          if (language) {
            var _this$_setLanguage2, _this$_loadTranslatio2;
            (_this$_setLanguage2 = this._setLanguage) === null || _this$_setLanguage2 === void 0 || _this$_setLanguage2.call(this, language);
            (_this$_loadTranslatio2 = this._loadTranslation) === null || _this$_loadTranslatio2 === void 0 || _this$_loadTranslatio2.call(this, language, dataEndpoint).catch(() => {}); // The error is logged in the Redux store
          }
        }
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        _superPropGet(C4DMastheadComposite, "disconnectedCallback", this, 3)([]);
        this._heightResizeObserver.disconnect();
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _isMobileVersion: isMobileVersion,
          activateSearch,
          mastheadAssistiveText,
          skipToContentText,
          skipToContentHref
        } = this;
        return html(_t39 || (_t39 = _`
      ${0}
      <c4d-masthead
        has-language-selector
        ?has-l1=${0}
        aria-label="${0}">
        <c4d-skip-to-content
          href="${0}"
          link-assistive-text="${0}"></c4d-skip-to-content>
        ${0} ${0}
        ${0}
        ${0} ${0}
        <c4d-masthead-global-bar ?has-search-active=${0}>
          ${0}
          ${0}${0}
          ${0}
        </c4d-masthead-global-bar>
        ${0}
        <c4d-megamenu-overlay></c4d-megamenu-overlay>
      </c4d-masthead>
    `), isMobileVersion ? this._renderLeftNav() : '', this.l1Data, ifNonEmpty(mastheadAssistiveText), skipToContentHref, skipToContentText, isMobileVersion ? this._renderMenuButton() : '', this._renderLogo(), this._renderPlatformTitle(), !isMobileVersion ? this._renderTopNav() : '', this._renderSearch(), activateSearch, this._renderContact(), this._renderCart(), this._renderLanguageSelector(), this._renderProfileMenu(), this._renderL1());
      }
    }, {
      kind: "method",
      key: "createRenderRoot",
      value: function createRenderRoot() {
        return this;
      }

      /**
       * The name of the CSS custom property to track bottom edge position.
       */
    }, {
      kind: "get",
      static: true,
      key: "customPropertyL0BottomEdge",
      value: function () {
        return `--${c4dPrefix}-masthead-l0-bottom-edge`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, HostListenerMixin(LitElement));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DMastheadComposite;
//# sourceMappingURL=masthead-composite.js.map
