/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DMastheadProfile from './masthead-profile';
/**
 * The contact button UI in the masthead.
 *
 * @element c4d-masthead-contact
 * @csspart contact-link -The masthead contact link. Usage `c4d-masthead-contact::part(contact-link)`
 */
declare class C4DMastheadContact extends C4DMastheadProfile {
    /**
     * The `aria-label` attribute for the trigger button.
     */
    triggerLabel: string;
    /**
     * Handles cm-app-pane-displayed event fired by CM_APP.
     *
     * @see DOCUMENT_EVENTS live-advisor/cm-app/js/helpers/otherConstants.js
     *   - https://github.ibm.com/live-advisor/cm-app/blob/master/js/helpers/otherConstants.js
     */
    protected _handleCMAppDisplayed: (_event: CustomEvent) => void;
    /**
     * Handles cm-app-pane-hidden event fired by CM_APP.
     *
     * @see DOCUMENT_EVENTS live-advisor/cm-app/js/helpers/otherConstants.js
     *   - https://github.ibm.com/live-advisor/cm-app/blob/master/js/helpers/otherConstants.js
     */
    protected _handleCMAppHidden: (_event: CustomEvent) => void;
    render(): import("lit-html").TemplateResult<1>;
    static styles: any;
}
export default C4DMastheadContact;

//# sourceMappingURL=masthead-contact.d.ts.map
