import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6,
  _t7,
  _t8,
  _t9,
  _t10,
  _t11,
  _t12,
  _t13,
  _t14,
  _t15,
  _t16,
  _t17,
  _t18,
  _t19,
  _t20,
  _t21,
  _t22,
  _t23,
  _t24,
  _t25,
  _t26,
  _t27,
  _t28,
  _t29,
  _t30,
  _t31,
  _t32,
  _t33,
  _t34,
  _t35,
  _t36,
  _t37,
  _t38,
  _t39,
  _t40,
  _t41,
  _t42,
  _t43,
  _t44;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html, LitElement } from 'lit';
import { property, query, queryAll, state } from 'lit/decorators.js';
import root from 'window-or-global';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././masthead-l1.css.js";
import { ifDefined } from 'lit/directives/if-defined.js';
import { unsafeHTML } from 'lit/directives/unsafe-html.js';
import ChevronDown16 from '@carbon/web-components/es/icons/chevron--down/16.js';
import ArrowRight16 from '@carbon/web-components/es/icons/arrow--right/16.js';
import ArrowRight20 from '@carbon/web-components/es/icons/arrow--right/20.js';
import ArrowLeft16 from '@carbon/web-components/es/icons/arrow--left/16.js';
import ArrowLeft20 from '@carbon/web-components/es/icons/arrow--left/20.js';
import CaretLeft20 from '@carbon/web-components/es/icons/caret--left/20.js';
import CaretRight20 from '@carbon/web-components/es/icons/caret--right/20.js';
import { classMap } from 'lit/directives/class-map.js';
import layoutBreakpoint from "./masthead-breakpoint.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;
function handleDropdownClose(event) {
  var _target$querySelector;
  const {
    currentTarget
  } = event;
  const target = currentTarget;
  const openDropdowns = Array.from((_target$querySelector = target === null || target === void 0 ? void 0 : target.querySelectorAll('.is-open')) !== null && _target$querySelector !== void 0 ? _target$querySelector : []);
  if (openDropdowns.length) {
    switch (event.type) {
      case 'keydown':
        {
          const {
            code
          } = event;
          if (code === 'Escape') {
            var _target$firstElementC;
            openDropdowns.forEach(el => {
              el.classList.remove('is-open');
            });
            target === null || target === void 0 || (_target$firstElementC = target.firstElementChild) === null || _target$firstElementC === void 0 || _target$firstElementC.focus();
          }
          break;
        }
      case 'focusout':
        {
          const {
            relatedTarget
          } = event;
          const hasUnknownTargets = !relatedTarget || !currentTarget;
          let focusHasEscaped = false;
          if (!hasUnknownTargets) {
            const comparison = relatedTarget.compareDocumentPosition(currentTarget);
            focusHasEscaped = !(comparison & 8) &&
            // relatedTarget is not ancestor of currentTarget
            relatedTarget !== currentTarget;
          }
          if (hasUnknownTargets || focusHasEscaped) {
            openDropdowns.forEach(el => {
              el.classList.remove('is-open');
            });
          }
          break;
        }
      default:
        break;
    }
  }
}

/**
 * Masthead.
 *
 * @element c4d-masthead-l1
 * @csspart l1-menu-container-inner - The container that wraps the L1 menu items for scrolling purposes. Usage: `c4d-masthead-l1::part(l1-menu-container-inner)`
 * @csspart masthead-l1-menu - The container element for the L1 menu items. Usage: `c4d-masthead-l1::part(masthead-l1-menu)`
 * @csspart l1-menu-first-item - The first item in the L1 menu. Usage: `c4d-masthead-l1::part(l1-menu-first-item)`
 * @csspart l1-menu-last-item - The last item in the L1 menu. Usage: `c4d-masthead-l1::part(l1-menu-last-item)`
 * @csspart l1-menu-container-scroller - The buttons used for scrolling the L1 menu items. Usage: `c4d-masthead-l1::part(l1-menu-container-scroller)`
 * @csspart l1-title-button - The title button in the L1 masthead. Usage: `c4d-masthead-l1::part(l1-title-button)`
 * @csspart l1-dropdown - The dropdown items in the L1 masthead. Usage: `c4d-masthead-l1::part(l1-dropdown)`
 * @csspart l1-dropdown-viewall - The "view all" link in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-viewall)`
 * @csspart l1-dropdown-announcement - The announcement in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-announcement)`
 * @csspart l1-dropdown-section - The sections in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-section)`
 * @csspart l1-dropdown-menu-items - The menu items in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-menu-items)`
 * @csspart l1-dropdown-menu-item - A single menu item in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-menu-item)`
 * @csspart l1-dropdown-item-ul - The item list in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item-ul)`
 * @csspart l1-dropdown-item-li - The list item in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item-li)`
 * @csspart l1-dropdown-item-link - The item link in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item-link)`
 * @csspart l1-dropdown-item-link--heading - The item link in the L1 dropdown that wraps headings. Usage: `c4d-masthead-l1::part(l1-dropdown-item-link--heading)`
 * @csspart l1-dropdown-subsection - The subsection in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-subsection)`
 * @csspart l1-dropdown-item - The dropdown item in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item)`
 * @csspart l1-dropdown-login-link - The login link in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-login-link)`
 * @csspart l1-dropdown-links - A group of l1 dropdown links. Usage: `c4d-masthead-l1::part(l1-dropdown-links)`
 * @csspart dropdown-item-li - The li element for the dropdown item. Usage: `c4d-masthead-l1::part(dropdown-item-li)`
 * @csspart dropdown-login-link-li - The li element for the login link. Usage: `c4d-masthead-l1::part(dropdown-login-link-li)`
 * @csspart cta-li - The li element for the cta. Usage: `c4d-masthead-l1::part(cta-li)`
 * @csspart dropdown-item-link-li - The li element for the dropdown item link. Usage: `c4d-masthead-l1::part(dropdown-item-link-li)`
 * @csspart dropdown-item-span-li - The li element for the dropdown item span. Usage: `c4d-masthead-l1::part(dropdown-item-span-li)`
 * @csspart dropdown-item-button-li - The li element for the dropdown item button. Usage: `c4d-masthead-l1::part(dropdown-item-button-li)`
 * @csspart dropdown-column - The dropdown column container. Usage: `c4d-masthead-l1::part(dropdown-column)
 * @csspart dropdown-column--narrow - The dropdown column narrow modifier. Usage: `c4d-masthead-l1::part(dropdown-column--narrow)
 * @csspart dropdown-column--wide - The dropdown column wide modifier. Usage: `c4d-masthead-l1::part(dropdown-column--wide)
 * @slot brand - The left hand area.
 * @slot nav - The nav content.
 * @slot profile - The right hand area.
 */
let C4DMastheadL1 = _decorate([customElement(`${c4dPrefix}-masthead-l1`)], function (_initialize, _StableSelectorMixin) {
  class C4DMastheadL1 extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadL1,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'active',
        reflect: true,
        type: Boolean
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "l1Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [property()],
      key: "currentUrlPath",
      value() {
        var _root$location;
        return (_root$location = root.location) === null || _root$location === void 0 ? void 0 : _root$location.href;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [state()],
      key: "isMobileVersion",
      value() {
        return layoutBreakpoint.matches;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "selectedElements",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'overview-text'
      })],
      key: "overviewText",
      value() {
        return 'Overview';
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "direction",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--masthead__l1-menu-container-inner`)],
      key: "menuContainerInner",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--masthead__l1-menu`)],
      key: "menu",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--masthead__l1-menu > *:first-child`)],
      key: "menuFirstItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--masthead__l1-menu > *:last-child`)],
      key: "menuLastItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [queryAll(`.${prefix}--masthead__l1-menu-container-scroller`)],
      key: "menuScrollerButtons",
      value: void 0
    }, {
      kind: "get",
      key: "Arrow16",
      value:
      /**
       * Whether an L1 menu is open or not.
       */

      /**
       * The L1 menu data, passed from the masthead-composite.
       */

      /**
       * The URL path of the current document root.
       */

      /**
       * The English title of the selected nav item.
       */

      /**
       * Whether the current viewport is below 800px or not
       */

      /**
       * Elements that are currently selected.
       */

      /**
       * The translated label for the overview links visible on mobile
       */

      /**
       * The writing direction of the page
       */

      /**
       * The x-scrolling element wrapping the L1 top-level items
       */

      /**
       * The first top-level menu items
       */

      /**
       * The last top-level menu items
       */

      /**
       * The buttons that scroll the top-level menu items
       */

      function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? ArrowLeft16 : ArrowRight16;
      }
    }, {
      kind: "get",
      key: "Arrow20",
      value: function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? ArrowLeft20 : ArrowRight20;
      }

      /**
       * Resize Observer responsible for show/hiding the scrolling buttons.
       */

      /**
       * Prevents resize observer from blocking main thread.
       */
    }, {
      kind: "method",
      key: "toggleScrollButtons",
      value:
      /**
       * ResizeObserver callback method
       */
      function toggleScrollButtons() {
        // Resize events happen rapidly. We need to throttle this functionality.
        if (!this.scrollObserverThrottler) {
          var _this$l1Data$menuItem, _this$l1Data;
          const {
            menu,
            menuContainerInner,
            menuFirstItem,
            menuLastItem,
            menuScrollerButtons
          } = this;

          // Only act if all the needed elements are present.
          const menuItems = (_this$l1Data$menuItem = (_this$l1Data = this.l1Data) === null || _this$l1Data === void 0 ? void 0 : _this$l1Data.menuItems) !== null && _this$l1Data$menuItem !== void 0 ? _this$l1Data$menuItem : [];
          if (menuItems.length === 0) {
            menuScrollerButtons === null || menuScrollerButtons === void 0 || menuScrollerButtons.forEach(button => {
              button.setAttribute('hidden', '');
            });
          } else if (menuFirstItem && menuLastItem && menuContainerInner && menuScrollerButtons) {
            // Find first & last items, calculate width between outer boundaries.
            const firstItemBox = menuFirstItem.getBoundingClientRect();
            const lastItemBox = menuLastItem.getBoundingClientRect();
            const menuLeft = Math.min(firstItemBox.left, lastItemBox.left);
            const menuRight = Math.max(firstItemBox.right, lastItemBox.right);
            const menuWidth = menuRight - menuLeft;
            const containerWidth = menuContainerInner === null || menuContainerInner === void 0 ? void 0 : menuContainerInner.getBoundingClientRect().width;

            // If we overflow the container, show buttons.
            if (menuWidth > containerWidth) {
              menuScrollerButtons.forEach(button => {
                button.removeAttribute('hidden');
              });
              if (menu !== null && menu !== void 0 && menu.style.translate) {
                const currentScroll = parseInt(menu.style.translate);
                const maxScroll = containerWidth - menuWidth;
                menu.style.translate = `${Math.max(currentScroll, maxScroll)}px`;
              }
            }
            // If we don't, hide the buttons.
            else {
              menuScrollerButtons.forEach(button => {
                button.setAttribute('hidden', '');
              });

              // Remove any translations we've used to mimic scrolling.
              if (menu) {
                menu.style.translate = '';
              }
            }
          }

          // Prevent this functionality from running again until the time threshold has passed.
          this.scrollObserverThrottler = setTimeout(() => {
            this.scrollObserverThrottler = undefined;
          }, 100);
        }
      }

      /**
       * Creates resize observer on load/update when above mobile breakpoint.
       */
    }, {
      kind: "method",
      key: "_createScrollObserver",
      value: function _createScrollObserver() {
        const {
          menuContainerInner,
          toggleScrollButtons
        } = this;
        this.scrollObserver = new ResizeObserver(toggleScrollButtons.bind(this));
        if (menuContainerInner) {
          this.scrollObserver.observe(menuContainerInner);
        }
      }

      /**
       * Scrolls the menu inner container on click.
       *
       * @param event The button click
       */
    }, {
      kind: "method",
      key: "_scrollL1TopNav",
      value: function _scrollL1TopNav(event) {
        const {
          currentTarget
        } = event;
        const {
          menuContainerInner,
          menu,
          direction
        } = this;
        if (!menu || !menuContainerInner) {
          return;
        }

        // Valid translations will exist between 0 and a some negative value.
        const minTranslationValue = (menu.clientWidth - menuContainerInner.clientWidth) * -1;
        const maxTranslationValue = 0;

        // Use a 1/-1 multiplier to account for correct button
        let buttonDirMultiplier;
        switch (currentTarget.id) {
          // "Next" button should pull menu toward 0
          case 'scroll-next':
            buttonDirMultiplier = -1;
            break;
          // "Prev" button should push menu away from 0
          case 'scroll-prev':
            buttonDirMultiplier = 1;
            break;
          default:
            buttonDirMultiplier = 0;
            break;
        }

        // Use a 1/-1 multiplier to account for writing direction
        let writingDirMultiplier;
        switch (direction) {
          // LTR is inline with x-axis
          case 'ltr':
            writingDirMultiplier = 1;
            break;
          // RTL must invert x-axis
          case 'rtl':
            writingDirMultiplier = -1;
            break;
          default:
            writingDirMultiplier = 0;
            break;
        }

        // Get current translation value
        const computedScroll = parseInt(window.getComputedStyle(menu).translate);
        const currentScroll = !Number.isNaN(computedScroll) ? computedScroll : 0;

        // Adjust translation value by adding/subtracting the width of the visible menu
        const newScroll = currentScroll + menuContainerInner.clientWidth * buttonDirMultiplier * writingDirMultiplier;

        // Cap the value to avoid over-translation to either side
        const cappedValue = Math.max(minTranslationValue, Math.min(maxTranslationValue, newScroll));
        menu.style.translate = `${cappedValue}px`;
      }

      /**
       * Renders the L1 CTA.
       *
       * @returns {_TemplateResult} A template fragment representing the L1 CTA
       */
    }, {
      kind: "method",
      key: "_renderCta",
      value: function _renderCta() {
        return html(_t || (_t = _`<slot name="l1-cta"></slot>`));
      }

      /**
       * Renders L1 for desktop screensizes
       *
       * @returns {_TemplateResult} L1 for desktop screensizes
       */
    }, {
      kind: "method",
      key: "_renderL1TopNav",
      value: function _renderL1TopNav() {
        const {
          l1Data,
          direction,
          _scrollL1TopNav: scrollL1TopNav
        } = this;
        const {
          url,
          title,
          actions,
          menuItems
        } = l1Data !== null && l1Data !== void 0 ? l1Data : {};
        const {
          login
        } = actions !== null && actions !== void 0 ? actions : {};
        return html(_t2 || (_t2 = _`
      <div
        part="masthead-l1-menu-container-mask"
        class="${0}--masthead__l1-menu-container-mask ${0}--masthead__l1-menu-container-mask--start"></div>
      ${0}
      <div
        part="masthead-l1-menu-container-outer"
        class="${0}--masthead__l1-menu-container-outer">
        <button
          part="l1-menu-container-scroller-button"
          class="${0}--masthead__l1-menu-container-scroller"
          id="scroll-prev"
          @click=${0}>
          <div
            part="l1-menu-container-scroller-inner"
            class="${0}--masthead__l1-menu-container-scroller-inner">
            ${0}
          </div>
        </button>
        <div
          part="l1-menu-container-inner"
          class="${0}--masthead__l1-menu-container-inner">
          <ul part="l1-menu" class="${0}--masthead__l1-menu">
            ${0}
          </ul>
        </div>
        <button
          part="l1-menu-container-scroller"
          class="${0}--masthead__l1-menu-container-scroller"
          id="scroll-next"
          @click=${0}>
          <div
            part="l1-menu-container-scroller-inner"
            class="${0}--masthead__l1-menu-container-scroller-inner">
            ${0}
          </div>
        </button>
      </div>
      ${0}
      ${0}
      <div
        part="masthead-l1-menu-container-mask"
        class="${0}--masthead__l1-menu-container-mask ${0}--masthead__l1-menu-container-mask--end"></div>
    `), prefix, prefix, !title || !url ? undefined : html(_t3 || (_t3 = _`
            <div
              part="masthead-background-wrapper"
              class="${0}--masthead__background-wrapper">
              <a
                part="masthead-l1-title"
                class="${0}--masthead__l1-title"
                href="${0}"
                >${0}</a
              >
            </div>
          `), prefix, prefix, url, title), prefix, prefix, scrollL1TopNav, prefix, direction === 'ltr' ? CaretLeft20() : CaretRight20(), prefix, prefix, (menuItems !== null && menuItems !== void 0 ? menuItems : []).map(menuItem => this._renderL1TopNavDropDowns(menuItem)), prefix, scrollL1TopNav, prefix, direction === 'ltr' ? CaretRight20() : CaretLeft20(), login && login.url && login.title ? html(_t4 || (_t4 = _`
            <div
              part="masthead-background-wrapper"
              class="${0}--masthead__background-wrapper">
              <a
                part="masthead-l1-login"
                class="${0}--masthead__l1-login"
                href="${0}"
                >${0}</a
              >
            </div>
          `), prefix, prefix, ifDefined(login.url), login.title) : '', this._renderCta(), prefix, prefix);
      }

      /**
       * Renders L1MenuItems with subsections containing announcements, headings, links, and footers.
       *
       * @param {_L1MenuItem} menuItem Array of menu items containing subnavs
       * @returns {_TemplateResult} rendered output
       */
    }, {
      kind: "method",
      key: "_renderL1TopNavDropDowns",
      value: function _renderL1TopNavDropDowns(menuItem) {
        const {
          _toggleSubsection: toggleSubsection,
          _handleTopNavFocusIn: handleTopNavFocusIn
        } = this;
        const {
          title,
          url,
          target,
          submenu
        } = menuItem;
        if (!submenu && url) {
          return html(_t5 || (_t5 = _`
        <li part="masthead-l1-item">
          <a
            part="masthead-l1-item-link"
            class="${0}--masthead__l1-item"
            href="${0}"
            target="${0}"
            @focusin=${0}
            >${0}</a
          >
        </li>
      `), prefix, url, target, handleTopNavFocusIn, title);
        } else if (!submenu) {
          return html(_t6 || (_t6 = _`
        <li part="masthead-l1-item">
          <span
            part="masthead-l1-item-span"
            class="${0}--masthead__l1-item"
            @focusin=${0}
            >${0}</span
          >
        </li>
      `), prefix, handleTopNavFocusIn, title);
        }
        const {
          announcement,
          menuSections,
          footer,
          columns
        } = submenu !== null && submenu !== void 0 ? submenu : {};

        // 3-column dropdown has option for 33/66 split.
        const hasWideColumn = columns === 3 ? menuSections.some(section => section.span > 1) : false;

        // Split can be 33/66 or 66/33.
        const wideColumnFirst = menuSections[0].span > 1;
        const wideColumns = menuSections.filter(section => section.span > 1);
        const normalColumns = menuSections.filter(section => !(section.span > 1));
        const dropdownClasses = classMap({
          [`${prefix}--masthead__l1-dropdown-links`]: true,
          [`${prefix}--masthead__l1-dropdown--has-column-wide`]: hasWideColumn
        });
        return html(_t7 || (_t7 = _`
      <li
        part="masthead-l1-item"
        @focusout=${0}
        @keydown=${0}
        tabindex="-1">
        <button
          part="masthead-l1-item-button"
          class="${0}--masthead__l1-item"
          @click=${0}
          @focusin=${0}>
          ${0}${0}
        </button>
        <div
          part="l1-dropdown"
          data-dropdown-target
          class="${0}--masthead__l1-dropdown ${0}--masthead__l1-dropdown__${0}-col">
          ${0}
          <div part="l1-dropdown-links" class="${0}">
            ${0}
            ${0}
            ${0}
          </div>
          ${0}
        </div>
      </li>
    `), handleDropdownClose, handleDropdownClose, prefix, toggleSubsection, handleTopNavFocusIn, title, ChevronDown16(), prefix, prefix, columns, announcement ? html(_t8 || (_t8 = _`<div
                part="l1-dropdown-announcement"
                class="${0}--masthead__l1-dropdown-announcement">
                ${0}
              </div>`), prefix, unsafeHTML(announcement)) : '', dropdownClasses, hasWideColumn && wideColumnFirst ? this._renderL1DropdownSections(wideColumns, hasWideColumn, true) : '', this._renderL1DropdownSections(normalColumns, hasWideColumn, false), hasWideColumn && !wideColumnFirst ? this._renderL1DropdownSections(wideColumns, hasWideColumn, true) : '', footer ? html(_t9 || (_t9 = _`<a
                part="l1-dropdown-viewall"
                class="${0}--masthead__l1-dropdown-viewall"
                href="${0}"
                >${0}${0}</a
              >`), prefix, footer.url, footer.title, this.Arrow16()) : '');
      }

      /**
       *
       * @param {_L1SubmenuSection[]} sections the sections to render.
       * @param {boolean} hasWide if this column will be rendered as or next to a wide column.
       * @param {boolean} isWide if this column will be rendered as a wide column.
       * @returns rendered markup
       */
    }, {
      kind: "method",
      key: "_renderL1DropdownSections",
      value: function _renderL1DropdownSections(sections, hasWide, isWide) {
        const renderedSections = sections.map(section => {
          const {
            heading,
            items
          } = section;
          return html(_t10 || (_t10 = _`
        <div
          part="l1-dropdown-section"
          class="${0}--masthead__l1-dropdown-section">
          ${0}
          ${0}
        </div>
      `), prefix, heading ? html(_t11 || (_t11 = _`${0}`), this._renderL1SubSectionHeading(heading)) : '', items ? html(_t12 || (_t12 = _` <ul
                part="l1-dropdown-menu-items"
                class="${0}--masthead__l1-dropdown-menu-items">
                ${0}
              </ul>`), prefix, items.map(item => {
            const {
              title,
              url,
              target,
              description
            } = item;
            const linkContents = description ? html(_t13 || (_t13 = _`
                        <span
                          part="l1-dropdown-item-title-span"
                          class="${0}--masthead__l1-dropdown-item-title"
                          >${0}</span
                        >
                        <span
                          part="l1-dropdown-item-description-span"
                          class="${0}--masthead__l1-dropdown-item-description"
                          >${0}</span
                        >
                      `), prefix, title, prefix, description) : html(_t14 || (_t14 = _` ${0} `), title);
            return html(_t15 || (_t15 = _`
                    <li part="l1-dropdown-menu-item">
                      <a
                        part="l1-dropdown-item-link"
                        class="${0}--masthead__l1-dropdown-item"
                        href="${0}"
                        target="${0}">
                        ${0}
                      </a>
                    </li>
                  `), prefix, url, target, linkContents);
          })) : '');
        });
        const classes = classMap({
          [`${prefix}--masthead__l1-dropdown-column-narrow`]: hasWide && !isWide,
          [`${prefix}--masthead__l1-dropdown-column-wide`]: hasWide && isWide
        });
        return hasWide ? html(_t16 || (_t16 = _`<div
          class=${0}
          part="dropdown-column${0}">
          ${0}
        </div>`), classes, hasWide && !isWide ? ' dropdown-column--narrow' : hasWide && isWide ? ' dropdown-column--wide' : '', renderedSections) : html(_t17 || (_t17 = _`${0}`), renderedSections);
      }

      /**
       * Renders L1 for mobile screensizes.
       *
       * @returns {_TemplateResult} L1 for mobile screensizes.
       */
    }, {
      kind: "method",
      key: "_renderL1MobileNav",
      value: function _renderL1MobileNav() {
        const {
          l1Data,
          overviewText
        } = this;
        const {
          url,
          title,
          actions,
          menuItems
        } = l1Data !== null && l1Data !== void 0 ? l1Data : {};
        const {
          cta,
          login
        } = actions !== null && actions !== void 0 ? actions : {};
        const {
          _toggleSubsection: toggleSubsection
        } = this;
        return html(_t18 || (_t18 = _`
      <button
        part="l1-title-button"
        class="${0}--masthead__l1-title"
        @click=${0}>
        ${0}${0}
      </button>
      <ul
        part="l1-dropdown"
        data-dropdown-target
        class="${0}--masthead__l1-dropdown">
        ${0}
        ${0}
        ${0}
        ${0}
      </ul>
    `), prefix, toggleSubsection, title, ChevronDown16(), prefix, url ? html(_t19 || (_t19 = _` <li part="dropdown-item-li">
              <a
                part="l1-dropdown-item"
                class="${0}--masthead__l1-dropdown-item"
                href="${0}">
                ${0}
              </a>
            </li>`), prefix, url, overviewText) : '', menuItems === null || menuItems === void 0 ? void 0 : menuItems.map(menuItem => this._renderL1MobileSubnav(menuItem)), login && login.url && login.title ? html(_t20 || (_t20 = _` <li part="dropdown-login-link-li">
              <a
                part="l1-dropdown-login-link"
                class="${0}--masthead__l1-dropdown-login"
                href="${0}">
                ${0}${0}
              </a>
            </li>`), prefix, ifDefined(login.url), login.title, this.Arrow16()) : '', cta ? html(_t21 || (_t21 = _`<li part="cta-li">${0}</li>`), this._renderCta()) : '');
      }

      /**
       * Renders L1MenuItems with subsections containing announcements, headings, links, and footers.
       *
       * @param {_L1MenuItem} menuItem Array of menu items containing subnavs
       * @returns {_TemplateResult} rendered output
       */
    }, {
      kind: "method",
      key: "_renderL1MobileSubnav",
      value: function _renderL1MobileSubnav(menuItem) {
        const {
          _toggleSubsection: toggleSubsection
        } = this;
        const {
          title,
          target,
          url,
          submenu
        } = menuItem;
        if (!submenu && url) {
          return html(_t22 || (_t22 = _`
        <li part="dropdown-item-link-li">
          <a
            part="l1-dropdown-item-link"
            class="${0}--masthead__l1-dropdown-item"
            target="${0}"
            href="${0}"
            >${0}</a
          >
        </li>
      `), prefix, target, url, title);
        } else if (!submenu) {
          return html(_t23 || (_t23 = _`
        <li part="dropdown-item-span-li">
          <span
            part="l1-dropdown-item-span"
            class="${0}--masthead__l1-dropdown-item"
            >${0}</span
          >
        </li>
      `), prefix, title);
        }
        const {
          announcement,
          menuSections,
          footer
        } = submenu !== null && submenu !== void 0 ? submenu : {};
        return html(_t24 || (_t24 = _`
      <li part="dropdown-item-button-li">
        <button
          part="l1-dropdown-item-button"
          class="${0}--masthead__l1-dropdown-item"
          @click=${0}>
          ${0}${0}
        </button>
        <div
          part="l1-dropdown-subsection"
          data-dropdown-target
          class="${0}--masthead__l1-dropdown-subsection">
          ${0}
          ${0}
          ${0}
        </div>
      </li>
    `), prefix, toggleSubsection, title, ChevronDown16(), prefix, announcement ? html(_t25 || (_t25 = _`<div
                part="l1-dropdown-announcement"
                class="${0}--masthead__l1-dropdown-announcement">
                ${0}
              </div>`), prefix, unsafeHTML(announcement)) : '', menuSections ? menuSections.map(section => {
          const {
            heading,
            items
          } = section;
          return html(_t26 || (_t26 = _`
                  ${0}
                  ${0}
                `), heading ? html(_t27 || (_t27 = _`${0}`), this._renderL1SubSectionHeading(heading)) : '', items ? html(_t28 || (_t28 = _` <ul part="l1-dropdown-item-ul">
                        ${0}
                      </ul>`), items.map(item => {
            const {
              title,
              url,
              target
            } = item;
            return html(_t29 || (_t29 = _` <li part="l1-dropdown-item-li">
                            <a
                              part="l1-dropdown-item-link"
                              class="${0}--masthead__l1-dropdown-item"
                              target="${0}"
                              href="${0}">
                              ${0}
                            </a>
                          </li>`), prefix, target, url, title);
          })) : '');
        }) : '', footer ? html(_t30 || (_t30 = _`
                <a part="l1-dropdown-viewall"
                  class="${0}--masthead__l1-dropdown-viewall"
                  href="${0}"
                >
                  ${0}${0}
                </li>`), prefix, footer.url, footer.title, this.Arrow16()) : '');
      }

      /**
       * Toggles the mobile navigation subsection.
       *
       * @param {PointerEvent} event The click event from the user
       */
    }, {
      kind: "method",
      key: "_toggleSubsection",
      value: function _toggleSubsection(event) {
        var _button$parentNode;
        const {
          isMobileVersion
        } = this;
        const {
          dropDownToggleEvent
        } = this.constructor;
        const {
          currentTarget
        } = event;
        const button = currentTarget;
        const dropdown = (_button$parentNode = button.parentNode) === null || _button$parentNode === void 0 ? void 0 : _button$parentNode.querySelector('[data-dropdown-target]');
        const isOpen = dropdown === null || dropdown === void 0 ? void 0 : dropdown.classList.contains('is-open');
        if (!isMobileVersion && dropdown && !isOpen) {
          // Get Button & Dropdown locations & widths
          const buttonRect = button.getBoundingClientRect().toJSON();
          const dropdownRect = dropdown.getBoundingClientRect().toJSON();
          const viewportWidth = window.innerWidth;
          const isLTR = window.getComputedStyle(this).direction.toUpperCase() === 'LTR';
          const dirMultiplier = isLTR ? -1 : 1;

          // Set logical bounding client rect properties
          buttonRect.inlineStart = isLTR ? buttonRect.left : viewportWidth - buttonRect.right;
          buttonRect.inlineEnd = isLTR ? buttonRect.right : viewportWidth - buttonRect.left;
          dropdownRect.inlineStart = isLTR ? dropdownRect.left : viewportWidth - dropdownRect.right;
          dropdownRect.inlineEnd = isLTR ? dropdownRect.right : viewportWidth - dropdownRect.left;

          // What would the left/right boundaries be if we centered the dropdown?
          const startBoundaryIfCentered = (viewportWidth - dropdownRect.width) / 2;
          const endBoundaryIfCentered = startBoundaryIfCentered + dropdownRect.width;

          // If start-aligning to button doesn't overflow viewport.
          if (buttonRect.inlineStart + dropdownRect.width < viewportWidth) {
            // Do nothing, the styles are fine.
          }

          // If center-aligning to viewport fully intersects with button.
          else if (startBoundaryIfCentered < buttonRect.inlineStart && endBoundaryIfCentered > buttonRect.inlineEnd) {
            const translationAmount = (buttonRect.inlineStart - startBoundaryIfCentered) * dirMultiplier;
            dropdown.style.translate = `${translationAmount}px`;
          }

          // Fallback: right align to button.
          else {
            const translationAmount = (dropdownRect.width - buttonRect.width) * dirMultiplier;
            dropdown.style.translate = `${translationAmount}px`;
          }

          // Ensure dropdown doesn't overflow viewport vertically.
          const viewportHeight = window.innerHeight;
          const maxHeight = viewportHeight - dropdownRect.top;
          dropdown.style.maxHeight = `calc(${maxHeight}px - 4rem)`;
        }
        this.dispatchEvent(new CustomEvent(dropDownToggleEvent, {
          bubbles: true,
          composed: true,
          cancelable: false,
          detail: {
            isOpen: !isOpen
          }
        }));
        this.active = !isOpen;
        button.classList.toggle('is-open', !isOpen);
        dropdown.classList.toggle('is-open', !isOpen);
      }

      /**
       * "Scrolls" the top nav in cases where elements are focused but not fully visible.
       *
       * @param event The focus event
       */
    }, {
      kind: "method",
      key: "_handleTopNavFocusIn",
      value: function _handleTopNavFocusIn(event) {
        const {
          menuContainerInner,
          menu
        } = this;
        const {
          target
        } = event;
        const containerBox = menuContainerInner.getBoundingClientRect();
        const buttonBox = target.getBoundingClientRect();
        const leftOverflow = Math.max(containerBox.left - buttonBox.left, 0);
        const rightOverflow = Math.max(buttonBox.right - containerBox.right, 0);
        if (leftOverflow || rightOverflow) {
          const computedScroll = parseInt(window.getComputedStyle(menu).translate);
          const currentScroll = !Number.isNaN(computedScroll) ? computedScroll : 0;
          let newScroll = currentScroll;
          if (rightOverflow) {
            newScroll = currentScroll - rightOverflow;
          }
          if (leftOverflow) {
            newScroll = currentScroll + leftOverflow;
          }
          menu.style.translate = `${newScroll}px`;
        }
      }

      /**
       * Sets active menu item styles.
       */
    }, {
      kind: "method",
      key: "_handleSelectedMenuItem",
      value: function _handleSelectedMenuItem() {
        const {
          selectedMenuItem,
          currentUrlPath
        } = this;
        const menuItems = Array.from(this.shadowRoot.querySelectorAll(`.${prefix}--masthead__l1-item, .${prefix}--masthead__l1-dropdown-item`));
        const allLinks = Array.from(this.shadowRoot.querySelectorAll('a'));

        // Reset all selected elements.
        Array.from(this.shadowRoot.querySelectorAll('[active]')).forEach(el => el === null || el === void 0 ? void 0 : el.removeAttribute('active'));
        this.selectedElements = [];

        // Check for manually set selected item.
        if (selectedMenuItem) {
          this.selectedElements = [...menuItems, ...allLinks].filter(el => {
            var _el$textContent;
            return ((_el$textContent = el.textContent) === null || _el$textContent === void 0 || (_el$textContent = _el$textContent.trim()) === null || _el$textContent === void 0 ? void 0 : _el$textContent.toLowerCase()) === selectedMenuItem.trim().toLowerCase();
          });
        }
        // Fall back to automated selection based on URL.
        else {
          this.selectedElements = allLinks.filter(el => {
            try {
              const elURL = new URL(el.href);
              const currURL = new URL(currentUrlPath || '');
              if (el.href.includes('#')) {
                return false;
              }
              // Compare url without query params.
              return elURL.host === currURL.host && elURL.pathname === currURL.pathname;
            } catch (_error) {
              return false;
            }
          });
        }
        if (this.selectedElements.length) {
          // Set active on nearest menu item.
          this.selectedElements.forEach(element => {
            var _element$closest, _parentMenuItem$class;
            const parentMenuItem = (_element$closest = element.closest(`.${prefix}--masthead__l1-dropdown, .${prefix}--masthead__l1-dropdown-subsection`)) === null || _element$closest === void 0 ? void 0 : _element$closest.previousElementSibling;

            // Set on parent item as long as it's not the dropdown toggle.
            if (parentMenuItem && !(parentMenuItem !== null && parentMenuItem !== void 0 && (_parentMenuItem$class = parentMenuItem.classList) !== null && _parentMenuItem$class !== void 0 && _parentMenuItem$class.contains(`bx--masthead__l1-title`))) {
              parentMenuItem === null || parentMenuItem === void 0 || parentMenuItem.setAttribute('active', '');
            } else {
              element.setAttribute('active', '');
            }
          });
        } else {
          var _this$shadowRoot;
          // Should default to active section name if no menu links are selected.
          const l1Title = (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector(`.${prefix}--masthead__l1-title`);
          l1Title.setAttribute('active', '');
          this.selectedElements.push(l1Title);
        }
      }

      /**
       * Renders a heading object in the proper <H#> element.
       *
       * @param heading The heading object to be rendered.
       * @returns {_TemplateResult} Rendered heading.
       */
    }, {
      kind: "method",
      key: "_renderL1SubSectionHeading",
      value: function _renderL1SubSectionHeading(heading) {
        const {
          isMobileVersion
        } = this;
        const headingDesc = !isMobileVersion && heading.description ? html(_t31 || (_t31 = _`<span class="${0}--masthead__l1-dropdown-heading-desc"
            >${0}</span
          >`), prefix, heading.description) : '';
        const headingContent = heading.url ? html(_t32 || (_t32 = _`
          <a
            part="l1-dropdown-item-link l1-dropdown-item-link--heading"
            class="${0}--masthead__l1-dropdown-item"
            href="${0}">
            ${0}${0}
          </a>
        `), prefix, heading.url, heading.title, isMobileVersion ? this.Arrow16() : this.Arrow20()) : html(_t33 || (_t33 = _` ${0} `), heading.title);
        const headingClasses = classMap({
          [`${prefix}--masthead__l1-dropdown-heading`]: true,
          [`${prefix}--masthead__l1-dropdown-heading--no-link`]: Boolean(heading.url) === false
        });
        let renderedHeading = headingContent;
        switch (heading.headingLevel) {
          case 2:
            renderedHeading = html(_t34 || (_t34 = _`
          <h2 part="masthead-l1-h2-heading" class=${0}>
            ${0}
          </h2>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 3:
            renderedHeading = html(_t35 || (_t35 = _`
          <h3 part="masthead-l1-h3-heading" class=${0}>
            ${0}
          </h3>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 4:
            renderedHeading = html(_t36 || (_t36 = _`
          <h4 part="masthead-l1-h4-heading" class=${0}>
            ${0}
          </h4>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 5:
            renderedHeading = html(_t37 || (_t37 = _`
          <h5 part="masthead-l1-h5-heading" class=${0}>
            ${0}
          </h5>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 6:
            renderedHeading = html(_t38 || (_t38 = _`
          <h6 part="masthead-l1-h6-heading" class=${0}>
            ${0}
          </h6>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          default:
            renderedHeading = headingContent;
        }
        return renderedHeading;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        this.style.setProperty('--scrollbarWidth', window.innerWidth - document.documentElement.clientWidth + 'px');

        // Allows component conditions on breakpoint change
        layoutBreakpoint.addEventListener('change', () => {
          this.isMobileVersion = layoutBreakpoint.matches;
        });
        if (this.isMobileVersion) {
          this._createScrollObserver();
        }
        this.direction = window.getComputedStyle(this).direction;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('selectedMenuItem')) {
          this._handleSelectedMenuItem();
        }
        if (changedProperties.has('isMobileVersion')) {
          if (this.isMobileVersion) {
            var _this$scrollObserver;
            // Stop observing, delete the observer.
            (_this$scrollObserver = this.scrollObserver) === null || _this$scrollObserver === void 0 || _this$scrollObserver.disconnect();
            this.scrollObserver = undefined;
          } else {
            // Creat observer, start observing.
            this._createScrollObserver();
          }
          this._handleSelectedMenuItem();
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          isMobileVersion
        } = this;
        return html(_t39 || (_t39 = _`
      <div
        part="masthead-l1-inner-container"
        class="${0}--masthead__l1-inner-container">
        ${0}
      </div>
    `), prefix, isMobileVersion ? html(_t40 || (_t40 = _` ${0} `), this._renderL1MobileNav()) : html(_t41 || (_t41 = _` ${0} `), this._renderL1TopNav()));
      }

      /**
       * Creates CTA markup and slots it into the L1.
       *
       * @param {L1CtaLink} cta L1 CTA data object
       * @returns A template fragment representing an L1 CTA or an empty string.
       */
    }, {
      kind: "method",
      static: true,
      key: "renderL1Cta",
      value: function renderL1Cta(cta) {
        const {
          url,
          ctaType
        } = cta;
        const slottedText = html(_t42 || (_t42 = _`<span slot="cta-text">${0}</span>`), cta === null || cta === void 0 ? void 0 : cta.title);
        if (ctaType) {
          return html(_t43 || (_t43 = _`
        <c4d-masthead-l1-cta slot="l1-cta" type="${0}">
          ${0}
        </c4d-masthead-l1-cta>
      `), ctaType, slottedText);
        }
        if (url) {
          return html(_t44 || (_t44 = _`
        <c4d-masthead-l1-cta slot="l1-cta" href="${0}">
          ${0}
        </c4d-masthead-l1-cta>
      `), url, slottedText);
        }
        return '';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--masthead__l1`;
      }
    }, {
      kind: "get",
      static: true,
      key: "dropDownToggleEvent",
      value: function () {
        return `${c4dPrefix}-masthead-l1-dropdown-toggle`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
export default C4DMastheadL1;
//# sourceMappingURL=masthead-l1.js.map
