import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import CDSHeaderMenuItem from '@carbon/web-components/es/components/ui-shell/header-menu-item.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Profile menu item in masthead.
 *
 * @element c4d-masthead-profile-item
 */
let C4DMastheadProfileItem = _decorate([customElement(`${c4dPrefix}-masthead-profile-item`)], function (_initialize, _CDSHeaderMenuItem) {
  class C4DMastheadProfileItem extends _CDSHeaderMenuItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadProfileItem,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$shadowRoot;
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
      }
    }]
  };
}, CDSHeaderMenuItem);
export default C4DMastheadProfileItem;
//# sourceMappingURL=masthead-profile-item.js.map
