/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { LitElement } from 'lit';
import './megamenu-link-with-icon';
/**
 * MegaMenu category group
 *
 * @element c4d-megamenu-category-group
 * @csspart shield - The shield element of the megamenu category group. Usage: `c4d-megamenu-category-group::part(shield)`
 * @csspart content-wrapper - The content wrapper of the megamenu category group. Usage: `c4d-megamenu-category-group::part(content-wrapper)`
 * @csspart heading - The heading of the megamenu category group. Usage: `c4d-megamenu-category-group::part(heading)`
 * @csspart content - The content of the megamenu category group. Usage: `c4d-megamenu-category-group::part(content)`
 */
declare class C4DMegaMenuCategoryGroup extends LitElement {
    /**
     * href for the category group title
     */
    href: string;
    /**
     * category group title/heading
     */
    title: string;
    render(): import("lit-html").TemplateResult<1>;
    static styles: any;
}
export default C4DMegaMenuCategoryGroup;

//# sourceMappingURL=megamenu-category-group.d.ts.map
