/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import CDSLink from '@carbon/web-components/es/components/link/link.js';
import { MEGAMENU_LAYOUT_SCHEME } from './defs';
/**
 * MegaMenu category sublink
 *
 * @element c4d-megamenu-category-link
 * @csspart link-heading - The link heading. Usage: `c4d-megamenu-category-link::part(link-heading)`
 * @csspart link-description - The link description. Usage: `c4d-megamenu-category-link::part(link-description)`
 * @csspart span - The span element. Usage: `c4d-megamenu-category-link::part(span)`
 */
declare class C4DMegaMenuCategoryLink extends CDSLink {
    layout?: MEGAMENU_LAYOUT_SCHEME;
    /**
     * link title.
     */
    title: string;
    /**
     * Maps target value to icons.
     */
    protected _targetMap: Map<string, import("lit-html").SVGTemplateResult>;
    /**
     * Renders an icon based on target value.
     */
    protected _renderIcon(): import("lit-html").SVGTemplateResult | undefined;
    /**
     * @returns The inner content.
     */
    protected _renderInner(): import("lit-html").TemplateResult<1>;
    protected _renderLink(): import("lit-html").TemplateResult<1>;
    connectedCallback(): void;
    static styles: any;
}
export default C4DMegaMenuCategoryLink;

//# sourceMappingURL=megamenu-category-link.d.ts.map
