import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import ifNonEmpty from '@carbon/web-components/es/globals/directives/if-non-empty.js';
import CDSLink from '@carbon/web-components/es/components/link/link.js';
import Launch16 from '@carbon/web-components/es/icons/launch/16.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DMegaMenu from "./megamenu.js";
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * MegaMenu category sublink
 *
 * @element c4d-megamenu-category-link
 * @csspart link-heading - The link heading. Usage: `c4d-megamenu-category-link::part(link-heading)`
 * @csspart link-description - The link description. Usage: `c4d-megamenu-category-link::part(link-description)`
 * @csspart span - The span element. Usage: `c4d-megamenu-category-link::part(span)`
 */
let C4DMegaMenuCategoryLink = _decorate([customElement(`${c4dPrefix}-megamenu-category-link`)], function (_initialize, _CDSLink) {
  class C4DMegaMenuCategoryLink extends _CDSLink {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuCategoryLink,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "layout",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "title",
      value() {
        return '';
      }
    }, {
      kind: "field",
      key: "_targetMap",
      value() {
        return new Map([['external', Launch16()]]);
      }
    }, {
      kind: "method",
      key: "_renderIcon",
      value:
      /**
       * link title.
       */

      /**
       * Maps target value to icons.
       */

      /**
       * Renders an icon based on target value.
       */
      function _renderIcon() {
        const {
          target,
          _targetMap
        } = this;
        return _targetMap.has(target) ? _targetMap.get(target) : undefined;
      }

      /**
       * @returns The inner content.
       */
    }, {
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        const {
          title
        } = this;
        return html(_t || (_t = _`
      ${0}
      <span part="link-description">
        <slot></slot>
      </span>
    `), title ? html(_t2 || (_t2 = _`
            <div part="link-heading">
              <span part="span">${0}${0}</span>
              <slot name="icon" @slotchange="${0}"></slot>
            </div>
          `), title, this._renderIcon(), this._handleSlotChange) : '');
      }
    }, {
      kind: "method",
      key: "_renderLink",
      value: function _renderLink() {
        const {
          download,
          href,
          hreflang,
          linkRole,
          ping,
          rel,
          target,
          title,
          type,
          _classes: classes,
          _handleClick: handleClick
        } = this;
        return html(_t3 || (_t3 = _`
      <a
        id="link"
        class="${0}"
        part="link"
        role="${0}"
        download="${0}"
        href="${0}"
        hreflang="${0}"
        ping="${0}"
        rel="${0}"
        target="${0}"
        type="${0}"
        @click="${0}"
        data-attribute1="headerNav"
        data-attribute2="FlatItem"
        data-attribute3="${0}">
        ${0}
      </a>
    `), classes, ifNonEmpty(linkRole), ifNonEmpty(download), ifNonEmpty(href), ifNonEmpty(hreflang), ifNonEmpty(ping), ifNonEmpty(rel), ifNonEmpty(target), ifNonEmpty(type), ifNonEmpty(handleClick), title, this._renderInner());
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        const megamenu = this.closest(`[data-autoid="${C4DMegaMenu.stableSelector}"`);
        this.layout = megamenu === null || megamenu === void 0 ? void 0 : megamenu.getAttribute('layout');
        _superPropGet(C4DMegaMenuCategoryLink, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSLink);
export default C4DMegaMenuCategoryLink;
//# sourceMappingURL=megamenu-category-link.js.map
