import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DMegaMenuRightNavigation from "./megamenu-right-navigation.js";
import styles from "././masthead.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * MegaMenu left navigation (highlighted) section.
 *
 * @element c4d-megamenu-left-navigation
 */
let C4DMegaMenuLeftNavigation = _decorate([customElement(`${c4dPrefix}-megamenu-left-navigation`)], function (_initialize, _C4DMegaMenuRightNavi) {
  class C4DMegaMenuLeftNavigation extends _C4DMegaMenuRightNavi {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuLeftNavigation,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }, {
      kind: "get",
      static: true,
      key: "onlyChildClassName",
      value:
      // `styles` here is a `CSSResult` generated by custom WebPack loader

      function () {
        return '';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--masthead__megamenu-left-navigation`;
      }
    }]
  };
}, C4DMegaMenuRightNavigation);
export default C4DMegaMenuLeftNavigation;
//# sourceMappingURL=megamenu-left-navigation.js.map
