import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { css } from 'lit';
import { property } from 'lit/decorators.js';
import CDSLink from '@carbon/web-components/es/components/link/link.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME } from "./defs.js";
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
export { MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME };
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Megamenu link with icon.
 *
 * @element c4d-megamenu-link-with-icon
 */
let C4DMegaMenuLinkWithIcon = _decorate([customElement(`${c4dPrefix}-megamenu-link-with-icon`)], function (_initialize, _CDSLink) {
  class C4DMegaMenuLinkWithIcon extends _CDSLink {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuLinkWithIcon,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'style-scheme'
      })],
      key: "styleScheme",
      value() {
        return MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME.DEFAULT;
      }
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value:
      /**
       * link title.
       */

      // `styles` here is a `CSSResult` generated by custom WebPack loader
      function () {
        return css(_t || (_t = _`
      ${0}${0}
    `), _superPropGet(C4DMegaMenuLinkWithIcon, "styles", this), styles);
      }
    }]
  };
}, CDSLink);
export default C4DMegaMenuLinkWithIcon;
//# sourceMappingURL=megamenu-link-with-icon.js.map
