import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import CDSTab from '@carbon/web-components/es/components/tabs/tab.js';
import c4dSettings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix
} = settings;
const {
  stablePrefix: c4dPrefix
} = c4dSettings;

/**
 * Megamenu Tab.
 *
 * @element c4d-megamenu-tab
 * @csspart nav-link - The text input. Usage: `c4d-megamenu-tab::part(nav-link)`
 */
let C4DMegaMenuTab = _decorate([customElement(`${c4dPrefix}-megamenu-tab`)], function (_initialize, _CDSTab) {
  class C4DMegaMenuTab extends _CDSTab {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuTab,
    d: [{
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DMegaMenuTab, "connectedCallback", this, 3)([]);
        this.closeOnActivation = false;
        this.hideDivider = false;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          disabled,
          selected,
          value
        } = this;

        // Safari does not set focus on clicked buttons, which causes megamenu to
        // close prematurely. Setting a tabindex circumvents the issue.
        const safariTabIndex = 0;
        return html(_t || (_t = _`
      <button
        part="nav-link"
        class="${0}--tabs__nav-link"
        role="tab"
        ?disabled="${0}"
        aria-selected="${0}"
        data-attribute1="headerNav"
        data-attribute2="TabHdline"
        data-attribute3="${0}"
        tabindex="${0}">
        <slot></slot>
      </button>
    `), prefix, disabled, Boolean(selected), value, safariTabIndex);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSTab);
export default C4DMegaMenuTab;
//# sourceMappingURL=megamenu-tab.js.map
