/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import CDSTabs from '@carbon/web-components/es/components/tabs/tabs.js';
/**
 * Megamenu Tabs.
 *
 * @element c4d-megamenu-tabs
 */
declare class C4DMegaMenuTabs extends CDSTabs {
    protected _disableIntersectionObservers: boolean;
    /**
     * @inheritdoc
     */
    protected renderPreviousButton(): null;
    /**
     * @inheritdoc
     */
    protected renderNextButton(): null;
    /**
     * A selector that will return megamenu tabs.
     */
    static get selectorItem(): string;
    /**
     * A selector that will return enabled tab items.
     */
    static get selectorItemEnabled(): string;
    /**
     * A selector that will return selected items.
     */
    static get selectorItemSelected(): string;
    /**
     * The name of the custom event fired before a tab is selected upon a user gesture.
     * Cancellation of this event stops changing the user-initiated selection.
     */
    static get eventBeforeSelect(): string;
    static styles: any;
}
export default C4DMegaMenuTabs;

//# sourceMappingURL=megamenu-tabs.d.ts.map
