import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import CDSSkipToContent from '@carbon/web-components/es/components/skip-to-content/skip-to-content.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Skip to content button in masthead.
 *
 * @element c4d-masthead-skip-to-content
 */
let C4DSkipToContent = _decorate([customElement(`${c4dPrefix}-skip-to-content`)], function (_initialize, _CDSSkipToContent) {
  class C4DSkipToContent extends _CDSSkipToContent {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DSkipToContent,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'brand';
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSSkipToContent);
export default C4DSkipToContent;
//# sourceMappingURL=skip-to-content.js.map
