import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property, query } from 'lit/decorators.js';
import CDSHeaderNavItem from '@carbon/web-components/es/components/ui-shell/header-nav-item.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Masthead top nav item.
 *
 * @element c4d-top-nav-item
 */
let C4DTopNavItem = _decorate([customElement(`${c4dPrefix}-top-nav-item`)], function (_initialize, _CDSHeaderNavItem) {
  class C4DTopNavItem extends _CDSHeaderNavItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavItem,
    d: [{
      kind: "field",
      decorators: [query('[part="link"]')],
      key: "_linkNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * The `<a>`.
       */

      /**
       * `true` if this nav item should be in its active state.
       */

      function updated(changedProperties) {
        _superPropGet(C4DTopNavItem, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('active')) {
          const {
            active,
            _linkNode: linkNode
          } = this;
          if (linkNode) {
            linkNode.setAttribute('data-selected', String(Boolean(active)));
          }
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$shadowRoot;
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
        if (this.hasAttribute('role') && this.getAttribute('role') === 'listitem') {
          this.removeAttribute('role');
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSHeaderNavItem);
export default C4DTopNavItem;
//# sourceMappingURL=top-nav-item.js.map
