import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import CDSHeaderMenu from '@carbon/web-components/es/components/ui-shell/header-menu.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * Masthead top nav submenu.
 *
 * @element c4d-top-nav-menu
 */
let C4DTopNavMenu = _decorate([customElement(`${c4dPrefix}-top-nav-menu`)], function (_initialize, _CDSHeaderMenu) {
  class C4DTopNavMenu extends _CDSHeaderMenu {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavMenu,
    d: [{
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * `true` if this submenu should be in its active state.
       */

      function updated(changedProperties) {
        var _this$shadowRoot;
        _superPropGet(C4DTopNavMenu, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('active')) {
          const {
            active,
            _topMenuItem: triggerNode
          } = this;
          if (triggerNode) {
            triggerNode.setAttribute('data-selected', String(Boolean(active)));
          }
        }
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DTopNavMenu, "connectedCallback", this, 3)([]);
        this.removeAttribute('role');
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSHeaderMenu);
export default C4DTopNavMenu;
//# sourceMappingURL=top-nav-menu.js.map
