/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DLeftNavName from './left-nav-name';
/**
 * The brand name UI in top nav.
 *
 * @element c4d-top-nav-name
 * @csspart name-prefix - The header name prefix. Usage: `c4d-top-nav-name::part(name-prefix)`
 * @csspart name-link - The header name prefix. Usage: `c4d-top-nav-name::part(name-link)`
 */
declare class C4DTopNavName extends C4DLeftNavName {
    connectedCallback(): void;
    disconnectedCallback(): void;
    render(): import("lit-html").TemplateResult<1>;
    /**
     * A selector that will return the nav bar.
     */
    static get selectorTopNav(): string;
    static get stableSelector(): string;
    static styles: any;
}
export default C4DTopNavName;

//# sourceMappingURL=top-nav-name.d.ts.map
