import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { ifDefined } from 'lit/directives/if-defined.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DLeftNavName from "./left-nav-name.js";
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * The brand name UI in top nav.
 *
 * @element c4d-top-nav-name
 * @csspart name-prefix - The header name prefix. Usage: `c4d-top-nav-name::part(name-prefix)`
 * @csspart name-link - The header name prefix. Usage: `c4d-top-nav-name::part(name-link)`
 */
let C4DTopNavName = _decorate([customElement(`${c4dPrefix}-top-nav-name`)], function (_initialize, _C4DLeftNavName) {
  class C4DTopNavName extends _C4DLeftNavName {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavName,
    d: [{
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DTopNavName, "connectedCallback", this, 3)([]);
        const {
          selectorTopNav
        } = this.constructor;
        const {
          nextElementSibling
        } = this;
        if (nextElementSibling && nextElementSibling.matches(selectorTopNav)) {
          nextElementSibling.hideDivider = true;
        }
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        const {
          selectorTopNav
        } = this.constructor;
        const {
          nextElementSibling
        } = this;
        if (nextElementSibling && nextElementSibling.matches(selectorTopNav)) {
          nextElementSibling.hideDivider = false;
        }
        _superPropGet(C4DTopNavName, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          href,
          prefix: namePrefix
        } = this;
        const namePrefixPart = !namePrefix ? undefined : html(_t || (_t = _`
          <span part="name-prefix" class="${0}--header__name--prefix"
            >${0}</span
          >&nbsp;
        `), prefix, namePrefix);
        return html(_t2 || (_t2 = _`
      <a
        part="name-link"
        class="${0}--header__name"
        href="${0}"
        >${0}<slot></slot
      ></a>
    `), prefix, ifDefined(href), namePrefixPart);
      }

      /**
       * A selector that will return the nav bar.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTopNav",
      value: function () {
        return `${c4dPrefix}-top-nav`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--masthead__platform-name`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DLeftNavName);
export default C4DTopNavName;
//# sourceMappingURL=top-nav-name.js.map
