import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { classMap } from 'lit/directives/class-map.js';
import { html } from 'lit';
import { property, query, state } from 'lit/decorators.js';
import CaretLeft20 from '@carbon/web-components/es/icons/caret--left/20.js';
import CaretRight20 from '@carbon/web-components/es/icons/caret--right/20.js';
import CDSHeaderNav from '@carbon/web-components/es/components/ui-shell/header-nav.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import HostListenerMixin from '@carbon/web-components/es/globals/mixins/host-listener.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././masthead.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

// button gradient width size
const buttonGradientWidth = 8;

/**
 * @param a An array.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns The index of the last item in the given array where `predicate` returns `true`. `-1` if no such item is found.
 */
function findLastIndex(a, predicate, thisObject) {
  for (let i = a.length - 1; i >= 0; --i) {
    if (predicate(a[i], i, thisObject)) {
      return i;
    }
  }
  return -1;
}

/**
 * Masthead top nav.
 *
 * @element c4d-top-nav
 * @csspart nav - The element containing the menu bar. Usage: `c4d-top-nav::part(nav)`
 * @csspart menubar - The menu bar. Usage: `c4d-top-nav::part(menubar)`
 * @csspart prev-button - The button to go to the previous page. Usage: `c4d-top-nav::part(prev-button)`
 * @csspart next-button - The button to go to the next page. Usage: `c4d-top-nav::part(next-button)`
 * @csspart header-nav-caret-left-container - The header nav caret left container. Usage: `c4d-top-nav::part(header-nav-caret-left-container)`
 * @csspart header-nav-caret-left-gradient - The header nav caret left gradient. Usage: `c4d-top-nav::part(header-nav-caret-left-gradient)`
 * @csspart header-nav-caret-right-container - The header nav caret right container. Usage: `c4d-top-nav::part(header-nav-caret-right-container)`
 * @csspart ce-header-nav-content-container - The ce header nav content container. Usage: `c4d-top-nav::part(ce-header-nav-content-container)`
 * @csspart header-nav-content-container - The header nav content container. Usage: `c4d-top-nav::part(header-nav-content)`
 * @csspart header-nav-content - The header nav content. Usage: `c4d-top-nav::part(header-nav-content)`
 * @csspart sub-content-right - The right sub content. Usage: `c4d-top-nav::part(sub-content-right)`
 * @csspart sub-content-left - The left sub content. Usage: `c4d-top-nav::part(sub-content-left)`
 */
let C4DTopNav = _decorate([customElement(`${c4dPrefix}-top-nav`)], function (_initialize, _StableSelectorMixin) {
  class C4DTopNav extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNav,
    d: [{
      kind: "field",
      decorators: [query(`.${prefix}--header__nav-caret-left`)],
      key: "_caretLeftNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--header__nav-caret-right`)],
      key: "_caretRightNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--header__nav`)],
      key: "_navNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${c4dPrefix}-ce--header__nav-content-container`)],
      key: "_contentContainerNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--header__nav-content`)],
      key: "_contentNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [state()],
      key: "_currentScrollPosition",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--sub-content-left`)],
      key: "_intersectionLeftSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--sub-content-right`)],
      key: "_intersectionRightSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true
      })],
      key: "hideNav",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean
      })],
      key: "importedMegamenu",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'nav-label'
      })],
      key: "navLabel",
      value() {
        return 'Primary navigation';
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      key: "_childItems",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_isIntersectionLeftTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_isIntersectionRightTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      key: "_observerIntersection",
      value() {
        return null;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_pageIsRTL",
      value() {
        return this.ownerDocument.documentElement.dir === 'rtl';
      }
    }, {
      kind: "field",
      decorators: [query('slot')],
      key: "_slotNode",
      value: void 0
    }, {
      kind: "method",
      key: "_cleanAndCreateIntersectionObserverContainer",
      value:
      /**
       * The left-hand paginator button.
       */

      /**
       * The right-hand paginator button.
       */

      /**
       * The `<nav>`.
       */

      /**
       * The scrolling container.
       */

      /**
       * The scrolling content.
       */

      /**
       * The current scroll position.
       */

      /**
       * The left-hand sentinel to track intersection with the host element.
       * If they intersect, the left-hand paginator button should be hidden.
       */

      /**
       * The right-hand sentinel to track intersection with the host element.
       * If they intersect, the right-hand paginator button should be hidden.
       */

      /**
       * `true` if the search is open and nav should be hidden
       */

      /**
       * `true` if the megamenu has been opened once and thus imported.
       *
       * Used for lazy loading the megamenu.
       */

      /**
       * The `aria-label` attribute for the nav element.
       */

      /**
       * The English title of the selected nav item.
       */

      /**
       * Array to hold the card-heading elements within child items.
       */

      /**
       * `true` if left-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the left-hand paginator button should be hidden.
       */

      /**
       * `true` if right-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the right-hand paginator button should be hidden.
       */

      /**
       * The observer for the intersection of left-side content edge.
       */

      /**
       * Boolean checking if page is RTL
       */

      /**
       * Cleans-up and creats the intersection observer for the scrolling container.
       *
       * @param [options] The options.
       * @param [options.create] `true` to create the new intersection observer.
       */
      function _cleanAndCreateIntersectionObserverContainer({
        create
      } = {}) {
        const {
          _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
          _intersectionRightSentinelNode: intersectionRightSentinelNode
        } = this;
        if (this._observerIntersection) {
          this._observerIntersection.disconnect();
          this._observerIntersection = null;
        }
        if (create) {
          this._observerIntersection = new IntersectionObserver(this._observeIntersectionContainer, {
            root: this,
            threshold: 0
          });
          if (intersectionLeftSentinelNode) {
            this._observerIntersection.observe(intersectionLeftSentinelNode);
          }
          if (intersectionRightSentinelNode) {
            this._observerIntersection.observe(intersectionRightSentinelNode);
          }
        }
      }

      /**
       * Handles `slotchange` event on the default `<slot>`.
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange(event) {
        this._childItems = event.target.assignedNodes().filter(elem => {
          var _matches, _ref;
          return (_matches = (_ref = elem).matches) === null || _matches === void 0 ? void 0 : _matches.call(_ref, 'c4d-megamenu-top-nav-menu');
        });
        this._paginateRight({
          onLoad: true
        });
      }

      /**
       * The intersection observer callback for the scrolling container.
       *
       * @param records The intersection observer records.
       */
    }, {
      kind: "field",
      key: "_observeIntersectionContainer",
      value() {
        return records => {
          const {
            _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
            _intersectionRightSentinelNode: intersectionRightSentinelNode
          } = this;
          records.forEach(({
            isIntersecting,
            target
          }) => {
            if (target === intersectionLeftSentinelNode) {
              this._isIntersectionLeftTrackerInContent = isIntersecting;
            }
            if (target === intersectionRightSentinelNode) {
              this._isIntersectionRightTrackerInContent = isIntersecting;
            }
          });
        };
      }
    }, {
      kind: "method",
      key: "_paginateLeft",
      value:
      /**
       * Handles `click` event on the left-hand paginator button.
       */
      function _paginateLeft() {
        const {
          _caretLeftNode: caretLeftNode,
          _caretRightNode: caretRightNode,
          _contentContainerNode: contentContainerNode,
          _currentScrollPosition: currentScrollPosition,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _navNode: navNode,
          _pageIsRTL: pageIsRTL,
          _slotNode: slotNode
        } = this;
        // If the right-side intersection sentinel is in the view, it means that right-side caret button is hidden.
        // Given scrolling to left makes it shown,
        // `contentContainerNode!.offsetWidth` will shrink as we scroll and we need to adjust for it.

        const elems = slotNode === null || slotNode === void 0 ? void 0 : slotNode.assignedElements();
        if (elems) {
          if (pageIsRTL) {
            const caretLeftNodeWidthAdjustment = this._isIntersectionLeftTrackerInContent ? caretLeftNode.offsetWidth : 0;
            const navRight = navNode.getBoundingClientRect().right;
            const lastVisibleElementIndex = elems.findIndex(elem => elem.getBoundingClientRect().left < navRight - currentScrollPosition - caretRightNode.offsetWidth);
            if (lastVisibleElementIndex >= 0) {
              this._currentScrollPosition = Math.max(navRight - elems[lastVisibleElementIndex].getBoundingClientRect().left - contentContainerNode.offsetWidth + caretLeftNodeWidthAdjustment + caretRightNode.offsetWidth + buttonGradientWidth, 0);
            }
          } else {
            const caretRightNodeWidthAdjustment = isIntersectionRightTrackerInContent ? caretRightNode.offsetWidth + buttonGradientWidth : buttonGradientWidth;
            const caretLeftNodeWidthAdjustment = this._isIntersectionLeftTrackerInContent ? caretLeftNode.offsetWidth + buttonGradientWidth : 0;
            const navLeft = navNode.getBoundingClientRect().left;
            const lastVisibleElementIndex = findLastIndex(elems, elem => elem.getBoundingClientRect().left - navLeft < currentScrollPosition);
            if (lastVisibleElementIndex >= 0) {
              const lastVisibleElementRight = elems[lastVisibleElementIndex].getBoundingClientRect().right - navLeft;
              const newScrollPosition = lastVisibleElementRight - (contentContainerNode.offsetWidth + caretLeftNodeWidthAdjustment - caretRightNodeWidthAdjustment);
              // If the new scroll position is less than the width of the left caret button,
              // it means that hiding the left caret button reveals the whole of the left-most nav item.
              // Snaps the left-most nav item to the left edge of nav container in this case.
              this._currentScrollPosition = newScrollPosition <= caretLeftNode.offsetWidth ? 0 : newScrollPosition;
            }
          }
        }
      }

      /**
       * Handles `click` event on the right-hand paginator button.
       */
    }, {
      kind: "method",
      key: "_paginateRight",
      value: async function _paginateRight({
        onLoad
      } = {}) {
        const {
          _caretLeftNode: caretLeftNode,
          _caretRightNode: caretRightNode,
          _contentContainerNode: contentContainerNode,
          _contentNode: contentNode,
          _currentScrollPosition: currentScrollPosition,
          _isIntersectionLeftTrackerInContent: isIntersectionLeftTrackerInContent,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _navNode: navNode,
          _pageIsRTL: pageIsRTL,
          _slotNode: slotNode
        } = this;
        await this.updateComplete;
        const elems = (slotNode === null || slotNode === void 0 ? void 0 : slotNode.assignedElements()) || this._childItems;
        if (elems && contentContainerNode) {
          const interimLeft = currentScrollPosition + contentContainerNode.offsetWidth;
          if (pageIsRTL) {
            const caretLeftNodeWidthAdjustment = isIntersectionLeftTrackerInContent ? caretLeftNode.offsetWidth : 0;
            const navRight = navNode.getBoundingClientRect().right;
            const firstVisibleElementIndex = onLoad ? elems.findIndex(elem => navRight - elem.getBoundingClientRect().left > interimLeft - caretLeftNode.offsetWidth - buttonGradientWidth && elem.hasAttribute('active')) : elems.findIndex(elem => navRight - elem.getBoundingClientRect().left > interimLeft - caretLeftNode.offsetWidth - buttonGradientWidth);
            if (firstVisibleElementIndex > 0) {
              const firstVisibleElementLeft = Math.abs(elems[firstVisibleElementIndex].getBoundingClientRect().right - navRight + caretLeftNode.offsetWidth + buttonGradientWidth);
              const maxLeft = contentNode.scrollWidth - contentContainerNode.offsetWidth + caretLeftNodeWidthAdjustment;
              this._currentScrollPosition = Math.min(firstVisibleElementLeft, maxLeft);
            }
          } else {
            const caretLeftNodeWidthAdjustment = isIntersectionLeftTrackerInContent ? 0 : caretLeftNode.offsetWidth;
            const caretRightNodeWidthAdjustment = isIntersectionRightTrackerInContent ? caretRightNode.offsetWidth : 0;
            const navLeft = navNode.getBoundingClientRect().left;
            const firstVisibleElementIndex = onLoad ? elems.findIndex(elem => elem.getBoundingClientRect().right - navLeft > interimLeft && elem.hasAttribute('active')) : elems.findIndex(elem => elem.getBoundingClientRect().right - navLeft > interimLeft);
            if (firstVisibleElementIndex > 0) {
              const firstVisibleElementLeft = elems[firstVisibleElementIndex].getBoundingClientRect().left - navLeft - buttonGradientWidth;
              // Ensures that is there is no blank area at the right hand side in scroll area
              // if we see the right remainder nav items can be contained in a page
              const maxLeft = contentNode.scrollWidth - (contentContainerNode.offsetWidth - caretRightNodeWidthAdjustment + caretLeftNodeWidthAdjustment);
              this._currentScrollPosition = Math.min(firstVisibleElementLeft, maxLeft);
            }
          }
        }
      }
    }, {
      kind: "method",
      key: "_handleOnKeyDown",
      value: function _handleOnKeyDown(event) {
        const target = event.target;
        const {
          _pageIsRTL: pageIsRTL,
          _navNode: navNode,
          _currentScrollPosition: currentScrollPosition,
          _contentContainerNode: contentContainerNode,
          _caretRightNode: caretRightNode
        } = this;
        if (target) {
          if (pageIsRTL) {
            if (event.key === 'Tab') {
              if (event.shiftKey) {
                if (target.previousElementSibling && caretRightNode && target.previousElementSibling.getBoundingClientRect().right + currentScrollPosition > navNode.getBoundingClientRect().right - caretRightNode.offsetWidth) {
                  this._paginateLeft();
                }
              } else if (target.nextElementSibling && caretRightNode && navNode.getBoundingClientRect().right - target.nextElementSibling.getBoundingClientRect().left > currentScrollPosition + contentContainerNode.offsetWidth - caretRightNode.offsetWidth) {
                this._paginateRight();
              }
            }
          } else if (event.key === 'Tab') {
            if (event.shiftKey) {
              if (target.previousElementSibling && target.previousElementSibling.parentElement === this && target.previousElementSibling.getBoundingClientRect().left - navNode.getBoundingClientRect().left < currentScrollPosition) {
                this._paginateLeft();
              }
            } else if (target.nextElementSibling && target.nextElementSibling.parentElement === this && Math.floor(target.nextElementSibling.getBoundingClientRect().right - navNode.getBoundingClientRect().left) > currentScrollPosition + contentContainerNode.offsetWidth) {
              this._paginateRight();
            }
          }
        }
      }

      /**
       * Handles toggle event from the search component.
       *
       * @param event The event.
       */
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventToggleSearch')],
      key: "_handleSearchToggle",
      value() {
        return event => {
          if (event.detail.active !== undefined) {
            this.hideNav = event.detail.active;
          }
        };
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        reflect: true,
        attribute: 'hide-divider'
      })],
      key: "hideDivider",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * `true` to hide the divider.
       */
      function connectedCallback() {
        _superPropGet(C4DTopNav, "connectedCallback", this, 3)([]);
        this._cleanAndCreateIntersectionObserverContainer({
          create: true
        });
        this.removeAttribute('role');
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this._cleanAndCreateIntersectionObserverContainer();
        _superPropGet(C4DTopNav, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        if (changedProperties.has('selectedMenuItem')) {
          this._paginateRight({
            onLoad: true
          });
        }
      }
    }, {
      kind: "method",
      key: "shouldUpdate",
      value: function shouldUpdate(changedProperties) {
        if (changedProperties.has('hideNav')) {
          this._cleanAndCreateIntersectionObserverContainer();
        }
        return true;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('hideNav')) {
          this._cleanAndCreateIntersectionObserverContainer({
            create: true
          });
        }
        if (changedProperties.has('_currentScrollPosition')) {
          if (this._contentNode) {
            this._contentNode.style.insetInlineStart = `-${this._currentScrollPosition}px`;
          }
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _isIntersectionLeftTrackerInContent: isIntersectionLeftTrackerInContent,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _handleSlotChange: handleSlotChange,
          _paginateLeft: paginateLeft,
          _paginateRight: paginateRight,
          _pageIsRTL: pageIsRTL,
          _handleOnKeyDown: handleOnKeyDown
        } = this;
        const caretLeftContainerClasses = classMap({
          [`${prefix}--header__nav-caret-left-container`]: true,
          [`${c4dPrefix}-ce--header__nav-caret-container--hidden`]: isIntersectionLeftTrackerInContent
        });
        const caretRightContainerClasses = classMap({
          [`${prefix}--header__nav-caret-right-container`]: true,
          [`${c4dPrefix}-ce--header__nav-caret-container--hidden`]: isIntersectionRightTrackerInContent
        });
        return this.hideNav ? undefined : html(_t || (_t = _`
          ${0}
        `), pageIsRTL ? html(_t2 || (_t2 = _`
                <div
                  part="header-nav-caret-left-container"
                  class="${0}">
                  <div
                    part="header_nav-caret-left-gradient"
                    class="${0}--header__nav-caret-right-gradient"></div>
                  <button
                    part="next-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-right"
                    @click="${0}">
                    ${0}
                  </button>
                </div>
                <div
                  part="ce-header-nav-content-container"
                  class="${0}-ce--header__nav-content-container">
                  <div
                    part="header-nav-content"
                    class="${0}--header__nav-content">
                    <nav
                      part="nav"
                      class="${0}--header__nav"
                      aria-label="${0}">
                      <div
                        part="sub-content-right"
                        class="${0}--sub-content-right"></div>
                      <div
                        part="menubar"
                        class="${0}--header__menu-bar"
                        aria-label="${0}">
                        <slot
                          @slotchange=${0}
                          @keydown="${0}"></slot>
                      </div>
                      <div
                        part="sub-content-left"
                        class="${0}--sub-content-left"></div>
                    </nav>
                  </div>
                </div>
                <div
                  part="header-nav-caret-left-container"
                  class="${0}">
                  <button
                    part="prev-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-left"
                    @click="${0}">
                    ${0}
                  </button>
                  <div
                    part="header-nav-caret-left-gradient"
                    class="${0}--header__nav-caret-left-gradient"></div>
                </div>
              `), caretRightContainerClasses, prefix, prefix, paginateRight, CaretLeft20(), c4dPrefix, prefix, prefix, ifDefined(this.navLabel), prefix, prefix, ifDefined(this.menuBarLabel), handleSlotChange, handleOnKeyDown, prefix, caretLeftContainerClasses, prefix, paginateLeft, CaretRight20(), prefix) : html(_t3 || (_t3 = _`
                <div
                  part="header-nav-caret-left-container"
                  class="${0}">
                  <button
                    part="prev-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-left"
                    @click="${0}">
                    ${0}
                  </button>
                  <div
                    part="header_nav-caret-left-gradient"
                    class="${0}--header__nav-caret-left-gradient"></div>
                </div>
                <div
                  part="ce-header-nav-content-container"
                  class="${0}-ce--header__nav-content-container">
                  <div
                    part="header-nav-content"
                    class="${0}--header__nav-content">
                    <nav
                      part="nav"
                      class="${0}--header__nav"
                      aria-label="${0}">
                      <div
                        part="sub-content-left"
                        class="${0}--sub-content-left"></div>
                      <div
                        part="menubar"
                        class="${0}--header__menu-bar"
                        aria-label="${0}">
                        <slot
                          @slotchange=${0}
                          @keydown="${0}"></slot>
                      </div>
                      <div
                        part="sub-content-right"
                        class="${0}--sub-content-right"></div>
                    </nav>
                  </div>
                </div>
                <div
                  part="header-nav-caret-right-container"
                  class="${0}">
                  <div
                    part="header-nav-caret-right-gradient"
                    class="${0}--header__nav-caret-right-gradient"></div>
                  <button
                    part="next-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-right"
                    @click="${0}">
                    ${0}
                  </button>
                </div>
              `), caretLeftContainerClasses, prefix, paginateLeft, CaretLeft20(), prefix, c4dPrefix, prefix, prefix, ifDefined(this.navLabel), prefix, prefix, ifDefined(this.menuBarLabel), handleSlotChange, handleOnKeyDown, prefix, caretRightContainerClasses, prefix, prefix, paginateRight, CaretRight20()));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--masthead__l0-nav`;
      }

      /**
       * The name of the custom event fired after the search is toggled.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggleSearch",
      value: function () {
        return `${c4dPrefix}-search-with-typeahead-toggled`; // TODO hook up the new event
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(HostListenerMixin(CDSHeaderNav)));
export default C4DTopNav;
//# sourceMappingURL=top-nav.js.map
