import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6,
  _t7,
  _t8,
  _t9,
  _t10,
  _t11,
  _t12;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2024
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */

import { loadContent, loadSettings } from "./services.js";
import { html, LitElement } from 'lit';
import { property } from 'lit/decorators.js';
import { pwsValueMap, resetToWorldWideContent, supportedLanguages } from "./utils.js";
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././notice-choice.css.js";
import { unsafeHTML } from 'lit/directives/unsafe-html.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Notice Choice
 *
 * @element c4d-notice-choice
 * @fires c4d-notice-choice-change
 * The custom event fired when default choice loaded or user change some preferences.
 * The field and value should be taken from the detail object and send it to MRS.
 * @csspart checkbox-wrapper - The checkbox wrapper. Usage `c4d-notice-choice::part(checkbox-wrapper)`
 * @csspart checkbox - An input checkbox. Usage `c4d-notice-choice::part(checkbox)`
 * @csspart checkbox-label - The checkbox label. Usage `c4d-notice-choice::part(checkbox-label)`
 * @csspart checkbox-label-text - The checkbox label text. Usage `c4d-notice-choice::part(checkbox-label-text)`
 * @csspart error - The error message. Usage `c4d-notice-choice::part(error)`
 * @csspart section - A section. Usage `c4d-notice-choice::part(section)`
 * @csspart container - The container. Usage `c4d-notice-choice::part(container)`
 * @csspart tooltip-link - The tooltip link. Usage `c4d-notice-choice::part(tooltip-link)`
 */
let NoticeChoice = _decorate([customElement(`c4d-notice-choice`)], function (_initialize, _StableSelectorMixin) {
  class NoticeChoice extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: NoticeChoice,
    d: [{
      kind: "field",
      decorators: [property({
        type: String,
        reflect: true,
        attribute: 'question-choices'
      })],
      key: "questionchoices",
      value() {
        return '1';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'country'
      })],
      key: "country",
      value() {
        return 'US';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'state'
      })],
      key: "state",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'language'
      })],
      key: "language",
      value() {
        return 'en';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'current-language'
      })],
      key: "currentLanguage",
      value() {
        return 'en';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'terms-condition-link'
      })],
      key: "termsConditionLink",
      value() {
        return html(_t || (_t = _``));
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'enable-all-opt-in'
      })],
      key: "enableAllOptIn",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'default-values'
      })],
      key: "defaultValues",
      value() {
        return {};
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'hide-error-message'
      })],
      key: "hideErrorMessage",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: 'combine-email-phone'
      })],
      key: "combineEmailPhone",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: 'environment'
      })],
      key: "environment",
      value() {
        return 'prod';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "checkboxes",
      value() {
        return {};
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "ncData",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: false
      })],
      key: "changed",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: String,
        attribute: false
      })],
      key: "fetchedPref",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "optInContent",
      value() {
        return {};
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: false
      })],
      key: "preventFormSubmission",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "isMandatoryCheckboxDisplayed",
      value() {
        return {
          countryCode: '',
          isDisplayed: false
        };
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "countrySettings",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "noticeOnly",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: false
      })],
      key: "emailPrechecked",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: false
      })],
      key: "telephonePrechecked",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Boolean,
        attribute: false
      })],
      key: "combinedEmailPhonePrechecked",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property({
        type: html,
        attribute: false
      })],
      key: "preText",
      value() {
        return html(_t2 || (_t2 = _``));
      }
    }, {
      kind: "field",
      decorators: [property({
        type: html,
        attribute: false
      })],
      key: "defaultPreText",
      value() {
        return html(_t3 || (_t3 = _``));
      }
    }, {
      kind: "field",
      decorators: [property({
        type: Object,
        attribute: false
      })],
      key: "values",
      value() {
        return {
          EMAIL: false,
          PHONE: false,
          NC_HIDDEN_EMAIL: 'SUPPRESSION',
          NC_HIDDEN_PHONE: 'SUPPRESSION'
        };
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "hiddenEmail",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "hiddenPhone",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'nc-tele-detail'
      })],
      key: "ncTeleDetail",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'nc-email-detail'
      })],
      key: "ncEmailDetail",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "prepareCheckboxes",
      value:
      /**
       * properties for passed attributes.
       */

      /**
       * End properties for passed attributes.
       */

      /**
       * properties for local state state management.
       */

      function prepareCheckboxes() {
        if (this.ncData) {
          const OptInContent = this.ncData;
          this.preText = OptInContent.preText;
          this.defaultPreText = OptInContent.preText;
          const newCheckboxes = this._buildCheckboxes();
          this.checkboxes = newCheckboxes;
          this.performUpdate();
        }
      }
    }, {
      kind: "method",
      key: "defaultLoadContent",
      value: function defaultLoadContent() {
        loadContent('en', this.environment, ncData => {
          this.ncData = ncData;
          this.prepareCheckboxes();
          this.countryChanged();
        }, error => {
          console.error('error loading content', error);
        });
      }
    }, {
      kind: "method",
      key: "defaultLoadSettings",
      value: function defaultLoadSettings() {
        loadSettings(this.environment, countryPreferencesSettings => {
          this.countrySettings = countryPreferencesSettings.preferences;
          this.noticeOnly = countryPreferencesSettings.noticeOnly || ['us'];
        }, error => {
          console.error('error loading content', error);
        });
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(NoticeChoice, "connectedCallback", this, 3)([]);
        const [language] = this.language.split(/[-_]/);
        let defaultLanguage = 'en';
        if (supportedLanguages(this.language)) {
          defaultLanguage = supportedLanguages(this.language);
        } else if (supportedLanguages(language)) {
          defaultLanguage = supportedLanguages(language);
        }
        loadSettings(this.environment, countryPreferencesSettings => {
          this.countrySettings = countryPreferencesSettings.preferences;
          this.noticeOnly = countryPreferencesSettings.noticeOnly || ['us'];
        }, () => {
          this.countrySettings = this.defaultLoadSettings();
        });
        loadContent(defaultLanguage, this.environment, ncData => {
          this.ncData = ncData;
          this.prepareCheckboxes();
          this.countryChanged();
        }, () => {
          this.defaultLoadContent();
        });
      }
    }, {
      kind: "method",
      key: "setDefaultSelections",
      value: function setDefaultSelections() {
        if (!this.enableAllOptIn && this.checkboxes) {
          const newValues = _objectSpread({}, this.values);
          Object.keys(this.checkboxes).forEach(key => {
            const option = this._getOptionByQuestion(key);
            newValues[key] = !!(option.checked === 'true' || option.checked === true);
            if (this.defaultValues && Object.prototype.hasOwnProperty.call(this.defaultValues, key)) {
              newValues[key] = this.defaultValues[key];
            }
            const hiddenFieldName = `NC_HIDDEN_${key}`;
            newValues[hiddenFieldName] = option[hiddenFieldName];
            this._onChange(hiddenFieldName, newValues.EMAIL ? 'OPT_IN' : 'OPT_OUT');
          });
          if (JSON.stringify(this.values) !== JSON.stringify(newValues)) {
            this.values = newValues;
          }
        }
      }
    }, {
      kind: "method",
      key: "countryChangeAction",
      value: function countryChangeAction() {
        var _this$ncData, _this$country;
        this.preventFormSubmission = false;
        if ((_this$ncData = this.ncData) !== null && _this$ncData !== void 0 && _this$ncData.mandatoryCheckbox[(_this$country = this.country) === null || _this$country === void 0 ? void 0 : _this$country.toLocaleLowerCase()]) {
          var _this$country2, _this$ncData2, _this$ncData3, _this$ncData4;
          const countyCode = (_this$country2 = this.country) === null || _this$country2 === void 0 ? void 0 : _this$country2.toLocaleLowerCase();
          const mrsField = (_this$ncData2 = this.ncData) !== null && _this$ncData2 !== void 0 && _this$ncData2.mandatoryCheckbox[countyCode].countryTransferText ? (_this$ncData3 = this.ncData) === null || _this$ncData3 === void 0 ? void 0 : _this$ncData3.mandatoryCheckbox[countyCode].countryTransferText.mrs_field : (_this$ncData4 = this.ncData) === null || _this$ncData4 === void 0 ? void 0 : _this$ncData4.mandatoryCheckbox[countyCode].chinaPIPLtext.mrs_field;
          this._onChange(mrsField, 'countyBasedCheckedNo');
          this.isMandatoryCheckboxDisplayed.countryCode = countyCode;
          this.isMandatoryCheckboxDisplayed.isDisplayed = true;
          this.preventFormSubmission = true;
          this._onChange('preventFormSubmission', 'formSubmissionNo');
        } else {
          this._onChange('preventFormSubmission', 'formSubmissionYes');
        }

        /**
         * @description if the user already interacted with the checkboxes,
         * skip country default selection.
         */
        if (!this.changed && !this.fetchedPref) {
          /**
           * @description
           * change checkbox checked option based on new country.
           */

          this.setDefaultSelections();
        }
      }
    }, {
      kind: "method",
      key: "countryChanged",
      value: function countryChanged() {
        resetToWorldWideContent();
        this.countryChangeAction();
      }
      /**
       *
       * @param name name of the attribute
       * @param oldVal old value of the attribute
       * @param newVal new value of the attrbute
       */
    }, {
      kind: "method",
      key: "attributeChangedCallback",
      value: function attributeChangedCallback(name, oldVal, newVal) {
        const hasValue = newVal !== null && oldVal !== null;
        _superPropGet(NoticeChoice, "attributeChangedCallback", this, 3)([name, oldVal, newVal]);
        switch (name) {
          case 'question-choices':
            {
              // Reload checkbox options when questionchoices changed
              if (oldVal !== newVal) {
                this.prepareCheckboxes();
                this.setDefaultSelections();
              }
              break;
            }
          case 'language':
          case 'environment':
            {
              // load content when locale changed.
              const [language] = newVal.split(/[-_]/);
              let defaultLanguage = 'en';
              if (supportedLanguages(newVal)) {
                defaultLanguage = supportedLanguages(newVal);
              } else if (supportedLanguages(language)) {
                defaultLanguage = supportedLanguages(language);
              }
              this.currentLanguage = defaultLanguage;
              if (hasValue && oldVal !== newVal) {
                loadSettings(this.environment, countryPreferencesSettings => {
                  this.countrySettings = countryPreferencesSettings.preferences;
                }, error => {
                  console.error('error loading content', error);
                });
                loadContent(defaultLanguage, this.environment, ncData => {
                  this.ncData = ncData;
                  this.prepareCheckboxes();
                }, () => {
                  this.defaultLoadContent();
                });
              }
              break;
            }
          case 'country':
            {
              /**
               * load content when country value changed.
               */
              if (hasValue && oldVal !== newVal && this.countrySettings[newVal.toLocaleLowerCase()]) {
                this.countryChanged();
              }
              break;
            }
          case 'enable-all-opt-in':
            if (oldVal !== newVal) {
              this.enableAllOptIn = JSON.parse(newVal);
              this.setDefaultSelections();
            }
            break;
          case 'hide-error-message':
            {
              if (oldVal !== newVal) {
                this.hideErrorMessage = JSON.parse(newVal);
                this.countryBasedLegalNotice();
              }
              break;
            }
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--notice-choice`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }, {
      kind: "method",
      key: "checkBoxLegalChange",
      value: // `styles` here is a `CSSResult` generated by custom WebPack loader
      function checkBoxLegalChange($event) {
        var _this$country3, _this$ncData5, _this$ncData6, _this$ncData7;
        const legalCheckbox = $event.target;
        const isChecked = legalCheckbox.checked;
        const legalTextError = legalCheckbox.parentNode.querySelector('.nc-error');
        const countyBasedText = isChecked ? 'countyBasedCheckedYes' : 'countyBasedCheckedNo';
        if (legalTextError) {
          legalTextError.style.display = isChecked ? 'none' : '';
        }
        const countyCode = (_this$country3 = this.country) === null || _this$country3 === void 0 ? void 0 : _this$country3.toLocaleLowerCase();
        const mrsField = (_this$ncData5 = this.ncData) !== null && _this$ncData5 !== void 0 && _this$ncData5.mandatoryCheckbox[countyCode].countryTransferText ? (_this$ncData6 = this.ncData) === null || _this$ncData6 === void 0 ? void 0 : _this$ncData6.mandatoryCheckbox[this.isMandatoryCheckboxDisplayed.countryCode].countryTransferText.mrs_field : (_this$ncData7 = this.ncData) === null || _this$ncData7 === void 0 ? void 0 : _this$ncData7.mandatoryCheckbox[countyCode].chinaPIPLtext.mrs_field;
        legalCheckbox.value = isChecked ? 1 : 0;
        this.preventFormSubmission = !isChecked;
        const preventFormSubmissionValue = isChecked ? 'formSubmissionYes' : 'formSubmissionNo';
        this._onChange('preventFormSubmission', preventFormSubmissionValue);
        this._onChange(mrsField, countyBasedText);
      }
    }, {
      kind: "method",
      key: "countryBasedLegalNotice",
      value: function countryBasedLegalNotice() {
        var _this$ncData8;
        const country = this.country.toLocaleLowerCase();
        const itemTemplates = [];
        if ((_this$ncData8 = this.ncData) !== null && _this$ncData8 !== void 0 && _this$ncData8.mandatoryCheckbox && this.ncData.mandatoryCheckbox[country]) {
          const mandatoryCheckboxes = this.ncData.mandatoryCheckbox[country];
          for (const [key, mandatoryCheckbox] of Object.entries(mandatoryCheckboxes)) {
            const legalTextName = key.replace(/([A-Z]+)/g, '-$1').toLowerCase();
            const mandatoryCheckboxTemplate = html(_t4 || (_t4 = _`
          <span>
            <div
              class="${0}--form-item bx--checkbox-wrapper"
              part="checkbox-wrapper checkbox-wrapper--mandatory">
              <p part=${0} class=${0}>
                <input
                  type="checkbox"
                  class="${0}--checkbox"
                  part="checkbox checkbox--mandatory"
                  id="${0}"
                  name="${0}"
                  @change="${0}" />
                <label
                  for="${0}"
                  class="${0}--checkbox-label ${0}--nc__checkbox-${0}"
                  part="checkbox-label checkbox-label--mandatory"
                  ><span
                    class="${0}--checkbox-label-text"
                    part="checkbox-label-text checkbox-label-text--mandatory"
                    dir="auto"
                    >${0}
                  </span>
                </label>
                ${0}
              </p>
            </div>
          </span>
        `), prefix, legalTextName, legalTextName, prefix, mandatoryCheckbox.mrs_field, mandatoryCheckbox.mrs_field, this.checkBoxLegalChange, mandatoryCheckbox.mrs_field, prefix, prefix, mandatoryCheckbox.mrs_field, prefix, mandatoryCheckbox.text, !this.hideErrorMessage && this.preventFormSubmission ? html(_t5 || (_t5 = _`<span
                      class="nc-error"
                      part="error"
                      style="color:#da1e28;font-size:.75rem"
                      >${0}</span
                    >`), mandatoryCheckbox.error) : '');
            itemTemplates.push(mandatoryCheckboxTemplate);
          }
        }
        return itemTemplates;
      }
    }, {
      kind: "method",
      key: "postTextTemplate",
      value: function postTextTemplate() {
        if (this.ncData) {
          const OtherPreferences = this.ncData.trialPrivacyText;
          let postText = this.ncData.postText;
          if (postText) {
            postText = '<p part="ncPostText">' + postText + '</p>';
          }
          if (!this.termsConditionLink.strings && this.termsConditionLink) {
            const originalValue = OtherPreferences;
            const matchedValue = originalValue.match(/<tc>.*<\/tc>/g);
            if (matchedValue) {
              const anrTagHtml = matchedValue[0].replace(/<tc>|<\/tc>/g, '');
              const link = `<a href='${this.termsConditionLink}' target='_blank' class='ibm-tooltip' part="tooltip-link">${anrTagHtml}</a>`;
              const reg = new RegExp('<tc>' + anrTagHtml + '</tc>', 'g');
              postText = postText + originalValue.replace(reg, link).replace(/<p>/g, '<p part="nc-trial-text" id="nc-trial-text">');
            }
          }
          if (postText !== '') {
            postText = "<div part='ncPostTextContainer' id='ncPostTextContainer'>" + postText + '</div>';
          }
          return html(_t6 || (_t6 = _`${0}`), unsafeHTML(postText));
        } else {
          return html(_t7 || (_t7 = _``));
        }
      }
    }, {
      kind: "method",
      key: "combinedPreTextTemplate",
      value: function combinedPreTextTemplate() {
        var _this$country4, _this$state, _ecmTranslateContent$4;
        if (!this.ncData) {
          return html(_t8 || (_t8 = _``));
        }
        const ecmTranslateContent = this.ncData;
        const country = ((_this$country4 = this.country) === null || _this$country4 === void 0 ? void 0 : _this$country4.toLocaleLowerCase()) || '';
        const state = ((_this$state = this.state) === null || _this$state === void 0 ? void 0 : _this$state.toLocaleLowerCase()) || '';
        let preText = ecmTranslateContent.combinedConsent;
        if (ecmTranslateContent.state[country]) {
          if ((this.noticeOnly || []).includes(country)) {
            preText = state === 'ca' || state === '' ? ecmTranslateContent.state[country]['ca'].noticeOnly : ecmTranslateContent.noticeOnly;
          } else {
            var _ecmTranslateContent$;
            preText = ((_ecmTranslateContent$ = ecmTranslateContent.state[country][state]) === null || _ecmTranslateContent$ === void 0 ? void 0 : _ecmTranslateContent$.combinedConsent) || ecmTranslateContent.combinedConsent;
          }
        } else if ((this.noticeOnly || []).includes(country)) {
          var _ecmTranslateContent$2, _ecmTranslateContent$3;
          preText = state === 'ca' || state === '' || typeof state === 'undefined' ? (_ecmTranslateContent$2 = ecmTranslateContent.state) !== null && _ecmTranslateContent$2 !== void 0 && (_ecmTranslateContent$2 = _ecmTranslateContent$2[country]) !== null && _ecmTranslateContent$2 !== void 0 && (_ecmTranslateContent$2 = _ecmTranslateContent$2['ca']) !== null && _ecmTranslateContent$2 !== void 0 && _ecmTranslateContent$2.noticeOnly ? (_ecmTranslateContent$3 = ecmTranslateContent.state) === null || _ecmTranslateContent$3 === void 0 || (_ecmTranslateContent$3 = _ecmTranslateContent$3[country]) === null || _ecmTranslateContent$3 === void 0 || (_ecmTranslateContent$3 = _ecmTranslateContent$3['ca']) === null || _ecmTranslateContent$3 === void 0 ? void 0 : _ecmTranslateContent$3.noticeOnly : ecmTranslateContent.noticeOnly : ecmTranslateContent.noticeOnly;
        }
        if ((_ecmTranslateContent$4 = ecmTranslateContent.country) !== null && _ecmTranslateContent$4 !== void 0 && _ecmTranslateContent$4[country]) {
          preText = ecmTranslateContent.country[country].combinedConsent;
        }
        if (!(this.noticeOnly || []).includes(country)) {
          let isPermissionOrSuppression = false;
          if (typeof this.values.EMAIL === 'object') {
            const checkStatus = this.values.EMAIL;
            isPermissionOrSuppression = checkStatus.checkBoxStatus === 'PERMISSION';
          }
          const checked = typeof this.values.EMAIL === 'object' ? isPermissionOrSuppression : this.values.EMAIL;
          preText = preText ? this.renderCheckbox(preText, checked) : this.renderCheckbox(ecmTranslateContent.preText, checked);
          return preText;
        }
        return html(_t9 || (_t9 = _`${0}`), unsafeHTML(preText));
      }
    }, {
      kind: "method",
      key: "checkCombineEmailPhoneBoxChange",
      value: function checkCombineEmailPhoneBoxChange($event) {
        const checked = $event.target.checked;
        const newValues = _objectSpread({}, this.values);
        this.changed = true;
        Object.keys(this.checkboxes).map(id => {
          newValues[id] = !!checked;
          this.values = newValues;
          const hiddenFieldName = `NC_HIDDEN_${id}`;
          const hiddenFieldStatus = checked ? 'PERMISSION' : 'SUPPRESSION';
          this.values[id] = {};
          this.values[id]['checkBoxStatus'] = hiddenFieldStatus;
          let statusPrechecked = '';
          switch (id) {
            case 'EMAIL':
            case 'PHONE':
              statusPrechecked = this.combinedEmailPhonePrechecked && !checked ? 'CU' : !this.combinedEmailPhonePrechecked && checked ? 'UC' : this.combinedEmailPhonePrechecked && checked ? 'CC' : 'UU';
              break;
          }
          this.values[id]['punsStatus'] = statusPrechecked;
          this._onChange(hiddenFieldName, hiddenFieldStatus);
          this._onChange(`${hiddenFieldName}_VALUE`, `NC_HIDDEN_${hiddenFieldStatus}`);
        });
      }
    }, {
      kind: "method",
      key: "renderCheckbox",
      value: function renderCheckbox(preText, checked) {
        const checkboxId = 'EMAIL_PHONE_CHECKBOX';
        return html(_t10 || (_t10 = _`
      <span part="container">
        <div
          class="${0}--form-item cds--checkbox-wrapper"
          part="checkbox-wrapper">
          <input
            type="checkbox"
            class="${0}--checkbox"
            part="checkbox"
            id="${0}"
            name="${0}"
            ?checked="${0}"
            @change="${0}" />
          <label
            for="${0}"
            class="${0}--checkbox-label ${0}--nc__checkbox-${0}"
            part="checkbox-label">
            <span
              class="${0}--checkbox-label-text"
              part="checkbox-label-text"
              dir="auto">
              ${0}
            </span>
          </label>
        </div>
      </span>
    `), prefix, prefix, checkboxId, checkboxId, checked, this.checkCombineEmailPhoneBoxChange, checkboxId, prefix, prefix, checkboxId, prefix, unsafeHTML(preText));
      }
    }, {
      kind: "method",
      key: "renderCombinedEmailPhoneSection",
      value: function renderCombinedEmailPhoneSection() {
        const getPunsStatus = (key, checked) => {
          var _this$country5, _this$values$key, _this$values$key2;
          const countryLowerCase = (_this$country5 = this.country) === null || _this$country5 === void 0 ? void 0 : _this$country5.toLocaleLowerCase();
          const isNoticeOnly = (this.noticeOnly || []).includes(countryLowerCase);
          if (isNoticeOnly) {
            return 'NOTICE_ONLY';
          }
          const defaultCountryStatus = {
            email: 'opt-in',
            phone: 'opt-in'
          };
          const countryStatus = countryLowerCase ? this.countrySettings[countryLowerCase] || defaultCountryStatus : defaultCountryStatus;
          const checkboxStatus = (_this$values$key = this.values[key]) === null || _this$values$key === void 0 ? void 0 : _this$values$key.checkBoxStatus;
          if (checkboxStatus === 'SUPPRESSION') {
            if (countryStatus.email === 'opt-in') {
              return 'UU';
            }
            if (countryStatus.email === 'opt-out') {
              return 'CU';
            }
          }
          return ((_this$values$key2 = this.values[key]) === null || _this$values$key2 === void 0 ? void 0 : _this$values$key2.punsStatus) || (checked ? 'CC' : 'UU');
        };
        const createHiddenInput = (id, value) => html(_t11 || (_t11 = _`<input type="hidden" id=${0} name=${0} value=${0} />`), id, id, value);
        return html(_t12 || (_t12 = _`
      <section class="${0}--nc" part="section">
        <p part="ncHeading" id="ncHeading" class="${0}--nc__pre-text ">
          ${0} ${0}
        </p>
        ${0}
        <div part="${0}--nc__post-text" class="${0}--nc__post-text">
          ${0}
        </div>
        ${0}
        <input
          type="hidden"
          id="preventFormSubmission"
          name="preventFormSubmission"
          value=${0} />
      </section>
    `), prefix, c4dPrefix, this.countryBasedLegalNotice(), this.combinedPreTextTemplate(), Object.keys(this.checkboxes).map(key => {
          const checked = this.values.EMAIL;
          const punsStatus = getPunsStatus(key, checked);
          const hiddenBox = {
            id: `NC_HIDDEN_${key}`,
            value: this.values[key]['checkBoxStatus'] ? this.values[key]['checkBoxStatus'] : this.values.EMAIL ? 'PERMISSION' : 'SUPPRESSION'
          };
          if (typeof checked !== 'object') {
            this.combinedEmailPhonePrechecked = checked ? true : false;
          }
          if ((this.noticeOnly || []).includes(this.country.toLocaleLowerCase())) {
            const countryStatus = this.country ? this.countrySettings[this.country.toLocaleLowerCase()] : {
              email: 'opt-in',
              phone: 'opt-in'
            };
            hiddenBox.value = countryStatus.email === 'opt-out' ? 'PERMISSION' : 'SUPPRESSION';
          }
          this._onChange(`NC_${key === 'PHONE' ? 'TELE' : key}_DETAIL`, `${key}_${punsStatus}`);
          console.log(`${hiddenBox.id}_VALUE`, `NC_HIDDEN_${hiddenBox.value}`);
          this._onChange(`${hiddenBox.id}_VALUE`, `NC_HIDDEN_${hiddenBox.value}`);
          if (Object.keys(this.checkboxes).length === 1) {
            this._onChange(`NC_HIDDEN_PHONE_VALUE`, `NC_HIDDEN_PHONE_NONE`);
          }
          return createHiddenInput(hiddenBox.id, hiddenBox.value);
        }), prefix, prefix, this.postTextTemplate(), createHiddenInput('preventFormSubmission', this.preventFormSubmission), this.preventFormSubmission);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        if (this.isMandatoryCheckboxDisplayed.isDisplayed && this.country.toLocaleLowerCase() !== this.isMandatoryCheckboxDisplayed.countryCode) {
          var _this$ncData9, _this$ncData10, _this$ncData11;
          const mrsField = (_this$ncData9 = this.ncData) !== null && _this$ncData9 !== void 0 && _this$ncData9.mandatoryCheckbox[this.isMandatoryCheckboxDisplayed.countryCode].countryTransferText ? (_this$ncData10 = this.ncData) === null || _this$ncData10 === void 0 ? void 0 : _this$ncData10.mandatoryCheckbox[this.isMandatoryCheckboxDisplayed.countryCode].countryTransferText.mrs_field : (_this$ncData11 = this.ncData) === null || _this$ncData11 === void 0 ? void 0 : _this$ncData11.mandatoryCheckbox[this.isMandatoryCheckboxDisplayed.countryCode].chinaPIPLtext.mrs_field;
          this._onChange(mrsField, 'countyBasedCheckedNo');
        }
        return this.renderCombinedEmailPhoneSection();
      }
    }, {
      kind: "field",
      key: "_getOptionByQuestion",
      value() {
        return question => {
          const questionChoiceStatus = this.country ? this.countrySettings[this.country.toLocaleLowerCase()] : {
            email: 'opt-in',
            phone: 'opt-in'
          };
          let option;
          switch (question) {
            case 'EMAIL':
              {
                option = {
                  id: '0',
                  checked: questionChoiceStatus.email === 'opt-out' ? true : false,
                  optionTextPost: this.ncData.email,
                  NC_HIDDEN_EMAIL: questionChoiceStatus.email === 'opt-out' ? 'OPT_OUT' : 'OPT_IN'
                };
                break;
              }
            case 'PHONE':
              {
                option = {
                  id: '1',
                  checked: questionChoiceStatus.phone === 'opt-out' ? true : false,
                  optionTextPost: this.ncData.telephone,
                  NC_HIDDEN_PHONE: questionChoiceStatus.phone === 'opt-out' ? 'OPT_OUT' : 'OPT_IN'
                };
                break;
              }
            default:
              {
                option = {
                  id: '0',
                  checked: questionChoiceStatus.email === 'opt-out' ? true : false,
                  optionTextPost: this.ncData.email,
                  NC_HIDDEN_EMAIL: questionChoiceStatus.email === 'opt-out' ? 'OPT_OUT' : 'OPT_IN'
                };
                break;
              }
          }
          return option;
        };
      }
    }, {
      kind: "method",
      key: "_buildCheckboxes",
      value: function _buildCheckboxes() {
        const fieldElements = {};
        const fieldCollections = {
          EMAIL: {
            id: 'EMAIL',
            labelText: this._getOptionByQuestion('EMAIL').optionTextPost
          },
          PHONE: {
            id: 'PHONE',
            labelText: this._getOptionByQuestion('PHONE').optionTextPost
          }
        };
        if (this.questionchoices) {
          // by email
          if (this.questionchoices.indexOf('1') > -1) {
            fieldElements.EMAIL = fieldCollections.EMAIL;
          }
          // by Phone
          if (this.questionchoices.indexOf('2') > -1) {
            fieldElements.PHONE = fieldCollections.PHONE;
          }
        }
        return fieldElements;
      }
    }, {
      kind: "method",
      key: "_onChange",
      value: function _onChange(field, value) {
        const pwsFieldsMap = {
          NC_HIDDEN_EMAIL: 'permission_email',
          NC_HIDDEN_PHONE: 'permission_phone',
          preventFormSubmission: 'preventFormSubmission',
          Q_CHINA_PIPL: 'Q_CHINA_PIPL',
          Q_COUNTRY_TRANSFER: 'Q_COUNTRY_TRANSFER',
          NC_HIDDEN_EMAIL_VALUE: 'NC_HIDDEN_EMAIL',
          NC_HIDDEN_PHONE_VALUE: 'NC_HIDDEN_PHONE',
          EMAIL_CU: 'EMAIL_CU',
          EMAIL_CC: 'EMAIL_CC',
          EMAIL_UC: 'EMAIL_UC',
          EMAIL_UU: 'EMAIL_UU',
          PHONE_CU: 'PHONE_CU',
          PHONE_CC: 'PHONE_CC',
          PHONE_UC: 'PHONE_UC',
          PHONE_UU: 'PHONE_UU',
          EMAIL_NOTICE_ONLY: 'EMAIL_NOTICE_ONLY',
          PHONE_NOTICE_ONLY: 'PHONE_NOTICE_ONLY',
          NC_HIDDEN_PHONE_NONE: 'NC_HIDDEN_PHONE_NONE'
        };
        if (Object.prototype.hasOwnProperty.call(pwsFieldsMap, field)) {
          field = pwsFieldsMap[field];
        }
        const init = {
          bubbles: true,
          detail: {
            field,
            value: pwsValueMap(value)
          }
        };
        this.dispatchEvent(new CustomEvent(`${c4dPrefix}-notice-choice-change`, init));
      }
    }]
  };
}, StableSelectorMixin(LitElement));
export default NoticeChoice;
//# sourceMappingURL=notice-choice.js.map
