import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { COLOR_OPTIONS } from "./defs.js";
import C4DContentItem from "../content-item/content-item.js";
import styles from "././pictogram-item.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Pictogram item.
 *
 * @element c4d-pictogram-item
 * @slot pictogram - The pictogram content.
 * @slot heading - The heading content.
 * @slot footer - The footer (CTA) content.
 * @csspart item-row - An item row. Usage `c4d-pictogram-item: :part(item-row)`
 * @csspart wrapper - The wrapper. Usage `c4d-pictogram-item: :part(wrapper)`
 * @csspart pictogram - A pictogram. Usage `c4d-pictogram-item: :part(pictogram)`
 * @csspart content - The content. Usage `c4d-pictogram-item: :part(content)`
 * @csspart content-item - The content item. Usage `c4d-pictogram-item: :part(content-item)`
 */
let C4DPictogramItem = _decorate([customElement(`${c4dPrefix}-pictogram-item`)], function (_initialize, _StableSelectorMixin) {
  class C4DPictogramItem extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPictogramItem,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'color',
        reflect: true
      })],
      key: "colorOption",
      value() {
        return COLOR_OPTIONS.DEFAULT;
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The pictogram color.
       *
       * Color scheme options are: "Black (Default)" and "Blue 50"
       */

      function render() {
        return html(_t || (_t = _`
      <div class="${0}--pictogram-item__row" part="item-row">
        <div class="${0}--pictogram-item__wrapper" part="wrapper">
          <slot
            class="${0}--pictogram-item__pictogram"
            part="pictogram"
            name="pictogram"></slot>
        </div>
        <div class="${0}--pictogram-item__content" part="content">
          <div class="${0}--content-item" part="content-item">
            ${0}
          </div>
        </div>
      </div>
    `), prefix, prefix, prefix, prefix, prefix, _superPropGet(C4DPictogramItem, "render", this, 3)([]));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pictogram-item`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DContentItem));
console.warn('The pictogram-item component has been deprecated in favor of the content-item (pictogram variation) component. ' + 'See content-item documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DPictogramItem;
//# sourceMappingURL=pictogram-item.js.map
