import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import ChevronDown16 from '@carbon/web-components/es/icons/chevron--down/16.js';
import Close16 from '@carbon/web-components/es/icons/close/16.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././pricing-table.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * @element c4d-pricing-table-annotation-toggle
 *
 * @csspart button - The button. Usage `c4d-pricing-table-annotation-toggle::part(button)`
 */
let C4DPricingTableAnnotationToggle = _decorate([customElement(`${c4dPrefix}-pricing-table-annotation-toggle`)], function (_initialize, _StableSelectorMixin) {
  class C4DPricingTableAnnotationToggle extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPricingTableAnnotationToggle,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'toggle';
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "toggled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [property()],
      key: "parentRow",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_handleClick",
      value() {
        return () => {
          const newVal = !this.toggled;
          this.toggled = newVal;
          this.dispatchEvent(new CustomEvent('event-toggle-annotations', {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: {
              emitter: this.parentRow,
              value: newVal
            }
          }));
        };
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        this.parentRow = this.closest(`${c4dPrefix}-pricing-table-row`);
        _superPropGet(C4DPricingTableAnnotationToggle, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          toggled
        } = this;
        return html(_t || (_t = _`
      <button
        part="button"
        @click="${0}"
        type="button"
        aria-pressed="${0}"
        aria-label="cell annotations visibility">
        ${0}
      </button>
    `), this._handleClick, toggled, toggled ? Close16() : ChevronDown16());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pricing-table-annotation-toggle`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
export default C4DPricingTableAnnotationToggle;
//# sourceMappingURL=pricing-table-annotation-toggle.js.map
