import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import HostListenerMixin from '@carbon/web-components/es/globals/mixins/host-listener.js';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DStructuredListCell from "../structured-list/structured-list-cell.js";
import styles from "././pricing-table.css.js";
import C4DPricingTableCellAnnotation from "./pricing-table-cell-annotation.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * @element c4d-pricing-table-cell
 *
 * @csspart container - The cell container. Usage `c4d-pricing-table-cell::part(container)`
 * @csspart content - The cell content. Usage `c4d-pricing-table-cell::part(content)`
 */
let C4DPricingTableCell = _decorate([customElement(`${c4dPrefix}-pricing-table-cell`)], function (_initialize, _StableSelectorMixin) {
  class C4DPricingTableCell extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPricingTableCell,
    d: [{
      kind: "field",
      key: "_parentGroup",
      value() {
        return this.closest(`${c4dPrefix}-pricing-table-group`);
      }
    }, {
      kind: "field",
      decorators: [HostListener('document:event-toggle-annotations')],
      key: "_handleAnnotationToggle",
      value() {
        return ({
          detail
        }) => {
          if (detail.emitter === this.parentNode) {
            this.classList.toggle('annotation-visible');
          }
        };
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        // Disable inherited tags functionality
        this.removeAttribute('tags');
        _superPropGet(C4DPricingTableCell, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$shadowRoot, _defaultSlot;
        const slots = (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelectorAll('slot');

        // Get default slot
        let defaultSlot;
        slots === null || slots === void 0 || slots.forEach(slot => {
          if (!slot.hasAttribute('name')) {
            defaultSlot = slot;
          }
        });

        // Filter out annotations, which should be in the "annotation" slot but
        // sometimes appear as inside the default slot. Also filter out empty
        // text nodes.
        const slotContents = (((_defaultSlot = defaultSlot) === null || _defaultSlot === void 0 ? void 0 : _defaultSlot.assignedNodes()) || []).filter(node => {
          var _node$textContent;
          const isAnnotation = node instanceof C4DPricingTableCellAnnotation;
          const isEmpty = ((_node$textContent = node.textContent) === null || _node$textContent === void 0 ? void 0 : _node$textContent.trim()) === '';
          return !isAnnotation && !isEmpty;
        });
        if (slotContents.length === 0) {
          this.classList.toggle('no-cell-content');
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <div class="${0}--pricing-table-cell-inner" part="container">
        <div class="${0}--pricing-table-cell-content" part="content">
          ${0}
        </div>
        <slot name="toggle"></slot>
      </div>
      <slot name="annotation"></slot>
    `), prefix, prefix, _superPropGet(C4DPricingTableCell, "render", this, 3)([]));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pricing-table-cell`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(HostListenerMixin(C4DStructuredListCell)));
export default C4DPricingTableCell;
//# sourceMappingURL=pricing-table-cell.js.map
