import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import C4DButton from "../cta/button-cta.js";
import { BUTTON_KIND } from '@carbon/web-components/es/components/button/button.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././pricing-table.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;
let C4DPricingTableHeaderCellCta = _decorate([customElement(`${c4dPrefix}-pricing-table-header-cell-cta`)], function (_initialize, _StableSelectorMixin) {
  class C4DPricingTableHeaderCellCta extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPricingTableHeaderCellCta,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'cta';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        this.kind = BUTTON_KIND.TERTIARY;
        _superPropGet(C4DPricingTableHeaderCellCta, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pricing-table-header-cell-cta`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DButton));
export default C4DPricingTableHeaderCellCta;
//# sourceMappingURL=pricing-table-header-cell-cta.js.map
