import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DStructuredListHeaderCell from "../structured-list/structured-list-header-cell.js";
import styles from "././pricing-table.css.js";
import { PRICING_TABLE_HEADER_CELL_TYPES } from "./defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * @element c4d-pricing-table-header-cell
 *
 * @csspart container - The cell container. Usage `c4d-pricing-table-header-cell::part(container)`
 * @csspart heading-container - The heading area container. Usage `c4d-pricing-table-header-cell::part(heading-container)`
 * @csspart tag-wrapper - A wrapper around the tags. Usage `c4d-pricing-table-header-cell::part(tag-wrapper)`
 * @csspart content-container - The content area container. Usage `c4d-pricing-table-header-cell::part(content-container)`
 * @csspart content - The cell content. Usage `c4d-pricing-table-header-cell::part(content)`
 * @csspart cta - The action. Usage `c4d-pricing-table-header-cell::part(cta)`
 */
let C4DPricingTableHeaderCell = _decorate([customElement(`${c4dPrefix}-pricing-table-header-cell`)], function (_initialize, _StableSelectorMixin) {
  class C4DPricingTableHeaderCell extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPricingTableHeaderCell,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "type",
      value() {
        return PRICING_TABLE_HEADER_CELL_TYPES.COMPLEX;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          type
        } = this;
        const {
          tagWrapperSelector
        } = this.constructor;
        return type === PRICING_TABLE_HEADER_CELL_TYPES.COMPLEX ? html(_t || (_t = _`
          <div
            class="${0}--pricing-table-header-cell-inner"
            part="container">
            <div part="heading-container">
              <slot name="highlight-label"></slot>
              <slot name="headline"></slot>
              <slot name="caption"></slot>
              <div class="${0}" part="tag-wrapper">
                <slot name="tag"></slot>
              </div>
              <div
                class="${0}--pricing-table-cell-inner"
                part="content-container">
                <div
                  class="${0}--pricing-table-cell-content"
                  part="content">
                  <slot></slot>
                </div>
                <slot name="toggle"></slot>
              </div>
            </div>
            <div part="cta">
              <slot name="cta"></slot>
            </div>
          </div>
        `), prefix, tagWrapperSelector, prefix, prefix) : html(_t2 || (_t2 = _`
          <div
            class="${0}--pricing-table-cell-inner"
            part="content-container">
            <div class="${0}--pricing-table-cell-content" part="content">
              ${0}
            </div>
          </div>
        `), prefix, prefix, _superPropGet(C4DPricingTableHeaderCell, "render", this, 3)([]));
      }
    }, {
      kind: "get",
      static: true,
      key: "tagWrapperSelector",
      value: function () {
        return `${prefix}--pricing-table-header-cell-tag-wrapper`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pricing-table-header-cell`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DStructuredListHeaderCell));
export default C4DPricingTableHeaderCell;
//# sourceMappingURL=pricing-table-header-cell.js.map
