import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import sameHeight from '@carbon/ibmdotcom-utilities/es/utilities/sameHeight/sameHeight.js';
import C4DStructuredListHeaderRow from "../structured-list/structured-list-header-row.js";
import C4DPricingTableHeaderCell from "./pricing-table-header-cell.js";
import styles from "././pricing-table.css.js";
import { setColumnWidth } from "./utils.js";
import { PRICING_TABLE_HEADER_CELL_TYPES } from "./defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;
let C4DPricingTableHeaderRow = _decorate([customElement(`${c4dPrefix}-pricing-table-header-row`)], function (_initialize, _StableSelectorMixin) {
  class C4DPricingTableHeaderRow extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPricingTableHeaderRow,
    d: [{
      kind: "field",
      key: "_tagWrappers",
      value() {
        return [];
      }
    }, {
      kind: "method",
      key: "_setSameHeight",
      value:
      /**
       * Array full of tag wrapper elements within header cells.
       */

      function _setSameHeight() {
        window.requestAnimationFrame(() => {
          sameHeight(this._tagWrappers);
        });
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange(e) {
        setColumnWidth(this);

        // Find cells that are eligible to have tags within them.
        const validCells = e.target.assignedNodes().filter(node => {
          if (node instanceof C4DPricingTableHeaderCell) {
            return node.type === PRICING_TABLE_HEADER_CELL_TYPES.COMPLEX;
          }
          return false;
        });

        // Get wrapper markup for tag slot, which is always rendered regardless of
        // the presence of a tag.
        this._tagWrappers = validCells.reduce((acc, cell) => {
          if (cell.length !== 0) {
            const tag = cell.shadowRoot.querySelector(`.${C4DPricingTableHeaderCell.tagWrapperSelector}`);
            if (tag) {
              acc.push(tag);
            }
          }
          return acc;
        }, []);
        this._setSameHeight();
        const {
          eventSlotChange
        } = this.constructor;
        this.dispatchEvent(new CustomEvent(eventSlotChange, {
          bubbles: true,
          cancelable: true,
          composed: true
        }));
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DPricingTableHeaderRow, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        _superPropGet(C4DPricingTableHeaderRow, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot @slotchange=${0}></slot> `), this._handleSlotChange);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pricing-table-header-row`;
      }
    }, {
      kind: "get",
      static: true,
      key: "eventSlotChange",
      value: function () {
        return `${c4dPrefix}-pricing-table-header-row-slot-change`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DStructuredListHeaderRow));
export default C4DPricingTableHeaderRow;
//# sourceMappingURL=pricing-table-header-row.js.map
