import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import C4DStructuredListRow from "../structured-list/structured-list-row.js";
import styles from "././pricing-table.css.js";
import { setColumnWidth } from "./utils.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;
let C4DPricingTableRow = _decorate([customElement(`${c4dPrefix}-pricing-table-row`)], function (_initialize, _StableSelectorMixin) {
  class C4DPricingTableRow extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DPricingTableRow,
    d: [{
      kind: "field",
      decorators: [property()],
      key: "hasAnnotations",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange() {
        setColumnWidth(this);
      }
    }, {
      kind: "method",
      key: "_hasAnnotations",
      value: function _hasAnnotations() {
        let hasAnnotations = false;
        Array.from(this.children).forEach(cell => {
          const annotation = cell.querySelector(`${c4dPrefix}-pricing-table-cell-annotation`);
          if (annotation) {
            hasAnnotations = true;
          }
        });
        return hasAnnotations;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        this.hasAnnotations = this._hasAnnotations();
        if (this.hasAnnotations) {
          const toggle = this.ownerDocument.createElement('c4d-pricing-table-annotation-toggle');
          this.children[0].append(toggle);
        }
        _superPropGet(C4DPricingTableRow, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot @slotchange=${0}></slot> `), this._handleSlotChange);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--pricing-table-row`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(C4DStructuredListRow));
export default C4DPricingTableRow;
//# sourceMappingURL=pricing-table-row.js.map
