/**
 * @license
 *
 * Copyright IBM Corp. 2022, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import C4DPricingTableHeaderRow from './pricing-table-header-row';
import C4DPricingTableRow from './pricing-table-row';
/**
 * Sets a CSS custom property on the given row that indicates the default
 * number of columns each of that row's cells row should span.
 */
export declare const setColumnWidth: (row: C4DPricingTableHeaderRow | C4DPricingTableRow) => void;
/**
 * Animates an element hidden.
 */
export declare const slideHidden: (element: HTMLElement) => void;
/**
 * Animates an element visible.
 */
export declare const slideUnhidden: (element: HTMLElement) => void;
/**
 * Splits a style attribute string into an object full of properties and values.
 */
export declare const convertStyleToObject: (styleString: string) => object;
export default setColumnWidth;

//# sourceMappingURL=utils.d.ts.map
