import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import styles from "././quote.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The source copy content of quote.
 *
 * @element c4d-quote-source-copy
 */
let C4DQuoteSourceCopy = _decorate([customElement(`${c4dPrefix}-quote-source-copy`)], function (_initialize, _LitElement) {
  class C4DQuoteSourceCopy extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DQuoteSourceCopy,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'source-copy';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The shadow slot this source copy content should be in.
       */

      function render() {
        return html(_t || (_t = _` <slot></slot> `));
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, LitElement);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DQuoteSourceCopy;
//# sourceMappingURL=quote-source-copy.js.map
