/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import CDSDropdown, { DROPDOWN_TYPE } from '@carbon/web-components/es/components/dropdown/dropdown.js';
import { DROPDOWN_COLOR_SCHEME, DROPDOWN_SIZE } from '../footer/defs';
export { DROPDOWN_COLOR_SCHEME, DROPDOWN_SIZE, DROPDOWN_TYPE };
/**
 * Dropdown component to change search scope.
 *
 * @element c4d-scoped-search-dropdown
 * @fires cds-select-selected - The custom event fired after the the dropdown value is changed upon a user gesture.
 */
declare class C4DScopedSearchDropdown extends CDSDropdown {
    /**
     * Handles user-initiated selection of a dropdown item
     *
     * @param [item] The dropdown item user wants to select. Absense of this argument means clearing selection.
     */
    protected _handleUserInitiatedSelectItem(item?: any): void;
    /**
     * The name of the custom event captured to retrieve the new search scope.
     */
    static get eventSelect(): string;
    static styles: any;
}
export default C4DScopedSearchDropdown;

//# sourceMappingURL=scoped-search-dropdown.d.ts.map
