import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _decorate from "@babel/runtime/helpers/esm/decorate";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import CDSDropdown, { DROPDOWN_TYPE } from '@carbon/web-components/es/components/dropdown/dropdown.js';
import styles from "././search-with-typeahead.css.js";
import { DROPDOWN_COLOR_SCHEME, DROPDOWN_SIZE } from "../footer/defs.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
export { DROPDOWN_COLOR_SCHEME, DROPDOWN_SIZE, DROPDOWN_TYPE };
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Dropdown component to change search scope.
 *
 * @element c4d-scoped-search-dropdown
 * @fires cds-select-selected - The custom event fired after the the dropdown value is changed upon a user gesture.
 */
let C4DScopedSearchDropdown = _decorate([customElement(`${c4dPrefix}-scoped-search-dropdown`)], function (_initialize, _CDSDropdown) {
  class C4DScopedSearchDropdown extends _CDSDropdown {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DScopedSearchDropdown,
    d: [{
      kind: "method",
      key: "_handleUserInitiatedSelectItem",
      value:
      /**
       * Handles user-initiated selection of a dropdown item
       *
       * @param [item] The dropdown item user wants to select. Absense of this argument means clearing selection.
       */
      function _handleUserInitiatedSelectItem(item) {
        if (this._selectionShouldChange(item)) {
          const init = {
            bubbles: true,
            composed: true,
            detail: {
              appId: item.value
            }
          };
          const constructor = this.constructor;
          const beforeSelectEvent = new CustomEvent(constructor.eventBeforeSelect, _objectSpread(_objectSpread({}, init), {}, {
            cancelable: true
          }));
          if (this.dispatchEvent(beforeSelectEvent)) {
            this._selectionDidChange(item);
            const afterSelectEvent = new CustomEvent(constructor.eventSelect, init);
            this.dispatchEvent(afterSelectEvent);
          }
        }
      }

      /**
       * The name of the custom event captured to retrieve the new search scope.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelect",
      value: function () {
        return `${prefix}-select-selected`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSDropdown);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DScopedSearchDropdown;
//# sourceMappingURL=scoped-search-dropdown.js.map
