import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import 'lit';
import CDSSearch from '@carbon/web-components/es/components/search/search.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././search.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Expressive search.
 *
 * @element c4d-search
 */
let C4DSearch = _decorate([customElement(`${c4dPrefix}-search`)], function (_initialize, _CDSSearch) {
  class C4DSearch extends _CDSSearch {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DSearch,
    d: [{
      kind: "get",
      static: true,
      key: "eventInput",
      value:
      /**
       * The name of the custom event fired after the search content is changed upon a user gesture.
       */
      function () {
        return `${prefix}-search-input`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSSearch);
console.warn('The c4d-search component has been deprecated in favor of the @carbon/web-components search component. ' + 'See @carbon/web-components search component documentation for more information.');
export default C4DSearch;
//# sourceMappingURL=search.js.map
