/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import CDSStructuredListCell from '@carbon/web-components/es/components/structured-list/structured-list-cell.js';
import C4DStructuredListGroup from './structured-list-group';
/**
 * StructuredListCell
 *
 * @element c4d-structured-list-cell
 * @csspart icon-text-container - Text wrapping element. Usage `c4d-structured-list-cell::part(icon-text)`
 * @csspart icon-text - Descriptive text of the cell. Usage `c4d-structured-list-cell::part(icon-text)`
 * @csspart tag - Tags of the cell. Usage `c4d-structured-list-cell::part(tag)`
 * @csspart icon - An icon. Usage `c4d-structured-list-cell::part(icon)`
 * @csspart tooltip - CDSTooltip. Usage `c4d-structured-list-cell::part(icon)`
 */
declare class C4DStructuredListCell extends CDSStructuredListCell {
    parentGroup: C4DStructuredListGroup | null;
    groupLabel?: string;
    tooltipText?: string;
    icon?: string;
    private _iconsAllowed;
    tags?: string;
    connectedCallback(): void;
    private _renderIcon;
    private _renderTags;
    private _renderTooltip;
    render(): import("lit-html").TemplateResult<1>;
    static styles: any;
}
export default C4DStructuredListCell;

//# sourceMappingURL=structured-list-cell.d.ts.map
