import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import CDSStructuredListCell from '@carbon/web-components/es/components/structured-list/structured-list-cell.js';
import { html } from 'lit';
import { property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import Info16 from '@carbon/web-components/es/icons/information/16.js';
import Checkmark20 from '@carbon/web-components/es/icons/checkmark/20.js';
import Error20 from '@carbon/web-components/es/icons/error/20.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././structured-list.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * StructuredListCell
 *
 * @element c4d-structured-list-cell
 * @csspart icon-text-container - Text wrapping element. Usage `c4d-structured-list-cell::part(icon-text)`
 * @csspart icon-text - Descriptive text of the cell. Usage `c4d-structured-list-cell::part(icon-text)`
 * @csspart tag - Tags of the cell. Usage `c4d-structured-list-cell::part(tag)`
 * @csspart icon - An icon. Usage `c4d-structured-list-cell::part(icon)`
 * @csspart tooltip - CDSTooltip. Usage `c4d-structured-list-cell::part(icon)`
 */
let C4DStructuredListCell = _decorate([customElement(`${c4dPrefix}-structured-list-cell`)], function (_initialize, _CDSStructuredListCel) {
  class C4DStructuredListCell extends _CDSStructuredListCel {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DStructuredListCell,
    d: [{
      kind: "field",
      key: "parentGroup",
      value() {
        return this.closest(`${c4dPrefix}-structured-list-group`);
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'aria-label',
        reflect: true
      })],
      key: "groupLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'tooltip',
        reflect: true
      })],
      key: "tooltipText",
      value: void 0
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'icon',
        reflect: true
      })],
      key: "icon",
      value: void 0
    }, {
      kind: "field",
      key: "_iconsAllowed",
      value() {
        return {
          checkmark: Checkmark20,
          error: Error20
        };
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'tags',
        reflect: true
      })],
      key: "tags",
      value: void 0
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this$parentGroup;
        _superPropGet(C4DStructuredListCell, "connectedCallback", this, 3)([]);
        this.groupLabel = (_this$parentGroup = this.parentGroup) === null || _this$parentGroup === void 0 ? void 0 : _this$parentGroup.groupTitle;
      }
    }, {
      kind: "method",
      key: "_renderIcon",
      value: function _renderIcon() {
        const {
          icon,
          _iconsAllowed: iconMap
        } = this;
        return html(_t || (_t = _` <div
      class="${0}--structured-list-cell-icon-text-container"
      part="icon-text-container">
      ${0}
      <span class="${0}--structured-list-cell-icon-text" part="icon-text">
        <slot></slot>
      </span>
    </div>`), prefix, iconMap[icon.toLowerCase()].call(null, {
          part: 'icon'
        }), prefix);
      }
    }, {
      kind: "method",
      key: "_renderTags",
      value: function _renderTags() {
        const {
          tags
        } = this;
        return html(_t2 || (_t2 = _`
      ${0}
    `), tags.split(',').map(tag => html(_t3 || (_t3 = _`
              <cds-tag part="tag" size="sm" type="green">${0}</cds-tag>
            `), tag.trim())));
      }
    }, {
      kind: "method",
      key: "_renderTooltip",
      value: function _renderTooltip() {
        const {
          tooltipText: tooltip
        } = this;
        return html(_t4 || (_t4 = _`
      <cds-tooltip-icon
        part="tooltip"
        alignment="start"
        body-text="${0}"
        direction="right">
        ${0}
      </cds-tooltip-icon>
    `), ifDefined(tooltip), Info16());
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          tooltipText: tooltip,
          icon,
          _iconsAllowed: iconsAllowed,
          tags
        } = this;
        if (icon && Object.keys(iconsAllowed).includes(icon.toLowerCase())) {
          return html(_t5 || (_t5 = _` ${0} `), this._renderIcon());
        }
        return html(_t6 || (_t6 = _`
      ${0} ${0}
      ${0}
    `), _superPropGet(C4DStructuredListCell, "render", this, 3)([]), tags ? this._renderTags() : '', tooltip ? this._renderTooltip() : '');
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, CDSStructuredListCell);
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DStructuredListCell;
//# sourceMappingURL=structured-list-cell.js.map
