import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import styles from "././structured-list.css.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * StructuredListGroup
 *
 * @element c4d-structured-list-group
 * @csspart row - The table group title row. Usage `c4d-structured-list-group::part(row)`
 * @csspart row--group-title - The table group title row. Usage `c4d-structured-list-group::part(row--group-title)`
 * @csspart group-title - The group title. Usage `c4d-structured-list-group::part(group-title)`
 */
let C4DStructuredListGroup = _decorate([customElement(`${c4dPrefix}-structured-list-group`)], function (_initialize, _StableSelectorMixin) {
  class C4DStructuredListGroup extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DStructuredListGroup,
    d: [{
      kind: "field",
      key: "_parentTable",
      value() {
        return this.closest(`${c4dPrefix}-structured-list`);
      }
    }, {
      kind: "field",
      decorators: [property({
        attribute: 'title'
      })],
      key: "groupTitle",
      value: void 0
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DStructuredListGroup, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "_renderTitle",
      value: function _renderTitle() {
        // Set colspan to max value to ensure it spans all columns.
        return html(_t || (_t = _`
      <tr part="row row--group-title">
        <th part="group-title" colspan="999">${0}</th>
      </tr>
    `), this.groupTitle);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t2 || (_t2 = _`
      ${0}
      <slot></slot>
    `), this.groupTitle ? this._renderTitle() : '');
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DStructuredListGroup;
//# sourceMappingURL=structured-list-group.js.map
