import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6,
  _t7,
  _t8,
  _t9,
  _t10,
  _t11,
  _t12,
  _t13,
  _t14,
  _t15,
  _t16;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2025
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { classMap } from 'lit/directives/class-map.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { html, LitElement } from 'lit';
import { property, query, queryAll, state } from 'lit/decorators.js';
import ChevronLeft20 from '@carbon/web-components/es/icons/chevron--left/20.js';
import ChevronRight20 from '@carbon/web-components/es/icons/chevron--right/20.js';
import HostListener from '@carbon/web-components/es/globals/decorators/host-listener.js';
import HostListenerMixin from '@carbon/web-components/es/globals/mixins/host-listener.js';
import throttle from 'lodash-es/throttle.js';
import StickyHeader from '@carbon/ibmdotcom-utilities/es/utilities/StickyHeader/StickyHeader.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././table-of-contents.css.js";
import { TOC_TYPES } from "./defs.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import MediaQueryMixin, { MQBreakpoints, MQDirs } from "../../component-mixins/media-query/media-query.js";
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

// total button width - grid offset
const buttonWidthOffset = 32;
/**
 * @param a An array.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns The index of the last item in the given array where `predicate` returns `true`. `-1` if no such item is found.
 */
function findLastIndex(a, predicate, thisObject) {
  for (let i = a.length - 1; i >= 0; --i) {
    if (predicate(a[i], i, thisObject)) {
      return i;
    }
  }
  return -1;
}

/**
 * Table of contents.
 *
 * @element c4d-table-of-contents
 * @csspart list - The menu list. Usage `c4d-table-of-contents::part(list)`
 * @csspart list-item - The menu items. Usage `c4d-table-of-contents::part(list-item)`
 * @csspart list-item--active - The menu items as active. Usage `c4d-table-of-contents::part(list-item--active)`
 * @csspart link - The links under TOC. Usage `c4d-table-of-contents::part(link)`
 * @csspart container - The container. Usage `c4d-table-of-contents::part(container)`
 * @csspart table - The table UI. Usage `c4d-table-of-contents::part(table)`
 * @csspart heading - The headings. Usage `c4d-table-of-contents::part(heading)`
 * @csspart prev-button - The previous button. Usage `c4d-table-of-contents::part(prev-button)`
 * @csspart item-container - The item container. Usage `c4d-table-of-contents::part(item-container)`
 * @csspart content - The content. Usage `c4d-table-of-contents::part(content)`
 * @csspart sub-content-right - The right side content. Usage `c4d-table-of-contents::part(sub-content-right)`
 * @csspart sub-content-left - The left side content. Usage `c4d-table-of-contents::part(sub-content-left)`
 * @csspart next-button - The next button. Usage `c4d-table-of-contents::part(next-button)`
 * @csspart content-table - The content table. Usage `c4d-table-of-contents::part(content-table)`
 * @csspart wrapper - The wrapper. Usage `c4d-table-of-contents::part(wrapper)`
 * @slot heading - The heading content.
 * @slot menu-rule - The menu rule.
 */
let C4DTableOfContents = _decorate([customElement(`${c4dPrefix}-table-of-contents`)], function (_initialize, _MediaQueryMixin) {
  class C4DTableOfContents extends _MediaQueryMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTableOfContents,
    d: [{
      kind: "field",
      decorators: [property({
        reflect: true,
        attribute: 'toc-layout'
      })],
      key: "layout",
      value() {
        return TOC_TYPES.DEFAULT;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_currentScrollPosition",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_currentTarget",
      value() {
        return null;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_isIntersectionLeftTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_isIntersectionRightTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_hasHeading",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "_observerIntersection",
      value() {
        return null;
      }
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--tableofcontents`)],
      key: "_contentNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--sub-content-left`)],
      key: "_intersectionLeftSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--sub-content-right`)],
      key: "_intersectionRightSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [queryAll(`.${prefix}--tableofcontents__item`)],
      key: "_itemNodes",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--tableofcontents__content`)],
      key: "_contentDiv",
      value: void 0
    }, {
      kind: "field",
      decorators: [query(`.${prefix}--tableofcontents__navbar`)],
      key: "_navBar",
      value: void 0
    }, {
      kind: "field",
      decorators: [state()],
      key: "_isMobile",
      value() {
        return !this.carbonBreakpoints.lg.matches;
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_targets",
      value() {
        return [];
      }
    }, {
      kind: "field",
      key: "_tagNamesToAvoid",
      value() {
        return [`${c4dPrefix}-video-player`, 'select', 'input'];
      }
    }, {
      kind: "field",
      key: "_disableTargetAttribute",
      value() {
        return 'no-toc';
      }
    }, {
      kind: "field",
      decorators: [state()],
      key: "_pageIsRTL",
      value() {
        return this.ownerDocument.documentElement.dir === 'rtl';
      }
    }, {
      kind: "field",
      key: "_throttleScroll",
      value() {
        return null;
      }
    }, {
      kind: "method",
      key: "_handleClickItem",
      value:
      /**
       * Defines TOC type, "" for default, `horizontal` for horizontal variant.
       */

      /**
       * The current scroll position.
       */

      /**
       * The current target `<a>` that should be in view.
       */

      /**
       * `true` if left-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the left-hand paginator button should be hidden.
       */

      /**
       * `true` if right-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the right-hand paginator button should be hidden.
       */

      /**
       * `true` if there is a heading content.
       */

      /**
       * The observer for the intersection of left-side content edge.
       */

      /**
       * The scrolling content.
       */

      /**
       * The left-hand sentinel to track intersection with the host element.
       * If they intersect, the left-hand paginator button should be hidden.
       */

      /**
       * The right-hand sentinel to track intersection with the host element.
       * If they intersect, the right-hand paginator button should be hidden.
       */

      /**
       * Whether we're viewing smaller or larger window.
       */

      /**
       * The target elements matching `[name]` harvested from the document.
       */

      /**
       * The Element.tagName values that should never be used as a TOC target.
       * Typically added here because these elements have their own `[name]` attribute.
       */

      /**
       * The name of an attribute that will prevent the DOM element and any elements
       * in its subtree from being added to the ToC.
       */

      /**
       * Boolean checking if page is RTL
       */

      /**
       * The handler for throttled scrolling
       */

      /**
       * Handles `click` event on a menu item.
       *
       * @param event The event.
       */
      function _handleClickItem(event) {
        var _target$matches;
        const {
          selectorItem
        } = this.constructor;
        const target = event.target;
        if ((_target$matches = target.matches) !== null && _target$matches !== void 0 && _target$matches.call(target, selectorItem)) {
          this._handleUserInitiatedJump(target.dataset.target);

          // This will make sure the clicked tab scrolls into view and is centered being completely visible in mobile res.
          if (this._isMobile) {
            target.scrollIntoView({
              block: 'nearest',
              inline: 'center',
              behavior: 'smooth'
            });
          }
          event.preventDefault();
        }
      }

      /**
       * Handles `keyboard` event on a TOC navigation item.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleOnKeyDown",
      value: function _handleOnKeyDown(event) {
        var _target$matches2;
        const {
          selectorItem
        } = this.constructor;
        const target = event.target;
        const {
          _pageIsRTL: pageIsRTL
        } = this;
        const paginateAccessibile = this.layout === TOC_TYPES.HORIZONTAL || this._isMobile;
        if ((_target$matches2 = target.matches) !== null && _target$matches2 !== void 0 && _target$matches2.call(target, selectorItem)) {
          if (pageIsRTL) {
            if (event.key === 'ArrowLeft') {
              var _target$parentElement, _target$parentElement2, _target$parentElement3;
              (_target$parentElement = target.parentElement) === null || _target$parentElement === void 0 || (_target$parentElement = _target$parentElement.nextElementSibling) === null || _target$parentElement === void 0 || (_target$parentElement = _target$parentElement.children[0]) === null || _target$parentElement === void 0 || _target$parentElement.focus();
              if (paginateAccessibile && (_target$parentElement2 = target.parentElement) !== null && _target$parentElement2 !== void 0 && _target$parentElement2.previousElementSibling && ((_target$parentElement3 = target.parentElement) === null || _target$parentElement3 === void 0 ? void 0 : _target$parentElement3.previousElementSibling.getBoundingClientRect().right) > this._navBar.getBoundingClientRect().right - buttonWidthOffset) {
                this._paginateLeft();
              }
            }
            if (event.key === 'ArrowRight') {
              var _target$parentElement4, _target$parentElement5, _target$parentElement6;
              (_target$parentElement4 = target.parentElement) === null || _target$parentElement4 === void 0 || (_target$parentElement4 = _target$parentElement4.previousElementSibling) === null || _target$parentElement4 === void 0 || (_target$parentElement4 = _target$parentElement4.children[0]) === null || _target$parentElement4 === void 0 || _target$parentElement4.focus();
              if (paginateAccessibile && (_target$parentElement5 = target.parentElement) !== null && _target$parentElement5 !== void 0 && _target$parentElement5.nextElementSibling && ((_target$parentElement6 = target.parentElement) === null || _target$parentElement6 === void 0 ? void 0 : _target$parentElement6.nextElementSibling.getBoundingClientRect().left) < this._navBar.getBoundingClientRect().left + buttonWidthOffset) {
                this._paginateRight();
              }
            }
          } else {
            if (event.key === 'ArrowLeft') {
              var _target$parentElement7, _target$parentElement8, _target$parentElement9;
              (_target$parentElement7 = target.parentElement) === null || _target$parentElement7 === void 0 || (_target$parentElement7 = _target$parentElement7.previousElementSibling) === null || _target$parentElement7 === void 0 || (_target$parentElement7 = _target$parentElement7.children[0]) === null || _target$parentElement7 === void 0 || _target$parentElement7.focus();
              if (paginateAccessibile && (_target$parentElement8 = target.parentElement) !== null && _target$parentElement8 !== void 0 && _target$parentElement8.previousElementSibling && ((_target$parentElement9 = target.parentElement) === null || _target$parentElement9 === void 0 ? void 0 : _target$parentElement9.previousElementSibling.getBoundingClientRect().left) < this._navBar.getBoundingClientRect().left + buttonWidthOffset) {
                this._paginateLeft();
              }
            }
            if (event.key === 'ArrowRight') {
              var _target$parentElement10, _target$parentElement11, _target$parentElement12;
              (_target$parentElement10 = target.parentElement) === null || _target$parentElement10 === void 0 || (_target$parentElement10 = _target$parentElement10.nextElementSibling) === null || _target$parentElement10 === void 0 || (_target$parentElement10 = _target$parentElement10.children[0]) === null || _target$parentElement10 === void 0 || _target$parentElement10.focus();
              if (paginateAccessibile && (_target$parentElement11 = target.parentElement) !== null && _target$parentElement11 !== void 0 && _target$parentElement11.nextElementSibling && ((_target$parentElement12 = target.parentElement) === null || _target$parentElement12 === void 0 ? void 0 : _target$parentElement12.nextElementSibling.getBoundingClientRect().right) > this._navBar.getBoundingClientRect().right - buttonWidthOffset) {
                this._paginateRight();
              }
            }
          }
        }
      }

      /**
       * Handles intersection of target `<a>`s with the viewport by checking which target's
       * immediate siblings are close to the viewport, and set the active target depending
       * on their positions.
       */
    }, {
      kind: "field",
      key: "_handleOnScroll",
      value() {
        return () => {
          this.ownerDocument.defaultView.requestAnimationFrame(() => {
            if (this._targets) {
              const items = this._targets.map((elem, index, arr) => ({
                elem,
                height: arr[index + 1] ? arr[index + 1].getBoundingClientRect().y - elem.getBoundingClientRect().y : null,
                position: elem.getBoundingClientRect().y
              })).filter((elem, index, arr) => elem.height === null ? arr[index - 1].position < arr[index - 1].height : elem.position - 50 - this.stickyOffset > -elem.height);

              // Sets last section as active at the end of page in case there is not enough height for it to dynamically activate
              const bottomReached = this.ownerDocument.scrollingElement.scrollTop + this.ownerDocument.scrollingElement.clientHeight === this.ownerDocument.scrollingElement.scrollHeight;
              if (items && items[0] && items[items.length - 1]) {
                this._currentTarget = !bottomReached ? items[0].elem : items[items.length - 1].elem;
              }
            }
          });
        };
      }
    }, {
      kind: "field",
      key: "_contentMutationObserver",
      value() {
        return new MutationObserver(this._contentObserverCallback.bind(this));
      }
    }, {
      kind: "method",
      key: "_contentObserverCallback",
      value:
      /**
       * Watches for changes to content in the default slot.
       */
      /**
       * Sets table of contents targets whenever any node tree mutation is observed.
       */
      function _contentObserverCallback() {
        const shadowRoot = this.shadowRoot;
        const allSlots = Array.from(shadowRoot.querySelectorAll(`slot`));
        const allSlottedNodes = allSlots.flatMap(slot => slot.assignedNodes());
        this._setTargets(allSlottedNodes);
      }

      /**
       * Sets targets used for generating the table of contents.
       */
    }, {
      kind: "method",
      key: "_setTargets",
      value: function _setTargets(nodes) {
        const {
          _tagNamesToAvoid: tagNamesToAvoid,
          _disableTargetAttribute: disableTargetAttribute
        } = this;
        const {
          selectorTarget
        } = this.constructor;
        this._targets = nodes.reduce((acc, node) => {
          if (node instanceof HTMLElement) {
            const descendants = node.querySelectorAll(selectorTarget);
            const elems = [node, ...descendants].filter(elem => {
              var _elem$innerText, _elem$dataset$title;
              if (elem.innerText == null && elem.innerText == undefined) {
                return false;
              }
              const notWhiteSpace = /[^\s\n\r]/g;
              const hasTitle = ((_elem$innerText = elem.innerText) === null || _elem$innerText === void 0 ? void 0 : _elem$innerText.match(notWhiteSpace)) || ((_elem$dataset$title = elem.dataset.title) === null || _elem$dataset$title === void 0 ? void 0 : _elem$dataset$title.match(notWhiteSpace));
              const hasNameAttr = elem.matches(selectorTarget);
              const notExcluded = !tagNamesToAvoid.includes(elem.tagName.toLowerCase()) && !elem.closest(`[${disableTargetAttribute}]`);
              return hasTitle && hasNameAttr && notExcluded;
            });
            acc.push(...elems);
          }
          return acc;
        }, []);
      }

      /**
       * Handles `slotchange` event on the default `<slot>`.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange(event) {
        // Handle changes to immediate slotted children.
        const slottedElements = event.target.assignedNodes().filter(node => node instanceof HTMLElement);
        this._setTargets(slottedElements);

        // Handle changes to slotted contents' children.
        this._contentMutationObserver.disconnect();
        event.target.assignedNodes().forEach(node => {
          if (node instanceof HTMLElement) {
            this._contentMutationObserver.observe(node, {
              subtree: true,
              childList: true,
              attributeFilter: ['name', 'data-title']
            });
          }
        });
      }

      /**
       * Handles `slotchange` event on `<slot name="heading">`.
       */
    }, {
      kind: "method",
      key: "_handleSlotChangeHeading",
      value: function _handleSlotChangeHeading() {
        this._hasHeading = Array.from(this.querySelectorAll('[slot="heading"]')).some(node => node.nodeType !== Node.TEXT_NODE || node.textContent.trim());
      }

      /**
       * Handles user-initiated jump to a hash.
       *
       * @param target The hash name.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedJump",
      value: function _handleUserInitiatedJump(target) {
        const elem = this.querySelector(`[name="${target}"]`);
        const masthead = this.ownerDocument.querySelector(`${c4dPrefix}-masthead`);
        if (elem instanceof HTMLElement) {
          const currentY = window.scrollY;
          let targetY;
          if (currentY > elem.offsetTop && masthead) {
            targetY = elem.offsetTop - masthead.offsetHeight;
          } else {
            targetY = elem.offsetTop - parseInt(window.getComputedStyle(elem).getPropertyValue('padding-top')) - parseInt(window.getComputedStyle(this._contentDiv).getPropertyValue('padding-top'));
          }
          window.scrollTo({
            top: targetY,
            left: 0,
            behavior: 'smooth'
          });
          elem.setAttribute('tabindex', '0');
          elem.focus({
            preventScroll: true
          });
          elem.addEventListener('focusout', ({
            target: focusoutTarget
          }) => {
            focusoutTarget === null || focusoutTarget === void 0 || focusoutTarget.removeAttribute('tabindex');
          }, {
            once: true
          });
        }
      }

      /**
       * Cleans-up and creates the intersection observer for the scrolling container.
       *
       * @param [options] The options.
       * @param [options.create] `true` to create the new intersection observer.
       */
    }, {
      kind: "method",
      key: "_cleanAndCreateIntersectionObserverContainer",
      value: function _cleanAndCreateIntersectionObserverContainer({
        create
      } = {}) {
        const {
          _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
          _intersectionRightSentinelNode: intersectionRightSentinelNode
        } = this;
        if (this._observerIntersection) {
          this._observerIntersection.disconnect();
          this._observerIntersection = null;
        }
        if (create) {
          this._observerIntersection = new IntersectionObserver(this._observeIntersectionContainer, {
            root: this._navBar,
            threshold: 0
          });
          if (intersectionLeftSentinelNode) {
            this._observerIntersection.observe(intersectionLeftSentinelNode);
          }
          if (intersectionRightSentinelNode) {
            this._observerIntersection.observe(intersectionRightSentinelNode);
          }
        }
      }

      /**
       * The intersection observer callback for the scrolling container.
       *
       * @param records The intersection observer records.
       */
    }, {
      kind: "field",
      key: "_observeIntersectionContainer",
      value() {
        return records => {
          const {
            _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
            _intersectionRightSentinelNode: intersectionRightSentinelNode
          } = this;
          records.forEach(({
            isIntersecting,
            target
          }) => {
            if (target === intersectionLeftSentinelNode) {
              this._isIntersectionLeftTrackerInContent = isIntersecting;
            }
            if (target === intersectionRightSentinelNode) {
              this._isIntersectionRightTrackerInContent = isIntersecting;
            }
          });
        };
      }
    }, {
      kind: "method",
      key: "_paginateLeft",
      value:
      /**
       * Handles `click` event on the left-hand paginator button.
       */
      function _paginateLeft() {
        const {
          _currentScrollPosition: currentScrollPosition,
          _navBar: navBar,
          _itemNodes: itemNodes,
          _pageIsRTL: pageIsRTL
        } = this;
        // If the right-side intersection sentinel is in the view, it means that right-side chevron button is hidden.
        // Given scrolling to left makes it shown,
        // `contentContainerNode!.offsetWidth` will shrink as we scroll and we need to adjust for it.
        const elems = Array.prototype.slice.call(itemNodes);
        if (elems) {
          if (pageIsRTL) {
            const interimLeft = navBar.getBoundingClientRect().right;
            const lastVisibleElementIndex = findLastIndex(elems, elem => elem.getBoundingClientRect().right > interimLeft - buttonWidthOffset);
            if (lastVisibleElementIndex >= 0) {
              const lastVisibleElementRight = elems[lastVisibleElementIndex].getBoundingClientRect().left;
              // 48 = button width - button gradient
              const newScrollPosition = currentScrollPosition - lastVisibleElementRight + 48;
              this._currentScrollPosition = newScrollPosition <= 0 ? 0 : newScrollPosition;
            }
          } else {
            const lastVisibleElementIndex = findLastIndex(elems, elem => elem.getBoundingClientRect().left < buttonWidthOffset + navBar.getBoundingClientRect().left);
            if (lastVisibleElementIndex >= 0) {
              const lastVisibleElementRight = elems[lastVisibleElementIndex].getBoundingClientRect().right;
              const newScrollPosition = lastVisibleElementRight + currentScrollPosition - navBar.getBoundingClientRect().right + buttonWidthOffset;
              // If the new scroll position is less than the width of the left chevron button,
              // it means that hiding the left chevron button reveals the whole of the left-most nav item.
              // Snaps the left-most nav item to the left edge of nav container in this case.
              this._currentScrollPosition = newScrollPosition <= 0 ? 0 : newScrollPosition;
            }
          }
        }
      }

      /**
       * Handles `click` event on the right-hand paginator button.
       */
    }, {
      kind: "method",
      key: "_paginateRight",
      value: function _paginateRight() {
        const {
          _navBar: navBar,
          _contentNode: contentNode,
          _currentScrollPosition: currentScrollPosition,
          _itemNodes: itemNodes,
          _pageIsRTL: pageIsRTL
        } = this;
        const elems = Array.prototype.slice.call(itemNodes);
        if (elems) {
          if (pageIsRTL) {
            const interimLeft = navBar.getBoundingClientRect().left;
            const firstVisibleElementIndex = elems.findIndex(elem => elem.getBoundingClientRect().left < interimLeft + buttonWidthOffset);
            if (firstVisibleElementIndex > 0) {
              const firstVisibleElementLeft = Math.abs(elems[firstVisibleElementIndex].getBoundingClientRect().right + buttonWidthOffset - navBar.getBoundingClientRect().right);
              const maxLeft = contentNode.scrollWidth - navBar.offsetWidth;
              this._currentScrollPosition = Math.min(firstVisibleElementLeft + currentScrollPosition, maxLeft);
            }
          } else {
            const interimRight = navBar.getBoundingClientRect().right;
            const firstVisibleElementIndex = elems.findIndex(elem => elem.getBoundingClientRect().right > interimRight - buttonWidthOffset);
            if (firstVisibleElementIndex > 0) {
              const firstVisibleElementLeft = elems[firstVisibleElementIndex].getBoundingClientRect().left - navBar.getBoundingClientRect().left - buttonWidthOffset;
              // Ensures that is there is no blank area at the right hand side in scroll area
              // if we see the right remainder nav items can be contained in a page
              const maxLeft = contentNode.scrollWidth - navBar.offsetWidth;
              this._currentScrollPosition = Math.min(firstVisibleElementLeft + currentScrollPosition, maxLeft);
            }
          }
        }
      }
    }, {
      kind: "method",
      key: "mediaQueryCallbackLG",
      value: function mediaQueryCallbackLG() {
        this._isMobile = !this.carbonBreakpoints.lg.matches;
      }

      /**
       * The current 0px offset from the top of page.
       */
    }, {
      kind: "field",
      decorators: [property({
        type: Number
      })],
      key: "stickyOffset",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      decorators: [HostListener('window:scroll')],
      key: "_handleScroll",
      value() {
        return event => {
          this._throttleScroll(event);
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener(`document:${c4dPrefix}-table-of-contents-reharvest`)],
      key: "_retriggerHarvest",
      value() {
        return () => {
          this._targets = Array.from(this.querySelectorAll('a[name]'));
        };
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The throttled scroll listener.
       *
       * @param event scroll handler
       */
      /**
       * The trigger reharvest listener.
       */
      function connectedCallback() {
        _superPropGet(C4DTableOfContents, "connectedCallback", this, 3)([]);
        this._cleanAndCreateIntersectionObserverContainer({
          create: true
        });
        if (!this._throttleScroll) {
          this._throttleScroll = throttle(this._handleOnScroll, 250);
          this._handleOnScroll();
        }
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this._cleanAndCreateIntersectionObserverContainer();
        this._contentMutationObserver.disconnect();
        if (this._throttleScroll) {
          this._throttleScroll.cancel();
          this._throttleScroll = null;
        }
        _superPropGet(C4DTableOfContents, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        _superPropGet(C4DTableOfContents, "firstUpdated", this, 3)([]);
        this._cleanAndCreateIntersectionObserverContainer({
          create: true
        });
        StickyHeader.global.tableOfContents = this;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          layout,
          stickyOffset,
          _currentTarget: currentTarget,
          _currentScrollPosition: currentScrollPosition,
          _hasHeading: hasHeading,
          _isIntersectionLeftTrackerInContent: isIntersectionLeftTrackerInContent,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _isMobile: isMobile,
          _targets: targets,
          _handleClickItem: handleClickItem,
          _handleOnKeyDown: handleOnKeyDown,
          _handleSlotChange: handleSlotChange,
          _handleSlotChangeHeading: handleSlotChangeHeading,
          _paginateLeft: paginateLeft,
          _paginateRight: paginateRight,
          _pageIsRTL: pageIsRTL
        } = this;
        const containerClasses = classMap({
          [`${c4dPrefix}-ce--table-of-contents__container`]: layout === TOC_TYPES.DEFAULT && !isMobile,
          [`${c4dPrefix}-ce--table-of-contents-horizontal__container`]: layout === TOC_TYPES.HORIZONTAL || isMobile
        });
        const navigationClasses = classMap({
          [`${prefix}--tableofcontents__sidebar`]: layout === TOC_TYPES.DEFAULT && !isMobile,
          [`${prefix}--tableofcontents__navbar`]: layout === TOC_TYPES.HORIZONTAL || isMobile
        });
        const chevronLeftContainerClasses = classMap({
          [`${prefix}--toc__navbar-chevron-left-container`]: true,
          [`${c4dPrefix}-ce--toc__navbar-chevron-container--hidden`]: isIntersectionLeftTrackerInContent
        });
        const chevronRightContainerClasses = classMap({
          [`${prefix}--toc__navbar-chevron-right-container`]: true,
          [`${c4dPrefix}-ce--toc__navbar-chevron-container--hidden`]: isIntersectionRightTrackerInContent
        });
        return html(_t || (_t = _`
      ${0}
      <div part="container" class="${0}">
        <div part="table" class="${0}">
          ${0}
          ${0}
          <div
            class="${0}-ce--table-of-contents__items-container"
            part="items-container"
            style="position: sticky; top: ${0}">
            <div
              class="${0}--tableofcontents-container"
              part="item-container">
              <div
                class="${0}--tableofcontents"
                part="content"
                style="${0}: -${0}px">
                ${0}
                <ul part="list">
                  ${0}
                </ul>
                ${0}
              </div>
            </div>
          </div>

          ${0}
        </div>

        <div class="${0}--tableofcontents__content" part="content-table">
          <div
            class="${0}--tableofcontents__content-wrapper"
            part="wrapper">
            ${0}
            <slot @slotchange="${0}"></slot>
          </div>
        </div>
      </div>
    `), this.layout === 'horizontal' ? html(_t2 || (_t2 = _`
            <ul class="${0}--toc__print-styles" part="list">
              ${0}
            </ul>
          `), prefix, targets.map(item => {
          var _ref, _item$dataset$title;
          const name = item.getAttribute('name');
          const title = ((_ref = (_item$dataset$title = item.dataset.title) !== null && _item$dataset$title !== void 0 ? _item$dataset$title : item.textContent) !== null && _ref !== void 0 ? _ref : '').trim();
          const selected = item === currentTarget;
          const itemClasses = classMap({
            [`${prefix}--tableofcontents__item`]: true,
            [`${prefix}--tableofcontents__item--active`]: selected
          });
          return html(_t3 || (_t3 = _`
                  <li
                    class="${0}"
                    part="list-item${0}"
                    @click="${0}"
                    @keydown="${0}">
                    <a
                      aria-current="${0}"
                      data-target="${0}"
                      href="#${0}"
                      part="link">
                      ${0}
                    </a>
                  </li>
                `), itemClasses, selected ? ' list-item--active' : '', handleClickItem, handleOnKeyDown, ifDefined(!selected ? undefined : 'location'), name, name, title);
        })) : ``, containerClasses, navigationClasses, isMobile ? '' : html(_t4 || (_t4 = _`
                <div
                  ?hidden="${0}"
                  class="${0}--tableofcontents__children"
                  part="heading">
                  <slot
                    name="heading"
                    @slotchange="${0}"></slot>
                  <slot name="menu-rule"></slot>
                </div>
              `), !hasHeading, prefix, handleSlotChangeHeading), layout === 'horizontal' || isMobile ? html(_t5 || (_t5 = _`
                ${0}
              `), pageIsRTL ? html(_t6 || (_t6 = _`
                      <button
                        part="prev-button"
                        tabindex="-1"
                        aria-hidden="true"
                        class="${0}"
                        @click="${0}">
                        ${0}
                      </button>
                    `), chevronRightContainerClasses, paginateLeft, ChevronLeft20()) : html(_t7 || (_t7 = _`
                      <button
                        part="prev-button"
                        tabindex="-1"
                        aria-hidden="true"
                        class="${0}"
                        @click="${0}">
                        ${0}
                      </button>
                    `), chevronLeftContainerClasses, paginateLeft, ChevronLeft20())) : ``, c4dPrefix, stickyOffset && this.layout !== TOC_TYPES.HORIZONTAL ? `${stickyOffset}px` : 0, prefix, prefix, pageIsRTL ? 'right' : 'left', currentScrollPosition, pageIsRTL ? html(_t8 || (_t8 = _`
                      <div
                        class="${0}--sub-content-right"
                        part="sub-content-right"></div>
                    `), prefix) : html(_t9 || (_t9 = _`
                      <div
                        class="${0}--sub-content-left"
                        part="sub-content-left"></div>
                    `), prefix), targets.map(item => {
          var _ref2, _item$dataset$title2;
          const name = item.getAttribute('name');
          const title = ((_ref2 = (_item$dataset$title2 = item.dataset.title) !== null && _item$dataset$title2 !== void 0 ? _item$dataset$title2 : item.textContent) !== null && _ref2 !== void 0 ? _ref2 : '').trim();
          const selected = item === currentTarget;
          const itemClasses = classMap({
            [`${prefix}--tableofcontents__item`]: true,
            [`${prefix}--tableofcontents__item--active`]: selected
          });
          return html(_t10 || (_t10 = _`
                      <li
                        class="${0}"
                        part="list-item${0}"
                        @click="${0}"
                        @keydown="${0}">
                        <a
                          aria-current="${0}"
                          data-target="${0}"
                          href="#${0}"
                          tabindex="${0}"
                          part="link">
                          ${0}
                        </a>
                      </li>
                    `), itemClasses, selected ? ' list-item--active' : '', handleClickItem, handleOnKeyDown, ifDefined(!selected ? undefined : 'location'), name, name, selected ? 0 : -1, title);
        }), pageIsRTL ? html(_t11 || (_t11 = _`
                      <div
                        class="${0}--sub-content-left"
                        part="sub-content-left"></div>
                    `), prefix) : html(_t12 || (_t12 = _`
                      <div
                        class="${0}--sub-content-right"
                        part="sub-content-right"></div>
                    `), prefix), this.layout === 'horizontal' || isMobile ? html(_t13 || (_t13 = _`
                ${0}
              `), pageIsRTL ? html(_t14 || (_t14 = _`
                      <button
                        part="next-button"
                        tabindex="-1"
                        aria-hidden="true"
                        class="${0}"
                        @click="${0}">
                        ${0}
                      </button>
                    `), chevronLeftContainerClasses, paginateRight, ChevronRight20()) : html(_t15 || (_t15 = _`
                      <button
                        part="next-button"
                        tabindex="-1"
                        aria-hidden="true"
                        class="${0}"
                        @click="${0}">
                        ${0}
                      </button>
                    `), chevronRightContainerClasses, paginateRight, ChevronRight20())) : ``, prefix, prefix, !isMobile ? '' : html(_t16 || (_t16 = _`
                  <div
                    ?hidden="${0}"
                    class="${0}--tableofcontents__children"
                    part="heading">
                    <slot
                      name="heading"
                      @slotchange="${0}"></slot>
                    <slot name="menu-rule"></slot>
                  </div>
                `), !hasHeading, prefix, handleSlotChangeHeading), handleSlotChange);
      }

      /**
       * The selector that selects the link items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `.${prefix}--tableofcontents__item a`;
      }

      /**
       * The selector that determines where to harvest the table of contents from.
       */
    }, {
      kind: "field",
      static: true,
      key: "selectorTarget",
      value() {
        return '[name]';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--table-of-contents`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, MediaQueryMixin(HostListenerMixin(StableSelectorMixin(LitElement)), {
  [MQBreakpoints.LG]: MQDirs.MIN
}));
/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DTableOfContents;
//# sourceMappingURL=table-of-contents.js.map
