import _decorate from "@babel/runtime/helpers/esm/decorate";
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { property } from 'lit/decorators.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import C4DTabsExtended from "../tabs-extended/tabs-extended.js";
import styles from "././tabs-extended-media.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * A component to present media content inside a tabbed layout.
 *
 * @element c4d-tabs-extended-media
 */
let C4DTabsExtendedMedia = _decorate([customElement(`${c4dPrefix}-tabs-extended-media`)], function (_initialize, _C4DTabsExtended) {
  class C4DTabsExtendedMedia extends _C4DTabsExtended {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTabsExtendedMedia,
    d: [{
      kind: "field",
      decorators: [property({
        attribute: 'section-heading',
        reflect: true
      })],
      key: "sectionHeading",
      value() {
        return 'true';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * `true` if section heading should be shown.
       */

      function () {
        return `${c4dPrefix}--tabs-extended-media`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, C4DTabsExtended);
console.warn('The tabs-extended-media component has been deprecated in favor of tabs-extended component. ' + 'See tabs-extended documentation for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DTabsExtendedMedia;
//# sourceMappingURL=tabs-extended-media.js.map
