import _decorate from "@babel/runtime/helpers/esm/decorate";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _get from "@babel/runtime/helpers/esm/get";
let _ = t => t,
  _t;
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././tag-group.css.js";
import StableSelectorMixin from "../../globals/mixins/stable-selector.js";
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
const {
  prefix,
  stablePrefix: c4dPrefix
} = settings;

/**
 * Tag Group
 *
 * @element c4d-tag-group
 */
let C4DTagGroup = _decorate([customElement(`${c4dPrefix}-tag-group`)], function (_initialize, _StableSelectorMixin) {
  class C4DTagGroup extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTagGroup,
    d: [{
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * Handler for @slotchange, ensure that the only elements being rendered are CDSTag and C4DTagLink
       *
       * @private
       */
      function _handleSlotChange(event) {
        const childItems = event.target.assignedNodes();
        const carbonTags = childItems.filter(elem => {
          var _matches, _ref;
          return (_matches = (_ref = elem).matches) === null || _matches === void 0 ? void 0 : _matches.call(_ref, this.constructor.selectorTag);
        });
        const carbonReactTags = childItems.filter(elem => {
          var _classList, _classList$contains;
          return (_classList = elem.classList) === null || _classList === void 0 || (_classList$contains = _classList.contains) === null || _classList$contains === void 0 ? void 0 : _classList$contains.call(_classList, this.constructor.selectorReactTag);
        });

        // Handle default color setting differently depending on Carbon WC or Carbon React
        carbonTags.forEach(elem => {
          if (!elem.hasAttribute('type')) {
            elem.setAttribute('type', 'green');
          }
        });
        carbonReactTags.forEach(elem => {
          if (!elem.className.split(' ').some(c => /^cds--tag--/.test(c))) {
            var _classList2;
            (_classList2 = elem.classList) === null || _classList2 === void 0 || _classList2.add(`${prefix}--tag--green`);
          }
        });
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _` <slot @slotchange="${0}"></slot> `), this._handleSlotChange);
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet(C4DTagGroup, "connectedCallback", this, 3)([]);
        this.setAttribute('role', 'list');
      }

      /**
       * A selector that will return the C4DTagLink child items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTagLink",
      value: function () {
        return `${c4dPrefix}-tag-link`;
      }

      /**
       * A selector that will return the CDSTag child items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTag",
      value: function () {
        return `${prefix}-tag`;
      }

      /**
       * A selector that will return the CDSTag child items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorReactTag",
      value: function () {
        return `${prefix}--tag`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix}--tag-group`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(LitElement));
console.warn('The tag-group component has been deprecated in favor of combing cds-tag components. ' + 'See cds-tag documentation in @carbon/web-components for more information.');

/* @__GENERATE_REACT_CUSTOM_ELEMENT_TYPE__ */
export default C4DTagGroup;
//# sourceMappingURL=tag-group.js.map
