import _decorate from "@babel/runtime/helpers/esm/decorate";
let _ = t => t,
  _t;
/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { LitElement, html } from 'lit';
import { carbonElement as customElement } from '@carbon/web-components/es/globals/decorators/carbon-element.js';
import settings from '@carbon/ibmdotcom-utilities/es/utilities/settings/settings.js';
import styles from "././tile.css.js";
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The Tile Group component.
 *
 * @element c4d-tile-group
 */
let C4DTileGroup = _decorate([customElement(`${c4dPrefix}-tile-group`)], function (_initialize, _LitElement) {
  class C4DTileGroup extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTileGroup,
    d: [{
      kind: "method",
      key: "render",
      value: function render() {
        return html(_t || (_t = _`
      <div class="${0}-tile-group">
        <slot></slot>
      </div>
    `), c4dPrefix);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, LitElement);
export default C4DTileGroup;
//# sourceMappingURL=tile-group.js.map
