/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * Formats an enum key as a user-friendly label for use in Storybook.
 *
 * @param {string} key The enum key.
 * @param {object} opts Optional configuration.
 * @param {string} opts.delimeter The character to split on.
 * @returns {string} The formatted version of the provided key.
 */
export declare const formatEnumKey: (key: any, opts?: {
    delimeter: string;
}) => any;
/**
 * Conversts a TypeScript enum into an array.
 *
 * @param en The enum to convert.
 * @returns {Array} An array containing the enum's values.
 */
export declare const enumValsToArray: (en: any) => any[];
/**
 * Converts a TypeScript enum's keys into an array of formatted labels.
 *
 * @param en The enum to convert.
 * @param {object} opts Optional configuration.
 * @param {string} opts.delimeter The character to split on.
 * @returns {Array} An array containing formatted versions of the enum's keys.
 */
export declare const enumKeysToArray: (en: any, opts?: {
    delimeter: string;
}) => any[];
/**
 * Converts an enum into a Storybook-friendly labels object.
 *
 * @param en The enum to convert.
 * @param {object} opts Optional configuration.
 * @param {string} opts.delimeter The character to split on.
 * @returns {object} An object for use in Storybook Control label config.
 */
export declare const enumToLabels: (en: any, opts?: {
    delimeter: string;
}) => {};

//# sourceMappingURL=enum-helpers.d.ts.map
