/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * This file contains the list of the default values of compile-time feature flags.
 */
/**
 * This flag will determine if all feature flags should be enabled
 *
 * @type {boolean}
 */
export declare const C4D_FLAGS_ALL: boolean;
/**
 * Enables Content Block - Headline
 *
 * @type {boolean}
 */
export declare const C4D_CONTENT_BLOCK_HEADLINES: boolean;
/**
 * Enables Content Block - Card static
 *
 * @type {boolean}
 */
export declare const C4D_CONTENT_BLOCK_CARD_STATIC: boolean;
/**
 * Enables scoped search in the Masthead search
 *
 * @type {boolean}
 */
export declare const C4D_SCOPED_SEARCH: boolean;
/**
 * Enables custom profile login url in Masthead
 *
 * @type {boolean}
 */
export declare const C4D_CUSTOM_PROFILE_LOGIN: boolean;
/**
 * Enables Pricing Table
 *
 * @type {boolean}
 */
export declare const C4D_PRICING_TABLE: boolean;

//# sourceMappingURL=feature-flags.d.ts.map
