/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * Wraps provided Storybook story in Carbon grid with no columns.
 *
 * @param story Storybook story
 * @returns {TemplateResult}
 */
export declare const gridNoCol: (story: any) => import("lit-html").TemplateResult<1>;
/**
 * Wraps provided Storybook story in Carbon grid with a single full-width column.
 *
 * @param story Storybook story
 * @returns {TemplateResult}
 */
export declare const grid16Col: (story: any) => import("lit-html").TemplateResult<1>;
/**
 * Wraps provided Storybook story in Carbon grid with a half-width, centered column.
 *
 * @param story Storybook story
 * @returns {TemplateResult}
 */
export declare const grid8ColCentered: (story: any) => import("lit-html").TemplateResult<1>;

//# sourceMappingURL=storybook-decorators.d.ts.map
