let _ = t => t,
  _t,
  _t2,
  _t3;
/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import { html } from 'lit';

/**
 * Wraps provided Storybook story in Carbon grid with no columns.
 *
 * @param story Storybook story
 * @returns {TemplateResult}
 */
export const gridNoCol = story => html(_t || (_t = _`
  <div class="cds--grid c4d-story-padding">
    <div class="cds--row">${0}</div>
  </div>
`), story instanceof Function ? story() : story);

/**
 * Wraps provided Storybook story in Carbon grid with a single full-width column.
 *
 * @param story Storybook story
 * @returns {TemplateResult}
 */
export const grid16Col = story => gridNoCol(html(_t2 || (_t2 = _` <div class="cds--col-lg-16">${0}</div> `), story()));

/**
 * Wraps provided Storybook story in Carbon grid with a half-width, centered column.
 *
 * @param story Storybook story
 * @returns {TemplateResult}
 */
export const grid8ColCentered = story => gridNoCol(html(_t3 || (_t3 = _` <div class="cds--offset-lg-4 cds--col-lg-8">${0}</div> `), story()));
//# sourceMappingURL=storybook-decorators.js.map
