/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import localeAPIReducer from './localeAPI';
import translateAPIReducer from './translateAPI';
import profileAPIReducer from './profileAPI';
export { localeAPIReducer as localeAPI, translateAPIReducer as translateAPI, profileAPIReducer as profileAPI, };
/**
 * The combined reducer for all APIs.
 */
declare const reducers: import("redux").Reducer<import("redux").CombinedState<{
    localeAPI: import("../types/localeAPI").LocaleAPIState;
    translateAPI: import("../types/translateAPI").TranslateAPIState;
    profileAPI: import("../types/profileAPI").ProfileAPIState;
    searchAPI: import("../types/searchAPI").SearchAPIState;
    kalturaPlayerAPI: import("../types/kalturaPlayerAPI").MediaPlayerAPIState;
    cloudAccountAuthAPI: import("../types/cloudAccountAuthAPI").CloudAccountAuthAPIState;
}>, import("../actions/localeAPI").LocaleAPIActions | import("../actions/translateAPI").TranslateAPIActions | import("../actions/profileAPI").ProfileAPIActions | import("../actions/searchAPI").SearchAPIActions | import("../actions/kalturaPlayerAPI").MediaPlayerAPIActions | import("../actions/cloudAccountAuthAPI").CloudAccountAuthAPIActions>;
export default reducers;

//# sourceMappingURL=index.d.ts.map
