/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2022
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */

import { SEARCH_API_ACTION } from "../types/searchAPI.js";
/**
 * @param state The state for search API.
 * @param action The action.
 * @returns The new state for search API.
 */
export default function reducer(state = {}, action) {
  switch (action.type) {
    case SEARCH_API_ACTION.SET_CURRENT_SEARCH_QUERY_STRING:
      {
        const {
          searchQueryString
        } = action;
        return {
          ...state,
          currentSearchQueryString: searchQueryString
        };
      }
    case SEARCH_API_ACTION.SET_REQUEST_SEARCH_RESULTS_IN_PROGRESS:
      {
        var _oldRequestsSearchRes, _oldRequestsSearchRes2;
        const {
          language,
          searchQueryString,
          request
        } = action;
        const {
          requestsSearchResultsInProgress: oldRequestsSearchResultsInProgress = {},
          requestsSearchResults: oldRequestsSearchResults = {}
        } = state;
        return {
          ...state,
          requestsSearchResultsInProgress: {
            ...oldRequestsSearchResultsInProgress,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes = oldRequestsSearchResultsInProgress[searchQueryString]) !== null && _oldRequestsSearchRes !== void 0 ? _oldRequestsSearchRes : {}),
              [language]: true
            }
          },
          requestsSearchResults: {
            ...oldRequestsSearchResults,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes2 = oldRequestsSearchResults[searchQueryString]) !== null && _oldRequestsSearchRes2 !== void 0 ? _oldRequestsSearchRes2 : {}),
              [language]: request
            }
          }
        };
      }
    case SEARCH_API_ACTION.SET_ERROR_REQUEST_SEARCH_RESULTS:
      {
        var _oldRequestsSearchRes3, _oldErrorsRequestSear;
        const {
          language,
          searchQueryString,
          error
        } = action;
        const {
          requestsSearchResultsInProgress: oldRequestsSearchResultsInProgress = {},
          errorsRequestSearchResults: oldErrorsRequestSearchResults = {}
        } = state;
        return {
          ...state,
          requestsSearchResultsInProgress: {
            ...oldRequestsSearchResultsInProgress,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes3 = oldRequestsSearchResultsInProgress[searchQueryString]) !== null && _oldRequestsSearchRes3 !== void 0 ? _oldRequestsSearchRes3 : {}),
              [language]: false
            }
          },
          errorsRequestSearchResults: {
            ...oldErrorsRequestSearchResults,
            [searchQueryString]: {
              ...((_oldErrorsRequestSear = oldErrorsRequestSearchResults[searchQueryString]) !== null && _oldErrorsRequestSear !== void 0 ? _oldErrorsRequestSear : {}),
              [language]: error
            }
          }
        };
      }
    case SEARCH_API_ACTION.SET_SEARCH_RESULTS:
      {
        var _oldRequestsSearchRes4, _oldRequestsSearchRes5, _oldSearchResults$sea;
        const {
          language,
          searchQueryString,
          results
        } = action;
        const {
          requestsSearchResultsInProgress: oldRequestsSearchResultsInProgress = {},
          requestsSearchResults: oldRequestsSearchResults = {},
          searchResults: oldSearchResults = {}
        } = state;
        return {
          ...state,
          requestsSearchResultsInProgress: {
            ...oldRequestsSearchResultsInProgress,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes4 = oldRequestsSearchResultsInProgress[searchQueryString]) !== null && _oldRequestsSearchRes4 !== void 0 ? _oldRequestsSearchRes4 : {}),
              [language]: false
            }
          },
          requestsSearchResults: {
            ...oldRequestsSearchResults,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes5 = oldRequestsSearchResults[searchQueryString]) !== null && _oldRequestsSearchRes5 !== void 0 ? _oldRequestsSearchRes5 : {}),
              [language]: Promise.resolve(results)
            }
          },
          searchResults: {
            ...oldSearchResults,
            [searchQueryString]: {
              ...((_oldSearchResults$sea = oldSearchResults[searchQueryString]) !== null && _oldSearchResults$sea !== void 0 ? _oldSearchResults$sea : {}),
              [language]: results
            }
          }
        };
      }
    default:
      return state;
  }
}
//# sourceMappingURL=searchAPI.js.map
