/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * @param initialState The initial state.
 * @returns The default Redux store for Carbon for IBM.com.
 */
export declare function createStore(initialState?: any): import("redux").Store<import("redux").EmptyObject & {
    localeAPI: import("./types/localeAPI").LocaleAPIState;
    translateAPI: import("./types/translateAPI").TranslateAPIState;
    profileAPI: import("./types/profileAPI").ProfileAPIState;
    searchAPI: import("./types/searchAPI").SearchAPIState;
    kalturaPlayerAPI: import("./types/kalturaPlayerAPI").MediaPlayerAPIState;
    cloudAccountAuthAPI: import("./types/cloudAccountAuthAPI").CloudAccountAuthAPIState;
}, import("./actions/localeAPI").LocaleAPIActions | import("./actions/translateAPI").TranslateAPIActions | import("./actions/profileAPI").ProfileAPIActions | import("./actions/searchAPI").SearchAPIActions | import("./actions/kalturaPlayerAPI").MediaPlayerAPIActions | import("./actions/cloudAccountAuthAPI").CloudAccountAuthAPIActions> & {
    dispatch: unknown;
};
declare const store: import("redux").Store<import("redux").EmptyObject & {
    localeAPI: import("./types/localeAPI").LocaleAPIState;
    translateAPI: import("./types/translateAPI").TranslateAPIState;
    profileAPI: import("./types/profileAPI").ProfileAPIState;
    searchAPI: import("./types/searchAPI").SearchAPIState;
    kalturaPlayerAPI: import("./types/kalturaPlayerAPI").MediaPlayerAPIState;
    cloudAccountAuthAPI: import("./types/cloudAccountAuthAPI").CloudAccountAuthAPIState;
}, import("./actions/localeAPI").LocaleAPIActions | import("./actions/translateAPI").TranslateAPIActions | import("./actions/profileAPI").ProfileAPIActions | import("./actions/searchAPI").SearchAPIActions | import("./actions/kalturaPlayerAPI").MediaPlayerAPIActions | import("./actions/cloudAccountAuthAPI").CloudAccountAuthAPIActions> & {
    dispatch: unknown;
};
export default store;

//# sourceMappingURL=store.d.ts.map
