import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import Cookies from 'js-cookie';
var _cookieName = 'activeCartId';
var SAPCommerceAPI = /*#__PURE__*/function () {
  function SAPCommerceAPI() {
    _classCallCheck(this, SAPCommerceAPI);
  }
  return _createClass(SAPCommerceAPI, null, [{
    key: "hasActiveCart",
    value:
    /**
     * Check if the user has an active cart by looking for the non-empty cookie.
     *
     * @returns {boolean}
     */
    function hasActiveCart() {
      var activeCartId = SAPCommerceAPI.getActiveCartId();
      // Return true if the activeCartId cookie is non-empty.
      return activeCartId !== '';
    }

    /**
     * Returns the active cart id.
     *
     * @returns {string}
     *   The active cart id if there is one, otherwise empty string.
     */
  }, {
    key: "getActiveCartId",
    value: function getActiveCartId() {
      var activeCartId = Cookies.get(_cookieName);
      return activeCartId && typeof activeCartId === 'string' ? activeCartId.trim() : '';
    }

    /**
     * Set the active cart id.
     *
     * @param {string} activeCartId
     *   The active cart id.
     */
  }, {
    key: "setActiveCartId",
    value: function setActiveCartId(activeCartId) {
      Cookies.set(_cookieName, activeCartId.trim());
    }

    /**
     * Remove the active cart id.
     */
  }, {
    key: "removeActiveCartId",
    value: function removeActiveCartId() {
      Cookies.remove(_cookieName);
    }
  }]);
}();
export default SAPCommerceAPI;