/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.propTypes = exports.descriptor = exports.default = void 0;
var _link = require('@carbon/web-components/es/components-react/link/link.js');
var _createReactCustomElementType = _interopRequireDefault(
  require('@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js')
);
var _propTypes = _interopRequireDefault(require('prop-types'));
var _settings = _interopRequireDefault(
  require('@carbon/ibmdotcom-utilities/lib/utilities/settings/settings.js')
);
function _interopRequireDefault(e) {
  return e && e.__esModule ? e : { default: e };
}
var prefix = _settings.default.prefix;
var c4dPrefix = _settings.default.stablePrefix;
var descriptor = (exports.descriptor = Object.assign({}, _link.descriptor, {
  onRequestAdditionalVideoData: {
    event: ''.concat(c4dPrefix, '-cta-request-additional-video-data'),
  },
  onVideoTitleUpdated: {
    event: ''.concat(c4dPrefix, '-card-video-title-updated'),
  },
}));
var propTypes = (exports.propTypes = {
  /**
   * The name of the custom event fired when there is a user gesture to run the action.
   */
  onRequestAdditionalVideoData: _propTypes.default.func,
  /**
   * The name of the custom event fired when the video title is updated
   */
  onVideoTitleUpdated: _propTypes.default.func,
});
const Component = (0, _createReactCustomElementType.default)(
  ''.concat(c4dPrefix, '-card'),
  descriptor
);
Component.propTypes = propTypes;
var _default = (exports.default = Component);
