/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.propTypes = exports.descriptor = exports.default = void 0;
var _createReactCustomElementType = _interopRequireDefault(
  require('@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js')
);
var _propTypes = _interopRequireDefault(require('prop-types'));
var _settings = _interopRequireDefault(
  require('@carbon/ibmdotcom-utilities/lib/utilities/settings/settings.js')
);
function _interopRequireDefault(e) {
  return e && e.__esModule ? e : { default: e };
}
var prefix = _settings.default.prefix;
var c4dPrefix = _settings.default.stablePrefix;
var descriptor = (exports.descriptor = {
  onCloseLightbox: {
    event: ''.concat(c4dPrefix, '-expressive-modal-closed'),
  },
  onRequestVideoData: {
    event: ''.concat(c4dPrefix, '-cta-request-video-data'),
  },
  onRunAction: {
    event: ''.concat(c4dPrefix, '-cta-run-action'),
  },
});
var propTypes = (exports.propTypes = {
  /**
   * The name of the custom event fired after the lightbox is closed upon a user gesture.
   */
  onCloseLightbox: _propTypes.default.func,
  /**
   * The name of the custom event fired when there is a user gesture to run the action.
   */
  onRequestVideoData: _propTypes.default.func,
  /**
   * The name of the custom event fired when there is a user gesture to run the action.
   */
  onRunAction: _propTypes.default.func,
});
const Component = (0, _createReactCustomElementType.default)(
  ''.concat(c4dPrefix, '-video-cta-composite'),
  descriptor
);
Component.propTypes = propTypes;
var _default = (exports.default = Component);
