/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.propTypes = exports.descriptor = exports.default = void 0;
var _createReactCustomElementType = _interopRequireDefault(
  require('@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js')
);
var _propTypes = _interopRequireDefault(require('prop-types'));
var _settings = _interopRequireDefault(
  require('@carbon/ibmdotcom-utilities/lib/utilities/settings/settings.js')
);
function _interopRequireDefault(e) {
  return e && e.__esModule ? e : { default: e };
}
var prefix = _settings.default.prefix;
var c4dPrefix = _settings.default.stablePrefix;
var descriptor = (exports.descriptor = {
  onCheckboxSelect: {
    event: ''.concat(c4dPrefix, '-checkbox-select'),
  },
  onInputSelectItem: {
    event: ''.concat(c4dPrefix, '-filter-panel-input-select'),
  },
  onFilterGroupViewAllToggle: {
    event: ''.concat(c4dPrefix, '-filter-group-view-all-toggle'),
  },
  onModalClose: {
    event: ''.concat(prefix, '-modal-beingclosed'),
  },
  onInputSelect: {
    event: ''.concat(c4dPrefix, '-filter-panel-input-select-title'),
  },
  onSelectionClear: {
    event: ''.concat(c4dPrefix, '-selection-clear'),
  },
  onHeadingChange: {
    event: ''.concat(c4dPrefix, '-filter-panel-heading-change'),
  },
});
var propTypes = (exports.propTypes = {
  /**
   * The name of the custom event captured upon selecting a checkbox
   */
  onCheckboxSelect: _propTypes.default.func,
  /**
   * The name of the custom event captured upon selecting an input select item.
   */
  onInputSelectItem: _propTypes.default.func,
  /**
   * The name of the custom event captured upon activating "view all" button in
   * a filter group item
   */
  onFilterGroupViewAllToggle: _propTypes.default.func,
  /**
   * The name of the custom event captured upon closing the modal
   */
  onModalClose: _propTypes.default.func,
  /**
   * The name of the custom event capture upon selecting an input select item
   */
  onInputSelect: _propTypes.default.func,
  /**
   * The name of the custom event fired to clear selections
   */
  onSelectionClear: _propTypes.default.func,
  /**
   * The name of the custom event capture when the heading changes
   */
  onHeadingChange: _propTypes.default.func,
});
const Component = (0, _createReactCustomElementType.default)(
  ''.concat(c4dPrefix, '-filter-panel-composite'),
  descriptor
);
Component.propTypes = propTypes;
var _default = (exports.default = Component);
