/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.propTypes = exports.descriptor = exports.default = void 0;
var _expressiveModal = require('../expressive-modal/expressive-modal.js');
var _createReactCustomElementType = _interopRequireDefault(
  require('@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js')
);
var _propTypes = _interopRequireDefault(require('prop-types'));
var _settings = _interopRequireDefault(
  require('@carbon/ibmdotcom-utilities/lib/utilities/settings/settings.js')
);
function _interopRequireDefault(e) {
  return e && e.__esModule ? e : { default: e };
}
var prefix = _settings.default.prefix;
var c4dPrefix = _settings.default.stablePrefix;
var descriptor = (exports.descriptor = Object.assign(
  {},
  _expressiveModal.descriptor,
  {
    onBeforeClose: {
      event: ''.concat(prefix, '-modal-beingclosed'),
    },
    onSelectionClear: {
      event: ''.concat(c4dPrefix, '-selection-clear'),
    },
  }
));
var propTypes = (exports.propTypes = {
  /**
   * The name of the custom event fired upon the modal being closed
   */
  onBeforeClose: _propTypes.default.func,
  /**
   * The name of the custom event captured upon cleared selections
   */
  onSelectionClear: _propTypes.default.func,
});
const Component = (0, _createReactCustomElementType.default)(
  ''.concat(c4dPrefix, '-filter-panel-modal'),
  descriptor
);
Component.propTypes = propTypes;
var _default = (exports.default = Component);
