/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
Object.defineProperty(exports, 'DROPDOWN_COLOR_SCHEME', {
  enumerable: true,
  get: function () {
    return _defs.DROPDOWN_COLOR_SCHEME;
  },
});
Object.defineProperty(exports, 'DROPDOWN_SIZE', {
  enumerable: true,
  get: function () {
    return _defs.DROPDOWN_SIZE;
  },
});
Object.defineProperty(exports, 'DROPDOWN_TYPE', {
  enumerable: true,
  get: function () {
    return _dropdown.DROPDOWN_TYPE;
  },
});
exports.propTypes = exports.descriptor = exports.default = void 0;
var _dropdown = require('@carbon/web-components/es/components/dropdown/dropdown.js');
var _defs = require('../footer/defs.js');
var _dropdown2 = require('@carbon/web-components/es/components-react/dropdown/dropdown.js');
var _createReactCustomElementType = _interopRequireDefault(
  require('@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js')
);
var _propTypes = _interopRequireDefault(require('prop-types'));
var _settings = _interopRequireDefault(
  require('@carbon/ibmdotcom-utilities/lib/utilities/settings/settings.js')
);
function _interopRequireDefault(e) {
  return e && e.__esModule ? e : { default: e };
}
var prefix = _settings.default.prefix;
var c4dPrefix = _settings.default.stablePrefix;
var descriptor = (exports.descriptor = Object.assign(
  {},
  _dropdown2.descriptor,
  {
    onSelect: {
      event: ''.concat(prefix, '-select-selected'),
    },
  }
));
var propTypes = (exports.propTypes = {
  /**
   * The name of the custom event captured to retrieve the new search scope.
   */
  onSelect: _propTypes.default.func,
});
const Component = (0, _createReactCustomElementType.default)(
  ''.concat(c4dPrefix, '-scoped-search-dropdown'),
  descriptor
);
Component.propTypes = propTypes;
var _default = (exports.default = Component);
