/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.propTypes = exports.descriptor = exports.default = void 0;
var _dropdown = require('@carbon/web-components/es/components-react/dropdown/dropdown.js');
var _createReactCustomElementType = _interopRequireDefault(
  require('@carbon/web-components/es/globals/wrappers/createReactCustomElementType.js')
);
var _propTypes = _interopRequireDefault(require('prop-types'));
var _settings = _interopRequireDefault(
  require('@carbon/ibmdotcom-utilities/lib/utilities/settings/settings.js')
);
function _interopRequireDefault(e) {
  return e && e.__esModule ? e : { default: e };
}
var prefix = _settings.default.prefix;
var c4dPrefix = _settings.default.stablePrefix;
var descriptor = (exports.descriptor = Object.assign({}, _dropdown.descriptor, {
  onBeforeRedirect: {
    event: ''.concat(c4dPrefix, '-search-with-typeahead-beingredirected'),
  },
  onInput: {
    event: ''.concat(c4dPrefix, '-search-with-typeahead-input'),
  },
  onSelectScope: {
    event: ''.concat(prefix, '-select-selected'),
  },
  onCustomResults: {
    event: ''.concat(c4dPrefix, '-custom-typeahead-api-results'),
  },
  onToggle: {
    event: ''.concat(c4dPrefix, '-search-with-typeahead-toggled'),
  },
}));
var propTypes = (exports.propTypes = {
  /**
   * The name of the custom event fired before the page is being redirected to the search result page.
   * Cancellation of this event stops the user-initiated action of redirection.
   */
  onBeforeRedirect: _propTypes.default.func,
  /**
   * The name of the custom event fired after the search content is changed upon a user gesture.
   */
  onInput: _propTypes.default.func,
  /**
   * The name of the custom event captured to retrieve the new search scope.
   */
  onSelectScope: _propTypes.default.func,
  /**
   * The name of the custom event captured to retrieve the custom typeahead API results.
   */
  onCustomResults: _propTypes.default.func,
  /**
   * The name of the custom event fired after this search box is toggled upon a user gesture.
   */
  onToggle: _propTypes.default.func,
});
const Component = (0, _createReactCustomElementType.default)(
  ''.concat(c4dPrefix, '-search-with-typeahead'),
  descriptor
);
Component.propTypes = propTypes;
var _default = (exports.default = Component);
