"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME = exports.MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME = exports.MEGAMENU_LAYOUT_SCHEME = exports.L1_CTA_TYPES = void 0;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * The style scheme for the megamenu link with icon.
 */
let MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME = exports.MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME = void 0;
/**
 * The style scheme for the right navigation.
 */
(function (MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME) {
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["VIEW_ALL"] = "view-all";
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["CATEGORY_HEADLINE"] = "category-headline";
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["CATEGORY_SUBLINK"] = "category-sublink";
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["DEFAULT"] = "default";
})(MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME || (exports.MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME = MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME = {}));
let MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME = exports.MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME = void 0;
/**
 * The layout options for rendering a megamenu
 */
(function (MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME) {
  MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME["FULL"] = "full";
  MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME["HAS_SIDEBAR"] = "has-sidebar";
})(MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME || (exports.MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME = MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME = {}));
let MEGAMENU_LAYOUT_SCHEME = exports.MEGAMENU_LAYOUT_SCHEME = void 0;
/**
 * Matches CMaaS's CTA options.
 *
 * @see https://github.ibm.com/live-advisor/cm-app/blob/master/docs/cm-doc.md#calls-to-action
 */
(function (MEGAMENU_LAYOUT_SCHEME) {
  MEGAMENU_LAYOUT_SCHEME["TAB"] = "tab";
  MEGAMENU_LAYOUT_SCHEME["LIST"] = "list";
})(MEGAMENU_LAYOUT_SCHEME || (exports.MEGAMENU_LAYOUT_SCHEME = MEGAMENU_LAYOUT_SCHEME = {}));
let L1_CTA_TYPES = exports.L1_CTA_TYPES = void 0;
(function (L1_CTA_TYPES) {
  L1_CTA_TYPES["NONE"] = "";
  L1_CTA_TYPES["CONTACT_US"] = "contact";
  L1_CTA_TYPES["CHAT_NOW"] = "chat";
  L1_CTA_TYPES["EMAIL_US"] = "email";
  L1_CTA_TYPES["CALL_US"] = "phone";
  L1_CTA_TYPES["BOOK_A_CONSULTATION"] = "scheduler";
  L1_CTA_TYPES["REQUEST_A_DEMO"] = "demo";
  L1_CTA_TYPES["REQUEST_A_QUOTE"] = "quote";
})(L1_CTA_TYPES || (exports.L1_CTA_TYPES = L1_CTA_TYPES = {}));
//# sourceMappingURL=defs.js.map
