"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createStore = createStore;
exports.default = void 0;
var _windowOrGlobal = _interopRequireDefault(require("window-or-global"));
var _redux = require("redux");
var _reduxThunk = _interopRequireDefault(require("redux-thunk"));
var _reduxLogger = require("redux-logger");
var _index = _interopRequireDefault(require("./reducers/index.js"));
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

const middlewares = [_reduxThunk.default];
if (process.env.NODE_ENV === 'development') {
  middlewares.push((0, _reduxLogger.createLogger)());
}

/**
 * @param initialState The initial state.
 * @returns The default Redux store for Carbon for IBM.com.
 */
function createStore(initialState = _windowOrGlobal.default.__PRELOADED_STATE__) {
  return (0, _redux.createStore)(_index.default, initialState !== null && initialState !== void 0 ? initialState : {}, (0, _redux.applyMiddleware)(...middlewares));
}
const store = createStore();
var _default = exports.default = store;
//# sourceMappingURL=store.js.map
