"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UNAUTHENTICATED_STATUS = exports.PROFILE_API_ACTION = exports.MASTHEAD_AUTH_METHOD = exports.CLOUD_UNAUTHENTICATED_STATUS = void 0;
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The user authentication status, etc.
 */

/**
 * Unauthenticated user status
 */
const UNAUTHENTICATED_STATUS = exports.UNAUTHENTICATED_STATUS = 'Unauthenticated';

/**
 * Cloud Unauthenticated user status
 */
const CLOUD_UNAUTHENTICATED_STATUS = exports.CLOUD_UNAUTHENTICATED_STATUS = 'anonymous';

/**
 * The Redux action ID for `ProfileAPI`.
 */
let PROFILE_API_ACTION = exports.PROFILE_API_ACTION = void 0;
/**
 * Authentication status types.
 */
(function (PROFILE_API_ACTION) {
  PROFILE_API_ACTION["SET_REQUEST_USER_STATUS_IN_PROGRESS"] = "SET_REQUEST_USER_STATUS_IN_PROGRESS";
  PROFILE_API_ACTION["SET_ERROR_REQUEST_USER_STATUS"] = "SET_ERROR_REQUEST_USER_STATUS";
  PROFILE_API_ACTION["SET_USER_STATUS"] = "SET_USER_STATUS";
})(PROFILE_API_ACTION || (exports.PROFILE_API_ACTION = PROFILE_API_ACTION = {}));
let MASTHEAD_AUTH_METHOD = exports.MASTHEAD_AUTH_METHOD = void 0;
/**
 * A Redux substate for `ProfileAPI`.
 */
(function (MASTHEAD_AUTH_METHOD) {
  MASTHEAD_AUTH_METHOD["DEFAULT"] = "profile-api";
  MASTHEAD_AUTH_METHOD["COOKIE"] = "cookie";
  MASTHEAD_AUTH_METHOD["DOCS_API"] = "docs-api";
})(MASTHEAD_AUTH_METHOD || (exports.MASTHEAD_AUTH_METHOD = MASTHEAD_AUTH_METHOD = {}));
//# sourceMappingURL=profileAPI.js.map
