"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _jsCookie = _interopRequireDefault(require("js-cookie"));
/**
 * @license
 *
 * Copyright IBM Corp. 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

var _cookieName = 'activeCartId';
var SAPCommerceAPI = /*#__PURE__*/function () {
  function SAPCommerceAPI() {
    (0, _classCallCheck2.default)(this, SAPCommerceAPI);
  }
  return (0, _createClass2.default)(SAPCommerceAPI, null, [{
    key: "hasActiveCart",
    value:
    /**
     * Check if the user has an active cart by looking for the non-empty cookie.
     *
     * @returns {boolean}
     */
    function hasActiveCart() {
      var activeCartId = SAPCommerceAPI.getActiveCartId();
      // Return true if the activeCartId cookie is non-empty.
      return activeCartId !== '';
    }

    /**
     * Returns the active cart id.
     *
     * @returns {string}
     *   The active cart id if there is one, otherwise empty string.
     */
  }, {
    key: "getActiveCartId",
    value: function getActiveCartId() {
      var activeCartId = _jsCookie.default.get(_cookieName);
      return activeCartId && typeof activeCartId === 'string' ? activeCartId.trim() : '';
    }

    /**
     * Set the active cart id.
     *
     * @param {string} activeCartId
     *   The active cart id.
     */
  }, {
    key: "setActiveCartId",
    value: function setActiveCartId(activeCartId) {
      _jsCookie.default.set(_cookieName, activeCartId.trim());
    }

    /**
     * Remove the active cart id.
     */
  }, {
    key: "removeActiveCartId",
    value: function removeActiveCartId() {
      _jsCookie.default.remove(_cookieName);
    }
  }]);
}();
var _default = exports.default = SAPCommerceAPI;