"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _deprecate = _interopRequireDefault(require("@carbon/ibmdotcom-utilities/lib/utilities/deprecate/deprecate.js"));
var _KalturaPlayer = _interopRequireDefault(require("../KalturaPlayer/KalturaPlayer"));
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); } /**
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * @deprecated in favor of KalturaPlayerAPI
 * VideoPlayerAPI class with methods of checking script state and
 * embed video meta data and api data
 *
 * In order to set the Partner ID/UIConf ID, set the following environment
 * variables:
 *
 * - KALTURA_PARTNER_ID (or REACT_APP_KALTURA_PARTNER_ID)
 * - KALTURA_UICONF_ID (or REACT_APP_KALTURA_UICONF_ID)
 */
var VideoPlayerAPI = /*#__PURE__*/function (_KalturaPlayerAPI) {
  function VideoPlayerAPI() {
    (0, _classCallCheck2.default)(this, VideoPlayerAPI);
    return _callSuper(this, VideoPlayerAPI, arguments);
  }
  (0, _inherits2.default)(VideoPlayerAPI, _KalturaPlayerAPI);
  return (0, _createClass2.default)(VideoPlayerAPI, null, [{
    key: "embedVideo",
    value: (
    /**
     * Gets the embed meta data
     *
     * @param {string} videoId  The videoId we're embedding the placeholder for.
     * @param {string} targetId The targetId the ID where we're putting the placeholder.
     * @param {boolean} autoPlay Determine whether to autoplay on load of video.
     * @returns {object}  object
     * @example
     * import { VideoPlayerAPI } from '@carbon/ibmdotcom-services';
     *
     * function embedMyVideo() {
     *   const elem = document.getElementById('foo');
     *   const videoid = '12345';
     *   VideoPlayerAPI.embedVideo(videoid, elem);
     * }
     */
    function () {
      var _embedVideo = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(videoId, targetId, autoPlay) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _KalturaPlayer.default.embedMedia(videoId, targetId, autoPlay);
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function embedVideo(_x, _x2, _x3) {
        return _embedVideo.apply(this, arguments);
      }
      return embedVideo;
    }()
    /**
     * Convert media duration from milliseconds and seconds to HH:MM:SS
     *
     * @param {string} duration video duration in milliseconds
     * @param {boolean} fromMilliseconds the duration argument is expressed in milliseconds rather than seconds
     * @returns {string} converted duration
     */
    )
  }, {
    key: "getVideoDuration",
    value: function getVideoDuration(duration, fromMilliseconds) {
      return _KalturaPlayer.default.getMediaDuration(duration, fromMilliseconds);
    }
  }]);
}(_KalturaPlayer.default);
var _default = exports.default = (0, _deprecate.default)(VideoPlayerAPI, 'The VideoPlayerAPI service has been deprecated in favor of the KalturaPlayerAPI service.');