/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * @license
 * 
 * This bundle contains the following third-party dependencies:
 * 
 * @carbon/web-components:
 * 
 * @license
 *
 * Copyright IBM Corp. 2019, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 * 
 * lit-element:
 * 
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 * 
 * lit-html:
 * 
 * @license
 * Copyright 2022 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 * 
 * @lit/reactive-element:
 * 
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 * 
 * @carbon/motion:
 * 
 * Copyright IBM Corp. 2018, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 * 
 * @carbon/layout:
 * 
 * Copyright IBM Corp. 2018, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 * 
 * @babel/runtime:
 * 
 regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE
 * 
 * js-cookie:
 * 
 * JavaScript Cookie v2.2.1
 * https://github.com/js-cookie/js-cookie
 *
 * Copyright 2006, 2015 Klaus Hartl & Fagner Brack
 * Released under the MIT license
 * 
 * marked:
 * 
 * marked v4.3.0 - a markdown parser
 * Copyright (c) 2011-2023, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/markedjs/marked
 * 
 * dompurify:
 * 
 @license DOMPurify 3.2.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.2.5/LICENSE
 * 
 * Also refer to the following links for the license of other third-party dependencies:
 * 
 * https://www.npmjs.com/package/lit
 * https://www.npmjs.com/package/redux
 * https://www.npmjs.com/package/lodash-es
 * https://www.npmjs.com/package/window-or-global
 * https://www.npmjs.com/package/redux-thunk
 * https://www.npmjs.com/package/redux-logger
 * https://www.npmjs.com/package/axios
 * https://www.npmjs.com/package/isomorphic-dompurify
 * https://www.npmjs.com/package/striptags
 */

let process = { env: {} };
/**
 * Copyright IBM Corp. 2020, 2025
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Global settings
 *
 * @exports ibmdotcom.settings
 * @type {object} Settings object
 * @property {string} [stablePrefix=c4d] stable prefix
 * @property {string} [prefix=cds] core Carbon prefix
 * Carbon for IBM.com v2.25.0',
 */
var settings = {
  version: 'Carbon for IBM.com v2.25.0',
  stablePrefix: 'c4d',
  prefix: 'cds'
};

function _defineProperty$f(e, r, t) { return (r = _toPropertyKey$15(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey$15(t) { var i = _toPrimitive$15(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$15(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param store A redux store.
 * @returns A function that takes a base class and returns a mix-in that connects the component to Redux store.
 */
const ConnectMixin = (store, mapStateToProps, mapDispatchToProps = () => ({})) => Base => {
  class ConnectMixinImpl extends Base {
    _handleChangeStoreState(state) {
      const props = mapStateToProps(state, this);
      Object.keys(props).forEach(name => {
        const old = this[name];
        const current = props[name];
        if (!Object.is(old, current)) {
          this[name] = current;
          // TODO: Figure out how to make this mix-in type-defined as `LitElement` inheritance
          this.requestUpdate(name, old);
        }
      });
    }
    constructor(...args) {
      super(...args);
      /**
       * The handle for subscribing the Redux store.
       */
      _defineProperty$f(this, "_hStore", null);
      Object.assign(this, mapDispatchToProps(store.dispatch));
    }
    connectedCallback() {
      // TS seems to miss `HTMLElement.prototype.connectedCallback()` definition
      // @ts-ignore
      super.connectedCallback();
      this._handleChangeStoreState(store.getState());
      const unsubscribe = store.subscribe(() => this._handleChangeStoreState(store.getState()));
      this._hStore = {
        release() {
          unsubscribe();
          return null;
        }
      };
    }
    disconnectedCallback() {
      if (this._hStore) {
        this._hStore = this._hStore.release();
      }
      // TS seems to miss `HTMLElement.prototype.connectedCallback()` definition
      // @ts-ignore
      super.disconnectedCallback();
    }
  }
  return ConnectMixinImpl;
};

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var lib = (typeof self === 'object' && self.self === self && self) ||
  (typeof commonjsGlobal === 'object' && commonjsGlobal.global === commonjsGlobal && commonjsGlobal) ||
  commonjsGlobal;

function _typeof$3(o) {
  "@babel/helpers - typeof";

  return _typeof$3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof$3(o);
}

function toPrimitive$1(t, r) {
  if ("object" != _typeof$3(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof$3(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey$1(t) {
  var i = toPrimitive$1(t, "string");
  return "symbol" == _typeof$3(i) ? i : i + "";
}

function _defineProperty$e(e, r, t) {
  return (r = toPropertyKey$1(r)) in e ? Object.defineProperty(e, r, {
    value: t,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : e[r] = t, e;
}

function ownKeys$9(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function (r) {
      return Object.getOwnPropertyDescriptor(e, r).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys$9(Object(t), !0).forEach(function (r) {
      _defineProperty$e(e, r, t[r]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$9(Object(t)).forEach(function (r) {
      Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
    });
  }
  return e;
}

// Inlined version of the `symbol-observable` polyfill
var $$observable = (function () {
  return typeof Symbol === 'function' && Symbol.observable || '@@observable';
})();

/**
 * These are private action types reserved by Redux.
 * For any unknown actions, you must return the current state.
 * If the current state is undefined, you must return the initial state.
 * Do not reference these action types directly in your code.
 */
var randomString = function randomString() {
  return Math.random().toString(36).substring(7).split('').join('.');
};

var ActionTypes = {
  INIT: "@@redux/INIT" + randomString(),
  REPLACE: "@@redux/REPLACE" + randomString(),
  PROBE_UNKNOWN_ACTION: function PROBE_UNKNOWN_ACTION() {
    return "@@redux/PROBE_UNKNOWN_ACTION" + randomString();
  }
};

/**
 * @param {any} obj The object to inspect.
 * @returns {boolean} True if the argument appears to be a plain object.
 */
function isPlainObject$1(obj) {
  if (typeof obj !== 'object' || obj === null) return false;
  var proto = obj;

  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }

  return Object.getPrototypeOf(obj) === proto;
}

// Inlined / shortened version of `kindOf` from https://github.com/jonschlinkert/kind-of
function miniKindOf(val) {
  if (val === void 0) return 'undefined';
  if (val === null) return 'null';
  var type = typeof val;

  switch (type) {
    case 'boolean':
    case 'string':
    case 'number':
    case 'symbol':
    case 'function':
      {
        return type;
      }
  }

  if (Array.isArray(val)) return 'array';
  if (isDate$1(val)) return 'date';
  if (isError(val)) return 'error';
  var constructorName = ctorName(val);

  switch (constructorName) {
    case 'Symbol':
    case 'Promise':
    case 'WeakMap':
    case 'WeakSet':
    case 'Map':
    case 'Set':
      return constructorName;
  } // other


  return type.slice(8, -1).toLowerCase().replace(/\s/g, '');
}

function ctorName(val) {
  return typeof val.constructor === 'function' ? val.constructor.name : null;
}

function isError(val) {
  return val instanceof Error || typeof val.message === 'string' && val.constructor && typeof val.constructor.stackTraceLimit === 'number';
}

function isDate$1(val) {
  if (val instanceof Date) return true;
  return typeof val.toDateString === 'function' && typeof val.getDate === 'function' && typeof val.setDate === 'function';
}

function kindOf$1(val) {
  var typeOfVal = typeof val;

  {
    typeOfVal = miniKindOf(val);
  }

  return typeOfVal;
}

/**
 * @deprecated
 *
 * **We recommend using the `configureStore` method
 * of the `@reduxjs/toolkit` package**, which replaces `createStore`.
 *
 * Redux Toolkit is our recommended approach for writing Redux logic today,
 * including store setup, reducers, data fetching, and more.
 *
 * **For more details, please read this Redux docs page:**
 * **https://redux.js.org/introduction/why-rtk-is-redux-today**
 *
 * `configureStore` from Redux Toolkit is an improved version of `createStore` that
 * simplifies setup and helps avoid common bugs.
 *
 * You should not be using the `redux` core package by itself today, except for learning purposes.
 * The `createStore` method from the core `redux` package will not be removed, but we encourage
 * all users to migrate to using Redux Toolkit for all Redux code.
 *
 * If you want to use `createStore` without this visual deprecation warning, use
 * the `legacy_createStore` import instead:
 *
 * `import { legacy_createStore as createStore} from 'redux'`
 *
 */

function createStore$1(reducer, preloadedState, enhancer) {
  var _ref2;

  if (typeof preloadedState === 'function' && typeof enhancer === 'function' || typeof enhancer === 'function' && typeof arguments[3] === 'function') {
    throw new Error('It looks like you are passing several store enhancers to ' + 'createStore(). This is not supported. Instead, compose them ' + 'together to a single function. See https://redux.js.org/tutorials/fundamentals/part-4-store#creating-a-store-with-enhancers for an example.');
  }

  if (typeof preloadedState === 'function' && typeof enhancer === 'undefined') {
    enhancer = preloadedState;
    preloadedState = undefined;
  }

  if (typeof enhancer !== 'undefined') {
    if (typeof enhancer !== 'function') {
      throw new Error("Expected the enhancer to be a function. Instead, received: '" + kindOf$1(enhancer) + "'");
    }

    return enhancer(createStore$1)(reducer, preloadedState);
  }

  if (typeof reducer !== 'function') {
    throw new Error("Expected the root reducer to be a function. Instead, received: '" + kindOf$1(reducer) + "'");
  }

  var currentReducer = reducer;
  var currentState = preloadedState;
  var currentListeners = [];
  var nextListeners = currentListeners;
  var isDispatching = false;
  /**
   * This makes a shallow copy of currentListeners so we can use
   * nextListeners as a temporary list while dispatching.
   *
   * This prevents any bugs around consumers calling
   * subscribe/unsubscribe in the middle of a dispatch.
   */

  function ensureCanMutateNextListeners() {
    if (nextListeners === currentListeners) {
      nextListeners = currentListeners.slice();
    }
  }
  /**
   * Reads the state tree managed by the store.
   *
   * @returns {any} The current state tree of your application.
   */


  function getState() {
    if (isDispatching) {
      throw new Error('You may not call store.getState() while the reducer is executing. ' + 'The reducer has already received the state as an argument. ' + 'Pass it down from the top reducer instead of reading it from the store.');
    }

    return currentState;
  }
  /**
   * Adds a change listener. It will be called any time an action is dispatched,
   * and some part of the state tree may potentially have changed. You may then
   * call `getState()` to read the current state tree inside the callback.
   *
   * You may call `dispatch()` from a change listener, with the following
   * caveats:
   *
   * 1. The subscriptions are snapshotted just before every `dispatch()` call.
   * If you subscribe or unsubscribe while the listeners are being invoked, this
   * will not have any effect on the `dispatch()` that is currently in progress.
   * However, the next `dispatch()` call, whether nested or not, will use a more
   * recent snapshot of the subscription list.
   *
   * 2. The listener should not expect to see all state changes, as the state
   * might have been updated multiple times during a nested `dispatch()` before
   * the listener is called. It is, however, guaranteed that all subscribers
   * registered before the `dispatch()` started will be called with the latest
   * state by the time it exits.
   *
   * @param {Function} listener A callback to be invoked on every dispatch.
   * @returns {Function} A function to remove this change listener.
   */


  function subscribe(listener) {
    if (typeof listener !== 'function') {
      throw new Error("Expected the listener to be a function. Instead, received: '" + kindOf$1(listener) + "'");
    }

    if (isDispatching) {
      throw new Error('You may not call store.subscribe() while the reducer is executing. ' + 'If you would like to be notified after the store has been updated, subscribe from a ' + 'component and invoke store.getState() in the callback to access the latest state. ' + 'See https://redux.js.org/api/store#subscribelistener for more details.');
    }

    var isSubscribed = true;
    ensureCanMutateNextListeners();
    nextListeners.push(listener);
    return function unsubscribe() {
      if (!isSubscribed) {
        return;
      }

      if (isDispatching) {
        throw new Error('You may not unsubscribe from a store listener while the reducer is executing. ' + 'See https://redux.js.org/api/store#subscribelistener for more details.');
      }

      isSubscribed = false;
      ensureCanMutateNextListeners();
      var index = nextListeners.indexOf(listener);
      nextListeners.splice(index, 1);
      currentListeners = null;
    };
  }
  /**
   * Dispatches an action. It is the only way to trigger a state change.
   *
   * The `reducer` function, used to create the store, will be called with the
   * current state tree and the given `action`. Its return value will
   * be considered the **next** state of the tree, and the change listeners
   * will be notified.
   *
   * The base implementation only supports plain object actions. If you want to
   * dispatch a Promise, an Observable, a thunk, or something else, you need to
   * wrap your store creating function into the corresponding middleware. For
   * example, see the documentation for the `redux-thunk` package. Even the
   * middleware will eventually dispatch plain object actions using this method.
   *
   * @param {Object} action A plain object representing “what changed”. It is
   * a good idea to keep actions serializable so you can record and replay user
   * sessions, or use the time travelling `redux-devtools`. An action must have
   * a `type` property which may not be `undefined`. It is a good idea to use
   * string constants for action types.
   *
   * @returns {Object} For convenience, the same action object you dispatched.
   *
   * Note that, if you use a custom middleware, it may wrap `dispatch()` to
   * return something else (for example, a Promise you can await).
   */


  function dispatch(action) {
    if (!isPlainObject$1(action)) {
      throw new Error("Actions must be plain objects. Instead, the actual type was: '" + kindOf$1(action) + "'. You may need to add middleware to your store setup to handle dispatching other values, such as 'redux-thunk' to handle dispatching functions. See https://redux.js.org/tutorials/fundamentals/part-4-store#middleware and https://redux.js.org/tutorials/fundamentals/part-6-async-logic#using-the-redux-thunk-middleware for examples.");
    }

    if (typeof action.type === 'undefined') {
      throw new Error('Actions may not have an undefined "type" property. You may have misspelled an action type string constant.');
    }

    if (isDispatching) {
      throw new Error('Reducers may not dispatch actions.');
    }

    try {
      isDispatching = true;
      currentState = currentReducer(currentState, action);
    } finally {
      isDispatching = false;
    }

    var listeners = currentListeners = nextListeners;

    for (var i = 0; i < listeners.length; i++) {
      var listener = listeners[i];
      listener();
    }

    return action;
  }
  /**
   * Replaces the reducer currently used by the store to calculate the state.
   *
   * You might need this if your app implements code splitting and you want to
   * load some of the reducers dynamically. You might also need this if you
   * implement a hot reloading mechanism for Redux.
   *
   * @param {Function} nextReducer The reducer for the store to use instead.
   * @returns {void}
   */


  function replaceReducer(nextReducer) {
    if (typeof nextReducer !== 'function') {
      throw new Error("Expected the nextReducer to be a function. Instead, received: '" + kindOf$1(nextReducer));
    }

    currentReducer = nextReducer; // This action has a similiar effect to ActionTypes.INIT.
    // Any reducers that existed in both the new and old rootReducer
    // will receive the previous state. This effectively populates
    // the new state tree with any relevant data from the old one.

    dispatch({
      type: ActionTypes.REPLACE
    });
  }
  /**
   * Interoperability point for observable/reactive libraries.
   * @returns {observable} A minimal observable of state changes.
   * For more information, see the observable proposal:
   * https://github.com/tc39/proposal-observable
   */


  function observable() {
    var _ref;

    var outerSubscribe = subscribe;
    return _ref = {
      /**
       * The minimal observable subscription method.
       * @param {Object} observer Any object that can be used as an observer.
       * The observer object should have a `next` method.
       * @returns {subscription} An object with an `unsubscribe` method that can
       * be used to unsubscribe the observable from the store, and prevent further
       * emission of values from the observable.
       */
      subscribe: function subscribe(observer) {
        if (typeof observer !== 'object' || observer === null) {
          throw new Error("Expected the observer to be an object. Instead, received: '" + kindOf$1(observer) + "'");
        }

        function observeState() {
          if (observer.next) {
            observer.next(getState());
          }
        }

        observeState();
        var unsubscribe = outerSubscribe(observeState);
        return {
          unsubscribe: unsubscribe
        };
      }
    }, _ref[$$observable] = function () {
      return this;
    }, _ref;
  } // When a store is created, an "INIT" action is dispatched so that every
  // reducer returns their initial state. This effectively populates
  // the initial state tree.


  dispatch({
    type: ActionTypes.INIT
  });
  return _ref2 = {
    dispatch: dispatch,
    subscribe: subscribe,
    getState: getState,
    replaceReducer: replaceReducer
  }, _ref2[$$observable] = observable, _ref2;
}

/**
 * Prints a warning in the console if it exists.
 *
 * @param {String} message The warning message.
 * @returns {void}
 */
function warning(message) {
  /* eslint-disable no-console */
  if (typeof console !== 'undefined' && typeof console.error === 'function') {
    console.error(message);
  }
  /* eslint-enable no-console */


  try {
    // This error was thrown as a convenience so that if you enable
    // "break on all exceptions" in your console,
    // it would pause the execution at this line.
    throw new Error(message);
  } catch (e) {} // eslint-disable-line no-empty

}

function getUnexpectedStateShapeWarningMessage(inputState, reducers, action, unexpectedKeyCache) {
  var reducerKeys = Object.keys(reducers);
  var argumentName = action && action.type === ActionTypes.INIT ? 'preloadedState argument passed to createStore' : 'previous state received by the reducer';

  if (reducerKeys.length === 0) {
    return 'Store does not have a valid reducer. Make sure the argument passed ' + 'to combineReducers is an object whose values are reducers.';
  }

  if (!isPlainObject$1(inputState)) {
    return "The " + argumentName + " has unexpected type of \"" + kindOf$1(inputState) + "\". Expected argument to be an object with the following " + ("keys: \"" + reducerKeys.join('", "') + "\"");
  }

  var unexpectedKeys = Object.keys(inputState).filter(function (key) {
    return !reducers.hasOwnProperty(key) && !unexpectedKeyCache[key];
  });
  unexpectedKeys.forEach(function (key) {
    unexpectedKeyCache[key] = true;
  });
  if (action && action.type === ActionTypes.REPLACE) return;

  if (unexpectedKeys.length > 0) {
    return "Unexpected " + (unexpectedKeys.length > 1 ? 'keys' : 'key') + " " + ("\"" + unexpectedKeys.join('", "') + "\" found in " + argumentName + ". ") + "Expected to find one of the known reducer keys instead: " + ("\"" + reducerKeys.join('", "') + "\". Unexpected keys will be ignored.");
  }
}

function assertReducerShape(reducers) {
  Object.keys(reducers).forEach(function (key) {
    var reducer = reducers[key];
    var initialState = reducer(undefined, {
      type: ActionTypes.INIT
    });

    if (typeof initialState === 'undefined') {
      throw new Error("The slice reducer for key \"" + key + "\" returned undefined during initialization. " + "If the state passed to the reducer is undefined, you must " + "explicitly return the initial state. The initial state may " + "not be undefined. If you don't want to set a value for this reducer, " + "you can use null instead of undefined.");
    }

    if (typeof reducer(undefined, {
      type: ActionTypes.PROBE_UNKNOWN_ACTION()
    }) === 'undefined') {
      throw new Error("The slice reducer for key \"" + key + "\" returned undefined when probed with a random type. " + ("Don't try to handle '" + ActionTypes.INIT + "' or other actions in \"redux/*\" ") + "namespace. They are considered private. Instead, you must return the " + "current state for any unknown actions, unless it is undefined, " + "in which case you must return the initial state, regardless of the " + "action type. The initial state may not be undefined, but can be null.");
    }
  });
}
/**
 * Turns an object whose values are different reducer functions, into a single
 * reducer function. It will call every child reducer, and gather their results
 * into a single state object, whose keys correspond to the keys of the passed
 * reducer functions.
 *
 * @param {Object} reducers An object whose values correspond to different
 * reducer functions that need to be combined into one. One handy way to obtain
 * it is to use ES6 `import * as reducers` syntax. The reducers may never return
 * undefined for any action. Instead, they should return their initial state
 * if the state passed to them was undefined, and the current state for any
 * unrecognized action.
 *
 * @returns {Function} A reducer function that invokes every reducer inside the
 * passed object, and builds a state object with the same shape.
 */


function combineReducers(reducers) {
  var reducerKeys = Object.keys(reducers);
  var finalReducers = {};

  for (var i = 0; i < reducerKeys.length; i++) {
    var key = reducerKeys[i];

    {
      if (typeof reducers[key] === 'undefined') {
        warning("No reducer provided for key \"" + key + "\"");
      }
    }

    if (typeof reducers[key] === 'function') {
      finalReducers[key] = reducers[key];
    }
  }

  var finalReducerKeys = Object.keys(finalReducers); // This is used to make sure we don't warn about the same
  // keys multiple times.

  var unexpectedKeyCache;

  {
    unexpectedKeyCache = {};
  }

  var shapeAssertionError;

  try {
    assertReducerShape(finalReducers);
  } catch (e) {
    shapeAssertionError = e;
  }

  return function combination(state, action) {
    if (state === void 0) {
      state = {};
    }

    if (shapeAssertionError) {
      throw shapeAssertionError;
    }

    {
      var warningMessage = getUnexpectedStateShapeWarningMessage(state, finalReducers, action, unexpectedKeyCache);

      if (warningMessage) {
        warning(warningMessage);
      }
    }

    var hasChanged = false;
    var nextState = {};

    for (var _i = 0; _i < finalReducerKeys.length; _i++) {
      var _key = finalReducerKeys[_i];
      var reducer = finalReducers[_key];
      var previousStateForKey = state[_key];
      var nextStateForKey = reducer(previousStateForKey, action);

      if (typeof nextStateForKey === 'undefined') {
        var actionType = action && action.type;
        throw new Error("When called with an action of type " + (actionType ? "\"" + String(actionType) + "\"" : '(unknown type)') + ", the slice reducer for key \"" + _key + "\" returned undefined. " + "To ignore an action, you must explicitly return the previous state. " + "If you want this reducer to hold no value, you can return null instead of undefined.");
      }

      nextState[_key] = nextStateForKey;
      hasChanged = hasChanged || nextStateForKey !== previousStateForKey;
    }

    hasChanged = hasChanged || finalReducerKeys.length !== Object.keys(state).length;
    return hasChanged ? nextState : state;
  };
}

function bindActionCreator(actionCreator, dispatch) {
  return function () {
    return dispatch(actionCreator.apply(this, arguments));
  };
}
/**
 * Turns an object whose values are action creators, into an object with the
 * same keys, but with every function wrapped into a `dispatch` call so they
 * may be invoked directly. This is just a convenience method, as you can call
 * `store.dispatch(MyActionCreators.doSomething())` yourself just fine.
 *
 * For convenience, you can also pass an action creator as the first argument,
 * and get a dispatch wrapped function in return.
 *
 * @param {Function|Object} actionCreators An object whose values are action
 * creator functions. One handy way to obtain it is to use ES6 `import * as`
 * syntax. You may also pass a single function.
 *
 * @param {Function} dispatch The `dispatch` function available on your Redux
 * store.
 *
 * @returns {Function|Object} The object mimicking the original object, but with
 * every action creator wrapped into the `dispatch` call. If you passed a
 * function as `actionCreators`, the return value will also be a single
 * function.
 */


function bindActionCreators(actionCreators, dispatch) {
  if (typeof actionCreators === 'function') {
    return bindActionCreator(actionCreators, dispatch);
  }

  if (typeof actionCreators !== 'object' || actionCreators === null) {
    throw new Error("bindActionCreators expected an object or a function, but instead received: '" + kindOf$1(actionCreators) + "'. " + "Did you write \"import ActionCreators from\" instead of \"import * as ActionCreators from\"?");
  }

  var boundActionCreators = {};

  for (var key in actionCreators) {
    var actionCreator = actionCreators[key];

    if (typeof actionCreator === 'function') {
      boundActionCreators[key] = bindActionCreator(actionCreator, dispatch);
    }
  }

  return boundActionCreators;
}

/**
 * Composes single-argument functions from right to left. The rightmost
 * function can take multiple arguments as it provides the signature for
 * the resulting composite function.
 *
 * @param {...Function} funcs The functions to compose.
 * @returns {Function} A function obtained by composing the argument functions
 * from right to left. For example, compose(f, g, h) is identical to doing
 * (...args) => f(g(h(...args))).
 */
function compose() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  if (funcs.length === 0) {
    return function (arg) {
      return arg;
    };
  }

  if (funcs.length === 1) {
    return funcs[0];
  }

  return funcs.reduce(function (a, b) {
    return function () {
      return a(b.apply(void 0, arguments));
    };
  });
}

/**
 * Creates a store enhancer that applies middleware to the dispatch method
 * of the Redux store. This is handy for a variety of tasks, such as expressing
 * asynchronous actions in a concise manner, or logging every action payload.
 *
 * See `redux-thunk` package as an example of the Redux middleware.
 *
 * Because middleware is potentially asynchronous, this should be the first
 * store enhancer in the composition chain.
 *
 * Note that each middleware will be given the `dispatch` and `getState` functions
 * as named arguments.
 *
 * @param {...Function} middlewares The middleware chain to be applied.
 * @returns {Function} A store enhancer applying the middleware.
 */

function applyMiddleware() {
  for (var _len = arguments.length, middlewares = new Array(_len), _key = 0; _key < _len; _key++) {
    middlewares[_key] = arguments[_key];
  }

  return function (createStore) {
    return function () {
      var store = createStore.apply(void 0, arguments);

      var _dispatch = function dispatch() {
        throw new Error('Dispatching while constructing your middleware is not allowed. ' + 'Other middleware would not be applied to this dispatch.');
      };

      var middlewareAPI = {
        getState: store.getState,
        dispatch: function dispatch() {
          return _dispatch.apply(void 0, arguments);
        }
      };
      var chain = middlewares.map(function (middleware) {
        return middleware(middlewareAPI);
      });
      _dispatch = compose.apply(void 0, chain)(store.dispatch);
      return _objectSpread2(_objectSpread2({}, store), {}, {
        dispatch: _dispatch
      });
    };
  };
}

/** A function that accepts a potential "extra argument" value to be injected later,
 * and returns an instance of the thunk middleware that uses that value
 */
function createThunkMiddleware(extraArgument) {
  // Standard Redux middleware definition pattern:
  // See: https://redux.js.org/tutorials/fundamentals/part-4-store#writing-custom-middleware
  var middleware = function middleware(_ref) {
    var dispatch = _ref.dispatch,
        getState = _ref.getState;
    return function (next) {
      return function (action) {
        // The thunk middleware looks for any functions that were passed to `store.dispatch`.
        // If this "action" is really a function, call it and return the result.
        if (typeof action === 'function') {
          // Inject the store's `dispatch` and `getState` methods, as well as any "extra arg"
          return action(dispatch, getState, extraArgument);
        } // Otherwise, pass the action down the middleware chain as usual


        return next(action);
      };
    };
  };

  return middleware;
}

var thunk = createThunkMiddleware(); // Attach the factory function so users can create a customized version
// with whatever "extra arg" they want to inject into their thunks

thunk.withExtraArgument = createThunkMiddleware;
var thunkMiddleware = thunk;

var reduxLogger = {exports: {}};

(function (module, exports) {
!function(e,t){t(exports);}(commonjsGlobal,function(e){function t(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}});}function r(e,t){Object.defineProperty(this,"kind",{value:e,enumerable:!0}),t&&t.length&&Object.defineProperty(this,"path",{value:t,enumerable:!0});}function n(e,t,r){n.super_.call(this,"E",e),Object.defineProperty(this,"lhs",{value:t,enumerable:!0}),Object.defineProperty(this,"rhs",{value:r,enumerable:!0});}function o(e,t){o.super_.call(this,"N",e),Object.defineProperty(this,"rhs",{value:t,enumerable:!0});}function i(e,t){i.super_.call(this,"D",e),Object.defineProperty(this,"lhs",{value:t,enumerable:!0});}function a(e,t,r){a.super_.call(this,"A",e),Object.defineProperty(this,"index",{value:t,enumerable:!0}),Object.defineProperty(this,"item",{value:r,enumerable:!0});}function f(e,t,r){var n=e.slice((r||t)+1||e.length);return e.length=t<0?e.length+t:t,e.push.apply(e,n),e}function u(e){var t="undefined"==typeof e?"undefined":N(e);return "object"!==t?t:e===Math?"math":null===e?"null":Array.isArray(e)?"array":"[object Date]"===Object.prototype.toString.call(e)?"date":"function"==typeof e.toString&&/^\/.*\//.test(e.toString())?"regexp":"object"}function l(e,t,r,c,s,d,p){s=s||[],p=p||[];var g=s.slice(0);if("undefined"!=typeof d){if(c){if("function"==typeof c&&c(g,d))return;if("object"===("undefined"==typeof c?"undefined":N(c))){if(c.prefilter&&c.prefilter(g,d))return;if(c.normalize){var h=c.normalize(g,d,e,t);h&&(e=h[0],t=h[1]);}}}g.push(d);}"regexp"===u(e)&&"regexp"===u(t)&&(e=e.toString(),t=t.toString());var y="undefined"==typeof e?"undefined":N(e),v="undefined"==typeof t?"undefined":N(t),b="undefined"!==y||p&&p[p.length-1].lhs&&p[p.length-1].lhs.hasOwnProperty(d),m="undefined"!==v||p&&p[p.length-1].rhs&&p[p.length-1].rhs.hasOwnProperty(d);if(!b&&m)r(new o(g,t));else if(!m&&b)r(new i(g,e));else if(u(e)!==u(t))r(new n(g,e,t));else if("date"===u(e)&&e-t!==0)r(new n(g,e,t));else if("object"===y&&null!==e&&null!==t)if(p.filter(function(t){return t.lhs===e}).length)e!==t&&r(new n(g,e,t));else {if(p.push({lhs:e,rhs:t}),Array.isArray(e)){var w;e.length;for(w=0;w<e.length;w++)w>=t.length?r(new a(g,w,new i(void 0,e[w]))):l(e[w],t[w],r,c,g,w,p);for(;w<t.length;)r(new a(g,w,new o(void 0,t[w++])));}else {var x=Object.keys(e),S=Object.keys(t);x.forEach(function(n,o){var i=S.indexOf(n);i>=0?(l(e[n],t[n],r,c,g,n,p),S=f(S,i)):l(e[n],void 0,r,c,g,n,p);}),S.forEach(function(e){l(void 0,t[e],r,c,g,e,p);});}p.length=p.length-1;}else e!==t&&("number"===y&&isNaN(e)&&isNaN(t)||r(new n(g,e,t)));}function c(e,t,r,n){return n=n||[],l(e,t,function(e){e&&n.push(e);},r),n.length?n:void 0}function s(e,t,r){if(r.path&&r.path.length){var n,o=e[t],i=r.path.length-1;for(n=0;n<i;n++)o=o[r.path[n]];switch(r.kind){case"A":s(o[r.path[n]],r.index,r.item);break;case"D":delete o[r.path[n]];break;case"E":case"N":o[r.path[n]]=r.rhs;}}else switch(r.kind){case"A":s(e[t],r.index,r.item);break;case"D":e=f(e,t);break;case"E":case"N":e[t]=r.rhs;}return e}function d(e,t,r){if(e&&t&&r&&r.kind){for(var n=e,o=-1,i=r.path?r.path.length-1:0;++o<i;)"undefined"==typeof n[r.path[o]]&&(n[r.path[o]]="number"==typeof r.path[o]?[]:{}),n=n[r.path[o]];switch(r.kind){case"A":s(r.path?n[r.path[o]]:n,r.index,r.item);break;case"D":delete n[r.path[o]];break;case"E":case"N":n[r.path[o]]=r.rhs;}}}function p(e,t,r){if(r.path&&r.path.length){var n,o=e[t],i=r.path.length-1;for(n=0;n<i;n++)o=o[r.path[n]];switch(r.kind){case"A":p(o[r.path[n]],r.index,r.item);break;case"D":o[r.path[n]]=r.lhs;break;case"E":o[r.path[n]]=r.lhs;break;case"N":delete o[r.path[n]];}}else switch(r.kind){case"A":p(e[t],r.index,r.item);break;case"D":e[t]=r.lhs;break;case"E":e[t]=r.lhs;break;case"N":e=f(e,t);}return e}function g(e,t,r){if(e&&t&&r&&r.kind){var n,o,i=e;for(o=r.path.length-1,n=0;n<o;n++)"undefined"==typeof i[r.path[n]]&&(i[r.path[n]]={}),i=i[r.path[n]];switch(r.kind){case"A":p(i[r.path[n]],r.index,r.item);break;case"D":i[r.path[n]]=r.lhs;break;case"E":i[r.path[n]]=r.lhs;break;case"N":delete i[r.path[n]];}}}function h(e,t,r){if(e&&t){var n=function(n){r&&!r(e,t,n)||d(e,t,n);};l(e,t,n);}}function y(e){return "color: "+F[e].color+"; font-weight: bold"}function v(e){var t=e.kind,r=e.path,n=e.lhs,o=e.rhs,i=e.index,a=e.item;switch(t){case"E":return [r.join("."),n,"→",o];case"N":return [r.join("."),o];case"D":return [r.join(".")];case"A":return [r.join(".")+"["+i+"]",a];default:return []}}function b(e,t,r,n){var o=c(e,t);try{n?r.groupCollapsed("diff"):r.group("diff");}catch(e){r.log("diff");}o?o.forEach(function(e){var t=e.kind,n=v(e);r.log.apply(r,["%c "+F[t].text,y(t)].concat(P(n)));}):r.log("—— no diff ——");try{r.groupEnd();}catch(e){r.log("—— diff end —— ");}}function m(e,t,r,n){switch("undefined"==typeof e?"undefined":N(e)){case"object":return "function"==typeof e[n]?e[n].apply(e,P(r)):e[n];case"function":return e(t);default:return e}}function w(e){var t=e.timestamp,r=e.duration;return function(e,n,o){var i=["action"];return i.push("%c"+String(e.type)),t&&i.push("%c@ "+n),r&&i.push("%c(in "+o.toFixed(2)+" ms)"),i.join(" ")}}function x(e,t){var r=t.logger,n=t.actionTransformer,o=t.titleFormatter,i=void 0===o?w(t):o,a=t.collapsed,f=t.colors,u=t.level,l=t.diff,c="undefined"==typeof t.titleFormatter;e.forEach(function(o,s){var d=o.started,p=o.startedTime,g=o.action,h=o.prevState,y=o.error,v=o.took,w=o.nextState,x=e[s+1];x&&(w=x.prevState,v=x.started-d);var S=n(g),k="function"==typeof a?a(function(){return w},g,o):a,j=D(p),E=f.title?"color: "+f.title(S)+";":"",A=["color: gray; font-weight: lighter;"];A.push(E),t.timestamp&&A.push("color: gray; font-weight: lighter;"),t.duration&&A.push("color: gray; font-weight: lighter;");var O=i(S,j,v);try{k?f.title&&c?r.groupCollapsed.apply(r,["%c "+O].concat(A)):r.groupCollapsed(O):f.title&&c?r.group.apply(r,["%c "+O].concat(A)):r.group(O);}catch(e){r.log(O);}var N=m(u,S,[h],"prevState"),P=m(u,S,[S],"action"),C=m(u,S,[y,h],"error"),F=m(u,S,[w],"nextState");if(N)if(f.prevState){var L="color: "+f.prevState(h)+"; font-weight: bold";r[N]("%c prev state",L,h);}else r[N]("prev state",h);if(P)if(f.action){var T="color: "+f.action(S)+"; font-weight: bold";r[P]("%c action    ",T,S);}else r[P]("action    ",S);if(y&&C)if(f.error){var M="color: "+f.error(y,h)+"; font-weight: bold;";r[C]("%c error     ",M,y);}else r[C]("error     ",y);if(F)if(f.nextState){var _="color: "+f.nextState(w)+"; font-weight: bold";r[F]("%c next state",_,w);}else r[F]("next state",w);l&&b(h,w,r,k);try{r.groupEnd();}catch(e){r.log("—— log end ——");}});}function S(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=Object.assign({},L,e),r=t.logger,n=t.stateTransformer,o=t.errorTransformer,i=t.predicate,a=t.logErrors,f=t.diffPredicate;if("undefined"==typeof r)return function(){return function(e){return function(t){return e(t)}}};if(e.getState&&e.dispatch)return console.error("[redux-logger] redux-logger not installed. Make sure to pass logger instance as middleware:\n// Logger with default options\nimport { logger } from 'redux-logger'\nconst store = createStore(\n  reducer,\n  applyMiddleware(logger)\n)\n// Or you can create your own logger with custom options http://bit.ly/redux-logger-options\nimport createLogger from 'redux-logger'\nconst logger = createLogger({\n  // ...options\n});\nconst store = createStore(\n  reducer,\n  applyMiddleware(logger)\n)\n"),function(){return function(e){return function(t){return e(t)}}};var u=[];return function(e){var r=e.getState;return function(e){return function(l){if("function"==typeof i&&!i(r,l))return e(l);var c={};u.push(c),c.started=O.now(),c.startedTime=new Date,c.prevState=n(r()),c.action=l;var s=void 0;if(a)try{s=e(l);}catch(e){c.error=o(e);}else s=e(l);c.took=O.now()-c.started,c.nextState=n(r());var d=t.diff&&"function"==typeof f?f(r,l):t.diff;if(x(u,Object.assign({},t,{diff:d})),u.length=0,c.error)throw c.error;return s}}}}var k,j,E=function(e,t){return new Array(t+1).join(e)},A=function(e,t){return E("0",t-e.toString().length)+e},D=function(e){return A(e.getHours(),2)+":"+A(e.getMinutes(),2)+":"+A(e.getSeconds(),2)+"."+A(e.getMilliseconds(),3)},O="undefined"!=typeof performance&&null!==performance&&"function"==typeof performance.now?performance:Date,N="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},P=function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)},C=[];k="object"===("undefined"==typeof commonjsGlobal?"undefined":N(commonjsGlobal))&&commonjsGlobal?commonjsGlobal:"undefined"!=typeof window?window:{},j=k.DeepDiff,j&&C.push(function(){"undefined"!=typeof j&&k.DeepDiff===c&&(k.DeepDiff=j,j=void 0);}),t(n,r),t(o,r),t(i,r),t(a,r),Object.defineProperties(c,{diff:{value:c,enumerable:!0},observableDiff:{value:l,enumerable:!0},applyDiff:{value:h,enumerable:!0},applyChange:{value:d,enumerable:!0},revertChange:{value:g,enumerable:!0},isConflict:{value:function(){return "undefined"!=typeof j},enumerable:!0},noConflict:{value:function(){return C&&(C.forEach(function(e){e();}),C=null),c},enumerable:!0}});var F={E:{color:"#2196F3",text:"CHANGED:"},N:{color:"#4CAF50",text:"ADDED:"},D:{color:"#F44336",text:"DELETED:"},A:{color:"#2196F3",text:"ARRAY:"}},L={level:"log",logger:console,logErrors:!0,collapsed:void 0,predicate:void 0,duration:!1,timestamp:!0,stateTransformer:function(e){return e},actionTransformer:function(e){return e},errorTransformer:function(e){return e},colors:{title:function(){return "inherit"},prevState:function(){return "#9E9E9E"},action:function(){return "#03A9F4"},nextState:function(){return "#4CAF50"},error:function(){return "#F20404"}},diff:!1,diffPredicate:void 0,transformer:void 0},T=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=e.dispatch,r=e.getState;return "function"==typeof t||"function"==typeof r?S()({dispatch:t,getState:r}):void console.error("\n[redux-logger v3] BREAKING CHANGE\n[redux-logger v3] Since 3.0.0 redux-logger exports by default logger with default settings.\n[redux-logger v3] Change\n[redux-logger v3] import createLogger from 'redux-logger'\n[redux-logger v3] to\n[redux-logger v3] import { createLogger } from 'redux-logger'\n")};e.defaults=L,e.createLogger=S,e.logger=T,e.default=T,Object.defineProperty(e,"__esModule",{value:!0});});
}(reduxLogger, reduxLogger.exports));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2021
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The translation data for locale modal.
 */

/**
 * The locale item data in locale modal, which is a tuple of the locale and the language.
 */

/**
 * The country item data in locale modal.
 */

/**
 * The region item data in locale modal.
 */

/**
 * The data available from `LocaleAPI.getList()`.
 */

/**
 * The Redux action ID for `LocaleAPI`.
 */
let LOCALE_API_ACTION;

/**
 * A Redux substate for `LocaleAPI`.
 */
(function (LOCALE_API_ACTION) {
  LOCALE_API_ACTION["SET_REQUEST_LANGUAGE_IN_PROGRESS"] = "SET_REQUEST_LANGUAGE_IN_PROGRESS";
  LOCALE_API_ACTION["SET_ERROR_REQUEST_LANGUAGE"] = "SET_ERROR_REQUEST_LANGUAGE";
  LOCALE_API_ACTION["SET_LANGUAGE"] = "SET_LANGUAGE";
  LOCALE_API_ACTION["SET_REQUEST_LANG_DISPLAY_IN_PROGRESS"] = "SET_REQUEST_LANG_DISPLAY_IN_PROGRESS";
  LOCALE_API_ACTION["SET_ERROR_REQUEST_LANG_DISPLAY"] = "SET_ERROR_REQUEST_LANG_DISPLAY";
  LOCALE_API_ACTION["SET_LANG_DISPLAY"] = "SET_LANG_DISPLAY";
  LOCALE_API_ACTION["SET_REQUEST_LOCALE_LIST_IN_PROGRESS"] = "SET_REQUEST_LOCALE_LIST_IN_PROGRESS";
  LOCALE_API_ACTION["SET_ERROR_REQUEST_LOCALE_LIST"] = "SET_ERROR_REQUEST_LOCALE_LIST";
  LOCALE_API_ACTION["SET_LOCALE_LIST"] = "SET_LOCALE_LIST";
})(LOCALE_API_ACTION || (LOCALE_API_ACTION = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2022
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */
/**
 * @param state The state for locale API.
 * @param action The action.
 * @returns The new state for locale API.
 */
function reducer$5(state = {}, action) {
  switch (action.type) {
    case LOCALE_API_ACTION.SET_REQUEST_LANGUAGE_IN_PROGRESS:
      {
        const {
          request: requestLanguage
        } = action;
        return {
          ...state,
          requestLanguageInProgress: true,
          requestLanguage
        };
      }
    case LOCALE_API_ACTION.SET_ERROR_REQUEST_LANGUAGE:
      {
        const {
          error: errorRequestLanguage
        } = action;
        return {
          ...state,
          requestLanguageInProgress: false,
          errorRequestLanguage
        };
      }
    case LOCALE_API_ACTION.SET_LANGUAGE:
      {
        const {
          language
        } = action;
        return {
          ...state,
          // If application sets language data without making a REST call, mark the request as resolved already
          requestLanguage: Promise.resolve(language),
          requestLanguageInProgress: false,
          language
        };
      }
    case LOCALE_API_ACTION.SET_REQUEST_LOCALE_LIST_IN_PROGRESS:
      {
        const {
          language,
          request
        } = action;
        return {
          ...state,
          requestsLocaleListInProgress: {
            ...(state.requestsLocaleListInProgress || {}),
            [language]: true
          },
          requestsLocaleList: {
            ...(state.requestsLocaleList || {}),
            [language]: request
          }
        };
      }
    case LOCALE_API_ACTION.SET_ERROR_REQUEST_LOCALE_LIST:
      {
        const {
          language,
          error
        } = action;
        return {
          ...state,
          requestsLocaleListInProgress: {
            ...(state.requestsLocaleListInProgress || {}),
            [language]: false
          },
          errorsRequestLocaleList: {
            ...(state.errorsRequestLocaleList || {}),
            [language]: error
          }
        };
      }
    case LOCALE_API_ACTION.SET_LOCALE_LIST:
      {
        const {
          language,
          localeList
        } = action;
        return {
          ...state,
          // If application sets language data without making a REST call, mark the request as resolved already
          requestsLocaleListInProgress: {
            ...(state.requestsLocaleListInProgress || {}),
            [language]: false
          },
          requestsLocaleList: {
            ...(state.requestsLocaleList || {}),
            [language]: Promise.resolve(localeList)
          },
          localeLists: {
            ...(state.localeLists || {}),
            [language]: localeList
          }
        };
      }
    default:
      return state;
  }
}

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * A link item.
 * Used for masthead, footer, etc.
 */

/**
 * A set of links.
 * Used for masthead, footer, etc.
 */

/**
 * A menu section for masthead
 */

/**
 * An profile item in masthead.
 */

/**
 * Labels object for leaving ibm component
 */

/**
 * Masthead logo tooltip
 */

/**
 * Cloud Masthead Profile content
 *
 * @deprecated
 */

/**
 * Misc labels
 */

/**
 * The translation data for ibm.com sites
 */

/**
 * The Redux action ID for `TranslationAPI`.
 */
let TRANSLATE_API_ACTION;

/**
 * A Redux substate for `TranslateAPI`.
 */
(function (TRANSLATE_API_ACTION) {
  TRANSLATE_API_ACTION["SET_REQUEST_TRANSLATION_IN_PROGRESS"] = "SET_REQUEST_TRANSLATION_IN_PROGRESS";
  TRANSLATE_API_ACTION["SET_ERROR_REQUEST_TRANSLATION"] = "SET_ERROR_REQUEST_TRANSLATION";
  TRANSLATE_API_ACTION["SET_TRANSLATION"] = "SET_TRANSLATION";
})(TRANSLATE_API_ACTION || (TRANSLATE_API_ACTION = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2023
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */
/**
 * @param state The state for translate API.
 * @param action The action.
 * @returns The new state for translate API.
 */
function reducer$4(state = {}, action) {
  switch (action.type) {
    case TRANSLATE_API_ACTION.SET_REQUEST_TRANSLATION_IN_PROGRESS:
      {
        const {
          language,
          request,
          endpoint
        } = action;
        return {
          ...state,
          requestsTranslationInProgress: {
            ...(state.requestsTranslationInProgress || {}),
            [language]: true
          },
          requestsTranslation: {
            ...(state.requestsTranslation || {}),
            [language]: request,
            endpoint
          }
        };
      }
    case TRANSLATE_API_ACTION.SET_ERROR_REQUEST_TRANSLATION:
      {
        const {
          language,
          error
        } = action;
        return {
          ...state,
          requestsTranslationInProgress: {
            ...(state.requestsTranslationInProgress || {}),
            [language]: false
          },
          errorsRequestTranslation: {
            ...(state.errorsRequestTranslation || {}),
            [language]: error
          }
        };
      }
    case TRANSLATE_API_ACTION.SET_TRANSLATION:
      {
        const {
          language,
          translation,
          endpoint
        } = action;
        return {
          ...state,
          // If application sets language data without making a REST call, mark the request as resolved already
          requestsTranslationInProgress: {
            ...(state.requestsTranslationInProgress || {}),
            [language]: false
          },
          requestsTranslation: {
            ...(state.requestsTranslation || {}),
            [language]: Promise.resolve(translation),
            endpoint
          },
          translations: {
            ...(state.translations || {}),
            [language]: translation
          }
        };
      }
    default:
      return state;
  }
}

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The user authentication status, etc.
 */

/**
 * Unauthenticated user status
 */
const UNAUTHENTICATED_STATUS = 'Unauthenticated';

/**
 * Cloud Unauthenticated user status
 */
const CLOUD_UNAUTHENTICATED_STATUS = 'anonymous';

/**
 * The Redux action ID for `ProfileAPI`.
 */
let PROFILE_API_ACTION;

/**
 * Authentication status types.
 */
(function (PROFILE_API_ACTION) {
  PROFILE_API_ACTION["SET_REQUEST_USER_STATUS_IN_PROGRESS"] = "SET_REQUEST_USER_STATUS_IN_PROGRESS";
  PROFILE_API_ACTION["SET_ERROR_REQUEST_USER_STATUS"] = "SET_ERROR_REQUEST_USER_STATUS";
  PROFILE_API_ACTION["SET_USER_STATUS"] = "SET_USER_STATUS";
})(PROFILE_API_ACTION || (PROFILE_API_ACTION = {}));
let MASTHEAD_AUTH_METHOD;

/**
 * A Redux substate for `ProfileAPI`.
 */
(function (MASTHEAD_AUTH_METHOD) {
  MASTHEAD_AUTH_METHOD["DEFAULT"] = "profile-api";
  MASTHEAD_AUTH_METHOD["COOKIE"] = "cookie";
  MASTHEAD_AUTH_METHOD["DOCS_API"] = "docs-api";
})(MASTHEAD_AUTH_METHOD || (MASTHEAD_AUTH_METHOD = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2022
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */
/**
 * @param state The state for profile API.
 * @param action The action.
 * @returns The new state for profile API.
 */
function reducer$3(state = {}, action) {
  switch (action.type) {
    case PROFILE_API_ACTION.SET_ERROR_REQUEST_USER_STATUS:
      {
        const {
          error: errorGetUserStatus
        } = action;
        return {
          ...state,
          errorGetUserStatus
        };
      }
    case PROFILE_API_ACTION.SET_USER_STATUS:
      {
        const {
          request
        } = action;
        return {
          ...state,
          request
        };
      }
    default:
      return state;
  }
}

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The Redux action ID for search API.
 */
let SEARCH_API_ACTION;

/**
 * A Redux substate for search API.
 */
(function (SEARCH_API_ACTION) {
  SEARCH_API_ACTION["SET_CURRENT_SEARCH_QUERY_STRING"] = "SET_CURRENT_SEARCH_QUERY_STRING";
  SEARCH_API_ACTION["SET_REQUEST_SEARCH_RESULTS_IN_PROGRESS"] = "SET_REQUEST_SEARCH_RESULTS_IN_PROGRESS";
  SEARCH_API_ACTION["SET_ERROR_REQUEST_SEARCH_RESULTS"] = "SET_ERROR_REQUEST_SEARCH_RESULTS";
  SEARCH_API_ACTION["SET_SEARCH_RESULTS"] = "SET_SEARCH_RESULTS";
})(SEARCH_API_ACTION || (SEARCH_API_ACTION = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2022
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */
/**
 * @param state The state for search API.
 * @param action The action.
 * @returns The new state for search API.
 */
function reducer$2(state = {}, action) {
  switch (action.type) {
    case SEARCH_API_ACTION.SET_CURRENT_SEARCH_QUERY_STRING:
      {
        const {
          searchQueryString
        } = action;
        return {
          ...state,
          currentSearchQueryString: searchQueryString
        };
      }
    case SEARCH_API_ACTION.SET_REQUEST_SEARCH_RESULTS_IN_PROGRESS:
      {
        var _oldRequestsSearchRes, _oldRequestsSearchRes2;
        const {
          language,
          searchQueryString,
          request
        } = action;
        const {
          requestsSearchResultsInProgress: oldRequestsSearchResultsInProgress = {},
          requestsSearchResults: oldRequestsSearchResults = {}
        } = state;
        return {
          ...state,
          requestsSearchResultsInProgress: {
            ...oldRequestsSearchResultsInProgress,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes = oldRequestsSearchResultsInProgress[searchQueryString]) !== null && _oldRequestsSearchRes !== void 0 ? _oldRequestsSearchRes : {}),
              [language]: true
            }
          },
          requestsSearchResults: {
            ...oldRequestsSearchResults,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes2 = oldRequestsSearchResults[searchQueryString]) !== null && _oldRequestsSearchRes2 !== void 0 ? _oldRequestsSearchRes2 : {}),
              [language]: request
            }
          }
        };
      }
    case SEARCH_API_ACTION.SET_ERROR_REQUEST_SEARCH_RESULTS:
      {
        var _oldRequestsSearchRes3, _oldErrorsRequestSear;
        const {
          language,
          searchQueryString,
          error
        } = action;
        const {
          requestsSearchResultsInProgress: oldRequestsSearchResultsInProgress = {},
          errorsRequestSearchResults: oldErrorsRequestSearchResults = {}
        } = state;
        return {
          ...state,
          requestsSearchResultsInProgress: {
            ...oldRequestsSearchResultsInProgress,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes3 = oldRequestsSearchResultsInProgress[searchQueryString]) !== null && _oldRequestsSearchRes3 !== void 0 ? _oldRequestsSearchRes3 : {}),
              [language]: false
            }
          },
          errorsRequestSearchResults: {
            ...oldErrorsRequestSearchResults,
            [searchQueryString]: {
              ...((_oldErrorsRequestSear = oldErrorsRequestSearchResults[searchQueryString]) !== null && _oldErrorsRequestSear !== void 0 ? _oldErrorsRequestSear : {}),
              [language]: error
            }
          }
        };
      }
    case SEARCH_API_ACTION.SET_SEARCH_RESULTS:
      {
        var _oldRequestsSearchRes4, _oldRequestsSearchRes5, _oldSearchResults$sea;
        const {
          language,
          searchQueryString,
          results
        } = action;
        const {
          requestsSearchResultsInProgress: oldRequestsSearchResultsInProgress = {},
          requestsSearchResults: oldRequestsSearchResults = {},
          searchResults: oldSearchResults = {}
        } = state;
        return {
          ...state,
          requestsSearchResultsInProgress: {
            ...oldRequestsSearchResultsInProgress,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes4 = oldRequestsSearchResultsInProgress[searchQueryString]) !== null && _oldRequestsSearchRes4 !== void 0 ? _oldRequestsSearchRes4 : {}),
              [language]: false
            }
          },
          requestsSearchResults: {
            ...oldRequestsSearchResults,
            [searchQueryString]: {
              ...((_oldRequestsSearchRes5 = oldRequestsSearchResults[searchQueryString]) !== null && _oldRequestsSearchRes5 !== void 0 ? _oldRequestsSearchRes5 : {}),
              [language]: Promise.resolve(results)
            }
          },
          searchResults: {
            ...oldSearchResults,
            [searchQueryString]: {
              ...((_oldSearchResults$sea = oldSearchResults[searchQueryString]) !== null && _oldSearchResults$sea !== void 0 ? _oldSearchResults$sea : {}),
              [language]: results
            }
          }
        };
      }
    default:
      return state;
  }
}

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The media data for ibm.com sites
 */

/**
 * The Redux action ID for `MediaPlayerAPI`.
 */
let MEDIA_PLAYER_API_ACTION;

/**
 * A Redux substate for `MediaPlayerAPI`.
 */
(function (MEDIA_PLAYER_API_ACTION) {
  MEDIA_PLAYER_API_ACTION["SET_REQUEST_MEDIA_DATA_IN_PROGRESS"] = "SET_REQUEST_MEDIA_DATA_IN_PROGRESS";
  MEDIA_PLAYER_API_ACTION["SET_ERROR_REQUEST_MEDIA_DATA"] = "SET_ERROR_REQUEST_MEDIA_DATA";
  MEDIA_PLAYER_API_ACTION["SET_MEDIA_DATA"] = "SET_MEDIA_DATA";
})(MEDIA_PLAYER_API_ACTION || (MEDIA_PLAYER_API_ACTION = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2020, 2022
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */
/**
 * @param state The state for media player API.
 * @param action The action.
 * @returns The new state for media player API.
 */
function reducer$1(state = {}, action) {
  switch (action.type) {
    case MEDIA_PLAYER_API_ACTION.SET_REQUEST_MEDIA_DATA_IN_PROGRESS:
      {
        const {
          mediaId,
          request
        } = action;
        return {
          ...state,
          requestsMediaDataInProgress: {
            ...(state.requestsMediaDataInProgress || {}),
            [mediaId]: true
          },
          requestsMediaData: {
            ...(state.requestsMediaData || {}),
            [mediaId]: request
          }
        };
      }
    case MEDIA_PLAYER_API_ACTION.SET_ERROR_REQUEST_MEDIA_DATA:
      {
        const {
          mediaId,
          error
        } = action;
        return {
          ...state,
          requestsMediaDataInProgress: {
            ...(state.requestsMediaDataInProgress || {}),
            [mediaId]: false
          },
          errorsRequestMediaData: {
            ...(state.errorsRequestMediaData || {}),
            [mediaId]: error
          }
        };
      }
    case MEDIA_PLAYER_API_ACTION.SET_MEDIA_DATA:
      {
        const {
          mediaId,
          mediaData
        } = action;
        return {
          ...state,
          // If application sets language data without making a REST call, mark the request as resolved already
          requestsMediaDataInProgress: {
            ...(state.requestsMediaDataInProgress || {}),
            [mediaId]: false
          },
          requestsMediaData: {
            ...(state.requestsMediaData || {}),
            [mediaId]: Promise.resolve(mediaData)
          },
          mediaData: {
            ...(state.mediaData || {}),
            [mediaId]: mediaData
          }
        };
      }
    default:
      return state;
  }
}

/**
 * @license
 *
 * Copyright IBM Corp. 2021
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The Redux action ID for `CloudAccountAuthAPI`.
 */
let CLOUD_ACCOUNT_AUTH_API_ACTION;

/**
 * A Redux substate for `CloudAccountAuthAPI`.
 */
(function (CLOUD_ACCOUNT_AUTH_API_ACTION) {
  CLOUD_ACCOUNT_AUTH_API_ACTION["SET_REQUEST_USER_STATUS_IN_PROGRESS"] = "SET_REQUEST_USER_STATUS_IN_PROGRESS";
  CLOUD_ACCOUNT_AUTH_API_ACTION["SET_ERROR_REQUEST_USER_STATUS"] = "SET_ERROR_REQUEST_USER_STATUS";
  CLOUD_ACCOUNT_AUTH_API_ACTION["SET_USER_STATUS"] = "SET_USER_STATUS";
})(CLOUD_ACCOUNT_AUTH_API_ACTION || (CLOUD_ACCOUNT_AUTH_API_ACTION = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2021, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */ /**
     * @license
     *
     * Copyright IBM Corp. 2021, 2022
     *
     * This source code is licensed under the Apache-2.0 license found in the
     * LICENSE file in the root directory of this source tree.
     */
/**
 * @param state The state for cloud account auth API.
 * @param action The action.
 * @returns The new state for cloud account auth API.
 */
function reducer(state = {}, action) {
  switch (action.type) {
    case CLOUD_ACCOUNT_AUTH_API_ACTION.SET_ERROR_REQUEST_USER_STATUS:
      {
        const {
          error: errorGetUserStatus
        } = action;
        return {
          ...state,
          errorGetUserStatus
        };
      }
    case CLOUD_ACCOUNT_AUTH_API_ACTION.SET_USER_STATUS:
      {
        const {
          request
        } = action;
        return {
          ...state,
          request
        };
      }
    default:
      return state;
  }
}

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The combined reducer for all APIs.
 */
const reducers = combineReducers({
  localeAPI: reducer$5,
  translateAPI: reducer$4,
  profileAPI: reducer$3,
  searchAPI: reducer$2,
  kalturaPlayerAPI: reducer$1,
  cloudAccountAuthAPI: reducer
});

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const middlewares = [thunkMiddleware];
{
  middlewares.push(reduxLogger.exports.createLogger());
}

/**
 * @param initialState The initial state.
 * @returns The default Redux store for Carbon for IBM.com.
 */
function createStore(initialState = lib.__PRELOADED_STATE__) {
  return createStore$1(reducers, initialState !== null && initialState !== void 0 ? initialState : {}, applyMiddleware(...middlewares));
}
const store = createStore();

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

var freeGlobal$1 = freeGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal$1 || freeSelf || Function('return this')();

var root$1 = root;

/** Built-in value references. */
var Symbol$1 = root$1.Symbol;

var Symbol$2 = Symbol$1;

/** Used for built-in method references. */
var objectProto$d = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$b = objectProto$d.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString$1 = objectProto$d.toString;

/** Built-in value references. */
var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty$b.call(value, symToStringTag$1),
      tag = value[symToStringTag$1];

  try {
    value[symToStringTag$1] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}

/** Used for built-in method references. */
var objectProto$c = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto$c.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString.call(value);
}

/** `Object#toString` result references. */
var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject$1(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]',
    funcTag$1 = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction$1(value) {
  if (!isObject$1(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag(value);
  return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
}

/** Used to detect overreaching core-js shims. */
var coreJsData = root$1['__core-js_shared__'];

var coreJsData$1 = coreJsData;

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

/** Used for built-in method references. */
var funcProto$1 = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString$1 = funcProto$1.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto$b = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty$a = objectProto$b.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty$a).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject$1(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction$1(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

/* Built-in method references that are verified to be native. */
var Map$1 = getNative(root$1, 'Map');

var Map$2 = Map$1;

/* Built-in method references that are verified to be native. */
var nativeCreate = getNative(Object, 'create');

var nativeCreate$1 = nativeCreate;

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
  this.size = 0;
}

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$2 = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto$a = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$9 = objectProto$a.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate$1) {
    var result = data[key];
    return result === HASH_UNDEFINED$2 ? undefined : result;
  }
  return hasOwnProperty$9.call(data, key) ? data[key] : undefined;
}

/** Used for built-in method references. */
var objectProto$9 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$8 = objectProto$9.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate$1 ? (data[key] !== undefined) : hasOwnProperty$8.call(data, key);
}

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate$1 && value === undefined) ? HASH_UNDEFINED$1 : value;
  return this;
}

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map$2 || ListCache),
    'string': new Hash
  };
}

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  var result = getMapData(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map$2 || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$5 = 1,
    COMPARE_UNORDERED_FLAG$3 = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$5,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Check that cyclic values are equal.
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG$3) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

/** Built-in value references. */
var Uint8Array$1 = root$1.Uint8Array;

var Uint8Array$2 = Uint8Array$1;

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$4 = 1,
    COMPARE_UNORDERED_FLAG$2 = 2;

/** `Object#toString` result references. */
var boolTag$1 = '[object Boolean]',
    dateTag$1 = '[object Date]',
    errorTag$1 = '[object Error]',
    mapTag$2 = '[object Map]',
    numberTag$1 = '[object Number]',
    regexpTag$1 = '[object RegExp]',
    setTag$2 = '[object Set]',
    stringTag$1 = '[object String]',
    symbolTag$1 = '[object Symbol]';

var arrayBufferTag$1 = '[object ArrayBuffer]',
    dataViewTag$2 = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto$1 = Symbol$2 ? Symbol$2.prototype : undefined,
    symbolValueOf = symbolProto$1 ? symbolProto$1.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag$2:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag$1:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array$2(object), new Uint8Array$2(other))) {
        return false;
      }
      return true;

    case boolTag$1:
    case dateTag$1:
    case numberTag$1:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag$1:
      return object.name == other.name && object.message == other.message;

    case regexpTag$1:
    case stringTag$1:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag$2:
      var convert = mapToArray;

    case setTag$2:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$4;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG$2;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag$1:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray$1 = Array.isArray;

var isArray$2 = isArray$1;

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$2(object) ? result : arrayPush(result, symbolsFunc(object));
}

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

/** Used for built-in method references. */
var objectProto$8 = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable$1 = objectProto$8.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols$1 = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols$1 ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols$1(object), function(symbol) {
    return propertyIsEnumerable$1.call(object, symbol);
  });
};

var getSymbols$1 = getSymbols;

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

/** `Object#toString` result references. */
var argsTag$2 = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag$2;
}

/** Used for built-in method references. */
var objectProto$7 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$7 = objectProto$7.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable = objectProto$7.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty$7.call(value, 'callee') &&
    !propertyIsEnumerable.call(value, 'callee');
};

var isArguments$1 = isArguments;

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

/** Detect free variable `exports`. */
var freeExports$1 = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule$1 = freeExports$1 && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1;

/** Built-in value references. */
var Buffer$1 = moduleExports$1 ? root$1.Buffer : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeIsBuffer = Buffer$1 ? Buffer$1.isBuffer : undefined;

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer$1 = nativeIsBuffer || stubFalse;

var isBuffer$2 = isBuffer$1;

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER$1 = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$1 : length;

  return !!length &&
    (type == 'number' ||
      (type != 'symbol' && reIsUint.test(value))) &&
        (value > -1 && value % 1 == 0 && value < length);
}

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

/** `Object#toString` result references. */
var argsTag$1 = '[object Arguments]',
    arrayTag$1 = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag$1 = '[object Map]',
    numberTag = '[object Number]',
    objectTag$2 = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag$1 = '[object Set]',
    stringTag = '[object String]',
    weakMapTag$1 = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag$1 = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag$1] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag$1] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag] =
typedArrayTags[mapTag$1] = typedArrayTags[numberTag] =
typedArrayTags[objectTag$2] = typedArrayTags[regexpTag] =
typedArrayTags[setTag$1] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag$1] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

/** Detect free variable `exports`. */
var freeExports = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports && freeGlobal$1.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    // Use `util.types` for Node.js 10+.
    var types = freeModule && freeModule.require && freeModule.require('util').types;

    if (types) {
      return types;
    }

    // Legacy `process.binding('util')` for Node.js < 10.
    return freeProcess && freeProcess.binding && freeProcess.binding('util');
  } catch (e) {}
}());

var nodeUtil$1 = nodeUtil;

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil$1 && nodeUtil$1.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray$1 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

var isTypedArray$2 = isTypedArray$1;

/** Used for built-in method references. */
var objectProto$6 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$6 = objectProto$6.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  var isArr = isArray$2(value),
      isArg = !isArr && isArguments$1(value),
      isBuff = !isArr && !isArg && isBuffer$2(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray$2(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty$6.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

/** Used for built-in method references. */
var objectProto$5 = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$5;

  return value === proto;
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

var nativeKeys$1 = nativeKeys;

/** Used for built-in method references. */
var objectProto$4 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$5 = objectProto$4.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys$1(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$5.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction$1(value);
}

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols$1);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$3 = 1;

/** Used for built-in method references. */
var objectProto$3 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$4 = objectProto$3.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty$4.call(other, key))) {
      return false;
    }
  }
  // Check that cyclic values are equal.
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

/* Built-in method references that are verified to be native. */
var DataView = getNative(root$1, 'DataView');

var DataView$1 = DataView;

/* Built-in method references that are verified to be native. */
var Promise$1 = getNative(root$1, 'Promise');

var Promise$2 = Promise$1;

/* Built-in method references that are verified to be native. */
var Set$1 = getNative(root$1, 'Set');

var Set$2 = Set$1;

/* Built-in method references that are verified to be native. */
var WeakMap$1 = getNative(root$1, 'WeakMap');

var WeakMap$2 = WeakMap$1;

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    objectTag$1 = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView$1),
    mapCtorString = toSource(Map$2),
    promiseCtorString = toSource(Promise$2),
    setCtorString = toSource(Set$2),
    weakMapCtorString = toSource(WeakMap$2);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView$1 && getTag(new DataView$1(new ArrayBuffer(1))) != dataViewTag) ||
    (Map$2 && getTag(new Map$2) != mapTag) ||
    (Promise$2 && getTag(Promise$2.resolve()) != promiseTag) ||
    (Set$2 && getTag(new Set$2) != setTag) ||
    (WeakMap$2 && getTag(new WeakMap$2) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag$1 ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

var getTag$1 = getTag;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$2 = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto$2 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$3 = objectProto$2.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$2(object),
      othIsArr = isArray$2(other),
      objTag = objIsArr ? arrayTag : getTag$1(object),
      othTag = othIsArr ? arrayTag : getTag$1(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer$2(object)) {
    if (!isBuffer$2(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray$2(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG$2)) {
    var objIsWrapped = objIsObj && hasOwnProperty$3.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty$3.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$1 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject$1(value);
}

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && baseGetTag(value) == symbolTag);
}

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray$2(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

/** Error message constants. */
var FUNC_ERROR_TEXT$2 = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT$2);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = MapCache;

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

var stringToPath$1 = stringToPath;

/** Used as references for various `Number` constants. */
var INFINITY$2 = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol$2 ? Symbol$2.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isArray$2(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return arrayMap(value, baseToString) + '';
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY$2) ? '-0' : result;
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString$1(value) {
  return value == null ? '' : baseToString(value);
}

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isArray$2(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath$1(toString$1(value));
}

/** Used as references for various `Number` constants. */
var INFINITY$1 = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY$1) ? '-0' : result;
}

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray$2(object) || isArguments$1(object));
}

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == 'object') {
    return isArray$2(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

var defineProperty$1 = (function() {
  try {
    var func = getNative(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

var defineProperty$2 = defineProperty$1;

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue(object, key, value) {
  if (key == '__proto__' && defineProperty$2) {
    defineProperty$2(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$2 = objectProto$1.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$2.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

/**
 * The base implementation of `_.set`.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @param {Function} [customizer] The function to customize path creation.
 * @returns {Object} Returns `object`.
 */
function baseSet(object, path, value, customizer) {
  if (!isObject$1(object)) {
    return object;
  }
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      lastIndex = length - 1,
      nested = object;

  while (nested != null && ++index < length) {
    var key = toKey(path[index]),
        newValue = value;

    if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
      return object;
    }

    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : undefined;
      if (newValue === undefined) {
        newValue = isObject$1(objValue)
          ? objValue
          : (isIndex(path[index + 1]) ? [] : {});
      }
    }
    assignValue(nested, key, newValue);
    nested = nested[key];
  }
  return object;
}

/**
 * The base implementation of  `_.pickBy` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The source object.
 * @param {string[]} paths The property paths to pick.
 * @param {Function} predicate The function invoked per property.
 * @returns {Object} Returns the new object.
 */
function basePickBy(object, paths, predicate) {
  var index = -1,
      length = paths.length,
      result = {};

  while (++index < length) {
    var path = paths[index],
        value = baseGet(object, path);

    if (predicate(value, path)) {
      baseSet(result, castPath(path, object), value);
    }
  }
  return result;
}

/** Built-in value references. */
var getPrototype = overArg(Object.getPrototypeOf, Object);

var getPrototype$1 = getPrototype;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush(result, getSymbols$1(object));
    object = getPrototype$1(object);
  }
  return result;
};

var getSymbolsIn$1 = getSymbolsIn;

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function nativeKeysIn(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$1 = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeysIn(object) {
  if (!isObject$1(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype(object),
      result = [];

  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty$1.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */
function keysIn(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeysIn(object) {
  return baseGetAllKeys(object, keysIn, getSymbolsIn$1);
}

/**
 * Creates an object composed of the `object` properties `predicate` returns
 * truthy for. The predicate is invoked with two arguments: (value, key).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The source object.
 * @param {Function} [predicate=_.identity] The function invoked per property.
 * @returns {Object} Returns the new object.
 * @example
 *
 * var object = { 'a': 1, 'b': '2', 'c': 3 };
 *
 * _.pickBy(object, _.isNumber);
 * // => { 'a': 1, 'c': 3 }
 */
function pickBy(object, predicate) {
  if (object == null) {
    return {};
  }
  var props = arrayMap(getAllKeysIn(object), function(prop) {
    return [prop];
  });
  predicate = baseIteratee(predicate);
  return basePickBy(object, props, function(value, path) {
    return predicate(value, path[0]);
  });
}

var toConsumableArray = {exports: {}};

var arrayWithoutHoles = {exports: {}};

var arrayLikeToArray = {exports: {}};

(function (module) {
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
module.exports = _arrayLikeToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(arrayLikeToArray));

(function (module) {
var arrayLikeToArray$1 = arrayLikeToArray.exports;
function _arrayWithoutHoles(r) {
  if (Array.isArray(r)) return arrayLikeToArray$1(r);
}
module.exports = _arrayWithoutHoles, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(arrayWithoutHoles));

var iterableToArray = {exports: {}};

(function (module) {
function _iterableToArray(r) {
  if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
}
module.exports = _iterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(iterableToArray));

var unsupportedIterableToArray = {exports: {}};

(function (module) {
var arrayLikeToArray$1 = arrayLikeToArray.exports;
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return arrayLikeToArray$1(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? arrayLikeToArray$1(r, a) : void 0;
  }
}
module.exports = _unsupportedIterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(unsupportedIterableToArray));

var nonIterableSpread = {exports: {}};

(function (module) {
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
module.exports = _nonIterableSpread, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(nonIterableSpread));

(function (module) {
var arrayWithoutHoles$1 = arrayWithoutHoles.exports;
var iterableToArray$1 = iterableToArray.exports;
var unsupportedIterableToArray$1 = unsupportedIterableToArray.exports;
var nonIterableSpread$1 = nonIterableSpread.exports;
function _toConsumableArray(r) {
  return arrayWithoutHoles$1(r) || iterableToArray$1(r) || unsupportedIterableToArray$1(r) || nonIterableSpread$1();
}
module.exports = _toConsumableArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(toConsumableArray));

var _toConsumableArray = /*@__PURE__*/getDefaultExportFromCjs(toConsumableArray.exports);

var classCallCheck = {exports: {}};

(function (module) {
function _classCallCheck(a, n) {
  if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function");
}
module.exports = _classCallCheck, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(classCallCheck));

var _classCallCheck$2 = /*@__PURE__*/getDefaultExportFromCjs(classCallCheck.exports);

var createClass = {exports: {}};

var toPropertyKey = {exports: {}};

var _typeof$2 = {exports: {}};

(function (module) {
function _typeof(o) {
  "@babel/helpers - typeof";

  return module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports, _typeof(o);
}
module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(_typeof$2));

var toPrimitive = {exports: {}};

(function (module) {
var _typeof = _typeof$2.exports["default"];
function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
module.exports = toPrimitive, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(toPrimitive));

(function (module) {
var _typeof = _typeof$2.exports["default"];
var toPrimitive$1 = toPrimitive.exports;
function toPropertyKey(t) {
  var i = toPrimitive$1(t, "string");
  return "symbol" == _typeof(i) ? i : i + "";
}
module.exports = toPropertyKey, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(toPropertyKey));

(function (module) {
var toPropertyKey$1 = toPropertyKey.exports;
function _defineProperties(e, r) {
  for (var t = 0; t < r.length; t++) {
    var o = r[t];
    o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, toPropertyKey$1(o.key), o);
  }
}
function _createClass(e, r, t) {
  return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", {
    writable: !1
  }), e;
}
module.exports = _createClass, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(createClass));

var _createClass$2 = /*@__PURE__*/getDefaultExportFromCjs(createClass.exports);

var asyncToGenerator = {exports: {}};

(function (module) {
function asyncGeneratorStep(n, t, e, r, o, a, c) {
  try {
    var i = n[a](c),
      u = i.value;
  } catch (n) {
    return void e(n);
  }
  i.done ? t(u) : Promise.resolve(u).then(r, o);
}
function _asyncToGenerator(n) {
  return function () {
    var t = this,
      e = arguments;
    return new Promise(function (r, o) {
      var a = n.apply(t, e);
      function _next(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "next", n);
      }
      function _throw(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "throw", n);
      }
      _next(void 0);
    });
  };
}
module.exports = _asyncToGenerator, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(asyncToGenerator));

var _asyncToGenerator = /*@__PURE__*/getDefaultExportFromCjs(asyncToGenerator.exports);

var regeneratorRuntime$1 = {exports: {}};

(function (module) {
var _typeof = _typeof$2.exports["default"];
function _regeneratorRuntime() {
  module.exports = _regeneratorRuntime = function _regeneratorRuntime() {
    return e;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  var t,
    e = {},
    r = Object.prototype,
    n = r.hasOwnProperty,
    o = Object.defineProperty || function (t, e, r) {
      t[e] = r.value;
    },
    i = "function" == typeof Symbol ? Symbol : {},
    a = i.iterator || "@@iterator",
    c = i.asyncIterator || "@@asyncIterator",
    u = i.toStringTag || "@@toStringTag";
  function define(t, e, r) {
    return Object.defineProperty(t, e, {
      value: r,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), t[e];
  }
  try {
    define({}, "");
  } catch (t) {
    define = function define(t, e, r) {
      return t[e] = r;
    };
  }
  function wrap(t, e, r, n) {
    var i = e && e.prototype instanceof Generator ? e : Generator,
      a = Object.create(i.prototype),
      c = new Context(n || []);
    return o(a, "_invoke", {
      value: makeInvokeMethod(t, r, c)
    }), a;
  }
  function tryCatch(t, e, r) {
    try {
      return {
        type: "normal",
        arg: t.call(e, r)
      };
    } catch (t) {
      return {
        type: "throw",
        arg: t
      };
    }
  }
  e.wrap = wrap;
  var h = "suspendedStart",
    l = "suspendedYield",
    f = "executing",
    s = "completed",
    y = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var p = {};
  define(p, a, function () {
    return this;
  });
  var d = Object.getPrototypeOf,
    v = d && d(d(values([])));
  v && v !== r && n.call(v, a) && (p = v);
  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
  function defineIteratorMethods(t) {
    ["next", "throw", "return"].forEach(function (e) {
      define(t, e, function (t) {
        return this._invoke(e, t);
      });
    });
  }
  function AsyncIterator(t, e) {
    function invoke(r, o, i, a) {
      var c = tryCatch(t[r], t, o);
      if ("throw" !== c.type) {
        var u = c.arg,
          h = u.value;
        return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
          invoke("next", t, i, a);
        }, function (t) {
          invoke("throw", t, i, a);
        }) : e.resolve(h).then(function (t) {
          u.value = t, i(u);
        }, function (t) {
          return invoke("throw", t, i, a);
        });
      }
      a(c.arg);
    }
    var r;
    o(this, "_invoke", {
      value: function value(t, n) {
        function callInvokeWithMethodAndArg() {
          return new e(function (e, r) {
            invoke(t, n, e, r);
          });
        }
        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(e, r, n) {
    var o = h;
    return function (i, a) {
      if (o === f) throw Error("Generator is already running");
      if (o === s) {
        if ("throw" === i) throw a;
        return {
          value: t,
          done: !0
        };
      }
      for (n.method = i, n.arg = a;;) {
        var c = n.delegate;
        if (c) {
          var u = maybeInvokeDelegate(c, n);
          if (u) {
            if (u === y) continue;
            return u;
          }
        }
        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
          if (o === h) throw o = s, n.arg;
          n.dispatchException(n.arg);
        } else "return" === n.method && n.abrupt("return", n.arg);
        o = f;
        var p = tryCatch(e, r, n);
        if ("normal" === p.type) {
          if (o = n.done ? s : l, p.arg === y) continue;
          return {
            value: p.arg,
            done: n.done
          };
        }
        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
      }
    };
  }
  function maybeInvokeDelegate(e, r) {
    var n = r.method,
      o = e.iterator[n];
    if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
    var i = tryCatch(o, e.iterator, r.arg);
    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
    var a = i.arg;
    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
  }
  function pushTryEntry(t) {
    var e = {
      tryLoc: t[0]
    };
    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
  }
  function resetTryEntry(t) {
    var e = t.completion || {};
    e.type = "normal", delete e.arg, t.completion = e;
  }
  function Context(t) {
    this.tryEntries = [{
      tryLoc: "root"
    }], t.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(e) {
    if (e || "" === e) {
      var r = e[a];
      if (r) return r.call(e);
      if ("function" == typeof e.next) return e;
      if (!isNaN(e.length)) {
        var o = -1,
          i = function next() {
            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
            return next.value = t, next.done = !0, next;
          };
        return i.next = i;
      }
    }
    throw new TypeError(_typeof(e) + " is not iterable");
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), o(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
    var e = "function" == typeof t && t.constructor;
    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
  }, e.mark = function (t) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
  }, e.awrap = function (t) {
    return {
      __await: t
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
    return this;
  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
    void 0 === i && (i = Promise);
    var a = new AsyncIterator(wrap(t, r, n, o), i);
    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
      return t.done ? t.value : a.next();
    });
  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
    return this;
  }), define(g, "toString", function () {
    return "[object Generator]";
  }), e.keys = function (t) {
    var e = Object(t),
      r = [];
    for (var n in e) r.push(n);
    return r.reverse(), function next() {
      for (; r.length;) {
        var t = r.pop();
        if (t in e) return next.value = t, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, e.values = values, Context.prototype = {
    constructor: Context,
    reset: function reset(e) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
    },
    stop: function stop() {
      this.done = !0;
      var t = this.tryEntries[0].completion;
      if ("throw" === t.type) throw t.arg;
      return this.rval;
    },
    dispatchException: function dispatchException(e) {
      if (this.done) throw e;
      var r = this;
      function handle(n, o) {
        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
      }
      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
        var i = this.tryEntries[o],
          a = i.completion;
        if ("root" === i.tryLoc) return handle("end");
        if (i.tryLoc <= this.prev) {
          var c = n.call(i, "catchLoc"),
            u = n.call(i, "finallyLoc");
          if (c && u) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          } else if (c) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
          } else {
            if (!u) throw Error("try statement without catch or finally");
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          }
        }
      }
    },
    abrupt: function abrupt(t, e) {
      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
        var o = this.tryEntries[r];
        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
          var i = o;
          break;
        }
      }
      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
      var a = i ? i.completion : {};
      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
    },
    complete: function complete(t, e) {
      if ("throw" === t.type) throw t.arg;
      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
    },
    finish: function finish(t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
      }
    },
    "catch": function _catch(t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.tryLoc === t) {
          var n = r.completion;
          if ("throw" === n.type) {
            var o = n.arg;
            resetTryEntry(r);
          }
          return o;
        }
      }
      throw Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(e, r, n) {
      return this.delegate = {
        iterator: values(e),
        resultName: r,
        nextLoc: n
      }, "next" === this.method && (this.arg = t), y;
    }
  }, e;
}
module.exports = _regeneratorRuntime, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(regeneratorRuntime$1));

// TODO(Babel 8): Remove this file.

var runtime = regeneratorRuntime$1.exports();
var regenerator = runtime;

// Copied from https://github.com/facebook/regenerator/blob/main/packages/runtime/runtime.js#L736=
try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}

function bind(fn, thisArg) {
  return function wrap() {
    return fn.apply(thisArg, arguments);
  };
}

// utils is a library of generic helper functions non-specific to axios

const {toString} = Object.prototype;
const {getPrototypeOf} = Object;

const kindOf = (cache => thing => {
    const str = toString.call(thing);
    return cache[str] || (cache[str] = str.slice(8, -1).toLowerCase());
})(Object.create(null));

const kindOfTest = (type) => {
  type = type.toLowerCase();
  return (thing) => kindOf(thing) === type
};

const typeOfTest = type => thing => typeof thing === type;

/**
 * Determine if a value is an Array
 *
 * @param {Object} val The value to test
 *
 * @returns {boolean} True if value is an Array, otherwise false
 */
const {isArray} = Array;

/**
 * Determine if a value is undefined
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if the value is undefined, otherwise false
 */
const isUndefined = typeOfTest('undefined');

/**
 * Determine if a value is a Buffer
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a Buffer, otherwise false
 */
function isBuffer(val) {
  return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor)
    && isFunction(val.constructor.isBuffer) && val.constructor.isBuffer(val);
}

/**
 * Determine if a value is an ArrayBuffer
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is an ArrayBuffer, otherwise false
 */
const isArrayBuffer = kindOfTest('ArrayBuffer');


/**
 * Determine if a value is a view on an ArrayBuffer
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
 */
function isArrayBufferView(val) {
  let result;
  if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
    result = ArrayBuffer.isView(val);
  } else {
    result = (val) && (val.buffer) && (isArrayBuffer(val.buffer));
  }
  return result;
}

/**
 * Determine if a value is a String
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a String, otherwise false
 */
const isString = typeOfTest('string');

/**
 * Determine if a value is a Function
 *
 * @param {*} val The value to test
 * @returns {boolean} True if value is a Function, otherwise false
 */
const isFunction = typeOfTest('function');

/**
 * Determine if a value is a Number
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a Number, otherwise false
 */
const isNumber = typeOfTest('number');

/**
 * Determine if a value is an Object
 *
 * @param {*} thing The value to test
 *
 * @returns {boolean} True if value is an Object, otherwise false
 */
const isObject = (thing) => thing !== null && typeof thing === 'object';

/**
 * Determine if a value is a Boolean
 *
 * @param {*} thing The value to test
 * @returns {boolean} True if value is a Boolean, otherwise false
 */
const isBoolean = thing => thing === true || thing === false;

/**
 * Determine if a value is a plain Object
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a plain Object, otherwise false
 */
const isPlainObject = (val) => {
  if (kindOf(val) !== 'object') {
    return false;
  }

  const prototype = getPrototypeOf(val);
  return (prototype === null || prototype === Object.prototype || Object.getPrototypeOf(prototype) === null) && !(Symbol.toStringTag in val) && !(Symbol.iterator in val);
};

/**
 * Determine if a value is a Date
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a Date, otherwise false
 */
const isDate = kindOfTest('Date');

/**
 * Determine if a value is a File
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a File, otherwise false
 */
const isFile = kindOfTest('File');

/**
 * Determine if a value is a Blob
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a Blob, otherwise false
 */
const isBlob = kindOfTest('Blob');

/**
 * Determine if a value is a FileList
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a File, otherwise false
 */
const isFileList = kindOfTest('FileList');

/**
 * Determine if a value is a Stream
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a Stream, otherwise false
 */
const isStream = (val) => isObject(val) && isFunction(val.pipe);

/**
 * Determine if a value is a FormData
 *
 * @param {*} thing The value to test
 *
 * @returns {boolean} True if value is an FormData, otherwise false
 */
const isFormData = (thing) => {
  let kind;
  return thing && (
    (typeof FormData === 'function' && thing instanceof FormData) || (
      isFunction(thing.append) && (
        (kind = kindOf(thing)) === 'formdata' ||
        // detect form-data instance
        (kind === 'object' && isFunction(thing.toString) && thing.toString() === '[object FormData]')
      )
    )
  )
};

/**
 * Determine if a value is a URLSearchParams object
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a URLSearchParams object, otherwise false
 */
const isURLSearchParams = kindOfTest('URLSearchParams');

const [isReadableStream, isRequest, isResponse, isHeaders] = ['ReadableStream', 'Request', 'Response', 'Headers'].map(kindOfTest);

/**
 * Trim excess whitespace off the beginning and end of a string
 *
 * @param {String} str The String to trim
 *
 * @returns {String} The String freed of excess whitespace
 */
const trim = (str) => str.trim ?
  str.trim() : str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');

/**
 * Iterate over an Array or an Object invoking a function for each item.
 *
 * If `obj` is an Array callback will be called passing
 * the value, index, and complete array for each item.
 *
 * If 'obj' is an Object callback will be called passing
 * the value, key, and complete object for each property.
 *
 * @param {Object|Array} obj The object to iterate
 * @param {Function} fn The callback to invoke for each item
 *
 * @param {Boolean} [allOwnKeys = false]
 * @returns {any}
 */
function forEach$2(obj, fn, {allOwnKeys = false} = {}) {
  // Don't bother if no value provided
  if (obj === null || typeof obj === 'undefined') {
    return;
  }

  let i;
  let l;

  // Force an array if not already something iterable
  if (typeof obj !== 'object') {
    /*eslint no-param-reassign:0*/
    obj = [obj];
  }

  if (isArray(obj)) {
    // Iterate over array values
    for (i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    // Iterate over object keys
    const keys = allOwnKeys ? Object.getOwnPropertyNames(obj) : Object.keys(obj);
    const len = keys.length;
    let key;

    for (i = 0; i < len; i++) {
      key = keys[i];
      fn.call(null, obj[key], key, obj);
    }
  }
}

function findKey(obj, key) {
  key = key.toLowerCase();
  const keys = Object.keys(obj);
  let i = keys.length;
  let _key;
  while (i-- > 0) {
    _key = keys[i];
    if (key === _key.toLowerCase()) {
      return _key;
    }
  }
  return null;
}

const _global = (() => {
  /*eslint no-undef:0*/
  if (typeof globalThis !== "undefined") return globalThis;
  return typeof self !== "undefined" ? self : (typeof window !== 'undefined' ? window : global)
})();

const isContextDefined = (context) => !isUndefined(context) && context !== _global;

/**
 * Accepts varargs expecting each argument to be an object, then
 * immutably merges the properties of each object and returns result.
 *
 * When multiple objects contain the same key the later object in
 * the arguments list will take precedence.
 *
 * Example:
 *
 * ```js
 * var result = merge({foo: 123}, {foo: 456});
 * console.log(result.foo); // outputs 456
 * ```
 *
 * @param {Object} obj1 Object to merge
 *
 * @returns {Object} Result of all merge properties
 */
function merge(/* obj1, obj2, obj3, ... */) {
  const {caseless} = isContextDefined(this) && this || {};
  const result = {};
  const assignValue = (val, key) => {
    const targetKey = caseless && findKey(result, key) || key;
    if (isPlainObject(result[targetKey]) && isPlainObject(val)) {
      result[targetKey] = merge(result[targetKey], val);
    } else if (isPlainObject(val)) {
      result[targetKey] = merge({}, val);
    } else if (isArray(val)) {
      result[targetKey] = val.slice();
    } else {
      result[targetKey] = val;
    }
  };

  for (let i = 0, l = arguments.length; i < l; i++) {
    arguments[i] && forEach$2(arguments[i], assignValue);
  }
  return result;
}

/**
 * Extends object a by mutably adding to it the properties of object b.
 *
 * @param {Object} a The object to be extended
 * @param {Object} b The object to copy properties from
 * @param {Object} thisArg The object to bind function to
 *
 * @param {Boolean} [allOwnKeys]
 * @returns {Object} The resulting value of object a
 */
const extend = (a, b, thisArg, {allOwnKeys}= {}) => {
  forEach$2(b, (val, key) => {
    if (thisArg && isFunction(val)) {
      a[key] = bind(val, thisArg);
    } else {
      a[key] = val;
    }
  }, {allOwnKeys});
  return a;
};

/**
 * Remove byte order marker. This catches EF BB BF (the UTF-8 BOM)
 *
 * @param {string} content with BOM
 *
 * @returns {string} content value without BOM
 */
const stripBOM = (content) => {
  if (content.charCodeAt(0) === 0xFEFF) {
    content = content.slice(1);
  }
  return content;
};

/**
 * Inherit the prototype methods from one constructor into another
 * @param {function} constructor
 * @param {function} superConstructor
 * @param {object} [props]
 * @param {object} [descriptors]
 *
 * @returns {void}
 */
const inherits = (constructor, superConstructor, props, descriptors) => {
  constructor.prototype = Object.create(superConstructor.prototype, descriptors);
  constructor.prototype.constructor = constructor;
  Object.defineProperty(constructor, 'super', {
    value: superConstructor.prototype
  });
  props && Object.assign(constructor.prototype, props);
};

/**
 * Resolve object with deep prototype chain to a flat object
 * @param {Object} sourceObj source object
 * @param {Object} [destObj]
 * @param {Function|Boolean} [filter]
 * @param {Function} [propFilter]
 *
 * @returns {Object}
 */
const toFlatObject = (sourceObj, destObj, filter, propFilter) => {
  let props;
  let i;
  let prop;
  const merged = {};

  destObj = destObj || {};
  // eslint-disable-next-line no-eq-null,eqeqeq
  if (sourceObj == null) return destObj;

  do {
    props = Object.getOwnPropertyNames(sourceObj);
    i = props.length;
    while (i-- > 0) {
      prop = props[i];
      if ((!propFilter || propFilter(prop, sourceObj, destObj)) && !merged[prop]) {
        destObj[prop] = sourceObj[prop];
        merged[prop] = true;
      }
    }
    sourceObj = filter !== false && getPrototypeOf(sourceObj);
  } while (sourceObj && (!filter || filter(sourceObj, destObj)) && sourceObj !== Object.prototype);

  return destObj;
};

/**
 * Determines whether a string ends with the characters of a specified string
 *
 * @param {String} str
 * @param {String} searchString
 * @param {Number} [position= 0]
 *
 * @returns {boolean}
 */
const endsWith = (str, searchString, position) => {
  str = String(str);
  if (position === undefined || position > str.length) {
    position = str.length;
  }
  position -= searchString.length;
  const lastIndex = str.indexOf(searchString, position);
  return lastIndex !== -1 && lastIndex === position;
};


/**
 * Returns new array from array like object or null if failed
 *
 * @param {*} [thing]
 *
 * @returns {?Array}
 */
const toArray = (thing) => {
  if (!thing) return null;
  if (isArray(thing)) return thing;
  let i = thing.length;
  if (!isNumber(i)) return null;
  const arr = new Array(i);
  while (i-- > 0) {
    arr[i] = thing[i];
  }
  return arr;
};

/**
 * Checking if the Uint8Array exists and if it does, it returns a function that checks if the
 * thing passed in is an instance of Uint8Array
 *
 * @param {TypedArray}
 *
 * @returns {Array}
 */
// eslint-disable-next-line func-names
const isTypedArray = (TypedArray => {
  // eslint-disable-next-line func-names
  return thing => {
    return TypedArray && thing instanceof TypedArray;
  };
})(typeof Uint8Array !== 'undefined' && getPrototypeOf(Uint8Array));

/**
 * For each entry in the object, call the function with the key and value.
 *
 * @param {Object<any, any>} obj - The object to iterate over.
 * @param {Function} fn - The function to call for each entry.
 *
 * @returns {void}
 */
const forEachEntry = (obj, fn) => {
  const generator = obj && obj[Symbol.iterator];

  const iterator = generator.call(obj);

  let result;

  while ((result = iterator.next()) && !result.done) {
    const pair = result.value;
    fn.call(obj, pair[0], pair[1]);
  }
};

/**
 * It takes a regular expression and a string, and returns an array of all the matches
 *
 * @param {string} regExp - The regular expression to match against.
 * @param {string} str - The string to search.
 *
 * @returns {Array<boolean>}
 */
const matchAll = (regExp, str) => {
  let matches;
  const arr = [];

  while ((matches = regExp.exec(str)) !== null) {
    arr.push(matches);
  }

  return arr;
};

/* Checking if the kindOfTest function returns true when passed an HTMLFormElement. */
const isHTMLForm = kindOfTest('HTMLFormElement');

const toCamelCase = str => {
  return str.toLowerCase().replace(/[-_\s]([a-z\d])(\w*)/g,
    function replacer(m, p1, p2) {
      return p1.toUpperCase() + p2;
    }
  );
};

/* Creating a function that will check if an object has a property. */
const hasOwnProperty = (({hasOwnProperty}) => (obj, prop) => hasOwnProperty.call(obj, prop))(Object.prototype);

/**
 * Determine if a value is a RegExp object
 *
 * @param {*} val The value to test
 *
 * @returns {boolean} True if value is a RegExp object, otherwise false
 */
const isRegExp = kindOfTest('RegExp');

const reduceDescriptors = (obj, reducer) => {
  const descriptors = Object.getOwnPropertyDescriptors(obj);
  const reducedDescriptors = {};

  forEach$2(descriptors, (descriptor, name) => {
    let ret;
    if ((ret = reducer(descriptor, name, obj)) !== false) {
      reducedDescriptors[name] = ret || descriptor;
    }
  });

  Object.defineProperties(obj, reducedDescriptors);
};

/**
 * Makes all methods read-only
 * @param {Object} obj
 */

const freezeMethods = (obj) => {
  reduceDescriptors(obj, (descriptor, name) => {
    // skip restricted props in strict mode
    if (isFunction(obj) && ['arguments', 'caller', 'callee'].indexOf(name) !== -1) {
      return false;
    }

    const value = obj[name];

    if (!isFunction(value)) return;

    descriptor.enumerable = false;

    if ('writable' in descriptor) {
      descriptor.writable = false;
      return;
    }

    if (!descriptor.set) {
      descriptor.set = () => {
        throw Error('Can not rewrite read-only method \'' + name + '\'');
      };
    }
  });
};

const toObjectSet = (arrayOrString, delimiter) => {
  const obj = {};

  const define = (arr) => {
    arr.forEach(value => {
      obj[value] = true;
    });
  };

  isArray(arrayOrString) ? define(arrayOrString) : define(String(arrayOrString).split(delimiter));

  return obj;
};

const noop = () => {};

const toFiniteNumber = (value, defaultValue) => {
  return value != null && Number.isFinite(value = +value) ? value : defaultValue;
};

/**
 * If the thing is a FormData object, return true, otherwise return false.
 *
 * @param {unknown} thing - The thing to check.
 *
 * @returns {boolean}
 */
function isSpecCompliantForm(thing) {
  return !!(thing && isFunction(thing.append) && thing[Symbol.toStringTag] === 'FormData' && thing[Symbol.iterator]);
}

const toJSONObject = (obj) => {
  const stack = new Array(10);

  const visit = (source, i) => {

    if (isObject(source)) {
      if (stack.indexOf(source) >= 0) {
        return;
      }

      if(!('toJSON' in source)) {
        stack[i] = source;
        const target = isArray(source) ? [] : {};

        forEach$2(source, (value, key) => {
          const reducedValue = visit(value, i + 1);
          !isUndefined(reducedValue) && (target[key] = reducedValue);
        });

        stack[i] = undefined;

        return target;
      }
    }

    return source;
  };

  return visit(obj, 0);
};

const isAsyncFn = kindOfTest('AsyncFunction');

const isThenable = (thing) =>
  thing && (isObject(thing) || isFunction(thing)) && isFunction(thing.then) && isFunction(thing.catch);

// original code
// https://github.com/DigitalBrainJS/AxiosPromise/blob/16deab13710ec09779922131f3fa5954320f83ab/lib/utils.js#L11-L34

const _setImmediate = ((setImmediateSupported, postMessageSupported) => {
  if (setImmediateSupported) {
    return setImmediate;
  }

  return postMessageSupported ? ((token, callbacks) => {
    _global.addEventListener("message", ({source, data}) => {
      if (source === _global && data === token) {
        callbacks.length && callbacks.shift()();
      }
    }, false);

    return (cb) => {
      callbacks.push(cb);
      _global.postMessage(token, "*");
    }
  })(`axios@${Math.random()}`, []) : (cb) => setTimeout(cb);
})(
  typeof setImmediate === 'function',
  isFunction(_global.postMessage)
);

const asap = typeof queueMicrotask !== 'undefined' ?
  queueMicrotask.bind(_global) : ( typeof process !== 'undefined' && process.nextTick || _setImmediate);

// *********************

var utils$1 = {
  isArray,
  isArrayBuffer,
  isBuffer,
  isFormData,
  isArrayBufferView,
  isString,
  isNumber,
  isBoolean,
  isObject,
  isPlainObject,
  isReadableStream,
  isRequest,
  isResponse,
  isHeaders,
  isUndefined,
  isDate,
  isFile,
  isBlob,
  isRegExp,
  isFunction,
  isStream,
  isURLSearchParams,
  isTypedArray,
  isFileList,
  forEach: forEach$2,
  merge,
  extend,
  trim,
  stripBOM,
  inherits,
  toFlatObject,
  kindOf,
  kindOfTest,
  endsWith,
  toArray,
  forEachEntry,
  matchAll,
  isHTMLForm,
  hasOwnProperty,
  hasOwnProp: hasOwnProperty, // an alias to avoid ESLint no-prototype-builtins detection
  reduceDescriptors,
  freezeMethods,
  toObjectSet,
  toCamelCase,
  noop,
  toFiniteNumber,
  findKey,
  global: _global,
  isContextDefined,
  isSpecCompliantForm,
  toJSONObject,
  isAsyncFn,
  isThenable,
  setImmediate: _setImmediate,
  asap
};

/**
 * Create an Error with the specified message, config, error code, request and response.
 *
 * @param {string} message The error message.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [config] The config.
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 *
 * @returns {Error} The created error.
 */
function AxiosError(message, code, config, request, response) {
  Error.call(this);

  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = (new Error()).stack;
  }

  this.message = message;
  this.name = 'AxiosError';
  code && (this.code = code);
  config && (this.config = config);
  request && (this.request = request);
  if (response) {
    this.response = response;
    this.status = response.status ? response.status : null;
  }
}

utils$1.inherits(AxiosError, Error, {
  toJSON: function toJSON() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: utils$1.toJSONObject(this.config),
      code: this.code,
      status: this.status
    };
  }
});

const prototype$1 = AxiosError.prototype;
const descriptors = {};

[
  'ERR_BAD_OPTION_VALUE',
  'ERR_BAD_OPTION',
  'ECONNABORTED',
  'ETIMEDOUT',
  'ERR_NETWORK',
  'ERR_FR_TOO_MANY_REDIRECTS',
  'ERR_DEPRECATED',
  'ERR_BAD_RESPONSE',
  'ERR_BAD_REQUEST',
  'ERR_CANCELED',
  'ERR_NOT_SUPPORT',
  'ERR_INVALID_URL'
// eslint-disable-next-line func-names
].forEach(code => {
  descriptors[code] = {value: code};
});

Object.defineProperties(AxiosError, descriptors);
Object.defineProperty(prototype$1, 'isAxiosError', {value: true});

// eslint-disable-next-line func-names
AxiosError.from = (error, code, config, request, response, customProps) => {
  const axiosError = Object.create(prototype$1);

  utils$1.toFlatObject(error, axiosError, function filter(obj) {
    return obj !== Error.prototype;
  }, prop => {
    return prop !== 'isAxiosError';
  });

  AxiosError.call(axiosError, error.message, code, config, request, response);

  axiosError.cause = error;

  axiosError.name = error.name;

  customProps && Object.assign(axiosError, customProps);

  return axiosError;
};

// eslint-disable-next-line strict
var httpAdapter = null;

/**
 * Determines if the given thing is a array or js object.
 *
 * @param {string} thing - The object or array to be visited.
 *
 * @returns {boolean}
 */
function isVisitable(thing) {
  return utils$1.isPlainObject(thing) || utils$1.isArray(thing);
}

/**
 * It removes the brackets from the end of a string
 *
 * @param {string} key - The key of the parameter.
 *
 * @returns {string} the key without the brackets.
 */
function removeBrackets(key) {
  return utils$1.endsWith(key, '[]') ? key.slice(0, -2) : key;
}

/**
 * It takes a path, a key, and a boolean, and returns a string
 *
 * @param {string} path - The path to the current key.
 * @param {string} key - The key of the current object being iterated over.
 * @param {string} dots - If true, the key will be rendered with dots instead of brackets.
 *
 * @returns {string} The path to the current key.
 */
function renderKey(path, key, dots) {
  if (!path) return key;
  return path.concat(key).map(function each(token, i) {
    // eslint-disable-next-line no-param-reassign
    token = removeBrackets(token);
    return !dots && i ? '[' + token + ']' : token;
  }).join(dots ? '.' : '');
}

/**
 * If the array is an array and none of its elements are visitable, then it's a flat array.
 *
 * @param {Array<any>} arr - The array to check
 *
 * @returns {boolean}
 */
function isFlatArray(arr) {
  return utils$1.isArray(arr) && !arr.some(isVisitable);
}

const predicates = utils$1.toFlatObject(utils$1, {}, null, function filter(prop) {
  return /^is[A-Z]/.test(prop);
});

/**
 * Convert a data object to FormData
 *
 * @param {Object} obj
 * @param {?Object} [formData]
 * @param {?Object} [options]
 * @param {Function} [options.visitor]
 * @param {Boolean} [options.metaTokens = true]
 * @param {Boolean} [options.dots = false]
 * @param {?Boolean} [options.indexes = false]
 *
 * @returns {Object}
 **/

/**
 * It converts an object into a FormData object
 *
 * @param {Object<any, any>} obj - The object to convert to form data.
 * @param {string} formData - The FormData object to append to.
 * @param {Object<string, any>} options
 *
 * @returns
 */
function toFormData(obj, formData, options) {
  if (!utils$1.isObject(obj)) {
    throw new TypeError('target must be an object');
  }

  // eslint-disable-next-line no-param-reassign
  formData = formData || new (FormData)();

  // eslint-disable-next-line no-param-reassign
  options = utils$1.toFlatObject(options, {
    metaTokens: true,
    dots: false,
    indexes: false
  }, false, function defined(option, source) {
    // eslint-disable-next-line no-eq-null,eqeqeq
    return !utils$1.isUndefined(source[option]);
  });

  const metaTokens = options.metaTokens;
  // eslint-disable-next-line no-use-before-define
  const visitor = options.visitor || defaultVisitor;
  const dots = options.dots;
  const indexes = options.indexes;
  const _Blob = options.Blob || typeof Blob !== 'undefined' && Blob;
  const useBlob = _Blob && utils$1.isSpecCompliantForm(formData);

  if (!utils$1.isFunction(visitor)) {
    throw new TypeError('visitor must be a function');
  }

  function convertValue(value) {
    if (value === null) return '';

    if (utils$1.isDate(value)) {
      return value.toISOString();
    }

    if (!useBlob && utils$1.isBlob(value)) {
      throw new AxiosError('Blob is not supported. Use a Buffer instead.');
    }

    if (utils$1.isArrayBuffer(value) || utils$1.isTypedArray(value)) {
      return useBlob && typeof Blob === 'function' ? new Blob([value]) : Buffer.from(value);
    }

    return value;
  }

  /**
   * Default visitor.
   *
   * @param {*} value
   * @param {String|Number} key
   * @param {Array<String|Number>} path
   * @this {FormData}
   *
   * @returns {boolean} return true to visit the each prop of the value recursively
   */
  function defaultVisitor(value, key, path) {
    let arr = value;

    if (value && !path && typeof value === 'object') {
      if (utils$1.endsWith(key, '{}')) {
        // eslint-disable-next-line no-param-reassign
        key = metaTokens ? key : key.slice(0, -2);
        // eslint-disable-next-line no-param-reassign
        value = JSON.stringify(value);
      } else if (
        (utils$1.isArray(value) && isFlatArray(value)) ||
        ((utils$1.isFileList(value) || utils$1.endsWith(key, '[]')) && (arr = utils$1.toArray(value))
        )) {
        // eslint-disable-next-line no-param-reassign
        key = removeBrackets(key);

        arr.forEach(function each(el, index) {
          !(utils$1.isUndefined(el) || el === null) && formData.append(
            // eslint-disable-next-line no-nested-ternary
            indexes === true ? renderKey([key], index, dots) : (indexes === null ? key : key + '[]'),
            convertValue(el)
          );
        });
        return false;
      }
    }

    if (isVisitable(value)) {
      return true;
    }

    formData.append(renderKey(path, key, dots), convertValue(value));

    return false;
  }

  const stack = [];

  const exposedHelpers = Object.assign(predicates, {
    defaultVisitor,
    convertValue,
    isVisitable
  });

  function build(value, path) {
    if (utils$1.isUndefined(value)) return;

    if (stack.indexOf(value) !== -1) {
      throw Error('Circular reference detected in ' + path.join('.'));
    }

    stack.push(value);

    utils$1.forEach(value, function each(el, key) {
      const result = !(utils$1.isUndefined(el) || el === null) && visitor.call(
        formData, el, utils$1.isString(key) ? key.trim() : key, path, exposedHelpers
      );

      if (result === true) {
        build(el, path ? path.concat(key) : [key]);
      }
    });

    stack.pop();
  }

  if (!utils$1.isObject(obj)) {
    throw new TypeError('data must be an object');
  }

  build(obj);

  return formData;
}

/**
 * It encodes a string by replacing all characters that are not in the unreserved set with
 * their percent-encoded equivalents
 *
 * @param {string} str - The string to encode.
 *
 * @returns {string} The encoded string.
 */
function encode$1(str) {
  const charMap = {
    '!': '%21',
    "'": '%27',
    '(': '%28',
    ')': '%29',
    '~': '%7E',
    '%20': '+',
    '%00': '\x00'
  };
  return encodeURIComponent(str).replace(/[!'()~]|%20|%00/g, function replacer(match) {
    return charMap[match];
  });
}

/**
 * It takes a params object and converts it to a FormData object
 *
 * @param {Object<string, any>} params - The parameters to be converted to a FormData object.
 * @param {Object<string, any>} options - The options object passed to the Axios constructor.
 *
 * @returns {void}
 */
function AxiosURLSearchParams(params, options) {
  this._pairs = [];

  params && toFormData(params, this, options);
}

const prototype = AxiosURLSearchParams.prototype;

prototype.append = function append(name, value) {
  this._pairs.push([name, value]);
};

prototype.toString = function toString(encoder) {
  const _encode = encoder ? function(value) {
    return encoder.call(this, value, encode$1);
  } : encode$1;

  return this._pairs.map(function each(pair) {
    return _encode(pair[0]) + '=' + _encode(pair[1]);
  }, '').join('&');
};

/**
 * It replaces all instances of the characters `:`, `$`, `,`, `+`, `[`, and `]` with their
 * URI encoded counterparts
 *
 * @param {string} val The value to be encoded.
 *
 * @returns {string} The encoded value.
 */
function encode(val) {
  return encodeURIComponent(val).
    replace(/%3A/gi, ':').
    replace(/%24/g, '$').
    replace(/%2C/gi, ',').
    replace(/%20/g, '+').
    replace(/%5B/gi, '[').
    replace(/%5D/gi, ']');
}

/**
 * Build a URL by appending params to the end
 *
 * @param {string} url The base of the url (e.g., http://www.google.com)
 * @param {object} [params] The params to be appended
 * @param {?(object|Function)} options
 *
 * @returns {string} The formatted url
 */
function buildURL(url, params, options) {
  /*eslint no-param-reassign:0*/
  if (!params) {
    return url;
  }
  
  const _encode = options && options.encode || encode;

  if (utils$1.isFunction(options)) {
    options = {
      serialize: options
    };
  } 

  const serializeFn = options && options.serialize;

  let serializedParams;

  if (serializeFn) {
    serializedParams = serializeFn(params, options);
  } else {
    serializedParams = utils$1.isURLSearchParams(params) ?
      params.toString() :
      new AxiosURLSearchParams(params, options).toString(_encode);
  }

  if (serializedParams) {
    const hashmarkIndex = url.indexOf("#");

    if (hashmarkIndex !== -1) {
      url = url.slice(0, hashmarkIndex);
    }
    url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
  }

  return url;
}

class InterceptorManager {
  constructor() {
    this.handlers = [];
  }

  /**
   * Add a new interceptor to the stack
   *
   * @param {Function} fulfilled The function to handle `then` for a `Promise`
   * @param {Function} rejected The function to handle `reject` for a `Promise`
   *
   * @return {Number} An ID used to remove interceptor later
   */
  use(fulfilled, rejected, options) {
    this.handlers.push({
      fulfilled,
      rejected,
      synchronous: options ? options.synchronous : false,
      runWhen: options ? options.runWhen : null
    });
    return this.handlers.length - 1;
  }

  /**
   * Remove an interceptor from the stack
   *
   * @param {Number} id The ID that was returned by `use`
   *
   * @returns {Boolean} `true` if the interceptor was removed, `false` otherwise
   */
  eject(id) {
    if (this.handlers[id]) {
      this.handlers[id] = null;
    }
  }

  /**
   * Clear all interceptors from the stack
   *
   * @returns {void}
   */
  clear() {
    if (this.handlers) {
      this.handlers = [];
    }
  }

  /**
   * Iterate over all the registered interceptors
   *
   * This method is particularly useful for skipping over any
   * interceptors that may have become `null` calling `eject`.
   *
   * @param {Function} fn The function to call for each interceptor
   *
   * @returns {void}
   */
  forEach(fn) {
    utils$1.forEach(this.handlers, function forEachHandler(h) {
      if (h !== null) {
        fn(h);
      }
    });
  }
}

var InterceptorManager$1 = InterceptorManager;

var transitionalDefaults = {
  silentJSONParsing: true,
  forcedJSONParsing: true,
  clarifyTimeoutError: false
};

var URLSearchParams$1 = typeof URLSearchParams !== 'undefined' ? URLSearchParams : AxiosURLSearchParams;

var FormData$1 = typeof FormData !== 'undefined' ? FormData : null;

var Blob$1 = typeof Blob !== 'undefined' ? Blob : null;

var platform$1 = {
  isBrowser: true,
  classes: {
    URLSearchParams: URLSearchParams$1,
    FormData: FormData$1,
    Blob: Blob$1
  },
  protocols: ['http', 'https', 'file', 'blob', 'url', 'data']
};

const hasBrowserEnv = typeof window !== 'undefined' && typeof document !== 'undefined';

const _navigator = typeof navigator === 'object' && navigator || undefined;

/**
 * Determine if we're running in a standard browser environment
 *
 * This allows axios to run in a web worker, and react-native.
 * Both environments support XMLHttpRequest, but not fully standard globals.
 *
 * web workers:
 *  typeof window -> undefined
 *  typeof document -> undefined
 *
 * react-native:
 *  navigator.product -> 'ReactNative'
 * nativescript
 *  navigator.product -> 'NativeScript' or 'NS'
 *
 * @returns {boolean}
 */
const hasStandardBrowserEnv = hasBrowserEnv &&
  (!_navigator || ['ReactNative', 'NativeScript', 'NS'].indexOf(_navigator.product) < 0);

/**
 * Determine if we're running in a standard browser webWorker environment
 *
 * Although the `isStandardBrowserEnv` method indicates that
 * `allows axios to run in a web worker`, the WebWorker will still be
 * filtered out due to its judgment standard
 * `typeof window !== 'undefined' && typeof document !== 'undefined'`.
 * This leads to a problem when axios post `FormData` in webWorker
 */
const hasStandardBrowserWebWorkerEnv = (() => {
  return (
    typeof WorkerGlobalScope !== 'undefined' &&
    // eslint-disable-next-line no-undef
    self instanceof WorkerGlobalScope &&
    typeof self.importScripts === 'function'
  );
})();

const origin = hasBrowserEnv && window.location.href || 'http://localhost';

var utils = /*#__PURE__*/Object.freeze({
  __proto__: null,
  hasBrowserEnv: hasBrowserEnv,
  hasStandardBrowserWebWorkerEnv: hasStandardBrowserWebWorkerEnv,
  hasStandardBrowserEnv: hasStandardBrowserEnv,
  navigator: _navigator,
  origin: origin
});

var platform = {
  ...utils,
  ...platform$1
};

function toURLEncodedForm(data, options) {
  return toFormData(data, new platform.classes.URLSearchParams(), Object.assign({
    visitor: function(value, key, path, helpers) {
      if (platform.isNode && utils$1.isBuffer(value)) {
        this.append(key, value.toString('base64'));
        return false;
      }

      return helpers.defaultVisitor.apply(this, arguments);
    }
  }, options));
}

/**
 * It takes a string like `foo[x][y][z]` and returns an array like `['foo', 'x', 'y', 'z']
 *
 * @param {string} name - The name of the property to get.
 *
 * @returns An array of strings.
 */
function parsePropPath(name) {
  // foo[x][y][z]
  // foo.x.y.z
  // foo-x-y-z
  // foo x y z
  return utils$1.matchAll(/\w+|\[(\w*)]/g, name).map(match => {
    return match[0] === '[]' ? '' : match[1] || match[0];
  });
}

/**
 * Convert an array to an object.
 *
 * @param {Array<any>} arr - The array to convert to an object.
 *
 * @returns An object with the same keys and values as the array.
 */
function arrayToObject(arr) {
  const obj = {};
  const keys = Object.keys(arr);
  let i;
  const len = keys.length;
  let key;
  for (i = 0; i < len; i++) {
    key = keys[i];
    obj[key] = arr[key];
  }
  return obj;
}

/**
 * It takes a FormData object and returns a JavaScript object
 *
 * @param {string} formData The FormData object to convert to JSON.
 *
 * @returns {Object<string, any> | null} The converted object.
 */
function formDataToJSON(formData) {
  function buildPath(path, value, target, index) {
    let name = path[index++];

    if (name === '__proto__') return true;

    const isNumericKey = Number.isFinite(+name);
    const isLast = index >= path.length;
    name = !name && utils$1.isArray(target) ? target.length : name;

    if (isLast) {
      if (utils$1.hasOwnProp(target, name)) {
        target[name] = [target[name], value];
      } else {
        target[name] = value;
      }

      return !isNumericKey;
    }

    if (!target[name] || !utils$1.isObject(target[name])) {
      target[name] = [];
    }

    const result = buildPath(path, value, target[name], index);

    if (result && utils$1.isArray(target[name])) {
      target[name] = arrayToObject(target[name]);
    }

    return !isNumericKey;
  }

  if (utils$1.isFormData(formData) && utils$1.isFunction(formData.entries)) {
    const obj = {};

    utils$1.forEachEntry(formData, (name, value) => {
      buildPath(parsePropPath(name), value, obj, 0);
    });

    return obj;
  }

  return null;
}

/**
 * It takes a string, tries to parse it, and if it fails, it returns the stringified version
 * of the input
 *
 * @param {any} rawValue - The value to be stringified.
 * @param {Function} parser - A function that parses a string into a JavaScript object.
 * @param {Function} encoder - A function that takes a value and returns a string.
 *
 * @returns {string} A stringified version of the rawValue.
 */
function stringifySafely(rawValue, parser, encoder) {
  if (utils$1.isString(rawValue)) {
    try {
      (parser || JSON.parse)(rawValue);
      return utils$1.trim(rawValue);
    } catch (e) {
      if (e.name !== 'SyntaxError') {
        throw e;
      }
    }
  }

  return (encoder || JSON.stringify)(rawValue);
}

const defaults = {

  transitional: transitionalDefaults,

  adapter: ['xhr', 'http', 'fetch'],

  transformRequest: [function transformRequest(data, headers) {
    const contentType = headers.getContentType() || '';
    const hasJSONContentType = contentType.indexOf('application/json') > -1;
    const isObjectPayload = utils$1.isObject(data);

    if (isObjectPayload && utils$1.isHTMLForm(data)) {
      data = new FormData(data);
    }

    const isFormData = utils$1.isFormData(data);

    if (isFormData) {
      return hasJSONContentType ? JSON.stringify(formDataToJSON(data)) : data;
    }

    if (utils$1.isArrayBuffer(data) ||
      utils$1.isBuffer(data) ||
      utils$1.isStream(data) ||
      utils$1.isFile(data) ||
      utils$1.isBlob(data) ||
      utils$1.isReadableStream(data)
    ) {
      return data;
    }
    if (utils$1.isArrayBufferView(data)) {
      return data.buffer;
    }
    if (utils$1.isURLSearchParams(data)) {
      headers.setContentType('application/x-www-form-urlencoded;charset=utf-8', false);
      return data.toString();
    }

    let isFileList;

    if (isObjectPayload) {
      if (contentType.indexOf('application/x-www-form-urlencoded') > -1) {
        return toURLEncodedForm(data, this.formSerializer).toString();
      }

      if ((isFileList = utils$1.isFileList(data)) || contentType.indexOf('multipart/form-data') > -1) {
        const _FormData = this.env && this.env.FormData;

        return toFormData(
          isFileList ? {'files[]': data} : data,
          _FormData && new _FormData(),
          this.formSerializer
        );
      }
    }

    if (isObjectPayload || hasJSONContentType ) {
      headers.setContentType('application/json', false);
      return stringifySafely(data);
    }

    return data;
  }],

  transformResponse: [function transformResponse(data) {
    const transitional = this.transitional || defaults.transitional;
    const forcedJSONParsing = transitional && transitional.forcedJSONParsing;
    const JSONRequested = this.responseType === 'json';

    if (utils$1.isResponse(data) || utils$1.isReadableStream(data)) {
      return data;
    }

    if (data && utils$1.isString(data) && ((forcedJSONParsing && !this.responseType) || JSONRequested)) {
      const silentJSONParsing = transitional && transitional.silentJSONParsing;
      const strictJSONParsing = !silentJSONParsing && JSONRequested;

      try {
        return JSON.parse(data);
      } catch (e) {
        if (strictJSONParsing) {
          if (e.name === 'SyntaxError') {
            throw AxiosError.from(e, AxiosError.ERR_BAD_RESPONSE, this, null, this.response);
          }
          throw e;
        }
      }
    }

    return data;
  }],

  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,

  xsrfCookieName: 'XSRF-TOKEN',
  xsrfHeaderName: 'X-XSRF-TOKEN',

  maxContentLength: -1,
  maxBodyLength: -1,

  env: {
    FormData: platform.classes.FormData,
    Blob: platform.classes.Blob
  },

  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  },

  headers: {
    common: {
      'Accept': 'application/json, text/plain, */*',
      'Content-Type': undefined
    }
  }
};

utils$1.forEach(['delete', 'get', 'head', 'post', 'put', 'patch'], (method) => {
  defaults.headers[method] = {};
});

var defaults$1 = defaults;

// RawAxiosHeaders whose duplicates are ignored by node
// c.f. https://nodejs.org/api/http.html#http_message_headers
const ignoreDuplicateOf = utils$1.toObjectSet([
  'age', 'authorization', 'content-length', 'content-type', 'etag',
  'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since',
  'last-modified', 'location', 'max-forwards', 'proxy-authorization',
  'referer', 'retry-after', 'user-agent'
]);

/**
 * Parse headers into an object
 *
 * ```
 * Date: Wed, 27 Aug 2014 08:58:49 GMT
 * Content-Type: application/json
 * Connection: keep-alive
 * Transfer-Encoding: chunked
 * ```
 *
 * @param {String} rawHeaders Headers needing to be parsed
 *
 * @returns {Object} Headers parsed into an object
 */
var parseHeaders = rawHeaders => {
  const parsed = {};
  let key;
  let val;
  let i;

  rawHeaders && rawHeaders.split('\n').forEach(function parser(line) {
    i = line.indexOf(':');
    key = line.substring(0, i).trim().toLowerCase();
    val = line.substring(i + 1).trim();

    if (!key || (parsed[key] && ignoreDuplicateOf[key])) {
      return;
    }

    if (key === 'set-cookie') {
      if (parsed[key]) {
        parsed[key].push(val);
      } else {
        parsed[key] = [val];
      }
    } else {
      parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
    }
  });

  return parsed;
};

const $internals = Symbol('internals');

function normalizeHeader(header) {
  return header && String(header).trim().toLowerCase();
}

function normalizeValue(value) {
  if (value === false || value == null) {
    return value;
  }

  return utils$1.isArray(value) ? value.map(normalizeValue) : String(value);
}

function parseTokens(str) {
  const tokens = Object.create(null);
  const tokensRE = /([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;
  let match;

  while ((match = tokensRE.exec(str))) {
    tokens[match[1]] = match[2];
  }

  return tokens;
}

const isValidHeaderName = (str) => /^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(str.trim());

function matchHeaderValue(context, value, header, filter, isHeaderNameFilter) {
  if (utils$1.isFunction(filter)) {
    return filter.call(this, value, header);
  }

  if (isHeaderNameFilter) {
    value = header;
  }

  if (!utils$1.isString(value)) return;

  if (utils$1.isString(filter)) {
    return value.indexOf(filter) !== -1;
  }

  if (utils$1.isRegExp(filter)) {
    return filter.test(value);
  }
}

function formatHeader(header) {
  return header.trim()
    .toLowerCase().replace(/([a-z\d])(\w*)/g, (w, char, str) => {
      return char.toUpperCase() + str;
    });
}

function buildAccessors(obj, header) {
  const accessorName = utils$1.toCamelCase(' ' + header);

  ['get', 'set', 'has'].forEach(methodName => {
    Object.defineProperty(obj, methodName + accessorName, {
      value: function(arg1, arg2, arg3) {
        return this[methodName].call(this, header, arg1, arg2, arg3);
      },
      configurable: true
    });
  });
}

class AxiosHeaders {
  constructor(headers) {
    headers && this.set(headers);
  }

  set(header, valueOrRewrite, rewrite) {
    const self = this;

    function setHeader(_value, _header, _rewrite) {
      const lHeader = normalizeHeader(_header);

      if (!lHeader) {
        throw new Error('header name must be a non-empty string');
      }

      const key = utils$1.findKey(self, lHeader);

      if(!key || self[key] === undefined || _rewrite === true || (_rewrite === undefined && self[key] !== false)) {
        self[key || _header] = normalizeValue(_value);
      }
    }

    const setHeaders = (headers, _rewrite) =>
      utils$1.forEach(headers, (_value, _header) => setHeader(_value, _header, _rewrite));

    if (utils$1.isPlainObject(header) || header instanceof this.constructor) {
      setHeaders(header, valueOrRewrite);
    } else if(utils$1.isString(header) && (header = header.trim()) && !isValidHeaderName(header)) {
      setHeaders(parseHeaders(header), valueOrRewrite);
    } else if (utils$1.isHeaders(header)) {
      for (const [key, value] of header.entries()) {
        setHeader(value, key, rewrite);
      }
    } else {
      header != null && setHeader(valueOrRewrite, header, rewrite);
    }

    return this;
  }

  get(header, parser) {
    header = normalizeHeader(header);

    if (header) {
      const key = utils$1.findKey(this, header);

      if (key) {
        const value = this[key];

        if (!parser) {
          return value;
        }

        if (parser === true) {
          return parseTokens(value);
        }

        if (utils$1.isFunction(parser)) {
          return parser.call(this, value, key);
        }

        if (utils$1.isRegExp(parser)) {
          return parser.exec(value);
        }

        throw new TypeError('parser must be boolean|regexp|function');
      }
    }
  }

  has(header, matcher) {
    header = normalizeHeader(header);

    if (header) {
      const key = utils$1.findKey(this, header);

      return !!(key && this[key] !== undefined && (!matcher || matchHeaderValue(this, this[key], key, matcher)));
    }

    return false;
  }

  delete(header, matcher) {
    const self = this;
    let deleted = false;

    function deleteHeader(_header) {
      _header = normalizeHeader(_header);

      if (_header) {
        const key = utils$1.findKey(self, _header);

        if (key && (!matcher || matchHeaderValue(self, self[key], key, matcher))) {
          delete self[key];

          deleted = true;
        }
      }
    }

    if (utils$1.isArray(header)) {
      header.forEach(deleteHeader);
    } else {
      deleteHeader(header);
    }

    return deleted;
  }

  clear(matcher) {
    const keys = Object.keys(this);
    let i = keys.length;
    let deleted = false;

    while (i--) {
      const key = keys[i];
      if(!matcher || matchHeaderValue(this, this[key], key, matcher, true)) {
        delete this[key];
        deleted = true;
      }
    }

    return deleted;
  }

  normalize(format) {
    const self = this;
    const headers = {};

    utils$1.forEach(this, (value, header) => {
      const key = utils$1.findKey(headers, header);

      if (key) {
        self[key] = normalizeValue(value);
        delete self[header];
        return;
      }

      const normalized = format ? formatHeader(header) : String(header).trim();

      if (normalized !== header) {
        delete self[header];
      }

      self[normalized] = normalizeValue(value);

      headers[normalized] = true;
    });

    return this;
  }

  concat(...targets) {
    return this.constructor.concat(this, ...targets);
  }

  toJSON(asStrings) {
    const obj = Object.create(null);

    utils$1.forEach(this, (value, header) => {
      value != null && value !== false && (obj[header] = asStrings && utils$1.isArray(value) ? value.join(', ') : value);
    });

    return obj;
  }

  [Symbol.iterator]() {
    return Object.entries(this.toJSON())[Symbol.iterator]();
  }

  toString() {
    return Object.entries(this.toJSON()).map(([header, value]) => header + ': ' + value).join('\n');
  }

  get [Symbol.toStringTag]() {
    return 'AxiosHeaders';
  }

  static from(thing) {
    return thing instanceof this ? thing : new this(thing);
  }

  static concat(first, ...targets) {
    const computed = new this(first);

    targets.forEach((target) => computed.set(target));

    return computed;
  }

  static accessor(header) {
    const internals = this[$internals] = (this[$internals] = {
      accessors: {}
    });

    const accessors = internals.accessors;
    const prototype = this.prototype;

    function defineAccessor(_header) {
      const lHeader = normalizeHeader(_header);

      if (!accessors[lHeader]) {
        buildAccessors(prototype, _header);
        accessors[lHeader] = true;
      }
    }

    utils$1.isArray(header) ? header.forEach(defineAccessor) : defineAccessor(header);

    return this;
  }
}

AxiosHeaders.accessor(['Content-Type', 'Content-Length', 'Accept', 'Accept-Encoding', 'User-Agent', 'Authorization']);

// reserved names hotfix
utils$1.reduceDescriptors(AxiosHeaders.prototype, ({value}, key) => {
  let mapped = key[0].toUpperCase() + key.slice(1); // map `set` => `Set`
  return {
    get: () => value,
    set(headerValue) {
      this[mapped] = headerValue;
    }
  }
});

utils$1.freezeMethods(AxiosHeaders);

var AxiosHeaders$1 = AxiosHeaders;

/**
 * Transform the data for a request or a response
 *
 * @param {Array|Function} fns A single function or Array of functions
 * @param {?Object} response The response object
 *
 * @returns {*} The resulting transformed data
 */
function transformData(fns, response) {
  const config = this || defaults$1;
  const context = response || config;
  const headers = AxiosHeaders$1.from(context.headers);
  let data = context.data;

  utils$1.forEach(fns, function transform(fn) {
    data = fn.call(config, data, headers.normalize(), response ? response.status : undefined);
  });

  headers.normalize();

  return data;
}

function isCancel(value) {
  return !!(value && value.__CANCEL__);
}

/**
 * A `CanceledError` is an object that is thrown when an operation is canceled.
 *
 * @param {string=} message The message.
 * @param {Object=} config The config.
 * @param {Object=} request The request.
 *
 * @returns {CanceledError} The created error.
 */
function CanceledError(message, config, request) {
  // eslint-disable-next-line no-eq-null,eqeqeq
  AxiosError.call(this, message == null ? 'canceled' : message, AxiosError.ERR_CANCELED, config, request);
  this.name = 'CanceledError';
}

utils$1.inherits(CanceledError, AxiosError, {
  __CANCEL__: true
});

/**
 * Resolve or reject a Promise based on response status.
 *
 * @param {Function} resolve A function that resolves the promise.
 * @param {Function} reject A function that rejects the promise.
 * @param {object} response The response.
 *
 * @returns {object} The response.
 */
function settle(resolve, reject, response) {
  const validateStatus = response.config.validateStatus;
  if (!response.status || !validateStatus || validateStatus(response.status)) {
    resolve(response);
  } else {
    reject(new AxiosError(
      'Request failed with status code ' + response.status,
      [AxiosError.ERR_BAD_REQUEST, AxiosError.ERR_BAD_RESPONSE][Math.floor(response.status / 100) - 4],
      response.config,
      response.request,
      response
    ));
  }
}

function parseProtocol(url) {
  const match = /^([-+\w]{1,25})(:?\/\/|:)/.exec(url);
  return match && match[1] || '';
}

/**
 * Calculate data maxRate
 * @param {Number} [samplesCount= 10]
 * @param {Number} [min= 1000]
 * @returns {Function}
 */
function speedometer(samplesCount, min) {
  samplesCount = samplesCount || 10;
  const bytes = new Array(samplesCount);
  const timestamps = new Array(samplesCount);
  let head = 0;
  let tail = 0;
  let firstSampleTS;

  min = min !== undefined ? min : 1000;

  return function push(chunkLength) {
    const now = Date.now();

    const startedAt = timestamps[tail];

    if (!firstSampleTS) {
      firstSampleTS = now;
    }

    bytes[head] = chunkLength;
    timestamps[head] = now;

    let i = tail;
    let bytesCount = 0;

    while (i !== head) {
      bytesCount += bytes[i++];
      i = i % samplesCount;
    }

    head = (head + 1) % samplesCount;

    if (head === tail) {
      tail = (tail + 1) % samplesCount;
    }

    if (now - firstSampleTS < min) {
      return;
    }

    const passed = startedAt && now - startedAt;

    return passed ? Math.round(bytesCount * 1000 / passed) : undefined;
  };
}

/**
 * Throttle decorator
 * @param {Function} fn
 * @param {Number} freq
 * @return {Function}
 */
function throttle$1(fn, freq) {
  let timestamp = 0;
  let threshold = 1000 / freq;
  let lastArgs;
  let timer;

  const invoke = (args, now = Date.now()) => {
    timestamp = now;
    lastArgs = null;
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
    fn.apply(null, args);
  };

  const throttled = (...args) => {
    const now = Date.now();
    const passed = now - timestamp;
    if ( passed >= threshold) {
      invoke(args, now);
    } else {
      lastArgs = args;
      if (!timer) {
        timer = setTimeout(() => {
          timer = null;
          invoke(lastArgs);
        }, threshold - passed);
      }
    }
  };

  const flush = () => lastArgs && invoke(lastArgs);

  return [throttled, flush];
}

const progressEventReducer = (listener, isDownloadStream, freq = 3) => {
  let bytesNotified = 0;
  const _speedometer = speedometer(50, 250);

  return throttle$1(e => {
    const loaded = e.loaded;
    const total = e.lengthComputable ? e.total : undefined;
    const progressBytes = loaded - bytesNotified;
    const rate = _speedometer(progressBytes);
    const inRange = loaded <= total;

    bytesNotified = loaded;

    const data = {
      loaded,
      total,
      progress: total ? (loaded / total) : undefined,
      bytes: progressBytes,
      rate: rate ? rate : undefined,
      estimated: rate && total && inRange ? (total - loaded) / rate : undefined,
      event: e,
      lengthComputable: total != null,
      [isDownloadStream ? 'download' : 'upload']: true
    };

    listener(data);
  }, freq);
};

const progressEventDecorator = (total, throttled) => {
  const lengthComputable = total != null;

  return [(loaded) => throttled[0]({
    lengthComputable,
    total,
    loaded
  }), throttled[1]];
};

const asyncDecorator = (fn) => (...args) => utils$1.asap(() => fn(...args));

var isURLSameOrigin = platform.hasStandardBrowserEnv ? ((origin, isMSIE) => (url) => {
  url = new URL(url, platform.origin);

  return (
    origin.protocol === url.protocol &&
    origin.host === url.host &&
    (isMSIE || origin.port === url.port)
  );
})(
  new URL(platform.origin),
  platform.navigator && /(msie|trident)/i.test(platform.navigator.userAgent)
) : () => true;

var cookies = platform.hasStandardBrowserEnv ?

  // Standard browser envs support document.cookie
  {
    write(name, value, expires, path, domain, secure) {
      const cookie = [name + '=' + encodeURIComponent(value)];

      utils$1.isNumber(expires) && cookie.push('expires=' + new Date(expires).toGMTString());

      utils$1.isString(path) && cookie.push('path=' + path);

      utils$1.isString(domain) && cookie.push('domain=' + domain);

      secure === true && cookie.push('secure');

      document.cookie = cookie.join('; ');
    },

    read(name) {
      const match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
      return (match ? decodeURIComponent(match[3]) : null);
    },

    remove(name) {
      this.write(name, '', Date.now() - 86400000);
    }
  }

  :

  // Non-standard browser env (web workers, react-native) lack needed support.
  {
    write() {},
    read() {
      return null;
    },
    remove() {}
  };

/**
 * Determines whether the specified URL is absolute
 *
 * @param {string} url The URL to test
 *
 * @returns {boolean} True if the specified URL is absolute, otherwise false
 */
function isAbsoluteURL(url) {
  // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
  // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
  // by any combination of letters, digits, plus, period, or hyphen.
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
}

/**
 * Creates a new URL by combining the specified URLs
 *
 * @param {string} baseURL The base URL
 * @param {string} relativeURL The relative URL
 *
 * @returns {string} The combined URL
 */
function combineURLs(baseURL, relativeURL) {
  return relativeURL
    ? baseURL.replace(/\/?\/$/, '') + '/' + relativeURL.replace(/^\/+/, '')
    : baseURL;
}

/**
 * Creates a new URL by combining the baseURL with the requestedURL,
 * only when the requestedURL is not already an absolute URL.
 * If the requestURL is absolute, this function returns the requestedURL untouched.
 *
 * @param {string} baseURL The base URL
 * @param {string} requestedURL Absolute or relative URL to combine
 *
 * @returns {string} The combined full path
 */
function buildFullPath(baseURL, requestedURL, allowAbsoluteUrls) {
  let isRelativeUrl = !isAbsoluteURL(requestedURL);
  if (baseURL && isRelativeUrl || allowAbsoluteUrls == false) {
    return combineURLs(baseURL, requestedURL);
  }
  return requestedURL;
}

const headersToObject = (thing) => thing instanceof AxiosHeaders$1 ? { ...thing } : thing;

/**
 * Config-specific merge-function which creates a new config-object
 * by merging two configuration objects together.
 *
 * @param {Object} config1
 * @param {Object} config2
 *
 * @returns {Object} New object resulting from merging config2 to config1
 */
function mergeConfig(config1, config2) {
  // eslint-disable-next-line no-param-reassign
  config2 = config2 || {};
  const config = {};

  function getMergedValue(target, source, prop, caseless) {
    if (utils$1.isPlainObject(target) && utils$1.isPlainObject(source)) {
      return utils$1.merge.call({caseless}, target, source);
    } else if (utils$1.isPlainObject(source)) {
      return utils$1.merge({}, source);
    } else if (utils$1.isArray(source)) {
      return source.slice();
    }
    return source;
  }

  // eslint-disable-next-line consistent-return
  function mergeDeepProperties(a, b, prop , caseless) {
    if (!utils$1.isUndefined(b)) {
      return getMergedValue(a, b, prop , caseless);
    } else if (!utils$1.isUndefined(a)) {
      return getMergedValue(undefined, a, prop , caseless);
    }
  }

  // eslint-disable-next-line consistent-return
  function valueFromConfig2(a, b) {
    if (!utils$1.isUndefined(b)) {
      return getMergedValue(undefined, b);
    }
  }

  // eslint-disable-next-line consistent-return
  function defaultToConfig2(a, b) {
    if (!utils$1.isUndefined(b)) {
      return getMergedValue(undefined, b);
    } else if (!utils$1.isUndefined(a)) {
      return getMergedValue(undefined, a);
    }
  }

  // eslint-disable-next-line consistent-return
  function mergeDirectKeys(a, b, prop) {
    if (prop in config2) {
      return getMergedValue(a, b);
    } else if (prop in config1) {
      return getMergedValue(undefined, a);
    }
  }

  const mergeMap = {
    url: valueFromConfig2,
    method: valueFromConfig2,
    data: valueFromConfig2,
    baseURL: defaultToConfig2,
    transformRequest: defaultToConfig2,
    transformResponse: defaultToConfig2,
    paramsSerializer: defaultToConfig2,
    timeout: defaultToConfig2,
    timeoutMessage: defaultToConfig2,
    withCredentials: defaultToConfig2,
    withXSRFToken: defaultToConfig2,
    adapter: defaultToConfig2,
    responseType: defaultToConfig2,
    xsrfCookieName: defaultToConfig2,
    xsrfHeaderName: defaultToConfig2,
    onUploadProgress: defaultToConfig2,
    onDownloadProgress: defaultToConfig2,
    decompress: defaultToConfig2,
    maxContentLength: defaultToConfig2,
    maxBodyLength: defaultToConfig2,
    beforeRedirect: defaultToConfig2,
    transport: defaultToConfig2,
    httpAgent: defaultToConfig2,
    httpsAgent: defaultToConfig2,
    cancelToken: defaultToConfig2,
    socketPath: defaultToConfig2,
    responseEncoding: defaultToConfig2,
    validateStatus: mergeDirectKeys,
    headers: (a, b , prop) => mergeDeepProperties(headersToObject(a), headersToObject(b),prop, true)
  };

  utils$1.forEach(Object.keys(Object.assign({}, config1, config2)), function computeConfigValue(prop) {
    const merge = mergeMap[prop] || mergeDeepProperties;
    const configValue = merge(config1[prop], config2[prop], prop);
    (utils$1.isUndefined(configValue) && merge !== mergeDirectKeys) || (config[prop] = configValue);
  });

  return config;
}

var resolveConfig = (config) => {
  const newConfig = mergeConfig({}, config);

  let {data, withXSRFToken, xsrfHeaderName, xsrfCookieName, headers, auth} = newConfig;

  newConfig.headers = headers = AxiosHeaders$1.from(headers);

  newConfig.url = buildURL(buildFullPath(newConfig.baseURL, newConfig.url), config.params, config.paramsSerializer);

  // HTTP basic authentication
  if (auth) {
    headers.set('Authorization', 'Basic ' +
      btoa((auth.username || '') + ':' + (auth.password ? unescape(encodeURIComponent(auth.password)) : ''))
    );
  }

  let contentType;

  if (utils$1.isFormData(data)) {
    if (platform.hasStandardBrowserEnv || platform.hasStandardBrowserWebWorkerEnv) {
      headers.setContentType(undefined); // Let the browser set it
    } else if ((contentType = headers.getContentType()) !== false) {
      // fix semicolon duplication issue for ReactNative FormData implementation
      const [type, ...tokens] = contentType ? contentType.split(';').map(token => token.trim()).filter(Boolean) : [];
      headers.setContentType([type || 'multipart/form-data', ...tokens].join('; '));
    }
  }

  // Add xsrf header
  // This is only done if running in a standard browser environment.
  // Specifically not if we're in a web worker, or react-native.

  if (platform.hasStandardBrowserEnv) {
    withXSRFToken && utils$1.isFunction(withXSRFToken) && (withXSRFToken = withXSRFToken(newConfig));

    if (withXSRFToken || (withXSRFToken !== false && isURLSameOrigin(newConfig.url))) {
      // Add xsrf header
      const xsrfValue = xsrfHeaderName && xsrfCookieName && cookies.read(xsrfCookieName);

      if (xsrfValue) {
        headers.set(xsrfHeaderName, xsrfValue);
      }
    }
  }

  return newConfig;
};

const isXHRAdapterSupported = typeof XMLHttpRequest !== 'undefined';

var xhrAdapter = isXHRAdapterSupported && function (config) {
  return new Promise(function dispatchXhrRequest(resolve, reject) {
    const _config = resolveConfig(config);
    let requestData = _config.data;
    const requestHeaders = AxiosHeaders$1.from(_config.headers).normalize();
    let {responseType, onUploadProgress, onDownloadProgress} = _config;
    let onCanceled;
    let uploadThrottled, downloadThrottled;
    let flushUpload, flushDownload;

    function done() {
      flushUpload && flushUpload(); // flush events
      flushDownload && flushDownload(); // flush events

      _config.cancelToken && _config.cancelToken.unsubscribe(onCanceled);

      _config.signal && _config.signal.removeEventListener('abort', onCanceled);
    }

    let request = new XMLHttpRequest();

    request.open(_config.method.toUpperCase(), _config.url, true);

    // Set the request timeout in MS
    request.timeout = _config.timeout;

    function onloadend() {
      if (!request) {
        return;
      }
      // Prepare the response
      const responseHeaders = AxiosHeaders$1.from(
        'getAllResponseHeaders' in request && request.getAllResponseHeaders()
      );
      const responseData = !responseType || responseType === 'text' || responseType === 'json' ?
        request.responseText : request.response;
      const response = {
        data: responseData,
        status: request.status,
        statusText: request.statusText,
        headers: responseHeaders,
        config,
        request
      };

      settle(function _resolve(value) {
        resolve(value);
        done();
      }, function _reject(err) {
        reject(err);
        done();
      }, response);

      // Clean up request
      request = null;
    }

    if ('onloadend' in request) {
      // Use onloadend if available
      request.onloadend = onloadend;
    } else {
      // Listen for ready state to emulate onloadend
      request.onreadystatechange = function handleLoad() {
        if (!request || request.readyState !== 4) {
          return;
        }

        // The request errored out and we didn't get a response, this will be
        // handled by onerror instead
        // With one exception: request that using file: protocol, most browsers
        // will return status as 0 even though it's a successful request
        if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
          return;
        }
        // readystate handler is calling before onerror or ontimeout handlers,
        // so we should call onloadend on the next 'tick'
        setTimeout(onloadend);
      };
    }

    // Handle browser request cancellation (as opposed to a manual cancellation)
    request.onabort = function handleAbort() {
      if (!request) {
        return;
      }

      reject(new AxiosError('Request aborted', AxiosError.ECONNABORTED, config, request));

      // Clean up request
      request = null;
    };

    // Handle low level network errors
    request.onerror = function handleError() {
      // Real errors are hidden from us by the browser
      // onerror should only fire if it's a network error
      reject(new AxiosError('Network Error', AxiosError.ERR_NETWORK, config, request));

      // Clean up request
      request = null;
    };

    // Handle timeout
    request.ontimeout = function handleTimeout() {
      let timeoutErrorMessage = _config.timeout ? 'timeout of ' + _config.timeout + 'ms exceeded' : 'timeout exceeded';
      const transitional = _config.transitional || transitionalDefaults;
      if (_config.timeoutErrorMessage) {
        timeoutErrorMessage = _config.timeoutErrorMessage;
      }
      reject(new AxiosError(
        timeoutErrorMessage,
        transitional.clarifyTimeoutError ? AxiosError.ETIMEDOUT : AxiosError.ECONNABORTED,
        config,
        request));

      // Clean up request
      request = null;
    };

    // Remove Content-Type if data is undefined
    requestData === undefined && requestHeaders.setContentType(null);

    // Add headers to the request
    if ('setRequestHeader' in request) {
      utils$1.forEach(requestHeaders.toJSON(), function setRequestHeader(val, key) {
        request.setRequestHeader(key, val);
      });
    }

    // Add withCredentials to request if needed
    if (!utils$1.isUndefined(_config.withCredentials)) {
      request.withCredentials = !!_config.withCredentials;
    }

    // Add responseType to request if needed
    if (responseType && responseType !== 'json') {
      request.responseType = _config.responseType;
    }

    // Handle progress if needed
    if (onDownloadProgress) {
      ([downloadThrottled, flushDownload] = progressEventReducer(onDownloadProgress, true));
      request.addEventListener('progress', downloadThrottled);
    }

    // Not all browsers support upload events
    if (onUploadProgress && request.upload) {
      ([uploadThrottled, flushUpload] = progressEventReducer(onUploadProgress));

      request.upload.addEventListener('progress', uploadThrottled);

      request.upload.addEventListener('loadend', flushUpload);
    }

    if (_config.cancelToken || _config.signal) {
      // Handle cancellation
      // eslint-disable-next-line func-names
      onCanceled = cancel => {
        if (!request) {
          return;
        }
        reject(!cancel || cancel.type ? new CanceledError(null, config, request) : cancel);
        request.abort();
        request = null;
      };

      _config.cancelToken && _config.cancelToken.subscribe(onCanceled);
      if (_config.signal) {
        _config.signal.aborted ? onCanceled() : _config.signal.addEventListener('abort', onCanceled);
      }
    }

    const protocol = parseProtocol(_config.url);

    if (protocol && platform.protocols.indexOf(protocol) === -1) {
      reject(new AxiosError('Unsupported protocol ' + protocol + ':', AxiosError.ERR_BAD_REQUEST, config));
      return;
    }


    // Send the request
    request.send(requestData || null);
  });
};

const composeSignals = (signals, timeout) => {
  const {length} = (signals = signals ? signals.filter(Boolean) : []);

  if (timeout || length) {
    let controller = new AbortController();

    let aborted;

    const onabort = function (reason) {
      if (!aborted) {
        aborted = true;
        unsubscribe();
        const err = reason instanceof Error ? reason : this.reason;
        controller.abort(err instanceof AxiosError ? err : new CanceledError(err instanceof Error ? err.message : err));
      }
    };

    let timer = timeout && setTimeout(() => {
      timer = null;
      onabort(new AxiosError(`timeout ${timeout} of ms exceeded`, AxiosError.ETIMEDOUT));
    }, timeout);

    const unsubscribe = () => {
      if (signals) {
        timer && clearTimeout(timer);
        timer = null;
        signals.forEach(signal => {
          signal.unsubscribe ? signal.unsubscribe(onabort) : signal.removeEventListener('abort', onabort);
        });
        signals = null;
      }
    };

    signals.forEach((signal) => signal.addEventListener('abort', onabort));

    const {signal} = controller;

    signal.unsubscribe = () => utils$1.asap(unsubscribe);

    return signal;
  }
};

var composeSignals$1 = composeSignals;

const streamChunk = function* (chunk, chunkSize) {
  let len = chunk.byteLength;

  if (!chunkSize || len < chunkSize) {
    yield chunk;
    return;
  }

  let pos = 0;
  let end;

  while (pos < len) {
    end = pos + chunkSize;
    yield chunk.slice(pos, end);
    pos = end;
  }
};

const readBytes = async function* (iterable, chunkSize) {
  for await (const chunk of readStream(iterable)) {
    yield* streamChunk(chunk, chunkSize);
  }
};

const readStream = async function* (stream) {
  if (stream[Symbol.asyncIterator]) {
    yield* stream;
    return;
  }

  const reader = stream.getReader();
  try {
    for (;;) {
      const {done, value} = await reader.read();
      if (done) {
        break;
      }
      yield value;
    }
  } finally {
    await reader.cancel();
  }
};

const trackStream = (stream, chunkSize, onProgress, onFinish) => {
  const iterator = readBytes(stream, chunkSize);

  let bytes = 0;
  let done;
  let _onFinish = (e) => {
    if (!done) {
      done = true;
      onFinish && onFinish(e);
    }
  };

  return new ReadableStream({
    async pull(controller) {
      try {
        const {done, value} = await iterator.next();

        if (done) {
         _onFinish();
          controller.close();
          return;
        }

        let len = value.byteLength;
        if (onProgress) {
          let loadedBytes = bytes += len;
          onProgress(loadedBytes);
        }
        controller.enqueue(new Uint8Array(value));
      } catch (err) {
        _onFinish(err);
        throw err;
      }
    },
    cancel(reason) {
      _onFinish(reason);
      return iterator.return();
    }
  }, {
    highWaterMark: 2
  })
};

const isFetchSupported = typeof fetch === 'function' && typeof Request === 'function' && typeof Response === 'function';
const isReadableStreamSupported = isFetchSupported && typeof ReadableStream === 'function';

// used only inside the fetch adapter
const encodeText = isFetchSupported && (typeof TextEncoder === 'function' ?
    ((encoder) => (str) => encoder.encode(str))(new TextEncoder()) :
    async (str) => new Uint8Array(await new Response(str).arrayBuffer())
);

const test = (fn, ...args) => {
  try {
    return !!fn(...args);
  } catch (e) {
    return false
  }
};

const supportsRequestStream = isReadableStreamSupported && test(() => {
  let duplexAccessed = false;

  const hasContentType = new Request(platform.origin, {
    body: new ReadableStream(),
    method: 'POST',
    get duplex() {
      duplexAccessed = true;
      return 'half';
    },
  }).headers.has('Content-Type');

  return duplexAccessed && !hasContentType;
});

const DEFAULT_CHUNK_SIZE = 64 * 1024;

const supportsResponseStream = isReadableStreamSupported &&
  test(() => utils$1.isReadableStream(new Response('').body));


const resolvers = {
  stream: supportsResponseStream && ((res) => res.body)
};

isFetchSupported && (((res) => {
  ['text', 'arrayBuffer', 'blob', 'formData', 'stream'].forEach(type => {
    !resolvers[type] && (resolvers[type] = utils$1.isFunction(res[type]) ? (res) => res[type]() :
      (_, config) => {
        throw new AxiosError(`Response type '${type}' is not supported`, AxiosError.ERR_NOT_SUPPORT, config);
      });
  });
})(new Response));

const getBodyLength = async (body) => {
  if (body == null) {
    return 0;
  }

  if(utils$1.isBlob(body)) {
    return body.size;
  }

  if(utils$1.isSpecCompliantForm(body)) {
    const _request = new Request(platform.origin, {
      method: 'POST',
      body,
    });
    return (await _request.arrayBuffer()).byteLength;
  }

  if(utils$1.isArrayBufferView(body) || utils$1.isArrayBuffer(body)) {
    return body.byteLength;
  }

  if(utils$1.isURLSearchParams(body)) {
    body = body + '';
  }

  if(utils$1.isString(body)) {
    return (await encodeText(body)).byteLength;
  }
};

const resolveBodyLength = async (headers, body) => {
  const length = utils$1.toFiniteNumber(headers.getContentLength());

  return length == null ? getBodyLength(body) : length;
};

var fetchAdapter = isFetchSupported && (async (config) => {
  let {
    url,
    method,
    data,
    signal,
    cancelToken,
    timeout,
    onDownloadProgress,
    onUploadProgress,
    responseType,
    headers,
    withCredentials = 'same-origin',
    fetchOptions
  } = resolveConfig(config);

  responseType = responseType ? (responseType + '').toLowerCase() : 'text';

  let composedSignal = composeSignals$1([signal, cancelToken && cancelToken.toAbortSignal()], timeout);

  let request;

  const unsubscribe = composedSignal && composedSignal.unsubscribe && (() => {
      composedSignal.unsubscribe();
  });

  let requestContentLength;

  try {
    if (
      onUploadProgress && supportsRequestStream && method !== 'get' && method !== 'head' &&
      (requestContentLength = await resolveBodyLength(headers, data)) !== 0
    ) {
      let _request = new Request(url, {
        method: 'POST',
        body: data,
        duplex: "half"
      });

      let contentTypeHeader;

      if (utils$1.isFormData(data) && (contentTypeHeader = _request.headers.get('content-type'))) {
        headers.setContentType(contentTypeHeader);
      }

      if (_request.body) {
        const [onProgress, flush] = progressEventDecorator(
          requestContentLength,
          progressEventReducer(asyncDecorator(onUploadProgress))
        );

        data = trackStream(_request.body, DEFAULT_CHUNK_SIZE, onProgress, flush);
      }
    }

    if (!utils$1.isString(withCredentials)) {
      withCredentials = withCredentials ? 'include' : 'omit';
    }

    // Cloudflare Workers throws when credentials are defined
    // see https://github.com/cloudflare/workerd/issues/902
    const isCredentialsSupported = "credentials" in Request.prototype;
    request = new Request(url, {
      ...fetchOptions,
      signal: composedSignal,
      method: method.toUpperCase(),
      headers: headers.normalize().toJSON(),
      body: data,
      duplex: "half",
      credentials: isCredentialsSupported ? withCredentials : undefined
    });

    let response = await fetch(request);

    const isStreamResponse = supportsResponseStream && (responseType === 'stream' || responseType === 'response');

    if (supportsResponseStream && (onDownloadProgress || (isStreamResponse && unsubscribe))) {
      const options = {};

      ['status', 'statusText', 'headers'].forEach(prop => {
        options[prop] = response[prop];
      });

      const responseContentLength = utils$1.toFiniteNumber(response.headers.get('content-length'));

      const [onProgress, flush] = onDownloadProgress && progressEventDecorator(
        responseContentLength,
        progressEventReducer(asyncDecorator(onDownloadProgress), true)
      ) || [];

      response = new Response(
        trackStream(response.body, DEFAULT_CHUNK_SIZE, onProgress, () => {
          flush && flush();
          unsubscribe && unsubscribe();
        }),
        options
      );
    }

    responseType = responseType || 'text';

    let responseData = await resolvers[utils$1.findKey(resolvers, responseType) || 'text'](response, config);

    !isStreamResponse && unsubscribe && unsubscribe();

    return await new Promise((resolve, reject) => {
      settle(resolve, reject, {
        data: responseData,
        headers: AxiosHeaders$1.from(response.headers),
        status: response.status,
        statusText: response.statusText,
        config,
        request
      });
    })
  } catch (err) {
    unsubscribe && unsubscribe();

    if (err && err.name === 'TypeError' && /fetch/i.test(err.message)) {
      throw Object.assign(
        new AxiosError('Network Error', AxiosError.ERR_NETWORK, config, request),
        {
          cause: err.cause || err
        }
      )
    }

    throw AxiosError.from(err, err && err.code, config, request);
  }
});

const knownAdapters = {
  http: httpAdapter,
  xhr: xhrAdapter,
  fetch: fetchAdapter
};

utils$1.forEach(knownAdapters, (fn, value) => {
  if (fn) {
    try {
      Object.defineProperty(fn, 'name', {value});
    } catch (e) {
      // eslint-disable-next-line no-empty
    }
    Object.defineProperty(fn, 'adapterName', {value});
  }
});

const renderReason = (reason) => `- ${reason}`;

const isResolvedHandle = (adapter) => utils$1.isFunction(adapter) || adapter === null || adapter === false;

var adapters = {
  getAdapter: (adapters) => {
    adapters = utils$1.isArray(adapters) ? adapters : [adapters];

    const {length} = adapters;
    let nameOrAdapter;
    let adapter;

    const rejectedReasons = {};

    for (let i = 0; i < length; i++) {
      nameOrAdapter = adapters[i];
      let id;

      adapter = nameOrAdapter;

      if (!isResolvedHandle(nameOrAdapter)) {
        adapter = knownAdapters[(id = String(nameOrAdapter)).toLowerCase()];

        if (adapter === undefined) {
          throw new AxiosError(`Unknown adapter '${id}'`);
        }
      }

      if (adapter) {
        break;
      }

      rejectedReasons[id || '#' + i] = adapter;
    }

    if (!adapter) {

      const reasons = Object.entries(rejectedReasons)
        .map(([id, state]) => `adapter ${id} ` +
          (state === false ? 'is not supported by the environment' : 'is not available in the build')
        );

      let s = length ?
        (reasons.length > 1 ? 'since :\n' + reasons.map(renderReason).join('\n') : ' ' + renderReason(reasons[0])) :
        'as no adapter specified';

      throw new AxiosError(
        `There is no suitable adapter to dispatch the request ` + s,
        'ERR_NOT_SUPPORT'
      );
    }

    return adapter;
  },
  adapters: knownAdapters
};

/**
 * Throws a `CanceledError` if cancellation has been requested.
 *
 * @param {Object} config The config that is to be used for the request
 *
 * @returns {void}
 */
function throwIfCancellationRequested(config) {
  if (config.cancelToken) {
    config.cancelToken.throwIfRequested();
  }

  if (config.signal && config.signal.aborted) {
    throw new CanceledError(null, config);
  }
}

/**
 * Dispatch a request to the server using the configured adapter.
 *
 * @param {object} config The config that is to be used for the request
 *
 * @returns {Promise} The Promise to be fulfilled
 */
function dispatchRequest(config) {
  throwIfCancellationRequested(config);

  config.headers = AxiosHeaders$1.from(config.headers);

  // Transform request data
  config.data = transformData.call(
    config,
    config.transformRequest
  );

  if (['post', 'put', 'patch'].indexOf(config.method) !== -1) {
    config.headers.setContentType('application/x-www-form-urlencoded', false);
  }

  const adapter = adapters.getAdapter(config.adapter || defaults$1.adapter);

  return adapter(config).then(function onAdapterResolution(response) {
    throwIfCancellationRequested(config);

    // Transform response data
    response.data = transformData.call(
      config,
      config.transformResponse,
      response
    );

    response.headers = AxiosHeaders$1.from(response.headers);

    return response;
  }, function onAdapterRejection(reason) {
    if (!isCancel(reason)) {
      throwIfCancellationRequested(config);

      // Transform response data
      if (reason && reason.response) {
        reason.response.data = transformData.call(
          config,
          config.transformResponse,
          reason.response
        );
        reason.response.headers = AxiosHeaders$1.from(reason.response.headers);
      }
    }

    return Promise.reject(reason);
  });
}

const VERSION = "1.8.2";

const validators$1 = {};

// eslint-disable-next-line func-names
['object', 'boolean', 'number', 'function', 'string', 'symbol'].forEach((type, i) => {
  validators$1[type] = function validator(thing) {
    return typeof thing === type || 'a' + (i < 1 ? 'n ' : ' ') + type;
  };
});

const deprecatedWarnings = {};

/**
 * Transitional option validator
 *
 * @param {function|boolean?} validator - set to false if the transitional option has been removed
 * @param {string?} version - deprecated version / removed since version
 * @param {string?} message - some message with additional info
 *
 * @returns {function}
 */
validators$1.transitional = function transitional(validator, version, message) {
  function formatMessage(opt, desc) {
    return '[Axios v' + VERSION + '] Transitional option \'' + opt + '\'' + desc + (message ? '. ' + message : '');
  }

  // eslint-disable-next-line func-names
  return (value, opt, opts) => {
    if (validator === false) {
      throw new AxiosError(
        formatMessage(opt, ' has been removed' + (version ? ' in ' + version : '')),
        AxiosError.ERR_DEPRECATED
      );
    }

    if (version && !deprecatedWarnings[opt]) {
      deprecatedWarnings[opt] = true;
      // eslint-disable-next-line no-console
      console.warn(
        formatMessage(
          opt,
          ' has been deprecated since v' + version + ' and will be removed in the near future'
        )
      );
    }

    return validator ? validator(value, opt, opts) : true;
  };
};

validators$1.spelling = function spelling(correctSpelling) {
  return (value, opt) => {
    // eslint-disable-next-line no-console
    console.warn(`${opt} is likely a misspelling of ${correctSpelling}`);
    return true;
  }
};

/**
 * Assert object's properties type
 *
 * @param {object} options
 * @param {object} schema
 * @param {boolean?} allowUnknown
 *
 * @returns {object}
 */

function assertOptions(options, schema, allowUnknown) {
  if (typeof options !== 'object') {
    throw new AxiosError('options must be an object', AxiosError.ERR_BAD_OPTION_VALUE);
  }
  const keys = Object.keys(options);
  let i = keys.length;
  while (i-- > 0) {
    const opt = keys[i];
    const validator = schema[opt];
    if (validator) {
      const value = options[opt];
      const result = value === undefined || validator(value, opt, options);
      if (result !== true) {
        throw new AxiosError('option ' + opt + ' must be ' + result, AxiosError.ERR_BAD_OPTION_VALUE);
      }
      continue;
    }
    if (allowUnknown !== true) {
      throw new AxiosError('Unknown option ' + opt, AxiosError.ERR_BAD_OPTION);
    }
  }
}

var validator = {
  assertOptions,
  validators: validators$1
};

const validators = validator.validators;

/**
 * Create a new instance of Axios
 *
 * @param {Object} instanceConfig The default config for the instance
 *
 * @return {Axios} A new instance of Axios
 */
class Axios {
  constructor(instanceConfig) {
    this.defaults = instanceConfig;
    this.interceptors = {
      request: new InterceptorManager$1(),
      response: new InterceptorManager$1()
    };
  }

  /**
   * Dispatch a request
   *
   * @param {String|Object} configOrUrl The config specific for this request (merged with this.defaults)
   * @param {?Object} config
   *
   * @returns {Promise} The Promise to be fulfilled
   */
  async request(configOrUrl, config) {
    try {
      return await this._request(configOrUrl, config);
    } catch (err) {
      if (err instanceof Error) {
        let dummy = {};

        Error.captureStackTrace ? Error.captureStackTrace(dummy) : (dummy = new Error());

        // slice off the Error: ... line
        const stack = dummy.stack ? dummy.stack.replace(/^.+\n/, '') : '';
        try {
          if (!err.stack) {
            err.stack = stack;
            // match without the 2 top stack lines
          } else if (stack && !String(err.stack).endsWith(stack.replace(/^.+\n.+\n/, ''))) {
            err.stack += '\n' + stack;
          }
        } catch (e) {
          // ignore the case where "stack" is an un-writable property
        }
      }

      throw err;
    }
  }

  _request(configOrUrl, config) {
    /*eslint no-param-reassign:0*/
    // Allow for axios('example/url'[, config]) a la fetch API
    if (typeof configOrUrl === 'string') {
      config = config || {};
      config.url = configOrUrl;
    } else {
      config = configOrUrl || {};
    }

    config = mergeConfig(this.defaults, config);

    const {transitional, paramsSerializer, headers} = config;

    if (transitional !== undefined) {
      validator.assertOptions(transitional, {
        silentJSONParsing: validators.transitional(validators.boolean),
        forcedJSONParsing: validators.transitional(validators.boolean),
        clarifyTimeoutError: validators.transitional(validators.boolean)
      }, false);
    }

    if (paramsSerializer != null) {
      if (utils$1.isFunction(paramsSerializer)) {
        config.paramsSerializer = {
          serialize: paramsSerializer
        };
      } else {
        validator.assertOptions(paramsSerializer, {
          encode: validators.function,
          serialize: validators.function
        }, true);
      }
    }

    // Set config.allowAbsoluteUrls
    if (config.allowAbsoluteUrls !== undefined) ; else if (this.defaults.allowAbsoluteUrls !== undefined) {
      config.allowAbsoluteUrls = this.defaults.allowAbsoluteUrls;
    } else {
      config.allowAbsoluteUrls = true;
    }

    validator.assertOptions(config, {
      baseUrl: validators.spelling('baseURL'),
      withXsrfToken: validators.spelling('withXSRFToken')
    }, true);

    // Set config.method
    config.method = (config.method || this.defaults.method || 'get').toLowerCase();

    // Flatten headers
    let contextHeaders = headers && utils$1.merge(
      headers.common,
      headers[config.method]
    );

    headers && utils$1.forEach(
      ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
      (method) => {
        delete headers[method];
      }
    );

    config.headers = AxiosHeaders$1.concat(contextHeaders, headers);

    // filter out skipped interceptors
    const requestInterceptorChain = [];
    let synchronousRequestInterceptors = true;
    this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
      if (typeof interceptor.runWhen === 'function' && interceptor.runWhen(config) === false) {
        return;
      }

      synchronousRequestInterceptors = synchronousRequestInterceptors && interceptor.synchronous;

      requestInterceptorChain.unshift(interceptor.fulfilled, interceptor.rejected);
    });

    const responseInterceptorChain = [];
    this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
      responseInterceptorChain.push(interceptor.fulfilled, interceptor.rejected);
    });

    let promise;
    let i = 0;
    let len;

    if (!synchronousRequestInterceptors) {
      const chain = [dispatchRequest.bind(this), undefined];
      chain.unshift.apply(chain, requestInterceptorChain);
      chain.push.apply(chain, responseInterceptorChain);
      len = chain.length;

      promise = Promise.resolve(config);

      while (i < len) {
        promise = promise.then(chain[i++], chain[i++]);
      }

      return promise;
    }

    len = requestInterceptorChain.length;

    let newConfig = config;

    i = 0;

    while (i < len) {
      const onFulfilled = requestInterceptorChain[i++];
      const onRejected = requestInterceptorChain[i++];
      try {
        newConfig = onFulfilled(newConfig);
      } catch (error) {
        onRejected.call(this, error);
        break;
      }
    }

    try {
      promise = dispatchRequest.call(this, newConfig);
    } catch (error) {
      return Promise.reject(error);
    }

    i = 0;
    len = responseInterceptorChain.length;

    while (i < len) {
      promise = promise.then(responseInterceptorChain[i++], responseInterceptorChain[i++]);
    }

    return promise;
  }

  getUri(config) {
    config = mergeConfig(this.defaults, config);
    const fullPath = buildFullPath(config.baseURL, config.url, config.allowAbsoluteUrls);
    return buildURL(fullPath, config.params, config.paramsSerializer);
  }
}

// Provide aliases for supported request methods
utils$1.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
  /*eslint func-names:0*/
  Axios.prototype[method] = function(url, config) {
    return this.request(mergeConfig(config || {}, {
      method,
      url,
      data: (config || {}).data
    }));
  };
});

utils$1.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  /*eslint func-names:0*/

  function generateHTTPMethod(isForm) {
    return function httpMethod(url, data, config) {
      return this.request(mergeConfig(config || {}, {
        method,
        headers: isForm ? {
          'Content-Type': 'multipart/form-data'
        } : {},
        url,
        data
      }));
    };
  }

  Axios.prototype[method] = generateHTTPMethod();

  Axios.prototype[method + 'Form'] = generateHTTPMethod(true);
});

var Axios$1 = Axios;

/**
 * A `CancelToken` is an object that can be used to request cancellation of an operation.
 *
 * @param {Function} executor The executor function.
 *
 * @returns {CancelToken}
 */
class CancelToken {
  constructor(executor) {
    if (typeof executor !== 'function') {
      throw new TypeError('executor must be a function.');
    }

    let resolvePromise;

    this.promise = new Promise(function promiseExecutor(resolve) {
      resolvePromise = resolve;
    });

    const token = this;

    // eslint-disable-next-line func-names
    this.promise.then(cancel => {
      if (!token._listeners) return;

      let i = token._listeners.length;

      while (i-- > 0) {
        token._listeners[i](cancel);
      }
      token._listeners = null;
    });

    // eslint-disable-next-line func-names
    this.promise.then = onfulfilled => {
      let _resolve;
      // eslint-disable-next-line func-names
      const promise = new Promise(resolve => {
        token.subscribe(resolve);
        _resolve = resolve;
      }).then(onfulfilled);

      promise.cancel = function reject() {
        token.unsubscribe(_resolve);
      };

      return promise;
    };

    executor(function cancel(message, config, request) {
      if (token.reason) {
        // Cancellation has already been requested
        return;
      }

      token.reason = new CanceledError(message, config, request);
      resolvePromise(token.reason);
    });
  }

  /**
   * Throws a `CanceledError` if cancellation has been requested.
   */
  throwIfRequested() {
    if (this.reason) {
      throw this.reason;
    }
  }

  /**
   * Subscribe to the cancel signal
   */

  subscribe(listener) {
    if (this.reason) {
      listener(this.reason);
      return;
    }

    if (this._listeners) {
      this._listeners.push(listener);
    } else {
      this._listeners = [listener];
    }
  }

  /**
   * Unsubscribe from the cancel signal
   */

  unsubscribe(listener) {
    if (!this._listeners) {
      return;
    }
    const index = this._listeners.indexOf(listener);
    if (index !== -1) {
      this._listeners.splice(index, 1);
    }
  }

  toAbortSignal() {
    const controller = new AbortController();

    const abort = (err) => {
      controller.abort(err);
    };

    this.subscribe(abort);

    controller.signal.unsubscribe = () => this.unsubscribe(abort);

    return controller.signal;
  }

  /**
   * Returns an object that contains a new `CancelToken` and a function that, when called,
   * cancels the `CancelToken`.
   */
  static source() {
    let cancel;
    const token = new CancelToken(function executor(c) {
      cancel = c;
    });
    return {
      token,
      cancel
    };
  }
}

var CancelToken$1 = CancelToken;

/**
 * Syntactic sugar for invoking a function and expanding an array for arguments.
 *
 * Common use case would be to use `Function.prototype.apply`.
 *
 *  ```js
 *  function f(x, y, z) {}
 *  var args = [1, 2, 3];
 *  f.apply(null, args);
 *  ```
 *
 * With `spread` this example can be re-written.
 *
 *  ```js
 *  spread(function(x, y, z) {})([1, 2, 3]);
 *  ```
 *
 * @param {Function} callback
 *
 * @returns {Function}
 */
function spread$1(callback) {
  return function wrap(arr) {
    return callback.apply(null, arr);
  };
}

/**
 * Determines whether the payload is an error thrown by Axios
 *
 * @param {*} payload The value to test
 *
 * @returns {boolean} True if the payload is an error thrown by Axios, otherwise false
 */
function isAxiosError(payload) {
  return utils$1.isObject(payload) && (payload.isAxiosError === true);
}

const HttpStatusCode = {
  Continue: 100,
  SwitchingProtocols: 101,
  Processing: 102,
  EarlyHints: 103,
  Ok: 200,
  Created: 201,
  Accepted: 202,
  NonAuthoritativeInformation: 203,
  NoContent: 204,
  ResetContent: 205,
  PartialContent: 206,
  MultiStatus: 207,
  AlreadyReported: 208,
  ImUsed: 226,
  MultipleChoices: 300,
  MovedPermanently: 301,
  Found: 302,
  SeeOther: 303,
  NotModified: 304,
  UseProxy: 305,
  Unused: 306,
  TemporaryRedirect: 307,
  PermanentRedirect: 308,
  BadRequest: 400,
  Unauthorized: 401,
  PaymentRequired: 402,
  Forbidden: 403,
  NotFound: 404,
  MethodNotAllowed: 405,
  NotAcceptable: 406,
  ProxyAuthenticationRequired: 407,
  RequestTimeout: 408,
  Conflict: 409,
  Gone: 410,
  LengthRequired: 411,
  PreconditionFailed: 412,
  PayloadTooLarge: 413,
  UriTooLong: 414,
  UnsupportedMediaType: 415,
  RangeNotSatisfiable: 416,
  ExpectationFailed: 417,
  ImATeapot: 418,
  MisdirectedRequest: 421,
  UnprocessableEntity: 422,
  Locked: 423,
  FailedDependency: 424,
  TooEarly: 425,
  UpgradeRequired: 426,
  PreconditionRequired: 428,
  TooManyRequests: 429,
  RequestHeaderFieldsTooLarge: 431,
  UnavailableForLegalReasons: 451,
  InternalServerError: 500,
  NotImplemented: 501,
  BadGateway: 502,
  ServiceUnavailable: 503,
  GatewayTimeout: 504,
  HttpVersionNotSupported: 505,
  VariantAlsoNegotiates: 506,
  InsufficientStorage: 507,
  LoopDetected: 508,
  NotExtended: 510,
  NetworkAuthenticationRequired: 511,
};

Object.entries(HttpStatusCode).forEach(([key, value]) => {
  HttpStatusCode[value] = key;
});

var HttpStatusCode$1 = HttpStatusCode;

/**
 * Create an instance of Axios
 *
 * @param {Object} defaultConfig The default config for the instance
 *
 * @returns {Axios} A new instance of Axios
 */
function createInstance(defaultConfig) {
  const context = new Axios$1(defaultConfig);
  const instance = bind(Axios$1.prototype.request, context);

  // Copy axios.prototype to instance
  utils$1.extend(instance, Axios$1.prototype, context, {allOwnKeys: true});

  // Copy context to instance
  utils$1.extend(instance, context, null, {allOwnKeys: true});

  // Factory for creating new instances
  instance.create = function create(instanceConfig) {
    return createInstance(mergeConfig(defaultConfig, instanceConfig));
  };

  return instance;
}

// Create the default instance to be exported
const axios = createInstance(defaults$1);

// Expose Axios class to allow class inheritance
axios.Axios = Axios$1;

// Expose Cancel & CancelToken
axios.CanceledError = CanceledError;
axios.CancelToken = CancelToken$1;
axios.isCancel = isCancel;
axios.VERSION = VERSION;
axios.toFormData = toFormData;

// Expose AxiosError class
axios.AxiosError = AxiosError;

// alias for CanceledError for backward compatibility
axios.Cancel = axios.CanceledError;

// Expose all/spread
axios.all = function all(promises) {
  return Promise.all(promises);
};

axios.spread = spread$1;

// Expose isAxiosError
axios.isAxiosError = isAxiosError;

// Expose mergeConfig
axios.mergeConfig = mergeConfig;

axios.AxiosHeaders = AxiosHeaders$1;

axios.formToJSON = thing => formDataToJSON(utils$1.isHTMLForm(thing) ? new FormData(thing) : thing);

axios.getAdapter = adapters.getAdapter;

axios.HttpStatusCode = HttpStatusCode$1;

axios.default = axios;

// this module should only have a default export
var axios$1 = axios;

/**
 * Returns boolean if the isDataLayerReady flag is true
 *
 * @returns {*} boolean flag if data layer is ready in the digitalData object
 * @private
 */
function _checkFlag() {
  return lib.digitalData && lib.digitalData.page && lib.digitalData.page.isDataLayerReady;
}

/**
 * Number of times to retry the datalayer ready loop before failing
 *
 * @type {number}
 * @private
 */
var _timeoutRetries$1 = 50;
var _dataLayerReadyPromise;

/**
 * Timeout loop to check if the digitalData object is ready.
 * This is the only way to achieve this without jQuery, as the event trigger
 * is fired from jQuery's custom event layer as
 * $(document).trigger('datalayer_ready').
 *
 * Application should `window.digitalData` up-front, e.g. in a `<script>` tag in `<head>`, that eliminates the polling.
 *
 * @private
 */
function _datalayerReady() {
  if (!_dataLayerReadyPromise) {
    _dataLayerReadyPromise = new Promise(function (resolve, reject) {
      /**
       * Tracks the number of attempts for the datalayer ready loop
       *
       * @type {number}
       * @private
       */
      var _attempt = 0;
      function _dataLayerReadyImpl() {
        if (_checkFlag()) {
          resolve();
        } else {
          _attempt++;
          if (_attempt < _timeoutRetries$1) {
            setTimeout(function () {
              _dataLayerReadyImpl();
            }, 100);
          } else {
            reject(new Error('Timeout polling for digital data object.'));
          }
        }
      }
      _dataLayerReadyImpl();
    });
  }
  return _dataLayerReadyPromise;
}

/**
 * DDO API class with methods of fetching search results for
 * ibm.com
 */
var DDOAPI = /*#__PURE__*/function () {
  function DDOAPI() {
    _classCallCheck$2(this, DDOAPI);
  }
  return _createClass$2(DDOAPI, null, [{
    key: "isReady",
    value:
    /**
     * Promise function that determines when the digital data object is ready
     *
     * @returns {Promise} Resolved data layer ready signal
     */
    function isReady() {
      return _datalayerReady();
    }

    /**
     * Gets the full digitalData (DDO) object.
     * Application should `window.digitalData` up-front, e.g. in a `<script>` tag in `<head>`.
     * For quick developerment purpose, what `ibm-common.js` automatically populates can be used.
     *
     * @returns {Promise<*>} Promise object
     */
  }, {
    key: "getAll",
    value: (function () {
      var _getAll = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
        return regenerator.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.isReady().then(function () {
                return lib.digitalData;
              }).catch(function () {
                return null;
              });
            case 2:
              return _context.abrupt("return", _context.sent);
            case 3:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function getAll() {
        return _getAll.apply(this, arguments);
      }
      return getAll;
    }()
    /**
     * Sets the version of the library to the DDO.
     * Application should `window.digitalData` up-front, e.g. in a `<script>` tag in `<head>`.
     * For quick developerment purpose, what `ibm-common.js` automatically populates can be used.
     *
     * @returns {Promise<any>} Promise object
     */
    )
  }, {
    key: "setVersion",
    value: (function () {
      var _setVersion = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2() {
        return regenerator.wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this.isReady().then(function () {
                lib.digitalData.page.pageInfo.version = settings.version;
              });
            case 2:
              return _context2.abrupt("return", _context2.sent);
            case 3:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function setVersion() {
        return _setVersion.apply(this, arguments);
      }
      return setVersion;
    }()
    /**
     * Gets the locale for the current page based on the language set as metadata.
     * Application should `window.digitalData` up-front, e.g. in a `<script>` tag in `<head>`.
     * For quick developerment purpose, what `ibm-common.js` automatically populates can be used.
     *
     * @returns {Promise<*>} Promise object
     */
    )
  }, {
    key: "getLanguage",
    value: (function () {
      var _getLanguage = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee3() {
        return regenerator.wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return this.isReady().then(function () {
                return lib.digitalData.page.pageInfo.language;
              });
            case 2:
              return _context3.abrupt("return", _context3.sent);
            case 3:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function getLanguage() {
        return _getLanguage.apply(this, arguments);
      }
      return getLanguage;
    }()
    /**
     * Gets the country location of the user based on data populated by IBM analytics script.
     * Application should `window.digitalData` up-front, e.g. in a `<script>` tag in `<head>`.
     * For quick developerment purpose, what `ibm-common.js` automatically populates can be used.
     *
     * @returns {Promise<*>} Promise object
     */
    )
  }, {
    key: "getLocation",
    value: (function () {
      var _getLocation = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee4() {
        return regenerator.wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return this.isReady().then(function () {
                return lib.digitalData.user.location.country.toLowerCase();
              });
            case 2:
              return _context4.abrupt("return", _context4.sent);
            case 3:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this);
      }));
      function getLocation() {
        return _getLocation.apply(this, arguments);
      }
      return getLocation;
    }())
  }]);
}();

var js_cookie = {exports: {}};

/*!
 * JavaScript Cookie v2.2.1
 * https://github.com/js-cookie/js-cookie
 *
 * Copyright 2006, 2015 Klaus Hartl & Fagner Brack
 * Released under the MIT license
 */

(function (module, exports) {
(function (factory) {
	var registeredInModuleLoader;
	{
		module.exports = factory();
		registeredInModuleLoader = true;
	}
	if (!registeredInModuleLoader) {
		var OldCookies = window.Cookies;
		var api = window.Cookies = factory();
		api.noConflict = function () {
			window.Cookies = OldCookies;
			return api;
		};
	}
}(function () {
	function extend () {
		var i = 0;
		var result = {};
		for (; i < arguments.length; i++) {
			var attributes = arguments[ i ];
			for (var key in attributes) {
				result[key] = attributes[key];
			}
		}
		return result;
	}

	function decode (s) {
		return s.replace(/(%[0-9A-Z]{2})+/g, decodeURIComponent);
	}

	function init (converter) {
		function api() {}

		function set (key, value, attributes) {
			if (typeof document === 'undefined') {
				return;
			}

			attributes = extend({
				path: '/'
			}, api.defaults, attributes);

			if (typeof attributes.expires === 'number') {
				attributes.expires = new Date(new Date() * 1 + attributes.expires * 864e+5);
			}

			// We're using "expires" because "max-age" is not supported by IE
			attributes.expires = attributes.expires ? attributes.expires.toUTCString() : '';

			try {
				var result = JSON.stringify(value);
				if (/^[\{\[]/.test(result)) {
					value = result;
				}
			} catch (e) {}

			value = converter.write ?
				converter.write(value, key) :
				encodeURIComponent(String(value))
					.replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g, decodeURIComponent);

			key = encodeURIComponent(String(key))
				.replace(/%(23|24|26|2B|5E|60|7C)/g, decodeURIComponent)
				.replace(/[\(\)]/g, escape);

			var stringifiedAttributes = '';
			for (var attributeName in attributes) {
				if (!attributes[attributeName]) {
					continue;
				}
				stringifiedAttributes += '; ' + attributeName;
				if (attributes[attributeName] === true) {
					continue;
				}

				// Considers RFC 6265 section 5.2:
				// ...
				// 3.  If the remaining unparsed-attributes contains a %x3B (";")
				//     character:
				// Consume the characters of the unparsed-attributes up to,
				// not including, the first %x3B (";") character.
				// ...
				stringifiedAttributes += '=' + attributes[attributeName].split(';')[0];
			}

			return (document.cookie = key + '=' + value + stringifiedAttributes);
		}

		function get (key, json) {
			if (typeof document === 'undefined') {
				return;
			}

			var jar = {};
			// To prevent the for loop in the first place assign an empty array
			// in case there are no cookies at all.
			var cookies = document.cookie ? document.cookie.split('; ') : [];
			var i = 0;

			for (; i < cookies.length; i++) {
				var parts = cookies[i].split('=');
				var cookie = parts.slice(1).join('=');

				if (!json && cookie.charAt(0) === '"') {
					cookie = cookie.slice(1, -1);
				}

				try {
					var name = decode(parts[0]);
					cookie = (converter.read || converter)(cookie, name) ||
						decode(cookie);

					if (json) {
						try {
							cookie = JSON.parse(cookie);
						} catch (e) {}
					}

					jar[name] = cookie;

					if (key === name) {
						break;
					}
				} catch (e) {}
			}

			return key ? jar[key] : jar;
		}

		api.set = set;
		api.get = function (key) {
			return get(key, false /* read as raw */);
		};
		api.getJSON = function (key) {
			return get(key, true /* read as json */);
		};
		api.remove = function (key, attributes) {
			set(key, '', extend(attributes, {
				expires: -1
			}));
		};

		api.defaults = {};

		api.withConverter = init;

		return api;
	}

	return init(function () {});
}));
}(js_cookie));

var Cookies = js_cookie.exports;

function _typeof$1(o) { "@babel/helpers - typeof"; return _typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof$1(o); }
function _classCallCheck$1(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties$1(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey$14(o.key), o); } }
function _createClass$1(e, r, t) { return r && _defineProperties$1(e.prototype, r), t && _defineProperties$1(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey$14(t) { var i = _toPrimitive$14(t, "string"); return "symbol" == _typeof$1(i) ? i : i + ""; }
function _toPrimitive$14(t, r) { if ("object" != _typeof$1(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof$1(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

/**
 * Name of cookie needed to grab cc and lc
 *
 * @type {string}
 * @private
 */
var _cookieName$2 = 'ipcInfo';

/**
 * Utility to set and get the ipcInfo cookie needed to determine country and language code
 */
var ipcinfoCookie = /*#__PURE__*/function () {
  function ipcinfoCookie() {
    _classCallCheck$1(this, ipcinfoCookie);
  }
  return _createClass$1(ipcinfoCookie, null, [{
    key: "get",
    value:
    /**
     * retreive the ipcInfo cookie that contains the cc and lc
     * decodes and converts to object
     *
     * @example
     * import { ipcinfoCookie } from '@carbon/ibmdotcom-utilities';
     *
     * const info = ipcinfoCookie.get();
     */
    function get() {
      var cookiesDecode = Cookies.withConverter({
        read: function read(value) {
          return decodeURIComponent(value);
        }
      });
      var ipcinfo = cookiesDecode.get(_cookieName$2);
      if (ipcinfo) {
        var cc;
        var lc;
        var info = ipcinfo.split(';');
        info.map(function (code) {
          var itemParts = code.split('=');
          if (itemParts[0] === 'cc') {
            cc = itemParts[1];
          }
          if (itemParts[0] === 'lc') {
            lc = itemParts[1];
          }
        });
        return {
          cc: cc,
          lc: lc
        };
      }
    }

    /**
     * set the ipcInfo cookie with expiration of a year
     * takes care of converting to string and encoding
     *
     * @param {object} params params object
     * @param {string} params.cc country code
     * @param {string} params.lc language code
     * @example
     * import { ipcinfoCookie } from '@carbon/ibmdotcom-utilities';
     *
     * const locale = {cc: 'us', lc: 'en'}
     * ipcinfoCookie.set(locale);
     */
  }, {
    key: "set",
    value: function set(_ref) {
      var cc = _ref.cc,
        lc = _ref.lc;
      var info = "cc=".concat(cc, ";lc=").concat(lc);
      var cookiesEncode = Cookies.withConverter({
        write: function write(value) {
          return encodeURIComponent(value);
        }
      });
      cookiesEncode.set(_cookieName$2, info, {
        expires: 365,
        domain: '.ibm.com'
      });
    }
  }]);
}();

/**
 * @typedef {object} Locale
 * @property {string} cc The country code.
 * @property {string} lc The language code.
 */

/**
 * @constant {string | string} Host for the Locale API call.
 * @private
 */
var _host$4 = process && (process.env.REACT_APP_TRANSLATION_HOST || process.env.TRANSLATION_HOST) || 'https://1.www.s81c.com';

/**
 * Sets the default location if nothing is returned.
 *
 * @type {Locale}
 * @private
 */
var _localeDefault$1 = {
  lc: 'en',
  cc: 'us'
};

/**
 * Default display name for lang combination.
 *
 * @type {string}
 * @private
 */
var _localeNameDefault = 'United States — English';

/**
 * Locale API endpoint.
 *
 * @type {string}
 * @private
 */
var _endpoint$2 = "".concat(_host$4, "/common/js/dynamicnav/www/countrylist/jsononly");

/**
 * Configuration for axios.
 *
 * @type {{headers: {'Content-Type': string}}}
 * @private
 */
var _axiosConfig = {
  headers: {
    'Content-Type': 'application/json; charset=utf-8'
  }
};

/**
 * Session Storage key for country list.
 *
 * @type {string}
 * @private
 */
var _sessionListKey = 'cds-countrylist';

/**
 * Two hours in milliseconds to compare session timestamp.
 *
 * @type {number}
 * @private
 */
var _twoHours$1 = 60 * 60 * 2000;

/**
 * The cache for in-flight or resolved requests for the country list, keyed by
 * the initiating locale.
 *
 * @type {object}
 * @private
 */
var _requestsList = {};

/**
 * Retrieves the default locale.
 *
 * @returns {Locale} The default locale.
 */
var _getLocaleDefault = function _getLocaleDefault() {
  return _localeDefault$1;
};

/**
 * Use the <html> lang attr to determine a return locale object, or "false"
 * when it's not available so the consumer can decide what to do next.
 *
 * @type {(Locale | boolean)}
 * @private
 */
function _getLocaleFromLangAttr() {
  var _root$document;
  if ((_root$document = lib.document) !== null && _root$document !== void 0 && (_root$document = _root$document.documentElement) !== null && _root$document !== void 0 && _root$document.lang) {
    var lang = lib.document.documentElement.lang.toLowerCase();
    var locale = {};
    if (lang.indexOf('-') === -1) {
      locale.lc = lang;
    } else {
      var codes = lang.split('-');
      locale.cc = codes[1];
      locale.lc = codes[0];
    }
    return locale;
  }
  return false;
}

/**
 * Gets the locale from the cookie and returns it if both 'cc' and 'lc' values
 * are present.
 *
 * @async
 * @returns {Promise<Locale|boolean>} The cookie object if 'cc' and 'lc' values are present, otherwise false.
 */
var _getLocaleFromCookie = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
    var cookie;
    return regenerator.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          cookie = ipcinfoCookie.get();
          if (!(cookie && cookie.cc && cookie.lc)) {
            _context.next = 5;
            break;
          }
          _context.next = 4;
          return LocaleAPI.getList(cookie);
        case 4:
          return _context.abrupt("return", cookie);
        case 5:
          return _context.abrupt("return", false);
        case 6:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function _getLocaleFromCookie() {
    return _ref.apply(this, arguments);
  };
}();

/**
 * Get the locale from the user's browser.
 *
 * @async
 * @returns {Promise<Locale|boolean>} The verified locale or false if not found.
 */
var _getLocaleFromBrowser = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2() {
    var cc, lang, lc, list, verifiedCodes;
    return regenerator.wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          _context2.prev = 0;
          _context2.next = 3;
          return DDOAPI.getLocation();
        case 3:
          cc = _context2.sent;
          // Language preference from browser can return in either 'en-US' format or
          // 'en' so will need to extract language only.
          lang = lib.navigator.language;
          lc = lang.split('-')[0];
          if (!(cc && lc)) {
            _context2.next = 13;
            break;
          }
          _context2.next = 9;
          return LocaleAPI.getList({
            cc: cc,
            lc: lc
          });
        case 9:
          list = _context2.sent;
          verifiedCodes = LocaleAPI.verifyLocale(cc, lc, list); // Set the ipcInfo cookie.
          ipcinfoCookie.set(verifiedCodes);
          return _context2.abrupt("return", verifiedCodes);
        case 13:
          _context2.next = 17;
          break;
        case 15:
          _context2.prev = 15;
          _context2.t0 = _context2["catch"](0);
        case 17:
          return _context2.abrupt("return", false);
        case 18:
        case "end":
          return _context2.stop();
      }
    }, _callee2, null, [[0, 15]]);
  }));
  return function _getLocaleFromBrowser() {
    return _ref2.apply(this, arguments);
  };
}();

/**
 * Return a locale object based on the DDO API, or "false" so the consumer can
 * decide what to do next.
 *
 * @returns {(Locale | boolean)} Locale from the DDO, or "false" if not present.
 * @private
 */
function _getLocaleFromDDO() {
  var _ddoLocal$page;
  var ddoLocal = Object.assign({}, lib.digitalData || {});
  if ((_ddoLocal$page = ddoLocal.page) !== null && _ddoLocal$page !== void 0 && (_ddoLocal$page = _ddoLocal$page.pageInfo) !== null && _ddoLocal$page !== void 0 && _ddoLocal$page.language) {
    var _ddoLocal$page2, _ddoLocal$page3;
    var lang = {};

    // if DDO language contains both lc & cc (ie. en-US)
    if ((_ddoLocal$page2 = ddoLocal.page) !== null && _ddoLocal$page2 !== void 0 && (_ddoLocal$page2 = _ddoLocal$page2.pageInfo) !== null && _ddoLocal$page2 !== void 0 && _ddoLocal$page2.language.includes('-') && (_ddoLocal$page3 = ddoLocal.page) !== null && _ddoLocal$page3 !== void 0 && (_ddoLocal$page3 = _ddoLocal$page3.pageInfo) !== null && _ddoLocal$page3 !== void 0 && (_ddoLocal$page3 = _ddoLocal$page3.ibm) !== null && _ddoLocal$page3 !== void 0 && _ddoLocal$page3.country) {
      // Set proper LC for us to use.
      lang.lc = ddoLocal.page.pageInfo.language.substring(0, 2).toLowerCase();
      lang.cc = ddoLocal.page.pageInfo.ibm.country.toLowerCase().trim();

      // If there are multiple countries use just the first one for the CC value
      if (lang.cc.indexOf(',') > -1) {
        lang.cc = lang.cc.substring(0, lang.cc.indexOf(',')).trim();
      }

      // Gb will be uk elsewhere
      if (lang.cc === 'gb') {
        lang.cc = 'uk';
      }

      // Map worldwide (ZZ) pages to US
      if (lang.cc === 'zz') {
        lang.cc = 'us';
      }
    } else {
      // set lc with just the language code
      lang.lc = ddoLocal.page.pageInfo.language.substring(0, 2).toLowerCase();
    }
    return lang;
  }
  return false;
}

/**
 * Locale API class with method of fetching user's locale for ibm.com.
 */
var LocaleAPI = /*#__PURE__*/function () {
  function LocaleAPI() {
    _classCallCheck$2(this, LocaleAPI);
  }
  return _createClass$2(LocaleAPI, null, [{
    key: "clearCache",
    value:
    /**
     * Clears the cache.
     */
    function clearCache() {
      if (typeof sessionStorage !== 'undefined') {
        Object.keys(_requestsList).forEach(function (key) {
          return delete _requestsList[key];
        });
        for (var i = 0; i < sessionStorage.length; ++i) {
          var key = sessionStorage.key(i);
          if (key.indexOf(_sessionListKey) === 0) {
            sessionStorage.removeItem(key);
          }
        }
      }
    }

    /**
     * Gets the user's locale.
     *
     * Grab the locale from the available information on the page in the following
     * order:
     *
     * 1. DDO
     * 2. HTML lang attribute
     * 3. ipcInfo cookie
     * 4. Browser (navigator.language)
     * 5. Default (us-EN)
     *
     * @returns {Promise<Locale>} Locale object.
     * @example
     * import { LocaleAPI } from '@carbon/ibmdotcom-services';
     *
     * async function getLocale() {
     *   const locale = await LocaleAPI.getLocale();
     *   return locale;
     * }
     */
  }, {
    key: "getLocale",
    value: (function () {
      var _getLocale = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee3() {
        var localeGetters, _i, _localeGetters, getter, locale;
        return regenerator.wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              localeGetters = [_getLocaleFromDDO, _getLocaleFromLangAttr, _getLocaleFromCookie, _getLocaleFromBrowser];
              _i = 0, _localeGetters = localeGetters;
            case 2:
              if (!(_i < _localeGetters.length)) {
                _context3.next = 12;
                break;
              }
              getter = _localeGetters[_i];
              _context3.next = 6;
              return getter();
            case 6:
              locale = _context3.sent;
              if (!locale) {
                _context3.next = 9;
                break;
              }
              return _context3.abrupt("return", locale);
            case 9:
              _i++;
              _context3.next = 2;
              break;
            case 12:
              return _context3.abrupt("return", _getLocaleDefault());
            case 13:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }));
      function getLocale() {
        return _getLocale.apply(this, arguments);
      }
      return getLocale;
    }()
    /**
     * Gets the user's locale.
     *
     * @returns {Promise<Locale>} Locale object.
     * @example
     * import { LocaleAPI } from '@carbon/ibmdotcom-services';
     *
     * function async getLocale() {
     *    const locale = await LocaleAPI.getLang();
     * }
     *
     * @deprecated in favor of LocalAPI.getLocale.
     */
    )
  }, {
    key: "getLang",
    value: (function () {
      var _getLang = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee4() {
        return regenerator.wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              return _context4.abrupt("return", this.getLocale());
            case 1:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this);
      }));
      function getLang() {
        return _getLang.apply(this, arguments);
      }
      return getLang;
    }()
    /**
     * This fetches the language display name based on locale.
     *
     * @param {(Locale | boolean)} locale (optional) If not given, uses LocaleAPI.getLocale logic.
     * @returns {Promise<string>} Display name of locale/language.
     */
    )
  }, {
    key: "getLangDisplay",
    value: (function () {
      var _getLangDisplay = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee5(locale) {
        var lang, list, countries, location;
        return regenerator.wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              if (!locale) {
                _context5.next = 4;
                break;
              }
              _context5.t0 = locale;
              _context5.next = 7;
              break;
            case 4:
              _context5.next = 6;
              return this.getLocale();
            case 6:
              _context5.t0 = _context5.sent;
            case 7:
              lang = _context5.t0;
              _context5.next = 10;
              return this.getList(lang);
            case 10:
              list = _context5.sent;
              // combines the countryList arrays
              countries = [];
              list.regionList.forEach(function (region) {
                countries = countries.concat(region.countryList);
              });

              // get match for countries with multiple languages
              location = countries.filter(function (country) {
                var htmlLang = country.locale.findIndex(function (loc) {
                  return loc[0] === "".concat(lang.lc, "-").concat(lang.cc);
                });
                if (htmlLang !== -1) {
                  var _country$locale;
                  var localeMatch = country.locale.filter(function (l) {
                    return l.includes("".concat(lang.lc, "-").concat(lang.cc));
                  });
                  (_country$locale = country.locale).splice.apply(_country$locale, [0, country.locale.length].concat(_toConsumableArray(localeMatch)));
                  return country;
                }
              });
              if (!location.length) {
                _context5.next = 18;
                break;
              }
              return _context5.abrupt("return", "".concat(location[0].name, " \u2014 ").concat(location[0].locale[0][1]));
            case 18:
              return _context5.abrupt("return", _localeNameDefault);
            case 19:
            case "end":
              return _context5.stop();
          }
        }, _callee5, this);
      }));
      function getLangDisplay(_x) {
        return _getLangDisplay.apply(this, arguments);
      }
      return getLangDisplay;
    }()
    /**
     * Get the country list of all supported countries and their languages
     * if it is not already stored in session storage.
     *
     * @param {Locale} locale Locale object.
     * @param {string} locale.cc Country code.
     * @param {string} locale.lc Language code.
     * @returns {Promise<any>} Promise object.
     * @example
     * import { LocaleAPI } from '@carbon/ibmdotcom-services';
     *
     * function async getLocale() {
     *    const list = await LocaleAPI.getList({ cc: 'us', lc: 'en' });
     *    return list;
     * }
     */
    )
  }, {
    key: "getList",
    value: (function () {
      var _getList = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee6(_ref3) {
        var _this = this;
        var cc, lc;
        return regenerator.wrap(function _callee6$(_context6) {
          while (1) switch (_context6.prev = _context6.next) {
            case 0:
              cc = _ref3.cc, lc = _ref3.lc;
              return _context6.abrupt("return", new Promise(function (resolve, reject) {
                _this.fetchList(cc, lc, resolve, reject);
              }));
            case 2:
            case "end":
              return _context6.stop();
          }
        }, _callee6);
      }));
      function getList(_x2) {
        return _getList.apply(this, arguments);
      }
      return getList;
    }()
    /**
     * Fetches the list data based on cc/lc combination.
     *
     * @param {string} cc Country code.
     * @param {string} lc Language code.
     * @param {Function} resolve Resolves the Promise.
     * @param {Function} reject Rejects the promise.
     */
    )
  }, {
    key: "fetchList",
    value: function fetchList(cc, lc, resolve, reject) {
      var _this2 = this;
      var key = cc !== 'undefined' ? "".concat(lc, "-").concat(cc) : "".concat(lc);
      var itemKey = "".concat(_sessionListKey, "-").concat(key);
      var sessionList = this.getSessionCache(itemKey);
      if (sessionList) {
        resolve(sessionList);
      } else {
        if (!_requestsList[key]) {
          var url = "".concat(_endpoint$2, "/").concat(cc !== 'undefined' ? "".concat(cc).concat(lc) : "".concat(lc), "-utf8.json");
          _requestsList[key] = axios$1.get(url, _axiosConfig).then(function (response) {
            var data = response.data;
            data['timestamp'] = Date.now();
            sessionStorage.setItem("".concat(_sessionListKey, "-").concat(key), JSON.stringify(data));
            return data;
          });
        }
        _requestsList[key].then(resolve, function (error) {
          if (cc === _localeDefault$1.cc && lc === _localeDefault$1.lc) {
            reject(error);
          } else {
            _this2.fetchList(_localeDefault$1.cc, _localeDefault$1.lc, resolve, reject);
          }
        });
      }
    }

    /**
     * Verify that the cc and lc combo is in the list of supported cc-lc combos.
     *
     * @param {string} cc Country code.
     * @param {string} lc Language code.
     * @param {object} list Country list.
     * @returns {object} Object with lc and cc.
     * @example
     * import { LocaleAPI } from '@carbon/ibmdotcom-services';
     *
     * async function getLocale() {
     *   const locale = await LocaleAPI.verifyLocale(cc, lc, data);
     *   return locale;
     * }
     */
  }, {
    key: "verifyLocale",
    value: function verifyLocale(cc, lc, list) {
      var priorityLC;
      var locale;
      var language = list && list.regionList.forEach(function (region) {
        return region.countryList.forEach(function (country) {
          var code = country.locale[0][0].split('-');
          var languageCode = code[0];
          var countryCode = code[1];
          if (countryCode === cc && languageCode === lc) {
            locale = {
              cc: cc,
              lc: lc
            };
          }
          // save the priority language associated with the user's country code
          else if (countryCode === cc && !priorityLC) {
            priorityLC = languageCode;
          }
        });
      });
      if (!language && priorityLC) {
        locale = {
          cc: cc,
          lc: priorityLC
        };
      }
      return locale;
    }

    /**
     * Retrieves session cache and checks if cache needs to be refreshed
     *
     * @param {string} key Session storage key.
     */
  }, {
    key: "getSessionCache",
    value: function getSessionCache(key) {
      var session = typeof sessionStorage === 'undefined' ? undefined : JSON.parse(sessionStorage.getItem(key));
      if (!session || !session.timestamp) {
        return;
      }
      var currentTime = Date.now(),
        timeDiff = currentTime - session.timestamp;
      if (timeDiff > _twoHours$1) {
        sessionStorage.removeItem(key);
        return;
      }
      return session;
    }
  }]);
}();

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param request The promise of the REST call for language data that is in progress.
 * @returns A Redux action to set the state that the REST call for language data is in progress.
 * @private
 */ /**
     * @param request The promise of the REST call for language data that is in progress.
     * @returns A Redux action to set the state that the REST call for language data is in progress.
     * @private
     */
function setRequestLanguageInProgress(request) {
  return {
    type: LOCALE_API_ACTION.SET_REQUEST_LANGUAGE_IN_PROGRESS,
    request
  };
}

/**
 * @param error An error from the REST call for language data.
 * @returns A Redux action to set the state that the REST call for language data failed.
 * @private
 */
function setErrorRequestLanguage(error) {
  return {
    type: LOCALE_API_ACTION.SET_ERROR_REQUEST_LANGUAGE,
    error
  };
}

/**
 * @param language The language data from the REST call.
 * @returns A Redux action to set the given language data.
 */
function setLanguage(language) {
  return {
    type: LOCALE_API_ACTION.SET_LANGUAGE,
    language
  };
}

/**
 * @param language A language.
 * @param request The promise of the REST call for locale list data of the given language that is in progress.
 * @returns A Redux action to set the state that the REST call for locale list data for the given language that is in progress.
 * @private
 */
function setRequestLocaleListInProgress(language, request) {
  return {
    type: LOCALE_API_ACTION.SET_REQUEST_LOCALE_LIST_IN_PROGRESS,
    language,
    request
  };
}

/**
 * @param language A language.
 * @param error An error from the REST call for locale list data of the given language.
 * @returns A Redux action to set the state that the REST call for locale list data for the given language failed.
 * @private
 */
function setErrorRequestLocaleList(language, error) {
  return {
    type: LOCALE_API_ACTION.SET_ERROR_REQUEST_LOCALE_LIST,
    language,
    error
  };
}

/**
 * @param language A language.
 * @param localeList The locale list data from the REST call.
 * @returns A Redux action to set the given locale list data.
 */
function setLocaleList(language, localeList) {
  return {
    type: LOCALE_API_ACTION.SET_LOCALE_LIST,
    language,
    localeList
  };
}

/**
 * A Redux action to work with `LocaleAPI`.
 */

/**
 * @returns A Redux action that sends a REST call for language data.
 */
function loadLanguage() {
  return async (dispatch, getState) => {
    var _getState$localeAPI;
    const {
      requestLanguage
    } = (_getState$localeAPI = getState().localeAPI) !== null && _getState$localeAPI !== void 0 ? _getState$localeAPI : {};
    if (requestLanguage) {
      return requestLanguage;
    }
    const promiseLanguage = LocaleAPI.getLocale().then(({
      cc: country,
      lc: primary
    }) => `${primary}-${country}`);
    dispatch(setRequestLanguageInProgress(promiseLanguage));
    try {
      dispatch(setLanguage(await promiseLanguage));
    } catch (error) {
      dispatch(setErrorRequestLanguage(error));
      throw error;
    }
    return promiseLanguage;
  };
}

/**
 * @param language The language. If not given, the default language from DDO is used.
 * @returns A Redux action that sends a REST call for locale list data.
 */
function loadLocaleList(language) {
  return async (dispatch, getState) => {
    var _getState$localeAPI2;
    const effectiveLanguage = language !== null && language !== void 0 ? language : await dispatch(loadLanguage());
    const {
      requestsLocaleList = {}
    } = (_getState$localeAPI2 = getState().localeAPI) !== null && _getState$localeAPI2 !== void 0 ? _getState$localeAPI2 : {};
    const {
      [effectiveLanguage]: requestLocaleList
    } = requestsLocaleList;
    if (requestLocaleList) {
      return requestLocaleList;
    }
    const [primary, country] = effectiveLanguage.split('-');
    const promiseLocaleList = LocaleAPI.getList({
      cc: country.toLowerCase(),
      lc: primary.toLowerCase()
    });
    dispatch(setRequestLocaleListInProgress(effectiveLanguage, promiseLocaleList));
    try {
      dispatch(setLocaleList(effectiveLanguage, await promiseLocaleList));
    } catch (error) {
      dispatch(setErrorRequestLocaleList(effectiveLanguage, error));
    }
    return promiseLocaleList;
  };
}

/**
 * @constant {string | string} Host for the Translation API call
 * @private
 */
var _host$3 = process && (process.env.REACT_APP_TRANSLATION_HOST || process.env.TRANSLATION_HOST) || 'https://1.www.s81c.com';

/**
 * Translation API default endpoint
 *
 * @type {string}
 * @private
 */
var _c4dEndpointDefault = '/common/carbon-for-ibm-dotcom/translations/masthead-footer/v2.1';

/**
 * Translation API endpoint
 *
 * @type {string}
 * @private
 */
var _c4dEndpoint = process && (process.env.REACT_APP_C4D_TRANSLATION_ENDPOINT || process.env.C4D_TRANSLATION_ENDPOINT) || _c4dEndpointDefault;

/**
 * Session Storage key for translation data
 *
 * @type {string}
 * @private
 */
var _sessionTranslationKey = 'c4d-translation';

/**
 * The cache for in-flight or resolved requests for the i18n data, keyed by the initiating locale.
 *
 * @type {object}
 * @private
 */
var _requestsTranslation = {};

/**
 * Sets the default location if nothing is returned
 *
 * @type {object}
 * @private
 */
var _localeDefault = {
  lc: 'en',
  cc: 'us'
};

/**
 * Two hours in milliseconds to compare session timestamp.
 *
 * @type {number}
 * @private
 */
var _twoHours = 60 * 60 * 2000;

/**
 * Translation API class with methods for fetching i18n data for ibm.com
 */
var TranslationAPI = /*#__PURE__*/function () {
  function TranslationAPI() {
    _classCallCheck$2(this, TranslationAPI);
  }
  return _createClass$2(TranslationAPI, null, [{
    key: "clearCache",
    value:
    /**
     * Clears the cache.
     *
     * @param {string} endpoint specified API non-default endpoint (optional)
     */
    function clearCache(endpoint) {
      var sessionKey = this.getSessionKey(endpoint);
      if (typeof sessionStorage !== 'undefined') {
        Object.keys(_requestsTranslation).forEach(function (key) {
          return delete _requestsTranslation[key];
        });
        for (var i = 0; i < sessionStorage.length; ++i) {
          var key = sessionStorage.key(i);
          if (key.indexOf(sessionKey) === 0) {
            sessionStorage.removeItem(key);
          }
        }
      }
    }

    /**
     * Returns translation i18n data
     *
     * @param {object} codes object containing lc and cc
     * @param {string} endpoint endpoint to fetch data from (optional)
     * @returns {Promise<any>} Translation data
     * @example
     * import { TranslationAPI } from '@carbon/ibmdotcom-services';
     *
     * async function getTranslation() {
     *   const response = await TranslationAPI.getTranslation({
     *     lc: 'en',
     *     cc: 'us',
     *   });
     *   return response;
     * }
     */
  }, {
    key: "getTranslation",
    value: (function () {
      var _getTranslation = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(codes, endpoint) {
        var _this = this;
        var lang, country, locale;
        return regenerator.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              lang = 'en';
              country = 'us';
              if (!(codes && codes.lc && codes.cc)) {
                _context.next = 7;
                break;
              }
              lang = codes.lc;
              country = codes.cc;
              _context.next = 12;
              break;
            case 7:
              _context.next = 9;
              return LocaleAPI.getLocale();
            case 9:
              locale = _context.sent;
              lang = locale.lc;
              country = locale.cc;
            case 12:
              return _context.abrupt("return", new Promise(function (resolve, reject) {
                _this.fetchTranslation(lang, country, endpoint, resolve, reject);
              }));
            case 13:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function getTranslation(_x, _x2) {
        return _getTranslation.apply(this, arguments);
      }
      return getTranslation;
    }()
    /**
     * Fetches the translation data from sessionStorage or data fetch
     *
     * @param {string} lang Language code
     * @param {string} country Country code
     * @param {string} endpoint endpoint to fetch data (optional)
     * @param {Function} resolve resolves the Promise
     * @param {Function} reject rejects the promise
     * @private
     */
    )
  }, {
    key: "fetchTranslation",
    value: function fetchTranslation(lang, country, endpoint, resolve, reject) {
      var _this2 = this;
      var sessionKey = this.getSessionKey(endpoint);
      var itemKey = "".concat(sessionKey, "-").concat(country, "-").concat(lang);
      var sessionTranslation = this.getSessionCache(itemKey);
      if (sessionTranslation) {
        resolve(sessionTranslation);
      } else {
        var key = country !== 'undefined' ? "".concat(country, "-").concat(lang) : "".concat(lang);
        if (!_requestsTranslation[key]) {
          var regex = /((http(s?)):\/\/)/g;

          // Check to see if the string from the endpoint variable contains https/http or not.
          var urlEndpoint = endpoint || _c4dEndpoint;
          var locationParam = country !== 'undefined' ? "".concat(country).concat(lang) : "".concat(lang);
          var host = regex.test(endpoint) ? '' : _host$3;
          var url = "".concat(host).concat(urlEndpoint, "/").concat(locationParam, ".json");
          _requestsTranslation[key] = axios$1.get(url, {
            headers: {
              'Content-Type': 'text/plain',
              origin: _host$3
            }
          }).then(function (response) {
            return _this2.transformData(response.data);
          }).then(function (data) {
            data['timestamp'] = Date.now();
            if (typeof sessionStorage !== 'undefined') {
              sessionStorage.setItem("".concat(sessionKey, "-").concat(key), JSON.stringify(data));
            }
            return data;
          });
        }
        _requestsTranslation[key].then(resolve, function (error) {
          if (country === _localeDefault.cc && lang === _localeDefault.lc) {
            reject(error);
          } else {
            _this2.fetchTranslation(_localeDefault.lc, _localeDefault.cc, endpoint, resolve, reject);
          }
        });
      }
    }

    /**
     * sets the Session key depending on API endpoint
     *
     * @param {string} endpoint specified endpoint passed as arg in getTranslation()
     * @returns {string} session key
     * @private
     */
  }, {
    key: "getSessionKey",
    value: function getSessionKey(endpoint) {
      var sessionKey = _sessionTranslationKey;
      // form session key from specified endpoint
      if (_c4dEndpointDefault !== _c4dEndpoint || endpoint) {
        var endpointSrc = endpoint || _c4dEndpoint;
        sessionKey = endpointSrc.replace(/[`~!@#$%^&*()_|+\-=?;:'",.<>{}[\]\\/]/gi, '');
      }
      return sessionKey;
    }

    /**
     * Transforms translation data
     *
     * @param   {object} data translation data to be transformed
     * @returns {object} Translation data
     * @private
     */
  }, {
    key: "transformData",
    value: function transformData(data) {
      var _data$profileMenu;
      var signedout = (_data$profileMenu = data.profileMenu) === null || _data$profileMenu === void 0 ? void 0 : _data$profileMenu.signedout;
      if (signedout) {
        var strReplace = 'state=https%3A%2F%2Fwww.ibm.com';
        var loginIdx = signedout.findIndex(function (elem) {
          var _elem$url;
          return ((_elem$url = elem.url) === null || _elem$url === void 0 ? void 0 : _elem$url.indexOf(strReplace)) !== -1;
        });
        if (loginIdx !== -1 && lib.location) {
          var location = encodeURIComponent(lib.location.href);
          data.profileMenu.signedout[loginIdx].url = signedout[loginIdx].url.replace(strReplace, "state=".concat(location));
        }
      }
      data.footerMenu.push(data.socialFollow);
      return data;
    }

    /**
     * Retrieves session cache and checks if cache needs to be refreshed
     *
     * @param {string} key session storage key
     * @private
     */
  }, {
    key: "getSessionCache",
    value: function getSessionCache(key) {
      var session = typeof sessionStorage === 'undefined' ? undefined : JSON.parse(sessionStorage.getItem(key));
      if (!session || !session.timestamp) {
        return;
      }
      var currentTime = Date.now(),
        timeDiff = currentTime - session.timestamp;
      if (timeDiff > _twoHours) {
        sessionStorage.removeItem(key);
        return;
      }
      return session;
    }
  }]);
}();

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param language A language.
 * @param request The promise of the REST call for translation data of the given language that is in progress.
 * @returns A Redux action to set the state that the REST call for translation data for the given language that is in progress.
 * @private
 */ /**
     * @param language A language.
     * @param request The promise of the REST call for translation data of the given language that is in progress.
     * @returns A Redux action to set the state that the REST call for translation data for the given language that is in progress.
     * @private
     */
function setRequestTranslationInProgress(language, request, endpoint) {
  return {
    type: TRANSLATE_API_ACTION.SET_REQUEST_TRANSLATION_IN_PROGRESS,
    language,
    request,
    endpoint
  };
}

/**
 * @param language A language.
 * @param error An error from the REST call for translation data of the given language.
 * @returns A Redux action to set the state that the REST call for translation data for the given language failed.
 * @private
 */
function setErrorRequestTranslation(language, error) {
  return {
    type: TRANSLATE_API_ACTION.SET_ERROR_REQUEST_TRANSLATION,
    language,
    error
  };
}

/**
 * @param language A language.
 * @param translation The translation data from the REST call.
 * @returns A Redux action to set the given translation data.
 */
function setTranslation(language, translation, endpoint) {
  return {
    type: TRANSLATE_API_ACTION.SET_TRANSLATION,
    language,
    translation,
    endpoint
  };
}

/**
 * A Redux action to work with `TranslateAPI`.
 */

/**
 * @param language The language. If not given, the default language from DDO is used.
 * @param dataEndpoint The translation endpoint to fetch from if not using default c4d endpoint
 * @returns A Redux action that sends a REST call for translation data.
 */
function loadTranslation(language, dataEndpoint) {
  return async (dispatch, getState) => {
    var _getState$translateAP;
    // TODO: Can we go without casts without making `LocaleAPI` types a hard-dependency?
    const effectiveLanguage = language !== null && language !== void 0 ? language : await dispatch(loadLanguage());
    const {
      requestsTranslation = {}
    } = (_getState$translateAP = getState().translateAPI) !== null && _getState$translateAP !== void 0 ? _getState$translateAP : {};
    if (requestsTranslation !== null && requestsTranslation !== void 0 && requestsTranslation[effectiveLanguage]) {
      const requestTranslation = requestsTranslation === null || requestsTranslation === void 0 ? void 0 : requestsTranslation[effectiveLanguage];
      if (requestTranslation && requestTranslation.endpoint === dataEndpoint) {
        return requestTranslation;
      }
    }
    const [primary, country] = effectiveLanguage.split('-');
    const promiseTranslation = TranslationAPI.getTranslation({
      cc: country.toLowerCase(),
      lc: primary.toLowerCase()
    }, dataEndpoint);
    dispatch(setRequestTranslationInProgress(effectiveLanguage, promiseTranslation, dataEndpoint));
    try {
      dispatch(setTranslation(effectiveLanguage, await promiseTranslation, dataEndpoint));
    } catch (error) {
      dispatch(setErrorRequestTranslation(effectiveLanguage, error));
    }
    return promiseTranslation;
  };
}

/**
 * @license
 * Copyright 2019 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const t$4=window,e$6=t$4.ShadowRoot&&(void 0===t$4.ShadyCSS||t$4.ShadyCSS.nativeShadow)&&"adoptedStyleSheets"in Document.prototype&&"replace"in CSSStyleSheet.prototype,s$3=Symbol(),n$5=new WeakMap;class o$7{constructor(t,e,n){if(this._$cssResult$=!0,n!==s$3)throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");this.cssText=t,this.t=e;}get styleSheet(){let t=this.o;const s=this.t;if(e$6&&void 0===t){const e=void 0!==s&&1===s.length;e&&(t=n$5.get(s)),void 0===t&&((this.o=t=new CSSStyleSheet).replaceSync(this.cssText),e&&n$5.set(s,t));}return t}toString(){return this.cssText}}const r$2=t=>new o$7("string"==typeof t?t:t+"",void 0,s$3),i$4=(t,...e)=>{const n=1===t.length?t[0]:e.reduce(((e,s,n)=>e+(t=>{if(!0===t._$cssResult$)return t.cssText;if("number"==typeof t)return t;throw Error("Value passed to 'css' function must be a 'css' function result: "+t+". Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.")})(s)+t[n+1]),t[0]);return new o$7(n,t,s$3)},S$1=(s,n)=>{e$6?s.adoptedStyleSheets=n.map((t=>t instanceof CSSStyleSheet?t:t.styleSheet)):n.forEach((e=>{const n=document.createElement("style"),o=t$4.litNonce;void 0!==o&&n.setAttribute("nonce",o),n.textContent=e.cssText,s.appendChild(n);}));},c$1=e$6?t=>t:t=>t instanceof CSSStyleSheet?(t=>{let e="";for(const s of t.cssRules)e+=s.cssText;return r$2(e)})(t):t;

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */var s$2;const e$5=window,r$1=e$5.trustedTypes,h$1=r$1?r$1.emptyScript:"",o$6=e$5.reactiveElementPolyfillSupport,n$4={toAttribute(t,i){switch(i){case Boolean:t=t?h$1:null;break;case Object:case Array:t=null==t?t:JSON.stringify(t);}return t},fromAttribute(t,i){let s=t;switch(i){case Boolean:s=null!==t;break;case Number:s=null===t?null:Number(t);break;case Object:case Array:try{s=JSON.parse(t);}catch(t){s=null;}}return s}},a$1=(t,i)=>i!==t&&(i==i||t==t),l$3={attribute:!0,type:String,converter:n$4,reflect:!1,hasChanged:a$1},d$1="finalized";class u$1 extends HTMLElement{constructor(){super(),this._$Ei=new Map,this.isUpdatePending=!1,this.hasUpdated=!1,this._$El=null,this._$Eu();}static addInitializer(t){var i;this.finalize(),(null!==(i=this.h)&&void 0!==i?i:this.h=[]).push(t);}static get observedAttributes(){this.finalize();const t=[];return this.elementProperties.forEach(((i,s)=>{const e=this._$Ep(s,i);void 0!==e&&(this._$Ev.set(e,s),t.push(e));})),t}static createProperty(t,i=l$3){if(i.state&&(i.attribute=!1),this.finalize(),this.elementProperties.set(t,i),!i.noAccessor&&!this.prototype.hasOwnProperty(t)){const s="symbol"==typeof t?Symbol():"__"+t,e=this.getPropertyDescriptor(t,s,i);void 0!==e&&Object.defineProperty(this.prototype,t,e);}}static getPropertyDescriptor(t,i,s){return {get(){return this[i]},set(e){const r=this[t];this[i]=e,this.requestUpdate(t,r,s);},configurable:!0,enumerable:!0}}static getPropertyOptions(t){return this.elementProperties.get(t)||l$3}static finalize(){if(this.hasOwnProperty(d$1))return !1;this[d$1]=!0;const t=Object.getPrototypeOf(this);if(t.finalize(),void 0!==t.h&&(this.h=[...t.h]),this.elementProperties=new Map(t.elementProperties),this._$Ev=new Map,this.hasOwnProperty("properties")){const t=this.properties,i=[...Object.getOwnPropertyNames(t),...Object.getOwnPropertySymbols(t)];for(const s of i)this.createProperty(s,t[s]);}return this.elementStyles=this.finalizeStyles(this.styles),!0}static finalizeStyles(i){const s=[];if(Array.isArray(i)){const e=new Set(i.flat(1/0).reverse());for(const i of e)s.unshift(c$1(i));}else void 0!==i&&s.push(c$1(i));return s}static _$Ep(t,i){const s=i.attribute;return !1===s?void 0:"string"==typeof s?s:"string"==typeof t?t.toLowerCase():void 0}_$Eu(){var t;this._$E_=new Promise((t=>this.enableUpdating=t)),this._$AL=new Map,this._$Eg(),this.requestUpdate(),null===(t=this.constructor.h)||void 0===t||t.forEach((t=>t(this)));}addController(t){var i,s;(null!==(i=this._$ES)&&void 0!==i?i:this._$ES=[]).push(t),void 0!==this.renderRoot&&this.isConnected&&(null===(s=t.hostConnected)||void 0===s||s.call(t));}removeController(t){var i;null===(i=this._$ES)||void 0===i||i.splice(this._$ES.indexOf(t)>>>0,1);}_$Eg(){this.constructor.elementProperties.forEach(((t,i)=>{this.hasOwnProperty(i)&&(this._$Ei.set(i,this[i]),delete this[i]);}));}createRenderRoot(){var t;const s=null!==(t=this.shadowRoot)&&void 0!==t?t:this.attachShadow(this.constructor.shadowRootOptions);return S$1(s,this.constructor.elementStyles),s}connectedCallback(){var t;void 0===this.renderRoot&&(this.renderRoot=this.createRenderRoot()),this.enableUpdating(!0),null===(t=this._$ES)||void 0===t||t.forEach((t=>{var i;return null===(i=t.hostConnected)||void 0===i?void 0:i.call(t)}));}enableUpdating(t){}disconnectedCallback(){var t;null===(t=this._$ES)||void 0===t||t.forEach((t=>{var i;return null===(i=t.hostDisconnected)||void 0===i?void 0:i.call(t)}));}attributeChangedCallback(t,i,s){this._$AK(t,s);}_$EO(t,i,s=l$3){var e;const r=this.constructor._$Ep(t,s);if(void 0!==r&&!0===s.reflect){const h=(void 0!==(null===(e=s.converter)||void 0===e?void 0:e.toAttribute)?s.converter:n$4).toAttribute(i,s.type);this._$El=t,null==h?this.removeAttribute(r):this.setAttribute(r,h),this._$El=null;}}_$AK(t,i){var s;const e=this.constructor,r=e._$Ev.get(t);if(void 0!==r&&this._$El!==r){const t=e.getPropertyOptions(r),h="function"==typeof t.converter?{fromAttribute:t.converter}:void 0!==(null===(s=t.converter)||void 0===s?void 0:s.fromAttribute)?t.converter:n$4;this._$El=r,this[r]=h.fromAttribute(i,t.type),this._$El=null;}}requestUpdate(t,i,s){let e=!0;void 0!==t&&(((s=s||this.constructor.getPropertyOptions(t)).hasChanged||a$1)(this[t],i)?(this._$AL.has(t)||this._$AL.set(t,i),!0===s.reflect&&this._$El!==t&&(void 0===this._$EC&&(this._$EC=new Map),this._$EC.set(t,s))):e=!1),!this.isUpdatePending&&e&&(this._$E_=this._$Ej());}async _$Ej(){this.isUpdatePending=!0;try{await this._$E_;}catch(t){Promise.reject(t);}const t=this.scheduleUpdate();return null!=t&&await t,!this.isUpdatePending}scheduleUpdate(){return this.performUpdate()}performUpdate(){var t;if(!this.isUpdatePending)return;this.hasUpdated,this._$Ei&&(this._$Ei.forEach(((t,i)=>this[i]=t)),this._$Ei=void 0);let i=!1;const s=this._$AL;try{i=this.shouldUpdate(s),i?(this.willUpdate(s),null===(t=this._$ES)||void 0===t||t.forEach((t=>{var i;return null===(i=t.hostUpdate)||void 0===i?void 0:i.call(t)})),this.update(s)):this._$Ek();}catch(t){throw i=!1,this._$Ek(),t}i&&this._$AE(s);}willUpdate(t){}_$AE(t){var i;null===(i=this._$ES)||void 0===i||i.forEach((t=>{var i;return null===(i=t.hostUpdated)||void 0===i?void 0:i.call(t)})),this.hasUpdated||(this.hasUpdated=!0,this.firstUpdated(t)),this.updated(t);}_$Ek(){this._$AL=new Map,this.isUpdatePending=!1;}get updateComplete(){return this.getUpdateComplete()}getUpdateComplete(){return this._$E_}shouldUpdate(t){return !0}update(t){void 0!==this._$EC&&(this._$EC.forEach(((t,i)=>this._$EO(i,this[i],t))),this._$EC=void 0),this._$Ek();}updated(t){}firstUpdated(t){}}u$1[d$1]=!0,u$1.elementProperties=new Map,u$1.elementStyles=[],u$1.shadowRootOptions={mode:"open"},null==o$6||o$6({ReactiveElement:u$1}),(null!==(s$2=e$5.reactiveElementVersions)&&void 0!==s$2?s$2:e$5.reactiveElementVersions=[]).push("1.6.3");

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
var t$3;const i$3=window,s$1=i$3.trustedTypes,e$4=s$1?s$1.createPolicy("lit-html",{createHTML:t=>t}):void 0,o$5="$lit$",n$3=`lit$${(Math.random()+"").slice(9)}$`,l$2="?"+n$3,h=`<${l$2}>`,r=document,u=()=>r.createComment(""),d=t=>null===t||"object"!=typeof t&&"function"!=typeof t,c=Array.isArray,v=t=>c(t)||"function"==typeof(null==t?void 0:t[Symbol.iterator]),a="[ \t\n\f\r]",f=/<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g,_$Z=/-->/g,m=/>/g,p=RegExp(`>|${a}(?:([^\\s"'>=/]+)(${a}*=${a}*(?:[^ \t\n\f\r"'\`<>=]|("|')|))|$)`,"g"),g=/'/g,$=/"/g,y=/^(?:script|style|textarea|title)$/i,w=t=>(i,...s)=>({_$litType$:t,strings:i,values:s}),x=w(1),b=w(2),T=Symbol.for("lit-noChange"),A=Symbol.for("lit-nothing"),E=new WeakMap,C=r.createTreeWalker(r,129,null,!1);function P(t,i){if(!Array.isArray(t)||!t.hasOwnProperty("raw"))throw Error("invalid template strings array");return void 0!==e$4?e$4.createHTML(i):i}const V=(t,i)=>{const s=t.length-1,e=[];let l,r=2===i?"<svg>":"",u=f;for(let i=0;i<s;i++){const s=t[i];let d,c,v=-1,a=0;for(;a<s.length&&(u.lastIndex=a,c=u.exec(s),null!==c);)a=u.lastIndex,u===f?"!--"===c[1]?u=_$Z:void 0!==c[1]?u=m:void 0!==c[2]?(y.test(c[2])&&(l=RegExp("</"+c[2],"g")),u=p):void 0!==c[3]&&(u=p):u===p?">"===c[0]?(u=null!=l?l:f,v=-1):void 0===c[1]?v=-2:(v=u.lastIndex-c[2].length,d=c[1],u=void 0===c[3]?p:'"'===c[3]?$:g):u===$||u===g?u=p:u===_$Z||u===m?u=f:(u=p,l=void 0);const w=u===p&&t[i+1].startsWith("/>")?" ":"";r+=u===f?s+h:v>=0?(e.push(d),s.slice(0,v)+o$5+s.slice(v)+n$3+w):s+n$3+(-2===v?(e.push(void 0),i):w);}return [P(t,r+(t[s]||"<?>")+(2===i?"</svg>":"")),e]};class N{constructor({strings:t,_$litType$:i},e){let h;this.parts=[];let r=0,d=0;const c=t.length-1,v=this.parts,[a,f]=V(t,i);if(this.el=N.createElement(a,e),C.currentNode=this.el.content,2===i){const t=this.el.content,i=t.firstChild;i.remove(),t.append(...i.childNodes);}for(;null!==(h=C.nextNode())&&v.length<c;){if(1===h.nodeType){if(h.hasAttributes()){const t=[];for(const i of h.getAttributeNames())if(i.endsWith(o$5)||i.startsWith(n$3)){const s=f[d++];if(t.push(i),void 0!==s){const t=h.getAttribute(s.toLowerCase()+o$5).split(n$3),i=/([.?@])?(.*)/.exec(s);v.push({type:1,index:r,name:i[2],strings:t,ctor:"."===i[1]?H:"?"===i[1]?L:"@"===i[1]?z:k});}else v.push({type:6,index:r});}for(const i of t)h.removeAttribute(i);}if(y.test(h.tagName)){const t=h.textContent.split(n$3),i=t.length-1;if(i>0){h.textContent=s$1?s$1.emptyScript:"";for(let s=0;s<i;s++)h.append(t[s],u()),C.nextNode(),v.push({type:2,index:++r});h.append(t[i],u());}}}else if(8===h.nodeType)if(h.data===l$2)v.push({type:2,index:r});else {let t=-1;for(;-1!==(t=h.data.indexOf(n$3,t+1));)v.push({type:7,index:r}),t+=n$3.length-1;}r++;}}static createElement(t,i){const s=r.createElement("template");return s.innerHTML=t,s}}function S(t,i,s=t,e){var o,n,l,h;if(i===T)return i;let r=void 0!==e?null===(o=s._$Co)||void 0===o?void 0:o[e]:s._$Cl;const u=d(i)?void 0:i._$litDirective$;return (null==r?void 0:r.constructor)!==u&&(null===(n=null==r?void 0:r._$AO)||void 0===n||n.call(r,!1),void 0===u?r=void 0:(r=new u(t),r._$AT(t,s,e)),void 0!==e?(null!==(l=(h=s)._$Co)&&void 0!==l?l:h._$Co=[])[e]=r:s._$Cl=r),void 0!==r&&(i=S(t,r._$AS(t,i.values),r,e)),i}class M{constructor(t,i){this._$AV=[],this._$AN=void 0,this._$AD=t,this._$AM=i;}get parentNode(){return this._$AM.parentNode}get _$AU(){return this._$AM._$AU}u(t){var i;const{el:{content:s},parts:e}=this._$AD,o=(null!==(i=null==t?void 0:t.creationScope)&&void 0!==i?i:r).importNode(s,!0);C.currentNode=o;let n=C.nextNode(),l=0,h=0,u=e[0];for(;void 0!==u;){if(l===u.index){let i;2===u.type?i=new R(n,n.nextSibling,this,t):1===u.type?i=new u.ctor(n,u.name,u.strings,this,t):6===u.type&&(i=new Z(n,this,t)),this._$AV.push(i),u=e[++h];}l!==(null==u?void 0:u.index)&&(n=C.nextNode(),l++);}return C.currentNode=r,o}v(t){let i=0;for(const s of this._$AV)void 0!==s&&(void 0!==s.strings?(s._$AI(t,s,i),i+=s.strings.length-2):s._$AI(t[i])),i++;}}class R{constructor(t,i,s,e){var o;this.type=2,this._$AH=A,this._$AN=void 0,this._$AA=t,this._$AB=i,this._$AM=s,this.options=e,this._$Cp=null===(o=null==e?void 0:e.isConnected)||void 0===o||o;}get _$AU(){var t,i;return null!==(i=null===(t=this._$AM)||void 0===t?void 0:t._$AU)&&void 0!==i?i:this._$Cp}get parentNode(){let t=this._$AA.parentNode;const i=this._$AM;return void 0!==i&&11===(null==t?void 0:t.nodeType)&&(t=i.parentNode),t}get startNode(){return this._$AA}get endNode(){return this._$AB}_$AI(t,i=this){t=S(this,t,i),d(t)?t===A||null==t||""===t?(this._$AH!==A&&this._$AR(),this._$AH=A):t!==this._$AH&&t!==T&&this._(t):void 0!==t._$litType$?this.g(t):void 0!==t.nodeType?this.$(t):v(t)?this.T(t):this._(t);}k(t){return this._$AA.parentNode.insertBefore(t,this._$AB)}$(t){this._$AH!==t&&(this._$AR(),this._$AH=this.k(t));}_(t){this._$AH!==A&&d(this._$AH)?this._$AA.nextSibling.data=t:this.$(r.createTextNode(t)),this._$AH=t;}g(t){var i;const{values:s,_$litType$:e}=t,o="number"==typeof e?this._$AC(t):(void 0===e.el&&(e.el=N.createElement(P(e.h,e.h[0]),this.options)),e);if((null===(i=this._$AH)||void 0===i?void 0:i._$AD)===o)this._$AH.v(s);else {const t=new M(o,this),i=t.u(this.options);t.v(s),this.$(i),this._$AH=t;}}_$AC(t){let i=E.get(t.strings);return void 0===i&&E.set(t.strings,i=new N(t)),i}T(t){c(this._$AH)||(this._$AH=[],this._$AR());const i=this._$AH;let s,e=0;for(const o of t)e===i.length?i.push(s=new R(this.k(u()),this.k(u()),this,this.options)):s=i[e],s._$AI(o),e++;e<i.length&&(this._$AR(s&&s._$AB.nextSibling,e),i.length=e);}_$AR(t=this._$AA.nextSibling,i){var s;for(null===(s=this._$AP)||void 0===s||s.call(this,!1,!0,i);t&&t!==this._$AB;){const i=t.nextSibling;t.remove(),t=i;}}setConnected(t){var i;void 0===this._$AM&&(this._$Cp=t,null===(i=this._$AP)||void 0===i||i.call(this,t));}}class k{constructor(t,i,s,e,o){this.type=1,this._$AH=A,this._$AN=void 0,this.element=t,this.name=i,this._$AM=e,this.options=o,s.length>2||""!==s[0]||""!==s[1]?(this._$AH=Array(s.length-1).fill(new String),this.strings=s):this._$AH=A;}get tagName(){return this.element.tagName}get _$AU(){return this._$AM._$AU}_$AI(t,i=this,s,e){const o=this.strings;let n=!1;if(void 0===o)t=S(this,t,i,0),n=!d(t)||t!==this._$AH&&t!==T,n&&(this._$AH=t);else {const e=t;let l,h;for(t=o[0],l=0;l<o.length-1;l++)h=S(this,e[s+l],i,l),h===T&&(h=this._$AH[l]),n||(n=!d(h)||h!==this._$AH[l]),h===A?t=A:t!==A&&(t+=(null!=h?h:"")+o[l+1]),this._$AH[l]=h;}n&&!e&&this.j(t);}j(t){t===A?this.element.removeAttribute(this.name):this.element.setAttribute(this.name,null!=t?t:"");}}class H extends k{constructor(){super(...arguments),this.type=3;}j(t){this.element[this.name]=t===A?void 0:t;}}const I=s$1?s$1.emptyScript:"";class L extends k{constructor(){super(...arguments),this.type=4;}j(t){t&&t!==A?this.element.setAttribute(this.name,I):this.element.removeAttribute(this.name);}}class z extends k{constructor(t,i,s,e,o){super(t,i,s,e,o),this.type=5;}_$AI(t,i=this){var s;if((t=null!==(s=S(this,t,i,0))&&void 0!==s?s:A)===T)return;const e=this._$AH,o=t===A&&e!==A||t.capture!==e.capture||t.once!==e.once||t.passive!==e.passive,n=t!==A&&(e===A||o);o&&this.element.removeEventListener(this.name,this,e),n&&this.element.addEventListener(this.name,this,t),this._$AH=t;}handleEvent(t){var i,s;"function"==typeof this._$AH?this._$AH.call(null!==(s=null===(i=this.options)||void 0===i?void 0:i.host)&&void 0!==s?s:this.element,t):this._$AH.handleEvent(t);}}class Z{constructor(t,i,s){this.element=t,this.type=6,this._$AN=void 0,this._$AM=i,this.options=s;}get _$AU(){return this._$AM._$AU}_$AI(t){S(this,t);}}const B=i$3.litHtmlPolyfillSupport;null==B||B(N,R),(null!==(t$3=i$3.litHtmlVersions)&&void 0!==t$3?t$3:i$3.litHtmlVersions=[]).push("2.8.0");const D=(t,i,s)=>{var e,o;const n=null!==(e=null==s?void 0:s.renderBefore)&&void 0!==e?e:i;let l=n._$litPart$;if(void 0===l){const t=null!==(o=null==s?void 0:s.renderBefore)&&void 0!==o?o:null;n._$litPart$=l=new R(i.insertBefore(u(),t),t,void 0,null!=s?s:{});}return l._$AI(t),l};

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */var l$1,o$4;class s extends u$1{constructor(){super(...arguments),this.renderOptions={host:this},this._$Do=void 0;}createRenderRoot(){var t,e;const i=super.createRenderRoot();return null!==(t=(e=this.renderOptions).renderBefore)&&void 0!==t||(e.renderBefore=i.firstChild),i}update(t){const i=this.render();this.hasUpdated||(this.renderOptions.isConnected=this.isConnected),super.update(t),this._$Do=D(i,this.renderRoot,this.renderOptions);}connectedCallback(){var t;super.connectedCallback(),null===(t=this._$Do)||void 0===t||t.setConnected(!0);}disconnectedCallback(){var t;super.disconnectedCallback(),null===(t=this._$Do)||void 0===t||t.setConnected(!1);}render(){return T}}s.finalized=!0,s._$litElement$=!0,null===(l$1=globalThis.litElementHydrateSupport)||void 0===l$1||l$1.call(globalThis,{LitElement:s});const n$2=globalThis.litElementPolyfillSupport;null==n$2||n$2({LitElement:s});(null!==(o$4=globalThis.litElementVersions)&&void 0!==o$4?o$4:globalThis.litElementVersions=[]).push("3.3.3");

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const i$2=(i,e)=>"method"===e.kind&&e.descriptor&&!("value"in e.descriptor)?{...e,finisher(n){n.createProperty(e.key,i);}}:{kind:"field",key:Symbol(),placement:"own",descriptor:{},originalKey:e.key,initializer(){"function"==typeof e.initializer&&(this[e.key]=e.initializer.call(this));},finisher(n){n.createProperty(e.key,i);}},e$3=(i,e,n)=>{e.constructor.createProperty(n,i);};function n$1(n){return (t,o)=>void 0!==o?e$3(n,t,o):i$2(n,t)}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function t$2(t){return n$1({...t,state:!0})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const o$3=({finisher:e,descriptor:t})=>(o,n)=>{var r;if(void 0===n){const n=null!==(r=o.originalKey)&&void 0!==r?r:o.key,i=null!=t?{kind:"method",placement:"prototype",key:n,descriptor:t(o.key)}:{...o,key:n};return null!=e&&(i.finisher=function(t){e(t,n);}),i}{const r=o.constructor;void 0!==t&&Object.defineProperty(o,n,t(n)),null==e||e(r,n);}};

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function i$1(i,n){return o$3({descriptor:o=>{const t={get(){var o,n;return null!==(n=null===(o=this.renderRoot)||void 0===o?void 0:o.querySelector(i))&&void 0!==n?n:null},enumerable:!0,configurable:!0};if(n){const n="symbol"==typeof o?Symbol():"__"+o;t.get=function(){var o,t;return void 0===this[n]&&(this[n]=null!==(t=null===(o=this.renderRoot)||void 0===o?void 0:o.querySelector(i))&&void 0!==t?t:null),this[n]};}return t}})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function e$2(e){return o$3({descriptor:r=>({get(){var r,o;return null!==(o=null===(r=this.renderRoot)||void 0===r?void 0:r.querySelectorAll(e))&&void 0!==o?o:[]},enumerable:!0,configurable:!0})})}

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */var n;null!=(null===(n=window.HTMLSlotElement)||void 0===n?void 0:n.prototype.assignedElements)?(o,n)=>o.assignedElements(n):(o,n)=>o.assignedNodes(n).filter((o=>o.nodeType===Node.ELEMENT_NODE));

/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const l=l=>null!=l?l:A;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Puts an event listener to an internal table for `@HostListener()`.
 *
 * @param type
 *   The event type. Can be prefixed with `document:` or `window:`.
 *   The event listener is attached to host element's owner document or its default view in such case.
 * @param options The event listener options.
 * @param Clazz The target class.
 * @param name The method name in the given target class that works as the event listener.
 */
const setHostListener = (type, options, Clazz, name) => {
  const hostListeners = Clazz._hostListeners;
  if (!hostListeners) {
    throw new Error('The method `@HostListener()` is defined on has to be of a class that has `HostListerMixin`.');
  }
  if (!hostListeners[name]) {
    hostListeners[name] = {};
  }
  hostListeners[name][type] = {
    options
  };
};

/**
 * @param type
 *   The event type. Can be prefixed with `document:` or `window:`.
 *   The event listener is attached to host element's owner document or its default view in such case.
 * @param options The event listener options.
 * @param descriptor The original class element descriptor of the event listener method.
 * @returns The updated class element descriptor with `@HostListener()` decorator.
 */
const HostListenerStandard = (type, options, descriptor) => {
  const {
    kind,
    key,
    placement
  } = descriptor;
  if (!(kind === 'method' && placement === 'prototype' || kind === 'field' && placement === 'own')) {
    throw new Error('`@HostListener()` must be defined on instance methods, but you may have defined it on static, field, etc.');
  }
  return _objectSpread2(_objectSpread2({}, descriptor), {}, {
    finisher(Clazz) {
      setHostListener(type, options, Clazz, key);
    }
  });
};

/**
 * A decorator to add event listener to the host element, or its `document`/`window`, of a custom element.
 * The `target` must extend `HostListenerMixin`.
 *
 * @param type
 *   The event type. Can be prefixed with `document:` or `window:`.
 *   The event listener is attached to host element's owner document or its default view in such case.
 * @param options The event listener options.
 */
const HostListener = (type, options) => (targetOrDescriptor, name) => typeof name !== 'undefined' ? setHostListener(type, options, targetOrDescriptor.constructor, name) : HostListenerStandard(type, options, targetOrDescriptor);

/**
 * Copyright IBM Corp. 2016, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

function on$1(element, ...args) {
  element.addEventListener(...args);
  return {
    release() {
      element.removeEventListener(...args);
      return null;
    }
  };
}

/**
 * The format for the event name used by `@HostListener` decorator.
 */
const EVENT_NAME_FORMAT = /^((document|window|parentRoot|shadowRoot):)?([\w-]+)$/;

/**
 * @param Base The base class.
 * @returns A mix-in that sets up and cleans up event listeners defined by `@HostListener` decorator.
 */
const HostListenerMixin = Base => {
  /**
   * A mix-in class that sets up and cleans up event listeners defined by `@HostListener` decorator.
   */
  class HostListenerMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * The list of handles managed by this mix-in.
       *
       * @private
       */
      _defineProperty$e(this, "_handles", new Set());
    }
    // Not using TypeScript `private` due to: microsoft/TypeScript#17744

    connectedCallback() {
      // @ts-ignore: Until `connectedCallback` is added to `HTMLElement` definition
      super.connectedCallback();
      const hostListeners = this.constructor._hostListeners;
      Object.keys(hostListeners).forEach(listenerName => {
        Object.keys(hostListeners[listenerName]).forEach(type => {
          var _unprefixedType;
          // Parses `document:click`/`window:click` format
          const tokens = EVENT_NAME_FORMAT.exec(type);
          if (!tokens) {
            throw new Error(`Could not parse the event name: ${listenerName}`);
          }
          const [,, targetName, unprefixedType] = tokens;
          const target = {
            document: this.ownerDocument,
            window: this.ownerDocument.defaultView,
            parentRoot: this.getRootNode(),
            shadowRoot: this.shadowRoot
          }[targetName] || this;
          const {
            options
          } = hostListeners[listenerName][type];
          this._handles.add(on$1(target, (_unprefixedType = this.constructor[unprefixedType]) !== null && _unprefixedType !== void 0 ? _unprefixedType : unprefixedType, this[listenerName], options));
        });
      });
    }
    disconnectedCallback() {
      this._handles.forEach(handle => {
        handle.release();
        this._handles.delete(handle);
      });
      // @ts-ignore: Until `disconnectedCallback` is added to `HTMLElement` definition
      super.disconnectedCallback();
    }

    /**
     * The map, keyed by method name, of event listeners that should be attached to host element or host document.
     *
     * @private
     */

    // Not using TypeScript `private` due to: microsoft/TypeScript#17744
  }
  _defineProperty$e(HostListenerMixinImpl, "_hostListeners", {});
  return HostListenerMixinImpl;
};

/**
 * Copyright IBM Corp. 2018, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Copyright IBM Corp. 2018, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

// Convert
// Default, Use with em() and rem() functions
var baseFontSize = 16;

/**
 * Convert a given px unit to a rem unit
 * @param {number} px
 * @returns {string}
 */
function rem(px) {
  return "".concat(px / baseFontSize, "rem");
}

// Breakpoint
// Initial map of our breakpoints and their values
var breakpoints = {
  sm: {
    width: rem(320),
    columns: 4,
    margin: '0'
  },
  md: {
    width: rem(672),
    columns: 8,
    margin: rem(16)
  },
  lg: {
    width: rem(1056),
    columns: 16,
    margin: rem(16)
  },
  xlg: {
    width: rem(1312),
    columns: 16,
    margin: rem(16)
  },
  max: {
    width: rem(1584),
    columns: 16,
    margin: rem(24)
  }
};

function _defineProperty$d(e, r, t) { return (r = _toPropertyKey$13(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey$13(t) { var i = _toPrimitive$13(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$13(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
let MQBreakpoints;
(function (MQBreakpoints) {
  MQBreakpoints["SM"] = "sm";
  MQBreakpoints["MD"] = "md";
  MQBreakpoints["LG"] = "lg";
  MQBreakpoints["XLG"] = "xlg";
  MQBreakpoints["MAX"] = "max";
})(MQBreakpoints || (MQBreakpoints = {}));
let MQDirs;

/**
 * @param Base The base class.
 * @returns A mix-in implementing the logic for performing actions when the
 * viewport width crosses over configured Carbon breakpoints.
 */
(function (MQDirs) {
  MQDirs["MIN"] = "min";
  MQDirs["MAX"] = "max";
})(MQDirs || (MQDirs = {}));
const MediaQueryMixin = (Base, config) => {
  class MediaQueryMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * Configuration passed as argument into MediaQueryMixin.
       */
      _defineProperty$d(this, "_mqConfig", config);
      /**
       * A keyed list of MediaQueryList objects.
       */
      _defineProperty$d(this, "carbonBreakpoints", this._generateMediaQueriesByBreakpoint());
    }
    /**
     * Generates a list of MediaQueryList objects keyed by breakpoint identifiers.
     *
     * @see https://developer.mozilla.org/en-US/docs/Web/API/MediaQueryList
     */
    _generateMediaQueriesByBreakpoint() {
      const {
        _mqConfig: config
      } = this;
      const breakpoints$1 = Object.keys(config);
      const queries = {};
      breakpoints$1.forEach(bp => {
        queries[bp] = lib.matchMedia(`(${config[bp]}-width: ${breakpoints[bp].width})`);
      });
      return queries;
    }
    /**
     * Sets up event listeners that fire any defined callback methods that
     * correspond to the breakpoint being crossed over.
     *
     * Example callback method names:
     *  - mediaQueryCallbackSM
     *  - mediaQueryCallbackLG
     *  - mediaQueryCallbackMaxMD
     *  - mediaQueryCallbackMaxMAX
     */
    _attachMediaQueryEventListeners() {
      const {
        _mqConfig: config,
        carbonBreakpoints
      } = this;
      Object.keys(carbonBreakpoints).forEach(bp => {
        const dir = config[bp] === MQDirs.MAX ? `${config[bp][0].toUpperCase()}${config[bp].slice(1)}` : '';
        const funcName = `mediaQueryCallback${dir}${bp.toUpperCase()}`;
        if (typeof this[funcName] === 'function') {
          this.carbonBreakpoints[bp].addEventListener('change', this[funcName].bind(this));
        } else {
          console.warn(`MediaQueryMixin: Element ${this.nodeName} has not defined a callback for the "${bp}" breakpoint. Please remove the breakpoint from the mixin configuration or implement the following method: ${funcName}`);
        }
      });
    }
    firstUpdated() {
      this._attachMediaQueryEventListeners();
      //@ts-ignore
      super.firstUpdated();
    }
  }
  return MediaQueryMixinImpl;
};

function _defineProperty$c(e, r, t) { return (r = _toPropertyKey$12(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey$12(t) { var i = _toPrimitive$12(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$12(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * @param Base The base class.
 * @returns A mix-in that allows rendering both Shadow DOM and light DOM.
 */
const HybridRenderMixin = Base => {
  class HybridRenderMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * The render target in the light DOM.
       */
      _defineProperty$c(this, "lightRenderRoot", null);
    }
    /**
     * @returns The template to be render into the light DOM.
     */
    /**
     * @returns The render root of the light DOM.
     */
    createLightRenderRoot() {
      return this;
    }
    update(changedProperties) {
      // TODO: Figure out how to inherit `LitElement` for this mix-in class
      // @ts-ignore
      super.update(changedProperties);
      if (!this.lightRenderRoot) {
        this.lightRenderRoot = this.createLightRenderRoot();
      }
      const {
        lightRenderRoot
      } = this;
      if (lightRenderRoot) {
        D(this.renderLightDOM(), lightRenderRoot);
      }
    }
  }
  return HybridRenderMixinImpl;
};

function _defineProperty$b(e, r, t) { return (r = _toPropertyKey$11(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey$11(t) { var i = _toPrimitive$11(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$11(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * @param elem The starting element.
 * @param selector The CSS selector.
 * @returns {Element}
 *   The closest ancestor node of the given element that matches the given selector, crossing Shadow DOM boundary.
 */
const closestComposed = (elem, selector) => {
  const found = elem.closest(selector);
  if (found) {
    return found;
  }
  const {
    host
  } = elem.getRootNode();
  if (host) {
    return closestComposed(host, selector);
  }
  return null;
};

/**
 * @param Base The base class.
 * @returns A mix-in that allows rendering modal, that should typically be rendered to a DOM node outside the component.
 */
const ModalRenderMixin = Base => {
  class ModalRenderMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * `true` if this component is disconnected from render tree after creation.
       *
       * @private
       */
      _defineProperty$b(this, "_disconnectedAfterCreation", false);
      /**
       * The render target of the modal.
       */
      _defineProperty$b(this, "modalRenderRoot", null);
      /**
       * Defines properties which should trigger modal renders. If none are specified,
       * modal renders on any property update.
       */
      _defineProperty$b(this, "modalTriggerProps", []);
    }
    // Not using TypeScript `private` due to: microsoft/TypeScript#17744

    /**
     * Creates and renders the modal
     *
     * @private
     */
    // Not using TypeScript `private` due to: microsoft/TypeScript#17744
    _createAndRenderModal() {
      if (!this.modalRenderRoot) {
        this.modalRenderRoot = this.createModalRenderRoot();
      }
      const {
        modalRenderRoot
      } = this;
      if (modalRenderRoot) {
        D(this.renderModal(), modalRenderRoot);
      }
    }

    /**
     * @returns The template of the modal.
     */

    /**
     * The DOM element to put the modal into.
     */
    get container() {
      const {
        selectorContainer
      } = this.constructor;
      return closestComposed(this, selectorContainer) || this.ownerDocument.body;
    }

    /**
     * @returns The render root of the modal.
     */
    createModalRenderRoot() {
      const {
        container,
        ownerDocument: doc
      } = this;
      const div = doc.createElement('div');
      div.style.display = 'contents'; // Prevents render-root `<div>` from being rendered
      container.appendChild(div);
      return div;
    }
    connectedCallback() {
      // TODO: Figure out how to inherit `LitElement` for this mix-in class
      // @ts-ignore
      super.connectedCallback();
      if (this._disconnectedAfterCreation) {
        this._disconnectedAfterCreation = false;
        this._createAndRenderModal();
      }
    }
    disconnectedCallback() {
      if (this.modalRenderRoot) {
        this.modalRenderRoot.remove();
        this.modalRenderRoot = null;
      }
      // TODO: Figure out how to inherit `LitElement` for this mix-in class
      // @ts-ignore
      super.disconnectedCallback();
      this._disconnectedAfterCreation = true;
    }
    update(changedProperties) {
      const {
        modalTriggerProps
      } = this;
      // TODO: Figure out how to inherit `LitElement` for this mix-in class
      // @ts-ignore
      super.update(changedProperties);
      if (!this._disconnectedAfterCreation) {
        if (modalTriggerProps.length > 0) {
          // React only on updates to specified properties.
          const changedPropNames = Array.from(changedProperties.keys());
          const matches = modalTriggerProps.filter(prop => changedPropNames.includes(prop));
          if (matches.length > 0) {
            this._createAndRenderModal();
          }
        } else {
          // React on every property update.
          this._createAndRenderModal();
        }
      }
    }

    /**
     * The CSS selector to find the element to put the modal in.
     */
    static get selectorContainer() {
      return '[data-modal-container]';
    }
  }
  return ModalRenderMixinImpl;
};

/**
 * @constant {boolean} scrollTracker determines whether scroll tracking analytics is enabled
 * @private
 */
var _scrollTracker = process && process.env.SCROLL_TRACKING === 'true' || false;

/**
 * Current NODE_ENV
 *
 * @type {string | string}
 * @private
 */
var _env = process && "development" || 'development';

/**
 * Analytics API class with methods for firing analytics events on
 * ibm.com
 */
var AnalyticsAPI = /*#__PURE__*/function () {
  function AnalyticsAPI() {
    _classCallCheck$2(this, AnalyticsAPI);
  }
  return _createClass$2(AnalyticsAPI, null, [{
    key: "registerEvent",
    value:
    /**
     * This method checks that the analytics script has been loaded
     * and fires an event to Coremetrics
     *
     * @param {object} eventData Object with standard IBM metric event properties and values to send to Coremetrics
     * @example
     * import { AnalyticsAPI } from '@carbon/ibmdotcom-services';
     *
     * function fireEvent() {
     *    const eventData = {
     *        type: 'element',
     *        primaryCategory: 'MASTHEAD',
     *        eventName: 'CLICK',
     *        executionPath: 'masthead__profile',
     *        execPathReturnCode: 'none',
     *        targetTitle: 'profile'
     *    }
     *    AnalyticsAPI.registerEvent(eventData);
     * }
     */
    function registerEvent(eventData) {
      if (lib.ibmStats) {
        lib.ibmStats.event(eventData);
      }
    }

    /**
     * Initializes all analytics global tracking init functions
     */
  }, {
    key: "initAll",
    value: function initAll() {
      this.initScrollTracker();
      this.initDynamicTabs();
      this.initModals();
    }

    /**
     *
     * If scroll tracking is enabled, this method will fire an event for every 400px
     * user scrolls down the page. Only the deepest depth will fire the event (e.g if
     * user scrolls back up the page, the event will not be triggered)
     *
     * @example
     * import { AnalyticsAPI } from '@carbon/ibmdotcom-services';
     *
     * function init() {
     *   AnalyticsAPI.initScrollTracker();
     * }
     * @deprecated
     */
  }, {
    key: "initScrollTracker",
    value: function initScrollTracker() {
      if (_scrollTracker) {
        console.warn('Scroll tracker service has been deprecated. Please refer to documentation for IBM DBDM gestures 2.0.');
      }
    }

    /**
     * This instantiates an event listener to trigger an event if the Carbon
     * Tabs component is being interacted with by the user
     *
     * @example
     * import { AnalyticsAPI } from '@carbon/ibmdotcom-services';
     *
     * function init() {
     *   AnalyticsAPI.initDynamicTabs();
     * }
     */
  }, {
    key: "initDynamicTabs",
    value: function initDynamicTabs() {
      var tabSelected = this.triggerTabSelected.bind(this);
      lib.document.addEventListener('tab-selected', function (evt) {
        tabSelected(evt.target.id, evt.detail.item.innerText);
      });
    }

    /**
     * Triggers to CLICK event for the dynamic tabs
     *
     * @param {string} executionPath Target ID
     * @param {string} targetTitle Target innerText
     */
  }, {
    key: "triggerTabSelected",
    value: function triggerTabSelected(executionPath, targetTitle) {
      try {
        this.registerEvent({
          type: 'element',
          primaryCategory: 'WIDGET',
          eventName: 'CLICK',
          eventCategoryGroup: 'TABS DYNAMIC',
          executionPath: executionPath,
          targetTitle: targetTitle
        });
      } catch (err) {
        if (_env !== 'production') {
          console.error('Error triggering tab event:', err);
        }
      }
    }

    /**
     * This instantiates an event listener to trigger an event if the Carbon
     * Modal component is being interacted with by the user
     *
     * @example
     * import { AnalyticsAPI } from '@carbon/ibmdotcom-services';
     *
     * function init() {
     *   AnalyticsAPI.initModals();
     * }
     */
  }, {
    key: "initModals",
    value: function initModals() {
      var modalHide = this.triggerModalHide.bind(this);
      lib.document.addEventListener('modal-hidden', function (evt) {
        modalHide(evt.target.id, evt.detail.launchingElement.innerText);
      });
      var modalShow = this.triggerModalShow.bind(this);
      lib.document.addEventListener('modal-shown', function (evt) {
        modalShow(evt.target.id, evt.detail.launchingElement.innerText);
      });
    }

    /**
     * Triggers the HIDE event for the modal
     *
     * @param {string} executionPath Target ID
     * @param {string} targetTitle Target innerText
     */
  }, {
    key: "triggerModalHide",
    value: function triggerModalHide(executionPath, targetTitle) {
      try {
        this.registerEvent({
          type: 'element',
          primaryCategory: 'WIDGET',
          eventName: 'HIDE',
          eventCategoryGroup: 'SHOWHIDE',
          executionPath: executionPath,
          targetTitle: targetTitle
        });
      } catch (err) {
        if (_env !== 'production') {
          console.error('Error triggering modal hide event:', err);
        }
      }
    }

    /**
     * Triggers the SHOW event for the modal
     *
     * @param {string} executionPath Target ID
     * @param {string} targetTitle Target innerText
     */
  }, {
    key: "triggerModalShow",
    value: function triggerModalShow(executionPath, targetTitle) {
      try {
        this.registerEvent({
          type: 'element',
          primaryCategory: 'WIDGET',
          eventName: 'SHOW',
          eventCategoryGroup: 'SHOWHIDE',
          executionPath: executionPath,
          targetTitle: targetTitle
        });
      } catch (err) {
        if (_env !== 'production') {
          console.error('Error triggering modal show event:', err);
        }
      }
    }

    /**
     * Sends video player metrics data
     *
     * @param {object} data event data from the video player
     * @example
     * import { AnalyticsAPI } from '@carbon/ibmdotcom-services';
     *
     *function init() {
     *    const data = {
     *       playerType: 'kaltura',
     *       title: 'Folgers Coffee',
     *       currentTime: 1,
     *       duration: 60,
     *       playerState: 1,
     *       mediaId: '1_9h94wo6b',
     *    };
     *
     *    AnalyticsAPI.videoPlayerStats(data);
     *}
     */
  }, {
    key: "videoPlayerStats",
    value: function videoPlayerStats(data) {
      var playerState = (data === null || data === void 0 ? void 0 : data.playerState) || '',
        currentTime = Math.floor(data.currentTime),
        duration = Math.floor(data.duration),
        percentWatched = Math.floor(currentTime / duration * 100);

      // Set nicenames for player states for event.
      switch (data.playerState) {
        case 0:
          playerState = 'launched';
          break;
        case 1:
          playerState = 'paused';
          break;
        case 2:
          playerState = 'played';
          break;
        case 3:
          playerState = 'ended';
          break;
        case 99:
          playerState = 'error';
          break;
        default:
          if (typeof playerState === 'number') {
            playerState = '';
          }
      }
      if (currentTime === 0) {
        currentTime = 'start';
        percentWatched = '0';
      }
      if (currentTime >= duration || data.playerState === 3) {
        currentTime = 'end';
        percentWatched = '100';
      }

      // If went to the end of the video, and fired "pause" event, don't fire pause event b/c it's really
      // the end of the video, so just let "end" event fire and tag metrics.
      if (currentTime === 'end' && data.playerState === 1) {
        return;
      }
      var eventData = {
        type: 'video',
        primaryCategory: 'VIDEO',
        eventName: data.title,
        eventCategoryGroup: data.playerType,
        executionPath: data.videoId || data.mediaId,
        execPathReturnCode: playerState,
        eventVidStatus: data.playerState,
        eventVidTimeStamp: currentTime,
        eventVidLength: duration,
        eventVidPlayed: percentWatched + '%'
      };
      if (data !== null && data !== void 0 && data.customMetricsData) {
        Object.keys(data.customMetricsData).forEach(function (customMetricsKey) {
          eventData[customMetricsKey] = data.customMetricsData[customMetricsKey];
        });
      }
      try {
        this.registerEvent(eventData);
      } catch (err) {
        if (_env !== 'production') {
          console.error('Error firing video metrics:', err);
        }
      }
    }
  }]);
}();

/**
 * Copyright IBM Corp. 2021, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * CDN host for plex fonts
 *
 * @type {string}
 * @private
 */
var _host$2 = 'https://1.www.s81c.com/common/carbon/plex';

/**
 * Non-Latin font keys and corresponding entry file/font-family
 *
 * @type {{ar: {entry: string, family: string}, jp: {entry: string, family: string}, kr: {entry: string, family: string}}}
 * @private
 */
var _fonts = {
  ar: {
    entry: 'sans-arabic',
    family: 'IBM Plex Sans Arabic'
  },
  ja: {
    entry: 'sans-jp',
    family: 'IBM Plex Sans JP'
  },
  ko: {
    entry: 'sans-kr',
    family: 'IBM Plex Sans KR'
  }
};

/**
 * Non-Latin font-weights and corresponding names
 *
 * @type {{'100': string, '200': string, '300': string, '400': string, '500': string, '600': string, '700': string, '450': string}}
 * @private
 */
var _weights = {
  100: 'thin',
  200: 'extralight',
  300: 'light',
  400: 'regular',
  450: 'text',
  500: 'medium',
  600: 'semibold',
  700: 'bold'
};

/**
 * Injects the corresponding CSS entry point to the page
 *
 * @param {string} language two-character language code
 * @param {Array} [weights=[]] Array of specific weights to load
 * @private
 */
function _injectCSS(language) {
  var weights = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (weights.length === 0) {
    var link = document.createElement('link');
    link.href = "".concat(_host$2, "/").concat(_fonts[language].entry, ".css");
    link.type = 'text/css';
    link.rel = 'stylesheet';
    link.media = 'screen,print';
    document.getElementsByTagName('head')[0].appendChild(link);
  } else {
    weights.forEach(function (weight) {
      var linkWeight = document.createElement('link');
      linkWeight.href = "".concat(_host$2, "/").concat(_fonts[language].entry, "-").concat(_weights[weight], ".css");
      linkWeight.type = 'text/css';
      linkWeight.rel = 'stylesheet';
      linkWeight.media = 'screen,print';
      document.getElementsByTagName('head')[0].appendChild(linkWeight);
    });
  }
}

/**
 * Sets the language's font-family to the page
 *
 * @param {string} language two-character language code
 * @private
 */
function _setFontFamily(language) {
  document.body.style.fontFamily = "".concat(_fonts[language].family, ",IBM Plex Sans,Helvetica Neue,Arial,sans-serif");
}

/**
 * Utility to load in the corresponding non-Latin Plex font if necessary
 *
 * @example
 * import { loadNonLatinPlex } from '@carbon/ibmdotcom-utilities';
 *
 * loadNonLatinPlex('ar');
 *
 * // Load specific weights only
 * loadNonLatinPlex('ar', [400,600]);
 * @param {string} language two-character language code
 * @param {Array} [weights=[]] Array of specific weights to load (100-700)
 */
function loadNonLatinPlex(language) {
  var weights = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (_fonts[language]) {
    _injectCSS(language, weights);
    _setFontFamily(language);
  }
}

/**
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Flag to determine if the global init has been fired
 *
 * @type {boolean}
 * @private
 */
var _initialized = false;

/**
 * Initializes various global functions
 */
function globalInit() {
  if (_initialized) {
    return;
  } else {
    _initialized = true;
  }

  // Sets the version of the library in the DDO
  DDOAPI.setVersion().catch(function (error) {
    console.error('Error setting the version of the library in the DDO:', error);
  });

  // Sets the Plex font for non-Latin fonts
  LocaleAPI.getLang().then(function (lang) {
    loadNonLatinPlex(lang.lc);
  });

  // analytics tracking
  AnalyticsAPI.initAll();
}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const t$1={ATTRIBUTE:1,CHILD:2,PROPERTY:3,BOOLEAN_ATTRIBUTE:4,EVENT:5,ELEMENT:6},e$1=t=>(...e)=>({_$litDirective$:t,values:e});class i{constructor(t){}get _$AU(){return this._$AM._$AU}_$AT(t,e,i){this._$Ct=t,this._$AM=e,this._$Ci=i;}_$AS(t,e){return this.update(t,e)}update(t,e){return this.render(...e)}}

/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const o$2=e$1(class extends i{constructor(t){var i;if(super(t),t.type!==t$1.ATTRIBUTE||"class"!==t.name||(null===(i=t.strings)||void 0===i?void 0:i.length)>2)throw Error("`classMap()` can only be used in the `class` attribute and must be the only part in the attribute.")}render(t){return " "+Object.keys(t).filter((i=>t[i])).join(" ")+" "}update(i,[s]){var r,o;if(void 0===this.it){this.it=new Set,void 0!==i.strings&&(this.nt=new Set(i.strings.join(" ").split(/\s/).filter((t=>""!==t))));for(const t in s)s[t]&&!(null===(r=this.nt)||void 0===r?void 0:r.has(t))&&this.it.add(t);return this.render(s)}const e=i.element.classList;this.it.forEach((t=>{t in s||(e.remove(t),this.it.delete(t));}));for(const t in s){const i=!!s[t];i===this.it.has(t)||(null===(o=this.nt)||void 0===o?void 0:o.has(t))||(i?(e.add(t),this.it.add(t)):(e.remove(t),this.it.delete(t)));}return T}});

function _defineProperty$a(e, r, t) { return (r = _toPropertyKey$10(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey$10(t) { var i = _toPrimitive$10(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$10(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param Base The base class.
 * @returns A mix-in that sets its defined stable selector.
 */
const StableSelectorMixin = Base => {
  class StableSelectorMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * The element that will be targeted for transposition
       *
       * @private
       */
      /**
       * The string array element containing the alternate attributes to target
       *
       * @private
       */
      /**
       * Mutation observer to watch for attribute changes
       *
       * @private
       */
      _defineProperty$a(this, "_mutationObserver", null);
    }
    connectedCallback() {
      // TS seems to miss `HTMLElement.prototype.connectedCallback()` definition
      // @ts-ignore
      super.connectedCallback();
      const {
        stableSelector
      } = this.constructor;
      if (stableSelector) {
        this.dataset.autoid = stableSelector;
      }
      this._cleanAndCreateMutationObserver({
        create: true
      });
      window.requestAnimationFrame(() => {
        if (!this.linkNode) {
          this.transposeAttributes();
        }
      });
    }
    disconnectedCallback() {
      this._cleanAndCreateMutationObserver();
    }

    /**
     * Function to transpose any data-* attributes to the anchor tag in the shadow dom.
     *
     * @param linkNodeArg optional argument to pass in custom element to target instead of an anchor link
     * @param altAttributesArg optional argument to target additional attributes to transpose
     */
    transposeAttributes(linkNodeArg, altAttributesArg) {
      var _this$shadowRoot;
      this.linkNode = linkNodeArg;
      this.altAttributes = altAttributesArg;
      if (!this.linkNode) {
        this.querySelectorAll('*').forEach(e => {
          var _e$shadowRoot;
          const anchor = (_e$shadowRoot = e.shadowRoot) === null || _e$shadowRoot === void 0 ? void 0 : _e$shadowRoot.querySelector('a');
          if (anchor) {
            this.linkNode = anchor;
          }
        });
      }
      this.linkNode = this.linkNode || ((_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector('a'));
      const scrapedAttributes = [].filter.call(this.attributes, at => /^data-/.test(at.name) && at.name !== 'data-autoid' || this.altAttributes && this.altAttributes.includes(at.name));
      scrapedAttributes.forEach(e => {
        if (this.linkNode) {
          var _this$linkNode;
          (_this$linkNode = this.linkNode) === null || _this$linkNode === void 0 || _this$linkNode.setAttribute(e.name, e.value);
        }
      });
    }

    /**
     * Cleans-up and creates the mutation observer.
     *
     * @param [options] The options.
     * @param [options.create] `true` to create the new mutation observer.
     */
    _cleanAndCreateMutationObserver({
      create
    } = {}) {
      if (this._mutationObserver) {
        this._mutationObserver.disconnect();
        this._mutationObserver = null;
      }
      if (create) {
        var _this$_mutationObserv;
        this._mutationObserver = new MutationObserver(mutations => {
          mutations.forEach(mutation => {
            if (mutation.type === 'attributes') {
              if (this.linkNode) {
                this.transposeAttributes(this.linkNode);
              }
            }
          });
        });
        (_this$_mutationObserv = this._mutationObserver) === null || _this$_mutationObserv === void 0 || _this$_mutationObserv.observe(this, {
          attributes: true
        });
      }
    }

    /**
     * The stable selector for this component.
     */
  }
  return StableSelectorMixinImpl;
};

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Color scheme for form elements.
 */
let FORM_ELEMENT_COLOR_SCHEME;
(function (FORM_ELEMENT_COLOR_SCHEME) {
  FORM_ELEMENT_COLOR_SCHEME["REGULAR"] = "";
  FORM_ELEMENT_COLOR_SCHEME["LIGHT"] = "light";
})(FORM_ELEMENT_COLOR_SCHEME || (FORM_ELEMENT_COLOR_SCHEME = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Footer size.
 */
let FOOTER_SIZE;

// TODO: Remove when JAWS bug has been fixed

/**
 * The style scheme of language selector.
 */
(function (FOOTER_SIZE) {
  FOOTER_SIZE["REGULAR"] = "";
  FOOTER_SIZE["SHORT"] = "short";
  FOOTER_SIZE["MICRO"] = "micro";
})(FOOTER_SIZE || (FOOTER_SIZE = {}));
let LANGUAGE_SELECTOR_STYLE_SCHEME;

/**
 * Dropdown size.
 */
(function (LANGUAGE_SELECTOR_STYLE_SCHEME) {
  LANGUAGE_SELECTOR_STYLE_SCHEME["REGULAR"] = "";
  LANGUAGE_SELECTOR_STYLE_SCHEME["BLENDED"] = "blended";
})(LANGUAGE_SELECTOR_STYLE_SCHEME || (LANGUAGE_SELECTOR_STYLE_SCHEME = {}));
let DROPDOWN_SIZE$1;
(function (DROPDOWN_SIZE) {
  DROPDOWN_SIZE["REGULAR"] = "";
  DROPDOWN_SIZE["SMALL"] = "sm";
  DROPDOWN_SIZE["LARGE"] = "lg";
  DROPDOWN_SIZE["MICRO"] = "micro";
})(DROPDOWN_SIZE$1 || (DROPDOWN_SIZE$1 = {}));

var styles$l = i$4(["/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--accordion {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion *,\n.cds--accordion *::before,\n.cds--accordion *::after {\n  box-sizing: inherit;\n}\n.cds--accordion {\n  inline-size: 100%;\n  list-style: none;\n}\n\n.cds--accordion__item {\n  display: list-item;\n  overflow: visible;\n  border-block-start: 1px solid var(--cds-border-subtle);\n  transition: border-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n.cds--accordion__item:last-child {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n\n.cds--accordion__item:not(.cds--accordion__item--active):hover, .cds--accordion__item:not(.cds--accordion__item--active):hover + .cds--accordion__item {\n  border-block-start-color: var(--cds-layer-hover);\n}\n.cds--accordion__item:not(.cds--accordion__item--active):last-child:hover {\n  border-block-end-color: var(--cds-layer-hover);\n}\n\n.cds--accordion__heading {\n  transition: background-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion__heading *,\n.cds--accordion__heading *::before,\n.cds--accordion__heading *::after {\n  box-sizing: inherit;\n}\n.cds--accordion__heading::-moz-focus-inner {\n  border: 0;\n}\n.cds--accordion__heading {\n  position: relative;\n  display: flex;\n  flex-direction: row-reverse;\n  align-items: center;\n  justify-content: flex-start;\n  margin: 0;\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  min-block-size: var(--cds-layout-size-height-local);\n  padding-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--accordion__heading:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--accordion__heading:focus {\n  position: relative;\n  z-index: 2;\n  box-shadow: 0 -1px 0 0 var(--cds-focus, #0f62fe), inset 0 1px 0 0 var(--cds-focus, #0f62fe), inset 2px 0 0 0 var(--cds-focus, #0f62fe), 0 1px 0 0 var(--cds-focus, #0f62fe), inset 0 -1px 0 0 var(--cds-focus, #0f62fe), inset -2px 0 0 0 var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--accordion__heading[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--accordion__heading[disabled] .cds--accordion__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--accordion__heading[disabled]:hover::before {\n  background-color: transparent;\n}\n\n.cds--accordion__item--disabled,\n.cds--accordion__item--disabled + .cds--accordion__item {\n  border-block-start: 1px solid var(--cds-border-subtle);\n}\n\nli.cds--accordion__item--disabled:last-of-type {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n\n.cds--accordion__arrow {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  transition: all 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion__arrow {\n  flex: 0 0 1rem;\n  block-size: 1rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1rem;\n  transform: rotate(-270deg) /*rtl:ignore*/;\n}\n\n.cds--accordion__title {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion__title {\n  z-index: 1;\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n  text-align: start;\n}\n\n.cds--accordion__wrapper {\n  overflow: hidden;\n  padding: 0;\n  max-block-size: 0;\n  opacity: 0;\n  transition: all 110ms cubic-bezier(0, 0, 0.38, 0.9);\n  writing-mode: horizontal-tb;\n}\n\n.cds--accordion__content {\n  padding-inline: var(--cds-layout-density-padding-inline-local);\n}\n@media (min-width: 480px) {\n  .cds--accordion__content {\n    padding-inline-end: 3rem;\n  }\n}\n@media (min-width: 640px) {\n  .cds--accordion__content {\n    padding-inline-end: 25%;\n  }\n}\n.cds--accordion__content > p {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n\n.cds--accordion--start .cds--accordion__heading {\n  flex-direction: row;\n}\n\n.cds--accordion--start .cds--accordion__arrow {\n  margin: 2px 0 0 var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 1rem;\n}\n\n.cds--accordion--start .cds--accordion__content {\n  margin-inline-start: calc(var(--cds-layout-density-padding-inline-local) + 1rem);\n}\n\n.cds--accordion__item--collapsing .cds--accordion__content,\n.cds--accordion__item--expanding .cds--accordion__content {\n  display: block;\n}\n\n.cds--accordion__item--active, :host(c4d-footer-nav-group[open]) {\n  overflow: visible;\n}\n.cds--accordion__item--active > .cds--accordion__wrapper, :host(c4d-footer-nav-group[open]) > .cds--accordion__wrapper {\n  overflow: visible;\n  max-block-size: -moz-fit-content;\n  max-block-size: fit-content;\n  opacity: 1;\n  padding-block: 0.5rem;\n  padding-block-end: 1.5rem;\n}\n.cds--accordion__item--active > .cds--accordion__heading > .cds--accordion__arrow, :host(c4d-footer-nav-group[open]) > .cds--accordion__heading > .cds--accordion__arrow {\n  fill: var(--cds-icon-primary, #161616);\n  transform: rotate(-90deg) /*rtl:ignore*/;\n}\n\n.cds--accordion--flush .cds--accordion__item {\n  position: relative;\n  border-color: transparent;\n}\n.cds--accordion--flush .cds--accordion__item:last-child, .cds--accordion--flush .cds--accordion__item:hover, .cds--accordion--flush .cds--accordion__item:last-child:hover, .cds--accordion--flush .cds--accordion__item:hover + .cds--accordion__item {\n  border-color: transparent;\n}\n.cds--accordion--flush .cds--accordion__item::before, .cds--accordion--flush .cds--accordion__item::after {\n  position: absolute;\n  display: block;\n  block-size: 1px;\n  content: \"\";\n  inline-size: calc(100% - 1rem - 1rem);\n  margin-inline-start: 1rem;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--accordion--flush .cds--accordion__item::before, .cds--accordion--flush .cds--accordion__item::after {\n    transition: none;\n  }\n}\n.cds--accordion--flush .cds--accordion__item::before {\n  background: var(--cds-border-subtle);\n  inset-block-start: -1px;\n}\n.cds--accordion--flush .cds--accordion__item:last-child::after {\n  background: var(--cds-border-subtle);\n  inset-block-end: -1px;\n}\n\n.cds--accordion--flush .cds--accordion__heading:hover {\n  position: relative;\n  z-index: 1;\n}\n.cds--accordion--flush .cds--accordion__heading:hover::before, .cds--accordion--flush .cds--accordion__heading:hover::after {\n  position: absolute;\n  display: block;\n  background: var(--cds-layer-hover);\n  block-size: 1px;\n  content: \"\";\n  inline-size: 100%;\n  inset-inline-start: 0;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--accordion--flush .cds--accordion__heading:hover::before, .cds--accordion--flush .cds--accordion__heading:hover::after {\n    transition: none;\n  }\n}\n.cds--accordion--flush .cds--accordion__heading:hover::before {\n  inset-block-start: -1px;\n}\n.cds--accordion--flush .cds--accordion__heading:hover::after {\n  inset-block-end: -1px;\n}\n.cds--accordion--flush .cds--accordion__heading:hover:focus::after, .cds--accordion--flush .cds--accordion__heading:hover:focus::before {\n  background: none;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__heading,\n.cds--accordion.cds--skeleton .cds--accordion__button {\n  cursor: default;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__arrow {\n  cursor: default;\n  fill: var(--cds-icon-primary, #161616);\n  pointer-events: none;\n}\n.cds--accordion.cds--skeleton .cds--accordion__arrow:hover, .cds--accordion.cds--skeleton .cds--accordion__arrow:focus, .cds--accordion.cds--skeleton .cds--accordion__arrow:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__heading:hover::before,\n.cds--accordion.cds--skeleton .cds--accordion__heading:hover {\n  background-color: transparent;\n}\n\n.cds--accordion--end.cds--skeleton .cds--accordion__arrow {\n  margin-inline-start: 1rem;\n}\n\n.cds--skeleton .cds--accordion__heading:focus .cds--accordion__arrow {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n\n.cds--accordion__title.cds--skeleton__text {\n  margin-block-end: 0;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__title {\n  margin-inline-start: 1rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--accordion__arrow,\n  .cds--accordion__item--active .cds--accordion__arrow {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--accordion--start .cds--accordion__heading {\n  padding-inline-end: 0;\n  padding-inline-start: var(--cds-layout-density-padding-inline-local);\n}\n\n[dir=rtl] .cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 0;\n  padding-inline-start: 0;\n}\n\ninput:-webkit-autofill,\ninput:-webkit-autofill:hover,\ninput:-webkit-autofill:focus,\ntextarea:-webkit-autofill,\ntextarea:-webkit-autofill:hover,\ntextarea:-webkit-autofill:focus {\n  box-shadow: 0 0 0 1000px var(--cds-field) inset;\n  -webkit-text-fill-color: var(--cds-text-primary, #161616);\n}\n\n.cds--fieldset {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n.cds--fieldset *,\n.cds--fieldset *::before,\n.cds--fieldset *::after {\n  box-sizing: inherit;\n}\n\n.cds--form-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n}\n\n.cds--label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: inline-block;\n  color: var(--cds-text-secondary, #525252);\n  font-weight: 400;\n  line-height: 1rem;\n  margin-block-end: 0.5rem;\n  vertical-align: baseline;\n}\n.cds--label html {\n  font-size: 100%;\n}\n.cds--label body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--label code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--label strong {\n  font-weight: 600;\n}\n\n.cds--label .cds--toggletip-label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n\n.cds--label--no-margin {\n  margin-block-end: 0;\n}\n\n.cds--label + .cds--tooltip {\n  position: relative;\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger *,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::before,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::after {\n  box-sizing: inherit;\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg :hover {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--label + .cds--toggletip {\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 0.875rem;\n  inline-size: 4.6875rem;\n}\n.cds--label.cds--skeleton:hover, .cds--label.cds--skeleton:focus, .cds--label.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--label.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--label.cds--skeleton::before {\n    animation: none;\n  }\n}\n\ninput[type=number] {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n}\n\ninput[data-invalid]:not(:focus),\n.cds--number[data-invalid] input[type=number]:not(:focus),\n.cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n.cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n.cds--combo-box--invalid--focused),\n.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  input[data-invalid]:not(:focus),\n  .cds--number[data-invalid] input[type=number]:not(:focus),\n  .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n  .cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n  .cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n  .cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n  .cds--combo-box--invalid--focused),\n  .cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--number__input-wrapper--warning ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--warn ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--time-picker--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning > .cds--text-input ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper--warn ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select--warning .cds--select-input__wrapper ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement,\n.cds--list-box--warning ~ .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid],\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  display: block;\n}\n\n.cds--form--fluid input[data-invalid] {\n  outline: none;\n}\n\n.cds--form--fluid .cds--form-requirement {\n  padding: 0.5rem 2.5rem 0.5rem 1rem;\n  margin: 0;\n}\n\ninput:not(output, [data-invalid]):-moz-ui-invalid {\n  box-shadow: none;\n}\n\n.cds--form-requirement {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: none;\n  overflow: hidden;\n  margin: 0.25rem 0 0;\n  max-block-size: 0;\n}\n.cds--form-requirement html {\n  font-size: 100%;\n}\n.cds--form-requirement body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--form-requirement code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--form-requirement strong {\n  font-weight: 600;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-start: 0;\n}\n\n.cds--form__helper-text {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n  z-index: 0;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  margin-block-start: 0.25rem;\n  opacity: 1;\n}\n\n.cds--label--disabled,\n.cds--form__helper-text--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\nfieldset[disabled] .cds--label,\nfieldset[disabled] .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input *,\n.cds--text-input *::before,\n.cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--text-input:focus, .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input:focus, .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n\n.cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n\n.cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n\n.cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n\n.cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--text-input--password__visibility:hover::before, .cds--text-input--password__visibility:hover::after, .cds--text-input--password__visibility:focus::before, .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n\n.cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n\n.cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n\n.cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--text-input--invalid,\n.cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n\n.cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n\n.cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--skeleton.cds--text-input:hover, .cds--skeleton.cds--text-input:focus, .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n\n.cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n\n.cds--text-input__divider,\n.cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n\n.cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n\n.cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n\n.cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n\n.cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n\n.cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n\n.cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n\n.cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n\n.cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n\n.cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\n.cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid:has(~ .cds--slug),\n.cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid ~ .cds--slug,\n.cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n\n.cds--tag {\n  --cds-layout-size-height-xs: 1.125rem;\n  --cds-layout-size-height-sm: 1.125rem;\n  --cds-layout-size-height-md: 1.5rem;\n  --cds-layout-size-height-lg: 2rem;\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 1rem;\n  margin: 0.25rem;\n  cursor: default;\n  max-inline-size: 13rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  min-inline-size: 2rem;\n  padding-inline: 0.5rem;\n  vertical-align: middle;\n  word-break: break-word;\n}\n.cds--layout--size-xs .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-xs);\n}\n.cds--layout--size-sm .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--tag.cds--tag--operational {\n  border: 1px solid var(--cds-tag-background-gray, #e0e0e0);\n}\n.cds--tag.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag.cds--tag--lg {\n  padding-inline-start: 0.75rem;\n}\n.cds--tag:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.25rem;\n}\n.cds--tag.cds--tag--lg:not(.cds--tag--filter) {\n  padding-inline: 0.75rem;\n}\n.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.5rem;\n}\n.cds--tag:not(.cds--tag--selectable) {\n  border: 0;\n}\n.cds--tag:not(:first-child) {\n  margin-inline-start: 0;\n}\n\n.cds--tag--operational > span,\n.cds--tag--selectable > span,\n.cds--tag__label {\n  display: block;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--tag--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--filter {\n  padding-block-end: 0;\n  padding-block-start: 0;\n  padding-inline-end: 0;\n}\n.cds--tag--filter:hover {\n  outline: none;\n}\n\n.cds--tag--selectable {\n  border: 1px solid var(--cds-border-inverse, #161616);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--tag--selectable:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--tag--selectable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--selectable-selected {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--selectable-selected:hover {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  cursor: pointer;\n}\n.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n  outline: none;\n}\n.cds--tag--operational:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--red {\n  background-color: var(--cds-tag-background-red, #ffd7d9);\n  color: var(--cds-tag-color-red, #a2191f);\n}\n.cds--tag--red.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-red, #ff8389);\n}\n.cds--tag--red.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n.cds--tag--red .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n\n.cds--tag--magenta {\n  background-color: var(--cds-tag-background-magenta, #ffd6e8);\n  color: var(--cds-tag-color-magenta, #9f1853);\n}\n.cds--tag--magenta.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-magenta, #ff7eb6);\n}\n.cds--tag--magenta.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n.cds--tag--magenta .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n\n.cds--tag--purple {\n  background-color: var(--cds-tag-background-purple, #e8daff);\n  color: var(--cds-tag-color-purple, #6929c4);\n}\n.cds--tag--purple.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-purple, #be95ff);\n}\n.cds--tag--purple.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n.cds--tag--purple .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n\n.cds--tag--blue {\n  background-color: var(--cds-tag-background-blue, #d0e2ff);\n  color: var(--cds-tag-color-blue, #0043ce);\n}\n.cds--tag--blue.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-blue, #78a9ff);\n}\n.cds--tag--blue.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n.cds--tag--blue .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n\n.cds--tag--cyan {\n  background-color: var(--cds-tag-background-cyan, #bae6ff);\n  color: var(--cds-tag-color-cyan, #00539a);\n}\n.cds--tag--cyan.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cyan, #33b1ff);\n}\n.cds--tag--cyan.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n.cds--tag--cyan .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n\n.cds--tag--teal {\n  background-color: var(--cds-tag-background-teal, #9ef0f0);\n  color: var(--cds-tag-color-teal, #005d5d);\n}\n.cds--tag--teal.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-teal, #08bdba);\n}\n.cds--tag--teal.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n.cds--tag--teal .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n\n.cds--tag--green {\n  background-color: var(--cds-tag-background-green, #a7f0ba);\n  color: var(--cds-tag-color-green, #0e6027);\n}\n.cds--tag--green.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-green, #42be65);\n}\n.cds--tag--green.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n.cds--tag--green .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n\n.cds--tag--gray {\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n}\n.cds--tag--gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n}\n.cds--tag--gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag--gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n\n.cds--tag--cool-gray {\n  background-color: var(--cds-tag-background-cool-gray, #dde1e6);\n  color: var(--cds-tag-color-cool-gray, #121619);\n}\n.cds--tag--cool-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cool-gray, #a2a9b0);\n}\n.cds--tag--cool-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n.cds--tag--cool-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n\n.cds--tag--warm-gray {\n  background-color: var(--cds-tag-background-warm-gray, #e5e0df);\n  color: var(--cds-tag-color-warm-gray, #171414);\n}\n.cds--tag--warm-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-warm-gray, #ada8a8);\n}\n.cds--tag--warm-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n.cds--tag--warm-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n\n.cds--tag--high-contrast:not(.cds--tag--operational) {\n  background-color: var(--cds-background-inverse, #393939);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational {\n  border: 1px solid var(--cds-background-inverse, #393939);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  outline: 1px solid var(--cds-background-inverse, #393939);\n  outline-offset: -1px;\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational {\n  border: 1px solid var(--cds-background, #ffffff);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--tag--disabled:not(.cds--tag--operational),\n.cds--tag--filter.cds--tag--disabled,\n.cds--tag--interactive.cds--tag--disabled {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  box-shadow: none;\n  outline: none;\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational {\n  border: 1px solid var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational):hover,\n.cds--tag--filter.cds--tag--disabled:hover,\n.cds--tag--interactive.cds--tag--disabled:hover {\n  cursor: not-allowed;\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,\n.cds--tag--filter.cds--tag--disabled .cds--tag__label,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__label {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--selectable.cds--tag--disabled,\n.cds--tag--operational.cds--tag--disabled {\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--tag--selectable.cds--tag--disabled:hover,\n.cds--tag--operational.cds--tag--disabled:hover {\n  background-color: var(--cds-layer);\n  cursor: not-allowed;\n}\n\n.cds--tag--interactive {\n  transition: background-color 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--tag__close-icon {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: 50%;\n  margin: 0 0 0 0.125rem;\n  background-color: transparent;\n  block-size: var(--cds-layout-size-height-local);\n  color: currentColor;\n  cursor: pointer;\n  inline-size: var(--cds-layout-size-height-local);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tag__close-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag__custom-icon {\n  flex-shrink: 0;\n  padding: 0;\n  border: 0;\n  background-color: transparent;\n  block-size: 1rem;\n  color: currentColor;\n  inline-size: 1rem;\n  margin-inline-end: 0.25rem;\n  outline: none;\n}\n.cds--tag__custom-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag--disabled .cds--tag__close-icon {\n  cursor: not-allowed;\n}\n\n.cds--tag__close-icon:focus {\n  z-index: 99999;\n  border-radius: 50%;\n  box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--tag--high-contrast .cds--tag__close-icon:focus {\n  box-shadow: inset 0 0 0 1px var(--cds-focus-inverse, #ffffff);\n}\n\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: transparent;\n}\n\n.cds--tag--filter.cds--tag--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--sm.cds--tag--filter {\n  padding-inline-end: 0;\n}\n\n.cds--tag--sm .cds--tag__close-icon {\n  margin-inline-start: 0.3125rem;\n}\n\n.cds--tag.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n  color: var(--cds-text-primary, #161616);\n  overflow: hidden;\n  inline-size: 3.75rem;\n}\n.cds--tag.cds--skeleton:hover, .cds--tag.cds--skeleton:focus, .cds--tag.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--tag.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--tag.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--tag.cds--skeleton.cds--tag--operational {\n  border: 1px solid var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton.cds--tag--operational:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton .cds--tag__close-icon:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n@media not all and (min-resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tag.cds--skeleton {\n      transform: translateZ(0);\n    }\n  }\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline {\n  color: currentColor;\n  margin-inline-start: 0.0625rem;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before {\n  background-color: currentColor;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline:hover {\n  border-color: currentColor;\n}\n\n/* stylelint-disable */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon svg,\n  .cds--tag__custom-icon svg {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n.cds--tag-label-tooltip {\n  max-inline-size: -webkit-fill-available;\n}\n\n.cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 11rem;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 9.875rem;\n}\n\n/* stylelint-enable */\n.cds--interactive--tag-children {\n  display: inline-flex;\n  max-inline-size: 12.5rem;\n  place-items: center;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + span > .cds--interactive--tag-children {\n  max-inline-size: 11.5rem;\n}\n\n.cds--tag .cds--definition-term {\n  border-block-end: none;\n  cursor: default;\n  max-inline-size: 12rem;\n}\n\n.cds--tag .cds--tag__custom-icon + span > .cds--definition-term {\n  max-inline-size: 11rem;\n}\n\n.cds--tag > .cds--popover-container {\n  display: flex;\n}\n\n.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled) {\n  pointer-events: none;\n}\n\n.cds--list-box__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0.25rem;\n  grid-template: auto auto/auto auto;\n}\n.cds--list-box__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--list-box__wrapper--inline .cds--label,\n.cds--list-box__wrapper--inline .cds--form__helper-text,\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--list-box__wrapper--inline .cds--form__helper-text {\n  max-inline-size: none;\n}\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--list-box {\n  position: relative;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  max-block-size: 2.5rem;\n  transition: all 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box html {\n  font-size: 100%;\n}\n.cds--list-box body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--list-box code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--list-box strong {\n  font-weight: 600;\n}\n.cds--list-box:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--list-box--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box--expanded:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--expanded:hover.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box .cds--text-input {\n  block-size: 100%;\n  min-inline-size: 0;\n}\n\n.cds--list-box__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--list-box__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--list-box.cds--list-box--warning .cds--list-box__field {\n  border-block-end: 0;\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field,\n.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--list-box--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--list-box--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--light .cds--list-box__menu {\n  background: var(--cds-layer);\n}\n\n.cds--list-box--light .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle);\n}\n\n.cds--list-box--light.cds--list-box--expanded {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box--disabled:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--light.cds--list-box--disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__field:focus {\n  border-block-end-color: transparent;\n  outline: none;\n}\n\n.cds--list-box--disabled .cds--list-box__label,\n.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled .cds--list-box__menu-icon > svg,\n.cds--list-box--disabled .cds--list-box__selection > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item,\n.cds--list-box--disabled .cds--list-box__menu-item:hover,\n.cds--list-box--disabled .cds--list-box__menu-item--highlighted {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  text-decoration: none;\n}\n\n.cds--list-box--disabled .cds--list-box__selection:hover {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 2rem;\n}\n\n.cds--list-box.cds--list-box--inline {\n  border-width: 0;\n  background-color: transparent;\n}\n.cds--list-box.cds--list-box--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded {\n  border-block-end-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true] {\n  border-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover,\n.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover {\n  background-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__field {\n  padding: 0 2rem 0 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--inline .cds--list-box__field {\n  block-size: 100%;\n}\n\n.cds--dropdown--inline .cds--list-box__field {\n  max-inline-size: 30rem;\n}\n\n.cds--dropdown--inline .cds--list-box__menu {\n  max-inline-size: 30rem;\n  min-inline-size: 18rem;\n}\n\n.cds--list-box__field {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  overflow: hidden;\n  align-items: center;\n  block-size: calc(100% + 1px);\n  cursor: pointer;\n  outline: none;\n  padding-block: 0;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  vertical-align: top;\n  white-space: nowrap;\n}\n.cds--list-box__field *,\n.cds--list-box__field *::before,\n.cds--list-box__field *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__field::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__field:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__field:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__field[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--list-box__field .cds--text-input {\n  padding-inline-end: 5rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input,\n.cds--list-box--warning .cds--list-box__field .cds--text-input {\n  padding-inline-end: 6.5625rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon {\n  inset-inline-end: 5.125rem;\n}\n\n.cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--list-box__label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  overflow: hidden;\n  color: var(--cds-text-primary, #161616);\n  text-overflow: ellipsis;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n}\n\n.cds--list-box__menu-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-inline-end: 0.75rem;\n  outline: none;\n  transition: transform 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu-icon *,\n.cds--list-box__menu-icon *::before,\n.cds--list-box__menu-icon *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-icon::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__menu-icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box__menu-icon--open {\n  justify-content: center;\n  inline-size: 1.5rem;\n  transform: rotate(180deg);\n}\n\n.cds--list-box__selection {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-block-start: 50%;\n  /* to preserve .5rem space between icons according to spec top/transform used to center the combobox clear selection icon in IE11 */\n  inset-inline-end: 2.8125rem;\n  transform: translateY(-50%);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__selection *,\n.cds--list-box__selection *::before,\n.cds--list-box__selection *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__selection::-moz-focus-inner {\n  border: 0;\n}\n.cds--list-box__selection:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__selection:focus:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__selection > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__selection:focus {\n  outline: none;\n}\n\n.cds--list-box__selection--multi {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  position: static;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding: 0.5rem;\n  border-radius: 0.75rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: 1.5rem;\n  color: var(--cds-text-inverse, #ffffff);\n  inline-size: auto;\n  inset-block-start: auto;\n  line-height: 0;\n  margin-inline-end: 0.625rem;\n  padding-inline-end: 0.125rem;\n  transform: none;\n}\n\n.cds--list-box__selection--multi > svg {\n  padding: 0.125rem;\n  block-size: 1.25rem;\n  fill: var(--cds-icon-inverse, #ffffff);\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n.cds--list-box__selection--multi > svg:hover {\n  border-radius: 50%;\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n\n.cds--list-box--disabled .cds--list-box__selection--multi {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  color: var(--cds-layer);\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational {\n  border: 1px solid var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg:hover {\n  background-color: initial;\n}\n\n.cds--list-box__selection--multi:hover {\n  outline: none;\n}\n\n.cds--list-box__menu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  position: absolute;\n  z-index: 9100;\n  display: none;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu {\n  display: none;\n  max-block-size: 0;\n  visibility: hidden;\n}\n\n.cds--list-box--expanded .cds--list-box__menu {\n  display: block;\n  max-block-size: 13.75rem;\n}\n\n.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu {\n  max-block-size: 16.5rem;\n}\n\n.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu {\n  max-block-size: 11rem;\n}\n\n.cds--list-box__menu-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  block-size: 2.5rem;\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  transition: background 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--light .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item {\n  block-size: 2rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item {\n  block-size: 3rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover {\n  background-color: transparent;\n}\n\n.cds--list-box--light .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item:hover .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item__option {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-end: 1px solid transparent;\n  border-block-start: 1px solid transparent;\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  padding-inline-end: 1.5rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  transition: border-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  white-space: nowrap;\n}\n.cds--list-box__menu-item__option *,\n.cds--list-box__menu-item__option *::before,\n.cds--list-box__menu-item__option *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-item__option:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  border-color: transparent;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item__option:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__menu-item__option:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item__option {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item__option {\n  block-size: 3rem;\n  padding-block-end: 0.9375rem;\n  padding-block-start: 0.9375rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,\n.cds--list-box--disabled .cds--list-box__menu-item__option {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled],\n.cds--list-box__menu-item[disabled] *,\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  outline: none;\n}\n\n.cds--list-box__menu-item[disabled]:hover {\n  background-color: revert;\n}\n\n.cds--list-box__menu-item[disabled] .cds--checkbox-label::before {\n  border-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-two .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-three .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option {\n  margin: 0 0.5rem;\n}\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus {\n  margin: 0;\n  padding-inline-end: 0.5rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--list-box__menu-item--highlighted {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item--highlighted {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,\n.cds--list-box__menu-item--highlighted + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--light .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n}\n\n.cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover);\n  border-block-end-color: var(--cds-layer-selected-hover);\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item > .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item__selected-icon {\n  position: absolute;\n  display: none;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box--inline .cds--list-box__menu-item__selected-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label {\n  inline-size: 100%;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label-text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--list-box--up .cds--list-box__menu {\n  inset-block-end: 2.5rem;\n}\n\n.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--sm .cds--list-box__menu {\n  inset-block-end: 2rem;\n}\n\n.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--lg .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n\n.cds--list-box input[role=combobox],\n.cds--list-box input[type=text] {\n  background-color: inherit;\n  min-inline-size: 0;\n  text-overflow: ellipsis;\n}\n\n.cds--list-box__wrapper--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 9px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after,\n.cds--list-box__wrapper--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box input[role=combobox] {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 8.8125rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning {\n  inset-inline-end: 5.1875rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before {\n  display: block;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug {\n  inset-inline-end: calc(4rem + 18px);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon {\n  inset-inline-end: 7.25rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field,\n  .cds--list-box__menu,\n  .cds--multi-select .cds--tag--filter {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field:focus,\n  .cds--multi-select .cds--tag__close-icon:focus,\n  .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-icon > svg,\n  .cds--list-box__selection > svg,\n  .cds--list-box__selection--multi > svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-start: 2.0625rem;\n}\n\n.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,\n.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-end: 2.0625rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--combo-box:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--combo-box.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--combo-box .cds--text-input::-ms-clear {\n  display: none;\n}\n\n.cds--combo-box.cds--list-box--expanded .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--combo-box--input--focus.cds--text-input {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--combo-box--input--focus.cds--text-input {\n    outline-style: dotted;\n  }\n}\n\n.cds--combo-box.cds--list-box--expanded:has(input[aria-activedescendant]:not([aria-activedescendant=\"\"])) .cds--combo-box--input--focus.cds--text-input {\n  outline-offset: -0.0625rem;\n  outline-width: 0.0625rem;\n}\n\n.cds--combo-box .cds--list-box__field,\n.cds--combo-box.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--combo-box.cds--list-box--warning .cds--list-box__field,\n.cds--combo-box.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--combo-box.cds--list-box--disabled.cds--list-box--warning .cds--list-box__field {\n  padding: 0;\n}\n\n.cds--combo-box--readonly,\n.cds--combo-box--readonly:hover {\n  background-color: transparent;\n}\n\n.cds--combo-box--readonly .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--combo-box--readonly .cds--list-box__menu-icon,\n.cds--combo-box--readonly .cds--list-box__selection {\n  cursor: default;\n}\n\n.cds--combo-box--readonly .cds--list-box__menu-icon svg,\n.cds--combo-box--readonly .cds--list-box__selection svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--select *,\n.cds--select *::before,\n.cds--select *::after {\n  box-sizing: inherit;\n}\n\n.cds--select-input__wrapper {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--select-input {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  border: none;\n  border-radius: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  font-family: inherit;\n  inline-size: 100%;\n  opacity: 1;\n  padding-block: 0;\n  padding-inline: 1rem 3rem;\n  text-overflow: ellipsis;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select-input::-ms-expand {\n  display: none;\n}\n@-moz-document url-prefix() {\n  .cds--select-input:-moz-focusring, .cds--select-input::-moz-focus-inner {\n    background-image: none;\n    color: transparent;\n    text-shadow: 0 0 0 #000000;\n  }\n}\n.cds--select-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--select-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--select-input:disabled, .cds--select-input:hover:disabled {\n  background-color: var(--cds-field);\n  border-block-end-color: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select-input--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--select-input--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--select--disabled .cds--label,\n.cds--select--disabled .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input,\n.cds--select--warning .cds--select-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--select-input:disabled ~ .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--light .cds--select-input {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--select--light .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select--light .cds--select-input:disabled, .cds--select--light .cds--select-input:hover:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select__arrow {\n  position: absolute;\n  block-size: 100%;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--select__arrow path {\n    fill: ButtonText;\n  }\n}\n\n.cds--select__invalid-icon {\n  position: absolute;\n  inset-inline-end: 2.5rem;\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon {\n  fill: var(--cds-support-error, #da1e28);\n}\n\n.cds--select__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--select__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\noptgroup.cds--select-optgroup,\n.cds--select-option {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\noptgroup.cds--select-optgroup:disabled,\n.cds--select-option:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--inline {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n\n.cds--select--inline.cds--select--invalid .cds--label,\n.cds--select--inline.cds--select--invalid .cds--form__helper-text {\n  align-self: flex-start;\n  margin-block-start: 0.8125rem;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-end: 0;\n  margin-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--label {\n  margin: 0 0.5rem 0 0;\n  white-space: nowrap;\n}\n\n.cds--select--inline .cds--select-input {\n  background-color: transparent;\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: auto;\n  padding-inline-end: 2rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--select-input:focus,\n.cds--select--inline .cds--select-input:focus option,\n.cds--select--inline .cds--select-input:focus optgroup {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.cds--select--inline .cds--select-input[disabled],\n.cds--select--inline .cds--select-input[disabled]:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--select--inline .cds--select__arrow {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--select--inline .cds--select-input:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--select--inline .cds--select-input:disabled ~ * {\n  cursor: not-allowed;\n}\n\n.cds--select--readonly .cds--select-input {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n  cursor: default;\n}\n\n.cds--select--readonly .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 2.5rem;\n  inline-size: 100%;\n}\n.cds--select.cds--skeleton:hover, .cds--select.cds--skeleton:focus, .cds--select.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--select.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--select.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--select.cds--skeleton .cds--select-input {\n  display: none;\n}\n\n.cds--select--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 8px + 1px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--select--slug .cds--slug::after,\n.cds--select--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--select--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--select--slug .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 4rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  padding-inline-end: 6rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before {\n  display: block;\n}\n\n.cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon,\n.cds--select--slug .cds--select-input__wrapper .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--select__arrow {\n    fill: ButtonText;\n  }\n}\n\n.cds--link {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline: none;\n  text-decoration: none;\n  transition: color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--link *,\n.cds--link *::before,\n.cds--link *::after {\n  box-sizing: inherit;\n}\n.cds--link:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n  text-decoration: underline;\n}\n.cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n    outline-style: dotted;\n  }\n}\n.cds--link:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:focus {\n    outline-style: dotted;\n  }\n}\n.cds--link:visited {\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n}\n.cds--link:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link--disabled,\n.cds--link--disabled:hover {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  font-weight: 400;\n  text-decoration: none;\n}\n.cds--link--disabled *,\n.cds--link--disabled *::before,\n.cds--link--disabled *::after,\n.cds--link--disabled:hover *,\n.cds--link--disabled:hover *::before,\n.cds--link--disabled:hover *::after {\n  box-sizing: inherit;\n}\n\n.cds--link.cds--link--visited:visited {\n  color: var(--cds-link-visited-text-color, var(--cds-link-visited, #8a3ffc));\n}\n\n.cds--link.cds--link--visited:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link.cds--link--inline {\n  display: inline;\n  text-decoration: underline;\n}\n\n.cds--link--disabled.cds--link--inline {\n  text-decoration: underline;\n}\n\n.cds--link--sm,\n.cds--link--sm.cds--link--disabled:hover {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n}\n\n.cds--link--lg,\n.cds--link--lg.cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n\n.cds--link__icon {\n  display: inline-flex;\n  align-self: center;\n  margin-inline-start: 0.5rem;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--tile-group html {\n  font-size: 100%;\n}\n.cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--tile-group strong {\n  font-weight: 600;\n}\n\n.cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--clickable,\n.cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--clickable *,\n.cds--tile--clickable *::before,\n.cds--tile--clickable *::after,\n.cds--tile--selectable *,\n.cds--tile--selectable *::before,\n.cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--tile--clickable:hover,\n.cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--tile--clickable:hover .cds--tile__checkmark, .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--tile--clickable:hover,\n.cds--tile--clickable:active,\n.cds--tile--clickable:visited,\n.cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n\n.cds--tile--clickable.cds--link--disabled,\n.cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--clickable .cds--tile--icon,\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n\n.cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n}\n\n.cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 0;\n}\n.cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n\n.cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron--interactive *,\n.cds--tile__chevron--interactive *::before,\n.cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n\n.cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n\n.cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n\n.cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n\n.cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n\n.cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n\n.cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile > .cds--slug,\n.cds--tile--expandable > div > .cds--slug,\n.cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n\n.cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n\n.cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--selectable::after,\n.cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable:focus,\n.cds--tile--slug.cds--tile--clickable:focus,\n.cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n\n.cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n\n.cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n\n.cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n\n.cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n\n.cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--slug-rounded,\n.cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n\n.cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tile__chevron svg,\n  .cds--tile__checkmark svg,\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--modal, :host(c4d-locale-modal), :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-locale-modal) .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-locale-modal) .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-locale-modal) .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-locale-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-locale-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-locale-modal) .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-locale-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-locale-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-locale-modal) .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-locale-modal) .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-locale-modal) .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-locale-modal) .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--card,\n:host(c4d-card),\n:host(c4d-region-item) .cds--link,\n:host(c4d-card-cta),\n:host(c4d-card-in-card),\n:host(c4d-card-group-item),\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-content-group-cards-item),\n:host(c4d-content-group-cards-item) .cds--card {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  padding: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 100%;\n  inline-size: 100%;\n  text-decoration: none;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile-group html,\n:host(c4d-card) .cds--tile-group html,\n:host(c4d-region-item) .cds--link .cds--tile-group html,\n:host(c4d-card-cta) .cds--tile-group html,\n:host(c4d-card-in-card) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--card .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group html {\n  font-size: 100%;\n}\n.cds--card .cds--tile-group body,\n:host(c4d-card) .cds--tile-group body,\n:host(c4d-region-item) .cds--link .cds--tile-group body,\n:host(c4d-card-cta) .cds--tile-group body,\n:host(c4d-card-in-card) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--card .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--card .cds--tile-group code,\n:host(c4d-card) .cds--tile-group code,\n:host(c4d-region-item) .cds--link .cds--tile-group code,\n:host(c4d-card-cta) .cds--tile-group code,\n:host(c4d-card-in-card) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--card .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--card .cds--tile-group strong,\n:host(c4d-card) .cds--tile-group strong,\n:host(c4d-region-item) .cds--link .cds--tile-group strong,\n:host(c4d-card-cta) .cds--tile-group strong,\n:host(c4d-card-in-card) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--card .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group strong {\n  font-weight: 600;\n}\n.cds--card .cds--tile,\n:host(c4d-card) .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile,\n:host(c4d-card-cta) .cds--tile,\n:host(c4d-card-in-card) .cds--tile,\n:host(c4d-card-group-item) .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--card .cds--tile:focus,\n:host(c4d-card) .cds--tile:focus,\n:host(c4d-region-item) .cds--link .cds--tile:focus,\n:host(c4d-card-cta) .cds--tile:focus,\n:host(c4d-card-in-card) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile:focus,\n  :host(c4d-card) .cds--tile:focus,\n  :host(c4d-region-item) .cds--link .cds--tile:focus,\n  :host(c4d-card-cta) .cds--tile:focus,\n  :host(c4d-card-in-card) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--light,\n:host(c4d-card) .cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--light,\n:host(c4d-card-cta) .cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--clickable,\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--clickable *,\n.cds--card .cds--tile--clickable *::before,\n.cds--card .cds--tile--clickable *::after,\n.cds--card .cds--tile--selectable *,\n.cds--card .cds--tile--selectable *::before,\n.cds--card .cds--tile--selectable *::after,\n:host(c4d-card) .cds--tile--clickable *,\n:host(c4d-card) .cds--tile--clickable *::before,\n:host(c4d-card) .cds--tile--clickable *::after,\n:host(c4d-card) .cds--tile--selectable *,\n:host(c4d-card) .cds--tile--selectable *::before,\n:host(c4d-card) .cds--tile--selectable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::after,\n:host(c4d-card-cta) .cds--tile--clickable *,\n:host(c4d-card-cta) .cds--tile--clickable *::before,\n:host(c4d-card-cta) .cds--tile--clickable *::after,\n:host(c4d-card-cta) .cds--tile--selectable *,\n:host(c4d-card-cta) .cds--tile--selectable *::before,\n:host(c4d-card-cta) .cds--tile--selectable *::after,\n:host(c4d-card-in-card) .cds--tile--clickable *,\n:host(c4d-card-in-card) .cds--tile--clickable *::before,\n:host(c4d-card-in-card) .cds--tile--clickable *::after,\n:host(c4d-card-in-card) .cds--tile--selectable *,\n:host(c4d-card-in-card) .cds--tile--selectable *::before,\n:host(c4d-card-in-card) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--selectable:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--selectable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--selectable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--selectable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--clickable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--clickable:focus,\n  :host(c4d-card) .cds--tile--clickable:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n  :host(c4d-card-cta) .cds--tile--clickable:focus,\n  :host(c4d-card-in-card) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--clickable:hover .cds--tile__checkmark, .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--clickable:active,\n.cds--card .cds--tile--clickable:visited,\n.cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--clickable:active,\n:host(c4d-card) .cds--tile--clickable:visited,\n:host(c4d-card) .cds--tile--clickable:visited:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:active,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:active,\n:host(c4d-card-cta) .cds--tile--clickable:visited,\n:host(c4d-card-cta) .cds--tile--clickable:visited:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:active,\n:host(c4d-card-in-card) .cds--tile--clickable:visited,\n:host(c4d-card-in-card) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--card .cds--tile--clickable.cds--link--disabled,\n.cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile__checkmark,\n:host(c4d-card) .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 1;\n}\n.cds--card .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--card .cds--tile__checkmark:focus,\n:host(c4d-card) .cds--tile__checkmark:focus,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n:host(c4d-card-cta) .cds--tile__checkmark:focus,\n:host(c4d-card-in-card) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-card) .cds--tile__checkmark:focus,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n  :host(c4d-card-cta) .cds--tile__checkmark:focus,\n  :host(c4d-card-in-card) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile__checkmark--persistent,\n:host(c4d-card) .cds--tile__checkmark--persistent,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark--persistent,\n:host(c4d-card-cta) .cds--tile__checkmark--persistent,\n:host(c4d-card-in-card) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n.cds--card .cds--tile__chevron,\n:host(c4d-card) .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--card .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile__chevron--interactive,\n:host(c4d-card) .cds--tile__chevron--interactive,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive,\n:host(c4d-card-cta) .cds--tile__chevron--interactive,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile__chevron--interactive *,\n.cds--card .cds--tile__chevron--interactive *::before,\n.cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-card) .cds--tile__chevron--interactive *,\n:host(c4d-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::before,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::after,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:focus,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:hover,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n.cds--card .cds--tile--expandable,\n:host(c4d-card) .cds--tile--expandable,\n:host(c4d-region-item) .cds--link .cds--tile--expandable,\n:host(c4d-card-cta) .cds--tile--expandable,\n:host(c4d-card-in-card) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n.cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n.cds--card .cds--tile--is-expanded,\n:host(c4d-card) .cds--tile--is-expanded,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded,\n:host(c4d-card-cta) .cds--tile--is-expanded,\n:host(c4d-card-in-card) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n.cds--card .cds--tile--is-selected,\n:host(c4d-card) .cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile-content,\n:host(c4d-card) .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile-content,\n:host(c4d-card-cta) .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--card .cds--tile-input,\n:host(c4d-card) .cds--tile-input,\n:host(c4d-region-item) .cds--link .cds--tile-input,\n:host(c4d-card-cta) .cds--tile-input,\n:host(c4d-card-in-card) .cds--tile-input,\n:host(c4d-card-group-item) .cds--tile-input,\n:host(c4d-card-group-item) .cds--card .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n.cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile > .cds--slug,\n.cds--card .cds--tile--expandable > div > .cds--slug,\n.cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card) .cds--tile > .cds--slug,\n:host(c4d-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-region-item) .cds--link .cds--tile > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--expandable > div > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-cta) .cds--tile > .cds--slug,\n:host(c4d-card-cta) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-in-card) .cds--tile > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n.cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n.cds--card .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:focus,\n.cds--card .cds--tile--slug.cds--tile--clickable:focus,\n.cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n.cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--slug-rounded,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug-rounded,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n.cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--card .cds--tile__chevron svg,\n  .cds--card .cds--tile__checkmark svg,\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card:focus-within .cds--tile--clickable,\n:host(c4d-card):focus-within .cds--tile--clickable,\n:host(c4d-region-item) .cds--link:focus-within .cds--tile--clickable,\n:host(c4d-card-cta):focus-within .cds--tile--clickable,\n:host(c4d-card-in-card):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item):focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--tile--clickable {\n  position: relative;\n  z-index: 2;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--card:focus-within ::slotted(c4d-image),\n.cds--card:focus-within ::slotted(c4d-card-cta-image),\n.cds--card:focus-within .cds--card__img,\n.cds--card:focus-within .cds--image,\n:host(c4d-card):focus-within ::slotted(c4d-image),\n:host(c4d-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card):focus-within .cds--card__img,\n:host(c4d-card):focus-within .cds--image,\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link:focus-within .cds--card__img,\n:host(c4d-region-item) .cds--link:focus-within .cds--image,\n:host(c4d-card-cta):focus-within ::slotted(c4d-image),\n:host(c4d-card-cta):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta):focus-within .cds--card__img,\n:host(c4d-card-cta):focus-within .cds--image,\n:host(c4d-card-in-card):focus-within ::slotted(c4d-image),\n:host(c4d-card-in-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card):focus-within .cds--card__img,\n:host(c4d-card-in-card):focus-within .cds--image,\n:host(c4d-card-group-item):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item):focus-within .cds--card__img,\n:host(c4d-card-group-item):focus-within .cds--image,\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--image,\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item):focus-within .cds--card__img,\n:host(c4d-content-group-cards-item):focus-within .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--image {\n  z-index: -1;\n}\n.cds--card:focus, .cds--card:visited, .cds--card:active,\n:host(c4d-card):focus,\n:host(c4d-card):visited,\n:host(c4d-card):active,\n:host(c4d-region-item) .cds--link:focus,\n:host(c4d-region-item) .cds--link:visited,\n:host(c4d-region-item) .cds--link:active,\n:host(c4d-card-cta):focus,\n:host(c4d-card-cta):visited,\n:host(c4d-card-cta):active,\n:host(c4d-card-in-card):focus,\n:host(c4d-card-in-card):visited,\n:host(c4d-card-in-card):active,\n:host(c4d-card-group-item):focus,\n:host(c4d-card-group-item):visited,\n:host(c4d-card-group-item):active,\n:host(c4d-card-group-item) .cds--card:focus,\n:host(c4d-card-group-item) .cds--card:visited,\n:host(c4d-card-group-item) .cds--card:active,\n:host(c4d-content-group-cards-item):focus,\n:host(c4d-content-group-cards-item):visited,\n:host(c4d-content-group-cards-item):active,\n:host(c4d-content-group-cards-item) .cds--card:focus,\n:host(c4d-content-group-cards-item) .cds--card:visited,\n:host(c4d-content-group-cards-item) .cds--card:active {\n  position: relative;\n  z-index: 2;\n  text-decoration: none;\n}\n.cds--card:focus ::slotted(c4d-image),\n.cds--card:focus .cds--image, .cds--card:visited ::slotted(c4d-image),\n.cds--card:visited .cds--image, .cds--card:active ::slotted(c4d-image),\n.cds--card:active .cds--image,\n:host(c4d-card):focus ::slotted(c4d-image),\n:host(c4d-card):focus .cds--image,\n:host(c4d-card):visited ::slotted(c4d-image),\n:host(c4d-card):visited .cds--image,\n:host(c4d-card):active ::slotted(c4d-image),\n:host(c4d-card):active .cds--image,\n:host(c4d-region-item) .cds--link:focus ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus .cds--image,\n:host(c4d-region-item) .cds--link:visited ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:visited .cds--image,\n:host(c4d-region-item) .cds--link:active ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:active .cds--image,\n:host(c4d-card-cta):focus ::slotted(c4d-image),\n:host(c4d-card-cta):focus .cds--image,\n:host(c4d-card-cta):visited ::slotted(c4d-image),\n:host(c4d-card-cta):visited .cds--image,\n:host(c4d-card-cta):active ::slotted(c4d-image),\n:host(c4d-card-cta):active .cds--image,\n:host(c4d-card-in-card):focus ::slotted(c4d-image),\n:host(c4d-card-in-card):focus .cds--image,\n:host(c4d-card-in-card):visited ::slotted(c4d-image),\n:host(c4d-card-in-card):visited .cds--image,\n:host(c4d-card-in-card):active ::slotted(c4d-image),\n:host(c4d-card-in-card):active .cds--image,\n:host(c4d-card-group-item):focus ::slotted(c4d-image),\n:host(c4d-card-group-item):focus .cds--image,\n:host(c4d-card-group-item):visited ::slotted(c4d-image),\n:host(c4d-card-group-item):visited .cds--image,\n:host(c4d-card-group-item):active ::slotted(c4d-image),\n:host(c4d-card-group-item):active .cds--image,\n:host(c4d-card-group-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus .cds--image,\n:host(c4d-card-group-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:visited .cds--image,\n:host(c4d-card-group-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:active .cds--image,\n:host(c4d-content-group-cards-item):focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus .cds--image,\n:host(c4d-content-group-cards-item):visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):visited .cds--image,\n:host(c4d-content-group-cards-item):active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):active .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:visited .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:active .cds--image {\n  z-index: -1;\n}\n.cds--card ::slotted(c4d-image),\n.cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-card) ::slotted(c4d-image),\n:host(c4d-card) ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta) ::slotted(c4d-image),\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card) ::slotted(c4d-image),\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) ::slotted(c4d-image),\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image) {\n  position: relative;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card ::slotted(c4d-image)::before,\n  .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card) ::slotted(c4d-image)::before,\n  :host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n    position: absolute;\n    background-color: var(--cds-border-inverse, #161616);\n    content: \"\";\n    inset: 0;\n    opacity: 0;\n    transition: none;\n  }\n}\n.cds--card ::slotted(c4d-image)::before,\n.cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card) ::slotted(c4d-image)::before,\n:host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n  position: absolute;\n  background-color: var(--cds-border-inverse, #161616);\n  content: \"\";\n  inset: 0;\n  opacity: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile {\n  padding: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  position: absolute;\n  background: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  opacity: 16%;\n}\n.cds--card .cds--card,\n:host(c4d-card) .cds--card,\n:host(c4d-region-item) .cds--link .cds--card,\n:host(c4d-card-cta) .cds--card,\n:host(c4d-card-in-card) .cds--card,\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-card-group-item) .cds--card .cds--card,\n:host(c4d-content-group-cards-item) .cds--card,\n:host(c4d-content-group-cards-item) .cds--card .cds--card {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n.cds--card .cds--card__wrapper,\n:host(c4d-card) .cds--card__wrapper,\n:host(c4d-region-item) .cds--link .cds--card__wrapper,\n:host(c4d-card-cta) .cds--card__wrapper,\n:host(c4d-card-in-card) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper {\n  display: flex;\n  flex: 1;\n  justify-content: space-between;\n  min-block-size: 10rem;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  display: flex;\n}\n.cds--card .cds--card__wrapper::before,\n:host(c4d-card) .cds--card__wrapper::before,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::before,\n:host(c4d-card-cta) .cds--card__wrapper::before,\n:host(c4d-card-in-card) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 50%;\n}\n.cds--card .cds--card__wrapper::after,\n:host(c4d-card) .cds--card__wrapper::after,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::after,\n:host(c4d-card-cta) .cds--card__wrapper::after,\n:host(c4d-card-in-card) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n.cds--card .cds--card__content,\n:host(c4d-card) .cds--card__content,\n:host(c4d-region-item) .cds--link .cds--card__content,\n:host(c4d-card-cta) .cds--card__content,\n:host(c4d-card-in-card) .cds--card__content,\n:host(c4d-card-group-item) .cds--card__content,\n:host(c4d-card-group-item) .cds--card .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__content {\n  display: flex;\n  flex-direction: column;\n  padding: 1rem;\n  inline-size: 100%;\n}\n.cds--card .cds--card__heading,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n  margin-block-end: 4rem;\n}\n@media (min-width: 82rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n.cds--card .cds--card__heading,\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  color: var(--cds-text-primary, #161616);\n  max-inline-size: 40rem;\n  padding-inline-end: 10%;\n}\n@media (min-width: 42rem) {\n  .cds--card .cds--card__heading,\n  .cds--card .cds--card__copy,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-card) .cds--card__copy,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__copy,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__copy,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n    padding-inline-end: 2rem;\n  }\n}\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n  margin-block-end: 2rem;\n}\n.cds--card .cds--card__img,\n:host(c4d-card) .cds--card__img,\n:host(c4d-region-item) .cds--link .cds--card__img,\n:host(c4d-card-cta) .cds--card__img,\n:host(c4d-card-in-card) .cds--card__img,\n:host(c4d-card-group-item) .cds--card__img,\n:host(c4d-card-group-item) .cds--card .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__img {\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--card__link::after,\n:host(c4d-card) .cds--card__link::after,\n:host(c4d-region-item) .cds--link .cds--card__link::after,\n:host(c4d-card-cta) .cds--card__link::after,\n:host(c4d-card-in-card) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__link::after {\n  position: absolute;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer-wrapper,\n:host(c4d-card) .cds--card__footer-wrapper,\n:host(c4d-region-item) .cds--link .cds--card__footer-wrapper,\n:host(c4d-card-cta) .cds--card__footer-wrapper,\n:host(c4d-card-in-card) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__footer-wrapper {\n  margin-block-start: auto;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-content-group-cards-item) {\n    inline-size: auto;\n    margin-inline: 1rem;\n  }\n}\n\n:host(c4d-card-group-item),\n:host(c4d-card-in-card),\n:host(c4d-card-cta),\n:host(c4d-card) {\n  outline: none;\n}\n:host(c4d-card-group-item) .cds--card__pictogram,\n:host(c4d-card-in-card) .cds--card__pictogram,\n:host(c4d-card-cta) .cds--card__pictogram,\n:host(c4d-card) .cds--card__pictogram {\n  display: flex;\n}\n:host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n  margin-block-end: 0;\n  padding-block-start: 2rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n    display: flex;\n    flex: 1;\n    padding-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item) .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card) .cds--card__pictogram-wrapper,\n:host(c4d-card-cta) .cds--card__pictogram-wrapper,\n:host(c4d-card) .cds--card__pictogram-wrapper {\n  display: flex;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram] .cds--card ::slotted(c4d-card-heading) {\n  padding-block-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-inline-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram] .cds--card .cds--card__content {\n  position: relative;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram] .cds--card .cds--card__copy {\n  margin-block: 2rem 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card svg,\n:host(c4d-card-in-card)[pictogram] .cds--card svg,\n:host(c4d-card-cta)[pictogram] .cds--card svg,\n:host(c4d-card)[pictogram] .cds--card svg {\n  position: absolute;\n  color: var(--cds-link-primary, #0f62fe);\n  inset-block-end: 1rem;\n  inset-inline-end: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-end;\n  margin-block: auto 0;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy {\n  margin-block-start: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-start;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content {\n  padding-block-end: 4rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper {\n  position: absolute;\n  inset-block-end: 1rem;\n  inset-inline-start: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]) {\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n:host(c4d-card) ::slotted(svg[slot=pictogram]) {\n  fill: currentColor;\n  margin-inline-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card) ::slotted(svg[slot=pictogram]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-in-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-cta)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card) .cds--card__copy {\n  display: flex;\n  flex-direction: column;\n  gap: 1rem;\n}\n:host(c4d-card-group-item) .cds--card__copy[hidden],\n:host(c4d-card-in-card) .cds--card__copy[hidden],\n:host(c4d-card-cta) .cds--card__copy[hidden],\n:host(c4d-card) .cds--card__copy[hidden] {\n  /* stylelint-disable declaration-no-important */\n  display: none !important;\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    padding-block-start: 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    /* stylelint-disable value-no-vendor-prefix, property-no-vendor-prefix */\n    display: -webkit-box;\n    /* stylelint-enable value-no-vendor-prefix, property-no-vendor-prefix */\n    overflow: hidden;\n    -webkit-box-orient: vertical;\n    -webkit-line-clamp: 3;\n    max-inline-size: calc(100% - 4rem);\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9) 0.25s;\n  }\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block: 2rem 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 0;\n    opacity: 0;\n    transform: translate3d(0, -16px, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9);\n    visibility: hidden;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading) {\n    opacity: 0;\n    transform: translate3d(0, 16px, 0);\n    transition-delay: 0s;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy {\n    display: block;\n    overflow: hidden;\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition-delay: 0.2s;\n    visibility: visible;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    position: absolute;\n    display: flow-root;\n    inset-block-end: 1rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 2rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]) {\n    margin-block-end: 0;\n  }\n}\n\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 100%;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 66.6666666667%;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 75%;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 56.25%;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n.cds--card.cds--card--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--card--border {\n  border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n.cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n}\n@media (min-width: 82rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n\n:host(c4d-card):not([href]) .cds--card .cds--card__copy,\n:host(c4d-card-group-item):not([href]) .cds--card .cds--card__copy {\n  margin-block-end: 0.125rem;\n}\n:host(c4d-card):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after {\n  display: none;\n}\n:host(c4d-card):not([href]):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):not([href]):focus-within ::slotted(c4d-image) {\n  z-index: 0;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-heading),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-heading) {\n  margin-block-end: auto;\n  padding-block-end: 4rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer) {\n  display: inline-flex;\n  margin-block-start: 2rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer)::after,\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer)::after {\n  position: relative;\n}\n:host(c4d-card)[color-scheme=light] .cds--card__wrapper, :host(c4d-card)[color-scheme=light]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light] .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n:host(c4d-card)[color-scheme=light][href] :hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light][href] :hover .cds--card__wrapper {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-card)[color-scheme=light][href]:active,\n:host(c4d-card)[color-scheme=light][href] a:active,\n:host(c4d-card-group-item)[color-scheme=light][href]:active,\n:host(c4d-card-group-item)[color-scheme=light][href] a:active {\n  outline: none;\n}\n:host(c4d-card)[logo] .cds--card,\n:host(c4d-card-group-item)[logo] .cds--card {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo] .cds--card__copy,\n:host(c4d-card-group-item)[logo] .cds--card__copy {\n  margin-block-end: 1rem;\n}\n:host(c4d-card)[logo]:hover,\n:host(c4d-card-group-item)[logo]:hover {\n  border-color: var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-card)[logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo]:active,\n:host(c4d-card-group-item)[logo]:active {\n  border-color: var(--cds-border-inverse, #161616);\n}\n:host(c4d-card)[logo] ::slotted(c4d-card-footer),\n:host(c4d-card-group-item)[logo] ::slotted(c4d-card-footer) {\n  block-size: 0;\n}\n:host(c4d-card)[href][logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[href][logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n:host(c4d-card[link]) ::slotted(c4d-card-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n:host(c4d-card[link]) .cds--card .cds--card__copy {\n  margin-block-start: 0;\n}\n\n:host(c4d-card-cta),\n:host(c4d-card-link-cta),\n:host(c4d-card-link) {\n  outline: none;\n}\n\n:host(c4d-card-eyebrow),\n.cds--card__eyebrow {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.5rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-eyebrow),\n  .cds--card__eyebrow {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-footer),\n:host(c4d-card-cta-footer),\n:host(c4d-card-in-card-footer),\n:host(c4d-feature-card-footer),\n:host(c4d-feature-cta-footer) {\n  display: flex;\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-footer):focus-visible,\n:host(c4d-card-cta-footer):focus-visible,\n:host(c4d-card-in-card-footer):focus-visible,\n:host(c4d-feature-card-footer):focus-visible,\n:host(c4d-feature-cta-footer):focus-visible {\n  outline: none;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: block;\n}\n\n.cds--card .cds--card__footer,\n:host(c4d-card-footer) a,\n:host(c4d-card-cta-footer) a,\n:host(c4d-card-in-card-footer) a,\n:host(c4d-feature-card-footer) a,\n:host(c4d-feature-cta-footer) a {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer:focus,\n:host(c4d-card-footer) a:focus,\n:host(c4d-card-cta-footer) a:focus,\n:host(c4d-card-in-card-footer) a:focus,\n:host(c4d-feature-card-footer) a:focus,\n:host(c4d-feature-cta-footer) a:focus {\n  outline: none;\n}\n.cds--card .cds--card__footer:hover,\n:host(c4d-card-footer) a:hover,\n:host(c4d-card-cta-footer) a:hover,\n:host(c4d-card-in-card-footer) a:hover,\n:host(c4d-feature-card-footer) a:hover,\n:host(c4d-feature-cta-footer) a:hover {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer span,\n:host(c4d-card-footer) a span,\n:host(c4d-card-cta-footer) a span,\n:host(c4d-card-in-card-footer) a span,\n:host(c4d-feature-card-footer) a span,\n:host(c4d-feature-cta-footer) a span {\n  flex: none;\n}\n.cds--card .cds--card__footer::after,\n:host(c4d-card-footer) a::after,\n:host(c4d-card-cta-footer) a::after,\n:host(c4d-card-in-card-footer) a::after,\n:host(c4d-feature-card-footer) a::after,\n:host(c4d-feature-cta-footer) a::after {\n  position: absolute;\n  z-index: 1;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer .cds--card__cta__copy,\n:host(c4d-card-footer) a .cds--card__cta__copy,\n:host(c4d-card-cta-footer) a .cds--card__cta__copy,\n:host(c4d-card-in-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-cta-footer) a .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n  max-inline-size: calc(100% - 20px - 0.5rem);\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n.cds--card .cds--card__footer .cds--card__footer__copy,\n:host(c4d-card-footer) a .cds--card__footer__copy,\n:host(c4d-card-cta-footer) a .cds--card__footer__copy,\n:host(c4d-card-in-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-cta-footer) a .cds--card__footer__copy {\n  margin-block-end: -0.125rem;\n  max-inline-size: calc(100% - 20px);\n}\n.cds--card .cds--card__footer svg,\n.cds--card .cds--card__footer ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) a svg,\n:host(c4d-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) a svg,\n:host(c4d-card-cta-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-in-card-footer) a svg,\n:host(c4d-card-in-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-card-footer) a svg,\n:host(c4d-feature-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-cta-footer) a svg,\n:host(c4d-feature-cta-footer) a ::slotted(svg[slot=icon]) {\n  display: block;\n  margin-inline-start: 0;\n  min-inline-size: 20px;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n  inline-size: 100%;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled),\n:host(c4d-card-cta-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer {\n  justify-content: flex-start;\n  inline-size: auto;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:active, :host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  text-decoration: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer::after {\n  content: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n}\n\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile {\n  border-color: var(--cds-background-inverse, #393939);\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  display: none;\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__copy,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__copy {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]):focus-within::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]):focus-within::after {\n  position: absolute;\n  z-index: 2;\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  content: \"\";\n  inset: 0;\n  outline: 1px solid var(--cds-focus-inset, #ffffff);\n  outline-offset: -3px;\n  pointer-events: none;\n}\n\n:host(c4d-card-heading),\n:host(c4d-card-link-heading) {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  color: var(--cds-text-primary, #161616);\n  margin-block-end: 4rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-heading),\n  :host(c4d-card-link-heading) {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-heading) {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\n:host(c4d-card-link-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n.cds--card-group__card ::slotted(c4d-card-eyebrow),\n.cds--card-group__card ::slotted(c4d-card-heading),\n.cds--card-group__card ::slotted(c4d-card-link-heading) {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n.cds--card-group__card:hover ::slotted(c4d-image),\n.cds--card-group__card:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n\n@media print {\n  :host(c4d-card),\n  :host(c4d-card-group-item),\n  :host(c4d-card-cta),\n  :host(c4d-card-in-card),\n  :host(c4d-content-group-cards-item) {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  :host(c4d-card) .cds--card,\n  :host(c4d-card-group-item) .cds--card,\n  :host(c4d-card-cta) .cds--card,\n  :host(c4d-card-in-card) .cds--card,\n  :host(c4d-content-group-cards-item) .cds--card {\n    border: none;\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-card) ::slotted(c4d-image),\n  :host(c4d-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card) .cds--image,\n  :host(c4d-card-group-item) ::slotted(c4d-image),\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-group-item) .cds--image,\n  :host(c4d-card-cta) ::slotted(c4d-image),\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-cta) .cds--image,\n  :host(c4d-card-in-card) ::slotted(c4d-image),\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-in-card) .cds--image,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image),\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-content-group-cards-item) .cds--image {\n    display: none;\n  }\n  .cds--card {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  .cds--card .cds--card__img,\n  .cds--card .cds--card__image_img,\n  .cds--card .cds--image,\n  .cds--card .cds--card__video-thumbnail {\n    display: none;\n  }\n}\n:host(c4d-card[disabled]) .cds--card,\n:host(c4d-region-item[disabled]) .cds--card {\n  cursor: not-allowed;\n}\n:host(c4d-card[disabled]) .cds--card__copy,\n:host(c4d-card[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-card[disabled]) ::slotted(c4d-card-heading),\n:host(c4d-region-item[disabled]) .cds--card__copy,\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-heading) {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n:host(c4d-card-cta-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  justify-content: space-between;\n}\n\n:host(c4d-card-footer[href])::after {\n  position: relative;\n}\n\n.cds--search {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--search .cds--label {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--search-input {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  order: 1;\n  padding: 0 2.5rem;\n  border: none;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  text-overflow: ellipsis;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search-input *,\n.cds--search-input *::before,\n.cds--search-input *::after {\n  box-sizing: inherit;\n}\n.cds--search-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--search-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--search-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--search-input::-ms-clear {\n  display: none;\n}\n\n.cds--search-input[disabled] {\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--search-input[disabled]::-moz-placeholder {\n  color: var(--cds-field);\n}\n.cds--search-input[disabled]::placeholder {\n  color: var(--cds-field);\n}\n\n.cds--search--light .cds--search-input {\n  background: var(--cds-field-02, #ffffff);\n}\n\n.cds--search--light .cds--search-close::before {\n  background: var(--cds-field-02, #ffffff);\n}\n\n.cds--search--sm .cds--search-input,\n.cds--search--sm.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 2rem;\n  block-size: 2rem;\n}\n\n.cds--search--sm .cds--search-magnifier-icon {\n  inset-inline-start: 0.5rem;\n}\n\n.cds--search--md .cds--search-input,\n.cds--search--md.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 2.5rem;\n  block-size: 2.5rem;\n}\n\n.cds--search--md .cds--search-magnifier-icon {\n  inset-inline-start: 0.75rem;\n}\n\n.cds--search--lg .cds--search-input,\n.cds--search--lg.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 3rem;\n  block-size: 3rem;\n}\n\n.cds--search-magnifier-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 2;\n  block-size: 1rem;\n  fill: var(--cds-icon-secondary, #525252);\n  inline-size: 1rem;\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n.cds--search-magnifier-icon *,\n.cds--search-magnifier-icon *::before,\n.cds--search-magnifier-icon *::after {\n  box-sizing: inherit;\n}\n\n.cds--search-close {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--search-close *,\n.cds--search-close *::before,\n.cds--search-close *::after {\n  box-sizing: inherit;\n}\n.cds--search-close::-moz-focus-inner {\n  border: 0;\n}\n.cds--search-close::before {\n  position: absolute;\n  display: block;\n  background-color: var(--cds-field);\n  block-size: calc(100% - 2px);\n  content: \"\";\n  inline-size: 2px;\n  inset-block-start: 0.0625rem;\n  inset-inline-start: 0;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--search-close::before {\n    transition: none;\n  }\n}\n.cds--search-close:hover {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n.cds--search-close:hover::before {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--search-button {\n  flex-shrink: 0;\n  background-color: var(--cds-field);\n  margin-inline-start: 0.125rem;\n}\n.cds--search-button svg {\n  fill: currentColor;\n  vertical-align: middle;\n}\n\n.cds--search-close svg {\n  fill: inherit;\n}\n\n.cds--search-close,\n.cds--search-button {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border-width: 1px 0;\n  border-style: solid;\n  border-color: transparent;\n  block-size: 2.5rem;\n  cursor: pointer;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 2.5rem;\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), border 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n.cds--search-close:hover,\n.cds--search-button:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--search-close:focus,\n.cds--search-button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-close:focus,\n  .cds--search-button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--search-close:active,\n.cds--search-button:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n@media screen and (prefers-contrast) {\n  .cds--search-close:active,\n  .cds--search-button:active {\n    outline-style: dotted;\n  }\n}\n\n.cds--search--disabled .cds--search-close,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier {\n  cursor: not-allowed;\n  outline: none;\n}\n.cds--search--disabled .cds--search-close:hover,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover {\n  background-color: transparent;\n  border-block-end-color: transparent;\n}\n.cds--search--disabled .cds--search-close:hover::before,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover::before {\n  background-color: transparent;\n}\n\n.cds--search--disabled svg {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--search-close:focus::before,\n.cds--search-close:active::before {\n  background-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--search-input:focus ~ .cds--search-close:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-input:focus ~ .cds--search-close:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--search--sm .cds--search-close,\n.cds--search--sm ~ .cds--search-button, .cds--search--sm.cds--search--expandable, .cds--search--sm.cds--search--expandable .cds--search-magnifier {\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--search--sm.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 2rem;\n}\n.cds--search--sm.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 2rem;\n}\n\n.cds--search--md .cds--search-close,\n.cds--search--md ~ .cds--search-button, .cds--search--md.cds--search--expandable, .cds--search--md.cds--search--expandable .cds--search-magnifier {\n  block-size: 2.5rem;\n  inline-size: 2.5rem;\n}\n.cds--search--md.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 2.5rem;\n}\n.cds--search--md.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 2.5rem;\n}\n\n.cds--search--lg .cds--search-close,\n.cds--search--lg ~ .cds--search-button, .cds--search--lg.cds--search--expandable, .cds--search--lg.cds--search--expandable .cds--search-magnifier {\n  block-size: 3rem;\n  inline-size: 3rem;\n}\n.cds--search--lg.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 3rem;\n}\n.cds--search--lg.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 3rem;\n}\n\n.cds--search-close--hidden {\n  opacity: 0;\n  visibility: hidden;\n}\n\n.cds--search--lg.cds--skeleton .cds--search-input,\n.cds--search--md.cds--skeleton .cds--search-input,\n.cds--search--sm.cds--skeleton .cds--search-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 100%;\n}\n.cds--search--lg.cds--skeleton .cds--search-input:hover, .cds--search--lg.cds--skeleton .cds--search-input:focus, .cds--search--lg.cds--skeleton .cds--search-input:active,\n.cds--search--md.cds--skeleton .cds--search-input:hover,\n.cds--search--md.cds--skeleton .cds--search-input:focus,\n.cds--search--md.cds--skeleton .cds--search-input:active,\n.cds--search--sm.cds--skeleton .cds--search-input:hover,\n.cds--search--sm.cds--skeleton .cds--search-input:focus,\n.cds--search--sm.cds--skeleton .cds--search-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--search--lg.cds--skeleton .cds--search-input::before,\n.cds--search--md.cds--skeleton .cds--search-input::before,\n.cds--search--sm.cds--skeleton .cds--search-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--search--lg.cds--skeleton .cds--search-input::before,\n  .cds--search--md.cds--skeleton .cds--search-input::before,\n  .cds--search--sm.cds--skeleton .cds--search-input::before {\n    animation: none;\n  }\n}\n.cds--search--lg.cds--skeleton .cds--search-input::-moz-placeholder, .cds--search--md.cds--skeleton .cds--search-input::-moz-placeholder, .cds--search--sm.cds--skeleton .cds--search-input::-moz-placeholder {\n  color: transparent;\n}\n.cds--search--lg.cds--skeleton .cds--search-input::placeholder,\n.cds--search--md.cds--skeleton .cds--search-input::placeholder,\n.cds--search--sm.cds--skeleton .cds--search-input::placeholder {\n  color: transparent;\n}\n\n.cds--search--expandable {\n  transition: width 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--search--expandable.cds--search--expanded {\n  inline-size: 100%;\n}\n\n.cds--search--expandable .cds--search-input {\n  padding: 0;\n  inline-size: 0;\n  transition: padding 70ms cubic-bezier(0.2, 0, 0.38, 0.9), width 0s linear 70ms;\n}\n.cds--search--expandable .cds--search-input::-moz-placeholder {\n  position: relative;\n  opacity: 0;\n  transition-duration: 70ms;\n  -moz-transition-property: padding, opacity;\n  transition-property: padding, opacity;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search--expandable .cds--search-input::placeholder {\n  position: relative;\n  opacity: 0;\n  transition-duration: 70ms;\n  transition-property: padding, opacity;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-input {\n  inline-size: 100%;\n  transition: padding 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search--expandable.cds--search--expanded .cds--search-input::-moz-placeholder {\n  position: relative;\n  padding: 0;\n  opacity: 1;\n}\n.cds--search--expandable.cds--search--expanded .cds--search-input::placeholder {\n  position: relative;\n  padding: 0;\n  opacity: 1;\n}\n\n.cds--search--expandable .cds--search-magnifier {\n  position: absolute;\n  cursor: pointer;\n}\n.cds--search--expandable .cds--search-magnifier:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--search--expandable .cds--search-magnifier:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-magnifier {\n  pointer-events: none;\n}\n\n.cds--search--expandable .cds--search-magnifier-icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-magnifier-icon {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--search--expandable.cds--search--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--search-close svg,\n  .cds--search-magnifier-icon {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-locale-modal) {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-locale-modal) .cds--modal-container {\n  padding: 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: calc(100% - 2rem);\n  min-block-size: 80%;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-locale-modal) .cds--modal-container {\n    inline-size: -moz-fit-content;\n    inline-size: fit-content;\n  }\n}\n:host(c4d-locale-modal) .cds--modal-container .cds--modal-content {\n  display: grid;\n  padding: 0;\n  margin: 0;\n  grid-template-rows: auto 1fr auto;\n}\n@media (max-height: 28.125rem) {\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__filtering .c4d--locale-modal__filter {\n    overflow-y: initial;\n  }\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__filtering .c4d--locale-modal__filter .c4d--locale-modal__list {\n    overflow-y: initial;\n  }\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__search {\n    position: relative;\n  }\n}\n:host(c4d-locale-modal) .c4d--locale-modal {\n  display: flex;\n  margin-block: 2rem 0;\n  padding-inline-start: 1rem;\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-modal) .c4d--locale-modal.cds--modal-content {\n  margin-block-start: 2rem;\n  padding-block-start: 0.5rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-modal) .c4d--locale-modal.cds--modal-content {\n    margin-block-start: auto;\n  }\n}\n:host(c4d-locale-modal) .c4d--locale-modal__locales.c4d--locale-modal__locales-hidden {\n  display: none;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label {\n  display: inline-flex;\n  padding: 0;\n  border: none;\n  background-color: transparent;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label:hover,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label:hover {\n  color: var(--cds-background-brand, #0f62fe);\n  cursor: pointer;\n  text-decoration: underline;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label:focus,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label:focus {\n  outline-color: var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label svg,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label svg {\n  fill: currentColor;\n}\n:host(c4d-locale-modal) .c4d--locale-modal__filter {\n  z-index: -1;\n  display: none;\n  inset-block-start: 3rem;\n  opacity: 0;\n  transform: translate3d(0, -24px, 0);\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n:host(c4d-locale-modal) .cds--modal-header {\n  padding-block-start: 1rem;\n  padding-inline-start: 2rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__label {\n  display: flex;\n  align-items: center;\n  color: var(--cds-text-primary, #161616);\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-modal) .cds--modal-header__label .c4d--locale-modal__label-globe {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__label .c4d--locale-modal__label-arrow {\n  margin-inline-end: 0.5rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__heading {\n  font-size: 1.75rem;\n  font-weight: 400;\n  line-height: 1.28572;\n  letter-spacing: 0;\n  font-size: calc(1.75rem + 0.25 * (100vw - 20rem) / 62);\n  padding: 0;\n  margin-block-start: 0.75rem;\n}\n@media (min-width: 82rem) {\n  :host(c4d-locale-modal) .cds--modal-header__heading {\n    font-size: 2rem;\n    line-height: 1.25;\n    font-weight: 400;\n    font-size: calc(2rem + 0 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-locale-modal) .cds--modal-header__heading {\n    font-size: 2rem;\n    font-weight: 400;\n    font-size: 2rem;\n  }\n}\n:host(c4d-locale-modal) .cds--modal-header__heading:focus {\n  outline: none;\n}\n:host(c4d-locale-modal) c4d-expressive-modal-header {\n  padding: 3px 20% 0 1rem;\n  margin-block-end: 0.5rem;\n}\n\n:host(c4d-locale-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-locale-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-locale-modal[open]) {\n    transition: none;\n  }\n}\n\n.c4d--locale-modal-container .c4d--locale-modal__regions {\n  inline-size: 100%;\n  margin-block-start: auto;\n}\n.c4d--locale-modal-container .c4d--locale-modal__regions > .cds--row {\n  margin-inline: 0;\n}\n\n:host(c4d-region-item) .cds--link {\n  display: flex;\n  align-items: stretch;\n  block-size: 100%;\n  inline-size: 100%;\n  max-inline-size: none;\n  outline: 1px solid var(--cds-layer-02, #ffffff);\n  outline-offset: -1px;\n  text-align: inherit;\n}\n:host(c4d-region-item) .cds--link:hover.cds--link--disabled {\n  display: flex;\n}\n:host(c4d-region-item) .cds--link:focus-within {\n  outline-color: var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-region-item) .cds--link {\n    min-block-size: 6rem;\n  }\n}\n\n:host(c4d-region-item) .cds--card.cds--tile {\n  border-block-end: transparent;\n}\n\n:host(c4d-region-item:last-of-type) .cds--card.cds--tile {\n  border-block-end: 1px solid var(--cds-border-tile);\n}\n\n@media (min-width: 66rem) {\n  :host(c4d-region-item) .cds--card.cds--tile {\n    border-block-end: 1px solid var(--cds-border-tile);\n  }\n  :host(c4d-region-item:first-of-type) .cds--card.cds--tile {\n    border-inline-end: transparent;\n  }\n  :host(c4d-region-item:nth-of-type(3)) .cds--card.cds--tile {\n    border-block-start: transparent;\n    border-inline-end: transparent;\n  }\n  :host(c4d-region-item:last-of-type) .cds--card.cds--tile {\n    border-block-start: transparent;\n  }\n}\n:host(c4d-region-item) svg.cds--card__cta,\n.cds--modal-container svg.cds--card__cta {\n  color: var(--cds-border-inverse, #161616);\n}\n\n:host(c4d-regions) {\n  display: flex;\n  flex-wrap: wrap;\n}\n\n:host(c4d-locale-item) a.cds--link {\n  display: flex;\n  border: 0.125rem solid transparent;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  min-block-size: 3rem;\n  text-decoration: none;\n  transition: background-color 110ms cubic-bezier(0.4, 0.14, 0.3, 1), border 110ms cubic-bezier(0.4, 0.14, 0.3, 1);\n}\n:host(c4d-locale-item) a.cds--link:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-locale-item) a.cds--link:active, :host(c4d-locale-item) a.cds--link:focus {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n:host(c4d-locale-item) .c4d--locale-modal__locales__name {\n  padding: 0.75rem 1rem;\n  color: var(--cds-text-helper, #6f6f6f);\n  inline-size: 50%;\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-item) .c4d--locale-modal__locales__name:first-of-type {\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-locale-search) {\n  display: flex;\n  overflow: hidden;\n  flex-direction: column;\n  margin-block-start: 2rem;\n  padding-block-start: 0.5rem;\n}\n:host(c4d-locale-search) cds-search::part(input)::-moz-placeholder {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-locale-search) cds-search::part(input)::placeholder {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-locale-search) .c4d--locale-modal__filter {\n  z-index: 1;\n  display: flex;\n  overflow: hidden;\n  flex: 1;\n  flex-direction: column;\n  opacity: 1;\n  transform: translate3d(0, 0, 0);\n  transition: 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n:host(c4d-locale-search) .c4d--locale-modal__regions {\n  z-index: -1;\n  display: none;\n  opacity: 0;\n  transition: 240ms cubic-bezier(0, 0, 0.3, 1);\n  visibility: hidden;\n}\n:host(c4d-locale-search) .c4d--locale-modal__search {\n  position: sticky;\n  background-color: var(--cds-background, #ffffff);\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  inset-block-start: 0;\n}\n:host(c4d-locale-search) .c4d--locale-modal__search-text {\n  padding: 2rem 1rem 1rem;\n  margin: 0;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n}\n:host(c4d-locale-search) .c4d--locale-modal__list {\n  flex: 1;\n  overflow-y: auto;\n}\n\n:host(c4d-locale-modal) c4d-expressive-modal-heading {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-region-item) {\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-region-item) {\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n  }\n}\n:host(c4d-region-item) .cds--card__wrapper {\n  block-size: 100%;\n}\n:host(c4d-region-item) ::slotted(div.c4d--region-item-footer) {\n  display: flex;\n  justify-content: flex-end;\n  color: var(--cds-border-inverse, #161616);\n  inline-size: 100%;\n  /* stylelint-disable declaration-no-important */\n  margin-block-start: auto !important;\n}\n:host(c4d-region-item) ::slotted(div.c4d--region-item-footer[disabled]) {\n  color: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-footer) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  padding-block: 3rem;\n  padding-block-start: 3rem;\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-footer) .cds--modal-content .cds--link, :host(c4d-footer) .cds--modal-content .cds--link:visited {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer) ::slotted([slot=brand]) {\n    margin-block-end: 3rem;\n  }\n}\n\n:host(c4d-footer[size=short]) .cds--footer__logo-container {\n  inline-size: 100%;\n}\n:host(c4d-footer[size=short]) .cds--language-selector__container {\n  margin-block-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=short]) .cds--language-selector__container {\n    margin-block-start: 0;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-footer[size=short]) .cds--language-selector__container {\n    margin-inline-start: 62.5%;\n  }\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer[size=short]) ::slotted([slot=brand]) {\n    margin-block-end: 0;\n  }\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=micro]) {\n    padding-block: 0;\n  }\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer[size=micro]) ::slotted([slot=locale-button]) {\n    margin-block-start: 0;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=micro]) .cds--footer__logo-container {\n    display: none;\n  }\n}\n:host(c4d-footer[size=micro]) .cds--language-selector__container {\n  padding: 0;\n}\n:host(c4d-footer[size=micro]) .cds--locale-btn__container {\n  flex-basis: auto;\n}\n:host(c4d-footer[size=micro]) .cds--locale-btn__container button {\n  border: none;\n}\n:host(c4d-footer[size=micro]) .cds--legal-nav {\n  border-block-start: 0;\n}\n\n:host(c4d-footer-nav-item),\n:host(c4d-legal-nav-item),\n:host(c4d-legal-nav-cookie-preferences-placeholder) {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: list-item;\n  outline: none;\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link, :host(c4d-footer-nav-item) .cds--footer__link.cds--link:visited,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:visited,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:visited {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link:focus,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:focus,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:focus {\n  outline-color: var(--cds-focus, #0f62fe);\n  outline-offset: -1px;\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link:active,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:active,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link:hover, :host(c4d-footer-nav-item) .cds--footer__link.cds--link:visited:hover,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:hover,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:visited:hover,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:hover,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:visited:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link {\n  cursor: pointer;\n}\n\n:host(c4d-legal-nav) {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-legal-nav) .cds--legal-nav__list .cds--legal-nav__list-item .cds--link {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-legal-nav) .cds--legal-nav__list .cds--legal-nav__list-item .cds--link:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--footer__main {\n  box-sizing: border-box;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n}\n@media (min-width: 42rem) {\n  .cds--footer__main {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--footer__main {\n    padding-inline: 2.5rem;\n  }\n}\n\n.cds--footer__main-container {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n  flex-direction: column;\n}\n:host(c4d-footer[size=short]) .cds--footer__main-container, .cds--footer--short .cds--footer__main-container {\n  flex-direction: row;\n}\n@media (min-width: 66rem) {\n  .cds--footer__main-container {\n    flex-direction: row;\n  }\n}\n\n.cds--footer__logo-container {\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n  margin-inline: 0;\n}\n@media (min-width: 42rem) {\n  .cds--footer__logo-container {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--footer__logo-container {\n    padding-inline: 2.5rem;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--footer__logo-container {\n    margin-block-end: 0;\n    padding-inline: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--footer__logo-container {\n    inline-size: 100%;\n    margin-inline: auto;\n  }\n}\n.cds--footer__logo-container .cds--footer__logo-row {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n  justify-content: space-between;\n}\n\n@media print {\n  :host(c4d-footer),\n  .cds--footer {\n    /* stylelint-disable declaration-no-important */\n    display: none !important;\n    /* stylelint-enable declaration-no-important */\n  }\n}\n:host(c4d-footer),\n:host(c4d-legal-nav) {\n  display: block;\n}\n:host(c4d-footer) .c4d--adjunct-links__container,\n:host(c4d-legal-nav) .c4d--adjunct-links__container {\n  list-style: none;\n  margin-block-start: 2rem;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav) .c4d--adjunct-links__container {\n    margin-inline: auto;\n    max-inline-size: 99rem;\n    padding-inline: 1rem;\n  }\n}\n@media (max-width: 41.98rem) and (min-width: 42rem) {\n  :host(c4d-footer) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav) .c4d--adjunct-links__container {\n    padding-inline: 2rem;\n  }\n}\n@media (max-width: 41.98rem) and (min-width: 99rem) {\n  :host(c4d-footer) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav) .c4d--adjunct-links__container {\n    padding-inline: 2.5rem;\n  }\n}\n:host(c4d-footer) .c4d--adjunct-links__container--hidden,\n:host(c4d-legal-nav) .c4d--adjunct-links__container--hidden {\n  display: none;\n}\n\n:host(c4d-footer-nav-group[open]) .cds--accordion__content {\n  display: block;\n  padding-block-start: 0;\n}\n\n:host(c4d-footer-nav-group) .cds--accordion__heading {\n  align-items: center;\n  padding: 0;\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  min-block-size: 3rem;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-footer-nav-group:last-of-type) {\n    border-block-end: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  }\n}\n\n:host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container,\n:host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list {\n  padding-block: 0;\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list {\n    padding-block-start: 0.5rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list {\n    margin-inline-start: 25%;\n  }\n}\n:host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container > ul,\n:host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list > ul {\n  inline-size: 100%;\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container > ul,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list > ul {\n    display: block;\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 2rem;\n         column-gap: 2rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container > ul,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list > ul {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav[size=micro]) ::slotted(c4d-legal-nav-item),\n  :host(c4d-legal-nav[size=micro]) ::slotted(c4d-legal-nav-cookie-preferences-placeholder) {\n    display: flex;\n    align-items: center;\n    padding: 0;\n    min-block-size: 3rem;\n  }\n}\n:host(c4d-legal-nav[size=micro]) .c4d--adjunct-links__container {\n  display: none;\n}\n:host(c4d-legal-nav[size=micro]) .c4d--legal-nav {\n  display: block;\n  border-block-start: 0;\n}\n:host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list {\n  inline-size: 100%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div {\n    display: flex;\n  }\n}\n:host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n  padding: 0 1rem;\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n    padding-block-start: 0.5rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n    display: flex;\n    -moz-column-count: inherit;\n         column-count: inherit;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n    padding: 0 1rem 0 2rem;\n    border-block-start: none;\n  }\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-locale-button[size=micro]) {\n    flex-shrink: 1;\n    padding: 0;\n    margin: 0;\n    margin-inline-start: 50%;\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary {\n    border: none;\n    margin: 0;\n    background-color: var(--cds-background, #ffffff);\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  }\n}\n@media (min-width: 42rem) and (min-width: 42rem) {\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary {\n    align-self: flex-end;\n    border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  }\n}\n@media (min-width: 42rem) and (min-width: 66rem) {\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary {\n    margin: 0 -1rem 0 0;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary:hover, :host(c4d-locale-button[size=micro]) .cds--btn--tertiary:focus {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--btn--tertiary,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input {\n    background-color: var(--cds-background, #ffffff);\n    max-inline-size: 100%;\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--btn--tertiary:hover,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box:hover,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--btn--tertiary:active,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box:active,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select {\n    max-inline-size: 100%;\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--text-input,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input {\n    border-block-end: none;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-button[size=micro]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-locale-button[size=micro]) .cds--btn {\n  padding-block: 0.75rem;\n}\n:host(c4d-locale-button[size=micro]) .cds--locale-btn {\n  max-inline-size: 100%;\n}\n\n:host(c4d-language-selector-desktop),\n:host(c4d-language-selector-mobile) {\n  position: relative;\n  padding: 0 1rem;\n  margin-block: 3rem;\n  max-block-size: 3rem;\n  outline: none;\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n}\n:host(c4d-language-selector-desktop) .cds--list-box__field,\n:host(c4d-language-selector-mobile) .cds--list-box__field {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-language-selector-desktop) .cds--combo-box,\n:host(c4d-language-selector-mobile) .cds--combo-box {\n  inset-block-end: 1rem;\n}\n:host(c4d-language-selector-desktop) .cds--list-box__menu,\n:host(c4d-language-selector-mobile) .cds--list-box__menu {\n  position: absolute;\n  inset-block: auto 47px;\n  max-block-size: 13.5rem;\n}\n:host(c4d-language-selector-desktop) .cds--text-input,\n:host(c4d-language-selector-mobile) .cds--text-input {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n@media (min-width: 42rem) {\n  :host(c4d-language-selector-desktop),\n  :host(c4d-language-selector-mobile) {\n    padding: 0;\n    margin-block-start: 0;\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-inline-start: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-language-selector-desktop),\n  :host(c4d-language-selector-mobile) {\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: 62.5%;\n    order: 1;\n    min-inline-size: 13.5rem;\n  }\n}\n\n:host(c4d-language-selector-desktop) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n:host(c4d-language-selector-desktop) .cds--list-box__selection {\n  inset-inline-end: 2.25rem;\n}\n:host(c4d-language-selector-desktop) .cds--label-visually-hidden {\n  block-size: 0;\n  visibility: hidden;\n}\n\n:host(c4d-language-selector-desktop[size=micro]) {\n  align-self: flex-end;\n  padding: 0;\n  margin: 0;\n  border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  inline-size: 100%;\n  margin-block-end: 0;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown {\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown .cds--list-box__field {\n  background-color: var(--cds-background, #ffffff);\n  block-size: inherit;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown,\n:host(c4d-language-selector-desktop[size=micro]) .cds--text-input {\n  border-block-end: none;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--select-input__wrapper {\n  block-size: 100%;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--select-input {\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  border-block-end: none;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--select-input:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n@media (min-width: 42rem) {\n  :host(c4d-language-selector-desktop[size=micro]) {\n    border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n    max-inline-size: 50%;\n  }\n}\n\n:host(c4d-language-selector-mobile[size=micro]) {\n  align-self: flex-end;\n  border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  inline-size: 100%;\n  margin-block-start: 0;\n}\n:host(c4d-language-selector-mobile[size=micro]) .cds--select {\n  display: block;\n}\n:host(c4d-language-selector-mobile[size=micro]) .cds--select-input {\n  block-size: 100%;\n  inline-size: 100%;\n  max-inline-size: 100%;\n}\n:host(c4d-language-selector-mobile[size=micro]) .cds--select-input:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n@media (min-width: 42rem) {\n  :host(c4d-language-selector-mobile[size=micro]) {\n    padding: 0;\n    margin: 0;\n    max-inline-size: 50%;\n  }\n  :host(c4d-language-selector-mobile[size=micro]) .cds--select-input {\n    background-color: var(--cds-background, #ffffff);\n    border-block-end: none;\n  }\n}\n\n:host(c4d-language-selector-mobile) .cds--select-input__wrapper {\n  block-size: 3rem;\n  margin-block-start: -1rem;\n}\n\n:host(c4d-footer-logo),\n.cds--footer-logo {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: block;\n  flex: 0 0 50%;\n  max-inline-size: 50%;\n}\n:host(c4d-footer-logo):focus-visible,\n.cds--footer-logo:focus-visible {\n  outline: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-logo),\n  .cds--footer-logo {\n    margin-block-end: 3rem;\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-logo),\n  .cds--footer-logo {\n    display: block;\n    flex: 0 0 12.5%;\n    max-inline-size: 12.5%;\n  }\n}\n\n.c4d--footer-logo__link {\n  display: inline-block;\n  color: var(--cds-text-on-color, #ffffff);\n  inline-size: auto;\n  padding-inline-start: 1rem;\n  inline-size: 100%;\n  padding-inline: 1rem;\n}\n.cds--row--condensed .c4d--footer-logo__link, .cds--grid--condensed .c4d--footer-logo__link {\n  padding-inline: 0.03125rem;\n}\n.cds--row--narrow .c4d--footer-logo__link, .cds--grid--narrow .c4d--footer-logo__link {\n  padding-inline: 0 1rem;\n}\n.c4d--footer-logo__link:focus {\n  box-shadow: inset 0 0 0 0.125rem var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.c4d--footer-logo__logo {\n  display: inline-block;\n  fill: currentColor;\n  inline-size: 128px;\n}\n\n:host(c4d-footer-logo[size=micro]) {\n  position: relative;\n  align-self: center;\n  margin: 0;\n}\n:host(c4d-footer-logo[size=micro]) .c4d--footer-logo__link {\n  position: absolute;\n  inset-block-start: -2.21875rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-logo[size=micro]) .c4d--footer-logo__link {\n    position: relative;\n    inset-block-start: 0;\n  }\n}\n\n@media (min-width: 42rem) and (max-width: 66rem) {\n  :host(c4d-footer-logo[size=micro][disable-locale-button]) {\n    background-color: var(--cds-background, #ffffff);\n    block-size: 3rem;\n    inline-size: 100%;\n  }\n  :host(c4d-footer-logo[size=micro][disable-locale-button]) .c4d--footer-logo__link {\n    inset-block-start: 0.78125rem;\n  }\n}\n:host(c4d-footer-nav) {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  inline-size: 100%;\n  padding-inline: 1rem;\n  order: 1;\n  padding: 0;\n}\n:host(c4d-footer-nav) .cds--accordion {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion *,\n:host(c4d-footer-nav) .cds--accordion *::before,\n:host(c4d-footer-nav) .cds--accordion *::after {\n  box-sizing: inherit;\n}\n:host(c4d-footer-nav) .cds--accordion {\n  inline-size: 100%;\n  list-style: none;\n}\n:host(c4d-footer-nav) .cds--accordion__item {\n  display: list-item;\n  overflow: visible;\n  border-block-start: 1px solid var(--cds-border-subtle);\n  transition: border-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n:host(c4d-footer-nav) .cds--accordion__item:last-child {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n:host(c4d-footer-nav) .cds--accordion__item:not(.cds--accordion__item--active):hover, :host(c4d-footer-nav) .cds--accordion__item:not(.cds--accordion__item--active):hover + .cds--accordion__item {\n  border-block-start-color: var(--cds-layer-hover);\n}\n:host(c4d-footer-nav) .cds--accordion__item:not(.cds--accordion__item--active):last-child:hover {\n  border-block-end-color: var(--cds-layer-hover);\n}\n:host(c4d-footer-nav) .cds--accordion__heading {\n  transition: background-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion__heading *,\n:host(c4d-footer-nav) .cds--accordion__heading *::before,\n:host(c4d-footer-nav) .cds--accordion__heading *::after {\n  box-sizing: inherit;\n}\n:host(c4d-footer-nav) .cds--accordion__heading::-moz-focus-inner {\n  border: 0;\n}\n:host(c4d-footer-nav) .cds--accordion__heading {\n  position: relative;\n  display: flex;\n  flex-direction: row-reverse;\n  align-items: center;\n  justify-content: flex-start;\n  margin: 0;\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  min-block-size: var(--cds-layout-size-height-local);\n  padding-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n:host(c4d-footer-nav) .cds--accordion__heading:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion__heading:focus {\n  position: relative;\n  z-index: 2;\n  box-shadow: 0 -1px 0 0 var(--cds-focus, #0f62fe), inset 0 1px 0 0 var(--cds-focus, #0f62fe), inset 2px 0 0 0 var(--cds-focus, #0f62fe), 0 1px 0 0 var(--cds-focus, #0f62fe), inset 0 -1px 0 0 var(--cds-focus, #0f62fe), inset -2px 0 0 0 var(--cds-focus, #0f62fe);\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion__heading[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n:host(c4d-footer-nav) .cds--accordion__heading[disabled] .cds--accordion__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n:host(c4d-footer-nav) .cds--accordion__heading[disabled]:hover::before {\n  background-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion__item--disabled,\n:host(c4d-footer-nav) .cds--accordion__item--disabled + .cds--accordion__item {\n  border-block-start: 1px solid var(--cds-border-subtle);\n}\n:host(c4d-footer-nav) li.cds--accordion__item--disabled:last-of-type {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n:host(c4d-footer-nav) .cds--accordion__arrow {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  transition: all 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion__arrow {\n  flex: 0 0 1rem;\n  block-size: 1rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1rem;\n  transform: rotate(-270deg) /*rtl:ignore*/;\n}\n:host(c4d-footer-nav) .cds--accordion__title {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion__title {\n  z-index: 1;\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n  text-align: start;\n}\n:host(c4d-footer-nav) .cds--accordion__wrapper {\n  overflow: hidden;\n  padding: 0;\n  max-block-size: 0;\n  opacity: 0;\n  transition: all 110ms cubic-bezier(0, 0, 0.38, 0.9);\n  writing-mode: horizontal-tb;\n}\n:host(c4d-footer-nav) .cds--accordion__content {\n  padding-inline: var(--cds-layout-density-padding-inline-local);\n}\n@media (min-width: 480px) {\n  :host(c4d-footer-nav) .cds--accordion__content {\n    padding-inline-end: 3rem;\n  }\n}\n@media (min-width: 640px) {\n  :host(c4d-footer-nav) .cds--accordion__content {\n    padding-inline-end: 25%;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion__content > p {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__heading {\n  flex-direction: row;\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__arrow {\n  margin: 2px 0 0 var(--cds-layout-density-padding-inline-local);\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 1rem;\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__content {\n  margin-inline-start: calc(var(--cds-layout-density-padding-inline-local) + 1rem);\n}\n:host(c4d-footer-nav) .cds--accordion__item--collapsing .cds--accordion__content,\n:host(c4d-footer-nav) .cds--accordion__item--expanding .cds--accordion__content {\n  display: block;\n}\n:host(c4d-footer-nav) .cds--accordion__item--active, :host(c4d-footer-nav) :host(c4d-footer-nav-group[open]) {\n  overflow: visible;\n}\n:host(c4d-footer-nav) .cds--accordion__item--active > .cds--accordion__wrapper, :host(c4d-footer-nav) :host(c4d-footer-nav-group[open]) > .cds--accordion__wrapper {\n  overflow: visible;\n  max-block-size: -moz-fit-content;\n  max-block-size: fit-content;\n  opacity: 1;\n  padding-block: 0.5rem;\n  padding-block-end: 1.5rem;\n}\n:host(c4d-footer-nav) .cds--accordion__item--active > .cds--accordion__heading > .cds--accordion__arrow, :host(c4d-footer-nav) :host(c4d-footer-nav-group[open]) > .cds--accordion__heading > .cds--accordion__arrow {\n  fill: var(--cds-icon-primary, #161616);\n  transform: rotate(-90deg) /*rtl:ignore*/;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item {\n  position: relative;\n  border-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:last-child, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:hover, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:last-child:hover, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:hover + .cds--accordion__item {\n  border-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::after {\n  position: absolute;\n  display: block;\n  block-size: 1px;\n  content: \"\";\n  inline-size: calc(100% - 1rem - 1rem);\n  margin-inline-start: 1rem;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::after {\n    transition: none;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::before {\n  background: var(--cds-border-subtle);\n  inset-block-start: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:last-child::after {\n  background: var(--cds-border-subtle);\n  inset-block-end: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover {\n  position: relative;\n  z-index: 1;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::after {\n  position: absolute;\n  display: block;\n  background: var(--cds-layer-hover);\n  block-size: 1px;\n  content: \"\";\n  inline-size: 100%;\n  inset-inline-start: 0;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::after {\n    transition: none;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::before {\n  inset-block-start: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::after {\n  inset-block-end: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover:focus::after, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover:focus::before {\n  background: none;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__heading,\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__button {\n  cursor: default;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow {\n  cursor: default;\n  fill: var(--cds-icon-primary, #161616);\n  pointer-events: none;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow:hover, :host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow:focus, :host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__heading:hover::before,\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__heading:hover {\n  background-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion--end.cds--skeleton .cds--accordion__arrow {\n  margin-inline-start: 1rem;\n}\n:host(c4d-footer-nav) .cds--skeleton .cds--accordion__heading:focus .cds--accordion__arrow {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion__title.cds--skeleton__text {\n  margin-block-end: 0;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__title {\n  margin-inline-start: 1rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  :host(c4d-footer-nav) .cds--accordion__arrow,\n  :host(c4d-footer-nav) .cds--accordion__item--active .cds--accordion__arrow {\n    fill: ButtonText;\n  }\n}\n:host(c4d-footer-nav) [dir=rtl] .cds--accordion--start .cds--accordion__heading {\n  padding-inline-end: 0;\n  padding-inline-start: var(--cds-layout-density-padding-inline-local);\n}\n:host(c4d-footer-nav) [dir=rtl] .cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 0;\n  padding-inline-start: 0;\n}\n.cds--row--condensed :host(c4d-footer-nav), .cds--grid--condensed :host(c4d-footer-nav) {\n  padding-inline: 0.03125rem;\n}\n.cds--row--narrow :host(c4d-footer-nav), .cds--grid--narrow :host(c4d-footer-nav) {\n  padding-inline: 0 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-nav) {\n    padding: 0 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-nav) {\n    display: block;\n    flex: 0 0 75%;\n    max-inline-size: 75%;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion__heading {\n  display: flex;\n  align-items: center;\n  padding: 0;\n  min-block-size: 3rem;\n}\n:host(c4d-footer-nav) ::slotted([slot=locale-button]),\n:host(c4d-footer-nav) ::slotted([slot=language-selector]) {\n  display: inline-block;\n  inline-size: 100%;\n  margin-inline-start: 0;\n  max-inline-size: 100%;\n}\n\n:host(c4d-footer-nav[disable-locale-button]),\nnav.cds--footer-nav__locale-button--disabled {\n  border-block-start: none;\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-nav[disable-locale-button]),\n  nav.cds--footer-nav__locale-button--disabled {\n    padding-block-start: 0;\n    margin-inline-start: 12.5%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--footer-nav__container {\n    display: flex;\n    flex-wrap: wrap;\n    margin-inline: -1rem;\n    display: block;\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 2rem;\n         column-gap: 2rem;\n    margin-inline: 0;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--footer-nav__container {\n    -moz-column-count: 3;\n         column-count: 3;\n    -moz-column-gap: 2rem;\n         column-gap: 2rem;\n  }\n}\n\n:host(c4d-footer[size=short]) ::slotted(c4d-footer-nav),\n.cds--footer--short .cds--footer-nav {\n  display: none;\n}\n\n:host(c4d-footer-nav-group),\n.cds--footer-nav-group,\n.cds--footer-nav-group.cds--accordion__item {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: block;\n  padding-inline-start: 0;\n}\n:host(c4d-footer-nav-group):last-child,\n.cds--footer-nav-group:last-child,\n.cds--footer-nav-group.cds--accordion__item:last-child {\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  margin-block-end: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-nav-group):last-child,\n  .cds--footer-nav-group:last-child,\n  .cds--footer-nav-group.cds--accordion__item:last-child {\n    border-block-end: none;\n  }\n}\n:host(c4d-footer-nav-group) .cds--accordion__content,\n.cds--footer-nav-group .cds--accordion__content,\n.cds--footer-nav-group.cds--accordion__item .cds--accordion__content {\n  padding-inline: 0;\n}\n:host(c4d-footer-nav-group) .cds--accordion__content ul,\n.cds--footer-nav-group .cds--accordion__content ul,\n.cds--footer-nav-group.cds--accordion__item .cds--accordion__content ul {\n  margin: 0;\n  list-style: none;\n  padding-inline-start: 0;\n}\n:host(c4d-footer-nav-group) .cds--accordion__arrow,\n.cds--footer-nav-group .cds--accordion__arrow,\n.cds--footer-nav-group.cds--accordion__item .cds--accordion__arrow {\n  margin: 2px 1rem 0 0;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-nav-group),\n  .cds--footer-nav-group,\n  .cds--footer-nav-group.cds--accordion__item {\n    inline-size: 100%;\n    padding-inline: 1rem;\n    display: inline-block;\n    margin-block-end: 3rem;\n    padding-inline-start: 0;\n  }\n  .cds--row--condensed :host(c4d-footer-nav-group), .cds--grid--condensed :host(c4d-footer-nav-group),\n  .cds--row--condensed .cds--footer-nav-group,\n  .cds--grid--condensed .cds--footer-nav-group,\n  .cds--row--condensed .cds--footer-nav-group.cds--accordion__item,\n  .cds--grid--condensed .cds--footer-nav-group.cds--accordion__item {\n    padding-inline: 0.03125rem;\n  }\n  .cds--row--narrow :host(c4d-footer-nav-group), .cds--grid--narrow :host(c4d-footer-nav-group),\n  .cds--row--narrow .cds--footer-nav-group,\n  .cds--grid--narrow .cds--footer-nav-group,\n  .cds--row--narrow .cds--footer-nav-group.cds--accordion__item,\n  .cds--grid--narrow .cds--footer-nav-group.cds--accordion__item {\n    padding-inline: 0 1rem;\n  }\n  :host(c4d-footer-nav-group).cds--accordion__item,\n  .cds--footer-nav-group.cds--accordion__item,\n  .cds--footer-nav-group.cds--accordion__item.cds--accordion__item {\n    border-block-start: 0 transparent;\n  }\n  :host(c4d-footer-nav-group) .cds--accordion__heading,\n  .cds--footer-nav-group .cds--accordion__heading,\n  .cds--footer-nav-group.cds--accordion__item .cds--accordion__heading {\n    display: none;\n  }\n  :host(c4d-footer-nav-group) .cds--accordion__content,\n  .cds--footer-nav-group .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item .cds--accordion__content {\n    display: block;\n    block-size: auto;\n    opacity: 1;\n    visibility: visible;\n  }\n  :host(c4d-footer-nav-group) .cds--accordion__content, :host(c4d-footer-nav-group).cds--accordion__item--active .cds--accordion__content,\n  .cds--footer-nav-group .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item--active .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item.cds--accordion__item--active .cds--accordion__content {\n    padding: 0;\n  }\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-footer-nav-group:not([open])) .cds--accordion__content {\n    display: none;\n  }\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-footer-nav-item) .cds--link,\n  .cds--footer-nav-group .cds--link {\n    display: block;\n    padding: 1rem;\n    margin-block-start: 0;\n  }\n  :host(c4d-footer-nav-item) .cds--link:hover, :host(c4d-footer-nav-item) .cds--link:active,\n  .cds--footer-nav-group .cds--link:hover,\n  .cds--footer-nav-group .cds--link:active {\n    text-decoration: none;\n  }\n  :host(c4d-footer-nav-item) .cds--link:hover,\n  .cds--footer-nav-group .cds--link:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  :host(c4d-footer-nav-item) .cds--link:active,\n  .cds--footer-nav-group .cds--link:active {\n    background-color: var(--cds-layer-active-01, #c6c6c6);\n  }\n  :host(c4d-footer-nav-item) .cds--link:focus,\n  .cds--footer-nav-group .cds--link:focus {\n    box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n    outline-width: 0;\n  }\n}\n\n.cds--footer-nav-group__title {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n  display: none;\n}\n\n.cds--footer-nav-group__link {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n\n@media (min-width: 42rem) {\n  .cds--footer-nav-group__title {\n    display: block;\n    margin: 0;\n  }\n  :host(c4d-footer-nav-item),\n  .cds--footer-nav-group__item {\n    margin-block-start: 0.5rem;\n  }\n}\n.cds--language-selector__container {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  order: 0;\n  margin: 3rem 0;\n  padding-inline: 0;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--language-selector__container .cds--combo-box:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--combo-box.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--combo-box .cds--text-input::-ms-clear {\n  display: none;\n}\n.cds--language-selector__container .cds--combo-box.cds--list-box--expanded .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--combo-box--input--focus.cds--text-input {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--combo-box--input--focus.cds--text-input {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--combo-box.cds--list-box--expanded:has(input[aria-activedescendant]:not([aria-activedescendant=\"\"])) .cds--combo-box--input--focus.cds--text-input {\n  outline-offset: -0.0625rem;\n  outline-width: 0.0625rem;\n}\n.cds--language-selector__container .cds--combo-box .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box--warning .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box--disabled.cds--list-box--warning .cds--list-box__field {\n  padding: 0;\n}\n.cds--language-selector__container .cds--combo-box--readonly,\n.cds--language-selector__container .cds--combo-box--readonly:hover {\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--combo-box--readonly .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__menu-icon,\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__selection {\n  cursor: default;\n}\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__menu-icon svg,\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__selection svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0.25rem;\n  grid-template: auto auto/auto auto;\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--label,\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form__helper-text,\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form__helper-text {\n  max-inline-size: none;\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n.cds--language-selector__container .cds--list-box {\n  position: relative;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  max-block-size: 2.5rem;\n  transition: all 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--list-box html {\n  font-size: 100%;\n}\n.cds--language-selector__container .cds--list-box body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--language-selector__container .cds--list-box code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--language-selector__container .cds--list-box strong {\n  font-weight: 600;\n}\n.cds--language-selector__container .cds--list-box:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--list-box--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n.cds--language-selector__container .cds--list-box--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n.cds--language-selector__container .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box--expanded:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--list-box--expanded:hover.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--list-box .cds--text-input {\n  block-size: 100%;\n  min-inline-size: 0;\n}\n.cds--language-selector__container .cds--list-box__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--list-box__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n.cds--language-selector__container .cds--list-box__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--list-box.cds--list-box--warning .cds--list-box__field {\n  border-block-end: 0;\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field,\n.cds--language-selector__container .cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 3.5rem;\n}\n.cds--language-selector__container .cds--list-box--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--list-box--light:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu {\n  background: var(--cds-layer);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--list-box--light.cds--list-box--expanded {\n  border-block-end-color: transparent;\n}\n.cds--language-selector__container .cds--list-box--disabled:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--list-box--light.cds--list-box--disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--list-box--disabled,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__field,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__field:focus {\n  border-block-end-color: transparent;\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__label,\n.cds--language-selector__container .cds--list-box--disabled.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-icon > svg,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__field,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item--highlighted {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  text-decoration: none;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection:hover {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field {\n  padding-inline-end: 3rem;\n}\n.cds--language-selector__container .cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline {\n  border-width: 0;\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--expanded {\n  border-block-end-width: 0;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true] {\n  border-width: 0;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover,\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover {\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__field {\n  padding: 0 2rem 0 0.5rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__menu-icon {\n  inset-inline-end: 0.5rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon {\n  inset-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--inline .cds--list-box__field {\n  block-size: 100%;\n}\n.cds--language-selector__container .cds--dropdown--inline .cds--list-box__field {\n  max-inline-size: 30rem;\n}\n.cds--language-selector__container .cds--dropdown--inline .cds--list-box__menu {\n  max-inline-size: 30rem;\n  min-inline-size: 18rem;\n}\n.cds--language-selector__container .cds--list-box__field {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  overflow: hidden;\n  align-items: center;\n  block-size: calc(100% + 1px);\n  cursor: pointer;\n  outline: none;\n  padding-block: 0;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  vertical-align: top;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box__field *,\n.cds--language-selector__container .cds--list-box__field *::before,\n.cds--language-selector__container .cds--list-box__field *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__field::-moz-focus-inner {\n  border: 0;\n}\n.cds--language-selector__container .cds--list-box__field:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__field:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__field[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__field .cds--text-input {\n  padding-inline-end: 5rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input {\n  padding-inline-end: 6.5625rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon {\n  inset-inline-end: 5.125rem;\n}\n.cds--language-selector__container .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 3rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--list-box__label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  overflow: hidden;\n  color: var(--cds-text-primary, #161616);\n  text-overflow: ellipsis;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box__menu-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-inline-end: 0.75rem;\n  outline: none;\n  transition: transform 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--list-box__menu-icon *,\n.cds--language-selector__container .cds--list-box__menu-icon *::before,\n.cds--language-selector__container .cds--list-box__menu-icon *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__menu-icon::-moz-focus-inner {\n  border: 0;\n}\n.cds--language-selector__container .cds--list-box__menu-icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box__menu-icon--open {\n  justify-content: center;\n  inline-size: 1.5rem;\n  transform: rotate(180deg);\n}\n.cds--language-selector__container .cds--list-box__selection {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-block-start: 50%;\n  /* to preserve .5rem space between icons according to spec top/transform used to center the combobox clear selection icon in IE11 */\n  inset-inline-end: 2.8125rem;\n  transform: translateY(-50%);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--language-selector__container .cds--list-box__selection *,\n.cds--language-selector__container .cds--list-box__selection *::before,\n.cds--language-selector__container .cds--list-box__selection *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__selection::-moz-focus-inner {\n  border: 0;\n}\n.cds--language-selector__container .cds--list-box__selection:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__selection:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__selection:focus:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__selection:focus:hover {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__selection > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection:focus {\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__selection--multi {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  position: static;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding: 0.5rem;\n  border-radius: 0.75rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: 1.5rem;\n  color: var(--cds-text-inverse, #ffffff);\n  inline-size: auto;\n  inset-block-start: auto;\n  line-height: 0;\n  margin-inline-end: 0.625rem;\n  padding-inline-end: 0.125rem;\n  transform: none;\n}\n.cds--language-selector__container .cds--list-box__selection--multi > svg {\n  padding: 0.125rem;\n  block-size: 1.25rem;\n  fill: var(--cds-icon-inverse, #ffffff);\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n.cds--language-selector__container .cds--list-box__selection--multi > svg:hover {\n  border-radius: 50%;\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  color: var(--cds-layer);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational {\n  border: 1px solid var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi > svg:hover {\n  background-color: initial;\n}\n.cds--language-selector__container .cds--list-box__selection--multi:hover {\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__menu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  position: absolute;\n  z-index: 9100;\n  display: none;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--list-box__menu:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__menu:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu {\n  display: none;\n  max-block-size: 0;\n  visibility: hidden;\n}\n.cds--language-selector__container .cds--list-box--expanded .cds--list-box__menu {\n  display: block;\n  max-block-size: 13.75rem;\n}\n.cds--language-selector__container .cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu {\n  max-block-size: 16.5rem;\n}\n.cds--language-selector__container .cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu {\n  max-block-size: 11rem;\n}\n.cds--language-selector__container .cds--list-box__menu-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  block-size: 2.5rem;\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  transition: background 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--language-selector__container .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--language-selector__container .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--language-selector__container .cds--list-box--sm .cds--list-box__menu-item {\n  block-size: 2rem;\n}\n.cds--language-selector__container .cds--list-box--lg .cds--list-box__menu-item {\n  block-size: 3rem;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover {\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__menu-item:hover .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box__menu-item__option {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-end: 1px solid transparent;\n  border-block-start: 1px solid transparent;\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  padding-inline-end: 1.5rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  transition: border-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box__menu-item__option *,\n.cds--language-selector__container .cds--list-box__menu-item__option *::before,\n.cds--language-selector__container .cds--list-box__menu-item__option *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__menu-item__option:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  border-color: transparent;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__menu-item__option:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__menu-item__option:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--sm .cds--list-box__menu-item__option {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n.cds--language-selector__container .cds--list-box--lg .cds--list-box__menu-item__option {\n  block-size: 3rem;\n  padding-block-end: 0.9375rem;\n  padding-block-start: 0.9375rem;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item__option {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled],\n.cds--language-selector__container .cds--list-box__menu-item[disabled] *,\n.cds--language-selector__container .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item[disabled]:hover {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled]:hover {\n  background-color: revert;\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled] .cds--checkbox-label::before {\n  border-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--layer-two .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--layer-three .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active + .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option {\n  margin: 0 0.5rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus {\n  margin: 0;\n  padding-inline-end: 0.5rem;\n  padding-inline-start: 0.5rem;\n}\n.cds--language-selector__container .cds--list-box__menu-item--highlighted {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__menu-item--highlighted {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item--highlighted + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover);\n  border-block-end-color: var(--cds-layer-selected-hover);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active + .cds--list-box__menu-item > .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__menu-item__selected-icon {\n  position: absolute;\n  display: none;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--list-box--inline .cds--list-box__menu-item__selected-icon {\n  inset-inline-end: 0.5rem;\n}\n.cds--language-selector__container .cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n.cds--language-selector__container .cds--list-box__menu-item .cds--checkbox-label {\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--list-box__menu-item .cds--checkbox-label-text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box--up .cds--list-box__menu {\n  inset-block-end: 2.5rem;\n}\n.cds--language-selector__container .cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up.cds--list-box--sm .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up .cds--list-box--sm .cds--list-box__menu {\n  inset-block-end: 2rem;\n}\n.cds--language-selector__container .cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up.cds--list-box--lg .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up .cds--list-box--lg .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n.cds--language-selector__container .cds--list-box input[role=combobox],\n.cds--language-selector__container .cds--list-box input[type=text] {\n  background-color: inherit;\n  min-inline-size: 0;\n  text-overflow: ellipsis;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 9px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::after,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: -0.5625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: -0.5625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box input[role=combobox] {\n  border-block-end-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box__field,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 6rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field {\n  padding-inline-end: 6rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 8.8125rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning {\n  inset-inline-end: 5.1875rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before {\n  display: block;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug {\n  inset-inline-end: calc(4rem + 18px);\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon {\n  inset-inline-end: 7.25rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--list-box__field,\n  .cds--language-selector__container .cds--list-box__menu,\n  .cds--language-selector__container .cds--multi-select .cds--tag--filter {\n    outline: 1px solid transparent;\n  }\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--list-box__field:focus,\n  .cds--language-selector__container .cds--multi-select .cds--tag__close-icon:focus,\n  .cds--language-selector__container .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--list-box__menu-icon > svg,\n  .cds--language-selector__container .cds--list-box__selection > svg,\n  .cds--language-selector__container .cds--list-box__selection--multi > svg {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-start: 2.0625rem;\n}\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,\n.cds--language-selector__container .cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-end: 2.0625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n.cds--language-selector__container .cds--select {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select *,\n.cds--language-selector__container .cds--select *::before,\n.cds--language-selector__container .cds--select *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--select-input__wrapper {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select-input {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  border: none;\n  border-radius: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  font-family: inherit;\n  inline-size: 100%;\n  opacity: 1;\n  padding-block: 0;\n  padding-inline: 1rem 3rem;\n  text-overflow: ellipsis;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--select-input::-ms-expand {\n  display: none;\n}\n@-moz-document url-prefix() {\n  .cds--language-selector__container .cds--select-input:-moz-focusring, .cds--language-selector__container .cds--select-input::-moz-focus-inner {\n    background-image: none;\n    color: transparent;\n    text-shadow: 0 0 0 #000000;\n  }\n}\n.cds--language-selector__container .cds--select-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--select-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--select-input:disabled, .cds--language-selector__container .cds--select-input:hover:disabled {\n  background-color: var(--cds-field);\n  border-block-end-color: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select-input--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n.cds--language-selector__container .cds--select-input--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n.cds--language-selector__container .cds--select--disabled .cds--label,\n.cds--language-selector__container .cds--select--disabled .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select-input__wrapper[data-invalid] .cds--select-input,\n.cds--language-selector__container .cds--select--warning .cds--select-input {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--select-input:disabled ~ .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select--light .cds--select-input {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--select--light .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--select--light .cds--select-input:disabled, .cds--language-selector__container .cds--select--light .cds--select-input:hover:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select__arrow {\n  position: absolute;\n  block-size: 100%;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--select__arrow path {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--select__invalid-icon {\n  position: absolute;\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon {\n  fill: var(--cds-support-error, #da1e28);\n}\n.cds--language-selector__container .cds--select__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n.cds--language-selector__container .cds--select__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n.cds--language-selector__container optgroup.cds--select-optgroup,\n.cds--language-selector__container .cds--select-option {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container optgroup.cds--select-optgroup:disabled,\n.cds--language-selector__container .cds--select-option:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select--inline {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--label,\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--form__helper-text {\n  align-self: flex-start;\n  margin-block-start: 0.8125rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--form__helper-text {\n  margin-block-end: 0;\n  margin-inline-start: 0.5rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--label {\n  margin: 0 0.5rem 0 0;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input {\n  background-color: transparent;\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: auto;\n  padding-inline-end: 2rem;\n  padding-inline-start: 0.5rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input:focus,\n.cds--language-selector__container .cds--select--inline .cds--select-input:focus option,\n.cds--language-selector__container .cds--select--inline .cds--select-input:focus optgroup {\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input[disabled],\n.cds--language-selector__container .cds--select--inline .cds--select-input[disabled]:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--select--inline .cds--select__arrow {\n  inset-inline-end: 0.5rem;\n}\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--select-input {\n  padding-inline-end: 3.5rem;\n}\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input:disabled ~ * {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select--readonly .cds--select-input {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n  cursor: default;\n}\n.cds--language-selector__container .cds--select--readonly .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 2.5rem;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select.cds--skeleton:hover, .cds--language-selector__container .cds--select.cds--skeleton:focus, .cds--language-selector__container .cds--select.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--language-selector__container .cds--select.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--language-selector__container .cds--select.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--language-selector__container .cds--select.cds--skeleton .cds--select-input {\n  display: none;\n}\n.cds--language-selector__container .cds--select--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 8px + 1px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--select--slug .cds--slug::after,\n.cds--language-selector__container .cds--select--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n.cds--language-selector__container .cds--select--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: calc(-0.5rem - 1px);\n}\n.cds--language-selector__container .cds--select--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: calc(-0.5rem - 1px);\n}\n.cds--language-selector__container .cds--select--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n.cds--language-selector__container .cds--select--slug .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  padding-inline-end: 6rem;\n}\n.cds--language-selector__container .cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before {\n  display: block;\n}\n.cds--language-selector__container .cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon,\n.cds--language-selector__container .cds--select--slug .cds--select-input__wrapper .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--select__arrow {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--text-input *,\n.cds--language-selector__container .cds--text-input *::before,\n.cds--language-selector__container .cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--text-input:focus, .cds--language-selector__container .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input:focus, .cds--language-selector__container .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n.cds--language-selector__container .cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n.cds--language-selector__container .cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n.cds--language-selector__container .cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--language-selector__container .cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--language-selector__container .cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--language-selector__container .cds--text-input--password__visibility:hover::before, .cds--language-selector__container .cds--text-input--password__visibility:hover::after, .cds--language-selector__container .cds--text-input--password__visibility:focus::before, .cds--language-selector__container .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--language-selector__container .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--language-selector__container .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n.cds--language-selector__container .cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n.cds--language-selector__container .cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--language-selector__container .cds--text-input--invalid,\n.cds--language-selector__container .cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n.cds--language-selector__container .cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n.cds--language-selector__container .cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--language-selector__container .cds--skeleton.cds--text-input:hover, .cds--language-selector__container .cds--skeleton.cds--text-input:focus, .cds--language-selector__container .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--language-selector__container .cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--language-selector__container .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n.cds--language-selector__container .cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n.cds--language-selector__container .cds--text-input__divider,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input--invalid,\n.cds--language-selector__container .cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--language-selector__container .cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n.cds--language-selector__container .cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n.cds--language-selector__container .cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n.cds--language-selector__container .cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n.cds--language-selector__container .cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n.cds--language-selector__container .cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--language-selector__container .cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--invalid:has(~ .cds--slug),\n.cds--language-selector__container .cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--text-input--invalid ~ .cds--slug,\n.cds--language-selector__container .cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--language-selector__container .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n@media (max-width: 41.98rem) {\n  .cds--language-selector__container {\n    inline-size: 100%;\n    padding-inline: 1rem;\n  }\n  .cds--row--condensed .cds--language-selector__container, .cds--grid--condensed .cds--language-selector__container {\n    padding-inline: 0.03125rem;\n  }\n  .cds--row--narrow .cds--language-selector__container, .cds--grid--narrow .cds--language-selector__container {\n    padding-inline: 0 1rem;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--language-selector__container {\n    margin-block-start: 0;\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-inline-start: 25%;\n  }\n}\n.cds--language-selector__container .cds--language-selector {\n  block-size: 3rem;\n  inline-size: 100%;\n  margin-inline-end: 0;\n  max-inline-size: 100%;\n}\n.cds--language-selector__container .cds--language-selector .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n.cds--language-selector__container .cds--language-selector .cds--list-box__selection {\n  inset-inline-end: 2.25rem;\n}\n.cds--language-selector__container .cds--language-selector .cds--list-box__field {\n  block-size: inherit;\n}\n@media (min-width: 42rem) {\n  .cds--language-selector__container .cds--language-selector {\n    min-inline-size: 13.5rem;\n  }\n  .cds--footer--short .cds--language-selector__container .cds--language-selector {\n    float: inline-end;\n  }\n}\n.cds--language-selector__container .cds--language-selector .cds--text-input,\n.cds--language-selector__container .cds--language-selector .cds--list-box__menu-item__option {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--footer--short .cds--language-selector__container {\n  margin-block-start: 0;\n}\n@media (min-width: 42rem) {\n  .cds--language-selector__container {\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-block-end: 1rem;\n  }\n  .cds--footer--short .cds--language-selector__container {\n    margin-inline-start: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--language-selector__container {\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: 62.5%;\n    order: 1;\n  }\n  .cds--footer--short .cds--language-selector__container {\n    margin-inline-start: 62.5%;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--footer--short .cds--language-selector__container {\n    margin-inline-start: 68.75%;\n  }\n}\n.cds--language-selector__container .cds--list-box--up .cds--list-box__menu {\n  z-index: 1;\n  inset-block-end: 2.9375rem;\n}\n.cds--language-selector__container .cds--select-input__wrapper {\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select-input__wrapper .cds--select-input {\n  block-size: 3rem;\n  inline-size: 100%;\n  max-inline-size: 100%;\n}\n.cds--language-selector__container .cds--form-item {\n  display: block;\n}\n@media (min-width: 66rem) {\n  .cds--language-selector__container .cds--form-item {\n    display: none;\n  }\n}\n.cds--language-selector__container .cds--list-box__wrapper {\n  display: none;\n}\n@media (min-width: 66rem) {\n  .cds--language-selector__container .cds--list-box__wrapper {\n    display: block;\n  }\n}\n.cds--language-selector__container .cds--label {\n  display: block;\n  padding: 0;\n  margin: 0;\n  block-size: 0;\n  visibility: hidden;\n}\n\n:host(c4d-legal-nav) {\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav) {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-legal-nav) {\n    padding-inline: 2.5rem;\n  }\n}\n\n.c4d--legal-nav {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n}\n@media (max-width: 41.98rem) {\n  .cds--footer:not(.cds--footer--short) .c4d--legal-nav {\n    border-block-start: 0;\n  }\n}\n\n.c4d--adjunct-links__container,\n.c4d--legal-nav__list {\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n}\n.c4d--adjunct-links__container ul,\n.c4d--legal-nav__list ul {\n  padding: 0;\n  margin: 0;\n  list-style: none;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container,\n  .c4d--legal-nav__list {\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container,\n  .c4d--legal-nav__list {\n    margin-inline-start: 25%;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro,\n.c4d--legal-nav__list.c4d--legal-nav__micro {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: flex;\n  flex-direction: column-reverse;\n  margin-inline-end: 0;\n  padding-block-end: 0;\n  padding-inline-start: 0;\n}\n@media (max-width: 41.98rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro ::slotted([slot=locale]),\n  .c4d--adjunct-links__container.c4d--legal-nav__micro ::slotted([slot=brand]),\n  .c4d--legal-nav__list.c4d--legal-nav__micro ::slotted([slot=locale]),\n  .c4d--legal-nav__list.c4d--legal-nav__micro ::slotted([slot=brand]) {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro,\n  .c4d--legal-nav__list.c4d--legal-nav__micro {\n    padding-inline-start: 0;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro,\n  .c4d--legal-nav__list.c4d--legal-nav__micro {\n    flex-direction: row;\n    justify-content: space-between;\n    margin-inline-start: 0;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder {\n  padding: 0 1rem;\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  -moz-column-count: inherit;\n       column-count: inherit;\n  margin-inline-start: 0;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder {\n    display: flex;\n    align-items: center;\n    padding: 0 1rem 0;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder {\n    border-block-start: none;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item {\n  display: flex;\n  align-items: center;\n  block-size: 3rem;\n  margin-inline-end: 0;\n  padding-block-start: 0;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item {\n    margin-inline-end: 2rem;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item a,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item a {\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container {\n  margin: 0;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container {\n    align-self: flex-end;\n    border-inline-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    inline-size: 50%;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container {\n    margin: 0;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input {\n  background-color: var(--cds-background, #ffffff);\n  max-inline-size: 100%;\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:active {\n  background-color: var(--cds-layer-active-01, #c6c6c6);\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select {\n  max-inline-size: 100%;\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--text-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--text-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--text-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--text-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input {\n  border-block-end: none;\n}\n\n.cds--legal-nav__holder {\n  margin-inline-start: 0;\n  padding-block-start: 0;\n}\n@media (min-width: 42rem) {\n  .cds--legal-nav__holder {\n    -moz-column-count: 2;\n         column-count: 2;\n    padding-block-start: 0.5rem;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--legal-nav__holder {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n\n.cds--adjunct-links__holder {\n  padding: 0 3rem 0 1rem;\n  inline-size: 100%;\n  margin-block-start: 3rem;\n  margin-inline-start: 0;\n}\n@media (min-width: 42rem) {\n  .cds--adjunct-links__holder {\n    inline-size: 50%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--adjunct-links__holder {\n    inline-size: 25%;\n    margin-inline-start: 25%;\n  }\n}\n.cds--adjunct-links__holder .cds--legal-nav__list-item {\n  margin-inline-end: 0;\n  padding-block-start: 0;\n}\n.cds--adjunct-links__holder .cds--legal-nav__list-item:not(:first-of-type) {\n  padding-block-start: 0.5rem;\n}\n\n:host(c4d-legal-nav-item),\n:host(c4d-legal-nav-cookie-preferences-placeholder),\n.cds--legal-nav__list-item {\n  padding: 0.5rem 0 0 0;\n  margin-inline-end: 2rem;\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-legal-nav-item):first-child,\n  :host(c4d-legal-nav-cookie-preferences-placeholder):first-child,\n  .cds--legal-nav__list-item:first-child {\n    padding-block-start: 0;\n  }\n}\n:host(c4d-legal-nav-item):last-child,\n:host(c4d-legal-nav-cookie-preferences-placeholder):last-child,\n.cds--legal-nav__list-item:last-child {\n  margin-inline-end: 0;\n}\n\n:host(c4d-locale-button),\n.cds--locale-btn__container {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  inline-size: 100%;\n  padding-inline: 1rem;\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n  margin: 3rem 0;\n}\n:host(c4d-locale-button) .cds--btn,\n.cds--locale-btn__container .cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n:host(c4d-locale-button) .cds--btn *,\n:host(c4d-locale-button) .cds--btn *::before,\n:host(c4d-locale-button) .cds--btn *::after,\n.cds--locale-btn__container .cds--btn *,\n.cds--locale-btn__container .cds--btn *::before,\n.cds--locale-btn__container .cds--btn *::after {\n  box-sizing: inherit;\n}\n:host(c4d-locale-button) .cds--btn:disabled, :host(c4d-locale-button) .cds--btn:hover:disabled, :host(c4d-locale-button) .cds--btn:focus:disabled, :host(c4d-locale-button) .cds--btn.cds--btn--disabled, :host(c4d-locale-button) .cds--btn.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn:disabled,\n.cds--locale-btn__container .cds--btn:hover:disabled,\n.cds--locale-btn__container .cds--btn:focus:disabled,\n.cds--locale-btn__container .cds--btn.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n:host(c4d-locale-button) .cds--btn .cds--btn__icon,\n.cds--locale-btn__container .cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n:host(c4d-locale-button) .cds--btn::-moz-focus-inner,\n.cds--locale-btn__container .cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n:host(c4d-locale-button) .cds--btn--primary,\n.cds--locale-btn__container .cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--primary:hover,\n.cds--locale-btn__container .cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n:host(c4d-locale-button) .cds--btn--primary:focus,\n.cds--locale-btn__container .cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--primary:active,\n.cds--locale-btn__container .cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n:host(c4d-locale-button) .cds--btn--primary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--primary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--primary:hover,\n.cds--locale-btn__container .cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--secondary,\n.cds--locale-btn__container .cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--secondary:hover,\n.cds--locale-btn__container .cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n:host(c4d-locale-button) .cds--btn--secondary:focus,\n.cds--locale-btn__container .cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--secondary:active,\n.cds--locale-btn__container .cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n:host(c4d-locale-button) .cds--btn--secondary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--secondary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--secondary:hover, :host(c4d-locale-button) .cds--btn--secondary:focus,\n.cds--locale-btn__container .cds--btn--secondary:hover,\n.cds--locale-btn__container .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary,\n.cds--locale-btn__container .cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:hover,\n.cds--locale-btn__container .cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:focus,\n.cds--locale-btn__container .cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:active,\n.cds--locale-btn__container .cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n:host(c4d-locale-button) .cds--btn--tertiary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--tertiary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--tertiary:hover,\n.cds--locale-btn__container .cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:focus,\n.cds--locale-btn__container .cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:active,\n.cds--locale-btn__container .cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:disabled, :host(c4d-locale-button) .cds--btn--tertiary:hover:disabled, :host(c4d-locale-button) .cds--btn--tertiary:focus:disabled, :host(c4d-locale-button) .cds--btn--tertiary.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--tertiary.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--tertiary.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--tertiary:disabled,\n.cds--locale-btn__container .cds--btn--tertiary:hover:disabled,\n.cds--locale-btn__container .cds--btn--tertiary:focus:disabled,\n.cds--locale-btn__container .cds--btn--tertiary.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--tertiary.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--ghost,\n.cds--locale-btn__container .cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n:host(c4d-locale-button) .cds--btn--ghost:hover,\n.cds--locale-btn__container .cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-locale-button) .cds--btn--ghost:focus,\n.cds--locale-btn__container .cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--ghost:active,\n.cds--locale-btn__container .cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n:host(c4d-locale-button) .cds--btn--ghost .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n:host(c4d-locale-button) .cds--btn--ghost:hover, :host(c4d-locale-button) .cds--btn--ghost:active,\n.cds--locale-btn__container .cds--btn--ghost:hover,\n.cds--locale-btn__container .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-locale-button) .cds--btn--ghost:active,\n.cds--locale-btn__container .cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n:host(c4d-locale-button) .cds--btn--ghost:disabled, :host(c4d-locale-button) .cds--btn--ghost:hover:disabled, :host(c4d-locale-button) .cds--btn--ghost:focus:disabled, :host(c4d-locale-button) .cds--btn--ghost.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--ghost.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--ghost.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--ghost:disabled,\n.cds--locale-btn__container .cds--btn--ghost:hover:disabled,\n.cds--locale-btn__container .cds--btn--ghost:focus:disabled,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--ghost:not([disabled]) svg,\n.cds--locale-btn__container .cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-locale-button) .cds--btn--icon-only,\n.cds--locale-btn__container .cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n:host(c4d-locale-button) .cds--btn--icon-only > :first-child,\n.cds--locale-btn__container .cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n:host(c4d-locale-button) .cds--btn--icon-only .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n:host(c4d-locale-button) .cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, :host(c4d-locale-button) .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n:host(c4d-locale-button) .cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n:host(c4d-locale-button) .cds--btn--icon-only.cds--btn--selected,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n:host(c4d-locale-button) .cds--btn path[data-icon-path=inner-path],\n.cds--locale-btn__container .cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--locale-btn__container .cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only[disabled],\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n:host(c4d-locale-button) .cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper,\n.cds--locale-btn__container .cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n:host(c4d-locale-button) .cds--icon-tooltip--disabled .cds--btn--icon-only[disabled],\n.cds--locale-btn__container .cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n:host(c4d-locale-button) .cds--btn--danger,\n.cds--locale-btn__container .cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger:hover,\n.cds--locale-btn__container .cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n:host(c4d-locale-button) .cds--btn--danger:focus,\n.cds--locale-btn__container .cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger:active,\n.cds--locale-btn__container .cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n:host(c4d-locale-button) .cds--btn--danger .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--danger .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--danger:hover,\n.cds--locale-btn__container .cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary,\n.cds--locale-btn__container .cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:hover,\n.cds--locale-btn__container .cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:focus,\n.cds--locale-btn__container .cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:active,\n.cds--locale-btn__container .cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--danger--tertiary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:hover,\n.cds--locale-btn__container .cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:focus,\n.cds--locale-btn__container .cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:active,\n.cds--locale-btn__container .cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary:hover:disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary:focus:disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--danger--tertiary.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--danger--tertiary:disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary:hover:disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary:focus:disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost,\n.cds--locale-btn__container .cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:hover,\n.cds--locale-btn__container .cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:focus,\n.cds--locale-btn__container .cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:active,\n.cds--locale-btn__container .cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--danger--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:hover, :host(c4d-locale-button) .cds--btn--danger--ghost:active,\n.cds--locale-btn__container .cds--btn--danger--ghost:hover,\n.cds--locale-btn__container .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:disabled, :host(c4d-locale-button) .cds--btn--danger--ghost:hover:disabled, :host(c4d-locale-button) .cds--btn--danger--ghost:focus:disabled, :host(c4d-locale-button) .cds--btn--danger--ghost.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--danger--ghost.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--danger--ghost.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--danger--ghost:disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost:hover:disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost:focus:disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--expressive,\n.cds--locale-btn__container .cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n:host(c4d-locale-button) .cds--btn--icon-only.cds--btn--expressive,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n:host(c4d-locale-button) .cds--btn.cds--btn--expressive .cds--btn__icon,\n.cds--locale-btn__container .cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--expressive,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n:host(c4d-locale-button) .cds--btn.cds--skeleton,\n.cds--locale-btn__container .cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n:host(c4d-locale-button) .cds--btn.cds--skeleton:hover, :host(c4d-locale-button) .cds--btn.cds--skeleton:focus, :host(c4d-locale-button) .cds--btn.cds--skeleton:active,\n.cds--locale-btn__container .cds--btn.cds--skeleton:hover,\n.cds--locale-btn__container .cds--btn.cds--skeleton:focus,\n.cds--locale-btn__container .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn.cds--skeleton::before,\n.cds--locale-btn__container .cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  :host(c4d-locale-button) .cds--btn.cds--skeleton::before,\n  .cds--locale-btn__container .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n:host(c4d-locale-button) .cds--btn-set,\n.cds--locale-btn__container .cds--btn-set {\n  display: flex;\n}\n:host(c4d-locale-button) .cds--btn-set--stacked,\n.cds--locale-btn__container .cds--btn-set--stacked {\n  flex-direction: column;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn,\n.cds--locale-btn__container .cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn:not(:focus),\n.cds--locale-btn__container .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn:first-of-type:not(:focus),\n.cds--locale-btn__container .cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn:focus + .cds--btn,\n.cds--locale-btn__container .cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn:not(:focus),\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn:first-of-type:not(:focus),\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--disabled:first-of-type,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type,\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--loading,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  :host(c4d-locale-button) .cds--btn:focus,\n  .cds--locale-btn__container .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  :host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  :host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,\n  .cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n:host(c4d-locale-button) [dir=rtl] .cds--btn-set .cds--btn:not(:focus),\n.cds--locale-btn__container [dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--row--condensed :host(c4d-locale-button), .cds--grid--condensed :host(c4d-locale-button),\n.cds--row--condensed .cds--locale-btn__container,\n.cds--grid--condensed .cds--locale-btn__container {\n  padding-inline: 0.03125rem;\n}\n.cds--row--narrow :host(c4d-locale-button), .cds--grid--narrow :host(c4d-locale-button),\n.cds--row--narrow .cds--locale-btn__container,\n.cds--grid--narrow .cds--locale-btn__container {\n  padding-inline: 0 1rem;\n}\n:host(c4d-locale-button) .c4d--locale-btn,\n.cds--locale-btn__container .c4d--locale-btn {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n  align-items: center;\n  inline-size: 100%;\n  max-inline-size: 100%;\n  padding-inline-end: 0.75rem;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media (min-width: 42rem) {\n  :host(c4d-locale-button) .c4d--locale-btn,\n  .cds--locale-btn__container .c4d--locale-btn {\n    min-inline-size: 13.5rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-locale-button),\n  .cds--locale-btn__container {\n    align-self: end;\n    margin-block: 0 4rem;\n    padding-inline: 0;\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-inline-start: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-button),\n  .cds--locale-btn__container {\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: 62.5%;\n  }\n}\n\n:host(c4d-footer[size=short]) ::slotted(c4d-locale-button),\n.cds--footer--short .cds--locale-btn__container {\n  margin-block-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=short]) ::slotted(c4d-locale-button),\n  .cds--footer--short .cds--locale-btn__container {\n    margin-block-start: 0;\n    margin-inline-start: 25%;\n  }\n  :host(c4d-footer[size=short]) ::slotted(c4d-locale-button) .cds--locale-btn,\n  .cds--footer--short .cds--locale-btn__container .cds--locale-btn {\n    float: inline-end;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer[size=short]) ::slotted(c4d-locale-button),\n  .cds--footer--short .cds--locale-btn__container {\n    margin-inline-start: 62.5%;\n  }\n}\n\n.cds--footer--micro .cds--locale-btn__container {\n  padding: 0;\n}\n.cds--footer--micro .cds--locale-btn__container .cds--btn--tertiary:hover, .cds--footer--micro .cds--locale-btn__container .cds--btn--tertiary:focus {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}"]);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/*
 * IMPORTANT: For compatibility with tsickle and the Closure JS compiler, all
 * property decorators (but not class decorators) in this file that have
 * an @ExportDecoratedItems annotation must be defined as a regular function,
 * not an arrow function.
 */

/**
 * Allow for custom element classes with private constructors
 */

const legacyCustomElement = (tagName, clazz) => {
  try {
    customElements.define(tagName, clazz);
  } catch (error) {
    console.warn(`Attempting to re-define ${tagName}`);
  }
  // Cast as any because TS doesn't recognize the return type as being a
  // subtype of the decorated class when clazz is typed as
  // `Constructor<HTMLElement>` for some reason.
  // `Constructor<HTMLElement>` is helpful to make sure the decorator is
  // applied to elements however.
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  return clazz;
};
const standardCustomElement = (tagName, descriptor) => {
  const {
    kind,
    elements
  } = descriptor;
  return {
    kind,
    elements,
    // This callback is called once the class is otherwise fully defined
    finisher(clazz) {
      try {
        customElements.define(tagName, clazz);
      } catch (error) {
        console.warn(`Attempting to re-define ${tagName}`);
      }
    }
  };
};

/**
 * Class decorator factory that defines the decorated class as a custom element.
 *
 * ```js
 * @customElement('my-element')
 * class MyElement extends LitElement {
 *   render() {
 *     return html``;
 *   }
 * }
 * ```
 *
 * @category Decorator
 * @param tagName The tag name of the custom element to define.
 */
const carbonElement = tagName => classOrDescriptor => typeof classOrDescriptor === 'function' ? legacyCustomElement(tagName, classOrDescriptor) : standardCustomElement(tagName, classOrDescriptor);

let _$Y = t => t,
  _t$_;
function _decorate$_(e, r, t, i) { var o = _getDecoratorsApi$_(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$_(s.d.map(_createElementDescriptor$_)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$_() { _getDecoratorsApi$_ = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$_(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$_(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$$(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$_(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$_(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$_(e) { var r, t = _toPropertyKey$$(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$_(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$_(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$_(o.descriptor) || _isDataDescriptor$_(i.descriptor)) { if (_hasDecorators$_(o) || _hasDecorators$_(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$_(o)) { if (_hasDecorators$_(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$_(o, i); } } else r.push(o); } return r; }
function _hasDecorators$_(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$_(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$_(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$$(t) { var i = _toPrimitive$$(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$$(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$_(r) { return _arrayWithHoles$$(r) || _iterableToArray$_(r) || _unsupportedIterableToArray$$(r) || _nonIterableRest$$(); }
function _nonIterableRest$$() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$$(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$$(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$$(r, a) : void 0; } }
function _arrayLikeToArray$$(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$_(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$$(r) { if (Array.isArray(r)) return r; }
function _superPropGet$E(t, e, r, o) { var p = _get$y(_getPrototypeOf$y(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$y() { return _get$y = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$y(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$y.apply(null, arguments); }
function _superPropBase$y(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$y(t));); return t; }
function _getPrototypeOf$y(t) { return _getPrototypeOf$y = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$y(t); }
const {
  prefix: prefix$C,
  stablePrefix: c4dPrefix$_
} = settings;

/**
 * The top-level element in footer.
 *
 * @element c4d-footer
 * @csspart main-section - The <section> container. Usage: `c4d-footer::part(main-section)`
 * @csspart main-container - The main container. Usage: `c4d-footer::part(main-container)`
 * @csspart logo-container - The logo container. Usage: `c4d-footer::part(logo-container)`
 * @csspart logo-row - The logo row. Usage: `c4d-footer::part(logo-row)`
 * @slot brand - The brand content.
 * @slot legal-nav - The legal nav content.
 * @slot locale-button - The locale button content.
 */
_decorate$_([carbonElement(`${c4dPrefix$_}-footer`)], function (_initialize, _StableSelectorMixin) {
  class C4DFooter extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooter,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return FOOTER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * Footer size.
       */

      /**
       * Update the CSS selectors depending on the locale button being rendered or not.
       */

      function connectedCallback() {
        this.setAttribute('role', 'contentinfo');
        if (!this.hasAttribute('aria-label')) {
          this.setAttribute('aria-label', 'footer');
        }
        _superPropGet$E(C4DFooter, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          disableLocaleButton
        } = this;
        const classes = {
          [`${prefix$C}--footer__logo-container`]: true,
          [`${prefix$C}--footer__locale-button--disabled`]: disableLocaleButton
        };
        return x(_t$_ || (_t$_ = _$Y`
      <section part="main-section" class="${0}--footer__main">
        <div part="main-container" class="${0}--footer__main-container">
          <div part="logo-container" class=${0}>
            <div part="logo-row" class="${0}--footer__logo-row">
              <slot name="brand"></slot>
              <slot name="locale-button"></slot>
              <slot name="language-selector"></slot>
              <slot></slot>
            </div>
          </div>
        </div>
      </section>
      <slot name="legal-nav"></slot>
    `), prefix$C, prefix$C, o$2(classes), prefix$C);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$_}--footer`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, StableSelectorMixin(s));

function _arrayWithHoles$_(r) {
  if (Array.isArray(r)) return r;
}

function _iterableToArray$Z(r) {
  if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
}

function _arrayLikeToArray$_(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}

function _unsupportedIterableToArray$_(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray$_(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$_(r, a) : void 0;
  }
}

function _nonIterableRest$_() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toArray$Z(r) {
  return _arrayWithHoles$_(r) || _iterableToArray$Z(r) || _unsupportedIterableToArray$_(r) || _nonIterableRest$_();
}

function _decorate$Z(e, r, t, i) {
  var o = _getDecoratorsApi$Z();
  if (i) for (var n = 0; n < i.length; n++) o = i[n](o);
  var s = r(function (e) {
      o.initializeInstanceElements(e, a.elements);
    }, t),
    a = o.decorateClass(_coalesceClassElements$Z(s.d.map(_createElementDescriptor$Z)), e);
  return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers);
}
function _getDecoratorsApi$Z() {
  _getDecoratorsApi$Z = function _getDecoratorsApi() {
    return e;
  };
  var e = {
    elementsDefinitionOrder: [["method"], ["field"]],
    initializeInstanceElements: function initializeInstanceElements(e, r) {
      ["method", "field"].forEach(function (t) {
        r.forEach(function (r) {
          r.kind === t && "own" === r.placement && this.defineClassElement(e, r);
        }, this);
      }, this);
    },
    initializeClassElements: function initializeClassElements(e, r) {
      var t = e.prototype;
      ["method", "field"].forEach(function (i) {
        r.forEach(function (r) {
          var o = r.placement;
          if (r.kind === i && ("static" === o || "prototype" === o)) {
            var n = "static" === o ? e : t;
            this.defineClassElement(n, r);
          }
        }, this);
      }, this);
    },
    defineClassElement: function defineClassElement(e, r) {
      var t = r.descriptor;
      if ("field" === r.kind) {
        var i = r.initializer;
        t = {
          enumerable: t.enumerable,
          writable: t.writable,
          configurable: t.configurable,
          value: void 0 === i ? void 0 : i.call(e)
        };
      }
      Object.defineProperty(e, r.key, t);
    },
    decorateClass: function decorateClass(e, r) {
      var t = [],
        i = [],
        o = {
          "static": [],
          prototype: [],
          own: []
        };
      if (e.forEach(function (e) {
        this.addElementPlacement(e, o);
      }, this), e.forEach(function (e) {
        if (!_hasDecorators$Z(e)) return t.push(e);
        var r = this.decorateElement(e, o);
        t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers);
      }, this), !r) return {
        elements: t,
        finishers: i
      };
      var n = this.decorateConstructor(t, r);
      return i.push.apply(i, n.finishers), n.finishers = i, n;
    },
    addElementPlacement: function addElementPlacement(e, r, t) {
      var i = r[e.placement];
      if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")");
      i.push(e.key);
    },
    decorateElement: function decorateElement(e, r) {
      for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) {
        var s = r[e.placement];
        s.splice(s.indexOf(e.key), 1);
        var a = this.fromElementDescriptor(e),
          l = this.toElementFinisherExtras((0, o[n])(a) || a);
        e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher);
        var c = l.extras;
        if (c) {
          for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r);
          t.push.apply(t, c);
        }
      }
      return {
        element: e,
        finishers: i,
        extras: t
      };
    },
    decorateConstructor: function decorateConstructor(e, r) {
      for (var t = [], i = r.length - 1; i >= 0; i--) {
        var o = this.fromClassDescriptor(e),
          n = this.toClassDescriptor((0, r[i])(o) || o);
        if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) {
          e = n.elements;
          for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")");
        }
      }
      return {
        elements: e,
        finishers: t
      };
    },
    fromElementDescriptor: function fromElementDescriptor(e) {
      var r = {
        kind: e.kind,
        key: e.key,
        placement: e.placement,
        descriptor: e.descriptor
      };
      return Object.defineProperty(r, Symbol.toStringTag, {
        value: "Descriptor",
        configurable: !0
      }), "field" === e.kind && (r.initializer = e.initializer), r;
    },
    toElementDescriptors: function toElementDescriptors(e) {
      if (void 0 !== e) return _toArray$Z(e).map(function (e) {
        var r = this.toElementDescriptor(e);
        return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r;
      }, this);
    },
    toElementDescriptor: function toElementDescriptor(e) {
      var r = e.kind + "";
      if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"');
      var t = toPropertyKey$1(e.key),
        i = e.placement + "";
      if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"');
      var o = e.descriptor;
      this.disallowProperty(e, "elements", "An element descriptor");
      var n = {
        kind: r,
        key: t,
        placement: i,
        descriptor: Object.assign({}, o)
      };
      return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n;
    },
    toElementFinisherExtras: function toElementFinisherExtras(e) {
      return {
        element: this.toElementDescriptor(e),
        finisher: _optionalCallableProperty$Z(e, "finisher"),
        extras: this.toElementDescriptors(e.extras)
      };
    },
    fromClassDescriptor: function fromClassDescriptor(e) {
      var r = {
        kind: "class",
        elements: e.map(this.fromElementDescriptor, this)
      };
      return Object.defineProperty(r, Symbol.toStringTag, {
        value: "Descriptor",
        configurable: !0
      }), r;
    },
    toClassDescriptor: function toClassDescriptor(e) {
      var r = e.kind + "";
      if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"');
      this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor");
      var t = _optionalCallableProperty$Z(e, "finisher");
      return {
        elements: this.toElementDescriptors(e.elements),
        finisher: t
      };
    },
    runClassFinishers: function runClassFinishers(e, r) {
      for (var t = 0; t < r.length; t++) {
        var i = (0, r[t])(e);
        if (void 0 !== i) {
          if ("function" != typeof i) throw new TypeError("Finishers must return a constructor.");
          e = i;
        }
      }
      return e;
    },
    disallowProperty: function disallowProperty(e, r, t) {
      if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property.");
    }
  };
  return e;
}
function _createElementDescriptor$Z(e) {
  var r,
    t = toPropertyKey$1(e.key);
  "method" === e.kind ? r = {
    value: e.value,
    writable: !0,
    configurable: !0,
    enumerable: !1
  } : "get" === e.kind ? r = {
    get: e.value,
    configurable: !0,
    enumerable: !1
  } : "set" === e.kind ? r = {
    set: e.value,
    configurable: !0,
    enumerable: !1
  } : "field" === e.kind && (r = {
    configurable: !0,
    writable: !0,
    enumerable: !0
  });
  var i = {
    kind: "field" === e.kind ? "field" : "method",
    key: t,
    placement: e["static"] ? "static" : "field" === e.kind ? "own" : "prototype",
    descriptor: r
  };
  return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i;
}
function _coalesceGetterSetter$Z(e, r) {
  void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set;
}
function _coalesceClassElements$Z(e) {
  for (var r = [], isSameElement = function isSameElement(e) {
      return "method" === e.kind && e.key === o.key && e.placement === o.placement;
    }, t = 0; t < e.length; t++) {
    var i,
      o = e[t];
    if ("method" === o.kind && (i = r.find(isSameElement))) {
      if (_isDataDescriptor$Z(o.descriptor) || _isDataDescriptor$Z(i.descriptor)) {
        if (_hasDecorators$Z(o) || _hasDecorators$Z(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated.");
        i.descriptor = o.descriptor;
      } else {
        if (_hasDecorators$Z(o)) {
          if (_hasDecorators$Z(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ").");
          i.decorators = o.decorators;
        }
        _coalesceGetterSetter$Z(o, i);
      }
    } else r.push(o);
  }
  return r;
}
function _hasDecorators$Z(e) {
  return e.decorators && e.decorators.length;
}
function _isDataDescriptor$Z(e) {
  return void 0 !== e && !(void 0 === e.value && void 0 === e.writable);
}
function _optionalCallableProperty$Z(e, r) {
  var t = e[r];
  if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function");
  return t;
}

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

const prefix$B = 'cds';

/**
 * A selector selecting tabbable nodes.
 * Borrowed from `carbon-angular`. tabbable === focusable.
 */
const selectorTabbable = `
  a[href], area[href], input:not([disabled]):not([tabindex='-1']),
  button:not([disabled]):not([tabindex='-1']),select:not([disabled]):not([tabindex='-1']),
  textarea:not([disabled]):not([tabindex='-1']),
  iframe, object, embed, *[tabindex]:not([tabindex='-1']), *[contenteditable=true],
  ${prefix$B}-accordion-item,
  ${prefix$B}-button,
  ${prefix$B}-breadcrumb-link,
  ${prefix$B}-checkbox,
  ${prefix$B}-code-snippet,
  ${prefix$B}-combo-box,
  ${prefix$B}-content-switcher-item,
  ${prefix$B}-copy-button,
  ${prefix$B}-table-header-row,
  ${prefix$B}-table-row,
  ${prefix$B}-table-toolbar-search,
  ${prefix$B}-date-picker-input,
  ${prefix$B}-dropdown,
  ${prefix$B}-input,
  ${prefix$B}-link,
  ${prefix$B}-number-input,
  ${prefix$B}-modal,
  ${prefix$B}-modal-close-button,
  ${prefix$B}-multi-select,
  ${prefix$B}-inline-notification,
  ${prefix$B}-toast-notification,
  ${prefix$B}-overflow-menu,
  ${prefix$B}-overflow-menu-item,
  ${prefix$B}-page-sizes-select,
  ${prefix$B}-pages-select,
  ${prefix$B}-progress-step,
  ${prefix$B}-radio-button,
  ${prefix$B}-search,
  ${prefix$B}-slider,
  ${prefix$B}-slider-input,
  ${prefix$B}-structured-list,
  ${prefix$B}-tab,
  ${prefix$B}-filter-tag,
  ${prefix$B}-textarea,
  ${prefix$B}-text-input,
  ${prefix$B}-clickable-tile,
  ${prefix$B}-expandable-tile,
  ${prefix$B}-radio-tile,
  ${prefix$B}-selectable-tile,
  ${prefix$B}-toggle,
  ${prefix$B}-tooltip,
  ${prefix$B}-tooltip-definition,
  ${prefix$B}-tooltip-icon,
  ${prefix$B}-header-menu,
  ${prefix$B}-header-menu-button,
  ${prefix$B}-header-menu-item,
  ${prefix$B}-header-name,
  ${prefix$B}-header-nav-item,
  ${prefix$B}-side-nav-link,
  ${prefix$B}-side-nav-menu,
  ${prefix$B}-side-nav-menu-item
`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * Stores the ClassInfo object applied to a given AttributePart.
 * Used to unset existing values when a new ClassInfo object is applied.
 */
const attributesMapCache = new WeakMap();

/**
 * A directive that applies attributes from a key-value pairs.
 * This must be used in the `...` name and must be the only part used in the attribute.
 * It applies the key-value pairs in the `attributesInfo` argument
 * and sets them as attribute name/value pairs.
 *
 */
class SpreadDirective extends i {
  /**
   * The update function that handles the attribute setting.
   *
   * @param part an object with an API to manage the element's DOM
   * @returns the render function
   */
  update(part, [attributesInfo]) {
    const {
      element
    } = part;

    // Removes old attributes that are no longer there
    const oldAttributesInfo = attributesMapCache.get(part);
    if (oldAttributesInfo) {
      Object.keys(oldAttributesInfo).forEach(name => {
        if (!(name in attributesInfo)) {
          element.removeAttribute(name);
        }
      });
    }

    // Adds new attributes
    Object.keys(attributesInfo).forEach(name => {
      const value = attributesInfo[name];
      if ((!oldAttributesInfo || !Object.is(value, oldAttributesInfo[name])) && typeof value !== 'undefined') {
        element.setAttribute(name, value);
      }
    });

    // Updates the cache
    attributesMapCache.set(part, attributesInfo);
    return this.render(attributesInfo);
  }

  /**
   * The rendering function that simply takes in the arguments to be used
   * in the update() function.
   *
   * @param attributesInfo The key-value pair to be set as the attribute name/value pairs.
   * @returns the attributes info
   */
  render(attributesInfo) {
    return attributesInfo;
  }
}
const spread = e$1(SpreadDirective);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$H = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$G = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M8,1C4.2,1,1,4.2,1,8s3.2,7,7,7s7-3.1,7-7S11.9,1,8,1z M7.5,4h1v5h-1C7.5,9,7.5,4,7.5,4z M8,12.2	c-0.4,0-0.8-0.4-0.8-0.8s0.3-0.8,0.8-0.8c0.4,0,0.8,0.4,0.8,0.8S8.4,12.2,8,12.2z"></path><path d="M7.5,4h1v5h-1C7.5,9,7.5,4,7.5,4z M8,12.2c-0.4,0-0.8-0.4-0.8-0.8s0.3-0.8,0.8-0.8	c0.4,0,0.8,0.4,0.8,0.8S8.4,12.2,8,12.2z" data-icon-path="inner-path" opacity="0"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$F = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}${children}<path fill="none" d="M16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Zm-1.125-5h2.25V12h-2.25Z" data-icon-path="inner-path"></path><path d="M16.002,6.1714h-.004L4.6487,27.9966,4.6506,28H27.3494l.0019-.0034ZM14.875,12h2.25v9h-2.25ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"></path><path d="M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param Base The base class.
 * @returns A mix-in implementing `.focus()` method that focuses on the first focusable element in the shadow DOM.
 */
const FocusMixin = Base => class extends Base {
  /**
   * Focuses on the first focusable element in the shadow DOM.
   */
  focus() {
    // @ts-ignore: Until `delegatesFocus` is added to `ShadowRoot` definition
    if (this.shadowRoot.delegatesFocus) {
      super.focus();
    } else {
      const delegateTarget = this.shadowRoot.querySelector(selectorTabbable) || this.querySelector(selectorTabbable);
      if (delegateTarget) {
        delegateTarget.focus();
      } else {
        super.focus();
      }
    }
  }
};

/**
 * @param Base The base class.
 * @returns A mix-in to handle `formdata` event on the containing form.
 */
const FormMixin = Base => {
  /**
   * A mix-in class to handle `formdata` event on the containing form.
   */
  class FormMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * The handle for `formdata` event listener on the containing form.
       *
       * @private
       */
      _defineProperty$e(this, "_hFormdata", null);
    } // Not using TypeScript `private` due to: microsoft/TypeScript#17744
    /**
     * Handles `formdata` event.
     *
     * @param event The event.
     */
    connectedCallback() {
      // @ts-ignore
      super.connectedCallback();
      const form = this.closest('form');
      if (form) {
        this._hFormdata = on$1(form, 'formdata', this._handleFormdata.bind(this));
      }
    }
    disconnectedCallback() {
      if (this._hFormdata) {
        this._hFormdata = this._hFormdata.release();
      }
      // @ts-ignore
      super.disconnectedCallback();
    }
  }
  return FormMixinImpl;
};

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Form validation status.
 */
let VALIDATION_STATUS;

/**
 * @param Base The base class.
 * @returns A mix-in implementing `.setCustomValidity()` method.
 */
(function (VALIDATION_STATUS) {
  VALIDATION_STATUS["NO_ERROR"] = "";
  VALIDATION_STATUS["ERROR_REQUIRED"] = "required";
})(VALIDATION_STATUS || (VALIDATION_STATUS = {}));
const ValidityMixin = Base => {
  class ValidityMixinImpl extends Base {
    // Not using TypeScript `protected` due to: microsoft/TypeScript#17744
    // Using `string` instead of `VALIDATION_STATUS` until we can require TypeScript 3.8
    /**
     * @param state The form validation status.
     * @returns The form validation error messages associated with the given status.
     * @protected
     */
    _getValidityMessage(state) {
      return {
        [VALIDATION_STATUS.NO_ERROR]: '',
        [VALIDATION_STATUS.ERROR_REQUIRED]: this.requiredValidityMessage
      }[state];
    }

    // Not using TypeScript `protected` due to: microsoft/TypeScript#17744
    // Using `string` instead of `VALIDATION_STATUS` until we can require TypeScript 3.8
    /**
     * Checks if the value meets the constraints.
     *
     * @returns `VALIDATION_STATUS.NO_ERROR` if the value meets the constraints. Some other values otherwise.
     * @protected
     */
    _testValidity() {
      const {
        required,
        value
      } = this;
      return required && !value ? VALIDATION_STATUS.ERROR_REQUIRED : VALIDATION_STATUS.NO_ERROR;
    }

    /**
     * `true` to show the UI of the invalid state.
     */

    /**
     * `true` if the value is required.
     */

    /**
     * The special validity message for `required`.
     */

    /**
     * The validity message.
     */

    /**
     * The value.
     */

    /**
     * Checks if the value meets the constraints.
     * Fires cancelable `invalid` event if it doesn't.
     *
     * @returns `true` if the value meets the constraints. `false` otherwise.
     */
    checkValidity() {
      const status = this._testValidity();
      if (status !== VALIDATION_STATUS.NO_ERROR) {
        if (this.dispatchEvent(new CustomEvent('invalid', {
          bubbles: false,
          cancelable: true,
          composed: false
        }))) {
          this.invalid = true;
          this.validityMessage = this._getValidityMessage(status);
        }
        return false;
      }
      this.invalid = false;
      this.validityMessage = '';
      return true;
    }

    /**
     * Sets the given custom validity message.
     *
     * @param validityMessage The custom validity message
     */
    setCustomValidity(validityMessage) {
      this.invalid = Boolean(validityMessage);
      this.validityMessage = validityMessage;
    }
  }
  return ValidityMixinImpl;
};

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param a A DOM collection.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns A new array with all elements where `predicate` returns truthy.
 */
const filter = (a, predicate, thisObject) => Array.prototype.filter.call(a, predicate, thisObject);

/**
 * @param a A DOM collection.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns The first item in the given collection where `predicate` returns `true`. `null` if no such item is found.
 */
const find$1 = (a, predicate, thisObject) => Array.prototype.find.call(a, predicate, thisObject);

/**
 * Walks through the given DOM collection and runs the given callback.
 *
 * @param a A DOM collection.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 */
const forEach$1 = (a, predicate, thisObject) => Array.prototype.forEach.call(a, predicate, thisObject);

/**
 * @param a A DOM collection.
 * @param item An item in the DOM collection.
 * @returns The index of the first occurence of the given item in the given collection. `-1` if no such item is found.
 */
const indexOf$1 = (a, item) => Array.prototype.indexOf.call(a, item);

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Navigation direction, associated with key symbols.
 */
const NAVIGATION_DIRECTION$1 = {
  Up: -1,
  ArrowUp: -1,
  Down: 1,
  ArrowDown: 1
};

/**
 * The keyboard action categories for dropdown.
 */
let DROPDOWN_KEYBOARD_ACTION;

/**
 * Dropdown size.
 */
(function (DROPDOWN_KEYBOARD_ACTION) {
  DROPDOWN_KEYBOARD_ACTION["NONE"] = "none";
  DROPDOWN_KEYBOARD_ACTION["CLOSING"] = "closing";
  DROPDOWN_KEYBOARD_ACTION["NAVIGATING"] = "navigating";
  DROPDOWN_KEYBOARD_ACTION["TRIGGERING"] = "triggering";
})(DROPDOWN_KEYBOARD_ACTION || (DROPDOWN_KEYBOARD_ACTION = {}));
let DROPDOWN_SIZE;

/**
 * Dropdown types.
 */
(function (DROPDOWN_SIZE) {
  DROPDOWN_SIZE["SMALL"] = "sm";
  DROPDOWN_SIZE["MEDIUM"] = "md";
  DROPDOWN_SIZE["LARGE"] = "lg";
})(DROPDOWN_SIZE || (DROPDOWN_SIZE = {}));
let DROPDOWN_TYPE;

/**
 * Dropdown direction.
 */
(function (DROPDOWN_TYPE) {
  DROPDOWN_TYPE["DEFAULT"] = "";
  DROPDOWN_TYPE["INLINE"] = "inline";
})(DROPDOWN_TYPE || (DROPDOWN_TYPE = {}));
let DROPDOWN_DIRECTION;
(function (DROPDOWN_DIRECTION) {
  DROPDOWN_DIRECTION["TOP"] = "top";
  DROPDOWN_DIRECTION["BOTTOM"] = "bottom";
})(DROPDOWN_DIRECTION || (DROPDOWN_DIRECTION = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$k = i$4([
  "@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}input:-webkit-autofill,input:-webkit-autofill:focus,input:-webkit-autofill:hover,textarea:-webkit-autofill,textarea:-webkit-autofill:focus,textarea:-webkit-autofill:hover{box-shadow:0 0 0 1000px var(--cds-field) inset;-webkit-text-fill-color:var(--cds-text-primary,#161616)}.cds--fieldset{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--fieldset *,.cds--fieldset ::after,.cds--fieldset ::before{box-sizing:inherit}.cds--form-item{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start}.cds--label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:inline-block;color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;margin-block-end:.5rem;vertical-align:baseline}.cds--label html{font-size:100%}.cds--label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--label strong{font-weight:600}.cds--label .cds--toggletip-label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label--no-margin{margin-block-end:0}.cds--label+.cds--tooltip{position:relative;inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label+.cds--tooltip .cds--tooltip__trigger{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:flex;align-items:center;justify-content:center;font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label+.cds--tooltip .cds--tooltip__trigger *,.cds--label+.cds--tooltip .cds--tooltip__trigger ::after,.cds--label+.cds--tooltip .cds--tooltip__trigger ::before{box-sizing:inherit}.cds--label+.cds--tooltip .cds--tooltip__trigger::-moz-focus-inner{border:0}.cds--label+.cds--tooltip .cds--tooltip__trigger:focus{outline:1px solid var(--cds-focus,#0f62fe)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg :hover{fill:var(--cds-icon-primary,#161616)}.cds--label+.cds--toggletip{inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:.875rem;inline-size:4.6875rem}.cds--label.cds--skeleton:active,.cds--label.cds--skeleton:focus,.cds--label.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--label.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--label.cds--skeleton::before{animation:none}}input[type=number]{font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif}.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline-style:dotted}}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper--warn~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box--warning~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--number__input-wrapper--warning~.cds--form-requirement,.cds--select--warning .cds--select-input__wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper--warn~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper--warning>.cds--text-input~.cds--form-requirement,.cds--text-input__field-wrapper--warning~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker--warning~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input__field-wrapper--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]{display:block}.cds--form--fluid input[data-invalid]{outline:0}.cds--form--fluid .cds--form-requirement{padding:.5rem 2.5rem .5rem 1rem;margin:0}input:not(output,[data-invalid]):-moz-ui-invalid{box-shadow:none}.cds--form-requirement{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:none;overflow:hidden;margin:.25rem 0 0;max-block-size:0}.cds--form-requirement html{font-size:100%}.cds--form-requirement body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--form-requirement code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--form-requirement strong{font-weight:600}.cds--select--inline .cds--form__helper-text{margin-block-start:0}.cds--form__helper-text{font-size:var(--cds-helper-text-01-font-size,.75rem);line-height:var(--cds-helper-text-01-line-height,1.33333);letter-spacing:var(--cds-helper-text-01-letter-spacing,.32px);z-index:0;color:var(--cds-text-secondary,#525252);inline-size:100%;margin-block-start:.25rem;opacity:1}.cds--form__helper-text--disabled,.cds--label--disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}fieldset[disabled] .cds--form__helper-text,fieldset[disabled] .cds--label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;padding:0 var(--cds-layout-density-padding-inline-local);border:none;background-color:var(--cds-field);block-size:var(--cds-layout-size-height-local);border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);font-family:inherit;inline-size:100%;transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input *,.cds--text-input ::after,.cds--text-input ::before{box-sizing:inherit}.cds--text-input:active,.cds--text-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--text-input:active,.cds--text-input:focus{outline-style:dotted}}.cds--text-input-wrapper svg[hidden]{display:none}.cds--password-input{padding-inline-end:2.5rem}.cds--text-input--sm.cds--password-input{padding-inline-end:2rem}.cds--text-input--lg.cds--password-input{padding-inline-end:3rem}.cds--text-input::-moz-placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input::placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input--light{background-color:var(--cds-field-02,#fff)}.cds--text-input__field-wrapper{position:relative;display:flex;inline-size:100%}.cds--text-input__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--text-input__invalid-icon--warning path:first-of-type{fill:#000;opacity:1}.cds--text-input--password__visibility{position:relative;display:inline-flex;overflow:visible;align-items:center;cursor:pointer}.cds--text-input--password__visibility:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus{outline-style:dotted}}.cds--text-input--password__visibility:focus{outline:1px solid transparent}.cds--text-input--password__visibility:focus svg{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus svg{outline-style:dotted}}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{position:absolute;z-index:6000;display:flex;align-items:center;opacity:0;pointer-events:none}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{display:inline-block}}.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:opacity 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (prefers-reduced-motion:reduce){.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:none}}.cds--text-input--password__visibility.cds--tooltip--a11y::after,.cds--text-input--password__visibility.cds--tooltip--a11y::before{transition:none}.cds--text-input--password__visibility::before{border-style:solid;block-size:0;content:\"\";inline-size:0}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text{box-sizing:content-box;color:inherit;opacity:1;white-space:normal;word-break:break-word}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));z-index:6000;padding:.1875rem 1rem;border-radius:.125rem;background-color:var(--cds-background-inverse,#393939);block-size:auto;color:var(--cds-text-inverse,#fff);font-weight:400;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:13rem;min-inline-size:1.5rem;text-align:start;transform:translateX(-50%);font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-accelerator:true){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-ime-align:auto){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{border:1px solid transparent}}.cds--text-input--password__visibility::after{content:attr(aria-label)}.cds--text-input--password__visibility.cds--tooltip--a11y::after{content:none}.cds--text-input--password__visibility.cds--tooltip--visible::after,.cds--text-input--password__visibility.cds--tooltip--visible::before,.cds--text-input--password__visibility:focus::after,.cds--text-input--password__visibility:focus::before,.cds--text-input--password__visibility:hover::after,.cds--text-input--password__visibility:hover::before{opacity:1}@keyframes cds--tooltip-fade{from{opacity:0}to{opacity:1}}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text{overflow:visible;margin:auto;clip:auto}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:focus.cds--tooltip--a11y::before,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text,.cds--text-input--password__visibility:hover.cds--tooltip--a11y::before{animation:cds--tooltip-fade 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--hidden+.cds--assistive-text{overflow:hidden;margin:-1px;clip:rect(0,0,0,0)}.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before{animation:none;opacity:0}.cds--text-input--password__visibility .cds--assistive-text::after{position:absolute;display:block;content:\"\";block-size:.75rem;inline-size:100%;inset-inline-start:0;inset-block-start:-.75rem}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{inset-block-end:0;inset-inline-start:50%}.cds--text-input--password__visibility::before{border-width:0 .25rem .3125rem .25rem;border-color:transparent transparent var(--cds-background-inverse,#393939) transparent;inset-block-end:-.5rem;transform:translate(-50%,100%)}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inset-block-end:-.8125rem;transform:translate(-50%,100%)}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{outline:2px solid transparent;outline-offset:-2px;position:absolute;display:flex;align-items:center;justify-content:center;padding:0;border:0;background:0 0;block-size:100%;cursor:pointer;inline-size:2.5rem;inset-inline-end:0;min-block-size:auto;transition:outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--toggle-password-tooltip .cds--popover{inset-inline-start:-2.5rem}.cds--toggle-password-tooltip .cds--popover-content{min-inline-size:2.5rem}.cds--text-input--sm+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:2rem}.cds--text-input--lg+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:3rem}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252);transition:fill 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:ButtonText}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline-style:dotted}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg,.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-primary,#161616)}.cds--text-input--invalid,.cds--text-input--warning{padding-inline-end:2.5rem}.cds--text-input--invalid.cds--password-input{padding-inline-end:4rem}.cds--text-input--invalid+.cds--text-input--password__visibility__toggle{inset-inline-end:1rem}.cds--password-input-wrapper .cds--text-input__invalid-icon{inset-inline-end:2.5rem}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{cursor:not-allowed}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input__counter-alert{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px}.cds--text-input:disabled{outline:2px solid transparent;outline-offset:-2px;background-color:var(--cds-field);border-block-end:1px solid transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;-webkit-text-fill-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input--light:disabled{background-color:var(--cds-field-02,#fff)}.cds--text-input:disabled::-moz-placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input:disabled::placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input--invalid{outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px;box-shadow:none}@media screen and (prefers-contrast){.cds--text-input--invalid{outline-style:dotted}}.cds--text-input--invalid .cds--text-input--password__visibility__toggle{inset-inline-end:2.5rem}.cds--skeleton.cds--text-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}.cds--skeleton.cds--text-input:active,.cds--skeleton.cds--text-input:focus,.cds--skeleton.cds--text-input:hover{border:none;cursor:default;outline:0}.cds--skeleton.cds--text-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--skeleton.cds--text-input::before{animation:none}}.cds--form--fluid .cds--text-input-wrapper{position:relative;background:var(--cds-field);transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--form--fluid .cds--label{position:absolute;z-index:1;display:flex;align-items:center;margin:0;block-size:1rem;inset-block-start:.8125rem;inset-inline-start:1rem}.cds--form--fluid .cds--form__helper-text{display:none}.cds--form--fluid .cds--text-input{padding:2rem 1rem .8125rem;min-block-size:4rem}.cds--form--fluid .cds--text-input__divider,.cds--text-input__divider{display:none}.cds--form--fluid .cds--text-input--invalid,.cds--form--fluid .cds--text-input--warning{border-block-end:none}.cds--form--fluid .cds--text-input--invalid+.cds--text-input__divider,.cds--form--fluid .cds--text-input--warning+.cds--text-input__divider{display:block;border-style:solid;border-color:var(--cds-border-subtle);margin:0 1rem;border-block-end:none}.cds--form--fluid .cds--text-input__invalid-icon{inset-block-start:5rem}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid{outline:0}.cds--form--fluid .cds--text-input__field-wrapper--warning{border-block-end:1px solid var(--cds-border-strong)}.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning:focus,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:focus{outline:0}.cds--text-input-wrapper.cds--text-input-wrapper--inline{flex-flow:row wrap}.cds--text-input-wrapper .cds--label--inline{flex:1;margin:.8125rem 0 0 0;overflow-wrap:break-word;word-break:break-word}.cds--text-input-wrapper .cds--label--inline--sm{margin-block-start:.5625rem}.cds--text-input-wrapper .cds--label--inline--lg{margin-block-start:1.0625rem}.cds--text-input__label-helper-wrapper{flex:2;flex-direction:column;margin-inline-end:1.5rem;max-inline-size:8rem;overflow-wrap:break-word}.cds--text-input-wrapper .cds--form__helper-text--inline{margin-block-start:.125rem}.cds--text-input__field-outer-wrapper{display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start;inline-size:100%}.cds--text-input__field-outer-wrapper--inline{flex:8;flex-direction:column}.cds--text-input-wrapper--inline .cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--text-input-wrapper--inline--invalid .cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input-wrapper--readonly,.cds--text-input-wrapper--readonly .cds--text-input{background:0 0;border-block-end-color:var(--cds-border-subtle)}.cds--text-input__field-wrapper .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff);padding-inline-end:2.5rem}.cds--text-input--invalid:has(~.cds--slug),.cds--text-input--warning:has(~.cds--slug){padding-inline-end:4rem}.cds--text-input--invalid~.cds--slug,.cds--text-input--warning~.cds--slug{inset-inline-end:2.5rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:ButtonText}}.cds--text-input__label-wrapper{display:flex;justify-content:space-between;inline-size:100%}.cds--text-input__label-wrapper .cds--text-input__label-counter{align-self:end}.cds--tag{--cds-layout-size-height-xs:1.125rem;--cds-layout-size-height-sm:1.125rem;--cds-layout-size-height-md:1.5rem;--cds-layout-size-height-lg:2rem;--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);background-color:var(--cds-tag-background-gray,#e0e0e0);color:var(--cds-tag-color-gray,#161616);display:inline-flex;align-items:center;justify-content:center;border-radius:1rem;margin:.25rem;cursor:default;max-inline-size:13rem;min-block-size:var(--cds-layout-size-height-local);min-inline-size:2rem;padding-inline:.5rem;vertical-align:middle;word-break:break-word}.cds--layout--size-xs .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-xs)}.cds--layout--size-sm .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--tag.cds--tag--operational{border:1px solid var(--cds-tag-background-gray,#e0e0e0)}.cds--tag.cds--tag--operational:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag.cds--tag--lg{padding-inline-start:.75rem}.cds--tag:has(.cds--tag__custom-icon){padding-inline-start:.25rem}.cds--tag.cds--tag--lg:not(.cds--tag--filter){padding-inline:.75rem}.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon){padding-inline-start:.5rem}.cds--tag:not(.cds--tag--selectable){border:0}.cds--tag:not(:first-child){margin-inline-start:0}.cds--tag--operational>span,.cds--tag--selectable>span,.cds--tag__label{display:block;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.cds--tag--interactive:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--tag--filter{padding-block-end:0;padding-block-start:0;padding-inline-end:0}.cds--tag--filter:hover{outline:0}.cds--tag--selectable{border:1px solid var(--cds-border-inverse,#161616);background-color:var(--cds-layer);color:var(--cds-text-primary,#161616);cursor:pointer}.cds--tag--selectable:hover{background-color:var(--cds-layer-hover);outline:0}.cds--tag--selectable:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--tag--selectable-selected{background-color:var(--cds-layer-selected-inverse,#161616);color:var(--cds-text-inverse,#fff)}.cds--tag--selectable-selected:hover{background-color:var(--cds-layer-selected-inverse,#161616)}.cds--tag--operational{border:1px solid var(--cds-tag-border-gray,#a8a8a8);background-color:var(--cds-tag-background-gray,#e0e0e0);color:var(--cds-tag-color-gray,#161616);cursor:pointer}.cds--tag--operational:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1);outline:0}.cds--tag--operational:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--tag--red{background-color:var(--cds-tag-background-red,#ffd7d9);color:var(--cds-tag-color-red,#750e13)}.cds--tag--red.cds--tag--operational{border:1px solid var(--cds-tag-border-red,#ff8389)}.cds--tag--red.cds--tag--operational:hover{background-color:var(--cds-tag-hover-red,#ffc2c5)}.cds--tag--red .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-red,#ffc2c5)}.cds--tag--magenta{background-color:var(--cds-tag-background-magenta,#ffd6e8);color:var(--cds-tag-color-magenta,#740937)}.cds--tag--magenta.cds--tag--operational{border:1px solid var(--cds-tag-border-magenta,#ff7eb6)}.cds--tag--magenta.cds--tag--operational:hover{background-color:var(--cds-tag-hover-magenta,#ffbdda)}.cds--tag--magenta .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-magenta,#ffbdda)}.cds--tag--purple{background-color:var(--cds-tag-background-purple,#e8daff);color:var(--cds-tag-color-purple,#491d8b)}.cds--tag--purple.cds--tag--operational{border:1px solid var(--cds-tag-border-purple,#be95ff)}.cds--tag--purple.cds--tag--operational:hover{background-color:var(--cds-tag-hover-purple,#dcc7ff)}.cds--tag--purple .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-purple,#dcc7ff)}.cds--tag--blue{background-color:var(--cds-tag-background-blue,#d0e2ff);color:var(--cds-tag-color-blue,#002d9c)}.cds--tag--blue.cds--tag--operational{border:1px solid var(--cds-tag-border-blue,#78a9ff)}.cds--tag--blue.cds--tag--operational:hover{background-color:var(--cds-tag-hover-blue,#b8d3ff)}.cds--tag--blue .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-blue,#b8d3ff)}.cds--tag--cyan{background-color:var(--cds-tag-background-cyan,#bae6ff);color:var(--cds-tag-color-cyan,#003a6d)}.cds--tag--cyan.cds--tag--operational{border:1px solid var(--cds-tag-border-cyan,#33b1ff)}.cds--tag--cyan.cds--tag--operational:hover{background-color:var(--cds-tag-hover-cyan,#99daff)}.cds--tag--cyan .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-cyan,#99daff)}.cds--tag--teal{background-color:var(--cds-tag-background-teal,#9ef0f0);color:var(--cds-tag-color-teal,#004144)}.cds--tag--teal.cds--tag--operational{border:1px solid var(--cds-tag-border-teal,#08bdba)}.cds--tag--teal.cds--tag--operational:hover{background-color:var(--cds-tag-hover-teal,#57e5e5)}.cds--tag--teal .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-teal,#57e5e5)}.cds--tag--green{background-color:var(--cds-tag-background-green,#a7f0ba);color:var(--cds-tag-color-green,#044317)}.cds--tag--green.cds--tag--operational{border:1px solid var(--cds-tag-border-green,#42be65)}.cds--tag--green.cds--tag--operational:hover{background-color:var(--cds-tag-hover-green,#74e792)}.cds--tag--green .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-green,#74e792)}.cds--tag--gray{background-color:var(--cds-tag-background-gray,#e0e0e0);color:var(--cds-tag-color-gray,#161616)}.cds--tag--gray.cds--tag--operational{border:1px solid var(--cds-tag-border-gray,#a8a8a8)}.cds--tag--gray.cds--tag--operational:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag--gray .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag--cool-gray{background-color:var(--cds-tag-background-cool-gray,#dde1e6);color:var(--cds-tag-color-cool-gray,#121619)}.cds--tag--cool-gray.cds--tag--operational{border:1px solid var(--cds-tag-border-cool-gray,#a2a9b0)}.cds--tag--cool-gray.cds--tag--operational:hover{background-color:var(--cds-tag-hover-cool-gray,#cdd3da)}.cds--tag--cool-gray .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-cool-gray,#cdd3da)}.cds--tag--warm-gray{background-color:var(--cds-tag-background-warm-gray,#e5e0df);color:var(--cds-tag-color-warm-gray,#171414)}.cds--tag--warm-gray.cds--tag--operational{border:1px solid var(--cds-tag-border-warm-gray,#ada8a8)}.cds--tag--warm-gray.cds--tag--operational:hover{background-color:var(--cds-tag-hover-warm-gray,#d8d0cf)}.cds--tag--warm-gray .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-warm-gray,#d8d0cf)}.cds--tag--high-contrast:not(.cds--tag--operational){background-color:var(--cds-background-inverse,#393939);color:var(--cds-text-inverse,#fff)}.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational{border:1px solid var(--cds-background-inverse,#393939)}.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover{background-color:var(--cds-background-inverse-hover,#474747)}.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover{background-color:var(--cds-background-inverse-hover,#474747)}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]){background-color:var(--cds-background,#fff);color:var(--cds-text-primary,#161616);outline:1px solid var(--cds-background-inverse,#393939);outline-offset:-1px}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational{border:1px solid var(--cds-background,#fff)}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover{background-color:var(--cds-layer-hover)}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover{background-color:var(--cds-layer-hover)}.cds--tag--disabled:not(.cds--tag--operational),.cds--tag--filter.cds--tag--disabled,.cds--tag--interactive.cds--tag--disabled{background-color:var(--cds-layer);color:var(--cds-text-disabled,rgba(22,22,22,.25));box-shadow:none;outline:0}.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,.cds--tag--filter.cds--tag--disabled.cds--tag--operational,.cds--tag--interactive.cds--tag--disabled.cds--tag--operational{border:1px solid var(--cds-layer)}.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover{background-color:var(--cds-layer)}.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover{background-color:var(--cds-layer)}.cds--tag--disabled:not(.cds--tag--operational):hover,.cds--tag--filter.cds--tag--disabled:hover,.cds--tag--interactive.cds--tag--disabled:hover{cursor:not-allowed}.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,.cds--tag--filter.cds--tag--disabled .cds--tag__label,.cds--tag--interactive.cds--tag--disabled .cds--tag__label{background-color:var(--cds-layer);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--tag--operational.cds--tag--disabled,.cds--tag--selectable.cds--tag--disabled{border:1px solid var(--cds-border-disabled,#c6c6c6);background-color:var(--cds-layer);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--tag--operational.cds--tag--disabled:hover,.cds--tag--selectable.cds--tag--disabled:hover{background-color:var(--cds-layer);cursor:not-allowed}.cds--tag--interactive{transition:background-color 70ms cubic-bezier(0,0,.38,.9)}.cds--tag__close-icon{display:flex;flex-shrink:0;align-items:center;justify-content:center;padding:0;border:0;border-radius:50%;margin:0 0 0 .125rem;background-color:transparent;block-size:var(--cds-layout-size-height-local);color:currentColor;cursor:pointer;inline-size:var(--cds-layout-size-height-local);transition:background-color 70ms cubic-bezier(.2,0,.38,.9),box-shadow 70ms cubic-bezier(.2,0,.38,.9)}.cds--tag__close-icon svg{fill:currentColor}.cds--tag__custom-icon{flex-shrink:0;padding:0;border:0;background-color:transparent;block-size:1rem;color:currentColor;inline-size:1rem;margin-inline-end:.25rem;outline:0}.cds--tag__custom-icon svg{fill:currentColor}.cds--tag--disabled .cds--tag__close-icon{cursor:not-allowed}.cds--tag__close-icon:focus{z-index:99999;border-radius:50%;box-shadow:inset 0 0 0 1px var(--cds-focus,#0f62fe);outline:0}.cds--tag--high-contrast .cds--tag__close-icon:focus{box-shadow:inset 0 0 0 1px var(--cds-focus-inverse,#fff)}.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover{background-color:transparent}.cds--tag--filter.cds--tag--disabled svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--tag--sm.cds--tag--filter{padding-inline-end:0}.cds--tag--sm .cds--tag__close-icon{margin-inline-start:.3125rem}.cds--tag.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;background-color:var(--cds-skeleton-background,#e8e8e8);color:var(--cds-text-primary,#161616);overflow:hidden;inline-size:3.75rem}.cds--tag.cds--skeleton:active,.cds--tag.cds--skeleton:focus,.cds--tag.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--tag.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--tag.cds--skeleton::before{animation:none}}.cds--tag.cds--skeleton.cds--tag--operational{border:1px solid var(--cds-skeleton-background,#e8e8e8)}.cds--tag.cds--skeleton.cds--tag--operational:hover{background-color:var(--cds-skeleton-background,#e8e8e8)}.cds--tag.cds--skeleton .cds--tag__close-icon:hover{background-color:var(--cds-skeleton-background,#e8e8e8)}@media not all and (min-resolution >= 0.001dpcm){@supports (-webkit-appearance:none) and (stroke-color:transparent){.cds--tag.cds--skeleton{transform:translateZ(0)}}}.cds--tag .cds--slug .cds--slug__button--inline{color:currentColor;margin-inline-start:.0625rem}.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before{background-color:currentColor}.cds--tag .cds--slug .cds--slug__button--inline:hover{border-color:currentColor}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tag{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tag__close-icon svg,.cds--tag__custom-icon svg{fill:ButtonText}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tag__close-icon:focus{color:Highlight;outline:1px solid Highlight}}.cds--tag-label-tooltip{max-inline-size:-webkit-fill-available}.cds--tag__custom-icon+.cds--tag-label-tooltip{max-inline-size:11rem}.cds--tag--filter .cds--tag__custom-icon+.cds--tag-label-tooltip{max-inline-size:9.875rem}.cds--interactive--tag-children{display:inline-flex;max-inline-size:12.5rem;place-items:center}.cds--tag--filter .cds--tag__custom-icon+span>.cds--interactive--tag-children{max-inline-size:11.5rem}.cds--tag .cds--definition-term{border-block-end:none;cursor:default;max-inline-size:12rem}.cds--tag .cds--tag__custom-icon+span>.cds--definition-term{max-inline-size:11rem}.cds--tag>.cds--popover-container{display:flex}.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled){pointer-events:none}.cds--list-box__wrapper--inline,:host(cds-dropdown[type=inline]){display:inline-grid;align-items:center;grid-gap:.25rem;grid-template:auto auto/auto auto}.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--list-box__wrapper--inline .cds--form-requirement,.cds--list-box__wrapper--inline .cds--form__helper-text,.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--label{margin:0}.cds--list-box__wrapper--inline .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--form__helper-text{max-inline-size:none}.cds--list-box__wrapper--inline .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form-requirement{grid-column:2}.cds--list-box{position:relative;border:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;inline-size:100%;max-block-size:2.5rem;transition:all 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box html{font-size:100%}.cds--list-box body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--list-box code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--list-box strong{font-weight:600}.cds--list-box:hover{background-color:var(--cds-field-hover)}.cds--list-box--lg{block-size:3rem;max-block-size:3rem}.cds--list-box--sm{block-size:2rem;max-block-size:2rem}.cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box--expanded:hover{background-color:var(--cds-field)}.cds--list-box--expanded:hover.cds--list-box--light:hover{background-color:var(--cds-field-02,#fff)}.cds--list-box .cds--text-input{block-size:100%;min-inline-size:0}.cds--list-box__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:2.5rem;transform:translateY(-50%)}.cds--list-box__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--list-box__invalid-icon--warning path[fill]{fill:#000;opacity:1}.cds--list-box.cds--list-box--warning .cds--list-box__field,.cds--list-box[data-invalid] .cds--list-box__field{border-block-end:0;padding-inline-end:4rem}.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field,.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:3.5rem}.cds--list-box--light{background-color:var(--cds-field-02,#fff)}.cds--list-box--light:hover{background-color:var(--cds-field-hover)}.cds--list-box--light .cds--list-box__menu{background:var(--cds-layer)}.cds--list-box--light .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle)}.cds--list-box--light.cds--list-box--expanded{border-block-end-color:transparent}.cds--list-box--disabled:hover{background-color:var(--cds-field)}.cds--list-box--light.cds--list-box--disabled{background-color:var(--cds-field-02,#fff)}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__field:focus{border-block-end-color:transparent;outline:0}.cds--list-box--disabled .cds--list-box__label,.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__menu-icon>svg,.cds--list-box--disabled .cds--list-box__selection>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__menu-icon{cursor:not-allowed}.cds--list-box--disabled .cds--list-box__menu-item,.cds--list-box--disabled .cds--list-box__menu-item--highlighted,.cds--list-box--disabled .cds--list-box__menu-item:hover,.cds--list-box--disabled :host(cds-dropdown-item){color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}.cds--list-box--disabled .cds--list-box__selection:hover{cursor:not-allowed}.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field{padding-inline-end:3rem}.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:2rem}.cds--list-box.cds--list-box--inline{border-width:0;background-color:transparent}.cds--list-box.cds--list-box--inline:hover{background-color:var(--cds-layer-hover)}.cds--list-box.cds--list-box--inline.cds--list-box--expanded{border-block-end-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true]{border-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover,.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover{background-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__field{padding:0 2rem 0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon{inset-inline-end:.5rem}.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon{inset-inline-end:2rem}.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-primary,#161616)}.cds--list-box--inline .cds--list-box__field{block-size:100%}.cds--dropdown--inline .cds--list-box__field{max-inline-size:30rem}.cds--dropdown--inline .cds--list-box__menu{max-inline-size:30rem;min-inline-size:18rem}.cds--list-box__field{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;overflow:hidden;align-items:center;block-size:calc(100% + 1px);cursor:pointer;outline:0;padding-block:0;padding-inline-end:3rem;padding-inline-start:1rem;text-overflow:ellipsis;vertical-align:top;white-space:nowrap}.cds--list-box__field *,.cds--list-box__field ::after,.cds--list-box__field ::before{box-sizing:inherit}.cds--list-box__field::-moz-focus-inner{border:0}.cds--list-box__field:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__field:focus{outline-style:dotted}}.cds--list-box__field[disabled]{color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--list-box__field .cds--text-input{padding-inline-end:5rem}.cds--list-box--warning .cds--list-box__field .cds--text-input,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input{padding-inline-end:6.5625rem}.cds--list-box--warning .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon{inset-inline-end:5.125rem}.cds--list-box__field .cds--text-input--empty{padding-inline-end:3rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon{inset-inline-end:2.5rem}.cds--list-box__label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);overflow:hidden;color:var(--cds-text-primary,#161616);text-overflow:ellipsis;-webkit-user-select:none;-moz-user-select:none;user-select:none;white-space:nowrap}.cds--list-box__menu-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-inline-end:.75rem;outline:0;transition:transform 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu-icon *,.cds--list-box__menu-icon ::after,.cds--list-box__menu-icon ::before{box-sizing:inherit}.cds--list-box__menu-icon::-moz-focus-inner{border:0}.cds--list-box__menu-icon>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box__menu-icon--open{justify-content:center;inline-size:1.5rem;transform:rotate(180deg)}.cds--list-box__selection{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-block-start:50%;inset-inline-end:2.8125rem;transform:translateY(-50%);transition:background-color 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__selection *,.cds--list-box__selection ::after,.cds--list-box__selection ::before{box-sizing:inherit}.cds--list-box__selection::-moz-focus-inner{border:0}.cds--list-box__selection:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus{outline-style:dotted}}.cds--list-box__selection:focus:hover{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus:hover{outline-style:dotted}}.cds--list-box__selection>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box--disabled .cds--list-box__selection:focus{outline:0}.cds--list-box__selection--multi{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);position:static;display:flex;align-items:center;justify-content:space-between;padding:.5rem;border-radius:.75rem;background-color:var(--cds-background-inverse,#393939);block-size:1.5rem;color:var(--cds-text-inverse,#fff);inline-size:auto;inset-block-start:auto;line-height:0;margin-inline-end:.625rem;padding-inline-end:.125rem;transform:none}.cds--list-box__selection--multi>svg{padding:.125rem;block-size:1.25rem;fill:var(--cds-icon-inverse,#fff);inline-size:1.25rem;margin-inline-start:.25rem}.cds--list-box__selection--multi>svg:hover{border-radius:50%;background-color:var(--cds-button-secondary-hover,#474747)}.cds--list-box--disabled .cds--list-box__selection--multi{background-color:var(--cds-text-disabled,rgba(22,22,22,.25));color:var(--cds-layer)}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational{border:1px solid var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg:hover{background-color:initial}.cds--list-box__selection--multi:hover{outline:0}.cds--list-box__menu{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));position:absolute;z-index:9100;display:none;background-color:var(--cds-layer);inline-size:100%;inset-inline-end:0;inset-inline-start:0;overflow-y:auto;transition:max-height 110ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--list-box__menu:focus{outline-style:dotted}}.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu{display:none;max-block-size:0;visibility:hidden}.cds--list-box--expanded .cds--list-box__menu{display:block;max-block-size:13.75rem}.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu{max-block-size:16.5rem}.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu{max-block-size:11rem}.cds--list-box__menu-item,:host(cds-dropdown-item){font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;block-size:2.5rem;color:var(--cds-text-secondary,#525252);cursor:pointer;transition:background 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--light .cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box--sm .cds--list-box__menu-item,.cds--list-box--sm :host(cds-dropdown-item){block-size:2rem}.cds--list-box--lg .cds--list-box__menu-item,.cds--list-box--lg :host(cds-dropdown-item){block-size:3rem}.cds--list-box--disabled .cds--list-box__menu-item:hover{background-color:transparent}.cds--list-box--light .cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item:hover .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item__option{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;outline:2px solid transparent;outline-offset:-2px;display:block;overflow:hidden;padding:.6875rem 0;margin:0 1rem;block-size:2.5rem;border-block-end:1px solid transparent;border-block-start:1px solid transparent;border-block-start-color:var(--cds-border-subtle-01,#c6c6c6);color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;padding-inline-end:1.5rem;text-decoration:none;text-overflow:ellipsis;transition:border-color 70ms cubic-bezier(.2,0,.38,.9),color 70ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}.cds--list-box__menu-item__option *,.cds--list-box__menu-item__option ::after,.cds--list-box__menu-item__option ::before{box-sizing:inherit}.cds--list-box__menu-item__option:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;border-color:transparent;margin:0}@media screen and (prefers-contrast){.cds--list-box__menu-item__option:focus{outline-style:dotted}}.cds--list-box__menu-item__option:hover{border-color:transparent;color:var(--cds-text-primary,#161616)}.cds--list-box--sm .cds--list-box__menu-item__option{block-size:2rem;padding-block-end:.4375rem;padding-block-start:.4375rem}.cds--list-box--lg .cds--list-box__menu-item__option{block-size:3rem;padding-block-end:.9375rem;padding-block-start:.9375rem}.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled],.cds--list-box__menu-item[disabled] *,.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;outline:0}.cds--list-box__menu-item[disabled]:hover{background-color:revert}.cds--list-box__menu-item[disabled] .cds--checkbox-label::before{border-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item--active+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option{margin:0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus{margin:0;padding-inline-end:.5rem;padding-inline-start:.5rem}.cds--list-box__menu-item--highlighted,:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;color:var(--cds-text-primary,#161616)}@media screen and (prefers-contrast){.cds--list-box__menu-item--highlighted,:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline-style:dotted}}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active,:host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}.cds--list-box--light .cds--list-box__menu-item--active,.cds--list-box--light :host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected)}.cds--list-box__menu-item--active:hover{background-color:var(--cds-layer-selected-hover);border-block-end-color:var(--cds-layer-selected-hover)}.cds--list-box__menu-item--active .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active+.cds--list-box__menu-item>.cds--list-box__menu-item__option,.cds--list-box__menu-item--active+:host(cds-dropdown-item)>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item)>.cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item__selected-icon{position:absolute;display:none;fill:var(--cds-icon-primary,#161616);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--list-box--inline .cds--list-box__menu-item__selected-icon{inset-inline-end:.5rem}.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}.cds--list-box__menu-item .cds--checkbox-label,:host(cds-dropdown-item) .cds--checkbox-label{inline-size:100%}.cds--list-box__menu-item .cds--checkbox-label-text,:host(cds-dropdown-item) .cds--checkbox-label-text{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.cds--list-box--up .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box__menu{inset-block-end:2.5rem}.cds--list-box--up .cds--list-box--sm .cds--list-box__menu,.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--sm .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--sm .cds--list-box__menu{inset-block-end:2rem}.cds--list-box--up .cds--list-box--lg .cds--list-box__menu,.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--lg .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--lg .cds--list-box__menu{inset-block-end:3rem}.cds--list-box input[role=combobox],.cds--list-box input[type=text]{background-color:inherit;min-inline-size:0;text-overflow:ellipsis}.cds--list-box__wrapper--slug .cds--slug,:host(cds-dropdown[slug]) .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:calc(2.5rem + 9px);margin-block-start:.03125rem;transform:translateY(-50%)}.cds--list-box__wrapper--slug .cds--slug::after,.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem}.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::before{display:none;inset-inline-start:-.5625rem}.cds--list-box__wrapper--slug .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::after{display:block;inset-inline-end:-.5625rem}.cds--list-box__wrapper--slug .cds--slug--revert::after,:host(cds-dropdown[slug]) .cds--slug--revert::after{inset-block-start:.5rem;inset-inline-end:-.0625rem}.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)),:host(cds-dropdown[slug]) .cds--list-box:not(:has(.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff)}.cds--list-box__wrapper--slug .cds--list-box input[role=combobox],:host(cds-dropdown[slug]) .cds--list-box input[role=combobox]{border-block-end-color:transparent}.cds--list-box__wrapper--slug .cds--list-box__field,.cds--list-box__wrapper--slug .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box__field,:host(cds-dropdown[slug]) .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--text-input:not(.cds--text-input--empty){padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input--empty{padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty){padding-inline-end:8.8125rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning{inset-inline-end:5.1875rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--slug::before{display:block}.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,:host(cds-dropdown[slug]) .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug{inset-inline-end:calc(4rem + 18px)}.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon{inset-inline-end:7.25rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field,.cds--list-box__menu,.cds--multi-select .cds--tag--filter{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field:focus,.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--multi-select .cds--tag__close-icon:focus,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-icon>svg,.cds--list-box__selection--multi>svg,.cds--list-box__selection>svg{fill:ButtonText}}.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-start:2.0625rem}.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-end:2.0625rem}.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon,:has(.cds--multi-select):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon,:has(.cds--dropdown):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}.cds--dropdown__wrapper--inline{display:inline-grid;align-items:center;grid-gap:0 1.5rem;grid-template:auto auto/auto min-content}.cds--dropdown__wrapper--inline .cds--label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--dropdown__wrapper--inline .cds--form-requirement,.cds--dropdown__wrapper--inline .cds--form__helper-text,.cds--dropdown__wrapper--inline .cds--label{margin:0}.cds--dropdown__wrapper--inline .cds--form-requirement{grid-column:2}.cds--dropdown{outline:2px solid transparent;outline-offset:-2px;position:relative;display:block;border:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;inline-size:100%;list-style:none;outline:2px solid transparent;transition:background-color 70ms cubic-bezier(.2,0,.38,.9)}.cds--dropdown html{font-size:100%}.cds--dropdown body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--dropdown code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--dropdown strong{font-weight:600}.cds--dropdown:hover{background-color:var(--cds-field-hover)}.cds--dropdown .cds--list-box__field{text-align:start}.cds--dropdown--lg{block-size:3rem;max-block-size:3rem}.cds--dropdown--lg .cds--dropdown__arrow{inset-block-start:1rem}.cds--dropdown--sm{block-size:2rem;max-block-size:2rem}.cds--dropdown--sm .cds--dropdown__arrow{inset-block-start:.5rem}.cds--dropdown--open{border-block-end-color:var(--cds-border-subtle)}.cds--dropdown--open .cds--list-box__field{outline:0}.cds--dropdown--invalid{outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--dropdown--invalid{outline-style:dotted}}.cds--dropdown--invalid .cds--dropdown-text{padding-inline-end:3.5rem}.cds--dropdown--invalid+.cds--form-requirement{display:inline-block;color:var(--cds-text-error,#da1e28);max-block-size:12.5rem}.cds--dropdown__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:2.5rem;transform:translateY(-50%)}.cds--dropdown--open:hover{background-color:var(--cds-field)}.cds--dropdown--open:focus{outline:1px solid transparent}.cds--dropdown--open .cds--dropdown-list{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));max-block-size:13.75rem;transition:max-height 110ms cubic-bezier(0,0,.38,.9)}.cds--dropdown--light{background-color:var(--cds-field-02,#fff)}.cds--dropdown--light:hover{background-color:var(--cds-field-hover)}.cds--dropdown--up .cds--dropdown-list{inset-block-end:2rem}.cds--dropdown__arrow{position:absolute;fill:var(--cds-icon-primary,#161616);inset-block-start:.8125rem;inset-inline-end:1rem;pointer-events:none;transform-origin:50% 45%;transition:transform 110ms cubic-bezier(.2,0,.38,.9)}button.cds--dropdown-text{border:none;background:0 0;color:var(--cds-text-primary,#161616);inline-size:100%;text-align:start}button.cds--dropdown-text:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){button.cds--dropdown-text:focus{outline-style:dotted}}.cds--dropdown-text{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:block;overflow:hidden;block-size:calc(100% + 1px);padding-inline-end:2.625rem;padding-inline-start:1rem;text-overflow:ellipsis;white-space:nowrap}.cds--dropdown-list{outline:2px solid transparent;outline-offset:-2px;box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:absolute;z-index:9100;display:flex;flex-direction:column;background-color:var(--cds-layer);inline-size:100%;list-style:none;max-block-size:0;overflow-x:hidden;overflow-y:auto;transition:max-height 110ms cubic-bezier(.2,0,.38,.9)}.cds--dropdown-list html{font-size:100%}.cds--dropdown-list body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--dropdown-list code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--dropdown-list strong{font-weight:600}.cds--dropdown--light .cds--dropdown-list{background-color:var(--cds-layer)}.cds--dropdown:not(.cds--dropdown--open) .cds--dropdown-item{visibility:hidden}.cds--dropdown-item{position:relative;opacity:0;transition:visibility 70ms cubic-bezier(.2,0,.38,.9),opacity 70ms cubic-bezier(.2,0,.38,.9),background-color 70ms cubic-bezier(.2,0,.38,.9);visibility:inherit}.cds--dropdown-item:hover{background-color:var(--cds-layer-hover)}.cds--dropdown-item:hover+.cds--dropdown-item .cds--dropdown-link{border-color:transparent}.cds--dropdown-item:active{background-color:var(--cds-layer-selected)}.cds--dropdown-item:first-of-type .cds--dropdown-link{border-block-start-color:transparent}.cds--dropdown-item:last-of-type .cds--dropdown-link{border-block-end:none}.cds--dropdown-link{outline:2px solid transparent;outline-offset:-2px;display:block;overflow:hidden;padding:.6875rem 0;border:1px solid transparent;margin:0 1rem;block-size:2.5rem;border-block-start-color:var(--cds-border-subtle);color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;text-decoration:none;text-overflow:ellipsis;white-space:nowrap}.cds--dropdown-link:hover{border-color:transparent;color:var(--cds-text-primary,#161616)}.cds--dropdown--light .cds--dropdown-link{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--dropdown--sm .cds--dropdown-link{block-size:2rem;padding-block-end:.4375rem;padding-block-start:.4375rem}.cds--dropdown--focused,.cds--dropdown-link:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;margin:0}@media screen and (prefers-contrast){.cds--dropdown--focused,.cds--dropdown-link:focus{outline-style:dotted}}.cds--dropdown-list[aria-activedescendant] .cds--dropdown-link:focus{padding:.6875rem 0;margin:0 1rem;outline:0}.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;margin:0}@media screen and (prefers-contrast){.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus{outline-style:dotted}}.cds--dropdown-list[aria-activedescendant] .cds--dropdown-item:active{background-color:inherit}.cds--dropdown-item:hover .cds--dropdown-link{border-block-end-color:var(--cds-layer-hover)}.cds--dropdown--open .cds--dropdown__arrow{transform:rotate(-180deg)}.cds--dropdown--open.cds--dropdown--sm .cds--dropdown-list{max-block-size:11rem}.cds--dropdown--open .cds--dropdown-item{opacity:1}.cds--dropdown--disabled{border-block-end-color:transparent}.cds--dropdown--disabled:hover{background-color:var(--cds-field)}.cds--dropdown--disabled:focus{outline:0}.cds--dropdown--disabled .cds--dropdown-text,.cds--dropdown--disabled .cds--list-box__label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--dropdown--disabled .cds--dropdown__arrow,.cds--dropdown--disabled .cds--list-box__menu-icon svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--dropdown--disabled.cds--dropdown--light:hover{background-color:var(--cds-field-02,#fff)}.cds--dropdown--disabled .cds--list-box__field,.cds--dropdown--disabled .cds--list-box__menu-icon{cursor:not-allowed}.cds--dropdown--auto-width{inline-size:auto;max-inline-size:25rem}.cds--dropdown--inline{display:inline-block;background-color:transparent;border-block-end-color:transparent;inline-size:auto;justify-self:start;transition:background 70ms cubic-bezier(0,0,.38,.9)}.cds--dropdown--inline:hover{background-color:var(--cds-layer-hover)}.cds--dropdown--inline.cds--dropdown--disabled{background-color:transparent}.cds--dropdown--inline .cds--dropdown__arrow{inset-block-start:.5rem;inset-inline-end:.5rem}.cds--dropdown--inline.cds--dropdown--open{background-color:transparent}.cds--dropdown--inline .cds--dropdown-text{display:inline-block;overflow:visible;padding:.4375rem 2rem .4375rem .75rem;block-size:2rem;color:var(--cds-text-primary,#161616)}.cds--dropdown--inline.cds--dropdown--disabled .cds--dropdown-text{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--dropdown--inline.cds--dropdown--disabled:focus .cds--dropdown-text{outline:0}.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown__invalid-icon{inset-inline-end:2rem}.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown-text{padding-inline-end:3.5rem}.cds--dropdown--inline.cds--dropdown--open:focus .cds--dropdown-list{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3))}.cds--dropdown--inline .cds--dropdown-link{font-weight:400}.cds--dropdown--show-selected .cds--dropdown--selected{display:block;background-color:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}.cds--dropdown--show-selected .cds--dropdown--selected:hover{background-color:var(--cds-layer-selected-hover)}.cds--dropdown--show-selected .cds--dropdown--selected .cds--dropdown-link{border-block-start-color:transparent}.cds--dropdown--show-selected .cds--dropdown--selected+.cds--dropdown-item .cds--dropdown-link{border-block-start-color:transparent}.cds--dropdown--show-selected .cds--dropdown--selected .cds--list-box__menu-item__selected-icon{display:block}.cds--dropdown-v2.cds--skeleton,.cds--dropdown.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}.cds--dropdown-v2.cds--skeleton:active,.cds--dropdown-v2.cds--skeleton:focus,.cds--dropdown-v2.cds--skeleton:hover,.cds--dropdown.cds--skeleton:active,.cds--dropdown.cds--skeleton:focus,.cds--dropdown.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--dropdown-v2.cds--skeleton::before,.cds--dropdown.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--dropdown-v2.cds--skeleton::before,.cds--dropdown.cds--skeleton::before{animation:none}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--dropdown .cds--list-box__field{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-item__option{outline:0}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-item__selected-icon{fill:ButtonText}}.cds--dropdown--readonly,.cds--dropdown--readonly:hover,:host(cds-dropdown[read-only]){background-color:transparent;border-block-end-color:var(--cds-border-subtle)}.cds--dropdown--inline.cds--dropdown--readonly{border-block-end-color:transparent}.cds--dropdown--readonly .cds--list-box__field,.cds--dropdown--readonly .cds--list-box__menu-icon,:host(cds-dropdown[read-only]) .cds--list-box__field,:host(cds-dropdown[read-only]) .cds--list-box__menu-icon{cursor:default}.cds--dropdown--readonly .cds--list-box__menu-icon svg,:host(cds-dropdown[read-only]) .cds--list-box__menu-icon svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-group{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--checkbox-group *,.cds--checkbox-group ::after,.cds--checkbox-group ::before{box-sizing:inherit}.cds--form-item.cds--checkbox-wrapper{position:relative;margin-block-end:.375rem}.cds--form-item.cds--checkbox-wrapper:first-of-type{margin-block-start:0}.cds--label+.cds--form-item.cds--checkbox-wrapper{margin-block-start:-.125rem}.cds--form-item.cds--checkbox-wrapper:last-of-type{margin-block-end:.1875rem}.cds--checkbox{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap;inset-block-start:1.25rem;inset-inline-start:.7rem}.cds--checkbox-label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:flex;cursor:pointer;min-block-size:1.25rem;padding-block-start:.0625rem;padding-inline-start:1.25rem;-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--checkbox-label html{font-size:100%}.cds--checkbox-label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--checkbox-label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--checkbox-label strong{font-weight:600}.cds--checkbox-label-text{padding-inline-start:.625rem}.cds--checkbox-label::after,.cds--checkbox-label::before{box-sizing:border-box}@media print{.cds--checkbox-label::after,.cds--checkbox-label::before{print-color-adjust:exact}}.cds--checkbox-label::before{position:absolute;border:1px solid var(--cds-icon-primary,#161616);border-radius:2px;background-color:transparent;block-size:1rem;content:\"\";inline-size:1rem;inset-block-start:.125rem;inset-inline-start:0;margin-block:.0625rem .125rem;margin-inline:.1875rem 0}.cds--checkbox-label::after{position:absolute;background:0 0;block-size:.3125rem;border-block-end:1.5px solid var(--cds-icon-inverse,#fff);border-inline-start:1.5px solid var(--cds-icon-inverse,#fff);content:\"\";inline-size:.5625rem;inset-block-start:.40625rem;inset-inline-start:.4375rem;margin-block-start:-.1875rem;transform:scale(0) rotate(-45deg);transform-origin:bottom right}.cds--checkbox-label[data-contained-checkbox-state=true]::before,.cds--checkbox:checked+.cds--checkbox-label::before,.cds--checkbox:indeterminate+.cds--checkbox-label::before{border:none;border-width:1px;background-color:var(--cds-icon-primary,#161616)}.cds--checkbox-label[data-contained-checkbox-state=true]::after,.cds--checkbox:checked+.cds--checkbox-label::after{transform:scale(1) rotate(-45deg)}.cds--checkbox:indeterminate+.cds--checkbox-label::after{border-block-end:2px solid var(--cds-icon-inverse,#fff);border-inline-start:0 solid var(--cds-icon-inverse,#fff);inline-size:.5rem;inset-block-start:.6875rem;transform:scale(1) rotate(0)}.cds--checkbox-label[data-contained-checkbox-state=true].cds--checkbox-label__focus::before,.cds--checkbox-label__focus::before,.cds--checkbox:checked:focus+.cds--checkbox-label::before,.cds--checkbox:focus+.cds--checkbox-label::before,.cds--checkbox:indeterminate:focus+.cds--checkbox-label::before{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--checkbox-label[data-contained-checkbox-disabled=true],.cds--checkbox:disabled+.cds--checkbox-label{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--checkbox-label[data-contained-checkbox-disabled=true]::before,.cds--checkbox:disabled+.cds--checkbox-label::before{border-color:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-label[data-contained-checkbox-state=true][data-contained-checkbox-disabled=true]::before,.cds--checkbox:checked:disabled+.cds--checkbox-label::before,.cds--checkbox:indeterminate:disabled+.cds--checkbox-label::before{background-color:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-group[data-invalid] .cds--checkbox-label::before,.cds--checkbox-wrapper--invalid .cds--checkbox-label::before,.cds--checkbox-wrapper--invalid .cds--checkbox:checked+.cds--checkbox-label::before{border:1px solid var(--cds-support-error,#da1e28)}.cds--checkbox-group .cds--checkbox-wrapper--invalid>.cds--checkbox__validation-msg,.cds--checkbox-group .cds--checkbox-wrapper--warning>.cds--checkbox__validation-msg,.cds--checkbox-group .cds--checkbox-wrapper>.cds--form__helper-text{display:none}.cds--checkbox-group:not(.cds--checkbox-group[data-invalid]) .cds--checkbox-wrapper--invalid .cds--checkbox-label::before,.cds--checkbox-group:not(.cds--checkbox-group[data-invalid]) .cds--checkbox-wrapper--invalid .cds--checkbox:checked+.cds--checkbox-label::before{border:1px solid var(--cds-icon-primary,#161616)}.cds--checkbox-group__validation-msg,.cds--checkbox__validation-msg{display:none;align-items:flex-start;margin-block-start:.25rem}.cds--checkbox__invalid-icon{margin:.0625rem .0625rem 0 .1875rem;fill:var(--cds-support-error,#da1e28);min-inline-size:1rem}.cds--checkbox__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--checkbox__invalid-icon--warning path:first-of-type{fill:#000}.cds--checkbox-group--invalid .cds--checkbox-group__validation-msg,.cds--checkbox-group--warning .cds--checkbox-group__validation-msg,.cds--checkbox-wrapper--invalid>.cds--checkbox__validation-msg,.cds--checkbox-wrapper--warning>.cds--checkbox__validation-msg{display:flex}.cds--checkbox-group--invalid .cds--checkbox-group__validation-msg .cds--form-requirement,.cds--checkbox-group--warning .cds--checkbox-group__validation-msg .cds--form-requirement,.cds--checkbox-wrapper--invalid .cds--checkbox__validation-msg .cds--form-requirement,.cds--checkbox-wrapper--warning .cds--checkbox__validation-msg .cds--form-requirement{display:block;overflow:visible;margin-block-start:0;margin-inline-start:.5rem;max-block-size:100%}.cds--checkbox-group--invalid .cds--checkbox-group__validation-msg .cds--form-requirement,.cds--checkbox-wrapper--invalid .cds--checkbox__validation-msg .cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--checkbox-group--readonly .cds--checkbox-label,.cds--checkbox-wrapper--readonly .cds--checkbox-label{cursor:default}.cds--checkbox-group--readonly .cds--checkbox-label-text,.cds--checkbox-wrapper--readonly .cds--checkbox-label-text{cursor:text;-webkit-user-select:text;-moz-user-select:text;user-select:text}.cds--checkbox-group--readonly .cds--checkbox+.cds--checkbox-label::before,.cds--checkbox-wrapper--readonly .cds--checkbox+.cds--checkbox-label::before{border-color:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-group--readonly .cds--checkbox:checked+.cds--checkbox-label::before,.cds--checkbox-wrapper--readonly .cds--checkbox:checked+.cds--checkbox-label::before{border:1px solid var(--cds-icon-disabled,rgba(22,22,22,.25));background:0 0}.cds--checkbox-group--readonly .cds--checkbox:checked+.cds--checkbox-label::after,.cds--checkbox-wrapper--readonly .cds--checkbox:checked+.cds--checkbox-label::after{border-color:var(--cds-text-primary,#161616)}.cds--checkbox-skeleton .cds--checkbox-label{cursor:default}.cds--checkbox-label-text.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:1rem;inline-size:6.25rem;margin-block:.0625rem 0;margin-inline:.375rem 0}.cds--checkbox-label-text.cds--skeleton:active,.cds--checkbox-label-text.cds--skeleton:focus,.cds--checkbox-label-text.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--checkbox-label-text.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--checkbox-label-text.cds--skeleton::before{animation:none}}.cds--checkbox--inline{position:relative}[dir=rtl] .cds--checkbox-label::after{margin-block-start:0;margin-inline-start:-.0625rem;transform-origin:center}[dir=rtl] .cds--checkbox-label[data-contained-checkbox-state=true]::after,[dir=rtl] .cds--checkbox:checked+.cds--checkbox-label::after{transform:scale(1.2) rotate3d(.5,1,0,158deg)}.cds--checkbox-group--slug legend.cds--label,.cds--checkbox-wrapper--slug .cds--checkbox-label-text{display:flex}.cds--checkbox-group--slug legend.cds--label .cds--slug,.cds--checkbox-wrapper--slug .cds--checkbox-label-text .cds--slug{margin-inline-start:.5rem}.cds--checkbox-wrapper--slug .cds--checkbox-label-text .cds--slug__button--inline{line-height:inherit;margin-block-start:-.0625rem}.cds--checkbox-group--horizontal{position:relative;display:flex;flex-flow:row wrap;justify-content:flex-start}.cds--checkbox-group--horizontal .cds--form-item{flex:none;margin-block-end:0}.cds--checkbox-group--horizontal .cds--form-item:not(:last-of-type){margin-inline-end:1rem}.cds--checkbox-group--horizontal .cds--checkbox-label-text{padding-inline-start:.5rem}.cds--checkbox-group--horizontal .cds--label+.cds--form-item.cds--checkbox-wrapper{margin-block-start:0}.cds--list-box__wrapper--inline,:host(cds-dropdown[type=inline]){display:inline-grid;align-items:center;grid-gap:.25rem;grid-template:auto auto/auto auto}.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--list-box__wrapper--inline .cds--form-requirement,.cds--list-box__wrapper--inline .cds--form__helper-text,.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--label{margin:0}.cds--list-box__wrapper--inline .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--form__helper-text{max-inline-size:none}.cds--list-box__wrapper--inline .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form-requirement{grid-column:2}.cds--list-box{position:relative;border:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;inline-size:100%;max-block-size:2.5rem;transition:all 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box html{font-size:100%}.cds--list-box body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--list-box code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--list-box strong{font-weight:600}.cds--list-box:hover{background-color:var(--cds-field-hover)}.cds--list-box--lg{block-size:3rem;max-block-size:3rem}.cds--list-box--sm{block-size:2rem;max-block-size:2rem}.cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box--expanded:hover{background-color:var(--cds-field)}.cds--list-box--expanded:hover.cds--list-box--light:hover{background-color:var(--cds-field-02,#fff)}.cds--list-box .cds--text-input{block-size:100%;min-inline-size:0}.cds--list-box__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:2.5rem;transform:translateY(-50%)}.cds--list-box__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--list-box__invalid-icon--warning path[fill]{fill:#000;opacity:1}.cds--list-box.cds--list-box--warning .cds--list-box__field,.cds--list-box[data-invalid] .cds--list-box__field{border-block-end:0;padding-inline-end:4rem}.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field,.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:3.5rem}.cds--list-box--light{background-color:var(--cds-field-02,#fff)}.cds--list-box--light:hover{background-color:var(--cds-field-hover)}.cds--list-box--light .cds--list-box__menu{background:var(--cds-layer)}.cds--list-box--light .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle)}.cds--list-box--light.cds--list-box--expanded{border-block-end-color:transparent}.cds--list-box--disabled:hover{background-color:var(--cds-field)}.cds--list-box--light.cds--list-box--disabled{background-color:var(--cds-field-02,#fff)}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__field:focus{border-block-end-color:transparent;outline:0}.cds--list-box--disabled .cds--list-box__label,.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__menu-icon>svg,.cds--list-box--disabled .cds--list-box__selection>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__menu-icon{cursor:not-allowed}.cds--list-box--disabled .cds--list-box__menu-item,.cds--list-box--disabled .cds--list-box__menu-item--highlighted,.cds--list-box--disabled .cds--list-box__menu-item:hover,.cds--list-box--disabled :host(cds-dropdown-item){color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}.cds--list-box--disabled .cds--list-box__selection:hover{cursor:not-allowed}.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field{padding-inline-end:3rem}.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:2rem}.cds--list-box.cds--list-box--inline{border-width:0;background-color:transparent}.cds--list-box.cds--list-box--inline:hover{background-color:var(--cds-layer-hover)}.cds--list-box.cds--list-box--inline.cds--list-box--expanded{border-block-end-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true]{border-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover,.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover{background-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__field{padding:0 2rem 0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon{inset-inline-end:.5rem}.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon{inset-inline-end:2rem}.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-primary,#161616)}.cds--list-box--inline .cds--list-box__field{block-size:100%}.cds--dropdown--inline .cds--list-box__field{max-inline-size:30rem}.cds--dropdown--inline .cds--list-box__menu{max-inline-size:30rem;min-inline-size:18rem}.cds--list-box__field{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;overflow:hidden;align-items:center;block-size:calc(100% + 1px);cursor:pointer;outline:0;padding-block:0;padding-inline-end:3rem;padding-inline-start:1rem;text-overflow:ellipsis;vertical-align:top;white-space:nowrap}.cds--list-box__field *,.cds--list-box__field ::after,.cds--list-box__field ::before{box-sizing:inherit}.cds--list-box__field::-moz-focus-inner{border:0}.cds--list-box__field:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__field:focus{outline-style:dotted}}.cds--list-box__field[disabled]{color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--list-box__field .cds--text-input{padding-inline-end:5rem}.cds--list-box--warning .cds--list-box__field .cds--text-input,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input{padding-inline-end:6.5625rem}.cds--list-box--warning .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon{inset-inline-end:5.125rem}.cds--list-box__field .cds--text-input--empty{padding-inline-end:3rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon{inset-inline-end:2.5rem}.cds--list-box__label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);overflow:hidden;color:var(--cds-text-primary,#161616);text-overflow:ellipsis;-webkit-user-select:none;-moz-user-select:none;user-select:none;white-space:nowrap}.cds--list-box__menu-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-inline-end:.75rem;outline:0;transition:transform 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu-icon *,.cds--list-box__menu-icon ::after,.cds--list-box__menu-icon ::before{box-sizing:inherit}.cds--list-box__menu-icon::-moz-focus-inner{border:0}.cds--list-box__menu-icon>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box__menu-icon--open{justify-content:center;inline-size:1.5rem;transform:rotate(180deg)}.cds--list-box__selection{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-block-start:50%;inset-inline-end:2.8125rem;transform:translateY(-50%);transition:background-color 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__selection *,.cds--list-box__selection ::after,.cds--list-box__selection ::before{box-sizing:inherit}.cds--list-box__selection::-moz-focus-inner{border:0}.cds--list-box__selection:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus{outline-style:dotted}}.cds--list-box__selection:focus:hover{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus:hover{outline-style:dotted}}.cds--list-box__selection>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box--disabled .cds--list-box__selection:focus{outline:0}.cds--list-box__selection--multi{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);position:static;display:flex;align-items:center;justify-content:space-between;padding:.5rem;border-radius:.75rem;background-color:var(--cds-background-inverse,#393939);block-size:1.5rem;color:var(--cds-text-inverse,#fff);inline-size:auto;inset-block-start:auto;line-height:0;margin-inline-end:.625rem;padding-inline-end:.125rem;transform:none}.cds--list-box__selection--multi>svg{padding:.125rem;block-size:1.25rem;fill:var(--cds-icon-inverse,#fff);inline-size:1.25rem;margin-inline-start:.25rem}.cds--list-box__selection--multi>svg:hover{border-radius:50%;background-color:var(--cds-button-secondary-hover,#474747)}.cds--list-box--disabled .cds--list-box__selection--multi{background-color:var(--cds-text-disabled,rgba(22,22,22,.25));color:var(--cds-layer)}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational{border:1px solid var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg:hover{background-color:initial}.cds--list-box__selection--multi:hover{outline:0}.cds--list-box__menu{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));position:absolute;z-index:9100;display:none;background-color:var(--cds-layer);inline-size:100%;inset-inline-end:0;inset-inline-start:0;overflow-y:auto;transition:max-height 110ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--list-box__menu:focus{outline-style:dotted}}.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu{display:none;max-block-size:0;visibility:hidden}.cds--list-box--expanded .cds--list-box__menu{display:block;max-block-size:13.75rem}.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu{max-block-size:16.5rem}.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu{max-block-size:11rem}.cds--list-box__menu-item,:host(cds-dropdown-item){font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;block-size:2.5rem;color:var(--cds-text-secondary,#525252);cursor:pointer;transition:background 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--light .cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box--sm .cds--list-box__menu-item,.cds--list-box--sm :host(cds-dropdown-item){block-size:2rem}.cds--list-box--lg .cds--list-box__menu-item,.cds--list-box--lg :host(cds-dropdown-item){block-size:3rem}.cds--list-box--disabled .cds--list-box__menu-item:hover{background-color:transparent}.cds--list-box--light .cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item:hover .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item__option{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;outline:2px solid transparent;outline-offset:-2px;display:block;overflow:hidden;padding:.6875rem 0;margin:0 1rem;block-size:2.5rem;border-block-end:1px solid transparent;border-block-start:1px solid transparent;border-block-start-color:var(--cds-border-subtle-01,#c6c6c6);color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;padding-inline-end:1.5rem;text-decoration:none;text-overflow:ellipsis;transition:border-color 70ms cubic-bezier(.2,0,.38,.9),color 70ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}.cds--list-box__menu-item__option *,.cds--list-box__menu-item__option ::after,.cds--list-box__menu-item__option ::before{box-sizing:inherit}.cds--list-box__menu-item__option:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;border-color:transparent;margin:0}@media screen and (prefers-contrast){.cds--list-box__menu-item__option:focus{outline-style:dotted}}.cds--list-box__menu-item__option:hover{border-color:transparent;color:var(--cds-text-primary,#161616)}.cds--list-box--sm .cds--list-box__menu-item__option{block-size:2rem;padding-block-end:.4375rem;padding-block-start:.4375rem}.cds--list-box--lg .cds--list-box__menu-item__option{block-size:3rem;padding-block-end:.9375rem;padding-block-start:.9375rem}.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled],.cds--list-box__menu-item[disabled] *,.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;outline:0}.cds--list-box__menu-item[disabled]:hover{background-color:revert}.cds--list-box__menu-item[disabled] .cds--checkbox-label::before{border-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item--active+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option{margin:0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus{margin:0;padding-inline-end:.5rem;padding-inline-start:.5rem}.cds--list-box__menu-item--highlighted,:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;color:var(--cds-text-primary,#161616)}@media screen and (prefers-contrast){.cds--list-box__menu-item--highlighted,:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline-style:dotted}}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active,:host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}.cds--list-box--light .cds--list-box__menu-item--active,.cds--list-box--light :host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected)}.cds--list-box__menu-item--active:hover{background-color:var(--cds-layer-selected-hover);border-block-end-color:var(--cds-layer-selected-hover)}.cds--list-box__menu-item--active .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active+.cds--list-box__menu-item>.cds--list-box__menu-item__option,.cds--list-box__menu-item--active+:host(cds-dropdown-item)>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item)>.cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item__selected-icon{position:absolute;display:none;fill:var(--cds-icon-primary,#161616);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--list-box--inline .cds--list-box__menu-item__selected-icon{inset-inline-end:.5rem}.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}.cds--list-box__menu-item .cds--checkbox-label,:host(cds-dropdown-item) .cds--checkbox-label{inline-size:100%}.cds--list-box__menu-item .cds--checkbox-label-text,:host(cds-dropdown-item) .cds--checkbox-label-text{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.cds--list-box--up .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box__menu{inset-block-end:2.5rem}.cds--list-box--up .cds--list-box--sm .cds--list-box__menu,.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--sm .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--sm .cds--list-box__menu{inset-block-end:2rem}.cds--list-box--up .cds--list-box--lg .cds--list-box__menu,.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--lg .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--lg .cds--list-box__menu{inset-block-end:3rem}.cds--list-box input[role=combobox],.cds--list-box input[type=text]{background-color:inherit;min-inline-size:0;text-overflow:ellipsis}.cds--list-box__wrapper--slug .cds--slug,:host(cds-dropdown[slug]) .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:calc(2.5rem + 9px);margin-block-start:.03125rem;transform:translateY(-50%)}.cds--list-box__wrapper--slug .cds--slug::after,.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem}.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::before{display:none;inset-inline-start:-.5625rem}.cds--list-box__wrapper--slug .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::after{display:block;inset-inline-end:-.5625rem}.cds--list-box__wrapper--slug .cds--slug--revert::after,:host(cds-dropdown[slug]) .cds--slug--revert::after{inset-block-start:.5rem;inset-inline-end:-.0625rem}.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)),:host(cds-dropdown[slug]) .cds--list-box:not(:has(.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff)}.cds--list-box__wrapper--slug .cds--list-box input[role=combobox],:host(cds-dropdown[slug]) .cds--list-box input[role=combobox]{border-block-end-color:transparent}.cds--list-box__wrapper--slug .cds--list-box__field,.cds--list-box__wrapper--slug .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box__field,:host(cds-dropdown[slug]) .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--text-input:not(.cds--text-input--empty){padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input--empty{padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty){padding-inline-end:8.8125rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning{inset-inline-end:5.1875rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--slug::before{display:block}.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,:host(cds-dropdown[slug]) .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug{inset-inline-end:calc(4rem + 18px)}.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon{inset-inline-end:7.25rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field,.cds--list-box__menu,.cds--multi-select .cds--tag--filter{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field:focus,.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--multi-select .cds--tag__close-icon:focus,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-icon>svg,.cds--list-box__selection--multi>svg,.cds--list-box__selection>svg{fill:ButtonText}}.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-start:2.0625rem}.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-end:2.0625rem}.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon,:has(.cds--multi-select):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon,:has(.cds--dropdown):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}:host(cds-dropdown){outline:0}:host(cds-dropdown) .cds--assistive-text{inset-block-start:-100%;inset-inline-start:-100%}:host(cds-dropdown) .cds--label[hidden]{display:none}:host(cds-dropdown) .cds--list-box__menu{inset-block-start:100%;margin-block-start:1px;outline:1px solid var(--cds-focus,#0f62fe)}:host(cds-dropdown[open]) .cds--list-box__field{outline:0}:host(cds-dropdown[invalid]) .cds--list-box__field{outline:0}:host(cds-dropdown[invalid]) .cds--form__helper-text{color:var(--cds-text-error,#da1e28)}:host(cds-dropdown[read-only]) .cds--list-box{background-color:transparent;border-block-end-color:var(--cds-border-subtle)}:host(cds-combo-box[direction=top]) .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box__menu{inset-block-start:auto}:host(cds-dropdown[type=inline]){grid-gap:0 1.5rem}:host(cds-dropdown[type=inline][warn]) .cds--list-box__field{padding-inline:1rem calc(2.5rem + 1rem)}:host(cds-dropdown[invalid]) .cds--form__helper-text,:host(cds-dropdown[warn]) .cds--form__helper-text{grid-column:2}:host(cds-dropdown-item){display:block}:host(cds-dropdown-item) .cds--list-box__menu-item__option{block-size:auto}:host(cds-dropdown-item:first-child) .cds--list-box__menu-item__option{border-block-start-width:0}:host(cds-dropdown-item:hover){background-color:var(--cds-layer-hover)}:host(cds-dropdown-item[disabled]) .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}:host(cds-dropdown-item[size=sm]){block-size:2rem}:host(cds-dropdown-item[size=sm]) .cds--list-box__menu-item__option{padding-block:.4375rem}:host(cds-dropdown-item[size=lg]){block-size:3rem}:host(cds-dropdown-item[size=lg]) .cds--list-box__menu-item__option{padding-block:.9375rem}:host(cds-dropdown-skeleton) .cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}:host(cds-dropdown-skeleton) .cds--skeleton:active,:host(cds-dropdown-skeleton) .cds--skeleton:focus,:host(cds-dropdown-skeleton) .cds--skeleton:hover{border:none;cursor:default;outline:0}:host(cds-dropdown-skeleton) .cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){:host(cds-dropdown-skeleton) .cds--skeleton::before{animation:none}}:host(cds-dropdown[slug]) ::slotted(cds-slug){position:absolute;inset-block-start:50%;inset-inline-end:2.5rem}:host(cds-dropdown[slug]) ::slotted(cds-slug:not([revert-active])){transform:translateY(-50%)}:host(cds-dropdown[slug][invalid]) .cds--list-box .cds--list-box__field,:host(cds-dropdown[slug][warn]) .cds--list-box .cds--list-box__field{padding-inline-end:6rem}:host(cds-dropdown[slug][invalid]) ::slotted(cds-slug),:host(cds-dropdown[slug][warn]) ::slotted(cds-slug){inset-inline-end:4rem}",
]);

let _$X = t => t,
  _t$Z,
  _t2$t,
  _t3$j,
  _t4$c;

/**
 * Dropdown.
 *
 * @element cds-dropdown
 * @csspart label-text The label text.
 * @csspart helper-text The helper text.
 * @csspart trigger-button The trigger button.
 * @csspart menu-body The menu body.
 * @csspart validity-message The validity message.
 * @fires cds-dropdown-beingselected
 *   The custom event fired before a dropdown item is selected upon a user gesture.
 *   Cancellation of this event stops changing the user-initiated selection.
 * @fires cds-dropdown-beingtoggled
 *   The custom event fired before the open state of this dropdown is toggled upon a user gesture.
 *   Cancellation of this event stops the user-initiated toggling.
 * @fires cds-dropdown-selected - The custom event fired after a dropdown item is selected upon a user gesture.
 * @fires cds-dropdown-toggled - The custom event fired after the open state of this dropdown is toggled upon a user gesture.
 */
let CDSDropdown = _decorate$Z([carbonElement(`${prefix$B}-dropdown`)], function (_initialize, _ValidityMixin) {
  class CDSDropdown extends _ValidityMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSDropdown,
    d: [{
      kind: "field",
      key: "_hasSlug",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_activeDescendant",
      value: void 0
    }, {
      kind: "field",
      key: "_selectedItemContent",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_shouldTriggerBeFocusable",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$B}--list-box`)],
      key: "_listBoxNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('slot[name="helper-text"]')],
      key: "_slotHelperTextNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('slot[name="title-text"]')],
      key: "_slotTitleTextNode",
      value: void 0
    }, {
      kind: "method",
      key: "_selectionShouldChange",
      value:
      /**
       * `true` if there is a slug.
       */

      /**
       * The content of the selected item.
       */

      /**
       * `true` if the trigger button should be focusable.
       * Derived class can set `false` to this if the trigger button contains another primary focusable element (e.g. `<input>`).
       */

      /**
       * The list box `<div>` node.
       */

      /**
       * The `<slot>` element for the helper text in the shadow DOM.
       */

      /**
       * The `<slot>` element for the title text in the shadow DOM.
       */

      /**
       * @param itemToSelect A dropdown item. Absense of this argument means clearing selection.
       * @returns `true` if the selection of this dropdown should change if the given item is selected upon user interaction.
       */
      function _selectionShouldChange(itemToSelect) {
        return !itemToSelect || itemToSelect.value !== this.value;
      }

      /**
       * A callback that runs after change in dropdown selection upon user interaction is confirmed.
       *
       * @param itemToSelect
       *   A dropdown item.
       *   Absense of this argument means clearing selection, which may be handled by a derived class.
       */
    }, {
      kind: "method",
      key: "_selectionDidChange",
      value: function _selectionDidChange(itemToSelect) {
        if (itemToSelect) {
          this.value = itemToSelect.value;
          this._activeDescendant = itemToSelect.id;
          forEach$1(this.querySelectorAll(this.constructor.selectorItemSelected), item => {
            item.selected = false;
            item.setAttribute('aria-selected', 'false');
          });
          itemToSelect.selected = true;
          itemToSelect.setAttribute('aria-selected', 'true');
          this._handleUserInitiatedToggle(false);
        }
      }

      /**
       * Handles `click` event on the top-level element in the shadow DOM.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleClickInner",
      value: function _handleClickInner(event) {
        if (this.readOnly) {
          return;
        }
        if (this.shadowRoot.contains(event.target)) {
          this._handleUserInitiatedToggle();
        } else {
          const item = event.target.closest(this.constructor.selectorItem);
          if (this.contains(item)) {
            this._handleUserInitiatedSelectItem(item);
          }
        }
      }

      /**
       * Handler for the `keydown` event on the top-level element in the shadow DOM.
       */
    }, {
      kind: "method",
      key: "_handleKeydownInner",
      value: function _handleKeydownInner(event) {
        const {
          key
        } = event;
        const action = this.constructor.getAction(key);
        if (!this.open) {
          switch (action) {
            case DROPDOWN_KEYBOARD_ACTION.NAVIGATING:
              this._handleUserInitiatedToggle(true);
              // If this menu gets open with an arrow key, reset the highlight
              this._clearHighlight();
              break;
          }
        } else {
          switch (action) {
            case DROPDOWN_KEYBOARD_ACTION.CLOSING:
              this._handleUserInitiatedToggle(false);
              break;
            case DROPDOWN_KEYBOARD_ACTION.NAVIGATING:
              this._navigate(NAVIGATION_DIRECTION$1[key]);
              break;
          }
        }
      }

      /**
       * Handler for the `keypress` event on the top-level element in the shadow DOM.
       */
    }, {
      kind: "method",
      key: "_handleKeypressInner",
      value: function _handleKeypressInner(event) {
        const {
          key
        } = event;
        const action = this.constructor.getAction(key);
        if (!this.open) {
          switch (action) {
            case DROPDOWN_KEYBOARD_ACTION.TRIGGERING:
              this._handleUserInitiatedToggle(true);
              break;
          }
        } else {
          switch (action) {
            case DROPDOWN_KEYBOARD_ACTION.TRIGGERING:
              {
                const constructor = this.constructor;
                const highlightedItem = this.querySelector(constructor.selectorItemHighlighted);
                if (highlightedItem) {
                  this._handleUserInitiatedSelectItem(highlightedItem);
                } else {
                  this._handleUserInitiatedToggle(false);
                }
              }
              break;
          }
        }
      }

      /**
       * Handles `blur` event handler on the document this element is in.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusout')],
      key: "_handleFocusOut",
      value: function _handleFocusOut(event) {
        if (!this.contains(event.relatedTarget)) {
          this._handleUserInitiatedToggle(false);
        }
      }

      /**
       * Handles `slotchange` event for the `<slot>` for helper text.
       */
    }, {
      kind: "method",
      key: "_handleSlotchangeHelperText",
      value: function _handleSlotchangeHelperText() {
        this.requestUpdate();
      }

      /**
       * Handles `slotchange` event for the `<slot>` for label text.
       */
    }, {
      kind: "method",
      key: "_handleSlotchangeLabelText",
      value: function _handleSlotchangeLabelText() {
        this.requestUpdate();
      }

      /**
       * Handles `slotchange` event.
       */
    }, {
      kind: "method",
      key: "_handleSlugSlotChange",
      value: function _handleSlugSlotChange({
        target
      }) {
        const hasContent = target.assignedNodes().filter(elem => elem.matches !== undefined ? elem.matches(this.constructor.slugItem) : false);
        this._hasSlug = Boolean(hasContent);
        hasContent[0].setAttribute('size', 'mini');
        this.requestUpdate();
      }

      /**
       * Handles user-initiated selection of a dropdown item.
       *
       * @param [item] The dropdown item user wants to select. Absense of this argument means clearing selection.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedSelectItem",
      value: function _handleUserInitiatedSelectItem(item) {
        if (item !== null && item !== void 0 && item.hasAttribute('disabled')) {
          return;
        }
        if (this._selectionShouldChange(item)) {
          const init = {
            bubbles: true,
            composed: true,
            detail: {
              item
            }
          };
          const constructor = this.constructor;
          const beforeSelectEvent = new CustomEvent(constructor.eventBeforeSelect, _objectSpread2(_objectSpread2({}, init), {}, {
            cancelable: true
          }));
          if (this.dispatchEvent(beforeSelectEvent)) {
            this._selectionDidChange(item);
            const afterSelectEvent = new CustomEvent(constructor.eventSelect, init);
            this.dispatchEvent(afterSelectEvent);
          }
        }
      }

      /**
       * Handles user-initiated toggling the open state.
       *
       * @param [force] If specified, forces the open state to the given one.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedToggle",
      value: function _handleUserInitiatedToggle(force = !this.open) {
        const {
          eventBeforeToggle,
          eventToggle
        } = this.constructor;
        const {
          disabled
        } = this;
        const init = {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            open: force
          }
        };
        if (!disabled) {
          if (this.dispatchEvent(new CustomEvent(eventBeforeToggle, init))) {
            this.open = force;
            if (!this.open) {
              forEach$1(this.querySelectorAll(this.constructor.selectorItemHighlighted), item => {
                item.highlighted = false;
              });
            }
            this.requestUpdate();
            this.dispatchEvent(new CustomEvent(eventToggle, init));
          }
        }
      }

      /**
       * Clears the selection of dropdown items.
       */
    }, {
      kind: "method",
      key: "_clearHighlight",
      value: function _clearHighlight() {
        forEach$1(this.querySelectorAll(this.constructor.selectorItem), item => {
          item.highlighted = false;
        });
      }

      /**
       * Navigate through dropdown items.
       *
       * @param direction `-1` to navigate backward, `1` to navigate forward.
       */
    }, {
      kind: "method",
      key: "_navigate",
      value: function _navigate(direction) {
        var _items$nextIndex;
        const constructor = this.constructor;
        const items = this.querySelectorAll(constructor.selectorItem);
        const highlightedItem = this.querySelector(constructor.selectorItemHighlighted);
        const highlightedIndex = indexOf$1(items, highlightedItem);
        let nextIndex = highlightedIndex + direction;
        if ((_items$nextIndex = items[nextIndex]) !== null && _items$nextIndex !== void 0 && _items$nextIndex.hasAttribute('disabled')) {
          nextIndex += direction;
        }
        if (nextIndex < 0) {
          nextIndex = items.length - 1;
        }
        if (nextIndex >= items.length) {
          nextIndex = 0;
        }
        forEach$1(items, (item, i) => {
          item.highlighted = i === nextIndex;
        });
        const nextItem = items[nextIndex];
        // Using `{ block: 'nearest' }` to prevent scrolling unless scrolling is absolutely necessary.
        // `scrollIntoViewOptions` seems to work in latest Safari despite of MDN/caniuse table.
        // IE falls back to the old behavior.
        nextItem.scrollIntoView({
          block: 'nearest'
        });
        const nextItemId = nextItem.id;
        if (nextItemId) {
          this._activeDescendant = nextItemId;
        }
      }

      /* eslint-disable class-methods-use-this */
      /**
       * @returns The content preceding the trigger button.
       */
    }, {
      kind: "method",
      key: "_renderPrecedingLabel",
      value: function _renderPrecedingLabel() {
        return undefined;
      }
      /* eslint-enable class-methods-use-this */

      /**
       * @returns The main content of the trigger button.
       */
    }, {
      kind: "method",
      key: "_renderLabel",
      value: function _renderLabel() {
        const {
          label,
          _selectedItemContent: selectedItemContent
        } = this;
        return x(_t$Z || (_t$Z = _$X`
      <span id="trigger-label" class="${0}--list-box__label"
        >${0}</span
      >
    `), prefix$B, selectedItemContent || label);
      }

      /**
       * @returns The title label.
       */
    }, {
      kind: "method",
      key: "_renderTitleLabel",
      value: function _renderTitleLabel() {
        const {
          disabled,
          hideLabel,
          titleText,
          _slotTitleTextNode: slotTitleTextNode,
          _handleSlotchangeLabelText: handleSlotchangeLabelText
        } = this;
        const labelClasses = o$2({
          [`${prefix$B}--label`]: true,
          [`${prefix$B}--label--disabled`]: disabled,
          [`${prefix$B}--visually-hidden`]: hideLabel
        });
        const hasTitleText = titleText || slotTitleTextNode && slotTitleTextNode.assignedNodes().length > 0;
        return x(_t2$t || (_t2$t = _$X`
      <label
        id="dropdown-label"
        part="title-text"
        class="${0}"
        for="trigger-button"
        ?hidden="${0}">
        <slot name="title-text" @slotchange="${0}"
          >${0}</slot
        >
      </label>
    `), labelClasses, !hasTitleText, handleSlotchangeLabelText, titleText);
      }

      /* eslint-disable class-methods-use-this */
      /**
       * @returns The content following the trigger button.
       */
    }, {
      kind: "method",
      key: "_renderFollowingLabel",
      value: function _renderFollowingLabel() {
        return undefined;
      }
      /* eslint-enable class-methods-use-this */

      /**
       * Handles event to include selected value on the parent form.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleFormdata",
      value: function _handleFormdata(event) {
        const {
          formData
        } = event; // TODO: Wait for `FormDataEvent` being available in `lib.dom.d.ts`
        const {
          disabled,
          name,
          value
        } = this;
        if (!disabled) {
          formData.append(name, value);
        }
      }

      /**
       * 'aria-label' of the ListBox component.
       * Specify a label to be read by screen readers on the container node
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true,
        attribute: 'aria-label'
      })],
      key: "ariaLabel",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true
      })],
      key: "direction",
      value() {
        return DROPDOWN_DIRECTION.BOTTOM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'helper-text'
      })],
      key: "helperText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'hide-label'
      })],
      key: "hideLabel",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "invalid",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'invalid-text'
      })],
      key: "invalidText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'title-text'
      })],
      key: "titleText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "name",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "open",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'read-only'
      })],
      key: "readOnly",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "required",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'required-validity-message'
      })],
      key: "requiredValidityMessage",
      value() {
        return 'Please fill out this field.';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return DROPDOWN_SIZE.MEDIUM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'toggle-label-closed'
      })],
      key: "toggleLabelClosed",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'toggle-label-open'
      })],
      key: "toggleLabelOpen",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'label'
      })],
      key: "label",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "type",
      value() {
        return DROPDOWN_TYPE.DEFAULT;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'validity-message'
      })],
      key: "validityMessage",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "value",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "warn",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'warn-text'
      })],
      key: "warnText",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "shouldUpdate",
      value:
      /**
       * Specify the direction of the dropdown. Can be either top or bottom.
       */
      /**
       * `true` if this dropdown should be disabled.
       */
      /**
       * The helper text.
       */
      /**
       * Specify whether the title text should be hidden or not
       */
      /**
       * `true` to show the UI of the invalid state.
       */
      /**
       * Message which is displayed if the value is invalid.
       */
      /**
       * Provide the title text that will be read by a screen reader when visiting this control
       */
      /**
       * Name for the dropdown in the `FormData`
       */
      /**
       * `true` if this dropdown should be open.
       */
      /**
       * Whether or not the Dropdown is readonly
       */
      /**
       * `true` if the value is required.
       */
      /**
       * The special validity message for `required`.
       */
      /**
       * Dropdown size.
       */
      /**
       * The `aria-label` attribute for the UI indicating the closed state.
       */
      /**
       * The `aria-label` attribute for the UI indicating the open state.
       */
      /**
       * Generic label that will be used as the textual representation of what this field is for
       */
      /**
       * `true` if this dropdown should use the inline UI variant.
       */
      /**
       * The validity message.
       */
      /**
       * The value of the selected item.
       */
      /**
       * Specify whether the control is currently in warning state
       */
      /**
       * Provide the text that is displayed when the control is in warning state
       */
      function shouldUpdate(changedProperties) {
        const {
          selectorItem
        } = this.constructor;
        if (changedProperties.has('size')) {
          forEach$1(this.querySelectorAll(selectorItem), elem => {
            elem.size = this.size;
          });
        }
        if (changedProperties.has('disabled') && this.disabled) {
          const {
            disabled
          } = this;
          // Propagate `disabled` attribute to descendants until `:host-context()` gets supported in all major browsers
          forEach$1(this.querySelectorAll(selectorItem), elem => {
            if (disabled) {
              elem.disabled = disabled;
            } else {
              elem.removeAttribute('disabled');
            }
          });
        }
        if (changedProperties.has('value')) {
          // `<cds-multi-select>` updates selection beforehand
          // because our rendering logic for `<cds-multi-select>` looks for selected items via `qSA()`
          forEach$1(this.querySelectorAll(selectorItem), elem => {
            elem.selected = elem.value === this.value;
          });
          const item = find$1(this.querySelectorAll(selectorItem), elem => elem.value === this.value);
          if (item) {
            const range = this.ownerDocument.createRange();
            range.selectNodeContents(item);
            this._selectedItemContent = range.cloneContents();
          } else {
            this._selectedItemContent = null;
          }
        }
        return true;
      }

      // eslint-disable-next-line @typescript-eslint/no-unused-vars
    }, {
      kind: "method",
      key: "updated",
      value: function updated(_changedProperties) {
        var _this$shadowRoot, _this$querySelector;
        this._hasSlug ? this.setAttribute('slug', '') : this.removeAttribute('slug');
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || (_this$shadowRoot = _this$shadowRoot.querySelector("slot[name='slug']")) === null || _this$shadowRoot === void 0 || _this$shadowRoot.classList.toggle(`${prefix$B}--slug--revert`, (_this$querySelector = this.querySelector(`${prefix$B}-slug`)) === null || _this$querySelector === void 0 ? void 0 : _this$querySelector.hasAttribute('revert-active'));
      }

      /**
       * The CSS class list for dropdown listbox
       */
    }, {
      kind: "get",
      key: "_classes",
      value: function () {
        const {
          disabled,
          size,
          type,
          invalid,
          open,
          warn
        } = this;
        const inline = type === DROPDOWN_TYPE.INLINE;
        const selectedItemsCount = this.querySelectorAll(this.constructor.selectorItemSelected).length;
        return o$2({
          [`${prefix$B}--dropdown`]: true,
          [`${prefix$B}--list-box`]: true,
          [`${prefix$B}--list-box--disabled`]: disabled,
          [`${prefix$B}--list-box--inline`]: inline,
          [`${prefix$B}--list-box--expanded`]: open,
          [`${prefix$B}--list-box--${size}`]: size,
          [`${prefix$B}--dropdown--invalid`]: invalid,
          [`${prefix$B}--dropdown--warn`]: warn,
          [`${prefix$B}--dropdown--inline`]: inline,
          [`${prefix$B}--dropdown--selected`]: selectedItemsCount > 0
        });
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          ariaLabel,
          _classes: classes,
          disabled,
          helperText,
          invalid,
          invalidText,
          open,
          toggleLabelClosed,
          toggleLabelOpen,
          type,
          warn,
          warnText,
          _activeDescendant: activeDescendant,
          _shouldTriggerBeFocusable: shouldTriggerBeFocusable,
          _handleClickInner: handleClickInner,
          _handleKeydownInner: handleKeydownInner,
          _handleKeypressInner: handleKeypressInner,
          _handleSlotchangeHelperText: handleSlotchangeHelperText,
          _handleSlugSlotChange: handleSlugSlotChange,
          _slotHelperTextNode: slotHelperTextNode
        } = this;
        const inline = type === DROPDOWN_TYPE.INLINE;
        let activeDescendantFallback;
        if (open && !activeDescendant) {
          var _items$;
          const constructor = this.constructor;
          const items = this.querySelectorAll(constructor.selectorItem);
          activeDescendantFallback = (_items$ = items[0]) === null || _items$ === void 0 ? void 0 : _items$.id;
        }
        const helperClasses = o$2({
          [`${prefix$B}--form__helper-text`]: true,
          [`${prefix$B}--form__helper-text--disabled`]: disabled
        });
        const iconContainerClasses = o$2({
          [`${prefix$B}--list-box__menu-icon`]: true,
          [`${prefix$B}--list-box__menu-icon--open`]: open
        });
        const toggleLabel = (open ? toggleLabelOpen : toggleLabelClosed) || undefined;
        const hasHelperText = helperText || invalidText || warnText || slotHelperTextNode && slotHelperTextNode.assignedNodes().length > 0;
        const validityIcon = !invalid ? undefined : svgResultCarbonIcon$G({
          class: `${prefix$B}--list-box__invalid-icon`,
          'aria-label': toggleLabel
        });
        const warningIcon = !warn || invalid && warn ? undefined : svgResultCarbonIcon$F({
          class: `${prefix$B}--list-box__invalid-icon ${prefix$B}--list-box__invalid-icon--warning`,
          'aria-label': toggleLabel
        });
        const helperMessage = invalid ? invalidText : warn ? warnText : helperText;
        const menuBody = x(_t3$j || (_t3$j = _$X`
      <div
        aria-labelledby="${0}"
        aria-label="${0}"
        id="menu-body"
        part="menu-body"
        class="${0}--list-box__menu"
        role="listbox"
        tabindex="-1"
        ?hidden=${0}>
        <slot></slot>
      </div>
    `), l(ariaLabel ? undefined : 'dropdown-label'), l(ariaLabel ? ariaLabel : undefined), prefix$B, !open);
        return x(_t4$c || (_t4$c = _$X`
      ${0}
      <div
        class="${0}"
        ?data-invalid=${0}
        @click=${0}
        @keydown=${0}
        @keypress=${0}>
        <div
          id="${0}"
          class="${0}--list-box__field"
          part="trigger-button"
          tabindex="${0}"
          role="${0}"
          aria-labelledby="${0}"
          aria-expanded="${0}"
          aria-haspopup="${0}"
          aria-controls="${0}"
          aria-activedescendant="${0}">
          ${0}${0}${0}${0}${0}
          <div id="trigger-caret" class="${0}">
            ${0}
          </div>
        </div>
        <slot name="slug" @slotchange=${0}></slot>
        ${0}
      </div>
      <div
        part="helper-text"
        class="${0}"
        ?hidden="${0}">
        <slot name="helper-text" @slotchange="${0}"
          >${0}</slot
        >
      </div>
    `), this._renderTitleLabel(), classes, invalid, handleClickInner, handleKeydownInner, handleKeypressInner, l(!shouldTriggerBeFocusable ? undefined : 'trigger-button'), prefix$B, l(!shouldTriggerBeFocusable ? undefined : '0'), l(!shouldTriggerBeFocusable ? undefined : 'combobox'), l(!shouldTriggerBeFocusable ? undefined : 'dropdown-label'), l(!shouldTriggerBeFocusable ? undefined : String(open)), l(!shouldTriggerBeFocusable ? undefined : 'listbox'), l(!shouldTriggerBeFocusable ? undefined : 'menu-body'), l(!shouldTriggerBeFocusable ? undefined : open ? activeDescendant !== null && activeDescendant !== void 0 ? activeDescendant : activeDescendantFallback : ''), this._renderPrecedingLabel(), this._renderLabel(), validityIcon, warningIcon, this._renderFollowingLabel(), iconContainerClasses, svgResultCarbonIcon$H({
          'aria-label': toggleLabel
        }), handleSlugSlotChange, menuBody, helperClasses, inline && !warn && !invalid || !hasHelperText, handleSlotchangeHelperText, helperMessage);
      }

      /**
       * Symbols of keys that triggers opening/closing menu and selecting/deselecting menu item.
       */
    }, {
      kind: "field",
      static: true,
      key: "TRIGGER_KEYS",
      value() {
        return new Set([' ', 'Enter']);
      }
    }, {
      kind: "get",
      static: true,
      key: "selectorItemHighlighted",
      value:
      /**
       * A selector that will return highlighted items.
       */
      function () {
        return `${prefix$B}-dropdown-item[highlighted]`;
      }

      /**
       * A selector that will return dropdown items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${prefix$B}-dropdown-item`;
      }

      /**
       * A selector that will return selected items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemSelected",
      value: function () {
        return `${prefix$B}-dropdown-item[selected]`;
      }

      /**
       * The name of the custom event fired before a dropdown item is selected upon a user gesture.
       * Cancellation of this event stops changing the user-initiated selection.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeSelect",
      value: function () {
        return `${prefix$B}-dropdown-beingselected`;
      }

      /**
       * The name of the custom event fired after a a dropdown item is selected upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelect",
      value: function () {
        return `${prefix$B}-dropdown-selected`;
      }

      /**
       * The name of the custom event fired before this dropdown item is being toggled upon a user gesture.
       * Cancellation of this event stops the user-initiated action of toggling this dropdown item.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeToggle",
      value: function () {
        return `${prefix$B}-dropdown-beingtoggled`;
      }

      /**
       * The name of the custom event fired after this dropdown item is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggle",
      value: function () {
        return `${prefix$B}-dropdown-toggled`;
      }

      /**
       * A selector that will return the slug item.
       */
    }, {
      kind: "get",
      static: true,
      key: "slugItem",
      value: function () {
        return `${prefix$B}-slug`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$k;
      }
    }, {
      kind: "method",
      static: true,
      key: "getAction",
      value:
      /**
       * @returns A action for dropdown for the given key symbol.
       */
      function getAction(key) {
        if (key === 'Escape') {
          return DROPDOWN_KEYBOARD_ACTION.CLOSING;
        }
        if (key in NAVIGATION_DIRECTION$1) {
          return DROPDOWN_KEYBOARD_ACTION.NAVIGATING;
        }
        if (this.TRIGGER_KEYS.has(key)) {
          return DROPDOWN_KEYBOARD_ACTION.TRIGGERING;
        }
        return DROPDOWN_KEYBOARD_ACTION.NONE;
      }
    }]
  };
}, ValidityMixin(HostListenerMixin(FormMixin(FocusMixin(s)))));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$E = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}${children}<path d="M17.4141 16L24 9.4141 22.5859 8 16 14.5859 9.4143 8 8 9.4141 14.5859 16 8 22.5859 9.4143 24 16 17.4141 22.5859 24 24 22.5859 17.4141 16z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param a A DOM collection.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns The index of the first item in the given collection where `predicate` returns `true`. `-1` if no such item is found.
 */
const findIndex = (a, predicate, thisObject) => Array.prototype.findIndex.call(a, predicate, thisObject);

/**
 * @param a A DOM collection.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns The first item in the given collection where `predicate` returns `true`. `null` if no such item is found.
 */
const find = (a, predicate, thisObject) => Array.prototype.find.call(a, predicate, thisObject);

/**
 * Walks through the given DOM collection and runs the given callback.
 *
 * @param a A DOM collection.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 */
const forEach = (a, predicate, thisObject) => Array.prototype.forEach.call(a, predicate, thisObject);

/**
 * @param a A DOM collection.
 * @param item An item in the DOM collection.
 * @returns The index of the first occurence of the given item in the given collection. `-1` if no such item is found.
 */
const indexOf = (a, item) => Array.prototype.indexOf.call(a, item);

let _$W = t => t,
  _t$Y,
  _t2$s;
function _decorate$Y(e, r, t, i) { var o = _getDecoratorsApi$Y(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$Y(s.d.map(_createElementDescriptor$Y)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$Y() { _getDecoratorsApi$Y = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$Y(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$Y(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$_(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$Y(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$Y(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$Y(e) { var r, t = _toPropertyKey$_(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$Y(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$Y(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$Y(o.descriptor) || _isDataDescriptor$Y(i.descriptor)) { if (_hasDecorators$Y(o) || _hasDecorators$Y(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$Y(o)) { if (_hasDecorators$Y(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$Y(o, i); } } else r.push(o); } return r; }
function _hasDecorators$Y(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$Y(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$Y(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$_(t) { var i = _toPrimitive$_(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$_(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$Y(r) { return _arrayWithHoles$Z(r) || _iterableToArray$Y(r) || _unsupportedIterableToArray$Z(r) || _nonIterableRest$Z(); }
function _nonIterableRest$Z() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$Z(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$Z(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$Z(r, a) : void 0; } }
function _arrayLikeToArray$Z(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$Y(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$Z(r) { if (Array.isArray(r)) return r; }
function _superPropGet$D(t, e, r, o) { var p = _get$x(_getPrototypeOf$x(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$x() { return _get$x = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$x(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$x.apply(null, arguments); }
function _superPropBase$x(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$x(t));); return t; }
function _getPrototypeOf$x(t) { return _getPrototypeOf$x = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$x(t); }
const {
  prefix: prefix$A,
  stablePrefix: c4dPrefix$Z
} = settings;

/**
 * Combo box.
 *
 * @element c4d-combo-box
 * @csspart text-input - The text input. Usage: `c4d-combo-box::part(text-input)`
 * @csspart selection-button - The selection button. Usage: `c4d-combo-box::part(selection-button)`
 * @fires cds-combo-box-beingselected
 *   The custom event fired before a combo box item is selected upon a user gesture.
 *   Cancellation of this event stops changing the user-initiated selection.
 * @fires cds-combo-box-beingtoggled
 *   The custom event fired before the open state of this combo box is toggled upon a user gesture.
 *   Cancellation of this event stops the user-initiated toggling.
 * @fires cds-combo-box-selected - The custom event fired after a combo box item is selected upon a user gesture.
 * @fires cds-combo-box-toggled - The custom event fired after the open state of this combo box is toggled upon a user gesture.
 */
let C4DComboBox = _decorate$Y([carbonElement(`${c4dPrefix$Z}-combo-box`)], function (_initialize, _CDSDropdown) {
  class C4DComboBox extends _CDSDropdown {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DComboBox,
    d: [{
      kind: "field",
      key: "_filterInputValue",
      value() {
        return '';
      }
    }, {
      kind: "field",
      key: "_shouldTriggerBeFocusable",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [i$1('#selection-button')],
      key: "_selectionButtonNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('input')],
      key: "_filterInputNode",
      value: void 0
    }, {
      kind: "method",
      key: "_testItemWithQueryText",
      value:
      /**
       * The text content that should be set to the `<input>` for filtering.
       */

      /**
       * The selection button.
       */

      /**
       * The `<input>` for filtering.
       */

      /**
       * @param item A combo box item.
       * @returns `true` if the given combo box item matches the query text user types.
       */
      function _testItemWithQueryText(item) {
        return (this.itemMatches || this._defaultItemMatches)(item, this._filterInputNode.value);
      }

      /* eslint-disable class-methods-use-this */
      /**
       * The default item matching callback.
       *
       * @param item The combo box item.
       * @param queryText The query text user types.
       * @returns `true` if the given combo box item matches the given query text.
       */
    }, {
      kind: "method",
      key: "_defaultItemMatches",
      value: function _defaultItemMatches(item, queryText) {
        return item.textContent.toLowerCase().indexOf(queryText.toLowerCase()) >= 0;
      }
      /* eslint-enable class-methods-use-this */

      /**
       * Handles `input` event on the `<input>` for filtering.
       */
    }, {
      kind: "method",
      key: "_handleInput",
      value: function _handleInput() {
        const items = this.querySelectorAll(this.constructor.selectorItem);
        const index = !this._filterInputNode.value ? -1 : findIndex(items, this._testItemWithQueryText, this);
        forEach(items, (item, i) => {
          item.highlighted = i === index;
        });
        const {
          _filterInputNode: filterInput
        } = this;
        this._filterInputValue = !filterInput ? '' : filterInput.value;
        this.open = true;
        this.requestUpdate(); // If the only change is to `_filterInputValue`, auto-update doesn't happen
      }
    }, {
      kind: "method",
      key: "_handleClickInner",
      value: function _handleClickInner(event) {
        var _this$_selectionButto;
        if ((_this$_selectionButto = this._selectionButtonNode) !== null && _this$_selectionButto !== void 0 && _this$_selectionButto.contains(event.target)) {
          this._handleUserInitiatedClearInput();
        } else {
          _superPropGet$D(C4DComboBox, "_handleClickInner", this, 3)([event]);
        }
      }
    }, {
      kind: "method",
      key: "_handleKeypressInner",
      value: function _handleKeypressInner(event) {
        var _this$_selectionButto2;
        const {
          key
        } = event;
        const action = this.constructor.getAction(key);
        const {
          TRIGGERING
        } = DROPDOWN_KEYBOARD_ACTION;
        if ((_this$_selectionButto2 = this._selectionButtonNode) !== null && _this$_selectionButto2 !== void 0 && _this$_selectionButto2.contains(event.target) && (
        // Space key should be handled by `<input>` unless "clear selection" button has focus
        action === TRIGGERING || key === ' ')) {
          this._handleUserInitiatedClearInput();
        } else {
          _superPropGet$D(C4DComboBox, "_handleKeypressInner", this, 3)([event]);
        }
      }

      /**
       * Handles user-initiated clearing the `<input>` for filtering.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedClearInput",
      value: function _handleUserInitiatedClearInput() {
        forEach(this.querySelectorAll(this.constructor.selectorItem), item => {
          item.highlighted = false;
        });
        this._filterInputValue = '';
        this._filterInputNode.focus();
        this.open = false;
        this.requestUpdate();
      }
    }, {
      kind: "method",
      key: "_handleUserInitiatedSelectItem",
      value: function _handleUserInitiatedSelectItem(item) {
        if (item && !this._selectionShouldChange(item)) {
          // Escape hatch for `shouldUpdate()` logic that updates `._filterInputValue()` when selection changes,
          // given we want to update the `<input>` and close the dropdown even if selection doesn't update.
          // Use case:
          // 1. Select the 2nd item in combo box drop down
          // 2. Type some text in the `<input>`
          // 3. Re-select the 2nd item in combo box drop down,
          //    the `<input>` has to updated with the 2nd item and the dropdown should be closed,
          //    even if there is no change in the selected value
          this._filterInputValue = item.textContent || '';
          this.open = false;
          this.requestUpdate();
        }
        _superPropGet$D(C4DComboBox, "_handleUserInitiatedSelectItem", this, 3)([item]);
      }
    }, {
      kind: "method",
      key: "_renderLabel",
      value: function _renderLabel() {
        const {
          disabled,
          label,
          _filterInputValue: filterInputValue,
          _handleInput: handleInput
        } = this;
        return x(_t$Y || (_t$Y = _$W`
      <input
        part="text-input"
        id="trigger-label"
        class="${0}--text-input"
        ?disabled=${0}
        placeholder="${0}"
        .value=${0}
        role="combobox"
        aria-expanded="${0}"
        aria-labelledby="assistiveStatus"
        aria-controls="menu-body"
        aria-autocomplete="list"
        @input=${0} />
    `), prefix$A, disabled, label, filterInputValue, this.open, handleInput);
      }
    }, {
      kind: "method",
      key: "_renderFollowingLabel",
      value: function _renderFollowingLabel() {
        const {
          clearSelectionLabel,
          _filterInputValue: filterInputValue
        } = this;
        return filterInputValue.length === 0 ? undefined : x(_t2$s || (_t2$s = _$W`
          <div
            part="selection-button"
            id="selection-button"
            role="button"
            class="${0}--list-box__selection"
            tabindex="0"
            title="${0}">
            ${0}
          </div>
        `), prefix$A, clearSelectionLabel, svgResultCarbonIcon$E({
          'aria-label': clearSelectionLabel
        }));
      }

      /**
       * The `aria-label` attribute for the icon to clear selection.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'clear-selection-label'
      })],
      key: "clearSelectionLabel",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "itemMatches",
      value: void 0
    }, {
      kind: "method",
      key: "shouldUpdate",
      value:
      /**
       * The custom item matching callback.
       */
      function shouldUpdate(changedProperties) {
        _superPropGet$D(C4DComboBox, "shouldUpdate", this, 3)([changedProperties]);
        const {
          _selectedItemContent: selectedItemContent
        } = this;
        if (selectedItemContent && changedProperties.has('value')) {
          this._filterInputValue = (selectedItemContent === null || selectedItemContent === void 0 ? void 0 : selectedItemContent.textContent) || '';
        }
        return true;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet$D(C4DComboBox, "updated", this, 3)([changedProperties]);
        const {
          _listBoxNode: listBoxNode
        } = this;
        if (listBoxNode) {
          listBoxNode.classList.add(`${prefix$A}--combo-box`);
        }
      }

      // For combo box, open/selection with space key is disabled given the input box should take it over
    }, {
      kind: "field",
      static: true,
      key: "TRIGGER_KEYS",
      value() {
        return new Set(['Enter']);
      }
    }, {
      kind: "get",
      static: true,
      key: "selectorItemHighlighted",
      value:
      /**
       * A selector that will return highlighted items.
       */
      function () {
        return `${prefix$A}-combo-box-item[highlighted]`;
      }

      /**
       * A selector that will return combo box items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${prefix$A}-combo-box-item`;
      }

      /**
       * A selector that will return selected items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemSelected",
      value: function () {
        return `${prefix$A}-combo-box-item[selected]`;
      }

      /**
       * The name of the custom event fired before this combo box item is being toggled upon a user gesture.
       * Cancellation of this event stops the user-initiated action of toggling this combo box item.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeToggle",
      value: function () {
        return `${prefix$A}-combo-box-beingtoggled`;
      }

      /**
       * The name of the custom event fired after this combo box item is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggle",
      value: function () {
        return `${prefix$A}-combo-box-toggled`;
      }

      /**
       * The name of the custom event fired before a combo box item is selected upon a user gesture.
       * Cancellation of this event stops changing the user-initiated selection.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeSelect",
      value: function () {
        return `${prefix$A}-combo-box-beingselected`;
      }

      /**
       * The name of the custom event fired after a a combo box item is selected upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelect",
      value: function () {
        return `${prefix$A}-combo-box-selected`;
      }
    }]
  };
}, CDSDropdown);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$D = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 20 20">${children}<path d="M11.8 2.8L10.8 3.8 16.2 9.3 1 9.3 1 10.7 16.2 10.7 10.8 16.2 11.8 17.2 19 10z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$C = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"></path></svg>`;

/**
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Utility to grab all alternative languages on the page. this scrapes the page
 * of all <link rel="alternate" hreflang="" href="" /> elements and returns
 * as a readable object
 *
 * @example
 * import { altlangs } from '@carbon/ibmdotcom-utilities';
 *
 * const langs = altlangs();
 *
 * console.log(langs); // { 'us-en': 'https://www.ibm.com/us-en', ... }
 * @returns {object} object of available languages and corresponding URLs
 */
function altlangs() {
  var links = [];
  var langs = {};
  if (lib.document) {
    links = lib.document.querySelectorAll('link[rel="alternate"]');
    links.forEach(function (link) {
      langs[link.getAttribute('hreflang')] = link.getAttribute('href');
    });
  }
  return langs;
}

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$B = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M14 26L15.41 24.59 7.83 17 28 17 28 15 7.83 15 15.41 7.41 14 6 4 16 14 26z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$A = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}<path d="M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2021
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Expressive modal size.
 */
let EXPRESSIVE_MODAL_SIZE;

/**
 * Expressive modal mode.
 */
(function (EXPRESSIVE_MODAL_SIZE) {
  EXPRESSIVE_MODAL_SIZE["REGULAR"] = "";
  EXPRESSIVE_MODAL_SIZE["FULL_WIDTH"] = "full-width";
})(EXPRESSIVE_MODAL_SIZE || (EXPRESSIVE_MODAL_SIZE = {}));
let EXPRESSIVE_MODAL_MODE;
(function (EXPRESSIVE_MODAL_MODE) {
  EXPRESSIVE_MODAL_MODE["DEFAULT"] = "";
  EXPRESSIVE_MODAL_MODE["LIGHTBOX"] = "lightbox";
})(EXPRESSIVE_MODAL_MODE || (EXPRESSIVE_MODAL_MODE = {}));

var styles$j = i$4(["/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--modal, :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}"]);

let _$V = t => t,
  _t$X,
  _t2$r,
  _t3$i,
  _t4$b;
function ownKeys$8(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$8(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$8(Object(t), !0).forEach(function (r) { _defineProperty$9(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$8(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$9(e, r, t) { return (r = _toPropertyKey$Z(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$X(e, r, t, i) { var o = _getDecoratorsApi$X(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$X(s.d.map(_createElementDescriptor$X)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$X() { _getDecoratorsApi$X = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$X(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$X(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$Z(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$X(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$X(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$X(e) { var r, t = _toPropertyKey$Z(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$X(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$X(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$X(o.descriptor) || _isDataDescriptor$X(i.descriptor)) { if (_hasDecorators$X(o) || _hasDecorators$X(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$X(o)) { if (_hasDecorators$X(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$X(o, i); } } else r.push(o); } return r; }
function _hasDecorators$X(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$X(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$X(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$Z(t) { var i = _toPrimitive$Z(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$Z(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$X(r) { return _arrayWithHoles$Y(r) || _iterableToArray$X(r) || _unsupportedIterableToArray$Y(r) || _nonIterableRest$Y(); }
function _nonIterableRest$Y() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$Y(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$Y(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$Y(r, a) : void 0; } }
function _arrayLikeToArray$Y(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$X(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$Y(r) { if (Array.isArray(r)) return r; }
function _superPropGet$C(t, e, r, o) { var p = _get$w(_getPrototypeOf$w(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$w() { return _get$w = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$w(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$w.apply(null, arguments); }
function _superPropBase$w(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$w(t));); return t; }
function _getPrototypeOf$w(t) { return _getPrototypeOf$w = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$w(t); }
const {
  prefix: prefix$z,
  stablePrefix: c4dPrefix$Y
} = settings;

/* eslint-disable no-bitwise */
const PRECEDING$1 = Node.DOCUMENT_POSITION_PRECEDING | Node.DOCUMENT_POSITION_CONTAINS;
const FOLLOWING$1 = Node.DOCUMENT_POSITION_FOLLOWING | Node.DOCUMENT_POSITION_CONTAINED_BY;
const WITHIN = Node.DOCUMENT_POSITION_CONTAINED_BY;
/* eslint-enable no-bitwise */

// TODO: Wait for `.d.ts` update to support `ResizeObserver`
// @ts-ignore
const onResize = ([entry]) => {
  const {
    target,
    contentRect
  } = entry;
  const {
    width,
    height
  } = contentRect;
  const modalContent = target;
  modalContent.style.setProperty('--modal-vh', `${height}px`);
  modalContent.style.setProperty('--modal-vw', `${width}px`);
};

/**
 * The table mapping slot name with the private property name that indicates the existence of the slot content.
 */
const slotExistencePropertyNames$1 = {
  header: '_hasHeader',
  footer: '_hasFooter'
};

/**
 * Expressive modal.
 *
 * @element c4d-expressive-modal
 * @fires c4d-expressive-modal-beingclosed
 *   The custom event fired before this modal is being closed upon a user gesture.
 *   Cancellation of this event stops the user-initiated action of closing this modal.
 * @fires c4d-expressive-modal-closed - The custom event fired after this modal is closed upon a user gesture.
 * @slot header - The header content.
 * @slot footer - The footer content.
 * @csspart modal-header - The modal header. Usage: `c4d-expressive-modal::part(modal-header)`
 * @csspart modal-body - The modal body. Usage: `c4d-expressive-modal::part(modal-body)`
 * @csspart sentinel-button - Taget all Sentinels buttons Usage: `c4d-expressive-modal::part(sentinel-button)`
 * @csspart sentinel-button--start - Button labled START. Usage: `c4d-expressive-modal::part(sentinel-button--start)`
 * @csspart sentinel-button--end - Button labled END. Usage: `c4d-expressive-modal::part(sentinel-button--end)`
 * @csspart modal-container - The modal container. Usage: `c4d-expressive-modal::part(modal-container)`
 * @csspart footer-container - The footer container. Usage: `c4d-expressive-modal::part(footer-container)`
 */
let C4DExpressiveModal = _decorate$X([carbonElement(`${c4dPrefix$Y}-expressive-modal`)], function (_initialize, _StableSelectorMixin) {
  class C4DExpressiveModal extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DExpressiveModal,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_hasHeader",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasBody",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasFooter",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "_launcher",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "hasFocusableElements",
      value() {
        return [this];
      }
    }, {
      kind: "get",
      key: "focusableElements",
      value:
      /**
       * `true` if there is a header content.
       */

      /**
       * `true` if there is a body content.
       */

      /**
       * `true` if there is a footer content.
       */

      /**
       * The element that had focus before this modal gets open.
       */

      /**
       * Collection of elements to search for focusable elements.
       */

      /**
       * Returns all focusable elements within this component and its shadowroot
       */
      function () {
        var _this$shadowRoot;
        const {
          selectorCloseButton,
          selectorTabbable: selectorTabbableForModal
        } = this.constructor;
        return [...Array.from(((_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelectorAll(selectorCloseButton)) || []), ...Array.from(this.querySelectorAll(selectorTabbableForModal))];
      }
    }, {
      kind: "get",
      key: "_focusableElements",
      value: function () {
        const {
          hasFocusableElements
        } = this;
        const focusableElements = [];
        hasFocusableElements.forEach(el => {
          if (el.focusableElements) {
            focusableElements.push(...el.focusableElements);
          }
        });
        return Array.from(new Set(focusableElements)).sort((a, b) => {
          const comparison = a.compareDocumentPosition(b);

          /* eslint-disable no-bitwise */
          if (comparison & PRECEDING$1) {
            return 1;
          }
          if (comparison & FOLLOWING$1) {
            return -1;
          }
          /* eslint-enable no-bitwise */

          return 0;
        });
      }

      /**
       * Node to track focus going outside of modal content.
       */
    }, {
      kind: "field",
      decorators: [i$1('#start-sentinel')],
      key: "_startSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('#end-sentinel')],
      key: "_endSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$z}--modal-content`)],
      key: "modalContent",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${c4dPrefix$Y}-ce--modal__body`)],
      key: "modalBody",
      value: void 0
    }, {
      kind: "field",
      key: "_resizeObserver",
      value() {
        return new ResizeObserver(onResize);
      }
    }, {
      kind: "field",
      decorators: [HostListener('click')],
      key: "_handleClick",
      value() {
        return event => {
          if (event.composedPath().indexOf(this.shadowRoot) < 0) {
            this._handleUserInitiatedClose(event.target);
          }
        };
      }
    }, {
      kind: "field",
      key: "_handleFocusIn",
      value() {
        return ({
          target,
          relatedTarget
        }) => {
          const {
            tryFocusElems
          } = this.constructor;
          let focusFromWithin = false;
          if (target && relatedTarget) {
            const comparedToThis = this.compareDocumentPosition(relatedTarget);
            const comparedToShadowRoot = this.shadowRoot.compareDocumentPosition(relatedTarget);
            // If relatedTarget is descendent of `this` or `this.shadowRoot`.
            if (comparedToThis & WITHIN || comparedToShadowRoot & WITHIN) {
              focusFromWithin = true;
            }
          }
          const {
            _endSentinelNode: endSentinelNode,
            _startSentinelNode: startSentinelNode,
            _focusableElements: focusableElements
          } = this;
          if (focusFromWithin) {
            if (target === startSentinelNode) {
              tryFocusElems(focusableElements, true, this);
            } else if (target === endSentinelNode) {
              tryFocusElems(focusableElements, false, this);
            }
          } else {
            tryFocusElems(focusableElements, false, this);
          }
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener('focusout')],
      key: "_handleFocusOut",
      value() {
        return ({
          target,
          relatedTarget
        }) => {
          var _this$shadowRoot2;
          // Don't attempt to wrap focus if the modal isn't open.
          if (!this.open) {
            return;
          }
          // If no target/relatedTarget, focus has entered/left the window. Do nothing.
          if (!target || !relatedTarget) {
            return;
          }
          const {
            tryFocusElems
          } = this.constructor;
          const {
            _focusableElements: focusableElements
          } = this;

          // See if element gaining focus is inside `this` or `this.shadowRoot`.
          const positionToModal = this.compareDocumentPosition(relatedTarget) | (((_this$shadowRoot2 = this.shadowRoot) === null || _this$shadowRoot2 === void 0 ? void 0 : _this$shadowRoot2.compareDocumentPosition(relatedTarget)) || 0);
          const positionToPrevious = target.compareDocumentPosition(relatedTarget);
          const relatedTargetIsContained = Boolean(positionToModal & WITHIN);

          // If focusing outside of `this`, cycle focus
          if (!relatedTargetIsContained && !(relatedTarget === this)) {
            if (positionToPrevious & PRECEDING$1) {
              tryFocusElems(focusableElements, true, this);
            } else if (positionToPrevious & FOLLOWING$1) {
              tryFocusElems(focusableElements, false, this);
            }
          }
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener('document:keydown')],
      key: "_handleKeydown",
      value() {
        return ({
          key,
          target
        }) => {
          if (key === 'Esc' || key === 'Escape') {
            this._handleUserInitiatedClose(target);
          }
        };
      }
    }, {
      kind: "method",
      key: "_handleClickContainer",
      value:
      /**
       * Node to track focus going outside of modal content.
       */
      // TODO: Wait for `.d.ts` update to support `ResizeObserver`
      // @ts-ignore
      /**
       * Handles `click` event on this element.
       *
       * @param event The event.
       */
      /* eslint-disable no-bitwise */
      /**
       * Handles the `focusin` event on the start and end sentinels
       *
       * @param event The event.
       * @param event.target The event target.
       * @param event.relatedTarget The event relatedTarget.
       */
      /**
       * Handles `focusout` event on this element.
       *
       * @param event The event.
       * @param event.target The event target.
       * @param event.relatedTarget The event relatedTarget.
       */
      /* eslint-enable no-bitwise */
      /**
       * Handles `click` event on the modal container.
       *
       * @param event The event.
       */
      function _handleClickContainer(event) {
        if (event.target.matches(this.constructor.selectorCloseButton)) {
          this._handleUserInitiatedClose(event.target);
        }
      }

      /**
       * Handles `slotchange` event.
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange({
        target
      }) {
        const {
          name
        } = target;
        const hasContent = target.assignedNodes().some(node => {
          // Allow non-empty text nodes.
          if (node.nodeType === Node.TEXT_NODE && node.textContent.trim()) {
            return true;
          }
          // Allow only element nodes that don't have a .cds--visually-hidden
          // class.
          if (node instanceof Element) {
            return !node.classList.contains('cds--visually-hidden');
          }
          // No opinion on other cases.
          return true;
        });
        this[slotExistencePropertyNames$1[name] || '_hasBody'] = hasContent;
      }

      /**
       * Handles user-initiated close request of this modal.
       *
       * @param triggeredBy The element that triggered this close request.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedClose",
      value: function _handleUserInitiatedClose(triggeredBy) {
        if (this.open) {
          const init = {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: {
              triggeredBy
            }
          };
          const {
            eventBeforeClose,
            eventClose
          } = this.constructor;
          if (this.dispatchEvent(new CustomEvent(eventBeforeClose, init))) {
            this.open = false;
            this.dispatchEvent(new CustomEvent(eventClose, init));
          }
          this.setAttribute('aria-hidden', 'true');
        }
      }

      /**
       * @param timeout The number of milliseconds as the longest time waiting for `transitionend` event.
       * @returns A promise that is resolves when `transitionend` on the host element fires.
       */
    }, {
      kind: "method",
      key: "_waitForTransitionEnd",
      value: function _waitForTransitionEnd(timeout = 1000) {
        return new Promise(resolve => {
          let done = false;
          const handleResolve = () => {
            if (!done) {
              resolve(undefined);
              done = true;
            }
          };
          on$1(this, 'transitionend', handleResolve);
          setTimeout(handleResolve, timeout);
        });
      }

      /**
       * @returns The header content.
       */
    }, {
      kind: "method",
      key: "_renderHeader",
      value: function _renderHeader() {
        const {
          _hasHeader: hasHeader,
          _hasBody: hasBody,
          _hasFooter: hasFooter
        } = this;
        const headerClasses = o$2({
          [`${c4dPrefix$Y}-ce--modal__header--with-body`]: hasHeader && (hasBody || hasFooter)
        });
        return x(_t$X || (_t$X = _$V`
      <div
        id="${0}--modal-header"
        class="${0}"
        part="modal-header">
        <slot name="header"></slot>
      </div>
    `), prefix$z, headerClasses);
      }

      /**
       * @returns The body content.
       */
    }, {
      kind: "method",
      key: "_renderBody",
      value: function _renderBody() {
        const {
          _hasBody: hasBody,
          _hasFooter: hasFooter
        } = this;
        const bodyClasses = o$2({
          [`${c4dPrefix$Y}-ce--modal__body`]: true,
          [`${c4dPrefix$Y}-ce--modal__body--with-footer`]: hasBody && hasFooter
        });
        return x(_t2$r || (_t2$r = _$V`
      <div class="${0}" part="modal-body"><slot></slot></div>
    `), bodyClasses);
      }

      /**
       * @returns The footer content.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderFooter",
      value: function _renderFooter() {
        return x(_t3$i || (_t3$i = _$V`
      <div part="footer-container"><slot name="footer"></slot></div>
    `));
      }

      /**
       * The additional CSS class names for the container <div> of the element.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'container-class'
      })],
      key: "containerClass",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "open",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'expressive-size'
      })],
      key: "size",
      value() {
        return EXPRESSIVE_MODAL_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'mode'
      })],
      key: "mode",
      value() {
        return EXPRESSIVE_MODAL_MODE.DEFAULT;
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * `true` if the modal should be open.
       */
      /**
       * The size variant.
       */
      /**
       * The mode variant.
       */
      function render() {
        const {
          size,
          _handleClickContainer: handleClickContainer,
          _handleSlotChange: handleSlotChange,
          _handleFocusIn: handleFocusIn
        } = this;
        const containerClass = this.containerClass.split(' ').filter(Boolean).reduce((acc, item) => _objectSpread$8(_objectSpread$8({}, acc), {}, {
          [item]: true
        }), {});
        const containerClasses = o$2(_objectSpread$8({
          [`${prefix$z}--modal-container`]: true,
          [`${prefix$z}--modal-container--fullwidth`]: size === EXPRESSIVE_MODAL_SIZE.FULL_WIDTH
        }, containerClass));
        return x(_t4$b || (_t4$b = _$V`
      <button
        id="start-sentinel"
        class="${0}--visually-hidden"
        part="sentinel-button sentinel-button--start"
        @focusin="${0}">
        START
      </button>
      <div
        class="${0}"
        part="modal-container"
        tabindex="-1"
        role="dialog"
        aria-labelledby="${0}--modal-header"
        @click="${0}"
        @slotchange="${0}">
        <div class="${0}--modal-content" part="modal-content">
          ${0}${0}${0}
        </div>
      </div>
      <button
        id="end-sentinel"
        class="${0}--visually-hidden"
        part="sentinel-button sentinel-button--end"
        @focusin="${0}">
        END
      </button>
    `), prefix$z, handleFocusIn, containerClasses, c4dPrefix$Y, handleClickContainer, handleSlotChange, prefix$z, this._renderHeader(), this._renderBody(), this._renderFooter(), prefix$z, handleFocusIn);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        if (this.modalContent) {
          this._resizeObserver.observe(this.modalContent);
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: async function updated(changedProperties) {
        const {
          _focusableElements: focusableElements,
          size
        } = this;
        const {
          selectorCloseButton,
          tryFocusElems
        } = this.constructor;
        if (changedProperties.has('size')) {
          const closeButton = this.querySelector(selectorCloseButton);
          if (closeButton) {
            closeButton.size = size;
          }
        }
        if (changedProperties.has('open')) {
          if (this.open) {
            this.ownerDocument.body.style.overflow = 'hidden';
            this.removeAttribute('aria-hidden');
            this._launcher = this.ownerDocument.activeElement;
            await this._waitForTransitionEnd();
            const primaryFocusNode = this.querySelector(this.constructor.selectorPrimaryFocus);
            if (primaryFocusNode) {
              // For cases where a `carbon-web-components` component (e.g. `<cds-btn>`) being `primaryFocusNode`,
              // where its first update/render cycle that makes it focusable happens after `<cds-modal>`'s first update/render cycle
              primaryFocusNode.focus();
            } else {
              tryFocusElems(focusableElements, true, this);
            }
          } else if (this._launcher && typeof this._launcher.focus === 'function') {
            this._launcher.focus();
            this.ownerDocument.body.style.overflow = '';
            this._launcher = null;
          }
        }
        return _superPropGet$C(C4DExpressiveModal, "updated", this, 3)([changedProperties]);
      }

      /**
       * A selector selecting buttons that should close this modal.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorCloseButton",
      value: function () {
        return `[data-modal-close],${prefix$z}-modal-close-button,${c4dPrefix$Y}-expressive-modal-close-button`;
      }

      /**
       * A selector selecting tabbable nodes.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTabbable",
      value: function () {
        return `
      ${selectorTabbable},
      ${c4dPrefix$Y}-button,
      ${c4dPrefix$Y}-expressive-modal,
      ${c4dPrefix$Y}-expressive-modal-close-button
    `;
      }

      /**
       * A selector selecting the nodes that should be focused when modal gets open.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorPrimaryFocus",
      value: function () {
        return `
      [data-modal-primary-focus],
      ${c4dPrefix$Y}-expressive-modal-footer ${c4dPrefix$Y}-button[kind="primary"]
    `;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$Y}--expressive-modal`;
      }

      /**
       * The name of the custom event fired before this modal is being closed upon a user gesture.
       * Cancellation of this event stops the user-initiated action of closing this modal.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeClose",
      value: function () {
        return `${c4dPrefix$Y}-expressive-modal-beingclosed`;
      }

      /**
       * The name of the custom event fired after this modal is closed upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventClose",
      value: function () {
        return `${c4dPrefix$Y}-expressive-modal-closed`;
      }

      /**
       * Tries to focus on the given elements and bails out if one of the is successful.
       *
       * @param elems The elements.
       * @param reverse `true` to go through the list in reverse order.
       * @param fallback element to focus on if none
       * @returns `true` if one of the attempts is successful, `false` otherwise.
       */
    }, {
      kind: "method",
      static: true,
      key: "tryFocusElems",
      value: function tryFocusElems(elems, reverse = false, fallback = null) {
        if (!reverse) {
          for (let i = 0; i < elems.length; ++i) {
            const elem = elems[i];
            if (elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length) {
              elem.focus();
              if (elem.getRootNode().activeElement === elem) {
                return true;
              }
            }
          }
        } else {
          for (let i = elems.length - 1; i >= 0; --i) {
            const elem = elems[i];
            if (elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length) {
              elem.focus();
              if (elem.getRootNode().activeElement === elem) {
                return true;
              }
            }
          }
        }
        fallback === null || fallback === void 0 || fallback.focus();
        return false;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$j;
      }
    }]
  };
}, StableSelectorMixin(HostListenerMixin(s)));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$i = i$4([
  ':root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two,:host(cds-modal-body){--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--popover-container{display:inline-block}.cds--popover-container:not(.cds--popover--auto-align){position:relative}.cds--popover--high-contrast .cds--popover{--cds-popover-background-color:var(--cds-background-inverse, #393939);--cds-popover-text-color:var(--cds-text-inverse, #ffffff)}.cds--popover--drop-shadow .cds--popover{--cds-popover-drop-shadow:drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2))}.cds--popover--caret{--cds-popover-offset:0.625rem}.cds--popover{position:absolute;z-index:6000;filter:var(--cds-popover-drop-shadow, none);inset:0;pointer-events:none}.cds--popover-content{--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:6000;display:none;border-radius:var(--cds-popover-border-radius,2px);background-color:var(--cds-popover-background-color,var(--cds-layer));color:var(--cds-popover-text-color,var(--cds-text-primary,#161616));inline-size:-moz-max-content;inline-size:max-content;max-inline-size:23rem;pointer-events:auto}.cds--layout--size-sm .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--popover-content *,.cds--popover-content ::after,.cds--popover-content ::before{box-sizing:inherit}.cds--popover--open>.cds--popover>.cds--popover-content{display:block}.cds--popover-content::before{position:absolute;display:none;content:""}.cds--popover--open>.cds--popover>.cds--popover-content::before{display:block}.cds--popover--auto-align.cds--popover-caret,.cds--popover-caret{position:absolute;z-index:6000;display:none;background-color:var(--cds-popover-background-color,var(--cds-layer));will-change:transform}.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-caret{display:block}.cds--popover--auto-align.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-content>.cds--popover-caret{display:block}.cds--popover--tab-tip>.cds--popover>.cds--popover-caret{display:none}.cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(100% + var(--cds-popover-offset,0)))}.cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--bottom-end>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-left>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-right>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-start>.cds--popover>.cds--popover-content::before,.cds--popover--bottom>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-start:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(-100%)}.cds--popover--bottom-end>.cds--popover>.cds--popover-caret,.cds--popover--bottom-left>.cds--popover>.cds--popover-caret,.cds--popover--bottom-right>.cds--popover>.cds--popover-caret,.cds--popover--bottom-start>.cds--popover>.cds--popover-caret,.cds--popover--bottom>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,var(--cds-popover-offset,0))}[dir=rtl] .cds--popover--bottom-end>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-left>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-right>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-start>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom>.cds--popover>.cds--popover-caret{transform:translate(50%,var(--cds-popover-offset,0))}.cds--popover--bottom-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(-100% - var(--cds-popover-offset,0)))}.cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--top-end>.cds--popover>.cds--popover-content::before,.cds--popover--top-left>.cds--popover>.cds--popover-content::before,.cds--popover--top-right>.cds--popover>.cds--popover-content::before,.cds--popover--top-start>.cds--popover>.cds--popover-content::before,.cds--popover--top>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-end:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--popover--top-end>.cds--popover>.cds--popover-caret,.cds--popover--top-left>.cds--popover>.cds--popover-caret,.cds--popover--top-right>.cds--popover>.cds--popover-caret,.cds--popover--top-start>.cds--popover>.cds--popover-caret,.cds--popover--top>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-1 * var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{transform:translate(50%,calc(-1 * var(--cds-popover-offset,0)))}.cds--popover--top-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),-50%)}.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) * -1 - 16px))}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--right-end>.cds--popover>.cds--popover-content::before,.cds--popover--right-start>.cds--popover>.cds--popover-content::before,.cds--popover--right-top>.cds--popover>.cds--popover-content::before,.cds--popover--right>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-start:0;transform:translateX(-100%)}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-start:100%;transform:translate(calc(var(--cds-popover-offset,0) - 100%),-50%)}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + .1px),-50%)}.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-.5 * var(--cds-popover-offset,0) - 16px))}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--left-end>.cds--popover>.cds--popover-content::before,.cds--popover--left-start>.cds--popover>.cds--popover-content::before,.cds--popover--left-top>.cds--popover>.cds--popover-content::before,.cds--popover--left>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-end:0;transform:translateX(100%)}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + 100%),-50%)}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--tab-tip>.cds--popover>.cds--popover-content{border-radius:0}.cds--popover--tab-tip .cds--popover{will-change:filter}.cds--popover--tab-tip__button{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;align-items:center;justify-content:center;block-size:2rem;inline-size:2rem}.cds--popover--tab-tip__button *,.cds--popover--tab-tip__button ::after,.cds--popover--tab-tip__button ::before{box-sizing:inherit}.cds--popover--tab-tip__button::-moz-focus-inner{border:0}.cds--popover--tab-tip__button:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--popover--tab-tip__button:focus{outline-style:dotted}}.cds--popover--tab-tip__button:hover{background-color:var(--cds-layer-hover)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button{background:var(--cds-layer);box-shadow:0 2px 2px rgba(0,0,0,.2)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after{position:absolute;z-index:6001;background:var(--cds-layer);block-size:2px;content:"";inline-size:100%;inset-block-end:0}.cds--popover--tab-tip__button svg{fill:var(--cds-icon-primary,#161616)}.cds--tooltip{--cds-popover-offset:12px}.cds--tooltip-content{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:var(--cds-tooltip-padding-block,1rem) var(--cds-tooltip-padding-inline,1rem);color:var(--cds-text-inverse,#fff);max-inline-size:18rem}.cds--icon-tooltip{--cds-tooltip-padding-block:0.125rem;--cds-popover-caret-width:0.5rem;--cds-popover-caret-height:0.25rem;--cds-popover-offset:0.5rem}.cds--icon-tooltip .cds--tooltip-content{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--definition-term{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;border-radius:0;border-block-end:1px dotted var(--cds-border-strong);color:var(--cds-text-primary,#161616)}.cds--definition-term *,.cds--definition-term ::after,.cds--definition-term ::before{box-sizing:inherit}.cds--definition-term::-moz-focus-inner{border:0}.cds--definition-term:focus{outline:1px solid var(--cds-focus,#0f62fe);border-block-end-color:var(--cds-border-interactive,#0f62fe)}@media screen and (prefers-contrast){.cds--definition-term:focus{outline-style:dotted}}.cds--definition-term:hover{border-block-end-color:var(--cds-border-interactive,#0f62fe)}.cds--definition-tooltip{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:.5rem 1rem;max-inline-size:11rem}.cds--btn{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));--temp-1lh:(\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );--temp-expressive-1lh:(\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );--temp-padding-block-max:calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:inline-flex;flex-shrink:0;justify-content:space-between;border-radius:0;margin:0;cursor:pointer;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:20rem;min-block-size:var(--cds-layout-size-height-local);outline:0;padding-block:min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - .0625rem,var(--temp-padding-block-max));padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - .0625rem);padding-inline-start:calc(var(--cds-layout-density-padding-inline-local) - .0625rem);text-align:start;text-decoration:none;transition:background 70ms cubic-bezier(0,0,.38,.9),box-shadow 70ms cubic-bezier(0,0,.38,.9),border-color 70ms cubic-bezier(0,0,.38,.9),outline 70ms cubic-bezier(0,0,.38,.9);vertical-align:top}.cds--btn *,.cds--btn ::after,.cds--btn ::before{box-sizing:inherit}.cds--btn.cds--btn--disabled,.cds--btn.cds--btn--disabled:focus,.cds--btn.cds--btn--disabled:hover,.cds--btn:disabled,.cds--btn:focus:disabled,.cds--btn:hover:disabled{border-color:var(--cds-button-disabled,#c6c6c6);background:var(--cds-button-disabled,#c6c6c6);box-shadow:none;color:var(--cds-text-on-color-disabled,#8d8d8d);cursor:not-allowed}.cds--btn .cds--btn__icon{position:absolute;flex-shrink:0;block-size:1rem;inline-size:1rem;inset-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max));inset-inline-end:var(--cds-layout-density-padding-inline-local);margin-block-start:.0625rem}.cds--btn::-moz-focus-inner{padding:0;border:0}.cds--btn--primary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-primary,#0f62fe);color:var(--cds-text-on-color,#fff)}.cds--btn--primary:hover{background-color:var(--cds-button-primary-hover,#0050e6)}.cds--btn--primary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--primary:active{background-color:var(--cds-button-primary-active,#002d9c)}.cds--btn--primary .cds--btn__icon,.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--primary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--secondary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-secondary,#393939);color:var(--cds-text-on-color,#fff)}.cds--btn--secondary:hover{background-color:var(--cds-button-secondary-hover,#474747)}.cds--btn--secondary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--secondary:active{background-color:var(--cds-button-secondary-active,#6f6f6f)}.cds--btn--secondary .cds--btn__icon,.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--secondary:focus,.cds--btn--secondary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-tertiary,#0f62fe);background-color:transparent;color:var(--cds-button-tertiary,#0f62fe)}.cds--btn--tertiary:hover{background-color:var(--cds-button-tertiary-hover,#0050e6)}.cds--btn--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--tertiary:active{background-color:var(--cds-button-tertiary-active,#002d9c)}.cds--btn--tertiary .cds--btn__icon,.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--tertiary:hover{color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:focus{background-color:var(--cds-button-tertiary,#0f62fe);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:active{border-color:transparent;background-color:var(--cds-button-tertiary-active,#002d9c);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary.cds--btn--disabled,.cds--btn--tertiary.cds--btn--disabled:focus,.cds--btn--tertiary.cds--btn--disabled:hover,.cds--btn--tertiary:disabled,.cds--btn--tertiary:focus:disabled,.cds--btn--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-link-primary,#0f62fe);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--ghost:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--btn--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost .cds--btn__icon,.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--ghost:active,.cds--btn--ghost:hover{color:var(--cds-link-primary-hover,#0043ce)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost.cds--btn--disabled,.cds--btn--ghost.cds--btn--disabled:focus,.cds--btn--ghost.cds--btn--disabled:hover,.cds--btn--ghost:disabled,.cds--btn--ghost:focus:disabled,.cds--btn--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost:not([disabled]) svg{fill:var(--cds-icon-primary,#161616)}.cds--btn--icon-only{justify-content:center;padding:0;block-size:var(--cds-layout-size-height-local);inline-size:var(--cds-layout-size-height-local);padding-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only>:first-child{margin-block-start:.0625rem;min-inline-size:1rem}.cds--btn--icon-only .cds--btn__icon{position:static}.cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon{margin:0}.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon{margin-block-start:0}.cds--btn--icon-only.cds--btn--selected{background:var(--cds-background-selected,rgba(141,141,141,.2))}.cds--btn path[data-icon-path=inner-path]{fill:none}.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:var(--cds-icon-primary,#161616)}.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn--ghost.cds--btn--icon-only[disabled]{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled]{pointer-events:none}.cds--btn--danger{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger .cds--btn__icon,.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-danger-secondary,#da1e28);background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28)}.cds--btn--danger--tertiary:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--tertiary:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--tertiary .cds--btn__icon,.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--tertiary:hover{border-color:var(--cds-button-danger-hover,#b81921);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:focus{background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:active{border-color:var(--cds-button-danger-active,#750e13);background-color:var(--cds-button-danger-active,#750e13);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary.cds--btn--disabled,.cds--btn--danger--tertiary.cds--btn--disabled:focus,.cds--btn--danger--tertiary.cds--btn--disabled:hover,.cds--btn--danger--tertiary:disabled,.cds--btn--danger--tertiary:focus:disabled,.cds--btn--danger--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--danger--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--danger--ghost:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--ghost:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--danger--ghost:active,.cds--btn--danger--ghost:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--ghost.cds--btn--disabled,.cds--btn--danger--ghost.cds--btn--disabled:focus,.cds--btn--danger--ghost.cds--btn--disabled:hover,.cds--btn--danger--ghost:disabled,.cds--btn--danger--ghost:focus:disabled,.cds--btn--danger--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--btn--expressive{font-size:var(--cds-body-compact-02-font-size,1rem);font-weight:var(--cds-body-compact-02-font-weight,400);line-height:var(--cds-body-compact-02-line-height,1.375);letter-spacing:var(--cds-body-compact-02-letter-spacing,0);padding-block:min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only.cds--btn--expressive{padding:12px 13px}.cds--btn.cds--btn--expressive .cds--btn__icon{block-size:1.25rem;inline-size:1.25rem}.cds--btn-set .cds--btn.cds--btn--expressive{max-inline-size:20rem}.cds--btn.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:9.375rem}.cds--btn.cds--skeleton:active,.cds--btn.cds--skeleton:focus,.cds--btn.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--btn.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--btn.cds--skeleton::before{animation:none}}.cds--btn-set{display:flex}.cds--btn-set--stacked{flex-direction:column}.cds--btn-set .cds--btn{inline-size:100%;max-inline-size:12.25rem}.cds--btn-set .cds--btn:not(:focus){box-shadow:-.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn:focus+.cds--btn{box-shadow:inherit}.cds--btn-set--stacked .cds--btn:not(:focus){box-shadow:0 -.0625rem 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn.cds--btn--disabled{box-shadow:-.0625rem 0 0 0 var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set--stacked .cds--btn.cds--btn--disabled{box-shadow:0 -.0625rem 0 0 var(--cds-layer-selected-disabled,#8d8d8d)}.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set .cds--btn.cds--btn--loading{border-color:transparent;background-color:transparent;box-shadow:none}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn:focus{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:ButtonText}}[dir=rtl] .cds--btn-set .cds--btn:not(:focus){box-shadow:.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--modal,:host(cds-modal){position:fixed;z-index:9000;display:flex;align-items:center;justify-content:center;background-color:var(--cds-overlay,rgba(22,22,22,.5));block-size:100vh;content:"";inline-size:100vw;inset-block-start:0;inset-inline-start:0;opacity:0;transition:opacity 240ms cubic-bezier(.4,.14,1,1),visibility 0s linear 240ms;visibility:hidden}.cds--modal.is-visible{opacity:1;transition:opacity 240ms cubic-bezier(0,0,.3,1),visibility 0s linear;visibility:inherit}@media screen and (prefers-reduced-motion:reduce){.cds--modal.is-visible{transition:none}}.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,.cds--modal .cds--number-input--fluid input[type=number],.cds--modal .cds--search--fluid .cds--search-input,.cds--modal .cds--select--fluid .cds--select-input,.cds--modal .cds--text-area--fluid .cds--text-area,.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider+.cds--form-requirement,.cds--modal .cds--text-input--fluid .cds--text-input,:host(cds-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,:host(cds-modal) .cds--list-box__wrapper--fluid .cds--list-box,:host(cds-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,:host(cds-modal) .cds--number-input--fluid .cds--number__control-btn::after,:host(cds-modal) .cds--number-input--fluid .cds--number__control-btn::before,:host(cds-modal) .cds--number-input--fluid input[type=number],:host(cds-modal) .cds--search--fluid .cds--search-input,:host(cds-modal) .cds--select--fluid .cds--select-input,:host(cds-modal) .cds--text-area--fluid .cds--text-area,:host(cds-modal) .cds--text-area--fluid .cds--text-area__wrapper,:host(cds-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider+.cds--form-requirement,:host(cds-modal) .cds--text-input--fluid .cds--text-input{background-color:var(--cds-field-01,#f4f4f4)}.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu,:host(cds-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu{background-color:var(--cds-layer-01,#f4f4f4)}.cds--modal .cds--list-box__menu-item:hover,:host(cds-modal) .cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover-02,#e8e8e8)}.cds--modal .cds--list-box__menu-item--active,:host(cds-modal) .cds--list-box__menu-item--active{background-color:var(--cds-layer-selected-02,#e0e0e0)}.cds--modal .cds--list-box__menu-item--active:hover,:host(cds-modal) .cds--list-box__menu-item--active:hover{background-color:var(--cds-layer-selected-hover-02,#d1d1d1)}.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before,:host(cds-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after,:host(cds-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before{background-color:var(--cds-field-hover)}.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before,:host(cds-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after,:host(cds-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before{border-inline-start:2px solid var(--cds-focus,#0f62fe)}.cds--modal.is-visible .cds--modal-container{transform:translate3d(0,0,0);transition:transform 240ms cubic-bezier(0,0,.3,1)}.cds--modal-container{position:fixed;display:grid;background-color:var(--cds-layer);block-size:100%;grid-template-columns:100%;grid-template-rows:auto 1fr auto;inline-size:100%;inset-block-start:0;max-block-size:100%;outline:3px solid transparent;outline-offset:-3px;transform:translate3d(0,-24px,0);transform-origin:top center;transition:transform 240ms cubic-bezier(.4,.14,1,1)}@media (min-width:42rem){.cds--modal-container{position:static;block-size:auto;inline-size:84%;max-block-size:90%}}@media (min-width:66rem){.cds--modal-container{inline-size:60%;max-block-size:84%}}@media (min-width:82rem){.cds--modal-container{inline-size:48%}}.cds--modal-container .cds--modal-container-body{display:contents}.cds--modal-content,:host(cds-modal-body){font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);position:relative;color:var(--cds-text-primary,#161616);font-weight:400;grid-column:1/-1;grid-row:2/-2;overflow-y:auto;padding-block-end:3rem;padding-block-start:.5rem;padding-inline-end:1rem;padding-inline-start:1rem}.cds--modal-content:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--modal-content:focus{outline-style:dotted}}.cds--modal-content .cds--form--fluid,:host(cds-modal-body) .cds--form--fluid{margin-inline-end:-1rem;margin-inline-start:-1rem}.cds--modal-content>p,.cds--modal-content__regular-content,:host(cds-modal-body)>p{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding-inline-end:calc(20% - 2rem)}.cds--modal-content--with-form{padding-inline-end:1rem}.cds--modal-header,:host(cds-modal-header){grid-column:1/-1;grid-row:1/1;margin-block-end:.5rem;padding-block-start:1rem;padding-inline-end:3rem;padding-inline-start:1rem}.cds--modal-header__label,:host(cds-modal-label){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);color:var(--cds-text-secondary,#525252);margin-block-end:.25rem}.cds--modal-header__label *,.cds--modal-header__label ::after,.cds--modal-header__label ::before,:host(cds-modal-label) *,:host(cds-modal-label) ::after,:host(cds-modal-label) ::before{box-sizing:inherit}.cds--modal-header__heading,:host(cds-modal-heading){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-heading-03-font-size,1.25rem);font-weight:var(--cds-heading-03-font-weight,400);line-height:var(--cds-heading-03-line-height,1.4);letter-spacing:var(--cds-heading-03-letter-spacing,0);color:var(--cds-text-primary,#161616);padding-inline-end:calc(20% - 3rem)}.cds--modal-header__heading *,.cds--modal-header__heading ::after,.cds--modal-header__heading ::before,:host(cds-modal-heading) *,:host(cds-modal-heading) ::after,:host(cds-modal-heading) ::before{box-sizing:inherit}.cds--modal-container--xs .cds--modal-content__regular-content{padding-inline-end:1rem}.cds--modal-container--xs .cds--modal-content>p,.cds--modal-container--xs :host(cds-modal-body)>p{padding-inline-end:0}@media (min-width:42rem){.cds--modal-container--xs{inline-size:48%}}@media (min-width:66rem){.cds--modal-container--xs{inline-size:32%;max-block-size:48%}}@media (min-width:82rem){.cds--modal-container--xs{inline-size:24%}}.cds--modal-container--sm .cds--modal-content__regular-content{padding-inline-end:1rem}.cds--modal-container--sm .cds--modal-content>p,.cds--modal-container--sm :host(cds-modal-body)>p{padding-inline-end:0}@media (min-width:42rem){.cds--modal-container--sm{inline-size:60%}}@media (min-width:66rem){.cds--modal-container--sm{inline-size:42%;max-block-size:72%}.cds--modal-container--sm .cds--modal-content>p,.cds--modal-container--sm .cds--modal-content__regular-content,.cds--modal-container--sm :host(cds-modal-body)>p{padding-inline-end:20%}}@media (min-width:82rem){.cds--modal-container--sm{inline-size:36%}}@media (min-width:42rem){.cds--modal-container--lg{inline-size:96%}}@media (min-width:66rem){.cds--modal-container--lg{inline-size:84%;max-block-size:96%}}@media (min-width:82rem){.cds--modal-container--lg{inline-size:72%}}.cds--modal-scroll-content,:host(cds-modal[has-scrolling-content]) ::slotted(cds-modal-body){border-block-end:2px solid transparent;-webkit-mask-image:linear-gradient(to bottom,var(--cds-layer) calc(100% - 80px),transparent calc(100% - 48px),transparent 100%),linear-gradient(to left,var(--cds-layer) 0,16px,transparent 16px),linear-gradient(to right,var(--cds-layer) 0,2px,transparent 2px),linear-gradient(to top,var(--cds-layer) 0,2px,transparent 2px);mask-image:linear-gradient(to bottom,var(--cds-layer) calc(100% - 80px),transparent calc(100% - 48px),transparent 100%),linear-gradient(to left,var(--cds-layer) 0,16px,transparent 16px),linear-gradient(to right,var(--cds-layer) 0,2px,transparent 2px),linear-gradient(to top,var(--cds-layer) 0,2px,transparent 2px)}.cds--modal-scroll-content:has(.cds--autoalign),:host(cds-modal[has-scrolling-content]) :has(.cds--autoalign)::slotted(cds-modal-body){-webkit-mask-image:none;mask-image:none}.cds--modal-scroll-content>:last-child,:host(cds-modal[has-scrolling-content]) ::slotted(cds-modal-body)>:last-child{margin-block-end:1.5rem}.cds--modal-footer,:host(cds-modal-footer){display:flex;justify-content:flex-end;block-size:4rem;grid-column:1/-1;grid-row:-1/-1;margin-block-start:auto}.cds--modal-footer .cds--btn,:host(cds-modal-footer) .cds--btn{flex:0 1 50%;align-items:baseline;margin:0;block-size:4rem;max-inline-size:none;padding-block-end:2rem;padding-block-start:.875rem}.cds--modal-footer--three-button .cds--btn,:host(cds-modal-footer[has-three-buttons]) .cds--btn{flex:0 1 25%;align-items:flex-start}.cds--modal-close-button,:host(cds-modal-close-button){position:absolute;inset-block-start:0;inset-inline-end:0}.cds--modal-close{padding:.75rem;border:2px solid transparent;background-color:transparent;block-size:3rem;cursor:pointer;inline-size:3rem;transition:background-color 110ms cubic-bezier(.2,0,.38,.9)}.cds--modal-close:hover{background-color:var(--cds-layer-hover)}.cds--modal-close:focus{border-color:var(--cds-focus,#0f62fe);outline:0}.cds--modal-close::-moz-focus-inner{border:0}.cds--modal-close__icon{block-size:1.25rem;fill:var(--cds-icon-primary,#161616);inline-size:1.25rem}.cds--body--with-modal-open{overflow:hidden}.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,.cds--body--with-modal-open .cds--modal .cds--tooltip,.cds--body--with-modal-open .cds--overflow-menu-options,.cds--body--with-modal-open :host(cds-modal) .cds--tooltip{z-index:9000}.cds--modal-container--full-width .cds--modal-content,.cds--modal-container--full-width :host(cds-modal-body){padding:0;margin:0}.cds--modal--slug.cds--modal{background-color:var(--cds-ai-overlay,rgba(0,17,65,.5))}.cds--modal--slug .cds--modal-container{background:linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)) 0,var(--cds-ai-aura-start,rgba(69,137,255,.1)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%) padding-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) padding-box,linear-gradient(to bottom,var(--cds-ai-border-start,rgba(166,200,255,.64)),var(--cds-ai-border-end,#78a9ff)) border-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) border-box;border:1px solid transparent;background-color:var(--cds-layer);box-shadow:inset 0 -80px 70px -65px var(--cds-ai-inner-shadow,rgba(69,137,255,.1)),0 24px 40px -24px var(--cds-ai-drop-shadow,rgba(15,98,254,.1))}.cds--modal--slug .cds--modal-container:has(.cds--modal-footer,:host(cds-modal-footer)){background:linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)) calc(0 + 64px),var(--cds-ai-aura-start,rgba(69,137,255,.1)) calc(0 + 64px),15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%) padding-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) padding-box,linear-gradient(to bottom,var(--cds-ai-border-start,rgba(166,200,255,.64)),var(--cds-ai-border-end,#78a9ff)) border-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) border-box;box-shadow:inset 0 -80px 0 -16px var(--cds-layer),inset 0 -160px 70px -65px var(--cds-ai-inner-shadow,rgba(69,137,255,.1)),0 24px 40px -24px var(--cds-ai-drop-shadow,rgba(15,98,254,.1))}.cds--modal--slug .cds--modal-content.cds--modal-scroll-content,:host(cds-modal[has-scrolling-content]) .cds--modal--slug .cds--modal-content::slotted(cds-modal-body),:host(cds-modal[has-scrolling-content]) .cds--modal--slug :host(cds-modal-body)::slotted(cds-modal-body){-webkit-mask-image:linear-gradient(to bottom,var(--cds-layer) calc(100% - 80px),transparent calc(100% - 48px),transparent 100%),linear-gradient(to left,var(--cds-layer) 0,16px,transparent 16px),linear-gradient(to right,var(--cds-layer) 0,2px,transparent 2px),linear-gradient(to top,var(--cds-layer) 0,2px,transparent 2px);mask-image:linear-gradient(to bottom,var(--cds-layer) calc(100% - 80px),transparent calc(100% - 48px),transparent 100%),linear-gradient(to left,var(--cds-layer) 0,16px,transparent 16px),linear-gradient(to right,var(--cds-layer) 0,2px,transparent 2px),linear-gradient(to top,var(--cds-layer) 0,2px,transparent 2px)}.cds--modal--slug .cds--modal-container-body>.cds--slug,.cds--modal-header>.cds--modal-close-button~.cds--slug,.cds--modal-header>.cds--slug:has(+.cds--modal-close-button,+:host(cds-modal-close-button)),.cds--modal-header>:host(cds-modal-close-button)~.cds--slug,:host(cds-modal-header)>.cds--modal-close-button~.cds--slug,:host(cds-modal-header)>.cds--slug:has(+.cds--modal-close-button,+:host(cds-modal-close-button)),:host(cds-modal-header)>:host(cds-modal-close-button)~.cds--slug{position:absolute;inset-block-start:.625rem;inset-inline-end:3rem}.cds--modal--slug .cds--modal-content--overflow-indicator,.cds--modal--slug .cds--modal-content--overflow-indicator::before{display:none}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--modal-close__icon{fill:ButtonText}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--modal-close:focus{color:Highlight;outline:1px solid Highlight}}:host(cds-modal[open]){opacity:1;transition:opacity 240ms cubic-bezier(0,0,.3,1),visibility 0s linear;visibility:inherit}:host(cds-modal[open]) .cds--modal-container{transform:translate3d(0,0,0);transition:transform 240ms cubic-bezier(0,0,.3,1)}@media screen and (prefers-reduced-motion:reduce){:host(cds-modal[open]){transition:none}}:host(cds-modal[full-width]) ::slotted(cds-modal-body){padding:0;margin:0}:host(cds-modal-close-button){outline:0}:host(cds-modal-heading),:host(cds-modal-label){display:block}:host(cds-modal-body) ::slotted(cds-form-item){margin-block-end:1rem}:host(cds-modal-body) ::slotted(cds-select:last-of-type){padding-block-end:0}:host(cds-modal-body) ::slotted(:last-child){padding-block-end:2rem}:host(cds-modal-body-content){font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);display:block;padding-inline-end:calc(20% - 2rem)}:host(cds-modal-body-content[description]){margin-block-end:1rem}:host(cds-modal-footer[has-three-buttons]) ::slotted(cds-modal-footer-button){flex:0 1 25%}:host(cds-modal-footer-button:first-of-type) .cds--btn{box-shadow:inherit}:host(cds-modal-footer-button) .cds--btn{block-size:100%;box-shadow:-.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0);inline-size:100%;max-inline-size:none;padding-block:1rem 2rem}:host(cds-modal-footer-button) .cds--btn:focus{box-shadow:inset 0 0 0 1px var(--cds-focus,#0f62fe),inset 0 0 0 2px var(--cds-background,#fff)}:host(cds-modal-footer) ::slotted(cds-button),:host(cds-modal-footer-button){flex:0 1 50%;margin:0;block-size:4rem;inline-size:50%;max-inline-size:none}:host(cds-modal[slug]){background-color:var(--cds-ai-overlay,rgba(0,17,65,.5))}:host(cds-modal[slug]) .cds--modal-container{background:linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)) 0,var(--cds-ai-aura-start,rgba(69,137,255,.1)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%) padding-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) padding-box,linear-gradient(to bottom,var(--cds-ai-border-start,rgba(166,200,255,.64)),var(--cds-ai-border-end,#78a9ff)) border-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) border-box;border:1px solid transparent;background-color:var(--cds-layer);box-shadow:inset 0 -80px 70px -65px var(--cds-ai-inner-shadow,rgba(69,137,255,.1)),0 24px 40px -24px var(--cds-ai-drop-shadow,rgba(15,98,254,.1))}:host(cds-modal[slug][has-footer]) .cds--modal-container{background:linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)) calc(0 + 64px),var(--cds-ai-aura-start,rgba(69,137,255,.1)) calc(0 + 64px),15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%) padding-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) padding-box,linear-gradient(to bottom,var(--cds-ai-border-start,rgba(166,200,255,.64)),var(--cds-ai-border-end,#78a9ff)) border-box,linear-gradient(to top,var(--cds-layer,var(--cds-ai-popover-background,#fff)),var(--cds-layer,var(--cds-ai-popover-background,#fff))) border-box;box-shadow:inset 0 -80px 0 -16px var(--cds-layer),inset 0 -160px 70px -65px var(--cds-ai-inner-shadow,rgba(69,137,255,.1)),0 24px 40px -24px var(--cds-ai-drop-shadow,rgba(15,98,254,.1))}:host(cds-modal[slug][has-scrolling-content]) ::slotted(cds-modal-body){-webkit-mask-image:linear-gradient(to bottom,var(--cds-layer) calc(100% - 80px),transparent calc(100% - 48px),transparent 100%),linear-gradient(to left,var(--cds-layer) 0,16px,transparent 16px),linear-gradient(to right,var(--cds-layer) 0,2px,transparent 2px),linear-gradient(to top,var(--cds-layer) 0,2px,transparent 2px);mask-image:linear-gradient(to bottom,var(--cds-layer) calc(100% - 80px),transparent calc(100% - 48px),transparent 100%),linear-gradient(to left,var(--cds-layer) 0,16px,transparent 16px),linear-gradient(to right,var(--cds-layer) 0,2px,transparent 2px),linear-gradient(to top,var(--cds-layer) 0,2px,transparent 2px)}:host(cds-modal[slug]) .cds--modal-content--overflow-indicator,:host(cds-modal[slug]) .cds--modal-content--overflow-indicator::before{display:none}:host(cds-modal-header) ::slotted(cds-slug){position:absolute;inset-block-start:0;inset-inline-end:0}:host(cds-modal-header[close-button]) ::slotted(cds-slug){inset-inline-end:3rem}',
]);

let _$U = t => t,
  _t$W;

/**
 * Modal header.
 *
 * @element cds-modal-header
 */
let CDSModalHeader = _decorate$Z([carbonElement(`${prefix$B}-modal-header`)], function (_initialize, _LitElement) {
  class CDSModalHeader extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSModalHeader,
    d: [{
      kind: "field",
      key: "_hasSlug",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * `true` if there is a slug.
       */

      /**
       * Handles `slotchange` event.
       */
      function _handleSlotChange({
        target
      }) {
        const hasContent = target.assignedNodes().filter(elem => elem.matches !== undefined ? elem.matches(this.constructor.slugItem) : false);
        if (hasContent.length > 0) {
          this._hasSlug = Boolean(hasContent);
          hasContent[0].setAttribute('size', 'lg');
        }
        this.requestUpdate();
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated() {
        if (this._hasSlug) {
          var _this$parentElement;
          (_this$parentElement = this.parentElement) === null || _this$parentElement === void 0 || _this$parentElement.setAttribute('slug', '');
        } else {
          var _this$parentElement2;
          (_this$parentElement2 = this.parentElement) === null || _this$parentElement2 === void 0 || _this$parentElement2.removeAttribute('slug');
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$W || (_t$W = _$U` <slot></slot>
      <slot name="slug" @slotchange="${0}"></slot>`), this._handleSlotChange);
      }

      /**
       * A selector that will return the slug item.
       */
    }, {
      kind: "get",
      static: true,
      key: "slugItem",
      value: function () {
        return `${prefix$B}-slug`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$i;
      }
    }]
  };
}, s);

function _decorate$W(e, r, t, i) { var o = _getDecoratorsApi$W(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$W(s.d.map(_createElementDescriptor$W)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$W() { _getDecoratorsApi$W = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$W(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$W(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$Y(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$W(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$W(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$W(e) { var r, t = _toPropertyKey$Y(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$W(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$W(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$W(o.descriptor) || _isDataDescriptor$W(i.descriptor)) { if (_hasDecorators$W(o) || _hasDecorators$W(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$W(o)) { if (_hasDecorators$W(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$W(o, i); } } else r.push(o); } return r; }
function _hasDecorators$W(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$W(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$W(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$Y(t) { var i = _toPrimitive$Y(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$Y(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$W(r) { return _arrayWithHoles$X(r) || _iterableToArray$W(r) || _unsupportedIterableToArray$X(r) || _nonIterableRest$X(); }
function _nonIterableRest$X() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$X(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$X(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$X(r, a) : void 0; } }
function _arrayLikeToArray$X(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$W(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$X(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$X
} = settings;

/**
 * Expressive modal header.
 *
 * @element c4d-expressive-modal-header
 */
_decorate$W([carbonElement(`${c4dPrefix$X}-expressive-modal-header`)], function (_initialize, _StableSelectorMixin) {
  class C4DExpressiveModalHeader extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DExpressiveModalHeader,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'header';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$X}--expressive-modal-header`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$j;
      }
    }]
  };
}, StableSelectorMixin(CDSModalHeader));

let _$T = t => t,
  _t$V;

/**
 * Modal heading.
 *
 * @element cds-modal-heading
 */
let CDSModalHeading = _decorate$Z([carbonElement(`${prefix$B}-modal-heading`)], function (_initialize, _LitElement) {
  class CDSModalHeading extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSModalHeading,
    d: [{
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$V || (_t$V = _$T` <slot></slot> `));
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$i;
      }
    }]
  };
}, s);

function _decorate$V(e, r, t, i) { var o = _getDecoratorsApi$V(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$V(s.d.map(_createElementDescriptor$V)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$V() { _getDecoratorsApi$V = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$V(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$V(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$X(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$V(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$V(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$V(e) { var r, t = _toPropertyKey$X(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$V(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$V(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$V(o.descriptor) || _isDataDescriptor$V(i.descriptor)) { if (_hasDecorators$V(o) || _hasDecorators$V(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$V(o)) { if (_hasDecorators$V(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$V(o, i); } } else r.push(o); } return r; }
function _hasDecorators$V(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$V(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$V(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$X(t) { var i = _toPrimitive$X(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$X(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$V(r) { return _arrayWithHoles$W(r) || _iterableToArray$V(r) || _unsupportedIterableToArray$W(r) || _nonIterableRest$W(); }
function _nonIterableRest$W() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$W(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$W(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$W(r, a) : void 0; } }
function _arrayLikeToArray$W(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$V(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$W(r) { if (Array.isArray(r)) return r; }
function _superPropGet$B(t, e, r, o) { var p = _get$v(_getPrototypeOf$v(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$v() { return _get$v = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$v(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$v.apply(null, arguments); }
function _superPropBase$v(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$v(t));); return t; }
function _getPrototypeOf$v(t) { return _getPrototypeOf$v = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$v(t); }
const {
  stablePrefix: c4dPrefix$W
} = settings;

/**
 * Expressive modal heading.
 *
 * @element c4d-expressive-modal-heading
 */
_decorate$V([carbonElement(`${c4dPrefix$W}-expressive-modal-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DExpressiveModalHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DExpressiveModalHeading,
    d: [{
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'heading');
        }
        if (!this.hasAttribute('aria-level')) {
          this.setAttribute('aria-level', '2');
        }
        _superPropGet$B(C4DExpressiveModalHeading, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$W}--expressive-modal-heading`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$j;
      }
    }]
  };
}, StableSelectorMixin(CDSModalHeading));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$z = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}${children}<path d="M17.4141 16L24 9.4141 22.5859 8 16 14.5859 9.4143 8 8 9.4141 14.5859 16 8 22.5859 9.4143 24 16 17.4141 22.5859 24 24 22.5859 17.4141 16z"></path></svg>`;

let _$S = t => t,
  _t$U;

/**
 * Modal close button.
 *
 * @element cds-modal-close-button
 * @csspart button The button.
 * @csspart close-icon The close icon.
 */
let CDSModalCloseButton = _decorate$Z([carbonElement(`${prefix$B}-modal-close-button`)], function (_initialize, _FocusMixin) {
  class CDSModalCloseButton extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSModalCloseButton,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'close-button-label'
      })],
      key: "closeButtonLabel",
      value() {
        return 'Close';
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * Specify a label for the close button of the modal; defaults to close
       */

      function updated() {
        var _this$parentElement;
        (_this$parentElement = this.parentElement) === null || _this$parentElement === void 0 || _this$parentElement.setAttribute('close-button', '');
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          closeButtonLabel
        } = this;
        return x(_t$U || (_t$U = _$S`
      <button
        part="button"
        aria-label="${0}"
        class="${0}--modal-close"
        title="${0}">
        ${0}
      </button>
    `), l(closeButtonLabel), prefix$B, l(closeButtonLabel), svgResultCarbonIcon$z({
          part: 'close-icon',
          class: `${prefix$B}--modal-close__icon`
        }));
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$i;
      }
    }]
  };
}, FocusMixin(s));

function _decorate$U(e, r, t, i) { var o = _getDecoratorsApi$U(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$U(s.d.map(_createElementDescriptor$U)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$U() { _getDecoratorsApi$U = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$U(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$U(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$W(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$U(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$U(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$U(e) { var r, t = _toPropertyKey$W(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$U(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$U(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$U(o.descriptor) || _isDataDescriptor$U(i.descriptor)) { if (_hasDecorators$U(o) || _hasDecorators$U(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$U(o)) { if (_hasDecorators$U(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$U(o, i); } } else r.push(o); } return r; }
function _hasDecorators$U(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$U(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$U(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$W(t) { var i = _toPrimitive$W(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$W(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$U(r) { return _arrayWithHoles$V(r) || _iterableToArray$U(r) || _unsupportedIterableToArray$V(r) || _nonIterableRest$V(); }
function _nonIterableRest$V() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$V(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$V(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$V(r, a) : void 0; } }
function _arrayLikeToArray$V(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$U(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$V(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$V
} = settings;

/**
 * Expressive modal close button.
 *
 * @element c4d-expressive-modal-close-button
 */
_decorate$U([carbonElement(`${c4dPrefix$V}-expressive-modal-close-button`)], function (_initialize, _StableSelectorMixin) {
  class C4DExpressiveModalCloseButton extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DExpressiveModalCloseButton,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'size'
      })],
      key: "size",
      value() {
        return EXPRESSIVE_MODAL_SIZE.REGULAR;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      /**
       * The size variant.
       */

      function () {
        return `${c4dPrefix$V}--expressive-modal-close-button`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$j;
      }
    }]
  };
}, StableSelectorMixin(CDSModalCloseButton));

var styles$h = i$4(["/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--tag {\n  --cds-layout-size-height-xs: 1.125rem;\n  --cds-layout-size-height-sm: 1.125rem;\n  --cds-layout-size-height-md: 1.5rem;\n  --cds-layout-size-height-lg: 2rem;\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 1rem;\n  margin: 0.25rem;\n  cursor: default;\n  max-inline-size: 13rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  min-inline-size: 2rem;\n  padding-inline: 0.5rem;\n  vertical-align: middle;\n  word-break: break-word;\n}\n.cds--layout--size-xs .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-xs);\n}\n.cds--layout--size-sm .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--tag.cds--tag--operational {\n  border: 1px solid var(--cds-tag-background-gray, #e0e0e0);\n}\n.cds--tag.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag.cds--tag--lg {\n  padding-inline-start: 0.75rem;\n}\n.cds--tag:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.25rem;\n}\n.cds--tag.cds--tag--lg:not(.cds--tag--filter) {\n  padding-inline: 0.75rem;\n}\n.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.5rem;\n}\n.cds--tag:not(.cds--tag--selectable) {\n  border: 0;\n}\n.cds--tag:not(:first-child) {\n  margin-inline-start: 0;\n}\n\n.cds--tag--operational > span,\n.cds--tag--selectable > span,\n.cds--tag__label {\n  display: block;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--tag--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--filter {\n  padding-block-end: 0;\n  padding-block-start: 0;\n  padding-inline-end: 0;\n}\n.cds--tag--filter:hover {\n  outline: none;\n}\n\n.cds--tag--selectable {\n  border: 1px solid var(--cds-border-inverse, #161616);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--tag--selectable:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--tag--selectable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--selectable-selected {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--selectable-selected:hover {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  cursor: pointer;\n}\n.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n  outline: none;\n}\n.cds--tag--operational:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--red {\n  background-color: var(--cds-tag-background-red, #ffd7d9);\n  color: var(--cds-tag-color-red, #a2191f);\n}\n.cds--tag--red.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-red, #ff8389);\n}\n.cds--tag--red.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n.cds--tag--red .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n\n.cds--tag--magenta {\n  background-color: var(--cds-tag-background-magenta, #ffd6e8);\n  color: var(--cds-tag-color-magenta, #9f1853);\n}\n.cds--tag--magenta.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-magenta, #ff7eb6);\n}\n.cds--tag--magenta.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n.cds--tag--magenta .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n\n.cds--tag--purple {\n  background-color: var(--cds-tag-background-purple, #e8daff);\n  color: var(--cds-tag-color-purple, #6929c4);\n}\n.cds--tag--purple.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-purple, #be95ff);\n}\n.cds--tag--purple.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n.cds--tag--purple .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n\n.cds--tag--blue {\n  background-color: var(--cds-tag-background-blue, #d0e2ff);\n  color: var(--cds-tag-color-blue, #0043ce);\n}\n.cds--tag--blue.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-blue, #78a9ff);\n}\n.cds--tag--blue.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n.cds--tag--blue .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n\n.cds--tag--cyan {\n  background-color: var(--cds-tag-background-cyan, #bae6ff);\n  color: var(--cds-tag-color-cyan, #00539a);\n}\n.cds--tag--cyan.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cyan, #33b1ff);\n}\n.cds--tag--cyan.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n.cds--tag--cyan .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n\n.cds--tag--teal {\n  background-color: var(--cds-tag-background-teal, #9ef0f0);\n  color: var(--cds-tag-color-teal, #005d5d);\n}\n.cds--tag--teal.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-teal, #08bdba);\n}\n.cds--tag--teal.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n.cds--tag--teal .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n\n.cds--tag--green {\n  background-color: var(--cds-tag-background-green, #a7f0ba);\n  color: var(--cds-tag-color-green, #0e6027);\n}\n.cds--tag--green.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-green, #42be65);\n}\n.cds--tag--green.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n.cds--tag--green .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n\n.cds--tag--gray {\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n}\n.cds--tag--gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n}\n.cds--tag--gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag--gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n\n.cds--tag--cool-gray {\n  background-color: var(--cds-tag-background-cool-gray, #dde1e6);\n  color: var(--cds-tag-color-cool-gray, #121619);\n}\n.cds--tag--cool-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cool-gray, #a2a9b0);\n}\n.cds--tag--cool-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n.cds--tag--cool-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n\n.cds--tag--warm-gray {\n  background-color: var(--cds-tag-background-warm-gray, #e5e0df);\n  color: var(--cds-tag-color-warm-gray, #171414);\n}\n.cds--tag--warm-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-warm-gray, #ada8a8);\n}\n.cds--tag--warm-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n.cds--tag--warm-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n\n.cds--tag--high-contrast:not(.cds--tag--operational) {\n  background-color: var(--cds-background-inverse, #393939);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational {\n  border: 1px solid var(--cds-background-inverse, #393939);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  outline: 1px solid var(--cds-background-inverse, #393939);\n  outline-offset: -1px;\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational {\n  border: 1px solid var(--cds-background, #ffffff);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--tag--disabled:not(.cds--tag--operational),\n.cds--tag--filter.cds--tag--disabled,\n.cds--tag--interactive.cds--tag--disabled {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  box-shadow: none;\n  outline: none;\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational {\n  border: 1px solid var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational):hover,\n.cds--tag--filter.cds--tag--disabled:hover,\n.cds--tag--interactive.cds--tag--disabled:hover {\n  cursor: not-allowed;\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,\n.cds--tag--filter.cds--tag--disabled .cds--tag__label,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__label {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--selectable.cds--tag--disabled,\n.cds--tag--operational.cds--tag--disabled {\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--tag--selectable.cds--tag--disabled:hover,\n.cds--tag--operational.cds--tag--disabled:hover {\n  background-color: var(--cds-layer);\n  cursor: not-allowed;\n}\n\n.cds--tag--interactive {\n  transition: background-color 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--tag__close-icon {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: 50%;\n  margin: 0 0 0 0.125rem;\n  background-color: transparent;\n  block-size: var(--cds-layout-size-height-local);\n  color: currentColor;\n  cursor: pointer;\n  inline-size: var(--cds-layout-size-height-local);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tag__close-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag__custom-icon {\n  flex-shrink: 0;\n  padding: 0;\n  border: 0;\n  background-color: transparent;\n  block-size: 1rem;\n  color: currentColor;\n  inline-size: 1rem;\n  margin-inline-end: 0.25rem;\n  outline: none;\n}\n.cds--tag__custom-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag--disabled .cds--tag__close-icon {\n  cursor: not-allowed;\n}\n\n.cds--tag__close-icon:focus {\n  z-index: 99999;\n  border-radius: 50%;\n  box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--tag--high-contrast .cds--tag__close-icon:focus {\n  box-shadow: inset 0 0 0 1px var(--cds-focus-inverse, #ffffff);\n}\n\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: transparent;\n}\n\n.cds--tag--filter.cds--tag--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--sm.cds--tag--filter {\n  padding-inline-end: 0;\n}\n\n.cds--tag--sm .cds--tag__close-icon {\n  margin-inline-start: 0.3125rem;\n}\n\n.cds--tag.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n  color: var(--cds-text-primary, #161616);\n  overflow: hidden;\n  inline-size: 3.75rem;\n}\n.cds--tag.cds--skeleton:hover, .cds--tag.cds--skeleton:focus, .cds--tag.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--tag.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--tag.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--tag.cds--skeleton.cds--tag--operational {\n  border: 1px solid var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton.cds--tag--operational:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton .cds--tag__close-icon:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n@media not all and (min-resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tag.cds--skeleton {\n      transform: translateZ(0);\n    }\n  }\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline {\n  color: currentColor;\n  margin-inline-start: 0.0625rem;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before {\n  background-color: currentColor;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline:hover {\n  border-color: currentColor;\n}\n\n/* stylelint-disable */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon svg,\n  .cds--tag__custom-icon svg {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n.cds--tag-label-tooltip {\n  max-inline-size: -webkit-fill-available;\n}\n\n.cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 11rem;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 9.875rem;\n}\n\n/* stylelint-enable */\n.cds--interactive--tag-children {\n  display: inline-flex;\n  max-inline-size: 12.5rem;\n  place-items: center;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + span > .cds--interactive--tag-children {\n  max-inline-size: 11.5rem;\n}\n\n.cds--tag .cds--definition-term {\n  border-block-end: none;\n  cursor: default;\n  max-inline-size: 12rem;\n}\n\n.cds--tag .cds--tag__custom-icon + span > .cds--definition-term {\n  max-inline-size: 11rem;\n}\n\n.cds--tag > .cds--popover-container {\n  display: flex;\n}\n\n.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled) {\n  pointer-events: none;\n}\n\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--tile-group html {\n  font-size: 100%;\n}\n.cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--tile-group strong {\n  font-weight: 600;\n}\n\n.cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--clickable,\n.cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--clickable *,\n.cds--tile--clickable *::before,\n.cds--tile--clickable *::after,\n.cds--tile--selectable *,\n.cds--tile--selectable *::before,\n.cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--tile--clickable:hover,\n.cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--tile--clickable:hover .cds--tile__checkmark, .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--tile--clickable:hover,\n.cds--tile--clickable:active,\n.cds--tile--clickable:visited,\n.cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n\n.cds--tile--clickable.cds--link--disabled,\n.cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--clickable .cds--tile--icon,\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n\n.cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n}\n\n.cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 0;\n}\n.cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n\n.cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron--interactive *,\n.cds--tile__chevron--interactive *::before,\n.cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n\n.cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n\n.cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n\n.cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n\n.cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n\n.cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n\n.cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile > .cds--slug,\n.cds--tile--expandable > div > .cds--slug,\n.cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n\n.cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n\n.cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--selectable::after,\n.cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable:focus,\n.cds--tile--slug.cds--tile--clickable:focus,\n.cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n\n.cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n\n.cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n\n.cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n\n.cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n\n.cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--slug-rounded,\n.cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n\n.cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tile__chevron svg,\n  .cds--tile__checkmark svg,\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--modal, :host(c4d-locale-modal), :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-locale-modal) .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-locale-modal) .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-locale-modal) .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-locale-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-locale-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-locale-modal) .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-locale-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-locale-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-locale-modal) .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-locale-modal) .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-locale-modal) .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-locale-modal) .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline: none;\n  text-decoration: none;\n  transition: color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--link *,\n.cds--link *::before,\n.cds--link *::after {\n  box-sizing: inherit;\n}\n.cds--link:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n  text-decoration: underline;\n}\n.cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n    outline-style: dotted;\n  }\n}\n.cds--link:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:focus {\n    outline-style: dotted;\n  }\n}\n.cds--link:visited {\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n}\n.cds--link:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link--disabled,\n.cds--link--disabled:hover {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  font-weight: 400;\n  text-decoration: none;\n}\n.cds--link--disabled *,\n.cds--link--disabled *::before,\n.cds--link--disabled *::after,\n.cds--link--disabled:hover *,\n.cds--link--disabled:hover *::before,\n.cds--link--disabled:hover *::after {\n  box-sizing: inherit;\n}\n\n.cds--link.cds--link--visited:visited {\n  color: var(--cds-link-visited-text-color, var(--cds-link-visited, #8a3ffc));\n}\n\n.cds--link.cds--link--visited:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link.cds--link--inline {\n  display: inline;\n  text-decoration: underline;\n}\n\n.cds--link--disabled.cds--link--inline {\n  text-decoration: underline;\n}\n\n.cds--link--sm,\n.cds--link--sm.cds--link--disabled:hover {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n}\n\n.cds--link--lg,\n.cds--link--lg.cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n\n.cds--link__icon {\n  display: inline-flex;\n  align-self: center;\n  margin-inline-start: 0.5rem;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--card,\n:host(c4d-card),\n:host(c4d-region-item) .cds--link,\n:host(c4d-card-cta),\n:host(c4d-card-in-card),\n:host(c4d-card-group-item),\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-content-group-cards-item),\n:host(c4d-content-group-cards-item) .cds--card {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  padding: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 100%;\n  inline-size: 100%;\n  text-decoration: none;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile-group html,\n:host(c4d-card) .cds--tile-group html,\n:host(c4d-region-item) .cds--link .cds--tile-group html,\n:host(c4d-card-cta) .cds--tile-group html,\n:host(c4d-card-in-card) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--card .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group html {\n  font-size: 100%;\n}\n.cds--card .cds--tile-group body,\n:host(c4d-card) .cds--tile-group body,\n:host(c4d-region-item) .cds--link .cds--tile-group body,\n:host(c4d-card-cta) .cds--tile-group body,\n:host(c4d-card-in-card) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--card .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--card .cds--tile-group code,\n:host(c4d-card) .cds--tile-group code,\n:host(c4d-region-item) .cds--link .cds--tile-group code,\n:host(c4d-card-cta) .cds--tile-group code,\n:host(c4d-card-in-card) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--card .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--card .cds--tile-group strong,\n:host(c4d-card) .cds--tile-group strong,\n:host(c4d-region-item) .cds--link .cds--tile-group strong,\n:host(c4d-card-cta) .cds--tile-group strong,\n:host(c4d-card-in-card) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--card .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group strong {\n  font-weight: 600;\n}\n.cds--card .cds--tile,\n:host(c4d-card) .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile,\n:host(c4d-card-cta) .cds--tile,\n:host(c4d-card-in-card) .cds--tile,\n:host(c4d-card-group-item) .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--card .cds--tile:focus,\n:host(c4d-card) .cds--tile:focus,\n:host(c4d-region-item) .cds--link .cds--tile:focus,\n:host(c4d-card-cta) .cds--tile:focus,\n:host(c4d-card-in-card) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile:focus,\n  :host(c4d-card) .cds--tile:focus,\n  :host(c4d-region-item) .cds--link .cds--tile:focus,\n  :host(c4d-card-cta) .cds--tile:focus,\n  :host(c4d-card-in-card) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--light,\n:host(c4d-card) .cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--light,\n:host(c4d-card-cta) .cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--clickable,\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--clickable *,\n.cds--card .cds--tile--clickable *::before,\n.cds--card .cds--tile--clickable *::after,\n.cds--card .cds--tile--selectable *,\n.cds--card .cds--tile--selectable *::before,\n.cds--card .cds--tile--selectable *::after,\n:host(c4d-card) .cds--tile--clickable *,\n:host(c4d-card) .cds--tile--clickable *::before,\n:host(c4d-card) .cds--tile--clickable *::after,\n:host(c4d-card) .cds--tile--selectable *,\n:host(c4d-card) .cds--tile--selectable *::before,\n:host(c4d-card) .cds--tile--selectable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::after,\n:host(c4d-card-cta) .cds--tile--clickable *,\n:host(c4d-card-cta) .cds--tile--clickable *::before,\n:host(c4d-card-cta) .cds--tile--clickable *::after,\n:host(c4d-card-cta) .cds--tile--selectable *,\n:host(c4d-card-cta) .cds--tile--selectable *::before,\n:host(c4d-card-cta) .cds--tile--selectable *::after,\n:host(c4d-card-in-card) .cds--tile--clickable *,\n:host(c4d-card-in-card) .cds--tile--clickable *::before,\n:host(c4d-card-in-card) .cds--tile--clickable *::after,\n:host(c4d-card-in-card) .cds--tile--selectable *,\n:host(c4d-card-in-card) .cds--tile--selectable *::before,\n:host(c4d-card-in-card) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--selectable:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--selectable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--selectable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--selectable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--clickable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--clickable:focus,\n  :host(c4d-card) .cds--tile--clickable:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n  :host(c4d-card-cta) .cds--tile--clickable:focus,\n  :host(c4d-card-in-card) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--clickable:hover .cds--tile__checkmark, .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--clickable:active,\n.cds--card .cds--tile--clickable:visited,\n.cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--clickable:active,\n:host(c4d-card) .cds--tile--clickable:visited,\n:host(c4d-card) .cds--tile--clickable:visited:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:active,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:active,\n:host(c4d-card-cta) .cds--tile--clickable:visited,\n:host(c4d-card-cta) .cds--tile--clickable:visited:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:active,\n:host(c4d-card-in-card) .cds--tile--clickable:visited,\n:host(c4d-card-in-card) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--card .cds--tile--clickable.cds--link--disabled,\n.cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile__checkmark,\n:host(c4d-card) .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 1;\n}\n.cds--card .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--card .cds--tile__checkmark:focus,\n:host(c4d-card) .cds--tile__checkmark:focus,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n:host(c4d-card-cta) .cds--tile__checkmark:focus,\n:host(c4d-card-in-card) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-card) .cds--tile__checkmark:focus,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n  :host(c4d-card-cta) .cds--tile__checkmark:focus,\n  :host(c4d-card-in-card) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile__checkmark--persistent,\n:host(c4d-card) .cds--tile__checkmark--persistent,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark--persistent,\n:host(c4d-card-cta) .cds--tile__checkmark--persistent,\n:host(c4d-card-in-card) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n.cds--card .cds--tile__chevron,\n:host(c4d-card) .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--card .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile__chevron--interactive,\n:host(c4d-card) .cds--tile__chevron--interactive,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive,\n:host(c4d-card-cta) .cds--tile__chevron--interactive,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile__chevron--interactive *,\n.cds--card .cds--tile__chevron--interactive *::before,\n.cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-card) .cds--tile__chevron--interactive *,\n:host(c4d-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::before,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::after,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:focus,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:hover,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n.cds--card .cds--tile--expandable,\n:host(c4d-card) .cds--tile--expandable,\n:host(c4d-region-item) .cds--link .cds--tile--expandable,\n:host(c4d-card-cta) .cds--tile--expandable,\n:host(c4d-card-in-card) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n.cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n.cds--card .cds--tile--is-expanded,\n:host(c4d-card) .cds--tile--is-expanded,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded,\n:host(c4d-card-cta) .cds--tile--is-expanded,\n:host(c4d-card-in-card) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n.cds--card .cds--tile--is-selected,\n:host(c4d-card) .cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile-content,\n:host(c4d-card) .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile-content,\n:host(c4d-card-cta) .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--card .cds--tile-input,\n:host(c4d-card) .cds--tile-input,\n:host(c4d-region-item) .cds--link .cds--tile-input,\n:host(c4d-card-cta) .cds--tile-input,\n:host(c4d-card-in-card) .cds--tile-input,\n:host(c4d-card-group-item) .cds--tile-input,\n:host(c4d-card-group-item) .cds--card .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n.cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile > .cds--slug,\n.cds--card .cds--tile--expandable > div > .cds--slug,\n.cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card) .cds--tile > .cds--slug,\n:host(c4d-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-region-item) .cds--link .cds--tile > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--expandable > div > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-cta) .cds--tile > .cds--slug,\n:host(c4d-card-cta) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-in-card) .cds--tile > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n.cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n.cds--card .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:focus,\n.cds--card .cds--tile--slug.cds--tile--clickable:focus,\n.cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n.cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--slug-rounded,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug-rounded,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n.cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--card .cds--tile__chevron svg,\n  .cds--card .cds--tile__checkmark svg,\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card:focus-within .cds--tile--clickable,\n:host(c4d-card):focus-within .cds--tile--clickable,\n:host(c4d-region-item) .cds--link:focus-within .cds--tile--clickable,\n:host(c4d-card-cta):focus-within .cds--tile--clickable,\n:host(c4d-card-in-card):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item):focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--tile--clickable {\n  position: relative;\n  z-index: 2;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--card:focus-within ::slotted(c4d-image),\n.cds--card:focus-within ::slotted(c4d-card-cta-image),\n.cds--card:focus-within .cds--card__img,\n.cds--card:focus-within .cds--image,\n:host(c4d-card):focus-within ::slotted(c4d-image),\n:host(c4d-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card):focus-within .cds--card__img,\n:host(c4d-card):focus-within .cds--image,\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link:focus-within .cds--card__img,\n:host(c4d-region-item) .cds--link:focus-within .cds--image,\n:host(c4d-card-cta):focus-within ::slotted(c4d-image),\n:host(c4d-card-cta):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta):focus-within .cds--card__img,\n:host(c4d-card-cta):focus-within .cds--image,\n:host(c4d-card-in-card):focus-within ::slotted(c4d-image),\n:host(c4d-card-in-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card):focus-within .cds--card__img,\n:host(c4d-card-in-card):focus-within .cds--image,\n:host(c4d-card-group-item):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item):focus-within .cds--card__img,\n:host(c4d-card-group-item):focus-within .cds--image,\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--image,\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item):focus-within .cds--card__img,\n:host(c4d-content-group-cards-item):focus-within .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--image {\n  z-index: -1;\n}\n.cds--card:focus, .cds--card:visited, .cds--card:active,\n:host(c4d-card):focus,\n:host(c4d-card):visited,\n:host(c4d-card):active,\n:host(c4d-region-item) .cds--link:focus,\n:host(c4d-region-item) .cds--link:visited,\n:host(c4d-region-item) .cds--link:active,\n:host(c4d-card-cta):focus,\n:host(c4d-card-cta):visited,\n:host(c4d-card-cta):active,\n:host(c4d-card-in-card):focus,\n:host(c4d-card-in-card):visited,\n:host(c4d-card-in-card):active,\n:host(c4d-card-group-item):focus,\n:host(c4d-card-group-item):visited,\n:host(c4d-card-group-item):active,\n:host(c4d-card-group-item) .cds--card:focus,\n:host(c4d-card-group-item) .cds--card:visited,\n:host(c4d-card-group-item) .cds--card:active,\n:host(c4d-content-group-cards-item):focus,\n:host(c4d-content-group-cards-item):visited,\n:host(c4d-content-group-cards-item):active,\n:host(c4d-content-group-cards-item) .cds--card:focus,\n:host(c4d-content-group-cards-item) .cds--card:visited,\n:host(c4d-content-group-cards-item) .cds--card:active {\n  position: relative;\n  z-index: 2;\n  text-decoration: none;\n}\n.cds--card:focus ::slotted(c4d-image),\n.cds--card:focus .cds--image, .cds--card:visited ::slotted(c4d-image),\n.cds--card:visited .cds--image, .cds--card:active ::slotted(c4d-image),\n.cds--card:active .cds--image,\n:host(c4d-card):focus ::slotted(c4d-image),\n:host(c4d-card):focus .cds--image,\n:host(c4d-card):visited ::slotted(c4d-image),\n:host(c4d-card):visited .cds--image,\n:host(c4d-card):active ::slotted(c4d-image),\n:host(c4d-card):active .cds--image,\n:host(c4d-region-item) .cds--link:focus ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus .cds--image,\n:host(c4d-region-item) .cds--link:visited ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:visited .cds--image,\n:host(c4d-region-item) .cds--link:active ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:active .cds--image,\n:host(c4d-card-cta):focus ::slotted(c4d-image),\n:host(c4d-card-cta):focus .cds--image,\n:host(c4d-card-cta):visited ::slotted(c4d-image),\n:host(c4d-card-cta):visited .cds--image,\n:host(c4d-card-cta):active ::slotted(c4d-image),\n:host(c4d-card-cta):active .cds--image,\n:host(c4d-card-in-card):focus ::slotted(c4d-image),\n:host(c4d-card-in-card):focus .cds--image,\n:host(c4d-card-in-card):visited ::slotted(c4d-image),\n:host(c4d-card-in-card):visited .cds--image,\n:host(c4d-card-in-card):active ::slotted(c4d-image),\n:host(c4d-card-in-card):active .cds--image,\n:host(c4d-card-group-item):focus ::slotted(c4d-image),\n:host(c4d-card-group-item):focus .cds--image,\n:host(c4d-card-group-item):visited ::slotted(c4d-image),\n:host(c4d-card-group-item):visited .cds--image,\n:host(c4d-card-group-item):active ::slotted(c4d-image),\n:host(c4d-card-group-item):active .cds--image,\n:host(c4d-card-group-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus .cds--image,\n:host(c4d-card-group-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:visited .cds--image,\n:host(c4d-card-group-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:active .cds--image,\n:host(c4d-content-group-cards-item):focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus .cds--image,\n:host(c4d-content-group-cards-item):visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):visited .cds--image,\n:host(c4d-content-group-cards-item):active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):active .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:visited .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:active .cds--image {\n  z-index: -1;\n}\n.cds--card ::slotted(c4d-image),\n.cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-card) ::slotted(c4d-image),\n:host(c4d-card) ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta) ::slotted(c4d-image),\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card) ::slotted(c4d-image),\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) ::slotted(c4d-image),\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image) {\n  position: relative;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card ::slotted(c4d-image)::before,\n  .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card) ::slotted(c4d-image)::before,\n  :host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n    position: absolute;\n    background-color: var(--cds-border-inverse, #161616);\n    content: \"\";\n    inset: 0;\n    opacity: 0;\n    transition: none;\n  }\n}\n.cds--card ::slotted(c4d-image)::before,\n.cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card) ::slotted(c4d-image)::before,\n:host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n  position: absolute;\n  background-color: var(--cds-border-inverse, #161616);\n  content: \"\";\n  inset: 0;\n  opacity: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile {\n  padding: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  position: absolute;\n  background: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  opacity: 16%;\n}\n.cds--card .cds--card,\n:host(c4d-card) .cds--card,\n:host(c4d-region-item) .cds--link .cds--card,\n:host(c4d-card-cta) .cds--card,\n:host(c4d-card-in-card) .cds--card,\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-card-group-item) .cds--card .cds--card,\n:host(c4d-content-group-cards-item) .cds--card,\n:host(c4d-content-group-cards-item) .cds--card .cds--card {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n.cds--card .cds--card__wrapper,\n:host(c4d-card) .cds--card__wrapper,\n:host(c4d-region-item) .cds--link .cds--card__wrapper,\n:host(c4d-card-cta) .cds--card__wrapper,\n:host(c4d-card-in-card) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper {\n  display: flex;\n  flex: 1;\n  justify-content: space-between;\n  min-block-size: 10rem;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  display: flex;\n}\n.cds--card .cds--card__wrapper::before,\n:host(c4d-card) .cds--card__wrapper::before,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::before,\n:host(c4d-card-cta) .cds--card__wrapper::before,\n:host(c4d-card-in-card) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 50%;\n}\n.cds--card .cds--card__wrapper::after,\n:host(c4d-card) .cds--card__wrapper::after,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::after,\n:host(c4d-card-cta) .cds--card__wrapper::after,\n:host(c4d-card-in-card) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n.cds--card .cds--card__content,\n:host(c4d-card) .cds--card__content,\n:host(c4d-region-item) .cds--link .cds--card__content,\n:host(c4d-card-cta) .cds--card__content,\n:host(c4d-card-in-card) .cds--card__content,\n:host(c4d-card-group-item) .cds--card__content,\n:host(c4d-card-group-item) .cds--card .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__content {\n  display: flex;\n  flex-direction: column;\n  padding: 1rem;\n  inline-size: 100%;\n}\n.cds--card .cds--card__heading,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n  margin-block-end: 4rem;\n}\n@media (min-width: 82rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n.cds--card .cds--card__heading,\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  color: var(--cds-text-primary, #161616);\n  max-inline-size: 40rem;\n  padding-inline-end: 10%;\n}\n@media (min-width: 42rem) {\n  .cds--card .cds--card__heading,\n  .cds--card .cds--card__copy,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-card) .cds--card__copy,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__copy,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__copy,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n    padding-inline-end: 2rem;\n  }\n}\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n  margin-block-end: 2rem;\n}\n.cds--card .cds--card__img,\n:host(c4d-card) .cds--card__img,\n:host(c4d-region-item) .cds--link .cds--card__img,\n:host(c4d-card-cta) .cds--card__img,\n:host(c4d-card-in-card) .cds--card__img,\n:host(c4d-card-group-item) .cds--card__img,\n:host(c4d-card-group-item) .cds--card .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__img {\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--card__link::after,\n:host(c4d-card) .cds--card__link::after,\n:host(c4d-region-item) .cds--link .cds--card__link::after,\n:host(c4d-card-cta) .cds--card__link::after,\n:host(c4d-card-in-card) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__link::after {\n  position: absolute;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer-wrapper,\n:host(c4d-card) .cds--card__footer-wrapper,\n:host(c4d-region-item) .cds--link .cds--card__footer-wrapper,\n:host(c4d-card-cta) .cds--card__footer-wrapper,\n:host(c4d-card-in-card) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__footer-wrapper {\n  margin-block-start: auto;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-content-group-cards-item) {\n    inline-size: auto;\n    margin-inline: 1rem;\n  }\n}\n\n:host(c4d-card-group-item),\n:host(c4d-card-in-card),\n:host(c4d-card-cta),\n:host(c4d-card) {\n  outline: none;\n}\n:host(c4d-card-group-item) .cds--card__pictogram,\n:host(c4d-card-in-card) .cds--card__pictogram,\n:host(c4d-card-cta) .cds--card__pictogram,\n:host(c4d-card) .cds--card__pictogram {\n  display: flex;\n}\n:host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n  margin-block-end: 0;\n  padding-block-start: 2rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n    display: flex;\n    flex: 1;\n    padding-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item) .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card) .cds--card__pictogram-wrapper,\n:host(c4d-card-cta) .cds--card__pictogram-wrapper,\n:host(c4d-card) .cds--card__pictogram-wrapper {\n  display: flex;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram] .cds--card ::slotted(c4d-card-heading) {\n  padding-block-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-inline-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram] .cds--card .cds--card__content {\n  position: relative;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram] .cds--card .cds--card__copy {\n  margin-block: 2rem 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card svg,\n:host(c4d-card-in-card)[pictogram] .cds--card svg,\n:host(c4d-card-cta)[pictogram] .cds--card svg,\n:host(c4d-card)[pictogram] .cds--card svg {\n  position: absolute;\n  color: var(--cds-link-primary, #0f62fe);\n  inset-block-end: 1rem;\n  inset-inline-end: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-end;\n  margin-block: auto 0;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy {\n  margin-block-start: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-start;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content {\n  padding-block-end: 4rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper {\n  position: absolute;\n  inset-block-end: 1rem;\n  inset-inline-start: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]) {\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n:host(c4d-card) ::slotted(svg[slot=pictogram]) {\n  fill: currentColor;\n  margin-inline-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card) ::slotted(svg[slot=pictogram]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-in-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-cta)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card) .cds--card__copy {\n  display: flex;\n  flex-direction: column;\n  gap: 1rem;\n}\n:host(c4d-card-group-item) .cds--card__copy[hidden],\n:host(c4d-card-in-card) .cds--card__copy[hidden],\n:host(c4d-card-cta) .cds--card__copy[hidden],\n:host(c4d-card) .cds--card__copy[hidden] {\n  /* stylelint-disable declaration-no-important */\n  display: none !important;\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    padding-block-start: 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    /* stylelint-disable value-no-vendor-prefix, property-no-vendor-prefix */\n    display: -webkit-box;\n    /* stylelint-enable value-no-vendor-prefix, property-no-vendor-prefix */\n    overflow: hidden;\n    -webkit-box-orient: vertical;\n    -webkit-line-clamp: 3;\n    max-inline-size: calc(100% - 4rem);\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9) 0.25s;\n  }\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block: 2rem 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 0;\n    opacity: 0;\n    transform: translate3d(0, -16px, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9);\n    visibility: hidden;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading) {\n    opacity: 0;\n    transform: translate3d(0, 16px, 0);\n    transition-delay: 0s;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy {\n    display: block;\n    overflow: hidden;\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition-delay: 0.2s;\n    visibility: visible;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    position: absolute;\n    display: flow-root;\n    inset-block-end: 1rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 2rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]) {\n    margin-block-end: 0;\n  }\n}\n\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 100%;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 66.6666666667%;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 75%;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 56.25%;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n.cds--card.cds--card--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--card--border {\n  border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n.cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n}\n@media (min-width: 82rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n\n:host(c4d-card):not([href]) .cds--card .cds--card__copy,\n:host(c4d-card-group-item):not([href]) .cds--card .cds--card__copy {\n  margin-block-end: 0.125rem;\n}\n:host(c4d-card):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after {\n  display: none;\n}\n:host(c4d-card):not([href]):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):not([href]):focus-within ::slotted(c4d-image) {\n  z-index: 0;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-heading),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-heading) {\n  margin-block-end: auto;\n  padding-block-end: 4rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer) {\n  display: inline-flex;\n  margin-block-start: 2rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer)::after,\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer)::after {\n  position: relative;\n}\n:host(c4d-card)[color-scheme=light] .cds--card__wrapper, :host(c4d-card)[color-scheme=light]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light] .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n:host(c4d-card)[color-scheme=light][href] :hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light][href] :hover .cds--card__wrapper {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-card)[color-scheme=light][href]:active,\n:host(c4d-card)[color-scheme=light][href] a:active,\n:host(c4d-card-group-item)[color-scheme=light][href]:active,\n:host(c4d-card-group-item)[color-scheme=light][href] a:active {\n  outline: none;\n}\n:host(c4d-card)[logo] .cds--card,\n:host(c4d-card-group-item)[logo] .cds--card {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo] .cds--card__copy,\n:host(c4d-card-group-item)[logo] .cds--card__copy {\n  margin-block-end: 1rem;\n}\n:host(c4d-card)[logo]:hover,\n:host(c4d-card-group-item)[logo]:hover {\n  border-color: var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-card)[logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo]:active,\n:host(c4d-card-group-item)[logo]:active {\n  border-color: var(--cds-border-inverse, #161616);\n}\n:host(c4d-card)[logo] ::slotted(c4d-card-footer),\n:host(c4d-card-group-item)[logo] ::slotted(c4d-card-footer) {\n  block-size: 0;\n}\n:host(c4d-card)[href][logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[href][logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n:host(c4d-card[link]) ::slotted(c4d-card-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n:host(c4d-card[link]) .cds--card .cds--card__copy {\n  margin-block-start: 0;\n}\n\n:host(c4d-card-cta),\n:host(c4d-card-link-cta),\n:host(c4d-card-link) {\n  outline: none;\n}\n\n:host(c4d-card-eyebrow),\n.cds--card__eyebrow {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.5rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-eyebrow),\n  .cds--card__eyebrow {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-footer),\n:host(c4d-card-cta-footer),\n:host(c4d-card-in-card-footer),\n:host(c4d-feature-card-footer),\n:host(c4d-feature-cta-footer) {\n  display: flex;\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-footer):focus-visible,\n:host(c4d-card-cta-footer):focus-visible,\n:host(c4d-card-in-card-footer):focus-visible,\n:host(c4d-feature-card-footer):focus-visible,\n:host(c4d-feature-cta-footer):focus-visible {\n  outline: none;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: block;\n}\n\n.cds--card .cds--card__footer,\n:host(c4d-card-footer) a,\n:host(c4d-card-cta-footer) a,\n:host(c4d-card-in-card-footer) a,\n:host(c4d-feature-card-footer) a,\n:host(c4d-feature-cta-footer) a {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer:focus,\n:host(c4d-card-footer) a:focus,\n:host(c4d-card-cta-footer) a:focus,\n:host(c4d-card-in-card-footer) a:focus,\n:host(c4d-feature-card-footer) a:focus,\n:host(c4d-feature-cta-footer) a:focus {\n  outline: none;\n}\n.cds--card .cds--card__footer:hover,\n:host(c4d-card-footer) a:hover,\n:host(c4d-card-cta-footer) a:hover,\n:host(c4d-card-in-card-footer) a:hover,\n:host(c4d-feature-card-footer) a:hover,\n:host(c4d-feature-cta-footer) a:hover {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer span,\n:host(c4d-card-footer) a span,\n:host(c4d-card-cta-footer) a span,\n:host(c4d-card-in-card-footer) a span,\n:host(c4d-feature-card-footer) a span,\n:host(c4d-feature-cta-footer) a span {\n  flex: none;\n}\n.cds--card .cds--card__footer::after,\n:host(c4d-card-footer) a::after,\n:host(c4d-card-cta-footer) a::after,\n:host(c4d-card-in-card-footer) a::after,\n:host(c4d-feature-card-footer) a::after,\n:host(c4d-feature-cta-footer) a::after {\n  position: absolute;\n  z-index: 1;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer .cds--card__cta__copy,\n:host(c4d-card-footer) a .cds--card__cta__copy,\n:host(c4d-card-cta-footer) a .cds--card__cta__copy,\n:host(c4d-card-in-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-cta-footer) a .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n  max-inline-size: calc(100% - 20px - 0.5rem);\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n.cds--card .cds--card__footer .cds--card__footer__copy,\n:host(c4d-card-footer) a .cds--card__footer__copy,\n:host(c4d-card-cta-footer) a .cds--card__footer__copy,\n:host(c4d-card-in-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-cta-footer) a .cds--card__footer__copy {\n  margin-block-end: -0.125rem;\n  max-inline-size: calc(100% - 20px);\n}\n.cds--card .cds--card__footer svg,\n.cds--card .cds--card__footer ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) a svg,\n:host(c4d-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) a svg,\n:host(c4d-card-cta-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-in-card-footer) a svg,\n:host(c4d-card-in-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-card-footer) a svg,\n:host(c4d-feature-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-cta-footer) a svg,\n:host(c4d-feature-cta-footer) a ::slotted(svg[slot=icon]) {\n  display: block;\n  margin-inline-start: 0;\n  min-inline-size: 20px;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n  inline-size: 100%;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled),\n:host(c4d-card-cta-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer {\n  justify-content: flex-start;\n  inline-size: auto;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:active, :host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  text-decoration: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer::after {\n  content: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n}\n\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile {\n  border-color: var(--cds-background-inverse, #393939);\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  display: none;\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__copy,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__copy {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]):focus-within::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]):focus-within::after {\n  position: absolute;\n  z-index: 2;\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  content: \"\";\n  inset: 0;\n  outline: 1px solid var(--cds-focus-inset, #ffffff);\n  outline-offset: -3px;\n  pointer-events: none;\n}\n\n:host(c4d-card-heading),\n:host(c4d-card-link-heading) {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  color: var(--cds-text-primary, #161616);\n  margin-block-end: 4rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-heading),\n  :host(c4d-card-link-heading) {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-heading) {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\n:host(c4d-card-link-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n.cds--card-group__card ::slotted(c4d-card-eyebrow),\n.cds--card-group__card ::slotted(c4d-card-heading),\n.cds--card-group__card ::slotted(c4d-card-link-heading) {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n.cds--card-group__card:hover ::slotted(c4d-image),\n.cds--card-group__card:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n\n@media print {\n  :host(c4d-card),\n  :host(c4d-card-group-item),\n  :host(c4d-card-cta),\n  :host(c4d-card-in-card),\n  :host(c4d-content-group-cards-item) {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  :host(c4d-card) .cds--card,\n  :host(c4d-card-group-item) .cds--card,\n  :host(c4d-card-cta) .cds--card,\n  :host(c4d-card-in-card) .cds--card,\n  :host(c4d-content-group-cards-item) .cds--card {\n    border: none;\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-card) ::slotted(c4d-image),\n  :host(c4d-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card) .cds--image,\n  :host(c4d-card-group-item) ::slotted(c4d-image),\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-group-item) .cds--image,\n  :host(c4d-card-cta) ::slotted(c4d-image),\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-cta) .cds--image,\n  :host(c4d-card-in-card) ::slotted(c4d-image),\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-in-card) .cds--image,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image),\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-content-group-cards-item) .cds--image {\n    display: none;\n  }\n  .cds--card {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  .cds--card .cds--card__img,\n  .cds--card .cds--card__image_img,\n  .cds--card .cds--image,\n  .cds--card .cds--card__video-thumbnail {\n    display: none;\n  }\n}\n:host(c4d-card[disabled]) .cds--card,\n:host(c4d-region-item[disabled]) .cds--card {\n  cursor: not-allowed;\n}\n:host(c4d-card[disabled]) .cds--card__copy,\n:host(c4d-card[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-card[disabled]) ::slotted(c4d-card-heading),\n:host(c4d-region-item[disabled]) .cds--card__copy,\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-heading) {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n:host(c4d-card-cta-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  justify-content: space-between;\n}\n\n:host(c4d-card-footer[href])::after {\n  position: relative;\n}\n\ninput:-webkit-autofill,\ninput:-webkit-autofill:hover,\ninput:-webkit-autofill:focus,\ntextarea:-webkit-autofill,\ntextarea:-webkit-autofill:hover,\ntextarea:-webkit-autofill:focus {\n  box-shadow: 0 0 0 1000px var(--cds-field) inset;\n  -webkit-text-fill-color: var(--cds-text-primary, #161616);\n}\n\n.cds--fieldset {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n.cds--fieldset *,\n.cds--fieldset *::before,\n.cds--fieldset *::after {\n  box-sizing: inherit;\n}\n\n.cds--form-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n}\n\n.cds--label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: inline-block;\n  color: var(--cds-text-secondary, #525252);\n  font-weight: 400;\n  line-height: 1rem;\n  margin-block-end: 0.5rem;\n  vertical-align: baseline;\n}\n.cds--label html {\n  font-size: 100%;\n}\n.cds--label body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--label code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--label strong {\n  font-weight: 600;\n}\n\n.cds--label .cds--toggletip-label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n\n.cds--label--no-margin {\n  margin-block-end: 0;\n}\n\n.cds--label + .cds--tooltip {\n  position: relative;\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger *,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::before,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::after {\n  box-sizing: inherit;\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg :hover {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--label + .cds--toggletip {\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 0.875rem;\n  inline-size: 4.6875rem;\n}\n.cds--label.cds--skeleton:hover, .cds--label.cds--skeleton:focus, .cds--label.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--label.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--label.cds--skeleton::before {\n    animation: none;\n  }\n}\n\ninput[type=number] {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n}\n\ninput[data-invalid]:not(:focus),\n.cds--number[data-invalid] input[type=number]:not(:focus),\n.cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n.cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n.cds--combo-box--invalid--focused),\n.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  input[data-invalid]:not(:focus),\n  .cds--number[data-invalid] input[type=number]:not(:focus),\n  .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n  .cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n  .cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n  .cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n  .cds--combo-box--invalid--focused),\n  .cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--number__input-wrapper--warning ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--warn ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--time-picker--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning > .cds--text-input ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper--warn ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select--warning .cds--select-input__wrapper ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement,\n.cds--list-box--warning ~ .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid],\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  display: block;\n}\n\n.cds--form--fluid input[data-invalid] {\n  outline: none;\n}\n\n.cds--form--fluid .cds--form-requirement {\n  padding: 0.5rem 2.5rem 0.5rem 1rem;\n  margin: 0;\n}\n\ninput:not(output, [data-invalid]):-moz-ui-invalid {\n  box-shadow: none;\n}\n\n.cds--form-requirement {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: none;\n  overflow: hidden;\n  margin: 0.25rem 0 0;\n  max-block-size: 0;\n}\n.cds--form-requirement html {\n  font-size: 100%;\n}\n.cds--form-requirement body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--form-requirement code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--form-requirement strong {\n  font-weight: 600;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-start: 0;\n}\n\n.cds--form__helper-text {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n  z-index: 0;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  margin-block-start: 0.25rem;\n  opacity: 1;\n}\n\n.cds--label--disabled,\n.cds--form__helper-text--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\nfieldset[disabled] .cds--label,\nfieldset[disabled] .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input *,\n.cds--text-input *::before,\n.cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--text-input:focus, .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input:focus, .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n\n.cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n\n.cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n\n.cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n\n.cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--text-input--password__visibility:hover::before, .cds--text-input--password__visibility:hover::after, .cds--text-input--password__visibility:focus::before, .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n\n.cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n\n.cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n\n.cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--text-input--invalid,\n.cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n\n.cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n\n.cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--skeleton.cds--text-input:hover, .cds--skeleton.cds--text-input:focus, .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n\n.cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n\n.cds--text-input__divider,\n.cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n\n.cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n\n.cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n\n.cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n\n.cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n\n.cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n\n.cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n\n.cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n\n.cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n\n.cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\n.cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid:has(~ .cds--slug),\n.cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid ~ .cds--slug,\n.cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n\n.cds--search {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--search .cds--label {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--search-input {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  order: 1;\n  padding: 0 2.5rem;\n  border: none;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  text-overflow: ellipsis;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search-input *,\n.cds--search-input *::before,\n.cds--search-input *::after {\n  box-sizing: inherit;\n}\n.cds--search-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--search-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--search-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--search-input::-ms-clear {\n  display: none;\n}\n\n.cds--search-input[disabled] {\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--search-input[disabled]::-moz-placeholder {\n  color: var(--cds-field);\n}\n.cds--search-input[disabled]::placeholder {\n  color: var(--cds-field);\n}\n\n.cds--search--light .cds--search-input {\n  background: var(--cds-field-02, #ffffff);\n}\n\n.cds--search--light .cds--search-close::before {\n  background: var(--cds-field-02, #ffffff);\n}\n\n.cds--search--sm .cds--search-input,\n.cds--search--sm.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 2rem;\n  block-size: 2rem;\n}\n\n.cds--search--sm .cds--search-magnifier-icon {\n  inset-inline-start: 0.5rem;\n}\n\n.cds--search--md .cds--search-input,\n.cds--search--md.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 2.5rem;\n  block-size: 2.5rem;\n}\n\n.cds--search--md .cds--search-magnifier-icon {\n  inset-inline-start: 0.75rem;\n}\n\n.cds--search--lg .cds--search-input,\n.cds--search--lg.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 3rem;\n  block-size: 3rem;\n}\n\n.cds--search-magnifier-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 2;\n  block-size: 1rem;\n  fill: var(--cds-icon-secondary, #525252);\n  inline-size: 1rem;\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n.cds--search-magnifier-icon *,\n.cds--search-magnifier-icon *::before,\n.cds--search-magnifier-icon *::after {\n  box-sizing: inherit;\n}\n\n.cds--search-close {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--search-close *,\n.cds--search-close *::before,\n.cds--search-close *::after {\n  box-sizing: inherit;\n}\n.cds--search-close::-moz-focus-inner {\n  border: 0;\n}\n.cds--search-close::before {\n  position: absolute;\n  display: block;\n  background-color: var(--cds-field);\n  block-size: calc(100% - 2px);\n  content: \"\";\n  inline-size: 2px;\n  inset-block-start: 0.0625rem;\n  inset-inline-start: 0;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--search-close::before {\n    transition: none;\n  }\n}\n.cds--search-close:hover {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n.cds--search-close:hover::before {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--search-button {\n  flex-shrink: 0;\n  background-color: var(--cds-field);\n  margin-inline-start: 0.125rem;\n}\n.cds--search-button svg {\n  fill: currentColor;\n  vertical-align: middle;\n}\n\n.cds--search-close svg {\n  fill: inherit;\n}\n\n.cds--search-close,\n.cds--search-button {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border-width: 1px 0;\n  border-style: solid;\n  border-color: transparent;\n  block-size: 2.5rem;\n  cursor: pointer;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 2.5rem;\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), border 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n.cds--search-close:hover,\n.cds--search-button:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--search-close:focus,\n.cds--search-button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-close:focus,\n  .cds--search-button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--search-close:active,\n.cds--search-button:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n@media screen and (prefers-contrast) {\n  .cds--search-close:active,\n  .cds--search-button:active {\n    outline-style: dotted;\n  }\n}\n\n.cds--search--disabled .cds--search-close,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier {\n  cursor: not-allowed;\n  outline: none;\n}\n.cds--search--disabled .cds--search-close:hover,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover {\n  background-color: transparent;\n  border-block-end-color: transparent;\n}\n.cds--search--disabled .cds--search-close:hover::before,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover::before {\n  background-color: transparent;\n}\n\n.cds--search--disabled svg {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--search-close:focus::before,\n.cds--search-close:active::before {\n  background-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--search-input:focus ~ .cds--search-close:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-input:focus ~ .cds--search-close:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--search--sm .cds--search-close,\n.cds--search--sm ~ .cds--search-button, .cds--search--sm.cds--search--expandable, .cds--search--sm.cds--search--expandable .cds--search-magnifier {\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--search--sm.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 2rem;\n}\n.cds--search--sm.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 2rem;\n}\n\n.cds--search--md .cds--search-close,\n.cds--search--md ~ .cds--search-button, .cds--search--md.cds--search--expandable, .cds--search--md.cds--search--expandable .cds--search-magnifier {\n  block-size: 2.5rem;\n  inline-size: 2.5rem;\n}\n.cds--search--md.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 2.5rem;\n}\n.cds--search--md.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 2.5rem;\n}\n\n.cds--search--lg .cds--search-close,\n.cds--search--lg ~ .cds--search-button, .cds--search--lg.cds--search--expandable, .cds--search--lg.cds--search--expandable .cds--search-magnifier {\n  block-size: 3rem;\n  inline-size: 3rem;\n}\n.cds--search--lg.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 3rem;\n}\n.cds--search--lg.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 3rem;\n}\n\n.cds--search-close--hidden {\n  opacity: 0;\n  visibility: hidden;\n}\n\n.cds--search--lg.cds--skeleton .cds--search-input,\n.cds--search--md.cds--skeleton .cds--search-input,\n.cds--search--sm.cds--skeleton .cds--search-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 100%;\n}\n.cds--search--lg.cds--skeleton .cds--search-input:hover, .cds--search--lg.cds--skeleton .cds--search-input:focus, .cds--search--lg.cds--skeleton .cds--search-input:active,\n.cds--search--md.cds--skeleton .cds--search-input:hover,\n.cds--search--md.cds--skeleton .cds--search-input:focus,\n.cds--search--md.cds--skeleton .cds--search-input:active,\n.cds--search--sm.cds--skeleton .cds--search-input:hover,\n.cds--search--sm.cds--skeleton .cds--search-input:focus,\n.cds--search--sm.cds--skeleton .cds--search-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--search--lg.cds--skeleton .cds--search-input::before,\n.cds--search--md.cds--skeleton .cds--search-input::before,\n.cds--search--sm.cds--skeleton .cds--search-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--search--lg.cds--skeleton .cds--search-input::before,\n  .cds--search--md.cds--skeleton .cds--search-input::before,\n  .cds--search--sm.cds--skeleton .cds--search-input::before {\n    animation: none;\n  }\n}\n.cds--search--lg.cds--skeleton .cds--search-input::-moz-placeholder, .cds--search--md.cds--skeleton .cds--search-input::-moz-placeholder, .cds--search--sm.cds--skeleton .cds--search-input::-moz-placeholder {\n  color: transparent;\n}\n.cds--search--lg.cds--skeleton .cds--search-input::placeholder,\n.cds--search--md.cds--skeleton .cds--search-input::placeholder,\n.cds--search--sm.cds--skeleton .cds--search-input::placeholder {\n  color: transparent;\n}\n\n.cds--search--expandable {\n  transition: width 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--search--expandable.cds--search--expanded {\n  inline-size: 100%;\n}\n\n.cds--search--expandable .cds--search-input {\n  padding: 0;\n  inline-size: 0;\n  transition: padding 70ms cubic-bezier(0.2, 0, 0.38, 0.9), width 0s linear 70ms;\n}\n.cds--search--expandable .cds--search-input::-moz-placeholder {\n  position: relative;\n  opacity: 0;\n  transition-duration: 70ms;\n  -moz-transition-property: padding, opacity;\n  transition-property: padding, opacity;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search--expandable .cds--search-input::placeholder {\n  position: relative;\n  opacity: 0;\n  transition-duration: 70ms;\n  transition-property: padding, opacity;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-input {\n  inline-size: 100%;\n  transition: padding 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search--expandable.cds--search--expanded .cds--search-input::-moz-placeholder {\n  position: relative;\n  padding: 0;\n  opacity: 1;\n}\n.cds--search--expandable.cds--search--expanded .cds--search-input::placeholder {\n  position: relative;\n  padding: 0;\n  opacity: 1;\n}\n\n.cds--search--expandable .cds--search-magnifier {\n  position: absolute;\n  cursor: pointer;\n}\n.cds--search--expandable .cds--search-magnifier:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--search--expandable .cds--search-magnifier:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-magnifier {\n  pointer-events: none;\n}\n\n.cds--search--expandable .cds--search-magnifier-icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-magnifier-icon {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--search--expandable.cds--search--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--search-close svg,\n  .cds--search-magnifier-icon {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-locale-modal) {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-locale-modal) .cds--modal-container {\n  padding: 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: calc(100% - 2rem);\n  min-block-size: 80%;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-locale-modal) .cds--modal-container {\n    inline-size: -moz-fit-content;\n    inline-size: fit-content;\n  }\n}\n:host(c4d-locale-modal) .cds--modal-container .cds--modal-content {\n  display: grid;\n  padding: 0;\n  margin: 0;\n  grid-template-rows: auto 1fr auto;\n}\n@media (max-height: 28.125rem) {\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__filtering .c4d--locale-modal__filter {\n    overflow-y: initial;\n  }\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__filtering .c4d--locale-modal__filter .c4d--locale-modal__list {\n    overflow-y: initial;\n  }\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__search {\n    position: relative;\n  }\n}\n:host(c4d-locale-modal) .c4d--locale-modal {\n  display: flex;\n  margin-block: 2rem 0;\n  padding-inline-start: 1rem;\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-modal) .c4d--locale-modal.cds--modal-content {\n  margin-block-start: 2rem;\n  padding-block-start: 0.5rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-modal) .c4d--locale-modal.cds--modal-content {\n    margin-block-start: auto;\n  }\n}\n:host(c4d-locale-modal) .c4d--locale-modal__locales.c4d--locale-modal__locales-hidden {\n  display: none;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label {\n  display: inline-flex;\n  padding: 0;\n  border: none;\n  background-color: transparent;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label:hover,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label:hover {\n  color: var(--cds-background-brand, #0f62fe);\n  cursor: pointer;\n  text-decoration: underline;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label:focus,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label:focus {\n  outline-color: var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label svg,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label svg {\n  fill: currentColor;\n}\n:host(c4d-locale-modal) .c4d--locale-modal__filter {\n  z-index: -1;\n  display: none;\n  inset-block-start: 3rem;\n  opacity: 0;\n  transform: translate3d(0, -24px, 0);\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n:host(c4d-locale-modal) .cds--modal-header {\n  padding-block-start: 1rem;\n  padding-inline-start: 2rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__label {\n  display: flex;\n  align-items: center;\n  color: var(--cds-text-primary, #161616);\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-modal) .cds--modal-header__label .c4d--locale-modal__label-globe {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__label .c4d--locale-modal__label-arrow {\n  margin-inline-end: 0.5rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__heading {\n  font-size: 1.75rem;\n  font-weight: 400;\n  line-height: 1.28572;\n  letter-spacing: 0;\n  font-size: calc(1.75rem + 0.25 * (100vw - 20rem) / 62);\n  padding: 0;\n  margin-block-start: 0.75rem;\n}\n@media (min-width: 82rem) {\n  :host(c4d-locale-modal) .cds--modal-header__heading {\n    font-size: 2rem;\n    line-height: 1.25;\n    font-weight: 400;\n    font-size: calc(2rem + 0 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-locale-modal) .cds--modal-header__heading {\n    font-size: 2rem;\n    font-weight: 400;\n    font-size: 2rem;\n  }\n}\n:host(c4d-locale-modal) .cds--modal-header__heading:focus {\n  outline: none;\n}\n:host(c4d-locale-modal) c4d-expressive-modal-header {\n  padding: 3px 20% 0 1rem;\n  margin-block-end: 0.5rem;\n}\n\n:host(c4d-locale-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-locale-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-locale-modal[open]) {\n    transition: none;\n  }\n}\n\n.c4d--locale-modal-container .c4d--locale-modal__regions {\n  inline-size: 100%;\n  margin-block-start: auto;\n}\n.c4d--locale-modal-container .c4d--locale-modal__regions > .cds--row {\n  margin-inline: 0;\n}\n\n:host(c4d-region-item) .cds--link {\n  display: flex;\n  align-items: stretch;\n  block-size: 100%;\n  inline-size: 100%;\n  max-inline-size: none;\n  outline: 1px solid var(--cds-layer-02, #ffffff);\n  outline-offset: -1px;\n  text-align: inherit;\n}\n:host(c4d-region-item) .cds--link:hover.cds--link--disabled {\n  display: flex;\n}\n:host(c4d-region-item) .cds--link:focus-within {\n  outline-color: var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-region-item) .cds--link {\n    min-block-size: 6rem;\n  }\n}\n\n:host(c4d-region-item) .cds--card.cds--tile {\n  border-block-end: transparent;\n}\n\n:host(c4d-region-item:last-of-type) .cds--card.cds--tile {\n  border-block-end: 1px solid var(--cds-border-tile);\n}\n\n@media (min-width: 66rem) {\n  :host(c4d-region-item) .cds--card.cds--tile {\n    border-block-end: 1px solid var(--cds-border-tile);\n  }\n  :host(c4d-region-item:first-of-type) .cds--card.cds--tile {\n    border-inline-end: transparent;\n  }\n  :host(c4d-region-item:nth-of-type(3)) .cds--card.cds--tile {\n    border-block-start: transparent;\n    border-inline-end: transparent;\n  }\n  :host(c4d-region-item:last-of-type) .cds--card.cds--tile {\n    border-block-start: transparent;\n  }\n}\n:host(c4d-region-item) svg.cds--card__cta,\n.cds--modal-container svg.cds--card__cta {\n  color: var(--cds-border-inverse, #161616);\n}\n\n:host(c4d-regions) {\n  display: flex;\n  flex-wrap: wrap;\n}\n\n:host(c4d-locale-item) a.cds--link {\n  display: flex;\n  border: 0.125rem solid transparent;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  min-block-size: 3rem;\n  text-decoration: none;\n  transition: background-color 110ms cubic-bezier(0.4, 0.14, 0.3, 1), border 110ms cubic-bezier(0.4, 0.14, 0.3, 1);\n}\n:host(c4d-locale-item) a.cds--link:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-locale-item) a.cds--link:active, :host(c4d-locale-item) a.cds--link:focus {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n:host(c4d-locale-item) .c4d--locale-modal__locales__name {\n  padding: 0.75rem 1rem;\n  color: var(--cds-text-helper, #6f6f6f);\n  inline-size: 50%;\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-item) .c4d--locale-modal__locales__name:first-of-type {\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-locale-search) {\n  display: flex;\n  overflow: hidden;\n  flex-direction: column;\n  margin-block-start: 2rem;\n  padding-block-start: 0.5rem;\n}\n:host(c4d-locale-search) cds-search::part(input)::-moz-placeholder {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-locale-search) cds-search::part(input)::placeholder {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-locale-search) .c4d--locale-modal__filter {\n  z-index: 1;\n  display: flex;\n  overflow: hidden;\n  flex: 1;\n  flex-direction: column;\n  opacity: 1;\n  transform: translate3d(0, 0, 0);\n  transition: 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n:host(c4d-locale-search) .c4d--locale-modal__regions {\n  z-index: -1;\n  display: none;\n  opacity: 0;\n  transition: 240ms cubic-bezier(0, 0, 0.3, 1);\n  visibility: hidden;\n}\n:host(c4d-locale-search) .c4d--locale-modal__search {\n  position: sticky;\n  background-color: var(--cds-background, #ffffff);\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  inset-block-start: 0;\n}\n:host(c4d-locale-search) .c4d--locale-modal__search-text {\n  padding: 2rem 1rem 1rem;\n  margin: 0;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n}\n:host(c4d-locale-search) .c4d--locale-modal__list {\n  flex: 1;\n  overflow-y: auto;\n}\n\n:host(c4d-locale-modal) c4d-expressive-modal-heading {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-region-item) {\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-region-item) {\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n  }\n}\n:host(c4d-region-item) .cds--card__wrapper {\n  block-size: 100%;\n}\n:host(c4d-region-item) ::slotted(div.c4d--region-item-footer) {\n  display: flex;\n  justify-content: flex-end;\n  color: var(--cds-border-inverse, #161616);\n  inline-size: 100%;\n  /* stylelint-disable declaration-no-important */\n  margin-block-start: auto !important;\n}\n:host(c4d-region-item) ::slotted(div.c4d--region-item-footer[disabled]) {\n  color: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}"]);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$g = i$4([
  '.cds--link{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:inline-flex;color:var(--cds-link-text-color,var(--cds-link-primary,#0f62fe));outline:0;text-decoration:none;transition:color 70ms cubic-bezier(.2,0,.38,.9)}.cds--link *,.cds--link ::after,.cds--link ::before{box-sizing:inherit}.cds--link:hover{color:var(--cds-link-hover-text-color,var(--cds-link-primary-hover,#0043ce));text-decoration:underline}.cds--link:active,.cds--link:active:visited,.cds--link:active:visited:hover{outline:1px solid var(--cds-focus,#0f62fe);color:var(--cds-link-text-color,var(--cds-link-primary,#0f62fe));outline-color:var(--cds-link-focus-text-color,var(--cds-focus,#0f62fe));text-decoration:underline}@media screen and (prefers-contrast){.cds--link:active,.cds--link:active:visited,.cds--link:active:visited:hover{outline-style:dotted}}.cds--link:focus{outline:1px solid var(--cds-focus,#0f62fe);outline-color:var(--cds-link-focus-text-color,var(--cds-focus,#0f62fe));text-decoration:underline}@media screen and (prefers-contrast){.cds--link:focus{outline-style:dotted}}.cds--link:visited{color:var(--cds-link-text-color,var(--cds-link-primary,#0f62fe))}.cds--link:visited:hover{color:var(--cds-link-hover-text-color,var(--cds-link-primary-hover,#0043ce))}.cds--link--disabled,.cds--link--disabled:hover{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;font-weight:400;text-decoration:none}.cds--link--disabled *,.cds--link--disabled ::after,.cds--link--disabled ::before,.cds--link--disabled:hover *,.cds--link--disabled:hover ::after,.cds--link--disabled:hover ::before{box-sizing:inherit}.cds--link.cds--link--visited:visited{color:var(--cds-link-visited-text-color,var(--cds-link-visited,#8a3ffc))}.cds--link.cds--link--visited:visited:hover{color:var(--cds-link-hover-text-color,var(--cds-link-primary-hover,#0043ce))}.cds--link.cds--link--inline{display:inline;text-decoration:underline}.cds--link--disabled.cds--link--inline{text-decoration:underline}.cds--link--sm,.cds--link--sm.cds--link--disabled:hover{font-size:var(--cds-helper-text-01-font-size,.75rem);line-height:var(--cds-helper-text-01-line-height,1.33333);letter-spacing:var(--cds-helper-text-01-letter-spacing,.32px)}.cds--link--lg,.cds--link--lg.cds--link--disabled:hover{font-size:var(--cds-body-compact-02-font-size,1rem);font-weight:var(--cds-body-compact-02-font-weight,400);line-height:var(--cds-body-compact-02-line-height,1.375);letter-spacing:var(--cds-body-compact-02-letter-spacing,0)}.cds--link__icon{display:inline-flex;align-self:center;margin-inline-start:.5rem}:host(cds-link){outline:0}:host(cds-link) .cds--link--disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}:host(cds-link) .cds--link__icon[hidden]{display:none}',
]);

let _2$1 = t => t,
  _t$T,
  _t2$q,
  _t3$h;

/**
 * Link size.
 */
const LINK_SIZE = {
  MEDIUM: '',
  SMALL: 'sm',
  LARGE: 'lg'
};

// Convert object key in a type
/**
 * Link.
 *
 * @element cds-link
 * @csspart link The link.
 */
let CDSLink = _decorate$Z([carbonElement(`${prefix$B}-link`)], function (_initialize, _FocusMixin) {
  class CDSLink extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSLink,
    d: [{
      kind: "field",
      key: "_hasIcon",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * `true` if there is an icon.
       */

      /**
       * Handles `slotchange` event.
       */
      function _handleSlotChange({
        target
      }) {
        const {
          name
        } = target;
        const hasContent = target.assignedNodes().some(node => node.nodeType !== Node.TEXT_NODE || node.textContent.trim());
        this[name === 'icon' ? '_hasIcon' : ''] = hasContent;
        this.requestUpdate();
      }
    }, {
      kind: "field",
      decorators: [i$1('#link')],
      key: "_linkNode",
      value: void 0
    }, {
      kind: "get",
      key: "_classes",
      value:
      /**
       * The CSS class list for the link node.
       */
      function () {
        const {
          disabled,
          size,
          inline,
          visited,
          _hasIcon
        } = this;
        return o$2({
          [`${prefix$B}--link`]: true,
          [`${prefix$B}--link--disabled`]: disabled,
          [`${prefix$B}--link--icon`]: _hasIcon,
          [`${prefix$B}--link--inline`]: inline,
          [`${prefix$B}--link--${size}`]: size,
          [`${prefix$B}--link--visited`]: visited
        });
      }

      /**
       * Handles `click` event on the `<a>`.
       */
      // eslint-disable-next-line class-methods-use-this, @typescript-eslint/no-unused-vars
    }, {
      kind: "method",
      key: "_handleClick",
      value: function _handleClick(_) {}

      /**
       * @returns The inner content.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        const {
          _hasIcon: hasIcon,
          _handleSlotChange: handleSlotChange
        } = this;
        return x(_t$T || (_t$T = _2$1`
      <slot @slotchange="${0}"></slot>
      <div ?hidden="${0}" class="${0}--link__icon">
        <slot name="icon" @slotchange="${0}"></slot>
      </div>
    `), handleSlotChange, !hasIcon, prefix$B, handleSlotChange);
      }

      /**
       * @returns The disabled link content.
       */
    }, {
      kind: "method",
      key: "_renderDisabledLink",
      value: function _renderDisabledLink() {
        const {
          _classes: classes
        } = this;
        return x(_t2$q || (_t2$q = _2$1`
      <p id="link" part="link" class="${0}">${0}</p>
    `), classes, this._renderInner());
      }

      /**
       * @returns The link content.
       */
    }, {
      kind: "method",
      key: "_renderLink",
      value: function _renderLink() {
        const {
          download,
          href,
          hreflang,
          linkRole,
          ping,
          rel,
          target,
          type,
          _classes: classes,
          _handleClick: handleClick
        } = this;
        return x(_t3$h || (_t3$h = _2$1`
      <a
        tabindex="0"
        id="link"
        role="${0}"
        class="${0}"
        part="link"
        download="${0}"
        href="${0}"
        hreflang="${0}"
        ping="${0}"
        rel="${0}"
        target="${0}"
        type="${0}"
        @click="${0}">
        ${0}
      </a>
    `), l(linkRole), classes, l(download), l(href), l(hreflang), l(ping), l(rel), l(target), l(type), handleClick, this._renderInner());
      }

      /**
       * `true` if the link should be disabled.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "download",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "href",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "hreflang",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "inline",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'link-role'
      })],
      key: "linkRole",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "ping",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "rel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return LINK_SIZE.MEDIUM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "target",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "type",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "visited",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The default file name.
       */
      /**
       * Link `href`.
       */
      /**
       * The language of what `href` points to.
       */
      /**
       * `true` if the link should be inline.
       */
      /**
       * The a11y role for `<a>`.
       */
      /**
       * URLs to ping.
       */
      /**
       * The link type.
       */
      /**
       * Link size.
       */
      /**
       * The link target.
       */
      /**
       * MIME type of the `target`.
       */
      /**
       * `true` if the link has been visited.
       */
      function render() {
        const {
          disabled
        } = this;
        return disabled ? this._renderDisabledLink() : this._renderLink();
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$g;
      }
    }]
  };
}, FocusMixin(s));

/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Basic color scheme for components.
 */
let BASIC_COLOR_SCHEME;

/**
 * Icon Placement.
 */
(function (BASIC_COLOR_SCHEME) {
  BASIC_COLOR_SCHEME["REGULAR"] = "";
  BASIC_COLOR_SCHEME["INVERSE"] = "inverse";
})(BASIC_COLOR_SCHEME || (BASIC_COLOR_SCHEME = {}));
let ICON_PLACEMENT;

/**
 * Constructor type. Used for defining mix-ins.
 */
(function (ICON_PLACEMENT) {
  ICON_PLACEMENT["LEFT"] = "left";
  ICON_PLACEMENT["RIGHT"] = "right";
})(ICON_PLACEMENT || (ICON_PLACEMENT = {}));

var styles$f = i$4(["/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline: none;\n  text-decoration: none;\n  transition: color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--link *,\n.cds--link *::before,\n.cds--link *::after {\n  box-sizing: inherit;\n}\n.cds--link:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n  text-decoration: underline;\n}\n.cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n    outline-style: dotted;\n  }\n}\n.cds--link:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:focus {\n    outline-style: dotted;\n  }\n}\n.cds--link:visited {\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n}\n.cds--link:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link--disabled,\n.cds--link--disabled:hover {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  font-weight: 400;\n  text-decoration: none;\n}\n.cds--link--disabled *,\n.cds--link--disabled *::before,\n.cds--link--disabled *::after,\n.cds--link--disabled:hover *,\n.cds--link--disabled:hover *::before,\n.cds--link--disabled:hover *::after {\n  box-sizing: inherit;\n}\n\n.cds--link.cds--link--visited:visited {\n  color: var(--cds-link-visited-text-color, var(--cds-link-visited, #8a3ffc));\n}\n\n.cds--link.cds--link--visited:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link.cds--link--inline {\n  display: inline;\n  text-decoration: underline;\n}\n\n.cds--link--disabled.cds--link--inline {\n  text-decoration: underline;\n}\n\n.cds--link--sm,\n.cds--link--sm.cds--link--disabled:hover {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n}\n\n.cds--link--lg,\n.cds--link--lg.cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n\n.cds--link__icon {\n  display: inline-flex;\n  align-self: center;\n  margin-inline-start: 0.5rem;\n}\n\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--modal, :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link-with-icon span,\n:host(c4d-link-with-icon) span,\n:host(c4d-link-list-item) span,\n:host(c4d-link-list-item-cta) span,\n:host(c4d-text-cta) span {\n  flex: 1;\n  align-self: center;\n  vertical-align: middle;\n}\n.cds--link-with-icon svg,\n.cds--link-with-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) svg,\n:host(c4d-link-with-icon) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) svg,\n:host(c4d-link-list-item) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) svg,\n:host(c4d-link-list-item-cta) ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) svg,\n:host(c4d-text-cta) ::slotted(svg[slot=icon]) {\n  display: inline;\n  align-self: middle;\n  fill: currentColor;\n  margin-inline-start: 0.5rem;\n}\n.cds--link-with-icon.cds--link--visited,\n:host(c4d-link-with-icon).cds--link--visited,\n:host(c4d-link-list-item).cds--link--visited,\n:host(c4d-link-list-item-cta).cds--link--visited,\n:host(c4d-text-cta).cds--link--visited {\n  color: var(--cds-link-visited, #8a3ffc);\n}\n.cds--link-with-icon.cds--link--disabled:hover,\n:host(c4d-link-with-icon).cds--link--disabled:hover,\n:host(c4d-link-list-item).cds--link--disabled:hover,\n:host(c4d-link-list-item-cta).cds--link--disabled:hover,\n:host(c4d-text-cta).cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n.cds--link-with-icon .cds--link--disabled,\n:host(c4d-link-with-icon) .cds--link--disabled,\n:host(c4d-link-list-item) .cds--link--disabled,\n:host(c4d-link-list-item-cta) .cds--link--disabled,\n:host(c4d-text-cta) .cds--link--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-text-cta).cds--link-with-icon__icon-left,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left {\n  display: flex;\n  flex-direction: row-reverse;\n  justify-content: flex-end;\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]) {\n  position: relative;\n  align-self: start;\n  inset-block-start: 1px;\n  margin-inline: 0 0.5rem;\n}\n\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: inline-block;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover {\n  text-underline-position: under;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: inline;\n  vertical-align: middle;\n  white-space: nowrap;\n}\n\n:host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n  display: none;\n}\n@media (min-width: 66rem) {\n  :host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n    display: inline;\n  }\n}\n\n.cds--link-with-icon:not(:first-of-type),\n:host(c4d-link-with-icon):not(:first-of-type),\n:host(c4d-text-cta):not(:first-of-type) {\n  margin-inline-start: 2rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]) {\n  margin-inline: 0 0.5rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]) {\n  margin-inline: 0.5rem 0;\n}\n.cds--link-with-icon:focus,\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.cds--link-with-icon:active,\n:host(c4d-link-with-icon):active,\n:host(c4d-text-cta):active {\n  text-decoration: none;\n}\n\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: none;\n}\n\n:host(c4d-link-with-icon),\n.cds--link-with-icon__container {\n  display: table;\n}"]);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$y = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M24.59 16.59L17 24.17 17 4 15 4 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$x = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M26 24v4H6V24H4v4H4a2 2 0 002 2H26a2 2 0 002-2h0V24zM26 14L24.59 12.59 17 20.17 17 2 15 2 15 20.17 7.41 12.59 6 14 16 24 26 14z"></path></svg>`;

var defineProperty = {exports: {}};

(function (module) {
var toPropertyKey$1 = toPropertyKey.exports;
function _defineProperty(e, r, t) {
  return (r = toPropertyKey$1(r)) in e ? Object.defineProperty(e, r, {
    value: t,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : e[r] = t, e;
}
module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(defineProperty));

var _defineProperty$8 = /*@__PURE__*/getDefaultExportFromCjs(defineProperty.exports);

function ownKeys$7(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$7(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$7(Object(t), !0).forEach(function (r) { _defineProperty$8(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$7(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

/**
 * Sets the Kaltura Partner ID, set by environment variable "KALTURA_PARTNER_ID"
 *
 * @type {number}
 * @private
 */
var _partnerId = process && (process.env.REACT_APP_KALTURA_PARTNER_ID || process.env.KALTURA_PARTNER_ID) || 1773841;

/**
 * Sets the Kaltura UIConf ID, set by environment variable "KALTURA_UICONF_ID"
 *
 * @type {number}
 * @private
 */
var _uiConfId = process && (process.env.REACT_APP_KALTURA_UICONF_ID || process.env.KALTURA_UICONF_ID) || 27941801;

/**
 * @type {string} _embedUrl The API URL to call
 * @private
 */
var _embedUrl = "https://cdnapisec.kaltura.com/p/".concat(_partnerId, "/sp/").concat(_partnerId, "00/embedIframeJs/uiconf_id/").concat(_uiConfId, "/partner_id/").concat(_partnerId);

/**
 * @type {string} _thumbnailUrl
 * @private
 */
var _thumbnailUrl = "https://cdnsecakmi.kaltura.com/p/".concat(_partnerId, "/thumbnail/entry_id/");

/**
 * Number of times to retry the script ready loop before failing
 *
 * @type {number}
 * @private
 */
var _timeoutRetries = 50;

/**
 * Tracks the number of attempts for the script ready loop
 *
 * @type {number}
 * @private
 */
var _attempt = 0;

/**
 * Tracks the script status
 *
 * @type {boolean} _scriptLoading to track the script loading or not
 * @private
 */
var _scriptLoading = false;

/**
 * Timeout loop to check script state is the _scriptLoaded state or _scriptLoading state
 *
 * @param {Function} resolve Resolve function
 * @param {Function} reject Reject function
 * @private
 */
function _scriptReady(resolve, reject) {
  /**
   *
   * @param {object} root.kWidget if exists then resolve
   */
  if (lib.kWidget) {
    _scriptLoading = false;
    resolve();
  } else if (_scriptLoading) {
    _attempt++;
    if (_attempt < _timeoutRetries) {
      setTimeout(function () {
        _scriptReady(resolve, reject);
      }, 100);
    } else {
      reject();
    }
  } else {
    _loadScript();
    _scriptReady(resolve, reject);
  }
}

/**
 * Returns boolean if the _scriptLoading and _scriptLoaded flag is false
 *
 * @private
 */
function _loadScript() {
  _scriptLoading = true;
  var script = document.createElement('script');
  script.src = _embedUrl;
  script.async = true;
  document.body.appendChild(script);
}

/**
 *
 * Object to cache media data
 *
 * @private
 */
var mediaData = {};

/**
 * KalturaPlayerAPI class with methods of checking script state and
 * embed media meta data and api data
 *
 * In order to set the Partner ID/UIConf ID, set the following environment
 * variables:
 *
 * - KALTURA_PARTNER_ID
 * - KALTURA_UICONF_ID
 */
var KalturaPlayerAPI = /*#__PURE__*/function () {
  function KalturaPlayerAPI() {
    _classCallCheck$2(this, KalturaPlayerAPI);
  }
  return _createClass$2(KalturaPlayerAPI, null, [{
    key: "checkScript",
    value:
    /**
     *
     * Gets the full _scriptReady state
     *
     * @returns {Promise<*>} Promise kaltura media player file
     */
    function checkScript() {
      return new Promise(function (resolve, reject) {
        _scriptReady(resolve, reject);
      });
    }

    /**
     * Creates thumbnail image url with customizable params
     *
     * @param {object} params param object
     * @param {string} params.mediaId media id
     * @param {string} params.height specify height in pixels
     * @param {string} params.width specify width in pixels
     * @returns {string} url of thumbnail image
     * @example
     * import { KalturaPlayerAPI } from '@carbon/ibmdotcom-services';
     *
     * function thumbnail() {
     *   const thumbnailData = {
     *      mediaId: '1_9h94wo6b',
     *      height: '240',
     *      width: '320'
     *   }
     *   const thumbnailUrl = KalturaPlayerAPI.getThumbnailUrl(thumbnailData);
     * }
     */
  }, {
    key: "getThumbnailUrl",
    value: function getThumbnailUrl(_ref) {
      var mediaId = _ref.mediaId,
        height = _ref.height,
        width = _ref.width;
      var url = _thumbnailUrl + mediaId;
      if (height) {
        url = url + "/height/".concat(height);
      }
      if (width) {
        url = url + "/width/".concat(width);
      }
      return url;
    }

    /**
     * Gets the embed meta data
     *
     * @param {string} mediaId  The mediaId we're embedding the placeholder for.
     * @param {string} targetId The targetId the ID where we're putting the placeholder.
     * @param {object} flashvars Determine any extra param or plugin for the player.
     * @param {boolean} useIbmMetrics Whether or not should IBM Metrics events be fired.
     * @param {Function} customReadyCallback Determine any extra functions that should be executed
     *  on player readyCallback.
     * @returns {object}  object
     * @example
     * import { KalturaPlayerAPI } from '@carbon/ibmdotcom-services';
     *
     * function embedMyVideo() {
     *   const elem = document.getElementById('foo');
     *   const videoid = '12345';
     *   KalturaPlayerAPI.embedMedia(videoid, elem);
     * }
     */
  }, {
    key: "embedMedia",
    value: (function () {
      var _embedMedia = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(mediaId, targetId) {
        var flashvars,
          useIbmMetrics,
          customReadyCallback,
          fireEvent,
          _args = arguments;
        return regenerator.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              flashvars = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
              useIbmMetrics = _args.length > 3 && _args[3] !== undefined ? _args[3] : true;
              customReadyCallback = _args.length > 4 && _args[4] !== undefined ? _args[4] : function () {};
              fireEvent = this.fireEvent;
              _context.next = 6;
              return this.checkScript().then(function () {
                var promiseKWidget = new Promise(function (resolve) {
                  var defaultFlashVars = {
                    autoPlay: true,
                    closedCaptions: {
                      plugin: true
                    },
                    /**
                     * When altering this default prop,
                     * please also check the video-player-container
                     * _getPlayerOptions prop of same name - as it also
                     * replicates the value below except for text
                     */
                    titleLabel: {
                      plugin: true,
                      align: 'left',
                      text: '{mediaProxy.entry.name}'
                    },
                    ibm: {
                      template: 'idl'
                    }
                  };
                  var isCustomCreated;
                  if (!document.getElementById(targetId) && document.querySelector('cds-tabs-extended-media')) {
                    var newVideoDiv = document.createElement('div');
                    newVideoDiv.classList.add("bx--video-player__video");
                    newVideoDiv.setAttribute('id', targetId);
                    document.body.append(newVideoDiv);
                    isCustomCreated = true;
                  }
                  lib.kWidget.embed({
                    targetId: targetId,
                    wid: '_' + _partnerId,
                    uiconf_id: _uiConfId,
                    entry_id: mediaId,
                    flashvars: _objectSpread$7(_objectSpread$7({}, defaultFlashVars), flashvars),
                    params: {
                      wmode: 'transparent'
                    },
                    // Ready callback is issued for this player:
                    readyCallback: function readyCallback(playerId) {
                      var kdp = document.getElementById(playerId);
                      if (useIbmMetrics) {
                        kdp.addJsListener('playerPaused.ibm', function () {
                          fireEvent({
                            playerState: 1,
                            kdp: kdp,
                            mediaId: mediaId
                          });
                        });
                        kdp.addJsListener('playerPlayed.ibm', function () {
                          fireEvent({
                            playerState: 2,
                            kdp: kdp,
                            mediaId: mediaId
                          });
                        });
                        kdp.addJsListener('playerPlayEnd.ibm', function () {
                          fireEvent({
                            playerState: 3,
                            kdp: kdp,
                            mediaId: mediaId
                          });
                        });
                        kdp.addJsListener('IbmCtaEvent.ibm', function (ctaData) {
                          var customMetricsData = (ctaData === null || ctaData === void 0 ? void 0 : ctaData.customMetricsData) || {};
                          fireEvent({
                            playerState: 101,
                            kdp: kdp,
                            mediaId: mediaId,
                            customMetricsData: customMetricsData
                          });
                        });
                      }
                      customReadyCallback(kdp);
                      resolve(kdp);
                    }
                  });
                  if (isCustomCreated) {
                    var previousVideoDiv = document.querySelector('cds-tabs-extended-media').shadowRoot.querySelector(".bx--accordion__item--active cds-video-player").lastChild;
                    previousVideoDiv.parentElement.appendChild(document.getElementById(targetId));
                  }
                });
                return {
                  kWidget: function kWidget() {
                    return promiseKWidget;
                  }
                };
              });
            case 6:
              return _context.abrupt("return", _context.sent);
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function embedMedia(_x, _x2) {
        return _embedMedia.apply(this, arguments);
      }
      return embedMedia;
    }()
    /**
     * Fires a metrics event when the media was played.
     * Pass events to common metrics event.
     *
     * @param {object} param params
     * @param {number} param.playerState state detecting different user actions
     * @param {object} param.kdp media object
     * @param {string} param.mediaId id of the media
     * @param {object} param.customMetricsData any extra parameter for custom events
     */
    )
  }, {
    key: "fireEvent",
    value: function fireEvent(_ref2) {
      var playerState = _ref2.playerState,
        kdp = _ref2.kdp,
        mediaId = _ref2.mediaId,
        _ref2$customMetricsDa = _ref2.customMetricsData,
        customMetricsData = _ref2$customMetricsDa === void 0 ? {} : _ref2$customMetricsDa;
      // If media was played and timestamp is 0, it should be "launched" state.
      var currentTime = Math.round(kdp.evaluate('{video.player.currentTime}'));
      if (playerState === 2 && currentTime === 0) {
        playerState = 0;
      }
      var eventData = {
        playerType: 'kaltura',
        title: kdp.evaluate('{mediaProxy.entry.name}'),
        currentTime: currentTime,
        duration: kdp.evaluate('{mediaProxy.entry.duration}'),
        playerState: playerState,
        mediaId: mediaId,
        customMetricsData: customMetricsData
      };
      AnalyticsAPI.videoPlayerStats(eventData);
    }

    /**
     * Gets the api data
     *
     * @param {string} mediaId  The mediaId we're embedding the placeholder for.
     * @returns {object}  object
     * @example
     * import { KalturaPlayerAPI } from '@carbon/ibmdotcom-services';
     *
     * async function getMyVideoInfo(id) {
     *   const data = await KalturaPlayerAPI.api(id);
     *   console.log(data);
     * }
     */
  }, {
    key: "api",
    value: (function () {
      var _api = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2(mediaId) {
        return regenerator.wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this.checkScript().then(function () {
                if (mediaData && mediaData[mediaId]) {
                  return mediaData[mediaId];
                } else {
                  return new Promise(function (resolve) {
                    return new lib.kWidget.api({
                      wid: '_' + _partnerId
                    }).doRequest({
                      service: 'media',
                      action: 'get',
                      entryId: mediaId
                    }, function (jsonObj) {
                      mediaData[jsonObj.id] = jsonObj;
                      resolve(jsonObj);
                    });
                  });
                }
              });
            case 2:
              return _context2.abrupt("return", _context2.sent);
            case 3:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function api(_x3) {
        return _api.apply(this, arguments);
      }
      return api;
    }()
    /**
     * Convert media duration from milliseconds and seconds to HH:MM:SS
     *
     * @param {string} duration media duration in seconds
     * @param {boolean} fromMilliseconds the duration argument is expressed in milliseconds rather than seconds
     * @returns {string} converted duration
     */
    )
  }, {
    key: "getMediaDuration",
    value: function getMediaDuration() {
      var _root$kWidget;
      var duration = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var fromMilliseconds = arguments.length > 1 ? arguments[1] : undefined;
      if (fromMilliseconds) {
        var _seconds = Math.floor(duration / 1000 % 60);
        var _minutes = Math.floor(duration / (1000 * 60) % 60);
        var _hours = Math.floor(duration / (1000 * 60 * 60) % 24);
        _hours = _hours > 0 ? _hours + ':' : '';
        _seconds = _seconds < 10 ? '0' + _seconds : _seconds;
        return duration && '(' + _hours + _minutes + ':' + _seconds + ')';
      }
      var parsedTime = (lib === null || lib === void 0 || (_root$kWidget = lib.kWidget) === null || _root$kWidget === void 0 ? void 0 : _root$kWidget.seconds2Measurements(duration)) || {};
      var hours = (parsedTime === null || parsedTime === void 0 ? void 0 : parsedTime.hours) || 0;
      var minutes = (parsedTime === null || parsedTime === void 0 ? void 0 : parsedTime.minutes) || 0;
      var seconds = (parsedTime === null || parsedTime === void 0 ? void 0 : parsedTime.seconds) || 0;
      minutes = (hours > 0 ? '0' + minutes : minutes).toString().slice(-2);
      hours = hours > 0 ? hours + ':' : '';
      seconds = ('0' + seconds).slice(-2);
      return hours + minutes + ':' + seconds;
    }
  }, {
    key: "getMediaDurationFormatted",
    value: function getMediaDurationFormatted() {
      var duration = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var fromMilliseconds = arguments.length > 1 ? arguments[1] : undefined;
      var ms = duration;
      if (!fromMilliseconds) {
        ms = duration * 1000;
      }
      var s = Math.floor(ms / 1000 % 60);
      var m = Math.floor(ms / (1000 * 60) % 60);
      var h = Math.floor(ms / (1000 * 60 * 60) % 24);
      var seconds = KalturaPlayerAPI.formatTime(s, 'second');
      var minutes = h || m ? KalturaPlayerAPI.formatTime(m, 'minute') : '';
      var hours = h ? KalturaPlayerAPI.formatTime(h, 'hour') : '';
      return "".concat(hours, " ").concat(minutes, " ").concat(seconds).trim();
    }
  }, {
    key: "formatTime",
    value: function formatTime(number, unit) {
      var locale = lib.document.documentElement.lang || lib.navigator.language;
      return new Intl.NumberFormat(locale, {
        style: 'unit',
        // @ts-ignore: TS lacking support for standard option
        unitDisplay: 'long',
        unit: unit
      }).format(number);
    }
  }]);
}();

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$w = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M26,28H6a2.0027,2.0027,0,0,1-2-2V6A2.0027,2.0027,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0027,2.0027,0,0,1,26,28Z"></path><path d="M20 2L20 4 26.586 4 18 12.586 19.414 14 28 5.414 28 12 30 12 30 2 20 2z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$v = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$u = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2v6A2 2 0 0126 14zM6 6v6H26V6zM26 28H20a2 2 0 01-2-2V20a2 2 0 012-2h6a2 2 0 012 2v6A2 2 0 0126 28zm-6-8v6h6V20z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$t = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M30 18L30 16 24 16 24 26 26 26 26 22 29 22 29 20 26 20 26 18 30 18zM19 26H15V16h4a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0119 26zm-2-2h2a1.0011 1.0011 0 001-1V19a1.0011 1.0011 0 00-1-1H17zM11 16H6V26H8V23h3a2.0027 2.0027 0 002-2V18A2.0023 2.0023 0 0011 16zM8 21V18h3l.001 3z"></path><path d="M22,14V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,14,2H4A2.0059,2.0059,0,0,0,2,4V28a2,2,0,0,0,2,2H20V28H4V4h8v6a2.0059,2.0059,0,0,0,2,2h6v2Zm-8-4V4.4L19.6,10Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$s = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"></path><path d="M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"></path><path d="M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$r = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$q = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M26,4h-4V2h-2v2h-8V2h-2v2H6C4.9,4,4,4.9,4,6v20c0,1.1,0.9,2,2,2h20c1.1,0,2-0.9,2-2V6C28,4.9,27.1,4,26,4z M26,26H6V12h20	V26z M26,10H6V6h4v2h2V6h8v2h2V6h4V10z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$p = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$o = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"></path><path d="M8 10H24V12H8zM8 16H18V18H8z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * CTA style.
 */
let CTA_STYLE;

/**
 * CTA type.
 */
(function (CTA_STYLE) {
  CTA_STYLE["TEXT"] = "text";
  CTA_STYLE["BUTTON"] = "button";
  CTA_STYLE["CARD"] = "card";
  CTA_STYLE["CARDLINK"] = "card-link";
  CTA_STYLE["FEATURE"] = "feature";
})(CTA_STYLE || (CTA_STYLE = {}));
let CTA_TYPE;
(function (CTA_TYPE) {
  CTA_TYPE["REGULAR"] = "";
  CTA_TYPE["LOCAL"] = "local";
  CTA_TYPE["JUMP"] = "jump";
  CTA_TYPE["EXTERNAL"] = "external";
  CTA_TYPE["NEW_TAB"] = "new tab";
  CTA_TYPE["DOWNLOAD"] = "download";
  CTA_TYPE["VIDEO"] = "video";
  CTA_TYPE["PDF"] = "pdf";
  CTA_TYPE["BLOG"] = "blog";
  CTA_TYPE["EMAIL"] = "email";
  CTA_TYPE["SCHEDULE"] = "schedule";
  CTA_TYPE["CHAT"] = "chat";
  CTA_TYPE["CALL"] = "call";
})(CTA_TYPE || (CTA_TYPE = {}));

/**
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The default g11n formatter for video caption, combining video name and video duration.
 * Components using this function should have a mechanism to allow translators
 * to replace it with one accomodating the preferences of specific locale.
 *
 * @param {object} [options] The options, with a video name and a formatted video duration.
 * @param {string} [options.duration] The video duration.
 * @param {string} [options.name] The video name.
 * @returns {string} The formatted video caption.
 */
function formatVideoCaption() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    duration = _ref.duration,
    name = _ref.name;
  return !name || duration !== 0 && !duration ? name || duration || '' : "".concat(name, " (").concat(duration, ")");
}

/**
 * The default g11n formatter for video duration.
 * Components using this function should have a mechanism to allow translators
 * to replace it with one accomodating the preferences of specific locale,
 * or to replace it with general-purpose g11n formatting library.
 * (e.g. moment, though it's too big for us to make it a hard dependency)
 *
 * @param {object} [options] The options, with a video duration.
 * @param {number} [options.duration] The video duration, in seconds.
 * @returns {string} The formatted video duration.
 */
function formatVideoDuration() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    duration = _ref2.duration;
  var hours = Math.floor((duration !== null && duration !== void 0 ? duration : 0) / (1000 * 60 * 60) % 24);
  var minutes = Math.floor((duration !== null && duration !== void 0 ? duration : 0) / 60000);
  var seconds = Math.floor((duration !== null && duration !== void 0 ? duration : 0) / 1000 % 60);
  var fillSeconds = Array.from({
    length: 2 - String(seconds).length + 1
  }).join('0');
  return duration == null ? duration : hours ? "".concat(hours, ":").concat(minutes, " hr") : "".concat(minutes, ":").concat(fillSeconds).concat(seconds, " min");
}

let _$R = t => t,
  _t$S;
function _decorate$T(e, r, t, i) { var o = _getDecoratorsApi$T(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$T(s.d.map(_createElementDescriptor$T)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$T() { _getDecoratorsApi$T = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$T(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$T(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$V(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$T(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$T(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$T(e) { var r, t = _toPropertyKey$V(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$T(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$T(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$T(o.descriptor) || _isDataDescriptor$T(i.descriptor)) { if (_hasDecorators$T(o) || _hasDecorators$T(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$T(o)) { if (_hasDecorators$T(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$T(o, i); } } else r.push(o); } return r; }
function _hasDecorators$T(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$T(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$T(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$V(t) { var i = _toPrimitive$V(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$V(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$T(r) { return _arrayWithHoles$U(r) || _iterableToArray$T(r) || _unsupportedIterableToArray$U(r) || _nonIterableRest$U(); }
function _nonIterableRest$U() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$U(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$U(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$U(r, a) : void 0; } }
function _arrayLikeToArray$U(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$T(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$U(r) { if (Array.isArray(r)) return r; }
function _superPropGet$A(t, e, r, o) { var p = _get$u(_getPrototypeOf$u(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$u() { return _get$u = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$u(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$u.apply(null, arguments); }
function _superPropBase$u(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$u(t));); return t; }
function _getPrototypeOf$u(t) { return _getPrototypeOf$u = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$u(t); }
const {
  prefix: prefix$y,
  stablePrefix: c4dPrefix$U
} = settings;

/**
 * Icons to use, keyed by CTA type.
 */
const icons = {
  [CTA_TYPE.LOCAL]: svgResultCarbonIcon$D,
  [`${CTA_TYPE.LOCAL}-rtl`]: svgResultCarbonIcon$B,
  [CTA_TYPE.DOWNLOAD]: svgResultCarbonIcon$x,
  [CTA_TYPE.EXTERNAL]: svgResultCarbonIcon$w,
  [CTA_TYPE.NEW_TAB]: svgResultCarbonIcon$s,
  [CTA_TYPE.JUMP]: svgResultCarbonIcon$y,
  [CTA_TYPE.VIDEO]: svgResultCarbonIcon$v,
  [CTA_TYPE.PDF]: svgResultCarbonIcon$t,
  [CTA_TYPE.BLOG]: svgResultCarbonIcon$u,
  [CTA_TYPE.EMAIL]: svgResultCarbonIcon$p,
  [CTA_TYPE.SCHEDULE]: svgResultCarbonIcon$q,
  [CTA_TYPE.CHAT]: svgResultCarbonIcon$o,
  [CTA_TYPE.CALL]: svgResultCarbonIcon$r
};

/**
 * Aria Labels to use, keyed by CTA type.
 */
const ariaLabels = {
  [CTA_TYPE.LOCAL]: '',
  [CTA_TYPE.DOWNLOAD]: ' - This link downloads a file',
  [CTA_TYPE.EXTERNAL]: ' - This link opens in a new tab',
  [CTA_TYPE.NEW_TAB]: ' - This link opens in a new tab',
  [CTA_TYPE.JUMP]: '',
  [CTA_TYPE.VIDEO]: ' - This link plays a video',
  [CTA_TYPE.PDF]: ' - This link downloads a pdf',
  [CTA_TYPE.BLOG]: ''
};

/**
 * @param Base The base class.
 * @returns A mix-in implementing the logic of handling link for CTA.
 * @csspart icon-visually-hidden - The cta icon element for screen readers. Usage: `c4d-left-nav-name::part(icon-visually-hidden)`
 */
const CTAMixin = Base => {
  let CTAMixinImpl = _decorate$T(null, function (_initialize, _Base) {
    class CTAMixinImpl extends _Base {
      constructor(...args) {
        super(...args);
        _initialize(this);
      }
    }
    return {
      F: CTAMixinImpl,
      d: [{
        kind: "method",
        key: "_handleClick",
        value:
        /**
         * The `<a>`.
         *
         * @internal
         */

        /**
         * Handles `click` event on the `<a>.
         *
         * @param event The event.
         */
        function _handleClick(event) {
          const {
            ctaType,
            disabled,
            href,
            videoDescription,
            videoName
          } = this;
          if (ctaType === CTA_TYPE.VIDEO) {
            event.preventDefault(); // Stop following the link
          }
          if (!disabled) {
            const {
              eventRunAction
            } = this.constructor;
            this.dispatchEvent(new CustomEvent(eventRunAction, {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: {
                href,
                ctaType,
                videoName,
                videoDescription
              }
            }));
          } else {
            event.preventDefault(); // Stop following the link
            event.stopPropagation(); // Stop firing `onClick`
          }
        }

        /**
         * The CTA type.
         */
      }, {
        kind: "field",
        decorators: [n$1({
          attribute: 'cta-type',
          type: String,
          reflect: true
        })],
        key: "ctaType",
        value() {
          return CTA_TYPE.REGULAR;
        }
      }, {
        kind: "field",
        decorators: [n$1({
          type: Boolean
        })],
        key: "disabled",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1()],
        key: "download",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1()],
        key: "href",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1()],
        key: "target",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1({
          attribute: false
        })],
        key: "formatVideoCaption",
        value() {
          return formatVideoCaption;
        }
      }, {
        kind: "field",
        decorators: [n$1({
          attribute: false
        })],
        key: "formatVideoDuration",
        value() {
          return formatVideoDuration;
        }
      }, {
        kind: "field",
        decorators: [n$1({
          type: Number,
          attribute: 'video-duration',
          reflect: true
        })],
        key: "videoDuration",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1({
          attribute: 'video-name',
          reflect: true
        })],
        key: "videoName",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1({
          attribute: 'video-description',
          reflect: true
        })],
        key: "videoDescription",
        value: void 0
      }, {
        kind: "field",
        decorators: [n$1()],
        key: "videoTitle",
        value: void 0
      }, {
        kind: "method",
        key: "_renderIcon",
        value:
        /**
         * `true` if the button should be disabled.
         */
        /**
         * The default file name.
         */
        /**
         * Link `href`.
         */
        /**
         * The link target.
         */
        /**
         * The formatter for the video caption, composed with the video name and the video duration.
         * Should be changed upon the locale the UI is rendered with.
         */
        /**
         * The formatter for the video duration.
         * Should be changed upon the locale the UI is rendered with.
         */
        /**
         * The video duration.
         */
        /**
         * The video name.
         */
        /**
         * The video description.
         */
        /**
         * The full formatted video title with duration
         */
        /**
         * The video thumbnail URL.
         * Text CTA does not support video thumbnail, and this property should never be set.
         */
        /**
         * @returns The template for the icon.
         */
        function _renderIcon() {
          var _icons;
          const {
            ctaType
          } = this;
          const icon = (_icons = icons[`${ctaType}-${document.dir}`]) !== null && _icons !== void 0 ? _icons : icons[ctaType];
          return x(_t$S || (_t$S = _$R`
        <slot name="icon">
          <span class="${0}--visually-hidden" part="icon-visually-hidden"
            >${0}</span
          >
          ${0}
        </slot>
      `), prefix$y, ariaLabels[ctaType], icon === null || icon === void 0 ? void 0 : icon({
            class: `${c4dPrefix$U}--card__cta ${c4dPrefix$U}-ce--cta__icon`
          }));
        }
      }, {
        kind: "method",
        key: "firstUpdated",
        value: function firstUpdated() {
          const {
            ctaType,
            href
          } = this;
          // Check for the URL trigger meant to fire eventRunAction.
          if (ctaType === CTA_TYPE.VIDEO && href) {
            this._checkUrlVideoTrigger();
          }
        }

        /**
         * Handles `.updated()` method of `lit-element`.
         */
      }, {
        kind: "method",
        key: "updated",
        value: function updated(changedProperties) {
          var _this$shadowRoot;
          // Declaring this mixin as it extends `LitElement` seems to cause a TS error
          // @ts-ignore
          _superPropGet$A(CTAMixinImpl, "updated", this, 3)([changedProperties]);
          const {
            ctaType,
            _linkNode: linkNode,
            videoName,
            videoDescription,
            href,
            videoDuration
          } = this;
          if (changedProperties.has('ctaType') || changedProperties.has('download')) {
            const {
              download
            } = this;
            const downloadTypes = [CTA_TYPE.DOWNLOAD, CTA_TYPE.PDF];
            if (!downloadTypes.includes(ctaType) && download) {
              // eslint-disable-next-line no-console
              console.warn(`\`download\` property used with a CTA data item besides \`type: download|pdf\` (\`type: ${ctaType}\`).`);
            }
            const contactMethods = {
              [CTA_TYPE.EMAIL]: 'email-link',
              [CTA_TYPE.SCHEDULE]: 'scheduler-link',
              [CTA_TYPE.CHAT]: 'chat-link',
              [CTA_TYPE.CALL]: 'phone-link'
            };
            if (Object.keys(contactMethods).includes(ctaType)) {
              linkNode.dataset.ibmContact = contactMethods[ctaType];
            }
          }
          // TODO: See why `linkNode` can possibly be `null`
          if (linkNode && linkNode.nodeName === 'A') {
            if (changedProperties.has('ctaType') || changedProperties.has('href')) {
              const {
                href: _href
              } = this;
              const hrefValue = ctaType !== CTA_TYPE.VIDEO ? _href : '#';
              // If this CTA is of video, uses the link as the action button
              if (hrefValue == null) {
                linkNode.removeAttribute('href');
              } else {
                linkNode.setAttribute('href', hrefValue);
              }
            }
            if (changedProperties.has('ctaType') || changedProperties.has('target')) {
              // Default the target to `_blank` if this CTA is an external link and
              // target is not already set
              const {
                target
              } = this;
              const newTabTypes = [CTA_TYPE.EXTERNAL, CTA_TYPE.NEW_TAB];
              const targetInEffect = newTabTypes.includes(ctaType) && !target ? '_blank' : target;
              if (!targetInEffect) {
                linkNode.removeAttribute('target');
              } else {
                linkNode.setAttribute('target', targetInEffect);
              }
            }
            if (linkNode.hasAttribute('aria-label')) {
              linkNode.setAttribute('aria-label', linkNode.getAttribute('aria-label') + (ctaType ? ariaLabels[ctaType] : ''));
            }
          }
          const {
            eventRequestVideoData
          } = this.constructor;
          if (changedProperties.has('ctaType') && ctaType === CTA_TYPE.VIDEO) {
            if (typeof videoDuration === 'undefined') {
              // Wait for the container to be ready without blocking.
              customElements.whenDefined(`${c4dPrefix$U}-video-cta-container`).then(() => {
                this.dispatchEvent(new CustomEvent(eventRequestVideoData, {
                  bubbles: true,
                  cancelable: true,
                  composed: true,
                  detail: {
                    href,
                    videoName,
                    videoDescription
                  }
                }));
              });
            }
          }
          if (changedProperties.has('videoName') && (videoName === null || videoName === 'null') || changedProperties.has('videoDescription')) {
            if (typeof videoDuration === 'undefined') {
              // Wait for the container to be ready without blocking.
              customElements.whenDefined(`${c4dPrefix$U}-video-cta-container`).then(() => {
                this.dispatchEvent(new CustomEvent(eventRequestVideoData, {
                  bubbles: true,
                  cancelable: true,
                  composed: true,
                  detail: {
                    videoName,
                    videoDescription,
                    href
                  }
                }));
              });
            }
          }
          const firstChild = this === null || this === void 0 || (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector(':first-child');
          if (ctaType === CTA_TYPE.VIDEO && firstChild && firstChild.offsetWidth > 0) {
            this._updateVideoThumbnailUrl(String(firstChild.offsetWidth));
          }
        }

        /**
         * Check the URL for a fragment including the video id.
         *
         * If we find a URL fragment that includes the video id, we trigger the
         * eventRunAction event, which for video will open the video and start
         * playback in a lightbox. This is the same thing that happens when the user
         * clicks on the CTA.
         */
      }, {
        kind: "method",
        key: "_checkUrlVideoTrigger",
        value: function _checkUrlVideoTrigger() {
          const {
            ctaType,
            disabled,
            href,
            videoDescription,
            videoName
          } = this;
          // Without a video id, or if the button is disabled, there is nothing to
          // do here.
          if (ctaType !== CTA_TYPE.VIDEO || !href || disabled) {
            return;
          }
          // Only trigger for the first CTA with the video id in the page.
          if (this.ownerDocument.querySelector(`[href='${href}']`) !== this) {
            return;
          }
          const {
            eventRunAction
          } = this.constructor;
          const hash = lib.location.hash;
          const urlTrigger = `cta-video-${href}`;
          if (hash === `#${urlTrigger}`) {
            this.dispatchEvent(new CustomEvent(eventRunAction, {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: {
                href,
                ctaType,
                videoName,
                videoDescription
              }
            }));
          }
        }

        /**
         * Updates video thumbnail url to match card width.
         */
      }, {
        kind: "method",
        key: "_updateVideoThumbnailUrl",
        value: function _updateVideoThumbnailUrl(width) {
          this.videoThumbnailUrl = KalturaPlayerAPI.getThumbnailUrl({
            mediaId: this.href,
            width: width !== null && width !== void 0 ? width : '340'
          });
        }

        /**
         * The name of the custom event fired when there is a user gesture to run the action.
         */
      }, {
        kind: "get",
        static: true,
        key: "eventRequestVideoData",
        value: function () {
          return `${c4dPrefix$U}-cta-request-video-data`;
        }

        /**
         * The name of the custom event fired when there is a user gesture to run the action.
         */
      }, {
        kind: "get",
        static: true,
        key: "eventRunAction",
        value: function () {
          return `${c4dPrefix$U}-cta-run-action`;
        }
      }]
    };
  }, Base);
  return CTAMixinImpl;
};

let _$Q = t => t,
  _t$R,
  _t2$p,
  _t3$g;
function _decorate$S(e, r, t, i) { var o = _getDecoratorsApi$S(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$S(s.d.map(_createElementDescriptor$S)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$S() { _getDecoratorsApi$S = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$S(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$S(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$U(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$S(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$S(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$S(e) { var r, t = _toPropertyKey$U(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$S(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$S(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$S(o.descriptor) || _isDataDescriptor$S(i.descriptor)) { if (_hasDecorators$S(o) || _hasDecorators$S(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$S(o)) { if (_hasDecorators$S(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$S(o, i); } } else r.push(o); } return r; }
function _hasDecorators$S(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$S(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$S(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$U(t) { var i = _toPrimitive$U(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$U(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$S(r) { return _arrayWithHoles$T(r) || _iterableToArray$S(r) || _unsupportedIterableToArray$T(r) || _nonIterableRest$T(); }
function _nonIterableRest$T() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$T(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$T(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$T(r, a) : void 0; } }
function _arrayLikeToArray$T(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$S(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$T(r) { if (Array.isArray(r)) return r; }
function _superPropGet$z(t, e, r, o) { var p = _get$t(_getPrototypeOf$t(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$t() { return _get$t = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$t(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$t.apply(null, arguments); }
function _superPropBase$t(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$t(t));); return t; }
function _getPrototypeOf$t(t) { return _getPrototypeOf$t = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$t(t); }
const {
  prefix: prefix$x,
  stablePrefix: c4dPrefix$T
} = settings;

/**
 * Link with icon.
 *
 * @element c4d-link-with-icon
 * @slot icon - The icon.
 * @slot icon-left - The CTA icon to place at the left.
 * @csspart span - The span element. Usage: `c4d-lightbox-video-player::part(span)`
 */
let C4DLinkWithIcon = _decorate$S([carbonElement(`${c4dPrefix$T}-link-with-icon`)], function (_initialize, _CTAMixin) {
  class C4DLinkWithIcon extends _CTAMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLinkWithIcon,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'icon-placement',
        reflect: true
      })],
      key: "iconPlacement",
      value() {
        return ICON_PLACEMENT.RIGHT;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "iconInline",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "size",
      value() {
        return 'lg';
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasContent",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * Icon placement(right (default) | left)
       */

      /**
       * Positions the icon inline with text when `true`
       */

      /**
       * Property that specifies the link to use size large
       *
       * @internal
       */

      /**
       * `true` if there is a non-empty default slot content.
       */

      /**
       * Handles `slotchange` event on the default `<slot>`.
       */
      function _handleSlotChange({
        target
      }) {
        this._hasContent = target.assignedNodes().some(node => {
          var _node$nodeValue;
          return node.nodeType !== Node.COMMENT_NODE && (node.nodeType !== Node.TEXT_NODE || ((_node$nodeValue = node.nodeValue) === null || _node$nodeValue === void 0 ? void 0 : _node$nodeValue.trim()));
        });
      }
    }, {
      kind: "method",
      key: "_renderContent",
      value: function _renderContent() {
        const {
          ctaType,
          _hasContent: hasContent
        } = this;
        if (ctaType !== CTA_TYPE.VIDEO) {
          return x(_t$R || (_t$R = _$Q`<span part="span"><slot></slot></span>`));
        }
        const {
          videoDuration,
          videoName,
          formatVideoCaption: formatVideoCaptionInEffect,
          formatVideoDuration: formatVideoDurationInEffect
        } = this;
        const caption = hasContent ? undefined : formatVideoCaptionInEffect({
          duration: formatVideoDurationInEffect({
            duration: !videoDuration ? videoDuration : videoDuration * 1000
          }),
          name: videoName
        });
        return x(_t2$p || (_t2$p = _$Q`
      <span
        ><slot @slotchange="${0}"></slot>${0}</span
      >
    `), this._handleSlotChange, caption);
      }
    }, {
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        return x(_t3$g || (_t3$g = _$Q` ${0}${0} `), this._renderContent(), this._renderIcon());
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet$z(C4DLinkWithIcon, "updated", this, 3)([changedProperties]);
        const {
          iconInline,
          iconPlacement,
          _linkNode: linkNode
        } = this;
        if (linkNode) {
          linkNode.classList.add(`${prefix$x}--link-with-icon`);
          linkNode.classList.toggle(`${prefix$x}--link-with-icon__icon-${ICON_PLACEMENT.LEFT}`, iconPlacement === ICON_PLACEMENT.LEFT);
          linkNode.classList.toggle(`${prefix$x}--link-with-icon__icon-${ICON_PLACEMENT.RIGHT}`, iconPlacement === ICON_PLACEMENT.RIGHT);
          if (iconInline && iconPlacement === ICON_PLACEMENT.RIGHT) {
            linkNode.classList.add(`${prefix$x}--link-with-icon--inline-icon`);
          }
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$T}--link-with-icon`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$f;
      }
    }]
  };
}, CTAMixin(StableSelectorMixin(CDSLink)));

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey$T(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey$T(t) { var i = _toPrimitive$T(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive$T(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var prefix$w = settings.prefix,
  c4dPrefix$S = settings.stablePrefix;
var ddsPrefix = 'dds';
var bxPrefix = 'bx';
var gridBreakpoint$1 = parseFloat(breakpoints.lg.width) * baseFontSize;
var StickyHeader = /*#__PURE__*/function () {
  function StickyHeader() {
    _classCallCheck(this, StickyHeader);
    this.ownerDocument = lib.document;
    this._state = {
      cumulativeOffset: 0,
      hasBanner: false,
      leadspaceSearchThreshold: 0,
      mastheadL0IsActive: false,
      mastheadL1IsActive: false,
      maxScrollaway: 0,
      scrollPosPrevious: 0,
      scrollPos: 0,
      searchIsAtTop: false,
      tocShouldStick: false,
      tocIsAtTop: false,
      tocIsAtSearch: false
    };
    this._elements = {
      banner: undefined,
      leadspaceSearch: undefined,
      leadspaceSearchBar: undefined,
      leadspaceSearchInput: undefined,
      localeModal: undefined,
      masthead: undefined,
      mastheadL0: undefined,
      mastheadL1: undefined,
      tableOfContents: undefined,
      tableOfContentsInnerBar: undefined
    };
    this._throttled = false;
    this._resizeObserver = new ResizeObserver(this._handleResize.bind(this));
    lib.addEventListener('scroll', this._throttledHandler.bind(this));
  }

  /**
   * Create (if needed) and return the globally-scoped instance of `this`.
   */
  return _createClass(StickyHeader, [{
    key: "height",
    get: function get() {
      return this._state.cumulativeOffset;
    }

    /**
     * Compares the tag name of the component provided to what we expect it to be
     *
     * @param {HTMLElement} component The component provided
     * @param {string} expected The lowercase tag name expected
     * @throws {TypeError} Throws error if component tag name doesn't match expected string
     * @returns {boolean} Returns true if component tag name matches expected string
     */
  }, {
    key: "_validateComponent",
    value: function _validateComponent(component, expected) {
      var received = component.tagName.toLowerCase();
      if (received !== expected) {
        // TODO: don't check for v1/v2 compatibility after v1 EOL.
        if (received.split('-').splice(1).join('-') !== expected.split('-').splice(1).join('-')) {
          throw new TypeError("".concat(expected, " expected, ").concat(received, " provided"));
        } else {
          var message = ["Mixed prefixes detected.\n", "expected ".concat(expected, ", found ").concat(received, ".")];
          console.warn(message.join(''));
          return true;
        }
      } else {
        return true;
      }
    }

    /**
     * Helper method to query for either C4IBM v1.x or v2.x sub-elements;
     *
     * @param {*} element The C4IBM element.
     * @param {*} v1Func The querying function to run if using a C4IBM v1.x element.
     * @param {*} v2Func The querying function to run if using a C4IBM v2.x element.
     */
  }, {
    key: "_updateRefsV1orV2",
    value: function _updateRefsV1orV2(element, v1Func, v2Func) {
      var elementPrefix = element.tagName.toLowerCase().split('-')[0];
      if (elementPrefix === ddsPrefix) {
        v1Func.bind(this)();
      } else if (elementPrefix === c4dPrefix$S) {
        v2Func.bind(this)();
      } else {
        throw new Error("\n        Could not find sub-elements for ".concat(element.tagName.toLowerCase(), ".\n      "));
      }
    }

    /**
     * Temporary method to find v1 leadspace sub-elements.
     */
  }, {
    key: "_updateLeadspaceRefsV1",
    value: function _updateLeadspaceRefsV1() {
      var leadspaceSearch = this._elements.leadspaceSearch;
      this._elements.leadspaceSearchBar = leadspaceSearch.shadowRoot.querySelector(".".concat(bxPrefix, "--search-container"));
      this._elements.leadspaceSearchInput = leadspaceSearch.querySelector("".concat(ddsPrefix, "-search-with-typeahead"));
    }

    /**
     * Temporary method to find v2 leadspace sub-elements.
     */
  }, {
    key: "_updateLeadspaceRefsV2",
    value: function _updateLeadspaceRefsV2() {
      var leadspaceSearch = this._elements.leadspaceSearch;
      this._elements.leadspaceSearchBar = leadspaceSearch.shadowRoot.querySelector(".".concat(prefix$w, "--search-container"));
      this._elements.leadspaceSearchInput = leadspaceSearch.querySelector("".concat(c4dPrefix$S, "-search-with-typeahead"));
    }

    /**
     * Temporary method to find v1 masthead sub-elements.
     */
  }, {
    key: "_updateMastheadRefsV1",
    value: function _updateMastheadRefsV1() {
      var masthead = this._elements.masthead;
      this._elements.mastheadL0 = masthead.shadowRoot.querySelector(".".concat(bxPrefix, "--masthead__l0"));
      this._elements.mastheadL1 = masthead.querySelector("".concat(ddsPrefix, "-masthead-l1"));
    }

    /**
     * Temporary method to find v2 masthead sub-elements.
     */
  }, {
    key: "_updateMastheadRefsV2",
    value: function _updateMastheadRefsV2() {
      var masthead = this._elements.masthead;
      this._elements.mastheadL0 = masthead.shadowRoot.querySelector(".".concat(prefix$w, "--masthead__l0"));
      this._elements.mastheadL1 = masthead.querySelector("".concat(c4dPrefix$S, "-masthead-l1"));
    }

    /**
     * Temporary method to find v1 table of contents sub-elements.
     */
  }, {
    key: "_updateTableOfContentsRefsV1",
    value: function _updateTableOfContentsRefsV1() {
      var toc = this._elements.tableOfContents;
      var tocRoot = toc.shadowRoot;
      var selectors = {
        desktop: {
          vertical: ".".concat(ddsPrefix, "-ce--table-of-contents__items-container"),
          horizontal: ".".concat(bxPrefix, "--tableofcontents__navbar")
        },
        mobile: {
          vertical: ".".concat(bxPrefix, "--tableofcontents__sidebar"),
          horizontal: ".".concat(bxPrefix, "--tableofcontents__navbar")
        }
      };
      var viewportDimension = window.innerWidth >= gridBreakpoint$1 ? 'desktop' : 'mobile';
      this._elements.tableOfContentsInnerBar = tocRoot.querySelector(selectors[viewportDimension][toc.layout || 'vertical']);
    }

    /**
     * Temporary method to find v2 table of contents sub-elements.
     */
  }, {
    key: "_updateTableOfContentsRefsV2",
    value: function _updateTableOfContentsRefsV2() {
      var toc = this._elements.tableOfContents;
      var tocRoot = toc.shadowRoot;
      this._elements.tableOfContentsInnerBar = tocRoot.querySelector(window.innerWidth >= gridBreakpoint$1 && (toc === null || toc === void 0 ? void 0 : toc.layout) !== 'horizontal' ? ".".concat(c4dPrefix$S, "-ce--table-of-contents__items-container") : ".".concat(prefix$w, "--tableofcontents__navbar"));
    }

    /**
     * Stores references to TOC sub-elements that are relevant to current viewport
     * dimensions.
     */
  }, {
    key: "_updateTableOfContentsRefs",
    value: function _updateTableOfContentsRefs() {
      var toc = this._elements.tableOfContents;
      this._updateRefsV1orV2(toc, this._updateTableOfContentsRefsV1, this._updateTableOfContentsRefsV2);
    }
  }, {
    key: "banner",
    set: function set(component) {
      if (this._validateComponent(component, "".concat(c4dPrefix$S, "-global-banner"))) {
        this._elements.banner = component;
        this._state.hasBanner = true;
        if (this._elements.masthead) {
          this._elements.masthead.setAttribute('with-banner', '');
        }
        this._manageStickyElements();
      }
    }
  }, {
    key: "leadspaceSearch",
    set: function set(component) {
      if (this._validateComponent(component, "".concat(c4dPrefix$S, "-leadspace-with-search"))) {
        this._elements.leadspaceSearch = component;
        this._updateRefsV1orV2(component, this._updateLeadspaceRefsV1, this._updateLeadspaceRefsV2);
        this._state.leadspaceSearchThreshold = parseInt(window.getComputedStyle(this._elements.leadspaceSearchBar).paddingBottom) - 16;
        this._manageStickyElements();
      }
    }
  }, {
    key: "localeModal",
    set: function set(component) {
      if (this._validateComponent(component, "".concat(c4dPrefix$S, "-locale-modal"))) {
        this._elements.localeModal = component;
        this._manageStickyElements();
      }
    }
  }, {
    key: "masthead",
    set: function set(component) {
      if (this._validateComponent(component, "".concat(c4dPrefix$S, "-masthead"))) {
        this._elements.masthead = component;
        if (this._elements.banner) {
          this._elements.masthead.setAttribute('with-banner', '');
        }
        this._updateRefsV1orV2(component, this._updateMastheadRefsV1, this._updateMastheadRefsV2);
        this._manageStickyElements();
      }
    }
  }, {
    key: "tableOfContents",
    set: function set(component) {
      if (this._validateComponent(component, "".concat(c4dPrefix$S, "-table-of-contents"))) {
        this._elements.tableOfContents = component;
        this._updateTableOfContentsRefs();
        this._resizeObserver.observe(this._elements.tableOfContents);
        this._manageStickyElements();
      }
    }

    /**
     * Rate-limits the scroll event handler
     */
  }, {
    key: "_throttledHandler",
    value: function _throttledHandler() {
      var _this = this;
      if (!this._throttled) {
        this._throttled = true;
        this._manageStickyElements();
        setTimeout(function () {
          _this._throttled = false;
        }, 20);
      }
    }
  }, {
    key: "_handleResize",
    value: function _handleResize() {
      var hasBanner = this._state._hasBanner;
      var _this$_elements = this._elements,
        masthead = _this$_elements.masthead,
        toc = _this$_elements.tableOfContents,
        leadspaceSearchBar = _this$_elements.leadspaceSearchBar;
      if (toc && masthead) {
        this._updateTableOfContentsRefs();
        if (window.innerWidth >= gridBreakpoint$1 && toc.layout !== 'horizontal' && !hasBanner) {
          masthead.style.insetBlockStart = '0';
        } else {
          // This has to happen after the _updateTableOfContentsRefs method.
          var tocInner = this._elements.tableOfContentsInnerBar;
          if (masthead.offsetTop === 0) {
            tocInner.style.insetBlockStart = "".concat(masthead.offsetHeight, "px");
          }
        }
        this._manageStickyElements();
      }
      if (leadspaceSearchBar) {
        this._state.leadspaceSearchThreshold = parseInt(window.getComputedStyle(leadspaceSearchBar).paddingBottom) - 16;
      }
    }

    /**
     * Handles the banner given the current scroll position.
     */
  }, {
    key: "_handleBanner",
    value: function _handleBanner() {
      var banner = this._elements.banner;
      var scrollPos = this._state.scrollPos;
      this._state.cumulativeOffset += Math.max(banner.offsetHeight - scrollPos, 0);
    }

    /**
     * Handles the masthead given the current scroll position.
     */
  }, {
    key: "_handleMasthead",
    value: function _handleMasthead() {
      var masthead = this._elements.masthead;
      masthead.style.transition = 'none';
      masthead.style.insetBlockStart = "".concat(this._state.cumulativeOffset, "px");

      // Masthead always sticks, therefore always add its height.
      this._state.cumulativeOffset += masthead.offsetHeight;
    }

    /**
     * Handles the table of contents given the current scroll position.
     */
  }, {
    key: "_handleToc",
    value: function _handleToc() {
      var tableOfContentsInnerBar = this._elements.tableOfContentsInnerBar;
      var tocShouldStick = this._state.tocShouldStick;
      tableOfContentsInnerBar.style.transition = 'none';
      tableOfContentsInnerBar.style.insetBlockStart = "".concat(this._state.cumulativeOffset, "px");
      var tocIsStuck = Math.round(tableOfContentsInnerBar.getBoundingClientRect().top) <= this._state.cumulativeOffset + 1;
      if (tocShouldStick && tocIsStuck) {
        this._state.cumulativeOffset += tableOfContentsInnerBar.offsetHeight;
      }
    }

    /**
     * Handles the leadspace search given the current scroll position.
     */
  }, {
    key: "_handleLeadspaceSearch",
    value: function _handleLeadspaceSearch() {
      var _this$_elements2 = this._elements,
        leadspaceSearch = _this$_elements2.leadspaceSearch,
        leadspaceSearchBar = _this$_elements2.leadspaceSearchBar,
        leadspaceSearchInput = _this$_elements2.leadspaceSearchInput;
      var leadspaceSearchThreshold = this._state.leadspaceSearchThreshold;
      var searchShouldBeSticky = leadspaceSearch.getBoundingClientRect().bottom <= leadspaceSearchThreshold;
      var searchIsSticky = leadspaceSearch.hasAttribute('sticky-search');
      if (searchShouldBeSticky) {
        if (!searchIsSticky) {
          leadspaceSearch.style.paddingBottom = "".concat(leadspaceSearchBar.offsetHeight, "px");
          leadspaceSearch.setAttribute('sticky-search', '');
          leadspaceSearchInput.setAttribute('large', '');
          window.requestAnimationFrame(function () {
            leadspaceSearchBar.style.transitionDuration = '110ms';
            leadspaceSearchBar.style.transform = 'translateY(0)';
          });
        }
        leadspaceSearchBar.style.insetBlockStart = "".concat(this._state.cumulativeOffset, "px");
        this._state.cumulativeOffset += leadspaceSearchBar.offsetHeight;
      } else if (searchIsSticky) {
        leadspaceSearch.style.paddingBottom = '';
        leadspaceSearch.removeAttribute('sticky-search');
        leadspaceSearchInput.removeAttribute('large');
        leadspaceSearchBar.style.transitionDuration = '';
        leadspaceSearchBar.style.transform = '';
        leadspaceSearchBar.style.insetBlockStart = '';
      }
    }

    /**
     * Calculates a value matching the height of all components that are allowed
     * to hide above the viewport.
     *
     * Adding an item's height to this value indicates we expect it to be hidden
     * above the viewport.
     *
     * Items that stick, in order
     * - L0
     * - L1
     * - The TOC in horizontal bar form
     * - The leadspace with search (if no TOC)
     */
  }, {
    key: "_calculateMaxScrollaway",
    value: function _calculateMaxScrollaway() {
      var _this$_elements3 = this._elements,
        masthead = _this$_elements3.masthead,
        mastheadL0 = _this$_elements3.mastheadL0,
        mastheadL1 = _this$_elements3.mastheadL1,
        tableOfContents = _this$_elements3.tableOfContents,
        tableOfContentsInnerBar = _this$_elements3.tableOfContentsInnerBar,
        leadspaceSearchBar = _this$_elements3.leadspaceSearchBar;

      // Reset the value before performing any further calculations.
      this._state.maxScrollaway = 0;

      // Collect conditions we may want to test for to make logic easier to read.
      this._state.tocShouldStick = tableOfContents ? tableOfContents.layout === 'horizontal' || window.innerWidth < gridBreakpoint$1 : false;
      this._state.tocIsAtTop = tableOfContentsInnerBar ? tableOfContentsInnerBar.getBoundingClientRect().top <= this.height + 1 : false;
      this._state.searchIsAtTop = leadspaceSearchBar ? leadspaceSearchBar.getBoundingClientRect().top <= this.height + 1 : false;
      this._state.tocIsAtSearch = leadspaceSearchBar && tableOfContentsInnerBar ? tableOfContentsInnerBar.getBoundingClientRect().top <= leadspaceSearchBar.getBoundingClientRect().bottom : false;
      this._state.mastheadL0IsActive = Boolean(masthead === null || masthead === void 0 ? void 0 : masthead.querySelector('[expanded]'));
      this._state.mastheadL1IsActive = mastheadL1 && mastheadL1.hasAttribute('active');
      var _this$_state = this._state,
        tocShouldStick = _this$_state.tocShouldStick,
        tocIsAtTop = _this$_state.tocIsAtTop,
        searchIsAtTop = _this$_state.searchIsAtTop,
        tocIsAtSearch = _this$_state.tocIsAtSearch,
        mastheadL0IsActive = _this$_state.mastheadL0IsActive,
        mastheadL1IsActive = _this$_state.mastheadL1IsActive;

      // Begin calculating maxScrollAway.

      // If L0 is open, lock it to the top of the page.
      if (mastheadL0 && mastheadL0IsActive) {
        this._state.maxScrollaway = 0;
      }
      // If L1 is open, lock it to the top of the page.
      else if (mastheadL1IsActive && mastheadL0) {
        this._state.maxScrollaway = mastheadL0.offsetHeight;
      } else {
        // In cases where we have both an eligible ToC and leadspace search, we want
        // the ToC to take precedence. Scroll away leadspace search.
        if (searchIsAtTop && tocIsAtSearch && tocShouldStick) {
          this._state.maxScrollaway += leadspaceSearchBar.offsetHeight;
        }

        // Scroll away entire masthead if either ToC or leadspace search is eligible
        // to be the stuck element (unless L1 is open). Otherwise, scroll away the
        // L0 if we have an L1.
        if (searchIsAtTop || tocIsAtTop && tocShouldStick) {
          if (masthead) {
            this._state.maxScrollaway += masthead.offsetHeight;
          }
        } else if (masthead && mastheadL0 && mastheadL1) {
          this._state.maxScrollaway += mastheadL0.offsetHeight;
        }
      }
    }

    /**
     * Positions sticky elements. Does so by checking the scroll position and where
     * tracked elements are in relation to it, then applying the correct styles to
     * each element in succession to ensure that only one element is stuck to the
     * top of the page, and all other elements that have been scrolled past can be
     * revealed when scrolling back up.
     */
  }, {
    key: "_positionElements",
    value: function _positionElements() {
      var _this$_elements4 = this._elements,
        banner = _this$_elements4.banner,
        masthead = _this$_elements4.masthead,
        tocInner = _this$_elements4.tableOfContentsInnerBar,
        leadspaceSearchBar = _this$_elements4.leadspaceSearchBar;
      var oldY = this._state.scrollPosPrevious;

      /**
       * Reset to a value that is equal to the difference between the previous
       * scrollY and the current scrollY values, but is positively and negatively
       * limited.
       *
       * Positive limit: 0
       *   all elements visible, starting at the top of the viewport.
       *
       * Negative limit: maxScrollaway * -1
       *   all elements that should be hidden are positioned above the viewport
       *   with the elements that should be visible starting at the top of the
       *   viewport.
       */
      this._state.cumulativeOffset = Math.max(Math.min((masthead ? masthead.offsetTop : 0) + oldY - this._state.scrollPos, 0), this._state.maxScrollaway * -1);

      /**
       * Handle each potentially sticky element in the order we expect them to
       * appear on the page. Important to do this sequentially for
       * cumulativeOffset to be correctly calculated by the time each of these
       * methods accesses it.
       *
       * To-do: One idea for improving this so the execution order doesn't matter
       * is to collect our elements into an array ordered by document position,
       * then loop over that array and execute a corresponding handler method.
       */
      if (banner) {
        this._handleBanner();
      }
      if (masthead) {
        this._handleMasthead();
      }
      if (leadspaceSearchBar) {
        this._handleLeadspaceSearch();
      }
      if (tocInner) {
        this._handleToc();
      }
    }

    /**
     * Manages which elements are stuck and where they are positioned. We should
     * only have one element stuck to the top of the viewport as the page scrolls
     * down.
     */
  }, {
    key: "_manageStickyElements",
    value: function _manageStickyElements() {
      var localeModal = this._elements.localeModal;
      var scrollPosPrevious = this._state.scrollPos;

      // Exit early if locale modal is open.
      if (localeModal && localeModal.hasAttribute('open')) {
        return;
      }

      // Store scroll positions.
      this._state.scrollPosPrevious = scrollPosPrevious;
      this._state.scrollPos = Math.max(0, window.scrollY);

      // Given the current state, calculate how elements should be positioned.
      this._calculateMaxScrollaway();
      this._positionElements();

      // Set custom property for use in stylesheets
      lib.document.documentElement.style.setProperty(this.constructor.customPropertyName, "".concat(this._state.cumulativeOffset, "px"));
    }
  }], [{
    key: "global",
    get: function get() {
      if (!Object.prototype.hasOwnProperty.call(lib, 'stickyHeader')) {
        lib.stickyHeader = new StickyHeader();
      }
      return lib.stickyHeader;
    }
  }, {
    key: "customPropertyName",
    get: function get() {
      return "--".concat(c4dPrefix$S, "-sticky-header-height");
    }
  }]);
}();

let _$P = t => t,
  _t$Q,
  _t2$o,
  _t3$f,
  _t4$a,
  _t5$a,
  _t6$8,
  _t7$8;
function _decorate$R(e, r, t, i) { var o = _getDecoratorsApi$R(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$R(s.d.map(_createElementDescriptor$R)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$R() { _getDecoratorsApi$R = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$R(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$R(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$S(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$R(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$R(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$R(e) { var r, t = _toPropertyKey$S(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$R(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$R(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$R(o.descriptor) || _isDataDescriptor$R(i.descriptor)) { if (_hasDecorators$R(o) || _hasDecorators$R(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$R(o)) { if (_hasDecorators$R(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$R(o, i); } } else r.push(o); } return r; }
function _hasDecorators$R(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$R(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$R(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$S(t) { var i = _toPrimitive$S(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$S(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$R(r) { return _arrayWithHoles$S(r) || _iterableToArray$R(r) || _unsupportedIterableToArray$S(r) || _nonIterableRest$S(); }
function _nonIterableRest$S() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$S(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$S(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$S(r, a) : void 0; } }
function _arrayLikeToArray$S(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$R(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$S(r) { if (Array.isArray(r)) return r; }
function _superPropGet$y(t, e, r, o) { var p = _get$s(_getPrototypeOf$s(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$s() { return _get$s = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$s(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$s.apply(null, arguments); }
function _superPropBase$s(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$s(t));); return t; }
function _getPrototypeOf$s(t) { return _getPrototypeOf$s = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$s(t); }
const {
  prefix: prefix$v,
  stablePrefix: c4dPrefix$R
} = settings;

/**
 * Locale modal.
 *
 * @element c4d-locale-modal
 * @slot regions-selector - The area for the regions selector.
 * @slot locales-selector - The area for the locales selector.
 * @csspart header-label - The header label. Usage: `c4d-locale-modal::part(header-label)`
 * @csspart link-with-icon - The link with icon. Usage: `c4d-locale-modal::part(link-with-icon)`
 * @csspart link-heading - The link heading. Usage: `c4d-locale-modal::part(link-heading)`
 * @csspart modal-content - The modal-content. Usage: `c4d-locale-modal::part(modal-content)`
 * @csspart header-container - The header container. Usage: `c4d-locale-modal::part(header-container)`
 * @csspart header - The header. Usage: `c4d-locale-modal::part(header)`
 * @csspart close-button - The close button. Usage: `c4d-locale-modal::part(close-button)`
 * @csspart heading - The heading. Usage: `c4d-locale-modal::part(heading)`
 * @csspart title - The title. Usage: `c4d-locale-modal::part(title)`
 */
let C4DLocaleModal = _decorate$R([carbonElement(`${c4dPrefix$R}-locale-modal`)], function (_initialize, _C4DExpressiveModal) {
  class C4DLocaleModal extends _C4DExpressiveModal {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLocaleModal,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_currentRegion",
      value: void 0
    }, {
      kind: "method",
      key: "_handleClickBackButton",
      value:
      /**
       * The current region.
       */

      /**
       * Handles `click` event on the back button.
       */
      function _handleClickBackButton(e) {
        e.preventDefault();
        this._currentRegion = undefined;
      }

      /**
       * Handles `click` event on a region card.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleClickRegionSelector",
      value: function _handleClickRegionSelector(event) {
        const {
          disabled,
          name
        } = event.target;
        if (!disabled) {
          this._currentRegion = name;
        }
      }
    }, {
      kind: "method",
      decorators: [HostListener('eventClose')],
      key: "_handleAfterClose",
      value: function _handleAfterClose() {
        this._currentRegion = undefined;
      }

      /**
       * Sets focus on primary selectable element.
       */
    }, {
      kind: "method",
      key: "_setPrimaryFocus",
      value: async function _setPrimaryFocus() {
        const {
          selectorPrimaryFocus
        } = C4DLocaleModal;
        const focusTarget = this.querySelector(selectorPrimaryFocus);
        if (focusTarget) {
          focusTarget.tabIndex = 0;
          focusTarget.focus();
        }
      }

      /**
       * Sets focus on locale selector search.
       */
    }, {
      kind: "method",
      key: "_setSearchFocus",
      value: async function _setSearchFocus() {
        const {
          selectorLocaleSearch
        } = C4DLocaleModal;
        await this.updateComplete;
        const localeSearch = this.querySelector(selectorLocaleSearch);
        if (localeSearch) {
          localeSearch.reset();
          localeSearch.focus();
        }
      }

      /**
       * @returns The heading content for the region selector page.
       */
    }, {
      kind: "method",
      key: "_renderRegionSelectorHeading",
      value: function _renderRegionSelectorHeading() {
        const {
          headerTitle,
          langDisplay
        } = this;
        return x(_t$Q || (_t$Q = _$P`
      ${0}
      ${0}
    `), langDisplay && x(_t2$o || (_t2$o = _$P`
        <p
          class="${0}--modal-header__label ${0}--type-delta"
          part="header-label">
          ${0}${0}
        </p>
      `), prefix$v, prefix$v, langDisplay, svgResultCarbonIcon$A({
          class: `${c4dPrefix$R}--locale-modal__label-globe`
        })), langDisplay && headerTitle && x(_t3$f || (_t3$f = _$P`
        <p class="cds--modal-header__heading cds--type-beta" part="title">
          ${0}
        </p>
      `), headerTitle));
      }

      /**
       * @returns The heading content for the locale selector page.
       */
    }, {
      kind: "method",
      key: "_renderLocaleSelectorHeading",
      value: function _renderLocaleSelectorHeading() {
        const {
          headerTitle,
          _currentRegion: currentRegion,
          _handleClickBackButton: handleClickBackButton
        } = this;
        return x(_t4$a || (_t4$a = _$P`
      <c4d-link-with-icon
        icon-placement="${0}"
        href="#"
        part="link-with-icon"
        @click="${0}">
        ${0}${0}
      </c4d-link-with-icon>
      <p
        class="cds--modal-header__heading cds--type-beta"
        tabindex="0"
        part="link-heading">
        ${0}
      </p>
    `), ICON_PLACEMENT.LEFT, handleClickBackButton, headerTitle, svgResultCarbonIcon$B({
          slot: 'icon',
          class: `${c4dPrefix$R}--locale-modal__label-arrow`
        }), currentRegion);
      }

      /**
       * @returns The heading content.
       */
    }, {
      kind: "method",
      key: "_renderHeading",
      value: function _renderHeading() {
        const {
          _currentRegion: currentRegion
        } = this;
        return !currentRegion ? this._renderRegionSelectorHeading() : this._renderLocaleSelectorHeading();
      }

      /**
       * @returns The body content for the region selector page.
       */
    }, {
      kind: "method",
      key: "_renderRegionSelectorBody",
      value: function _renderRegionSelectorBody() {
        const {
          _handleClickRegionSelector: handleClickRegionSelector
        } = this;
        return x(_t5$a || (_t5$a = _$P`
      <div
        class="${0}--modal-content ${0}--locale-modal"
        @click="${0}"
        part="modal-content">
        <slot name="regions-selector"></slot>
      </div>
    `), prefix$v, c4dPrefix$R, handleClickRegionSelector);
      }

      /**
       * @returns The body content for the locale selector page.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderLocaleSelectorBody",
      value: function _renderLocaleSelectorBody() {
        return x(_t6$8 || (_t6$8 = _$P` <slot name="locales-selector"></slot> `));
      }
    }, {
      kind: "method",
      key: "_renderHeader",
      value: function _renderHeader() {
        const {
          closeButtonAssistiveText
        } = this;
        return x(_t7$8 || (_t7$8 = _$P`
      <div id="${0}--modal-header" part="header-container">
        <c4d-expressive-modal-header part="header">
          <c4d-expressive-modal-close-button
            assistive-text="${0}"
            part="close-button">
          </c4d-expressive-modal-close-button>
          <c4d-expressive-modal-heading part="heading"
            >${0}</c4d-expressive-modal-heading
          >
        </c4d-expressive-modal-header>
      </div>
    `), prefix$v, l(closeButtonAssistiveText), this._renderHeading());
      }
    }, {
      kind: "method",
      key: "_renderBody",
      value: function _renderBody() {
        const {
          _currentRegion: currentRegion
        } = this;
        return !currentRegion ? this._renderRegionSelectorBody() : this._renderLocaleSelectorBody();
      }

      /**
       * The assistive text for the close button.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'close-button-assistive-text'
      })],
      key: "closeButtonAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'header-title'
      })],
      key: "headerTitle",
      value() {
        return 'Select geographic area';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'lang-display'
      })],
      key: "langDisplay",
      value: void 0
    }, {
      kind: "method",
      key: "firstUpdated",
      value:
      /**
       * The header title.
       */
      /**
       * The language to show in the UI.
       */
      function firstUpdated() {
        StickyHeader.global.localeModal = this;
      }
    }, {
      kind: "method",
      key: "updated",
      value: async function updated(changedProperties) {
        _superPropGet$y(C4DLocaleModal, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('_currentRegion')) {
          // Allow listening components to update their state.
          this.dispatchEvent(new CustomEvent(this.constructor.eventRegionUpdated, {
            bubbles: true,
            composed: true,
            cancelable: true,
            detail: {
              region: this._currentRegion
            }
          }));

          // Pass state to search element.
          const {
            selectorLocaleSearch
          } = this.constructor;
          const localeSearch = this.querySelector(selectorLocaleSearch);
          if (localeSearch) {
            var _this$_currentRegion;
            localeSearch.region = (_this$_currentRegion = this._currentRegion) !== null && _this$_currentRegion !== void 0 ? _this$_currentRegion : '';
          }

          // Set element focus.
          this._currentRegion ? this._setSearchFocus() : this._setPrimaryFocus();
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$R}--locale-modal`;
      }

      /**
       * A selector selecting the locale search UI.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorLocaleSearch",
      value: function () {
        return `${c4dPrefix$R}-locale-search`;
      }

      /**
       * A selector selecting the nodes that should be focused when modal gets open.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorPrimaryFocus",
      value: function () {
        return `
      [data-modal-primary-focus],
      ${c4dPrefix$R}-region-item
    `;
      }

      /**
       * A selector selecting tabbable nodes.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTabbable",
      value: function () {
        return `
      ${selectorTabbable},
      ${c4dPrefix$R}-expressive-modal,
      ${c4dPrefix$R}-expressive-modal-close-button,
      ${c4dPrefix$R}-region-item,
      ${prefix$v}-search,
      ${c4dPrefix$R}-locale-item
    `;
      }

      /**
       * Name for event fired when a region is selected.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventRegionUpdated",
      value: function () {
        return `${c4dPrefix$R}-locale-modal-region-updated`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$h;
      }
    }]
  };
}, C4DExpressiveModal);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$n = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M15,14.3L10.7,10c1.9-2.3,1.6-5.8-0.7-7.7S4.2,0.7,2.3,3S0.7,8.8,3,10.7c2,1.7,5,1.7,7,0l4.3,4.3L15,14.3z M2,6.5	C2,4,4,2,6.5,2S11,4,11,6.5S9,11,6.5,11S2,9,2,6.5z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * A variant of `if-non-null` which stops rendering if the given value is an emptry string in addition to `null`/`undefined`.
 *
 * @param value The value.
 */
var ifNonEmpty = (value => l(value === '' ? undefined : value !== null && value !== void 0 ? value : undefined));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$m = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M15.5,7.8C14.3,4.7,11.3,2.6,8,2.5C4.7,2.6,1.7,4.7,0.5,7.8c0,0.1,0,0.2,0,0.3c1.2,3.1,4.1,5.2,7.5,5.3	c3.3-0.1,6.3-2.2,7.5-5.3C15.5,8.1,15.5,7.9,15.5,7.8z M8,12.5c-2.7,0-5.4-2-6.5-4.5c1-2.5,3.8-4.5,6.5-4.5s5.4,2,6.5,4.5	C13.4,10.5,10.6,12.5,8,12.5z"></path><path d="M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z M8,10c-1.1,0-2-0.9-2-2s0.9-2,2-2s2,0.9,2,2S9.1,10,8,10z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$l = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M2.6,11.3l0.7-0.7C2.6,9.8,1.9,9,1.5,8c1-2.5,3.8-4.5,6.5-4.5c0.7,0,1.4,0.1,2,0.4l0.8-0.8C9.9,2.7,9,2.5,8,2.5	C4.7,2.6,1.7,4.7,0.5,7.8c0,0.1,0,0.2,0,0.3C1,9.3,1.7,10.4,2.6,11.3z"></path><path d="M6 7.9c.1-1 .9-1.8 1.8-1.8l.9-.9C7.2 4.7 5.5 5.6 5.1 7.2 5 7.7 5 8.3 5.1 8.8L6 7.9zM15.5 7.8c-.6-1.5-1.6-2.8-2.9-3.7L15 1.7 14.3 1 1 14.3 1.7 15l2.6-2.6c1.1.7 2.4 1 3.7 1.1 3.3-.1 6.3-2.2 7.5-5.3C15.5 8.1 15.5 7.9 15.5 7.8zM10 8c0 1.1-.9 2-2 2-.3 0-.7-.1-1-.3L9.7 7C9.9 7.3 10 7.6 10 8zM8 12.5c-1 0-2.1-.3-3-.8l1.3-1.3c1.4.9 3.2.6 4.2-.8.7-1 .7-2.4 0-3.4l1.4-1.4c1.1.8 2 1.9 2.6 3.2C13.4 10.5 10.6 12.5 8 12.5z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Input size.
 */
let INPUT_SIZE;

/**
 * Input tooltop alignment
 */
(function (INPUT_SIZE) {
  INPUT_SIZE["SMALL"] = "sm";
  INPUT_SIZE["MEDIUM"] = "md";
  INPUT_SIZE["LARGE"] = "lg";
  INPUT_SIZE["EXTRA_LARGE"] = "xl";
})(INPUT_SIZE || (INPUT_SIZE = {}));
let INPUT_TOOLTIP_ALIGNMENT;

/**
 * Input tooltop direction
 */
(function (INPUT_TOOLTIP_ALIGNMENT) {
  INPUT_TOOLTIP_ALIGNMENT["START"] = "start";
  INPUT_TOOLTIP_ALIGNMENT["CENTER"] = "center";
  INPUT_TOOLTIP_ALIGNMENT["END"] = "end";
})(INPUT_TOOLTIP_ALIGNMENT || (INPUT_TOOLTIP_ALIGNMENT = {}));
let INPUT_TOOLTIP_DIRECTION;

/**
 * Supported input types.
 *
 * For this component we only support textual types
 */
(function (INPUT_TOOLTIP_DIRECTION) {
  INPUT_TOOLTIP_DIRECTION["TOP"] = "top";
  INPUT_TOOLTIP_DIRECTION["RIGHT"] = "right";
  INPUT_TOOLTIP_DIRECTION["BOTTOM"] = "bottom";
  INPUT_TOOLTIP_DIRECTION["LEFT"] = "left";
})(INPUT_TOOLTIP_DIRECTION || (INPUT_TOOLTIP_DIRECTION = {}));
let INPUT_TYPE;
(function (INPUT_TYPE) {
  INPUT_TYPE["EMAIL"] = "email";
  INPUT_TYPE["PASSWORD"] = "password";
  INPUT_TYPE["TEL"] = "tel";
  INPUT_TYPE["TEXT"] = "text";
  INPUT_TYPE["URL"] = "url";
})(INPUT_TYPE || (INPUT_TYPE = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$e = i$4([
  "@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}input:-webkit-autofill,input:-webkit-autofill:focus,input:-webkit-autofill:hover,textarea:-webkit-autofill,textarea:-webkit-autofill:focus,textarea:-webkit-autofill:hover{box-shadow:0 0 0 1000px var(--cds-field) inset;-webkit-text-fill-color:var(--cds-text-primary,#161616)}.cds--fieldset{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--fieldset *,.cds--fieldset ::after,.cds--fieldset ::before{box-sizing:inherit}.cds--form-item{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start}.cds--label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:inline-block;color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;margin-block-end:.5rem;vertical-align:baseline}.cds--label html{font-size:100%}.cds--label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--label strong{font-weight:600}.cds--label .cds--toggletip-label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label--no-margin{margin-block-end:0}.cds--label+.cds--tooltip{position:relative;inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label+.cds--tooltip .cds--tooltip__trigger{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:flex;align-items:center;justify-content:center;font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label+.cds--tooltip .cds--tooltip__trigger *,.cds--label+.cds--tooltip .cds--tooltip__trigger ::after,.cds--label+.cds--tooltip .cds--tooltip__trigger ::before{box-sizing:inherit}.cds--label+.cds--tooltip .cds--tooltip__trigger::-moz-focus-inner{border:0}.cds--label+.cds--tooltip .cds--tooltip__trigger:focus{outline:1px solid var(--cds-focus,#0f62fe)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg :hover{fill:var(--cds-icon-primary,#161616)}.cds--label+.cds--toggletip{inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:.875rem;inline-size:4.6875rem}.cds--label.cds--skeleton:active,.cds--label.cds--skeleton:focus,.cds--label.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--label.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--label.cds--skeleton::before{animation:none}}input[type=number]{font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif}.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline-style:dotted}}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper--warn~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box--warning~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--number__input-wrapper--warning~.cds--form-requirement,.cds--select--warning .cds--select-input__wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper--warn~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper--warning>.cds--text-input~.cds--form-requirement,.cds--text-input__field-wrapper--warning~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker--warning~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input__field-wrapper--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]{display:block}.cds--form--fluid input[data-invalid]{outline:0}.cds--form--fluid .cds--form-requirement{padding:.5rem 2.5rem .5rem 1rem;margin:0}input:not(output,[data-invalid]):-moz-ui-invalid{box-shadow:none}.cds--form-requirement{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:none;overflow:hidden;margin:.25rem 0 0;max-block-size:0}.cds--form-requirement html{font-size:100%}.cds--form-requirement body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--form-requirement code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--form-requirement strong{font-weight:600}.cds--select--inline .cds--form__helper-text{margin-block-start:0}.cds--form__helper-text{font-size:var(--cds-helper-text-01-font-size,.75rem);line-height:var(--cds-helper-text-01-line-height,1.33333);letter-spacing:var(--cds-helper-text-01-letter-spacing,.32px);z-index:0;color:var(--cds-text-secondary,#525252);inline-size:100%;margin-block-start:.25rem;opacity:1}.cds--form__helper-text--disabled,.cds--label--disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}fieldset[disabled] .cds--form__helper-text,fieldset[disabled] .cds--label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;padding:0 var(--cds-layout-density-padding-inline-local);border:none;background-color:var(--cds-field);block-size:var(--cds-layout-size-height-local);border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);font-family:inherit;inline-size:100%;transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input *,.cds--text-input ::after,.cds--text-input ::before{box-sizing:inherit}.cds--text-input:active,.cds--text-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--text-input:active,.cds--text-input:focus{outline-style:dotted}}.cds--text-input-wrapper svg[hidden]{display:none}.cds--password-input{padding-inline-end:2.5rem}.cds--text-input--sm.cds--password-input{padding-inline-end:2rem}.cds--text-input--lg.cds--password-input{padding-inline-end:3rem}.cds--text-input::-moz-placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input::placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input--light{background-color:var(--cds-field-02,#fff)}.cds--text-input__field-wrapper{position:relative;display:flex;inline-size:100%}.cds--text-input__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--text-input__invalid-icon--warning path:first-of-type{fill:#000;opacity:1}.cds--text-input--password__visibility{position:relative;display:inline-flex;overflow:visible;align-items:center;cursor:pointer}.cds--text-input--password__visibility:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus{outline-style:dotted}}.cds--text-input--password__visibility:focus{outline:1px solid transparent}.cds--text-input--password__visibility:focus svg{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus svg{outline-style:dotted}}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{position:absolute;z-index:6000;display:flex;align-items:center;opacity:0;pointer-events:none}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{display:inline-block}}.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:opacity 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (prefers-reduced-motion:reduce){.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:none}}.cds--text-input--password__visibility.cds--tooltip--a11y::after,.cds--text-input--password__visibility.cds--tooltip--a11y::before{transition:none}.cds--text-input--password__visibility::before{border-style:solid;block-size:0;content:\"\";inline-size:0}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text{box-sizing:content-box;color:inherit;opacity:1;white-space:normal;word-break:break-word}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));z-index:6000;padding:.1875rem 1rem;border-radius:.125rem;background-color:var(--cds-background-inverse,#393939);block-size:auto;color:var(--cds-text-inverse,#fff);font-weight:400;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:13rem;min-inline-size:1.5rem;text-align:start;transform:translateX(-50%);font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-accelerator:true){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-ime-align:auto){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{border:1px solid transparent}}.cds--text-input--password__visibility::after{content:attr(aria-label)}.cds--text-input--password__visibility.cds--tooltip--a11y::after{content:none}.cds--text-input--password__visibility.cds--tooltip--visible::after,.cds--text-input--password__visibility.cds--tooltip--visible::before,.cds--text-input--password__visibility:focus::after,.cds--text-input--password__visibility:focus::before,.cds--text-input--password__visibility:hover::after,.cds--text-input--password__visibility:hover::before{opacity:1}@keyframes cds--tooltip-fade{from{opacity:0}to{opacity:1}}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text{overflow:visible;margin:auto;clip:auto}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:focus.cds--tooltip--a11y::before,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text,.cds--text-input--password__visibility:hover.cds--tooltip--a11y::before{animation:cds--tooltip-fade 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--hidden+.cds--assistive-text{overflow:hidden;margin:-1px;clip:rect(0,0,0,0)}.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before{animation:none;opacity:0}.cds--text-input--password__visibility .cds--assistive-text::after{position:absolute;display:block;content:\"\";block-size:.75rem;inline-size:100%;inset-inline-start:0;inset-block-start:-.75rem}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{inset-block-end:0;inset-inline-start:50%}.cds--text-input--password__visibility::before{border-width:0 .25rem .3125rem .25rem;border-color:transparent transparent var(--cds-background-inverse,#393939) transparent;inset-block-end:-.5rem;transform:translate(-50%,100%)}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inset-block-end:-.8125rem;transform:translate(-50%,100%)}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{outline:2px solid transparent;outline-offset:-2px;position:absolute;display:flex;align-items:center;justify-content:center;padding:0;border:0;background:0 0;block-size:100%;cursor:pointer;inline-size:2.5rem;inset-inline-end:0;min-block-size:auto;transition:outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--toggle-password-tooltip .cds--popover{inset-inline-start:-2.5rem}.cds--toggle-password-tooltip .cds--popover-content{min-inline-size:2.5rem}.cds--text-input--sm+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:2rem}.cds--text-input--lg+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:3rem}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252);transition:fill 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:ButtonText}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline-style:dotted}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg,.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-primary,#161616)}.cds--text-input--invalid,.cds--text-input--warning{padding-inline-end:2.5rem}.cds--text-input--invalid.cds--password-input{padding-inline-end:4rem}.cds--text-input--invalid+.cds--text-input--password__visibility__toggle{inset-inline-end:1rem}.cds--password-input-wrapper .cds--text-input__invalid-icon{inset-inline-end:2.5rem}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{cursor:not-allowed}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input__counter-alert{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px}.cds--text-input:disabled{outline:2px solid transparent;outline-offset:-2px;background-color:var(--cds-field);border-block-end:1px solid transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;-webkit-text-fill-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input--light:disabled{background-color:var(--cds-field-02,#fff)}.cds--text-input:disabled::-moz-placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input:disabled::placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input--invalid{outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px;box-shadow:none}@media screen and (prefers-contrast){.cds--text-input--invalid{outline-style:dotted}}.cds--text-input--invalid .cds--text-input--password__visibility__toggle{inset-inline-end:2.5rem}.cds--skeleton.cds--text-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}.cds--skeleton.cds--text-input:active,.cds--skeleton.cds--text-input:focus,.cds--skeleton.cds--text-input:hover{border:none;cursor:default;outline:0}.cds--skeleton.cds--text-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--skeleton.cds--text-input::before{animation:none}}.cds--form--fluid .cds--text-input-wrapper{position:relative;background:var(--cds-field);transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--form--fluid .cds--label{position:absolute;z-index:1;display:flex;align-items:center;margin:0;block-size:1rem;inset-block-start:.8125rem;inset-inline-start:1rem}.cds--form--fluid .cds--form__helper-text{display:none}.cds--form--fluid .cds--text-input{padding:2rem 1rem .8125rem;min-block-size:4rem}.cds--form--fluid .cds--text-input__divider,.cds--text-input__divider{display:none}.cds--form--fluid .cds--text-input--invalid,.cds--form--fluid .cds--text-input--warning{border-block-end:none}.cds--form--fluid .cds--text-input--invalid+.cds--text-input__divider,.cds--form--fluid .cds--text-input--warning+.cds--text-input__divider{display:block;border-style:solid;border-color:var(--cds-border-subtle);margin:0 1rem;border-block-end:none}.cds--form--fluid .cds--text-input__invalid-icon{inset-block-start:5rem}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid{outline:0}.cds--form--fluid .cds--text-input__field-wrapper--warning{border-block-end:1px solid var(--cds-border-strong)}.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning:focus,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:focus{outline:0}.cds--text-input-wrapper.cds--text-input-wrapper--inline{flex-flow:row wrap}.cds--text-input-wrapper .cds--label--inline{flex:1;margin:.8125rem 0 0 0;overflow-wrap:break-word;word-break:break-word}.cds--text-input-wrapper .cds--label--inline--sm{margin-block-start:.5625rem}.cds--text-input-wrapper .cds--label--inline--lg{margin-block-start:1.0625rem}.cds--text-input__label-helper-wrapper{flex:2;flex-direction:column;margin-inline-end:1.5rem;max-inline-size:8rem;overflow-wrap:break-word}.cds--text-input-wrapper .cds--form__helper-text--inline{margin-block-start:.125rem}.cds--text-input__field-outer-wrapper{display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start;inline-size:100%}.cds--text-input__field-outer-wrapper--inline{flex:8;flex-direction:column}.cds--text-input-wrapper--inline .cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--text-input-wrapper--inline--invalid .cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input-wrapper--readonly,.cds--text-input-wrapper--readonly .cds--text-input{background:0 0;border-block-end-color:var(--cds-border-subtle)}.cds--text-input__field-wrapper .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff);padding-inline-end:2.5rem}.cds--text-input--invalid:has(~.cds--slug),.cds--text-input--warning:has(~.cds--slug){padding-inline-end:4rem}.cds--text-input--invalid~.cds--slug,.cds--text-input--warning~.cds--slug{inset-inline-end:2.5rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:ButtonText}}.cds--text-input__label-wrapper{display:flex;justify-content:space-between;inline-size:100%}.cds--text-input__label-wrapper .cds--text-input__label-counter{align-self:end}:host(cds-text-input){--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px;inline-size:100%;outline:0}:host(cds-text-input) ::slotted(cds-slug){position:absolute;inset-block-start:50%;inset-inline-end:1rem}:host(cds-text-input) ::slotted(cds-slug:not([revert-active])){transform:translateY(-50%)}:host(cds-text-input[show-password-visibility-toggle]) .cds--text-input{padding-inline-end:2.5rem}:host(cds-text-input[show-password-visibility-toggle])[size=sm] .cds--text-input__invalid-icon{inset-inline-end:2rem}:host(cds-text-input[show-password-visibility-toggle])[size=md] .cds--text-input__invalid-icon{inset-inline-end:2rem}:host(cds-text-input[show-password-visibility-toggle])[size=lg] .cds--text-input__invalid-icon{inset-inline-end:2rem}:host(cds-text-input[invalid]) .cds--text-input__field-wrapper--slug .cds--text-input,:host(cds-text-input[warn]) .cds--text-input__field-wrapper--slug .cds--text-input{padding-inline-end:4rem}:host(cds-text-input[invalid]) ::slotted(cds-slug),:host(cds-text-input[warn]) ::slotted(cds-slug){inset-inline-end:2.5rem}",
]);

let _$O = t => t,
  _t$P,
  _t2$n,
  _t3$e,
  _t4$9,
  _t5$9,
  _t6$7,
  _t7$7,
  _t8$7;

/**
 * Text Input element. Supports all the usual attributes for textual input types
 *
 * @element cds-text-input
 * @slot helper-text - The helper text.
 * @slot label-text - The label text.
 * @slot validity-message - The validity message. If present and non-empty, this input shows the UI of its invalid state.
 */
_decorate$Z([carbonElement(`${prefix$B}-text-input`)], function (_initialize, _ValidityMixin) {
  class CDSTextInput extends _ValidityMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSTextInput,
    d: [{
      kind: "field",
      key: "_hasSlug",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * `true` if there is a slug.
       */

      /**
       * Handles `slotchange` event.
       */
      function _handleSlotChange({
        target
      }) {
        const hasContent = target.assignedNodes().filter(elem => elem.matches !== undefined ? elem.matches(this.constructor.slugItem) : false);
        this._hasSlug = Boolean(hasContent);
        hasContent[0].setAttribute('size', 'mini');
        this.requestUpdate();
      }
      /**
       * The underlying input element
       */
    }, {
      kind: "field",
      decorators: [i$1('input')],
      key: "_input",
      value: void 0
    }, {
      kind: "field",
      key: "_value",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "_handleInput",
      value:
      /**
       * The internal value.
       */
      /**
       * Handles `oninput` event on the `<input>`.
       *
       * @param event The event.
       * @param event.target The event target.
       */
      function _handleInput({
        target
      }) {
        this.value = target.value;
      }
    }, {
      kind: "method",
      key: "_handleFormdata",
      value: function _handleFormdata(event) {
        const {
          formData
        } = event; // TODO: Wait for `FormDataEvent` being available in `lib.dom.d.ts`
        const {
          disabled,
          name,
          value
        } = this;
        if (!disabled) {
          formData.append(name, value);
        }
      }

      /**
       * May be any of the standard HTML autocomplete options
       */
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "autocomplete",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "autofocus",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'enable-counter',
        reflect: true
      })],
      key: "enableCounter",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'helper-text'
      })],
      key: "helperText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "invalid",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'invalid-text'
      })],
      key: "invalidText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Number,
        attribute: 'max-count',
        reflect: true
      })],
      key: "maxCount",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "warn",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'warn-text'
      })],
      key: "warnText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'hide-label',
        type: Boolean,
        reflect: true
      })],
      key: "hideLabel",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'label'
      })],
      key: "label",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "name",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "pattern",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "placeholder",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "readonly",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "required",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'required-validity-message'
      })],
      key: "requiredValidityMessage",
      value() {
        return 'Please fill out this field.';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "hidePasswordLabel",
      value() {
        return 'Hide password';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "showPasswordLabel",
      value() {
        return 'Show password';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'show-password-visibility-toggle',
        reflect: true
      })],
      key: "showPasswordVisibilityToggle",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return INPUT_SIZE.MEDIUM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "inline",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "tooltipAlignment",
      value() {
        return INPUT_TOOLTIP_ALIGNMENT.CENTER;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "tooltipDirection",
      value() {
        return INPUT_TOOLTIP_DIRECTION.BOTTOM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "type",
      value() {
        return INPUT_TYPE.TEXT;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'validity-message'
      })],
      key: "validityMessage",
      value() {
        return '';
      }
    }, {
      kind: "get",
      decorators: [n$1({
        reflect: true
      })],
      key: "value",
      value:
      /**
       * Sets the input to be focussed automatically on page load. Defaults to false
       */
      /**
       * Controls the disabled state of the input
       */
      /**
       * Specify whether to display the character counter
       */
      /**
       * The helper text.
       */
      /**
       * Specify if the currently value is invalid.
       */
      /**
       * Message which is displayed if the value is invalid.
       */
      /**
       * Max character count allowed for input. This is needed in order for enableCounter to display
       */
      /**
       * Specify whether the control is currently in warning state
       */
      /**
       * Provide the text that is displayed when the control is in warning state
       */
      /**
       * Specify whether you want the underlying label to be visually hidden
       */
      /**
       * Generic label that will be used as the textual representation of what this field is for
       */
      /**
       * Name for the input in the `FormData`
       */
      /**
       * Pattern to validate the input against for HTML validity checking
       */
      /**
       * Value to display when the input has an empty `value`
       */
      /**
       * Specify if the component should be read-only
       */
      /**
       * Boolean property to set the required status
       */
      /**
       * The special validity message for `required`.
       */
      /**
       * "Hide password" tooltip text on password visibility toggle
       */
      /**
       * "Show password" tooltip text on password visibility toggle
       */
      /**
       * Boolean property to render password visibility toggle
       */
      /**
       * The input box size.
       */
      /**
       * true to use the inline version.
       */
      /**
       * Specify the alignment of the tooltip to the icon-only button.
       * Can be one of: start, center, or end.
       */
      /**
       * Specify the direction of the tooltip for icon-only buttons.
       * Can be either top, right, bottom, or left.
       */
      /**
       * The type of the input. Can be one of the types listed in the INPUT_TYPE enum
       */
      /**
       * The validity message. If present and non-empty, this input shows the UI of its invalid state.
       */
      /**
       * The value of the input.
       */
      function () {
        // FIXME: Figure out how to deal with TS2611
        // once we have the input we can directly query for the value
        if (this._input) {
          return this._input.value;
        }
        // but before then _value will work fine
        return this._value;
      }
    }, {
      kind: "set",
      key: "value",
      value: function (value) {
        const oldValue = this._value;
        this._value = value;
        // make sure that lit-element updates the right properties
        this.requestUpdate('value', oldValue);
        // we set the value directly on the input (when available)
        // so that programatic manipulation updates the UI correctly
        if (this._input) {
          this._input.value = value;
        }
      }

      /**
       * Handles password visibility toggle button click
       */
    }, {
      kind: "method",
      key: "handleTogglePasswordVisibility",
      value: function handleTogglePasswordVisibility() {
        this.type = this.type === INPUT_TYPE.PASSWORD ? INPUT_TYPE.TEXT : INPUT_TYPE.PASSWORD;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          disabled,
          enableCounter,
          helperText,
          hideLabel,
          inline,
          invalid,
          invalidText,
          label,
          maxCount,
          readonly,
          required,
          size,
          type,
          warn,
          warnText,
          value,
          _handleInput: handleInput,
          _hasSlug: hasSlug,
          _handleSlotChange: handleSlotChange
        } = this;
        const invalidIcon = svgResultCarbonIcon$G({
          class: `${prefix$B}--text-input__invalid-icon`
        });
        const warnIcon = svgResultCarbonIcon$F({
          class: `${prefix$B}--text-input__invalid-icon ${prefix$B}--text-input__invalid-icon--warning`
        });
        const normalizedProps = {
          disabled: !readonly && disabled,
          invalid: !readonly && invalid,
          warn: !readonly && !invalid && warn,
          'slot-name': '',
          'slot-text': '',
          icon: null
        };
        if (normalizedProps.invalid) {
          normalizedProps.icon = invalidIcon;
          normalizedProps['slot-name'] = 'invalid-text';
          normalizedProps['slot-text'] = invalidText;
        } else if (normalizedProps.warn) {
          normalizedProps.icon = warnIcon;
          normalizedProps['slot-name'] = 'warn-text';
          normalizedProps['slot-text'] = warnText;
        }
        const counterClasses = o$2({
          [`${prefix$B}--label`]: true,
          [`${prefix$B}--text-input__label-counter`]: true,
          [`${prefix$B}--label--disabled`]: disabled
        });
        const inputWrapperClasses = o$2({
          [`${prefix$B}--form-item`]: true,
          [`${prefix$B}--text-input-wrapper`]: true,
          [`${prefix$B}--text-input-wrapper--inline`]: inline,
          [`${prefix$B}--text-input-wrapper--readonly`]: readonly,
          [`${prefix$B}--text-input-wrapper--inline--invalid`]: inline && normalizedProps.invalid
        });
        const inputClasses = o$2({
          [`${prefix$B}--text-input`]: true,
          [`${prefix$B}--text-input--invalid`]: normalizedProps.invalid,
          [`${prefix$B}--text-input--warning`]: normalizedProps.warn,
          [`${prefix$B}--text-input--${size}`]: size,
          [`${prefix$B}--layout--size-${size}`]: size,
          [`${prefix$B}--password-input`]: type === INPUT_TYPE.PASSWORD
        });
        const fieldOuterWrapperClasses = o$2({
          [`${prefix$B}--text-input__field-outer-wrapper`]: true,
          [`${prefix$B}--text-input__field-outer-wrapper--inline`]: inline
        });
        const fieldWrapperClasses = o$2({
          [`${prefix$B}--text-input__field-wrapper`]: true,
          [`${prefix$B}--text-input__field-wrapper--warning`]: normalizedProps.warn,
          [`${prefix$B}--text-input__field-wrapper--slug`]: hasSlug
        });
        const labelClasses = o$2({
          [`${prefix$B}--label`]: true,
          [`${prefix$B}--visually-hidden`]: hideLabel,
          [`${prefix$B}--label--disabled`]: normalizedProps.disabled
        });
        const helperTextClasses = o$2({
          [`${prefix$B}--form__helper-text`]: true,
          [`${prefix$B}--form__helper-text--disabled`]: normalizedProps.disabled
        });
        const passwordIsVisible = type !== INPUT_TYPE.PASSWORD;
        const passwordVisibilityIcon = passwordIsVisible ? svgResultCarbonIcon$l({
          class: `${prefix$B}--icon-visibility-off`
        }) : svgResultCarbonIcon$m({
          class: `${prefix$B}--icon-visibility-on`
        });
        const passwordVisibilityToggleClasses = o$2({
          [`${prefix$B}--text-input--password__visibility__toggle`]: true,
          [`${prefix$B}--btn`]: true,
          [`${prefix$B}--btn--icon-only`]: true,
          [`${prefix$B}--tooltip__trigger`]: true,
          [`${prefix$B}--tooltip--a11y`]: true,
          [`${prefix$B}--btn--disabled`]: normalizedProps.disabled,
          [`${prefix$B}--tooltip--${this.tooltipDirection}`]: this.tooltipDirection,
          [`${prefix$B}--tooltip--align-${this.tooltipAlignment}`]: this.tooltipAlignment
        });
        const passwordButtonLabel = x(_t$P || (_t$P = _$O`
      <span class="${0}--assistive-text">
        ${0}
      </span>
    `), prefix$B, passwordIsVisible ? this.hidePasswordLabel : this.showPasswordLabel);
        const passwordVisibilityButton = () => x(_t2$n || (_t2$n = _$O`
      <button
        type="button"
        class="${0}"
        ?disabled="${0}"
        @click="${0}">
        ${0}
        ${0}
      </button>
    `), passwordVisibilityToggleClasses, normalizedProps.disabled, this.handleTogglePasswordVisibility, !normalizedProps.disabled ? passwordButtonLabel : null, passwordVisibilityIcon);
        const textCount = value === null || value === void 0 ? void 0 : value.length;
        const counter = enableCounter && maxCount ? x(_t3$e || (_t3$e = _$O` <label class="${0}">
            <slot name="label-text">${0}/${0}</slot>
          </label>`), counterClasses, textCount, maxCount) : null;
        const labelText = label && !hideLabel ? x(_t4$9 || (_t4$9 = _$O`<label class="${0}"> ${0} </label>`), labelClasses, label) : null;
        const labelWrapper = x(_t5$9 || (_t5$9 = _$O`<div class="${0}--text-input__label-wrapper">
      ${0} ${0}
    </div>`), prefix$B, labelText, counter);
        const helper = helperText ? x(_t6$7 || (_t6$7 = _$O`<div
          class="${0}"
          id="helper-text"
          ?hidden="${0}">
          <slot name="helper-text"> ${0} </slot>
        </div>`), helperTextClasses, normalizedProps.invalid || normalizedProps.warn, helperText) : null;
        return x(_t7$7 || (_t7$7 = _$O`
      <div class="${0}">
        ${0}
        <div class="${0}">
          <div class="${0}" ?data-invalid="${0}">
            ${0}
            <input
              autocomplete="${0}"
              ?autofocus="${0}"
              class="${0}"
              ?data-invalid="${0}"
              ?disabled="${0}"
              aria-describedby="helper-text"
              id="input"
              name="${0}"
              pattern="${0}"
              placeholder="${0}"
              ?readonly="${0}"
              ?required="${0}"
              type="${0}"
              .value="${0}"
              maxlength="${0}"
              @input="${0}" />
            <slot name="slug" @slotchange="${0}"></slot>
            ${0}
          </div>
          ${0}
          <div
            class="${0}--form-requirement"
            ?hidden="${0}">
            <slot name="${0}">
              ${0}
            </slot>
          </div>
        </div>
      </div>
    `), inputWrapperClasses, !inline ? labelWrapper : x(_t8$7 || (_t8$7 = _$O`<div class="${0}--text-input__label-helper-wrapper">
              ${0} ${0}
            </div>`), prefix$B, labelWrapper, helper), fieldOuterWrapperClasses, fieldWrapperClasses, invalid, normalizedProps.icon, this.autocomplete, this.autofocus, inputClasses, invalid, disabled, ifNonEmpty(this.name), ifNonEmpty(this.pattern), ifNonEmpty(this.placeholder), readonly, required, ifNonEmpty(type), this._value, ifNonEmpty(maxCount), handleInput, handleSlotChange, this.showPasswordVisibilityToggle && (type === INPUT_TYPE.PASSWORD || type === INPUT_TYPE.TEXT) ? passwordVisibilityButton() : null, !inline ? helper : null, prefix$B, !normalizedProps.invalid && !normalizedProps.warn, normalizedProps['slot-name'], normalizedProps['slot-text']);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated() {
        var _this$shadowRoot, _this$querySelector;
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || (_this$shadowRoot = _this$shadowRoot.querySelector("slot[name='slug']")) === null || _this$shadowRoot === void 0 || _this$shadowRoot.classList.toggle(`${prefix$B}--slug--revert`, (_this$querySelector = this.querySelector(`${prefix$B}-slug`)) === null || _this$querySelector === void 0 ? void 0 : _this$querySelector.hasAttribute('revert-active'));
      }

      /**
       * A selector that will return the slug item.
       */
    }, {
      kind: "get",
      static: true,
      key: "slugItem",
      value: function () {
        return `${prefix$B}-slug`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$e;
      }
    }]
  };
}, ValidityMixin(FormMixin(s)));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$d = i$4([
  "@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}input:-webkit-autofill,input:-webkit-autofill:focus,input:-webkit-autofill:hover,textarea:-webkit-autofill,textarea:-webkit-autofill:focus,textarea:-webkit-autofill:hover{box-shadow:0 0 0 1000px var(--cds-field) inset;-webkit-text-fill-color:var(--cds-text-primary,#161616)}.cds--fieldset{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--fieldset *,.cds--fieldset ::after,.cds--fieldset ::before{box-sizing:inherit}.cds--form-item{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start}.cds--label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:inline-block;color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;margin-block-end:.5rem;vertical-align:baseline}.cds--label html{font-size:100%}.cds--label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--label strong{font-weight:600}.cds--label .cds--toggletip-label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label--no-margin{margin-block-end:0}.cds--label+.cds--tooltip{position:relative;inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label+.cds--tooltip .cds--tooltip__trigger{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:flex;align-items:center;justify-content:center;font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label+.cds--tooltip .cds--tooltip__trigger *,.cds--label+.cds--tooltip .cds--tooltip__trigger ::after,.cds--label+.cds--tooltip .cds--tooltip__trigger ::before{box-sizing:inherit}.cds--label+.cds--tooltip .cds--tooltip__trigger::-moz-focus-inner{border:0}.cds--label+.cds--tooltip .cds--tooltip__trigger:focus{outline:1px solid var(--cds-focus,#0f62fe)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg :hover{fill:var(--cds-icon-primary,#161616)}.cds--label+.cds--toggletip{inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:.875rem;inline-size:4.6875rem}.cds--label.cds--skeleton:active,.cds--label.cds--skeleton:focus,.cds--label.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--label.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--label.cds--skeleton::before{animation:none}}input[type=number]{font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif}.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline-style:dotted}}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper--warn~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box--warning~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--number__input-wrapper--warning~.cds--form-requirement,.cds--select--warning .cds--select-input__wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper--warn~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper--warning>.cds--text-input~.cds--form-requirement,.cds--text-input__field-wrapper--warning~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker--warning~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input__field-wrapper--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]{display:block}.cds--form--fluid input[data-invalid]{outline:0}.cds--form--fluid .cds--form-requirement{padding:.5rem 2.5rem .5rem 1rem;margin:0}input:not(output,[data-invalid]):-moz-ui-invalid{box-shadow:none}.cds--form-requirement{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:none;overflow:hidden;margin:.25rem 0 0;max-block-size:0}.cds--form-requirement html{font-size:100%}.cds--form-requirement body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--form-requirement code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--form-requirement strong{font-weight:600}.cds--select--inline .cds--form__helper-text{margin-block-start:0}.cds--form__helper-text{font-size:var(--cds-helper-text-01-font-size,.75rem);line-height:var(--cds-helper-text-01-line-height,1.33333);letter-spacing:var(--cds-helper-text-01-letter-spacing,.32px);z-index:0;color:var(--cds-text-secondary,#525252);inline-size:100%;margin-block-start:.25rem;opacity:1}.cds--form__helper-text--disabled,.cds--label--disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}fieldset[disabled] .cds--form__helper-text,fieldset[disabled] .cds--label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;padding:0 var(--cds-layout-density-padding-inline-local);border:none;background-color:var(--cds-field);block-size:var(--cds-layout-size-height-local);border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);font-family:inherit;inline-size:100%;transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input *,.cds--text-input ::after,.cds--text-input ::before{box-sizing:inherit}.cds--text-input:active,.cds--text-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--text-input:active,.cds--text-input:focus{outline-style:dotted}}.cds--text-input-wrapper svg[hidden]{display:none}.cds--password-input{padding-inline-end:2.5rem}.cds--text-input--sm.cds--password-input{padding-inline-end:2rem}.cds--text-input--lg.cds--password-input{padding-inline-end:3rem}.cds--text-input::-moz-placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input::placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input--light{background-color:var(--cds-field-02,#fff)}.cds--text-input__field-wrapper{position:relative;display:flex;inline-size:100%}.cds--text-input__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--text-input__invalid-icon--warning path:first-of-type{fill:#000;opacity:1}.cds--text-input--password__visibility{position:relative;display:inline-flex;overflow:visible;align-items:center;cursor:pointer}.cds--text-input--password__visibility:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus{outline-style:dotted}}.cds--text-input--password__visibility:focus{outline:1px solid transparent}.cds--text-input--password__visibility:focus svg{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus svg{outline-style:dotted}}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{position:absolute;z-index:6000;display:flex;align-items:center;opacity:0;pointer-events:none}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{display:inline-block}}.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:opacity 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (prefers-reduced-motion:reduce){.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:none}}.cds--text-input--password__visibility.cds--tooltip--a11y::after,.cds--text-input--password__visibility.cds--tooltip--a11y::before{transition:none}.cds--text-input--password__visibility::before{border-style:solid;block-size:0;content:\"\";inline-size:0}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text{box-sizing:content-box;color:inherit;opacity:1;white-space:normal;word-break:break-word}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));z-index:6000;padding:.1875rem 1rem;border-radius:.125rem;background-color:var(--cds-background-inverse,#393939);block-size:auto;color:var(--cds-text-inverse,#fff);font-weight:400;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:13rem;min-inline-size:1.5rem;text-align:start;transform:translateX(-50%);font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-accelerator:true){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-ime-align:auto){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{border:1px solid transparent}}.cds--text-input--password__visibility::after{content:attr(aria-label)}.cds--text-input--password__visibility.cds--tooltip--a11y::after{content:none}.cds--text-input--password__visibility.cds--tooltip--visible::after,.cds--text-input--password__visibility.cds--tooltip--visible::before,.cds--text-input--password__visibility:focus::after,.cds--text-input--password__visibility:focus::before,.cds--text-input--password__visibility:hover::after,.cds--text-input--password__visibility:hover::before{opacity:1}@keyframes cds--tooltip-fade{from{opacity:0}to{opacity:1}}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text{overflow:visible;margin:auto;clip:auto}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:focus.cds--tooltip--a11y::before,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text,.cds--text-input--password__visibility:hover.cds--tooltip--a11y::before{animation:cds--tooltip-fade 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--hidden+.cds--assistive-text{overflow:hidden;margin:-1px;clip:rect(0,0,0,0)}.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before{animation:none;opacity:0}.cds--text-input--password__visibility .cds--assistive-text::after{position:absolute;display:block;content:\"\";block-size:.75rem;inline-size:100%;inset-inline-start:0;inset-block-start:-.75rem}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{inset-block-end:0;inset-inline-start:50%}.cds--text-input--password__visibility::before{border-width:0 .25rem .3125rem .25rem;border-color:transparent transparent var(--cds-background-inverse,#393939) transparent;inset-block-end:-.5rem;transform:translate(-50%,100%)}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inset-block-end:-.8125rem;transform:translate(-50%,100%)}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{outline:2px solid transparent;outline-offset:-2px;position:absolute;display:flex;align-items:center;justify-content:center;padding:0;border:0;background:0 0;block-size:100%;cursor:pointer;inline-size:2.5rem;inset-inline-end:0;min-block-size:auto;transition:outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--toggle-password-tooltip .cds--popover{inset-inline-start:-2.5rem}.cds--toggle-password-tooltip .cds--popover-content{min-inline-size:2.5rem}.cds--text-input--sm+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:2rem}.cds--text-input--lg+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:3rem}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252);transition:fill 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:ButtonText}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline-style:dotted}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg,.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-primary,#161616)}.cds--text-input--invalid,.cds--text-input--warning{padding-inline-end:2.5rem}.cds--text-input--invalid.cds--password-input{padding-inline-end:4rem}.cds--text-input--invalid+.cds--text-input--password__visibility__toggle{inset-inline-end:1rem}.cds--password-input-wrapper .cds--text-input__invalid-icon{inset-inline-end:2.5rem}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{cursor:not-allowed}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input__counter-alert{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px}.cds--text-input:disabled{outline:2px solid transparent;outline-offset:-2px;background-color:var(--cds-field);border-block-end:1px solid transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;-webkit-text-fill-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input--light:disabled{background-color:var(--cds-field-02,#fff)}.cds--text-input:disabled::-moz-placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input:disabled::placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input--invalid{outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px;box-shadow:none}@media screen and (prefers-contrast){.cds--text-input--invalid{outline-style:dotted}}.cds--text-input--invalid .cds--text-input--password__visibility__toggle{inset-inline-end:2.5rem}.cds--skeleton.cds--text-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}.cds--skeleton.cds--text-input:active,.cds--skeleton.cds--text-input:focus,.cds--skeleton.cds--text-input:hover{border:none;cursor:default;outline:0}.cds--skeleton.cds--text-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--skeleton.cds--text-input::before{animation:none}}.cds--form--fluid .cds--text-input-wrapper{position:relative;background:var(--cds-field);transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--form--fluid .cds--label{position:absolute;z-index:1;display:flex;align-items:center;margin:0;block-size:1rem;inset-block-start:.8125rem;inset-inline-start:1rem}.cds--form--fluid .cds--form__helper-text{display:none}.cds--form--fluid .cds--text-input{padding:2rem 1rem .8125rem;min-block-size:4rem}.cds--form--fluid .cds--text-input__divider,.cds--text-input__divider{display:none}.cds--form--fluid .cds--text-input--invalid,.cds--form--fluid .cds--text-input--warning{border-block-end:none}.cds--form--fluid .cds--text-input--invalid+.cds--text-input__divider,.cds--form--fluid .cds--text-input--warning+.cds--text-input__divider{display:block;border-style:solid;border-color:var(--cds-border-subtle);margin:0 1rem;border-block-end:none}.cds--form--fluid .cds--text-input__invalid-icon{inset-block-start:5rem}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid{outline:0}.cds--form--fluid .cds--text-input__field-wrapper--warning{border-block-end:1px solid var(--cds-border-strong)}.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning:focus,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:focus{outline:0}.cds--text-input-wrapper.cds--text-input-wrapper--inline{flex-flow:row wrap}.cds--text-input-wrapper .cds--label--inline{flex:1;margin:.8125rem 0 0 0;overflow-wrap:break-word;word-break:break-word}.cds--text-input-wrapper .cds--label--inline--sm{margin-block-start:.5625rem}.cds--text-input-wrapper .cds--label--inline--lg{margin-block-start:1.0625rem}.cds--text-input__label-helper-wrapper{flex:2;flex-direction:column;margin-inline-end:1.5rem;max-inline-size:8rem;overflow-wrap:break-word}.cds--text-input-wrapper .cds--form__helper-text--inline{margin-block-start:.125rem}.cds--text-input__field-outer-wrapper{display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start;inline-size:100%}.cds--text-input__field-outer-wrapper--inline{flex:8;flex-direction:column}.cds--text-input-wrapper--inline .cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--text-input-wrapper--inline--invalid .cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input-wrapper--readonly,.cds--text-input-wrapper--readonly .cds--text-input{background:0 0;border-block-end-color:var(--cds-border-subtle)}.cds--text-input__field-wrapper .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff);padding-inline-end:2.5rem}.cds--text-input--invalid:has(~.cds--slug),.cds--text-input--warning:has(~.cds--slug){padding-inline-end:4rem}.cds--text-input--invalid~.cds--slug,.cds--text-input--warning~.cds--slug{inset-inline-end:2.5rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:ButtonText}}.cds--text-input__label-wrapper{display:flex;justify-content:space-between;inline-size:100%}.cds--text-input__label-wrapper .cds--text-input__label-counter{align-self:end}.cds--search,:host(cds-search){position:relative;display:flex;align-items:center;inline-size:100%}.cds--search .cds--label,:host(cds-search) .cds--label{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--search-input{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;order:1;padding:0 2.5rem;border:none;-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--cds-field);border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);inline-size:100%;text-overflow:ellipsis;transition:background-color 110ms cubic-bezier(.2,0,.38,.9),outline 110ms cubic-bezier(.2,0,.38,.9)}.cds--search-input *,.cds--search-input ::after,.cds--search-input ::before{box-sizing:inherit}.cds--search-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--search-input:focus{outline-style:dotted}}.cds--search-input::-moz-placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--search-input::placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--search-input::-ms-clear{display:none}.cds--search-input[disabled]{background-color:var(--cds-field);border-block-end:1px solid transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--search-input[disabled]::-moz-placeholder{color:var(--cds-field)}.cds--search-input[disabled]::placeholder{color:var(--cds-field)}.cds--search--light .cds--search-input{background:var(--cds-field-02,#fff)}.cds--search--light .cds--search-close::before{background:var(--cds-field-02,#fff)}.cds--search--sm .cds--search-input,.cds--search--sm.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search-skeleton[size=sm]) .cds--search-input,:host(cds-search[size=sm]) .cds--search-input{padding:0 2rem;block-size:2rem}.cds--search--sm .cds--search-magnifier-icon,:host(cds-search-skeleton[size=sm]) .cds--search-magnifier-icon,:host(cds-search[size=sm]) .cds--search-magnifier-icon{inset-inline-start:.5rem}.cds--search--md .cds--search-input,.cds--search--md.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search-skeleton[size=md]) .cds--search-input,:host(cds-search[size=md]) .cds--search-input{padding:0 2.5rem;block-size:2.5rem}.cds--search--md .cds--search-magnifier-icon,:host(cds-search-skeleton[size=md]) .cds--search-magnifier-icon,:host(cds-search[size=md]) .cds--search-magnifier-icon{inset-inline-start:.75rem}.cds--search--lg .cds--search-input,.cds--search--lg.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search-skeleton[size=lg]) .cds--search-input,:host(cds-search[size=lg]) .cds--search-input{padding:0 3rem;block-size:3rem}.cds--search-magnifier-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:2;block-size:1rem;fill:var(--cds-icon-secondary,#525252);inline-size:1rem;inset-block-start:50%;inset-inline-start:1rem;pointer-events:none;transform:translateY(-50%)}.cds--search-magnifier-icon *,.cds--search-magnifier-icon ::after,.cds--search-magnifier-icon ::before{box-sizing:inherit}.cds--search-close{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;outline:2px solid transparent;outline-offset:-2px;position:absolute;inset-block-start:0;inset-inline-end:0}.cds--search-close *,.cds--search-close ::after,.cds--search-close ::before{box-sizing:inherit}.cds--search-close::-moz-focus-inner{border:0}.cds--search-close::before{position:absolute;display:block;background-color:var(--cds-field);block-size:calc(100% - 2px);content:\"\";inline-size:2px;inset-block-start:.0625rem;inset-inline-start:0;transition:background-color 110ms cubic-bezier(.2,0,.38,.9)}@media screen and (prefers-reduced-motion:reduce){.cds--search-close::before{transition:none}}.cds--search-close:hover{border-block-end:1px solid var(--cds-border-strong)}.cds--search-close:hover::before{background-color:var(--cds-field-hover)}.cds--search-button{flex-shrink:0;background-color:var(--cds-field);margin-inline-start:.125rem}.cds--search-button svg{fill:currentColor;vertical-align:middle}.cds--search-close svg{fill:inherit}.cds--search-button,.cds--search-close{display:flex;align-items:center;justify-content:center;border-width:1px 0;border-style:solid;border-color:transparent;block-size:2.5rem;cursor:pointer;fill:var(--cds-icon-primary,#161616);inline-size:2.5rem;opacity:1;transition:opacity 110ms cubic-bezier(.2,0,.38,.9),background-color 110ms cubic-bezier(.2,0,.38,.9),outline 110ms cubic-bezier(.2,0,.38,.9),border 110ms cubic-bezier(.2,0,.38,.9);visibility:inherit}.cds--search-button:hover,.cds--search-close:hover{background-color:var(--cds-field-hover)}.cds--search-button:focus,.cds--search-close:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--search-button:focus,.cds--search-close:focus{outline-style:dotted}}.cds--search-button:active,.cds--search-close:active{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;background-color:var(--cds-background-selected,rgba(141,141,141,.2))}@media screen and (prefers-contrast){.cds--search-button:active,.cds--search-close:active{outline-style:dotted}}.cds--search--disabled .cds--search-close,.cds--search--disabled.cds--search--expandable .cds--search-magnifier{cursor:not-allowed;outline:0}.cds--search--disabled .cds--search-close:hover,.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover{background-color:transparent;border-block-end-color:transparent}.cds--search--disabled .cds--search-close:hover::before,.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover::before{background-color:transparent}.cds--search--disabled svg{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--search-close:active::before,.cds--search-close:focus::before{background-color:var(--cds-focus,#0f62fe)}.cds--search-input:focus~.cds--search-close:hover{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--search-input:focus~.cds--search-close:hover{outline-style:dotted}}.cds--search--sm .cds--search-close,.cds--search--sm.cds--search--expandable,.cds--search--sm.cds--search--expandable .cds--search-magnifier,.cds--search--sm~.cds--search-button,:host(cds-search-skeleton[size=sm]) .cds--search-close,:host(cds-search-skeleton[size=sm]):host(cds-search[expandable]),:host(cds-search-skeleton[size=sm]):host(cds-search[expandable]) .cds--search-magnifier,:host(cds-search-skeleton[size=sm])~.cds--search-button,:host(cds-search[size=sm]) .cds--search-close,:host(cds-search[size=sm]):host(cds-search[expandable]),:host(cds-search[size=sm]):host(cds-search[expandable]) .cds--search-magnifier,:host(cds-search[size=sm])~.cds--search-button{block-size:2rem;inline-size:2rem}.cds--search--sm.cds--search--expandable .cds--search-input::-moz-placeholder,:host(cds-search-skeleton[size=sm]):host(cds-search[expandable]) .cds--search-input::-moz-placeholder,:host(cds-search[size=sm]):host(cds-search[expandable]) .cds--search-input::-moz-placeholder{padding:0 2rem}.cds--search--sm.cds--search--expandable .cds--search-input::placeholder,:host(cds-search-skeleton[size=sm]):host(cds-search[expandable]) .cds--search-input::placeholder,:host(cds-search[size=sm]):host(cds-search[expandable]) .cds--search-input::placeholder{padding:0 2rem}.cds--search--md .cds--search-close,.cds--search--md.cds--search--expandable,.cds--search--md.cds--search--expandable .cds--search-magnifier,.cds--search--md~.cds--search-button,:host(cds-search-skeleton[size=md]) .cds--search-close,:host(cds-search-skeleton[size=md]):host(cds-search[expandable]),:host(cds-search-skeleton[size=md]):host(cds-search[expandable]) .cds--search-magnifier,:host(cds-search-skeleton[size=md])~.cds--search-button,:host(cds-search[size=md]) .cds--search-close,:host(cds-search[size=md]):host(cds-search[expandable]),:host(cds-search[size=md]):host(cds-search[expandable]) .cds--search-magnifier,:host(cds-search[size=md])~.cds--search-button{block-size:2.5rem;inline-size:2.5rem}.cds--search--md.cds--search--expandable .cds--search-input::-moz-placeholder,:host(cds-search-skeleton[size=md]):host(cds-search[expandable]) .cds--search-input::-moz-placeholder,:host(cds-search[size=md]):host(cds-search[expandable]) .cds--search-input::-moz-placeholder{padding:0 2.5rem}.cds--search--md.cds--search--expandable .cds--search-input::placeholder,:host(cds-search-skeleton[size=md]):host(cds-search[expandable]) .cds--search-input::placeholder,:host(cds-search[size=md]):host(cds-search[expandable]) .cds--search-input::placeholder{padding:0 2.5rem}.cds--search--lg .cds--search-close,.cds--search--lg.cds--search--expandable,.cds--search--lg.cds--search--expandable .cds--search-magnifier,.cds--search--lg~.cds--search-button,:host(cds-search-skeleton[size=lg]) .cds--search-close,:host(cds-search-skeleton[size=lg]):host(cds-search[expandable]),:host(cds-search-skeleton[size=lg]):host(cds-search[expandable]) .cds--search-magnifier,:host(cds-search-skeleton[size=lg])~.cds--search-button,:host(cds-search[size=lg]) .cds--search-close,:host(cds-search[size=lg]):host(cds-search[expandable]),:host(cds-search[size=lg]):host(cds-search[expandable]) .cds--search-magnifier,:host(cds-search[size=lg])~.cds--search-button{block-size:3rem;inline-size:3rem}.cds--search--lg.cds--search--expandable .cds--search-input::-moz-placeholder,:host(cds-search-skeleton[size=lg]):host(cds-search[expandable]) .cds--search-input::-moz-placeholder,:host(cds-search[size=lg]):host(cds-search[expandable]) .cds--search-input::-moz-placeholder{padding:0 3rem}.cds--search--lg.cds--search--expandable .cds--search-input::placeholder,:host(cds-search-skeleton[size=lg]):host(cds-search[expandable]) .cds--search-input::placeholder,:host(cds-search[size=lg]):host(cds-search[expandable]) .cds--search-input::placeholder{padding:0 3rem}.cds--search-close--hidden{opacity:0;visibility:hidden}.cds--search--lg.cds--skeleton .cds--search-input,.cds--search--md.cds--skeleton .cds--search-input,.cds--search--sm.cds--skeleton .cds--search-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:100%}.cds--search--lg.cds--skeleton .cds--search-input:active,.cds--search--lg.cds--skeleton .cds--search-input:focus,.cds--search--lg.cds--skeleton .cds--search-input:hover,.cds--search--md.cds--skeleton .cds--search-input:active,.cds--search--md.cds--skeleton .cds--search-input:focus,.cds--search--md.cds--skeleton .cds--search-input:hover,.cds--search--sm.cds--skeleton .cds--search-input:active,.cds--search--sm.cds--skeleton .cds--search-input:focus,.cds--search--sm.cds--skeleton .cds--search-input:hover{border:none;cursor:default;outline:0}.cds--search--lg.cds--skeleton .cds--search-input::before,.cds--search--md.cds--skeleton .cds--search-input::before,.cds--search--sm.cds--skeleton .cds--search-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--search--lg.cds--skeleton .cds--search-input::before,.cds--search--md.cds--skeleton .cds--search-input::before,.cds--search--sm.cds--skeleton .cds--search-input::before{animation:none}}.cds--search--lg.cds--skeleton .cds--search-input::-moz-placeholder,.cds--search--md.cds--skeleton .cds--search-input::-moz-placeholder,.cds--search--sm.cds--skeleton .cds--search-input::-moz-placeholder{color:transparent}.cds--search--lg.cds--skeleton .cds--search-input::placeholder,.cds--search--md.cds--skeleton .cds--search-input::placeholder,.cds--search--sm.cds--skeleton .cds--search-input::placeholder{color:transparent}.cds--search--expandable,:host(cds-search[expandable]){transition:width 70ms cubic-bezier(.2,0,.38,.9)}.cds--search--expandable.cds--search--expanded,:host(cds-search[expandable]):host(cds-search[expandable][expanded]){inline-size:100%}.cds--search--expandable .cds--search-input,:host(cds-search[expandable]) .cds--search-input{padding:0;inline-size:0;transition:padding 70ms cubic-bezier(.2,0,.38,.9),width 0s linear 70ms}.cds--search--expandable .cds--search-input::-moz-placeholder,:host(cds-search[expandable]) .cds--search-input::-moz-placeholder{position:relative;opacity:0;transition-duration:70ms;-moz-transition-property:padding,opacity;transition-property:padding,opacity;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.cds--search--expandable .cds--search-input::placeholder,:host(cds-search[expandable]) .cds--search-input::placeholder{position:relative;opacity:0;transition-duration:70ms;transition-property:padding,opacity;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search[expandable]):host(cds-search[expandable][expanded]) .cds--search-input{inline-size:100%;transition:padding 70ms cubic-bezier(.2,0,.38,.9)}.cds--search--expandable.cds--search--expanded .cds--search-input::-moz-placeholder,:host(cds-search[expandable]):host(cds-search[expandable][expanded]) .cds--search-input::-moz-placeholder{position:relative;padding:0;opacity:1}.cds--search--expandable.cds--search--expanded .cds--search-input::placeholder,:host(cds-search[expandable]):host(cds-search[expandable][expanded]) .cds--search-input::placeholder{position:relative;padding:0;opacity:1}.cds--search--expandable .cds--search-magnifier,:host(cds-search[expandable]) .cds--search-magnifier{position:absolute;cursor:pointer}.cds--search--expandable .cds--search-magnifier:focus,:host(cds-search[expandable]) .cds--search-magnifier:focus{outline:2px solid var(--cds-focus,#0f62fe)}.cds--search--expandable .cds--search-magnifier:hover,:host(cds-search[expandable]) .cds--search-magnifier:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--search--expandable.cds--search--expanded .cds--search-magnifier,:host(cds-search[expandable]):host(cds-search[expandable][expanded]) .cds--search-magnifier{pointer-events:none}.cds--search--expandable .cds--search-magnifier-icon,:host(cds-search[expandable]) .cds--search-magnifier-icon{fill:var(--cds-icon-primary,#161616)}.cds--search--expandable.cds--search--expanded .cds--search-magnifier-icon,:host(cds-search[expandable]):host(cds-search[expandable][expanded]) .cds--search-magnifier-icon{fill:var(--cds-icon-secondary,#525252)}.cds--search--expandable.cds--search--disabled svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--search-close svg,.cds--search-magnifier-icon{fill:ButtonText}}.cds--search,:host(cds-search){position:relative;display:flex;align-items:center;inline-size:100%}.cds--search .cds--label,:host(cds-search) .cds--label{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--search-input{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;order:1;padding:0 2.5rem;border:none;-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--cds-field);border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);inline-size:100%;text-overflow:ellipsis;transition:background-color 110ms cubic-bezier(.2,0,.38,.9),outline 110ms cubic-bezier(.2,0,.38,.9)}.cds--search-input *,.cds--search-input ::after,.cds--search-input ::before{box-sizing:inherit}.cds--search-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--search-input:focus{outline-style:dotted}}.cds--search-input::-moz-placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--search-input::placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--search-input::-ms-clear{display:none}.cds--search-input[disabled]{background-color:var(--cds-field);border-block-end:1px solid transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--search-input[disabled]::-moz-placeholder{color:var(--cds-field)}.cds--search-input[disabled]::placeholder{color:var(--cds-field)}.cds--search--light .cds--search-input{background:var(--cds-field-02,#fff)}.cds--search--light .cds--search-close::before{background:var(--cds-field-02,#fff)}.cds--search--sm .cds--search-input,.cds--search--sm.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search-skeleton[size=sm]) .cds--search-input,:host(cds-search[size=sm]) .cds--search-input{padding:0 2rem;block-size:2rem}.cds--search--sm .cds--search-magnifier-icon,:host(cds-search-skeleton[size=sm]) .cds--search-magnifier-icon,:host(cds-search[size=sm]) .cds--search-magnifier-icon{inset-inline-start:.5rem}.cds--search--md .cds--search-input,.cds--search--md.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search-skeleton[size=md]) .cds--search-input,:host(cds-search[size=md]) .cds--search-input{padding:0 2.5rem;block-size:2.5rem}.cds--search--md .cds--search-magnifier-icon,:host(cds-search-skeleton[size=md]) .cds--search-magnifier-icon,:host(cds-search[size=md]) .cds--search-magnifier-icon{inset-inline-start:.75rem}.cds--search--lg .cds--search-input,.cds--search--lg.cds--search--expandable.cds--search--expanded .cds--search-input,:host(cds-search-skeleton[size=lg]) .cds--search-input,:host(cds-search[size=lg]) .cds--search-input{padding:0 3rem;block-size:3rem}.cds--search-magnifier-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:2;block-size:1rem;fill:var(--cds-icon-secondary,#525252);inline-size:1rem;inset-block-start:50%;inset-inline-start:1rem;pointer-events:none;transform:translateY(-50%)}.cds--search-magnifier-icon *,.cds--search-magnifier-icon ::after,.cds--search-magnifier-icon ::before{box-sizing:inherit}.cds--search-close{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;outline:2px solid transparent;outline-offset:-2px;position:absolute;inset-block-start:0;inset-inline-end:0}.cds--search-close *,.cds--search-close ::after,.cds--search-close ::before{box-sizing:inherit}.cds--search-close::-moz-focus-inner{border:0}.cds--search-close::before{position:absolute;display:block;background-color:var(--cds-field);block-size:calc(100% - 2px);content:\"\";inline-size:2px;inset-block-start:.0625rem;inset-inline-start:0;transition:background-color 110ms cubic-bezier(.2,0,.38,.9)}@media screen and (prefers-reduced-motion:reduce){.cds--search-close::before{transition:none}}.cds--search-close:hover{border-block-end:1px solid var(--cds-border-strong)}.cds--search-close:hover::before{background-color:var(--cds-field-hover)}.cds--search-button{flex-shrink:0;background-color:var(--cds-field);margin-inline-start:.125rem}.cds--search-button svg{fill:currentColor;vertical-align:middle}.cds--search-close svg{fill:inherit}.cds--search-button,.cds--search-close{display:flex;align-items:center;justify-content:center;border-width:1px 0;border-style:solid;border-color:transparent;block-size:2.5rem;cursor:pointer;fill:var(--cds-icon-primary,#161616);inline-size:2.5rem;opacity:1;transition:opacity 110ms cubic-bezier(.2,0,.38,.9),background-color 110ms cubic-bezier(.2,0,.38,.9),outline 110ms cubic-bezier(.2,0,.38,.9),border 110ms cubic-bezier(.2,0,.38,.9);visibility:inherit}.cds--search-button:hover,.cds--search-close:hover{background-color:var(--cds-field-hover)}.cds--search-button:focus,.cds--search-close:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--search-button:focus,.cds--search-close:focus{outline-style:dotted}}.cds--search-button:active,.cds--search-close:active{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;background-color:var(--cds-background-selected,rgba(141,141,141,.2))}@media screen and (prefers-contrast){.cds--search-button:active,.cds--search-close:active{outline-style:dotted}}.cds--search--disabled .cds--search-close,.cds--search--disabled.cds--search--expandable .cds--search-magnifier{cursor:not-allowed;outline:0}.cds--search--disabled .cds--search-close:hover,.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover{background-color:transparent;border-block-end-color:transparent}.cds--search--disabled .cds--search-close:hover::before,.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover::before{background-color:transparent}.cds--search--disabled svg{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--search-close:active::before,.cds--search-close:focus::before{background-color:var(--cds-focus,#0f62fe)}.cds--search-input:focus~.cds--search-close:hover{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--search-input:focus~.cds--search-close:hover{outline-style:dotted}}.cds--search--sm .cds--search-close,.cds--search--sm.cds--search--expandable,.cds--search--sm.cds--search--expandable .cds--search-magnifier,.cds--search--sm~.cds--search-button,:host(cds-search-skeleton[size=sm]) .cds--search-close,:host(cds-search-skeleton[size=sm])~.cds--search-button,:host(cds-search[size=sm]) .cds--search-close,:host(cds-search[size=sm])~.cds--search-button{block-size:2rem;inline-size:2rem}.cds--search--sm.cds--search--expandable .cds--search-input::-moz-placeholder{padding:0 2rem}.cds--search--sm.cds--search--expandable .cds--search-input::placeholder{padding:0 2rem}.cds--search--md .cds--search-close,.cds--search--md.cds--search--expandable,.cds--search--md.cds--search--expandable .cds--search-magnifier,.cds--search--md~.cds--search-button,:host(cds-search-skeleton[size=md]) .cds--search-close,:host(cds-search-skeleton[size=md])~.cds--search-button,:host(cds-search[size=md]) .cds--search-close,:host(cds-search[size=md])~.cds--search-button{block-size:2.5rem;inline-size:2.5rem}.cds--search--md.cds--search--expandable .cds--search-input::-moz-placeholder{padding:0 2.5rem}.cds--search--md.cds--search--expandable .cds--search-input::placeholder{padding:0 2.5rem}.cds--search--lg .cds--search-close,.cds--search--lg.cds--search--expandable,.cds--search--lg.cds--search--expandable .cds--search-magnifier,.cds--search--lg~.cds--search-button,:host(cds-search-skeleton[size=lg]) .cds--search-close,:host(cds-search-skeleton[size=lg])~.cds--search-button,:host(cds-search[size=lg]) .cds--search-close,:host(cds-search[size=lg])~.cds--search-button{block-size:3rem;inline-size:3rem}.cds--search--lg.cds--search--expandable .cds--search-input::-moz-placeholder{padding:0 3rem}.cds--search--lg.cds--search--expandable .cds--search-input::placeholder{padding:0 3rem}.cds--search-close--hidden{opacity:0;visibility:hidden}.cds--search--lg.cds--skeleton .cds--search-input,.cds--search--md.cds--skeleton .cds--search-input,.cds--search--sm.cds--skeleton .cds--search-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:100%}.cds--search--lg.cds--skeleton .cds--search-input:active,.cds--search--lg.cds--skeleton .cds--search-input:focus,.cds--search--lg.cds--skeleton .cds--search-input:hover,.cds--search--md.cds--skeleton .cds--search-input:active,.cds--search--md.cds--skeleton .cds--search-input:focus,.cds--search--md.cds--skeleton .cds--search-input:hover,.cds--search--sm.cds--skeleton .cds--search-input:active,.cds--search--sm.cds--skeleton .cds--search-input:focus,.cds--search--sm.cds--skeleton .cds--search-input:hover{border:none;cursor:default;outline:0}.cds--search--lg.cds--skeleton .cds--search-input::before,.cds--search--md.cds--skeleton .cds--search-input::before,.cds--search--sm.cds--skeleton .cds--search-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--search--lg.cds--skeleton .cds--search-input::before,.cds--search--md.cds--skeleton .cds--search-input::before,.cds--search--sm.cds--skeleton .cds--search-input::before{animation:none}}.cds--search--lg.cds--skeleton .cds--search-input::-moz-placeholder,.cds--search--md.cds--skeleton .cds--search-input::-moz-placeholder,.cds--search--sm.cds--skeleton .cds--search-input::-moz-placeholder{color:transparent}.cds--search--lg.cds--skeleton .cds--search-input::placeholder,.cds--search--md.cds--skeleton .cds--search-input::placeholder,.cds--search--sm.cds--skeleton .cds--search-input::placeholder{color:transparent}.cds--search--expandable,:host(cds-search[expandable]){transition:width 70ms cubic-bezier(.2,0,.38,.9)}.cds--search--expandable.cds--search--expanded{inline-size:100%}.cds--search--expandable .cds--search-input,:host(cds-search[expandable]) .cds--search-input{padding:0;inline-size:0;transition:padding 70ms cubic-bezier(.2,0,.38,.9),width 0s linear 70ms}.cds--search--expandable .cds--search-input::-moz-placeholder,:host(cds-search[expandable]) .cds--search-input::-moz-placeholder{position:relative;opacity:0;transition-duration:70ms;-moz-transition-property:padding,opacity;transition-property:padding,opacity;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.cds--search--expandable .cds--search-input::placeholder,:host(cds-search[expandable]) .cds--search-input::placeholder{position:relative;opacity:0;transition-duration:70ms;transition-property:padding,opacity;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.cds--search--expandable.cds--search--expanded .cds--search-input{inline-size:100%;transition:padding 70ms cubic-bezier(.2,0,.38,.9)}.cds--search--expandable.cds--search--expanded .cds--search-input::-moz-placeholder{position:relative;padding:0;opacity:1}.cds--search--expandable.cds--search--expanded .cds--search-input::placeholder{position:relative;padding:0;opacity:1}.cds--search--expandable .cds--search-magnifier,:host(cds-search[expandable]) .cds--search-magnifier{position:absolute;cursor:pointer}.cds--search--expandable .cds--search-magnifier:focus,:host(cds-search[expandable]) .cds--search-magnifier:focus{outline:2px solid var(--cds-focus,#0f62fe)}.cds--search--expandable .cds--search-magnifier:hover,:host(cds-search[expandable]) .cds--search-magnifier:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--search--expandable.cds--search--expanded .cds--search-magnifier{pointer-events:none}.cds--search--expandable .cds--search-magnifier-icon,:host(cds-search[expandable]) .cds--search-magnifier-icon{fill:var(--cds-icon-primary,#161616)}.cds--search--expandable.cds--search--expanded .cds--search-magnifier-icon{fill:var(--cds-icon-secondary,#525252)}.cds--search--expandable.cds--search--disabled svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--search-close svg,.cds--search-magnifier-icon{fill:ButtonText}}:host(cds-search){outline:0}:host(cds-search[expandable][size=sm]) .cds--search-magnifier{block-size:2rem;inline-size:2rem}:host(cds-search[expandable][size=md]) .cds--search-magnifier{block-size:2.5rem;inline-size:2.5rem}:host(cds-search[expandable][size=lg]) .cds--search-magnifier{block-size:3rem;inline-size:3rem}:host(cds-search[expandable][expanded]) .cds--search-input{inline-size:100%}:host(cds-search[expandable][expanded]) .cds--search-magnifier{pointer-events:none}:host(cds-search[expandable][expanded][size=sm]) .cds--search-input{padding:0 2rem}:host(cds-search[expandable][expanded][size=md]) .cds--search-input{padding:0 2.5rem}:host(cds-search[expandable][expanded][size=lg]) .cds--search-input{padding:0 3rem}:host(cds-search[expandable][expanded][size=lg]) ::slotted(.cds--search-magnifier){block-size:3rem;inline-size:3rem}:host(cds-search[disabled]) svg{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}:host(cds-search[disabled]) .cds--search-close{outline:0;pointer-events:none}:host(cds-search[disabled]) .cds--search-close::before{background:0 0}:host(cds-search-skeleton){inline-size:100%}:host(cds-search-skeleton) .cds--search-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:100%}:host(cds-search-skeleton) .cds--search-input:active,:host(cds-search-skeleton) .cds--search-input:focus,:host(cds-search-skeleton) .cds--search-input:hover{border:none;cursor:default;outline:0}:host(cds-search-skeleton) .cds--search-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){:host(cds-search-skeleton) .cds--search-input::before{animation:none}}:host(cds-search-skeleton) .cds--search-input::-moz-placeholder{color:transparent}:host(cds-search-skeleton) .cds--search-input::placeholder{color:transparent}",
]);

let _$N = t => t,
  _t$O,
  _t2$m,
  _t3$d;

/**
 * Search box.
 *
 * @element cds-search
 * @csspart search-icon The search icon.
 * @csspart label-text The label text.
 * @csspart input The input box.
 * @csspart close-button The close button.
 * @csspart close-icon The close icon.
 * @fires cds-search-input - The custom event fired after the search content is changed upon a user gesture.
 */
_decorate$Z([carbonElement(`${prefix$B}-search`)], function (_initialize, _HostListenerMixin) {
  class CDSSearch extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSSearch,
    d: [{
      kind: "method",
      key: "_handleInput",
      value:
      /**
       * Handles `input` event on the `<input>` in the shadow DOM.
       */
      function _handleInput(event) {
        const {
          target
        } = event;
        const {
          value
        } = target;
        this.dispatchEvent(new CustomEvent(this.constructor.eventInput, {
          bubbles: true,
          composed: true,
          cancelable: false,
          detail: {
            value
          }
        }));
        this.value = value;
      }

      /**
       * Handles `click` event on the button to clear search box content.
       */
    }, {
      kind: "method",
      key: "_handleClearInputButtonClick",
      value: function _handleClearInputButtonClick() {
        if (this.value) {
          this.dispatchEvent(new CustomEvent(this.constructor.eventInput, {
            bubbles: true,
            composed: true,
            cancelable: false,
            detail: {
              value: ''
            }
          }));
          this.value = '';

          // set focus on back to input once search is cleared
          const input = this.shadowRoot.querySelector('input');
          input.focus();
        }
      }

      /**
       * Handles `focus` event on the button when the button can be expanded
       */
    }, {
      kind: "method",
      decorators: [HostListener('focus')],
      key: "_handleExpand",
      value: function _handleExpand() {
        if (this.expandable && !this.expanded) {
          this.setAttribute('expanded', '');
        }
      }

      /**
       * Handles `focusout` event on the component to be closed after being expanded
       * Will not close if there is a value typed within.
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusout')],
      key: "_handleClose",
      value: function _handleClose() {
        if (this.expandable && this.expanded && !this.value) {
          this.removeAttribute('expanded');
        }
      }

      /**
       * Handler for @slotchange, will only be ran if user sets an element under the "icon" slot.
       *
       * @private
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange() {
        const icon = this.querySelector('svg');
        icon === null || icon === void 0 || icon.setAttribute('part', 'search-icon');
        icon === null || icon === void 0 || icon.setAttribute('class', `${prefix$B}--search-magnifier-icon`);
        icon === null || icon === void 0 || icon.setAttribute('role', `img`);
        this.hasCustomIcon = true;
      }
    }, {
      kind: "method",
      key: "_handleFormdata",
      value: function _handleFormdata(event) {
        const {
          formData
        } = event; // TODO: Wait for `FormDataEvent` being available in `lib.dom.d.ts`
        const {
          disabled,
          name,
          value
        } = this;
        if (!disabled) {
          formData.append(name, value);
        }
      }

      /**
       * Specify an optional value for the autocomplete property on the underlying <input>,
       * defaults to "off"
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'autocomplete'
      })],
      key: "autoComplete",
      value() {
        return 'off';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'close-button-label-text'
      })],
      key: "closeButtonLabelText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "expandable",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "expanded",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "hasCustomIcon",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'label-text'
      })],
      key: "labelText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "name",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "role",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "placeholder",
      value() {
        return 'Search';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return INPUT_SIZE.MEDIUM;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "type",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: String
      })],
      key: "value",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Specify a label to be read by screen readers on the "close" button
       */
      /**
       * `true` if the search box should be disabled.
       */
      /**
       * `true` if the search bar can be expandable
       */
      /**
       * `true` if the expandable search has been expanded
       */
      /**
       * The label text.
       */
      /**
       * The form name in `FormData`.
       */
      /**
       * Specify the role for the underlying <input>, defaults to searchbox
       */
      /**
       * The placeholder text.
       */
      /**
       * The search box size.
       */
      /**
       * The `<input>` name.
       */
      /**
       * The value.
       */
      function render() {
        const {
          autoComplete,
          closeButtonLabelText,
          disabled,
          hasCustomIcon,
          labelText,
          name,
          placeholder,
          role,
          type,
          value = '',
          _handleInput: handleInput,
          _handleClearInputButtonClick: handleClearInputButtonClick,
          _handleSlotChange: handleSlotChange
        } = this;
        const clearClasses = o$2({
          [`${prefix$B}--search-close`]: true,
          [`${prefix$B}--search-close--hidden`]: !this.value
        });
        return x(_t$O || (_t$O = _$N`
      <div class="${0}--search-magnifier">
        <slot name="icon" @slotchange=${0}>
          ${0}
        </slot>
      </div>
      <label for="input" part="label-text" class="${0}--label">
        <slot>${0}</slot>
      </label>
      <input
        autocomplete="${0}"
        id="input"
        part="input"
        type="${0}"
        class="${0}--search-input"
        ?disabled="${0}"
        name="${0}"
        placeholder="${0}"
        role="${0}"
        .value="${0}"
        @input="${0}" />
      <button
        part="close-button"
        class="${0}"
        @click="${0}"
        type="button"
        aria-label="${0}">
        ${0}
      </button>
    `), prefix$B, handleSlotChange, hasCustomIcon ? x(_t2$m || (_t2$m = _$N``)) : x(_t3$d || (_t3$d = _$N`${0}`), svgResultCarbonIcon$n({
          part: 'search-icon',
          class: `${prefix$B}--search-magnifier-icon`,
          role: 'img'
        })), prefix$B, labelText, autoComplete, ifNonEmpty(type), prefix$B, disabled, ifNonEmpty(name), ifNonEmpty(placeholder), role, value, handleInput, clearClasses, handleClearInputButtonClick, closeButtonLabelText, svgResultCarbonIcon$E({
          part: 'close-icon',
          'aria-label': closeButtonLabelText,
          role: 'img'
        }));
      }

      /**
       * The name of the custom event fired after the search content is changed upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventInput",
      value: function () {
        return `${prefix$B}-search-input`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$d;
      }
    }]
  };
}, HostListenerMixin(FocusMixin(FormMixin(s))));

let _$M = t => t,
  _t$N;
function _decorate$Q(e, r, t, i) { var o = _getDecoratorsApi$Q(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$Q(s.d.map(_createElementDescriptor$Q)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$Q() { _getDecoratorsApi$Q = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$Q(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$Q(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$R(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$Q(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$Q(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$Q(e) { var r, t = _toPropertyKey$R(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$Q(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$Q(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$Q(o.descriptor) || _isDataDescriptor$Q(i.descriptor)) { if (_hasDecorators$Q(o) || _hasDecorators$Q(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$Q(o)) { if (_hasDecorators$Q(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$Q(o, i); } } else r.push(o); } return r; }
function _hasDecorators$Q(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$Q(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$Q(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$R(t) { var i = _toPrimitive$R(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$R(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$Q(r) { return _arrayWithHoles$R(r) || _iterableToArray$Q(r) || _unsupportedIterableToArray$R(r) || _nonIterableRest$R(); }
function _nonIterableRest$R() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$R(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$R(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$R(r, a) : void 0; } }
function _arrayLikeToArray$R(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$Q(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$R(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$Q
} = settings;

/**
 * The regions selector in locale modal.
 *
 * @element c4d-regions
 */
_decorate$Q([carbonElement(`${c4dPrefix$Q}-regions`)], function (_initialize, _StableSelectorMixin) {
  class C4DRegions extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DRegions,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'regions-selector';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The shadow slot this regions selector should be in.
       */

      function render() {
        return x(_t$N || (_t$N = _$M` <slot></slot> `));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$Q}--regions`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$h;
      }
    }]
  };
}, StableSelectorMixin(s));

var purify = {exports: {}};

/*! @license DOMPurify 3.2.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.2.5/LICENSE */

(function (module, exports) {
(function (global, factory) {
  module.exports = factory() ;
})(commonjsGlobal, (function () {
  const {
    entries,
    setPrototypeOf,
    isFrozen,
    getPrototypeOf,
    getOwnPropertyDescriptor
  } = Object;
  let {
    freeze,
    seal,
    create
  } = Object; // eslint-disable-line import/no-mutable-exports
  let {
    apply,
    construct
  } = typeof Reflect !== 'undefined' && Reflect;
  if (!freeze) {
    freeze = function freeze(x) {
      return x;
    };
  }
  if (!seal) {
    seal = function seal(x) {
      return x;
    };
  }
  if (!apply) {
    apply = function apply(fun, thisValue, args) {
      return fun.apply(thisValue, args);
    };
  }
  if (!construct) {
    construct = function construct(Func, args) {
      return new Func(...args);
    };
  }
  const arrayForEach = unapply(Array.prototype.forEach);
  const arrayLastIndexOf = unapply(Array.prototype.lastIndexOf);
  const arrayPop = unapply(Array.prototype.pop);
  const arrayPush = unapply(Array.prototype.push);
  const arraySplice = unapply(Array.prototype.splice);
  const stringToLowerCase = unapply(String.prototype.toLowerCase);
  const stringToString = unapply(String.prototype.toString);
  const stringMatch = unapply(String.prototype.match);
  const stringReplace = unapply(String.prototype.replace);
  const stringIndexOf = unapply(String.prototype.indexOf);
  const stringTrim = unapply(String.prototype.trim);
  const objectHasOwnProperty = unapply(Object.prototype.hasOwnProperty);
  const regExpTest = unapply(RegExp.prototype.test);
  const typeErrorCreate = unconstruct(TypeError);
  /**
   * Creates a new function that calls the given function with a specified thisArg and arguments.
   *
   * @param func - The function to be wrapped and called.
   * @returns A new function that calls the given function with a specified thisArg and arguments.
   */
  function unapply(func) {
    return function (thisArg) {
      if (thisArg instanceof RegExp) {
        thisArg.lastIndex = 0;
      }
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      return apply(func, thisArg, args);
    };
  }
  /**
   * Creates a new function that constructs an instance of the given constructor function with the provided arguments.
   *
   * @param func - The constructor function to be wrapped and called.
   * @returns A new function that constructs an instance of the given constructor function with the provided arguments.
   */
  function unconstruct(func) {
    return function () {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      return construct(func, args);
    };
  }
  /**
   * Add properties to a lookup table
   *
   * @param set - The set to which elements will be added.
   * @param array - The array containing elements to be added to the set.
   * @param transformCaseFunc - An optional function to transform the case of each element before adding to the set.
   * @returns The modified set with added elements.
   */
  function addToSet(set, array) {
    let transformCaseFunc = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : stringToLowerCase;
    if (setPrototypeOf) {
      // Make 'in' and truthy checks like Boolean(set.constructor)
      // independent of any properties defined on Object.prototype.
      // Prevent prototype setters from intercepting set as a this value.
      setPrototypeOf(set, null);
    }
    let l = array.length;
    while (l--) {
      let element = array[l];
      if (typeof element === 'string') {
        const lcElement = transformCaseFunc(element);
        if (lcElement !== element) {
          // Config presets (e.g. tags.js, attrs.js) are immutable.
          if (!isFrozen(array)) {
            array[l] = lcElement;
          }
          element = lcElement;
        }
      }
      set[element] = true;
    }
    return set;
  }
  /**
   * Clean up an array to harden against CSPP
   *
   * @param array - The array to be cleaned.
   * @returns The cleaned version of the array
   */
  function cleanArray(array) {
    for (let index = 0; index < array.length; index++) {
      const isPropertyExist = objectHasOwnProperty(array, index);
      if (!isPropertyExist) {
        array[index] = null;
      }
    }
    return array;
  }
  /**
   * Shallow clone an object
   *
   * @param object - The object to be cloned.
   * @returns A new object that copies the original.
   */
  function clone(object) {
    const newObject = create(null);
    for (const [property, value] of entries(object)) {
      const isPropertyExist = objectHasOwnProperty(object, property);
      if (isPropertyExist) {
        if (Array.isArray(value)) {
          newObject[property] = cleanArray(value);
        } else if (value && typeof value === 'object' && value.constructor === Object) {
          newObject[property] = clone(value);
        } else {
          newObject[property] = value;
        }
      }
    }
    return newObject;
  }
  /**
   * This method automatically checks if the prop is function or getter and behaves accordingly.
   *
   * @param object - The object to look up the getter function in its prototype chain.
   * @param prop - The property name for which to find the getter function.
   * @returns The getter function found in the prototype chain or a fallback function.
   */
  function lookupGetter(object, prop) {
    while (object !== null) {
      const desc = getOwnPropertyDescriptor(object, prop);
      if (desc) {
        if (desc.get) {
          return unapply(desc.get);
        }
        if (typeof desc.value === 'function') {
          return unapply(desc.value);
        }
      }
      object = getPrototypeOf(object);
    }
    function fallbackValue() {
      return null;
    }
    return fallbackValue;
  }

  const html$1 = freeze(['a', 'abbr', 'acronym', 'address', 'area', 'article', 'aside', 'audio', 'b', 'bdi', 'bdo', 'big', 'blink', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'center', 'cite', 'code', 'col', 'colgroup', 'content', 'data', 'datalist', 'dd', 'decorator', 'del', 'details', 'dfn', 'dialog', 'dir', 'div', 'dl', 'dt', 'element', 'em', 'fieldset', 'figcaption', 'figure', 'font', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hgroup', 'hr', 'html', 'i', 'img', 'input', 'ins', 'kbd', 'label', 'legend', 'li', 'main', 'map', 'mark', 'marquee', 'menu', 'menuitem', 'meter', 'nav', 'nobr', 'ol', 'optgroup', 'option', 'output', 'p', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'section', 'select', 'shadow', 'small', 'source', 'spacer', 'span', 'strike', 'strong', 'style', 'sub', 'summary', 'sup', 'table', 'tbody', 'td', 'template', 'textarea', 'tfoot', 'th', 'thead', 'time', 'tr', 'track', 'tt', 'u', 'ul', 'var', 'video', 'wbr']);
  const svg$1 = freeze(['svg', 'a', 'altglyph', 'altglyphdef', 'altglyphitem', 'animatecolor', 'animatemotion', 'animatetransform', 'circle', 'clippath', 'defs', 'desc', 'ellipse', 'filter', 'font', 'g', 'glyph', 'glyphref', 'hkern', 'image', 'line', 'lineargradient', 'marker', 'mask', 'metadata', 'mpath', 'path', 'pattern', 'polygon', 'polyline', 'radialgradient', 'rect', 'stop', 'style', 'switch', 'symbol', 'text', 'textpath', 'title', 'tref', 'tspan', 'view', 'vkern']);
  const svgFilters = freeze(['feBlend', 'feColorMatrix', 'feComponentTransfer', 'feComposite', 'feConvolveMatrix', 'feDiffuseLighting', 'feDisplacementMap', 'feDistantLight', 'feDropShadow', 'feFlood', 'feFuncA', 'feFuncB', 'feFuncG', 'feFuncR', 'feGaussianBlur', 'feImage', 'feMerge', 'feMergeNode', 'feMorphology', 'feOffset', 'fePointLight', 'feSpecularLighting', 'feSpotLight', 'feTile', 'feTurbulence']);
  // List of SVG elements that are disallowed by default.
  // We still need to know them so that we can do namespace
  // checks properly in case one wants to add them to
  // allow-list.
  const svgDisallowed = freeze(['animate', 'color-profile', 'cursor', 'discard', 'font-face', 'font-face-format', 'font-face-name', 'font-face-src', 'font-face-uri', 'foreignobject', 'hatch', 'hatchpath', 'mesh', 'meshgradient', 'meshpatch', 'meshrow', 'missing-glyph', 'script', 'set', 'solidcolor', 'unknown', 'use']);
  const mathMl$1 = freeze(['math', 'menclose', 'merror', 'mfenced', 'mfrac', 'mglyph', 'mi', 'mlabeledtr', 'mmultiscripts', 'mn', 'mo', 'mover', 'mpadded', 'mphantom', 'mroot', 'mrow', 'ms', 'mspace', 'msqrt', 'mstyle', 'msub', 'msup', 'msubsup', 'mtable', 'mtd', 'mtext', 'mtr', 'munder', 'munderover', 'mprescripts']);
  // Similarly to SVG, we want to know all MathML elements,
  // even those that we disallow by default.
  const mathMlDisallowed = freeze(['maction', 'maligngroup', 'malignmark', 'mlongdiv', 'mscarries', 'mscarry', 'msgroup', 'mstack', 'msline', 'msrow', 'semantics', 'annotation', 'annotation-xml', 'mprescripts', 'none']);
  const text = freeze(['#text']);

  const html = freeze(['accept', 'action', 'align', 'alt', 'autocapitalize', 'autocomplete', 'autopictureinpicture', 'autoplay', 'background', 'bgcolor', 'border', 'capture', 'cellpadding', 'cellspacing', 'checked', 'cite', 'class', 'clear', 'color', 'cols', 'colspan', 'controls', 'controlslist', 'coords', 'crossorigin', 'datetime', 'decoding', 'default', 'dir', 'disabled', 'disablepictureinpicture', 'disableremoteplayback', 'download', 'draggable', 'enctype', 'enterkeyhint', 'face', 'for', 'headers', 'height', 'hidden', 'high', 'href', 'hreflang', 'id', 'inputmode', 'integrity', 'ismap', 'kind', 'label', 'lang', 'list', 'loading', 'loop', 'low', 'max', 'maxlength', 'media', 'method', 'min', 'minlength', 'multiple', 'muted', 'name', 'nonce', 'noshade', 'novalidate', 'nowrap', 'open', 'optimum', 'pattern', 'placeholder', 'playsinline', 'popover', 'popovertarget', 'popovertargetaction', 'poster', 'preload', 'pubdate', 'radiogroup', 'readonly', 'rel', 'required', 'rev', 'reversed', 'role', 'rows', 'rowspan', 'spellcheck', 'scope', 'selected', 'shape', 'size', 'sizes', 'span', 'srclang', 'start', 'src', 'srcset', 'step', 'style', 'summary', 'tabindex', 'title', 'translate', 'type', 'usemap', 'valign', 'value', 'width', 'wrap', 'xmlns', 'slot']);
  const svg = freeze(['accent-height', 'accumulate', 'additive', 'alignment-baseline', 'amplitude', 'ascent', 'attributename', 'attributetype', 'azimuth', 'basefrequency', 'baseline-shift', 'begin', 'bias', 'by', 'class', 'clip', 'clippathunits', 'clip-path', 'clip-rule', 'color', 'color-interpolation', 'color-interpolation-filters', 'color-profile', 'color-rendering', 'cx', 'cy', 'd', 'dx', 'dy', 'diffuseconstant', 'direction', 'display', 'divisor', 'dur', 'edgemode', 'elevation', 'end', 'exponent', 'fill', 'fill-opacity', 'fill-rule', 'filter', 'filterunits', 'flood-color', 'flood-opacity', 'font-family', 'font-size', 'font-size-adjust', 'font-stretch', 'font-style', 'font-variant', 'font-weight', 'fx', 'fy', 'g1', 'g2', 'glyph-name', 'glyphref', 'gradientunits', 'gradienttransform', 'height', 'href', 'id', 'image-rendering', 'in', 'in2', 'intercept', 'k', 'k1', 'k2', 'k3', 'k4', 'kerning', 'keypoints', 'keysplines', 'keytimes', 'lang', 'lengthadjust', 'letter-spacing', 'kernelmatrix', 'kernelunitlength', 'lighting-color', 'local', 'marker-end', 'marker-mid', 'marker-start', 'markerheight', 'markerunits', 'markerwidth', 'maskcontentunits', 'maskunits', 'max', 'mask', 'media', 'method', 'mode', 'min', 'name', 'numoctaves', 'offset', 'operator', 'opacity', 'order', 'orient', 'orientation', 'origin', 'overflow', 'paint-order', 'path', 'pathlength', 'patterncontentunits', 'patterntransform', 'patternunits', 'points', 'preservealpha', 'preserveaspectratio', 'primitiveunits', 'r', 'rx', 'ry', 'radius', 'refx', 'refy', 'repeatcount', 'repeatdur', 'restart', 'result', 'rotate', 'scale', 'seed', 'shape-rendering', 'slope', 'specularconstant', 'specularexponent', 'spreadmethod', 'startoffset', 'stddeviation', 'stitchtiles', 'stop-color', 'stop-opacity', 'stroke-dasharray', 'stroke-dashoffset', 'stroke-linecap', 'stroke-linejoin', 'stroke-miterlimit', 'stroke-opacity', 'stroke', 'stroke-width', 'style', 'surfacescale', 'systemlanguage', 'tabindex', 'tablevalues', 'targetx', 'targety', 'transform', 'transform-origin', 'text-anchor', 'text-decoration', 'text-rendering', 'textlength', 'type', 'u1', 'u2', 'unicode', 'values', 'viewbox', 'visibility', 'version', 'vert-adv-y', 'vert-origin-x', 'vert-origin-y', 'width', 'word-spacing', 'wrap', 'writing-mode', 'xchannelselector', 'ychannelselector', 'x', 'x1', 'x2', 'xmlns', 'y', 'y1', 'y2', 'z', 'zoomandpan']);
  const mathMl = freeze(['accent', 'accentunder', 'align', 'bevelled', 'close', 'columnsalign', 'columnlines', 'columnspan', 'denomalign', 'depth', 'dir', 'display', 'displaystyle', 'encoding', 'fence', 'frame', 'height', 'href', 'id', 'largeop', 'length', 'linethickness', 'lspace', 'lquote', 'mathbackground', 'mathcolor', 'mathsize', 'mathvariant', 'maxsize', 'minsize', 'movablelimits', 'notation', 'numalign', 'open', 'rowalign', 'rowlines', 'rowspacing', 'rowspan', 'rspace', 'rquote', 'scriptlevel', 'scriptminsize', 'scriptsizemultiplier', 'selection', 'separator', 'separators', 'stretchy', 'subscriptshift', 'supscriptshift', 'symmetric', 'voffset', 'width', 'xmlns']);
  const xml = freeze(['xlink:href', 'xml:id', 'xlink:title', 'xml:space', 'xmlns:xlink']);

  // eslint-disable-next-line unicorn/better-regex
  const MUSTACHE_EXPR = seal(/\{\{[\w\W]*|[\w\W]*\}\}/gm); // Specify template detection regex for SAFE_FOR_TEMPLATES mode
  const ERB_EXPR = seal(/<%[\w\W]*|[\w\W]*%>/gm);
  const TMPLIT_EXPR = seal(/\$\{[\w\W]*/gm); // eslint-disable-line unicorn/better-regex
  const DATA_ATTR = seal(/^data-[\-\w.\u00B7-\uFFFF]+$/); // eslint-disable-line no-useless-escape
  const ARIA_ATTR = seal(/^aria-[\-\w]+$/); // eslint-disable-line no-useless-escape
  const IS_ALLOWED_URI = seal(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i // eslint-disable-line no-useless-escape
  );
  const IS_SCRIPT_OR_DATA = seal(/^(?:\w+script|data):/i);
  const ATTR_WHITESPACE = seal(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g // eslint-disable-line no-control-regex
  );
  const DOCTYPE_NAME = seal(/^html$/i);
  const CUSTOM_ELEMENT = seal(/^[a-z][.\w]*(-[.\w]+)+$/i);

  var EXPRESSIONS = /*#__PURE__*/Object.freeze({
    __proto__: null,
    ARIA_ATTR: ARIA_ATTR,
    ATTR_WHITESPACE: ATTR_WHITESPACE,
    CUSTOM_ELEMENT: CUSTOM_ELEMENT,
    DATA_ATTR: DATA_ATTR,
    DOCTYPE_NAME: DOCTYPE_NAME,
    ERB_EXPR: ERB_EXPR,
    IS_ALLOWED_URI: IS_ALLOWED_URI,
    IS_SCRIPT_OR_DATA: IS_SCRIPT_OR_DATA,
    MUSTACHE_EXPR: MUSTACHE_EXPR,
    TMPLIT_EXPR: TMPLIT_EXPR
  });

  /* eslint-disable @typescript-eslint/indent */
  // https://developer.mozilla.org/en-US/docs/Web/API/Node/nodeType
  const NODE_TYPE = {
    element: 1,
    attribute: 2,
    text: 3,
    cdataSection: 4,
    entityReference: 5,
    // Deprecated
    entityNode: 6,
    // Deprecated
    progressingInstruction: 7,
    comment: 8,
    document: 9,
    documentType: 10,
    documentFragment: 11,
    notation: 12 // Deprecated
  };
  const getGlobal = function getGlobal() {
    return typeof window === 'undefined' ? null : window;
  };
  /**
   * Creates a no-op policy for internal use only.
   * Don't export this function outside this module!
   * @param trustedTypes The policy factory.
   * @param purifyHostElement The Script element used to load DOMPurify (to determine policy name suffix).
   * @return The policy created (or null, if Trusted Types
   * are not supported or creating the policy failed).
   */
  const _createTrustedTypesPolicy = function _createTrustedTypesPolicy(trustedTypes, purifyHostElement) {
    if (typeof trustedTypes !== 'object' || typeof trustedTypes.createPolicy !== 'function') {
      return null;
    }
    // Allow the callers to control the unique policy name
    // by adding a data-tt-policy-suffix to the script element with the DOMPurify.
    // Policy creation with duplicate names throws in Trusted Types.
    let suffix = null;
    const ATTR_NAME = 'data-tt-policy-suffix';
    if (purifyHostElement && purifyHostElement.hasAttribute(ATTR_NAME)) {
      suffix = purifyHostElement.getAttribute(ATTR_NAME);
    }
    const policyName = 'dompurify' + (suffix ? '#' + suffix : '');
    try {
      return trustedTypes.createPolicy(policyName, {
        createHTML(html) {
          return html;
        },
        createScriptURL(scriptUrl) {
          return scriptUrl;
        }
      });
    } catch (_) {
      // Policy creation failed (most likely another DOMPurify script has
      // already run). Skip creating the policy, as this will only cause errors
      // if TT are enforced.
      console.warn('TrustedTypes policy ' + policyName + ' could not be created.');
      return null;
    }
  };
  const _createHooksMap = function _createHooksMap() {
    return {
      afterSanitizeAttributes: [],
      afterSanitizeElements: [],
      afterSanitizeShadowDOM: [],
      beforeSanitizeAttributes: [],
      beforeSanitizeElements: [],
      beforeSanitizeShadowDOM: [],
      uponSanitizeAttribute: [],
      uponSanitizeElement: [],
      uponSanitizeShadowNode: []
    };
  };
  function createDOMPurify() {
    let window = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getGlobal();
    const DOMPurify = root => createDOMPurify(root);
    DOMPurify.version = '3.2.5';
    DOMPurify.removed = [];
    if (!window || !window.document || window.document.nodeType !== NODE_TYPE.document || !window.Element) {
      // Not running in a browser, provide a factory function
      // so that you can pass your own Window
      DOMPurify.isSupported = false;
      return DOMPurify;
    }
    let {
      document
    } = window;
    const originalDocument = document;
    const currentScript = originalDocument.currentScript;
    const {
      DocumentFragment,
      HTMLTemplateElement,
      Node,
      Element,
      NodeFilter,
      NamedNodeMap = window.NamedNodeMap || window.MozNamedAttrMap,
      HTMLFormElement,
      DOMParser,
      trustedTypes
    } = window;
    const ElementPrototype = Element.prototype;
    const cloneNode = lookupGetter(ElementPrototype, 'cloneNode');
    const remove = lookupGetter(ElementPrototype, 'remove');
    const getNextSibling = lookupGetter(ElementPrototype, 'nextSibling');
    const getChildNodes = lookupGetter(ElementPrototype, 'childNodes');
    const getParentNode = lookupGetter(ElementPrototype, 'parentNode');
    // As per issue #47, the web-components registry is inherited by a
    // new document created via createHTMLDocument. As per the spec
    // (http://w3c.github.io/webcomponents/spec/custom/#creating-and-passing-registries)
    // a new empty registry is used when creating a template contents owner
    // document, so we use that as our parent document to ensure nothing
    // is inherited.
    if (typeof HTMLTemplateElement === 'function') {
      const template = document.createElement('template');
      if (template.content && template.content.ownerDocument) {
        document = template.content.ownerDocument;
      }
    }
    let trustedTypesPolicy;
    let emptyHTML = '';
    const {
      implementation,
      createNodeIterator,
      createDocumentFragment,
      getElementsByTagName
    } = document;
    const {
      importNode
    } = originalDocument;
    let hooks = _createHooksMap();
    /**
     * Expose whether this browser supports running the full DOMPurify.
     */
    DOMPurify.isSupported = typeof entries === 'function' && typeof getParentNode === 'function' && implementation && implementation.createHTMLDocument !== undefined;
    const {
      MUSTACHE_EXPR,
      ERB_EXPR,
      TMPLIT_EXPR,
      DATA_ATTR,
      ARIA_ATTR,
      IS_SCRIPT_OR_DATA,
      ATTR_WHITESPACE,
      CUSTOM_ELEMENT
    } = EXPRESSIONS;
    let {
      IS_ALLOWED_URI: IS_ALLOWED_URI$1
    } = EXPRESSIONS;
    /**
     * We consider the elements and attributes below to be safe. Ideally
     * don't add any new ones but feel free to remove unwanted ones.
     */
    /* allowed element names */
    let ALLOWED_TAGS = null;
    const DEFAULT_ALLOWED_TAGS = addToSet({}, [...html$1, ...svg$1, ...svgFilters, ...mathMl$1, ...text]);
    /* Allowed attribute names */
    let ALLOWED_ATTR = null;
    const DEFAULT_ALLOWED_ATTR = addToSet({}, [...html, ...svg, ...mathMl, ...xml]);
    /*
     * Configure how DOMPurify should handle custom elements and their attributes as well as customized built-in elements.
     * @property {RegExp|Function|null} tagNameCheck one of [null, regexPattern, predicate]. Default: `null` (disallow any custom elements)
     * @property {RegExp|Function|null} attributeNameCheck one of [null, regexPattern, predicate]. Default: `null` (disallow any attributes not on the allow list)
     * @property {boolean} allowCustomizedBuiltInElements allow custom elements derived from built-ins if they pass CUSTOM_ELEMENT_HANDLING.tagNameCheck. Default: `false`.
     */
    let CUSTOM_ELEMENT_HANDLING = Object.seal(create(null, {
      tagNameCheck: {
        writable: true,
        configurable: false,
        enumerable: true,
        value: null
      },
      attributeNameCheck: {
        writable: true,
        configurable: false,
        enumerable: true,
        value: null
      },
      allowCustomizedBuiltInElements: {
        writable: true,
        configurable: false,
        enumerable: true,
        value: false
      }
    }));
    /* Explicitly forbidden tags (overrides ALLOWED_TAGS/ADD_TAGS) */
    let FORBID_TAGS = null;
    /* Explicitly forbidden attributes (overrides ALLOWED_ATTR/ADD_ATTR) */
    let FORBID_ATTR = null;
    /* Decide if ARIA attributes are okay */
    let ALLOW_ARIA_ATTR = true;
    /* Decide if custom data attributes are okay */
    let ALLOW_DATA_ATTR = true;
    /* Decide if unknown protocols are okay */
    let ALLOW_UNKNOWN_PROTOCOLS = false;
    /* Decide if self-closing tags in attributes are allowed.
     * Usually removed due to a mXSS issue in jQuery 3.0 */
    let ALLOW_SELF_CLOSE_IN_ATTR = true;
    /* Output should be safe for common template engines.
     * This means, DOMPurify removes data attributes, mustaches and ERB
     */
    let SAFE_FOR_TEMPLATES = false;
    /* Output should be safe even for XML used within HTML and alike.
     * This means, DOMPurify removes comments when containing risky content.
     */
    let SAFE_FOR_XML = true;
    /* Decide if document with <html>... should be returned */
    let WHOLE_DOCUMENT = false;
    /* Track whether config is already set on this instance of DOMPurify. */
    let SET_CONFIG = false;
    /* Decide if all elements (e.g. style, script) must be children of
     * document.body. By default, browsers might move them to document.head */
    let FORCE_BODY = false;
    /* Decide if a DOM `HTMLBodyElement` should be returned, instead of a html
     * string (or a TrustedHTML object if Trusted Types are supported).
     * If `WHOLE_DOCUMENT` is enabled a `HTMLHtmlElement` will be returned instead
     */
    let RETURN_DOM = false;
    /* Decide if a DOM `DocumentFragment` should be returned, instead of a html
     * string  (or a TrustedHTML object if Trusted Types are supported) */
    let RETURN_DOM_FRAGMENT = false;
    /* Try to return a Trusted Type object instead of a string, return a string in
     * case Trusted Types are not supported  */
    let RETURN_TRUSTED_TYPE = false;
    /* Output should be free from DOM clobbering attacks?
     * This sanitizes markups named with colliding, clobberable built-in DOM APIs.
     */
    let SANITIZE_DOM = true;
    /* Achieve full DOM Clobbering protection by isolating the namespace of named
     * properties and JS variables, mitigating attacks that abuse the HTML/DOM spec rules.
     *
     * HTML/DOM spec rules that enable DOM Clobbering:
     *   - Named Access on Window (§7.3.3)
     *   - DOM Tree Accessors (§3.1.5)
     *   - Form Element Parent-Child Relations (§4.10.3)
     *   - Iframe srcdoc / Nested WindowProxies (§4.8.5)
     *   - HTMLCollection (§4.2.10.2)
     *
     * Namespace isolation is implemented by prefixing `id` and `name` attributes
     * with a constant string, i.e., `user-content-`
     */
    let SANITIZE_NAMED_PROPS = false;
    const SANITIZE_NAMED_PROPS_PREFIX = 'user-content-';
    /* Keep element content when removing element? */
    let KEEP_CONTENT = true;
    /* If a `Node` is passed to sanitize(), then performs sanitization in-place instead
     * of importing it into a new Document and returning a sanitized copy */
    let IN_PLACE = false;
    /* Allow usage of profiles like html, svg and mathMl */
    let USE_PROFILES = {};
    /* Tags to ignore content of when KEEP_CONTENT is true */
    let FORBID_CONTENTS = null;
    const DEFAULT_FORBID_CONTENTS = addToSet({}, ['annotation-xml', 'audio', 'colgroup', 'desc', 'foreignobject', 'head', 'iframe', 'math', 'mi', 'mn', 'mo', 'ms', 'mtext', 'noembed', 'noframes', 'noscript', 'plaintext', 'script', 'style', 'svg', 'template', 'thead', 'title', 'video', 'xmp']);
    /* Tags that are safe for data: URIs */
    let DATA_URI_TAGS = null;
    const DEFAULT_DATA_URI_TAGS = addToSet({}, ['audio', 'video', 'img', 'source', 'image', 'track']);
    /* Attributes safe for values like "javascript:" */
    let URI_SAFE_ATTRIBUTES = null;
    const DEFAULT_URI_SAFE_ATTRIBUTES = addToSet({}, ['alt', 'class', 'for', 'id', 'label', 'name', 'pattern', 'placeholder', 'role', 'summary', 'title', 'value', 'style', 'xmlns']);
    const MATHML_NAMESPACE = 'http://www.w3.org/1998/Math/MathML';
    const SVG_NAMESPACE = 'http://www.w3.org/2000/svg';
    const HTML_NAMESPACE = 'http://www.w3.org/1999/xhtml';
    /* Document namespace */
    let NAMESPACE = HTML_NAMESPACE;
    let IS_EMPTY_INPUT = false;
    /* Allowed XHTML+XML namespaces */
    let ALLOWED_NAMESPACES = null;
    const DEFAULT_ALLOWED_NAMESPACES = addToSet({}, [MATHML_NAMESPACE, SVG_NAMESPACE, HTML_NAMESPACE], stringToString);
    let MATHML_TEXT_INTEGRATION_POINTS = addToSet({}, ['mi', 'mo', 'mn', 'ms', 'mtext']);
    let HTML_INTEGRATION_POINTS = addToSet({}, ['annotation-xml']);
    // Certain elements are allowed in both SVG and HTML
    // namespace. We need to specify them explicitly
    // so that they don't get erroneously deleted from
    // HTML namespace.
    const COMMON_SVG_AND_HTML_ELEMENTS = addToSet({}, ['title', 'style', 'font', 'a', 'script']);
    /* Parsing of strict XHTML documents */
    let PARSER_MEDIA_TYPE = null;
    const SUPPORTED_PARSER_MEDIA_TYPES = ['application/xhtml+xml', 'text/html'];
    const DEFAULT_PARSER_MEDIA_TYPE = 'text/html';
    let transformCaseFunc = null;
    /* Keep a reference to config to pass to hooks */
    let CONFIG = null;
    /* Ideally, do not touch anything below this line */
    /* ______________________________________________ */
    const formElement = document.createElement('form');
    const isRegexOrFunction = function isRegexOrFunction(testValue) {
      return testValue instanceof RegExp || testValue instanceof Function;
    };
    /**
     * _parseConfig
     *
     * @param cfg optional config literal
     */
    // eslint-disable-next-line complexity
    const _parseConfig = function _parseConfig() {
      let cfg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      if (CONFIG && CONFIG === cfg) {
        return;
      }
      /* Shield configuration object from tampering */
      if (!cfg || typeof cfg !== 'object') {
        cfg = {};
      }
      /* Shield configuration object from prototype pollution */
      cfg = clone(cfg);
      PARSER_MEDIA_TYPE =
      // eslint-disable-next-line unicorn/prefer-includes
      SUPPORTED_PARSER_MEDIA_TYPES.indexOf(cfg.PARSER_MEDIA_TYPE) === -1 ? DEFAULT_PARSER_MEDIA_TYPE : cfg.PARSER_MEDIA_TYPE;
      // HTML tags and attributes are not case-sensitive, converting to lowercase. Keeping XHTML as is.
      transformCaseFunc = PARSER_MEDIA_TYPE === 'application/xhtml+xml' ? stringToString : stringToLowerCase;
      /* Set configuration parameters */
      ALLOWED_TAGS = objectHasOwnProperty(cfg, 'ALLOWED_TAGS') ? addToSet({}, cfg.ALLOWED_TAGS, transformCaseFunc) : DEFAULT_ALLOWED_TAGS;
      ALLOWED_ATTR = objectHasOwnProperty(cfg, 'ALLOWED_ATTR') ? addToSet({}, cfg.ALLOWED_ATTR, transformCaseFunc) : DEFAULT_ALLOWED_ATTR;
      ALLOWED_NAMESPACES = objectHasOwnProperty(cfg, 'ALLOWED_NAMESPACES') ? addToSet({}, cfg.ALLOWED_NAMESPACES, stringToString) : DEFAULT_ALLOWED_NAMESPACES;
      URI_SAFE_ATTRIBUTES = objectHasOwnProperty(cfg, 'ADD_URI_SAFE_ATTR') ? addToSet(clone(DEFAULT_URI_SAFE_ATTRIBUTES), cfg.ADD_URI_SAFE_ATTR, transformCaseFunc) : DEFAULT_URI_SAFE_ATTRIBUTES;
      DATA_URI_TAGS = objectHasOwnProperty(cfg, 'ADD_DATA_URI_TAGS') ? addToSet(clone(DEFAULT_DATA_URI_TAGS), cfg.ADD_DATA_URI_TAGS, transformCaseFunc) : DEFAULT_DATA_URI_TAGS;
      FORBID_CONTENTS = objectHasOwnProperty(cfg, 'FORBID_CONTENTS') ? addToSet({}, cfg.FORBID_CONTENTS, transformCaseFunc) : DEFAULT_FORBID_CONTENTS;
      FORBID_TAGS = objectHasOwnProperty(cfg, 'FORBID_TAGS') ? addToSet({}, cfg.FORBID_TAGS, transformCaseFunc) : {};
      FORBID_ATTR = objectHasOwnProperty(cfg, 'FORBID_ATTR') ? addToSet({}, cfg.FORBID_ATTR, transformCaseFunc) : {};
      USE_PROFILES = objectHasOwnProperty(cfg, 'USE_PROFILES') ? cfg.USE_PROFILES : false;
      ALLOW_ARIA_ATTR = cfg.ALLOW_ARIA_ATTR !== false; // Default true
      ALLOW_DATA_ATTR = cfg.ALLOW_DATA_ATTR !== false; // Default true
      ALLOW_UNKNOWN_PROTOCOLS = cfg.ALLOW_UNKNOWN_PROTOCOLS || false; // Default false
      ALLOW_SELF_CLOSE_IN_ATTR = cfg.ALLOW_SELF_CLOSE_IN_ATTR !== false; // Default true
      SAFE_FOR_TEMPLATES = cfg.SAFE_FOR_TEMPLATES || false; // Default false
      SAFE_FOR_XML = cfg.SAFE_FOR_XML !== false; // Default true
      WHOLE_DOCUMENT = cfg.WHOLE_DOCUMENT || false; // Default false
      RETURN_DOM = cfg.RETURN_DOM || false; // Default false
      RETURN_DOM_FRAGMENT = cfg.RETURN_DOM_FRAGMENT || false; // Default false
      RETURN_TRUSTED_TYPE = cfg.RETURN_TRUSTED_TYPE || false; // Default false
      FORCE_BODY = cfg.FORCE_BODY || false; // Default false
      SANITIZE_DOM = cfg.SANITIZE_DOM !== false; // Default true
      SANITIZE_NAMED_PROPS = cfg.SANITIZE_NAMED_PROPS || false; // Default false
      KEEP_CONTENT = cfg.KEEP_CONTENT !== false; // Default true
      IN_PLACE = cfg.IN_PLACE || false; // Default false
      IS_ALLOWED_URI$1 = cfg.ALLOWED_URI_REGEXP || IS_ALLOWED_URI;
      NAMESPACE = cfg.NAMESPACE || HTML_NAMESPACE;
      MATHML_TEXT_INTEGRATION_POINTS = cfg.MATHML_TEXT_INTEGRATION_POINTS || MATHML_TEXT_INTEGRATION_POINTS;
      HTML_INTEGRATION_POINTS = cfg.HTML_INTEGRATION_POINTS || HTML_INTEGRATION_POINTS;
      CUSTOM_ELEMENT_HANDLING = cfg.CUSTOM_ELEMENT_HANDLING || {};
      if (cfg.CUSTOM_ELEMENT_HANDLING && isRegexOrFunction(cfg.CUSTOM_ELEMENT_HANDLING.tagNameCheck)) {
        CUSTOM_ELEMENT_HANDLING.tagNameCheck = cfg.CUSTOM_ELEMENT_HANDLING.tagNameCheck;
      }
      if (cfg.CUSTOM_ELEMENT_HANDLING && isRegexOrFunction(cfg.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)) {
        CUSTOM_ELEMENT_HANDLING.attributeNameCheck = cfg.CUSTOM_ELEMENT_HANDLING.attributeNameCheck;
      }
      if (cfg.CUSTOM_ELEMENT_HANDLING && typeof cfg.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements === 'boolean') {
        CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements = cfg.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements;
      }
      if (SAFE_FOR_TEMPLATES) {
        ALLOW_DATA_ATTR = false;
      }
      if (RETURN_DOM_FRAGMENT) {
        RETURN_DOM = true;
      }
      /* Parse profile info */
      if (USE_PROFILES) {
        ALLOWED_TAGS = addToSet({}, text);
        ALLOWED_ATTR = [];
        if (USE_PROFILES.html === true) {
          addToSet(ALLOWED_TAGS, html$1);
          addToSet(ALLOWED_ATTR, html);
        }
        if (USE_PROFILES.svg === true) {
          addToSet(ALLOWED_TAGS, svg$1);
          addToSet(ALLOWED_ATTR, svg);
          addToSet(ALLOWED_ATTR, xml);
        }
        if (USE_PROFILES.svgFilters === true) {
          addToSet(ALLOWED_TAGS, svgFilters);
          addToSet(ALLOWED_ATTR, svg);
          addToSet(ALLOWED_ATTR, xml);
        }
        if (USE_PROFILES.mathMl === true) {
          addToSet(ALLOWED_TAGS, mathMl$1);
          addToSet(ALLOWED_ATTR, mathMl);
          addToSet(ALLOWED_ATTR, xml);
        }
      }
      /* Merge configuration parameters */
      if (cfg.ADD_TAGS) {
        if (ALLOWED_TAGS === DEFAULT_ALLOWED_TAGS) {
          ALLOWED_TAGS = clone(ALLOWED_TAGS);
        }
        addToSet(ALLOWED_TAGS, cfg.ADD_TAGS, transformCaseFunc);
      }
      if (cfg.ADD_ATTR) {
        if (ALLOWED_ATTR === DEFAULT_ALLOWED_ATTR) {
          ALLOWED_ATTR = clone(ALLOWED_ATTR);
        }
        addToSet(ALLOWED_ATTR, cfg.ADD_ATTR, transformCaseFunc);
      }
      if (cfg.ADD_URI_SAFE_ATTR) {
        addToSet(URI_SAFE_ATTRIBUTES, cfg.ADD_URI_SAFE_ATTR, transformCaseFunc);
      }
      if (cfg.FORBID_CONTENTS) {
        if (FORBID_CONTENTS === DEFAULT_FORBID_CONTENTS) {
          FORBID_CONTENTS = clone(FORBID_CONTENTS);
        }
        addToSet(FORBID_CONTENTS, cfg.FORBID_CONTENTS, transformCaseFunc);
      }
      /* Add #text in case KEEP_CONTENT is set to true */
      if (KEEP_CONTENT) {
        ALLOWED_TAGS['#text'] = true;
      }
      /* Add html, head and body to ALLOWED_TAGS in case WHOLE_DOCUMENT is true */
      if (WHOLE_DOCUMENT) {
        addToSet(ALLOWED_TAGS, ['html', 'head', 'body']);
      }
      /* Add tbody to ALLOWED_TAGS in case tables are permitted, see #286, #365 */
      if (ALLOWED_TAGS.table) {
        addToSet(ALLOWED_TAGS, ['tbody']);
        delete FORBID_TAGS.tbody;
      }
      if (cfg.TRUSTED_TYPES_POLICY) {
        if (typeof cfg.TRUSTED_TYPES_POLICY.createHTML !== 'function') {
          throw typeErrorCreate('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');
        }
        if (typeof cfg.TRUSTED_TYPES_POLICY.createScriptURL !== 'function') {
          throw typeErrorCreate('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');
        }
        // Overwrite existing TrustedTypes policy.
        trustedTypesPolicy = cfg.TRUSTED_TYPES_POLICY;
        // Sign local variables required by `sanitize`.
        emptyHTML = trustedTypesPolicy.createHTML('');
      } else {
        // Uninitialized policy, attempt to initialize the internal dompurify policy.
        if (trustedTypesPolicy === undefined) {
          trustedTypesPolicy = _createTrustedTypesPolicy(trustedTypes, currentScript);
        }
        // If creating the internal policy succeeded sign internal variables.
        if (trustedTypesPolicy !== null && typeof emptyHTML === 'string') {
          emptyHTML = trustedTypesPolicy.createHTML('');
        }
      }
      // Prevent further manipulation of configuration.
      // Not available in IE8, Safari 5, etc.
      if (freeze) {
        freeze(cfg);
      }
      CONFIG = cfg;
    };
    /* Keep track of all possible SVG and MathML tags
     * so that we can perform the namespace checks
     * correctly. */
    const ALL_SVG_TAGS = addToSet({}, [...svg$1, ...svgFilters, ...svgDisallowed]);
    const ALL_MATHML_TAGS = addToSet({}, [...mathMl$1, ...mathMlDisallowed]);
    /**
     * @param element a DOM element whose namespace is being checked
     * @returns Return false if the element has a
     *  namespace that a spec-compliant parser would never
     *  return. Return true otherwise.
     */
    const _checkValidNamespace = function _checkValidNamespace(element) {
      let parent = getParentNode(element);
      // In JSDOM, if we're inside shadow DOM, then parentNode
      // can be null. We just simulate parent in this case.
      if (!parent || !parent.tagName) {
        parent = {
          namespaceURI: NAMESPACE,
          tagName: 'template'
        };
      }
      const tagName = stringToLowerCase(element.tagName);
      const parentTagName = stringToLowerCase(parent.tagName);
      if (!ALLOWED_NAMESPACES[element.namespaceURI]) {
        return false;
      }
      if (element.namespaceURI === SVG_NAMESPACE) {
        // The only way to switch from HTML namespace to SVG
        // is via <svg>. If it happens via any other tag, then
        // it should be killed.
        if (parent.namespaceURI === HTML_NAMESPACE) {
          return tagName === 'svg';
        }
        // The only way to switch from MathML to SVG is via`
        // svg if parent is either <annotation-xml> or MathML
        // text integration points.
        if (parent.namespaceURI === MATHML_NAMESPACE) {
          return tagName === 'svg' && (parentTagName === 'annotation-xml' || MATHML_TEXT_INTEGRATION_POINTS[parentTagName]);
        }
        // We only allow elements that are defined in SVG
        // spec. All others are disallowed in SVG namespace.
        return Boolean(ALL_SVG_TAGS[tagName]);
      }
      if (element.namespaceURI === MATHML_NAMESPACE) {
        // The only way to switch from HTML namespace to MathML
        // is via <math>. If it happens via any other tag, then
        // it should be killed.
        if (parent.namespaceURI === HTML_NAMESPACE) {
          return tagName === 'math';
        }
        // The only way to switch from SVG to MathML is via
        // <math> and HTML integration points
        if (parent.namespaceURI === SVG_NAMESPACE) {
          return tagName === 'math' && HTML_INTEGRATION_POINTS[parentTagName];
        }
        // We only allow elements that are defined in MathML
        // spec. All others are disallowed in MathML namespace.
        return Boolean(ALL_MATHML_TAGS[tagName]);
      }
      if (element.namespaceURI === HTML_NAMESPACE) {
        // The only way to switch from SVG to HTML is via
        // HTML integration points, and from MathML to HTML
        // is via MathML text integration points
        if (parent.namespaceURI === SVG_NAMESPACE && !HTML_INTEGRATION_POINTS[parentTagName]) {
          return false;
        }
        if (parent.namespaceURI === MATHML_NAMESPACE && !MATHML_TEXT_INTEGRATION_POINTS[parentTagName]) {
          return false;
        }
        // We disallow tags that are specific for MathML
        // or SVG and should never appear in HTML namespace
        return !ALL_MATHML_TAGS[tagName] && (COMMON_SVG_AND_HTML_ELEMENTS[tagName] || !ALL_SVG_TAGS[tagName]);
      }
      // For XHTML and XML documents that support custom namespaces
      if (PARSER_MEDIA_TYPE === 'application/xhtml+xml' && ALLOWED_NAMESPACES[element.namespaceURI]) {
        return true;
      }
      // The code should never reach this place (this means
      // that the element somehow got namespace that is not
      // HTML, SVG, MathML or allowed via ALLOWED_NAMESPACES).
      // Return false just in case.
      return false;
    };
    /**
     * _forceRemove
     *
     * @param node a DOM node
     */
    const _forceRemove = function _forceRemove(node) {
      arrayPush(DOMPurify.removed, {
        element: node
      });
      try {
        // eslint-disable-next-line unicorn/prefer-dom-node-remove
        getParentNode(node).removeChild(node);
      } catch (_) {
        remove(node);
      }
    };
    /**
     * _removeAttribute
     *
     * @param name an Attribute name
     * @param element a DOM node
     */
    const _removeAttribute = function _removeAttribute(name, element) {
      try {
        arrayPush(DOMPurify.removed, {
          attribute: element.getAttributeNode(name),
          from: element
        });
      } catch (_) {
        arrayPush(DOMPurify.removed, {
          attribute: null,
          from: element
        });
      }
      element.removeAttribute(name);
      // We void attribute values for unremovable "is" attributes
      if (name === 'is') {
        if (RETURN_DOM || RETURN_DOM_FRAGMENT) {
          try {
            _forceRemove(element);
          } catch (_) {}
        } else {
          try {
            element.setAttribute(name, '');
          } catch (_) {}
        }
      }
    };
    /**
     * _initDocument
     *
     * @param dirty - a string of dirty markup
     * @return a DOM, filled with the dirty markup
     */
    const _initDocument = function _initDocument(dirty) {
      /* Create a HTML document */
      let doc = null;
      let leadingWhitespace = null;
      if (FORCE_BODY) {
        dirty = '<remove></remove>' + dirty;
      } else {
        /* If FORCE_BODY isn't used, leading whitespace needs to be preserved manually */
        const matches = stringMatch(dirty, /^[\r\n\t ]+/);
        leadingWhitespace = matches && matches[0];
      }
      if (PARSER_MEDIA_TYPE === 'application/xhtml+xml' && NAMESPACE === HTML_NAMESPACE) {
        // Root of XHTML doc must contain xmlns declaration (see https://www.w3.org/TR/xhtml1/normative.html#strict)
        dirty = '<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>' + dirty + '</body></html>';
      }
      const dirtyPayload = trustedTypesPolicy ? trustedTypesPolicy.createHTML(dirty) : dirty;
      /*
       * Use the DOMParser API by default, fallback later if needs be
       * DOMParser not work for svg when has multiple root element.
       */
      if (NAMESPACE === HTML_NAMESPACE) {
        try {
          doc = new DOMParser().parseFromString(dirtyPayload, PARSER_MEDIA_TYPE);
        } catch (_) {}
      }
      /* Use createHTMLDocument in case DOMParser is not available */
      if (!doc || !doc.documentElement) {
        doc = implementation.createDocument(NAMESPACE, 'template', null);
        try {
          doc.documentElement.innerHTML = IS_EMPTY_INPUT ? emptyHTML : dirtyPayload;
        } catch (_) {
          // Syntax error if dirtyPayload is invalid xml
        }
      }
      const body = doc.body || doc.documentElement;
      if (dirty && leadingWhitespace) {
        body.insertBefore(document.createTextNode(leadingWhitespace), body.childNodes[0] || null);
      }
      /* Work on whole document or just its body */
      if (NAMESPACE === HTML_NAMESPACE) {
        return getElementsByTagName.call(doc, WHOLE_DOCUMENT ? 'html' : 'body')[0];
      }
      return WHOLE_DOCUMENT ? doc.documentElement : body;
    };
    /**
     * Creates a NodeIterator object that you can use to traverse filtered lists of nodes or elements in a document.
     *
     * @param root The root element or node to start traversing on.
     * @return The created NodeIterator
     */
    const _createNodeIterator = function _createNodeIterator(root) {
      return createNodeIterator.call(root.ownerDocument || root, root,
      // eslint-disable-next-line no-bitwise
      NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_COMMENT | NodeFilter.SHOW_TEXT | NodeFilter.SHOW_PROCESSING_INSTRUCTION | NodeFilter.SHOW_CDATA_SECTION, null);
    };
    /**
     * _isClobbered
     *
     * @param element element to check for clobbering attacks
     * @return true if clobbered, false if safe
     */
    const _isClobbered = function _isClobbered(element) {
      return element instanceof HTMLFormElement && (typeof element.nodeName !== 'string' || typeof element.textContent !== 'string' || typeof element.removeChild !== 'function' || !(element.attributes instanceof NamedNodeMap) || typeof element.removeAttribute !== 'function' || typeof element.setAttribute !== 'function' || typeof element.namespaceURI !== 'string' || typeof element.insertBefore !== 'function' || typeof element.hasChildNodes !== 'function');
    };
    /**
     * Checks whether the given object is a DOM node.
     *
     * @param value object to check whether it's a DOM node
     * @return true is object is a DOM node
     */
    const _isNode = function _isNode(value) {
      return typeof Node === 'function' && value instanceof Node;
    };
    function _executeHooks(hooks, currentNode, data) {
      arrayForEach(hooks, hook => {
        hook.call(DOMPurify, currentNode, data, CONFIG);
      });
    }
    /**
     * _sanitizeElements
     *
     * @protect nodeName
     * @protect textContent
     * @protect removeChild
     * @param currentNode to check for permission to exist
     * @return true if node was killed, false if left alive
     */
    const _sanitizeElements = function _sanitizeElements(currentNode) {
      let content = null;
      /* Execute a hook if present */
      _executeHooks(hooks.beforeSanitizeElements, currentNode, null);
      /* Check if element is clobbered or can clobber */
      if (_isClobbered(currentNode)) {
        _forceRemove(currentNode);
        return true;
      }
      /* Now let's check the element's type and name */
      const tagName = transformCaseFunc(currentNode.nodeName);
      /* Execute a hook if present */
      _executeHooks(hooks.uponSanitizeElement, currentNode, {
        tagName,
        allowedTags: ALLOWED_TAGS
      });
      /* Detect mXSS attempts abusing namespace confusion */
      if (currentNode.hasChildNodes() && !_isNode(currentNode.firstElementChild) && regExpTest(/<[/\w!]/g, currentNode.innerHTML) && regExpTest(/<[/\w!]/g, currentNode.textContent)) {
        _forceRemove(currentNode);
        return true;
      }
      /* Remove any occurrence of processing instructions */
      if (currentNode.nodeType === NODE_TYPE.progressingInstruction) {
        _forceRemove(currentNode);
        return true;
      }
      /* Remove any kind of possibly harmful comments */
      if (SAFE_FOR_XML && currentNode.nodeType === NODE_TYPE.comment && regExpTest(/<[/\w]/g, currentNode.data)) {
        _forceRemove(currentNode);
        return true;
      }
      /* Remove element if anything forbids its presence */
      if (!ALLOWED_TAGS[tagName] || FORBID_TAGS[tagName]) {
        /* Check if we have a custom element to handle */
        if (!FORBID_TAGS[tagName] && _isBasicCustomElement(tagName)) {
          if (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck, tagName)) {
            return false;
          }
          if (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.tagNameCheck(tagName)) {
            return false;
          }
        }
        /* Keep content except for bad-listed elements */
        if (KEEP_CONTENT && !FORBID_CONTENTS[tagName]) {
          const parentNode = getParentNode(currentNode) || currentNode.parentNode;
          const childNodes = getChildNodes(currentNode) || currentNode.childNodes;
          if (childNodes && parentNode) {
            const childCount = childNodes.length;
            for (let i = childCount - 1; i >= 0; --i) {
              const childClone = cloneNode(childNodes[i], true);
              childClone.__removalCount = (currentNode.__removalCount || 0) + 1;
              parentNode.insertBefore(childClone, getNextSibling(currentNode));
            }
          }
        }
        _forceRemove(currentNode);
        return true;
      }
      /* Check whether element has a valid namespace */
      if (currentNode instanceof Element && !_checkValidNamespace(currentNode)) {
        _forceRemove(currentNode);
        return true;
      }
      /* Make sure that older browsers don't get fallback-tag mXSS */
      if ((tagName === 'noscript' || tagName === 'noembed' || tagName === 'noframes') && regExpTest(/<\/no(script|embed|frames)/i, currentNode.innerHTML)) {
        _forceRemove(currentNode);
        return true;
      }
      /* Sanitize element content to be template-safe */
      if (SAFE_FOR_TEMPLATES && currentNode.nodeType === NODE_TYPE.text) {
        /* Get the element's text content */
        content = currentNode.textContent;
        arrayForEach([MUSTACHE_EXPR, ERB_EXPR, TMPLIT_EXPR], expr => {
          content = stringReplace(content, expr, ' ');
        });
        if (currentNode.textContent !== content) {
          arrayPush(DOMPurify.removed, {
            element: currentNode.cloneNode()
          });
          currentNode.textContent = content;
        }
      }
      /* Execute a hook if present */
      _executeHooks(hooks.afterSanitizeElements, currentNode, null);
      return false;
    };
    /**
     * _isValidAttribute
     *
     * @param lcTag Lowercase tag name of containing element.
     * @param lcName Lowercase attribute name.
     * @param value Attribute value.
     * @return Returns true if `value` is valid, otherwise false.
     */
    // eslint-disable-next-line complexity
    const _isValidAttribute = function _isValidAttribute(lcTag, lcName, value) {
      /* Make sure attribute cannot clobber */
      if (SANITIZE_DOM && (lcName === 'id' || lcName === 'name') && (value in document || value in formElement)) {
        return false;
      }
      /* Allow valid data-* attributes: At least one character after "-"
          (https://html.spec.whatwg.org/multipage/dom.html#embedding-custom-non-visible-data-with-the-data-*-attributes)
          XML-compatible (https://html.spec.whatwg.org/multipage/infrastructure.html#xml-compatible and http://www.w3.org/TR/xml/#d0e804)
          We don't need to check the value; it's always URI safe. */
      if (ALLOW_DATA_ATTR && !FORBID_ATTR[lcName] && regExpTest(DATA_ATTR, lcName)) ; else if (ALLOW_ARIA_ATTR && regExpTest(ARIA_ATTR, lcName)) ; else if (!ALLOWED_ATTR[lcName] || FORBID_ATTR[lcName]) {
        if (
        // First condition does a very basic check if a) it's basically a valid custom element tagname AND
        // b) if the tagName passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.tagNameCheck
        // and c) if the attribute name passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.attributeNameCheck
        _isBasicCustomElement(lcTag) && (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck, lcTag) || CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.tagNameCheck(lcTag)) && (CUSTOM_ELEMENT_HANDLING.attributeNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.attributeNameCheck, lcName) || CUSTOM_ELEMENT_HANDLING.attributeNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.attributeNameCheck(lcName)) ||
        // Alternative, second condition checks if it's an `is`-attribute, AND
        // the value passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.tagNameCheck
        lcName === 'is' && CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements && (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck, value) || CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.tagNameCheck(value))) ; else {
          return false;
        }
        /* Check value is safe. First, is attr inert? If so, is safe */
      } else if (URI_SAFE_ATTRIBUTES[lcName]) ; else if (regExpTest(IS_ALLOWED_URI$1, stringReplace(value, ATTR_WHITESPACE, ''))) ; else if ((lcName === 'src' || lcName === 'xlink:href' || lcName === 'href') && lcTag !== 'script' && stringIndexOf(value, 'data:') === 0 && DATA_URI_TAGS[lcTag]) ; else if (ALLOW_UNKNOWN_PROTOCOLS && !regExpTest(IS_SCRIPT_OR_DATA, stringReplace(value, ATTR_WHITESPACE, ''))) ; else if (value) {
        return false;
      } else ;
      return true;
    };
    /**
     * _isBasicCustomElement
     * checks if at least one dash is included in tagName, and it's not the first char
     * for more sophisticated checking see https://github.com/sindresorhus/validate-element-name
     *
     * @param tagName name of the tag of the node to sanitize
     * @returns Returns true if the tag name meets the basic criteria for a custom element, otherwise false.
     */
    const _isBasicCustomElement = function _isBasicCustomElement(tagName) {
      return tagName !== 'annotation-xml' && stringMatch(tagName, CUSTOM_ELEMENT);
    };
    /**
     * _sanitizeAttributes
     *
     * @protect attributes
     * @protect nodeName
     * @protect removeAttribute
     * @protect setAttribute
     *
     * @param currentNode to sanitize
     */
    const _sanitizeAttributes = function _sanitizeAttributes(currentNode) {
      /* Execute a hook if present */
      _executeHooks(hooks.beforeSanitizeAttributes, currentNode, null);
      const {
        attributes
      } = currentNode;
      /* Check if we have attributes; if not we might have a text node */
      if (!attributes || _isClobbered(currentNode)) {
        return;
      }
      const hookEvent = {
        attrName: '',
        attrValue: '',
        keepAttr: true,
        allowedAttributes: ALLOWED_ATTR,
        forceKeepAttr: undefined
      };
      let l = attributes.length;
      /* Go backwards over all attributes; safely remove bad ones */
      while (l--) {
        const attr = attributes[l];
        const {
          name,
          namespaceURI,
          value: attrValue
        } = attr;
        const lcName = transformCaseFunc(name);
        let value = name === 'value' ? attrValue : stringTrim(attrValue);
        /* Execute a hook if present */
        hookEvent.attrName = lcName;
        hookEvent.attrValue = value;
        hookEvent.keepAttr = true;
        hookEvent.forceKeepAttr = undefined; // Allows developers to see this is a property they can set
        _executeHooks(hooks.uponSanitizeAttribute, currentNode, hookEvent);
        value = hookEvent.attrValue;
        /* Full DOM Clobbering protection via namespace isolation,
         * Prefix id and name attributes with `user-content-`
         */
        if (SANITIZE_NAMED_PROPS && (lcName === 'id' || lcName === 'name')) {
          // Remove the attribute with this value
          _removeAttribute(name, currentNode);
          // Prefix the value and later re-create the attribute with the sanitized value
          value = SANITIZE_NAMED_PROPS_PREFIX + value;
        }
        /* Work around a security issue with comments inside attributes */
        if (SAFE_FOR_XML && regExpTest(/((--!?|])>)|<\/(style|title)/i, value)) {
          _removeAttribute(name, currentNode);
          continue;
        }
        /* Did the hooks approve of the attribute? */
        if (hookEvent.forceKeepAttr) {
          continue;
        }
        /* Remove attribute */
        _removeAttribute(name, currentNode);
        /* Did the hooks approve of the attribute? */
        if (!hookEvent.keepAttr) {
          continue;
        }
        /* Work around a security issue in jQuery 3.0 */
        if (!ALLOW_SELF_CLOSE_IN_ATTR && regExpTest(/\/>/i, value)) {
          _removeAttribute(name, currentNode);
          continue;
        }
        /* Sanitize attribute content to be template-safe */
        if (SAFE_FOR_TEMPLATES) {
          arrayForEach([MUSTACHE_EXPR, ERB_EXPR, TMPLIT_EXPR], expr => {
            value = stringReplace(value, expr, ' ');
          });
        }
        /* Is `value` valid for this attribute? */
        const lcTag = transformCaseFunc(currentNode.nodeName);
        if (!_isValidAttribute(lcTag, lcName, value)) {
          continue;
        }
        /* Handle attributes that require Trusted Types */
        if (trustedTypesPolicy && typeof trustedTypes === 'object' && typeof trustedTypes.getAttributeType === 'function') {
          if (namespaceURI) ; else {
            switch (trustedTypes.getAttributeType(lcTag, lcName)) {
              case 'TrustedHTML':
                {
                  value = trustedTypesPolicy.createHTML(value);
                  break;
                }
              case 'TrustedScriptURL':
                {
                  value = trustedTypesPolicy.createScriptURL(value);
                  break;
                }
            }
          }
        }
        /* Handle invalid data-* attribute set by try-catching it */
        try {
          if (namespaceURI) {
            currentNode.setAttributeNS(namespaceURI, name, value);
          } else {
            /* Fallback to setAttribute() for browser-unrecognized namespaces e.g. "x-schema". */
            currentNode.setAttribute(name, value);
          }
          if (_isClobbered(currentNode)) {
            _forceRemove(currentNode);
          } else {
            arrayPop(DOMPurify.removed);
          }
        } catch (_) {}
      }
      /* Execute a hook if present */
      _executeHooks(hooks.afterSanitizeAttributes, currentNode, null);
    };
    /**
     * _sanitizeShadowDOM
     *
     * @param fragment to iterate over recursively
     */
    const _sanitizeShadowDOM = function _sanitizeShadowDOM(fragment) {
      let shadowNode = null;
      const shadowIterator = _createNodeIterator(fragment);
      /* Execute a hook if present */
      _executeHooks(hooks.beforeSanitizeShadowDOM, fragment, null);
      while (shadowNode = shadowIterator.nextNode()) {
        /* Execute a hook if present */
        _executeHooks(hooks.uponSanitizeShadowNode, shadowNode, null);
        /* Sanitize tags and elements */
        _sanitizeElements(shadowNode);
        /* Check attributes next */
        _sanitizeAttributes(shadowNode);
        /* Deep shadow DOM detected */
        if (shadowNode.content instanceof DocumentFragment) {
          _sanitizeShadowDOM(shadowNode.content);
        }
      }
      /* Execute a hook if present */
      _executeHooks(hooks.afterSanitizeShadowDOM, fragment, null);
    };
    // eslint-disable-next-line complexity
    DOMPurify.sanitize = function (dirty) {
      let cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      let body = null;
      let importedNode = null;
      let currentNode = null;
      let returnNode = null;
      /* Make sure we have a string to sanitize.
        DO NOT return early, as this will return the wrong type if
        the user has requested a DOM object rather than a string */
      IS_EMPTY_INPUT = !dirty;
      if (IS_EMPTY_INPUT) {
        dirty = '<!-->';
      }
      /* Stringify, in case dirty is an object */
      if (typeof dirty !== 'string' && !_isNode(dirty)) {
        if (typeof dirty.toString === 'function') {
          dirty = dirty.toString();
          if (typeof dirty !== 'string') {
            throw typeErrorCreate('dirty is not a string, aborting');
          }
        } else {
          throw typeErrorCreate('toString is not a function');
        }
      }
      /* Return dirty HTML if DOMPurify cannot run */
      if (!DOMPurify.isSupported) {
        return dirty;
      }
      /* Assign config vars */
      if (!SET_CONFIG) {
        _parseConfig(cfg);
      }
      /* Clean up removed elements */
      DOMPurify.removed = [];
      /* Check if dirty is correctly typed for IN_PLACE */
      if (typeof dirty === 'string') {
        IN_PLACE = false;
      }
      if (IN_PLACE) {
        /* Do some early pre-sanitization to avoid unsafe root nodes */
        if (dirty.nodeName) {
          const tagName = transformCaseFunc(dirty.nodeName);
          if (!ALLOWED_TAGS[tagName] || FORBID_TAGS[tagName]) {
            throw typeErrorCreate('root node is forbidden and cannot be sanitized in-place');
          }
        }
      } else if (dirty instanceof Node) {
        /* If dirty is a DOM element, append to an empty document to avoid
           elements being stripped by the parser */
        body = _initDocument('<!---->');
        importedNode = body.ownerDocument.importNode(dirty, true);
        if (importedNode.nodeType === NODE_TYPE.element && importedNode.nodeName === 'BODY') {
          /* Node is already a body, use as is */
          body = importedNode;
        } else if (importedNode.nodeName === 'HTML') {
          body = importedNode;
        } else {
          // eslint-disable-next-line unicorn/prefer-dom-node-append
          body.appendChild(importedNode);
        }
      } else {
        /* Exit directly if we have nothing to do */
        if (!RETURN_DOM && !SAFE_FOR_TEMPLATES && !WHOLE_DOCUMENT &&
        // eslint-disable-next-line unicorn/prefer-includes
        dirty.indexOf('<') === -1) {
          return trustedTypesPolicy && RETURN_TRUSTED_TYPE ? trustedTypesPolicy.createHTML(dirty) : dirty;
        }
        /* Initialize the document to work on */
        body = _initDocument(dirty);
        /* Check we have a DOM node from the data */
        if (!body) {
          return RETURN_DOM ? null : RETURN_TRUSTED_TYPE ? emptyHTML : '';
        }
      }
      /* Remove first element node (ours) if FORCE_BODY is set */
      if (body && FORCE_BODY) {
        _forceRemove(body.firstChild);
      }
      /* Get node iterator */
      const nodeIterator = _createNodeIterator(IN_PLACE ? dirty : body);
      /* Now start iterating over the created document */
      while (currentNode = nodeIterator.nextNode()) {
        /* Sanitize tags and elements */
        _sanitizeElements(currentNode);
        /* Check attributes next */
        _sanitizeAttributes(currentNode);
        /* Shadow DOM detected, sanitize it */
        if (currentNode.content instanceof DocumentFragment) {
          _sanitizeShadowDOM(currentNode.content);
        }
      }
      /* If we sanitized `dirty` in-place, return it. */
      if (IN_PLACE) {
        return dirty;
      }
      /* Return sanitized string or DOM */
      if (RETURN_DOM) {
        if (RETURN_DOM_FRAGMENT) {
          returnNode = createDocumentFragment.call(body.ownerDocument);
          while (body.firstChild) {
            // eslint-disable-next-line unicorn/prefer-dom-node-append
            returnNode.appendChild(body.firstChild);
          }
        } else {
          returnNode = body;
        }
        if (ALLOWED_ATTR.shadowroot || ALLOWED_ATTR.shadowrootmode) {
          /*
            AdoptNode() is not used because internal state is not reset
            (e.g. the past names map of a HTMLFormElement), this is safe
            in theory but we would rather not risk another attack vector.
            The state that is cloned by importNode() is explicitly defined
            by the specs.
          */
          returnNode = importNode.call(originalDocument, returnNode, true);
        }
        return returnNode;
      }
      let serializedHTML = WHOLE_DOCUMENT ? body.outerHTML : body.innerHTML;
      /* Serialize doctype if allowed */
      if (WHOLE_DOCUMENT && ALLOWED_TAGS['!doctype'] && body.ownerDocument && body.ownerDocument.doctype && body.ownerDocument.doctype.name && regExpTest(DOCTYPE_NAME, body.ownerDocument.doctype.name)) {
        serializedHTML = '<!DOCTYPE ' + body.ownerDocument.doctype.name + '>\n' + serializedHTML;
      }
      /* Sanitize final string template-safe */
      if (SAFE_FOR_TEMPLATES) {
        arrayForEach([MUSTACHE_EXPR, ERB_EXPR, TMPLIT_EXPR], expr => {
          serializedHTML = stringReplace(serializedHTML, expr, ' ');
        });
      }
      return trustedTypesPolicy && RETURN_TRUSTED_TYPE ? trustedTypesPolicy.createHTML(serializedHTML) : serializedHTML;
    };
    DOMPurify.setConfig = function () {
      let cfg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _parseConfig(cfg);
      SET_CONFIG = true;
    };
    DOMPurify.clearConfig = function () {
      CONFIG = null;
      SET_CONFIG = false;
    };
    DOMPurify.isValidAttribute = function (tag, attr, value) {
      /* Initialize shared config vars if necessary. */
      if (!CONFIG) {
        _parseConfig({});
      }
      const lcTag = transformCaseFunc(tag);
      const lcName = transformCaseFunc(attr);
      return _isValidAttribute(lcTag, lcName, value);
    };
    DOMPurify.addHook = function (entryPoint, hookFunction) {
      if (typeof hookFunction !== 'function') {
        return;
      }
      arrayPush(hooks[entryPoint], hookFunction);
    };
    DOMPurify.removeHook = function (entryPoint, hookFunction) {
      if (hookFunction !== undefined) {
        const index = arrayLastIndexOf(hooks[entryPoint], hookFunction);
        return index === -1 ? undefined : arraySplice(hooks[entryPoint], index, 1)[0];
      }
      return arrayPop(hooks[entryPoint]);
    };
    DOMPurify.removeHooks = function (entryPoint) {
      hooks[entryPoint] = [];
    };
    DOMPurify.removeAllHooks = function () {
      hooks = _createHooksMap();
    };
    return DOMPurify;
  }
  var purify = createDOMPurify();

  return purify;

}));

}(purify));

var browser = window.DOMPurify || (window.DOMPurify = purify.exports.default || purify.exports);

var marked_umd = {exports: {}};

/**
 * marked v4.3.0 - a markdown parser
 * Copyright (c) 2011-2023, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/markedjs/marked
 */

(function (module, exports) {
/**
 * DO NOT EDIT THIS FILE
 * The code in this file is generated from files in ./src/
 */

(function (global, factory) {
  factory(exports) ;
})(commonjsGlobal, (function (exports) {
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
    }
  }
  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }
  function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends.apply(this, arguments);
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
    return arr2;
  }
  function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (it) return (it = it.call(o)).next.bind(it);
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _toPrimitive(input, hint) {
    if (typeof input !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
      var res = prim.call(input, hint || "default");
      if (typeof res !== "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key === "symbol" ? key : String(key);
  }

  function getDefaults() {
    return {
      async: false,
      baseUrl: null,
      breaks: false,
      extensions: null,
      gfm: true,
      headerIds: true,
      headerPrefix: '',
      highlight: null,
      hooks: null,
      langPrefix: 'language-',
      mangle: true,
      pedantic: false,
      renderer: null,
      sanitize: false,
      sanitizer: null,
      silent: false,
      smartypants: false,
      tokenizer: null,
      walkTokens: null,
      xhtml: false
    };
  }
  exports.defaults = getDefaults();
  function changeDefaults(newDefaults) {
    exports.defaults = newDefaults;
  }

  /**
   * Helpers
   */
  var escapeTest = /[&<>"']/;
  var escapeReplace = new RegExp(escapeTest.source, 'g');
  var escapeTestNoEncode = /[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/;
  var escapeReplaceNoEncode = new RegExp(escapeTestNoEncode.source, 'g');
  var escapeReplacements = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#39;'
  };
  var getEscapeReplacement = function getEscapeReplacement(ch) {
    return escapeReplacements[ch];
  };
  function escape(html, encode) {
    if (encode) {
      if (escapeTest.test(html)) {
        return html.replace(escapeReplace, getEscapeReplacement);
      }
    } else {
      if (escapeTestNoEncode.test(html)) {
        return html.replace(escapeReplaceNoEncode, getEscapeReplacement);
      }
    }
    return html;
  }
  var unescapeTest = /&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;

  /**
   * @param {string} html
   */
  function unescape(html) {
    // explicitly match decimal, hex, and named HTML entities
    return html.replace(unescapeTest, function (_, n) {
      n = n.toLowerCase();
      if (n === 'colon') return ':';
      if (n.charAt(0) === '#') {
        return n.charAt(1) === 'x' ? String.fromCharCode(parseInt(n.substring(2), 16)) : String.fromCharCode(+n.substring(1));
      }
      return '';
    });
  }
  var caret = /(^|[^\[])\^/g;

  /**
   * @param {string | RegExp} regex
   * @param {string} opt
   */
  function edit(regex, opt) {
    regex = typeof regex === 'string' ? regex : regex.source;
    opt = opt || '';
    var obj = {
      replace: function replace(name, val) {
        val = val.source || val;
        val = val.replace(caret, '$1');
        regex = regex.replace(name, val);
        return obj;
      },
      getRegex: function getRegex() {
        return new RegExp(regex, opt);
      }
    };
    return obj;
  }
  var nonWordAndColonTest = /[^\w:]/g;
  var originIndependentUrl = /^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;

  /**
   * @param {boolean} sanitize
   * @param {string} base
   * @param {string} href
   */
  function cleanUrl(sanitize, base, href) {
    if (sanitize) {
      var prot;
      try {
        prot = decodeURIComponent(unescape(href)).replace(nonWordAndColonTest, '').toLowerCase();
      } catch (e) {
        return null;
      }
      if (prot.indexOf('javascript:') === 0 || prot.indexOf('vbscript:') === 0 || prot.indexOf('data:') === 0) {
        return null;
      }
    }
    if (base && !originIndependentUrl.test(href)) {
      href = resolveUrl(base, href);
    }
    try {
      href = encodeURI(href).replace(/%25/g, '%');
    } catch (e) {
      return null;
    }
    return href;
  }
  var baseUrls = {};
  var justDomain = /^[^:]+:\/*[^/]*$/;
  var protocol = /^([^:]+:)[\s\S]*$/;
  var domain = /^([^:]+:\/*[^/]*)[\s\S]*$/;

  /**
   * @param {string} base
   * @param {string} href
   */
  function resolveUrl(base, href) {
    if (!baseUrls[' ' + base]) {
      // we can ignore everything in base after the last slash of its path component,
      // but we might need to add _that_
      // https://tools.ietf.org/html/rfc3986#section-3
      if (justDomain.test(base)) {
        baseUrls[' ' + base] = base + '/';
      } else {
        baseUrls[' ' + base] = rtrim(base, '/', true);
      }
    }
    base = baseUrls[' ' + base];
    var relativeBase = base.indexOf(':') === -1;
    if (href.substring(0, 2) === '//') {
      if (relativeBase) {
        return href;
      }
      return base.replace(protocol, '$1') + href;
    } else if (href.charAt(0) === '/') {
      if (relativeBase) {
        return href;
      }
      return base.replace(domain, '$1') + href;
    } else {
      return base + href;
    }
  }
  var noopTest = {
    exec: function noopTest() {}
  };
  function splitCells(tableRow, count) {
    // ensure that every cell-delimiting pipe has a space
    // before it to distinguish it from an escaped pipe
    var row = tableRow.replace(/\|/g, function (match, offset, str) {
        var escaped = false,
          curr = offset;
        while (--curr >= 0 && str[curr] === '\\') {
          escaped = !escaped;
        }
        if (escaped) {
          // odd number of slashes means | is escaped
          // so we leave it alone
          return '|';
        } else {
          // add space before unescaped |
          return ' |';
        }
      }),
      cells = row.split(/ \|/);
    var i = 0;

    // First/last cell in a row cannot be empty if it has no leading/trailing pipe
    if (!cells[0].trim()) {
      cells.shift();
    }
    if (cells.length > 0 && !cells[cells.length - 1].trim()) {
      cells.pop();
    }
    if (cells.length > count) {
      cells.splice(count);
    } else {
      while (cells.length < count) {
        cells.push('');
      }
    }
    for (; i < cells.length; i++) {
      // leading or trailing whitespace is ignored per the gfm spec
      cells[i] = cells[i].trim().replace(/\\\|/g, '|');
    }
    return cells;
  }

  /**
   * Remove trailing 'c's. Equivalent to str.replace(/c*$/, '').
   * /c*$/ is vulnerable to REDOS.
   *
   * @param {string} str
   * @param {string} c
   * @param {boolean} invert Remove suffix of non-c chars instead. Default falsey.
   */
  function rtrim(str, c, invert) {
    var l = str.length;
    if (l === 0) {
      return '';
    }

    // Length of suffix matching the invert condition.
    var suffLen = 0;

    // Step left until we fail to match the invert condition.
    while (suffLen < l) {
      var currChar = str.charAt(l - suffLen - 1);
      if (currChar === c && !invert) {
        suffLen++;
      } else if (currChar !== c && invert) {
        suffLen++;
      } else {
        break;
      }
    }
    return str.slice(0, l - suffLen);
  }
  function findClosingBracket(str, b) {
    if (str.indexOf(b[1]) === -1) {
      return -1;
    }
    var l = str.length;
    var level = 0,
      i = 0;
    for (; i < l; i++) {
      if (str[i] === '\\') {
        i++;
      } else if (str[i] === b[0]) {
        level++;
      } else if (str[i] === b[1]) {
        level--;
        if (level < 0) {
          return i;
        }
      }
    }
    return -1;
  }
  function checkSanitizeDeprecation(opt) {
    if (opt && opt.sanitize && !opt.silent) {
      console.warn('marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options');
    }
  }

  // copied from https://stackoverflow.com/a/5450113/806777
  /**
   * @param {string} pattern
   * @param {number} count
   */
  function repeatString(pattern, count) {
    if (count < 1) {
      return '';
    }
    var result = '';
    while (count > 1) {
      if (count & 1) {
        result += pattern;
      }
      count >>= 1;
      pattern += pattern;
    }
    return result + pattern;
  }

  function outputLink(cap, link, raw, lexer) {
    var href = link.href;
    var title = link.title ? escape(link.title) : null;
    var text = cap[1].replace(/\\([\[\]])/g, '$1');
    if (cap[0].charAt(0) !== '!') {
      lexer.state.inLink = true;
      var token = {
        type: 'link',
        raw: raw,
        href: href,
        title: title,
        text: text,
        tokens: lexer.inlineTokens(text)
      };
      lexer.state.inLink = false;
      return token;
    }
    return {
      type: 'image',
      raw: raw,
      href: href,
      title: title,
      text: escape(text)
    };
  }
  function indentCodeCompensation(raw, text) {
    var matchIndentToCode = raw.match(/^(\s+)(?:```)/);
    if (matchIndentToCode === null) {
      return text;
    }
    var indentToCode = matchIndentToCode[1];
    return text.split('\n').map(function (node) {
      var matchIndentInNode = node.match(/^\s+/);
      if (matchIndentInNode === null) {
        return node;
      }
      var indentInNode = matchIndentInNode[0];
      if (indentInNode.length >= indentToCode.length) {
        return node.slice(indentToCode.length);
      }
      return node;
    }).join('\n');
  }

  /**
   * Tokenizer
   */
  var Tokenizer = /*#__PURE__*/function () {
    function Tokenizer(options) {
      this.options = options || exports.defaults;
    }
    var _proto = Tokenizer.prototype;
    _proto.space = function space(src) {
      var cap = this.rules.block.newline.exec(src);
      if (cap && cap[0].length > 0) {
        return {
          type: 'space',
          raw: cap[0]
        };
      }
    };
    _proto.code = function code(src) {
      var cap = this.rules.block.code.exec(src);
      if (cap) {
        var text = cap[0].replace(/^ {1,4}/gm, '');
        return {
          type: 'code',
          raw: cap[0],
          codeBlockStyle: 'indented',
          text: !this.options.pedantic ? rtrim(text, '\n') : text
        };
      }
    };
    _proto.fences = function fences(src) {
      var cap = this.rules.block.fences.exec(src);
      if (cap) {
        var raw = cap[0];
        var text = indentCodeCompensation(raw, cap[3] || '');
        return {
          type: 'code',
          raw: raw,
          lang: cap[2] ? cap[2].trim().replace(this.rules.inline._escapes, '$1') : cap[2],
          text: text
        };
      }
    };
    _proto.heading = function heading(src) {
      var cap = this.rules.block.heading.exec(src);
      if (cap) {
        var text = cap[2].trim();

        // remove trailing #s
        if (/#$/.test(text)) {
          var trimmed = rtrim(text, '#');
          if (this.options.pedantic) {
            text = trimmed.trim();
          } else if (!trimmed || / $/.test(trimmed)) {
            // CommonMark requires space before trailing #s
            text = trimmed.trim();
          }
        }
        return {
          type: 'heading',
          raw: cap[0],
          depth: cap[1].length,
          text: text,
          tokens: this.lexer.inline(text)
        };
      }
    };
    _proto.hr = function hr(src) {
      var cap = this.rules.block.hr.exec(src);
      if (cap) {
        return {
          type: 'hr',
          raw: cap[0]
        };
      }
    };
    _proto.blockquote = function blockquote(src) {
      var cap = this.rules.block.blockquote.exec(src);
      if (cap) {
        var text = cap[0].replace(/^ *>[ \t]?/gm, '');
        var top = this.lexer.state.top;
        this.lexer.state.top = true;
        var tokens = this.lexer.blockTokens(text);
        this.lexer.state.top = top;
        return {
          type: 'blockquote',
          raw: cap[0],
          tokens: tokens,
          text: text
        };
      }
    };
    _proto.list = function list(src) {
      var cap = this.rules.block.list.exec(src);
      if (cap) {
        var raw, istask, ischecked, indent, i, blankLine, endsWithBlankLine, line, nextLine, rawLine, itemContents, endEarly;
        var bull = cap[1].trim();
        var isordered = bull.length > 1;
        var list = {
          type: 'list',
          raw: '',
          ordered: isordered,
          start: isordered ? +bull.slice(0, -1) : '',
          loose: false,
          items: []
        };
        bull = isordered ? "\\d{1,9}\\" + bull.slice(-1) : "\\" + bull;
        if (this.options.pedantic) {
          bull = isordered ? bull : '[*+-]';
        }

        // Get next list item
        var itemRegex = new RegExp("^( {0,3}" + bull + ")((?:[\t ][^\\n]*)?(?:\\n|$))");

        // Check if current bullet point can start a new List Item
        while (src) {
          endEarly = false;
          if (!(cap = itemRegex.exec(src))) {
            break;
          }
          if (this.rules.block.hr.test(src)) {
            // End list if bullet was actually HR (possibly move into itemRegex?)
            break;
          }
          raw = cap[0];
          src = src.substring(raw.length);
          line = cap[2].split('\n', 1)[0].replace(/^\t+/, function (t) {
            return ' '.repeat(3 * t.length);
          });
          nextLine = src.split('\n', 1)[0];
          if (this.options.pedantic) {
            indent = 2;
            itemContents = line.trimLeft();
          } else {
            indent = cap[2].search(/[^ ]/); // Find first non-space char
            indent = indent > 4 ? 1 : indent; // Treat indented code blocks (> 4 spaces) as having only 1 indent
            itemContents = line.slice(indent);
            indent += cap[1].length;
          }
          blankLine = false;
          if (!line && /^ *$/.test(nextLine)) {
            // Items begin with at most one blank line
            raw += nextLine + '\n';
            src = src.substring(nextLine.length + 1);
            endEarly = true;
          }
          if (!endEarly) {
            var nextBulletRegex = new RegExp("^ {0," + Math.min(3, indent - 1) + "}(?:[*+-]|\\d{1,9}[.)])((?:[ \t][^\\n]*)?(?:\\n|$))");
            var hrRegex = new RegExp("^ {0," + Math.min(3, indent - 1) + "}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");
            var fencesBeginRegex = new RegExp("^ {0," + Math.min(3, indent - 1) + "}(?:```|~~~)");
            var headingBeginRegex = new RegExp("^ {0," + Math.min(3, indent - 1) + "}#");

            // Check if following lines should be included in List Item
            while (src) {
              rawLine = src.split('\n', 1)[0];
              nextLine = rawLine;

              // Re-align to follow commonmark nesting rules
              if (this.options.pedantic) {
                nextLine = nextLine.replace(/^ {1,4}(?=( {4})*[^ ])/g, '  ');
              }

              // End list item if found code fences
              if (fencesBeginRegex.test(nextLine)) {
                break;
              }

              // End list item if found start of new heading
              if (headingBeginRegex.test(nextLine)) {
                break;
              }

              // End list item if found start of new bullet
              if (nextBulletRegex.test(nextLine)) {
                break;
              }

              // Horizontal rule found
              if (hrRegex.test(src)) {
                break;
              }
              if (nextLine.search(/[^ ]/) >= indent || !nextLine.trim()) {
                // Dedent if possible
                itemContents += '\n' + nextLine.slice(indent);
              } else {
                // not enough indentation
                if (blankLine) {
                  break;
                }

                // paragraph continuation unless last line was a different block level element
                if (line.search(/[^ ]/) >= 4) {
                  // indented code block
                  break;
                }
                if (fencesBeginRegex.test(line)) {
                  break;
                }
                if (headingBeginRegex.test(line)) {
                  break;
                }
                if (hrRegex.test(line)) {
                  break;
                }
                itemContents += '\n' + nextLine;
              }
              if (!blankLine && !nextLine.trim()) {
                // Check if current line is blank
                blankLine = true;
              }
              raw += rawLine + '\n';
              src = src.substring(rawLine.length + 1);
              line = nextLine.slice(indent);
            }
          }
          if (!list.loose) {
            // If the previous item ended with a blank line, the list is loose
            if (endsWithBlankLine) {
              list.loose = true;
            } else if (/\n *\n *$/.test(raw)) {
              endsWithBlankLine = true;
            }
          }

          // Check for task list items
          if (this.options.gfm) {
            istask = /^\[[ xX]\] /.exec(itemContents);
            if (istask) {
              ischecked = istask[0] !== '[ ] ';
              itemContents = itemContents.replace(/^\[[ xX]\] +/, '');
            }
          }
          list.items.push({
            type: 'list_item',
            raw: raw,
            task: !!istask,
            checked: ischecked,
            loose: false,
            text: itemContents
          });
          list.raw += raw;
        }

        // Do not consume newlines at end of final item. Alternatively, make itemRegex *start* with any newlines to simplify/speed up endsWithBlankLine logic
        list.items[list.items.length - 1].raw = raw.trimRight();
        list.items[list.items.length - 1].text = itemContents.trimRight();
        list.raw = list.raw.trimRight();
        var l = list.items.length;

        // Item child tokens handled here at end because we needed to have the final item to trim it first
        for (i = 0; i < l; i++) {
          this.lexer.state.top = false;
          list.items[i].tokens = this.lexer.blockTokens(list.items[i].text, []);
          if (!list.loose) {
            // Check if list should be loose
            var spacers = list.items[i].tokens.filter(function (t) {
              return t.type === 'space';
            });
            var hasMultipleLineBreaks = spacers.length > 0 && spacers.some(function (t) {
              return /\n.*\n/.test(t.raw);
            });
            list.loose = hasMultipleLineBreaks;
          }
        }

        // Set all items to loose if list is loose
        if (list.loose) {
          for (i = 0; i < l; i++) {
            list.items[i].loose = true;
          }
        }
        return list;
      }
    };
    _proto.html = function html(src) {
      var cap = this.rules.block.html.exec(src);
      if (cap) {
        var token = {
          type: 'html',
          raw: cap[0],
          pre: !this.options.sanitizer && (cap[1] === 'pre' || cap[1] === 'script' || cap[1] === 'style'),
          text: cap[0]
        };
        if (this.options.sanitize) {
          var text = this.options.sanitizer ? this.options.sanitizer(cap[0]) : escape(cap[0]);
          token.type = 'paragraph';
          token.text = text;
          token.tokens = this.lexer.inline(text);
        }
        return token;
      }
    };
    _proto.def = function def(src) {
      var cap = this.rules.block.def.exec(src);
      if (cap) {
        var tag = cap[1].toLowerCase().replace(/\s+/g, ' ');
        var href = cap[2] ? cap[2].replace(/^<(.*)>$/, '$1').replace(this.rules.inline._escapes, '$1') : '';
        var title = cap[3] ? cap[3].substring(1, cap[3].length - 1).replace(this.rules.inline._escapes, '$1') : cap[3];
        return {
          type: 'def',
          tag: tag,
          raw: cap[0],
          href: href,
          title: title
        };
      }
    };
    _proto.table = function table(src) {
      var cap = this.rules.block.table.exec(src);
      if (cap) {
        var item = {
          type: 'table',
          header: splitCells(cap[1]).map(function (c) {
            return {
              text: c
            };
          }),
          align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
          rows: cap[3] && cap[3].trim() ? cap[3].replace(/\n[ \t]*$/, '').split('\n') : []
        };
        if (item.header.length === item.align.length) {
          item.raw = cap[0];
          var l = item.align.length;
          var i, j, k, row;
          for (i = 0; i < l; i++) {
            if (/^ *-+: *$/.test(item.align[i])) {
              item.align[i] = 'right';
            } else if (/^ *:-+: *$/.test(item.align[i])) {
              item.align[i] = 'center';
            } else if (/^ *:-+ *$/.test(item.align[i])) {
              item.align[i] = 'left';
            } else {
              item.align[i] = null;
            }
          }
          l = item.rows.length;
          for (i = 0; i < l; i++) {
            item.rows[i] = splitCells(item.rows[i], item.header.length).map(function (c) {
              return {
                text: c
              };
            });
          }

          // parse child tokens inside headers and cells

          // header child tokens
          l = item.header.length;
          for (j = 0; j < l; j++) {
            item.header[j].tokens = this.lexer.inline(item.header[j].text);
          }

          // cell child tokens
          l = item.rows.length;
          for (j = 0; j < l; j++) {
            row = item.rows[j];
            for (k = 0; k < row.length; k++) {
              row[k].tokens = this.lexer.inline(row[k].text);
            }
          }
          return item;
        }
      }
    };
    _proto.lheading = function lheading(src) {
      var cap = this.rules.block.lheading.exec(src);
      if (cap) {
        return {
          type: 'heading',
          raw: cap[0],
          depth: cap[2].charAt(0) === '=' ? 1 : 2,
          text: cap[1],
          tokens: this.lexer.inline(cap[1])
        };
      }
    };
    _proto.paragraph = function paragraph(src) {
      var cap = this.rules.block.paragraph.exec(src);
      if (cap) {
        var text = cap[1].charAt(cap[1].length - 1) === '\n' ? cap[1].slice(0, -1) : cap[1];
        return {
          type: 'paragraph',
          raw: cap[0],
          text: text,
          tokens: this.lexer.inline(text)
        };
      }
    };
    _proto.text = function text(src) {
      var cap = this.rules.block.text.exec(src);
      if (cap) {
        return {
          type: 'text',
          raw: cap[0],
          text: cap[0],
          tokens: this.lexer.inline(cap[0])
        };
      }
    };
    _proto.escape = function escape$1(src) {
      var cap = this.rules.inline.escape.exec(src);
      if (cap) {
        return {
          type: 'escape',
          raw: cap[0],
          text: escape(cap[1])
        };
      }
    };
    _proto.tag = function tag(src) {
      var cap = this.rules.inline.tag.exec(src);
      if (cap) {
        if (!this.lexer.state.inLink && /^<a /i.test(cap[0])) {
          this.lexer.state.inLink = true;
        } else if (this.lexer.state.inLink && /^<\/a>/i.test(cap[0])) {
          this.lexer.state.inLink = false;
        }
        if (!this.lexer.state.inRawBlock && /^<(pre|code|kbd|script)(\s|>)/i.test(cap[0])) {
          this.lexer.state.inRawBlock = true;
        } else if (this.lexer.state.inRawBlock && /^<\/(pre|code|kbd|script)(\s|>)/i.test(cap[0])) {
          this.lexer.state.inRawBlock = false;
        }
        return {
          type: this.options.sanitize ? 'text' : 'html',
          raw: cap[0],
          inLink: this.lexer.state.inLink,
          inRawBlock: this.lexer.state.inRawBlock,
          text: this.options.sanitize ? this.options.sanitizer ? this.options.sanitizer(cap[0]) : escape(cap[0]) : cap[0]
        };
      }
    };
    _proto.link = function link(src) {
      var cap = this.rules.inline.link.exec(src);
      if (cap) {
        var trimmedUrl = cap[2].trim();
        if (!this.options.pedantic && /^</.test(trimmedUrl)) {
          // commonmark requires matching angle brackets
          if (!/>$/.test(trimmedUrl)) {
            return;
          }

          // ending angle bracket cannot be escaped
          var rtrimSlash = rtrim(trimmedUrl.slice(0, -1), '\\');
          if ((trimmedUrl.length - rtrimSlash.length) % 2 === 0) {
            return;
          }
        } else {
          // find closing parenthesis
          var lastParenIndex = findClosingBracket(cap[2], '()');
          if (lastParenIndex > -1) {
            var start = cap[0].indexOf('!') === 0 ? 5 : 4;
            var linkLen = start + cap[1].length + lastParenIndex;
            cap[2] = cap[2].substring(0, lastParenIndex);
            cap[0] = cap[0].substring(0, linkLen).trim();
            cap[3] = '';
          }
        }
        var href = cap[2];
        var title = '';
        if (this.options.pedantic) {
          // split pedantic href and title
          var link = /^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(href);
          if (link) {
            href = link[1];
            title = link[3];
          }
        } else {
          title = cap[3] ? cap[3].slice(1, -1) : '';
        }
        href = href.trim();
        if (/^</.test(href)) {
          if (this.options.pedantic && !/>$/.test(trimmedUrl)) {
            // pedantic allows starting angle bracket without ending angle bracket
            href = href.slice(1);
          } else {
            href = href.slice(1, -1);
          }
        }
        return outputLink(cap, {
          href: href ? href.replace(this.rules.inline._escapes, '$1') : href,
          title: title ? title.replace(this.rules.inline._escapes, '$1') : title
        }, cap[0], this.lexer);
      }
    };
    _proto.reflink = function reflink(src, links) {
      var cap;
      if ((cap = this.rules.inline.reflink.exec(src)) || (cap = this.rules.inline.nolink.exec(src))) {
        var link = (cap[2] || cap[1]).replace(/\s+/g, ' ');
        link = links[link.toLowerCase()];
        if (!link) {
          var text = cap[0].charAt(0);
          return {
            type: 'text',
            raw: text,
            text: text
          };
        }
        return outputLink(cap, link, cap[0], this.lexer);
      }
    };
    _proto.emStrong = function emStrong(src, maskedSrc, prevChar) {
      if (prevChar === void 0) {
        prevChar = '';
      }
      var match = this.rules.inline.emStrong.lDelim.exec(src);
      if (!match) return;

      // _ can't be between two alphanumerics. \p{L}\p{N} includes non-english alphabet/numbers as well
      if (match[3] && prevChar.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/)) return;
      var nextChar = match[1] || match[2] || '';
      if (!nextChar || nextChar && (prevChar === '' || this.rules.inline.punctuation.exec(prevChar))) {
        var lLength = match[0].length - 1;
        var rDelim,
          rLength,
          delimTotal = lLength,
          midDelimTotal = 0;
        var endReg = match[0][0] === '*' ? this.rules.inline.emStrong.rDelimAst : this.rules.inline.emStrong.rDelimUnd;
        endReg.lastIndex = 0;

        // Clip maskedSrc to same section of string as src (move to lexer?)
        maskedSrc = maskedSrc.slice(-1 * src.length + lLength);
        while ((match = endReg.exec(maskedSrc)) != null) {
          rDelim = match[1] || match[2] || match[3] || match[4] || match[5] || match[6];
          if (!rDelim) continue; // skip single * in __abc*abc__

          rLength = rDelim.length;
          if (match[3] || match[4]) {
            // found another Left Delim
            delimTotal += rLength;
            continue;
          } else if (match[5] || match[6]) {
            // either Left or Right Delim
            if (lLength % 3 && !((lLength + rLength) % 3)) {
              midDelimTotal += rLength;
              continue; // CommonMark Emphasis Rules 9-10
            }
          }

          delimTotal -= rLength;
          if (delimTotal > 0) continue; // Haven't found enough closing delimiters

          // Remove extra characters. *a*** -> *a*
          rLength = Math.min(rLength, rLength + delimTotal + midDelimTotal);
          var raw = src.slice(0, lLength + match.index + (match[0].length - rDelim.length) + rLength);

          // Create `em` if smallest delimiter has odd char count. *a***
          if (Math.min(lLength, rLength) % 2) {
            var _text = raw.slice(1, -1);
            return {
              type: 'em',
              raw: raw,
              text: _text,
              tokens: this.lexer.inlineTokens(_text)
            };
          }

          // Create 'strong' if smallest delimiter has even char count. **a***
          var text = raw.slice(2, -2);
          return {
            type: 'strong',
            raw: raw,
            text: text,
            tokens: this.lexer.inlineTokens(text)
          };
        }
      }
    };
    _proto.codespan = function codespan(src) {
      var cap = this.rules.inline.code.exec(src);
      if (cap) {
        var text = cap[2].replace(/\n/g, ' ');
        var hasNonSpaceChars = /[^ ]/.test(text);
        var hasSpaceCharsOnBothEnds = /^ /.test(text) && / $/.test(text);
        if (hasNonSpaceChars && hasSpaceCharsOnBothEnds) {
          text = text.substring(1, text.length - 1);
        }
        text = escape(text, true);
        return {
          type: 'codespan',
          raw: cap[0],
          text: text
        };
      }
    };
    _proto.br = function br(src) {
      var cap = this.rules.inline.br.exec(src);
      if (cap) {
        return {
          type: 'br',
          raw: cap[0]
        };
      }
    };
    _proto.del = function del(src) {
      var cap = this.rules.inline.del.exec(src);
      if (cap) {
        return {
          type: 'del',
          raw: cap[0],
          text: cap[2],
          tokens: this.lexer.inlineTokens(cap[2])
        };
      }
    };
    _proto.autolink = function autolink(src, mangle) {
      var cap = this.rules.inline.autolink.exec(src);
      if (cap) {
        var text, href;
        if (cap[2] === '@') {
          text = escape(this.options.mangle ? mangle(cap[1]) : cap[1]);
          href = 'mailto:' + text;
        } else {
          text = escape(cap[1]);
          href = text;
        }
        return {
          type: 'link',
          raw: cap[0],
          text: text,
          href: href,
          tokens: [{
            type: 'text',
            raw: text,
            text: text
          }]
        };
      }
    };
    _proto.url = function url(src, mangle) {
      var cap;
      if (cap = this.rules.inline.url.exec(src)) {
        var text, href;
        if (cap[2] === '@') {
          text = escape(this.options.mangle ? mangle(cap[0]) : cap[0]);
          href = 'mailto:' + text;
        } else {
          // do extended autolink path validation
          var prevCapZero;
          do {
            prevCapZero = cap[0];
            cap[0] = this.rules.inline._backpedal.exec(cap[0])[0];
          } while (prevCapZero !== cap[0]);
          text = escape(cap[0]);
          if (cap[1] === 'www.') {
            href = 'http://' + cap[0];
          } else {
            href = cap[0];
          }
        }
        return {
          type: 'link',
          raw: cap[0],
          text: text,
          href: href,
          tokens: [{
            type: 'text',
            raw: text,
            text: text
          }]
        };
      }
    };
    _proto.inlineText = function inlineText(src, smartypants) {
      var cap = this.rules.inline.text.exec(src);
      if (cap) {
        var text;
        if (this.lexer.state.inRawBlock) {
          text = this.options.sanitize ? this.options.sanitizer ? this.options.sanitizer(cap[0]) : escape(cap[0]) : cap[0];
        } else {
          text = escape(this.options.smartypants ? smartypants(cap[0]) : cap[0]);
        }
        return {
          type: 'text',
          raw: cap[0],
          text: text
        };
      }
    };
    return Tokenizer;
  }();

  /**
   * Block-Level Grammar
   */
  var block = {
    newline: /^(?: *(?:\n|$))+/,
    code: /^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,
    fences: /^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,
    hr: /^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,
    heading: /^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,
    blockquote: /^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,
    list: /^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,
    html: '^ {0,3}(?:' // optional indentation
    + '<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)' // (1)
    + '|comment[^\\n]*(\\n+|$)' // (2)
    + '|<\\?[\\s\\S]*?(?:\\?>\\n*|$)' // (3)
    + '|<![A-Z][\\s\\S]*?(?:>\\n*|$)' // (4)
    + '|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)' // (5)
    + '|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)' // (6)
    + '|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)' // (7) open tag
    + '|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)' // (7) closing tag
    + ')',
    def: /^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,
    table: noopTest,
    lheading: /^((?:.|\n(?!\n))+?)\n {0,3}(=+|-+) *(?:\n+|$)/,
    // regex template, placeholders will be replaced according to different paragraph
    // interruption rules of commonmark and the original markdown spec:
    _paragraph: /^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,
    text: /^[^\n]+/
  };
  block._label = /(?!\s*\])(?:\\.|[^\[\]\\])+/;
  block._title = /(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/;
  block.def = edit(block.def).replace('label', block._label).replace('title', block._title).getRegex();
  block.bullet = /(?:[*+-]|\d{1,9}[.)])/;
  block.listItemStart = edit(/^( *)(bull) */).replace('bull', block.bullet).getRegex();
  block.list = edit(block.list).replace(/bull/g, block.bullet).replace('hr', '\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))').replace('def', '\\n+(?=' + block.def.source + ')').getRegex();
  block._tag = 'address|article|aside|base|basefont|blockquote|body|caption' + '|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption' + '|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe' + '|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option' + '|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr' + '|track|ul';
  block._comment = /<!--(?!-?>)[\s\S]*?(?:-->|$)/;
  block.html = edit(block.html, 'i').replace('comment', block._comment).replace('tag', block._tag).replace('attribute', / +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex();
  block.paragraph = edit(block._paragraph).replace('hr', block.hr).replace('heading', ' {0,3}#{1,6} ').replace('|lheading', '') // setex headings don't interrupt commonmark paragraphs
  .replace('|table', '').replace('blockquote', ' {0,3}>').replace('fences', ' {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n').replace('list', ' {0,3}(?:[*+-]|1[.)]) ') // only lists starting from 1 can interrupt
  .replace('html', '</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)').replace('tag', block._tag) // pars can be interrupted by type (6) html blocks
  .getRegex();
  block.blockquote = edit(block.blockquote).replace('paragraph', block.paragraph).getRegex();

  /**
   * Normal Block Grammar
   */

  block.normal = _extends({}, block);

  /**
   * GFM Block Grammar
   */

  block.gfm = _extends({}, block.normal, {
    table: '^ *([^\\n ].*\\|.*)\\n' // Header
    + ' {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?' // Align
    + '(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)' // Cells
  });

  block.gfm.table = edit(block.gfm.table).replace('hr', block.hr).replace('heading', ' {0,3}#{1,6} ').replace('blockquote', ' {0,3}>').replace('code', ' {4}[^\\n]').replace('fences', ' {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n').replace('list', ' {0,3}(?:[*+-]|1[.)]) ') // only lists starting from 1 can interrupt
  .replace('html', '</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)').replace('tag', block._tag) // tables can be interrupted by type (6) html blocks
  .getRegex();
  block.gfm.paragraph = edit(block._paragraph).replace('hr', block.hr).replace('heading', ' {0,3}#{1,6} ').replace('|lheading', '') // setex headings don't interrupt commonmark paragraphs
  .replace('table', block.gfm.table) // interrupt paragraphs with table
  .replace('blockquote', ' {0,3}>').replace('fences', ' {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n').replace('list', ' {0,3}(?:[*+-]|1[.)]) ') // only lists starting from 1 can interrupt
  .replace('html', '</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)').replace('tag', block._tag) // pars can be interrupted by type (6) html blocks
  .getRegex();
  /**
   * Pedantic grammar (original John Gruber's loose markdown specification)
   */

  block.pedantic = _extends({}, block.normal, {
    html: edit('^ *(?:comment *(?:\\n|\\s*$)' + '|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)' // closed tag
    + '|<tag(?:"[^"]*"|\'[^\']*\'|\\s[^\'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))').replace('comment', block._comment).replace(/tag/g, '(?!(?:' + 'a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub' + '|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)' + '\\b)\\w+(?!:|[^\\w\\s@]*@)\\b').getRegex(),
    def: /^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,
    heading: /^(#{1,6})(.*)(?:\n+|$)/,
    fences: noopTest,
    // fences not supported
    lheading: /^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,
    paragraph: edit(block.normal._paragraph).replace('hr', block.hr).replace('heading', ' *#{1,6} *[^\n]').replace('lheading', block.lheading).replace('blockquote', ' {0,3}>').replace('|fences', '').replace('|list', '').replace('|html', '').getRegex()
  });

  /**
   * Inline-Level Grammar
   */
  var inline = {
    escape: /^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,
    autolink: /^<(scheme:[^\s\x00-\x1f<>]*|email)>/,
    url: noopTest,
    tag: '^comment' + '|^</[a-zA-Z][\\w:-]*\\s*>' // self-closing tag
    + '|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>' // open tag
    + '|^<\\?[\\s\\S]*?\\?>' // processing instruction, e.g. <?php ?>
    + '|^<![a-zA-Z]+\\s[\\s\\S]*?>' // declaration, e.g. <!DOCTYPE html>
    + '|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>',
    // CDATA section
    link: /^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,
    reflink: /^!?\[(label)\]\[(ref)\]/,
    nolink: /^!?\[(ref)\](?:\[\])?/,
    reflinkSearch: 'reflink|nolink(?!\\()',
    emStrong: {
      lDelim: /^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,
      //        (1) and (2) can only be a Right Delimiter. (3) and (4) can only be Left.  (5) and (6) can be either Left or Right.
      //          () Skip orphan inside strong                                      () Consume to delim     (1) #***                (2) a***#, a***                             (3) #***a, ***a                 (4) ***#              (5) #***#                 (6) a***a
      rDelimAst: /^(?:[^_*\\]|\\.)*?\_\_(?:[^_*\\]|\\.)*?\*(?:[^_*\\]|\\.)*?(?=\_\_)|(?:[^*\\]|\\.)+(?=[^*])|[punct_](\*+)(?=[\s]|$)|(?:[^punct*_\s\\]|\\.)(\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|(?:[^punct*_\s\\]|\\.)(\*+)(?=[^punct*_\s])/,
      rDelimUnd: /^(?:[^_*\\]|\\.)*?\*\*(?:[^_*\\]|\\.)*?\_(?:[^_*\\]|\\.)*?(?=\*\*)|(?:[^_\\]|\\.)+(?=[^_])|[punct*](\_+)(?=[\s]|$)|(?:[^punct*_\s\\]|\\.)(\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/ // ^- Not allowed for _
    },

    code: /^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,
    br: /^( {2,}|\\)\n(?!\s*$)/,
    del: noopTest,
    text: /^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,
    punctuation: /^([\spunctuation])/
  };

  // list of punctuation marks from CommonMark spec
  // without * and _ to handle the different emphasis markers * and _
  inline._punctuation = '!"#$%&\'()+\\-.,/:;<=>?@\\[\\]`^{|}~';
  inline.punctuation = edit(inline.punctuation).replace(/punctuation/g, inline._punctuation).getRegex();

  // sequences em should skip over [title](link), `code`, <html>
  inline.blockSkip = /\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g;
  // lookbehind is not available on Safari as of version 16
  // inline.escapedEmSt = /(?<=(?:^|[^\\)(?:\\[^])*)\\[*_]/g;
  inline.escapedEmSt = /(?:^|[^\\])(?:\\\\)*\\[*_]/g;
  inline._comment = edit(block._comment).replace('(?:-->|$)', '-->').getRegex();
  inline.emStrong.lDelim = edit(inline.emStrong.lDelim).replace(/punct/g, inline._punctuation).getRegex();
  inline.emStrong.rDelimAst = edit(inline.emStrong.rDelimAst, 'g').replace(/punct/g, inline._punctuation).getRegex();
  inline.emStrong.rDelimUnd = edit(inline.emStrong.rDelimUnd, 'g').replace(/punct/g, inline._punctuation).getRegex();
  inline._escapes = /\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g;
  inline._scheme = /[a-zA-Z][a-zA-Z0-9+.-]{1,31}/;
  inline._email = /[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/;
  inline.autolink = edit(inline.autolink).replace('scheme', inline._scheme).replace('email', inline._email).getRegex();
  inline._attribute = /\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/;
  inline.tag = edit(inline.tag).replace('comment', inline._comment).replace('attribute', inline._attribute).getRegex();
  inline._label = /(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/;
  inline._href = /<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/;
  inline._title = /"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/;
  inline.link = edit(inline.link).replace('label', inline._label).replace('href', inline._href).replace('title', inline._title).getRegex();
  inline.reflink = edit(inline.reflink).replace('label', inline._label).replace('ref', block._label).getRegex();
  inline.nolink = edit(inline.nolink).replace('ref', block._label).getRegex();
  inline.reflinkSearch = edit(inline.reflinkSearch, 'g').replace('reflink', inline.reflink).replace('nolink', inline.nolink).getRegex();

  /**
   * Normal Inline Grammar
   */

  inline.normal = _extends({}, inline);

  /**
   * Pedantic Inline Grammar
   */

  inline.pedantic = _extends({}, inline.normal, {
    strong: {
      start: /^__|\*\*/,
      middle: /^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,
      endAst: /\*\*(?!\*)/g,
      endUnd: /__(?!_)/g
    },
    em: {
      start: /^_|\*/,
      middle: /^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,
      endAst: /\*(?!\*)/g,
      endUnd: /_(?!_)/g
    },
    link: edit(/^!?\[(label)\]\((.*?)\)/).replace('label', inline._label).getRegex(),
    reflink: edit(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace('label', inline._label).getRegex()
  });

  /**
   * GFM Inline Grammar
   */

  inline.gfm = _extends({}, inline.normal, {
    escape: edit(inline.escape).replace('])', '~|])').getRegex(),
    _extended_email: /[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,
    url: /^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,
    _backpedal: /(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,
    del: /^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,
    text: /^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/
  });
  inline.gfm.url = edit(inline.gfm.url, 'i').replace('email', inline.gfm._extended_email).getRegex();
  /**
   * GFM + Line Breaks Inline Grammar
   */

  inline.breaks = _extends({}, inline.gfm, {
    br: edit(inline.br).replace('{2,}', '*').getRegex(),
    text: edit(inline.gfm.text).replace('\\b_', '\\b_| {2,}\\n').replace(/\{2,\}/g, '*').getRegex()
  });

  /**
   * smartypants text replacement
   * @param {string} text
   */
  function smartypants(text) {
    return text
    // em-dashes
    .replace(/---/g, "\u2014")
    // en-dashes
    .replace(/--/g, "\u2013")
    // opening singles
    .replace(/(^|[-\u2014/(\[{"\s])'/g, "$1\u2018")
    // closing singles & apostrophes
    .replace(/'/g, "\u2019")
    // opening doubles
    .replace(/(^|[-\u2014/(\[{\u2018\s])"/g, "$1\u201C")
    // closing doubles
    .replace(/"/g, "\u201D")
    // ellipses
    .replace(/\.{3}/g, "\u2026");
  }

  /**
   * mangle email addresses
   * @param {string} text
   */
  function mangle(text) {
    var out = '',
      i,
      ch;
    var l = text.length;
    for (i = 0; i < l; i++) {
      ch = text.charCodeAt(i);
      if (Math.random() > 0.5) {
        ch = 'x' + ch.toString(16);
      }
      out += '&#' + ch + ';';
    }
    return out;
  }

  /**
   * Block Lexer
   */
  var Lexer = /*#__PURE__*/function () {
    function Lexer(options) {
      this.tokens = [];
      this.tokens.links = Object.create(null);
      this.options = options || exports.defaults;
      this.options.tokenizer = this.options.tokenizer || new Tokenizer();
      this.tokenizer = this.options.tokenizer;
      this.tokenizer.options = this.options;
      this.tokenizer.lexer = this;
      this.inlineQueue = [];
      this.state = {
        inLink: false,
        inRawBlock: false,
        top: true
      };
      var rules = {
        block: block.normal,
        inline: inline.normal
      };
      if (this.options.pedantic) {
        rules.block = block.pedantic;
        rules.inline = inline.pedantic;
      } else if (this.options.gfm) {
        rules.block = block.gfm;
        if (this.options.breaks) {
          rules.inline = inline.breaks;
        } else {
          rules.inline = inline.gfm;
        }
      }
      this.tokenizer.rules = rules;
    }

    /**
     * Expose Rules
     */
    /**
     * Static Lex Method
     */
    Lexer.lex = function lex(src, options) {
      var lexer = new Lexer(options);
      return lexer.lex(src);
    }

    /**
     * Static Lex Inline Method
     */;
    Lexer.lexInline = function lexInline(src, options) {
      var lexer = new Lexer(options);
      return lexer.inlineTokens(src);
    }

    /**
     * Preprocessing
     */;
    var _proto = Lexer.prototype;
    _proto.lex = function lex(src) {
      src = src.replace(/\r\n|\r/g, '\n');
      this.blockTokens(src, this.tokens);
      var next;
      while (next = this.inlineQueue.shift()) {
        this.inlineTokens(next.src, next.tokens);
      }
      return this.tokens;
    }

    /**
     * Lexing
     */;
    _proto.blockTokens = function blockTokens(src, tokens) {
      var _this = this;
      if (tokens === void 0) {
        tokens = [];
      }
      if (this.options.pedantic) {
        src = src.replace(/\t/g, '    ').replace(/^ +$/gm, '');
      } else {
        src = src.replace(/^( *)(\t+)/gm, function (_, leading, tabs) {
          return leading + '    '.repeat(tabs.length);
        });
      }
      var token, lastToken, cutSrc, lastParagraphClipped;
      while (src) {
        if (this.options.extensions && this.options.extensions.block && this.options.extensions.block.some(function (extTokenizer) {
          if (token = extTokenizer.call({
            lexer: _this
          }, src, tokens)) {
            src = src.substring(token.raw.length);
            tokens.push(token);
            return true;
          }
          return false;
        })) {
          continue;
        }

        // newline
        if (token = this.tokenizer.space(src)) {
          src = src.substring(token.raw.length);
          if (token.raw.length === 1 && tokens.length > 0) {
            // if there's a single \n as a spacer, it's terminating the last line,
            // so move it there so that we don't get unecessary paragraph tags
            tokens[tokens.length - 1].raw += '\n';
          } else {
            tokens.push(token);
          }
          continue;
        }

        // code
        if (token = this.tokenizer.code(src)) {
          src = src.substring(token.raw.length);
          lastToken = tokens[tokens.length - 1];
          // An indented code block cannot interrupt a paragraph.
          if (lastToken && (lastToken.type === 'paragraph' || lastToken.type === 'text')) {
            lastToken.raw += '\n' + token.raw;
            lastToken.text += '\n' + token.text;
            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
          } else {
            tokens.push(token);
          }
          continue;
        }

        // fences
        if (token = this.tokenizer.fences(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // heading
        if (token = this.tokenizer.heading(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // hr
        if (token = this.tokenizer.hr(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // blockquote
        if (token = this.tokenizer.blockquote(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // list
        if (token = this.tokenizer.list(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // html
        if (token = this.tokenizer.html(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // def
        if (token = this.tokenizer.def(src)) {
          src = src.substring(token.raw.length);
          lastToken = tokens[tokens.length - 1];
          if (lastToken && (lastToken.type === 'paragraph' || lastToken.type === 'text')) {
            lastToken.raw += '\n' + token.raw;
            lastToken.text += '\n' + token.raw;
            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
          } else if (!this.tokens.links[token.tag]) {
            this.tokens.links[token.tag] = {
              href: token.href,
              title: token.title
            };
          }
          continue;
        }

        // table (gfm)
        if (token = this.tokenizer.table(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // lheading
        if (token = this.tokenizer.lheading(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // top-level paragraph
        // prevent paragraph consuming extensions by clipping 'src' to extension start
        cutSrc = src;
        if (this.options.extensions && this.options.extensions.startBlock) {
          (function () {
            var startIndex = Infinity;
            var tempSrc = src.slice(1);
            var tempStart = void 0;
            _this.options.extensions.startBlock.forEach(function (getStartIndex) {
              tempStart = getStartIndex.call({
                lexer: this
              }, tempSrc);
              if (typeof tempStart === 'number' && tempStart >= 0) {
                startIndex = Math.min(startIndex, tempStart);
              }
            });
            if (startIndex < Infinity && startIndex >= 0) {
              cutSrc = src.substring(0, startIndex + 1);
            }
          })();
        }
        if (this.state.top && (token = this.tokenizer.paragraph(cutSrc))) {
          lastToken = tokens[tokens.length - 1];
          if (lastParagraphClipped && lastToken.type === 'paragraph') {
            lastToken.raw += '\n' + token.raw;
            lastToken.text += '\n' + token.text;
            this.inlineQueue.pop();
            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
          } else {
            tokens.push(token);
          }
          lastParagraphClipped = cutSrc.length !== src.length;
          src = src.substring(token.raw.length);
          continue;
        }

        // text
        if (token = this.tokenizer.text(src)) {
          src = src.substring(token.raw.length);
          lastToken = tokens[tokens.length - 1];
          if (lastToken && lastToken.type === 'text') {
            lastToken.raw += '\n' + token.raw;
            lastToken.text += '\n' + token.text;
            this.inlineQueue.pop();
            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
          } else {
            tokens.push(token);
          }
          continue;
        }
        if (src) {
          var errMsg = 'Infinite loop on byte: ' + src.charCodeAt(0);
          if (this.options.silent) {
            console.error(errMsg);
            break;
          } else {
            throw new Error(errMsg);
          }
        }
      }
      this.state.top = true;
      return tokens;
    };
    _proto.inline = function inline(src, tokens) {
      if (tokens === void 0) {
        tokens = [];
      }
      this.inlineQueue.push({
        src: src,
        tokens: tokens
      });
      return tokens;
    }

    /**
     * Lexing/Compiling
     */;
    _proto.inlineTokens = function inlineTokens(src, tokens) {
      var _this2 = this;
      if (tokens === void 0) {
        tokens = [];
      }
      var token, lastToken, cutSrc;

      // String with links masked to avoid interference with em and strong
      var maskedSrc = src;
      var match;
      var keepPrevChar, prevChar;

      // Mask out reflinks
      if (this.tokens.links) {
        var links = Object.keys(this.tokens.links);
        if (links.length > 0) {
          while ((match = this.tokenizer.rules.inline.reflinkSearch.exec(maskedSrc)) != null) {
            if (links.includes(match[0].slice(match[0].lastIndexOf('[') + 1, -1))) {
              maskedSrc = maskedSrc.slice(0, match.index) + '[' + repeatString('a', match[0].length - 2) + ']' + maskedSrc.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex);
            }
          }
        }
      }
      // Mask out other blocks
      while ((match = this.tokenizer.rules.inline.blockSkip.exec(maskedSrc)) != null) {
        maskedSrc = maskedSrc.slice(0, match.index) + '[' + repeatString('a', match[0].length - 2) + ']' + maskedSrc.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);
      }

      // Mask out escaped em & strong delimiters
      while ((match = this.tokenizer.rules.inline.escapedEmSt.exec(maskedSrc)) != null) {
        maskedSrc = maskedSrc.slice(0, match.index + match[0].length - 2) + '++' + maskedSrc.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);
        this.tokenizer.rules.inline.escapedEmSt.lastIndex--;
      }
      while (src) {
        if (!keepPrevChar) {
          prevChar = '';
        }
        keepPrevChar = false;

        // extensions
        if (this.options.extensions && this.options.extensions.inline && this.options.extensions.inline.some(function (extTokenizer) {
          if (token = extTokenizer.call({
            lexer: _this2
          }, src, tokens)) {
            src = src.substring(token.raw.length);
            tokens.push(token);
            return true;
          }
          return false;
        })) {
          continue;
        }

        // escape
        if (token = this.tokenizer.escape(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // tag
        if (token = this.tokenizer.tag(src)) {
          src = src.substring(token.raw.length);
          lastToken = tokens[tokens.length - 1];
          if (lastToken && token.type === 'text' && lastToken.type === 'text') {
            lastToken.raw += token.raw;
            lastToken.text += token.text;
          } else {
            tokens.push(token);
          }
          continue;
        }

        // link
        if (token = this.tokenizer.link(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // reflink, nolink
        if (token = this.tokenizer.reflink(src, this.tokens.links)) {
          src = src.substring(token.raw.length);
          lastToken = tokens[tokens.length - 1];
          if (lastToken && token.type === 'text' && lastToken.type === 'text') {
            lastToken.raw += token.raw;
            lastToken.text += token.text;
          } else {
            tokens.push(token);
          }
          continue;
        }

        // em & strong
        if (token = this.tokenizer.emStrong(src, maskedSrc, prevChar)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // code
        if (token = this.tokenizer.codespan(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // br
        if (token = this.tokenizer.br(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // del (gfm)
        if (token = this.tokenizer.del(src)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // autolink
        if (token = this.tokenizer.autolink(src, mangle)) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // url (gfm)
        if (!this.state.inLink && (token = this.tokenizer.url(src, mangle))) {
          src = src.substring(token.raw.length);
          tokens.push(token);
          continue;
        }

        // text
        // prevent inlineText consuming extensions by clipping 'src' to extension start
        cutSrc = src;
        if (this.options.extensions && this.options.extensions.startInline) {
          (function () {
            var startIndex = Infinity;
            var tempSrc = src.slice(1);
            var tempStart = void 0;
            _this2.options.extensions.startInline.forEach(function (getStartIndex) {
              tempStart = getStartIndex.call({
                lexer: this
              }, tempSrc);
              if (typeof tempStart === 'number' && tempStart >= 0) {
                startIndex = Math.min(startIndex, tempStart);
              }
            });
            if (startIndex < Infinity && startIndex >= 0) {
              cutSrc = src.substring(0, startIndex + 1);
            }
          })();
        }
        if (token = this.tokenizer.inlineText(cutSrc, smartypants)) {
          src = src.substring(token.raw.length);
          if (token.raw.slice(-1) !== '_') {
            // Track prevChar before string of ____ started
            prevChar = token.raw.slice(-1);
          }
          keepPrevChar = true;
          lastToken = tokens[tokens.length - 1];
          if (lastToken && lastToken.type === 'text') {
            lastToken.raw += token.raw;
            lastToken.text += token.text;
          } else {
            tokens.push(token);
          }
          continue;
        }
        if (src) {
          var errMsg = 'Infinite loop on byte: ' + src.charCodeAt(0);
          if (this.options.silent) {
            console.error(errMsg);
            break;
          } else {
            throw new Error(errMsg);
          }
        }
      }
      return tokens;
    };
    _createClass(Lexer, null, [{
      key: "rules",
      get: function get() {
        return {
          block: block,
          inline: inline
        };
      }
    }]);
    return Lexer;
  }();

  /**
   * Renderer
   */
  var Renderer = /*#__PURE__*/function () {
    function Renderer(options) {
      this.options = options || exports.defaults;
    }
    var _proto = Renderer.prototype;
    _proto.code = function code(_code, infostring, escaped) {
      var lang = (infostring || '').match(/\S*/)[0];
      if (this.options.highlight) {
        var out = this.options.highlight(_code, lang);
        if (out != null && out !== _code) {
          escaped = true;
          _code = out;
        }
      }
      _code = _code.replace(/\n$/, '') + '\n';
      if (!lang) {
        return '<pre><code>' + (escaped ? _code : escape(_code, true)) + '</code></pre>\n';
      }
      return '<pre><code class="' + this.options.langPrefix + escape(lang) + '">' + (escaped ? _code : escape(_code, true)) + '</code></pre>\n';
    }

    /**
     * @param {string} quote
     */;
    _proto.blockquote = function blockquote(quote) {
      return "<blockquote>\n" + quote + "</blockquote>\n";
    };
    _proto.html = function html(_html) {
      return _html;
    }

    /**
     * @param {string} text
     * @param {string} level
     * @param {string} raw
     * @param {any} slugger
     */;
    _proto.heading = function heading(text, level, raw, slugger) {
      if (this.options.headerIds) {
        var id = this.options.headerPrefix + slugger.slug(raw);
        return "<h" + level + " id=\"" + id + "\">" + text + "</h" + level + ">\n";
      }

      // ignore IDs
      return "<h" + level + ">" + text + "</h" + level + ">\n";
    };
    _proto.hr = function hr() {
      return this.options.xhtml ? '<hr/>\n' : '<hr>\n';
    };
    _proto.list = function list(body, ordered, start) {
      var type = ordered ? 'ol' : 'ul',
        startatt = ordered && start !== 1 ? ' start="' + start + '"' : '';
      return '<' + type + startatt + '>\n' + body + '</' + type + '>\n';
    }

    /**
     * @param {string} text
     */;
    _proto.listitem = function listitem(text) {
      return "<li>" + text + "</li>\n";
    };
    _proto.checkbox = function checkbox(checked) {
      return '<input ' + (checked ? 'checked="" ' : '') + 'disabled="" type="checkbox"' + (this.options.xhtml ? ' /' : '') + '> ';
    }

    /**
     * @param {string} text
     */;
    _proto.paragraph = function paragraph(text) {
      return "<p>" + text + "</p>\n";
    }

    /**
     * @param {string} header
     * @param {string} body
     */;
    _proto.table = function table(header, body) {
      if (body) body = "<tbody>" + body + "</tbody>";
      return '<table>\n' + '<thead>\n' + header + '</thead>\n' + body + '</table>\n';
    }

    /**
     * @param {string} content
     */;
    _proto.tablerow = function tablerow(content) {
      return "<tr>\n" + content + "</tr>\n";
    };
    _proto.tablecell = function tablecell(content, flags) {
      var type = flags.header ? 'th' : 'td';
      var tag = flags.align ? "<" + type + " align=\"" + flags.align + "\">" : "<" + type + ">";
      return tag + content + ("</" + type + ">\n");
    }

    /**
     * span level renderer
     * @param {string} text
     */;
    _proto.strong = function strong(text) {
      return "<strong>" + text + "</strong>";
    }

    /**
     * @param {string} text
     */;
    _proto.em = function em(text) {
      return "<em>" + text + "</em>";
    }

    /**
     * @param {string} text
     */;
    _proto.codespan = function codespan(text) {
      return "<code>" + text + "</code>";
    };
    _proto.br = function br() {
      return this.options.xhtml ? '<br/>' : '<br>';
    }

    /**
     * @param {string} text
     */;
    _proto.del = function del(text) {
      return "<del>" + text + "</del>";
    }

    /**
     * @param {string} href
     * @param {string} title
     * @param {string} text
     */;
    _proto.link = function link(href, title, text) {
      href = cleanUrl(this.options.sanitize, this.options.baseUrl, href);
      if (href === null) {
        return text;
      }
      var out = '<a href="' + href + '"';
      if (title) {
        out += ' title="' + title + '"';
      }
      out += '>' + text + '</a>';
      return out;
    }

    /**
     * @param {string} href
     * @param {string} title
     * @param {string} text
     */;
    _proto.image = function image(href, title, text) {
      href = cleanUrl(this.options.sanitize, this.options.baseUrl, href);
      if (href === null) {
        return text;
      }
      var out = "<img src=\"" + href + "\" alt=\"" + text + "\"";
      if (title) {
        out += " title=\"" + title + "\"";
      }
      out += this.options.xhtml ? '/>' : '>';
      return out;
    };
    _proto.text = function text(_text) {
      return _text;
    };
    return Renderer;
  }();

  /**
   * TextRenderer
   * returns only the textual part of the token
   */
  var TextRenderer = /*#__PURE__*/function () {
    function TextRenderer() {}
    var _proto = TextRenderer.prototype;
    // no need for block level renderers
    _proto.strong = function strong(text) {
      return text;
    };
    _proto.em = function em(text) {
      return text;
    };
    _proto.codespan = function codespan(text) {
      return text;
    };
    _proto.del = function del(text) {
      return text;
    };
    _proto.html = function html(text) {
      return text;
    };
    _proto.text = function text(_text) {
      return _text;
    };
    _proto.link = function link(href, title, text) {
      return '' + text;
    };
    _proto.image = function image(href, title, text) {
      return '' + text;
    };
    _proto.br = function br() {
      return '';
    };
    return TextRenderer;
  }();

  /**
   * Slugger generates header id
   */
  var Slugger = /*#__PURE__*/function () {
    function Slugger() {
      this.seen = {};
    }

    /**
     * @param {string} value
     */
    var _proto = Slugger.prototype;
    _proto.serialize = function serialize(value) {
      return value.toLowerCase().trim()
      // remove html tags
      .replace(/<[!\/a-z].*?>/ig, '')
      // remove unwanted chars
      .replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g, '').replace(/\s/g, '-');
    }

    /**
     * Finds the next safe (unique) slug to use
     * @param {string} originalSlug
     * @param {boolean} isDryRun
     */;
    _proto.getNextSafeSlug = function getNextSafeSlug(originalSlug, isDryRun) {
      var slug = originalSlug;
      var occurenceAccumulator = 0;
      if (this.seen.hasOwnProperty(slug)) {
        occurenceAccumulator = this.seen[originalSlug];
        do {
          occurenceAccumulator++;
          slug = originalSlug + '-' + occurenceAccumulator;
        } while (this.seen.hasOwnProperty(slug));
      }
      if (!isDryRun) {
        this.seen[originalSlug] = occurenceAccumulator;
        this.seen[slug] = 0;
      }
      return slug;
    }

    /**
     * Convert string to unique id
     * @param {object} [options]
     * @param {boolean} [options.dryrun] Generates the next unique slug without
     * updating the internal accumulator.
     */;
    _proto.slug = function slug(value, options) {
      if (options === void 0) {
        options = {};
      }
      var slug = this.serialize(value);
      return this.getNextSafeSlug(slug, options.dryrun);
    };
    return Slugger;
  }();

  /**
   * Parsing & Compiling
   */
  var Parser = /*#__PURE__*/function () {
    function Parser(options) {
      this.options = options || exports.defaults;
      this.options.renderer = this.options.renderer || new Renderer();
      this.renderer = this.options.renderer;
      this.renderer.options = this.options;
      this.textRenderer = new TextRenderer();
      this.slugger = new Slugger();
    }

    /**
     * Static Parse Method
     */
    Parser.parse = function parse(tokens, options) {
      var parser = new Parser(options);
      return parser.parse(tokens);
    }

    /**
     * Static Parse Inline Method
     */;
    Parser.parseInline = function parseInline(tokens, options) {
      var parser = new Parser(options);
      return parser.parseInline(tokens);
    }

    /**
     * Parse Loop
     */;
    var _proto = Parser.prototype;
    _proto.parse = function parse(tokens, top) {
      if (top === void 0) {
        top = true;
      }
      var out = '',
        i,
        j,
        k,
        l2,
        l3,
        row,
        cell,
        header,
        body,
        token,
        ordered,
        start,
        loose,
        itemBody,
        item,
        checked,
        task,
        checkbox,
        ret;
      var l = tokens.length;
      for (i = 0; i < l; i++) {
        token = tokens[i];

        // Run any renderer extensions
        if (this.options.extensions && this.options.extensions.renderers && this.options.extensions.renderers[token.type]) {
          ret = this.options.extensions.renderers[token.type].call({
            parser: this
          }, token);
          if (ret !== false || !['space', 'hr', 'heading', 'code', 'table', 'blockquote', 'list', 'html', 'paragraph', 'text'].includes(token.type)) {
            out += ret || '';
            continue;
          }
        }
        switch (token.type) {
          case 'space':
            {
              continue;
            }
          case 'hr':
            {
              out += this.renderer.hr();
              continue;
            }
          case 'heading':
            {
              out += this.renderer.heading(this.parseInline(token.tokens), token.depth, unescape(this.parseInline(token.tokens, this.textRenderer)), this.slugger);
              continue;
            }
          case 'code':
            {
              out += this.renderer.code(token.text, token.lang, token.escaped);
              continue;
            }
          case 'table':
            {
              header = '';

              // header
              cell = '';
              l2 = token.header.length;
              for (j = 0; j < l2; j++) {
                cell += this.renderer.tablecell(this.parseInline(token.header[j].tokens), {
                  header: true,
                  align: token.align[j]
                });
              }
              header += this.renderer.tablerow(cell);
              body = '';
              l2 = token.rows.length;
              for (j = 0; j < l2; j++) {
                row = token.rows[j];
                cell = '';
                l3 = row.length;
                for (k = 0; k < l3; k++) {
                  cell += this.renderer.tablecell(this.parseInline(row[k].tokens), {
                    header: false,
                    align: token.align[k]
                  });
                }
                body += this.renderer.tablerow(cell);
              }
              out += this.renderer.table(header, body);
              continue;
            }
          case 'blockquote':
            {
              body = this.parse(token.tokens);
              out += this.renderer.blockquote(body);
              continue;
            }
          case 'list':
            {
              ordered = token.ordered;
              start = token.start;
              loose = token.loose;
              l2 = token.items.length;
              body = '';
              for (j = 0; j < l2; j++) {
                item = token.items[j];
                checked = item.checked;
                task = item.task;
                itemBody = '';
                if (item.task) {
                  checkbox = this.renderer.checkbox(checked);
                  if (loose) {
                    if (item.tokens.length > 0 && item.tokens[0].type === 'paragraph') {
                      item.tokens[0].text = checkbox + ' ' + item.tokens[0].text;
                      if (item.tokens[0].tokens && item.tokens[0].tokens.length > 0 && item.tokens[0].tokens[0].type === 'text') {
                        item.tokens[0].tokens[0].text = checkbox + ' ' + item.tokens[0].tokens[0].text;
                      }
                    } else {
                      item.tokens.unshift({
                        type: 'text',
                        text: checkbox
                      });
                    }
                  } else {
                    itemBody += checkbox;
                  }
                }
                itemBody += this.parse(item.tokens, loose);
                body += this.renderer.listitem(itemBody, task, checked);
              }
              out += this.renderer.list(body, ordered, start);
              continue;
            }
          case 'html':
            {
              // TODO parse inline content if parameter markdown=1
              out += this.renderer.html(token.text);
              continue;
            }
          case 'paragraph':
            {
              out += this.renderer.paragraph(this.parseInline(token.tokens));
              continue;
            }
          case 'text':
            {
              body = token.tokens ? this.parseInline(token.tokens) : token.text;
              while (i + 1 < l && tokens[i + 1].type === 'text') {
                token = tokens[++i];
                body += '\n' + (token.tokens ? this.parseInline(token.tokens) : token.text);
              }
              out += top ? this.renderer.paragraph(body) : body;
              continue;
            }
          default:
            {
              var errMsg = 'Token with "' + token.type + '" type was not found.';
              if (this.options.silent) {
                console.error(errMsg);
                return;
              } else {
                throw new Error(errMsg);
              }
            }
        }
      }
      return out;
    }

    /**
     * Parse Inline Tokens
     */;
    _proto.parseInline = function parseInline(tokens, renderer) {
      renderer = renderer || this.renderer;
      var out = '',
        i,
        token,
        ret;
      var l = tokens.length;
      for (i = 0; i < l; i++) {
        token = tokens[i];

        // Run any renderer extensions
        if (this.options.extensions && this.options.extensions.renderers && this.options.extensions.renderers[token.type]) {
          ret = this.options.extensions.renderers[token.type].call({
            parser: this
          }, token);
          if (ret !== false || !['escape', 'html', 'link', 'image', 'strong', 'em', 'codespan', 'br', 'del', 'text'].includes(token.type)) {
            out += ret || '';
            continue;
          }
        }
        switch (token.type) {
          case 'escape':
            {
              out += renderer.text(token.text);
              break;
            }
          case 'html':
            {
              out += renderer.html(token.text);
              break;
            }
          case 'link':
            {
              out += renderer.link(token.href, token.title, this.parseInline(token.tokens, renderer));
              break;
            }
          case 'image':
            {
              out += renderer.image(token.href, token.title, token.text);
              break;
            }
          case 'strong':
            {
              out += renderer.strong(this.parseInline(token.tokens, renderer));
              break;
            }
          case 'em':
            {
              out += renderer.em(this.parseInline(token.tokens, renderer));
              break;
            }
          case 'codespan':
            {
              out += renderer.codespan(token.text);
              break;
            }
          case 'br':
            {
              out += renderer.br();
              break;
            }
          case 'del':
            {
              out += renderer.del(this.parseInline(token.tokens, renderer));
              break;
            }
          case 'text':
            {
              out += renderer.text(token.text);
              break;
            }
          default:
            {
              var errMsg = 'Token with "' + token.type + '" type was not found.';
              if (this.options.silent) {
                console.error(errMsg);
                return;
              } else {
                throw new Error(errMsg);
              }
            }
        }
      }
      return out;
    };
    return Parser;
  }();

  var Hooks = /*#__PURE__*/function () {
    function Hooks(options) {
      this.options = options || exports.defaults;
    }
    var _proto = Hooks.prototype;
    /**
     * Process markdown before marked
     */
    _proto.preprocess = function preprocess(markdown) {
      return markdown;
    }

    /**
     * Process HTML after marked is finished
     */;
    _proto.postprocess = function postprocess(html) {
      return html;
    };
    return Hooks;
  }();
  Hooks.passThroughHooks = new Set(['preprocess', 'postprocess']);

  function onError(silent, async, callback) {
    return function (e) {
      e.message += '\nPlease report this to https://github.com/markedjs/marked.';
      if (silent) {
        var msg = '<p>An error occurred:</p><pre>' + escape(e.message + '', true) + '</pre>';
        if (async) {
          return Promise.resolve(msg);
        }
        if (callback) {
          callback(null, msg);
          return;
        }
        return msg;
      }
      if (async) {
        return Promise.reject(e);
      }
      if (callback) {
        callback(e);
        return;
      }
      throw e;
    };
  }
  function parseMarkdown(lexer, parser) {
    return function (src, opt, callback) {
      if (typeof opt === 'function') {
        callback = opt;
        opt = null;
      }
      var origOpt = _extends({}, opt);
      opt = _extends({}, marked.defaults, origOpt);
      var throwError = onError(opt.silent, opt.async, callback);

      // throw error in case of non string input
      if (typeof src === 'undefined' || src === null) {
        return throwError(new Error('marked(): input parameter is undefined or null'));
      }
      if (typeof src !== 'string') {
        return throwError(new Error('marked(): input parameter is of type ' + Object.prototype.toString.call(src) + ', string expected'));
      }
      checkSanitizeDeprecation(opt);
      if (opt.hooks) {
        opt.hooks.options = opt;
      }
      if (callback) {
        var highlight = opt.highlight;
        var tokens;
        try {
          if (opt.hooks) {
            src = opt.hooks.preprocess(src);
          }
          tokens = lexer(src, opt);
        } catch (e) {
          return throwError(e);
        }
        var done = function done(err) {
          var out;
          if (!err) {
            try {
              if (opt.walkTokens) {
                marked.walkTokens(tokens, opt.walkTokens);
              }
              out = parser(tokens, opt);
              if (opt.hooks) {
                out = opt.hooks.postprocess(out);
              }
            } catch (e) {
              err = e;
            }
          }
          opt.highlight = highlight;
          return err ? throwError(err) : callback(null, out);
        };
        if (!highlight || highlight.length < 3) {
          return done();
        }
        delete opt.highlight;
        if (!tokens.length) return done();
        var pending = 0;
        marked.walkTokens(tokens, function (token) {
          if (token.type === 'code') {
            pending++;
            setTimeout(function () {
              highlight(token.text, token.lang, function (err, code) {
                if (err) {
                  return done(err);
                }
                if (code != null && code !== token.text) {
                  token.text = code;
                  token.escaped = true;
                }
                pending--;
                if (pending === 0) {
                  done();
                }
              });
            }, 0);
          }
        });
        if (pending === 0) {
          done();
        }
        return;
      }
      if (opt.async) {
        return Promise.resolve(opt.hooks ? opt.hooks.preprocess(src) : src).then(function (src) {
          return lexer(src, opt);
        }).then(function (tokens) {
          return opt.walkTokens ? Promise.all(marked.walkTokens(tokens, opt.walkTokens)).then(function () {
            return tokens;
          }) : tokens;
        }).then(function (tokens) {
          return parser(tokens, opt);
        }).then(function (html) {
          return opt.hooks ? opt.hooks.postprocess(html) : html;
        })["catch"](throwError);
      }
      try {
        if (opt.hooks) {
          src = opt.hooks.preprocess(src);
        }
        var _tokens = lexer(src, opt);
        if (opt.walkTokens) {
          marked.walkTokens(_tokens, opt.walkTokens);
        }
        var html = parser(_tokens, opt);
        if (opt.hooks) {
          html = opt.hooks.postprocess(html);
        }
        return html;
      } catch (e) {
        return throwError(e);
      }
    };
  }

  /**
   * Marked
   */
  function marked(src, opt, callback) {
    return parseMarkdown(Lexer.lex, Parser.parse)(src, opt, callback);
  }

  /**
   * Options
   */

  marked.options = marked.setOptions = function (opt) {
    marked.defaults = _extends({}, marked.defaults, opt);
    changeDefaults(marked.defaults);
    return marked;
  };
  marked.getDefaults = getDefaults;
  marked.defaults = exports.defaults;

  /**
   * Use Extension
   */

  marked.use = function () {
    var extensions = marked.defaults.extensions || {
      renderers: {},
      childTokens: {}
    };
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    args.forEach(function (pack) {
      // copy options to new object
      var opts = _extends({}, pack);

      // set async to true if it was set to true before
      opts.async = marked.defaults.async || opts.async || false;

      // ==-- Parse "addon" extensions --== //
      if (pack.extensions) {
        pack.extensions.forEach(function (ext) {
          if (!ext.name) {
            throw new Error('extension name required');
          }
          if (ext.renderer) {
            // Renderer extensions
            var prevRenderer = extensions.renderers[ext.name];
            if (prevRenderer) {
              // Replace extension with func to run new extension but fall back if false
              extensions.renderers[ext.name] = function () {
                for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                  args[_key2] = arguments[_key2];
                }
                var ret = ext.renderer.apply(this, args);
                if (ret === false) {
                  ret = prevRenderer.apply(this, args);
                }
                return ret;
              };
            } else {
              extensions.renderers[ext.name] = ext.renderer;
            }
          }
          if (ext.tokenizer) {
            // Tokenizer Extensions
            if (!ext.level || ext.level !== 'block' && ext.level !== 'inline') {
              throw new Error("extension level must be 'block' or 'inline'");
            }
            if (extensions[ext.level]) {
              extensions[ext.level].unshift(ext.tokenizer);
            } else {
              extensions[ext.level] = [ext.tokenizer];
            }
            if (ext.start) {
              // Function to check for start of token
              if (ext.level === 'block') {
                if (extensions.startBlock) {
                  extensions.startBlock.push(ext.start);
                } else {
                  extensions.startBlock = [ext.start];
                }
              } else if (ext.level === 'inline') {
                if (extensions.startInline) {
                  extensions.startInline.push(ext.start);
                } else {
                  extensions.startInline = [ext.start];
                }
              }
            }
          }
          if (ext.childTokens) {
            // Child tokens to be visited by walkTokens
            extensions.childTokens[ext.name] = ext.childTokens;
          }
        });
        opts.extensions = extensions;
      }

      // ==-- Parse "overwrite" extensions --== //
      if (pack.renderer) {
        (function () {
          var renderer = marked.defaults.renderer || new Renderer();
          var _loop = function _loop(prop) {
            var prevRenderer = renderer[prop];
            // Replace renderer with func to run extension, but fall back if false
            renderer[prop] = function () {
              for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                args[_key3] = arguments[_key3];
              }
              var ret = pack.renderer[prop].apply(renderer, args);
              if (ret === false) {
                ret = prevRenderer.apply(renderer, args);
              }
              return ret;
            };
          };
          for (var prop in pack.renderer) {
            _loop(prop);
          }
          opts.renderer = renderer;
        })();
      }
      if (pack.tokenizer) {
        (function () {
          var tokenizer = marked.defaults.tokenizer || new Tokenizer();
          var _loop2 = function _loop2(prop) {
            var prevTokenizer = tokenizer[prop];
            // Replace tokenizer with func to run extension, but fall back if false
            tokenizer[prop] = function () {
              for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
                args[_key4] = arguments[_key4];
              }
              var ret = pack.tokenizer[prop].apply(tokenizer, args);
              if (ret === false) {
                ret = prevTokenizer.apply(tokenizer, args);
              }
              return ret;
            };
          };
          for (var prop in pack.tokenizer) {
            _loop2(prop);
          }
          opts.tokenizer = tokenizer;
        })();
      }

      // ==-- Parse Hooks extensions --== //
      if (pack.hooks) {
        (function () {
          var hooks = marked.defaults.hooks || new Hooks();
          var _loop3 = function _loop3(prop) {
            var prevHook = hooks[prop];
            if (Hooks.passThroughHooks.has(prop)) {
              hooks[prop] = function (arg) {
                if (marked.defaults.async) {
                  return Promise.resolve(pack.hooks[prop].call(hooks, arg)).then(function (ret) {
                    return prevHook.call(hooks, ret);
                  });
                }
                var ret = pack.hooks[prop].call(hooks, arg);
                return prevHook.call(hooks, ret);
              };
            } else {
              hooks[prop] = function () {
                for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
                  args[_key5] = arguments[_key5];
                }
                var ret = pack.hooks[prop].apply(hooks, args);
                if (ret === false) {
                  ret = prevHook.apply(hooks, args);
                }
                return ret;
              };
            }
          };
          for (var prop in pack.hooks) {
            _loop3(prop);
          }
          opts.hooks = hooks;
        })();
      }

      // ==-- Parse WalkTokens extensions --== //
      if (pack.walkTokens) {
        var _walkTokens = marked.defaults.walkTokens;
        opts.walkTokens = function (token) {
          var values = [];
          values.push(pack.walkTokens.call(this, token));
          if (_walkTokens) {
            values = values.concat(_walkTokens.call(this, token));
          }
          return values;
        };
      }
      marked.setOptions(opts);
    });
  };

  /**
   * Run callback for every token
   */

  marked.walkTokens = function (tokens, callback) {
    var values = [];
    var _loop4 = function _loop4() {
      var token = _step.value;
      values = values.concat(callback.call(marked, token));
      switch (token.type) {
        case 'table':
          {
            for (var _iterator2 = _createForOfIteratorHelperLoose(token.header), _step2; !(_step2 = _iterator2()).done;) {
              var cell = _step2.value;
              values = values.concat(marked.walkTokens(cell.tokens, callback));
            }
            for (var _iterator3 = _createForOfIteratorHelperLoose(token.rows), _step3; !(_step3 = _iterator3()).done;) {
              var row = _step3.value;
              for (var _iterator4 = _createForOfIteratorHelperLoose(row), _step4; !(_step4 = _iterator4()).done;) {
                var _cell = _step4.value;
                values = values.concat(marked.walkTokens(_cell.tokens, callback));
              }
            }
            break;
          }
        case 'list':
          {
            values = values.concat(marked.walkTokens(token.items, callback));
            break;
          }
        default:
          {
            if (marked.defaults.extensions && marked.defaults.extensions.childTokens && marked.defaults.extensions.childTokens[token.type]) {
              // Walk any extensions
              marked.defaults.extensions.childTokens[token.type].forEach(function (childTokens) {
                values = values.concat(marked.walkTokens(token[childTokens], callback));
              });
            } else if (token.tokens) {
              values = values.concat(marked.walkTokens(token.tokens, callback));
            }
          }
      }
    };
    for (var _iterator = _createForOfIteratorHelperLoose(tokens), _step; !(_step = _iterator()).done;) {
      _loop4();
    }
    return values;
  };

  /**
   * Parse Inline
   * @param {string} src
   */
  marked.parseInline = parseMarkdown(Lexer.lexInline, Parser.parseInline);

  /**
   * Expose
   */
  marked.Parser = Parser;
  marked.parser = Parser.parse;
  marked.Renderer = Renderer;
  marked.TextRenderer = TextRenderer;
  marked.Lexer = Lexer;
  marked.lexer = Lexer.lex;
  marked.Tokenizer = Tokenizer;
  marked.Slugger = Slugger;
  marked.Hooks = Hooks;
  marked.parse = marked;
  var options = marked.options;
  var setOptions = marked.setOptions;
  var use = marked.use;
  var walkTokens = marked.walkTokens;
  var parseInline = marked.parseInline;
  var parse = marked;
  var parser = Parser.parse;
  var lexer = Lexer.lex;

  exports.Hooks = Hooks;
  exports.Lexer = Lexer;
  exports.Parser = Parser;
  exports.Renderer = Renderer;
  exports.Slugger = Slugger;
  exports.TextRenderer = TextRenderer;
  exports.Tokenizer = Tokenizer;
  exports.getDefaults = getDefaults;
  exports.lexer = lexer;
  exports.marked = marked;
  exports.options = options;
  exports.parse = parse;
  exports.parseInline = parseInline;
  exports.parser = parser;
  exports.setOptions = setOptions;
  exports.use = use;
  exports.walkTokens = walkTokens;

}));
}(marked_umd, marked_umd.exports));

var striptags$1 = {exports: {}};

(function (module) {

(function (global) {

    // minimal symbol polyfill for IE11 and others
    if (typeof Symbol !== 'function') {
        var Symbol = function(name) {
            return name;
        };

        Symbol.nonNative = true;
    }

    const STATE_PLAINTEXT = Symbol('plaintext');
    const STATE_HTML      = Symbol('html');
    const STATE_COMMENT   = Symbol('comment');

    const ALLOWED_TAGS_REGEX  = /<(\w*)>/g;
    const NORMALIZE_TAG_REGEX = /<\/?([^\s\/>]+)/;

    function striptags(html, allowable_tags, tag_replacement) {
        html            = html || '';
        allowable_tags  = allowable_tags || [];
        tag_replacement = tag_replacement || '';

        let context = init_context(allowable_tags, tag_replacement);

        return striptags_internal(html, context);
    }

    function init_striptags_stream(allowable_tags, tag_replacement) {
        allowable_tags  = allowable_tags || [];
        tag_replacement = tag_replacement || '';

        let context = init_context(allowable_tags, tag_replacement);

        return function striptags_stream(html) {
            return striptags_internal(html || '', context);
        };
    }

    striptags.init_streaming_mode = init_striptags_stream;

    function init_context(allowable_tags, tag_replacement) {
        allowable_tags = parse_allowable_tags(allowable_tags);

        return {
            allowable_tags : allowable_tags,
            tag_replacement: tag_replacement,

            state         : STATE_PLAINTEXT,
            tag_buffer    : '',
            depth         : 0,
            in_quote_char : ''
        };
    }

    function striptags_internal(html, context) {
        if (typeof html != "string") {
            throw new TypeError("'html' parameter must be a string");
        }

        let allowable_tags  = context.allowable_tags;
        let tag_replacement = context.tag_replacement;

        let state         = context.state;
        let tag_buffer    = context.tag_buffer;
        let depth         = context.depth;
        let in_quote_char = context.in_quote_char;
        let output        = '';

        for (let idx = 0, length = html.length; idx < length; idx++) {
            let char = html[idx];

            if (state === STATE_PLAINTEXT) {
                switch (char) {
                    case '<':
                        state       = STATE_HTML;
                        tag_buffer += char;
                        break;

                    default:
                        output += char;
                        break;
                }
            }

            else if (state === STATE_HTML) {
                switch (char) {
                    case '<':
                        // ignore '<' if inside a quote
                        if (in_quote_char) {
                            break;
                        }

                        // we're seeing a nested '<'
                        depth++;
                        break;

                    case '>':
                        // ignore '>' if inside a quote
                        if (in_quote_char) {
                            break;
                        }

                        // something like this is happening: '<<>>'
                        if (depth) {
                            depth--;

                            break;
                        }

                        // this is closing the tag in tag_buffer
                        in_quote_char = '';
                        state         = STATE_PLAINTEXT;
                        tag_buffer   += '>';

                        if (allowable_tags.has(normalize_tag(tag_buffer))) {
                            output += tag_buffer;
                        } else {
                            output += tag_replacement;
                        }

                        tag_buffer = '';
                        break;

                    case '"':
                    case '\'':
                        // catch both single and double quotes

                        if (char === in_quote_char) {
                            in_quote_char = '';
                        } else {
                            in_quote_char = in_quote_char || char;
                        }

                        tag_buffer += char;
                        break;

                    case '-':
                        if (tag_buffer === '<!-') {
                            state = STATE_COMMENT;
                        }

                        tag_buffer += char;
                        break;

                    case ' ':
                    case '\n':
                        if (tag_buffer === '<') {
                            state      = STATE_PLAINTEXT;
                            output    += '< ';
                            tag_buffer = '';

                            break;
                        }

                        tag_buffer += char;
                        break;

                    default:
                        tag_buffer += char;
                        break;
                }
            }

            else if (state === STATE_COMMENT) {
                switch (char) {
                    case '>':
                        if (tag_buffer.slice(-2) == '--') {
                            // close the comment
                            state = STATE_PLAINTEXT;
                        }

                        tag_buffer = '';
                        break;

                    default:
                        tag_buffer += char;
                        break;
                }
            }
        }

        // save the context for future iterations
        context.state         = state;
        context.tag_buffer    = tag_buffer;
        context.depth         = depth;
        context.in_quote_char = in_quote_char;

        return output;
    }

    function parse_allowable_tags(allowable_tags) {
        let tag_set = new Set();

        if (typeof allowable_tags === 'string') {
            let match;

            while ((match = ALLOWED_TAGS_REGEX.exec(allowable_tags))) {
                tag_set.add(match[1]);
            }
        }

        else if (!Symbol.nonNative &&
                 typeof allowable_tags[Symbol.iterator] === 'function') {

            tag_set = new Set(allowable_tags);
        }

        else if (typeof allowable_tags.forEach === 'function') {
            // IE11 compatible
            allowable_tags.forEach(tag_set.add, tag_set);
        }

        return tag_set;
    }

    function normalize_tag(tag_buffer) {
        let match = NORMALIZE_TAG_REGEX.exec(tag_buffer);

        return match ? match[1].toLowerCase() : null;
    }

    if (module.exports) {
        // Node
        module.exports = striptags;
    }

    else {
        // Browser
        global.striptags = striptags;
    }
}(commonjsGlobal));
}(striptags$1));

var striptags = striptags$1.exports;

/**
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var prefix$u = settings.prefix;
var _cleanStringRegex = /\n|\s{2,}|&;/g;

/**
 * Cleans string by replacing multiple spaces with a single space
 * and removing single new lines.
 *
 * @param {string} str String to be checked
 * @returns {string} String with multiple spaces and single new lines removed
 * @private
 */
var _cleanString = function _cleanString(str) {
  return str.replace(_cleanStringRegex, ' ');
};

/**
 * Converts markdown syntaxes into html
 *
 * @param {string} str String to convert to html
 * @param {object} [options={}] Object with options for the conversion
 * @param {boolean} [options.allowHtml=false] Defines if should allow or remove html tags
 * @param {object} [options.renderer] Custom renderers
 * @param {Set<string>} [options.customTags] List of custom element tags the `renderer` uses.
 * @returns {string} String converted to html
 * @example
 * import { markdownToHtml } from '@carbon/ibmdotcom-utilities';
 *
 * markdownToHtml('Lorem *ipsum* dolor __sit__.')
 * // 'Lorem <em class="bx--type-light">ipsum</em> dolor <strong class="bx--type-semibold">sit</strong>.'
 */
function markdownToHtml(str) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
    _ref$allowHtml = _ref.allowHtml,
    allowHtml = _ref$allowHtml === void 0 ? false : _ref$allowHtml,
    _ref$renderer = _ref.renderer,
    renderer = _ref$renderer === void 0 ? {} : _ref$renderer,
    customTags = _ref.customTags;
  var converted = allowHtml ? str : striptags(str);

  /**
   * Custom rendering options to add Carbon styles
   *
   */
  var defaultRenderer = {
    link: function link(href, title, text) {
      var linkTitle = title ? "title=\"".concat(title, "\"") : null;
      return "<a class=\"".concat(prefix$u, "--link ").concat(prefix$u, "--link--lg\" href=\"").concat(href, "\" ").concat(linkTitle, ">").concat(text, "</a>");
    },
    list: function list(body, ordered) {
      var listType = ordered ? 'ol' : 'ul';
      var listClass = ordered ? "".concat(prefix$u, "--list--ordered") : "".concat(prefix$u, "--list--unordered");
      return "<".concat(listType, " class=\"").concat(listClass, "\">").concat(body, "</").concat(listType, ">");
    },
    listitem: function listitem(text) {
      return "<li class=\"".concat(prefix$u, "--list__item\">").concat(text, "</li>");
    }
  };
  marked_umd.exports.marked.use({
    smartypants: true,
    renderer: Object.assign(defaultRenderer, renderer)
  });
  if (customTags) {
    browser.addHook('uponSanitizeElement', function (node, _ref2) {
      var allowedTags = _ref2.allowedTags,
        tagName = _ref2.tagName;
      if (customTags.has(tagName) && !allowedTags[tagName]) {
        allowedTags[tagName] = true;
      }
    });
  }
  var convertedMarkdown = browser.sanitize(marked_umd.exports.marked(converted));
  if (customTags) {
    browser.removeHook('uponSanitizeElement');
  }
  return _cleanString(convertedMarkdown);
}

var styles$c = i$4(["/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--tag {\n  --cds-layout-size-height-xs: 1.125rem;\n  --cds-layout-size-height-sm: 1.125rem;\n  --cds-layout-size-height-md: 1.5rem;\n  --cds-layout-size-height-lg: 2rem;\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 1rem;\n  margin: 0.25rem;\n  cursor: default;\n  max-inline-size: 13rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  min-inline-size: 2rem;\n  padding-inline: 0.5rem;\n  vertical-align: middle;\n  word-break: break-word;\n}\n.cds--layout--size-xs .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-xs);\n}\n.cds--layout--size-sm .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--tag.cds--tag--operational {\n  border: 1px solid var(--cds-tag-background-gray, #e0e0e0);\n}\n.cds--tag.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag.cds--tag--lg {\n  padding-inline-start: 0.75rem;\n}\n.cds--tag:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.25rem;\n}\n.cds--tag.cds--tag--lg:not(.cds--tag--filter) {\n  padding-inline: 0.75rem;\n}\n.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.5rem;\n}\n.cds--tag:not(.cds--tag--selectable) {\n  border: 0;\n}\n.cds--tag:not(:first-child) {\n  margin-inline-start: 0;\n}\n\n.cds--tag--operational > span,\n.cds--tag--selectable > span,\n.cds--tag__label {\n  display: block;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--tag--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--filter {\n  padding-block-end: 0;\n  padding-block-start: 0;\n  padding-inline-end: 0;\n}\n.cds--tag--filter:hover {\n  outline: none;\n}\n\n.cds--tag--selectable {\n  border: 1px solid var(--cds-border-inverse, #161616);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--tag--selectable:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--tag--selectable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--selectable-selected {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--selectable-selected:hover {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  cursor: pointer;\n}\n.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n  outline: none;\n}\n.cds--tag--operational:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--red {\n  background-color: var(--cds-tag-background-red, #ffd7d9);\n  color: var(--cds-tag-color-red, #a2191f);\n}\n.cds--tag--red.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-red, #ff8389);\n}\n.cds--tag--red.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n.cds--tag--red .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n\n.cds--tag--magenta {\n  background-color: var(--cds-tag-background-magenta, #ffd6e8);\n  color: var(--cds-tag-color-magenta, #9f1853);\n}\n.cds--tag--magenta.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-magenta, #ff7eb6);\n}\n.cds--tag--magenta.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n.cds--tag--magenta .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n\n.cds--tag--purple {\n  background-color: var(--cds-tag-background-purple, #e8daff);\n  color: var(--cds-tag-color-purple, #6929c4);\n}\n.cds--tag--purple.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-purple, #be95ff);\n}\n.cds--tag--purple.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n.cds--tag--purple .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n\n.cds--tag--blue {\n  background-color: var(--cds-tag-background-blue, #d0e2ff);\n  color: var(--cds-tag-color-blue, #0043ce);\n}\n.cds--tag--blue.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-blue, #78a9ff);\n}\n.cds--tag--blue.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n.cds--tag--blue .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n\n.cds--tag--cyan {\n  background-color: var(--cds-tag-background-cyan, #bae6ff);\n  color: var(--cds-tag-color-cyan, #00539a);\n}\n.cds--tag--cyan.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cyan, #33b1ff);\n}\n.cds--tag--cyan.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n.cds--tag--cyan .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n\n.cds--tag--teal {\n  background-color: var(--cds-tag-background-teal, #9ef0f0);\n  color: var(--cds-tag-color-teal, #005d5d);\n}\n.cds--tag--teal.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-teal, #08bdba);\n}\n.cds--tag--teal.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n.cds--tag--teal .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n\n.cds--tag--green {\n  background-color: var(--cds-tag-background-green, #a7f0ba);\n  color: var(--cds-tag-color-green, #0e6027);\n}\n.cds--tag--green.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-green, #42be65);\n}\n.cds--tag--green.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n.cds--tag--green .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n\n.cds--tag--gray {\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n}\n.cds--tag--gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n}\n.cds--tag--gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag--gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n\n.cds--tag--cool-gray {\n  background-color: var(--cds-tag-background-cool-gray, #dde1e6);\n  color: var(--cds-tag-color-cool-gray, #121619);\n}\n.cds--tag--cool-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cool-gray, #a2a9b0);\n}\n.cds--tag--cool-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n.cds--tag--cool-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n\n.cds--tag--warm-gray {\n  background-color: var(--cds-tag-background-warm-gray, #e5e0df);\n  color: var(--cds-tag-color-warm-gray, #171414);\n}\n.cds--tag--warm-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-warm-gray, #ada8a8);\n}\n.cds--tag--warm-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n.cds--tag--warm-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n\n.cds--tag--high-contrast:not(.cds--tag--operational) {\n  background-color: var(--cds-background-inverse, #393939);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational {\n  border: 1px solid var(--cds-background-inverse, #393939);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  outline: 1px solid var(--cds-background-inverse, #393939);\n  outline-offset: -1px;\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational {\n  border: 1px solid var(--cds-background, #ffffff);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--tag--disabled:not(.cds--tag--operational),\n.cds--tag--filter.cds--tag--disabled,\n.cds--tag--interactive.cds--tag--disabled {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  box-shadow: none;\n  outline: none;\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational {\n  border: 1px solid var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational):hover,\n.cds--tag--filter.cds--tag--disabled:hover,\n.cds--tag--interactive.cds--tag--disabled:hover {\n  cursor: not-allowed;\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,\n.cds--tag--filter.cds--tag--disabled .cds--tag__label,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__label {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--selectable.cds--tag--disabled,\n.cds--tag--operational.cds--tag--disabled {\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--tag--selectable.cds--tag--disabled:hover,\n.cds--tag--operational.cds--tag--disabled:hover {\n  background-color: var(--cds-layer);\n  cursor: not-allowed;\n}\n\n.cds--tag--interactive {\n  transition: background-color 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--tag__close-icon {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: 50%;\n  margin: 0 0 0 0.125rem;\n  background-color: transparent;\n  block-size: var(--cds-layout-size-height-local);\n  color: currentColor;\n  cursor: pointer;\n  inline-size: var(--cds-layout-size-height-local);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tag__close-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag__custom-icon {\n  flex-shrink: 0;\n  padding: 0;\n  border: 0;\n  background-color: transparent;\n  block-size: 1rem;\n  color: currentColor;\n  inline-size: 1rem;\n  margin-inline-end: 0.25rem;\n  outline: none;\n}\n.cds--tag__custom-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag--disabled .cds--tag__close-icon {\n  cursor: not-allowed;\n}\n\n.cds--tag__close-icon:focus {\n  z-index: 99999;\n  border-radius: 50%;\n  box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--tag--high-contrast .cds--tag__close-icon:focus {\n  box-shadow: inset 0 0 0 1px var(--cds-focus-inverse, #ffffff);\n}\n\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: transparent;\n}\n\n.cds--tag--filter.cds--tag--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--sm.cds--tag--filter {\n  padding-inline-end: 0;\n}\n\n.cds--tag--sm .cds--tag__close-icon {\n  margin-inline-start: 0.3125rem;\n}\n\n.cds--tag.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n  color: var(--cds-text-primary, #161616);\n  overflow: hidden;\n  inline-size: 3.75rem;\n}\n.cds--tag.cds--skeleton:hover, .cds--tag.cds--skeleton:focus, .cds--tag.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--tag.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--tag.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--tag.cds--skeleton.cds--tag--operational {\n  border: 1px solid var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton.cds--tag--operational:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton .cds--tag__close-icon:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n@media not all and (min-resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tag.cds--skeleton {\n      transform: translateZ(0);\n    }\n  }\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline {\n  color: currentColor;\n  margin-inline-start: 0.0625rem;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before {\n  background-color: currentColor;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline:hover {\n  border-color: currentColor;\n}\n\n/* stylelint-disable */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon svg,\n  .cds--tag__custom-icon svg {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n.cds--tag-label-tooltip {\n  max-inline-size: -webkit-fill-available;\n}\n\n.cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 11rem;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 9.875rem;\n}\n\n/* stylelint-enable */\n.cds--interactive--tag-children {\n  display: inline-flex;\n  max-inline-size: 12.5rem;\n  place-items: center;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + span > .cds--interactive--tag-children {\n  max-inline-size: 11.5rem;\n}\n\n.cds--tag .cds--definition-term {\n  border-block-end: none;\n  cursor: default;\n  max-inline-size: 12rem;\n}\n\n.cds--tag .cds--tag__custom-icon + span > .cds--definition-term {\n  max-inline-size: 11rem;\n}\n\n.cds--tag > .cds--popover-container {\n  display: flex;\n}\n\n.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled) {\n  pointer-events: none;\n}\n\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--tile-group html {\n  font-size: 100%;\n}\n.cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--tile-group strong {\n  font-weight: 600;\n}\n\n.cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--clickable,\n.cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--clickable *,\n.cds--tile--clickable *::before,\n.cds--tile--clickable *::after,\n.cds--tile--selectable *,\n.cds--tile--selectable *::before,\n.cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--tile--clickable:hover,\n.cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--tile--clickable:hover .cds--tile__checkmark, .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--tile--clickable:hover,\n.cds--tile--clickable:active,\n.cds--tile--clickable:visited,\n.cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n\n.cds--tile--clickable.cds--link--disabled,\n.cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--clickable .cds--tile--icon,\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n\n.cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n}\n\n.cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 0;\n}\n.cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n\n.cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron--interactive *,\n.cds--tile__chevron--interactive *::before,\n.cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n\n.cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n\n.cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n\n.cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n\n.cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n\n.cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n\n.cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile > .cds--slug,\n.cds--tile--expandable > div > .cds--slug,\n.cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n\n.cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n\n.cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--selectable::after,\n.cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable:focus,\n.cds--tile--slug.cds--tile--clickable:focus,\n.cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n\n.cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n\n.cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n\n.cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n\n.cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n\n.cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--slug-rounded,\n.cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n\n.cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tile__chevron svg,\n  .cds--tile__checkmark svg,\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--modal, :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline: none;\n  text-decoration: none;\n  transition: color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--link *,\n.cds--link *::before,\n.cds--link *::after {\n  box-sizing: inherit;\n}\n.cds--link:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n  text-decoration: underline;\n}\n.cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n    outline-style: dotted;\n  }\n}\n.cds--link:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:focus {\n    outline-style: dotted;\n  }\n}\n.cds--link:visited {\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n}\n.cds--link:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link--disabled,\n.cds--link--disabled:hover {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  font-weight: 400;\n  text-decoration: none;\n}\n.cds--link--disabled *,\n.cds--link--disabled *::before,\n.cds--link--disabled *::after,\n.cds--link--disabled:hover *,\n.cds--link--disabled:hover *::before,\n.cds--link--disabled:hover *::after {\n  box-sizing: inherit;\n}\n\n.cds--link.cds--link--visited:visited {\n  color: var(--cds-link-visited-text-color, var(--cds-link-visited, #8a3ffc));\n}\n\n.cds--link.cds--link--visited:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link.cds--link--inline {\n  display: inline;\n  text-decoration: underline;\n}\n\n.cds--link--disabled.cds--link--inline {\n  text-decoration: underline;\n}\n\n.cds--link--sm,\n.cds--link--sm.cds--link--disabled:hover {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n}\n\n.cds--link--lg,\n.cds--link--lg.cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n\n.cds--link__icon {\n  display: inline-flex;\n  align-self: center;\n  margin-inline-start: 0.5rem;\n}\n\n.cds--card,\n:host(c4d-card),\n:host(c4d-region-item) .cds--link,\n:host(c4d-card-cta),\n:host(c4d-card-in-card),\n:host(c4d-card-group-item),\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-content-group-cards-item),\n:host(c4d-content-group-cards-item) .cds--card {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  padding: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 100%;\n  inline-size: 100%;\n  text-decoration: none;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile-group html,\n:host(c4d-card) .cds--tile-group html,\n:host(c4d-region-item) .cds--link .cds--tile-group html,\n:host(c4d-card-cta) .cds--tile-group html,\n:host(c4d-card-in-card) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--card .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group html {\n  font-size: 100%;\n}\n.cds--card .cds--tile-group body,\n:host(c4d-card) .cds--tile-group body,\n:host(c4d-region-item) .cds--link .cds--tile-group body,\n:host(c4d-card-cta) .cds--tile-group body,\n:host(c4d-card-in-card) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--card .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--card .cds--tile-group code,\n:host(c4d-card) .cds--tile-group code,\n:host(c4d-region-item) .cds--link .cds--tile-group code,\n:host(c4d-card-cta) .cds--tile-group code,\n:host(c4d-card-in-card) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--card .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--card .cds--tile-group strong,\n:host(c4d-card) .cds--tile-group strong,\n:host(c4d-region-item) .cds--link .cds--tile-group strong,\n:host(c4d-card-cta) .cds--tile-group strong,\n:host(c4d-card-in-card) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--card .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group strong {\n  font-weight: 600;\n}\n.cds--card .cds--tile,\n:host(c4d-card) .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile,\n:host(c4d-card-cta) .cds--tile,\n:host(c4d-card-in-card) .cds--tile,\n:host(c4d-card-group-item) .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--card .cds--tile:focus,\n:host(c4d-card) .cds--tile:focus,\n:host(c4d-region-item) .cds--link .cds--tile:focus,\n:host(c4d-card-cta) .cds--tile:focus,\n:host(c4d-card-in-card) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile:focus,\n  :host(c4d-card) .cds--tile:focus,\n  :host(c4d-region-item) .cds--link .cds--tile:focus,\n  :host(c4d-card-cta) .cds--tile:focus,\n  :host(c4d-card-in-card) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--light,\n:host(c4d-card) .cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--light,\n:host(c4d-card-cta) .cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--clickable,\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--clickable *,\n.cds--card .cds--tile--clickable *::before,\n.cds--card .cds--tile--clickable *::after,\n.cds--card .cds--tile--selectable *,\n.cds--card .cds--tile--selectable *::before,\n.cds--card .cds--tile--selectable *::after,\n:host(c4d-card) .cds--tile--clickable *,\n:host(c4d-card) .cds--tile--clickable *::before,\n:host(c4d-card) .cds--tile--clickable *::after,\n:host(c4d-card) .cds--tile--selectable *,\n:host(c4d-card) .cds--tile--selectable *::before,\n:host(c4d-card) .cds--tile--selectable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::after,\n:host(c4d-card-cta) .cds--tile--clickable *,\n:host(c4d-card-cta) .cds--tile--clickable *::before,\n:host(c4d-card-cta) .cds--tile--clickable *::after,\n:host(c4d-card-cta) .cds--tile--selectable *,\n:host(c4d-card-cta) .cds--tile--selectable *::before,\n:host(c4d-card-cta) .cds--tile--selectable *::after,\n:host(c4d-card-in-card) .cds--tile--clickable *,\n:host(c4d-card-in-card) .cds--tile--clickable *::before,\n:host(c4d-card-in-card) .cds--tile--clickable *::after,\n:host(c4d-card-in-card) .cds--tile--selectable *,\n:host(c4d-card-in-card) .cds--tile--selectable *::before,\n:host(c4d-card-in-card) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--selectable:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--selectable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--selectable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--selectable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--clickable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--clickable:focus,\n  :host(c4d-card) .cds--tile--clickable:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n  :host(c4d-card-cta) .cds--tile--clickable:focus,\n  :host(c4d-card-in-card) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--clickable:hover .cds--tile__checkmark, .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--clickable:active,\n.cds--card .cds--tile--clickable:visited,\n.cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--clickable:active,\n:host(c4d-card) .cds--tile--clickable:visited,\n:host(c4d-card) .cds--tile--clickable:visited:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:active,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:active,\n:host(c4d-card-cta) .cds--tile--clickable:visited,\n:host(c4d-card-cta) .cds--tile--clickable:visited:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:active,\n:host(c4d-card-in-card) .cds--tile--clickable:visited,\n:host(c4d-card-in-card) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--card .cds--tile--clickable.cds--link--disabled,\n.cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile__checkmark,\n:host(c4d-card) .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 1;\n}\n.cds--card .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--card .cds--tile__checkmark:focus,\n:host(c4d-card) .cds--tile__checkmark:focus,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n:host(c4d-card-cta) .cds--tile__checkmark:focus,\n:host(c4d-card-in-card) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-card) .cds--tile__checkmark:focus,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n  :host(c4d-card-cta) .cds--tile__checkmark:focus,\n  :host(c4d-card-in-card) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile__checkmark--persistent,\n:host(c4d-card) .cds--tile__checkmark--persistent,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark--persistent,\n:host(c4d-card-cta) .cds--tile__checkmark--persistent,\n:host(c4d-card-in-card) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n.cds--card .cds--tile__chevron,\n:host(c4d-card) .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--card .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile__chevron--interactive,\n:host(c4d-card) .cds--tile__chevron--interactive,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive,\n:host(c4d-card-cta) .cds--tile__chevron--interactive,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile__chevron--interactive *,\n.cds--card .cds--tile__chevron--interactive *::before,\n.cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-card) .cds--tile__chevron--interactive *,\n:host(c4d-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::before,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::after,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:focus,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:hover,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n.cds--card .cds--tile--expandable,\n:host(c4d-card) .cds--tile--expandable,\n:host(c4d-region-item) .cds--link .cds--tile--expandable,\n:host(c4d-card-cta) .cds--tile--expandable,\n:host(c4d-card-in-card) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n.cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n.cds--card .cds--tile--is-expanded,\n:host(c4d-card) .cds--tile--is-expanded,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded,\n:host(c4d-card-cta) .cds--tile--is-expanded,\n:host(c4d-card-in-card) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n.cds--card .cds--tile--is-selected,\n:host(c4d-card) .cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile-content,\n:host(c4d-card) .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile-content,\n:host(c4d-card-cta) .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--card .cds--tile-input,\n:host(c4d-card) .cds--tile-input,\n:host(c4d-region-item) .cds--link .cds--tile-input,\n:host(c4d-card-cta) .cds--tile-input,\n:host(c4d-card-in-card) .cds--tile-input,\n:host(c4d-card-group-item) .cds--tile-input,\n:host(c4d-card-group-item) .cds--card .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n.cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile > .cds--slug,\n.cds--card .cds--tile--expandable > div > .cds--slug,\n.cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card) .cds--tile > .cds--slug,\n:host(c4d-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-region-item) .cds--link .cds--tile > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--expandable > div > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-cta) .cds--tile > .cds--slug,\n:host(c4d-card-cta) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-in-card) .cds--tile > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n.cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n.cds--card .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:focus,\n.cds--card .cds--tile--slug.cds--tile--clickable:focus,\n.cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n.cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--slug-rounded,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug-rounded,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n.cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--card .cds--tile__chevron svg,\n  .cds--card .cds--tile__checkmark svg,\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card:focus-within .cds--tile--clickable,\n:host(c4d-card):focus-within .cds--tile--clickable,\n:host(c4d-region-item) .cds--link:focus-within .cds--tile--clickable,\n:host(c4d-card-cta):focus-within .cds--tile--clickable,\n:host(c4d-card-in-card):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item):focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--tile--clickable {\n  position: relative;\n  z-index: 2;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--card:focus-within ::slotted(c4d-image),\n.cds--card:focus-within ::slotted(c4d-card-cta-image),\n.cds--card:focus-within .cds--card__img,\n.cds--card:focus-within .cds--image,\n:host(c4d-card):focus-within ::slotted(c4d-image),\n:host(c4d-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card):focus-within .cds--card__img,\n:host(c4d-card):focus-within .cds--image,\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link:focus-within .cds--card__img,\n:host(c4d-region-item) .cds--link:focus-within .cds--image,\n:host(c4d-card-cta):focus-within ::slotted(c4d-image),\n:host(c4d-card-cta):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta):focus-within .cds--card__img,\n:host(c4d-card-cta):focus-within .cds--image,\n:host(c4d-card-in-card):focus-within ::slotted(c4d-image),\n:host(c4d-card-in-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card):focus-within .cds--card__img,\n:host(c4d-card-in-card):focus-within .cds--image,\n:host(c4d-card-group-item):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item):focus-within .cds--card__img,\n:host(c4d-card-group-item):focus-within .cds--image,\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--image,\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item):focus-within .cds--card__img,\n:host(c4d-content-group-cards-item):focus-within .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--image {\n  z-index: -1;\n}\n.cds--card:focus, .cds--card:visited, .cds--card:active,\n:host(c4d-card):focus,\n:host(c4d-card):visited,\n:host(c4d-card):active,\n:host(c4d-region-item) .cds--link:focus,\n:host(c4d-region-item) .cds--link:visited,\n:host(c4d-region-item) .cds--link:active,\n:host(c4d-card-cta):focus,\n:host(c4d-card-cta):visited,\n:host(c4d-card-cta):active,\n:host(c4d-card-in-card):focus,\n:host(c4d-card-in-card):visited,\n:host(c4d-card-in-card):active,\n:host(c4d-card-group-item):focus,\n:host(c4d-card-group-item):visited,\n:host(c4d-card-group-item):active,\n:host(c4d-card-group-item) .cds--card:focus,\n:host(c4d-card-group-item) .cds--card:visited,\n:host(c4d-card-group-item) .cds--card:active,\n:host(c4d-content-group-cards-item):focus,\n:host(c4d-content-group-cards-item):visited,\n:host(c4d-content-group-cards-item):active,\n:host(c4d-content-group-cards-item) .cds--card:focus,\n:host(c4d-content-group-cards-item) .cds--card:visited,\n:host(c4d-content-group-cards-item) .cds--card:active {\n  position: relative;\n  z-index: 2;\n  text-decoration: none;\n}\n.cds--card:focus ::slotted(c4d-image),\n.cds--card:focus .cds--image, .cds--card:visited ::slotted(c4d-image),\n.cds--card:visited .cds--image, .cds--card:active ::slotted(c4d-image),\n.cds--card:active .cds--image,\n:host(c4d-card):focus ::slotted(c4d-image),\n:host(c4d-card):focus .cds--image,\n:host(c4d-card):visited ::slotted(c4d-image),\n:host(c4d-card):visited .cds--image,\n:host(c4d-card):active ::slotted(c4d-image),\n:host(c4d-card):active .cds--image,\n:host(c4d-region-item) .cds--link:focus ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus .cds--image,\n:host(c4d-region-item) .cds--link:visited ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:visited .cds--image,\n:host(c4d-region-item) .cds--link:active ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:active .cds--image,\n:host(c4d-card-cta):focus ::slotted(c4d-image),\n:host(c4d-card-cta):focus .cds--image,\n:host(c4d-card-cta):visited ::slotted(c4d-image),\n:host(c4d-card-cta):visited .cds--image,\n:host(c4d-card-cta):active ::slotted(c4d-image),\n:host(c4d-card-cta):active .cds--image,\n:host(c4d-card-in-card):focus ::slotted(c4d-image),\n:host(c4d-card-in-card):focus .cds--image,\n:host(c4d-card-in-card):visited ::slotted(c4d-image),\n:host(c4d-card-in-card):visited .cds--image,\n:host(c4d-card-in-card):active ::slotted(c4d-image),\n:host(c4d-card-in-card):active .cds--image,\n:host(c4d-card-group-item):focus ::slotted(c4d-image),\n:host(c4d-card-group-item):focus .cds--image,\n:host(c4d-card-group-item):visited ::slotted(c4d-image),\n:host(c4d-card-group-item):visited .cds--image,\n:host(c4d-card-group-item):active ::slotted(c4d-image),\n:host(c4d-card-group-item):active .cds--image,\n:host(c4d-card-group-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus .cds--image,\n:host(c4d-card-group-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:visited .cds--image,\n:host(c4d-card-group-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:active .cds--image,\n:host(c4d-content-group-cards-item):focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus .cds--image,\n:host(c4d-content-group-cards-item):visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):visited .cds--image,\n:host(c4d-content-group-cards-item):active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):active .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:visited .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:active .cds--image {\n  z-index: -1;\n}\n.cds--card ::slotted(c4d-image),\n.cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-card) ::slotted(c4d-image),\n:host(c4d-card) ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta) ::slotted(c4d-image),\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card) ::slotted(c4d-image),\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) ::slotted(c4d-image),\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image) {\n  position: relative;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card ::slotted(c4d-image)::before,\n  .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card) ::slotted(c4d-image)::before,\n  :host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n    position: absolute;\n    background-color: var(--cds-border-inverse, #161616);\n    content: \"\";\n    inset: 0;\n    opacity: 0;\n    transition: none;\n  }\n}\n.cds--card ::slotted(c4d-image)::before,\n.cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card) ::slotted(c4d-image)::before,\n:host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n  position: absolute;\n  background-color: var(--cds-border-inverse, #161616);\n  content: \"\";\n  inset: 0;\n  opacity: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile {\n  padding: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  position: absolute;\n  background: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  opacity: 16%;\n}\n.cds--card .cds--card,\n:host(c4d-card) .cds--card,\n:host(c4d-region-item) .cds--link .cds--card,\n:host(c4d-card-cta) .cds--card,\n:host(c4d-card-in-card) .cds--card,\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-card-group-item) .cds--card .cds--card,\n:host(c4d-content-group-cards-item) .cds--card,\n:host(c4d-content-group-cards-item) .cds--card .cds--card {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n.cds--card .cds--card__wrapper,\n:host(c4d-card) .cds--card__wrapper,\n:host(c4d-region-item) .cds--link .cds--card__wrapper,\n:host(c4d-card-cta) .cds--card__wrapper,\n:host(c4d-card-in-card) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper {\n  display: flex;\n  flex: 1;\n  justify-content: space-between;\n  min-block-size: 10rem;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  display: flex;\n}\n.cds--card .cds--card__wrapper::before,\n:host(c4d-card) .cds--card__wrapper::before,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::before,\n:host(c4d-card-cta) .cds--card__wrapper::before,\n:host(c4d-card-in-card) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 50%;\n}\n.cds--card .cds--card__wrapper::after,\n:host(c4d-card) .cds--card__wrapper::after,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::after,\n:host(c4d-card-cta) .cds--card__wrapper::after,\n:host(c4d-card-in-card) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n.cds--card .cds--card__content,\n:host(c4d-card) .cds--card__content,\n:host(c4d-region-item) .cds--link .cds--card__content,\n:host(c4d-card-cta) .cds--card__content,\n:host(c4d-card-in-card) .cds--card__content,\n:host(c4d-card-group-item) .cds--card__content,\n:host(c4d-card-group-item) .cds--card .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__content {\n  display: flex;\n  flex-direction: column;\n  padding: 1rem;\n  inline-size: 100%;\n}\n.cds--card .cds--card__heading,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n  margin-block-end: 4rem;\n}\n@media (min-width: 82rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n.cds--card .cds--card__heading,\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  color: var(--cds-text-primary, #161616);\n  max-inline-size: 40rem;\n  padding-inline-end: 10%;\n}\n@media (min-width: 42rem) {\n  .cds--card .cds--card__heading,\n  .cds--card .cds--card__copy,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-card) .cds--card__copy,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__copy,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__copy,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n    padding-inline-end: 2rem;\n  }\n}\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n  margin-block-end: 2rem;\n}\n.cds--card .cds--card__img,\n:host(c4d-card) .cds--card__img,\n:host(c4d-region-item) .cds--link .cds--card__img,\n:host(c4d-card-cta) .cds--card__img,\n:host(c4d-card-in-card) .cds--card__img,\n:host(c4d-card-group-item) .cds--card__img,\n:host(c4d-card-group-item) .cds--card .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__img {\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--card__link::after,\n:host(c4d-card) .cds--card__link::after,\n:host(c4d-region-item) .cds--link .cds--card__link::after,\n:host(c4d-card-cta) .cds--card__link::after,\n:host(c4d-card-in-card) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__link::after {\n  position: absolute;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer-wrapper,\n:host(c4d-card) .cds--card__footer-wrapper,\n:host(c4d-region-item) .cds--link .cds--card__footer-wrapper,\n:host(c4d-card-cta) .cds--card__footer-wrapper,\n:host(c4d-card-in-card) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__footer-wrapper {\n  margin-block-start: auto;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-content-group-cards-item) {\n    inline-size: auto;\n    margin-inline: 1rem;\n  }\n}\n\n:host(c4d-card-group-item),\n:host(c4d-card-in-card),\n:host(c4d-card-cta),\n:host(c4d-card) {\n  outline: none;\n}\n:host(c4d-card-group-item) .cds--card__pictogram,\n:host(c4d-card-in-card) .cds--card__pictogram,\n:host(c4d-card-cta) .cds--card__pictogram,\n:host(c4d-card) .cds--card__pictogram {\n  display: flex;\n}\n:host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n  margin-block-end: 0;\n  padding-block-start: 2rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n    display: flex;\n    flex: 1;\n    padding-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item) .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card) .cds--card__pictogram-wrapper,\n:host(c4d-card-cta) .cds--card__pictogram-wrapper,\n:host(c4d-card) .cds--card__pictogram-wrapper {\n  display: flex;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram] .cds--card ::slotted(c4d-card-heading) {\n  padding-block-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-inline-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram] .cds--card .cds--card__content {\n  position: relative;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram] .cds--card .cds--card__copy {\n  margin-block: 2rem 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card svg,\n:host(c4d-card-in-card)[pictogram] .cds--card svg,\n:host(c4d-card-cta)[pictogram] .cds--card svg,\n:host(c4d-card)[pictogram] .cds--card svg {\n  position: absolute;\n  color: var(--cds-link-primary, #0f62fe);\n  inset-block-end: 1rem;\n  inset-inline-end: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-end;\n  margin-block: auto 0;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy {\n  margin-block-start: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-start;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content {\n  padding-block-end: 4rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper {\n  position: absolute;\n  inset-block-end: 1rem;\n  inset-inline-start: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]) {\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n:host(c4d-card) ::slotted(svg[slot=pictogram]) {\n  fill: currentColor;\n  margin-inline-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card) ::slotted(svg[slot=pictogram]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-in-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-cta)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card) .cds--card__copy {\n  display: flex;\n  flex-direction: column;\n  gap: 1rem;\n}\n:host(c4d-card-group-item) .cds--card__copy[hidden],\n:host(c4d-card-in-card) .cds--card__copy[hidden],\n:host(c4d-card-cta) .cds--card__copy[hidden],\n:host(c4d-card) .cds--card__copy[hidden] {\n  /* stylelint-disable declaration-no-important */\n  display: none !important;\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    padding-block-start: 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    /* stylelint-disable value-no-vendor-prefix, property-no-vendor-prefix */\n    display: -webkit-box;\n    /* stylelint-enable value-no-vendor-prefix, property-no-vendor-prefix */\n    overflow: hidden;\n    -webkit-box-orient: vertical;\n    -webkit-line-clamp: 3;\n    max-inline-size: calc(100% - 4rem);\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9) 0.25s;\n  }\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block: 2rem 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 0;\n    opacity: 0;\n    transform: translate3d(0, -16px, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9);\n    visibility: hidden;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading) {\n    opacity: 0;\n    transform: translate3d(0, 16px, 0);\n    transition-delay: 0s;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy {\n    display: block;\n    overflow: hidden;\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition-delay: 0.2s;\n    visibility: visible;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    position: absolute;\n    display: flow-root;\n    inset-block-end: 1rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 2rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]) {\n    margin-block-end: 0;\n  }\n}\n\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 100%;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 66.6666666667%;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 75%;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 56.25%;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n.cds--card.cds--card--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--card--border {\n  border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n.cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n}\n@media (min-width: 82rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n\n:host(c4d-card):not([href]) .cds--card .cds--card__copy,\n:host(c4d-card-group-item):not([href]) .cds--card .cds--card__copy {\n  margin-block-end: 0.125rem;\n}\n:host(c4d-card):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after {\n  display: none;\n}\n:host(c4d-card):not([href]):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):not([href]):focus-within ::slotted(c4d-image) {\n  z-index: 0;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-heading),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-heading) {\n  margin-block-end: auto;\n  padding-block-end: 4rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer) {\n  display: inline-flex;\n  margin-block-start: 2rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer)::after,\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer)::after {\n  position: relative;\n}\n:host(c4d-card)[color-scheme=light] .cds--card__wrapper, :host(c4d-card)[color-scheme=light]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light] .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n:host(c4d-card)[color-scheme=light][href] :hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light][href] :hover .cds--card__wrapper {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-card)[color-scheme=light][href]:active,\n:host(c4d-card)[color-scheme=light][href] a:active,\n:host(c4d-card-group-item)[color-scheme=light][href]:active,\n:host(c4d-card-group-item)[color-scheme=light][href] a:active {\n  outline: none;\n}\n:host(c4d-card)[logo] .cds--card,\n:host(c4d-card-group-item)[logo] .cds--card {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo] .cds--card__copy,\n:host(c4d-card-group-item)[logo] .cds--card__copy {\n  margin-block-end: 1rem;\n}\n:host(c4d-card)[logo]:hover,\n:host(c4d-card-group-item)[logo]:hover {\n  border-color: var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-card)[logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo]:active,\n:host(c4d-card-group-item)[logo]:active {\n  border-color: var(--cds-border-inverse, #161616);\n}\n:host(c4d-card)[logo] ::slotted(c4d-card-footer),\n:host(c4d-card-group-item)[logo] ::slotted(c4d-card-footer) {\n  block-size: 0;\n}\n:host(c4d-card)[href][logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[href][logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n:host(c4d-card[link]) ::slotted(c4d-card-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n:host(c4d-card[link]) .cds--card .cds--card__copy {\n  margin-block-start: 0;\n}\n\n:host(c4d-card-cta),\n:host(c4d-card-link-cta),\n:host(c4d-card-link) {\n  outline: none;\n}\n\n:host(c4d-card-eyebrow),\n.cds--card__eyebrow {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.5rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-eyebrow),\n  .cds--card__eyebrow {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-footer),\n:host(c4d-card-cta-footer),\n:host(c4d-card-in-card-footer),\n:host(c4d-feature-card-footer),\n:host(c4d-feature-cta-footer) {\n  display: flex;\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-footer):focus-visible,\n:host(c4d-card-cta-footer):focus-visible,\n:host(c4d-card-in-card-footer):focus-visible,\n:host(c4d-feature-card-footer):focus-visible,\n:host(c4d-feature-cta-footer):focus-visible {\n  outline: none;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: block;\n}\n\n.cds--card .cds--card__footer,\n:host(c4d-card-footer) a,\n:host(c4d-card-cta-footer) a,\n:host(c4d-card-in-card-footer) a,\n:host(c4d-feature-card-footer) a,\n:host(c4d-feature-cta-footer) a {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer:focus,\n:host(c4d-card-footer) a:focus,\n:host(c4d-card-cta-footer) a:focus,\n:host(c4d-card-in-card-footer) a:focus,\n:host(c4d-feature-card-footer) a:focus,\n:host(c4d-feature-cta-footer) a:focus {\n  outline: none;\n}\n.cds--card .cds--card__footer:hover,\n:host(c4d-card-footer) a:hover,\n:host(c4d-card-cta-footer) a:hover,\n:host(c4d-card-in-card-footer) a:hover,\n:host(c4d-feature-card-footer) a:hover,\n:host(c4d-feature-cta-footer) a:hover {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer span,\n:host(c4d-card-footer) a span,\n:host(c4d-card-cta-footer) a span,\n:host(c4d-card-in-card-footer) a span,\n:host(c4d-feature-card-footer) a span,\n:host(c4d-feature-cta-footer) a span {\n  flex: none;\n}\n.cds--card .cds--card__footer::after,\n:host(c4d-card-footer) a::after,\n:host(c4d-card-cta-footer) a::after,\n:host(c4d-card-in-card-footer) a::after,\n:host(c4d-feature-card-footer) a::after,\n:host(c4d-feature-cta-footer) a::after {\n  position: absolute;\n  z-index: 1;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer .cds--card__cta__copy,\n:host(c4d-card-footer) a .cds--card__cta__copy,\n:host(c4d-card-cta-footer) a .cds--card__cta__copy,\n:host(c4d-card-in-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-cta-footer) a .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n  max-inline-size: calc(100% - 20px - 0.5rem);\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n.cds--card .cds--card__footer .cds--card__footer__copy,\n:host(c4d-card-footer) a .cds--card__footer__copy,\n:host(c4d-card-cta-footer) a .cds--card__footer__copy,\n:host(c4d-card-in-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-cta-footer) a .cds--card__footer__copy {\n  margin-block-end: -0.125rem;\n  max-inline-size: calc(100% - 20px);\n}\n.cds--card .cds--card__footer svg,\n.cds--card .cds--card__footer ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) a svg,\n:host(c4d-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) a svg,\n:host(c4d-card-cta-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-in-card-footer) a svg,\n:host(c4d-card-in-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-card-footer) a svg,\n:host(c4d-feature-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-cta-footer) a svg,\n:host(c4d-feature-cta-footer) a ::slotted(svg[slot=icon]) {\n  display: block;\n  margin-inline-start: 0;\n  min-inline-size: 20px;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n  inline-size: 100%;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled),\n:host(c4d-card-cta-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer {\n  justify-content: flex-start;\n  inline-size: auto;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:active, :host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  text-decoration: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer::after {\n  content: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n}\n\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile {\n  border-color: var(--cds-background-inverse, #393939);\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  display: none;\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__copy,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__copy {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]):focus-within::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]):focus-within::after {\n  position: absolute;\n  z-index: 2;\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  content: \"\";\n  inset: 0;\n  outline: 1px solid var(--cds-focus-inset, #ffffff);\n  outline-offset: -3px;\n  pointer-events: none;\n}\n\n:host(c4d-card-heading),\n:host(c4d-card-link-heading) {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  color: var(--cds-text-primary, #161616);\n  margin-block-end: 4rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-heading),\n  :host(c4d-card-link-heading) {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-heading) {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\n:host(c4d-card-link-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n.cds--card-group__card ::slotted(c4d-card-eyebrow),\n.cds--card-group__card ::slotted(c4d-card-heading),\n.cds--card-group__card ::slotted(c4d-card-link-heading) {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n.cds--card-group__card:hover ::slotted(c4d-image),\n.cds--card-group__card:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n\n@media print {\n  :host(c4d-card),\n  :host(c4d-card-group-item),\n  :host(c4d-card-cta),\n  :host(c4d-card-in-card),\n  :host(c4d-content-group-cards-item) {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  :host(c4d-card) .cds--card,\n  :host(c4d-card-group-item) .cds--card,\n  :host(c4d-card-cta) .cds--card,\n  :host(c4d-card-in-card) .cds--card,\n  :host(c4d-content-group-cards-item) .cds--card {\n    border: none;\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-card) ::slotted(c4d-image),\n  :host(c4d-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card) .cds--image,\n  :host(c4d-card-group-item) ::slotted(c4d-image),\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-group-item) .cds--image,\n  :host(c4d-card-cta) ::slotted(c4d-image),\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-cta) .cds--image,\n  :host(c4d-card-in-card) ::slotted(c4d-image),\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-in-card) .cds--image,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image),\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-content-group-cards-item) .cds--image {\n    display: none;\n  }\n  .cds--card {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  .cds--card .cds--card__img,\n  .cds--card .cds--card__image_img,\n  .cds--card .cds--image,\n  .cds--card .cds--card__video-thumbnail {\n    display: none;\n  }\n}\n:host(c4d-card[disabled]) .cds--card,\n:host(c4d-region-item[disabled]) .cds--card {\n  cursor: not-allowed;\n}\n:host(c4d-card[disabled]) .cds--card__copy,\n:host(c4d-card[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-card[disabled]) ::slotted(c4d-card-heading),\n:host(c4d-region-item[disabled]) .cds--card__copy,\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-heading) {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n:host(c4d-card-cta-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  justify-content: space-between;\n}\n\n:host(c4d-card-footer[href])::after {\n  position: relative;\n}"]);

/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

let PICTOGRAM_PLACEMENT;
(function (PICTOGRAM_PLACEMENT) {
  PICTOGRAM_PLACEMENT["TOP"] = "top";
  PICTOGRAM_PLACEMENT["BOTTOM"] = "bottom";
})(PICTOGRAM_PLACEMENT || (PICTOGRAM_PLACEMENT = {}));

let _$L = t => t,
  _t$M,
  _t2$l,
  _t3$c,
  _t4$8,
  _t5$8,
  _t6$6,
  _t7$6,
  _t8$6,
  _t9$5,
  _t10$5,
  _t11$5,
  _t12$4;
function ownKeys$6(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$6(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$6(Object(t), !0).forEach(function (r) { _defineProperty$7(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$6(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$7(e, r, t) { return (r = _toPropertyKey$Q(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$P(e, r, t, i) { var o = _getDecoratorsApi$P(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$P(s.d.map(_createElementDescriptor$P)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$P() { _getDecoratorsApi$P = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$P(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$P(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$Q(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$P(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$P(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$P(e) { var r, t = _toPropertyKey$Q(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$P(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$P(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$P(o.descriptor) || _isDataDescriptor$P(i.descriptor)) { if (_hasDecorators$P(o) || _hasDecorators$P(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$P(o)) { if (_hasDecorators$P(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$P(o, i); } } else r.push(o); } return r; }
function _hasDecorators$P(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$P(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$P(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$Q(t) { var i = _toPrimitive$Q(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$Q(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$P(r) { return _arrayWithHoles$Q(r) || _iterableToArray$P(r) || _unsupportedIterableToArray$Q(r) || _nonIterableRest$Q(); }
function _nonIterableRest$Q() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$Q(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$Q(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$Q(r, a) : void 0; } }
function _arrayLikeToArray$Q(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$P(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$Q(r) { if (Array.isArray(r)) return r; }
function _superPropGet$x(t, e, r, o) { var p = _get$r(_getPrototypeOf$r(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$r() { return _get$r = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$r(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$r.apply(null, arguments); }
function _superPropBase$r(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$r(t));); return t; }
function _getPrototypeOf$r(t) { return _getPrototypeOf$r = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$r(t); }
const {
  prefix: prefix$t,
  stablePrefix: c4dPrefix$P
} = settings;

/**
 * The table mapping slot name with the private property name that indicates the
 * existence of the slot content.
 */
const slotExistencePropertyNames = {
  image: '_hasImage',
  pictogram: '_hasPictogram',
  eyebrow: '_hasEyebrow'
};

/**
 * Card.
 *
 * @element c4d-card
 * @slot eyebrow - The eyebrow content.
 * @slot heading - The heading content.
 * @slot image - The image content.
 * @slot footer - The footer content.
 * @csspart caption - The Caption (default heading). Usage: `c4d-card::part(caption)`
 * @csspart copy - The Copy. Usage: `c4d-card::part(copy)`
 * @csspart container - The Inner content container. Usage: `c4d-card::part(container)`
 * @csspart video-thumbnail - The video thumbnail. Usage: `c4d-card::part(video-thumbnail)`
 * @csspart disabled-link - . Disabled link. Usage: `c4d-card::part(disabled-link)`
 * @csspart wrapper - The component wrapper. Usage: `c4d-card::part(wrapper)`
 * @csspart content - The content container. Usage: `c4d-card::part(content)`
 * @csspart link - Active link. Usage: `c4d-card::part(link)`
 */
let C4DCard = _decorate$P([carbonElement(`${c4dPrefix$P}-card`)], function (_initialize, _CTAMixin) {
  class C4DCard extends _CTAMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCard,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'cta-type'
      })],
      key: "ctaType",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasImage",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasCopy",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasPictogram",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasEyebrow",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'no-poster',
        type: Boolean
      })],
      key: "noPoster",
      value: void 0
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * `true` if there is copy content.
       */

      /**
       * `true` if there is image content.
       */

      /**
       * `true` if there is copy content.
       */

      /**
       * `true` if there is a pictogram.
       */

      /**
       * `true` if there is eyebrow content.
       */

      /**
       * Handles `slotchange` event for slots other than the copy slot.
       */
      function _handleSlotChange({
        target
      }) {
        const {
          name
        } = target;
        this[slotExistencePropertyNames[name]] = target.assignedNodes().some(node => node.nodeType !== Node.TEXT_NODE || node.textContent.trim());
      }

      /**
       * Handles `slotchange` event for the copy slot.
       */
    }, {
      kind: "method",
      key: "_handleCopySlotChange",
      value: function _handleCopySlotChange({
        target
      }) {
        this._hasCopy = target.assignedNodes().some(node => node.nodeType !== Node.TEXT_NODE || node.textContent.trim());
      }

      /**
       * @returns The heading content.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderHeading",
      value: function _renderHeading() {
        const {
          ctaType,
          videoName,
          formatVideoCaption: formatVideoCaptionInEffect
        } = this;
        if (ctaType !== CTA_TYPE.VIDEO) {
          return x(_t$M || (_t$M = _$L`<div part="heading-wrapper">
        <slot name="heading"></slot>
      </div>`));
        }
        const formattedVideoName = formatVideoCaptionInEffect({
          name: videoName
        });
        this.dispatchEvent(new CustomEvent(this.constructor.eventVideoTitleUpdated, {
          bubbles: true,
          composed: true
        }));
        return x(_t2$l || (_t2$l = _$L`
      <div part="heading-wrapper">
        <slot name="heading">
          <c4d-card-heading>${0}</c4d-card-heading>
        </slot>
      </div>
    `), formattedVideoName);
      }

      /**
       * @returns The copy content.
       */
    }, {
      kind: "method",
      key: "_renderCopy",
      value: function _renderCopy() {
        const {
          _hasCopy: hasCopy
        } = this;
        return x(_t3$c || (_t3$c = _$L`
      <div ?hidden="${0}" class="${0}--card__copy" part="copy">
        <slot @slotchange="${0}"></slot>
      </div>
    `), !hasCopy, prefix$t, this._handleCopySlotChange);
      }
    }, {
      kind: "method",
      key: "_renderImage",
      value: function _renderImage() {
        const {
          ctaType,
          videoName,
          videoThumbnailUrl,
          _hasImage: hasImage,
          noPoster
        } = this;
        const image = hasImage || ctaType !== CTA_TYPE.VIDEO || noPoster ? undefined : x(_t4$8 || (_t4$8 = _$L`
            <c4d-image
              class="${0}--card__video-thumbnail"
              part="video-thumbnail"
              alt="${0}"
              default-src="${0}">
            </c4d-image>
          `), prefix$t, videoName, videoThumbnailUrl);
        return x(_t5$8 || (_t5$8 = _$L`
      <div part="image-wrapper" class="${0}--card__image-wrapper">
        <slot name="image" @slotchange="${0}">
          ${0}
        </slot>
      </div>
    `), prefix$t, this._handleSlotChange, image);
      }

      /**
       * @returns The disabled link content.
       */
    }, {
      kind: "method",
      key: "_renderDisabledLink",
      value: function _renderDisabledLink() {
        const {
          _classes: classes
        } = this;
        return x(_t6$6 || (_t6$6 = _$L`
      <div id="link" class="${0}" part="disabled-link">
        ${0}
      </div>
    `), classes, this._renderInner());
      }
    }, {
      kind: "method",
      key: "_renderPictogramSlot",
      value: function _renderPictogramSlot(placement) {
        const {
          _handleSlotChange: handleSlotChange,
          _hasPictogram: hasPictogram
        } = this;
        return x(_t7$6 || (_t7$6 = _$L`
      <div
        part="pictogram-wrapper"
        class="${0}--card__pictogram-wrapper ${0}">
        <slot
          name="pictogram"
          data-pictogram-placement="${0}"
          @slotchange="${0}"></slot>
      </div>
    `), prefix$t, !hasPictogram ? `${prefix$t}--card__pictogram-wrapper--empty` : '', placement, handleSlotChange);
      }
    }, {
      kind: "method",
      key: "_renderEyebrowSlot",
      value: function _renderEyebrowSlot() {
        const {
          _hasEyebrow: hasEyebrow
        } = this;
        return x(_t8$6 || (_t8$6 = _$L`<div
      part="eyebrow-wrapper"
      class="${0}--card__eyebrow-wrapper ${0}">
      <slot name="eyebrow" @slotchange="${0}"></slot>
    </div>`), prefix$t, !hasEyebrow ? `${prefix$t}--card__eyebrow-wrapper--empty` : '', this._handleSlotChange);
      }

      /**
       * @returns The inner content.
       */
    }, {
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        const {
          _hasPictogram: hasPictogram,
          _hasCopy: hasCopy
        } = this;
        return x(_t9$5 || (_t9$5 = _$L`
      ${0}
      <div
        class="${0}--card__wrapper ${0} ${0}"
        part="wrapper">
        <div class="${0}--card__content" part="content">
          ${0}
          ${0}
          ${0}
          ${0}
          ${0}
          ${0}
          ${0}
          <div part="footer-wrapper" class="${0}--card__footer-wrapper">
            <slot name="footer"></slot>
          </div>
        </div>
      </div>
    `), this._renderImage(), prefix$t, hasPictogram ? `${prefix$t}--card__pictogram` : '', hasPictogram && hasCopy ? `${prefix$t}--card__motion` : '', prefix$t, this._renderEyebrowSlot(), this.pictogramPlacement === PICTOGRAM_PLACEMENT.TOP ? this._renderPictogramSlot(PICTOGRAM_PLACEMENT.TOP) : '', this.pictogramPlacement !== PICTOGRAM_PLACEMENT.TOP || !hasPictogram ? this._renderHeading() : null, this.pictogramPlacement === PICTOGRAM_PLACEMENT.BOTTOM || !hasPictogram ? this._renderCopy() : '', this.pictogramPlacement === PICTOGRAM_PLACEMENT.BOTTOM ? this._renderPictogramSlot(PICTOGRAM_PLACEMENT.BOTTOM) : '', hasPictogram && this.pictogramPlacement === PICTOGRAM_PLACEMENT.TOP ? this._renderHeading() : null, hasPictogram && this.pictogramPlacement === PICTOGRAM_PLACEMENT.TOP ? this._renderCopy() : '', prefix$t);
      }

      /**
       * @returns The CTA arrow.
       *
       */
    }, {
      kind: "method",
      key: "_renderArrow",
      value: function _renderArrow() {
        var _this$querySelector;
        const isLTR = window.getComputedStyle(this).direction.toUpperCase() === 'LTR';
        return x(_t10$5 || (_t10$5 = _$L`
      <a
        class="${0}"
        part="link"
        href="${0}"
        aria-label="${0}"
        >${0}</a
      >
    `), `${prefix$t}--card__link`, l(this.href), ((_this$querySelector = this.querySelector(`${c4dPrefix$P}-card-heading`)) === null || _this$querySelector === void 0 ? void 0 : _this$querySelector.textContent) || '', isLTR ? svgResultCarbonIcon$D() : svgResultCarbonIcon$B());
      }
      /**
       * The color scheme.
       * A typical use case of using another color scheme of card is having a "CTA" purpose of card at the last in card group.
       *
       * Color scheme options are: "inverse" and "regular"
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'color-scheme',
        reflect: true
      })],
      key: "colorScheme",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'pictogram-placement',
        reflect: true
      })],
      key: "pictogramPlacement",
      value() {
        return PICTOGRAM_PLACEMENT.BOTTOM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "link",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "logo",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [i$1('div')],
      key: "_linkNode",
      value: void 0
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * Link `href`.
       */
      /**
       * Pictogram placement
       */
      /**
       * Whether or not to apply the link style.
       */
      /**
       * Whether or not to apply the logo style.
       */
      function updated(changedProperties) {
        _superPropGet$x(C4DCard, "updated", this, 3)([changedProperties]);
        const {
          colorScheme,
          disabled,
          href,
          _linkNode: linkNode,
          ctaType
        } = this;
        if (changedProperties.has('ctaType') || changedProperties.has('disabled') || changedProperties.has('formatCaption') || changedProperties.has('formatDuration') || changedProperties.has('videoDuration') || changedProperties.has('videoName')) {
          var _this$querySelector2;
          const {
            ctaType: _ctaType,
            videoDuration,
            videoName,
            videoDescription,
            formatVideoCaption: formatVideoCaptionInEffect,
            formatVideoDuration: formatVideoDurationInEffect
          } = this;
          const footer = this.querySelector(this.constructor.selectorFooter);
          const headingText = (_this$querySelector2 = this.querySelector(`${c4dPrefix$P}-card-heading`)) === null || _this$querySelector2 === void 0 ? void 0 : _this$querySelector2.textContent;
          const copyText = this.textContent;
          if (footer) {
            const ariaTitle = videoName || headingText || copyText;
            let ariaDuration = '';
            if (videoDuration !== undefined) {
              ariaDuration = `, DURATION ${videoDuration}`;
            }
            footer.disabled = disabled;
            footer.altAriaLabel = `${ariaTitle}${ariaDuration}`;
            footer.ctaType = _ctaType;
            footer.videoDuration = videoDuration;
            footer.videoName = videoName;
            footer.videoDescription = videoDescription;
            if (formatVideoCaptionInEffect) {
              footer.formatVideoCaption = formatVideoCaptionInEffect;
            }
            if (formatVideoDurationInEffect) {
              footer.formatVideoDuration = formatVideoDurationInEffect;
            }
          }
        }
        if (changedProperties.has('colorScheme') || changedProperties.has('href')) {
          var _this$querySelector3;
          const headingText = (_this$querySelector3 = this.querySelector(`${c4dPrefix$P}-card-heading`)) === null || _this$querySelector3 === void 0 ? void 0 : _this$querySelector3.textContent;
          const copyText = this.textContent;
          const footer = this.querySelector(this.constructor.selectorFooter);
          if (footer && href) {
            footer.colorScheme = colorScheme;
            footer.parentHref = href;
            footer.ctaType = ctaType;
            footer.href = href;
            footer.altAriaLabel = headingText || copyText;
          }
        }
        if (linkNode) {
          linkNode.classList.add(`${prefix$t}--tile`);
          linkNode.classList.add(`${prefix$t}--card`);
          linkNode.classList.toggle(`${prefix$t}--tile--clickable`, Boolean(href));
          linkNode.classList.toggle(`${prefix$t}--card--link`, Boolean(href));
          linkNode.classList.toggle(`${prefix$t}--card--inverse`, colorScheme === BASIC_COLOR_SCHEME.INVERSE);
          linkNode.classList.toggle(`${prefix$t}--link--disabled`, Boolean(this.disabled));
        }
        if (this._hasPictogram) {
          this.setAttribute('pictogram', '');
        } else {
          this.removeAttribute('pictogram');
        }
        const copyElement = this.querySelector('p');
        if (this._hasCopy && copyElement !== null && copyElement !== void 0 && copyElement.innerText) {
          var _copyElement$firstEle;
          copyElement.innerHTML = `${markdownToHtml(copyElement === null || copyElement === void 0 ? void 0 : copyElement.innerText, {
            bold: false
          })}`;
          (_copyElement$firstEle = copyElement.firstElementChild) === null || _copyElement$firstEle === void 0 || _copyElement$firstEle.setAttribute('style', 'all:unset;');
        }
      }

      /**
       * Handles card with video heading and applies the set same height function.
       *
       * @param event The event.
       */
      // @ts-ignore: The decorator refers to this method but TS thinks this method is not referred to
    }, {
      kind: "field",
      key: "_handleVideoTitleUpdate",
      value() {
        return async event => {
          const {
            videoId
          } = event.detail || {};
          if (event && this.ctaType === CTA_TYPE.VIDEO && this.href === videoId) {
            var _heading$textContent, _footer$textContent;
            const {
              videoDuration,
              videoName
            } = event.detail;
            const {
              formatVideoDuration,
              formatVideoCaption
            } = this;
            const formattedVideoDuration = formatVideoDuration({
              duration: !videoDuration ? videoDuration : videoDuration * 1000
            });
            this.videoDuration ? null : this.videoDuration = formattedVideoDuration;
            this.videoTitle = formatVideoCaption({
              name: videoName
            });
            const heading = this.querySelector(`${c4dPrefix$P}-card-heading`);
            const footer = this.querySelector(`${c4dPrefix$P}-card-footer`);
            if ((heading === null || heading === void 0 || (_heading$textContent = heading.textContent) === null || _heading$textContent === void 0 ? void 0 : _heading$textContent.trim()) === '') {
              const title = document.createTextNode(this.videoTitle);
              heading === null || heading === void 0 || heading.appendChild(title);
            }
            if ((footer === null || footer === void 0 || (_footer$textContent = footer.textContent) === null || _footer$textContent === void 0 ? void 0 : _footer$textContent.trim()) === '') {
              const title = document.createTextNode(formattedVideoDuration);
              footer === null || footer === void 0 || footer.appendChild(title);
            }
          }
        };
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet$x(C4DCard, "connectedCallback", this, 3)([]);
        const {
          eventRequestAdditionalVideoData
        } = this.constructor;
        document.addEventListener(eventRequestAdditionalVideoData, this._handleVideoTitleUpdate);
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        _superPropGet$x(C4DCard, "disconnectedCallback", this, 3)([]);
        const {
          eventRequestAdditionalVideoData
        } = this.constructor;
        document.removeEventListener(eventRequestAdditionalVideoData, this._handleVideoTitleUpdate);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return this._hasPictogram ? x(_t11$5 || (_t11$5 = _$L`
          <div part="container">
            ${0} ${0}
          </div>
        `), this._renderInner(), this._renderArrow()) : x(_t12$4 || (_t12$4 = _$L` <div part="container">${0}</div> `), this._renderInner());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$P}--card`;
      }

      /**
       * A selector that will return the child footer.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorFooter",
      value: function () {
        return `${c4dPrefix$P}-card-footer`;
      }

      /**
       * The name of the custom event fired when there is a user gesture to run the action.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventRequestAdditionalVideoData",
      value: function () {
        return `${c4dPrefix$P}-cta-request-additional-video-data`;
      }

      /**
       * The name of the custom event fired when the video title is updated
       */
    }, {
      kind: "get",
      static: true,
      key: "eventVideoTitleUpdated",
      value: function () {
        return `${c4dPrefix$P}-card-video-title-updated`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread$6(_objectSpread$6({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$c;
      }
    }]
  };
}, CTAMixin(StableSelectorMixin(CDSLink)));

let _$K = t => t,
  _t$L,
  _t2$k,
  _t3$b;
function _decorate$O(e, r, t, i) { var o = _getDecoratorsApi$O(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$O(s.d.map(_createElementDescriptor$O)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$O() { _getDecoratorsApi$O = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$O(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$O(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$P(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$O(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$O(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$O(e) { var r, t = _toPropertyKey$P(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$O(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$O(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$O(o.descriptor) || _isDataDescriptor$O(i.descriptor)) { if (_hasDecorators$O(o) || _hasDecorators$O(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$O(o)) { if (_hasDecorators$O(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$O(o, i); } } else r.push(o); } return r; }
function _hasDecorators$O(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$O(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$O(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$P(t) { var i = _toPrimitive$P(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$P(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$O(r) { return _arrayWithHoles$P(r) || _iterableToArray$O(r) || _unsupportedIterableToArray$P(r) || _nonIterableRest$P(); }
function _nonIterableRest$P() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$P(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$P(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$P(r, a) : void 0; } }
function _arrayLikeToArray$P(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$O(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$P(r) { if (Array.isArray(r)) return r; }
function _superPropGet$w(t, e, r, o) { var p = _get$q(_getPrototypeOf$q(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$q() { return _get$q = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$q(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$q.apply(null, arguments); }
function _superPropBase$q(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$q(t));); return t; }
function _getPrototypeOf$q(t) { return _getPrototypeOf$q = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$q(t); }
const {
  prefix: prefix$s,
  stablePrefix: c4dPrefix$O
} = settings;

/**
 * Region item.
 *
 * @element c4d-region-item
 * @csspart button - Targets all buttons  - Usage: `c4d-region-item::part(button)`
 * @csspart button--disabled - The disabled button - Usage: `c4d-region-item::part(button--disabled)`
 * @csspart button--enabled - The enabled button - Usage: `:c4d-region-item:part(button--enabled)`
 * @csspart content- Targets all content wrappers - Usage: `c4d-region-item::part(content)`
 * @csspart disabled-content - The disabled content wrapper - Usage: `c4d-region-item::part(disabled-content)`
 * @csspart enabled-content - The enabled content wrapper - Usage: `:c4d-region-item:part(enabled-content)`
 */
_decorate$O([carbonElement(`${c4dPrefix$O}-region-item`)], function (_initialize, _C4DCard) {
  class C4DRegionItem extends _C4DCard {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DRegionItem,
    d: [{
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "name",
      value() {
        return '';
      }
    }, {
      kind: "field",
      key: "_cardClasses",
      value() {
        return o$2({
          [`${prefix$s}--tile`]: true,
          [`${prefix$s}--card`]: true,
          [`${prefix$s}--tile--clickable`]: true,
          [`${prefix$s}--card--link`]: true
        });
      }
    }, {
      kind: "method",
      key: "_renderDisabledLink",
      value:
      /**
       * `true` if this region has no countries.
       */

      /**
       * The region name.
       */

      /**
       * @returns The disabled link content.
       */
      function _renderDisabledLink() {
        const {
          _classes: classes,
          _cardClasses: cardClasses
        } = this;
        return x(_t$L || (_t$L = _$K`
      <button
        id="link"
        class="${0}"
        disabled
        type="button"
        part="button button--disabled">
        <div class="${0}" part="content disabled-content">
          ${0}
        </div>
      </button>
    `), classes, cardClasses, this._renderInner());
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _classes: classes,
          disabled,
          _cardClasses: cardClasses
        } = this;
        return disabled ? this._renderDisabledLink() : x(_t2$k || (_t2$k = _$K`
          <button
            id="link"
            class="${0}"
            type="button"
            part="button button--enabled">
            <div class="${0}" part="content enabled-content">
              ${0}
            </div>
          </button>
        `), classes, cardClasses, this._renderInner());
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('name')) {
          const {
            name
          } = this;
          this.dataset.autoId = `${c4dPrefix$O}--locale-modal__geo-btn-${name}`;
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value: function () {
        return i$4(_t3$b || (_t3$b = _$K`
      ${0}${0}
    `), _superPropGet$w(C4DRegionItem, "styles", this), styles$h);
      }
    }]
  };
}, C4DCard);

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function() {
  return root$1.Date.now();
};

var now$1 = now;

/** Used to match a single whitespace character. */
var reWhitespace = /\s/;

/**
 * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
 * character of `string`.
 *
 * @private
 * @param {string} string The string to inspect.
 * @returns {number} Returns the index of the last non-whitespace character.
 */
function trimmedEndIndex(string) {
  var index = string.length;

  while (index-- && reWhitespace.test(string.charAt(index))) {}
  return index;
}

/** Used to match leading whitespace. */
var reTrimStart = /^\s+/;

/**
 * The base implementation of `_.trim`.
 *
 * @private
 * @param {string} string The string to trim.
 * @returns {string} Returns the trimmed string.
 */
function baseTrim(string) {
  return string
    ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
    : string;
}

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject$1(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject$1(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

/** Error message constants. */
var FUNC_ERROR_TEXT$1 = 'Expected a function';

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax$1 = Math.max,
    nativeMin$1 = Math.min;

/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
  var lastArgs,
      lastThis,
      maxWait,
      result,
      timerId,
      lastCallTime,
      lastInvokeTime = 0,
      leading = false,
      maxing = false,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT$1);
  }
  wait = toNumber(wait) || 0;
  if (isObject$1(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax$1(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }

  function invokeFunc(time) {
    var args = lastArgs,
        thisArg = lastThis;

    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time;
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait);
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result;
  }

  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime,
        timeWaiting = wait - timeSinceLastCall;

    return maxing
      ? nativeMin$1(timeWaiting, maxWait - timeSinceLastInvoke)
      : timeWaiting;
  }

  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime;

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
  }

  function timerExpired() {
    var time = now$1();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time));
  }

  function trailingEdge(time) {
    timerId = undefined;

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = undefined;
    return result;
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(now$1());
  }

  function debounced() {
    var time = now$1(),
        isInvoking = shouldInvoke(time);

    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a throttled function that only invokes `func` at most once per
 * every `wait` milliseconds. The throttled function comes with a `cancel`
 * method to cancel delayed `func` invocations and a `flush` method to
 * immediately invoke them. Provide `options` to indicate whether `func`
 * should be invoked on the leading and/or trailing edge of the `wait`
 * timeout. The `func` is invoked with the last arguments provided to the
 * throttled function. Subsequent calls to the throttled function return the
 * result of the last `func` invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the throttled function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.throttle` and `_.debounce`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to throttle.
 * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=true]
 *  Specify invoking on the leading edge of the timeout.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new throttled function.
 * @example
 *
 * // Avoid excessively updating the position while scrolling.
 * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
 *
 * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
 * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
 * jQuery(element).on('click', throttled);
 *
 * // Cancel the trailing throttled invocation.
 * jQuery(window).on('popstate', throttled.cancel);
 */
function throttle(func, wait, options) {
  var leading = true,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  if (isObject$1(options)) {
    leading = 'leading' in options ? !!options.leading : leading;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }
  return debounce(func, wait, {
    'leading': leading,
    'maxWait': wait,
    'trailing': trailing
  });
}

function _defineProperty$6(e, r, t) { return (r = _toPropertyKey$O(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey$O(t) { var i = _toPrimitive$O(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$O(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * @param Base The base class.
 * @returns A mix-in that handles `input` event and makes throtted calls to `_handleThrottledInput`.
 */
const ThrottledInputMixin = Base => {
  class ThrottledInputMixinImpl extends Base {
    constructor(...args) {
      super(...args);
      /**
       * The handle for the listener of `input` event.
       *
       * @private
       */
      _defineProperty$6(this, "_hInputToBeThrottled", null);
      /**
       * The throttled listener of `input` event.
       *
       * @private
       */
      _defineProperty$6(this, "_throttledHandleInput", null);
    }
    /**
     * Handles the throttled `input` event.
     *
     * @param event The event.
     * @protected
     */
    /**
     * Handles `input` event on the search box.
     *
     * @param event The event.
     * @private
     */
    _invokeHandleThrottledInput(event) {
      var _this$_throttledHandl;
      (_this$_throttledHandl = this._throttledHandleInput) === null || _this$_throttledHandl === void 0 || _this$_throttledHandl.call(this, event);
    }

    /**
     * Updates the throttled listener of `input` event upon change in `inputTimeout`.
     *
     * @private
     */
    _updateThrottledHandleInput() {
      if (this._throttledHandleInput) {
        this._throttledHandleInput.cancel();
        this._throttledHandleInput = null;
      }
      this._throttledHandleInput = throttle(this._handleThrottledInput, this.inputTimeout);
    }

    /**
     * The throttle timeout to run query upon user input.
     */

    connectedCallback() {
      // TS seems to miss `HTMLElement.prototype.connectedCallback()` definition
      // @ts-ignore
      super.connectedCallback();
      const {
        eventInput
      } = this.constructor;
      this._hInputToBeThrottled = on$1(this, eventInput, this._invokeHandleThrottledInput);
      this._updateThrottledHandleInput();
    }
    disconnectedCallback() {
      if (this._throttledHandleInput) {
        this._throttledHandleInput.cancel();
        this._throttledHandleInput = null;
      }
      if (this._hInputToBeThrottled) {
        this._hInputToBeThrottled = this._hInputToBeThrottled.release();
      }
      // TS seems to miss `HTMLElement.prototype.disconnectedCallback()` definition
      // @ts-ignore
      super.disconnectedCallback();
    }
    updated(changedProperties) {
      if (changedProperties.has('inputTimeout')) {
        this._updateThrottledHandleInput();
      }
    }

    /**
     * The event that represents the user input gesture.
     */
  }
  _defineProperty$6(ThrottledInputMixinImpl, "eventInput", 'input');
  return ThrottledInputMixinImpl;
};

let _$J = t => t,
  _t$K;
function _decorate$N(e, r, t, i) { var o = _getDecoratorsApi$N(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$N(s.d.map(_createElementDescriptor$N)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$N() { _getDecoratorsApi$N = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$N(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$N(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$N(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$N(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$N(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$N(e) { var r, t = _toPropertyKey$N(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$N(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$N(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$N(o.descriptor) || _isDataDescriptor$N(i.descriptor)) { if (_hasDecorators$N(o) || _hasDecorators$N(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$N(o)) { if (_hasDecorators$N(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$N(o, i); } } else r.push(o); } return r; }
function _hasDecorators$N(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$N(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$N(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$N(t) { var i = _toPrimitive$N(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$N(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$N(r) { return _arrayWithHoles$O(r) || _iterableToArray$N(r) || _unsupportedIterableToArray$O(r) || _nonIterableRest$O(); }
function _nonIterableRest$O() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$O(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$O(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$O(r, a) : void 0; } }
function _arrayLikeToArray$O(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$N(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$O(r) { if (Array.isArray(r)) return r; }
function _superPropGet$v(t, e, r, o) { var p = _get$p(_getPrototypeOf$p(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$p() { return _get$p = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$p(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$p.apply(null, arguments); }
function _superPropBase$p(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$p(t));); return t; }
function _getPrototypeOf$p(t) { return _getPrototypeOf$p = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$p(t); }
const {
  prefix: prefix$r,
  stablePrefix: c4dPrefix$N
} = settings;

/**
 * @param target The strings to find the given `searchText` within.
 * @param searchText The search string.
 * @returns `true` if there is a match.
 */
function search(target, searchText) {
  const isEmpty = !target || !target.some(Boolean);
  if (isEmpty || !searchText) {
    return true;
  }
  return target.some(item => item && item.toLowerCase().indexOf(searchText.toLowerCase()) >= 0);
}

/**
 * Locale search box.
 *
 * @element c4d-locale-search
 * @csspart filter - The filter. Usage: `c4d-locale-search::part(filter)`
 * @csspart search - The search. Usage: `c4d-locale-search::part(search)`
 * @csspart aria-updates - The hidden div between searchbox and search-text. Usage: `c4d-locale-search::part(aria-updates)`
 * @csspart search-text - The search text. Usage: `c4d-locale-search::part(search-text)`
 * @csspart list - The list. Usage: `c4d-locale-search::part(ist)`
 * @csspart searchbox - The searchbox. Usage: `c4d-locale-search::part(searchbox)`
 */
_decorate$N([carbonElement(`${c4dPrefix$N}-locale-search`)], function (_initialize, _ThrottedInputMixin) {
  class C4DLocaleSearch extends _ThrottedInputMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLocaleSearch,
    d: [{
      kind: "field",
      decorators: [i$1(`.${c4dPrefix$N}--locale-modal__list`)],
      key: "_listNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasAvailableItem",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [i$1(`${prefix$r}-search`)],
      key: "_searchNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('[aria-live]')],
      key: "_liveRegion",
      value: void 0
    }, {
      kind: "method",
      key: "_updateSearchResults",
      value:
      /**
       * The container for the locale list.
       */

      /**
       * `true` if there is one or more search result.
       */

      /**
       * The search box.
       */

      /**
       * Updates the search results.
       *
       * @param searchText The search text.
       */
      function _updateSearchResults(searchText) {
        const {
          selectorItem
        } = this.constructor;
        const {
          region: currentRegion,
          _liveRegion: liveRegion
        } = this;
        let count = 0;
        forEach(this.querySelectorAll(selectorItem), item => {
          const {
            country,
            language,
            region
          } = item;
          const matches = region === currentRegion && search([country, language], searchText);
          if (matches) {
            count++;
          }
          item.hidden = !matches;
        });
        this._hasAvailableItem = count > 0;
        if (liveRegion) {
          const announcement = count === 1 ? `${count} result` : `${count} results`;
          liveRegion.innerText = announcement;
        }
      }
    }, {
      kind: "method",
      key: "_handleThrottledInput",
      value: function _handleThrottledInput(event) {
        this._updateSearchResults(event.detail.value);
      }

      /**
       * The text for the label for the UI showing the available locales.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'availability-label-text'
      })],
      key: "availabilityLabelText",
      value() {
        return 'This page is available in the following locations and languages';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'close-button-assistive-text'
      })],
      key: "closeButtonAssistiveText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Number,
        attribute: 'input-timeout'
      })],
      key: "inputTimeout",
      value() {
        return 200;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'label-text'
      })],
      key: "labelText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "placeholder",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "region",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'locales-selector';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'unavailability-label-text'
      })],
      key: "unavailabilityLabelText",
      value() {
        return 'This page is unavailable in your preferred location or language';
      }
    }, {
      kind: "method",
      key: "focus",
      value:
      /**
       * The assistive text for the close button in the search box.
       */
      /**
       * The throttle timeout to run query upon user input.
       */
      /**
       * The label text for the search box.
       */
      /**
       * The placeholder text for the search box.
       */
      /**
       * The current region.
       */
      /**
       * The shadow slot this locale search box should be in.
       */
      /**
       * The text for the label for the UI showing no available locale.
       */
      /**
       * Focus on first focusable element in shadow DOM
       */
      function focus() {
        // @ts-ignore: Ultil `delegatesFocus` is added to `ShadowRoot` definition
        if (this.shadowRoot.delegatesFocus) {
          _superPropGet$v(C4DLocaleSearch, "focus", this, 3)([]);
        } else {
          const {
            selectorTabable
          } = this.constructor;
          const delegateTarget = this.shadowRoot.querySelector(selectorTabable);
          if (delegateTarget) {
            delegateTarget.focus();
          } else {
            _superPropGet$v(C4DLocaleSearch, "focus", this, 3)([]);
          }
        }
      }

      /**
       * Resets the search box and the scroll position.
       */
    }, {
      kind: "method",
      key: "reset",
      value: function reset() {
        const {
          _listNode: listNode,
          _searchNode: searchNode
        } = this;
        if (listNode) {
          listNode.scrollTop = 0;
        }
        if (searchNode) {
          searchNode.value = '';
          this._updateSearchResults('');
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        const {
          _searchNode: searchNode
        } = this;
        if (searchNode) {
          this._updateSearchResults(searchNode.value);
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('region')) {
          const {
            selectorItem
          } = this.constructor;
          const {
            region
          } = this;
          forEach(this.querySelectorAll(selectorItem), item => {
            item.hidden = item.region !== region;
          });
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          availabilityLabelText,
          closeButtonAssistiveText,
          labelText,
          placeholder,
          unavailabilityLabelText,
          _hasAvailableItem: hasAvailableItem
        } = this;
        return x(_t$K || (_t$K = _$J`
      <div class="${0}--locale-modal__filter" part="filter">
        <div class="${0}--locale-modal__search" part="search">
          <cds-search
            part="searchbox"
            close-button-assistive-text="${0}"
            label-text="${0}"
            placeholder="${0}"
            size="${0}"
            data-autoid="${0}--locale-modal__filter">
          </cds-search>
          <div
            class="${0}--visually-hidden"
            aria-live="polite"
            part="aria-updates"></div>
          <p class="${0}--locale-modal__search-text" part="search-text">
            ${0}
          </p>
        </div>
        <div class="${0}--locale-modal__list" part="list" role="list">
          <slot></slot>
        </div>
      </div>
    `), c4dPrefix$N, c4dPrefix$N, closeButtonAssistiveText, labelText, placeholder, INPUT_SIZE.LARGE, c4dPrefix$N, prefix$r, c4dPrefix$N, hasAvailableItem ? availabilityLabelText : unavailabilityLabelText, c4dPrefix$N);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$N}--locale-search`;
      }

      /**
       * A selector selecting the locale item,
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTabable",
      value: function () {
        return `${prefix$r}-search`;
      }

      /**
       * A selector selecting the locale items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${c4dPrefix$N}-locale-item`;
      }

      /**
       * The event that represents the user input gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventInput",
      value: function () {
        return `${prefix$r}-search-input`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$h;
      }
    }]
  };
}, ThrottledInputMixin(StableSelectorMixin(s)));

let _$I = t => t,
  _t$J;
function _decorate$M(e, r, t, i) { var o = _getDecoratorsApi$M(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$M(s.d.map(_createElementDescriptor$M)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$M() { _getDecoratorsApi$M = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$M(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$M(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$M(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$M(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$M(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$M(e) { var r, t = _toPropertyKey$M(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$M(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$M(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$M(o.descriptor) || _isDataDescriptor$M(i.descriptor)) { if (_hasDecorators$M(o) || _hasDecorators$M(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$M(o)) { if (_hasDecorators$M(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$M(o, i); } } else r.push(o); } return r; }
function _hasDecorators$M(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$M(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$M(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$M(t) { var i = _toPrimitive$M(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$M(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$M(r) { return _arrayWithHoles$N(r) || _iterableToArray$M(r) || _unsupportedIterableToArray$N(r) || _nonIterableRest$N(); }
function _nonIterableRest$N() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$N(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$N(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$N(r, a) : void 0; } }
function _arrayLikeToArray$N(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$M(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$N(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$M
} = settings;

/**
 * Locale item.
 *
 * @element c4d-locale-item
 * @csspart country - the country text container. Usage: `c4d-locale-item::part(country)`
 * @csspart language - the language text container. Usage: `c4d-locale-item::part(language)`
 */
_decorate$M([carbonElement(`${c4dPrefix$M}-locale-item`)], function (_initialize, _CDSLink) {
  class C4DLocaleItem extends _CDSLink {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLocaleItem,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "country",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "language",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "locale",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "region",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "role",
      value() {
        return 'listitem';
      }
    }, {
      kind: "method",
      key: "_handleClick",
      value:
      /**
       * The country.
       */

      /**
       * The language.
       */

      /**
       * The locale ID.
       */

      /**
       * The region the country is in.
       */

      /**
       * Element's role for assistive technologies
       */

      /**
       * method to handle when country/region has been selected
       * sets the ipcInfo cookie with selected locale
       */
      function _handleClick() {
        const {
          locale
        } = this;
        const localeSplit = locale.split('-');
        const localeObj = {
          cc: localeSplit[1],
          lc: localeSplit[0]
        };
        ipcinfoCookie.set(localeObj);
      }

      /**
       * @returns The inner content.
       */
    }, {
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        const {
          country,
          language
        } = this;
        return x(_t$J || (_t$J = _$I`
      <div class="${0}--locale-modal__locales__name" part="country">
        ${0}
      </div>
      <div class="${0}--locale-modal__locales__name" part="language">
        ${0}
      </div>
    `), c4dPrefix$M, country, c4dPrefix$M, language);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$h;
      }
    }]
  };
}, CDSLink);

let _$H = t => t,
  _t$I;
function _decorate$L(e, r, t, i) { var o = _getDecoratorsApi$L(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$L(s.d.map(_createElementDescriptor$L)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$L() { _getDecoratorsApi$L = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$L(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$L(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$L(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$L(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$L(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$L(e) { var r, t = _toPropertyKey$L(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$L(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$L(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$L(o.descriptor) || _isDataDescriptor$L(i.descriptor)) { if (_hasDecorators$L(o) || _hasDecorators$L(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$L(o)) { if (_hasDecorators$L(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$L(o, i); } } else r.push(o); } return r; }
function _hasDecorators$L(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$L(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$L(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$L(t) { var i = _toPrimitive$L(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$L(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$L(r) { return _arrayWithHoles$M(r) || _iterableToArray$L(r) || _unsupportedIterableToArray$M(r) || _nonIterableRest$M(); }
function _nonIterableRest$M() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$M(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$M(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$M(r, a) : void 0; } }
function _arrayLikeToArray$M(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$L(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$M(r) { if (Array.isArray(r)) return r; }
function _superPropGet$u(t, e, r, o) { var p = _get$o(_getPrototypeOf$o(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$o() { return _get$o = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$o(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$o.apply(null, arguments); }
function _superPropBase$o(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$o(t));); return t; }
function _getPrototypeOf$o(t) { return _getPrototypeOf$o = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$o(t); }
const {
  stablePrefix: c4dPrefix$L
} = settings;

/**
 * The heading content of card.
 *
 * @element c4d-card-heading
 */
_decorate$L([carbonElement(`${c4dPrefix$L}-card-heading`)], function (_initialize, _StableSelectorMixin) {
  class C4DCardHeading extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCardHeading,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'heading';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The shadow slot this card heading should be in.
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'heading');
        }
        if (!this.hasAttribute('aria-level')) {
          this.setAttribute('aria-level', '3');
        }
        _superPropGet$u(C4DCardHeading, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$I || (_t$I = _$H` <slot></slot> `));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$L}--card-heading`;
      }

      // `styles` here is a `CSSResult` generated by custom WebPack loader
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$c;
      }
    }]
  };
}, StableSelectorMixin(s));

let _$G = t => t,
  _t$H,
  _t2$j;
function _decorate$K(e, r, t, i) { var o = _getDecoratorsApi$K(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$K(s.d.map(_createElementDescriptor$K)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$K() { _getDecoratorsApi$K = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$K(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$K(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$K(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$K(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$K(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$K(e) { var r, t = _toPropertyKey$K(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$K(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$K(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$K(o.descriptor) || _isDataDescriptor$K(i.descriptor)) { if (_hasDecorators$K(o) || _hasDecorators$K(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$K(o)) { if (_hasDecorators$K(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$K(o, i); } } else r.push(o); } return r; }
function _hasDecorators$K(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$K(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$K(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$K(t) { var i = _toPrimitive$K(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$K(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$K(r) { return _arrayWithHoles$L(r) || _iterableToArray$K(r) || _unsupportedIterableToArray$L(r) || _nonIterableRest$L(); }
function _nonIterableRest$L() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$L(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$L(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$L(r, a) : void 0; } }
function _arrayLikeToArray$L(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$K(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$L(r) { if (Array.isArray(r)) return r; }
function _superPropGet$t(t, e, r, o) { var p = _get$n(_getPrototypeOf$n(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$n() { return _get$n = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$n(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$n.apply(null, arguments); }
function _superPropBase$n(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$n(t));); return t; }
function _getPrototypeOf$n(t) { return _getPrototypeOf$n = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$n(t); }
const {
  prefix: prefix$q,
  stablePrefix: c4dPrefix$K
} = settings;

/**
 * Card footer.
 *
 * @element c4d-card-footer
 * @csspart copy - The Copy. Usage: `c4d-card-footer::part(copy)`
 */
_decorate$K([carbonElement(`${c4dPrefix$K}-card-footer`)], function (_initialize, _C4DLinkWithIcon) {
  class C4DCardFooter extends _C4DLinkWithIcon {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DCardFooter,
    d: [{
      kind: "field",
      decorators: [i$1(`.${c4dPrefix$K}-ce--card__footer--static`)],
      key: "_staticNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasCopy",
      value() {
        return false;
      }
    }, {
      kind: "get",
      key: "_shouldUseParentLink",
      value:
      /**
       * The non-link container node, used when the link of parent `<c4d-card>` should be used.
       */

      /**
       * `true` if there is copy content.
       */

      /**
       * `true` if the link of parent `<c4d-card>` should be used.
       */
      function () {
        const {
          href,
          parentHref
        } = this;
        return Boolean(parentHref) && (!href || parentHref === href);
      }

      /**
       * Handles `slotchange` event on the default `<slot>`.
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange({
        target
      }) {
        if (!target.name) {
          const hasContent = target.assignedNodes().some(node => node.nodeType !== Node.TEXT_NODE || node.textContent.trim());
          this._hasCopy = hasContent;
        }
      }

      /**
       * @returns The main content.
       */
    }, {
      kind: "method",
      key: "_renderContent",
      value: function _renderContent() {
        const {
          _hasCopy: hasCopy
        } = this;
        return x(_t$H || (_t$H = _$G`
      <span
        ?hidden="${0}"
        class="${0}--card__cta__copy"
        part="copy">
        <slot @slotchange="${0}"></slot>
      </span>
    `), !hasCopy, prefix$q, this._handleSlotChange);
      }
    }, {
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        return x(_t2$j || (_t2$j = _$G`
      ${0} ${0}
    `), this._renderContent(), this.disabled ? svgResultCarbonIcon$C() : this._renderIcon());
      }

      /**
       * Alternative aria label if no text in footer.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: false
      })],
      key: "altAriaLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'color-scheme',
        reflect: true
      })],
      key: "colorScheme",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'parent-href',
        reflect: true
      })],
      key: "parentHref",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "iconInline",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'footer';
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * The color scheme.
       */
      /**
       * The `href` in parent `<c4d-card>`.
       * `<c4d-card>` sets this automatically.
       */
      /**
       * Positions the icon inline with text when `true`
       */
      /**
       * The slot in parent `<c4d-card>`.
       */
      function updated(changedProperties) {
        _superPropGet$t(C4DCardFooter, "updated", this, 3)([changedProperties]);
        if (!this._hasCopy) {
          var _this$shadowRoot;
          (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || (_this$shadowRoot = _this$shadowRoot.querySelector(`a`)) === null || _this$shadowRoot === void 0 || _this$shadowRoot.setAttribute('aria-label', this.altAriaLabel ? this.altAriaLabel : '');
        } else {
          var _this$shadowRoot2;
          (_this$shadowRoot2 = this.shadowRoot) === null || _this$shadowRoot2 === void 0 || (_this$shadowRoot2 = _this$shadowRoot2.querySelector(`a`)) === null || _this$shadowRoot2 === void 0 || _this$shadowRoot2.removeAttribute('aria-label');
        }
        const {
          iconInline,
          _staticNode: staticNode,
          _linkNode: linkNode
        } = this;
        const targetNode = linkNode !== null && linkNode !== void 0 ? linkNode : staticNode;
        targetNode.classList.add(`${prefix$q}--card__footer`);
        targetNode.classList.add(`${c4dPrefix$K}-ce--card__footer`);
        if (iconInline) {
          targetNode.classList.add(`${prefix$q}--link-with-icon--inline-icon`);
        }
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$K}--card-footer`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$c;
      }
    }]
  };
}, C4DLinkWithIcon);

var styles$b = i$4(["/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-locale-modal-composite),\n:host(c4d-locale-modal-container) {\n  display: contents;\n}"]);

let _$F = t => t,
  _t$G,
  _t2$i,
  _t3$a,
  _t4$7,
  _t5$7;
function _decorate$J(e, r, t, i) { var o = _getDecoratorsApi$J(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$J(s.d.map(_createElementDescriptor$J)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$J() { _getDecoratorsApi$J = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$J(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$J(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$J(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$J(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$J(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$J(e) { var r, t = _toPropertyKey$J(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$J(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$J(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$J(o.descriptor) || _isDataDescriptor$J(i.descriptor)) { if (_hasDecorators$J(o) || _hasDecorators$J(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$J(o)) { if (_hasDecorators$J(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$J(o, i); } } else r.push(o); } return r; }
function _hasDecorators$J(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$J(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$J(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$J(t) { var i = _toPrimitive$J(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$J(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$J(r) { return _arrayWithHoles$K(r) || _iterableToArray$J(r) || _unsupportedIterableToArray$K(r) || _nonIterableRest$K(); }
function _nonIterableRest$K() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$K(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$K(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$K(r, a) : void 0; } }
function _arrayLikeToArray$K(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$J(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$K(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$J
} = settings;

/**
 * Container component for locale modal.
 *
 * @element c4d-locale-modal-composite
 */
_decorate$J([carbonElement(`${c4dPrefix$J}-locale-modal-composite`)], function (_initialize, _HostListenerMixin) {
  class C4DLocaleModalComposite extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLocaleModalComposite,
    d: [{
      kind: "method",
      key: "_sortCountries",
      value:
      /**
       * @param countries A country list.
       * @returns Sorted version of the given country list.
       */
      function _sortCountries(countries) {
        return countries.sort((lhs, rhs) => this.collatorCountryName.compare(lhs.name, rhs.name));
      }

      /**
       * The placeholder for `loadLocaleList()` Redux action that may be mixed in.
       *
       * @internal
       */

      /**
       * The placeholder for `setLanguage()` Redux action that may be mixed in.
       *
       * @internal
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "collatorCountryName",
      value() {
        return new Intl.Collator();
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'lang-display'
      })],
      key: "langDisplay",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "localeList",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "open",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "chosenRegion",
      value: void 0
    }, {
      kind: "method",
      decorators: [HostListener(C4DLocaleModal.eventRegionUpdated)],
      key: "_handleRegionUpdatedEvent",
      value:
      /**
       * The g11n collator to use for sorting contry names.
       */
      /**
       * The language to show in the UI.
       */
      /**
       * The language used for query.
       */
      /**
       * The locale list.
       */
      /**
       * `true` to open the modal.
       */
      /**
       * The region chosen by user.
       */
      function _handleRegionUpdatedEvent(event) {
        this.chosenRegion = event.detail.region || undefined;
      }

      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "getLangDisplay",
      value: async function getLangDisplay() {
        const response = await LocaleAPI.getLangDisplay();
        return response;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$_loadLocaleList;
        const {
          language
        } = this;
        if (language) {
          var _this$_setLanguage;
          (_this$_setLanguage = this._setLanguage) === null || _this$_setLanguage === void 0 || _this$_setLanguage.call(this, language);
        }
        (_this$_loadLocaleList = this._loadLocaleList) === null || _this$_loadLocaleList === void 0 || _this$_loadLocaleList.call(this, language);
        this.getLangDisplay().then(res => {
          this.langDisplay = res;
        });
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        const {
          language
        } = this;
        if (changedProperties.has('language')) {
          if (language) {
            var _this$_setLanguage2, _this$_loadLocaleList2;
            (_this$_setLanguage2 = this._setLanguage) === null || _this$_setLanguage2 === void 0 || _this$_setLanguage2.call(this, language);
            (_this$_loadLocaleList2 = this._loadLocaleList) === null || _this$_loadLocaleList2 === void 0 || _this$_loadLocaleList2.call(this, language).catch(() => {}); // The error is logged in the Redux store
          }
        }
      }
    }, {
      kind: "method",
      key: "renderLightDOM",
      value: function renderLightDOM() {
        const {
          chosenRegion,
          langDisplay,
          localeList,
          open
        } = this;
        const {
          localeModal,
          regionList
        } = localeList !== null && localeList !== void 0 ? localeList : {};
        const {
          availabilityText,
          headerTitle,
          modalClose,
          searchClearText,
          searchLabel,
          searchPlaceholder,
          unavailabilityText
        } = localeModal !== null && localeModal !== void 0 ? localeModal : {};
        const pageLangs = altlangs();
        if (Object.keys(pageLangs).length === 0 && (regionList === null || regionList === void 0 ? void 0 : regionList.length) > 0) {
          const messages = ['Detected that `<link rel="alternate">` is likely missing.', 'The locale search UI will yield to an empty result.'];
          console.warn(messages.join(' ')); // eslint-disable-line no-console
        }
        const massagedCountryList = regionList === null || regionList === void 0 ? void 0 : regionList.reduce((acc, {
          countryList,
          name: region
        }) => {
          this._sortCountries(countryList).forEach(({
            name: country,
            locale: localeItems
          }) => {
            localeItems.forEach(([locale, language]) => {
              const href = pageLangs[locale];
              if (href) {
                acc.push({
                  locale,
                  region,
                  country,
                  href,
                  language
                });
              }
            });
          });
          return acc;
        }, []);
        return x(_t$G || (_t$G = _$F`
      <c4d-locale-modal
        close-button-assistive-text="${0}"
        header-title="${0}"
        lang-display="${0}"
        ?open="${0}">
        <c4d-regions title="${0}">
          ${0}
        </c4d-regions>

        <c4d-locale-search
          close-button-assistive-text="${0}"
          label-text="${0}"
          placeholder="${0}"
          availability-label-text="${0}"
          unavailability-label-text="${0}">
          ${0}
        </c4d-locale-search>
      </c4d-locale-modal>
    `), l(modalClose), l(headerTitle), l(langDisplay), open, l(headerTitle), regionList === null || regionList === void 0 ? void 0 : regionList.map(({
          countryList,
          name
        }) => {
          const isInvalid = countryList.length === 0 || (massagedCountryList === null || massagedCountryList === void 0 ? void 0 : massagedCountryList.find(({
            region
          }) => region === name)) === undefined;
          return x(_t2$i || (_t2$i = _$F`
              <c4d-region-item link ?disabled="${0}" name="${0}">
                <c4d-card-heading>${0}</c4d-card-heading>
                <div
                  slot="footer"
                  class="${0}--region-item-footer"
                  ?disabled="${0}">
                  ${0}
                </div>
              </c4d-region-item>
            `), isInvalid, name, name, c4dPrefix$J, isInvalid, isInvalid ? svgResultCarbonIcon$C({
            slot: 'icon',
            class: `${c4dPrefix$J}--card__cta`
          }) : svgResultCarbonIcon$D({
            slot: 'icon',
            class: `${c4dPrefix$J}--card__cta`
          }));
        }), l(searchClearText), l(searchLabel), l(searchPlaceholder), l(availabilityText), l(unavailabilityText), chosenRegion ? x(_t3$a || (_t3$a = _$F`
                ${0}
              `), massagedCountryList === null || massagedCountryList === void 0 ? void 0 : massagedCountryList.filter(({
          region
        }) => {
          return region === chosenRegion;
        }).map(({
          country,
          href,
          language,
          locale,
          region
        }) => x(_t4$7 || (_t4$7 = _$F`
                      <c4d-locale-item
                        country="${0}"
                        href="${0}"
                        language="${0}"
                        locale="${0}"
                        region="${0}">
                      </c4d-locale-item>
                    `), country, href, language, locale, region))) : ``);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t5$7 || (_t5$7 = _$F` <slot></slot> `));
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$b;
      }
    }]
  };
}, HostListenerMixin(HybridRenderMixin(s)));

/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultIBMdotcomIcon$2 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" class="c4d--footer-logo__logo" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" role="img" aria-labelledby="footer-logo" ...="${spread(
    attrs
  )}" width="157" height="65" viewBox="0 0 157 65">${children}<path d="M30.4436498,60.2076728 L30.4436498,64.2376746 L-2.91322522e-13,64.2376746 L-2.91322522e-13,60.2076728 L30.4436498,60.2076728 Z M108.735358,60.2067171 L108.735358,64.2376746 L86.9826603,64.2376746 L86.9826603,60.2067171 L108.735358,60.2067171 Z M156.592795,60.2067171 L156.592795,64.2376746 L134.840096,64.2376746 L134.840096,60.2067171 L156.592795,60.2067171 Z M123.176704,60.2067171 L121.779475,64.2376746 L120.398188,60.2067171 L123.176704,60.2067171 Z M34.7933454,60.2078639 L77.5682441,60.2078639 C74.7705526,62.6327259 71.1773563,64.1319583 67.2410591,64.2324704 L66.8180207,64.2378657 L34.7933454,64.2378657 L34.7933454,60.2078639 L77.5682441,60.2078639 Z M30.4436498,51.7462936 L30.4436498,55.7762954 L-2.91322522e-13,55.7762954 L-2.91322522e-13,51.7462936 L30.4436498,51.7462936 Z M82.8448933,51.7469625 C82.5134031,52.9954078 82.0440654,54.1860508 81.4563549,55.3022459 L81.1972884,55.7760087 L34.7933454,55.7760087 L34.7933454,51.7469625 L82.8448933,51.7469625 Z M156.592795,51.742471 L156.592795,55.7734284 L134.840096,55.7734284 L134.840096,51.742471 L156.592795,51.742471 Z M108.735358,51.742471 L108.735358,55.7734284 L86.9826603,55.7734284 L86.9826603,51.742471 L108.735358,51.742471 Z M126.109666,51.7420887 L124.712437,55.7730462 L118.86283,55.7730462 L117.466539,51.7420887 L126.109666,51.7420887 Z M21.7451962,43.2849144 L21.7451962,47.3149162 L8.69751584,47.3149162 L8.69751584,43.2849144 L21.7451962,43.2849144 Z M82.940355,43.2851055 C83.2119472,44.4164829 83.378718,45.588834 83.4161671,46.7957568 L83.4242276,47.3151073 L68.7955217,47.3151073 L68.7955217,43.2851055 L82.940355,43.2851055 Z M56.5390105,43.2849144 L56.5390105,47.3149162 L43.4913301,47.3149162 L43.4913301,43.2849144 L56.5390105,43.2849144 Z M129.041034,43.2784159 L127.644742,47.3084177 L115.930525,47.3084177 L114.534234,43.2784159 L129.041034,43.2784159 Z M147.891528,43.2782248 L147.891528,47.3082266 L134.840096,47.3082266 L134.840096,43.2782248 L147.891528,43.2782248 Z M108.735358,43.2782248 L108.735358,47.3082266 L95.6839271,47.3082266 L95.6839271,43.2782248 L108.735358,43.2782248 Z M21.7451962,34.8235352 L21.7451962,38.853537 L8.69751584,38.853537 L8.69751584,34.8235352 L21.7451962,34.8235352 Z M77.8615684,34.8232485 C78.9907919,35.873419 79.9779764,37.0776317 80.7882576,38.4059297 L81.0517515,38.8532503 L43.4916115,38.8532503 L43.4916115,34.8232485 L77.8615684,34.8232485 Z M108.735358,34.8139786 L108.735358,38.8449361 L95.6839271,38.8449361 L95.6839271,34.8139786 L108.735358,34.8139786 Z M147.891528,34.8139786 L147.891528,38.8449361 L134.840096,38.8449361 L134.840096,34.8139786 L147.891528,34.8139786 Z M131.973433,34.8136919 L130.577142,38.8446494 L112.998313,38.8446494 L111.602022,34.8136919 L131.973433,34.8136919 Z M81.1948503,26.3623471 C80.4234674,27.7178498 79.472067,28.9518216 78.3755133,30.0356991 L78.0046671,30.3913933 L43.4912364,30.3913933 L43.4912364,26.3623471 L81.1948503,26.3623471 Z M21.7451962,26.362156 L21.7451962,30.3912022 L8.69751584,30.3912022 L8.69751584,26.362156 L21.7451962,26.362156 Z M147.891528,26.3490635 L147.891528,30.380021 L134.840096,30.380021 L134.839345,26.5412738 L133.509447,30.380021 L122.054045,30.380021 L123.426893,26.3490635 L147.891528,26.3490635 Z M120.148562,26.3492547 L121.52141,30.3802121 L110.06507,30.3802121 L108.735358,26.5413415 L108.735358,30.3802121 L95.6839271,30.3802121 L95.6839271,26.3492547 L120.148562,26.3492547 Z M21.7451962,17.9007768 L21.7451962,21.9307786 L8.69751584,21.9307786 L8.69751584,17.9007768 L21.7451962,17.9007768 Z M83.4242276,17.900299 C83.4242276,19.1161325 83.2914058,20.2997723 83.0502626,21.4428957 L82.940355,21.9303008 L68.7955217,21.9303008 L68.7955217,17.900299 L83.4242276,17.900299 Z M56.5390105,17.8998212 L56.5390105,21.929823 L43.4913301,21.929823 L43.4913301,17.8998212 L56.5390105,17.8998212 Z M147.891434,17.8846262 L147.891434,21.9155837 L124.936556,21.9155837 L126.307529,17.8846262 L147.891434,17.8846262 Z M117.266988,17.8844351 L118.638898,21.9153926 L95.6840208,21.9153926 L95.6840208,17.8844351 L117.266988,17.8844351 Z M30.4436498,9.43844199 L30.4436498,13.4684438 L-2.91322522e-13,13.4684438 L-2.91322522e-13,9.43844199 L30.4436498,9.43844199 Z M81.197476,9.43844199 C81.8186099,10.5338628 82.324153,11.7053777 82.6946307,12.9369814 L82.8450809,13.4684438 L34.793533,13.4684438 L34.793533,9.43844199 L81.197476,9.43844199 Z M156.593451,9.41971113 L156.593451,13.4506686 L127.817099,13.4506686 L129.189946,9.41971113 L156.593451,9.41971113 Z M114.385696,9.41999783 L115.757606,13.4509553 L86.9821914,13.4509553 L86.9821914,9.41999783 L114.385696,9.41999783 Z M30.4436498,0.978018462 L30.4436498,5.00706462 L-2.91322522e-13,5.00706462 L-2.91322522e-13,0.978018462 L30.4436498,0.978018462 Z M66.818302,0.977540633 C70.7785294,0.977540633 74.4118131,2.3931571 77.2657493,4.75043913 L77.5685254,5.00658679 L34.7936268,5.00658679 L34.7936268,0.977540633 L66.818302,0.977540633 Z M156.592607,0.956229502 L156.592607,4.98718697 L130.69886,4.98718697 L132.07077,0.956229502 L156.592607,0.956229502 Z M111.495495,0.955273846 L112.867405,4.98527566 L86.9820976,4.98527566 L86.9820976,0.955273846 L111.495495,0.955273846 Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultIBMdotcomIcon$1 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" fill="none" xmlns="http://www.w3.org/2000/svg" ...="${spread(
    attrs
  )}" aria-hidden="true" width="58" height="24" viewBox="0 0 58 24">${children}<g id="logo"><path id="logo color" fill-rule="evenodd" clip-rule="evenodd" d="M32.1335 0.846069H41.1894L41.6962 2.27207H32.1335V0.846069ZM24.6845 0.853948C26.1997 0.853948 27.5854 1.39128 28.6559 2.27961H12.8537V0.853948H24.6845ZM30.6052 5.27381C30.4652 4.76894 30.2588 4.29079 29.9965 3.84781H12.8537V5.27381H30.6052ZM16.0668 11.2619V9.83626H29.9956C29.6789 10.3692 29.2802 10.849 28.817 11.2619H16.0668ZM28.7641 12.8301H16.067V14.2561H29.9427C29.6264 13.7232 29.2277 13.243 28.7641 12.8301ZM20.887 17.2502H16.0669V15.8242H20.887V17.2502ZM12.8536 20.2442V18.8185H30.6051C30.4652 19.3234 30.2587 19.8015 29.9964 20.2442H12.8536ZM16.0669 8.26783H20.887V6.84183H16.0669V8.26783ZM30.6404 8.268H25.4149V6.842H30.8191C30.8191 7.33368 30.7551 7.81048 30.6404 8.268ZM25.4149 15.8243V17.2503H30.8191C30.8191 16.7583 30.7551 16.2818 30.6404 15.8243H25.4149ZM32.1337 23.2383H40.1698V21.812H32.1337V23.2383ZM40.1698 20.2433H32.1337V18.8169H40.1698V20.2433ZM35.3482 17.2479H40.1698V15.8219H35.3482V17.2479ZM40.1698 14.2532H35.3482V12.8268H40.1698V14.2532ZM49.8135 23.2383H57.8496V21.812H49.8135V23.2383ZM57.8496 20.2433H49.8135V18.8169H57.8496V20.2433ZM49.8135 17.2479H54.6351V15.8219H49.8135V17.2479ZM54.6351 14.2532H49.8135V12.8268H54.6351V14.2532ZM49.8135 11.2579H54.6351V9.83156H49.8135H45.5972L45.09 11.2579H49.322L49.8135 9.89953V11.2579ZM40.1698 9.83163H44.3861L44.8933 11.258H40.661L40.1698 9.8996V11.258H35.3482V9.83163H40.1698ZM54.6351 6.83646H46.6614L46.1549 8.26279H54.6351V6.83646ZM48.2837 2.27275L48.7905 0.846407H57.8495V2.27275H48.2837ZM44.9886 23.2383L45.5048 21.812H44.4783L44.9886 23.2383ZM46.0721 20.2431H43.9111L43.3953 18.8168H46.5883L46.0721 20.2431ZM42.8278 17.248H47.1554L47.6712 15.8219H42.312L42.8278 17.248ZM48.2387 14.2531H41.7446L41.2288 12.8267H48.7545L48.2387 14.2531ZM35.3482 8.26273H43.8284L43.3216 6.83639H35.3482V8.26273ZM57.8498 5.26752H47.2191L47.7262 3.84118H57.8498V5.26752ZM42.2571 3.84128H32.1335V5.26762H42.764L42.2571 3.84128ZM12.8536 23.2384V21.8124H28.6558C27.5853 22.701 26.1996 23.2384 24.6844 23.2384H12.8536ZM0 23.2303H11.2467V21.8043H0V23.2303ZM11.2467 20.2362H0V18.8102H11.2467V20.2362ZM3.21309 17.2422H8.03326V15.8162H3.21309V17.2422ZM8.03326 14.2482H3.21309V12.8222H8.03326V14.2482ZM3.21309 11.2538H8.03326V9.82815H3.21309V11.2538ZM8.03326 8.26012H3.21309V6.83412H8.03326V8.26012ZM0 5.26576H11.2467V3.83976H0V5.26576ZM11.2467 2.27173H0V0.846069H11.2467V2.27173Z" fill="#8C8C8C"></path><mask id="mask0_1455_52615" style="mask-type:luminance" maskUnits="userSpaceOnUse" x="0" y="0" width="58" height="24"><path id="logo color_2" fill-rule="evenodd" clip-rule="evenodd" d="M32.1335 0.846069H41.1894L41.6962 2.27207H32.1335V0.846069ZM24.6845 0.853948C26.1997 0.853948 27.5854 1.39128 28.6559 2.27961H12.8537V0.853948H24.6845ZM30.6052 5.27381C30.4652 4.76894 30.2588 4.29079 29.9965 3.84781H12.8537V5.27381H30.6052ZM16.0668 11.2619V9.83626H29.9956C29.6789 10.3692 29.2802 10.849 28.817 11.2619H16.0668ZM28.7641 12.8301H16.067V14.2561H29.9427C29.6264 13.7232 29.2277 13.243 28.7641 12.8301ZM20.887 17.2502H16.0669V15.8242H20.887V17.2502ZM12.8536 20.2442V18.8185H30.6051C30.4652 19.3234 30.2587 19.8015 29.9964 20.2442H12.8536ZM16.0669 8.26783H20.887V6.84183H16.0669V8.26783ZM30.6404 8.268H25.4149V6.842H30.8191C30.8191 7.33368 30.7551 7.81048 30.6404 8.268ZM25.4149 15.8243V17.2503H30.8191C30.8191 16.7583 30.7551 16.2818 30.6404 15.8243H25.4149ZM32.1337 23.2383H40.1698V21.812H32.1337V23.2383ZM40.1698 20.2433H32.1337V18.8169H40.1698V20.2433ZM35.3482 17.2479H40.1698V15.8219H35.3482V17.2479ZM40.1698 14.2532H35.3482V12.8268H40.1698V14.2532ZM49.8135 23.2383H57.8496V21.812H49.8135V23.2383ZM57.8496 20.2433H49.8135V18.8169H57.8496V20.2433ZM49.8135 17.2479H54.6351V15.8219H49.8135V17.2479ZM54.6351 14.2532H49.8135V12.8268H54.6351V14.2532ZM49.8135 11.2579H54.6351V9.83156H49.8135H45.5972L45.09 11.2579H49.322L49.8135 9.89953V11.2579ZM40.1698 9.83163H44.3861L44.8933 11.258H40.661L40.1698 9.8996V11.258H35.3482V9.83163H40.1698ZM54.6351 6.83646H46.6614L46.1549 8.26279H54.6351V6.83646ZM48.2837 2.27275L48.7905 0.846407H57.8495V2.27275H48.2837ZM44.9886 23.2383L45.5048 21.812H44.4783L44.9886 23.2383ZM46.0721 20.2431H43.9111L43.3953 18.8168H46.5883L46.0721 20.2431ZM42.8278 17.248H47.1554L47.6712 15.8219H42.312L42.8278 17.248ZM48.2387 14.2531H41.7446L41.2288 12.8267H48.7545L48.2387 14.2531ZM35.3482 8.26273H43.8284L43.3216 6.83639H35.3482V8.26273ZM57.8498 5.26752H47.2191L47.7262 3.84118H57.8498V5.26752ZM42.2571 3.84128H32.1335V5.26762H42.764L42.2571 3.84128ZM12.8536 23.2384V21.8124H28.6558C27.5853 22.701 26.1996 23.2384 24.6844 23.2384H12.8536ZM0 23.2303H11.2467V21.8043H0V23.2303ZM11.2467 20.2362H0V18.8102H11.2467V20.2362ZM3.21309 17.2422H8.03326V15.8162H3.21309V17.2422ZM8.03326 14.2482H3.21309V12.8222H8.03326V14.2482ZM3.21309 11.2538H8.03326V9.82815H3.21309V11.2538ZM8.03326 8.26012H3.21309V6.83412H8.03326V8.26012ZM0 5.26576H11.2467V3.83976H0V5.26576ZM11.2467 2.27173H0V0.846069H11.2467V2.27173Z" fill="white"></path></mask><g mask="url(#mask0_1455_52615)"><g id="color/gray/gray-10"><rect id="gray-10" y="0.5" width="58" height="23" fill="#F4F4F4"></rect></g></g></g></svg>`;

let _$E = t => t,
  _t$F;
function ownKeys$5(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$5(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$5(Object(t), !0).forEach(function (r) { _defineProperty$5(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$5(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$5(e, r, t) { return (r = _toPropertyKey$I(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$I(e, r, t, i) { var o = _getDecoratorsApi$I(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$I(s.d.map(_createElementDescriptor$I)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$I() { _getDecoratorsApi$I = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$I(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$I(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$I(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$I(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$I(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$I(e) { var r, t = _toPropertyKey$I(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$I(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$I(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$I(o.descriptor) || _isDataDescriptor$I(i.descriptor)) { if (_hasDecorators$I(o) || _hasDecorators$I(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$I(o)) { if (_hasDecorators$I(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$I(o, i); } } else r.push(o); } return r; }
function _hasDecorators$I(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$I(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$I(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$I(t) { var i = _toPrimitive$I(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$I(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$I(r) { return _arrayWithHoles$J(r) || _iterableToArray$I(r) || _unsupportedIterableToArray$J(r) || _nonIterableRest$J(); }
function _nonIterableRest$J() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$J(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$J(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$J(r, a) : void 0; } }
function _arrayLikeToArray$J(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$I(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$J(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$I
} = settings;

/**
 * The IBM logo UI in footer.
 *
 * @element c4d-footer-logo
 */
_decorate$I([carbonElement(`${c4dPrefix$I}-footer-logo`)], function (_initialize, _StableSelectorMixin) {
  class C4DFooterLogo extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterLogo,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value() {
        return 'https://www.ibm.com/';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "size",
      value() {
        return FOOTER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'brand';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Link `href`.
       */

      /**
       * Size property used for applying classes
       */

      /**
       * The shadow slot this logo UI should be in.
       */

      function render() {
        const {
          href,
          size
        } = this;
        return x(_t$F || (_t$F = _$E`
      <a
        part="logo-link"
        class="${0}--footer-logo__link"
        aria-label="IBM logo"
        href="${0}">
        ${0}
        <slot></slot>
      </a>
    `), c4dPrefix$I, l(href), size !== FOOTER_SIZE.MICRO ? svgResultIBMdotcomIcon$2() : svgResultIBMdotcomIcon$1());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$I}--footer-logo`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread$5(_objectSpread$5({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, StableSelectorMixin(FocusMixin(s)));

let _$D = t => t,
  _t$E;
function _decorate$H(e, r, t, i) { var o = _getDecoratorsApi$H(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$H(s.d.map(_createElementDescriptor$H)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$H() { _getDecoratorsApi$H = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$H(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$H(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$H(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$H(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$H(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$H(e) { var r, t = _toPropertyKey$H(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$H(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$H(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$H(o.descriptor) || _isDataDescriptor$H(i.descriptor)) { if (_hasDecorators$H(o) || _hasDecorators$H(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$H(o)) { if (_hasDecorators$H(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$H(o, i); } } else r.push(o); } return r; }
function _hasDecorators$H(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$H(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$H(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$H(t) { var i = _toPrimitive$H(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$H(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$H(r) { return _arrayWithHoles$I(r) || _iterableToArray$H(r) || _unsupportedIterableToArray$I(r) || _nonIterableRest$I(); }
function _nonIterableRest$I() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$I(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$I(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$I(r, a) : void 0; } }
function _arrayLikeToArray$I(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$H(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$I(r) { if (Array.isArray(r)) return r; }
function _superPropGet$s(t, e, r, o) { var p = _get$m(_getPrototypeOf$m(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$m() { return _get$m = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$m(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$m.apply(null, arguments); }
function _superPropBase$m(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$m(t));); return t; }
function _getPrototypeOf$m(t) { return _getPrototypeOf$m = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$m(t); }
const {
  prefix: prefix$p,
  stablePrefix: c4dPrefix$H
} = settings;

/**
 * Footer nav.
 *
 * @element c4d-footer-nav
 * @csspart nav-container - The nav container. Usage: `c4d-footer-nav::part(nav-container)`
 */
_decorate$H([carbonElement(`${c4dPrefix$H}-footer-nav`)], function (_initialize, _StableSelectorMixin) {
  class C4DFooterNav extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterNav,
    d: [{
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'navigation');
        }
        if (!this.hasAttribute('aria-label')) {
          this.setAttribute('aria-label', 'Footer navigation');
        }
        _superPropGet$s(C4DFooterNav, "connectedCallback", this, 3)([]);
      }

      /**
       * Update the CSS selectors depending on the locale button being rendered or not.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          disableLocaleButton
        } = this;
        const classes = {
          [`${prefix$p}--footer-nav__container`]: true,
          [`${prefix$p}--accordion`]: true,
          [`${prefix$p}--footer-nav__locale-button--disabled`]: disableLocaleButton
        };
        return x(_t$E || (_t$E = _$D`
      <ul part="nav-container" class=${0}>
        <slot></slot>
        <slot name="locale-button"></slot>
        <slot name="language-selector"></slot>
      </ul>
    `), o$2(classes));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$H}--footer-nav`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, StableSelectorMixin(s));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$k = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M11 8L6 13 5.3 12.3 9.6 8 5.3 3.7 6 3z"></path></svg>`;

let _$C = t => t,
  _t$D,
  _t2$h,
  _t3$9;
function _decorate$G(e, r, t, i) { var o = _getDecoratorsApi$G(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$G(s.d.map(_createElementDescriptor$G)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$G() { _getDecoratorsApi$G = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$G(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$G(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$G(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$G(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$G(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$G(e) { var r, t = _toPropertyKey$G(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$G(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$G(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$G(o.descriptor) || _isDataDescriptor$G(i.descriptor)) { if (_hasDecorators$G(o) || _hasDecorators$G(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$G(o)) { if (_hasDecorators$G(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$G(o, i); } } else r.push(o); } return r; }
function _hasDecorators$G(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$G(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$G(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$G(t) { var i = _toPrimitive$G(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$G(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$G(r) { return _arrayWithHoles$H(r) || _iterableToArray$G(r) || _unsupportedIterableToArray$H(r) || _nonIterableRest$H(); }
function _nonIterableRest$H() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$H(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$H(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$H(r, a) : void 0; } }
function _arrayLikeToArray$H(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$G(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$H(r) { if (Array.isArray(r)) return r; }
function _superPropGet$r(t, e, r, o) { var p = _get$l(_getPrototypeOf$l(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$l() { return _get$l = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$l(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$l.apply(null, arguments); }
function _superPropBase$l(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$l(t));); return t; }
function _getPrototypeOf$l(t) { return _getPrototypeOf$l = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$l(t); }
const {
  prefix: prefix$o,
  stablePrefix: c4dPrefix$G
} = settings;

/**
 * Footer nav group.
 *
 * @element c4d-footer-nav-group
 * @csspart nav-group-title - The nav group title. Usage: `c4d-footer-nav::part(nav-group-title)`
 * @csspart accordion-heading - The accordion nav heading. Usage: `c4d-footer-nav::part(accordion-heading)`
 * @csspart accordion-title - The accordion title. Usage: `c4d-footer-nav::part(accordion-title)`
 * @csspart accordion-content - The accordion content. Usage: `c4d-footer-nav::part(accordion-content)`
 * @csspart link-list - The list of links. Usage: `c4d-footer-nav-group::part(link-list)`
 * @slot title - The title content.
 */
_decorate$G([carbonElement(`${c4dPrefix$G}-footer-nav-group`)], function (_initialize, _MediaQueryMixin) {
  class C4DFooterNavGroup extends _MediaQueryMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterNavGroup,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_isMediumOrGreater",
      value() {
        return this.carbonBreakpoints.md.matches;
      }
    }, {
      kind: "method",
      key: "mediaQueryCallbackMD",
      value: function mediaQueryCallbackMD() {
        this._isMediumOrGreater = this.carbonBreakpoints.md.matches;
      }

      /**
       * Handles user-initiated toggle request of this accordion item.
       *
       * @param open The new open state.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedToggle",
      value: function _handleUserInitiatedToggle(open = !this.open) {
        const {
          eventBeforeToggle,
          eventToggle
        } = this.constructor;
        const init = {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            open
          }
        };
        if (this.dispatchEvent(new CustomEvent(eventBeforeToggle, init))) {
          this.open = open;
          this.dispatchEvent(new CustomEvent(eventToggle, init));
        }
      }

      /**
       * Handles the `click` event on the expando button.
       */
    }, {
      kind: "method",
      key: "_handleClickExpando",
      value: function _handleClickExpando() {
        this._handleUserInitiatedToggle();
      }

      /**
       * Handles the `keydown` event on the expando button.
       *
       * @param event The event.
       * @param event.key The event key.
       */
    }, {
      kind: "field",
      key: "_handleKeydownExpando",
      value() {
        return ({
          key
        }) => {
          if (this.open && (key === 'Esc' || key === 'Escape')) {
            this._handleUserInitiatedToggle(false);
          }
        };
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "open",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'title-text'
      })],
      key: "titleText",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * `true` if the check box should be open.
       */
      /**
       * The title text.
       */
      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'listitem');
        }
        _superPropGet$r(C4DFooterNavGroup, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          titleText,
          open,
          _isMediumOrGreater: isMediumOrGreater,
          _handleClickExpando: handleClickExpando,
          _handleKeydownExpando: handleKeydownExpando
        } = this;
        const heading = isMediumOrGreater ? x(_t$D || (_t$D = _$C`
          <h2 part="nav-group-title" class="${0}--footer-nav-group__title">
            <slot name="title">${0}</slot>
          </h2>
        `), prefix$o, titleText) : x(_t2$h || (_t2$h = _$C`
          <button
            part="accordion-heading"
            type="button"
            class="${0}--accordion__heading"
            aria-controls="content"
            aria-expanded="${0}"
            @click="${0}"
            @keydown="${0}">
            ${0}
            <div part="accordion-title" class="${0}--accordion__title">
              <slot name="title">${0}</slot>
            </div>
          </button>
        `), prefix$o, String(Boolean(open)), handleClickExpando, handleKeydownExpando, svgResultCarbonIcon$k({
          class: `${prefix$o}--accordion__arrow`
        }), prefix$o, titleText);
        return x(_t3$9 || (_t3$9 = _$C`
      ${0}
      <div
        part="accordion-content"
        id="content"
        class="${0}--accordion__content">
        <ul part="link-list">
          <slot></slot>
        </ul>
      </div>
    `), heading, prefix$o);
      }

      /**
       * The name of the custom event fired before this accordion item is being toggled upon a user gesture.
       * Cancellation of this event stops the user-initiated action of toggling this accordion item.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeToggle",
      value: function () {
        return `${c4dPrefix$G}-footer-nav-group-beingtoggled`;
      }

      /**
       * The name of the custom event fired after this accordion item is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggle",
      value: function () {
        return `${c4dPrefix$G}-footer-nav-group-toggled`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$G}--footer-nav-group`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, MediaQueryMixin(StableSelectorMixin(s), {
  [MQBreakpoints.MD]: MQDirs.MIN
}));

let _$B = t => t,
  _t$C;
function _decorate$F(e, r, t, i) { var o = _getDecoratorsApi$F(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$F(s.d.map(_createElementDescriptor$F)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$F() { _getDecoratorsApi$F = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$F(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$F(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$F(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$F(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$F(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$F(e) { var r, t = _toPropertyKey$F(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$F(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$F(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$F(o.descriptor) || _isDataDescriptor$F(i.descriptor)) { if (_hasDecorators$F(o) || _hasDecorators$F(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$F(o)) { if (_hasDecorators$F(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$F(o, i); } } else r.push(o); } return r; }
function _hasDecorators$F(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$F(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$F(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$F(t) { var i = _toPrimitive$F(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$F(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$F(r) { return _arrayWithHoles$G(r) || _iterableToArray$F(r) || _unsupportedIterableToArray$G(r) || _nonIterableRest$G(); }
function _nonIterableRest$G() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$G(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$G(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$G(r, a) : void 0; } }
function _arrayLikeToArray$G(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$F(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$G(r) { if (Array.isArray(r)) return r; }
function _superPropGet$q(t, e, r, o) { var p = _get$k(_getPrototypeOf$k(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$k() { return _get$k = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$k(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$k.apply(null, arguments); }
function _superPropBase$k(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$k(t));); return t; }
function _getPrototypeOf$k(t) { return _getPrototypeOf$k = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$k(t); }
const {
  prefix: prefix$n,
  stablePrefix: c4dPrefix$F
} = settings;

/**
 * Footer nav item.
 *
 * @element c4d-footer-nav-item
 */
let C4DFooterNavItem = _decorate$F([carbonElement(`${c4dPrefix$F}-footer-nav-item`)], function (_initialize, _CDSLink) {
  class C4DFooterNavItem extends _CDSLink {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterNavItem,
    d: [{
      kind: "method",
      key: "_renderInner",
      value: function _renderInner() {
        const {
          titleText
        } = this;
        return x(_t$C || (_t$C = _$B` <slot>${0}</slot> `), titleText);
      }

      /**
       * The title.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'title-text'
      })],
      key: "titleText",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'listitem');
        }
        _superPropGet$q(C4DFooterNavItem, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated() {
        const {
          _linkNode: linkNode
        } = this;
        if (linkNode) {
          linkNode.classList.add(`${prefix$n}--footer__link`);
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, CDSLink);

let _$A = t => t,
  _t$B;
function ownKeys$4(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$4(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$4(Object(t), !0).forEach(function (r) { _defineProperty$4(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$4(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$4(e, r, t) { return (r = _toPropertyKey$E(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$E(e, r, t, i) { var o = _getDecoratorsApi$E(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$E(s.d.map(_createElementDescriptor$E)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$E() { _getDecoratorsApi$E = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$E(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$E(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$E(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$E(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$E(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$E(e) { var r, t = _toPropertyKey$E(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$E(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$E(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$E(o.descriptor) || _isDataDescriptor$E(i.descriptor)) { if (_hasDecorators$E(o) || _hasDecorators$E(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$E(o)) { if (_hasDecorators$E(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$E(o, i); } } else r.push(o); } return r; }
function _hasDecorators$E(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$E(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$E(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$E(t) { var i = _toPrimitive$E(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$E(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$E(r) { return _arrayWithHoles$F(r) || _iterableToArray$E(r) || _unsupportedIterableToArray$F(r) || _nonIterableRest$F(); }
function _nonIterableRest$F() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$F(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$F(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$F(r, a) : void 0; } }
function _arrayLikeToArray$F(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$E(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$F(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$m,
  stablePrefix: c4dPrefix$E
} = settings;

/**
 * Locale button.
 *
 * @element c4d-locale-button
 */
_decorate$E([carbonElement(`${c4dPrefix$E}-locale-button`)], function (_initialize, _StableSelectorMixin) {
  class C4DLocaleButton extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLocaleButton,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "buttonLabel",
      value() {
        return 'Select geographic area';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "size",
      value() {
        return FOOTER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'locale-button';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Button label for accessibility.
       */

      /**
       * Size property to apply different styles.
       */

      /**
       * The shadow slot this locale button should be in.
       */

      function render() {
        const {
          buttonLabel
        } = this;
        return x(_t$B || (_t$B = _$A`
      <button
        part="locale-button"
        id="button"
        class="${0}--btn ${0}--btn--tertiary ${0}--locale-btn"
        aria-label="${0}">
        <slot></slot>
        ${0}
      </button>
    `), prefix$m, prefix$m, c4dPrefix$E, l(buttonLabel), svgResultCarbonIcon$A());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$E}--locale-btn`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread$4(_objectSpread$4({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, StableSelectorMixin(FocusMixin(s)));

let _$z = t => t,
  _t$A,
  _t2$g;
function _decorate$D(e, r, t, i) { var o = _getDecoratorsApi$D(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$D(s.d.map(_createElementDescriptor$D)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$D() { _getDecoratorsApi$D = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$D(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$D(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$D(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$D(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$D(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$D(e) { var r, t = _toPropertyKey$D(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$D(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$D(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$D(o.descriptor) || _isDataDescriptor$D(i.descriptor)) { if (_hasDecorators$D(o) || _hasDecorators$D(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$D(o)) { if (_hasDecorators$D(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$D(o, i); } } else r.push(o); } return r; }
function _hasDecorators$D(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$D(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$D(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$D(t) { var i = _toPrimitive$D(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$D(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$D(r) { return _arrayWithHoles$E(r) || _iterableToArray$D(r) || _unsupportedIterableToArray$E(r) || _nonIterableRest$E(); }
function _nonIterableRest$E() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$E(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$E(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$E(r, a) : void 0; } }
function _arrayLikeToArray$E(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$D(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$E(r) { if (Array.isArray(r)) return r; }
function _superPropGet$p(t, e, r, o) { var p = _get$j(_getPrototypeOf$j(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$j() { return _get$j = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$j(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$j.apply(null, arguments); }
function _superPropBase$j(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$j(t));); return t; }
function _getPrototypeOf$j(t) { return _getPrototypeOf$j = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$j(t); }
const {
  stablePrefix: c4dPrefix$D
} = settings;

/**
 * Legal nav.
 *
 * @element c4d-legal-nav
 * @csspart legal-nav - The <nav> container. Usage: `c4d-legal-nav::part(legal-nav)`
 * @csspart legal-nav-list-container - The legal nav list container. Usage: `c4d-legal-nav::part(legal-nav-list-container)`
 * @csspart legal-nav-list - The list of links. Usage: `c4d-legal-nav::part(legal-nav-list)`
 * @csspart adjunct-links-list - The list of adjunct links. Usage: `c4d-legal-nav::part(adjunct-links-list)`
 * @csspart adjunct-links-container - The adjunct links container. Usage: `c4d-legal-nav::part(adjunct-links-container)`
 * @csspart legal-nav-items-container - The legal nav items container. Usage: `c4d-legal-nav::part(legal-nav-items-container)`
 */
_decorate$D([carbonElement(`${c4dPrefix$D}-legal-nav`)], function (_initialize, _StableSelectorMixin) {
  class C4DLegalNav extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLegalNav,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "size",
      value() {
        return FOOTER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "navLabel",
      value() {
        return 'Legal Navigation';
      }
    }, {
      kind: "field",
      decorators: [i$1('[name="adjunct-links"]')],
      key: "_adjunctLinksSlot",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasAdjunctLinks",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_getTypeClass",
      value:
      /**
       * Size property used for applying classes
       */

      /**
       * Navigation label for accessibility.
       */

      /**
       * The adjunct links slot
       */

      /**
       * Returns a class-name based on the type parameter type
       */
      function _getTypeClass() {
        return o$2({
          [`${c4dPrefix$D}--legal-nav__list`]: true,
          [`${c4dPrefix$D}--legal-nav__micro`]: this.size === FOOTER_SIZE.MICRO
        });
      }

      /**
       * Handles slot change event of adjunct-links slot to track if there are any.
       */
    }, {
      kind: "field",
      key: "_handleAdjunctLinksVisibility",
      value() {
        return () => {
          const {
            _adjunctLinksSlot: adjunctLinksSlot
          } = this;
          this._hasAdjunctLinks = ((adjunctLinksSlot === null || adjunctLinksSlot === void 0 ? void 0 : adjunctLinksSlot.assignedNodes().length) || 0) !== 0;
        };
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'legal-nav';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The shadow slot this legal nav should be in.
       */
      function connectedCallback() {
        if (this.hasAttribute('role')) {
          this.removeAttribute('role');
        }
        _superPropGet$p(C4DLegalNav, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        const {
          _adjunctLinksSlot: adjunctLinksSlot
        } = this;
        this._hasAdjunctLinks = ((adjunctLinksSlot === null || adjunctLinksSlot === void 0 ? void 0 : adjunctLinksSlot.assignedNodes().length) || 0) !== 0;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          navLabel,
          _hasAdjunctLinks: hasAdjunctLinks
        } = this;
        return this.size !== FOOTER_SIZE.MICRO ? x(_t$A || (_t$A = _$z`
          <nav
            part="legal-nav"
            class="${0}--legal-nav"
            aria-label="${0}">
            <div
              part="legal-nav-list-container"
              class="${0}">
              <ul part="legal-nav-list">
                <slot></slot>
              </ul>
              <slot name="locale"></slot>
            </div>
            <div
              part="adjunct-links-container"
              class="${0}--adjunct-links__container${0}">
              <ul part="adjunct-links-list adjunct-links-list">
                <slot
                  name="adjunct-links"
                  @slotchange="${0}"></slot>
              </ul>
            </div>
          </nav>
        `), c4dPrefix$D, l(navLabel), this._getTypeClass(), c4dPrefix$D, hasAdjunctLinks ? '' : ` ${c4dPrefix$D}--adjunct-links__container--hidden`, this._handleAdjunctLinksVisibility) : x(_t2$g || (_t2$g = _$z`
          <nav part="legal-nav" class="${0}--legal-nav">
            <div
              part="legal-nav-list-container"
              class="${0}">
              <div part="legal-nav-items-container">
                <slot name="brand"></slot>
                <ul part="legal-nav-list">
                  <slot></slot>
                </ul>
              </div>
              <slot name="locale"></slot>
            </div>
          </nav>
        `), c4dPrefix$D, this._getTypeClass());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$D}--footer-legal-nav`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, StableSelectorMixin(s));

function _decorate$C(e, r, t, i) { var o = _getDecoratorsApi$C(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$C(s.d.map(_createElementDescriptor$C)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$C() { _getDecoratorsApi$C = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$C(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$C(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$C(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$C(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$C(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$C(e) { var r, t = _toPropertyKey$C(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$C(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$C(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$C(o.descriptor) || _isDataDescriptor$C(i.descriptor)) { if (_hasDecorators$C(o) || _hasDecorators$C(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$C(o)) { if (_hasDecorators$C(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$C(o, i); } } else r.push(o); } return r; }
function _hasDecorators$C(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$C(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$C(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$C(t) { var i = _toPrimitive$C(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$C(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$C(r) { return _arrayWithHoles$D(r) || _iterableToArray$C(r) || _unsupportedIterableToArray$D(r) || _nonIterableRest$D(); }
function _nonIterableRest$D() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$D(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$D(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$D(r, a) : void 0; } }
function _arrayLikeToArray$D(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$C(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$D(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$l,
  stablePrefix: c4dPrefix$C
} = settings;

/**
 * Legal nav item.
 *
 * @element c4d-legal-nav-item
 */
_decorate$C([carbonElement(`${c4dPrefix$C}-legal-nav-item`)], function (_initialize, _C4DFooterNavItem) {
  class C4DLegalNavItem extends _C4DFooterNavItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLegalNavItem,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "autoid",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * autoid text.
       */

      function updated() {
        const {
          _linkNode: linkNode
        } = this;
        if (linkNode) {
          var _this$autoid;
          const dataTitle = (_this$autoid = this.autoid) === null || _this$autoid === void 0 ? void 0 : _this$autoid.replace(/[^-a-zA-Z0-9_ ]/g, '').replace(/ +/g, '-').toLowerCase();
          linkNode.classList.add(`${prefix$l}--footer__link`);
          linkNode.setAttribute('data-autoid', `${c4dPrefix$C}--footer-legal-nav__link-${dataTitle}`);
        }
      }
    }]
  };
}, C4DFooterNavItem);

let _$y = t => t,
  _t$z;
function _decorate$B(e, r, t, i) { var o = _getDecoratorsApi$B(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$B(s.d.map(_createElementDescriptor$B)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$B() { _getDecoratorsApi$B = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$B(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$B(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$B(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$B(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$B(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$B(e) { var r, t = _toPropertyKey$B(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$B(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$B(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$B(o.descriptor) || _isDataDescriptor$B(i.descriptor)) { if (_hasDecorators$B(o) || _hasDecorators$B(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$B(o)) { if (_hasDecorators$B(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$B(o, i); } } else r.push(o); } return r; }
function _hasDecorators$B(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$B(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$B(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$B(t) { var i = _toPrimitive$B(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$B(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$B(r) { return _arrayWithHoles$C(r) || _iterableToArray$B(r) || _unsupportedIterableToArray$C(r) || _nonIterableRest$C(); }
function _nonIterableRest$C() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$C(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$C(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$C(r, a) : void 0; } }
function _arrayLikeToArray$C(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$B(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$C(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$k,
  stablePrefix: c4dPrefix$B
} = settings;

/**
 * Legal nav item, working as a placeholder for cookie perference link.
 *
 * @element c4d-legal-nav-cookie-preferences-placeholder
 * @csspart legal-nav-cookie-preferences - The legal nav cookie preferences container. Usage: `c4d-legal-nav-cookie-preferences-placeholder::part(legal-nav-cookie-preferences)`
 */
_decorate$B([carbonElement(`${c4dPrefix$B}-legal-nav-cookie-preferences-placeholder`)], function (_initialize, _StableSelectorMixin) {
  class C4DLegalNavCookiePreferencesPlaceholder extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLegalNavCookiePreferencesPlaceholder,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_hasCookies",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value:
      /**
       * `true` if there is cookie content.
       */

      /**
       * Handles `slotchange` event.
       */
      function _handleSlotChange(event) {
        // Finds new injected links
        const linkNodes = event.target.assignedNodes().filter(node => node.tagName === 'A');
        linkNodes.forEach(node => {
          // Adds Carbon CSS classes
          node.classList.add(`${prefix$k}--link`);
          node.classList.add(`${prefix$k}--footer__link`);
          // Moves new injected links to shadow DOM
          this.shadowRoot.appendChild(node);
        });
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _handleSlotChange: handleSlotchange,
          _hasCookies: hasCookies
        } = this;
        return x(_t$z || (_t$z = _$y`
      <div part="legal-nav-cookie-preferences" ?hidden="${0}">
        <slot @slotchange="${0}"></slot>
      </div>
    `), !hasCookies, handleSlotchange);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$B}--privacy-cp`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, StableSelectorMixin(s));

function _decorate$A(e, r, t, i) { var o = _getDecoratorsApi$A(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$A(s.d.map(_createElementDescriptor$A)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$A() { _getDecoratorsApi$A = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$A(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$A(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$A(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$A(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$A(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$A(e) { var r, t = _toPropertyKey$A(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$A(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$A(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$A(o.descriptor) || _isDataDescriptor$A(i.descriptor)) { if (_hasDecorators$A(o) || _hasDecorators$A(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$A(o)) { if (_hasDecorators$A(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$A(o, i); } } else r.push(o); } return r; }
function _hasDecorators$A(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$A(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$A(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$A(t) { var i = _toPrimitive$A(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$A(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$A(r) { return _arrayWithHoles$B(r) || _iterableToArray$A(r) || _unsupportedIterableToArray$B(r) || _nonIterableRest$B(); }
function _nonIterableRest$B() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$B(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$B(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$B(r, a) : void 0; } }
function _arrayLikeToArray$B(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$A(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$B(r) { if (Array.isArray(r)) return r; }
function _superPropGet$o(t, e, r, o) { var p = _get$i(_getPrototypeOf$i(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$i() { return _get$i = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$i(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$i.apply(null, arguments); }
function _superPropBase$i(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$i(t));); return t; }
function _getPrototypeOf$i(t) { return _getPrototypeOf$i = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$i(t); }
const {
  stablePrefix: c4dPrefix$A
} = settings;

/**
 * Language selector component - desktop.
 * The API for language selection is still subject to change.
 *
 * @element c4d-language-selector-desktop
 */
_decorate$A([carbonElement(`${c4dPrefix$A}-language-selector-desktop`)], function (_initialize, _HostListenerMixin) {
  class C4DLanguageSelectorDesktop extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLanguageSelectorDesktop,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_lastValidLang",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('input')],
      key: "_filterInputNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [HostListener('document:click')],
      key: "_handleClickOutside",
      value() {
        return event => {
          if (!this.contains(event.target)) {
            this._filterInputValue = this._lastValidLang;
            this._filterInputNode.value = this._lastValidLang;
            this.open = false;
            this.requestUpdate(); // If the only change is to `_filterInputValue`, auto-update doesn't happen
          }
        };
      }
    }, {
      kind: "method",
      key: "_handleInput",
      value:
      /**
       * Property that saves the last valid language to use on reset cases.
       */

      /**
       * The `<input>` for filtering.
       */

      /**
       * Reverts input value to last chosen valid language.
       *
       * @param event the event
       */

      /**
       * Handles `input` event on the `<input>` for filtering.
       * Highlights and scrolls into the view the matched item.
       */
      function _handleInput() {
        const items = this.querySelectorAll(this.constructor.selectorItem);
        const index = !this._filterInputNode.value ? -1 : findIndex(items, this._testItemWithQueryText, this);
        forEach(items, (item, i) => {
          if (i === index) {
            item.scrollIntoView();
          }
          item.highlighted = i === index;
        });
        const {
          _filterInputNode: filterInput
        } = this;
        this._filterInputValue = !filterInput ? '' : filterInput.value;
        this.open = true;
        this.requestUpdate(); // If the only change is to `_filterInputValue`, auto-update doesn't happen
      }

      /**
       * Handles user-initiated clearing the `<input>` for filtering.
       * Also saves the current valid language.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedClearInput",
      value: function _handleUserInitiatedClearInput() {
        forEach(this.querySelectorAll(this.constructor.selectorItem), item => {
          item.highlighted = false;
          item.selected = false;
        });
        this._lastValidLang = this._filterInputValue;
        this._filterInputValue = '';
        this._filterInputNode.focus();
        this.open = false;
        this.requestUpdate();
      }

      /**
       * Updates the input and last valid language to the selected item text.
       *
       * @param item that was selected
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedSelectItem",
      value: function _handleUserInitiatedSelectItem(item) {
        if (item && !this._selectionShouldChange(item)) {
          // Escape hatch for `shouldUpdate()` logic that updates `._filterInputValue()` when selection changes,
          // given we want to update the `<input>` and close the dropdown even if selection doesn't update.
          // Use case:
          // 1. Select the 2nd item in combo box drop down
          // 2. Type some text in the `<input>`
          // 3. Re-select the 2nd item in combo box drop down,
          //    the `<input>` has to updated with the 2nd item and the dropdown should be closed,
          //    even if there is no change in the selected value
          this._filterInputValue = item.textContent || '';
          this.open = false;
          this.requestUpdate();
        }
        this._lastValidLang = item === null || item === void 0 ? void 0 : item.textContent;
        item.selected = true;
        _superPropGet$o(C4DLanguageSelectorDesktop, "_handleUserInitiatedSelectItem", this, 3)([item]);
      }

      /**
       * Size property to apply different styles.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'style-scheme'
      })],
      key: "styleScheme",
      value() {
        return LANGUAGE_SELECTOR_STYLE_SCHEME.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'language-selector';
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * The shadow slot this language-selector should be in.
       */
      function updated(changedProperties) {
        _superPropGet$o(C4DLanguageSelectorDesktop, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('value')) {
          this._lastValidLang = this.value;
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, HostListenerMixin(C4DComboBox));

function _getPrototypeOf$h(t) {
  return _getPrototypeOf$h = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) {
    return t.__proto__ || Object.getPrototypeOf(t);
  }, _getPrototypeOf$h(t);
}

function _superPropBase$h(t, o) {
  for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$h(t)););
  return t;
}

function _get$h() {
  return _get$h = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) {
    var p = _superPropBase$h(e, t);
    if (p) {
      var n = Object.getOwnPropertyDescriptor(p, t);
      return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value;
    }
  }, _get$h.apply(null, arguments);
}

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$a = i$4([
  ":root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}input:-webkit-autofill,input:-webkit-autofill:focus,input:-webkit-autofill:hover,textarea:-webkit-autofill,textarea:-webkit-autofill:focus,textarea:-webkit-autofill:hover{box-shadow:0 0 0 1000px var(--cds-field) inset;-webkit-text-fill-color:var(--cds-text-primary,#161616)}.cds--fieldset{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--fieldset *,.cds--fieldset ::after,.cds--fieldset ::before{box-sizing:inherit}.cds--form-item{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start}.cds--label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:inline-block;color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;margin-block-end:.5rem;vertical-align:baseline}.cds--label html{font-size:100%}.cds--label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--label strong{font-weight:600}.cds--label .cds--toggletip-label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label--no-margin{margin-block-end:0}.cds--label+.cds--tooltip{position:relative;inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label+.cds--tooltip .cds--tooltip__trigger{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:flex;align-items:center;justify-content:center;font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label+.cds--tooltip .cds--tooltip__trigger *,.cds--label+.cds--tooltip .cds--tooltip__trigger ::after,.cds--label+.cds--tooltip .cds--tooltip__trigger ::before{box-sizing:inherit}.cds--label+.cds--tooltip .cds--tooltip__trigger::-moz-focus-inner{border:0}.cds--label+.cds--tooltip .cds--tooltip__trigger:focus{outline:1px solid var(--cds-focus,#0f62fe)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg :hover{fill:var(--cds-icon-primary,#161616)}.cds--label+.cds--toggletip{inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:.875rem;inline-size:4.6875rem}.cds--label.cds--skeleton:active,.cds--label.cds--skeleton:focus,.cds--label.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--label.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--label.cds--skeleton::before{animation:none}}input[type=number]{font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif}.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline-style:dotted}}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper--warn~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box--warning~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--number__input-wrapper--warning~.cds--form-requirement,.cds--select--warning .cds--select-input__wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper--warn~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper--warning>.cds--text-input~.cds--form-requirement,.cds--text-input__field-wrapper--warning~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker--warning~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input__field-wrapper--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]{display:block}.cds--form--fluid input[data-invalid]{outline:0}.cds--form--fluid .cds--form-requirement{padding:.5rem 2.5rem .5rem 1rem;margin:0}input:not(output,[data-invalid]):-moz-ui-invalid{box-shadow:none}.cds--form-requirement{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:none;overflow:hidden;margin:.25rem 0 0;max-block-size:0}.cds--form-requirement html{font-size:100%}.cds--form-requirement body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--form-requirement code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--form-requirement strong{font-weight:600}.cds--select--inline .cds--form__helper-text{margin-block-start:0}.cds--form__helper-text{font-size:var(--cds-helper-text-01-font-size,.75rem);line-height:var(--cds-helper-text-01-line-height,1.33333);letter-spacing:var(--cds-helper-text-01-letter-spacing,.32px);z-index:0;color:var(--cds-text-secondary,#525252);inline-size:100%;margin-block-start:.25rem;opacity:1}.cds--form__helper-text--disabled,.cds--label--disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}fieldset[disabled] .cds--form__helper-text,fieldset[disabled] .cds--label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--select,:host(cds-select){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:relative;display:flex;flex-direction:column;align-items:flex-start;inline-size:100%}.cds--select *,.cds--select ::after,.cds--select ::before,:host(cds-select) *,:host(cds-select) ::after,:host(cds-select) ::before{box-sizing:inherit}.cds--select-input__wrapper{position:relative;display:flex;align-items:center;inline-size:100%}.cds--select-input{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;display:block;border:none;border-radius:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;font-family:inherit;inline-size:100%;opacity:1;padding-block:0;padding-inline:1rem 3rem;text-overflow:ellipsis;transition:outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--select-input:hover{background-color:var(--cds-field-hover)}.cds--select-input::-ms-expand{display:none}@-moz-document url-prefix(){.cds--select-input:-moz-focusring,.cds--select-input::-moz-focus-inner{background-image:none;color:transparent;text-shadow:0 0 0 #000}}.cds--select-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;color:var(--cds-text-primary,#161616)}@media screen and (prefers-contrast){.cds--select-input:focus{outline-style:dotted}}.cds--select-input:disabled,.cds--select-input:hover:disabled{background-color:var(--cds-field);border-block-end-color:transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--select-input--sm{block-size:2rem;max-block-size:2rem}.cds--select-input--lg{block-size:3rem;max-block-size:3rem}.cds--select--disabled .cds--form__helper-text,.cds--select--disabled .cds--label,:host(cds-select[disabled]) .cds--form__helper-text,:host(cds-select[disabled]) .cds--label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--select--warning .cds--select-input,.cds--select-input__wrapper[data-invalid] .cds--select-input{padding-inline-end:4rem}.cds--select-input:disabled~.cds--select__arrow{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--select--light .cds--select-input{background-color:var(--cds-field-02,#fff)}.cds--select--light .cds--select-input:hover{background-color:var(--cds-field-hover)}.cds--select--light .cds--select-input:disabled,.cds--select--light .cds--select-input:hover:disabled{background-color:var(--cds-field-02,#fff);color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--select__arrow{position:absolute;block-size:100%;fill:var(--cds-icon-primary,#161616);inset-block-start:0;inset-inline-end:1rem;pointer-events:none}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--select__arrow path{fill:ButtonText}}.cds--select__invalid-icon{position:absolute;inset-inline-end:2.5rem}.cds--select-input__wrapper[data-invalid] .cds--select-input~.cds--select__invalid-icon{fill:var(--cds-support-error,#da1e28)}.cds--select__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--select__invalid-icon--warning path[fill]{fill:#000;opacity:1}.cds--select-option,optgroup.cds--select-optgroup{background-color:var(--cds-layer-hover);color:var(--cds-text-primary,#161616)}.cds--select-option:disabled,optgroup.cds--select-optgroup:disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--select--inline{display:flex;flex-direction:row;align-items:center}.cds--select--inline.cds--select--invalid .cds--form__helper-text,.cds--select--inline.cds--select--invalid .cds--label{align-self:flex-start;margin-block-start:.8125rem}.cds--select--inline .cds--form__helper-text{margin-block-end:0;margin-inline-start:.5rem}.cds--select--inline .cds--label{margin:0 .5rem 0 0;white-space:nowrap}.cds--select--inline .cds--select-input{background-color:transparent;border-block-end:none;color:var(--cds-text-primary,#161616);inline-size:auto;padding-inline-end:2rem;padding-inline-start:.5rem}.cds--select--inline .cds--select-input:focus,.cds--select--inline .cds--select-input:focus optgroup,.cds--select--inline .cds--select-input:focus option{background-color:var(--cds-background,#fff)}.cds--select--inline .cds--select-input[disabled],.cds--select--inline .cds--select-input[disabled]:hover{background-color:var(--cds-field)}.cds--select--inline .cds--select__arrow{inset-inline-end:.5rem}.cds--select--inline.cds--select--invalid .cds--select-input{padding-inline-end:3.5rem}.cds--select--inline.cds--select--invalid .cds--select-input~.cds--select__invalid-icon{inset-inline-end:2rem}.cds--select--inline .cds--select-input:disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--select--inline .cds--select-input:disabled~*{cursor:not-allowed}.cds--select--readonly .cds--select-input{background-color:transparent;border-block-end-color:var(--cds-border-subtle);cursor:default}.cds--select--readonly .cds--select__arrow{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--select.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:2.5rem;inline-size:100%}.cds--select.cds--skeleton:active,.cds--select.cds--skeleton:focus,.cds--select.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--select.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--select.cds--skeleton::before{animation:none}}.cds--select.cds--skeleton .cds--select-input{display:none}.cds--select--slug .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:calc(2.5rem + 8px + 1px);margin-block-start:.03125rem;transform:translateY(-50%)}.cds--select--slug .cds--slug::after,.cds--select--slug .cds--slug::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem}.cds--select--slug .cds--slug::before{display:none;inset-inline-start:calc(-.5rem - 1px)}.cds--select--slug .cds--slug::after{display:block;inset-inline-end:calc(-.5rem - 1px)}.cds--select--slug .cds--slug--revert::after{inset-block-start:.5rem;inset-inline-end:-.0625rem}.cds--select--slug .cds--select-input:not(:has(~.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff);padding-inline-end:4rem}.cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~.cds--slug--revert)){padding-inline-end:6rem}.cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before{display:block}.cds--select--slug .cds--select-input__wrapper .cds--select-input~.cds--select__invalid-icon,.cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input~.cds--select__invalid-icon{inset-inline-end:5rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--select__arrow{fill:ButtonText}}:host(cds-select){outline:0}:host(cds-select) ::slotted(cds-slug){position:absolute;inset-block-start:50%;inset-inline-end:2.5rem}:host(cds-select) ::slotted(cds-slug:not([revert-active])){transform:translateY(-50%)}:host(cds-select[readonly]) select{pointer-events:none}:host(cds-select[inline][warn]) .cds--form__helper-text,:host(cds-select[inline][warn]) .cds--label{align-self:flex-start;margin-block-start:.8125rem}:host(cds-select[inline][warn]) select{padding-inline-end:3.5rem}:host(cds-select[inline][warn]) .cds--select__invalid-icon--warning{inset-inline-end:2rem}:host(cds-select[pagination]) .cds--label{margin:0}:host(cds-select[pagination]) .cds--select-input{padding:0 2.25rem 0 1rem}:host(cds-select[pagination]) .cds--select-input:focus{background-color:transparent}:host(cds-select[pagination]) .cds--select__arrow{inset-block-start:50%;transform:translate(-.5rem,-50%)}:host(cds-select[pagination][left-select]) .cds--select-input{border-inline-end:1px solid var(--cds-border-subtle)}:host(cds-select[invalid]) ::slotted(cds-slug),:host(cds-select[warn]) ::slotted(cds-slug){inset-inline-end:4rem}",
]);

let _$x = t => t,
  _t$y,
  _t2$f,
  _t3$8,
  _t4$6,
  _t5$6,
  _t6$5,
  _t7$5,
  _t8$5,
  _t9$4,
  _t10$4,
  _t11$4;
function _superPropGet$n(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Select box.
 *
 * @element cds-select
 * @fires cds-select-selected
 *   The name of the custom event fired after an item is selected.
 * @slot helper-text - The helper text.
 * @slot label-text - The label text.
 * @slot validity-message - The validity message. If present and non-empty, this input shows the UI of its invalid state.
 */
let CDSSelect = _decorate$Z([carbonElement(`${prefix$B}-select`)], function (_initialize, _FormMixin) {
  class CDSSelect extends _FormMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSSelect,
    d: [{
      kind: "field",
      key: "_hasSlug",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "_observerMutation",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_placeholderItemValue",
      value() {
        return `__${prefix$B}-select-placeholder_${Math.random().toString(36).slice(2)}`;
      }
    }, {
      kind: "field",
      decorators: [i$1('select')],
      key: "_selectNode",
      value: void 0
    }, {
      kind: "method",
      key: "_handleInput",
      value:
      /**
       * `true` if there is a slug.
       */

      /**
       * The mutation observer DOM mutation.
       */

      /**
       * The `value` for placeholder `<option>`.
       */

      /**
       * The select box.
       */

      /**
       * Handles `oninput` event on the `<input>`.
       *
       * @param event The event.
       * @param event.target The event target.
       */
      function _handleInput({
        target
      }) {
        const {
          value
        } = target;
        this.value = value;
        const {
          eventSelect
        } = this.constructor;
        this.dispatchEvent(new CustomEvent(eventSelect, {
          bubbles: true,
          composed: true,
          detail: {
            value
          }
        }));
      }

      /**
       * Handles DOM mutation of `<cds-select-item>` or `<cds-select-item-group>` put in `<cds-select>`, or their changes.
       * In such event, `<cds-select>` creates the corresponding `<option>` and `<optgroup>`, respectively, into shadow DOM,
       * with `._renderItems()`.
       * Doing so allows the shadow DOM style of `<cds-select>` to control the style of the `<option>` and `<optgroup>`,
       * notably the disabled ones.
       */
    }, {
      kind: "field",
      key: "_handleMutation",
      value() {
        return () => {
          this.requestUpdate();
        };
      }
    }, {
      kind: "method",
      key: "_renderItems",
      value:
      /**
       * @param element The parent element containing pseudo `<optgroup>`/`<option>`.
       * @returns The template containing child `<optgroup>`/`<option>` that will be rendered to shadow DOM.
       */
      function _renderItems(element) {
        const {
          selectorItem,
          selectorLeafItem
        } = this.constructor;
        // Harvests attributes from `<cds-select-item>` and `<cds-select-item-group>`.
        // Does not use properties to avoid delay in attribute to property mapping, which runs in custom element reaction cycle:
        // https://html.spec.whatwg.org/multipage/custom-elements.html#custom-element-reactions
        return x(_t$y || (_t$y = _$x`
      ${0}
    `), filter(element.childNodes, item => item.nodeType === Node.ELEMENT_NODE && item.matches(selectorItem)).map(item => {
          const disabled = item.hasAttribute('disabled');
          const label = item.getAttribute('label');
          const selected = item.hasAttribute('selected');
          const value = item.getAttribute('value');
          const {
            textContent
          } = item;
          return item.matches(selectorLeafItem) ? x(_t2$f || (_t2$f = _$x`
              <option
                class="${0}--select-option"
                ?disabled="${0}"
                label="${0}"
                ?selected="${0}"
                value="${0}">
                ${0}
              </option>
            `), prefix$B, disabled, ifNonEmpty(label), selected, l(value), textContent) : x(_t3$8 || (_t3$8 = _$x`
              <optgroup
                class="${0}--select-optgroup"
                ?disabled="${0}"
                label="${0}">
                ${0}
              </optgroup>
            `), prefix$B, disabled, l(label), this._renderItems(item));
        }));
      }
    }, {
      kind: "method",
      key: "_handleFormdata",
      value: function _handleFormdata(event) {
        const {
          formData
        } = event; // TODO: Wait for `FormDataEvent` being available in `lib.dom.d.ts`
        const {
          disabled,
          name,
          value
        } = this;
        if (!disabled) {
          formData.append(name, value);
        }
      }

      /**
       * Handles `slotchange` event.
       */
    }, {
      kind: "method",
      key: "_handleSlugSlotChange",
      value: function _handleSlugSlotChange({
        target
      }) {
        const hasContent = target.assignedNodes().filter(elem => elem.matches !== undefined ? elem.matches(this.constructor.slugItem) : false);
        this._hasSlug = Boolean(hasContent);
        hasContent[0].setAttribute('size', 'mini');
        this.requestUpdate();
      }

      /**
       * The count of child `<option>`s.
       * If the placeholder is in effect, it includes the `<option>` for the placeholder.
       */
    }, {
      kind: "get",
      key: "length",
      value: function () {
        return this._selectNode.length;
      }

      /**
       * The child `<option>`s.
       */
    }, {
      kind: "get",
      key: "options",
      value: function () {
        return this._selectNode.options;
      }

      /**
       * This form control's type.
       */
    }, {
      kind: "get",
      key: "type",
      value: function () {
        return this._selectNode.type;
      }

      /**
       * Sets the select to be focussed automatically on page load. Defaults to false
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "autofocus",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'helper-text'
      })],
      key: "helperText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'hide-label'
      })],
      key: "hideLabel",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "id",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "invalid",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'invalid-text'
      })],
      key: "invalidText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "warn",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'warn-text'
      })],
      key: "warnText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'label-text'
      })],
      key: "labelText",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "inline",
      value() {
        return false;
      }
    }, {
      kind: "get",
      decorators: [n$1({
        type: Boolean
      })],
      key: "multiple",
      value:
      /**
       * Controls the disabled state of the select
       */
      /**
       * The helper text.
       */
      /**
       * Specify whether the label should be hidden, or not
       */
      /**
       * ID to link the `label` and `select`
       */
      /**
       * Specify if the currently value is invalid.
       */
      /**
       * Message which is displayed if the value is invalid.
       */
      /**
       * Specify if the currently value is warn.
       */
      /**
       * Message which is displayed if the value is warn.
       */
      /**
       * The label text.
       */
      /**
       * Specify whether you want the inline version of this control
       */
      /**
       * `true` to enable multiple selection.
       */
      function () {
        return false;
      }

      /**
       * Name for the select in the `FormData`
       */
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "name",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "pattern",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "placeholder",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "readonly",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "required",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'required-validity-message'
      })],
      key: "requiredValidityMessage",
      value() {
        return 'Please fill out this field.';
      }
    }, {
      kind: "get",
      decorators: [n$1({
        type: Number
      })],
      key: "selectedIndex",
      value:
      /**
       * Pattern to validate the select against for HTML validity checking
       */
      /**
       * Value to display when the select has an empty `value`
       */
      /**
       * Controls the readonly state of the select
       */
      /**
       * Boolean property to set the required status
       */
      /**
       * The special validity message for `required`.
       */
      /**
       * The selected index.
       */
      function () {
        return this._selectNode.selectedIndex;
      }
    }, {
      kind: "set",
      key: "selectedIndex",
      value: function (value) {
        this._selectNode.selectedIndex = value;
        this.value = this._selectNode.value;
      }

      /**
       * The input box size.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return INPUT_SIZE.MEDIUM;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "value",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The value of the text area.
       */
      function connectedCallback() {
        _superPropGet$n(CDSSelect, "connectedCallback", this, 3)([]);
        this._observerMutation = new MutationObserver(this._handleMutation);
        this._observerMutation.observe(this, {
          attributes: true,
          childList: true,
          subtree: true
        });
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        if (this._observerMutation) {
          this._observerMutation.disconnect();
          this._observerMutation = null;
        }
        _superPropGet$n(CDSSelect, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        var _this$shadowRoot, _this$querySelector;
        if (changedProperties.has('value')) {
          const {
            value,
            _placeholderItemValue: placeholderItemValue
          } = this;
          // Ensures setting the `value` after rendering child `<option>`s/`<optgroup>`s when there is a change in `value`,
          // given reflecting `value` requires child `<option>`s/`<optgroup>`s being there beforehand
          this._selectNode.value = !value ? placeholderItemValue : value;
        }
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || (_this$shadowRoot = _this$shadowRoot.querySelector("slot[name='slug']")) === null || _this$shadowRoot === void 0 || _this$shadowRoot.classList.toggle(`${prefix$B}--slug--revert`, (_this$querySelector = this.querySelector(`${prefix$B}-slug`)) === null || _this$querySelector === void 0 ? void 0 : _this$querySelector.hasAttribute('revert-active'));
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          disabled,
          helperText,
          hideLabel,
          inline,
          invalid,
          invalidText,
          labelText,
          placeholder,
          readonly,
          size,
          warn,
          warnText,
          value,
          _placeholderItemValue: placeholderItemValue,
          _handleInput: handleInput,
          _handleSlugSlotChange: handleSlugSlotChange,
          _hasSlug: hasSlug
        } = this;
        const selectClasses = o$2({
          [`${prefix$B}--select`]: true,
          [`${prefix$B}--select--inline`]: inline,
          [`${prefix$B}--select--invalid`]: invalid,
          [`${prefix$B}--select--warning`]: warn,
          [`${prefix$B}--select--disabled`]: disabled,
          [`${prefix$B}--select--readonly`]: readonly,
          [`${prefix$B}--select--slug`]: hasSlug
        });
        const inputClasses = o$2({
          [`${prefix$B}--select-input`]: true,
          [`${prefix$B}--select-input--${size}`]: size
        });
        const labelClasses = o$2({
          [`${prefix$B}--label`]: true,
          [`${prefix$B}--label--disabled`]: disabled
        });
        const helperTextClasses = o$2({
          [`${prefix$B}--form__helper-text`]: true,
          [`${prefix$B}--form__helper-text--disabled`]: disabled
        });
        const supplementalText = helperText ? x(_t4$6 || (_t4$6 = _$x`
          <div class="${0}">
            <slot name="helper-text"> ${0} </slot>
          </div>
        `), helperTextClasses, helperText) : null;
        const errorText = invalid || warn ? x(_t5$6 || (_t5$6 = _$x` <div class="${0}--form-requirement">
            ${0}
          </div>`), prefix$B, invalid ? invalidText : warnText) : null;
        const input = x(_t6$5 || (_t6$5 = _$x`
      <select
        id="input"
        class="${0}"
        ?disabled="${0}"
        aria-readonly="${0}"
        aria-invalid="${0}"
        aria-describedby="${0}"
        @input="${0}">
        ${0}
        ${0}
      </select>
      ${0}
      <slot name="slug" @slotchange=${0}></slot>
      ${0}
      ${0}
    `), inputClasses, disabled, String(Boolean(readonly)), String(Boolean(invalid)), l(!invalid ? undefined : 'invalid-text'), handleInput, !placeholder || value ? undefined : x(_t7$5 || (_t7$5 = _$x`
              <option
                disabled
                hidden
                class="${0}--select-option"
                value="${0}"
                selected>
                ${0}
              </option>
            `), prefix$B, placeholderItemValue, placeholder), this._renderItems(this), svgResultCarbonIcon$H({
          class: `${prefix$B}--select__arrow`
        }), handleSlugSlotChange, !invalid ? undefined : svgResultCarbonIcon$G({
          class: `${prefix$B}--select__invalid-icon`
        }), !invalid && warn ? svgResultCarbonIcon$F({
          class: `${prefix$B}--select__invalid-icon ${prefix$B}--select__invalid-icon--warning`
        }) : null);
        return x(_t8$5 || (_t8$5 = _$x`
      <div class="${0}">
        ${0}
        ${0}
        ${0}
      </div>
    `), selectClasses, !hideLabel ? x(_t9$4 || (_t9$4 = _$x`<label class="${0}" for="input">
              <slot name="label-text"> ${0} </slot>
            </label>`), labelClasses, labelText) : null, inline ? x(_t10$4 || (_t10$4 = _$x`<div class="${0}--select-input--inline__wrapper">
              <div
                class="${0}--select-input__wrapper"
                ?data-invalid="${0}">
                ${0}
              </div>
              ${0}
            </div>`), prefix$B, prefix$B, invalid, input, errorText) : x(_t11$4 || (_t11$4 = _$x`<div
              class="${0}--select-input__wrapper"
              ?data-invalid="${0}">
              ${0}
            </div> `), prefix$B, invalid, input), !inline && errorText ? errorText : supplementalText);
      }

      /**
       * A selector selecting child pseudo `<optgroup>`/`<option>`.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${prefix$B}-select-item-group,${prefix$B}-select-item`;
      }

      /**
       * A selector selecting child pseudo `<option>`.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorLeafItem",
      value: function () {
        return `${prefix$B}-select-item`;
      }

      /**
       * A selector that will return the slug item.
       */
    }, {
      kind: "get",
      static: true,
      key: "slugItem",
      value: function () {
        return `${prefix$B}-slug`;
      }

      /**
       * The name of the custom event fired after item is selected.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelect",
      value: function () {
        return `${prefix$B}-select-selected`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$a;
      }
    }]
  };
}, FormMixin(s));

function _decorate$z(e, r, t, i) { var o = _getDecoratorsApi$z(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$z(s.d.map(_createElementDescriptor$z)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$z() { _getDecoratorsApi$z = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$z(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$z(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$z(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$z(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$z(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$z(e) { var r, t = _toPropertyKey$z(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$z(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$z(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$z(o.descriptor) || _isDataDescriptor$z(i.descriptor)) { if (_hasDecorators$z(o) || _hasDecorators$z(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$z(o)) { if (_hasDecorators$z(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$z(o, i); } } else r.push(o); } return r; }
function _hasDecorators$z(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$z(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$z(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$z(t) { var i = _toPrimitive$z(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$z(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$z(r) { return _arrayWithHoles$A(r) || _iterableToArray$z(r) || _unsupportedIterableToArray$A(r) || _nonIterableRest$A(); }
function _nonIterableRest$A() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$A(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$A(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$A(r, a) : void 0; } }
function _arrayLikeToArray$A(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$z(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$A(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$z
} = settings;

/**
 * Language selector component - mobile version.
 * The API for language selection is still subject to change.
 *
 * @element c4d-language-selector-mobile
 */
_decorate$z([carbonElement(`${c4dPrefix$z}-language-selector-mobile`)], function (_initialize, _CDSSelect) {
  class C4DLanguageSelectorMobile extends _CDSSelect {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLanguageSelectorMobile,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'language-selector';
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$l;
      }
    }]
  };
}, CDSSelect);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$j = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}${children}<path d="M13 24L4 15 5.414 13.586 13 21.171 26.586 7.586 28 9 13 24z"></path></svg>`;

let _$w = t => t,
  _t$x;
function _superPropGet$m(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Dropdown item.
 *
 * @element cds-dropdown-item
 * @csspart selected-icon The selected icon.
 */
let CDSDropdownItem = _decorate$Z([carbonElement(`${prefix$B}-dropdown-item`)], function (_initialize, _LitElement) {
  class CDSDropdownItem extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSDropdownItem,
    d: [{
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "highlighted",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "selected",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return DROPDOWN_SIZE.MEDIUM;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "value",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * `true` if this dropdown item should be disabled.
       */

      /**
       * `true` if this dropdown item should be highlighted.
       * If `true`, parent `<dropdown>` selects/deselects this dropdown item upon keyboard interaction.
       *
       * @private
       */

      /**
       * `true` if this dropdown item should be selected.
       *
       * @private
       */

      /**
       * Dropdown size.
       */

      /**
       * The `value` attribute that is set to the parent `<cds-dropdown>` when this dropdown item is selected.
       */

      function connectedCallback() {
        _superPropGet$m(CDSDropdownItem, "connectedCallback", this, 3)([]);
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'option');
        }
        if (!this.hasAttribute('id')) {
          this.setAttribute('id', `${prefix$B}-dropdown-item-${this.constructor.id++}`);
        }
        this.setAttribute('aria-selected', String(this.selected));
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          selected
        } = this;
        return x(_t$x || (_t$x = _$w`
      <div class="${0}--list-box__menu-item__option">
        <slot></slot>
        ${0}
      </div>
    `), prefix$B, !selected ? undefined : svgResultCarbonIcon$j({
          part: 'selected-icon',
          class: `${prefix$B}--list-box__menu-item__selected-icon`
        }));
      }

      /**
       * Store an identifier for use in composing this item's id.
       *
       * Auto-increments anytime a new dropdown-item appears.
       */
    }, {
      kind: "field",
      static: true,
      key: "id",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$k;
      }
    }]
  };
}, s);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$9 = i$4([
  "@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}input:-webkit-autofill,input:-webkit-autofill:focus,input:-webkit-autofill:hover,textarea:-webkit-autofill,textarea:-webkit-autofill:focus,textarea:-webkit-autofill:hover{box-shadow:0 0 0 1000px var(--cds-field) inset;-webkit-text-fill-color:var(--cds-text-primary,#161616)}.cds--fieldset{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--fieldset *,.cds--fieldset ::after,.cds--fieldset ::before{box-sizing:inherit}.cds--form-item{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start}.cds--label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:inline-block;color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;margin-block-end:.5rem;vertical-align:baseline}.cds--label html{font-size:100%}.cds--label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--label strong{font-weight:600}.cds--label .cds--toggletip-label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label--no-margin{margin-block-end:0}.cds--label+.cds--tooltip{position:relative;inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label+.cds--tooltip .cds--tooltip__trigger{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:flex;align-items:center;justify-content:center;font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px)}.cds--label+.cds--tooltip .cds--tooltip__trigger *,.cds--label+.cds--tooltip .cds--tooltip__trigger ::after,.cds--label+.cds--tooltip .cds--tooltip__trigger ::before{box-sizing:inherit}.cds--label+.cds--tooltip .cds--tooltip__trigger::-moz-focus-inner{border:0}.cds--label+.cds--tooltip .cds--tooltip__trigger:focus{outline:1px solid var(--cds-focus,#0f62fe)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252)}.cds--label+.cds--tooltip .cds--tooltip__trigger svg :hover{fill:var(--cds-icon-primary,#161616)}.cds--label+.cds--toggletip{inset-block-start:.2rem;inset-inline-start:.5rem}.cds--label.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:.875rem;inline-size:4.6875rem}.cds--label.cds--skeleton:active,.cds--label.cds--skeleton:focus,.cds--label.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--label.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--label.cds--skeleton::before{animation:none}}input[type=number]{font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif}.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus),.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,.cds--combo-box--invalid--focused),.cds--number[data-invalid] input[type=number]:not(:focus),.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),.cds--text-area__wrapper[data-invalid]>.cds--text-area--invalid:not(:focus),.cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:not(:focus),input[data-invalid]:not(:focus){outline-style:dotted}}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper--warn~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box--warning~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--number__input-wrapper--warning~.cds--form-requirement,.cds--select--warning .cds--select-input__wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper--warn~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper--warning>.cds--text-input~.cds--form-requirement,.cds--text-input__field-wrapper--warning~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker--warning~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--date-picker-input__wrapper--invalid~.cds--form-requirement,.cds--date-picker-input__wrapper~.cds--form-requirement,.cds--list-box[data-invalid]~.cds--form-requirement,.cds--number[data-invalid] .cds--number__input-wrapper~.cds--form-requirement,.cds--select-input__wrapper[data-invalid]~.cds--form-requirement,.cds--text-area__wrapper[data-invalid]~.cds--form-requirement,.cds--text-input__field-wrapper[data-invalid]~.cds--form-requirement,.cds--time-picker--invalid~.cds--form-requirement,.cds--time-picker[data-invalid]~.cds--form-requirement,input[data-invalid]~.cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input__field-wrapper--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]{display:block}.cds--form--fluid input[data-invalid]{outline:0}.cds--form--fluid .cds--form-requirement{padding:.5rem 2.5rem .5rem 1rem;margin:0}input:not(output,[data-invalid]):-moz-ui-invalid{box-shadow:none}.cds--form-requirement{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);display:none;overflow:hidden;margin:.25rem 0 0;max-block-size:0}.cds--form-requirement html{font-size:100%}.cds--form-requirement body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--form-requirement code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--form-requirement strong{font-weight:600}.cds--select--inline .cds--form__helper-text{margin-block-start:0}.cds--form__helper-text{font-size:var(--cds-helper-text-01-font-size,.75rem);line-height:var(--cds-helper-text-01-line-height,1.33333);letter-spacing:var(--cds-helper-text-01-letter-spacing,.32px);z-index:0;color:var(--cds-text-secondary,#525252);inline-size:100%;margin-block-start:.25rem;opacity:1}.cds--form__helper-text--disabled,.cds--label--disabled{color:var(--cds-text-disabled,rgba(22,22,22,.25))}fieldset[disabled] .cds--form__helper-text,fieldset[disabled] .cds--label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;padding:0 var(--cds-layout-density-padding-inline-local);border:none;background-color:var(--cds-field);block-size:var(--cds-layout-size-height-local);border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);font-family:inherit;inline-size:100%;transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input *,.cds--text-input ::after,.cds--text-input ::before{box-sizing:inherit}.cds--text-input:active,.cds--text-input:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--text-input:active,.cds--text-input:focus{outline-style:dotted}}.cds--text-input-wrapper svg[hidden]{display:none}.cds--password-input{padding-inline-end:2.5rem}.cds--text-input--sm.cds--password-input{padding-inline-end:2rem}.cds--text-input--lg.cds--password-input{padding-inline-end:3rem}.cds--text-input::-moz-placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input::placeholder{color:var(--cds-text-placeholder,rgba(22,22,22,.4));opacity:1}.cds--text-input--light{background-color:var(--cds-field-02,#fff)}.cds--text-input__field-wrapper{position:relative;display:flex;inline-size:100%}.cds--text-input__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--text-input__invalid-icon--warning path:first-of-type{fill:#000;opacity:1}.cds--text-input--password__visibility{position:relative;display:inline-flex;overflow:visible;align-items:center;cursor:pointer}.cds--text-input--password__visibility:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus{outline-style:dotted}}.cds--text-input--password__visibility:focus{outline:1px solid transparent}.cds--text-input--password__visibility:focus svg{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--text-input--password__visibility:focus svg{outline-style:dotted}}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{position:absolute;z-index:6000;display:flex;align-items:center;opacity:0;pointer-events:none}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{display:inline-block}}.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:opacity 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (prefers-reduced-motion:reduce){.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{transition:none}}.cds--text-input--password__visibility.cds--tooltip--a11y::after,.cds--text-input--password__visibility.cds--tooltip--a11y::before{transition:none}.cds--text-input--password__visibility::before{border-style:solid;block-size:0;content:\"\";inline-size:0}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text{box-sizing:content-box;color:inherit;opacity:1;white-space:normal;word-break:break-word}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));z-index:6000;padding:.1875rem 1rem;border-radius:.125rem;background-color:var(--cds-background-inverse,#393939);block-size:auto;color:var(--cds-text-inverse,#fff);font-weight:400;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:13rem;min-inline-size:1.5rem;text-align:start;transform:translateX(-50%);font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-accelerator:true){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@supports (-ms-ime-align:auto){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inline-size:auto}}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{border:1px solid transparent}}.cds--text-input--password__visibility::after{content:attr(aria-label)}.cds--text-input--password__visibility.cds--tooltip--a11y::after{content:none}.cds--text-input--password__visibility.cds--tooltip--visible::after,.cds--text-input--password__visibility.cds--tooltip--visible::before,.cds--text-input--password__visibility:focus::after,.cds--text-input--password__visibility:focus::before,.cds--text-input--password__visibility:hover::after,.cds--text-input--password__visibility:hover::before{opacity:1}@keyframes cds--tooltip-fade{from{opacity:0}to{opacity:1}}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text{overflow:visible;margin:auto;clip:auto}.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible+.cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before,.cds--text-input--password__visibility:focus .cds--assistive-text,.cds--text-input--password__visibility:focus+.cds--assistive-text,.cds--text-input--password__visibility:focus.cds--tooltip--a11y::before,.cds--text-input--password__visibility:hover .cds--assistive-text,.cds--text-input--password__visibility:hover+.cds--assistive-text,.cds--text-input--password__visibility:hover.cds--tooltip--a11y::before{animation:cds--tooltip-fade 70ms cubic-bezier(.2,0,.38,.9)}.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text,.cds--text-input--password__visibility.cds--tooltip--hidden+.cds--assistive-text{overflow:hidden;margin:-1px;clip:rect(0,0,0,0)}.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before{animation:none;opacity:0}.cds--text-input--password__visibility .cds--assistive-text::after{position:absolute;display:block;content:\"\";block-size:.75rem;inline-size:100%;inset-inline-start:0;inset-block-start:-.75rem}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after,.cds--text-input--password__visibility::before{inset-block-end:0;inset-inline-start:50%}.cds--text-input--password__visibility::before{border-width:0 .25rem .3125rem .25rem;border-color:transparent transparent var(--cds-background-inverse,#393939) transparent;inset-block-end:-.5rem;transform:translate(-50%,100%)}.cds--text-input--password__visibility .cds--assistive-text,.cds--text-input--password__visibility+.cds--assistive-text,.cds--text-input--password__visibility::after{inset-block-end:-.8125rem;transform:translate(-50%,100%)}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{outline:2px solid transparent;outline-offset:-2px;position:absolute;display:flex;align-items:center;justify-content:center;padding:0;border:0;background:0 0;block-size:100%;cursor:pointer;inline-size:2.5rem;inset-inline-end:0;min-block-size:auto;transition:outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--toggle-password-tooltip .cds--popover{inset-inline-start:-2.5rem}.cds--toggle-password-tooltip .cds--popover-content{min-inline-size:2.5rem}.cds--text-input--sm+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:2rem}.cds--text-input--lg+.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{inline-size:3rem}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-secondary,#525252);transition:fill 70ms cubic-bezier(.2,0,.38,.9)}@media screen and (-ms-high-contrast:active),screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:ButtonText}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus{outline-style:dotted}}.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg,.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-primary,#161616)}.cds--text-input--invalid,.cds--text-input--warning{padding-inline-end:2.5rem}.cds--text-input--invalid.cds--password-input{padding-inline-end:4rem}.cds--text-input--invalid+.cds--text-input--password__visibility__toggle{inset-inline-end:1rem}.cds--password-input-wrapper .cds--text-input__invalid-icon{inset-inline-end:2.5rem}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger{cursor:not-allowed}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input:disabled~.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover{cursor:default}.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--text-input__counter-alert{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px}.cds--text-input:disabled{outline:2px solid transparent;outline-offset:-2px;background-color:var(--cds-field);border-block-end:1px solid transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;-webkit-text-fill-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--text-input--light:disabled{background-color:var(--cds-field-02,#fff)}.cds--text-input:disabled::-moz-placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input:disabled::placeholder{color:var(--cds-text-disabled,rgba(22,22,22,.25));opacity:1}.cds--text-input--invalid{outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px;box-shadow:none}@media screen and (prefers-contrast){.cds--text-input--invalid{outline-style:dotted}}.cds--text-input--invalid .cds--text-input--password__visibility__toggle{inset-inline-end:2.5rem}.cds--skeleton.cds--text-input{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}.cds--skeleton.cds--text-input:active,.cds--skeleton.cds--text-input:focus,.cds--skeleton.cds--text-input:hover{border:none;cursor:default;outline:0}.cds--skeleton.cds--text-input::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--skeleton.cds--text-input::before{animation:none}}.cds--form--fluid .cds--text-input-wrapper{position:relative;background:var(--cds-field);transition:background-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--form--fluid .cds--label{position:absolute;z-index:1;display:flex;align-items:center;margin:0;block-size:1rem;inset-block-start:.8125rem;inset-inline-start:1rem}.cds--form--fluid .cds--form__helper-text{display:none}.cds--form--fluid .cds--text-input{padding:2rem 1rem .8125rem;min-block-size:4rem}.cds--form--fluid .cds--text-input__divider,.cds--text-input__divider{display:none}.cds--form--fluid .cds--text-input--invalid,.cds--form--fluid .cds--text-input--warning{border-block-end:none}.cds--form--fluid .cds--text-input--invalid+.cds--text-input__divider,.cds--form--fluid .cds--text-input--warning+.cds--text-input__divider{display:block;border-style:solid;border-color:var(--cds-border-subtle);margin:0 1rem;border-block-end:none}.cds--form--fluid .cds--text-input__invalid-icon{inset-block-start:5rem}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid{outline:0}.cds--form--fluid .cds--text-input__field-wrapper--warning{border-block-end:1px solid var(--cds-border-strong)}.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus){outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within{outline-style:dotted}}.cds--form--fluid .cds--text-input__field-wrapper--warning>.cds--text-input--warning:focus,.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]>.cds--text-input--invalid:focus{outline:0}.cds--text-input-wrapper.cds--text-input-wrapper--inline{flex-flow:row wrap}.cds--text-input-wrapper .cds--label--inline{flex:1;margin:.8125rem 0 0 0;overflow-wrap:break-word;word-break:break-word}.cds--text-input-wrapper .cds--label--inline--sm{margin-block-start:.5625rem}.cds--text-input-wrapper .cds--label--inline--lg{margin-block-start:1.0625rem}.cds--text-input__label-helper-wrapper{flex:2;flex-direction:column;margin-inline-end:1.5rem;max-inline-size:8rem;overflow-wrap:break-word}.cds--text-input-wrapper .cds--form__helper-text--inline{margin-block-start:.125rem}.cds--text-input__field-outer-wrapper{display:flex;flex:1 1 auto;flex-direction:column;align-items:flex-start;inline-size:100%}.cds--text-input__field-outer-wrapper--inline{flex:8;flex-direction:column}.cds--text-input-wrapper--inline .cds--form-requirement{display:block;overflow:visible;font-weight:400;max-block-size:12.5rem}.cds--text-input-wrapper--inline--invalid .cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--form--fluid .cds--text-input-wrapper--readonly,.cds--text-input-wrapper--readonly .cds--text-input{background:0 0;border-block-end-color:var(--cds-border-subtle)}.cds--text-input__field-wrapper .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff);padding-inline-end:2.5rem}.cds--text-input--invalid:has(~.cds--slug),.cds--text-input--warning:has(~.cds--slug){padding-inline-end:4rem}.cds--text-input--invalid~.cds--slug,.cds--text-input--warning~.cds--slug{inset-inline-end:2.5rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,.cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg{fill:ButtonText}}.cds--text-input__label-wrapper{display:flex;justify-content:space-between;inline-size:100%}.cds--text-input__label-wrapper .cds--text-input__label-counter{align-self:end}.cds--tag{--cds-layout-size-height-xs:1.125rem;--cds-layout-size-height-sm:1.125rem;--cds-layout-size-height-md:1.5rem;--cds-layout-size-height-lg:2rem;--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);background-color:var(--cds-tag-background-gray,#e0e0e0);color:var(--cds-tag-color-gray,#161616);display:inline-flex;align-items:center;justify-content:center;border-radius:1rem;margin:.25rem;cursor:default;max-inline-size:13rem;min-block-size:var(--cds-layout-size-height-local);min-inline-size:2rem;padding-inline:.5rem;vertical-align:middle;word-break:break-word}.cds--layout--size-xs .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-xs)}.cds--layout--size-sm .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--tag{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--tag.cds--tag--operational{border:1px solid var(--cds-tag-background-gray,#e0e0e0)}.cds--tag.cds--tag--operational:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag.cds--tag--lg{padding-inline-start:.75rem}.cds--tag:has(.cds--tag__custom-icon){padding-inline-start:.25rem}.cds--tag.cds--tag--lg:not(.cds--tag--filter){padding-inline:.75rem}.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon){padding-inline-start:.5rem}.cds--tag:not(.cds--tag--selectable){border:0}.cds--tag:not(:first-child){margin-inline-start:0}.cds--tag--operational>span,.cds--tag--selectable>span,.cds--tag__label{display:block;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.cds--tag--interactive:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--tag--filter{padding-block-end:0;padding-block-start:0;padding-inline-end:0}.cds--tag--filter:hover{outline:0}.cds--tag--selectable{border:1px solid var(--cds-border-inverse,#161616);background-color:var(--cds-layer);color:var(--cds-text-primary,#161616);cursor:pointer}.cds--tag--selectable:hover{background-color:var(--cds-layer-hover);outline:0}.cds--tag--selectable:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--tag--selectable-selected{background-color:var(--cds-layer-selected-inverse,#161616);color:var(--cds-text-inverse,#fff)}.cds--tag--selectable-selected:hover{background-color:var(--cds-layer-selected-inverse,#161616)}.cds--tag--operational{border:1px solid var(--cds-tag-border-gray,#a8a8a8);background-color:var(--cds-tag-background-gray,#e0e0e0);color:var(--cds-tag-color-gray,#161616);cursor:pointer}.cds--tag--operational:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1);outline:0}.cds--tag--operational:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--tag--red{background-color:var(--cds-tag-background-red,#ffd7d9);color:var(--cds-tag-color-red,#750e13)}.cds--tag--red.cds--tag--operational{border:1px solid var(--cds-tag-border-red,#ff8389)}.cds--tag--red.cds--tag--operational:hover{background-color:var(--cds-tag-hover-red,#ffc2c5)}.cds--tag--red .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-red,#ffc2c5)}.cds--tag--magenta{background-color:var(--cds-tag-background-magenta,#ffd6e8);color:var(--cds-tag-color-magenta,#740937)}.cds--tag--magenta.cds--tag--operational{border:1px solid var(--cds-tag-border-magenta,#ff7eb6)}.cds--tag--magenta.cds--tag--operational:hover{background-color:var(--cds-tag-hover-magenta,#ffbdda)}.cds--tag--magenta .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-magenta,#ffbdda)}.cds--tag--purple{background-color:var(--cds-tag-background-purple,#e8daff);color:var(--cds-tag-color-purple,#491d8b)}.cds--tag--purple.cds--tag--operational{border:1px solid var(--cds-tag-border-purple,#be95ff)}.cds--tag--purple.cds--tag--operational:hover{background-color:var(--cds-tag-hover-purple,#dcc7ff)}.cds--tag--purple .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-purple,#dcc7ff)}.cds--tag--blue{background-color:var(--cds-tag-background-blue,#d0e2ff);color:var(--cds-tag-color-blue,#002d9c)}.cds--tag--blue.cds--tag--operational{border:1px solid var(--cds-tag-border-blue,#78a9ff)}.cds--tag--blue.cds--tag--operational:hover{background-color:var(--cds-tag-hover-blue,#b8d3ff)}.cds--tag--blue .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-blue,#b8d3ff)}.cds--tag--cyan{background-color:var(--cds-tag-background-cyan,#bae6ff);color:var(--cds-tag-color-cyan,#003a6d)}.cds--tag--cyan.cds--tag--operational{border:1px solid var(--cds-tag-border-cyan,#33b1ff)}.cds--tag--cyan.cds--tag--operational:hover{background-color:var(--cds-tag-hover-cyan,#99daff)}.cds--tag--cyan .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-cyan,#99daff)}.cds--tag--teal{background-color:var(--cds-tag-background-teal,#9ef0f0);color:var(--cds-tag-color-teal,#004144)}.cds--tag--teal.cds--tag--operational{border:1px solid var(--cds-tag-border-teal,#08bdba)}.cds--tag--teal.cds--tag--operational:hover{background-color:var(--cds-tag-hover-teal,#57e5e5)}.cds--tag--teal .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-teal,#57e5e5)}.cds--tag--green{background-color:var(--cds-tag-background-green,#a7f0ba);color:var(--cds-tag-color-green,#044317)}.cds--tag--green.cds--tag--operational{border:1px solid var(--cds-tag-border-green,#42be65)}.cds--tag--green.cds--tag--operational:hover{background-color:var(--cds-tag-hover-green,#74e792)}.cds--tag--green .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-green,#74e792)}.cds--tag--gray{background-color:var(--cds-tag-background-gray,#e0e0e0);color:var(--cds-tag-color-gray,#161616)}.cds--tag--gray.cds--tag--operational{border:1px solid var(--cds-tag-border-gray,#a8a8a8)}.cds--tag--gray.cds--tag--operational:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag--gray .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-gray,#d1d1d1)}.cds--tag--cool-gray{background-color:var(--cds-tag-background-cool-gray,#dde1e6);color:var(--cds-tag-color-cool-gray,#121619)}.cds--tag--cool-gray.cds--tag--operational{border:1px solid var(--cds-tag-border-cool-gray,#a2a9b0)}.cds--tag--cool-gray.cds--tag--operational:hover{background-color:var(--cds-tag-hover-cool-gray,#cdd3da)}.cds--tag--cool-gray .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-cool-gray,#cdd3da)}.cds--tag--warm-gray{background-color:var(--cds-tag-background-warm-gray,#e5e0df);color:var(--cds-tag-color-warm-gray,#171414)}.cds--tag--warm-gray.cds--tag--operational{border:1px solid var(--cds-tag-border-warm-gray,#ada8a8)}.cds--tag--warm-gray.cds--tag--operational:hover{background-color:var(--cds-tag-hover-warm-gray,#d8d0cf)}.cds--tag--warm-gray .cds--tag__close-icon:hover{background-color:var(--cds-tag-hover-warm-gray,#d8d0cf)}.cds--tag--high-contrast:not(.cds--tag--operational){background-color:var(--cds-background-inverse,#393939);color:var(--cds-text-inverse,#fff)}.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational{border:1px solid var(--cds-background-inverse,#393939)}.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover{background-color:var(--cds-background-inverse-hover,#474747)}.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover{background-color:var(--cds-background-inverse-hover,#474747)}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]){background-color:var(--cds-background,#fff);color:var(--cds-text-primary,#161616);outline:1px solid var(--cds-background-inverse,#393939);outline-offset:-1px}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational{border:1px solid var(--cds-background,#fff)}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover{background-color:var(--cds-layer-hover)}.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover{background-color:var(--cds-layer-hover)}.cds--tag--disabled:not(.cds--tag--operational),.cds--tag--filter.cds--tag--disabled,.cds--tag--interactive.cds--tag--disabled{background-color:var(--cds-layer);color:var(--cds-text-disabled,rgba(22,22,22,.25));box-shadow:none;outline:0}.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,.cds--tag--filter.cds--tag--disabled.cds--tag--operational,.cds--tag--interactive.cds--tag--disabled.cds--tag--operational{border:1px solid var(--cds-layer)}.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover{background-color:var(--cds-layer)}.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover{background-color:var(--cds-layer)}.cds--tag--disabled:not(.cds--tag--operational):hover,.cds--tag--filter.cds--tag--disabled:hover,.cds--tag--interactive.cds--tag--disabled:hover{cursor:not-allowed}.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,.cds--tag--filter.cds--tag--disabled .cds--tag__label,.cds--tag--interactive.cds--tag--disabled .cds--tag__label{background-color:var(--cds-layer);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--tag--operational.cds--tag--disabled,.cds--tag--selectable.cds--tag--disabled{border:1px solid var(--cds-border-disabled,#c6c6c6);background-color:var(--cds-layer);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--tag--operational.cds--tag--disabled:hover,.cds--tag--selectable.cds--tag--disabled:hover{background-color:var(--cds-layer);cursor:not-allowed}.cds--tag--interactive{transition:background-color 70ms cubic-bezier(0,0,.38,.9)}.cds--tag__close-icon{display:flex;flex-shrink:0;align-items:center;justify-content:center;padding:0;border:0;border-radius:50%;margin:0 0 0 .125rem;background-color:transparent;block-size:var(--cds-layout-size-height-local);color:currentColor;cursor:pointer;inline-size:var(--cds-layout-size-height-local);transition:background-color 70ms cubic-bezier(.2,0,.38,.9),box-shadow 70ms cubic-bezier(.2,0,.38,.9)}.cds--tag__close-icon svg{fill:currentColor}.cds--tag__custom-icon{flex-shrink:0;padding:0;border:0;background-color:transparent;block-size:1rem;color:currentColor;inline-size:1rem;margin-inline-end:.25rem;outline:0}.cds--tag__custom-icon svg{fill:currentColor}.cds--tag--disabled .cds--tag__close-icon{cursor:not-allowed}.cds--tag__close-icon:focus{z-index:99999;border-radius:50%;box-shadow:inset 0 0 0 1px var(--cds-focus,#0f62fe);outline:0}.cds--tag--high-contrast .cds--tag__close-icon:focus{box-shadow:inset 0 0 0 1px var(--cds-focus-inverse,#fff)}.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover{background-color:transparent}.cds--tag--filter.cds--tag--disabled svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--tag--sm.cds--tag--filter{padding-inline-end:0}.cds--tag--sm .cds--tag__close-icon{margin-inline-start:.3125rem}.cds--tag.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;background-color:var(--cds-skeleton-background,#e8e8e8);color:var(--cds-text-primary,#161616);overflow:hidden;inline-size:3.75rem}.cds--tag.cds--skeleton:active,.cds--tag.cds--skeleton:focus,.cds--tag.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--tag.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--tag.cds--skeleton::before{animation:none}}.cds--tag.cds--skeleton.cds--tag--operational{border:1px solid var(--cds-skeleton-background,#e8e8e8)}.cds--tag.cds--skeleton.cds--tag--operational:hover{background-color:var(--cds-skeleton-background,#e8e8e8)}.cds--tag.cds--skeleton .cds--tag__close-icon:hover{background-color:var(--cds-skeleton-background,#e8e8e8)}@media not all and (min-resolution >= 0.001dpcm){@supports (-webkit-appearance:none) and (stroke-color:transparent){.cds--tag.cds--skeleton{transform:translateZ(0)}}}.cds--tag .cds--slug .cds--slug__button--inline{color:currentColor;margin-inline-start:.0625rem}.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before{background-color:currentColor}.cds--tag .cds--slug .cds--slug__button--inline:hover{border-color:currentColor}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tag{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tag__close-icon svg,.cds--tag__custom-icon svg{fill:ButtonText}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tag__close-icon:focus{color:Highlight;outline:1px solid Highlight}}.cds--tag-label-tooltip{max-inline-size:-webkit-fill-available}.cds--tag__custom-icon+.cds--tag-label-tooltip{max-inline-size:11rem}.cds--tag--filter .cds--tag__custom-icon+.cds--tag-label-tooltip{max-inline-size:9.875rem}.cds--interactive--tag-children{display:inline-flex;max-inline-size:12.5rem;place-items:center}.cds--tag--filter .cds--tag__custom-icon+span>.cds--interactive--tag-children{max-inline-size:11.5rem}.cds--tag .cds--definition-term{border-block-end:none;cursor:default;max-inline-size:12rem}.cds--tag .cds--tag__custom-icon+span>.cds--definition-term{max-inline-size:11rem}.cds--tag>.cds--popover-container{display:flex}.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled){pointer-events:none}.cds--list-box__wrapper--inline,:host(cds-dropdown[type=inline]){display:inline-grid;align-items:center;grid-gap:.25rem;grid-template:auto auto/auto auto}.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--list-box__wrapper--inline .cds--form-requirement,.cds--list-box__wrapper--inline .cds--form__helper-text,.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--label{margin:0}.cds--list-box__wrapper--inline .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--form__helper-text{max-inline-size:none}.cds--list-box__wrapper--inline .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form-requirement{grid-column:2}.cds--list-box{position:relative;border:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;inline-size:100%;max-block-size:2.5rem;transition:all 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box html{font-size:100%}.cds--list-box body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--list-box code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--list-box strong{font-weight:600}.cds--list-box:hover{background-color:var(--cds-field-hover)}.cds--list-box--lg{block-size:3rem;max-block-size:3rem}.cds--list-box--sm{block-size:2rem;max-block-size:2rem}.cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box--expanded:hover{background-color:var(--cds-field)}.cds--list-box--expanded:hover.cds--list-box--light:hover{background-color:var(--cds-field-02,#fff)}.cds--list-box .cds--text-input{block-size:100%;min-inline-size:0}.cds--list-box__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:2.5rem;transform:translateY(-50%)}.cds--list-box__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--list-box__invalid-icon--warning path[fill]{fill:#000;opacity:1}.cds--list-box.cds--list-box--warning .cds--list-box__field,.cds--list-box[data-invalid] .cds--list-box__field{border-block-end:0;padding-inline-end:4rem}.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field,.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:3.5rem}.cds--list-box--light{background-color:var(--cds-field-02,#fff)}.cds--list-box--light:hover{background-color:var(--cds-field-hover)}.cds--list-box--light .cds--list-box__menu{background:var(--cds-layer)}.cds--list-box--light .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle)}.cds--list-box--light.cds--list-box--expanded{border-block-end-color:transparent}.cds--list-box--disabled:hover{background-color:var(--cds-field)}.cds--list-box--light.cds--list-box--disabled{background-color:var(--cds-field-02,#fff)}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__field:focus{border-block-end-color:transparent;outline:0}.cds--list-box--disabled .cds--list-box__label,.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__menu-icon>svg,.cds--list-box--disabled .cds--list-box__selection>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__menu-icon{cursor:not-allowed}.cds--list-box--disabled .cds--list-box__menu-item,.cds--list-box--disabled .cds--list-box__menu-item--highlighted,.cds--list-box--disabled .cds--list-box__menu-item:hover,.cds--list-box--disabled :host(cds-combo-box-item),.cds--list-box--disabled :host(cds-dropdown-item){color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}.cds--list-box--disabled .cds--list-box__selection:hover{cursor:not-allowed}.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field{padding-inline-end:3rem}.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:2rem}.cds--list-box.cds--list-box--inline{border-width:0;background-color:transparent}.cds--list-box.cds--list-box--inline:hover{background-color:var(--cds-layer-hover)}.cds--list-box.cds--list-box--inline.cds--list-box--expanded{border-block-end-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true]{border-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover,.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover{background-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__field{padding:0 2rem 0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon{inset-inline-end:.5rem}.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon{inset-inline-end:2rem}.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-primary,#161616)}.cds--list-box--inline .cds--list-box__field{block-size:100%}.cds--dropdown--inline .cds--list-box__field{max-inline-size:30rem}.cds--dropdown--inline .cds--list-box__menu{max-inline-size:30rem;min-inline-size:18rem}.cds--list-box__field{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;overflow:hidden;align-items:center;block-size:calc(100% + 1px);cursor:pointer;outline:0;padding-block:0;padding-inline-end:3rem;padding-inline-start:1rem;text-overflow:ellipsis;vertical-align:top;white-space:nowrap}.cds--list-box__field *,.cds--list-box__field ::after,.cds--list-box__field ::before{box-sizing:inherit}.cds--list-box__field::-moz-focus-inner{border:0}.cds--list-box__field:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__field:focus{outline-style:dotted}}.cds--list-box__field[disabled]{color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--list-box__field .cds--text-input{padding-inline-end:5rem}.cds--list-box--warning .cds--list-box__field .cds--text-input,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input{padding-inline-end:6.5625rem}.cds--list-box--warning .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon{inset-inline-end:5.125rem}.cds--list-box__field .cds--text-input--empty{padding-inline-end:3rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon{inset-inline-end:2.5rem}.cds--list-box__label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);overflow:hidden;color:var(--cds-text-primary,#161616);text-overflow:ellipsis;-webkit-user-select:none;-moz-user-select:none;user-select:none;white-space:nowrap}.cds--list-box__menu-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-inline-end:.75rem;outline:0;transition:transform 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu-icon *,.cds--list-box__menu-icon ::after,.cds--list-box__menu-icon ::before{box-sizing:inherit}.cds--list-box__menu-icon::-moz-focus-inner{border:0}.cds--list-box__menu-icon>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box__menu-icon--open{justify-content:center;inline-size:1.5rem;transform:rotate(180deg)}.cds--list-box__selection{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-block-start:50%;inset-inline-end:2.8125rem;transform:translateY(-50%);transition:background-color 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__selection *,.cds--list-box__selection ::after,.cds--list-box__selection ::before{box-sizing:inherit}.cds--list-box__selection::-moz-focus-inner{border:0}.cds--list-box__selection:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus{outline-style:dotted}}.cds--list-box__selection:focus:hover{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus:hover{outline-style:dotted}}.cds--list-box__selection>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box--disabled .cds--list-box__selection:focus{outline:0}.cds--list-box__selection--multi{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);position:static;display:flex;align-items:center;justify-content:space-between;padding:.5rem;border-radius:.75rem;background-color:var(--cds-background-inverse,#393939);block-size:1.5rem;color:var(--cds-text-inverse,#fff);inline-size:auto;inset-block-start:auto;line-height:0;margin-inline-end:.625rem;padding-inline-end:.125rem;transform:none}.cds--list-box__selection--multi>svg{padding:.125rem;block-size:1.25rem;fill:var(--cds-icon-inverse,#fff);inline-size:1.25rem;margin-inline-start:.25rem}.cds--list-box__selection--multi>svg:hover{border-radius:50%;background-color:var(--cds-button-secondary-hover,#474747)}.cds--list-box--disabled .cds--list-box__selection--multi{background-color:var(--cds-text-disabled,rgba(22,22,22,.25));color:var(--cds-layer)}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational{border:1px solid var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg:hover{background-color:initial}.cds--list-box__selection--multi:hover{outline:0}.cds--list-box__menu{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));position:absolute;z-index:9100;display:none;background-color:var(--cds-layer);inline-size:100%;inset-inline-end:0;inset-inline-start:0;overflow-y:auto;transition:max-height 110ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--list-box__menu:focus{outline-style:dotted}}.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu{display:none;max-block-size:0;visibility:hidden}.cds--list-box--expanded .cds--list-box__menu{display:block;max-block-size:13.75rem}.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu{max-block-size:16.5rem}.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu{max-block-size:11rem}.cds--list-box__menu-item,:host(cds-combo-box-item),:host(cds-dropdown-item){font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;block-size:2.5rem;color:var(--cds-text-secondary,#525252);cursor:pointer;transition:background 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--light .cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box--sm .cds--list-box__menu-item,.cds--list-box--sm :host(cds-combo-box-item),.cds--list-box--sm :host(cds-dropdown-item){block-size:2rem}.cds--list-box--lg .cds--list-box__menu-item,.cds--list-box--lg :host(cds-combo-box-item),.cds--list-box--lg :host(cds-dropdown-item){block-size:3rem}.cds--list-box--disabled .cds--list-box__menu-item:hover{background-color:transparent}.cds--list-box--light .cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item:hover .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item__option{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;outline:2px solid transparent;outline-offset:-2px;display:block;overflow:hidden;padding:.6875rem 0;margin:0 1rem;block-size:2.5rem;border-block-end:1px solid transparent;border-block-start:1px solid transparent;border-block-start-color:var(--cds-border-subtle-01,#c6c6c6);color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;padding-inline-end:1.5rem;text-decoration:none;text-overflow:ellipsis;transition:border-color 70ms cubic-bezier(.2,0,.38,.9),color 70ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}.cds--list-box__menu-item__option *,.cds--list-box__menu-item__option ::after,.cds--list-box__menu-item__option ::before{box-sizing:inherit}.cds--list-box__menu-item__option:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;border-color:transparent;margin:0}@media screen and (prefers-contrast){.cds--list-box__menu-item__option:focus{outline-style:dotted}}.cds--list-box__menu-item__option:hover{border-color:transparent;color:var(--cds-text-primary,#161616)}.cds--list-box--sm .cds--list-box__menu-item__option{block-size:2rem;padding-block-end:.4375rem;padding-block-start:.4375rem}.cds--list-box--lg .cds--list-box__menu-item__option{block-size:3rem;padding-block-end:.9375rem;padding-block-start:.9375rem}.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled],.cds--list-box__menu-item[disabled] *,.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;outline:0}.cds--list-box__menu-item[disabled]:hover{background-color:revert}.cds--list-box__menu-item[disabled] .cds--checkbox-label::before{border-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item--active+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option{margin:0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus{margin:0;padding-inline-end:.5rem;padding-inline-start:.5rem}.cds--list-box__menu-item--highlighted,:host(cds-combo-box-item[highlighted]),:host(cds-combo-box-item[selected]),:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;color:var(--cds-text-primary,#161616)}@media screen and (prefers-contrast){.cds--list-box__menu-item--highlighted,:host(cds-combo-box-item[highlighted]),:host(cds-combo-box-item[selected]),:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline-style:dotted}}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active,:host(cds-combo-box-item[selected]),:host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}.cds--list-box--light .cds--list-box__menu-item--active,.cds--list-box--light :host(cds-combo-box-item[selected]),.cds--list-box--light :host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected)}.cds--list-box__menu-item--active:hover{background-color:var(--cds-layer-selected-hover);border-block-end-color:var(--cds-layer-selected-hover)}.cds--list-box__menu-item--active .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active+.cds--list-box__menu-item>.cds--list-box__menu-item__option,.cds--list-box__menu-item--active+:host(cds-combo-box-item)>.cds--list-box__menu-item__option,.cds--list-box__menu-item--active+:host(cds-dropdown-item)>.cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+.cds--list-box__menu-item>.cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-combo-box-item)>.cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-dropdown-item)>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-combo-box-item)>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item)>.cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item__selected-icon{position:absolute;display:none;fill:var(--cds-icon-primary,#161616);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--list-box--inline .cds--list-box__menu-item__selected-icon{inset-inline-end:.5rem}.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__selected-icon,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}.cds--list-box__menu-item .cds--checkbox-label,:host(cds-combo-box-item) .cds--checkbox-label,:host(cds-dropdown-item) .cds--checkbox-label{inline-size:100%}.cds--list-box__menu-item .cds--checkbox-label-text,:host(cds-combo-box-item) .cds--checkbox-label-text,:host(cds-dropdown-item) .cds--checkbox-label-text{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.cds--list-box--up .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box__menu{inset-block-end:2.5rem}.cds--list-box--up .cds--list-box--sm .cds--list-box__menu,.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--sm .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--sm .cds--list-box__menu{inset-block-end:2rem}.cds--list-box--up .cds--list-box--lg .cds--list-box__menu,.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--lg .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--lg .cds--list-box__menu{inset-block-end:3rem}.cds--list-box input[role=combobox],.cds--list-box input[type=text]{background-color:inherit;min-inline-size:0;text-overflow:ellipsis}.cds--list-box__wrapper--slug .cds--slug,:host(cds-combo-box[slug]) .cds--slug,:host(cds-dropdown[slug]) .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:calc(2.5rem + 9px);margin-block-start:.03125rem;transform:translateY(-50%)}.cds--list-box__wrapper--slug .cds--slug::after,.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-combo-box[slug]) .cds--slug::after,:host(cds-combo-box[slug]) .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem}.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-combo-box[slug]) .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::before{display:none;inset-inline-start:-.5625rem}.cds--list-box__wrapper--slug .cds--slug::after,:host(cds-combo-box[slug]) .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::after{display:block;inset-inline-end:-.5625rem}.cds--list-box__wrapper--slug .cds--slug--revert::after,:host(cds-combo-box[slug]) .cds--slug--revert::after,:host(cds-dropdown[slug]) .cds--slug--revert::after{inset-block-start:.5rem;inset-inline-end:-.0625rem}.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)),:host(cds-combo-box[slug]) .cds--list-box:not(:has(.cds--slug--revert)),:host(cds-dropdown[slug]) .cds--list-box:not(:has(.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff)}.cds--list-box__wrapper--slug .cds--list-box input[role=combobox],:host(cds-combo-box[slug]) .cds--list-box input[role=combobox],:host(cds-dropdown[slug]) .cds--list-box input[role=combobox]{border-block-end-color:transparent}.cds--list-box__wrapper--slug .cds--list-box__field,.cds--list-box__wrapper--slug .cds--text-input--empty,:host(cds-combo-box[slug]) .cds--list-box__field,:host(cds-combo-box[slug]) .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box__field,:host(cds-dropdown[slug]) .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty),:host(cds-combo-box[slug]) .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--text-input:not(.cds--text-input--empty){padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__field,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input--empty,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--list-box__field,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input--empty{padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty),:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),:host(cds-combo-box[slug]) .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty){padding-inline-end:8.8125rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning{inset-inline-end:5.1875rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--slug::before,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--slug::before{display:block}.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,:host(cds-combo-box[slug]) .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,:host(cds-dropdown[slug]) .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug{inset-inline-end:calc(4rem + 18px)}.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-combo-box[slug]) .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon{inset-inline-end:7.25rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field,.cds--list-box__menu,.cds--multi-select .cds--tag--filter{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field:focus,.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--multi-select .cds--tag__close-icon:focus,:host(cds-combo-box-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-icon>svg,.cds--list-box__selection--multi>svg,.cds--list-box__selection>svg{fill:ButtonText}}.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-start:2.0625rem}.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-end:2.0625rem}.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon,:has(.cds--multi-select):host(cds-combo-box[slug]) .cds--list-box__menu-icon,:has(.cds--multi-select):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon,:has(.cds--dropdown):host(cds-combo-box[slug]) .cds--list-box__menu-icon,:has(.cds--dropdown):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}.cds--combo-box:hover{background-color:var(--cds-field)}.cds--combo-box.cds--list-box--light:hover{background-color:var(--cds-field-02,#fff)}.cds--combo-box .cds--text-input::-ms-clear{display:none}.cds--combo-box.cds--list-box--expanded .cds--text-input{border-block-end-color:var(--cds-border-subtle)}.cds--combo-box--input--focus.cds--text-input{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--combo-box--input--focus.cds--text-input{outline-style:dotted}}.cds--combo-box.cds--list-box--expanded:has(input[aria-activedescendant]:not([aria-activedescendant=\"\"])) .cds--combo-box--input--focus.cds--text-input{outline-offset:-.0625rem;outline-width:.0625rem}.cds--combo-box .cds--list-box__field,.cds--combo-box.cds--list-box--disabled.cds--list-box--warning .cds--list-box__field,.cds--combo-box.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field,.cds--combo-box.cds--list-box--warning .cds--list-box__field,.cds--combo-box.cds--list-box[data-invalid] .cds--list-box__field{padding:0}.cds--combo-box--readonly,.cds--combo-box--readonly:hover{background-color:transparent}.cds--combo-box--readonly .cds--text-input{border-block-end-color:var(--cds-border-subtle)}.cds--combo-box--readonly .cds--list-box__menu-icon,.cds--combo-box--readonly .cds--list-box__selection{cursor:default}.cds--combo-box--readonly .cds--list-box__menu-icon svg,.cds--combo-box--readonly .cds--list-box__selection svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--dropdown__wrapper--inline{display:inline-grid;align-items:center;grid-gap:0 1.5rem;grid-template:auto auto/auto min-content}.cds--dropdown__wrapper--inline .cds--label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--dropdown__wrapper--inline .cds--form-requirement,.cds--dropdown__wrapper--inline .cds--form__helper-text,.cds--dropdown__wrapper--inline .cds--label{margin:0}.cds--dropdown__wrapper--inline .cds--form-requirement{grid-column:2}.cds--dropdown{outline:2px solid transparent;outline-offset:-2px;position:relative;display:block;border:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;inline-size:100%;list-style:none;outline:2px solid transparent;transition:background-color 70ms cubic-bezier(.2,0,.38,.9)}.cds--dropdown html{font-size:100%}.cds--dropdown body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--dropdown code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--dropdown strong{font-weight:600}.cds--dropdown:hover{background-color:var(--cds-field-hover)}.cds--dropdown .cds--list-box__field{text-align:start}.cds--dropdown--lg{block-size:3rem;max-block-size:3rem}.cds--dropdown--lg .cds--dropdown__arrow{inset-block-start:1rem}.cds--dropdown--sm{block-size:2rem;max-block-size:2rem}.cds--dropdown--sm .cds--dropdown__arrow{inset-block-start:.5rem}.cds--dropdown--open{border-block-end-color:var(--cds-border-subtle)}.cds--dropdown--open .cds--list-box__field{outline:0}.cds--dropdown--invalid{outline:2px solid var(--cds-support-error,#da1e28);outline-offset:-2px}@media screen and (prefers-contrast){.cds--dropdown--invalid{outline-style:dotted}}.cds--dropdown--invalid .cds--dropdown-text{padding-inline-end:3.5rem}.cds--dropdown--invalid+.cds--form-requirement{display:inline-block;color:var(--cds-text-error,#da1e28);max-block-size:12.5rem}.cds--dropdown__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:2.5rem;transform:translateY(-50%)}.cds--dropdown--open:hover{background-color:var(--cds-field)}.cds--dropdown--open:focus{outline:1px solid transparent}.cds--dropdown--open .cds--dropdown-list{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));max-block-size:13.75rem;transition:max-height 110ms cubic-bezier(0,0,.38,.9)}.cds--dropdown--light{background-color:var(--cds-field-02,#fff)}.cds--dropdown--light:hover{background-color:var(--cds-field-hover)}.cds--dropdown--up .cds--dropdown-list{inset-block-end:2rem}.cds--dropdown__arrow{position:absolute;fill:var(--cds-icon-primary,#161616);inset-block-start:.8125rem;inset-inline-end:1rem;pointer-events:none;transform-origin:50% 45%;transition:transform 110ms cubic-bezier(.2,0,.38,.9)}button.cds--dropdown-text{border:none;background:0 0;color:var(--cds-text-primary,#161616);inline-size:100%;text-align:start}button.cds--dropdown-text:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){button.cds--dropdown-text:focus{outline-style:dotted}}.cds--dropdown-text{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:block;overflow:hidden;block-size:calc(100% + 1px);padding-inline-end:2.625rem;padding-inline-start:1rem;text-overflow:ellipsis;white-space:nowrap}.cds--dropdown-list{outline:2px solid transparent;outline-offset:-2px;box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:absolute;z-index:9100;display:flex;flex-direction:column;background-color:var(--cds-layer);inline-size:100%;list-style:none;max-block-size:0;overflow-x:hidden;overflow-y:auto;transition:max-height 110ms cubic-bezier(.2,0,.38,.9)}.cds--dropdown-list html{font-size:100%}.cds--dropdown-list body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--dropdown-list code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--dropdown-list strong{font-weight:600}.cds--dropdown--light .cds--dropdown-list{background-color:var(--cds-layer)}.cds--dropdown:not(.cds--dropdown--open) .cds--dropdown-item{visibility:hidden}.cds--dropdown-item{position:relative;opacity:0;transition:visibility 70ms cubic-bezier(.2,0,.38,.9),opacity 70ms cubic-bezier(.2,0,.38,.9),background-color 70ms cubic-bezier(.2,0,.38,.9);visibility:inherit}.cds--dropdown-item:hover{background-color:var(--cds-layer-hover)}.cds--dropdown-item:hover+.cds--dropdown-item .cds--dropdown-link{border-color:transparent}.cds--dropdown-item:active{background-color:var(--cds-layer-selected)}.cds--dropdown-item:first-of-type .cds--dropdown-link{border-block-start-color:transparent}.cds--dropdown-item:last-of-type .cds--dropdown-link{border-block-end:none}.cds--dropdown-link{outline:2px solid transparent;outline-offset:-2px;display:block;overflow:hidden;padding:.6875rem 0;border:1px solid transparent;margin:0 1rem;block-size:2.5rem;border-block-start-color:var(--cds-border-subtle);color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;text-decoration:none;text-overflow:ellipsis;white-space:nowrap}.cds--dropdown-link:hover{border-color:transparent;color:var(--cds-text-primary,#161616)}.cds--dropdown--light .cds--dropdown-link{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--dropdown--sm .cds--dropdown-link{block-size:2rem;padding-block-end:.4375rem;padding-block-start:.4375rem}.cds--dropdown--focused,.cds--dropdown-link:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;margin:0}@media screen and (prefers-contrast){.cds--dropdown--focused,.cds--dropdown-link:focus{outline-style:dotted}}.cds--dropdown-list[aria-activedescendant] .cds--dropdown-link:focus{padding:.6875rem 0;margin:0 1rem;outline:0}.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;margin:0}@media screen and (prefers-contrast){.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus{outline-style:dotted}}.cds--dropdown-list[aria-activedescendant] .cds--dropdown-item:active{background-color:inherit}.cds--dropdown-item:hover .cds--dropdown-link{border-block-end-color:var(--cds-layer-hover)}.cds--dropdown--open .cds--dropdown__arrow{transform:rotate(-180deg)}.cds--dropdown--open.cds--dropdown--sm .cds--dropdown-list{max-block-size:11rem}.cds--dropdown--open .cds--dropdown-item{opacity:1}.cds--dropdown--disabled{border-block-end-color:transparent}.cds--dropdown--disabled:hover{background-color:var(--cds-field)}.cds--dropdown--disabled:focus{outline:0}.cds--dropdown--disabled .cds--dropdown-text,.cds--dropdown--disabled .cds--list-box__label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--dropdown--disabled .cds--dropdown__arrow,.cds--dropdown--disabled .cds--list-box__menu-icon svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--dropdown--disabled.cds--dropdown--light:hover{background-color:var(--cds-field-02,#fff)}.cds--dropdown--disabled .cds--list-box__field,.cds--dropdown--disabled .cds--list-box__menu-icon{cursor:not-allowed}.cds--dropdown--auto-width{inline-size:auto;max-inline-size:25rem}.cds--dropdown--inline{display:inline-block;background-color:transparent;border-block-end-color:transparent;inline-size:auto;justify-self:start;transition:background 70ms cubic-bezier(0,0,.38,.9)}.cds--dropdown--inline:hover{background-color:var(--cds-layer-hover)}.cds--dropdown--inline.cds--dropdown--disabled{background-color:transparent}.cds--dropdown--inline .cds--dropdown__arrow{inset-block-start:.5rem;inset-inline-end:.5rem}.cds--dropdown--inline.cds--dropdown--open{background-color:transparent}.cds--dropdown--inline .cds--dropdown-text{display:inline-block;overflow:visible;padding:.4375rem 2rem .4375rem .75rem;block-size:2rem;color:var(--cds-text-primary,#161616)}.cds--dropdown--inline.cds--dropdown--disabled .cds--dropdown-text{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--dropdown--inline.cds--dropdown--disabled:focus .cds--dropdown-text{outline:0}.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown__invalid-icon{inset-inline-end:2rem}.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown-text{padding-inline-end:3.5rem}.cds--dropdown--inline.cds--dropdown--open:focus .cds--dropdown-list{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3))}.cds--dropdown--inline .cds--dropdown-link{font-weight:400}.cds--dropdown--show-selected .cds--dropdown--selected{display:block;background-color:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}.cds--dropdown--show-selected .cds--dropdown--selected:hover{background-color:var(--cds-layer-selected-hover)}.cds--dropdown--show-selected .cds--dropdown--selected .cds--dropdown-link{border-block-start-color:transparent}.cds--dropdown--show-selected .cds--dropdown--selected+.cds--dropdown-item .cds--dropdown-link{border-block-start-color:transparent}.cds--dropdown--show-selected .cds--dropdown--selected .cds--list-box__menu-item__selected-icon{display:block}.cds--dropdown-v2.cds--skeleton,.cds--dropdown.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}.cds--dropdown-v2.cds--skeleton:active,.cds--dropdown-v2.cds--skeleton:focus,.cds--dropdown-v2.cds--skeleton:hover,.cds--dropdown.cds--skeleton:active,.cds--dropdown.cds--skeleton:focus,.cds--dropdown.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--dropdown-v2.cds--skeleton::before,.cds--dropdown.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--dropdown-v2.cds--skeleton::before,.cds--dropdown.cds--skeleton::before{animation:none}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--dropdown .cds--list-box__field{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-item__option{outline:0}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-item__selected-icon{fill:ButtonText}}.cds--dropdown--readonly,.cds--dropdown--readonly:hover,:host(cds-dropdown[read-only]){background-color:transparent;border-block-end-color:var(--cds-border-subtle)}.cds--dropdown--inline.cds--dropdown--readonly{border-block-end-color:transparent}.cds--dropdown--readonly .cds--list-box__field,.cds--dropdown--readonly .cds--list-box__menu-icon,:host(cds-dropdown[read-only]) .cds--list-box__field,:host(cds-dropdown[read-only]) .cds--list-box__menu-icon{cursor:default}.cds--dropdown--readonly .cds--list-box__menu-icon svg,:host(cds-dropdown[read-only]) .cds--list-box__menu-icon svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-group{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline}.cds--checkbox-group *,.cds--checkbox-group ::after,.cds--checkbox-group ::before{box-sizing:inherit}.cds--form-item.cds--checkbox-wrapper{position:relative;margin-block-end:.375rem}.cds--form-item.cds--checkbox-wrapper:first-of-type{margin-block-start:0}.cds--label+.cds--form-item.cds--checkbox-wrapper{margin-block-start:-.125rem}.cds--form-item.cds--checkbox-wrapper:last-of-type{margin-block-end:.1875rem}.cds--checkbox{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap;inset-block-start:1.25rem;inset-inline-start:.7rem}.cds--checkbox-label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:flex;cursor:pointer;min-block-size:1.25rem;padding-block-start:.0625rem;padding-inline-start:1.25rem;-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--checkbox-label html{font-size:100%}.cds--checkbox-label body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--checkbox-label code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--checkbox-label strong{font-weight:600}.cds--checkbox-label-text{padding-inline-start:.625rem}.cds--checkbox-label::after,.cds--checkbox-label::before{box-sizing:border-box}@media print{.cds--checkbox-label::after,.cds--checkbox-label::before{print-color-adjust:exact}}.cds--checkbox-label::before{position:absolute;border:1px solid var(--cds-icon-primary,#161616);border-radius:2px;background-color:transparent;block-size:1rem;content:\"\";inline-size:1rem;inset-block-start:.125rem;inset-inline-start:0;margin-block:.0625rem .125rem;margin-inline:.1875rem 0}.cds--checkbox-label::after{position:absolute;background:0 0;block-size:.3125rem;border-block-end:1.5px solid var(--cds-icon-inverse,#fff);border-inline-start:1.5px solid var(--cds-icon-inverse,#fff);content:\"\";inline-size:.5625rem;inset-block-start:.40625rem;inset-inline-start:.4375rem;margin-block-start:-.1875rem;transform:scale(0) rotate(-45deg);transform-origin:bottom right}.cds--checkbox-label[data-contained-checkbox-state=true]::before,.cds--checkbox:checked+.cds--checkbox-label::before,.cds--checkbox:indeterminate+.cds--checkbox-label::before{border:none;border-width:1px;background-color:var(--cds-icon-primary,#161616)}.cds--checkbox-label[data-contained-checkbox-state=true]::after,.cds--checkbox:checked+.cds--checkbox-label::after{transform:scale(1) rotate(-45deg)}.cds--checkbox:indeterminate+.cds--checkbox-label::after{border-block-end:2px solid var(--cds-icon-inverse,#fff);border-inline-start:0 solid var(--cds-icon-inverse,#fff);inline-size:.5rem;inset-block-start:.6875rem;transform:scale(1) rotate(0)}.cds--checkbox-label[data-contained-checkbox-state=true].cds--checkbox-label__focus::before,.cds--checkbox-label__focus::before,.cds--checkbox:checked:focus+.cds--checkbox-label::before,.cds--checkbox:focus+.cds--checkbox-label::before,.cds--checkbox:indeterminate:focus+.cds--checkbox-label::before{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:1px}.cds--checkbox-label[data-contained-checkbox-disabled=true],.cds--checkbox:disabled+.cds--checkbox-label{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--checkbox-label[data-contained-checkbox-disabled=true]::before,.cds--checkbox:disabled+.cds--checkbox-label::before{border-color:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-label[data-contained-checkbox-state=true][data-contained-checkbox-disabled=true]::before,.cds--checkbox:checked:disabled+.cds--checkbox-label::before,.cds--checkbox:indeterminate:disabled+.cds--checkbox-label::before{background-color:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-group[data-invalid] .cds--checkbox-label::before,.cds--checkbox-wrapper--invalid .cds--checkbox-label::before,.cds--checkbox-wrapper--invalid .cds--checkbox:checked+.cds--checkbox-label::before{border:1px solid var(--cds-support-error,#da1e28)}.cds--checkbox-group .cds--checkbox-wrapper--invalid>.cds--checkbox__validation-msg,.cds--checkbox-group .cds--checkbox-wrapper--warning>.cds--checkbox__validation-msg,.cds--checkbox-group .cds--checkbox-wrapper>.cds--form__helper-text{display:none}.cds--checkbox-group:not(.cds--checkbox-group[data-invalid]) .cds--checkbox-wrapper--invalid .cds--checkbox-label::before,.cds--checkbox-group:not(.cds--checkbox-group[data-invalid]) .cds--checkbox-wrapper--invalid .cds--checkbox:checked+.cds--checkbox-label::before{border:1px solid var(--cds-icon-primary,#161616)}.cds--checkbox-group__validation-msg,.cds--checkbox__validation-msg{display:none;align-items:flex-start;margin-block-start:.25rem}.cds--checkbox__invalid-icon{margin:.0625rem .0625rem 0 .1875rem;fill:var(--cds-support-error,#da1e28);min-inline-size:1rem}.cds--checkbox__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--checkbox__invalid-icon--warning path:first-of-type{fill:#000}.cds--checkbox-group--invalid .cds--checkbox-group__validation-msg,.cds--checkbox-group--warning .cds--checkbox-group__validation-msg,.cds--checkbox-wrapper--invalid>.cds--checkbox__validation-msg,.cds--checkbox-wrapper--warning>.cds--checkbox__validation-msg{display:flex}.cds--checkbox-group--invalid .cds--checkbox-group__validation-msg .cds--form-requirement,.cds--checkbox-group--warning .cds--checkbox-group__validation-msg .cds--form-requirement,.cds--checkbox-wrapper--invalid .cds--checkbox__validation-msg .cds--form-requirement,.cds--checkbox-wrapper--warning .cds--checkbox__validation-msg .cds--form-requirement{display:block;overflow:visible;margin-block-start:0;margin-inline-start:.5rem;max-block-size:100%}.cds--checkbox-group--invalid .cds--checkbox-group__validation-msg .cds--form-requirement,.cds--checkbox-wrapper--invalid .cds--checkbox__validation-msg .cds--form-requirement{color:var(--cds-text-error,#da1e28)}.cds--checkbox-group--readonly .cds--checkbox-label,.cds--checkbox-wrapper--readonly .cds--checkbox-label{cursor:default}.cds--checkbox-group--readonly .cds--checkbox-label-text,.cds--checkbox-wrapper--readonly .cds--checkbox-label-text{cursor:text;-webkit-user-select:text;-moz-user-select:text;user-select:text}.cds--checkbox-group--readonly .cds--checkbox+.cds--checkbox-label::before,.cds--checkbox-wrapper--readonly .cds--checkbox+.cds--checkbox-label::before{border-color:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--checkbox-group--readonly .cds--checkbox:checked+.cds--checkbox-label::before,.cds--checkbox-wrapper--readonly .cds--checkbox:checked+.cds--checkbox-label::before{border:1px solid var(--cds-icon-disabled,rgba(22,22,22,.25));background:0 0}.cds--checkbox-group--readonly .cds--checkbox:checked+.cds--checkbox-label::after,.cds--checkbox-wrapper--readonly .cds--checkbox:checked+.cds--checkbox-label::after{border-color:var(--cds-text-primary,#161616)}.cds--checkbox-skeleton .cds--checkbox-label{cursor:default}.cds--checkbox-label-text.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:1rem;inline-size:6.25rem;margin-block:.0625rem 0;margin-inline:.375rem 0}.cds--checkbox-label-text.cds--skeleton:active,.cds--checkbox-label-text.cds--skeleton:focus,.cds--checkbox-label-text.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--checkbox-label-text.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--checkbox-label-text.cds--skeleton::before{animation:none}}.cds--checkbox--inline{position:relative}[dir=rtl] .cds--checkbox-label::after{margin-block-start:0;margin-inline-start:-.0625rem;transform-origin:center}[dir=rtl] .cds--checkbox-label[data-contained-checkbox-state=true]::after,[dir=rtl] .cds--checkbox:checked+.cds--checkbox-label::after{transform:scale(1.2) rotate3d(.5,1,0,158deg)}.cds--checkbox-group--slug legend.cds--label,.cds--checkbox-wrapper--slug .cds--checkbox-label-text{display:flex}.cds--checkbox-group--slug legend.cds--label .cds--slug,.cds--checkbox-wrapper--slug .cds--checkbox-label-text .cds--slug{margin-inline-start:.5rem}.cds--checkbox-wrapper--slug .cds--checkbox-label-text .cds--slug__button--inline{line-height:inherit;margin-block-start:-.0625rem}.cds--checkbox-group--horizontal{position:relative;display:flex;flex-flow:row wrap;justify-content:flex-start}.cds--checkbox-group--horizontal .cds--form-item{flex:none;margin-block-end:0}.cds--checkbox-group--horizontal .cds--form-item:not(:last-of-type){margin-inline-end:1rem}.cds--checkbox-group--horizontal .cds--checkbox-label-text{padding-inline-start:.5rem}.cds--checkbox-group--horizontal .cds--label+.cds--form-item.cds--checkbox-wrapper{margin-block-start:0}.cds--list-box__wrapper--inline,:host(cds-dropdown[type=inline]){display:inline-grid;align-items:center;grid-gap:.25rem;grid-template:auto auto/auto auto}.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--list-box__wrapper--inline .cds--form-requirement,.cds--list-box__wrapper--inline .cds--form__helper-text,.cds--list-box__wrapper--inline .cds--label,:host(cds-dropdown[type=inline]) .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--label{margin:0}.cds--list-box__wrapper--inline .cds--form__helper-text,:host(cds-dropdown[type=inline]) .cds--form__helper-text{max-inline-size:none}.cds--list-box__wrapper--inline .cds--form-requirement,:host(cds-dropdown[type=inline]) .cds--form-requirement{grid-column:2}.cds--list-box{position:relative;border:none;background-color:var(--cds-field);block-size:2.5rem;border-block-end:1px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616);cursor:pointer;inline-size:100%;max-block-size:2.5rem;transition:all 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box html{font-size:100%}.cds--list-box body{font-weight:400;font-family:'IBM Plex Sans',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--list-box code{font-family:'IBM Plex Mono',system-ui,-apple-system,BlinkMacSystemFont,'.SFNSText-Regular',monospace}.cds--list-box strong{font-weight:600}.cds--list-box:hover{background-color:var(--cds-field-hover)}.cds--list-box--lg{block-size:3rem;max-block-size:3rem}.cds--list-box--sm{block-size:2rem;max-block-size:2rem}.cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--expanded{border-block-end-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box--expanded:hover{background-color:var(--cds-field)}.cds--list-box--expanded:hover.cds--list-box--light:hover{background-color:var(--cds-field-02,#fff)}.cds--list-box .cds--text-input{block-size:100%;min-inline-size:0}.cds--list-box__invalid-icon{position:absolute;fill:var(--cds-support-error,#da1e28);inset-block-start:50%;inset-inline-end:2.5rem;transform:translateY(-50%)}.cds--list-box__invalid-icon--warning{fill:var(--cds-support-warning,#f1c21b)}.cds--list-box__invalid-icon--warning path[fill]{fill:#000;opacity:1}.cds--list-box.cds--list-box--warning .cds--list-box__field,.cds--list-box[data-invalid] .cds--list-box__field{border-block-end:0;padding-inline-end:4rem}.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field,.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:3.5rem}.cds--list-box--light{background-color:var(--cds-field-02,#fff)}.cds--list-box--light:hover{background-color:var(--cds-field-hover)}.cds--list-box--light .cds--list-box__menu{background:var(--cds-layer)}.cds--list-box--light .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle)}.cds--list-box--light.cds--list-box--expanded{border-block-end-color:transparent}.cds--list-box--disabled:hover{background-color:var(--cds-field)}.cds--list-box--light.cds--list-box--disabled{background-color:var(--cds-field-02,#fff)}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__field:focus{border-block-end-color:transparent;outline:0}.cds--list-box--disabled .cds--list-box__label,.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__menu-icon>svg,.cds--list-box--disabled .cds--list-box__selection>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled,.cds--list-box--disabled .cds--list-box__field,.cds--list-box--disabled .cds--list-box__menu-icon{cursor:not-allowed}.cds--list-box--disabled .cds--list-box__menu-item,.cds--list-box--disabled .cds--list-box__menu-item--highlighted,.cds--list-box--disabled .cds--list-box__menu-item:hover,.cds--list-box--disabled :host(cds-combo-box-item),.cds--list-box--disabled :host(cds-dropdown-item){color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}.cds--list-box--disabled .cds--list-box__selection:hover{cursor:not-allowed}.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field{padding-inline-end:3rem}.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field{padding-inline-end:2rem}.cds--list-box.cds--list-box--inline{border-width:0;background-color:transparent}.cds--list-box.cds--list-box--inline:hover{background-color:var(--cds-layer-hover)}.cds--list-box.cds--list-box--inline.cds--list-box--expanded{border-block-end-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true]{border-width:0}.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover,.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover{background-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__field{padding:0 2rem 0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon{inset-inline-end:.5rem}.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon{inset-inline-end:2rem}.cds--list-box--inline .cds--list-box__label{color:var(--cds-text-primary,#161616)}.cds--list-box--inline .cds--list-box__field{block-size:100%}.cds--dropdown--inline .cds--list-box__field{max-inline-size:30rem}.cds--dropdown--inline .cds--list-box__menu{max-inline-size:30rem;min-inline-size:18rem}.cds--list-box__field{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;overflow:hidden;align-items:center;block-size:calc(100% + 1px);cursor:pointer;outline:0;padding-block:0;padding-inline-end:3rem;padding-inline-start:1rem;text-overflow:ellipsis;vertical-align:top;white-space:nowrap}.cds--list-box__field *,.cds--list-box__field ::after,.cds--list-box__field ::before{box-sizing:inherit}.cds--list-box__field::-moz-focus-inner{border:0}.cds--list-box__field:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__field:focus{outline-style:dotted}}.cds--list-box__field[disabled]{color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--list-box__field .cds--text-input{padding-inline-end:5rem}.cds--list-box--warning .cds--list-box__field .cds--text-input,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input{padding-inline-end:6.5625rem}.cds--list-box--warning .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input+.cds--list-box__invalid-icon{inset-inline-end:5.125rem}.cds--list-box__field .cds--text-input--empty{padding-inline-end:3rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box--warning .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty+.cds--list-box__invalid-icon{inset-inline-end:2.5rem}.cds--list-box__label{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);overflow:hidden;color:var(--cds-text-primary,#161616);text-overflow:ellipsis;-webkit-user-select:none;-moz-user-select:none;user-select:none;white-space:nowrap}.cds--list-box__menu-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-inline-end:.75rem;outline:0;transition:transform 70ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu-icon *,.cds--list-box__menu-icon ::after,.cds--list-box__menu-icon ::before{box-sizing:inherit}.cds--list-box__menu-icon::-moz-focus-inner{border:0}.cds--list-box__menu-icon>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box__menu-icon--open{justify-content:center;inline-size:1.5rem;transform:rotate(180deg)}.cds--list-box__selection{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;position:absolute;display:flex;align-items:center;justify-content:center;block-size:1.5rem;cursor:pointer;inline-size:1.5rem;inset-block-start:50%;inset-inline-end:2.8125rem;transform:translateY(-50%);transition:background-color 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__selection *,.cds--list-box__selection ::after,.cds--list-box__selection ::before{box-sizing:inherit}.cds--list-box__selection::-moz-focus-inner{border:0}.cds--list-box__selection:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus{outline-style:dotted}}.cds--list-box__selection:focus:hover{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--list-box__selection:focus:hover{outline-style:dotted}}.cds--list-box__selection>svg{fill:var(--cds-icon-primary,#161616)}.cds--list-box--disabled .cds--list-box__selection:focus{outline:0}.cds--list-box__selection--multi{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);position:static;display:flex;align-items:center;justify-content:space-between;padding:.5rem;border-radius:.75rem;background-color:var(--cds-background-inverse,#393939);block-size:1.5rem;color:var(--cds-text-inverse,#fff);inline-size:auto;inset-block-start:auto;line-height:0;margin-inline-end:.625rem;padding-inline-end:.125rem;transform:none}.cds--list-box__selection--multi>svg{padding:.125rem;block-size:1.25rem;fill:var(--cds-icon-inverse,#fff);inline-size:1.25rem;margin-inline-start:.25rem}.cds--list-box__selection--multi>svg:hover{border-radius:50%;background-color:var(--cds-button-secondary-hover,#474747)}.cds--list-box--disabled .cds--list-box__selection--multi{background-color:var(--cds-text-disabled,rgba(22,22,22,.25));color:var(--cds-layer)}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational{border:1px solid var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover{background-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--list-box--disabled .cds--list-box__selection--multi>svg:hover{background-color:initial}.cds--list-box__selection--multi:hover{outline:0}.cds--list-box__menu{box-shadow:0 2px 6px var(--cds-shadow,rgba(0,0,0,.3));position:absolute;z-index:9100;display:none;background-color:var(--cds-layer);inline-size:100%;inset-inline-end:0;inset-inline-start:0;overflow-y:auto;transition:max-height 110ms cubic-bezier(.2,0,.38,.9)}.cds--list-box__menu:focus{outline:1px solid var(--cds-focus,#0f62fe)}@media screen and (prefers-contrast){.cds--list-box__menu:focus{outline-style:dotted}}.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu{display:none;max-block-size:0;visibility:hidden}.cds--list-box--expanded .cds--list-box__menu{display:block;max-block-size:13.75rem}.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu{max-block-size:16.5rem}.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu{max-block-size:11rem}.cds--list-box__menu-item,:host(cds-combo-box-item),:host(cds-dropdown-item){font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;block-size:2.5rem;color:var(--cds-text-secondary,#525252);cursor:pointer;transition:background 70ms cubic-bezier(.2,0,.38,.9);-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--light .cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover)}.cds--list-box--sm .cds--list-box__menu-item,.cds--list-box--sm :host(cds-combo-box-item),.cds--list-box--sm :host(cds-dropdown-item){block-size:2rem}.cds--list-box--lg .cds--list-box__menu-item,.cds--list-box--lg :host(cds-combo-box-item),.cds--list-box--lg :host(cds-dropdown-item){block-size:3rem}.cds--list-box--disabled .cds--list-box__menu-item:hover{background-color:transparent}.cds--list-box--light .cds--list-box__menu-item:active{background-color:var(--cds-layer-selected)}.cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item:hover .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item__option{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;outline:2px solid transparent;outline-offset:-2px;display:block;overflow:hidden;padding:.6875rem 0;margin:0 1rem;block-size:2.5rem;border-block-end:1px solid transparent;border-block-start:1px solid transparent;border-block-start-color:var(--cds-border-subtle-01,#c6c6c6);color:var(--cds-text-secondary,#525252);font-weight:400;line-height:1rem;padding-inline-end:1.5rem;text-decoration:none;text-overflow:ellipsis;transition:border-color 70ms cubic-bezier(.2,0,.38,.9),color 70ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}.cds--list-box__menu-item__option *,.cds--list-box__menu-item__option ::after,.cds--list-box__menu-item__option ::before{box-sizing:inherit}.cds--list-box__menu-item__option:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;padding:.6875rem 1rem;border-color:transparent;margin:0}@media screen and (prefers-contrast){.cds--list-box__menu-item__option:focus{outline-style:dotted}}.cds--list-box__menu-item__option:hover{border-color:transparent;color:var(--cds-text-primary,#161616)}.cds--list-box--sm .cds--list-box__menu-item__option{block-size:2rem;padding-block-end:.4375rem;padding-block-start:.4375rem}.cds--list-box--lg .cds--list-box__menu-item__option{block-size:3rem;padding-block-end:.9375rem;padding-block-start:.9375rem}.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,.cds--list-box--disabled .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled],.cds--list-box__menu-item[disabled] *,.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover{color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed;outline:0}.cds--list-box__menu-item[disabled]:hover{background-color:revert}.cds--list-box__menu-item[disabled] .cds--checkbox-label::before{border-color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-01,#c6c6c6)}.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-two .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-02,#e0e0e0)}.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--layer-three .cds--list-box__menu-item[disabled]:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:var(--cds-border-subtle-03,#c6c6c6)}.cds--list-box__menu-item--active+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box__menu-item:hover+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option{margin:0 .5rem}.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus{margin:0;padding-inline-end:.5rem;padding-inline-start:.5rem}.cds--list-box__menu-item--highlighted,:host(cds-combo-box-item[highlighted]),:host(cds-combo-box-item[selected]),:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px;color:var(--cds-text-primary,#161616)}@media screen and (prefers-contrast){.cds--list-box__menu-item--highlighted,:host(cds-combo-box-item[highlighted]),:host(cds-combo-box-item[selected]),:host(cds-dropdown-item[highlighted]),:host(cds-dropdown-item[selected]){outline-style:dotted}}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+.cds--list-box__menu-item .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+:host(cds-combo-box-item) .cds--list-box__menu-item__option,.cds--list-box__menu-item--highlighted+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted])+:host(cds-dropdown-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-combo-box-item) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item) .cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,:host(cds-combo-box-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active,:host(cds-combo-box-item[selected]),:host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}.cds--list-box--light .cds--list-box__menu-item--active,.cds--list-box--light :host(cds-combo-box-item[selected]),.cds--list-box--light :host(cds-dropdown-item[selected]){background-color:var(--cds-layer-selected);border-block-end-color:var(--cds-layer-selected)}.cds--list-box__menu-item--active:hover{background-color:var(--cds-layer-selected-hover);border-block-end-color:var(--cds-layer-selected-hover)}.cds--list-box__menu-item--active .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}.cds--list-box__menu-item--active+.cds--list-box__menu-item>.cds--list-box__menu-item__option,.cds--list-box__menu-item--active+:host(cds-combo-box-item)>.cds--list-box__menu-item__option,.cds--list-box__menu-item--active+:host(cds-dropdown-item)>.cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+.cds--list-box__menu-item>.cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-combo-box-item)>.cds--list-box__menu-item__option,:host(cds-combo-box-item[selected])+:host(cds-dropdown-item)>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+.cds--list-box__menu-item>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-combo-box-item)>.cds--list-box__menu-item__option,:host(cds-dropdown-item[selected])+:host(cds-dropdown-item)>.cds--list-box__menu-item__option{border-block-start-color:transparent}.cds--list-box__menu-item__selected-icon{position:absolute;display:none;fill:var(--cds-icon-primary,#161616);inset-block-start:50%;inset-inline-end:1rem;transform:translateY(-50%)}.cds--list-box--inline .cds--list-box__menu-item__selected-icon{inset-inline-end:.5rem}.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__selected-icon,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}.cds--list-box__menu-item .cds--checkbox-label,:host(cds-combo-box-item) .cds--checkbox-label,:host(cds-dropdown-item) .cds--checkbox-label{inline-size:100%}.cds--list-box__menu-item .cds--checkbox-label-text,:host(cds-combo-box-item) .cds--checkbox-label-text,:host(cds-dropdown-item) .cds--checkbox-label-text{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.cds--list-box--up .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box__menu{inset-block-end:2.5rem}.cds--list-box--up .cds--list-box--sm .cds--list-box__menu,.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--sm .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--sm .cds--list-box__menu{inset-block-end:2rem}.cds--list-box--up .cds--list-box--lg .cds--list-box__menu,.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,:host(cds-combo-box[direction=top]) .cds--list-box--lg .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box--lg .cds--list-box__menu{inset-block-end:3rem}.cds--list-box input[role=combobox],.cds--list-box input[type=text]{background-color:inherit;min-inline-size:0;text-overflow:ellipsis}.cds--list-box__wrapper--slug .cds--slug,:host(cds-combo-box[slug]) .cds--slug,:host(cds-dropdown[slug]) .cds--slug{position:absolute;inset-block-start:50%;inset-inline-end:calc(2.5rem + 9px);margin-block-start:.03125rem;transform:translateY(-50%)}.cds--list-box__wrapper--slug .cds--slug::after,.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-combo-box[slug]) .cds--slug::after,:host(cds-combo-box[slug]) .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem}.cds--list-box__wrapper--slug .cds--slug::before,:host(cds-combo-box[slug]) .cds--slug::before,:host(cds-dropdown[slug]) .cds--slug::before{display:none;inset-inline-start:-.5625rem}.cds--list-box__wrapper--slug .cds--slug::after,:host(cds-combo-box[slug]) .cds--slug::after,:host(cds-dropdown[slug]) .cds--slug::after{display:block;inset-inline-end:-.5625rem}.cds--list-box__wrapper--slug .cds--slug--revert::after,:host(cds-combo-box[slug]) .cds--slug--revert::after,:host(cds-dropdown[slug]) .cds--slug--revert::after{inset-block-start:.5rem;inset-inline-end:-.0625rem}.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)),:host(cds-combo-box[slug]) .cds--list-box:not(:has(.cds--slug--revert)),:host(cds-dropdown[slug]) .cds--list-box:not(:has(.cds--slug--revert)){background-image:linear-gradient(0deg,var(--cds-ai-aura-start-sm,rgba(69,137,255,.16)) 0,15%,var(--cds-ai-aura-end,rgba(255,255,255,0)) 50%,transparent 100%);border-block-end-color:var(--cds-ai-border-strong,#4589ff)}.cds--list-box__wrapper--slug .cds--list-box input[role=combobox],:host(cds-combo-box[slug]) .cds--list-box input[role=combobox],:host(cds-dropdown[slug]) .cds--list-box input[role=combobox]{border-block-end-color:transparent}.cds--list-box__wrapper--slug .cds--list-box__field,.cds--list-box__wrapper--slug .cds--text-input--empty,:host(cds-combo-box[slug]) .cds--list-box__field,:host(cds-combo-box[slug]) .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box__field,:host(cds-dropdown[slug]) .cds--text-input--empty{padding-inline-end:4rem}.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty),:host(cds-combo-box[slug]) .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--text-input:not(.cds--text-input--empty){padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__field,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input--empty,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--list-box__field,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input--empty,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input--empty{padding-inline-end:6rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty),:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),:host(cds-combo-box[slug]) .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),:host(cds-dropdown[slug]) .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty){padding-inline-end:8.8125rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty+.cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning{inset-inline-end:5.1875rem}.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before,:host(cds-combo-box[slug]) .cds--list-box--invalid[data-invalid] .cds--slug::before,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--invalid[data-invalid] .cds--slug::before,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--slug::before{display:block}.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,:host(cds-combo-box[slug]) .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug,:host(cds-dropdown[slug]) .cds--list-box__field:has(.cds--list-box__selection)~.cds--slug{inset-inline-end:calc(4rem + 18px)}.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-combo-box[slug]) .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-combo-box[slug]) .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,:host(cds-dropdown[slug]) .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon{inset-inline-end:7.25rem}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field,.cds--list-box__menu,.cds--multi-select .cds--tag--filter{outline:1px solid transparent}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__field:focus,.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,.cds--multi-select .cds--tag__close-icon:focus,:host(cds-combo-box-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[highlighted]) .cds--list-box__menu-item__option,:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--list-box__menu-icon>svg,.cds--list-box__selection--multi>svg,.cds--list-box__selection>svg{fill:ButtonText}}.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-start:2.0625rem}.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before{position:absolute;background-color:var(--cds-border-subtle-01,#c6c6c6);block-size:1rem;content:\"\";inline-size:.0625rem;margin-inline-end:2.0625rem}.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon,:has(.cds--multi-select):host(cds-combo-box[slug]) .cds--list-box__menu-icon,:has(.cds--multi-select):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon,:has(.cds--dropdown):host(cds-combo-box[slug]) .cds--list-box__menu-icon,:has(.cds--dropdown):host(cds-dropdown[slug]) .cds--list-box__menu-icon{inset-inline-end:.75rem}:host(cds-combo-box),:host(cds-dropdown){outline:0}:host(cds-combo-box) .cds--assistive-text,:host(cds-dropdown) .cds--assistive-text{inset-block-start:-100%;inset-inline-start:-100%}:host(cds-combo-box) .cds--label[hidden],:host(cds-dropdown) .cds--label[hidden]{display:none}:host(cds-combo-box) .cds--list-box__menu,:host(cds-dropdown) .cds--list-box__menu{inset-block-start:100%;margin-block-start:1px;outline:1px solid var(--cds-focus,#0f62fe)}:host(cds-dropdown[open]) .cds--list-box__field{outline:0}:host(cds-dropdown[invalid]) .cds--list-box__field{outline:0}:host(cds-dropdown[invalid]) .cds--form__helper-text{color:var(--cds-text-error,#da1e28)}:host(cds-dropdown[read-only]) .cds--list-box{background-color:transparent;border-block-end-color:var(--cds-border-subtle)}:host(cds-combo-box[direction=top]) .cds--list-box__menu,:host(cds-dropdown[direction=top]) .cds--list-box__menu{inset-block-start:auto}:host(cds-dropdown[type=inline]){grid-gap:0 1.5rem}:host(cds-dropdown[type=inline][warn]) .cds--list-box__field{padding-inline:1rem calc(2.5rem + 1rem)}:host(cds-dropdown[invalid]) .cds--form__helper-text,:host(cds-dropdown[warn]) .cds--form__helper-text{grid-column:2}:host(cds-dropdown-item){display:block}:host(cds-dropdown-item) .cds--list-box__menu-item__option{block-size:auto}:host(cds-dropdown-item:first-child) .cds--list-box__menu-item__option{border-block-start-width:0}:host(cds-dropdown-item:hover){background-color:var(--cds-layer-hover)}:host(cds-dropdown-item[disabled]) .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}:host(cds-dropdown-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}:host(cds-dropdown-item[size=sm]){block-size:2rem}:host(cds-dropdown-item[size=sm]) .cds--list-box__menu-item__option{padding-block:.4375rem}:host(cds-dropdown-item[size=lg]){block-size:3rem}:host(cds-dropdown-item[size=lg]) .cds--list-box__menu-item__option{padding-block:.9375rem}:host(cds-dropdown-skeleton) .cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none}:host(cds-dropdown-skeleton) .cds--skeleton:active,:host(cds-dropdown-skeleton) .cds--skeleton:focus,:host(cds-dropdown-skeleton) .cds--skeleton:hover{border:none;cursor:default;outline:0}:host(cds-dropdown-skeleton) .cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:\"\";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){:host(cds-dropdown-skeleton) .cds--skeleton::before{animation:none}}:host(cds-dropdown[slug]) ::slotted(cds-slug){position:absolute;inset-block-start:50%;inset-inline-end:2.5rem}:host(cds-dropdown[slug]) ::slotted(cds-slug:not([revert-active])){transform:translateY(-50%)}:host(cds-dropdown[slug][invalid]) .cds--list-box .cds--list-box__field,:host(cds-dropdown[slug][warn]) .cds--list-box .cds--list-box__field{padding-inline-end:6rem}:host(cds-dropdown[slug][invalid]) ::slotted(cds-slug),:host(cds-dropdown[slug][warn]) ::slotted(cds-slug){inset-inline-end:4rem}:host(cds-combo-box){--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px;outline:0}:host(cds-combo-box) .cds--assistive-text{inset-block-start:-100%;inset-inline-start:-100%}:host(cds-combo-box) .cds--list-box__field{padding:0}:host(cds-combo-box) .cds--list-box__menu{inset-block-start:100%;margin-block-start:1px;outline:0}:host(cds-combo-box[isClosable]) .cds--list-box__invalid-icon{inset-inline-end:4.125rem!important}:host(cds-combo-box[disabled]) .cds--list-box__selection,:host(cds-combo-box[read-only]) .cds--list-box__selection{pointer-events:none}:host(cds-combo-box[invalid]) .cds--form__helper-text{color:var(--cds-text-error,#da1e28)}:host(cds-combo-box[read-only]) .cds--list-box__selection svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}:host(cds-combo-box-item){display:block}:host(cds-combo-box-item) .cds--list-box__menu-item__option{block-size:auto}:host(cds-combo-box-item):hover{background-color:var(--cds-layer-hover)}:host(cds-combo-box-item[disabled]) .cds--list-box__menu-item__option{color:var(--cds-text-disabled,rgba(22,22,22,.25));text-decoration:none}:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__option{color:var(--cds-text-primary,#161616)}:host(cds-combo-box-item[selected]) .cds--list-box__menu-item__selected-icon{display:block}:host(cds-combo-box-item[size=sm]){block-size:2rem}:host(cds-combo-box-item[size=sm]) .cds--list-box__menu-item__option{padding-block:.4375rem}:host(cds-combo-box-item[size=lg]){block-size:3rem}:host(cds-combo-box-item[size=lg]) .cds--list-box__menu-item__option{padding-block:.9375rem}:host(cds-combo-box[slug]) .cds--list-box__field{padding:0}:host(cds-combo-box[slug]) ::slotted(cds-slug){position:absolute;inset-block-start:50%;inset-inline-end:2.5rem}:host(cds-combo-box[slug]) ::slotted(cds-slug:not([revert-active])){transform:translateY(-50%)}:host(cds-combo-box[slug][isclosable]) ::slotted(cds-slug){inset-inline-end:4rem}:host(cds-combo-box[invalid]) ::slotted(cds-slug),:host(cds-combo-box[warn]) ::slotted(cds-slug){inset-inline-end:4rem}:host(cds-combo-box[invalid][isclosable]) ::slotted(cds-slug),:host(cds-combo-box[warn][isclosable]) ::slotted(cds-slug){inset-inline-end:5.5rem}",
]);

/**
 * Combo box item.
 *
 * @element cds-combo-box-item
 */
_decorate$Z([carbonElement(`${prefix$B}-combo-box-item`)], function (_initialize, _CDSDropdownItem) {
  class CDSComboBoxItem extends _CDSDropdownItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSComboBoxItem,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$9;
      }
    }]
  };
}, CDSDropdownItem);

/**
 * An option in select box.
 *
 * @element cds-select-item
 */
_decorate$Z([carbonElement(`${prefix$B}-select-item`)], function (_initialize, _LitElement) {
  class CDSSelectItem extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSSelectItem,
    d: [{
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "label",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "selected",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "value",
      value() {
        return '';
      }
    }]
  };
}, s);

/**
 * Copyright IBM Corp. 2018, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var moderate02 = '240ms';

let _$v = t => t,
  _t$w,
  _t2$e,
  _t3$7,
  _t4$5,
  _t5$5,
  _t6$4,
  _t7$4,
  _t8$4,
  _t9$3,
  _t10$3,
  _t11$3,
  _t12$3,
  _t13$3,
  _t14$3;
function _decorate$y(e, r, t, i) { var o = _getDecoratorsApi$y(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$y(s.d.map(_createElementDescriptor$y)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$y() { _getDecoratorsApi$y = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$y(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$y(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$y(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$y(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$y(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$y(e) { var r, t = _toPropertyKey$y(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$y(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$y(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$y(o.descriptor) || _isDataDescriptor$y(i.descriptor)) { if (_hasDecorators$y(o) || _hasDecorators$y(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$y(o)) { if (_hasDecorators$y(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$y(o, i); } } else r.push(o); } return r; }
function _hasDecorators$y(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$y(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$y(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$y(t) { var i = _toPrimitive$y(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$y(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$y(r) { return _arrayWithHoles$z(r) || _iterableToArray$y(r) || _unsupportedIterableToArray$z(r) || _nonIterableRest$z(); }
function _nonIterableRest$z() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$z(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$z(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$z(r, a) : void 0; } }
function _arrayLikeToArray$z(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$y(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$z(r) { if (Array.isArray(r)) return r; }
function _superPropGet$l(t, e, r, o) { var p = _get$g(_getPrototypeOf$g(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$g() { return _get$g = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$g(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$g.apply(null, arguments); }
function _superPropBase$g(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$g(t));); return t; }
function _getPrototypeOf$g(t) { return _getPrototypeOf$g = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$g(t); }
const {
  stablePrefix: c4dPrefix$y
} = settings;

// Delay matches the CSS animation timing for fadein/out of modal.
const delay = parseInt(moderate02, 10);

/**
 * Component that rendres footer from inks data.
 *
 * @element c4d-footer-composite
 */
let C4DFooterComposite = _decorate$y([carbonElement(`${c4dPrefix$y}-footer-composite`)], function (_initialize, _MediaQueryMixin) {
  class C4DFooterComposite extends _MediaQueryMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterComposite,
    d: [{
      kind: "method",
      key: "_handleClickLocaleButton",
      value:
      /**
       * Handles `click` event on the locale button.
       */
      async function _handleClickLocaleButton() {
        this.openLocaleModal = true;

        // Set 'open' attribute after modal is in dom so CSS can fade it in.
        this.updateComplete.then(() => {
          var _this$modalRenderRoot;
          const composite = (_this$modalRenderRoot = this.modalRenderRoot) === null || _this$modalRenderRoot === void 0 ? void 0 : _this$modalRenderRoot.querySelector(`${c4dPrefix$y}-locale-modal-composite`);
          composite === null || composite === void 0 || composite.setAttribute('open', '');
        });
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_isMobile",
      value() {
        return this.carbonBreakpoints.lg.matches;
      }
    }, {
      kind: "method",
      key: "mediaQueryCallbackMaxLG",
      value: function mediaQueryCallbackMaxLG() {
        this._isMobile = this.carbonBreakpoints.lg.matches;
      }

      /**
       * Handles `c4d-expressive-modal-closed` event on the locale modal.
       */
    }, {
      kind: "field",
      decorators: [HostListener('document:eventCloseModal')],
      key: "_handleCloseModal",
      value() {
        return event => {
          if (this.modalRenderRoot.contains(event.target)) {
            // Timeout here ensures the modal closing animation is visible.
            setTimeout(() => {
              this.openLocaleModal = false;
            }, delay);
          }
        };
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "buttonLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "navLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'clear-selection-label'
      })],
      key: "clearSelectionLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "collatorCountryName",
      value() {
        return new Intl.Collator();
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "langList",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'lang-display'
      })],
      key: "langDisplay",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'language-selector-label'
      })],
      key: "languageSelectorLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-language'
      })],
      key: "selectedLanguage",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "legalLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "adjunctLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "links",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "localeList",
      value: void 0
    }, {
      kind: "field",
      key: "modalTriggerProps",
      value() {
        return ['openLocaleModal', 'localeList'];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'open-locale-modal'
      })],
      key: "openLocaleModal",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value: void 0
    }, {
      kind: "method",
      key: "getLangDisplay",
      value:
      /**
       * The placeholder for `loadLocaleList()` Redux action that may be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `loadTranslation()` Redux action that may be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `setLanguage()` Redux action that may be mixed in.
       *
       * @internal
       */
      /**
       * The aria-label to use for the locale-button
       */
      /**
       * The aria-label to use for the legal-nav
       */
      /**
       * The clear button label for language selector.
       *
       * @internal
       */
      /**
       * The g11n collator to use for sorting contry names.
       */
      /**
       * `true` to omit the locale switcher button.
       */
      /**
       * The language used for query.
       */
      /**
       * Placeholder list of languages to populate language selector
       *
       * @internal
       */
      /**
       * The language to show in the UI.
       */
      /**
       * The placeholder label for language selector.
       *
       * @internal
       */
      /**
       * The initial selected language in the selector.
       *
       * @internal
       */
      /**
       * The legal nav links.
       */
      /**
       * The adjunct links.
       */
      /**
       * The footer links.
       */
      /**
       * The locale list.
       */
      /**
       * @inheritdoc
       */
      /**
       * `true` to open the locale modal.
       */
      /**
       * Footer size.
       */
      // eslint-disable-next-line class-methods-use-this
      async function getLangDisplay() {
        const response = await LocaleAPI.getLangDisplay();
        return response;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$_loadTranslatio;
        const {
          language
        } = this;
        globalInit();
        if (language) {
          var _this$_setLanguage;
          (_this$_setLanguage = this._setLanguage) === null || _this$_setLanguage === void 0 || _this$_setLanguage.call(this, language);
        }
        (_this$_loadTranslatio = this._loadTranslation) === null || _this$_loadTranslatio === void 0 || _this$_loadTranslatio.call(this, language);
        this.getLangDisplay().then(res => {
          this.langDisplay = res;
        });
        _superPropGet$l(C4DFooterComposite, "firstUpdated", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('language')) {
          const {
            language
          } = this;
          if (language) {
            var _this$_setLanguage2, _this$_loadTranslatio2;
            (_this$_setLanguage2 = this._setLanguage) === null || _this$_setLanguage2 === void 0 || _this$_setLanguage2.call(this, language);
            (_this$_loadTranslatio2 = this._loadTranslation) === null || _this$_loadTranslatio2 === void 0 || _this$_loadTranslatio2.call(this, language).catch(() => {}); // The error is logged in the Redux store
          }
        }
      }

      /**
       * @returns The locale modal.
       */
    }, {
      kind: "method",
      key: "renderModal",
      value: function renderModal() {
        const {
          collatorCountryName,
          langDisplay,
          language,
          localeList,
          openLocaleModal,
          _loadLocaleList: loadLocaleList
        } = this;
        return openLocaleModal ? x(_t$w || (_t$w = _$v`
          <c4d-locale-modal-composite
            lang-display="${0}"
            language="${0}"
            .collatorCountryName="${0}"
            .localeList="${0}"
            ._loadLocaleList="${0}">
          </c4d-locale-modal-composite>
        `), l(langDisplay), l(language), l(collatorCountryName), l(localeList), l(loadLocaleList)) : x(_t2$e || (_t2$e = _$v``));
      }
    }, {
      kind: "method",
      key: "renderLanguageSelector",
      value: function renderLanguageSelector(slot = 'language-selector') {
        const {
          clearSelectionLabel,
          _isMobile: isMobile,
          langList,
          languageSelectorLabel,
          selectedLanguage,
          size
        } = this;
        const dropdownSize = size === FOOTER_SIZE.MICRO ? DROPDOWN_SIZE$1.MICRO : DROPDOWN_SIZE$1.LARGE;
        return isMobile ? x(_t3$7 || (_t3$7 = _$v`
          <c4d-language-selector-mobile
            size="${0}"
            slot="${0}"
            value="${0}"
            placeholder="${0}">
            ${0}
          </c4d-language-selector-mobile>
        `), dropdownSize, slot, selectedLanguage, selectedLanguage, langList === null || langList === void 0 ? void 0 : langList.map(language => x(_t4$5 || (_t4$5 = _$v`
                <cds-select-item
                  label="${0}"
                  value="${0}"
                  lang="${0}"
                  >${0}</cds-select-item
                >
              `), l(language.text), l(language.text), l(language.id), l(language.text)))) : x(_t5$5 || (_t5$5 = _$v`
          <c4d-language-selector-desktop
            size="${0}"
            slot="${0}"
            trigger-content="${0}"
            label-text="${0}"
            label="${0}"
            value="${0}"
            clear-selection-label="${0}">
            ${0}
          </c4d-language-selector-desktop>
        `), dropdownSize, slot, languageSelectorLabel, languageSelectorLabel, languageSelectorLabel, selectedLanguage, clearSelectionLabel, langList === null || langList === void 0 ? void 0 : langList.map(language => x(_t6$4 || (_t6$4 = _$v`
                <cds-combo-box-item
                  value="${0}"
                  lang="${0}"
                  >${0}</cds-combo-box-item
                >
              `), l(language.text), l(language.id), l(language.text))));
      }
    }, {
      kind: "method",
      key: "renderLocaleButton",
      value: function renderLocaleButton(slot = 'locale-button') {
        const {
          buttonLabel,
          _handleClickLocaleButton: handleClickLocaleButton,
          langDisplay,
          size
        } = this;
        return x(_t7$4 || (_t7$4 = _$v`
      <c4d-locale-button
        buttonLabel="${0}"
        size="${0}"
        slot="${0}"
        @click="${0}"
        >${0}</c4d-locale-button
      >
    `), l(buttonLabel), size, slot, handleClickLocaleButton.bind(this), langDisplay);
      }
    }, {
      kind: "method",
      key: "renderLightDOM",
      value: function renderLightDOM() {
        const {
          disableLocaleButton,
          langList,
          size,
          links,
          legalLinks,
          adjunctLinks,
          navLabel
        } = this;
        return x(_t8$4 || (_t8$4 = _$v`
      <c4d-footer
        size="${0}"
        ?disable-locale-button="${0}">
        <c4d-footer-logo></c4d-footer-logo>
        ${0}
        ${0}
        ${0}

        <c4d-legal-nav
          size="${0}"
          navLabel="${0}">
          <c4d-footer-logo
            size="${0}"
            ?disable-locale-button="${0}"></c4d-footer-logo>
          ${0}
          ${0}
          <c4d-legal-nav-cookie-preferences-placeholder></c4d-legal-nav-cookie-preferences-placeholder>
          ${0}
          ${0}
        </c4d-legal-nav>
      </c4d-footer>
    `), l(size), l(disableLocaleButton), size !== FOOTER_SIZE.MICRO && size !== FOOTER_SIZE.SHORT ? x(_t9$3 || (_t9$3 = _$v` <c4d-footer-nav
              ?disable-locale-button="${0}">
              ${0}
              ${0}
              ${0}
            </c4d-footer-nav>`), l(disableLocaleButton), links === null || links === void 0 ? void 0 : links.map(({
          title: groupTitle,
          links: groupLinks
        }) => x(_t10$3 || (_t10$3 = _$v`
                  <c4d-footer-nav-group title-text="${0}">
                    ${0}
                  </c4d-footer-nav-group>
                `), l(groupTitle), groupLinks === null || groupLinks === void 0 ? void 0 : groupLinks.map(({
          title,
          url
        }) => x(_t11$3 || (_t11$3 = _$v`
                        <c4d-footer-nav-item href="${0}"
                          >${0}</c4d-footer-nav-item
                        >
                      `), l(url), title)))), !langList && !disableLocaleButton ? this.renderLocaleButton() : ``, langList && !disableLocaleButton ? this.renderLanguageSelector() : ``) : ``, (size === FOOTER_SIZE.SHORT || size === FOOTER_SIZE.MICRO) && !langList && !disableLocaleButton ? this.renderLocaleButton() : ``, (size === FOOTER_SIZE.SHORT || size === FOOTER_SIZE.MICRO) && langList && !disableLocaleButton ? this.renderLanguageSelector() : ``, l(size), l(navLabel), l(size), disableLocaleButton, legalLinks === null || legalLinks === void 0 ? void 0 : legalLinks.map(({
          title,
          url,
          titleEnglish
        }) => x(_t12$3 || (_t12$3 = _$v`
              <c4d-legal-nav-item
                autoid="${0}"
                href="${0}"
                >${0}</c4d-legal-nav-item
              >
            `), l(titleEnglish), l(url), title)), size !== FOOTER_SIZE.MICRO ? adjunctLinks === null || adjunctLinks === void 0 ? void 0 : adjunctLinks.map(({
          title,
          url,
          titleEnglish
        }) => x(_t13$3 || (_t13$3 = _$v`
                  <c4d-legal-nav-item
                    autoid="${0}"
                    href="${0}"
                    slot="adjunct-links">
                    ${0}
                  </c4d-legal-nav-item>
                `), l(titleEnglish), l(url), title)) : ``, size === FOOTER_SIZE.MICRO && !langList && !disableLocaleButton ? this.renderLocaleButton('locale') : ``, size === FOOTER_SIZE.MICRO && langList && !disableLocaleButton ? this.renderLanguageSelector('locale') : ``);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t14$3 || (_t14$3 = _$v` <slot></slot> `));
      }

      /**
       * The name of the custom event fired after this modal is closed upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventCloseModal",
      value: function () {
        return `${c4dPrefix$y}-expressive-modal-closed`;
      }
    }]
  };
}, MediaQueryMixin(ModalRenderMixin(HybridRenderMixin(HostListenerMixin(s))), {
  [MQBreakpoints.LG]: MQDirs.MAX
}));

function _decorate$x(e, r, t, i) { var o = _getDecoratorsApi$x(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$x(s.d.map(_createElementDescriptor$x)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$x() { _getDecoratorsApi$x = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$x(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$x(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$x(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$x(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$x(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$x(e) { var r, t = _toPropertyKey$x(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$x(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$x(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$x(o.descriptor) || _isDataDescriptor$x(i.descriptor)) { if (_hasDecorators$x(o) || _hasDecorators$x(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$x(o)) { if (_hasDecorators$x(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$x(o, i); } } else r.push(o); } return r; }
function _hasDecorators$x(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$x(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$x(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$x(t) { var i = _toPrimitive$x(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$x(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$x(r) { return _arrayWithHoles$y(r) || _iterableToArray$x(r) || _unsupportedIterableToArray$y(r) || _nonIterableRest$y(); }
function _nonIterableRest$y() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$y(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$y(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$y(r, a) : void 0; } }
function _arrayLikeToArray$y(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$x(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$y(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$x
} = settings;

/**
 * The Redux actions used for `<c4d-footer-container>`.
 */

/**
 * The Redux state used for `<c4d-footer-container>`.
 */

/**
 * The properties for `<c4d-footer-container>` from Redux state.
 */

/**
 * @param state The Redux state for masthead.
 * @returns The converted version of the given state, tailored for `<c4d-footer-container>`.
 */
function mapStateToProps$2(state) {
  var _translations$languag, _translations$languag2;
  const {
    localeAPI,
    translateAPI
  } = state;
  const {
    language,
    localeLists
  } = localeAPI !== null && localeAPI !== void 0 ? localeAPI : {};
  const {
    translations
  } = translateAPI !== null && translateAPI !== void 0 ? translateAPI : {};
  return pickBy({
    localeList: !language ? undefined : localeLists === null || localeLists === void 0 ? void 0 : localeLists[language],
    links: !language ? undefined : translations === null || translations === void 0 || (_translations$languag = translations[language]) === null || _translations$languag === void 0 ? void 0 : _translations$languag.footerMenu,
    legalLinks: !language ? undefined : translations === null || translations === void 0 || (_translations$languag2 = translations[language]) === null || _translations$languag2 === void 0 ? void 0 : _translations$languag2.footerThin
  }, value => value !== undefined);
}

/**
 * @param dispatch The Redux `dispatch()` API.
 * @returns The methods in `<c4d-footer-container>` to dispatch Redux actions.
 */
function mapDispatchToProps$2(dispatch) {
  return bindActionCreators({
    _loadLanguage: loadLanguage,
    _setLanguage: setLanguage,
    _loadLocaleList: loadLocaleList,
    _setLocaleList: setLocaleList,
    _loadTranslation: loadTranslation,
    _setTranslation: setTranslation
  }, dispatch // TS definition of `bindActionCreators()` seems to have no templated `Dispatch`
  );
}

/**
 * Container component for masthead.
 *
 * @element c4d-footer-container
 */
_decorate$x([carbonElement(`${c4dPrefix$x}-footer-container`)], function (_initialize, _ConnectMixin) {
  class C4DFooterContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DFooterContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps$2, mapDispatchToProps$2)(C4DFooterComposite));

/**
 * @constant {string | string} Host for the profile status API call
 * @private
 */
var _host$1 = process && (process.env.REACT_APP_PROFILE_HOST || process.env.PROFILE_HOST) || 'https://login.ibm.com';

/**
 * @constant {string | string} API version
 * @private
 */
var _version$1 = process && process.env.PROFILE_VERSION || 'v1';

/**
 * Profile status endpoint
 *
 * @type {string}
 * @private
 */
var _endpoint$1 = "".concat(_host$1, "/").concat(_version$1, "/mgmt/idaas/user/status/");

/**
 * The cookie name for determining user login status for cloud.ibm.com.
 *
 * @type {string}
 * @private
 */
var _cookieName$1 = 'com.ibm.cloud.iam.LoggedIn.prod';

/**
 * Profile API class with methods for checking user authentication for ibm.com
 */
var ProfileAPI = /*#__PURE__*/function () {
  function ProfileAPI() {
    _classCallCheck$2(this, ProfileAPI);
  }
  return _createClass$2(ProfileAPI, null, [{
    key: "getUserStatus",
    value: (
    /**
     * Returns user status (authenticated or unauthenticated)
     *
     * @returns {Promise<any>} User status
     * @example
     * import { ProfileAPI } from '@carbon/ibmdotcom-services';
     *
     * async function getUserStatus() {
     *   const response = await ProfileAPI.getUserStatus();
     *   return response;
     * }
     */
    function () {
      var _getUserStatus = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
        return regenerator.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return axios$1.get(_endpoint$1, {
                headers: {
                  'Content-Type': 'application/json; charset=utf-8'
                },
                withCredentials: true
              }).then(function (response) {
                return response.data;
              }).catch(function (error) {
                console.log('Failed Profile Network Call', error);
                return {
                  user: 'Unauthenticated'
                };
              });
            case 2:
              return _context.abrupt("return", _context.sent);
            case 3:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function getUserStatus() {
        return _getUserStatus.apply(this, arguments);
      }
      return getUserStatus;
    }()
    /**
     * retrieve the cloud login status via cookie
     *
     *
     * @returns {string} string determining login status
     */
    )
  }, {
    key: "checkCloudCookie",
    value: function checkCloudCookie() {
      var cloudLogin = Cookies.get(_cookieName$1);
      return {
        user: cloudLogin === '1' ? 'authenticated' : 'anonymous'
      };
    }

    /**
     * retrieve the cloud login status via api
     *
     *
     * @returns {string} string determining login status
     */
  }, {
    key: "checkCloudDocsAPI",
    value: (function () {
      var _checkCloudDocsAPI = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2() {
        var cloudLogin;
        return regenerator.wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return axios$1.get('/api/v6/selected-account?profile=true', {
                headers: {
                  Accept: 'application/json'
                }
              }).then(function (response) {
                return response.status === 200 ? 'authenticated' : 'anonymous';
              }).catch(function (error) {
                console.error(error);
                return 'anonymous';
              });
            case 2:
              cloudLogin = _context2.sent;
              return _context2.abrupt("return", {
                user: cloudLogin
              });
            case 4:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));
      function checkCloudDocsAPI() {
        return _checkCloudDocsAPI.apply(this, arguments);
      }
      return checkCloudDocsAPI;
    }())
  }]);
}();

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * @param error An error from the JSONP call for user authentication status.
 * @returns A Redux action to set the state that the JSONP call for user authentication status failed.
 * @private
 */ /**
     * @param error An error from the JSONP call for user authentication status.
     * @returns A Redux action to set the state that the JSONP call for user authentication status failed.
     * @private
     */
function setErrorRequestUserStatus(error) {
  return {
    type: PROFILE_API_ACTION.SET_ERROR_REQUEST_USER_STATUS,
    error
  };
}

/**
 * @param request The promise of the REST call for  user status that is in progress.
 * @returns A Redux action to set the state that the REST call for user status is in progress.
 * @private
 */
function setRequestUserStatusInProgress(request) {
  return {
    type: PROFILE_API_ACTION.SET_REQUEST_USER_STATUS_IN_PROGRESS,
    request
  };
}

/**
 * @param request The user authentication status from the JSONP call.
 * @returns A Redux action to set the given user authentication status.
 */
function setUserStatus(request) {
  return {
    type: PROFILE_API_ACTION.SET_USER_STATUS,
    request
  };
}
/**
 * @returns A Redux action that sends a REST call for user authentication status.
 */
function loadUserStatus(authMethod) {
  return async dispatch => {
    let promiseStatus;
    switch (authMethod) {
      case MASTHEAD_AUTH_METHOD.COOKIE:
        promiseStatus = ProfileAPI.checkCloudCookie();
        break;
      case MASTHEAD_AUTH_METHOD.DOCS_API:
        promiseStatus = ProfileAPI.checkCloudDocsAPI();
        break;
      default:
        promiseStatus = ProfileAPI.getUserStatus();
    }
    dispatch(setRequestUserStatusInProgress(promiseStatus));
    try {
      dispatch(setUserStatus(await promiseStatus));
    } catch (error) {
      dispatch(setErrorRequestUserStatus(error));
      throw error;
    }
    return promiseStatus;
  };
}

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$i = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}<path d="M9.3 3.7L13.1 7.5 1 7.5 1 8.5 13.1 8.5 9.3 12.3 10 13 15 8 10 3z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$h = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M6.7 12.3L2.9 8.5 15 8.5 15 7.5 2.9 7.5 6.7 3.7 6 3 1 8 6 13z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$g = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"></path></svg>`;

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */class e extends i{constructor(i){if(super(i),this.et=A,i.type!==t$1.CHILD)throw Error(this.constructor.directiveName+"() can only be used in child bindings")}render(r){if(r===A||null==r)return this.ft=void 0,this.et=r;if(r===T)return r;if("string"!=typeof r)throw Error(this.constructor.directiveName+"() called with a non-string value");if(r===this.et)return this.ft;this.et=r;const s=[r];return s.raw=s,this.ft={_$litType$:this.constructor.resultType,strings:s,values:[]}}}e.directiveName="unsafeHTML",e.resultType=1;const o$1=e$1(e);

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */class t extends e{}t.directiveName="unsafeSVG",t.resultType=2;const o=e$1(t);

/**
 * Copyright IBM Corp. 2016, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var MastheadLogoAPI = /*#__PURE__*/function () {
  function MastheadLogoAPI() {
    _classCallCheck$2(this, MastheadLogoAPI);
  }
  return _createClass$2(MastheadLogoAPI, null, [{
    key: "setMastheadLogo",
    value:
    /**
     * Determines whether to return custom or default IBM logo
     *
     * @returns {boolean} Use alternate logo or not
     * @example
     * import { MastheadLogoAPI } from '@carbon/ibmdotcom-services';
     *
     * const useAlternateLogo = MastheadLogoAPI.setMastheadLogo(logoData);
     */
    function setMastheadLogo(logoData) {
      if (logoData === undefined) {
        return false;
      }
      var currentTime = new Date().getTime();
      var expireTime = logoData.end ? Date.parse(logoData.end) : null;
      var isExpired = expireTime && currentTime > expireTime ? true : false;
      if (logoData.svg === null || isExpired || logoData.denylist && logoData.denylist.indexOf(location.pathname) !== -1) {
        return false;
      } else if (logoData.allowlist && (logoData.allowlist.length == 0 || logoData.allowlist.indexOf(location.pathname) !== -1) && logoData.svg) {
        return true;
      } else {
        return false;
      }
    }
  }]);
}();

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The style scheme for the megamenu link with icon.
 */
let MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME;

/**
 * The style scheme for the right navigation.
 */
(function (MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME) {
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["VIEW_ALL"] = "view-all";
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["CATEGORY_HEADLINE"] = "category-headline";
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["CATEGORY_SUBLINK"] = "category-sublink";
  MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME["DEFAULT"] = "default";
})(MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME || (MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME = {}));
let MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME;

/**
 * The layout options for rendering a megamenu
 */
(function (MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME) {
  MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME["FULL"] = "full";
  MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME["HAS_SIDEBAR"] = "has-sidebar";
})(MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME || (MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME = {}));
let MEGAMENU_LAYOUT_SCHEME;

/**
 * Matches CMaaS's CTA options.
 *
 * @see https://github.ibm.com/live-advisor/cm-app/blob/master/docs/cm-doc.md#calls-to-action
 */
(function (MEGAMENU_LAYOUT_SCHEME) {
  MEGAMENU_LAYOUT_SCHEME["TAB"] = "tab";
  MEGAMENU_LAYOUT_SCHEME["LIST"] = "list";
})(MEGAMENU_LAYOUT_SCHEME || (MEGAMENU_LAYOUT_SCHEME = {}));
let L1_CTA_TYPES;
(function (L1_CTA_TYPES) {
  L1_CTA_TYPES["NONE"] = "";
  L1_CTA_TYPES["CONTACT_US"] = "contact";
  L1_CTA_TYPES["CHAT_NOW"] = "chat";
  L1_CTA_TYPES["EMAIL_US"] = "email";
  L1_CTA_TYPES["CALL_US"] = "phone";
  L1_CTA_TYPES["BOOK_A_CONSULTATION"] = "scheduler";
  L1_CTA_TYPES["REQUEST_A_DEMO"] = "demo";
  L1_CTA_TYPES["REQUEST_A_QUOTE"] = "quote";
})(L1_CTA_TYPES || (L1_CTA_TYPES = {}));

var styles$8 = i$4(["html,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover, :host(cds-tooltip[highContrast]) .cds--popover--high-contrast ::slotted(cds-tooltip-content),\n:host(cds-tooltip[highContrast]) .cds--popover--high-contrast ::slotted(cds-popover-content),\n:host(cds-popover[highContrast]) .cds--popover--high-contrast ::slotted(cds-tooltip-content),\n:host(cds-popover[highContrast]) .cds--popover--high-contrast ::slotted(cds-popover-content), .cds--popover--high-contrast :host(cds-tooltip-content),\n.cds--popover--high-contrast :host(cds-popover-content) {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover, :host(cds-tooltip[highContrast]) .cds--popover--drop-shadow ::slotted(cds-tooltip-content),\n:host(cds-tooltip[highContrast]) .cds--popover--drop-shadow ::slotted(cds-popover-content),\n:host(cds-popover[highContrast]) .cds--popover--drop-shadow ::slotted(cds-tooltip-content),\n:host(cds-popover[highContrast]) .cds--popover--drop-shadow ::slotted(cds-popover-content), .cds--popover--drop-shadow :host(cds-tooltip-content),\n.cds--popover--drop-shadow :host(cds-popover-content) {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover, :host(cds-tooltip[highContrast]) ::slotted(cds-tooltip-content),\n:host(cds-tooltip[highContrast]) ::slotted(cds-popover-content),\n:host(cds-popover[highContrast]) ::slotted(cds-tooltip-content),\n:host(cds-popover[highContrast]) ::slotted(cds-popover-content), :host(cds-tooltip-content),\n:host(cds-popover-content) {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--open > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--open > :host(cds-popover-content) > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before, :host(cds-tooltip[highContrast]) .cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-content::before, .cds--popover--open > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--open > :host(cds-popover-content) > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--caret.cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--caret.cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--caret.cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--caret.cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-caret, .cds--popover--caret.cds--popover--open > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--caret.cds--popover--open > :host(cds-popover-content) > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--auto-align.cds--popover--caret.cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--auto-align.cds--popover--caret.cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--auto-align.cds--popover--caret.cds--popover--open > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--auto-align.cds--popover--caret.cds--popover--open > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret, .cds--popover--auto-align.cds--popover--caret.cds--popover--open > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--tab-tip > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--tab-tip > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--tab-tip > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--tab-tip > ::slotted(cds-popover-content) > .cds--popover-caret, .cds--popover--tab-tip > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--tab-tip > :host(cds-popover-content) > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--bottom-left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--bottom-right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before, :host(cds-tooltip[highContrast]) .cds--popover--bottom > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom > ::slotted(cds-popover-content) > .cds--popover-content::before, .cds--popover--bottom > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--bottom > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-left > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--bottom-left > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-start > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--bottom-start > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-right > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--bottom-right > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--bottom-end > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--bottom-end > :host(cds-popover-content) > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--bottom > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom > ::slotted(cds-popover-content) > .cds--popover-caret, .cds--popover--bottom > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--bottom > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-left > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--bottom-left > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-start > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--bottom-start > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-right > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--bottom-right > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--bottom-end > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--bottom-end > :host(cds-popover-content) > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom > ::slotted(cds-popover-content) > .cds--popover-caret, [dir=rtl] .cds--popover--bottom > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-left > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-left > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-left > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-left > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-start > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-start > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-start > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-start > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-right > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-right > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-right > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-right > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-end > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--bottom-end > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-end > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--bottom-end > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > :host(cds-popover-content) > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--bottom.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret, .cds--popover--bottom.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-left.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-left.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-right.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-right.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--bottom-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--bottom-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--top-left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--top-left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--top-right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--top-right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before, :host(cds-tooltip[highContrast]) .cds--popover--top > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top > ::slotted(cds-popover-content) > .cds--popover-content::before, .cds--popover--top > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--top > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-left > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-left > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-left > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--top-left > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-start > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--top-start > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-right > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-right > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-right > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--top-right > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--top-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--top-end > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--top-end > :host(cds-popover-content) > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--top > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top > ::slotted(cds-popover-content) > .cds--popover-caret, .cds--popover--top > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--top > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-left > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-left > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-left > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--top-left > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-start > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-start > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-start > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--top-start > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-right > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-right > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-right > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--top-right > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-end > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-end > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--top-end > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--top-end > :host(cds-popover-content) > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret, [dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--top.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret, .cds--popover--top.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-left.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-left.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-left.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-right.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-right.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-right.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--top-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--top-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before, :host(cds-tooltip[highContrast]) .cds--popover--right > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right > ::slotted(cds-popover-content) > .cds--popover-content::before, .cds--popover--right > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--right > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-top > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-top > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-top > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--right-top > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-start > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--right-start > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-bottom > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--right-bottom > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--right-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--right-end > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--right-end > :host(cds-popover-content) > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret, .cds--popover--right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret, [dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--right.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret, .cds--popover--right.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-top.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-top.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-top.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-bottom.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-bottom.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--right-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--right-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content, [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before, :host(cds-tooltip[highContrast]) .cds--popover--left > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left > ::slotted(cds-popover-content) > .cds--popover-content::before, .cds--popover--left > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--left > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-top > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-top > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-top > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--left-top > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-start > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-start > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-start > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--left-start > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-bottom > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--left-bottom > :host(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-end > ::slotted(cds-tooltip-content) > .cds--popover-content::before,\n:host(cds-popover[highContrast]) .cds--popover--left-end > ::slotted(cds-popover-content) > .cds--popover-content::before,\n.cds--popover--left-end > :host(cds-tooltip-content) > .cds--popover-content::before,\n.cds--popover--left-end > :host(cds-popover-content) > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret, .cds--popover--left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret, :host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret, [dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-tooltip-content) > .cds--popover-caret,\n:host(cds-popover[highContrast]) [dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > ::slotted(cds-popover-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-tooltip-content) > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > :host(cds-popover-content) > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret, :host(cds-tooltip[highContrast]) .cds--popover--left.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret, .cds--popover--left.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-top.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-top.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-top.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-start.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-start.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-bottom.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-bottom.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-tooltip[highContrast]) .cds--popover--left-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-end.cds--popover--auto-align > ::slotted(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n:host(cds-popover[highContrast]) .cds--popover--left-end.cds--popover--auto-align > ::slotted(cds-popover-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > :host(cds-tooltip-content) > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > :host(cds-popover-content) > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content, :host(cds-tooltip[highContrast]) .cds--popover--tab-tip > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-tooltip[highContrast]) .cds--popover--tab-tip > ::slotted(cds-popover-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--tab-tip > ::slotted(cds-tooltip-content) > .cds--popover-content,\n:host(cds-popover[highContrast]) .cds--popover--tab-tip > ::slotted(cds-popover-content) > .cds--popover-content, .cds--popover--tab-tip > :host(cds-tooltip-content) > .cds--popover-content,\n.cds--popover--tab-tip > :host(cds-popover-content) > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover, :host(cds-tooltip[highContrast]) .cds--popover--tab-tip ::slotted(cds-tooltip-content),\n:host(cds-tooltip[highContrast]) .cds--popover--tab-tip ::slotted(cds-popover-content),\n:host(cds-popover[highContrast]) .cds--popover--tab-tip ::slotted(cds-tooltip-content),\n:host(cds-popover[highContrast]) .cds--popover--tab-tip ::slotted(cds-popover-content), .cds--popover--tab-tip :host(cds-tooltip-content),\n.cds--popover--tab-tip :host(cds-popover-content) {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button, :host(cds-tooltip) ::slotted(.cds--popover--tab-tip__button),\n:host(cds-popover) ::slotted(.cds--popover--tab-tip__button) {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *, :host(cds-tooltip) ::slotted(.cds--popover--tab-tip__button) *,\n:host(cds-popover) ::slotted(.cds--popover--tab-tip__button) *,\n.cds--popover--tab-tip__button *::before,\n:host(cds-tooltip) ::slotted(.cds--popover--tab-tip__button) *::before,\n:host(cds-popover) ::slotted(.cds--popover--tab-tip__button) *::before,\n.cds--popover--tab-tip__button *::after,\n:host(cds-tooltip) ::slotted(.cds--popover--tab-tip__button) *::after,\n:host(cds-popover) ::slotted(.cds--popover--tab-tip__button) *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus, :host(cds-tooltip) :focus::slotted(.cds--popover--tab-tip__button),\n:host(cds-popover) :focus::slotted(.cds--popover--tab-tip__button) {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus, :host(cds-tooltip) :focus::slotted(.cds--popover--tab-tip__button),\n  :host(cds-popover) :focus::slotted(.cds--popover--tab-tip__button) {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover, :host(cds-tooltip) :hover::slotted(.cds--popover--tab-tip__button),\n:host(cds-popover) :hover::slotted(.cds--popover--tab-tip__button) {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button, :host(cds-tooltip) .cds--popover--tab-tip.cds--popover--open ::slotted(.cds--popover--tab-tip__button),\n:host(cds-popover) .cds--popover--tab-tip.cds--popover--open ::slotted(.cds--popover--tab-tip__button) {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg, :host(cds-tooltip) ::slotted(.cds--popover--tab-tip__button) svg,\n:host(cds-popover) ::slotted(.cds--popover--tab-tip__button) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content, :host(prefix-tooltip-content) ::slotted(.cds-tooltip-content) {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content, :host(prefix-tooltip-content) .cds--icon-tooltip ::slotted(.cds-tooltip-content) {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon, :host(c4d-button) .cds--btn svg, :host(c4d-button-group-item) .cds--btn ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn svg,\n:host(c4d-button-cta) .cds--btn svg {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon, :host(c4d-button) .cds--btn--primary svg, :host(c4d-button-group-item) .cds--btn--primary ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--primary svg,\n:host(c4d-button-cta) .cds--btn--primary svg,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--primary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--primary ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--primary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--primary svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon, :host(c4d-button) .cds--btn--secondary svg, :host(c4d-button-group-item) .cds--btn--secondary ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--secondary svg,\n:host(c4d-button-cta) .cds--btn--secondary svg,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--secondary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--secondary ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--secondary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--secondary svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon, :host(c4d-button) .cds--btn--tertiary svg, :host(c4d-button-group-item) .cds--btn--tertiary ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--tertiary svg,\n:host(c4d-button-cta) .cds--btn--tertiary svg,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--tertiary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--tertiary ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--tertiary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--tertiary svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon, :host(c4d-button) .cds--btn--ghost svg, :host(c4d-button-group-item) .cds--btn--ghost ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--ghost svg,\n:host(c4d-button-cta) .cds--btn--ghost svg,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--ghost svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--ghost ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--ghost svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--ghost svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon, :host(c4d-button) .cds--btn--ghost svg, :host(c4d-button-group-item) .cds--btn--ghost ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--ghost svg,\n:host(c4d-button-cta) .cds--btn--ghost svg {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon, :host(c4d-button) .cds--btn--icon-only svg, :host(c4d-button-group-item) .cds--btn--icon-only ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--icon-only svg,\n:host(c4d-button-cta) .cds--btn--icon-only svg {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, :host(c4d-button) .cds--btn--icon-only.cds--btn--ghost svg, :host(c4d-button-group-item) .cds--btn--icon-only.cds--btn--ghost ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--icon-only.cds--btn--ghost svg,\n:host(c4d-button-cta) .cds--btn--icon-only.cds--btn--ghost svg, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon, :host(c4d-button) .cds--btn--icon-only.cds--btn--danger--ghost svg, :host(c4d-button-group-item) .cds--btn--icon-only.cds--btn--danger--ghost ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--icon-only.cds--btn--danger--ghost svg,\n:host(c4d-button-cta) .cds--btn--icon-only.cds--btn--danger--ghost svg {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon, :host(c4d-button) .cds--btn--sm:not(.cds--btn--icon-only) svg, :host(c4d-button-group-item) .cds--btn--sm:not(.cds--btn--icon-only) ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--sm:not(.cds--btn--icon-only) svg,\n:host(c4d-button-cta) .cds--btn--sm:not(.cds--btn--icon-only) svg,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,\n:host(c4d-button) .cds--btn--md:not(.cds--btn--icon-only) svg,\n:host(c4d-button-group-item) .cds--btn--md:not(.cds--btn--icon-only) ::slotted([slot=icon]),\n:host(c4d-button-group-item) .cds--btn--md:not(.cds--btn--icon-only) svg,\n:host(c4d-button-cta) .cds--btn--md:not(.cds--btn--icon-only) svg {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]), :host(c4d-button) .cds--btn--ghost.cds--btn--icon-only svg path:not([data-icon-path]):not([fill=none]), :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]), :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--ghost.cds--btn--icon-only svg path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,\n:host(c4d-button) .cds--btn--ghost.cds--btn--icon-only svg,\n:host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only ::slotted([slot=icon]),\n:host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only svg,\n:host(c4d-button-cta) .cds--btn--ghost.cds--btn--icon-only svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]), :host(c4d-button) .cds--btn--ghost.cds--btn--icon-only[disabled] svg path:not([data-icon-path]):not([fill=none]), :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only[disabled] ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]), :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only[disabled] svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--ghost.cds--btn--icon-only[disabled] svg path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n:host(c4d-button) .cds--btn--ghost.cds--btn--icon-only[disabled] svg,\n:host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only[disabled] ::slotted([slot=icon]),\n:host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only[disabled] svg,\n:host(c4d-button-cta) .cds--btn--ghost.cds--btn--icon-only[disabled] svg,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon, :host(c4d-button) .cds--btn--danger svg, :host(c4d-button-group-item) .cds--btn--danger ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--danger svg,\n:host(c4d-button-cta) .cds--btn--danger svg,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--danger svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--danger ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--danger svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--danger svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon, :host(c4d-button) .cds--btn--danger--tertiary svg, :host(c4d-button-group-item) .cds--btn--danger--tertiary ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--danger--tertiary svg,\n:host(c4d-button-cta) .cds--btn--danger--tertiary svg,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--danger--tertiary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--danger--tertiary ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--danger--tertiary svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--danger--tertiary svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon, :host(c4d-button) .cds--btn--danger--ghost svg, :host(c4d-button-group-item) .cds--btn--danger--ghost ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--danger--ghost svg,\n:host(c4d-button-cta) .cds--btn--danger--ghost svg,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button) .cds--btn--danger--ghost svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--danger--ghost ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-group-item) .cds--btn--danger--ghost svg path:not([data-icon-path]):not([fill=none]),\n:host(c4d-button-cta) .cds--btn--danger--ghost svg path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon, :host(c4d-button) .cds--btn--danger--ghost svg, :host(c4d-button-group-item) .cds--btn--danger--ghost ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn--danger--ghost svg,\n:host(c4d-button-cta) .cds--btn--danger--ghost svg {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon, :host(c4d-button) .cds--btn.cds--btn--expressive svg, :host(c4d-button-group-item) .cds--btn.cds--btn--expressive ::slotted([slot=icon]), :host(c4d-button-group-item) .cds--btn.cds--btn--expressive svg,\n:host(c4d-button-cta) .cds--btn.cds--btn--expressive svg {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]), :host(c4d-button) .cds--btn--ghost.cds--btn--icon-only svg path:not([data-icon-path]):not([fill=none]), :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only ::slotted([slot=icon]) path:not([data-icon-path]):not([fill=none]), :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only svg path:not([data-icon-path]):not([fill=none]),\n  :host(c4d-button-cta) .cds--btn--ghost.cds--btn--icon-only svg path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,\n  :host(c4d-button) .cds--btn--ghost.cds--btn--icon-only svg,\n  :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only ::slotted([slot=icon]),\n  :host(c4d-button-group-item) .cds--btn--ghost.cds--btn--icon-only svg,\n  :host(c4d-button-cta) .cds--btn--ghost.cds--btn--icon-only svg {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--header, :host(cds-header) {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: fixed;\n  z-index: 8000;\n  display: flex;\n  align-items: center;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: 1px solid var(--cds-border-subtle);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n}\n.cds--header *, :host(cds-header) *,\n.cds--header *::before,\n:host(cds-header) *::before,\n.cds--header *::after,\n:host(cds-header) *::after {\n  box-sizing: inherit;\n}\n\n.cds--header__action {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: inline-flex;\n  border: 0.0625rem solid transparent;\n  block-size: 3rem;\n  inline-size: 3rem;\n  transition: background-color 110ms, border-color 110ms;\n}\n.cds--header__action *,\n.cds--header__action *::before,\n.cds--header__action *::after {\n  box-sizing: inherit;\n}\n.cds--header__action::-moz-focus-inner {\n  border: 0;\n}\n@media (max-width: 41.98rem) {\n  .cds--header__action {\n    min-inline-size: 3rem;\n  }\n}\n\n.cds--header__global .cds--popover, :host(c4d-masthead-global-bar) .cds--popover, :host(cds-header) ::slotted(.cds--header__global, :host(c4d-masthead-global-bar)) .cds--popover {\n  z-index: 8001;\n}\n\n.cds--header__action > :first-child {\n  margin-block-start: 0;\n}\n\n.cds--header__action > svg.cds--navigation-menu-panel-collapse-icon,\n.cds--header__action--active > svg.cds--navigation-menu-panel-expand-icon {\n  display: none;\n}\n\n.cds--header__action--active > svg.cds--navigation-menu-panel-collapse-icon {\n  display: inline;\n}\n\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__action--active {\n  background: var(--cds-layer);\n  border-block-end: 1px solid transparent;\n  border-inline-end: 1px solid var(--cds-border-subtle);\n  border-inline-start: 1px solid var(--cds-border-subtle);\n}\n\n.cds--header__action--active > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__action:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--header__action:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n\n.cds--header__action.cds--btn--icon-only {\n  align-items: center;\n  justify-content: center;\n}\n\n.cds--btn.cds--btn--icon-only.cds--header__action svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--btn.cds--btn--icon-only.cds--header__action:hover svg,\n.cds--btn.cds--btn--icon-only.cds--header__action:active svg,\n.cds--btn.cds--btn--icon-only.cds--header__action--active svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-trigger > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-trigger:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-toggle {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n@media (min-width: 66rem) {\n  .cds--header__menu-toggle__hidden {\n    display: none;\n  }\n}\n\na.cds--header__name {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  padding: 0 2rem 0 1rem;\n  border: 0.125rem solid transparent;\n  block-size: 100%;\n  font-weight: 600;\n  letter-spacing: 0.1px;\n  line-height: 1.25rem;\n  outline: none;\n  text-decoration: none;\n  transition: border-color 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n@media (max-width: 41.98rem) {\n  a.cds--header__name {\n    padding: 0 1rem;\n  }\n}\n\na.cds--header__name:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--header__name--prefix {\n  font-weight: 400;\n}\n\na.cds--header__name,\na.cds--header__name:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-toggle:not(.cds--header__menu-toggle__hidden) ~ .cds--header__name {\n  padding-inline-start: 0.5rem;\n}\n\n.cds--header__nav, :host(cds-header-nav) {\n  position: relative;\n  display: none;\n  block-size: 100%;\n  padding-inline-start: 1rem;\n}\n@media (min-width: 66rem) {\n  .cds--header__nav, :host(cds-header-nav) {\n    display: block;\n  }\n}\n.cds--header__nav::before {\n  position: absolute;\n  display: block;\n  background-color: var(--cds-border-subtle);\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__menu-bar {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: flex;\n  padding: 0;\n  margin: 0;\n  block-size: 100%;\n  list-style: none;\n}\n.cds--header__menu-bar *,\n.cds--header__menu-bar *::before,\n.cds--header__menu-bar *::after {\n  box-sizing: inherit;\n}\n\na.cds--header__menu-item {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: 2px solid transparent;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  color: var(--cds-text-secondary, #525252);\n  font-size: 0.875rem;\n  font-weight: 400;\n  letter-spacing: 0;\n  line-height: 1.125rem;\n  text-decoration: none;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\na.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__action:active,\na.cds--header__menu-item:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--header__menu-item:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\na.cds--header__menu-item:hover > svg,\na.cds--header__menu-item:active > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\na.cds--header__menu-item[aria-current=page],\n.cds--header__menu-item--current {\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--header__menu-item[aria-current=page]::after,\n.cds--header__menu-item--current::after {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: 3px;\n  content: \"\";\n  inline-size: calc(100% + 4px);\n  inset-block-end: -2px;\n  inset-inline-start: -2px;\n}\n\na.cds--header__menu-item[aria-current=page]:focus::after,\n.cds--header__menu-item--current:focus::after {\n  border: 0;\n}\n\n.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]::after, :host(cds-header-menu) .cds--header__menu a.cds--header__menu-item[aria-current=page]::after,\n.cds--header__submenu .cds--header__menu .cds--header__menu-item--current::after,\n:host(cds-header-menu) .cds--header__menu .cds--header__menu-item--current::after {\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: calc(100% + 4px);\n  inline-size: 3px;\n  inset-block-start: -2px;\n  inset-inline-start: -2px;\n}\n.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after, :host(cds-header-menu) .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after,\n.cds--header__submenu .cds--header__menu .cds--header__menu-item--current:focus::after,\n:host(cds-header-menu) .cds--header__menu .cds--header__menu-item--current:focus::after {\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: calc(100% + 4px);\n  inline-size: 5px;\n  inset-block-start: -2px;\n  inset-inline-start: -2px;\n}\n\na.cds--header__menu-item[aria-current=page]:focus,\na.cds--header__menu-item.cds--header__menu-item--current:focus {\n  border: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--header__submenu, :host(cds-header-menu) {\n  position: relative;\n}\n\n.cds--header__menu-title[aria-haspopup=true] {\n  position: relative;\n}\n\n.cds--header__menu-title[aria-expanded=true] {\n  z-index: 8002;\n  background-color: var(--cds-layer);\n  color: var(--cds-text-secondary, #525252);\n}\n\n.cds--header__menu-title[aria-expanded=true] > .cds--header__menu-arrow {\n  transform: rotate(180deg);\n}\n\n.cds--header__menu {\n  display: none;\n  padding: 0;\n  margin: 0;\n  list-style: none;\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  position: absolute;\n  z-index: 8001;\n  display: flex;\n  flex-direction: column;\n  background-color: var(--cds-layer);\n  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.5);\n  inline-size: 12.5rem;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item {\n  background-color: var(--cds-layer);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:active {\n  background-color: var(--cds-layer-active);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item.cds--header__menu-item--current {\n  background-color: var(--cds-layer-selected);\n}\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n\n.cds--header__menu .cds--header__menu-item {\n  block-size: 3rem;\n}\n\n.cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n  margin-inline-start: 0.5rem;\n  transition: transform 110ms, fill 110ms;\n}\n\n.cds--header__global, :host(c4d-masthead-global-bar), :host(cds-header) ::slotted(.cds--header__global, :host(c4d-masthead-global-bar)) {\n  display: flex;\n  flex: 1 1 0%;\n  justify-content: flex-end;\n  block-size: 100%;\n}\n\n.cds--skip-to-content {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--skip-to-content:focus {\n  z-index: 9999;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: 4px solid var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  clip: auto;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: auto;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  outline: none;\n}\n\n.cds--side-nav, :host(c4d-left-nav) {\n  position: fixed;\n  z-index: 8000;\n  overflow: hidden;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 3rem;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  max-inline-size: 16rem;\n  transition: inline-size 0.11s cubic-bezier(0.2, 0, 1, 0.9), transform 0.11s cubic-bezier(0.2, 0, 1, 0.9);\n  will-change: inline-size;\n}\n\n.cds--side-nav--ux {\n  inline-size: 16rem;\n  inset-block-start: 3rem;\n}\n@media (max-width: 65.98rem) {\n  .cds--side-nav--ux {\n    inline-size: 0;\n  }\n}\n\n.cds--side-nav--rail {\n  inline-size: 3rem;\n}\n\n.cds--side-nav--hidden {\n  inline-size: 0;\n}\n\n.cds--side-nav--expanded {\n  inline-size: 16rem;\n}\n\n.cds--side-nav__overlay {\n  position: fixed;\n  background-color: transparent;\n  block-size: 0;\n  inline-size: 0;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n}\n\n@media (max-width: 65.98rem) {\n  .cds--side-nav__overlay-active {\n    z-index: 6000;\n    background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n    block-size: 100vh;\n    inline-size: 100vw;\n    opacity: 1;\n    transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  }\n}\n\n.cds--header ~ .cds--side-nav, .cds--header ~ :host(c4d-left-nav) {\n  block-size: calc(100% - 48px);\n  inset-block-start: 3rem;\n}\n\n.cds--side-nav--fixed {\n  inline-size: 16rem;\n}\n\n.cds--side-nav--collapsed {\n  inline-size: 16rem;\n  transform: translateX(-16rem);\n}\n\n.cds--side-nav__navigation {\n  display: flex;\n  flex-direction: column;\n}\n\n.cds--side-nav__items, :host(cds-side-nav-items) {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  overflow: hidden;\n  flex: 1 1 0%;\n  padding: 1rem 0 0;\n}\n.cds--side-nav__items *, :host(cds-side-nav-items) *,\n.cds--side-nav__items *::before,\n:host(cds-side-nav-items) *::before,\n.cds--side-nav__items *::after,\n:host(cds-side-nav-items) *::after {\n  box-sizing: inherit;\n}\n.cds--side-nav:hover .cds--side-nav__items, .cds--side-nav:hover :host(cds-side-nav-items), .cds--side-nav--fixed .cds--side-nav__items, .cds--side-nav--fixed :host(cds-side-nav-items), .cds--side-nav--expanded .cds--side-nav__items, .cds--side-nav--expanded :host(cds-side-nav-items) {\n  overflow-y: auto;\n}\n\n.cds--side-nav--ux .cds--side-nav__items, .cds--side-nav--ux :host(cds-side-nav-items) {\n  overflow-y: auto;\n}\n\n.cds--side-nav__item, :host(cds-side-nav-link), :host(cds-side-nav-menu), :host(c4d-left-nav-item) {\n  overflow: hidden;\n  block-size: auto;\n  inline-size: auto;\n}\n\n.cds--side-nav--ux .cds--side-nav__item, .cds--side-nav--ux :host(cds-side-nav-link), .cds--side-nav--ux :host(cds-side-nav-menu), .cds--side-nav--ux :host(c4d-left-nav-item) {\n  block-size: auto;\n  inline-size: auto;\n}\n\n.cds--side-nav__item:not(.cds--side-nav__item--active):hover .cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__submenu:hover, .cds--side-nav__item:not(.cds--side-nav__item--active):hover :not(.cds--side-nav__item--active):host(cds-side-nav-link) > .cds--side-nav__submenu:hover, .cds--side-nav__item:not(.cds--side-nav__item--active):hover :not(.cds--side-nav__item--active):host(cds-side-nav-menu) > .cds--side-nav__submenu:hover, .cds--side-nav__item:not(.cds--side-nav__item--active):hover :not(.cds--side-nav__item--active):host(c4d-left-nav-item) > .cds--side-nav__submenu:hover,\n.cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__link:hover,\n:not(.cds--side-nav__item--active):host(cds-side-nav-link) > .cds--side-nav__link:hover,\n:not(.cds--side-nav__item--active):host(cds-side-nav-menu) > .cds--side-nav__link:hover,\n:not(.cds--side-nav__item--active):host(c4d-left-nav-item) > .cds--side-nav__link:hover,\n.cds--side-nav__menu a.cds--side-nav__link:not(.cds--side-nav__link--current):not([aria-current=page]):hover,\n.cds--side-nav a.cds--header__menu-item:hover,\n:host(c4d-left-nav) a.cds--header__menu-item:hover,\n.cds--side-nav .cds--header__menu-title[aria-expanded=true]:hover,\n:host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true]:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__link:hover > span, :not(.cds--side-nav__item--active):host(cds-side-nav-link) > .cds--side-nav__link:hover > span, :not(.cds--side-nav__item--active):host(cds-side-nav-menu) > .cds--side-nav__link:hover > span, :not(.cds--side-nav__item--active):host(c4d-left-nav-item) > .cds--side-nav__link:hover > span,\n.cds--side-nav__item:not(.cds--side-nav__item--active) .cds--side-nav__menu-item > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(cds-side-nav-link) .cds--side-nav__menu-item > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(cds-side-nav-menu) .cds--side-nav__menu-item > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(c4d-left-nav-item) .cds--side-nav__menu-item > .cds--side-nav__link:hover > span,\n.cds--side-nav__item:not(.cds--side-nav__item--active) :host(cds-side-nav-menu-item) > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(cds-side-nav-link) :host(cds-side-nav-menu-item) > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(cds-side-nav-menu) :host(cds-side-nav-menu-item) > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(c4d-left-nav-item) :host(cds-side-nav-menu-item) > .cds--side-nav__link:hover > span,\n.cds--side-nav__item:not(.cds--side-nav__item--active) :host(c4d-left-nav-menu-item) > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(cds-side-nav-link) :host(c4d-left-nav-menu-item) > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(cds-side-nav-menu) :host(c4d-left-nav-menu-item) > .cds--side-nav__link:hover > span,\n:not(.cds--side-nav__item--active):host(c4d-left-nav-item) :host(c4d-left-nav-menu-item) > .cds--side-nav__link:hover > span {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item--large, :host(cds-side-nav-link[large]), :host(cds-side-nav-menu[large]) {\n  block-size: auto;\n}\n\n.cds--side-nav__divider, :host(cds-side-nav-divider) {\n  margin: 0.5rem 1rem;\n  background-color: var(--cds-border-subtle);\n  block-size: 1px;\n  list-style-type: none;\n}\n\n.cds--side-nav__divider hr, :host(cds-side-nav-divider) hr {\n  border: none;\n}\n\n.cds--side-nav__submenu {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  block-size: 2rem;\n  color: var(--cds-text-secondary, #525252);\n  transition: color 110ms, background-color 110ms, outline 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--side-nav__submenu *,\n.cds--side-nav__submenu *::before,\n.cds--side-nav__submenu *::after {\n  box-sizing: inherit;\n}\n.cds--side-nav__submenu::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--side-nav__submenu:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__submenu:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--side-nav__submenu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--side-nav__submenu-title {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  text-align: start;\n}\n\n.cds--side-nav__icon.cds--side-nav__submenu-chevron {\n  display: flex;\n  flex: 1;\n  justify-content: flex-end;\n}\n\n.cds--side-nav__submenu-chevron > svg {\n  block-size: 1rem;\n  inline-size: 1rem;\n  transition: transform 110ms;\n}\n\n.cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  transform: rotate(180deg);\n}\n\n.cds--side-nav__item--large .cds--side-nav__submenu, :host(cds-side-nav-link[large]) .cds--side-nav__submenu, :host(cds-side-nav-menu[large]) .cds--side-nav__submenu {\n  block-size: 3rem;\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu:hover, :host(cds-side-nav-menu[active]) .cds--side-nav__submenu:hover {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false], :host(cds-side-nav-menu[active]) .cds--side-nav__submenu[aria-expanded=false] {\n  position: relative;\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false]::before, :host(cds-side-nav-menu[active]) .cds--side-nav__submenu[aria-expanded=false]::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 3px;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu-title, :host(cds-side-nav-menu[active]) .cds--side-nav__submenu-title {\n  color: var(--cds-text-primary, #161616);\n  font-weight: 600;\n}\n\n.cds--side-nav__item--active .cds--side-nav__icon > svg, :host(cds-side-nav-menu[active]) .cds--side-nav__icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--side-nav__menu {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: block;\n  max-block-size: 0;\n  visibility: hidden;\n}\n.cds--side-nav__menu *,\n.cds--side-nav__menu *::before,\n.cds--side-nav__menu *::after {\n  box-sizing: inherit;\n}\n\n.cds--side-nav__submenu[aria-expanded=true] + .cds--side-nav__menu {\n  max-block-size: 93.75rem;\n  visibility: inherit;\n}\n\n.cds--side-nav__menu a.cds--side-nav__link {\n  block-size: 2rem;\n  font-weight: 400;\n  min-block-size: 2rem;\n  padding-inline-start: 2rem;\n}\n\n.cds--side-nav__item.cds--side-nav__item--icon a.cds--side-nav__link, :host(cds-side-nav-menu):host(cds-side-nav-menu[has-icon]) a.cds--side-nav__link {\n  padding-inline-start: 4.5rem;\n}\n\n.cds--side-nav__menu a.cds--side-nav__link--current,\n.cds--side-nav__menu a.cds--side-nav__link[aria-current=page],\na.cds--side-nav__link--current {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n.cds--side-nav__menu a.cds--side-nav__link--current > span,\n.cds--side-nav__menu a.cds--side-nav__link[aria-current=page] > span,\na.cds--side-nav__link--current > span {\n  color: var(--cds-text-primary, #161616);\n  font-weight: 600;\n}\n\na.cds--side-nav__link,\n.cds--side-nav a.cds--header__menu-item,\n:host(c4d-left-nav) a.cds--header__menu-item,\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  min-block-size: 2rem;\n  text-decoration: none;\n  transition: color 110ms, background-color 110ms, outline 110ms;\n}\n\n.cds--side-nav__item--large a.cds--side-nav__link, :host(cds-side-nav-link[large]) a.cds--side-nav__link, :host(cds-side-nav-menu[large]) a.cds--side-nav__link {\n  block-size: 3rem;\n}\n\na.cds--side-nav__link > .cds--side-nav__link-text,\n.cds--side-nav a.cds--header__menu-item .cds--text-truncate-end,\n:host(c4d-left-nav) a.cds--header__menu-item .cds--text-truncate-end {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  color: var(--cds-text-secondary, #525252);\n  font-size: 0.875rem;\n  letter-spacing: 0.1px;\n  line-height: 1.25rem;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\na.cds--side-nav__link:focus,\n.cds--side-nav a.cds--header__menu-item:focus,\n:host(c4d-left-nav) a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  a.cds--side-nav__link:focus,\n  .cds--side-nav a.cds--header__menu-item:focus,\n  :host(c4d-left-nav) a.cds--header__menu-item:focus {\n    outline-style: dotted;\n  }\n}\n\na.cds--side-nav__link[aria-current=page],\na.cds--side-nav__link--current {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  font-weight: 600;\n}\n\na.cds--side-nav__link[aria-current=page] .cds--side-nav__link-text,\na.cds--side-nav__link--current .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--side-nav__link[aria-current=page]::before,\na.cds--side-nav__link--current::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 3px;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--side-nav__icon {\n  display: flex;\n  flex: 0 0 1rem;\n  align-items: center;\n  justify-content: center;\n}\n\n.cds--side-nav__icon:not(.cds--side-nav__submenu-chevron) {\n  margin-inline-end: 1.5rem;\n}\n\n.cds--side-nav__icon > svg {\n  block-size: 1rem;\n  fill: var(--cds-icon-secondary, #525252);\n  inline-size: 1rem;\n}\n\n.cds--side-nav__icon > svg.cds--side-nav-collapse-icon {\n  display: none;\n}\n\n.cds--side-nav--expanded .cds--side-nav__icon > svg.cds--side-nav-expand-icon {\n  display: none;\n}\n\n.cds--side-nav--expanded .cds--side-nav__icon > svg.cds--side-nav-collapse-icon {\n  display: block;\n}\n\n.cds--side-nav--fixed a.cds--side-nav__link,\n.cds--side-nav--fixed .cds--side-nav__submenu {\n  padding-inline-start: 1rem;\n}\n\n.cds--side-nav--fixed .cds--side-nav__item:not(.cds--side-nav__item--icon) .cds--side-nav__menu a.cds--side-nav__link, .cds--side-nav--fixed :not(.cds--side-nav__item--icon):host(cds-side-nav-link) .cds--side-nav__menu a.cds--side-nav__link, .cds--side-nav--fixed :not(.cds--side-nav__item--icon):host(cds-side-nav-menu) .cds--side-nav__menu a.cds--side-nav__link, .cds--side-nav--fixed :not(.cds--side-nav__item--icon):host(c4d-left-nav-item) .cds--side-nav__menu a.cds--side-nav__link {\n  padding-inline-start: 2rem;\n}\n\n@media (max-width: 65.98rem) {\n  .cds--side-nav .cds--header__nav, :host(c4d-left-nav) .cds--header__nav {\n    display: block;\n  }\n}\n\n.cds--side-nav__header-navigation, :host(cds-header-side-nav-items) {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: none;\n}\n.cds--side-nav__header-navigation *, :host(cds-header-side-nav-items) *,\n.cds--side-nav__header-navigation *::before,\n:host(cds-header-side-nav-items) *::before,\n.cds--side-nav__header-navigation *::after,\n:host(cds-header-side-nav-items) *::after {\n  box-sizing: inherit;\n}\n@media (max-width: 65.98rem) {\n  .cds--side-nav__header-navigation, :host(cds-header-side-nav-items) {\n    position: relative;\n    display: block;\n    margin-block-end: 2rem;\n  }\n}\n\n.cds--side-nav__header-divider::after {\n  position: absolute;\n  background: var(--cds-border-subtle);\n  block-size: 0.0625rem;\n  content: \"\";\n  inline-size: calc(100% - 32px);\n  inset-block-end: -1rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--side-nav a.cds--header__menu-item, :host(c4d-left-nav) a.cds--header__menu-item {\n  justify-content: space-between;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n}\n.cds--side-nav a.cds--header__menu-item[aria-expanded=true], :host(c4d-left-nav) a.cds--header__menu-item[aria-expanded=true] {\n  background-color: transparent;\n}\n\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu, :host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  padding: 0;\n  background-color: transparent;\n  box-shadow: none;\n  inline-size: 100%;\n  inset-block-end: inherit;\n  transform: none;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li, :host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li {\n  inline-size: 100%;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item, :host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item {\n  font-weight: 400;\n  padding-inline-start: 4.25rem;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item:hover, :host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item--current:hover, :host(c4d-left-nav) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n\n.cds--side-nav .cds--side-nav__header-navigation a.cds--header__menu-item[aria-current=page]::after, :host(c4d-left-nav) .cds--side-nav__header-navigation a.cds--header__menu-item[aria-current=page]::after, .cds--side-nav :host(cds-header-side-nav-items) a.cds--header__menu-item[aria-current=page]::after, :host(c4d-left-nav) :host(cds-header-side-nav-items) a.cds--header__menu-item[aria-current=page]::after,\n.cds--side-nav .cds--side-nav__header-navigation .cds--header__menu-item--current::after,\n:host(c4d-left-nav) .cds--side-nav__header-navigation .cds--header__menu-item--current::after,\n.cds--side-nav :host(cds-header-side-nav-items) .cds--header__menu-item--current::after,\n:host(c4d-left-nav) :host(cds-header-side-nav-items) .cds--header__menu-item--current::after {\n  block-size: calc(100% + 4px);\n  inline-size: 3px;\n}\n\n.cds--side-nav .cds--header__menu a.cds--header__menu-item, :host(c4d-left-nav) .cds--header__menu a.cds--header__menu-item {\n  block-size: inherit;\n}\n\n.cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,\n.cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,\n.cds--side-nav .cds--header__menu-arrow,\n:host(c4d-left-nav) .cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--side-nav__icon > svg,\n  .cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,\n  .cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,\n  .cds--side-nav .cds--header__menu-arrow,\n  :host(c4d-left-nav) .cds--header__menu-arrow {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--content {\n  padding: 2rem;\n  color: var(--cds-text-primary, #161616);\n  will-change: margin-left;\n}\n\n.cds--header ~ .cds--content,\ndiv:has(.cds--header) ~ .cds--content {\n  margin-block-start: 3rem;\n}\n\n.cds--side-nav ~ .cds--content, :host(c4d-left-nav) ~ .cds--content {\n  margin-inline-start: 3rem;\n}\n\n.cds--side-nav.cds--side-nav--expanded ~ .cds--content {\n  margin-inline-start: 16rem;\n}\n\n.cds--header-panel, :host(cds-header-panel) {\n  position: fixed;\n  z-index: 8000;\n  overflow: hidden;\n  border: none;\n  background-color: var(--cds-layer);\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 0;\n  inset-block-end: 0;\n  inset-block-start: 3rem;\n  inset-inline-end: 0;\n  transition: width 110ms cubic-bezier(0.2, 0, 1, 0.9);\n  will-change: width;\n}\n\n.cds--header-panel--expanded, :host(cds-header-panel[expanded]) {\n  border-inline-end: 1px solid var(--cds-border-subtle);\n  border-inline-start: 1px solid var(--cds-border-subtle);\n  inline-size: 16rem;\n  overflow-y: auto;\n}\n\n.cds--switcher, :host(cds-switcher) {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  color: var(--cds-text-secondary, #525252);\n}\n.cds--switcher *, :host(cds-switcher) *,\n.cds--switcher *::before,\n:host(cds-switcher) *::before,\n.cds--switcher *::after,\n:host(cds-switcher) *::after {\n  box-sizing: inherit;\n}\n\n.cds--switcher__item, :host(cds-switcher-item) {\n  block-size: 2rem;\n  inline-size: 100%;\n}\n\n.cds--switcher__item:nth-child(1) {\n  margin-block-start: 1rem;\n}\n\n.cds--switcher__item--divider, :host(cds-switcher-divider) {\n  display: block;\n  border: none;\n  margin: 0.5rem 1rem;\n  background: var(--cds-border-subtle);\n  block-size: 1px;\n  inline-size: 14rem;\n}\n\n.cds--switcher__item-link {\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  display: block;\n  padding: 0.375rem 1rem;\n  block-size: 2rem;\n  color: var(--cds-text-secondary, #525252);\n  text-decoration: none;\n}\n.cds--switcher__item-link:hover:not(.cds--switcher__item-link--selected) {\n  background: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--switcher__item-link:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--switcher__item-link:active {\n  background: var(--cds-layer-active);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--switcher__item-link--selected {\n  background: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline: none;\n  text-decoration: none;\n  transition: color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--link *,\n.cds--link *::before,\n.cds--link *::after {\n  box-sizing: inherit;\n}\n.cds--link:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n  text-decoration: underline;\n}\n.cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n    outline-style: dotted;\n  }\n}\n.cds--link:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:focus {\n    outline-style: dotted;\n  }\n}\n.cds--link:visited {\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n}\n.cds--link:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link--disabled,\n.cds--link--disabled:hover {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  font-weight: 400;\n  text-decoration: none;\n}\n.cds--link--disabled *,\n.cds--link--disabled *::before,\n.cds--link--disabled *::after,\n.cds--link--disabled:hover *,\n.cds--link--disabled:hover *::before,\n.cds--link--disabled:hover *::after {\n  box-sizing: inherit;\n}\n\n.cds--link.cds--link--visited:visited {\n  color: var(--cds-link-visited-text-color, var(--cds-link-visited, #8a3ffc));\n}\n\n.cds--link.cds--link--visited:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link.cds--link--inline {\n  display: inline;\n  text-decoration: underline;\n}\n\n.cds--link--disabled.cds--link--inline {\n  text-decoration: underline;\n}\n\n.cds--link--sm,\n.cds--link--sm.cds--link--disabled:hover {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n}\n\n.cds--link--lg,\n.cds--link--lg.cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n\n.cds--link__icon {\n  display: inline-flex;\n  align-self: center;\n  margin-inline-start: 0.5rem;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--modal, :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n.cds--link-with-icon span,\n:host(c4d-link-with-icon) span,\n:host(c4d-link-list-item) span,\n:host(c4d-link-list-item-cta) span,\n:host(c4d-text-cta) span {\n  flex: 1;\n  align-self: center;\n  vertical-align: middle;\n}\n.cds--link-with-icon svg,\n.cds--link-with-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) svg,\n:host(c4d-link-with-icon) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) svg,\n:host(c4d-link-list-item) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) svg,\n:host(c4d-link-list-item-cta) ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) svg,\n:host(c4d-text-cta) ::slotted(svg[slot=icon]) {\n  display: inline;\n  align-self: middle;\n  fill: currentColor;\n  margin-inline-start: 0.5rem;\n}\n.cds--link-with-icon.cds--link--visited,\n:host(c4d-link-with-icon).cds--link--visited,\n:host(c4d-link-list-item).cds--link--visited,\n:host(c4d-link-list-item-cta).cds--link--visited,\n:host(c4d-text-cta).cds--link--visited {\n  color: var(--cds-link-visited, #8a3ffc);\n}\n.cds--link-with-icon.cds--link--disabled:hover,\n:host(c4d-link-with-icon).cds--link--disabled:hover,\n:host(c4d-link-list-item).cds--link--disabled:hover,\n:host(c4d-link-list-item-cta).cds--link--disabled:hover,\n:host(c4d-text-cta).cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n.cds--link-with-icon .cds--link--disabled,\n:host(c4d-link-with-icon) .cds--link--disabled,\n:host(c4d-link-list-item) .cds--link--disabled,\n:host(c4d-link-list-item-cta) .cds--link--disabled,\n:host(c4d-text-cta) .cds--link--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-text-cta).cds--link-with-icon__icon-left,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left {\n  display: flex;\n  flex-direction: row-reverse;\n  justify-content: flex-end;\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]) {\n  position: relative;\n  align-self: start;\n  inset-block-start: 1px;\n  margin-inline: 0 0.5rem;\n}\n\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: inline-block;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover {\n  text-underline-position: under;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: inline;\n  vertical-align: middle;\n  white-space: nowrap;\n}\n\n:host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n  display: none;\n}\n@media (min-width: 66rem) {\n  :host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n    display: inline;\n  }\n}\n\n.cds--link-with-icon:not(:first-of-type),\n:host(c4d-link-with-icon):not(:first-of-type),\n:host(c4d-text-cta):not(:first-of-type) {\n  margin-inline-start: 2rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]) {\n  margin-inline: 0 0.5rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]) {\n  margin-inline: 0.5rem 0;\n}\n.cds--link-with-icon:focus,\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.cds--link-with-icon:active,\n:host(c4d-link-with-icon):active,\n:host(c4d-text-cta):active {\n  text-decoration: none;\n}\n\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: none;\n}\n\n:host(c4d-link-with-icon),\n.cds--link-with-icon__container {\n  display: table;\n}\n\n/**\n* Copyright IBM Corp. 2016, 2021\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n*/\ninput:-webkit-autofill,\ninput:-webkit-autofill:hover,\ninput:-webkit-autofill:focus,\ntextarea:-webkit-autofill,\ntextarea:-webkit-autofill:hover,\ntextarea:-webkit-autofill:focus {\n  box-shadow: 0 0 0 1000px var(--cds-field) inset;\n  -webkit-text-fill-color: var(--cds-text-primary, #161616);\n}\n\n.cds--fieldset {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n.cds--fieldset *,\n.cds--fieldset *::before,\n.cds--fieldset *::after {\n  box-sizing: inherit;\n}\n\n.cds--form-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n}\n\n.cds--label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: inline-block;\n  color: var(--cds-text-secondary, #525252);\n  font-weight: 400;\n  line-height: 1rem;\n  margin-block-end: 0.5rem;\n  vertical-align: baseline;\n}\n.cds--label html {\n  font-size: 100%;\n}\n.cds--label body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--label code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--label strong {\n  font-weight: 600;\n}\n\n.cds--label .cds--toggletip-label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n\n.cds--label--no-margin {\n  margin-block-end: 0;\n}\n\n.cds--label + .cds--tooltip {\n  position: relative;\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger *,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::before,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::after {\n  box-sizing: inherit;\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg :hover {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--label + .cds--toggletip {\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 0.875rem;\n  inline-size: 4.6875rem;\n}\n.cds--label.cds--skeleton:hover, .cds--label.cds--skeleton:focus, .cds--label.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--label.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--label.cds--skeleton::before {\n    animation: none;\n  }\n}\n\ninput[type=number] {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n}\n\ninput[data-invalid]:not(:focus),\n.cds--number[data-invalid] input[type=number]:not(:focus),\n.cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n.cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n.cds--combo-box--invalid--focused),\n.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  input[data-invalid]:not(:focus),\n  .cds--number[data-invalid] input[type=number]:not(:focus),\n  .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n  .cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n  .cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n  .cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n  .cds--combo-box--invalid--focused),\n  .cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--number__input-wrapper--warning ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--warn ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--time-picker--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning > .cds--text-input ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper--warn ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select--warning .cds--select-input__wrapper ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement,\n.cds--list-box--warning ~ .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid],\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  display: block;\n}\n\n.cds--form--fluid input[data-invalid] {\n  outline: none;\n}\n\n.cds--form--fluid .cds--form-requirement {\n  padding: 0.5rem 2.5rem 0.5rem 1rem;\n  margin: 0;\n}\n\ninput:not(output, [data-invalid]):-moz-ui-invalid {\n  box-shadow: none;\n}\n\n.cds--form-requirement {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: none;\n  overflow: hidden;\n  margin: 0.25rem 0 0;\n  max-block-size: 0;\n}\n.cds--form-requirement html {\n  font-size: 100%;\n}\n.cds--form-requirement body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--form-requirement code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--form-requirement strong {\n  font-weight: 600;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-start: 0;\n}\n\n.cds--form__helper-text {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n  z-index: 0;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  margin-block-start: 0.25rem;\n  opacity: 1;\n}\n\n.cds--label--disabled,\n.cds--form__helper-text--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\nfieldset[disabled] .cds--label,\nfieldset[disabled] .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input *,\n.cds--text-input *::before,\n.cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--text-input:focus, .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input:focus, .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n\n.cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n\n.cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n\n.cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n\n.cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--text-input--password__visibility:hover::before, .cds--text-input--password__visibility:hover::after, .cds--text-input--password__visibility:focus::before, .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n\n.cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n\n.cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n\n.cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--text-input--invalid,\n.cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n\n.cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n\n.cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--skeleton.cds--text-input:hover, .cds--skeleton.cds--text-input:focus, .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n\n.cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n\n.cds--text-input__divider,\n.cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n\n.cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n\n.cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n\n.cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n\n.cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n\n.cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n\n.cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n\n.cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n\n.cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n\n.cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\n.cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid:has(~ .cds--slug),\n.cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid ~ .cds--slug,\n.cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n\n.cds--tag {\n  --cds-layout-size-height-xs: 1.125rem;\n  --cds-layout-size-height-sm: 1.125rem;\n  --cds-layout-size-height-md: 1.5rem;\n  --cds-layout-size-height-lg: 2rem;\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 1rem;\n  margin: 0.25rem;\n  cursor: default;\n  max-inline-size: 13rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  min-inline-size: 2rem;\n  padding-inline: 0.5rem;\n  vertical-align: middle;\n  word-break: break-word;\n}\n.cds--layout--size-xs .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-xs);\n}\n.cds--layout--size-sm .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--tag.cds--tag--operational {\n  border: 1px solid var(--cds-tag-background-gray, #e0e0e0);\n}\n.cds--tag.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag.cds--tag--lg {\n  padding-inline-start: 0.75rem;\n}\n.cds--tag:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.25rem;\n}\n.cds--tag.cds--tag--lg:not(.cds--tag--filter) {\n  padding-inline: 0.75rem;\n}\n.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.5rem;\n}\n.cds--tag:not(.cds--tag--selectable) {\n  border: 0;\n}\n.cds--tag:not(:first-child) {\n  margin-inline-start: 0;\n}\n\n.cds--tag--operational > span,\n.cds--tag--selectable > span,\n.cds--tag__label {\n  display: block;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--tag--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--filter {\n  padding-block-end: 0;\n  padding-block-start: 0;\n  padding-inline-end: 0;\n}\n.cds--tag--filter:hover {\n  outline: none;\n}\n\n.cds--tag--selectable {\n  border: 1px solid var(--cds-border-inverse, #161616);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--tag--selectable:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--tag--selectable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--selectable-selected {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--selectable-selected:hover {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  cursor: pointer;\n}\n.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n  outline: none;\n}\n.cds--tag--operational:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--red {\n  background-color: var(--cds-tag-background-red, #ffd7d9);\n  color: var(--cds-tag-color-red, #a2191f);\n}\n.cds--tag--red.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-red, #ff8389);\n}\n.cds--tag--red.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n.cds--tag--red .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n\n.cds--tag--magenta {\n  background-color: var(--cds-tag-background-magenta, #ffd6e8);\n  color: var(--cds-tag-color-magenta, #9f1853);\n}\n.cds--tag--magenta.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-magenta, #ff7eb6);\n}\n.cds--tag--magenta.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n.cds--tag--magenta .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n\n.cds--tag--purple {\n  background-color: var(--cds-tag-background-purple, #e8daff);\n  color: var(--cds-tag-color-purple, #6929c4);\n}\n.cds--tag--purple.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-purple, #be95ff);\n}\n.cds--tag--purple.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n.cds--tag--purple .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n\n.cds--tag--blue {\n  background-color: var(--cds-tag-background-blue, #d0e2ff);\n  color: var(--cds-tag-color-blue, #0043ce);\n}\n.cds--tag--blue.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-blue, #78a9ff);\n}\n.cds--tag--blue.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n.cds--tag--blue .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n\n.cds--tag--cyan {\n  background-color: var(--cds-tag-background-cyan, #bae6ff);\n  color: var(--cds-tag-color-cyan, #00539a);\n}\n.cds--tag--cyan.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cyan, #33b1ff);\n}\n.cds--tag--cyan.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n.cds--tag--cyan .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n\n.cds--tag--teal {\n  background-color: var(--cds-tag-background-teal, #9ef0f0);\n  color: var(--cds-tag-color-teal, #005d5d);\n}\n.cds--tag--teal.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-teal, #08bdba);\n}\n.cds--tag--teal.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n.cds--tag--teal .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n\n.cds--tag--green {\n  background-color: var(--cds-tag-background-green, #a7f0ba);\n  color: var(--cds-tag-color-green, #0e6027);\n}\n.cds--tag--green.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-green, #42be65);\n}\n.cds--tag--green.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n.cds--tag--green .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n\n.cds--tag--gray {\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n}\n.cds--tag--gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n}\n.cds--tag--gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag--gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n\n.cds--tag--cool-gray {\n  background-color: var(--cds-tag-background-cool-gray, #dde1e6);\n  color: var(--cds-tag-color-cool-gray, #121619);\n}\n.cds--tag--cool-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cool-gray, #a2a9b0);\n}\n.cds--tag--cool-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n.cds--tag--cool-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n\n.cds--tag--warm-gray {\n  background-color: var(--cds-tag-background-warm-gray, #e5e0df);\n  color: var(--cds-tag-color-warm-gray, #171414);\n}\n.cds--tag--warm-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-warm-gray, #ada8a8);\n}\n.cds--tag--warm-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n.cds--tag--warm-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n\n.cds--tag--high-contrast:not(.cds--tag--operational) {\n  background-color: var(--cds-background-inverse, #393939);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational {\n  border: 1px solid var(--cds-background-inverse, #393939);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  outline: 1px solid var(--cds-background-inverse, #393939);\n  outline-offset: -1px;\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational {\n  border: 1px solid var(--cds-background, #ffffff);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--tag--disabled:not(.cds--tag--operational),\n.cds--tag--filter.cds--tag--disabled,\n.cds--tag--interactive.cds--tag--disabled {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  box-shadow: none;\n  outline: none;\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational {\n  border: 1px solid var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational):hover,\n.cds--tag--filter.cds--tag--disabled:hover,\n.cds--tag--interactive.cds--tag--disabled:hover {\n  cursor: not-allowed;\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,\n.cds--tag--filter.cds--tag--disabled .cds--tag__label,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__label {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--selectable.cds--tag--disabled,\n.cds--tag--operational.cds--tag--disabled {\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--tag--selectable.cds--tag--disabled:hover,\n.cds--tag--operational.cds--tag--disabled:hover {\n  background-color: var(--cds-layer);\n  cursor: not-allowed;\n}\n\n.cds--tag--interactive {\n  transition: background-color 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--tag__close-icon {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: 50%;\n  margin: 0 0 0 0.125rem;\n  background-color: transparent;\n  block-size: var(--cds-layout-size-height-local);\n  color: currentColor;\n  cursor: pointer;\n  inline-size: var(--cds-layout-size-height-local);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tag__close-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag__custom-icon {\n  flex-shrink: 0;\n  padding: 0;\n  border: 0;\n  background-color: transparent;\n  block-size: 1rem;\n  color: currentColor;\n  inline-size: 1rem;\n  margin-inline-end: 0.25rem;\n  outline: none;\n}\n.cds--tag__custom-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag--disabled .cds--tag__close-icon {\n  cursor: not-allowed;\n}\n\n.cds--tag__close-icon:focus {\n  z-index: 99999;\n  border-radius: 50%;\n  box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--tag--high-contrast .cds--tag__close-icon:focus {\n  box-shadow: inset 0 0 0 1px var(--cds-focus-inverse, #ffffff);\n}\n\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: transparent;\n}\n\n.cds--tag--filter.cds--tag--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--sm.cds--tag--filter {\n  padding-inline-end: 0;\n}\n\n.cds--tag--sm .cds--tag__close-icon {\n  margin-inline-start: 0.3125rem;\n}\n\n.cds--tag.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n  color: var(--cds-text-primary, #161616);\n  overflow: hidden;\n  inline-size: 3.75rem;\n}\n.cds--tag.cds--skeleton:hover, .cds--tag.cds--skeleton:focus, .cds--tag.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--tag.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--tag.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--tag.cds--skeleton.cds--tag--operational {\n  border: 1px solid var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton.cds--tag--operational:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton .cds--tag__close-icon:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n@media not all and (min-resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tag.cds--skeleton {\n      transform: translateZ(0);\n    }\n  }\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline {\n  color: currentColor;\n  margin-inline-start: 0.0625rem;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before {\n  background-color: currentColor;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline:hover {\n  border-color: currentColor;\n}\n\n/* stylelint-disable */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon svg,\n  .cds--tag__custom-icon svg {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n.cds--tag-label-tooltip {\n  max-inline-size: -webkit-fill-available;\n}\n\n.cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 11rem;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 9.875rem;\n}\n\n/* stylelint-enable */\n.cds--interactive--tag-children {\n  display: inline-flex;\n  max-inline-size: 12.5rem;\n  place-items: center;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + span > .cds--interactive--tag-children {\n  max-inline-size: 11.5rem;\n}\n\n.cds--tag .cds--definition-term {\n  border-block-end: none;\n  cursor: default;\n  max-inline-size: 12rem;\n}\n\n.cds--tag .cds--tag__custom-icon + span > .cds--definition-term {\n  max-inline-size: 11rem;\n}\n\n.cds--tag > .cds--popover-container {\n  display: flex;\n}\n\n.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled) {\n  pointer-events: none;\n}\n\n.cds--list-box__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0.25rem;\n  grid-template: auto auto/auto auto;\n}\n.cds--list-box__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--list-box__wrapper--inline .cds--label,\n.cds--list-box__wrapper--inline .cds--form__helper-text,\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--list-box__wrapper--inline .cds--form__helper-text {\n  max-inline-size: none;\n}\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--list-box {\n  position: relative;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  max-block-size: 2.5rem;\n  transition: all 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box html {\n  font-size: 100%;\n}\n.cds--list-box body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--list-box code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--list-box strong {\n  font-weight: 600;\n}\n.cds--list-box:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--list-box--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box--expanded:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--expanded:hover.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box .cds--text-input {\n  block-size: 100%;\n  min-inline-size: 0;\n}\n\n.cds--list-box__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--list-box__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--list-box.cds--list-box--warning .cds--list-box__field {\n  border-block-end: 0;\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field,\n.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--list-box--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--list-box--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--light .cds--list-box__menu {\n  background: var(--cds-layer);\n}\n\n.cds--list-box--light .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle);\n}\n\n.cds--list-box--light.cds--list-box--expanded {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box--disabled:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--light.cds--list-box--disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__field:focus {\n  border-block-end-color: transparent;\n  outline: none;\n}\n\n.cds--list-box--disabled .cds--list-box__label,\n.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled .cds--list-box__menu-icon > svg,\n.cds--list-box--disabled .cds--list-box__selection > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item,\n.cds--list-box--disabled .cds--list-box__menu-item:hover,\n.cds--list-box--disabled .cds--list-box__menu-item--highlighted {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  text-decoration: none;\n}\n\n.cds--list-box--disabled .cds--list-box__selection:hover {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 2rem;\n}\n\n.cds--list-box.cds--list-box--inline {\n  border-width: 0;\n  background-color: transparent;\n}\n.cds--list-box.cds--list-box--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded {\n  border-block-end-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true] {\n  border-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover,\n.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover {\n  background-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__field {\n  padding: 0 2rem 0 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--inline .cds--list-box__field {\n  block-size: 100%;\n}\n\n.cds--dropdown--inline .cds--list-box__field {\n  max-inline-size: 30rem;\n}\n\n.cds--dropdown--inline .cds--list-box__menu {\n  max-inline-size: 30rem;\n  min-inline-size: 18rem;\n}\n\n.cds--list-box__field {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  overflow: hidden;\n  align-items: center;\n  block-size: calc(100% + 1px);\n  cursor: pointer;\n  outline: none;\n  padding-block: 0;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  vertical-align: top;\n  white-space: nowrap;\n}\n.cds--list-box__field *,\n.cds--list-box__field *::before,\n.cds--list-box__field *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__field::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__field:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__field:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__field[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--list-box__field .cds--text-input {\n  padding-inline-end: 5rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input,\n.cds--list-box--warning .cds--list-box__field .cds--text-input {\n  padding-inline-end: 6.5625rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon {\n  inset-inline-end: 5.125rem;\n}\n\n.cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--list-box__label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  overflow: hidden;\n  color: var(--cds-text-primary, #161616);\n  text-overflow: ellipsis;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n}\n\n.cds--list-box__menu-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-inline-end: 0.75rem;\n  outline: none;\n  transition: transform 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu-icon *,\n.cds--list-box__menu-icon *::before,\n.cds--list-box__menu-icon *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-icon::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__menu-icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box__menu-icon--open {\n  justify-content: center;\n  inline-size: 1.5rem;\n  transform: rotate(180deg);\n}\n\n.cds--list-box__selection {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-block-start: 50%;\n  /* to preserve .5rem space between icons according to spec top/transform used to center the combobox clear selection icon in IE11 */\n  inset-inline-end: 2.8125rem;\n  transform: translateY(-50%);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__selection *,\n.cds--list-box__selection *::before,\n.cds--list-box__selection *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__selection::-moz-focus-inner {\n  border: 0;\n}\n.cds--list-box__selection:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__selection:focus:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__selection > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__selection:focus {\n  outline: none;\n}\n\n.cds--list-box__selection--multi {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  position: static;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding: 0.5rem;\n  border-radius: 0.75rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: 1.5rem;\n  color: var(--cds-text-inverse, #ffffff);\n  inline-size: auto;\n  inset-block-start: auto;\n  line-height: 0;\n  margin-inline-end: 0.625rem;\n  padding-inline-end: 0.125rem;\n  transform: none;\n}\n\n.cds--list-box__selection--multi > svg {\n  padding: 0.125rem;\n  block-size: 1.25rem;\n  fill: var(--cds-icon-inverse, #ffffff);\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n.cds--list-box__selection--multi > svg:hover {\n  border-radius: 50%;\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n\n.cds--list-box--disabled .cds--list-box__selection--multi {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  color: var(--cds-layer);\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational {\n  border: 1px solid var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg:hover {\n  background-color: initial;\n}\n\n.cds--list-box__selection--multi:hover {\n  outline: none;\n}\n\n.cds--list-box__menu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  position: absolute;\n  z-index: 9100;\n  display: none;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu {\n  display: none;\n  max-block-size: 0;\n  visibility: hidden;\n}\n\n.cds--list-box--expanded .cds--list-box__menu {\n  display: block;\n  max-block-size: 13.75rem;\n}\n\n.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu {\n  max-block-size: 16.5rem;\n}\n\n.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu {\n  max-block-size: 11rem;\n}\n\n.cds--list-box__menu-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  block-size: 2.5rem;\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  transition: background 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--light .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item {\n  block-size: 2rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item {\n  block-size: 3rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover {\n  background-color: transparent;\n}\n\n.cds--list-box--light .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item:hover .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item__option {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-end: 1px solid transparent;\n  border-block-start: 1px solid transparent;\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  padding-inline-end: 1.5rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  transition: border-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  white-space: nowrap;\n}\n.cds--list-box__menu-item__option *,\n.cds--list-box__menu-item__option *::before,\n.cds--list-box__menu-item__option *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-item__option:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  border-color: transparent;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item__option:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__menu-item__option:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item__option {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item__option {\n  block-size: 3rem;\n  padding-block-end: 0.9375rem;\n  padding-block-start: 0.9375rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,\n.cds--list-box--disabled .cds--list-box__menu-item__option {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled],\n.cds--list-box__menu-item[disabled] *,\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  outline: none;\n}\n\n.cds--list-box__menu-item[disabled]:hover {\n  background-color: revert;\n}\n\n.cds--list-box__menu-item[disabled] .cds--checkbox-label::before {\n  border-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-two .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-three .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option {\n  margin: 0 0.5rem;\n}\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus {\n  margin: 0;\n  padding-inline-end: 0.5rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--list-box__menu-item--highlighted {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item--highlighted {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,\n.cds--list-box__menu-item--highlighted + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--light .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n}\n\n.cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover);\n  border-block-end-color: var(--cds-layer-selected-hover);\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item > .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item__selected-icon {\n  position: absolute;\n  display: none;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box--inline .cds--list-box__menu-item__selected-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label {\n  inline-size: 100%;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label-text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--list-box--up .cds--list-box__menu {\n  inset-block-end: 2.5rem;\n}\n\n.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--sm .cds--list-box__menu {\n  inset-block-end: 2rem;\n}\n\n.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--lg .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n\n.cds--list-box input[role=combobox],\n.cds--list-box input[type=text] {\n  background-color: inherit;\n  min-inline-size: 0;\n  text-overflow: ellipsis;\n}\n\n.cds--list-box__wrapper--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 9px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after,\n.cds--list-box__wrapper--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box input[role=combobox] {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 8.8125rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning {\n  inset-inline-end: 5.1875rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before {\n  display: block;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug {\n  inset-inline-end: calc(4rem + 18px);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon {\n  inset-inline-end: 7.25rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field,\n  .cds--list-box__menu,\n  .cds--multi-select .cds--tag--filter {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field:focus,\n  .cds--multi-select .cds--tag__close-icon:focus,\n  .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-icon > svg,\n  .cds--list-box__selection > svg,\n  .cds--list-box__selection--multi > svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-start: 2.0625rem;\n}\n\n.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,\n.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-end: 2.0625rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--dropdown__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0 1.5rem;\n  grid-template: auto auto/auto min-content;\n}\n.cds--dropdown__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--dropdown__wrapper--inline .cds--label,\n.cds--dropdown__wrapper--inline .cds--form__helper-text,\n.cds--dropdown__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--dropdown__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--dropdown {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: relative;\n  display: block;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  list-style: none;\n  outline: 2px solid transparent;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--dropdown html {\n  font-size: 100%;\n}\n.cds--dropdown body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--dropdown code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--dropdown strong {\n  font-weight: 600;\n}\n.cds--dropdown:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--dropdown .cds--list-box__field {\n  text-align: start;\n}\n\n.cds--dropdown--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--dropdown--lg .cds--dropdown__arrow {\n  inset-block-start: 1rem;\n}\n\n.cds--dropdown--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--dropdown--sm .cds--dropdown__arrow {\n  inset-block-start: 0.5rem;\n}\n\n.cds--dropdown--open {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--dropdown--open .cds--list-box__field {\n  outline: none;\n}\n\n.cds--dropdown--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--dropdown--invalid .cds--dropdown-text {\n  padding-inline-end: 3.5rem;\n}\n.cds--dropdown--invalid + .cds--form-requirement {\n  display: inline-block;\n  color: var(--cds-text-error, #da1e28);\n  max-block-size: 12.5rem;\n}\n\n.cds--dropdown__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--dropdown--open:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--dropdown--open:focus {\n  outline: 1px solid transparent;\n}\n\n.cds--dropdown--open .cds--dropdown-list {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  max-block-size: 13.75rem;\n  transition: max-height 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--dropdown--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--dropdown--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--dropdown--up .cds--dropdown-list {\n  inset-block-end: 2rem;\n}\n\n.cds--dropdown__arrow {\n  position: absolute;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0.8125rem;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n  transform-origin: 50% 45%;\n  transition: transform 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\nbutton.cds--dropdown-text {\n  border: none;\n  background: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  text-align: start;\n}\nbutton.cds--dropdown-text:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  button.cds--dropdown-text:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-text {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: block;\n  overflow: hidden;\n  block-size: calc(100% + 1px);\n  padding-inline-end: 2.625rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--dropdown-list {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: absolute;\n  z-index: 9100;\n  display: flex;\n  flex-direction: column;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  list-style: none;\n  max-block-size: 0;\n  overflow-x: hidden;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--dropdown-list html {\n  font-size: 100%;\n}\n.cds--dropdown-list body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--dropdown-list code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--dropdown-list strong {\n  font-weight: 600;\n}\n\n.cds--dropdown--light .cds--dropdown-list {\n  background-color: var(--cds-layer);\n}\n\n.cds--dropdown:not(.cds--dropdown--open) .cds--dropdown-item {\n  visibility: hidden;\n}\n\n.cds--dropdown-item {\n  position: relative;\n  opacity: 0;\n  transition: visibility 70ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9), background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n.cds--dropdown-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--dropdown-item:hover + .cds--dropdown-item .cds--dropdown-link {\n  border-color: transparent;\n}\n.cds--dropdown-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--dropdown-item:first-of-type .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n\n.cds--dropdown-item:last-of-type .cds--dropdown-link {\n  border-block-end: none;\n}\n\n.cds--dropdown-link {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  border: 1px solid transparent;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-start-color: var(--cds-border-subtle);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n.cds--dropdown-link:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--dropdown--light .cds--dropdown-link {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--dropdown--sm .cds--dropdown-link {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--dropdown--focused,\n.cds--dropdown-link:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown--focused,\n  .cds--dropdown-link:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown-link:focus {\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  outline: none;\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown-item:active {\n  background-color: inherit;\n}\n\n.cds--dropdown-item:hover .cds--dropdown-link {\n  border-block-end-color: var(--cds-layer-hover);\n}\n\n.cds--dropdown--open .cds--dropdown__arrow {\n  transform: rotate(-180deg);\n}\n\n.cds--dropdown--open.cds--dropdown--sm .cds--dropdown-list {\n  max-block-size: 11rem;\n}\n\n.cds--dropdown--open .cds--dropdown-item {\n  opacity: 1;\n}\n\n.cds--dropdown--disabled {\n  border-block-end-color: transparent;\n}\n.cds--dropdown--disabled:hover {\n  background-color: var(--cds-field);\n}\n.cds--dropdown--disabled:focus {\n  outline: none;\n}\n.cds--dropdown--disabled .cds--dropdown-text,\n.cds--dropdown--disabled .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--dropdown--disabled .cds--dropdown__arrow,\n.cds--dropdown--disabled .cds--list-box__menu-icon svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--dropdown--disabled.cds--dropdown--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--dropdown--disabled .cds--list-box__field,\n.cds--dropdown--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--dropdown--auto-width {\n  inline-size: auto;\n  max-inline-size: 25rem;\n}\n\n.cds--dropdown--inline {\n  display: inline-block;\n  background-color: transparent;\n  border-block-end-color: transparent;\n  inline-size: auto;\n  justify-self: start;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n.cds--dropdown--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--dropdown--inline.cds--dropdown--disabled {\n  background-color: transparent;\n}\n.cds--dropdown--inline .cds--dropdown__arrow {\n  inset-block-start: 0.5rem;\n  inset-inline-end: 0.5rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--open {\n  background-color: transparent;\n}\n\n.cds--dropdown--inline .cds--dropdown-text {\n  display: inline-block;\n  overflow: visible;\n  padding: 0.4375rem 2rem 0.4375rem 0.75rem;\n  block-size: 2rem;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--dropdown--inline.cds--dropdown--disabled .cds--dropdown-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--dropdown--inline.cds--dropdown--disabled:focus .cds--dropdown-text {\n  outline: 0;\n}\n\n.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown-text {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--open:focus .cds--dropdown-list {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n}\n\n.cds--dropdown--inline .cds--dropdown-link {\n  font-weight: normal;\n}\n\n.cds--dropdown--show-selected .cds--dropdown--selected {\n  display: block;\n  background-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--dropdown--show-selected .cds--dropdown--selected:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n.cds--dropdown--show-selected .cds--dropdown--selected .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n.cds--dropdown--show-selected .cds--dropdown--selected + .cds--dropdown-item .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n.cds--dropdown--show-selected .cds--dropdown--selected .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--dropdown-v2.cds--skeleton,\n.cds--dropdown.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--dropdown-v2.cds--skeleton:hover, .cds--dropdown-v2.cds--skeleton:focus, .cds--dropdown-v2.cds--skeleton:active,\n.cds--dropdown.cds--skeleton:hover,\n.cds--dropdown.cds--skeleton:focus,\n.cds--dropdown.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--dropdown-v2.cds--skeleton::before,\n.cds--dropdown.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--dropdown-v2.cds--skeleton::before,\n  .cds--dropdown.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--dropdown .cds--list-box__field {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-item__option {\n    outline: none;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-item__selected-icon {\n    fill: ButtonText;\n  }\n}\n\n.cds--dropdown--readonly,\n.cds--dropdown--readonly:hover {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--dropdown--inline.cds--dropdown--readonly {\n  border-block-end-color: transparent;\n}\n\n.cds--dropdown--readonly .cds--list-box__field,\n.cds--dropdown--readonly .cds--list-box__menu-icon {\n  cursor: default;\n}\n\n.cds--dropdown--readonly .cds--list-box__menu-icon svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--select *,\n.cds--select *::before,\n.cds--select *::after {\n  box-sizing: inherit;\n}\n\n.cds--select-input__wrapper {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--select-input {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  border: none;\n  border-radius: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  font-family: inherit;\n  inline-size: 100%;\n  opacity: 1;\n  padding-block: 0;\n  padding-inline: 1rem 3rem;\n  text-overflow: ellipsis;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select-input::-ms-expand {\n  display: none;\n}\n@-moz-document url-prefix() {\n  .cds--select-input:-moz-focusring, .cds--select-input::-moz-focus-inner {\n    background-image: none;\n    color: transparent;\n    text-shadow: 0 0 0 #000000;\n  }\n}\n.cds--select-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--select-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--select-input:disabled, .cds--select-input:hover:disabled {\n  background-color: var(--cds-field);\n  border-block-end-color: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select-input--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--select-input--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--select--disabled .cds--label,\n.cds--select--disabled .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input,\n.cds--select--warning .cds--select-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--select-input:disabled ~ .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--light .cds--select-input {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--select--light .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select--light .cds--select-input:disabled, .cds--select--light .cds--select-input:hover:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select__arrow {\n  position: absolute;\n  block-size: 100%;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--select__arrow path {\n    fill: ButtonText;\n  }\n}\n\n.cds--select__invalid-icon {\n  position: absolute;\n  inset-inline-end: 2.5rem;\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon {\n  fill: var(--cds-support-error, #da1e28);\n}\n\n.cds--select__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--select__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\noptgroup.cds--select-optgroup,\n.cds--select-option {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\noptgroup.cds--select-optgroup:disabled,\n.cds--select-option:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--inline {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n\n.cds--select--inline.cds--select--invalid .cds--label,\n.cds--select--inline.cds--select--invalid .cds--form__helper-text {\n  align-self: flex-start;\n  margin-block-start: 0.8125rem;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-end: 0;\n  margin-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--label {\n  margin: 0 0.5rem 0 0;\n  white-space: nowrap;\n}\n\n.cds--select--inline .cds--select-input {\n  background-color: transparent;\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: auto;\n  padding-inline-end: 2rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--select-input:focus,\n.cds--select--inline .cds--select-input:focus option,\n.cds--select--inline .cds--select-input:focus optgroup {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.cds--select--inline .cds--select-input[disabled],\n.cds--select--inline .cds--select-input[disabled]:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--select--inline .cds--select__arrow {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--select--inline .cds--select-input:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--select--inline .cds--select-input:disabled ~ * {\n  cursor: not-allowed;\n}\n\n.cds--select--readonly .cds--select-input {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n  cursor: default;\n}\n\n.cds--select--readonly .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 2.5rem;\n  inline-size: 100%;\n}\n.cds--select.cds--skeleton:hover, .cds--select.cds--skeleton:focus, .cds--select.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--select.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--select.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--select.cds--skeleton .cds--select-input {\n  display: none;\n}\n\n.cds--select--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 8px + 1px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--select--slug .cds--slug::after,\n.cds--select--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--select--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--select--slug .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 4rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  padding-inline-end: 6rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before {\n  display: block;\n}\n\n.cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon,\n.cds--select--slug .cds--select-input__wrapper .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--select__arrow {\n    fill: ButtonText;\n  }\n}\n\n:host(c4d-search-with-typeahead-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-search-with-typeahead-item) span {\n  font-weight: 600;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead-item):hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n:host(c4d-search-with-typeahead-item):hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-highlight-class:not(:hover), :host(c4d-search-with-typeahead-item):focus, :host(c4d-search-with-typeahead-item):active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead-item):last-of-type .cds--container-class {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead-item) span {\n  white-space: pre;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle] {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  color: var(--cds-text-helper, #6f6f6f);\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:active {\n  outline: none;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:hover {\n  background: none;\n  cursor: auto;\n}\n:host(c4d-search-with-typeahead-item)[lastBeforeGroup] .cds--container-class {\n  border-block-end-color: var(--cds-toggle-off, #8d8d8d);\n}\n\n:host(c4d-search-with-typeahead-item[alternate]) {\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n}\n\n:host(c4d-scoped-search-dropdown),\n:host(c4d-scoped-search-dropdown-mobile) {\n  display: flex;\n  border-inline-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box {\n  block-size: 3rem;\n  max-block-size: none;\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__field:focus,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box__field:focus {\n  outline: none;\n}\n\n@media (max-width: 65.98rem) {\n  :host(c4d-scoped-search-dropdown) {\n    display: none;\n  }\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__menu {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-scoped-search-dropdown-mobile) {\n  inline-size: 3rem;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select-input {\n  padding: 0;\n  color: transparent;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select__arrow {\n  position: absolute;\n  inset-inline: 0;\n  margin-inline: auto;\n  text-align: center;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--form__helper-text {\n  inline-size: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-scoped-search-dropdown-mobile) {\n    display: none;\n  }\n}\n\n:host(c4d-top-nav),\n.cds--header__search {\n  position: relative;\n  display: flex;\n  flex: 1;\n  align-items: center;\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav,\n.cds--header__search.cds--masthead__platform .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav::before,\n.cds--header__search.cds--masthead__platform .cds--header__nav::before {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--masthead__platform-name,\n.cds--header__search.cds--masthead__platform .cds--masthead__platform-name {\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active .cds--header__nav-container,\n.cds--header__search.cds--masthead__header--search-active .cds--header__nav-container {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n.cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n  .cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n    display: flex;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--header__search:not(.cds--masthead__header--search-active) {\n    overflow-x: visible;\n  }\n}\n\n.cds--header__action {\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border: 0.125rem solid transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__action > svg {\n  position: relative;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__action:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__action:focus, .cds--header__action:active {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__search--actions {\n  position: absolute;\n  display: flex;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--header__search--actions .cds--header__search--search,\n.cds--header__search--actions .cds--header__search--close {\n  padding: 0;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-icon-secondary, #525252);\n}\n.cds--header__search--actions .cds--header__search--search:hover,\n.cds--header__search--actions .cds--header__search--close:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__search--actions .cds--header__search--search:hover svg[focusable=false][aria-hidden=true],\n.cds--header__search--actions .cds--header__search--close:hover svg[focusable=false][aria-hidden=true] {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text, .cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text {\n  display: none;\n}\n\n.cds--header__profile .cds--header__action:focus,\n.cds--header__search--actions .cds--btn.cds--btn--icon-only.cds--tooltip__trigger:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\nbutton.cds--header__search--close.cds--header__action[part=close-button] {\n  display: none;\n  overflow: hidden;\n  border: none;\n  inline-size: 0;\n}\nbutton.cds--header__search--close.cds--header__action[part=close-button] svg {\n  position: relative;\n}\n\n.cds--header__search--search {\n  inline-size: 3rem;\n  outline: none;\n}\n\n:host(c4d-search-with-typeahead) {\n  position: relative;\n  display: block;\n  block-size: 3rem;\n  margin-inline-start: 3rem;\n  outline: none;\n}\n:host(c4d-search-with-typeahead) .c4d-ce__search__list {\n  overflow: hidden;\n  margin: 0;\n  block-size: 0;\n}\n:host(c4d-search-with-typeahead)[open] .c4d-ce__search__list {\n  padding: 0;\n  block-size: auto;\n}\n:host(c4d-search-with-typeahead)[active] {\n  z-index: 999;\n  inline-size: 100%;\n  margin-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action[part=close-button] {\n  display: inline-flex;\n  min-inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action.cds--header__search--hide {\n  display: none;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--actions {\n  z-index: 10001;\n}\n:host(c4d-search-with-typeahead)[active] .react-autosuggest__container::after {\n  position: absolute;\n  z-index: 10002;\n  display: block;\n  block-size: 0.125rem;\n  border-block-end: 0.125rem solid var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input {\n  z-index: 10000;\n  display: flex;\n  flex: 1;\n  padding: 0 1rem;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close {\n  display: inline-flex;\n  inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search {\n  border: 0.125rem solid transparent;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close:focus, :host(c4d-search-with-typeahead)[active] .cds--header__search--close:active,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:focus,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:active {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__action {\n  background-color: var(--cds-layer-01, #f4f4f4);\n  transition-delay: 380ms;\n  transition-duration: 112ms;\n  transition-property: width;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-search-with-typeahead)[scope-value] .react-autosuggest__suggestions-container {\n    inline-size: calc(100% - 3rem);\n    inset-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] {\n    background: var(--cds-layer-01, #f4f4f4);\n    inset-block-start: 0;\n    outline: 0.125rem solid transparent;\n    transition: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n    border-block-end: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n    outline: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n    display: flex;\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n    inline-size: 100%;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n    position: absolute;\n    z-index: 2;\n    fill: var(--cds-icon-secondary, #525252);\n    inset-block-start: 50%;\n    inset-inline-start: 1rem;\n    pointer-events: none;\n    transform: translateY(-50%);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n    content: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: calc(3rem + 2px);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n    border-block-end: none;\n    color: var(--cds-text-primary, #161616);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] {\n  background: var(--cds-layer-01, #f4f4f4);\n  inset-block-start: 0;\n  outline: 0.125rem solid transparent;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), top 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n  outline: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n  display: flex;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  inline-size: 100%;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n  position: absolute;\n  z-index: 2;\n  fill: var(--cds-icon-secondary, #525252);\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n  content: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n  inset-block-start: calc(3rem + 2px);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n  inset-block-start: 3.125rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[sticky-search] {\n  inset-block-start: 5rem;\n}\n:host(c4d-search-with-typeahead)[theme-sticky] {\n  inset-block-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 2rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 3rem;\n  }\n}\n\n.react-autosuggest__container {\n  position: relative;\n  display: flex;\n  justify-content: flex-end;\n  block-size: 3rem;\n}\n\n.react-autosuggest__suggestions-container {\n  position: absolute;\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inline-size: 100%;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  max-block-size: 80vh;\n  overflow-y: auto;\n}\n\n.react-autosuggest__suggestions-list {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.react-autosuggest__section-title {\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: solid 1px var(--cds-layer-01, #f4f4f4);\n  border-block-start: solid 1px var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-secondary, #525252);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.react-autosuggest__suggestion, :host(c4d-masthead-search-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n.react-autosuggest__suggestion span, :host(c4d-masthead-search-item) span {\n  font-weight: 600;\n}\n.react-autosuggest__suggestion .cds--container-class, :host(c4d-masthead-search-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n.react-autosuggest__suggestion .cds--container-class:focus, :host(c4d-masthead-search-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .react-autosuggest__suggestion:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n.react-autosuggest__suggestion:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n.react-autosuggest__suggestion .cds--container-highlight-class:not(:hover), :host(c4d-masthead-search-item) .cds--container-highlight-class:not(:hover), .react-autosuggest__suggestion:focus, .react-autosuggest__suggestion:active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.react-autosuggest__suggestion:last-of-type .cds--container-class {\n  border-block-end: none;\n}\n\n.cds--header__search--input {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  padding: 0;\n  border: none;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  font-size: 1rem;\n  inline-size: 0;\n  line-height: 1.375rem;\n  transition: 120ms;\n}\n.cds--header__search--input::-moz-placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n.cds--header__search--input::placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * This locks the scroll on the body element when the megamenu is expanded.\n * When using the megamenu web component, adopters will need to load this file in their application for\n * the scroll locking to work.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n* {\n  box-sizing: border-box;\n}\n\n:host(c4d-masthead-composite),\n:host(c4d-masthead-container) {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n  position: relative;\n  z-index: 900;\n  display: block;\n  padding-block-start: 3rem;\n}\n\n.cds--masthead,\n:host(c4d-masthead) {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  position: fixed;\n  z-index: 99;\n  background-color: var(--cds-background, #ffffff);\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transition-delay: 200ms;\n  transition-duration: 300ms;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--masthead[with-banner],\n:host(c4d-masthead)[with-banner] {\n  inset-block-start: 10rem;\n}\n.cds--masthead[has-l1],\n:host(c4d-masthead)[has-l1] {\n  --c4d-active-l0-border-color: var(--cds-layer-accent-01, #e0e0e0);\n}\n.cds--masthead ::slotted([slot=profile]),\n:host(c4d-masthead) ::slotted([slot=profile]) {\n  background-color: var(--cds-background, #ffffff);\n}\n\n:host(c4d-megamenu-overlay),\n.cds--masthead__overlay {\n  position: fixed;\n  z-index: -1;\n  background-color: none;\n  block-size: 100%;\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), visibility 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  visibility: hidden;\n}\n\n:host(c4d-megamenu-overlay)[active],\n.cds--masthead__overlay-show {\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  opacity: 1;\n  visibility: visible;\n}\n\n.cds--masthead--sticky.cds--masthead--sticky__l1 {\n  inset-block-start: -98px;\n}\n@media (min-width: 800px) {\n  .cds--masthead--sticky.cds--masthead--sticky__l1 {\n    inset-block-start: -3rem;\n  }\n}\n\n.cds--masthead--sticky__l1 + .cds--dotcom-shell .cds--tableofcontents__sidebar {\n  inset-block-start: 98px;\n}\n\n.cds--masthead--sticky__l1.cds--masthead--sticky + .cds--dotcom-shell .cds--tableofcontents__sidebar {\n  inset-block-start: 0;\n}\n@media (min-width: 800px) {\n  .cds--masthead--sticky__l1.cds--masthead--sticky + .cds--dotcom-shell .cds--tableofcontents__sidebar {\n    inset-block-start: 3rem;\n  }\n}\n\n.cds--masthead__l0 {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: relative;\n  background: var(--cds-background, #ffffff);\n}\n.cds--masthead__l0::after {\n  position: absolute;\n  background-color: var(--cds-layer-accent-01, #e0e0e0);\n  block-size: 1px;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-end: -1px;\n  inset-inline-start: 0;\n}\n\n.cds--header,\n.cds--masthead__l0 cds-header {\n  position: relative;\n  z-index: 5999;\n  border: none;\n  background: var(--cds-background, #ffffff);\n  margin-block-end: 1px;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--header::before,\n.cds--masthead__l0 cds-header::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  content: \"\";\n  inset-inline: calc(-50vw + 50%) 100%;\n}\n.cds--header::after,\n.cds--masthead__l0 cds-header::after {\n  position: absolute;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  content: \"\";\n  inset-inline: 100% calc(-50vw + 50%);\n}\n.cds--header .cds--header__menu-arrow,\n.cds--masthead__l0 cds-header .cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header .cds--header__menu-arrow:hover,\n.cds--masthead__l0 cds-header .cds--header__menu-arrow:hover {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--skip-to-content:focus {\n  block-size: 3.0625rem;\n}\n\n.cds--header__logo {\n  z-index: 2;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--header__logo a {\n    position: relative;\n    display: flex;\n    align-items: center;\n    padding: 0 2rem;\n    border: solid 0.125rem transparent;\n    block-size: 100%;\n    outline: none;\n    transition: none;\n  }\n  .cds--header__logo a:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--header__logo a:active, .cds--header__logo a:focus {\n    border-color: var(--cds-focus, #0f62fe);\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 99rem) {\n  .cds--header__logo a {\n    padding: 0 2.5rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (max-width: 81.98rem) {\n  .cds--header__logo a {\n    padding: 0 2rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (max-width: 65.98rem) {\n  .cds--header__logo a {\n    padding: 0 1rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--header__logo a svg {\n    block-size: 23px;\n    inline-size: 58px;\n  }\n  .cds--header__logo a svg g,\n  .cds--header__logo a svg path {\n    fill: var(--cds-layer-selected-inverse, #161616);\n    /* stylelint-disable-next-line media-feature-name-no-unknown */\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (prefers-contrast: more) {\n  .cds--header__logo a svg g,\n  .cds--header__logo a svg path {\n    fill: ButtonText;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 800px) {\n  .cds--header__logo a::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-layer-accent-01, #e0e0e0);\n    block-size: 1.5rem;\n    content: \"\";\n    inline-size: 0.0625rem;\n    inset-block-start: 50%;\n    inset-inline-end: -0.1875rem;\n    transform: translateY(-50%);\n  }\n}\n.cds--header__logo a {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 2rem;\n  border: solid 0.125rem transparent;\n  block-size: 100%;\n  outline: none;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n}\n.cds--header__logo a:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__logo a:active, .cds--header__logo a:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n@media (min-width: 99rem) {\n  .cds--header__logo a {\n    padding: 0 2.5rem;\n  }\n}\n@media (max-width: 81.98rem) {\n  .cds--header__logo a {\n    padding: 0 2rem;\n  }\n}\n@media (max-width: 65.98rem) {\n  .cds--header__logo a {\n    padding: 0 1rem;\n  }\n}\n.cds--header__logo a svg {\n  block-size: 23px;\n  inline-size: 58px;\n}\n.cds--header__logo a svg g,\n.cds--header__logo a svg path {\n  fill: var(--cds-layer-selected-inverse, #161616);\n  /* stylelint-disable-next-line media-feature-name-no-unknown */\n}\n@media (prefers-contrast: more) {\n  .cds--header__logo a svg g,\n  .cds--header__logo a svg path {\n    fill: ButtonText;\n  }\n}\n@media (min-width: 800px) {\n  .cds--header__logo a::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-layer-accent-01, #e0e0e0);\n    block-size: 1.5rem;\n    content: \"\";\n    inline-size: 0.0625rem;\n    inset-block-start: 50%;\n    inset-inline-end: -0.1875rem;\n    transform: translateY(-50%);\n  }\n}\n.cds--header__logo .cds--tooltip__trigger.cds--tooltip__trigger--definition,\n.cds--header__logo .cds--tooltip--definition {\n  border: none;\n}\n.cds--header__logo .cds--tooltip__trigger.cds--tooltip__trigger--definition .cds--tooltip__trigger,\n.cds--header__logo .cds--tooltip--definition .cds--tooltip__trigger {\n  border: none;\n}\n.cds--header__logo .cds--tooltip__trigger.cds--tooltip__trigger--definition.cds--tooltip--a11y,\n.cds--header__logo .cds--tooltip--definition.cds--tooltip--a11y {\n  block-size: 100%;\n}\n.cds--header__logo.cds--search-active {\n  display: none;\n}\n@media (min-width: 42rem) {\n  .cds--header__logo.cds--search-active {\n    display: block;\n  }\n}\n\n.cds--header__global, :host(c4d-masthead-global-bar) {\n  flex: 0;\n}\n\n.cds--header__nav-container {\n  position: relative;\n  display: flex;\n  flex: 1;\n  block-size: 100%;\n  overflow-x: visible;\n}\n\n/* Set to zero-slecificity so it can be overridden by dynamic stylesheet */\n/* stylelint-disable-next-line selector-pseudo-class-no-unknown */\n:where(.cds--header__nav-content) {\n  position: absolute;\n  block-size: 100%;\n  inset-inline-start: 0;\n  transition: inset 250ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--header__submenu .cds--text-truncate--end,\n:host(c4d-top-nav-menu-item) .cds--text-truncate--end {\n  white-space: normal;\n}\n\n:host(c4d-top-nav-item) a.cds--header__menu-item,\n:host(c4d-top-nav-menu) a.cds--header__menu-item,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item,\n.cds--header__nav a.cds--header__menu-item {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding: 0.8125rem 1rem;\n  border: none;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item > svg,\n.cds--header__nav a.cds--header__menu-item > svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n.cds--header__nav a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n.cds--header__nav a.cds--header__menu-item:active {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active, :host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n.cds--header__nav a.cds--header__menu-item:active,\n.cds--header__nav a.cds--header__menu-item:hover {\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active > svg, :host(c4d-top-nav-item) a.cds--header__menu-item:hover > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover > svg,\n.cds--header__nav a.cds--header__menu-item:active > svg,\n.cds--header__nav a.cds--header__menu-item:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active, :host(c4d-top-nav-item) a.cds--header__menu-item:focus,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus,\n.cds--header__nav a.cds--header__menu-item:active,\n.cds--header__nav a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-button-primary, #0f62fe);\n  outline-offset: -2px;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:focus[data-selected=true], :host(c4d-top-nav-item) a.cds--header__menu-item:active[data-selected=true],\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus[data-selected=true],\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active[data-selected=true],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus[data-selected=true],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active[data-selected=true],\n.cds--header__nav a.cds--header__menu-item:focus[data-selected=true],\n.cds--header__nav a.cds--header__menu-item:active[data-selected=true] {\n  border-block-end-color: transparent;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:focus::after, :host(c4d-top-nav-item) a.cds--header__menu-item:active::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active::after,\n.cds--header__nav a.cds--header__menu-item:focus::after,\n.cds--header__nav a.cds--header__menu-item:active::after {\n  background-color: var(--cds-focus, #0f62fe);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false], :host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false],\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false],\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false],\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false],\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false] {\n  border-block-end-color: transparent;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after, :host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after,\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after,\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after {\n  background-color: var(--cds-focus, #0f62fe);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item[data-selected=true],\n:host(c4d-top-nav-menu) a.cds--header__menu-item[data-selected=true],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item[data-selected=true],\n.cds--header__nav a.cds--header__menu-item[data-selected=true] {\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item[data-selected=true]::after,\n:host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item[data-selected=true]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item[data-selected=true]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after,\n.cds--header__nav a.cds--header__menu-item[data-selected=true]::after,\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after {\n  position: absolute;\n  display: block;\n  box-sizing: border-box;\n  background-color: var(--c4d-active-l0-border-color, var(--cds-link-primary, #0f62fe));\n  block-size: 0.1875rem;\n  content: \"\";\n  inset-block-end: 0;\n  inset-inline: 0;\n}\n\n:host(c4d-top-nav-menu) a.cds--header__menu-item,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item {\n  padding: 0.8125rem 1rem 0.6875rem;\n  border-block-end: 0.125rem solid transparent;\n}\n\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true],\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] {\n  z-index: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  background-color: var(--cds-layer-02, #ffffff);\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inline-size: 16rem;\n  inset-block-end: -1px;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li {\n  position: relative;\n  block-size: 100%;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li::before {\n  position: absolute;\n  block-size: 100%;\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:first-of-type::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:first-of-type::before {\n  border-block-start: none;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover::before {\n  border-block-start: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover + li::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover + li::before {\n  border-block-start: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:focus::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:focus::before {\n  box-sizing: border-box;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item {\n  position: relative;\n  border: none;\n  block-size: 100%;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:focus::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:focus::before {\n  box-sizing: border-box;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item::before {\n  position: absolute;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-top-nav-menu) .cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-top-nav-menu) .cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inline-size: 100%;\n}\n:host(c4d-top-nav-menu)::before,\n.cds--header__nav::before {\n  display: none;\n}\n\n.cds--header__action {\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border: 0.125rem solid transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__action:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__action:focus, .cds--header__action:active {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__action > svg {\n  position: relative;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header__action .cds--overflow-menu {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--header__action .cds--overflow-menu.cds--overflow-menu--open {\n  box-shadow: none;\n  outline: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  outline-offset: 0;\n}\n.cds--header__action .cds--overflow-menu:hover {\n  background: none;\n}\n.cds--header__action .cds--overflow-menu:focus {\n  box-shadow: none;\n  outline: none;\n}\n\n.cds--sub-content-left {\n  position: absolute;\n  block-size: 100%;\n  inline-size: 1px;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--sub-content-right {\n  position: absolute;\n  block-size: 100%;\n  inline-size: 1px;\n  inset-block-start: 0;\n  inset-inline-end: 1px;\n}\n\n.cds--header__nav-caret-left,\n.cds--header__nav-caret-right {\n  position: absolute;\n  display: none;\n  border: none;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  inline-size: 2.5rem;\n  inset-block-start: 0;\n}\n.cds--header__nav-caret-left > svg,\n.cds--header__nav-caret-right > svg {\n  position: absolute;\n  fill: currentColor;\n  inset-block-start: 50%;\n  inset-inline-start: 50%;\n  transform: translateX(-50%) translateY(-50%);\n}\n.cds--header__nav-caret-left:hover,\n.cds--header__nav-caret-right:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__nav-caret-left:hover > svg,\n.cds--header__nav-caret-right:hover > svg {\n  fill: var(--cds-text-primary, #161616);\n}\n.cds--header__nav-caret-left:focus, .cds--header__nav-caret-left:active,\n.cds--header__nav-caret-right:focus,\n.cds--header__nav-caret-right:active {\n  display: block;\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  outline: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--header__nav-caret-left:focus::before, .cds--header__nav-caret-left:focus::after, .cds--header__nav-caret-left:active::before, .cds--header__nav-caret-left:active::after,\n.cds--header__nav-caret-right:focus::before,\n.cds--header__nav-caret-right:focus::after,\n.cds--header__nav-caret-right:active::before,\n.cds--header__nav-caret-right:active::after {\n  display: none;\n}\n@media (width >= 800px) {\n  .cds--header__nav-caret-left,\n  .cds--header__nav-caret-right {\n    display: block;\n  }\n}\n\n.cds--header__nav-caret-left-container[hidden],\n.cds--header__nav-caret-right-container[hidden] {\n  display: none;\n}\n\n.cds--header__nav-caret-left {\n  inset-inline-start: 0;\n}\n.cds--header__nav-caret-left::before {\n  position: absolute;\n  display: block;\n  background-color: #dcdcdc;\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__nav-caret-left-gradient {\n  position: absolute;\n  z-index: 1;\n  display: block;\n  background: linear-gradient(to right, var(--cds-background, #ffffff), rgba(255, 255, 255, 0));\n  block-size: 100%;\n  inline-size: 0.5rem;\n  inset-block-start: 0;\n  inset-inline-start: 2.5rem;\n}\n\n.cds--header__nav-caret-right {\n  inset-inline-end: 0;\n}\n.cds--header__nav-caret-right::after {\n  position: absolute;\n  display: block;\n  background-color: #dcdcdc;\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-end: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__nav-caret-right-gradient {\n  position: absolute;\n  display: block;\n  background: linear-gradient(to left, var(--cds-background, #ffffff), rgba(255, 255, 255, 0));\n  block-size: 100%;\n  inline-size: 0.5rem;\n  inset-block-start: 0;\n  inset-inline-end: 2.5rem;\n}\n\n.cds--header__action--active {\n  position: relative;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  z-index: 6001;\n  inset-block-start: 0;\n}\n\n.cds--header__menu li:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--header__menu li:last-of-type .cds--header__menu-item::after {\n  display: none;\n}\n.cds--header__menu .cds--header__menu-item {\n  position: relative;\n}\n\nbutton.cds--header__search--close.cds--header__action[part=close-button] {\n  display: none;\n  overflow: hidden;\n  border: none;\n  inline-size: 0;\n}\nbutton.cds--header__search--close.cds--header__action[part=close-button] svg {\n  position: relative;\n}\n\n.cds--header__search--search {\n  inline-size: 3rem;\n  outline: none;\n}\n\n.cds--overflow-menu-options {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: fixed;\n  z-index: 99999;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--overflow-menu-options:focus {\n  outline: none;\n}\n.cds--overflow-menu-options::after {\n  display: none;\n}\n\n.cds--overflow-menu-options__btn {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--overflow-menu-options__btn:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n\n.cds--overflow-menu-options__option {\n  block-size: 3rem;\n}\n.cds--overflow-menu-options__option:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n\n.cds--overflow-menu.cds--overflow-menu--open {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  box-shadow: none;\n}\n\n.cds--header__action.cds--overflow-menu {\n  block-size: 3rem;\n}\n\n@media (min-width: 800px) {\n  .cds--header__menu-toggle__hidden {\n    display: none;\n  }\n  .cds--header__nav {\n    display: block;\n  }\n}\n@media print {\n  :host(c4d-masthead),\n  .cds--masthead {\n    display: none;\n  }\n}\n.cds--masthead__l1,\n:host(c4d-masthead-l1) {\n  /* stylelint-disable-next-line length-zero-no-unit */\n  --page-width: calc(100vw - var(--scrollbar-width, 0px));\n  --grid-width: var(--page-width);\n  --column-width: var(--page-width);\n  --gutter-width: 1rem;\n  --column-width: calc(var(--grid-width) / 4);\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: relative;\n  overflow: visible;\n  background-color: var(--cds-layer-02, #ffffff);\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media (min-width: 42rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --grid-width: calc(var(--page-width) - 2rem);\n    --column-width: calc(var(--grid-width) / 8);\n  }\n}\n@media (min-width: 66rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --column-width: calc(var(--grid-width) / 16);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --grid-width: calc(99rem - 3rem);\n  }\n}\n\n@media screen and (width <= 799px) {\n  .cds--masthead__l1-inner-container {\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    background-color: transparent;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    color: var(--cds-text-primary, #161616);\n    gap: 1.5rem;\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-title:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--masthead__l1-title:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  .cds--masthead__l1-title:active, .cds--masthead__l1-title:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-title:disabled {\n    border-block-end-color: var(--cds-border-disabled, #c6c6c6);\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-title[active] {\n    border-block-end: 3px solid var(--cds-focus, #0f62fe);\n  }\n  .cds--masthead__l1-title.is-open svg {\n    transform: rotateX(180deg);\n  }\n  .cds--masthead__l1-title svg {\n    color: var(--cds-icon-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown {\n    position: absolute;\n    background-color: var(--cds-background, #ffffff);\n    color: var(--cds-text-secondary, #525252);\n    inset-block-start: 100%;\n    inset-inline: 0;\n    max-block-size: calc(100vh - 98px - 4rem - 3rem);\n    overflow-y: auto;\n  }\n  .cds--masthead__l1-dropdown.is-open {\n    box-shadow: 0 2px 6px 0 var(--cds-shadow, rgba(0, 0, 0, 0.3));\n    /* stylelint-disable-next-line declaration-no-important */\n    inline-size: 100vw !important;\n  }\n  .cds--masthead__l1-dropdown:not(.is-open) {\n    display: none;\n  }\n  .cds--masthead__l1-dropdown:last-child > a,\n  .cds--masthead__l1-dropdown:last-child > button {\n    border-block-end: initial;\n  }\n  .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    background-color: transparent;\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active, .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item:disabled {\n    border-block-end-color: var(--cds-border-disabled, #c6c6c6);\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-dropdown-item[active] {\n    position: relative;\n  }\n  .cds--masthead__l1-dropdown-item[active]::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-focus, #0f62fe);\n    content: \"\";\n    inline-size: 3px;\n    inset-block: 0;\n    inset-inline-start: 0;\n  }\n  .cds--masthead__l1-dropdown-item.is-open {\n    background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item.is-open svg {\n    color: var(--cds-icon-primary, #161616);\n    transform: rotateX(180deg);\n  }\n  .cds--masthead__l1-dropdown-item svg {\n    color: var(--cds-icon-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-subsection {\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 2rem;\n  }\n  .cds--masthead__l1-dropdown-subsection:not(.is-open) {\n    display: none;\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item {\n    border-block-end: none;\n    color: var(--cds-text-secondary, #525252);\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item:hover, .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item:active {\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-viewall {\n    margin-block-start: 2rem;\n  }\n  .cds--masthead__l1-dropdown-announcement {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem 0;\n    margin: 0 1rem 1rem;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-dropdown-heading {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading.cds--masthead__l1-dropdown-heading--no-link {\n    inline-size: 100%;\n    min-block-size: 2rem;\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    justify-content: flex-start;\n    color: inherit;\n    gap: 0.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item svg {\n    fill: var(--cds-icon-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading:not(:nth-of-type(1)) {\n    margin-block-start: 2rem;\n  }\n  .cds--masthead__l1-dropdown-viewall {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: flex-start;\n    padding: 1rem;\n    background-color: transparent;\n    gap: 0.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n  }\n  .cds--masthead__l1-dropdown-viewall:focus {\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active, .cds--masthead__l1-dropdown-viewall:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-login {\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    color: var(--cds-button-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-login:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-login svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown-login:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  .cds--masthead__l1-dropdown-login:focus-visible {\n    color: var(--cds-button-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-login:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-button-primary-active, #002d9c);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta {\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    background-color: var(--cds-background-brand, #0f62fe);\n    border-block-end: initial;\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta svg {\n    color: inherit;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:hover {\n    background-color: var(--cds-button-primary-hover, #0050e6);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:focus-visible {\n    outline-color: var(--cds-layer-02, #ffffff);\n    outline-offset: calc(-1 * 0.25rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:active {\n    background-color: var(--cds-button-primary-active, #002d9c);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:disabled {\n    background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n}\n@media screen and (width >= 800px) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    display: block;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-inner-container {\n    position: relative;\n    z-index: 1;\n    display: grid;\n    margin: 0 auto;\n    block-size: 4rem;\n    grid-template-areas: \"padding platform menu spacer login cta\";\n    grid-template-columns: 1rem auto minmax(1px, 1fr) 2.5rem auto auto;\n    inline-size: 100%;\n    max-inline-size: 98rem;\n  }\n  .cds--masthead__l1-inner-container > * {\n    position: relative;\n    z-index: 1;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask {\n    position: absolute;\n    z-index: 2;\n    display: block;\n    background-color: var(--cds-background, #ffffff);\n    content: \"\";\n    inset-block: 0;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask--start {\n    inset-inline: -50vw 100%;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask--end {\n    inset-inline: 100% -50vw;\n  }\n  .cds--masthead__l1-inner-container::before, .cds--masthead__l1-inner-container::after {\n    position: relative;\n    z-index: 1;\n    display: block;\n    background-color: var(--cds-background, #ffffff);\n    content: \"\";\n  }\n  .cds--masthead__l1-inner-container::before {\n    grid-area: padding;\n  }\n  .cds--masthead__l1-inner-container::after {\n    grid-area: spacer;\n  }\n  .cds--masthead__background-wrapper {\n    background-color: var(--cds-background, #ffffff);\n  }\n  .cds--masthead__l1-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background, #ffffff);\n    block-size: 100%;\n    border-block-end: 3px solid transparent;\n    color: var(--cds-text-primary, #161616);\n    grid-area: platform;\n    padding-block-end: calc(1rem - 0.125rem);\n  }\n  .cds--masthead__l1-title[active] {\n    border-block-end-color: var(--cds-focus, #0f62fe);\n  }\n  .cds--masthead__l1-title:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--masthead__l1-title:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  .cds--masthead__l1-title:active, .cds--masthead__l1-title:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-menu-container-outer {\n    z-index: 0;\n    display: flex;\n    grid-area: menu;\n  }\n  .cds--masthead__l1-menu-container-scroller {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    z-index: 1;\n    padding: 0;\n    background-color: var(--cds-background, #ffffff);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner {\n    display: inline-flex;\n    flex-shrink: 0;\n    align-items: flex-end;\n    padding: 1rem 0.5rem;\n    background-color: var(--cds-background, #ffffff);\n    block-size: 100%;\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:active, .cds--masthead__l1-menu-container-scroller-inner:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner[hidden] {\n    /* stylelint-disable-next-line declaration-no-important */\n    display: none !important;\n  }\n  .cds--masthead__l1-menu-container-inner {\n    z-index: 0;\n    flex-grow: 1;\n    flex-shrink: 1;\n    block-size: 100%;\n  }\n  .cds--masthead__l1-menu {\n    position: absolute;\n    display: flex;\n    block-size: 100%;\n    transition: translate 95ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  }\n  .cds--masthead__l1-menu > li {\n    position: relative;\n  }\n  .cds--masthead__l1-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-flex;\n    align-items: flex-end;\n    border: 1px solid transparent;\n    background-color: var(--cds-background, #ffffff);\n    border-block-start: none;\n    color: var(--cds-text-secondary, #525252);\n    white-space: nowrap;\n  }\n  .cds--masthead__l1-item[active]::after {\n    position: absolute;\n    background-color: var(--cds-focus, #0f62fe);\n    block-size: 3px;\n    content: \"\";\n    inset-block-end: 0;\n    inset-inline: 0;\n  }\n  .cds--masthead__l1-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-item:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-item:active, .cds--masthead__l1-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-item:is([disabled], .is-disabled) {\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-item.is-open {\n    border-color: #c6c6c6;\n    block-size: calc(100% + 3px);\n    box-shadow: 0 0 6px #c6c6c6;\n    clip-path: polygon(calc(0% - 6px) calc(0% - 6px), calc(100% + 6px) calc(0% - 6px), calc(100% + 6px) 100%, calc(0% - 6px) 100%);\n    padding-block-end: calc(1rem + 3px);\n  }\n  .cds--masthead__l1-item.is-open svg {\n    rotate: 180deg;\n  }\n  .cds--masthead__l1-item svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown {\n    position: absolute;\n    padding: 1rem 0 0;\n    border: 1px solid #c6c6c6;\n    background-color: var(--cds-background, #ffffff);\n    border-block-start: none;\n    box-shadow: 0 0 6px #c6c6c6;\n    clip-path: polygon(calc(0% - 6px) 0%, calc(100% + 6px) 0%, calc(100% + 6px) calc(100% + 6px), calc(0% - 6px) calc(100% + 6px));\n    inline-size: 320;\n    inset-block-start: calc(100% + 1px);\n    inset-inline-start: 0;\n    max-inline-size: calc(100vw - 2 * 1rem);\n    overflow-y: auto;\n    visibility: hidden;\n  }\n  .cds--masthead__l1-dropdown.is-open {\n    visibility: visible;\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__1-col {\n    inline-size: calc(2 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__2-col {\n    inline-size: calc(4 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__3-col {\n    inline-size: calc(6 * var(--column-width));\n  }\n}\n@media screen and (width >= 800px) and (width >= 66rem) {\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__1-col {\n    inline-size: calc(4 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__2-col {\n    inline-size: calc(8 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__3-col {\n    inline-size: calc(12 * var(--column-width));\n  }\n}\n@media screen and (width >= 800px) {\n  .cds--masthead__l1-dropdown-links {\n    -moz-column-rule: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n         column-rule: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 2.5rem;\n  }\n  .cds--masthead__l1-dropdown__2-col .cds--masthead__l1-dropdown-links {\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 0;\n         column-gap: 0;\n  }\n  .cds--masthead__l1-dropdown__3-col .cds--masthead__l1-dropdown-links {\n    -moz-column-count: 3;\n         column-count: 3;\n    -moz-column-gap: 0;\n         column-gap: 0;\n  }\n  .cds--masthead__l1-dropdown-links > * {\n    -moz-column-break-inside: avoid;\n         break-inside: avoid;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide {\n    display: grid;\n    grid-template-columns: repeat(3, 1fr);\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide .cds--masthead__l1-dropdown-column-wide {\n    grid-column: span 2;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide .cds--masthead__l1-dropdown-column-wide .cds--masthead__l1-dropdown-menu-items {\n    -moz-column-gap: 0;\n         column-gap: 0;\n    -moz-columns: 2;\n         columns: 2;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide > *:nth-child(2) {\n    border-inline-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-dropdown-announcement {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    margin: 0 1rem 1rem;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 1rem;\n  }\n  .cds--masthead__l1-dropdown-announcement :is(h1, h2, h3, h4, h5, h6, strong, b) {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  }\n  .cds--masthead__l1-dropdown-announcement :focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-menu-items {\n    padding-block-end: 1.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading {\n    font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n    font-weight: var(--cds-productive-heading-03-font-weight, 400);\n    line-height: var(--cds-productive-heading-03-line-height, 1.4);\n    letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n    font-weight: var(--cds-productive-heading-03-font-weight, 400);\n    line-height: var(--cds-productive-heading-03-line-height, 1.4);\n    letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    padding: 0.5rem 1rem;\n    color: inherit;\n    margin-block-end: 0.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item svg {\n    position: relative;\n    inset-block-end: 0.125rem;\n    margin-inline-start: 0.5rem;\n    vertical-align: middle;\n  }\n  .cds--masthead__l1-dropdown-heading.cds--masthead__l1-dropdown-heading--no-link {\n    padding: 0.5rem 1rem;\n    margin-block-end: 0.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading-desc {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: block;\n    padding: 0 1rem;\n    margin: calc(-1 * 0.5rem) 0 0.5rem;\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-block;\n    padding: 0.5rem 1rem;\n    color: var(--cds-text-secondary, #525252);\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-dropdown-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active {\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item:active, .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown-item .cds--masthead__l1-dropdown-item-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    display: block;\n  }\n  .cds--masthead__l1-dropdown-item .cds--masthead__l1-dropdown-item-description {\n    display: block;\n    color: var(--cds-text-secondary, #525252);\n    white-space: break-spaces;\n  }\n  .cds--masthead__l1-dropdown-viewall {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    align-content: center;\n    padding: 1rem;\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    color: var(--cds-link-primary, #0f62fe);\n    gap: 0.5rem;\n    text-decoration: none;\n  }\n  .cds--masthead__l1-dropdown-viewall:hover {\n    color: var(--cds-link-primary-hover, #0043ce);\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active, .cds--masthead__l1-dropdown-viewall:active:visited, .cds--masthead__l1-dropdown-viewall:active:visited:hover {\n    color: var(--cds-text-primary, #161616);\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-viewall:visited {\n    color: var(--cds-link-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-viewall:visited:hover {\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  :host(c4d-masthead-l1-cta) {\n    position: relative;\n    z-index: 1;\n    grid-area: cta;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background-brand, #0f62fe);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta svg {\n    color: inherit;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:hover {\n    background-color: var(--cds-button-primary-hover, #0050e6);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:focus-visible {\n    outline: 0.125rem solid var(--cds-layer-02, #ffffff);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:active {\n    background-color: var(--cds-button-primary-active, #002d9c);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:disabled {\n    background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta-inner {\n    display: inline-flex;\n    align-items: center;\n    gap: 0.5rem;\n  }\n  .cds--masthead__l1-login {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background, #ffffff);\n    color: var(--cds-button-primary, #0f62fe);\n    grid-area: login;\n  }\n  .cds--masthead__l1-login svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-login:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  .cds--masthead__l1-login:focus-visible {\n    color: var(--cds-button-primary, #0f62fe);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-login:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-button-primary-active, #002d9c);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n}\n:host(c4d-top-nav),\n.cds--header__search {\n  position: relative;\n  display: flex;\n  flex: 1;\n  align-items: center;\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav,\n.cds--header__search.cds--masthead__platform .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav::before,\n.cds--header__search.cds--masthead__platform .cds--header__nav::before {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--masthead__platform-name,\n.cds--header__search.cds--masthead__platform .cds--masthead__platform-name {\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n:host(c4d-top-nav) a.cds--header__name,\n.cds--header__search a.cds--header__name {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  position: relative;\n  z-index: 1;\n  border: solid 0.125rem transparent;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  padding-inline: 1rem;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n  white-space: nowrap;\n}\n@media (min-width: 66rem) {\n  :host(c4d-top-nav) a.cds--header__name,\n  .cds--header__search a.cds--header__name {\n    margin-inline-start: 1rem;\n  }\n}\n:host(c4d-top-nav) a.cds--header__name:hover,\n.cds--header__search a.cds--header__name:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-top-nav) a.cds--header__name:active, :host(c4d-top-nav) a.cds--header__name:focus,\n.cds--header__search a.cds--header__name:active,\n.cds--header__search a.cds--header__name:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav) a.cds--header__name::before,\n.cds--header__search a.cds--header__name::before {\n  position: absolute;\n  display: block;\n  background-color: #dcdcdc;\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: -0.875rem;\n  transform: translateY(-50%);\n}\n@media (max-width: 800px) {\n  :host(c4d-top-nav) a.cds--header__name,\n  .cds--header__search a.cds--header__name {\n    display: none;\n  }\n}\n:host(c4d-top-nav).cds--masthead__header--search-active .cds--header__nav-container,\n.cds--header__search.cds--masthead__header--search-active .cds--header__nav-container {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n.cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n  .cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n    display: flex;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--header__search:not(.cds--masthead__header--search-active) {\n    overflow-x: visible;\n  }\n}\n\n.cds--header__search--actions {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--header__search--actions .cds--header__search--search,\n.cds--header__search--actions .cds--header__search--close {\n  padding: 0;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-icon-secondary, #525252);\n}\n.cds--header__search--actions .cds--header__search--search:hover,\n.cds--header__search--actions .cds--header__search--close:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__search--actions .cds--header__search--search:hover svg[focusable=false][aria-hidden=true],\n.cds--header__search--actions .cds--header__search--close:hover svg[focusable=false][aria-hidden=true] {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text, .cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text {\n  display: none;\n}\n\n.cds--header__profile .cds--header__action:focus,\n.cds--header__search--actions .cds--btn.cds--btn--icon-only.cds--tooltip__trigger:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--masthead__search,\n:host(c4d-masthead-search) {\n  block-size: 3rem;\n  margin-inline-start: 3rem;\n}\n.cds--masthead__search.cds--masthead__search--active, .cds--masthead__search[active],\n:host(c4d-masthead-search).cds--masthead__search--active,\n:host(c4d-masthead-search)[active] {\n  z-index: 999;\n  inline-size: 100%;\n  margin-inline-start: 0;\n}\n.cds--masthead__search.cds--masthead__search--active button.cds--header__search--close.cds--header__action[part=close-button], .cds--masthead__search[active] button.cds--header__search--close.cds--header__action[part=close-button],\n:host(c4d-masthead-search).cds--masthead__search--active button.cds--header__search--close.cds--header__action[part=close-button],\n:host(c4d-masthead-search)[active] button.cds--header__search--close.cds--header__action[part=close-button] {\n  display: inline-flex;\n  inline-size: 3rem;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--actions, .cds--masthead__search[active] .cds--header__search--actions,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--actions,\n:host(c4d-masthead-search)[active] .cds--header__search--actions {\n  z-index: 10001;\n}\n.cds--masthead__search.cds--masthead__search--active .react-autosuggest__container::after, .cds--masthead__search[active] .react-autosuggest__container::after,\n:host(c4d-masthead-search).cds--masthead__search--active .react-autosuggest__container::after,\n:host(c4d-masthead-search)[active] .react-autosuggest__container::after {\n  position: absolute;\n  z-index: 10002;\n  display: block;\n  block-size: 0.125rem;\n  border-block-end: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--input, .cds--masthead__search[active] .cds--header__search--input,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--input,\n:host(c4d-masthead-search)[active] .cds--header__search--input {\n  z-index: 10000;\n  display: flex;\n  flex: 1;\n  padding: 0 1rem;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 3rem;\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--input::-moz-placeholder, .cds--masthead__search[active] .cds--header__search--input::-moz-placeholder, :host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--input::-moz-placeholder, :host(c4d-masthead-search)[active] .cds--header__search--input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--input::placeholder, .cds--masthead__search[active] .cds--header__search--input::placeholder,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--input::placeholder,\n:host(c4d-masthead-search)[active] .cds--header__search--input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--close,\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--search, .cds--masthead__search[active] .cds--header__search--close,\n.cds--masthead__search[active] .cds--header__search--search,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--close,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--search,\n:host(c4d-masthead-search)[active] .cds--header__search--close,\n:host(c4d-masthead-search)[active] .cds--header__search--search {\n  border: 0.125rem solid transparent;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--close:focus, .cds--masthead__search.cds--masthead__search--active .cds--header__search--close:active,\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--search:focus,\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--search:active, .cds--masthead__search[active] .cds--header__search--close:focus, .cds--masthead__search[active] .cds--header__search--close:active,\n.cds--masthead__search[active] .cds--header__search--search:focus,\n.cds--masthead__search[active] .cds--header__search--search:active,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--close:focus,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--close:active,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--search:focus,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--search:active,\n:host(c4d-masthead-search)[active] .cds--header__search--close:focus,\n:host(c4d-masthead-search)[active] .cds--header__search--close:active,\n:host(c4d-masthead-search)[active] .cds--header__search--search:focus,\n:host(c4d-masthead-search)[active] .cds--header__search--search:active {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__action, .cds--masthead__search[active] .cds--header__action,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__action,\n:host(c4d-masthead-search)[active] .cds--header__action {\n  background-color: var(--cds-layer-01, #f4f4f4);\n  transition-delay: 380ms;\n  transition-duration: 112ms;\n  transition-property: width;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead__search.cds--masthead__search--active,\n  :host(c4d-masthead-search).cds--masthead__search--active {\n    position: absolute;\n    inline-size: 100vw;\n  }\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead__search[active],\n  :host(c4d-masthead-search)[active] {\n    inline-size: 100vw;\n    inset-inline-end: 0;\n  }\n}\n\n.react-autosuggest__container {\n  position: relative;\n  display: flex;\n  justify-content: flex-end;\n  block-size: 3rem;\n}\n\n.react-autosuggest__suggestions-container {\n  position: absolute;\n  box-shadow: 0 0.25rem 0.5rem 0 rgba(0, 0, 0, 0.5);\n  inline-size: 100%;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n}\n\n.react-autosuggest__suggestions-list {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.react-autosuggest__section-title {\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: solid 1px var(--cds-layer-01, #f4f4f4);\n  border-block-start: solid 1px var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-secondary, #525252);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.react-autosuggest__suggestion, :host(c4d-masthead-search-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n.react-autosuggest__suggestion span, :host(c4d-masthead-search-item) span {\n  font-weight: 600;\n}\n.react-autosuggest__suggestion .cds--container-class, :host(c4d-masthead-search-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n.react-autosuggest__suggestion .cds--container-class:focus, :host(c4d-masthead-search-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .react-autosuggest__suggestion:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n.react-autosuggest__suggestion:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n.react-autosuggest__suggestion .cds--container-highlight-class:not(:hover), :host(c4d-masthead-search-item) .cds--container-highlight-class:not(:hover), .react-autosuggest__suggestion:focus, .react-autosuggest__suggestion:active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.react-autosuggest__suggestion:last-of-type .cds--container-class {\n  border-block-end: none;\n}\n\n.cds--header__search--input {\n  padding: 0;\n  border: none;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  font-size: 1rem;\n  inline-size: 0;\n  line-height: 1.375rem;\n  transition: 120ms;\n}\n.cds--header__search--input::-moz-placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n.cds--header__search--input::placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n\n.cds--masthead__focus {\n  position: absolute;\n  border: none;\n  opacity: 0;\n}\n\n.cds--masthead .cds--side-nav__navigation {\n  block-size: calc(100% - 3rem);\n}\n.cds--masthead .cds--side-nav__navigation > nav {\n  block-size: 100%;\n}\n@media (min-width: 800px) {\n  .cds--masthead .cds--side-nav__navigation {\n    display: none;\n  }\n}\n\n.cds--header__menu-trigger {\n  margin-inline-end: 0;\n}\n.cds--header__menu-trigger .cds--side-nav__close {\n  display: none;\n}\n.cds--header__menu-trigger.cds--header__action--active {\n  border-color: transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__menu-trigger.cds--header__action--active:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__menu-trigger.cds--header__action--active + .cds--header__logo {\n  z-index: 6001;\n  margin-inline-start: 3rem;\n}\n.cds--header__menu-trigger.cds--header__action--active .cds--side-nav__close {\n  display: inline;\n}\n.cds--header__menu-trigger.cds--header__action--active .cds--side-nav__open {\n  display: none;\n}\n@media (max-width: 41.98rem) {\n  .cds--header__menu-trigger.cds--masthead__header--search-active {\n    display: none;\n  }\n}\n@media (min-width: 42rem) and (max-width: 66rem) {\n  .cds--header__menu-trigger + .cds--header__logo a {\n    padding: 0 1rem;\n  }\n}\n\n.cds--side-nav__header-navigation {\n  block-size: 100%;\n  margin-block-end: 0;\n}\n\n.cds--masthead .cds--side-nav, .cds--masthead :host(c4d-left-nav) {\n  inset-inline-start: -100vw;\n  transform: translateZ(0.0001px);\n  /* stylelint-disable-next-line  time-min-milliseconds */\n  transition: visibility 1ms cubic-bezier(0.2, 0, 1, 0.9) 110ms, inset-inline-start 110ms cubic-bezier(0.2, 0, 1, 0.9) 1ms;\n  visibility: hidden;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead .cds--side-nav:not(.cds--side-nav--fixed):hover {\n    inline-size: 100vw;\n    max-inline-size: 100vw;\n  }\n}\n.cds--masthead .cds--side-nav .cds--header__logo, .cds--masthead :host(c4d-left-nav) .cds--header__logo {\n  block-size: 3rem;\n  padding-inline-start: 3rem;\n}\n.cds--masthead .cds--side-nav, .cds--masthead :host(c4d-left-nav),\n.cds--masthead .cds--side-nav--expanded {\n  inline-size: 16rem;\n  max-inline-size: 16rem;\n}\n.cds--masthead .cds--side-nav__items {\n  block-size: 100%;\n  padding-block-start: 0;\n}\n.cds--masthead .cds--side-nav__item {\n  block-size: auto;\n  min-block-size: 3rem;\n}\n.cds--masthead .cds--side-nav__item .cds--side-nav__submenu {\n  block-size: 100%;\n}\n.cds--masthead .cds--side-nav__overlay {\n  z-index: 1000;\n  inset-block-start: 0;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead .cds--side-nav__overlay {\n    background-color: var(--cds-background, #ffffff);\n  }\n}\n.cds--masthead .cds--side-nav__overlay-active {\n  display: none;\n}\n@media (max-width: 800px) {\n  .cds--masthead .cds--side-nav__overlay-active {\n    display: block;\n    background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  }\n}\n.cds--masthead .cds--side-nav--expanded {\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transform: translateZ(0.0001px);\n  /* stylelint-disable-next-line time-min-milliseconds */\n  transition: visibility 1ms cubic-bezier(0.2, 0, 1, 0.9) 0ms, inset-inline-start 110ms cubic-bezier(0.2, 0, 1, 0.9) 1ms;\n  visibility: visible;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead .cds--side-nav--ux,\n  .cds--masthead .cds--side-nav,\n  .cds--masthead :host(c4d-left-nav),\n  .cds--masthead .cds--side-nav--expanded {\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    inline-size: 100vw;\n    max-inline-size: 100vw;\n  }\n}\n\n:host(c4d-left-nav-menu-section),\n.cds--side-nav__menu-section {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: absolute;\n  z-index: 0;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  inline-size: 100%;\n  inset-inline-start: -100%;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  transform: translateZ(0.0001px);\n  transition: inset-inline-start 150ms cubic-bezier(0.2, 0, 1, 0.9);\n}\n:host(c4d-left-nav-menu-section) a,\n.cds--side-nav__menu-section a {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  block-size: 3rem;\n  padding-inline-start: 1rem;\n}\n:host(c4d-left-nav-menu-section) a:hover,\n.cds--side-nav__menu-section a:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  text-decoration: none;\n}\n:host(c4d-left-nav-menu-section) .cds--masthead__side-nav--submemu-title,\n.cds--side-nav__menu-section .cds--masthead__side-nav--submemu-title {\n  font-size: var(--cds-heading-compact-02-font-size, 1rem);\n  font-weight: var(--cds-heading-compact-02-font-weight, 600);\n  line-height: var(--cds-heading-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-heading-compact-02-letter-spacing, 0);\n  display: flex;\n  align-items: center;\n  padding: 0.8rem 1rem;\n  block-size: auto;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-primary, #161616);\n  min-block-size: 3rem;\n  text-decoration: none;\n}\n:host(c4d-left-nav-menu-section) .cds--masthead__side-nav--submemu-title:focus,\n.cds--side-nav__menu-section .cds--masthead__side-nav--submemu-title:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-left-nav-menu-section) .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title,\n.cds--side-nav__menu-section .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title {\n  padding: 0;\n  block-size: auto;\n  min-block-size: 3rem;\n}\n:host(c4d-left-nav-menu-section) .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title span,\n.cds--side-nav__menu-section .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title span {\n  font-size: var(--cds-heading-compact-02-font-size, 1rem);\n  font-weight: var(--cds-heading-compact-02-font-weight, 600);\n  line-height: var(--cds-heading-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-heading-compact-02-letter-spacing, 0);\n  display: flex;\n  padding: 0.8rem 1rem;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n}\n:host(c4d-left-nav-menu-section) .cds--masthead__side-nav--submemu-section-title__icon,\n.cds--side-nav__menu-section .cds--masthead__side-nav--submemu-section-title__icon {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  align-self: flex-start;\n  justify-content: flex-end;\n  margin-block-start: 0.125rem;\n}\n\na.cds--side-nav__link,\nbutton.cds--side-nav__link {\n  block-size: 3rem;\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n}\na.cds--side-nav__link > .cds--side-nav__link-text,\nbutton.cds--side-nav__link > .cds--side-nav__link-text {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  block-size: 100%;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  text-overflow: ellipsis;\n}\na.cds--side-nav__link:hover > .cds--side-nav__link-text, a.cds--side-nav__link:focus > .cds--side-nav__link-text,\nbutton.cds--side-nav__link:hover > .cds--side-nav__link-text,\nbutton.cds--side-nav__link:focus > .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\na.cds--side-nav__link--current,\nbutton.cds--side-nav__link--current {\n  background-color: var(--cds-background, #ffffff);\n}\na.cds--side-nav__link--current > .cds--side-nav__link-text,\nbutton.cds--side-nav__link--current > .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--masthead__side-nav--submemu-back {\n  position: sticky;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-start: 0;\n}\n.cds--masthead__side-nav--submemu-back button {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: none;\n  background-color: var(--cds-background, #ffffff);\n  cursor: pointer;\n  inline-size: 100%;\n  min-block-size: 2rem;\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n.cds--masthead__side-nav--submemu-back button:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--masthead__side-nav--submemu-back button:hover > .cds--side-nav__link-text {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--masthead__side-nav--submemu-back button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--masthead__side-nav--submemu-back button:focus > .cds--side-nav__link-text {\n  color: var(--cds-link-primary, #0f62fe);\n}\n.cds--masthead__side-nav--submemu-back button > .cds--side-nav__link-text {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  border-block-end: none;\n  color: var(--cds-link-primary, #0f62fe);\n}\n.cds--masthead__side-nav--submemu-back button svg {\n  margin-inline-end: 5px;\n}\n.cds--masthead__side-nav--submemu-back button svg path {\n  fill: currentColor;\n}\n:host([dir=rtl]) .cds--masthead__side-nav--submemu-back button svg {\n  transform: rotate(180deg);\n}\n\n:host(c4d-left-nav-menu-section)[expanded],\n.cds--side-nav__menu-section--expanded {\n  z-index: 1;\n  inset-inline-start: 0;\n}\n\n:host(c4d-left-nav-menu-section)[is-submenu],\n.cds--side-nav__menu-section-submenu {\n  inset-inline-start: 100%;\n}\n\n:host(c4d-left-nav-menu-section)[is-submenu][expanded],\n.cds--side-nav__menu-section-submenu.cds--side-nav__menu-section--expanded {\n  inset-inline-start: 0;\n}\n\n:host(c4d-left-nav-menu-section)[is-submenu][transition],\n.cds--side-nav__menu-section-submenu--expanded {\n  inset-inline-start: -100%;\n}\n\n.cds--side-nav__menu {\n  transform: translateX(100%);\n}\n\n.cds--side-nav__menu--hasactivechildren {\n  overflow: hidden;\n}\n\n.cds--side-nav__submenu {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n.cds--side-nav__submenu .cds--side-nav__submenu-content {\n  display: flex;\n  block-size: auto;\n  inline-size: 100%;\n  min-block-size: 3rem;\n}\n.cds--side-nav__submenu .cds--side-nav__submenu-title {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  align-self: center;\n  color: var(--cds-text-secondary, #525252);\n}\n.cds--side-nav__submenu[aria-haspopup=true] {\n  block-size: 3rem;\n}\n.cds--side-nav__submenu[aria-haspopup=true].cds--side-nav__submenu-platform {\n  block-size: 3rem;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n.cds--side-nav__submenu:hover .cds--side-nav__submenu-title, .cds--side-nav__submenu:focus .cds--side-nav__submenu-title {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__submenu-title,\na.cds--side-nav__link > .cds--side-nav__link-text,\nbutton.cds--side-nav__link > .cds--side-nav__link-text {\n  padding: 0.8rem 0;\n  text-overflow: initial;\n  white-space: normal;\n}\n\n.cds--masthead__side-nav--submemu-heading,\n:host(c4d-left-nav-menu-category-heading) {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  color: var(--cds-text-secondary, #525252);\n}\n.cds--masthead__side-nav--submemu-heading:is(.cds--left-nav-menu-category__heading-large),\n:host(c4d-left-nav-menu-category-heading):is(.cds--left-nav-menu-category__heading-large) {\n  margin: 0.5rem 0 1.5rem;\n}\n.cds--masthead__side-nav--submemu-heading:is(.cds--left-nav-menu-category__heading-large) .cds--side-nav__heading,\n:host(c4d-left-nav-menu-category-heading):is(.cds--left-nav-menu-category__heading-large) .cds--side-nav__heading {\n  padding: 0;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading {\n  padding: 1rem 0;\n  block-size: auto;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title {\n  display: block;\n  padding: 0 1rem;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title:where(a),\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title:where(a) {\n  display: inline-flex;\n  align-items: center;\n  color: inherit;\n  gap: 0.5rem;\n  text-decoration: none;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title:where(a):hover,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title:where(a):hover {\n  text-decoration: underline;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title:where(a):focus,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title:where(a):focus {\n  color: var(--cds-text-primary, #161616);\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-description,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-description {\n  padding: 0 1rem;\n}\n.cds--masthead__side-nav--submemu-heading ::slotted(:first-child),\n:host(c4d-left-nav-menu-category-heading) ::slotted(:first-child) {\n  padding-block-start: 0.5rem;\n}\n.cds--masthead__side-nav--submemu-heading h2,\n:host(c4d-left-nav-menu-category-heading) h2 {\n  font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-productive-heading-01-font-weight, 600);\n  line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n  letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--masthead__side-nav--submemu-heading h2.cds--side-nav__menu-section-title,\n:host(c4d-left-nav-menu-category-heading) h2.cds--side-nav__menu-section-title {\n  font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-productive-heading-03-font-weight, 400);\n  line-height: var(--cds-productive-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n}\n.cds--masthead__side-nav--submemu-heading h2.cds--side-nav__menu-section-title + .cds--side-nav__heading-description,\n:host(c4d-left-nav-menu-category-heading) h2.cds--side-nav__menu-section-title + .cds--side-nav__heading-description {\n  margin-block-start: 0.5rem;\n}\n\n/* stylelint-disable selector-pseudo-class-parentheses-space-inside */\n:host(c4d-left-nav-menu-category-heading):not(.cds--left-nav-menu-category__heading-large),\n:host(c4d-left-nav-menu),\n:host(c4d-left-nav-menu-item) {\n  display: block;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n/* stylelint-enable selector-pseudo-class-parentheses-space-inside */\n:host(c4d-left-nav-menu-item) .cds--side-nav__link {\n  display: flex;\n  align-items: center;\n  block-size: auto;\n  inline-size: 100%;\n  min-block-size: 3rem;\n  padding-inline-start: 1rem;\n}\n:host(c4d-left-nav-menu-item) .cds--side-nav__link:not(:is(a)):hover {\n  background-color: transparent;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-header:not(:first-of-type) {\n  margin-block-start: 2rem;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-header .cds--side-nav__link-text {\n  font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-productive-heading-01-font-weight, 600);\n  line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n  letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  align-items: center;\n  justify-content: space-between;\n  color: var(--cds-text-primary, #161616);\n  gap: 0.5rem;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-header .cds--side-nav__link-text svg {\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-view-all:hover .cds--side-nav__link-text {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-view-all .cds--side-nav__link-text {\n  display: inline-flex;\n  align-items: center;\n  justify-content: space-between;\n  color: var(--cds-button-primary, #0f62fe);\n  gap: 0.5rem;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-view-all .cds--side-nav__link-text svg {\n  color: var(--cds-button-primary, #0f62fe);\n}\n\n.cds--masthead__side-nav--submemu--selected {\n  border-inline-start: 3px solid var(--cds-background-brand, #0f62fe);\n}\n.cds--masthead__side-nav--submemu--selected .cds--side-nav__submenu-title, .cds--masthead__side-nav--submemu--selected.cds--side-nav__link .cds--side-nav__link-text {\n  font-weight: carbon--font-weight(\"semibold\");\n}\n\n.cds--side-nav__submenu-chevron > svg,\n.cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  fill: var(--cds-text-primary, #161616);\n  transform: rotate(-90deg);\n}\n:host([dir=rtl]) .cds--side-nav__submenu-chevron > svg,\n:host([dir=rtl]) .cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  transform: rotate(90deg) scale(1.25);\n}\n\n.cds--side-nav__item .cds--side-nav__link,\n.cds--side-nav__menu-item .cds--side-nav__link:not([isbackbutton=true]),\n:host(c4d-left-nav-item-highlighted) a.cds--side-nav__link,\n:host(c4d-left-nav-menu-item-highlighted) a.cds--side-nav__link,\n:host(c4d-left-nav-item) a.cds--side-nav__link {\n  display: flex;\n  block-size: auto;\n  inline-size: 100%;\n  min-block-size: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--side-nav__submenu-platform {\n  flex-direction: row;\n}\n.cds--side-nav__submenu-platform::after {\n  content: none;\n}\n\n@keyframes expand {\n  0% {\n    max-block-size: 0;\n    overflow-y: hidden;\n  }\n  100% {\n    max-block-size: 100%;\n  }\n}\n@keyframes collapse {\n  0% {\n    max-block-size: 100vh;\n  }\n  100% {\n    max-block-size: 0;\n  }\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  background-color: transparent;\n  box-shadow: none;\n  inset-block-end: 0;\n}\n\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu {\n  position: fixed;\n  display: block;\n  inline-size: 100vw;\n  inset-inline-start: 0;\n  margin-block-end: 4rem;\n  transform: translateZ(0.0001px);\n  transition: visibility 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  visibility: hidden;\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=false] + .cds--header__menu ::slotted(c4d-megamenu),\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=false] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu .cds--masthead__megamenu {\n  animation: 300ms cubic-bezier(0.4, 0.14, 0.3, 1) collapse;\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  position: fixed;\n  block-size: calc(100vh - 4rem - 3rem);\n  inline-size: var(--c4d-ce--viewport-width, 100vw);\n  inset-inline-start: 0;\n  margin-block-end: 4rem;\n  min-block-size: 320px;\n  transform: translateZ(0);\n  visibility: visible;\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu ::slotted(c4d-megamenu),\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--masthead__megamenu {\n  animation: 300ms cubic-bezier(0.4, 0.14, 0.3, 1) expand;\n}\n\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inset-block-start: var(--c4d-masthead-l0-bottom-edge, 3rem);\n}\n\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inset-block-start: 6.125rem;\n}\n\n:host(c4d-megamenu),\n.cds--masthead__megamenu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  --c4d-masthead-max-height: calc(\n    100vh - var(--cds-spacing-09, 3rem) - var(--cds-layout-05, 4rem)\n  );\n  --c4d-masthead-overflow: auto;\n  display: block;\n  overflow: hidden auto;\n  background-color: var(--cds-background, #ffffff);\n}\n:host(c4d-megamenu):focus,\n.cds--masthead__megamenu:focus {\n  outline: none;\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container,\n.cds--masthead__megamenu .cds--masthead__megamenu__container {\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n  inline-size: 100vw;\n}\n@media (min-width: 42rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container {\n    padding-inline: 2.5rem;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row,\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row {\n  background-color: var(--cds-layer-accent-01, #e0e0e0);\n  /**\n   * Faceted (tab) and Simple (list) megamenus have different layouts between\n   * 'md' and 'lg' breakpoints. This requires us to apply identical styles at\n   * different breakpoints, and we must also leverage custom properties to assign\n   * values across shadow roots. The concept is that these upper shadow roots have\n   * the stateful information needed to dictate how elements in the lower shadow\n   * roots should appear, and we can pass that information down via custom props.\n   */\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab,\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n  flex-wrap: nowrap;\n  gap: 1px;\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab ::slotted(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab ::slotted(c4d-megamenu-right-navigation) {\n  --c4d-right-nav-padding: 1rem;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list {\n    overflow: var(--c4d-masthead-overflow);\n    max-block-size: var(--c4d-masthead-max-height);\n    --c4d-view-all-inset: calc(1rem * -1);\n    --c4d-view-all-container-position: initial;\n    --c4d-view-all-container-transform: initial;\n    position: relative;\n    z-index: 1;\n    margin-inline: calc(3rem * -1);\n    transform: rotate(0deg);\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list {\n    display: flex;\n    flex-wrap: wrap;\n    margin-inline: -1rem;\n    flex-wrap: nowrap;\n    gap: 1px;\n  }\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n    --c4d-view-all-padding: 1rem;\n    --c4d-masthead-max-height: initial;\n    --c4d-masthead-overflow: initial;\n    overflow: initial;\n    border-block-end: 0.0625rem solid var(--cds-layer-accent-01, #e0e0e0);\n    inline-size: 100%;\n    margin-inline: initial;\n    max-block-size: initial;\n    max-inline-size: initial;\n    padding-inline: 2rem;\n  }\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container,\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container {\n    overflow: initial;\n    max-block-size: initial;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) {\n  --c4d-left-nav-columns: 2;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) {\n    --c4d-left-nav-columns: initial;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n  --c4d-right-nav-padding: 0;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n    --c4d-view-all-display: none;\n    border-block-end: none;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n    --c4d-right-nav-padding: 1rem;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]) {\n  --c4d-view-all-padding: 3rem;\n  position: sticky;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  border-block-start: 0.0625rem solid var(--cds-layer-accent-01, #e0e0e0);\n  inset-block-end: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]) {\n    display: none;\n  }\n}\n:host(c4d-megamenu) ::slotted([role=tabpanel]),\n.cds--masthead__megamenu ::slotted([role=tabpanel]) {\n  inline-size: 100%;\n}\n\n:host(c4d-megamenu-left-navigation),\n.cds--masthead__megamenu__highlight-section,\n:host(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu__categories-section {\n  position: relative;\n  display: block;\n  background-color: var(--cds-background, #ffffff);\n  padding-block-start: 1.5rem;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container {\n  overflow: var(--c4d-masthead-overflow);\n  max-block-size: var(--c4d-masthead-max-height);\n  position: var(--c4d-view-all-container-position, relative);\n  z-index: 1;\n  block-size: 100%;\n  transform: var(--c4d-view-all-container-transform, rotate(0deg));\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner {\n  overflow: overlay;\n  max-block-size: 100%;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all {\n  position: relative;\n  display: var(--c4d-view-all-display, inherit);\n  background-color: var(--cds-background, #ffffff);\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border {\n  position: absolute;\n  background: var(--cds-layer-accent-01, #e0e0e0);\n  block-size: 0.0625rem;\n  inset-block-start: 0;\n}\n\n:host(c4d-megamenu-left-navigation),\n.cds--masthead__megamenu__highlight-section {\n  display: block;\n  flex: 0 0 25%;\n  max-inline-size: 25%;\n  margin-inline-start: calc(1rem * -1);\n  min-block-size: 100%;\n  padding-inline-start: 1rem;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu__categories {\n  -moz-columns: var(--c4d-left-nav-columns, \"initial\");\n       columns: var(--c4d-left-nav-columns, \"initial\");\n  gap: 0;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu__view-all__border {\n  inset-inline: 0;\n}\n\n:host(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu__categories-section {\n  display: block;\n  inline-size: 100%;\n}\n:host(c4d-megamenu-right-navigation).c4d--masthead__tabpanel-child,\n.cds--masthead__megamenu__categories-section.c4d--masthead__tabpanel-child {\n  block-size: 100%;\n}\n:host(c4d-megamenu-right-navigation)[style-scheme=has-sidebar] .cds--masthead__megamenu__heading,\n:host(c4d-megamenu-right-navigation)[style-scheme=has-sidebar] .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section[style-scheme=has-sidebar] .cds--masthead__megamenu__heading,\n.cds--masthead__megamenu__categories-section[style-scheme=has-sidebar] .cds--masthead__megamenu__categories {\n  padding-inline-start: var(--c4d-right-nav-padding, 1rem);\n}\n:host(c4d-megamenu-right-navigation) ::slotted(c4d-megamenu-heading),\n.cds--masthead__megamenu__categories-section ::slotted(c4d-megamenu-heading) {\n  --heading-description-column-count: 2;\n  --heading-description-column-count-lg: 4;\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu--has-view-all-link .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu--has-view-all-link .cds--masthead__megamenu__categories {\n  padding-block-end: 0;\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container--has-sidebar ::slotted(c4d-megamenu-heading),\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container--has-sidebar ::slotted(c4d-megamenu-heading) {\n  --heading-description-column-count: 2;\n  --heading-description-column-count-lg: 3;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container--has-sidebar .cds--masthead__megamenu__categories,\n  .cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container--has-sidebar .cds--masthead__megamenu__categories {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu__categories {\n  -moz-column-count: 2;\n       column-count: 2;\n  -moz-column-gap: 0;\n       column-gap: 0;\n  padding-block-end: 2rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-right-navigation) .cds--masthead__megamenu__categories,\n  .cds--masthead__megamenu__categories-section .cds--masthead__megamenu__categories {\n    -moz-column-count: 4;\n         column-count: 4;\n  }\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu__view-all__border {\n  inset-inline: 0;\n}\n:host(c4d-megamenu-right-navigation)[data-child-count=\"1\"] .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section[data-child-count=\"1\"] .cds--masthead__megamenu__categories {\n  -moz-column-count: initial;\n       column-count: initial;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-right-navigation)[data-child-count=\"1\"] .cds--masthead__megamenu__categories,\n  .cds--masthead__megamenu__categories-section[data-child-count=\"1\"] .cds--masthead__megamenu__categories {\n    -moz-column-count: initial;\n         column-count: initial;\n  }\n}\n\n.cds--masthead__megamenu__heading span,\n:host(c4d-megamenu-heading) span {\n  display: block;\n  max-inline-size: calc(1 / var(--heading-description-column-count, 2) * 100%);\n}\n@media (min-width: 66rem) {\n  .cds--masthead__megamenu__heading span,\n  :host(c4d-megamenu-heading) span {\n    max-inline-size: calc(1 / var(--heading-description-column-count-lg, 4) * 100%);\n  }\n}\n\n.cds--masthead__megamenu__copy,\n:host(c4d-megamenu-category-group-copy) {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  margin: 0.375rem 1rem 0.625rem;\n  color: var(--cds-text-secondary, #525252);\n  max-inline-size: 17rem;\n}\n\n:host(c4d-megamenu-category-group),\n.cds--masthead__megamenu__category-group {\n  display: block;\n}\n:host(c4d-megamenu-category-group).only-child,\n.cds--masthead__megamenu__category-group.only-child {\n  /**\n   * Necessary to accommodate Safari issue with columns.\n   *\n   * Container height is calculated before breaking into specified number\n   * of columns, which causes extra blank whitespace beneath column content.\n   */\n}\n:host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-content-wrapper,\n.cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-content-wrapper {\n  display: inline;\n}\n:host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-heading,\n.cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-heading {\n  display: block;\n  flex: 0 0 50%;\n  max-inline-size: 50%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-heading,\n  .cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-heading {\n    display: block;\n    flex: 0 0 33.3333333333%;\n    max-inline-size: 33.3333333333%;\n  }\n}\n:host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-content,\n.cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-content {\n  -moz-column-count: 2;\n       column-count: 2;\n  -moz-column-gap: 0;\n       column-gap: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-content,\n  .cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-content {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n:host(c4d-megamenu-category-group).only-child ::slotted(c4d-megamenu-category-link),\n.cds--masthead__megamenu__category-group.only-child ::slotted(c4d-megamenu-category-link) {\n  display: block;\n  -moz-column-break-inside: avoid;\n       break-inside: avoid;\n}\n:host(c4d-megamenu-category-group) .cds--masthead__megamenu__category-group-content-wrapper,\n.cds--masthead__megamenu__category-group .cds--masthead__megamenu__category-group-content-wrapper {\n  display: inline-block;\n  inline-size: 100%;\n  padding-block-end: 1.5rem;\n}\n:host(c4d-megamenu-category-group) .cds--masthead__megamenu__copy,\n:host(c4d-megamenu-category-group) ::slotted(c4d-megamenu-category-group-copy),\n.cds--masthead__megamenu__category-group .cds--masthead__megamenu__copy,\n.cds--masthead__megamenu__category-group ::slotted(c4d-megamenu-category-group-copy) {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  margin: -0.375rem 1rem 1.5rem;\n  color: var(--cds-text-secondary, #525252);\n}\n\n:host(c4d-megamenu-link-with-icon) span {\n  flex: inherit;\n}\n:host(c4d-megamenu-link-with-icon) ::slotted([slot=icon]) {\n  transform: none;\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /* !rtl:raw:\n  transform: scaleX(-1);\n  */\n}\n\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] {\n  inline-size: 100%;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] p,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] a,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] .cds--link-with-icon {\n  padding: 0.375rem 1rem;\n  inline-size: 100%;\n  margin-block-end: 1.5rem;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] p,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] a,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] .cds--link-with-icon,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] ::slotted(span),\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] span {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-secondary, #525252);\n  text-decoration: none;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] ::slotted(span),\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] span {\n  flex: inherit;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] ::slotted(svg),\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] svg {\n  fill: var(--cds-text-secondary, #525252);\n  min-inline-size: 1rem;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline]:visited, :host(c4d-megamenu-link-with-icon)[style-scheme=category-headline]:hover {\n  color: var(--cds-text-secondary, #525252);\n}\n\n:host(c4d-megamenu-category-link) a,\n.cds--masthead__megamenu__category-sublink {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  padding: 0.375rem 1rem;\n  color: var(--cds-text-secondary, #525252);\n  text-decoration: none;\n}\n:host(c4d-megamenu-category-link) a:visited,\n.cds--masthead__megamenu__category-sublink:visited {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-megamenu-category-link) a:hover, :host(c4d-megamenu-category-link) a:active, :host(c4d-megamenu-category-link) a:hover:visited,\n.cds--masthead__megamenu__category-sublink:hover,\n.cds--masthead__megamenu__category-sublink:active,\n.cds--masthead__megamenu__category-sublink:hover:visited {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--masthead__megamenu__category-sublink--highlighted,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-sublink] {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  inline-size: 100%;\n}\n.cds--masthead__megamenu__category-sublink--highlighted a,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-sublink] a {\n  padding: 0.4375rem 1rem;\n  inline-size: 100%;\n}\n.cds--masthead__megamenu__category-sublink--highlighted span,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-sublink] span {\n  flex: inherit;\n}\n\n:host(c4d-megamenu-link-with-icon)[part*=view-all],\n.cds--masthead__megamenu__view-all-cta {\n  display: flex;\n  inline-size: 100%;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all][part*=view-all-left] [part=link],\n.cds--masthead__megamenu__view-all-cta[part*=view-all-left] [part=link] {\n  padding-inline-start: 1rem;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] [part=link],\n.cds--masthead__megamenu__view-all-cta [part=link] {\n  block-size: 3rem;\n  inline-size: 100%;\n  padding-inline: var(--c4d-view-all-padding, 2rem) 1rem;\n  text-decoration: none;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] [part=link]:hover,\n.cds--masthead__megamenu__view-all-cta [part=link]:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] ::slotted(span),\n.cds--masthead__megamenu__view-all-cta ::slotted(span) {\n  align-self: center;\n  vertical-align: middle;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] span,\n.cds--masthead__megamenu__view-all-cta span {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  flex: inherit;\n}\n\n:host(c4d-megamenu-category-link) a:focus, :host(c4d-megamenu-category-link) a:active,\n:host(c4d-megamenu-link-with-icon) a:focus,\n:host(c4d-megamenu-link-with-icon) a:active,\n.cds--masthead__megamenu__category-sublink--highlighted:focus,\n.cds--masthead__megamenu__category-sublink--highlighted:active,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:focus,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:active,\n.cds--masthead__megamenu__category-sublink:focus,\n.cds--masthead__megamenu__category-sublink:active {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n@media screen and (prefers-contrast) {\n  :host(c4d-megamenu-category-link) a:focus, :host(c4d-megamenu-category-link) a:active,\n  :host(c4d-megamenu-link-with-icon) a:focus,\n  :host(c4d-megamenu-link-with-icon) a:active,\n  .cds--masthead__megamenu__category-sublink--highlighted:focus,\n  .cds--masthead__megamenu__category-sublink--highlighted:active,\n  .cds--masthead__megamenu__view-all-cta .cds--link-with-icon:focus,\n  .cds--masthead__megamenu__view-all-cta .cds--link-with-icon:active,\n  .cds--masthead__megamenu__category-sublink:focus,\n  .cds--masthead__megamenu__category-sublink:active {\n    outline-style: dotted;\n  }\n}\n:host(c4d-megamenu-category-link) a:active, :host(c4d-megamenu-category-link) a:hover,\n:host(c4d-megamenu-link-with-icon) a:active,\n:host(c4d-megamenu-link-with-icon) a:hover,\n.cds--masthead__megamenu__category-sublink--highlighted:active,\n.cds--masthead__megamenu__category-sublink--highlighted:hover,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:active,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:hover,\n.cds--masthead__megamenu__category-sublink:active,\n.cds--masthead__megamenu__category-sublink:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  text-decoration: none;\n}\n:host(c4d-megamenu-category-link) a svg,\n:host(c4d-megamenu-link-with-icon) a svg,\n.cds--masthead__megamenu__category-sublink--highlighted svg,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon svg,\n.cds--masthead__megamenu__category-sublink svg {\n  transform: none;\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /* !rtl:raw:\n  transform: scaleX(-1);\n  */\n}\n\n.cds--body__lock-scroll {\n  position: relative;\n  overflow: hidden;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n*/\n/**\n* Copyright IBM Corp. 2016, 2021\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n:host(c4d-search-with-typeahead-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-search-with-typeahead-item) span {\n  font-weight: 600;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead-item):hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n:host(c4d-search-with-typeahead-item):hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-highlight-class:not(:hover), :host(c4d-search-with-typeahead-item):focus, :host(c4d-search-with-typeahead-item):active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead-item):last-of-type .cds--container-class {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead-item) span {\n  white-space: pre;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle] {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  color: var(--cds-text-helper, #6f6f6f);\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:active {\n  outline: none;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:hover {\n  background: none;\n  cursor: auto;\n}\n:host(c4d-search-with-typeahead-item)[lastBeforeGroup] .cds--container-class {\n  border-block-end-color: var(--cds-toggle-off, #8d8d8d);\n}\n\n:host(c4d-search-with-typeahead-item[alternate]) {\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n}\n\n:host(c4d-scoped-search-dropdown),\n:host(c4d-scoped-search-dropdown-mobile) {\n  display: flex;\n  border-inline-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box {\n  block-size: 3rem;\n  max-block-size: none;\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__field:focus,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box__field:focus {\n  outline: none;\n}\n\n@media (max-width: 65.98rem) {\n  :host(c4d-scoped-search-dropdown) {\n    display: none;\n  }\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__menu {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-scoped-search-dropdown-mobile) {\n  inline-size: 3rem;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select-input {\n  padding: 0;\n  color: transparent;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select__arrow {\n  position: absolute;\n  inset-inline: 0;\n  margin-inline: auto;\n  text-align: center;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--form__helper-text {\n  inline-size: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-scoped-search-dropdown-mobile) {\n    display: none;\n  }\n}\n\n:host(c4d-top-nav),\n.cds--header__search {\n  position: relative;\n  display: flex;\n  flex: 1;\n  align-items: center;\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav,\n.cds--header__search.cds--masthead__platform .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav::before,\n.cds--header__search.cds--masthead__platform .cds--header__nav::before {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--masthead__platform-name,\n.cds--header__search.cds--masthead__platform .cds--masthead__platform-name {\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active .cds--header__nav-container,\n.cds--header__search.cds--masthead__header--search-active .cds--header__nav-container {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n.cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n  .cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n    display: flex;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--header__search:not(.cds--masthead__header--search-active) {\n    overflow-x: visible;\n  }\n}\n\n.cds--header__action {\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border: 0.125rem solid transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__action > svg {\n  position: relative;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__action:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__action:focus, .cds--header__action:active {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__search--actions {\n  position: absolute;\n  display: flex;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--header__search--actions .cds--header__search--search,\n.cds--header__search--actions .cds--header__search--close {\n  padding: 0;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-icon-secondary, #525252);\n}\n.cds--header__search--actions .cds--header__search--search:hover,\n.cds--header__search--actions .cds--header__search--close:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__search--actions .cds--header__search--search:hover svg[focusable=false][aria-hidden=true],\n.cds--header__search--actions .cds--header__search--close:hover svg[focusable=false][aria-hidden=true] {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text, .cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text {\n  display: none;\n}\n\n.cds--header__profile .cds--header__action:focus,\n.cds--header__search--actions .cds--btn.cds--btn--icon-only.cds--tooltip__trigger:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\nbutton.cds--header__search--close.cds--header__action[part=close-button] {\n  display: none;\n  overflow: hidden;\n  border: none;\n  inline-size: 0;\n}\nbutton.cds--header__search--close.cds--header__action[part=close-button] svg {\n  position: relative;\n}\n\n.cds--header__search--search {\n  inline-size: 3rem;\n  outline: none;\n}\n\n:host(c4d-search-with-typeahead) {\n  position: relative;\n  display: block;\n  block-size: 3rem;\n  margin-inline-start: 3rem;\n  outline: none;\n}\n:host(c4d-search-with-typeahead) .c4d-ce__search__list {\n  overflow: hidden;\n  margin: 0;\n  block-size: 0;\n}\n:host(c4d-search-with-typeahead)[open] .c4d-ce__search__list {\n  padding: 0;\n  block-size: auto;\n}\n:host(c4d-search-with-typeahead)[active] {\n  z-index: 999;\n  inline-size: 100%;\n  margin-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action[part=close-button] {\n  display: inline-flex;\n  min-inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action.cds--header__search--hide {\n  display: none;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--actions {\n  z-index: 10001;\n}\n:host(c4d-search-with-typeahead)[active] .react-autosuggest__container::after {\n  position: absolute;\n  z-index: 10002;\n  display: block;\n  block-size: 0.125rem;\n  border-block-end: 0.125rem solid var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input {\n  z-index: 10000;\n  display: flex;\n  flex: 1;\n  padding: 0 1rem;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close {\n  display: inline-flex;\n  inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search {\n  border: 0.125rem solid transparent;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close:focus, :host(c4d-search-with-typeahead)[active] .cds--header__search--close:active,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:focus,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:active {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__action {\n  background-color: var(--cds-layer-01, #f4f4f4);\n  transition-delay: 380ms;\n  transition-duration: 112ms;\n  transition-property: width;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-search-with-typeahead)[scope-value] .react-autosuggest__suggestions-container {\n    inline-size: calc(100% - 3rem);\n    inset-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] {\n    background: var(--cds-layer-01, #f4f4f4);\n    inset-block-start: 0;\n    outline: 0.125rem solid transparent;\n    transition: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n    border-block-end: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n    outline: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n    display: flex;\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n    inline-size: 100%;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n    position: absolute;\n    z-index: 2;\n    fill: var(--cds-icon-secondary, #525252);\n    inset-block-start: 50%;\n    inset-inline-start: 1rem;\n    pointer-events: none;\n    transform: translateY(-50%);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n    content: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: calc(3rem + 2px);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n    border-block-end: none;\n    color: var(--cds-text-primary, #161616);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] {\n  background: var(--cds-layer-01, #f4f4f4);\n  inset-block-start: 0;\n  outline: 0.125rem solid transparent;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), top 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n  outline: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n  display: flex;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  inline-size: 100%;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n  position: absolute;\n  z-index: 2;\n  fill: var(--cds-icon-secondary, #525252);\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n  content: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n  inset-block-start: calc(3rem + 2px);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n  inset-block-start: 3.125rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[sticky-search] {\n  inset-block-start: 5rem;\n}\n:host(c4d-search-with-typeahead)[theme-sticky] {\n  inset-block-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 2rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 3rem;\n  }\n}\n\n.react-autosuggest__container {\n  position: relative;\n  display: flex;\n  justify-content: flex-end;\n  block-size: 3rem;\n}\n\n.react-autosuggest__suggestions-container {\n  position: absolute;\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inline-size: 100%;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  max-block-size: 80vh;\n  overflow-y: auto;\n}\n\n.react-autosuggest__suggestions-list {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.react-autosuggest__section-title {\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: solid 1px var(--cds-layer-01, #f4f4f4);\n  border-block-start: solid 1px var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-secondary, #525252);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.react-autosuggest__suggestion, :host(c4d-masthead-search-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n.react-autosuggest__suggestion span, :host(c4d-masthead-search-item) span {\n  font-weight: 600;\n}\n.react-autosuggest__suggestion .cds--container-class, :host(c4d-masthead-search-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n.react-autosuggest__suggestion .cds--container-class:focus, :host(c4d-masthead-search-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .react-autosuggest__suggestion:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n.react-autosuggest__suggestion:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n.react-autosuggest__suggestion .cds--container-highlight-class:not(:hover), :host(c4d-masthead-search-item) .cds--container-highlight-class:not(:hover), .react-autosuggest__suggestion:focus, .react-autosuggest__suggestion:active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.react-autosuggest__suggestion:last-of-type .cds--container-class {\n  border-block-end: none;\n}\n\n.cds--header__search--input {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  padding: 0;\n  border: none;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  font-size: 1rem;\n  inline-size: 0;\n  line-height: 1.375rem;\n  transition: 120ms;\n}\n.cds--header__search--input::-moz-placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n.cds--header__search--input::placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n\n/**\n * @license\n *\n * Copyright IBM Corp. 2019, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * @license\n *\n * Copyright IBM Corp. 2019, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(cds-popover[tabTip][open]) ::slotted(.cds--popover--tab-tip__button, :host(cds-tooltip) ::slotted(.cds--popover--tab-tip__button),\n:host(cds-popover) ::slotted(.cds--popover--tab-tip__button)) {\n  background: var(--cds-layer) !important; /* stylelint-disable-line declaration-no-important */\n  box-shadow: 0 0.125rem 0.125rem rgba(0, 0, 0, 0.2);\n}\n\n:host(cds-tooltip-content[open]) .cds--popover-content,\n:host(cds-popover-content[open]) .cds--popover-content,\n:host(cds-toggletip[open]) .cds--popover-content,\n:host(cds-slug[open]) .cds--popover-content {\n  display: block;\n}\n\n:host(cds-tooltip-content[open][tabTip]) .cds--popover-content,\n:host(cds-popover-content[open][tabTip]) .cds--popover-content {\n  border-radius: 0;\n  background: var(--cds-layer);\n}\n\n:host(cds-tooltip-content[open][caret]) .cds--popover-caret,\n:host(cds-popover-content[open][caret]) .cds--popover-caret,\n:host(cds-toggletip[open]) .cds--popover-caret,\n:host(cds-slug[open]) .cds--popover-caret {\n  display: block;\n}\n\n:host(cds-popover-content[dropShadow]) {\n  --cds-popover-drop-shadow: drop-shadow(0 0.125rem 0.125rem rgba(0, 0, 0, 0.2));\n}\n\n:host(cds-tooltip-content[align^=bottom]:not([autoalign])) .cds--popover-caret,\n:host(cds-popover-content[align^=bottom]:not([autoalign])) .cds--popover-caret,\n:host(cds-toggletip[alignment^=bottom]:not([autoalign])) .cds--popover-caret,\n:host(cds-slug[alignment^=bottom]:not([autoalign])) .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n:host(cds-slug[alignment^=bottom]:not([autoalign])) .cds--popover-caret {\n  clip-path: none;\n}\n\n:host(cds-tooltip-content[align=bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=bottom]:not([autoalign])) .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-tooltip-content[align=bottom-left]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=bottom-left]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=bottom-left]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=bottom-left]:not([autoalign])) .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-tooltip-content[align=bottom-right]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=bottom-right]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=bottom-right]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=bottom-right]:not([autoalign])) .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-tooltip-content[align^=left]:not([autoalign])) .cds--popover-caret,\n:host(cds-popover-content[align^=left]:not([autoalign])) .cds--popover-caret,\n:host(cds-toggletip[alignment^=left]:not([autoalign])) .cds--popover-caret,\n:host(cds-slug[alignment^=left]:not([autoalign])) .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n:host(cds-tooltip-content[align=left]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=left]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=left]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=left]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n:host(cds-tooltip-content[align=left-bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=left-bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=left-bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=left-bottom]:not([autoalign])) .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 1rem));\n}\n\n:host(cds-tooltip-content[align=left-top]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=left-top]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=left-top]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=left-top]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 1rem));\n}\n\n:host(cds-tooltip-content[align^=right]:not([autoalign])) .cds--popover-caret,\n:host(cds-popover-content[align^=right]:not([autoalign])) .cds--popover-caret,\n:host(cds-toggletip[alignment^=right]:not([autoalign])) .cds--popover-caret,\n:host(cds-slug[alignment^=right]:not([autoalign])) .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n:host(cds-tooltip-content[align=right]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=right]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=right]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=right]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n:host(cds-tooltip-content[align=right-bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=right-bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=right-bottom]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=right-bottom]:not([autoalign])) .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n:host(cds-tooltip-content[align=right-top]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=right-top]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=right-top]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=right-top]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n:host(cds-tooltip-content[align^=top]:not([autoalign])) .cds--popover-caret,\n:host(cds-popover-content[align^=top]:not([autoalign])) .cds--popover-caret,\n:host(cds-toggletip[alignment^=top]:not([autoalign])) .cds--popover-caret,\n:host(cds-slug[alignment^=top]:not([autoalign])) .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-tooltip-content[align=top]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=top]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=top]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=top]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-tooltip-content[align=top-left]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=top-left]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=top-left]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=top-left]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-tooltip-content[align=top-right]:not([autoalign])) .cds--popover-content,\n:host(cds-popover-content[align=top-right]:not([autoalign])) .cds--popover-content,\n:host(cds-toggletip[alignment=top-right]:not([autoalign])) .cds--popover-content,\n:host(cds-slug[alignment=top-right]:not([autoalign])) .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n:host(cds-toggletip[autoalign]) .cds--popover-caret,\n:host(cds-tooltip-content[autoalign]) .cds--popover-caret,\n:host(cds-popover-content[autoalign]) .cds--popover-caret {\n  block-size: 8px;\n  inline-size: 8px;\n  transform: rotate(45deg);\n}\n\n:host(cds-slug[autoalign]) .cds--popover-container,\n:host(cds-tooltip[autoalign]) .cds--popover-container,\n:host(cds-toggletip[autoalign]) .cds--popover-container,\n:host(cds-popover[autoalign]) .cds--popover-container {\n  position: static;\n}\n\n:host(cds-tooltip[data-table]) {\n  display: contents;\n}\n:host(cds-tooltip[data-table]):hover ::slotted(button) {\n  /* stylelint-disable-next-line declaration-no-important */\n  background-color: var(--cds-layer-selected-hover) !important;\n}\n\n:host(cds-tooltip[data-table][size=xs]) ::slotted(button),\n:host(cds-tooltip[data-table][size=sm]) ::slotted(button) {\n  /* stylelint-disable-next-line declaration-no-important */\n  block-size: calc(100% + 1px) !important;\n}\n\n:host(cds-tooltip[toolbar-action]) ::slotted(button) {\n  /* stylelint-disable-next-line declaration-no-important */\n  outline: none !important;\n}\n\n:host(cds-header-nav) .cds-ce--header__divider {\n  position: absolute;\n  background-color: var(--cds-border-subtle);\n  block-size: 1.5rem;\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: 0;\n  transform: translateY(-50%);\n}\n\n:host(cds-header-nav-item) {\n  outline: none;\n}\n\n:host(cds-header-menu) {\n  outline: none;\n}\n\n:host(cds-header-menu-item) {\n  outline: none;\n}\n:host(cds-header-menu-item) a.cds--header__menu-item {\n  background-color: var(--cds-layer);\n  block-size: 3rem;\n}\n:host(cds-header-menu-item) a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n:host(cds-header-menu-item) a.cds--header__menu-item:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n:host(cds-header-menu-item) a.cds--header__menu-item--current {\n  background-color: var(--cds-layer-selected);\n}\n:host(cds-header-menu-item) a.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n:host(cds-header-menu-item) a.cds--header__menu-item--current::after {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 3px;\n  inset-block: -0.125rem;\n  inset-inline-start: -0.125rem;\n}\n\n:host(cds-header-global-action) ::slotted(svg) {\n  fill: var(--cds-icon-secondary, #525252);\n}\n:host(cds-header-global-action):hover ::slotted(svg) {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(cds-header-global-action) .cds--popover {\n  z-index: 8001;\n}\n\n:host(cds-header-nav-item) a.cds--header__menu-item,\n:host(cds-header-menu) a.cds--header__menu-item {\n  box-sizing: border-box;\n}\n\n:host(cds-header-menu-button) {\n  display: content;\n  outline: none;\n}\n@media (min-width: 66rem) {\n  :host(cds-header-menu-button) {\n    display: none;\n  }\n}\n\n:host(cds-header-menu-button[collapse-mode=fixed]) {\n  display: none;\n}\n\n@media (min-width: 66rem) {\n  :host(cds-header-menu-button[collapse-mode=rail]) {\n    display: block;\n  }\n}\n\n:host(cds-header-name), :host(c4d-masthead-logo) {\n  display: content;\n  block-size: 100%;\n}\n:host(cds-header-name) a, :host(c4d-masthead-logo) a {\n  box-sizing: border-box;\n}\n\n:host(cds-switcher-item) a {\n  box-sizing: border-box;\n}\n\n:host(cds-switcher-item:nth-child(1)) {\n  margin-block-start: 1rem;\n}\n\n:host(cds-side-nav[expanded]) ::slotted(cds-side-nav-items) {\n  overflow-y: auto;\n}\n\n:host(cds-side-nav-link), :host(c4d-left-nav-item) {\n  display: block;\n  block-size: auto;\n  inline-size: auto;\n  outline: none;\n}\n:host(cds-side-nav-link) .cds--side-nav__icon, :host(c4d-left-nav-item) .cds--side-nav__icon {\n  color: var(--cds-text-primary, #161616);\n}\n:host(cds-side-nav-link) .cds--side-nav__icon[hidden], :host(c4d-left-nav-item) .cds--side-nav__icon[hidden] {\n  display: none;\n}\n\n:host(cds-side-nav-divider) {\n  display: block;\n}\n\n:host(cds-side-nav-menu) {\n  display: block;\n}\n:host(cds-side-nav-menu) .cds--side-nav__icon[hidden] {\n  display: none;\n}\n:host(cds-side-nav-menu) .cds--side-nav__menu {\n  padding: 0;\n  margin: 0;\n}\n:host(cds-side-nav-menu) .cds--side-nav__submenu[aria-expanded=true] + .cds--side-nav__menu {\n  max-block-size: none;\n}\n\n:host(cds-side-nav-menu[active]) {\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n}\n:host(cds-side-nav-menu[active])::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 0.25rem;\n  inset-block: 0;\n  inset-inline-start: 0;\n}\n\n:host(cds-side-nav-menu[active][expanded]) {\n  position: inherit;\n  background-color: inherit;\n  color: inherit;\n}\n:host(cds-side-nav-menu[active][expanded])::before {\n  content: none;\n}\n\n:host(cds-side-nav-menu-item), :host(c4d-left-nav-menu-item) {\n  display: block;\n  block-size: auto;\n  inline-size: auto;\n  outline: none;\n}\n:host(cds-side-nav-menu-item) a.cds--side-nav__link, :host(c4d-left-nav-menu-item) a.cds--side-nav__link {\n  block-size: 2rem;\n  font-weight: 400;\n  min-block-size: 2rem;\n  padding-inline-start: 2rem;\n}\n\n:host(cds-side-nav-menu-item[parent-has-icon]) a.cds--side-nav__link {\n  padding-inline-start: 4.5rem;\n}\n\n:host(cds-side-nav-item) .cds--side-nav__link:hover,\n:host(cds-side-nav-menu) .cds--side-nav__submenu:hover,\n:host(cds-side-nav-menu-item) .cds--side-nav__link:hover,\n:host(c4d-left-nav-menu-item) .cds--side-nav__link:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n/**\n* Copyright IBM Corp. 2016, 2024\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body), :host(c4d-lightbox-image-viewer),\n:host(c4d-lightbox-video-player),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n:host(c4d-lightbox-video-player-container),\n:host(c4d-lightbox-video-player-composite) {\n  display: contents;\n}\n\n:host(c4d-lightbox-video-player) .c4d--video-player {\n  inline-size: 100%;\n}\n:host(c4d-lightbox-video-player) .c4d--video-player ::slotted(.c4d--video-player__video) {\n  position: absolute;\n  inset: 0;\n}\n\n.c4d--modal--expressive--fullwidth .c4d--modal-container .c4d--modal-content {\n  min-block-size: 100%;\n}\n\n.c4d--lightbox-media-viewer, :host(c4d-lightbox-image-viewer),\n:host(c4d-lightbox-video-player) {\n  color: var(--cds-text-primary, #161616);\n}\n@media (max-width: 41.98rem) {\n  .c4d--lightbox-media-viewer .cds--modal-container, :host(c4d-lightbox-image-viewer) .cds--modal-container,\n  :host(c4d-lightbox-video-player) .cds--modal-container {\n    padding: 0 1rem;\n  }\n}\n.c4d--lightbox-media-viewer .cds--modal-container .cds--modal-content, :host(c4d-lightbox-image-viewer) .cds--modal-container .cds--modal-content,\n:host(c4d-lightbox-video-player) .cds--modal-container .cds--modal-content {\n  padding-inline-end: 0;\n}\n.c4d--lightbox-media-viewer .c4d--video-player, :host(c4d-lightbox-image-viewer) .c4d--video-player,\n:host(c4d-lightbox-video-player) .c4d--video-player {\n  inline-size: 100%;\n}\n.c4d--lightbox-media-viewer .c4d--video-player .c4d--video-player__video-container, :host(c4d-lightbox-image-viewer) .c4d--video-player .c4d--video-player__video-container,\n:host(c4d-lightbox-video-player) .c4d--video-player .c4d--video-player__video-container {\n  /* stylelint-disable-next-line function-name-case */\n  padding-block-start: min(100vh - 10rem, 56.25%);\n}\n@media (min-width: 42rem) {\n  .c4d--lightbox-media-viewer .cds--model-container, :host(c4d-lightbox-image-viewer) .cds--model-container,\n  :host(c4d-lightbox-video-player) .cds--model-container {\n    padding-block: 4rem 0;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--lightbox-media-viewer .cds--model-container, :host(c4d-lightbox-image-viewer) .cds--model-container,\n  :host(c4d-lightbox-video-player) .cds--model-container {\n    padding-block: 3rem 1rem;\n  }\n}\n\n:host(c4d-lightbox-media-viewer-body),\n.c4d--lightbox-media-viewer__container {\n  display: block;\n  block-size: 100%;\n  inline-size: 100%;\n  overflow-y: auto;\n}\n:host(c4d-lightbox-media-viewer-body)::before, :host(c4d-lightbox-media-viewer-body)::after,\n.c4d--lightbox-media-viewer__container::before,\n.c4d--lightbox-media-viewer__container::after {\n  position: sticky;\n  z-index: 1;\n  display: block;\n  flex: 0 0 auto;\n  block-size: 2rem;\n  content: \"\";\n  inline-size: 100%;\n  padding-block-start: 0;\n}\n:host(c4d-lightbox-media-viewer-body)::before,\n.c4d--lightbox-media-viewer__container::before {\n  background: linear-gradient(to bottom, var(--cds-layer-01, #f4f4f4), transparent);\n  inset-block-start: 0;\n}\n:host(c4d-lightbox-media-viewer-body)::after,\n.c4d--lightbox-media-viewer__container::after {\n  background: linear-gradient(to top, var(--cds-layer-01, #f4f4f4), transparent);\n  inset-block-end: 0;\n}\n@media (min-width: 42rem) {\n  :host(c4d-lightbox-media-viewer-body),\n  .c4d--lightbox-media-viewer__container {\n    padding-inline: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-lightbox-media-viewer-body),\n  .c4d--lightbox-media-viewer__container {\n    display: flex;\n    flex-direction: column;\n    padding: 0;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__row,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__row {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: 0;\n  flex-flow: column nowrap;\n  inline-size: 100%;\n  padding-block-start: calc(3rem - 2rem);\n}\n@media (min-width: 66rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__row,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__row {\n    flex-direction: row;\n    padding-block-start: 0;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media,\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description {\n  box-sizing: border-box;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media {\n    position: relative;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media img,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media img {\n  block-size: auto;\n  inline-size: auto;\n  max-block-size: 100%;\n  max-inline-size: 100%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media {\n    display: flex;\n    align-items: center;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media {\n    inline-size: 100%;\n    padding-inline: 1rem;\n    display: block;\n    flex: 0 0 75%;\n    max-inline-size: 75%;\n    flex: none;\n    /* stylelint-disable-next-line property-no-unknown */\n    aspect-ratio: 16/9;\n    inline-size: 100%;\n  }\n  .cds--row--condensed :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media, .cds--grid--condensed :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media,\n  .cds--row--condensed .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media,\n  .cds--grid--condensed .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media {\n    padding-inline: 0.03125rem;\n  }\n  .cds--row--narrow :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media, .cds--grid--narrow :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media,\n  .cds--row--narrow .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media,\n  .cds--grid--narrow .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media {\n    padding-inline: 0 1rem;\n  }\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media .c4d--image,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media .c4d--image {\n    block-size: 100%;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n}\n@media (min-width: 66rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description {\n    inline-size: 100%;\n    padding-inline: 1rem;\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: auto;\n  }\n  .cds--row--condensed :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description, .cds--grid--condensed :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description,\n  .cds--row--condensed .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description,\n  .cds--grid--condensed .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description {\n    padding-inline: 0.03125rem;\n  }\n  .cds--row--narrow :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description, .cds--grid--narrow :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description,\n  .cds--row--narrow .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description,\n  .cds--grid--narrow .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description {\n    padding-inline: 0 1rem;\n  }\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__media-description,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__media-description {\n    flex-grow: 1;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content {\n  padding-inline-end: 2rem;\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n@media (min-width: 66rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content {\n    overflow: auto;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content__title,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content__title {\n  padding-block-end: 2rem;\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n}\n@media (min-width: 82rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content__title,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content__title {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content__title,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content__title {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content__title,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content__title {\n    padding-block-start: 1rem;\n  }\n}\n:host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__content__desc,\n.c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__content__desc {\n  color: var(--cds-text-secondary, #525252);\n  padding-block-end: 2rem;\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n@media (min-width: 66rem) {\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__title,\n  :host(c4d-lightbox-media-viewer-body) .c4d--lightbox-media-viewer__desc,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__title,\n  .c4d--lightbox-media-viewer__container .c4d--lightbox-media-viewer__desc {\n    display: flex;\n    block-size: 100%;\n    max-inline-size: 95%;\n  }\n}\n\n::slotted(c4d-video-player-container) {\n  inline-size: 100%;\n}\n\n/**\n* Copyright IBM Corp. 2016, 2024\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n:host(c4d-button), :host(c4d-button-group-item),\n:host(c4d-button-cta) {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n  display: inline-flex;\n}\n:host(c4d-button) .cds--btn, :host(c4d-button-group-item) .cds--btn,\n:host(c4d-button-cta) .cds--btn {\n  flex-grow: 1;\n  max-inline-size: 100%;\n}\n:host(c4d-button) .cds--btn--hidden, :host(c4d-button-group-item) .cds--btn--hidden,\n:host(c4d-button-cta) .cds--btn--hidden {\n  display: none;\n  visibility: hidden;\n}\n@media print {\n  :host(c4d-button) .cds--btn--hidden, :host(c4d-button-group-item) .cds--btn--hidden,\n  :host(c4d-button-cta) .cds--btn--hidden {\n    display: inline-block;\n    color: var(--cds-text-primary, #161616);\n    font-weight: 200;\n    visibility: visible;\n  }\n  :host(c4d-button) .cds--btn--hidden span, :host(c4d-button-group-item) .cds--btn--hidden span,\n  :host(c4d-button-cta) .cds--btn--hidden span {\n    font-weight: 600;\n    margin-inline: calc(-1 * 0.25rem) 0.25rem;\n  }\n}\n\n:host(c4d-button-group-item),\n:host(c4d-button-cta) {\n  max-inline-size: 100%;\n  min-inline-size: 0;\n  outline: none;\n}\n@media print {\n  :host(c4d-button-group-item),\n  :host(c4d-button-cta) {\n    display: block;\n    margin-block-end: 1rem;\n    max-inline-size: 100%;\n  }\n}\n:host(c4d-button-group-item) .cds--btn,\n:host(c4d-button-cta) .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 100%;\n  transition: all 70ms cubic-bezier(0, 0, 0.38, 0.9), width 0s, height 0s;\n  word-break: break-word;\n}\n@media print {\n  :host(c4d-button-group-item) .cds--btn,\n  :host(c4d-button-cta) .cds--btn {\n    display: block;\n    border: 0.0625rem solid #161616;\n    background: #ffffff;\n    color: #161616;\n    font-weight: 600;\n    max-inline-size: inherit;\n  }\n}\n:host(c4d-button-group-item) .cds--btn .cds--btn__icon, :host(c4d-button-group-item) .cds--btn ::slotted([slot=icon]),\n:host(c4d-button-cta) .cds--btn .cds--btn__icon {\n  block-size: auto;\n  inline-size: auto;\n}\n:host(c4d-button-group-item) .cds--btn .cds--btn--hidden,\n:host(c4d-button-cta) .cds--btn .cds--btn--hidden {\n  display: none;\n  visibility: hidden;\n}\n@media print {\n  :host(c4d-button-group-item) .cds--btn .cds--btn--hidden,\n  :host(c4d-button-cta) .cds--btn .cds--btn--hidden {\n    display: inline-block;\n    color: #161616;\n    font-weight: 200;\n    visibility: visible;\n  }\n  :host(c4d-button-group-item) .cds--btn .cds--btn--hidden span,\n  :host(c4d-button-cta) .cds--btn .cds--btn--hidden span {\n    font-weight: 600;\n    margin-inline: calc(-1 * 0.25rem) 0.25rem;\n  }\n}\n:host(c4d-button-group-item) .cds--btn--multiline,\n:host(c4d-button-cta) .cds--btn--multiline {\n  align-items: start;\n}\n\n:host(c4d-button-group),\n:host(c4d-leadspace-block-cta) {\n  --c4d--button-group--item-count: 3;\n  display: grid;\n  grid-auto-rows: 1fr;\n  grid-gap: 1rem;\n  grid-template-columns: 1fr;\n}\n@media (min-width: 42rem) {\n  :host(c4d-button-group),\n  :host(c4d-leadspace-block-cta) {\n    display: inline-grid;\n    grid-template-columns: repeat(var(--c4d--button-group--item-count), 1fr);\n  }\n}\n@media print {\n  :host(c4d-button-group),\n  :host(c4d-leadspace-block-cta) {\n    display: block;\n  }\n}\n\n@media print {\n  :host(c4d-button-group-item) ::slotted([slot=icon]) {\n    fill: #161616;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link-with-icon span,\n:host(c4d-link-with-icon) span,\n:host(c4d-link-list-item) span,\n:host(c4d-link-list-item-cta) span,\n:host(c4d-text-cta) span {\n  flex: 1;\n  align-self: center;\n  vertical-align: middle;\n}\n.cds--link-with-icon svg,\n.cds--link-with-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) svg,\n:host(c4d-link-with-icon) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) svg,\n:host(c4d-link-list-item) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) svg,\n:host(c4d-link-list-item-cta) ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) svg,\n:host(c4d-text-cta) ::slotted(svg[slot=icon]) {\n  display: inline;\n  align-self: middle;\n  fill: currentColor;\n  margin-inline-start: 0.5rem;\n}\n.cds--link-with-icon.cds--link--visited,\n:host(c4d-link-with-icon).cds--link--visited,\n:host(c4d-link-list-item).cds--link--visited,\n:host(c4d-link-list-item-cta).cds--link--visited,\n:host(c4d-text-cta).cds--link--visited {\n  color: var(--cds-link-visited, #8a3ffc);\n}\n.cds--link-with-icon.cds--link--disabled:hover,\n:host(c4d-link-with-icon).cds--link--disabled:hover,\n:host(c4d-link-list-item).cds--link--disabled:hover,\n:host(c4d-link-list-item-cta).cds--link--disabled:hover,\n:host(c4d-text-cta).cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n.cds--link-with-icon .cds--link--disabled,\n:host(c4d-link-with-icon) .cds--link--disabled,\n:host(c4d-link-list-item) .cds--link--disabled,\n:host(c4d-link-list-item-cta) .cds--link--disabled,\n:host(c4d-text-cta) .cds--link--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-text-cta).cds--link-with-icon__icon-left,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left {\n  display: flex;\n  flex-direction: row-reverse;\n  justify-content: flex-end;\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]) {\n  position: relative;\n  align-self: start;\n  inset-block-start: 1px;\n  margin-inline: 0 0.5rem;\n}\n\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: inline-block;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover {\n  text-underline-position: under;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: inline;\n  vertical-align: middle;\n  white-space: nowrap;\n}\n\n:host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n  display: none;\n}\n@media (min-width: 66rem) {\n  :host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n    display: inline;\n  }\n}\n\n.cds--link-with-icon:not(:first-of-type),\n:host(c4d-link-with-icon):not(:first-of-type),\n:host(c4d-text-cta):not(:first-of-type) {\n  margin-inline-start: 2rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]) {\n  margin-inline: 0 0.5rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]) {\n  margin-inline: 0.5rem 0;\n}\n.cds--link-with-icon:focus,\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.cds--link-with-icon:active,\n:host(c4d-link-with-icon):active,\n:host(c4d-text-cta):active {\n  text-decoration: none;\n}\n\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: none;\n}\n\n:host(c4d-link-with-icon),\n.cds--link-with-icon__container {\n  display: table;\n}\n\n/**\n * @license\n *\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-global-banner-image),\n:host(c4d-card-cta-image),\n:host(c4d-image) {\n  position: relative;\n  display: block;\n}\n:host(c4d-global-banner-image) .c4d--image__img,\n:host(c4d-card-cta-image) .c4d--image__img,\n:host(c4d-image) .c4d--image__img {\n  display: block;\n  block-size: 100%;\n  inline-size: 100%;\n  -o-object-fit: cover;\n     object-fit: cover;\n}\n:host(c4d-global-banner-image) .c4d--image__img--border,\n:host(c4d-card-cta-image) .c4d--image__img--border,\n:host(c4d-image) .c4d--image__img--border {\n  outline: 1px solid var(--cds-border-subtle-02, #e0e0e0);\n}\n\n:host(c4d-card-cta-image::slotted(svg[slot=icon])),\n:host(c4d-image::slotted(svg[slot=icon])) {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n\n:host(c4d-image-item) {\n  display: none;\n}\n\n:host(c4d-image)[card-group-item],\n:host(c4d-image) {\n  overflow: hidden;\n}\n\n.c4d--image__longdescription {\n  position: absolute;\n  overflow: hidden;\n  block-size: 1px;\n  inline-size: 1px;\n  inset-block-start: auto;\n  inset-inline-start: -10000px;\n}\n\n:host(c4d-image)[heading] {\n  display: block;\n  margin-block: 2rem;\n  max-inline-size: 40rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-image)[heading] {\n    margin-block: 2rem;\n  }\n}\n\n.c4d--image-with-caption__image {\n  position: relative;\n  display: block;\n  padding: 0;\n  border: 1px solid var(--cds-border-tile-01, #c6c6c6);\n  background-color: transparent;\n  inline-size: 100%;\n  pointer-events: none;\n}\n@media (min-width: 42rem) {\n  .c4d--image-with-caption__image:hover {\n    cursor: zoom-in;\n  }\n  .c4d--image-with-caption__image:hover .c4d--image__img {\n    filter: brightness(80%);\n  }\n  .c4d--image-with-caption__image:hover .c4d--image-with-caption__zoom-button {\n    background-color: #161616;\n  }\n}\n@media (min-width: 42rem) {\n  .c4d--image-with-caption__image:focus {\n    border: 1px solid var(--cds-focus-inset, #ffffff);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  }\n}\n\n.c4d--image-with-caption__zoom-button {\n  display: none;\n}\n@media (min-width: 42rem) {\n  .c4d--image-with-caption__zoom-button {\n    position: absolute;\n    display: flex;\n    background-color: rgba(22, 22, 22, 0.85);\n    block-size: 3rem;\n    inline-size: 3rem;\n    inset-block-end: 0;\n    inset-inline-end: 0;\n  }\n  .c4d--image-with-caption__zoom-button svg {\n    margin: auto;\n    fill: #ffffff;\n  }\n}\n\n@media (min-width: 42rem) {\n  .c4d--image-with-caption__image,\n  .c4d--image-with-caption__zoom-button {\n    pointer-events: auto;\n    transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  }\n}\n\n.c4d--image__caption {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  color: var(--cds-text-helper, #6f6f6f);\n  margin-block-start: 0.5rem;\n}\n\n:host(c4d-image[lightbox-contrast=dark]) .c4d--image-with-caption__zoom-button {\n  background-color: rgba(255, 255, 255, 0.85);\n}\n:host(c4d-image[lightbox-contrast=dark]) .c4d--image-with-caption__zoom-button svg {\n  fill: #262626;\n}\n@media (min-width: 42rem) {\n  :host(c4d-image[lightbox-contrast=dark]) .c4d--image-with-caption__image:hover .c4d--image__img {\n    filter: brightness(120%);\n  }\n  :host(c4d-image[lightbox-contrast=dark]) .c4d--image-with-caption__image:hover .c4d--image-with-caption__zoom-button {\n    background-color: white;\n  }\n}\n\n:host(c4d-image-logo) {\n  margin: 1rem 1rem 0.5rem 1rem;\n  background-color: var(--cds-layer-02, #ffffff);\n  max-inline-size: 10rem;\n  display: flex;\n}\n:host(c4d-image-logo)::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 50%;\n}\n:host(c4d-image-logo)::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n:host(c4d-image-logo) .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n  -o-object-fit: contain;\n     object-fit: contain;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--tile-group html {\n  font-size: 100%;\n}\n.cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--tile-group strong {\n  font-weight: 600;\n}\n\n.cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--clickable,\n.cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--clickable *,\n.cds--tile--clickable *::before,\n.cds--tile--clickable *::after,\n.cds--tile--selectable *,\n.cds--tile--selectable *::before,\n.cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--tile--clickable:hover,\n.cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--tile--clickable:hover .cds--tile__checkmark, .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--tile--clickable:hover,\n.cds--tile--clickable:active,\n.cds--tile--clickable:visited,\n.cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n\n.cds--tile--clickable.cds--link--disabled,\n.cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--clickable .cds--tile--icon,\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n\n.cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n}\n\n.cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 0;\n}\n.cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n\n.cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron--interactive *,\n.cds--tile__chevron--interactive *::before,\n.cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n\n.cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n\n.cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n\n.cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n\n.cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n\n.cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n\n.cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile > .cds--slug,\n.cds--tile--expandable > div > .cds--slug,\n.cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n\n.cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n\n.cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--selectable::after,\n.cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable:focus,\n.cds--tile--slug.cds--tile--clickable:focus,\n.cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n\n.cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n\n.cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n\n.cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n\n.cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n\n.cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--slug-rounded,\n.cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n\n.cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tile__chevron svg,\n  .cds--tile__checkmark svg,\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--card,\n:host(c4d-card),\n:host(c4d-region-item) .cds--link,\n:host(c4d-card-cta),\n:host(c4d-card-in-card),\n:host(c4d-card-group-item),\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-content-group-cards-item),\n:host(c4d-content-group-cards-item) .cds--card {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  padding: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 100%;\n  inline-size: 100%;\n  text-decoration: none;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile-group html,\n:host(c4d-card) .cds--tile-group html,\n:host(c4d-region-item) .cds--link .cds--tile-group html,\n:host(c4d-card-cta) .cds--tile-group html,\n:host(c4d-card-in-card) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--card .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group html {\n  font-size: 100%;\n}\n.cds--card .cds--tile-group body,\n:host(c4d-card) .cds--tile-group body,\n:host(c4d-region-item) .cds--link .cds--tile-group body,\n:host(c4d-card-cta) .cds--tile-group body,\n:host(c4d-card-in-card) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--card .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--card .cds--tile-group code,\n:host(c4d-card) .cds--tile-group code,\n:host(c4d-region-item) .cds--link .cds--tile-group code,\n:host(c4d-card-cta) .cds--tile-group code,\n:host(c4d-card-in-card) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--card .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--card .cds--tile-group strong,\n:host(c4d-card) .cds--tile-group strong,\n:host(c4d-region-item) .cds--link .cds--tile-group strong,\n:host(c4d-card-cta) .cds--tile-group strong,\n:host(c4d-card-in-card) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--card .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group strong {\n  font-weight: 600;\n}\n.cds--card .cds--tile,\n:host(c4d-card) .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile,\n:host(c4d-card-cta) .cds--tile,\n:host(c4d-card-in-card) .cds--tile,\n:host(c4d-card-group-item) .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--card .cds--tile:focus,\n:host(c4d-card) .cds--tile:focus,\n:host(c4d-region-item) .cds--link .cds--tile:focus,\n:host(c4d-card-cta) .cds--tile:focus,\n:host(c4d-card-in-card) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile:focus,\n  :host(c4d-card) .cds--tile:focus,\n  :host(c4d-region-item) .cds--link .cds--tile:focus,\n  :host(c4d-card-cta) .cds--tile:focus,\n  :host(c4d-card-in-card) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--light,\n:host(c4d-card) .cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--light,\n:host(c4d-card-cta) .cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--clickable,\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--clickable *,\n.cds--card .cds--tile--clickable *::before,\n.cds--card .cds--tile--clickable *::after,\n.cds--card .cds--tile--selectable *,\n.cds--card .cds--tile--selectable *::before,\n.cds--card .cds--tile--selectable *::after,\n:host(c4d-card) .cds--tile--clickable *,\n:host(c4d-card) .cds--tile--clickable *::before,\n:host(c4d-card) .cds--tile--clickable *::after,\n:host(c4d-card) .cds--tile--selectable *,\n:host(c4d-card) .cds--tile--selectable *::before,\n:host(c4d-card) .cds--tile--selectable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::after,\n:host(c4d-card-cta) .cds--tile--clickable *,\n:host(c4d-card-cta) .cds--tile--clickable *::before,\n:host(c4d-card-cta) .cds--tile--clickable *::after,\n:host(c4d-card-cta) .cds--tile--selectable *,\n:host(c4d-card-cta) .cds--tile--selectable *::before,\n:host(c4d-card-cta) .cds--tile--selectable *::after,\n:host(c4d-card-in-card) .cds--tile--clickable *,\n:host(c4d-card-in-card) .cds--tile--clickable *::before,\n:host(c4d-card-in-card) .cds--tile--clickable *::after,\n:host(c4d-card-in-card) .cds--tile--selectable *,\n:host(c4d-card-in-card) .cds--tile--selectable *::before,\n:host(c4d-card-in-card) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--selectable:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--selectable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--selectable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--selectable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--clickable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--clickable:focus,\n  :host(c4d-card) .cds--tile--clickable:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n  :host(c4d-card-cta) .cds--tile--clickable:focus,\n  :host(c4d-card-in-card) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--clickable:hover .cds--tile__checkmark, .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--clickable:active,\n.cds--card .cds--tile--clickable:visited,\n.cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--clickable:active,\n:host(c4d-card) .cds--tile--clickable:visited,\n:host(c4d-card) .cds--tile--clickable:visited:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:active,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:active,\n:host(c4d-card-cta) .cds--tile--clickable:visited,\n:host(c4d-card-cta) .cds--tile--clickable:visited:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:active,\n:host(c4d-card-in-card) .cds--tile--clickable:visited,\n:host(c4d-card-in-card) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--card .cds--tile--clickable.cds--link--disabled,\n.cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile__checkmark,\n:host(c4d-card) .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 1;\n}\n.cds--card .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--card .cds--tile__checkmark:focus,\n:host(c4d-card) .cds--tile__checkmark:focus,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n:host(c4d-card-cta) .cds--tile__checkmark:focus,\n:host(c4d-card-in-card) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-card) .cds--tile__checkmark:focus,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n  :host(c4d-card-cta) .cds--tile__checkmark:focus,\n  :host(c4d-card-in-card) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile__checkmark--persistent,\n:host(c4d-card) .cds--tile__checkmark--persistent,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark--persistent,\n:host(c4d-card-cta) .cds--tile__checkmark--persistent,\n:host(c4d-card-in-card) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n.cds--card .cds--tile__chevron,\n:host(c4d-card) .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--card .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile__chevron--interactive,\n:host(c4d-card) .cds--tile__chevron--interactive,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive,\n:host(c4d-card-cta) .cds--tile__chevron--interactive,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile__chevron--interactive *,\n.cds--card .cds--tile__chevron--interactive *::before,\n.cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-card) .cds--tile__chevron--interactive *,\n:host(c4d-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::before,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::after,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:focus,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:hover,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n.cds--card .cds--tile--expandable,\n:host(c4d-card) .cds--tile--expandable,\n:host(c4d-region-item) .cds--link .cds--tile--expandable,\n:host(c4d-card-cta) .cds--tile--expandable,\n:host(c4d-card-in-card) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n.cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n.cds--card .cds--tile--is-expanded,\n:host(c4d-card) .cds--tile--is-expanded,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded,\n:host(c4d-card-cta) .cds--tile--is-expanded,\n:host(c4d-card-in-card) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n.cds--card .cds--tile--is-selected,\n:host(c4d-card) .cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile-content,\n:host(c4d-card) .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile-content,\n:host(c4d-card-cta) .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--card .cds--tile-input,\n:host(c4d-card) .cds--tile-input,\n:host(c4d-region-item) .cds--link .cds--tile-input,\n:host(c4d-card-cta) .cds--tile-input,\n:host(c4d-card-in-card) .cds--tile-input,\n:host(c4d-card-group-item) .cds--tile-input,\n:host(c4d-card-group-item) .cds--card .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n.cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile > .cds--slug,\n.cds--card .cds--tile--expandable > div > .cds--slug,\n.cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card) .cds--tile > .cds--slug,\n:host(c4d-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-region-item) .cds--link .cds--tile > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--expandable > div > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-cta) .cds--tile > .cds--slug,\n:host(c4d-card-cta) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-in-card) .cds--tile > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n.cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n.cds--card .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:focus,\n.cds--card .cds--tile--slug.cds--tile--clickable:focus,\n.cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n.cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--slug-rounded,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug-rounded,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n.cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--card .cds--tile__chevron svg,\n  .cds--card .cds--tile__checkmark svg,\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card:focus-within .cds--tile--clickable,\n:host(c4d-card):focus-within .cds--tile--clickable,\n:host(c4d-region-item) .cds--link:focus-within .cds--tile--clickable,\n:host(c4d-card-cta):focus-within .cds--tile--clickable,\n:host(c4d-card-in-card):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item):focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--tile--clickable {\n  position: relative;\n  z-index: 2;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--card:focus-within ::slotted(c4d-image),\n.cds--card:focus-within ::slotted(c4d-card-cta-image),\n.cds--card:focus-within .cds--card__img,\n.cds--card:focus-within .cds--image,\n:host(c4d-card):focus-within ::slotted(c4d-image),\n:host(c4d-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card):focus-within .cds--card__img,\n:host(c4d-card):focus-within .cds--image,\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link:focus-within .cds--card__img,\n:host(c4d-region-item) .cds--link:focus-within .cds--image,\n:host(c4d-card-cta):focus-within ::slotted(c4d-image),\n:host(c4d-card-cta):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta):focus-within .cds--card__img,\n:host(c4d-card-cta):focus-within .cds--image,\n:host(c4d-card-in-card):focus-within ::slotted(c4d-image),\n:host(c4d-card-in-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card):focus-within .cds--card__img,\n:host(c4d-card-in-card):focus-within .cds--image,\n:host(c4d-card-group-item):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item):focus-within .cds--card__img,\n:host(c4d-card-group-item):focus-within .cds--image,\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--image,\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item):focus-within .cds--card__img,\n:host(c4d-content-group-cards-item):focus-within .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--image {\n  z-index: -1;\n}\n.cds--card:focus, .cds--card:visited, .cds--card:active,\n:host(c4d-card):focus,\n:host(c4d-card):visited,\n:host(c4d-card):active,\n:host(c4d-region-item) .cds--link:focus,\n:host(c4d-region-item) .cds--link:visited,\n:host(c4d-region-item) .cds--link:active,\n:host(c4d-card-cta):focus,\n:host(c4d-card-cta):visited,\n:host(c4d-card-cta):active,\n:host(c4d-card-in-card):focus,\n:host(c4d-card-in-card):visited,\n:host(c4d-card-in-card):active,\n:host(c4d-card-group-item):focus,\n:host(c4d-card-group-item):visited,\n:host(c4d-card-group-item):active,\n:host(c4d-card-group-item) .cds--card:focus,\n:host(c4d-card-group-item) .cds--card:visited,\n:host(c4d-card-group-item) .cds--card:active,\n:host(c4d-content-group-cards-item):focus,\n:host(c4d-content-group-cards-item):visited,\n:host(c4d-content-group-cards-item):active,\n:host(c4d-content-group-cards-item) .cds--card:focus,\n:host(c4d-content-group-cards-item) .cds--card:visited,\n:host(c4d-content-group-cards-item) .cds--card:active {\n  position: relative;\n  z-index: 2;\n  text-decoration: none;\n}\n.cds--card:focus ::slotted(c4d-image),\n.cds--card:focus .cds--image, .cds--card:visited ::slotted(c4d-image),\n.cds--card:visited .cds--image, .cds--card:active ::slotted(c4d-image),\n.cds--card:active .cds--image,\n:host(c4d-card):focus ::slotted(c4d-image),\n:host(c4d-card):focus .cds--image,\n:host(c4d-card):visited ::slotted(c4d-image),\n:host(c4d-card):visited .cds--image,\n:host(c4d-card):active ::slotted(c4d-image),\n:host(c4d-card):active .cds--image,\n:host(c4d-region-item) .cds--link:focus ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus .cds--image,\n:host(c4d-region-item) .cds--link:visited ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:visited .cds--image,\n:host(c4d-region-item) .cds--link:active ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:active .cds--image,\n:host(c4d-card-cta):focus ::slotted(c4d-image),\n:host(c4d-card-cta):focus .cds--image,\n:host(c4d-card-cta):visited ::slotted(c4d-image),\n:host(c4d-card-cta):visited .cds--image,\n:host(c4d-card-cta):active ::slotted(c4d-image),\n:host(c4d-card-cta):active .cds--image,\n:host(c4d-card-in-card):focus ::slotted(c4d-image),\n:host(c4d-card-in-card):focus .cds--image,\n:host(c4d-card-in-card):visited ::slotted(c4d-image),\n:host(c4d-card-in-card):visited .cds--image,\n:host(c4d-card-in-card):active ::slotted(c4d-image),\n:host(c4d-card-in-card):active .cds--image,\n:host(c4d-card-group-item):focus ::slotted(c4d-image),\n:host(c4d-card-group-item):focus .cds--image,\n:host(c4d-card-group-item):visited ::slotted(c4d-image),\n:host(c4d-card-group-item):visited .cds--image,\n:host(c4d-card-group-item):active ::slotted(c4d-image),\n:host(c4d-card-group-item):active .cds--image,\n:host(c4d-card-group-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus .cds--image,\n:host(c4d-card-group-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:visited .cds--image,\n:host(c4d-card-group-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:active .cds--image,\n:host(c4d-content-group-cards-item):focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus .cds--image,\n:host(c4d-content-group-cards-item):visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):visited .cds--image,\n:host(c4d-content-group-cards-item):active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):active .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:visited .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:active .cds--image {\n  z-index: -1;\n}\n.cds--card ::slotted(c4d-image),\n.cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-card) ::slotted(c4d-image),\n:host(c4d-card) ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta) ::slotted(c4d-image),\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card) ::slotted(c4d-image),\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) ::slotted(c4d-image),\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image) {\n  position: relative;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card ::slotted(c4d-image)::before,\n  .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card) ::slotted(c4d-image)::before,\n  :host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n    position: absolute;\n    background-color: var(--cds-border-inverse, #161616);\n    content: \"\";\n    inset: 0;\n    opacity: 0;\n    transition: none;\n  }\n}\n.cds--card ::slotted(c4d-image)::before,\n.cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card) ::slotted(c4d-image)::before,\n:host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n  position: absolute;\n  background-color: var(--cds-border-inverse, #161616);\n  content: \"\";\n  inset: 0;\n  opacity: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile {\n  padding: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  position: absolute;\n  background: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  opacity: 16%;\n}\n.cds--card .cds--card,\n:host(c4d-card) .cds--card,\n:host(c4d-region-item) .cds--link .cds--card,\n:host(c4d-card-cta) .cds--card,\n:host(c4d-card-in-card) .cds--card,\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-card-group-item) .cds--card .cds--card,\n:host(c4d-content-group-cards-item) .cds--card,\n:host(c4d-content-group-cards-item) .cds--card .cds--card {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n.cds--card .cds--card__wrapper,\n:host(c4d-card) .cds--card__wrapper,\n:host(c4d-region-item) .cds--link .cds--card__wrapper,\n:host(c4d-card-cta) .cds--card__wrapper,\n:host(c4d-card-in-card) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper {\n  display: flex;\n  flex: 1;\n  justify-content: space-between;\n  min-block-size: 10rem;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  display: flex;\n}\n.cds--card .cds--card__wrapper::before,\n:host(c4d-card) .cds--card__wrapper::before,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::before,\n:host(c4d-card-cta) .cds--card__wrapper::before,\n:host(c4d-card-in-card) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 50%;\n}\n.cds--card .cds--card__wrapper::after,\n:host(c4d-card) .cds--card__wrapper::after,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::after,\n:host(c4d-card-cta) .cds--card__wrapper::after,\n:host(c4d-card-in-card) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n.cds--card .cds--card__content,\n:host(c4d-card) .cds--card__content,\n:host(c4d-region-item) .cds--link .cds--card__content,\n:host(c4d-card-cta) .cds--card__content,\n:host(c4d-card-in-card) .cds--card__content,\n:host(c4d-card-group-item) .cds--card__content,\n:host(c4d-card-group-item) .cds--card .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__content {\n  display: flex;\n  flex-direction: column;\n  padding: 1rem;\n  inline-size: 100%;\n}\n.cds--card .cds--card__heading,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n  margin-block-end: 4rem;\n}\n@media (min-width: 82rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n.cds--card .cds--card__heading,\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  color: var(--cds-text-primary, #161616);\n  max-inline-size: 40rem;\n  padding-inline-end: 10%;\n}\n@media (min-width: 42rem) {\n  .cds--card .cds--card__heading,\n  .cds--card .cds--card__copy,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-card) .cds--card__copy,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__copy,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__copy,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n    padding-inline-end: 2rem;\n  }\n}\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n  margin-block-end: 2rem;\n}\n.cds--card .cds--card__img,\n:host(c4d-card) .cds--card__img,\n:host(c4d-region-item) .cds--link .cds--card__img,\n:host(c4d-card-cta) .cds--card__img,\n:host(c4d-card-in-card) .cds--card__img,\n:host(c4d-card-group-item) .cds--card__img,\n:host(c4d-card-group-item) .cds--card .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__img {\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--card__link::after,\n:host(c4d-card) .cds--card__link::after,\n:host(c4d-region-item) .cds--link .cds--card__link::after,\n:host(c4d-card-cta) .cds--card__link::after,\n:host(c4d-card-in-card) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__link::after {\n  position: absolute;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer-wrapper,\n:host(c4d-card) .cds--card__footer-wrapper,\n:host(c4d-region-item) .cds--link .cds--card__footer-wrapper,\n:host(c4d-card-cta) .cds--card__footer-wrapper,\n:host(c4d-card-in-card) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__footer-wrapper {\n  margin-block-start: auto;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-content-group-cards-item) {\n    inline-size: auto;\n    margin-inline: 1rem;\n  }\n}\n\n:host(c4d-card-group-item),\n:host(c4d-card-in-card),\n:host(c4d-card-cta),\n:host(c4d-card) {\n  outline: none;\n}\n:host(c4d-card-group-item) .cds--card__pictogram,\n:host(c4d-card-in-card) .cds--card__pictogram,\n:host(c4d-card-cta) .cds--card__pictogram,\n:host(c4d-card) .cds--card__pictogram {\n  display: flex;\n}\n:host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n  margin-block-end: 0;\n  padding-block-start: 2rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n    display: flex;\n    flex: 1;\n    padding-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item) .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card) .cds--card__pictogram-wrapper,\n:host(c4d-card-cta) .cds--card__pictogram-wrapper,\n:host(c4d-card) .cds--card__pictogram-wrapper {\n  display: flex;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram] .cds--card ::slotted(c4d-card-heading) {\n  padding-block-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-inline-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram] .cds--card .cds--card__content {\n  position: relative;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram] .cds--card .cds--card__copy {\n  margin-block: 2rem 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card svg,\n:host(c4d-card-in-card)[pictogram] .cds--card svg,\n:host(c4d-card-cta)[pictogram] .cds--card svg,\n:host(c4d-card)[pictogram] .cds--card svg {\n  position: absolute;\n  color: var(--cds-link-primary, #0f62fe);\n  inset-block-end: 1rem;\n  inset-inline-end: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-end;\n  margin-block: auto 0;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy {\n  margin-block-start: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-start;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content {\n  padding-block-end: 4rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper {\n  position: absolute;\n  inset-block-end: 1rem;\n  inset-inline-start: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]) {\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n:host(c4d-card) ::slotted(svg[slot=pictogram]) {\n  fill: currentColor;\n  margin-inline-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card) ::slotted(svg[slot=pictogram]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-in-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-cta)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card) .cds--card__copy {\n  display: flex;\n  flex-direction: column;\n  gap: 1rem;\n}\n:host(c4d-card-group-item) .cds--card__copy[hidden],\n:host(c4d-card-in-card) .cds--card__copy[hidden],\n:host(c4d-card-cta) .cds--card__copy[hidden],\n:host(c4d-card) .cds--card__copy[hidden] {\n  /* stylelint-disable declaration-no-important */\n  display: none !important;\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    padding-block-start: 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    /* stylelint-disable value-no-vendor-prefix, property-no-vendor-prefix */\n    display: -webkit-box;\n    /* stylelint-enable value-no-vendor-prefix, property-no-vendor-prefix */\n    overflow: hidden;\n    -webkit-box-orient: vertical;\n    -webkit-line-clamp: 3;\n    max-inline-size: calc(100% - 4rem);\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9) 0.25s;\n  }\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block: 2rem 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 0;\n    opacity: 0;\n    transform: translate3d(0, -16px, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9);\n    visibility: hidden;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading) {\n    opacity: 0;\n    transform: translate3d(0, 16px, 0);\n    transition-delay: 0s;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy {\n    display: block;\n    overflow: hidden;\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition-delay: 0.2s;\n    visibility: visible;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    position: absolute;\n    display: flow-root;\n    inset-block-end: 1rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 2rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]) {\n    margin-block-end: 0;\n  }\n}\n\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 100%;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 66.6666666667%;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 75%;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 56.25%;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n.cds--card.cds--card--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--card--border {\n  border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n.cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n}\n@media (min-width: 82rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n\n:host(c4d-card):not([href]) .cds--card .cds--card__copy,\n:host(c4d-card-group-item):not([href]) .cds--card .cds--card__copy {\n  margin-block-end: 0.125rem;\n}\n:host(c4d-card):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after {\n  display: none;\n}\n:host(c4d-card):not([href]):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):not([href]):focus-within ::slotted(c4d-image) {\n  z-index: 0;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-heading),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-heading) {\n  margin-block-end: auto;\n  padding-block-end: 4rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer) {\n  display: inline-flex;\n  margin-block-start: 2rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer)::after,\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer)::after {\n  position: relative;\n}\n:host(c4d-card)[color-scheme=light] .cds--card__wrapper, :host(c4d-card)[color-scheme=light]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light] .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n:host(c4d-card)[color-scheme=light][href] :hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light][href] :hover .cds--card__wrapper {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-card)[color-scheme=light][href]:active,\n:host(c4d-card)[color-scheme=light][href] a:active,\n:host(c4d-card-group-item)[color-scheme=light][href]:active,\n:host(c4d-card-group-item)[color-scheme=light][href] a:active {\n  outline: none;\n}\n:host(c4d-card)[logo] .cds--card,\n:host(c4d-card-group-item)[logo] .cds--card {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo] .cds--card__copy,\n:host(c4d-card-group-item)[logo] .cds--card__copy {\n  margin-block-end: 1rem;\n}\n:host(c4d-card)[logo]:hover,\n:host(c4d-card-group-item)[logo]:hover {\n  border-color: var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-card)[logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo]:active,\n:host(c4d-card-group-item)[logo]:active {\n  border-color: var(--cds-border-inverse, #161616);\n}\n:host(c4d-card)[logo] ::slotted(c4d-card-footer),\n:host(c4d-card-group-item)[logo] ::slotted(c4d-card-footer) {\n  block-size: 0;\n}\n:host(c4d-card)[href][logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[href][logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n:host(c4d-card[link]) ::slotted(c4d-card-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n:host(c4d-card[link]) .cds--card .cds--card__copy {\n  margin-block-start: 0;\n}\n\n:host(c4d-card-cta),\n:host(c4d-card-link-cta),\n:host(c4d-card-link) {\n  outline: none;\n}\n\n:host(c4d-card-eyebrow),\n.cds--card__eyebrow {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.5rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-eyebrow),\n  .cds--card__eyebrow {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-footer),\n:host(c4d-card-cta-footer),\n:host(c4d-card-in-card-footer),\n:host(c4d-feature-card-footer),\n:host(c4d-feature-cta-footer) {\n  display: flex;\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-footer):focus-visible,\n:host(c4d-card-cta-footer):focus-visible,\n:host(c4d-card-in-card-footer):focus-visible,\n:host(c4d-feature-card-footer):focus-visible,\n:host(c4d-feature-cta-footer):focus-visible {\n  outline: none;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: block;\n}\n\n.cds--card .cds--card__footer,\n:host(c4d-card-footer) a,\n:host(c4d-card-cta-footer) a,\n:host(c4d-card-in-card-footer) a,\n:host(c4d-feature-card-footer) a,\n:host(c4d-feature-cta-footer) a {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer:focus,\n:host(c4d-card-footer) a:focus,\n:host(c4d-card-cta-footer) a:focus,\n:host(c4d-card-in-card-footer) a:focus,\n:host(c4d-feature-card-footer) a:focus,\n:host(c4d-feature-cta-footer) a:focus {\n  outline: none;\n}\n.cds--card .cds--card__footer:hover,\n:host(c4d-card-footer) a:hover,\n:host(c4d-card-cta-footer) a:hover,\n:host(c4d-card-in-card-footer) a:hover,\n:host(c4d-feature-card-footer) a:hover,\n:host(c4d-feature-cta-footer) a:hover {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer span,\n:host(c4d-card-footer) a span,\n:host(c4d-card-cta-footer) a span,\n:host(c4d-card-in-card-footer) a span,\n:host(c4d-feature-card-footer) a span,\n:host(c4d-feature-cta-footer) a span {\n  flex: none;\n}\n.cds--card .cds--card__footer::after,\n:host(c4d-card-footer) a::after,\n:host(c4d-card-cta-footer) a::after,\n:host(c4d-card-in-card-footer) a::after,\n:host(c4d-feature-card-footer) a::after,\n:host(c4d-feature-cta-footer) a::after {\n  position: absolute;\n  z-index: 1;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer .cds--card__cta__copy,\n:host(c4d-card-footer) a .cds--card__cta__copy,\n:host(c4d-card-cta-footer) a .cds--card__cta__copy,\n:host(c4d-card-in-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-cta-footer) a .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n  max-inline-size: calc(100% - 20px - 0.5rem);\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n.cds--card .cds--card__footer .cds--card__footer__copy,\n:host(c4d-card-footer) a .cds--card__footer__copy,\n:host(c4d-card-cta-footer) a .cds--card__footer__copy,\n:host(c4d-card-in-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-cta-footer) a .cds--card__footer__copy {\n  margin-block-end: -0.125rem;\n  max-inline-size: calc(100% - 20px);\n}\n.cds--card .cds--card__footer svg,\n.cds--card .cds--card__footer ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) a svg,\n:host(c4d-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) a svg,\n:host(c4d-card-cta-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-in-card-footer) a svg,\n:host(c4d-card-in-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-card-footer) a svg,\n:host(c4d-feature-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-cta-footer) a svg,\n:host(c4d-feature-cta-footer) a ::slotted(svg[slot=icon]) {\n  display: block;\n  margin-inline-start: 0;\n  min-inline-size: 20px;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n  inline-size: 100%;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled),\n:host(c4d-card-cta-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer {\n  justify-content: flex-start;\n  inline-size: auto;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:active, :host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  text-decoration: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer::after {\n  content: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n}\n\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile {\n  border-color: var(--cds-background-inverse, #393939);\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  display: none;\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__copy,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__copy {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]):focus-within::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]):focus-within::after {\n  position: absolute;\n  z-index: 2;\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  content: \"\";\n  inset: 0;\n  outline: 1px solid var(--cds-focus-inset, #ffffff);\n  outline-offset: -3px;\n  pointer-events: none;\n}\n\n:host(c4d-card-heading),\n:host(c4d-card-link-heading) {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  color: var(--cds-text-primary, #161616);\n  margin-block-end: 4rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-heading),\n  :host(c4d-card-link-heading) {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-heading) {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\n:host(c4d-card-link-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n.cds--card-group__card ::slotted(c4d-card-eyebrow),\n.cds--card-group__card ::slotted(c4d-card-heading),\n.cds--card-group__card ::slotted(c4d-card-link-heading) {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n.cds--card-group__card:hover ::slotted(c4d-image),\n.cds--card-group__card:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n\n@media print {\n  :host(c4d-card),\n  :host(c4d-card-group-item),\n  :host(c4d-card-cta),\n  :host(c4d-card-in-card),\n  :host(c4d-content-group-cards-item) {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  :host(c4d-card) .cds--card,\n  :host(c4d-card-group-item) .cds--card,\n  :host(c4d-card-cta) .cds--card,\n  :host(c4d-card-in-card) .cds--card,\n  :host(c4d-content-group-cards-item) .cds--card {\n    border: none;\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-card) ::slotted(c4d-image),\n  :host(c4d-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card) .cds--image,\n  :host(c4d-card-group-item) ::slotted(c4d-image),\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-group-item) .cds--image,\n  :host(c4d-card-cta) ::slotted(c4d-image),\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-cta) .cds--image,\n  :host(c4d-card-in-card) ::slotted(c4d-image),\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-in-card) .cds--image,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image),\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-content-group-cards-item) .cds--image {\n    display: none;\n  }\n  .cds--card {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  .cds--card .cds--card__img,\n  .cds--card .cds--card__image_img,\n  .cds--card .cds--image,\n  .cds--card .cds--card__video-thumbnail {\n    display: none;\n  }\n}\n:host(c4d-card[disabled]) .cds--card,\n:host(c4d-region-item[disabled]) .cds--card {\n  cursor: not-allowed;\n}\n:host(c4d-card[disabled]) .cds--card__copy,\n:host(c4d-card[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-card[disabled]) ::slotted(c4d-card-heading),\n:host(c4d-region-item[disabled]) .cds--card__copy,\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-heading) {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n:host(c4d-card-cta-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  justify-content: space-between;\n}\n\n:host(c4d-card-footer[href])::after {\n  position: relative;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-feature-card),\n:host(c4d-feature-cta) {\n  display: block;\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-border-subtle-selected);\n}\n:host(c4d-feature-card):hover ::slotted([slot=image])::before,\n:host(c4d-feature-card):hover c4d-image::before,\n:host(c4d-feature-card):hover .cds--image::before,\n:host(c4d-feature-cta):hover ::slotted([slot=image])::before,\n:host(c4d-feature-cta):hover c4d-image::before,\n:host(c4d-feature-cta):hover .cds--image::before {\n  opacity: 0.08;\n}\n:host(c4d-feature-card):focus-within,\n:host(c4d-feature-cta):focus-within {\n  border-color: transparent;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-feature-card) .cds--card,\n  :host(c4d-feature-cta) .cds--card {\n    display: block;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-feature-card) .cds--card,\n  :host(c4d-feature-cta) .cds--card {\n    flex-direction: row;\n  }\n}\n:host(c4d-feature-card) .cds--card:focus-within,\n:host(c4d-feature-cta) .cds--card:focus-within {\n  outline: none;\n  outline-offset: 0;\n}\n:host(c4d-feature-card) .cds--card:focus-within::before,\n:host(c4d-feature-cta) .cds--card:focus-within::before {\n  position: absolute;\n  z-index: 1;\n  display: block;\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  content: \"\";\n  inset: -1px;\n  outline: 1px solid var(--cds-focus-inset, #ffffff);\n  outline-offset: -3px;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-feature-card) .cds--card:focus-within::before,\n  :host(c4d-feature-cta) .cds--card:focus-within::before {\n    min-block-size: 292px;\n  }\n}\n:host(c4d-feature-card) .cds--card__image-wrapper,\n:host(c4d-feature-card) .cds--card__wrapper,\n:host(c4d-feature-cta) .cds--card__image-wrapper,\n:host(c4d-feature-cta) .cds--card__wrapper {\n  flex: 1 0 50%;\n}\n:host(c4d-feature-card) .cds--card__image-wrapper,\n:host(c4d-feature-cta) .cds--card__image-wrapper {\n  aspect-ratio: 1/1;\n}\n:host(c4d-feature-card) .cds--card__wrapper::before, :host(c4d-feature-card) .cds--card__wrapper::after,\n:host(c4d-feature-cta) .cds--card__wrapper::before,\n:host(c4d-feature-cta) .cds--card__wrapper::after {\n  display: none;\n}\n:host(c4d-feature-card) .cds--card__content,\n:host(c4d-feature-cta) .cds--card__content {\n  justify-content: space-between;\n  padding: 1rem;\n  aspect-ratio: 2/1;\n  transition: background-color 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media (min-width: 42rem) {\n  :host(c4d-feature-card) .cds--card__content,\n  :host(c4d-feature-cta) .cds--card__content {\n    aspect-ratio: auto;\n  }\n}\n:host(c4d-feature-card) .cds--card__eyebrow-wrapper--empty,\n:host(c4d-feature-card) .cds--card__pictogram-wrapper--empty,\n:host(c4d-feature-cta) .cds--card__eyebrow-wrapper--empty,\n:host(c4d-feature-cta) .cds--card__pictogram-wrapper--empty {\n  display: none;\n}\n:host(c4d-feature-card) .cds--card__copy,\n:host(c4d-feature-cta) .cds--card__copy {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n@media (min-width: 42rem) {\n  :host(c4d-feature-card) .cds--card__copy,\n  :host(c4d-feature-cta) .cds--card__copy {\n    font-size: var(--cds-body-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-01-font-weight, 400);\n    line-height: var(--cds-body-01-line-height, 1.42857);\n    letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-feature-card) .cds--card__copy,\n  :host(c4d-feature-cta) .cds--card__copy {\n    font-size: var(--cds-body-02-font-size, 1rem);\n    font-weight: var(--cds-body-02-font-weight, 400);\n    line-height: var(--cds-body-02-line-height, 1.5);\n    letter-spacing: var(--cds-body-02-letter-spacing, 0);\n  }\n}\n:host(c4d-feature-card) ::slotted([slot=image]),\n:host(c4d-feature-card) c4d-image,\n:host(c4d-feature-cta) ::slotted([slot=image]),\n:host(c4d-feature-cta) c4d-image {\n  z-index: 0;\n  block-size: 100%;\n}\n:host(c4d-feature-card) ::slotted([slot=image])::before,\n:host(c4d-feature-card) c4d-image::before,\n:host(c4d-feature-cta) ::slotted([slot=image])::before,\n:host(c4d-feature-cta) c4d-image::before {\n  position: absolute;\n  z-index: 1;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-feature-card) ::slotted([slot=image])::before,\n  :host(c4d-feature-card) c4d-image::before,\n  :host(c4d-feature-cta) ::slotted([slot=image])::before,\n  :host(c4d-feature-cta) c4d-image::before {\n    transition: none;\n  }\n}\n:host(c4d-feature-card) ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-card) ::slotted(c4d-card-heading),\n:host(c4d-feature-cta) ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-cta) ::slotted(c4d-card-heading) {\n  inline-size: 100%;\n}\n@media (min-width: 42rem) {\n  :host(c4d-feature-card) ::slotted(c4d-card-eyebrow),\n  :host(c4d-feature-card) ::slotted(c4d-card-heading),\n  :host(c4d-feature-cta) ::slotted(c4d-card-eyebrow),\n  :host(c4d-feature-cta) ::slotted(c4d-card-heading) {\n    inline-size: 90%;\n  }\n}\n:host(c4d-feature-card) ::slotted(c4d-card-heading),\n:host(c4d-feature-cta) ::slotted(c4d-card-heading) {\n  margin-block-end: 2rem;\n}\n:host(c4d-feature-card) ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-cta) ::slotted(c4d-card-eyebrow) {\n  margin-inline-end: 0.5rem;\n}\n\n@media (min-width: 82rem) {\n  :host(c4d-feature-card)[size=large] .cds--card__content,\n  :host(c4d-feature-cta)[size=large] .cds--card__content {\n    padding: 2rem;\n  }\n}\n@media (min-width: 82rem) {\n  :host(c4d-feature-card)[size=large] ::slotted(c4d-card-heading),\n  :host(c4d-feature-cta)[size=large] ::slotted(c4d-card-heading) {\n    font-size: var(--cds-heading-04-font-size, 1.75rem);\n    font-weight: var(--cds-heading-04-font-weight, 400);\n    line-height: var(--cds-heading-04-line-height, 1.28572);\n    letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n  }\n}\n\n:host(c4d-feature-card)[color-scheme=inverse],\n:host(c4d-feature-cta)[color-scheme=inverse] {\n  border-color: var(--cds-border-inverse, #161616);\n}\n:host(c4d-feature-card)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-feature-cta)[color-scheme=inverse] ::slotted(c4d-card-heading) {\n  color: var(--cds-focus-inset, #ffffff);\n}\n:host(c4d-feature-card)[color-scheme=inverse]:hover .cds--card__wrapper,\n:host(c4d-feature-cta)[color-scheme=inverse]:hover .cds--card__wrapper {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-feature-card)[color-scheme=inverse] ::slotted([slot=image])::before,\n:host(c4d-feature-card)[color-scheme=inverse] c4d-image::before,\n:host(c4d-feature-card)[color-scheme=inverse] .cds--image::before,\n:host(c4d-feature-cta)[color-scheme=inverse] ::slotted([slot=image])::before,\n:host(c4d-feature-cta)[color-scheme=inverse] c4d-image::before,\n:host(c4d-feature-cta)[color-scheme=inverse] .cds--image::before {\n  background-color: var(--cds-icon-inverse, #ffffff);\n}\n\n:host(c4d-feature-card:not([size=large]))[color-scheme=inverse] .cds--card__wrapper,\n:host(c4d-feature-cta:not([size=large]))[color-scheme=inverse] .cds--card__wrapper {\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-feature-card:not([size=large]))[color-scheme=inverse]:hover .cds--card__wrapper,\n:host(c4d-feature-cta:not([size=large]))[color-scheme=inverse]:hover .cds--card__wrapper {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-feature-card:not([size=large]))[color-scheme=inverse] .cds--feature-card__card .cds--card__footer svg,\n:host(c4d-feature-cta:not([size=large]))[color-scheme=inverse] .cds--feature-card__card .cds--card__footer svg {\n  fill: var(--cds-link-inverse, #78a9ff);\n}\n\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper,\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper {\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper .cds--card__eyebrow,\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper .cds--card__copy,\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-heading),\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper .cds--card__eyebrow,\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper .cds--card__copy,\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-heading) {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper .cds--card__eyebrow,\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper .cds--card__eyebrow,\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-eyebrow) {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-feature-card[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-heading),\n:host(c4d-feature-cta[size=large])[color-scheme=inverse] .cds--card__wrapper ::slotted(c4d-card-heading) {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n\n:host(c4d-feature-card-footer)[color-scheme=inverse] .c4d-ce--card__footer .c4d-ce--cta__icon,\n:host(c4d-feature-card-footer)[color-scheme=inverse] .c4d-ce--card__footer ::slotted(svg[slot=icon]) {\n  fill: var(--cds-link-inverse, #78a9ff);\n}\n:host(c4d-feature-card-footer)[color-scheme=inverse] .c4d-ce--card__footer:hover .c4d-ce--cta__icon,\n:host(c4d-feature-card-footer)[color-scheme=inverse] .c4d-ce--card__footer:hover ::slotted(svg[slot=icon]) {\n  fill: var(--cds-link-inverse-hover, #a6c8ff);\n}\n:host(c4d-feature-card-footer)[color-scheme=inverse] .c4d-ce--card__footer:active .c4d-ce--cta__icon,\n:host(c4d-feature-card-footer)[color-scheme=inverse] .c4d-ce--card__footer:active ::slotted(svg[slot=icon]) {\n  fill: var(--cds-link-inverse-active, #f4f4f4);\n}\n\n:host(c4d-feature-card[size=large]) ::slotted(c4d-feature-card-footer) {\n  display: flex;\n  justify-content: flex-end;\n}\n@media (min-width: 82rem) {\n  :host(c4d-feature-card[size=large]) ::slotted(c4d-feature-card-footer) {\n    justify-content: flex-end;\n  }\n}\n\n:host(c4d-feature-card-footer),\n:host(c4d-feature-cta-footer) {\n  display: flex;\n  justify-content: flex-end;\n}\n@media (min-width: 42rem) {\n  :host(c4d-feature-card-footer),\n  :host(c4d-feature-cta-footer) {\n    justify-content: flex-end;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-feature-card-footer)[size=large] .c4d-ce--card__footer ::slotted(svg[slot=icon]),\n  :host(c4d-feature-cta-footer)[size=large] .c4d-ce--card__footer ::slotted(svg[slot=icon]) {\n    block-size: 4rem;\n    inline-size: 4rem;\n  }\n}\n\n:host(c4d-feature-card[size=large])[color-scheme=inverse]:hover .cds--card__wrapper {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n/* Covers regular card style, too */\n:host(c4d-cta) {\n  display: block;\n}\n\n:host(c4d-masthead-container),\nc4d-masthead-container {\n  position: relative;\n}\n\n:host(c4d-masthead-menu-button) {\n  position: relative;\n  block-size: 3rem;\n  inline-size: 3rem;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-masthead-menu-button)[hide-menu-button] {\n    display: none;\n  }\n}\n:host(c4d-masthead-menu-button) .c4d-ce--header__menu-trigger__container {\n  display: contents;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-masthead-menu-button) .c4d-ce--header__menu-trigger__container--has-search-active {\n    display: none;\n  }\n}\n\n:host(c4d-masthead-logo) {\n  z-index: 2;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-masthead-logo) a {\n    position: relative;\n    display: flex;\n    align-items: center;\n    padding: 0 2rem;\n    border: solid 0.125rem transparent;\n    block-size: 100%;\n    outline: none;\n    transition: none;\n  }\n  :host(c4d-masthead-logo) a:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  :host(c4d-masthead-logo) a:active, :host(c4d-masthead-logo) a:focus {\n    border-color: var(--cds-focus, #0f62fe);\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 99rem) {\n  :host(c4d-masthead-logo) a {\n    padding: 0 2.5rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (max-width: 81.98rem) {\n  :host(c4d-masthead-logo) a {\n    padding: 0 2rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (max-width: 65.98rem) {\n  :host(c4d-masthead-logo) a {\n    padding: 0 1rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-masthead-logo) a svg {\n    block-size: 23px;\n    inline-size: 58px;\n  }\n  :host(c4d-masthead-logo) a svg g,\n  :host(c4d-masthead-logo) a svg path {\n    fill: var(--cds-layer-selected-inverse, #161616);\n    /* stylelint-disable-next-line media-feature-name-no-unknown */\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (prefers-contrast: more) {\n  :host(c4d-masthead-logo) a svg g,\n  :host(c4d-masthead-logo) a svg path {\n    fill: ButtonText;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 800px) {\n  :host(c4d-masthead-logo) a::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-layer-accent-01, #e0e0e0);\n    block-size: 1.5rem;\n    content: \"\";\n    inline-size: 0.0625rem;\n    inset-block-start: 50%;\n    inset-inline-end: -0.1875rem;\n    transform: translateY(-50%);\n  }\n}\n:host(c4d-masthead-logo) a {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 2rem;\n  border: solid 0.125rem transparent;\n  block-size: 100%;\n  outline: none;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n}\n:host(c4d-masthead-logo) a:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-masthead-logo) a:active, :host(c4d-masthead-logo) a:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n@media (min-width: 99rem) {\n  :host(c4d-masthead-logo) a {\n    padding: 0 2.5rem;\n  }\n}\n@media (max-width: 81.98rem) {\n  :host(c4d-masthead-logo) a {\n    padding: 0 2rem;\n  }\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-masthead-logo) a {\n    padding: 0 1rem;\n  }\n}\n:host(c4d-masthead-logo) a svg {\n  block-size: 23px;\n  inline-size: 58px;\n}\n:host(c4d-masthead-logo) a svg g,\n:host(c4d-masthead-logo) a svg path {\n  fill: var(--cds-layer-selected-inverse, #161616);\n  /* stylelint-disable-next-line media-feature-name-no-unknown */\n}\n@media (prefers-contrast: more) {\n  :host(c4d-masthead-logo) a svg g,\n  :host(c4d-masthead-logo) a svg path {\n    fill: ButtonText;\n  }\n}\n@media (min-width: 800px) {\n  :host(c4d-masthead-logo) a::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-layer-accent-01, #e0e0e0);\n    block-size: 1.5rem;\n    content: \"\";\n    inline-size: 0.0625rem;\n    inset-block-start: 50%;\n    inset-inline-end: -0.1875rem;\n    transform: translateY(-50%);\n  }\n}\n:host(c4d-masthead-logo) .cds--tooltip__trigger.cds--tooltip__trigger--definition,\n:host(c4d-masthead-logo) .cds--tooltip--definition {\n  border: none;\n}\n:host(c4d-masthead-logo) .cds--tooltip__trigger.cds--tooltip__trigger--definition .cds--tooltip__trigger,\n:host(c4d-masthead-logo) .cds--tooltip--definition .cds--tooltip__trigger {\n  border: none;\n}\n:host(c4d-masthead-logo) .cds--tooltip__trigger.cds--tooltip__trigger--definition.cds--tooltip--a11y,\n:host(c4d-masthead-logo) .cds--tooltip--definition.cds--tooltip--a11y {\n  block-size: 100%;\n}\n:host(c4d-masthead-logo).cds--search-active {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-masthead-logo).cds--search-active {\n    display: block;\n  }\n}\n:host(c4d-masthead-logo)[hasTooltip] {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: default;\n}\n:host(c4d-masthead-logo)[hasTooltip]:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  :host(c4d-masthead-logo)[hasTooltip]:focus {\n    outline-style: dotted;\n  }\n}\n:host(c4d-masthead-logo)[hasTooltip]::before, :host(c4d-masthead-logo)[hasTooltip]::after,\n:host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  :host(c4d-masthead-logo)[hasTooltip]::before, :host(c4d-masthead-logo)[hasTooltip]::after,\n  :host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n  :host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n:host(c4d-masthead-logo)[hasTooltip]::before, :host(c4d-masthead-logo)[hasTooltip]::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-masthead-logo)[hasTooltip]::before, :host(c4d-masthead-logo)[hasTooltip]::after {\n    transition: none;\n  }\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--a11y::before, :host(c4d-masthead-logo)[hasTooltip].cds--tooltip--a11y::after {\n  transition: none;\n}\n:host(c4d-masthead-logo)[hasTooltip]::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n:host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n:host(c4d-masthead-logo)[hasTooltip]::after,\n:host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.5rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  :host(c4d-masthead-logo)[hasTooltip]::after,\n  :host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n  :host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  :host(c4d-masthead-logo)[hasTooltip]::after,\n  :host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n  :host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  :host(c4d-masthead-logo)[hasTooltip]::after,\n  :host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n  :host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  :host(c4d-masthead-logo)[hasTooltip]::after,\n  :host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n  :host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n:host(c4d-masthead-logo)[hasTooltip]::after {\n  content: attr(aria-label);\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--a11y::after {\n  content: none;\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible::before, :host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible::after, :host(c4d-masthead-logo)[hasTooltip]:hover::before, :host(c4d-masthead-logo)[hasTooltip]:hover::after, :host(c4d-masthead-logo)[hasTooltip]:focus::before, :host(c4d-masthead-logo)[hasTooltip]:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible + .cds--assistive-text, :host(c4d-masthead-logo)[hasTooltip]:hover .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip]:hover + .cds--assistive-text, :host(c4d-masthead-logo)[hasTooltip]:focus .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip]:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible + .cds--assistive-text, :host(c4d-masthead-logo)[hasTooltip].cds--tooltip--visible.cds--tooltip--a11y::before, :host(c4d-masthead-logo)[hasTooltip]:hover .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip]:hover + .cds--assistive-text, :host(c4d-masthead-logo)[hasTooltip]:hover.cds--tooltip--a11y::before, :host(c4d-masthead-logo)[hasTooltip]:focus .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip]:focus + .cds--assistive-text, :host(c4d-masthead-logo)[hasTooltip]:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--hidden .cds--assistive-text, :host(c4d-masthead-logo)[hasTooltip].cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n:host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n:host(c4d-masthead-logo)[hasTooltip]::before, :host(c4d-masthead-logo)[hasTooltip]::after,\n:host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n:host(c4d-masthead-logo)[hasTooltip]::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.25rem;\n  transform: translate(-50%, 100%);\n}\n:host(c4d-masthead-logo)[hasTooltip]::after,\n:host(c4d-masthead-logo)[hasTooltip] .cds--assistive-text,\n:host(c4d-masthead-logo)[hasTooltip] + .cds--assistive-text {\n  inset-block-end: -0.5625rem;\n  inset-inline-start: 0;\n  transform: translate(0, 100%);\n}\n:host(c4d-masthead-logo)[hasTooltip].cds--tooltip--a11y + .cds--assistive-text {\n  inset-block-end: -0.5rem;\n  transform: translate(0, 100%);\n}\n:host(c4d-masthead-logo) a ::slotted(svg) {\n  block-size: 23px;\n  inline-size: 58px;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-masthead-logo) .c4d-ce--header__logo--has-search-active {\n    display: none;\n  }\n}\n:host(c4d-masthead-logo):active, :host(c4d-masthead-logo):focus {\n  border: none;\n  outline: none;\n}\n\n:host(c4d-top-nav-name) {\n  position: relative;\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  outline: none;\n}\n:host(c4d-top-nav-name) a.cds--header__name {\n  margin-inline-start: 0;\n}\n@media (max-width: 799px) {\n  :host(c4d-top-nav-name) a.cds--header__name {\n    position: absolute;\n    display: flex;\n    inset-block-start: 0;\n    inset-inline-start: 0;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-top-nav-name) a.cds--header__name {\n    margin-inline-start: 0;\n  }\n}\n@media (min-width: 82rem) {\n  :host(c4d-top-nav-name) a.cds--header__name {\n    position: relative;\n    margin-inline-start: 1rem;\n  }\n}\n\n:host(c4d-masthead-search) {\n  outline: none;\n}\n:host(c4d-masthead-search) .c4d-ce--masthead__search__list {\n  overflow: hidden;\n  block-size: 0;\n}\n:host(c4d-masthead-search)[open] .c4d-ce--masthead__search__list {\n  block-size: auto;\n}\n\n:host(c4d-masthead-search-item) {\n  font-size: 1rem;\n}\n\n:host(c4d-masthead-global-bar) {\n  z-index: 0;\n  display: flex;\n  flex: none;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-masthead-global-bar) ::slotted(c4d-button-cta) {\n    display: none;\n  }\n}\n:host(c4d-masthead-global-bar) ::slotted(div.earth-language-icon) {\n  display: flex;\n  align-items: center;\n  /* stylelint-disable-next-line declaration-no-important */\n  padding: 1rem !important;\n  cursor: pointer;\n}\n:host(c4d-masthead-global-bar) ::slotted(div.earth-language-icon:hover) {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-masthead-global-bar)[has-search-active] {\n    display: none;\n  }\n}\n:host(c4d-masthead-global-bar) .c4d-ce--header__global__container {\n  display: contents;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-masthead-global-bar) .c4d-ce--header__global__container--has-search-active {\n    display: none;\n  }\n}\n\n:host(c4d-masthead-profile),\n:host(c4d-masthead-contact),\n:host(c4d-masthead-cart) {\n  background-color: var(--cds-background, #ffffff);\n  inline-size: 3rem;\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item,\n:host(c4d-masthead-contact) a.cds--header__menu-item,\n:host(c4d-masthead-cart) a.cds--header__menu-item {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding: 0.8125rem 1rem;\n  border: none;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n  justify-content: center;\n  padding: 0;\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item > svg,\n:host(c4d-masthead-contact) a.cds--header__menu-item > svg,\n:host(c4d-masthead-cart) a.cds--header__menu-item > svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item:hover,\n:host(c4d-masthead-contact) a.cds--header__menu-item:hover,\n:host(c4d-masthead-cart) a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item:active,\n:host(c4d-masthead-contact) a.cds--header__menu-item:active,\n:host(c4d-masthead-cart) a.cds--header__menu-item:active {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item:active, :host(c4d-masthead-profile) a.cds--header__menu-item:hover,\n:host(c4d-masthead-contact) a.cds--header__menu-item:active,\n:host(c4d-masthead-contact) a.cds--header__menu-item:hover,\n:host(c4d-masthead-cart) a.cds--header__menu-item:active,\n:host(c4d-masthead-cart) a.cds--header__menu-item:hover {\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item:active > svg, :host(c4d-masthead-profile) a.cds--header__menu-item:hover > svg,\n:host(c4d-masthead-contact) a.cds--header__menu-item:active > svg,\n:host(c4d-masthead-contact) a.cds--header__menu-item:hover > svg,\n:host(c4d-masthead-cart) a.cds--header__menu-item:active > svg,\n:host(c4d-masthead-cart) a.cds--header__menu-item:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-masthead-profile) a.cds--header__menu-item:active, :host(c4d-masthead-profile) a.cds--header__menu-item:focus,\n:host(c4d-masthead-contact) a.cds--header__menu-item:active,\n:host(c4d-masthead-contact) a.cds--header__menu-item:focus,\n:host(c4d-masthead-cart) a.cds--header__menu-item:active,\n:host(c4d-masthead-cart) a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-button-primary, #0f62fe);\n  outline-offset: -2px;\n}\n:host(c4d-masthead-profile) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-masthead-contact) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-masthead-cart) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inline-size: 10rem;\n  inset-inline: auto 0;\n}\n\n:host(c4d-top-nav),\n:host(c4d-top-nav-l1) {\n  display: none;\n  background-color: var(--cds-background, #ffffff);\n}\n@media (min-width: 799px) {\n  :host(c4d-top-nav),\n  :host(c4d-top-nav-l1) {\n    display: flex;\n    flex: 1;\n    align-items: stretch;\n  }\n}\n@media (min-width: 799px) {\n  :host(c4d-top-nav) .cds--header__nav,\n  :host(c4d-top-nav-l1) .cds--header__nav {\n    position: absolute;\n    display: block;\n  }\n}\n:host(c4d-top-nav)[hide-divider] .cds--header__nav,\n:host(c4d-top-nav-l1)[hide-divider] .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav) .c4d-ce--header__nav-content-container,\n:host(c4d-top-nav-l1) .c4d-ce--header__nav-content-container {\n  position: relative;\n  flex: 1;\n}\n:host(c4d-top-nav) .cds--header__nav-caret-left-container,\n:host(c4d-top-nav) .cds--header__nav-caret-right-container,\n:host(c4d-top-nav-l1) .cds--header__nav-caret-left-container,\n:host(c4d-top-nav-l1) .cds--header__nav-caret-right-container {\n  position: relative;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-end: 0;\n}\n:host(c4d-top-nav) .cds--header__nav-caret-right-container,\n:host(c4d-top-nav-l1) .cds--header__nav-caret-right-container {\n  inset-inline-end: 0;\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /* !rtl:raw:\n  position: absolute !important;\n  */\n}\n:host(c4d-top-nav) .cds--header__nav-caret-left-container,\n:host(c4d-top-nav-l1) .cds--header__nav-caret-left-container {\n  inset-inline-start: 0;\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /* !rtl:raw:\n  right: initial;\n  position: absolute !important;\n  */\n}\n:host(c4d-top-nav) .cds--header__nav-caret-left,\n:host(c4d-top-nav) .cds--header__nav-caret-right,\n:host(c4d-top-nav-l1) .cds--header__nav-caret-left,\n:host(c4d-top-nav-l1) .cds--header__nav-caret-right {\n  position: relative;\n  block-size: 3rem;\n}\n:host(c4d-top-nav) .c4d-ce--header__nav-caret-container--hidden,\n:host(c4d-top-nav-l1) .c4d-ce--header__nav-caret-container--hidden {\n  position: absolute;\n  visibility: hidden;\n}\n\n:host(c4d-top-nav-l1) {\n  overflow: visible;\n}\n\n:host(c4d-top-nav-menu),\n:host(c4d-megamenu-top-nav-menu),\n:host(c4d-masthead-profile),\n:host(c4d-masthead-contact) {\n  position: relative;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true],\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true],\n:host(c4d-masthead-profile) .cds--header__menu-title[aria-expanded=true],\n:host(c4d-masthead-contact) .cds--header__menu-title[aria-expanded=true] {\n  z-index: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-masthead-profile) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-masthead-contact) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  background-color: var(--cds-background, #ffffff);\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inset-block-end: -1px;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n  :host(c4d-masthead-profile) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n  :host(c4d-masthead-contact) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n    inline-size: 100vw;\n  }\n}\n\n:host(c4d-top-nav-menu-item),\n:host(c4d-masthead-profile-item) {\n  position: relative;\n  block-size: 100%;\n}\n:host(c4d-top-nav-menu-item)::before,\n:host(c4d-masthead-profile-item)::before {\n  position: absolute;\n  block-size: 100%;\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-top-nav-menu-item):first-of-type::before,\n:host(c4d-masthead-profile-item):first-of-type::before {\n  border-block-start: none;\n}\n:host(c4d-top-nav-menu-item):hover,\n:host(c4d-masthead-profile-item):hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu-item):hover::before,\n:host(c4d-masthead-profile-item):hover::before {\n  border-block-start: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu-item):hover + li::before,\n:host(c4d-masthead-profile-item):hover + li::before {\n  border-block-start: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu-item):focus::before,\n:host(c4d-masthead-profile-item):focus::before {\n  box-sizing: border-box;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n}\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item {\n  background-color: transparent;\n  block-size: 100%;\n}\n\n:host(c4d-masthead-cart) {\n  position: relative;\n}\n:host(c4d-masthead-cart)::after {\n  position: absolute;\n  display: block;\n  border-radius: 50%;\n  background-color: var(--cds-button-primary-hover, #0050e6);\n  block-size: 10px;\n  content: \"\";\n  inline-size: 10px;\n  inset-block-start: 12px;\n  inset-inline-end: 10px;\n}\n\n:host(c4d-top-nav-item) .cds--header__menu-arrow,\n:host(c4d-top-nav-menu) .cds--header__menu-arrow,\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-arrow,\n:host(c4d-top-nav-menu-item) .cds--header__menu-arrow,\n:host(c4d-masthead-profile-item) .cds--header__menu-arrow {\n  block-size: 20px;\n  inline-size: 20px;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item,\n:host(c4d-top-nav-menu) a.cds--header__menu-item,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding: 0.8125rem 1rem;\n  border: none;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item > svg,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item > svg,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item > svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:hover,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:active,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:active {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active, :host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:hover,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:active,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:hover {\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active > svg, :host(c4d-top-nav-item) a.cds--header__menu-item:hover > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover > svg,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:active > svg,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:hover > svg,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:active > svg,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active, :host(c4d-top-nav-item) a.cds--header__menu-item:focus,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:focus,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:active,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-button-primary, #0f62fe);\n  outline-offset: -2px;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item svg,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item svg,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu-item) a.cds--header__menu-item:hover,\n:host(c4d-masthead-profile-item) a.cds--header__menu-item:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  block-size: auto;\n  inset-block-end: auto;\n  min-block-size: 0;\n}\n\n:host(c4d-left-nav) {\n  display: block;\n  overflow: hidden;\n  block-size: calc(100% - 3rem - 1px);\n  inline-size: 16rem;\n  margin-block-start: calc(var(--c4d-masthead-l0-bottom-edge, 3rem) + 1px);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-left-nav) {\n    inline-size: 100vw;\n    max-inline-size: 100vw;\n  }\n}\n:host(c4d-left-nav)[usage-mode=header-nav], :host(c4d-left-nav)[collapse-mode][usage-mode=header-nav] {\n  inset-inline-start: -100vw;\n  /* stylelint-disable-next-line  time-min-milliseconds */\n  transition: visibility 1ms cubic-bezier(0.2, 0, 1, 0.9) 110ms, left 110ms cubic-bezier(0.2, 0, 1, 0.9) 1ms;\n  visibility: hidden;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-left-nav)[usage-mode=header-nav], :host(c4d-left-nav)[collapse-mode][usage-mode=header-nav] {\n    transition: none;\n  }\n}\n:host(c4d-left-nav)[expanded][usage-mode=header-nav], :host(c4d-left-nav)[collapse-mode][expanded][usage-mode=header-nav] {\n  overflow: hidden auto;\n  inset-inline-start: 0;\n  /* stylelint-disable-next-line time-min-milliseconds */\n  transition: visibility 1ms cubic-bezier(0.2, 0, 1, 0.9) 0ms, inset-inline-start 110ms cubic-bezier(0.2, 0, 1, 0.9) 1ms;\n  visibility: visible;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-left-nav)[expanded][usage-mode=header-nav], :host(c4d-left-nav)[collapse-mode][expanded][usage-mode=header-nav] {\n    transition: none;\n  }\n}\n:host(c4d-left-nav) .cds--side-nav__wrapper {\n  display: flex;\n  flex-direction: column;\n  block-size: 100%;\n}\n:host(c4d-left-nav) .cds--side-nav__platform-name {\n  flex-grow: 0;\n  flex-shrink: 0;\n}\n:host(c4d-left-nav) .cds--side-nav__menu-sections {\n  position: relative;\n  flex-basis: 100%;\n  flex-shrink: 1;\n}\n:host(c4d-left-nav) ::slotted(c4d-left-nav-menu-section) {\n  overflow: hidden;\n  block-size: auto;\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-masthead-menu-button),\n  :host(c4d-left-nav) {\n    display: block;\n  }\n}\n\n:host(c4d-left-nav-name) .cds--side-nav__submenu-platform {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  padding: 0 1rem;\n  block-size: 3rem;\n  border-block-end: 1px solid var(--cds-border-strong-01, #8d8d8d);\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n:host(c4d-left-nav-name) .cds--side-nav__submenu-platform::after {\n  content: none;\n}\n\n:host(c4d-left-nav-item) a.cds--side-nav__link .cds--side-nav__link-text {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-left-nav-item) a.cds--side-nav__link .cds--side-nav__link-text:hover, :host(c4d-left-nav-item) a.cds--side-nav__link .cds--side-nav__link-text:focus {\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-left-nav-item):last-child a.cds--side-nav__link .cds--side-nav__link-text {\n  color: var(--cds-link-primary, #0f62fe);\n}\n:host(c4d-left-nav-item):last-child a.cds--side-nav__link .cds--side-nav__link-text:hover, :host(c4d-left-nav-item):last-child a.cds--side-nav__link .cds--side-nav__link-text:focus {\n  color: var(--cds-link-secondary, #0043ce);\n}\n\n:host(c4d-left-nav-item-highlighted) a.cds--side-nav__link,\n:host(c4d-left-nav-menu-item-highlighted) a.cds--side-nav__link,\n:host(c4d-left-nav-item) a.cds--side-nav__link,\n:host(c4d-left-nav-menu-item) a.cds--side-nav__link {\n  display: flex;\n  flex-direction: column;\n  justify-content: center;\n  block-size: 3rem;\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n}\n\n:host(c4d-left-nav-item) .cds--side-nav__link:hover,\n:host(c4d-left-nav-menu) .cds--side-nav__link:hover,\n:host(c4d-left-nav-menu-item) .cds--side-nav__link:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-left-nav-menu) .cds--side-nav__link,\n:host(c4d-left-nav-menu) .cds--side-nav__submenu,\n:host(c4d-left-nav-menu) a.cds--side-nav__link,\n:host(c4d-left-nav-menu) .cds--side-nav__submenu .cds--side-nav__submenu-content,\n:host(c4d-left-nav-menu-item) .cds--side-nav__link,\n:host(c4d-left-nav-menu-item) .cds--side-nav__submenu,\n:host(c4d-left-nav-menu-item) a.cds--side-nav__link,\n:host(c4d-left-nav-menu-item) .cds--side-nav__submenu .cds--side-nav__submenu-content,\n:host(c4d-left-nav-menu-section) .cds--side-nav__link,\n:host(c4d-left-nav-menu-section) .cds--side-nav__submenu,\n:host(c4d-left-nav-menu-section) a.cds--side-nav__link,\n:host(c4d-left-nav-menu-section) .cds--side-nav__submenu .cds--side-nav__submenu-content {\n  block-size: auto;\n  min-block-size: 3rem;\n}\n:host(c4d-left-nav-menu) .cds--side-nav__submenu-title,\n:host(c4d-left-nav-menu) a.cds--side-nav__link > .cds--side-nav__link-text,\n:host(c4d-left-nav-menu) button.cds--side-nav__link > .cds--side-nav__link-text,\n:host(c4d-left-nav-menu-item) .cds--side-nav__submenu-title,\n:host(c4d-left-nav-menu-item) a.cds--side-nav__link > .cds--side-nav__link-text,\n:host(c4d-left-nav-menu-item) button.cds--side-nav__link > .cds--side-nav__link-text,\n:host(c4d-left-nav-menu-section) .cds--side-nav__submenu-title,\n:host(c4d-left-nav-menu-section) a.cds--side-nav__link > .cds--side-nav__link-text,\n:host(c4d-left-nav-menu-section) button.cds--side-nav__link > .cds--side-nav__link-text {\n  padding: 0.8rem 0;\n  block-size: auto;\n  white-space: normal;\n}\n\n@media (max-width: 799px) {\n  :host(c4d-left-nav-overlay)[active] {\n    position: fixed;\n    z-index: calc(8000 - 1);\n    background-color: rgba(22, 22, 22, 0.5);\n    block-size: 100vh;\n    clip-path: polygon(0 0, 0 calc(var(--c4d-masthead-l0-bottom-edge, 3rem) - 3rem), 3rem calc(var(--c4d-masthead-l0-bottom-edge, 3rem) - 3rem), 3rem calc(var(--c4d-masthead-l0-bottom-edge, 3rem) + 1px), 0 calc(var(--c4d-masthead-l0-bottom-edge, 3rem) + 1px), 0 100%, 100% 100%, 100% 0, 0 0);\n    inline-size: 100%;\n    inset-block-start: 0;\n    inset-inline-start: 0;\n    opacity: 1;\n    transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  }\n}\n@media screen and (max-width: 799px) and (prefers-reduced-motion: reduce) {\n  :host(c4d-left-nav-overlay)[active] {\n    transition: none;\n  }\n}\n\n:host(c4d-left-nav-overlay[dir=rtl]) {\n  clip-path: polygon(0 0, 0 100%, 100% 100%, 100% calc(var(--c4d-masthead-l0-bottom-edge, 3rem) + 1px), calc(100% - 3rem) calc(var(--c4d-masthead-l0-bottom-edge, 3rem) + 1px), calc(100% - 3rem) calc(var(--c4d-masthead-l0-bottom-edge, 3rem) - 3rem), 100% calc(var(--c4d-masthead-l0-bottom-edge, 3rem) - 3rem), 100% 0);\n}\n\n:host(c4d-megamenu-link-with-icon):focus,\n:host(c4d-megamenu-category-link):focus {\n  outline: none;\n}\n\n:host(c4d-masthead-search-composite),\n:host(c4d-masthead-search-container) {\n  display: contents;\n}\n\n:host(c4d-megamenu),\n.cds--masthead__megamenu {\n  position: relative;\n}\n:host(c4d-megamenu)[overflowing]::after,\n.cds--masthead__megamenu[overflowing]::after {\n  position: fixed;\n  background: linear-gradient(transparent, var(--cds-background, #ffffff));\n  block-size: 3rem;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  pointer-events: none;\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container,\n.cds--masthead__megamenu .cds--masthead__megamenu__container {\n  block-size: 100%;\n  inline-size: 100%;\n  overflow-x: hidden;\n}\n\n:host(c4d-megamenu[layout=tab]) ::slotted(c4d-megamenu-left-navigation) {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n\n:host(c4d-megamenu-tabs) {\n  display: flex;\n  flex-direction: column;\n  margin-block-end: 1rem;\n}\n:host(c4d-megamenu-tabs) .cds--tabs-trigger {\n  display: none;\n}\n\n:host(c4d-megamenu-tab) {\n  outline: 0;\n}\n:host(c4d-megamenu-tab) button {\n  font-size: var(--cds-body-long-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-long-01-font-weight, 400);\n  line-height: var(--cds-body-long-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-long-01-letter-spacing, 0.16px);\n  padding: 0.375rem 1rem;\n  border: none;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  inline-size: 100%;\n  text-align: start;\n}\n:host(c4d-megamenu-tab) button:hover, :host(c4d-megamenu-tab) button:focus {\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-megamenu-tab) button:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-megamenu-tab) button:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n\n:host(c4d-megamenu-tab)[selected] button {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-megamenu-category-link-group) {\n  display: flex;\n  flex-flow: wrap;\n  justify-content: flex-start;\n}\n\n:host(c4d-megamenu-category-link) a:has([part=link-heading]) {\n  padding: 0.75rem 1rem;\n  block-size: 100%;\n}\n:host(c4d-megamenu-category-link) a:has([part=link-heading]) > span {\n  display: block;\n  max-inline-size: 17rem;\n}\n:host(c4d-megamenu-category-link) a:has([part=link-heading]):active svg, :host(c4d-megamenu-category-link) a:has([part=link-heading]):hover svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-megamenu-category-link) [part=link-heading] {\n  font-size: var(--cds-expressive-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-expressive-heading-01-font-weight, 600);\n  line-height: var(--cds-expressive-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-expressive-heading-01-letter-spacing, 0.16px);\n}\n:host(c4d-megamenu-category-link) [part=link-heading] svg {\n  margin-inline-start: 0.5rem;\n  padding-block-start: 0.125rem;\n  /* shrink SVG with padding to match font-size */\n}\n\n:host(c4d-megamenu-heading),\n:host(c4d-megamenu-category-heading) {\n  display: block;\n  padding: 0 1rem;\n}\n:host(c4d-megamenu-heading) h2,\n:host(c4d-megamenu-heading) h3,\n:host(c4d-megamenu-heading) h4,\n:host(c4d-megamenu-heading) h5,\n:host(c4d-megamenu-heading) h6,\n:host(c4d-megamenu-category-heading) h2,\n:host(c4d-megamenu-category-heading) h3,\n:host(c4d-megamenu-category-heading) h4,\n:host(c4d-megamenu-category-heading) h5,\n:host(c4d-megamenu-category-heading) h6 {\n  display: inline-block;\n  color: var(--cds-text-primary, #161616);\n  margin-block: 0;\n}\n:host(c4d-megamenu-heading) h2 a,\n:host(c4d-megamenu-heading) h3 a,\n:host(c4d-megamenu-heading) h4 a,\n:host(c4d-megamenu-heading) h5 a,\n:host(c4d-megamenu-heading) h6 a,\n:host(c4d-megamenu-category-heading) h2 a,\n:host(c4d-megamenu-category-heading) h3 a,\n:host(c4d-megamenu-category-heading) h4 a,\n:host(c4d-megamenu-category-heading) h5 a,\n:host(c4d-megamenu-category-heading) h6 a {\n  display: flex;\n  align-self: center;\n  color: inherit;\n  text-decoration: none;\n}\n:host(c4d-megamenu-heading) h2 a:hover,\n:host(c4d-megamenu-heading) h3 a:hover,\n:host(c4d-megamenu-heading) h4 a:hover,\n:host(c4d-megamenu-heading) h5 a:hover,\n:host(c4d-megamenu-heading) h6 a:hover,\n:host(c4d-megamenu-category-heading) h2 a:hover,\n:host(c4d-megamenu-category-heading) h3 a:hover,\n:host(c4d-megamenu-category-heading) h4 a:hover,\n:host(c4d-megamenu-category-heading) h5 a:hover,\n:host(c4d-megamenu-category-heading) h6 a:hover {\n  text-decoration: underline;\n}\n:host(c4d-megamenu-heading) h2 a:focus,\n:host(c4d-megamenu-heading) h3 a:focus,\n:host(c4d-megamenu-heading) h4 a:focus,\n:host(c4d-megamenu-heading) h5 a:focus,\n:host(c4d-megamenu-heading) h6 a:focus,\n:host(c4d-megamenu-category-heading) h2 a:focus,\n:host(c4d-megamenu-category-heading) h3 a:focus,\n:host(c4d-megamenu-category-heading) h4 a:focus,\n:host(c4d-megamenu-category-heading) h5 a:focus,\n:host(c4d-megamenu-category-heading) h6 a:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-megamenu-heading) h2 svg,\n:host(c4d-megamenu-heading) h3 svg,\n:host(c4d-megamenu-heading) h4 svg,\n:host(c4d-megamenu-heading) h5 svg,\n:host(c4d-megamenu-heading) h6 svg,\n:host(c4d-megamenu-category-heading) h2 svg,\n:host(c4d-megamenu-category-heading) h3 svg,\n:host(c4d-megamenu-category-heading) h4 svg,\n:host(c4d-megamenu-category-heading) h5 svg,\n:host(c4d-megamenu-category-heading) h6 svg {\n  position: relative;\n  flex-shrink: 0;\n  margin: 0 0.5rem;\n  fill: var(--cds-icon-primary, #161616);\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /*!rtl:raw:\n    transform: scaleX(-1);\n    */\n}\n:host(c4d-megamenu-heading) h2[data-has-href]:active a,\n:host(c4d-megamenu-heading) h2[data-has-href]:active ~ span, :host(c4d-megamenu-heading) h2[data-has-href]:hover a,\n:host(c4d-megamenu-heading) h2[data-has-href]:hover ~ span,\n:host(c4d-megamenu-heading) h3[data-has-href]:active a,\n:host(c4d-megamenu-heading) h3[data-has-href]:active ~ span,\n:host(c4d-megamenu-heading) h3[data-has-href]:hover a,\n:host(c4d-megamenu-heading) h3[data-has-href]:hover ~ span,\n:host(c4d-megamenu-heading) h4[data-has-href]:active a,\n:host(c4d-megamenu-heading) h4[data-has-href]:active ~ span,\n:host(c4d-megamenu-heading) h4[data-has-href]:hover a,\n:host(c4d-megamenu-heading) h4[data-has-href]:hover ~ span,\n:host(c4d-megamenu-heading) h5[data-has-href]:active a,\n:host(c4d-megamenu-heading) h5[data-has-href]:active ~ span,\n:host(c4d-megamenu-heading) h5[data-has-href]:hover a,\n:host(c4d-megamenu-heading) h5[data-has-href]:hover ~ span,\n:host(c4d-megamenu-heading) h6[data-has-href]:active a,\n:host(c4d-megamenu-heading) h6[data-has-href]:active ~ span,\n:host(c4d-megamenu-heading) h6[data-has-href]:hover a,\n:host(c4d-megamenu-heading) h6[data-has-href]:hover ~ span,\n:host(c4d-megamenu-category-heading) h2[data-has-href]:active a,\n:host(c4d-megamenu-category-heading) h2[data-has-href]:active ~ span,\n:host(c4d-megamenu-category-heading) h2[data-has-href]:hover a,\n:host(c4d-megamenu-category-heading) h2[data-has-href]:hover ~ span,\n:host(c4d-megamenu-category-heading) h3[data-has-href]:active a,\n:host(c4d-megamenu-category-heading) h3[data-has-href]:active ~ span,\n:host(c4d-megamenu-category-heading) h3[data-has-href]:hover a,\n:host(c4d-megamenu-category-heading) h3[data-has-href]:hover ~ span,\n:host(c4d-megamenu-category-heading) h4[data-has-href]:active a,\n:host(c4d-megamenu-category-heading) h4[data-has-href]:active ~ span,\n:host(c4d-megamenu-category-heading) h4[data-has-href]:hover a,\n:host(c4d-megamenu-category-heading) h4[data-has-href]:hover ~ span,\n:host(c4d-megamenu-category-heading) h5[data-has-href]:active a,\n:host(c4d-megamenu-category-heading) h5[data-has-href]:active ~ span,\n:host(c4d-megamenu-category-heading) h5[data-has-href]:hover a,\n:host(c4d-megamenu-category-heading) h5[data-has-href]:hover ~ span,\n:host(c4d-megamenu-category-heading) h6[data-has-href]:active a,\n:host(c4d-megamenu-category-heading) h6[data-has-href]:active ~ span,\n:host(c4d-megamenu-category-heading) h6[data-has-href]:hover a,\n:host(c4d-megamenu-category-heading) h6[data-has-href]:hover ~ span {\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-megamenu-heading) h2[data-has-href]:active svg, :host(c4d-megamenu-heading) h2[data-has-href]:hover svg,\n:host(c4d-megamenu-heading) h3[data-has-href]:active svg,\n:host(c4d-megamenu-heading) h3[data-has-href]:hover svg,\n:host(c4d-megamenu-heading) h4[data-has-href]:active svg,\n:host(c4d-megamenu-heading) h4[data-has-href]:hover svg,\n:host(c4d-megamenu-heading) h5[data-has-href]:active svg,\n:host(c4d-megamenu-heading) h5[data-has-href]:hover svg,\n:host(c4d-megamenu-heading) h6[data-has-href]:active svg,\n:host(c4d-megamenu-heading) h6[data-has-href]:hover svg,\n:host(c4d-megamenu-category-heading) h2[data-has-href]:active svg,\n:host(c4d-megamenu-category-heading) h2[data-has-href]:hover svg,\n:host(c4d-megamenu-category-heading) h3[data-has-href]:active svg,\n:host(c4d-megamenu-category-heading) h3[data-has-href]:hover svg,\n:host(c4d-megamenu-category-heading) h4[data-has-href]:active svg,\n:host(c4d-megamenu-category-heading) h4[data-has-href]:hover svg,\n:host(c4d-megamenu-category-heading) h5[data-has-href]:active svg,\n:host(c4d-megamenu-category-heading) h5[data-has-href]:hover svg,\n:host(c4d-megamenu-category-heading) h6[data-has-href]:active svg,\n:host(c4d-megamenu-category-heading) h6[data-has-href]:hover svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-megamenu-heading) > span,\n:host(c4d-megamenu-category-heading) > span {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  color: var(--cds-text-secondary, #525252);\n  margin-block-start: 0.5rem;\n}\n:host(c4d-megamenu-heading) > span[data-has-content],\n:host(c4d-megamenu-category-heading) > span[data-has-content] {\n  margin-block-end: 1.5rem;\n}\n\n:host(c4d-megamenu-heading) {\n  margin-block-end: 1.5rem;\n}\n:host(c4d-megamenu-heading) h2,\n:host(c4d-megamenu-heading) h3,\n:host(c4d-megamenu-heading) h4,\n:host(c4d-megamenu-heading) h5,\n:host(c4d-megamenu-heading) h6 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n:host(c4d-megamenu-heading) h2 svg,\n:host(c4d-megamenu-heading) h3 svg,\n:host(c4d-megamenu-heading) h4 svg,\n:host(c4d-megamenu-heading) h5 svg,\n:host(c4d-megamenu-heading) h6 svg {\n  inset-block-start: 0.5rem;\n}\n\n:host(c4d-megamenu-category-heading) {\n  margin-block-end: 1rem;\n}\n:host(c4d-megamenu-category-heading) h2,\n:host(c4d-megamenu-category-heading) h3,\n:host(c4d-megamenu-category-heading) h4,\n:host(c4d-megamenu-category-heading) h5,\n:host(c4d-megamenu-category-heading) h6 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n:host(c4d-megamenu-category-heading) h2 svg,\n:host(c4d-megamenu-category-heading) h3 svg,\n:host(c4d-megamenu-category-heading) h4 svg,\n:host(c4d-megamenu-category-heading) h5 svg,\n:host(c4d-megamenu-category-heading) h6 svg {\n  inset-block-start: 0.25rem;\n}\n\n:host(c4d-megamenu-category-heading.has-content) {\n  margin-block-end: 1.5rem;\n}"]);

let _$u = t => t,
  _t$v;
function _decorate$w(e, r, t, i) { var o = _getDecoratorsApi$w(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$w(s.d.map(_createElementDescriptor$w)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$w() { _getDecoratorsApi$w = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$w(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$w(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$w(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$w(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$w(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$w(e) { var r, t = _toPropertyKey$w(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$w(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$w(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$w(o.descriptor) || _isDataDescriptor$w(i.descriptor)) { if (_hasDecorators$w(o) || _hasDecorators$w(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$w(o)) { if (_hasDecorators$w(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$w(o, i); } } else r.push(o); } return r; }
function _hasDecorators$w(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$w(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$w(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$w(t) { var i = _toPrimitive$w(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$w(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$w(r) { return _arrayWithHoles$x(r) || _iterableToArray$w(r) || _unsupportedIterableToArray$x(r) || _nonIterableRest$x(); }
function _nonIterableRest$x() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$x(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$x(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$x(r, a) : void 0; } }
function _arrayLikeToArray$x(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$w(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$x(r) { if (Array.isArray(r)) return r; }
function _superPropGet$k(t, e, r, o) { var p = _get$f(_getPrototypeOf$f(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$f() { return _get$f = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$f(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$f.apply(null, arguments); }
function _superPropBase$f(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$f(t));); return t; }
function _getPrototypeOf$f(t) { return _getPrototypeOf$f = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$f(t); }
const {
  stablePrefix: c4dPrefix$w
} = settings;

/**
 * Megamenu link with icon.
 *
 * @element c4d-megamenu-link-with-icon
 */
let C4DMegaMenuLinkWithIcon = _decorate$w([carbonElement(`${c4dPrefix$w}-megamenu-link-with-icon`)], function (_initialize, _CDSLink) {
  class C4DMegaMenuLinkWithIcon extends _CDSLink {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuLinkWithIcon,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'style-scheme'
      })],
      key: "styleScheme",
      value() {
        return MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME.DEFAULT;
      }
    }, {
      kind: "get",
      static: true,
      key: "styles",
      value:
      /**
       * link title.
       */

      // `styles` here is a `CSSResult` generated by custom WebPack loader
      function () {
        return i$4(_t$v || (_t$v = _$u`
      ${0}${0}
    `), _superPropGet$k(C4DMegaMenuLinkWithIcon, "styles", this), styles$8);
      }
    }]
  };
}, CDSLink);

var megamenuLinkWithIcon = /*#__PURE__*/Object.freeze({
  __proto__: null,
  get MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME () { return MEGAMENU_LINK_WITH_ICON_STYLE_SCHEME; },
  'default': C4DMegaMenuLinkWithIcon
});

let _$t = t => t,
  _t$u;
function _decorate$v(e, r, t, i) { var o = _getDecoratorsApi$v(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$v(s.d.map(_createElementDescriptor$v)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$v() { _getDecoratorsApi$v = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$v(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$v(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$v(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$v(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$v(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$v(e) { var r, t = _toPropertyKey$v(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$v(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$v(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$v(o.descriptor) || _isDataDescriptor$v(i.descriptor)) { if (_hasDecorators$v(o) || _hasDecorators$v(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$v(o)) { if (_hasDecorators$v(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$v(o, i); } } else r.push(o); } return r; }
function _hasDecorators$v(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$v(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$v(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$v(t) { var i = _toPrimitive$v(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$v(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$v(r) { return _arrayWithHoles$w(r) || _iterableToArray$v(r) || _unsupportedIterableToArray$w(r) || _nonIterableRest$w(); }
function _nonIterableRest$w() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$w(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$w(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$w(r, a) : void 0; } }
function _arrayLikeToArray$w(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$v(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$w(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$j,
  stablePrefix: c4dPrefix$v
} = settings;

/**
 * MegaMenu right navigation section
 *
 * @element c4d-megamenu-right-navigation
 * @csspart container - The container for the megamenu. Usage: `c4d-megamenu-right-navigation::part(container)`
 * @csspart container-inner - The inner container of the megamenu. Usage: `c4d-megamenu-right-navigation::part(container-inner)`
 * @csspart heading - The heading of the megamenu. Usage: `c4d-megamenu-right-navigation::part(heading)`
 * @csspart categories - The categories section of the megamenu. Usage: `c4d-megamenu-right-navigation::part(categories)`
 * @csspart view-all - The view all section of the megamenu. Usage: `c4d-megamenu-right-navigation::part(view-all)`
 * @csspart view-all-border - The border for the view all section. Usage: `c4d-megamenu-right-navigation::part(view-all-border)`
 */
let C4DMegaMenuRightNavigation = _decorate$v([carbonElement(`${c4dPrefix$v}-megamenu-right-navigation`)], function (_initialize, _StableSelectorMixin) {
  class C4DMegaMenuRightNavigation extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuRightNavigation,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'style-scheme'
      })],
      key: "styleScheme",
      value() {
        return MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.FULL;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'data-child-count',
        reflect: true
      })],
      key: "childCount",
      value: void 0
    }, {
      kind: "method",
      key: "_getClassNames",
      value:
      /**
       * `true` to render left (highlighted) section layout.
       */

      /**
       * Returns a class-name(s) for megamenu container
       */
      function _getClassNames() {
        return o$2({
          [`${prefix$j}--masthead__megamenu-container`]: true,
          [`${prefix$j}--masthead__megamenu-container--has-sidebar`]: this.styleScheme === MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.HAS_SIDEBAR
        });
      }

      /**
       * Handles default slot content changes.
       *
       * @param event Event
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange(event) {
        const {
          onlyChildClassName
        } = this.constructor;
        const children = event.target.assignedElements();
        this.childCount = children.length;

        // Supports alternative layout for single items.
        if (children.length === 1 && onlyChildClassName) {
          children[0].classList.add(onlyChildClassName);
        } else if (children[0].classList.contains(onlyChildClassName)) {
          children[0].classList.remove(onlyChildClassName);
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated() {
        var _this$shadowRoot, _this$shadowRoot2;
        const hasViewAll = ((_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector('slot[name="view-all"]')).assignedElements().length > 0;
        (_this$shadowRoot2 = this.shadowRoot) === null || _this$shadowRoot2 === void 0 || (_this$shadowRoot2 = _this$shadowRoot2.querySelector(`.${prefix$j}--masthead__megamenu-container`)) === null || _this$shadowRoot2 === void 0 || _this$shadowRoot2.classList.toggle(`${prefix$j}--masthead__megamenu-container--has-view-all-link`, hasViewAll);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$u || (_t$u = _$t`
      <div part="container" class="${0}">
        <div
          part="container-inner"
          class="${0}--masthead__megamenu-container-inner">
          <div part="heading" class="${0}--masthead__megamenu__heading">
            <slot name="heading"></slot>
          </div>
          <div
            part="categories"
            class="${0}--masthead__megamenu__categories">
            <slot @slotchange="${0}"></slot>
          </div>
        </div>
        <div part="view-all" class="${0}--masthead__megamenu__view-all">
          <span
            part="view-all-border"
            class="${0}--masthead__megamenu__view-all__border"></span>
          <slot name="view-all"></slot>
        </div>
      </div>
    `), this._getClassNames(), prefix$j, prefix$j, prefix$j, this._handleSlotChange, prefix$j, prefix$j);
      }
    }, {
      kind: "get",
      static: true,
      key: "onlyChildClassName",
      value: function () {
        return 'only-child';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$v}--masthead__megamenu-right-navigation`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(s));

(function() {
    const env = {"C4D_CONTENT_BLOCK_HEADLINES":"true","C4D_CONTENT_BLOCK_CARD_STATIC":"true","C4D_CLOUD_MASTHEAD":"true"};
    try {
        if (process) {
            process.env = Object.assign({}, process.env);
            Object.assign(process.env, env);
            return;
        }
    } catch (e) {} // avoid ReferenceError: process is not defined
    globalThis.process = { env:env };
})();

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * This file contains the list of the default values of compile-time feature flags.
 */

/**
 * This flag will determine if all feature flags should be enabled
 *
 * @type {boolean}
 */
const C4D_FLAGS_ALL = process.env.C4D_FLAGS_ALL === 'true' || false;

/**
 * Enables Content Block - Headline
 *
 * @type {boolean}
 */
process.env.C4D_CONTENT_BLOCK_HEADLINES === 'true' || C4D_FLAGS_ALL || false;

/**
 * Enables Content Block - Card static
 *
 * @type {boolean}
 */
process.env.C4D_CONTENT_BLOCK_CARD_STATIC === 'true' || C4D_FLAGS_ALL || false;

/**
 * Enables scoped search in the Masthead search
 *
 * @type {boolean}
 */
process.env.C4D_SCOPED_SEARCH === 'true' || C4D_FLAGS_ALL || false;

/**
 * Enables custom profile login url in Masthead
 *
 * @type {boolean}
 */
const C4D_CUSTOM_PROFILE_LOGIN = process.env.C4D_CUSTOM_PROFILE_LOGIN === 'true' || C4D_FLAGS_ALL || false;

/**
 * Enables Pricing Table
 *
 * @type {boolean}
 */
process.env.C4D_PRICING_TABLE === 'true' || C4D_FLAGS_ALL || false;

/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultIBMdotcomIcon = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" ...="${spread(
    attrs
  )}" aria-hidden="true" width="58px" height="23px" viewBox="0 0 58 23">${children}<g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"><g id="ibm-8-bar-logo--h15-copy"><path d="M58,21.4666667 L58,23 L50.3684211,23 L50.3684211,21.4666667 L58,21.4666667 Z M39.6842105,21.4666667 L39.6842105,23 L32.0526316,23 L32.0526316,21.4666667 L39.6842105,21.4666667 Z M45.6385329,21.4666667 L45.0245693,23 L44.41871,21.4666667 L45.6385329,21.4666667 Z M28.5421053,21.4666667 C27.4471432,22.4188667 26.0029202,23 24.3905263,23 L24.3905263,23 L12.2105263,23 L12.2105263,21.4666667 Z M10.6842105,21.4666667 L10.6842105,23 L0,23 L0,21.4666667 L10.6842105,21.4666667 Z M39.6842105,18.4 L39.6842105,19.9333333 L32.0526316,19.9333333 L32.0526316,18.4 L39.6842105,18.4 Z M46.8318522,18.4 L46.2377311,19.9333333 L43.8212353,19.9333333 L43.2226426,18.4 L46.8318522,18.4 Z M30.0684211,18.4 C29.9306437,18.9451697 29.7105614,19.4599515 29.4273684,19.9333333 L29.4273684,19.9333333 L12.2105263,19.9333333 L12.2105263,18.4 Z M10.6842105,18.4 L10.6842105,19.9333333 L0,19.9333333 L0,18.4 L10.6842105,18.4 Z M58,18.4 L58,19.9333333 L50.3684211,19.9333333 L50.3684211,18.4 L58,18.4 Z M54.9473684,15.3333333 L54.9473684,16.8666667 L50.3684211,16.8666667 L50.3684211,15.3333333 L54.9473684,15.3333333 Z M39.6842105,15.3333333 L39.6842105,16.8666667 L35.1052632,16.8666667 L35.1052632,15.3333333 L39.6842105,15.3333333 Z M48.0292704,15.3333333 L47.4295831,16.8666667 L42.6233978,16.8666667 L42.019006,15.3333333 L48.0292704,15.3333333 Z M29.8547368,15.3333333 C29.991899,15.8221879 30.0684211,16.3357152 30.0684211,16.8666667 L30.0684211,16.8666667 L24.4210526,16.8666667 L24.4210526,15.3333333 Z M19.8421053,15.3333333 L19.8421053,16.8666667 L15.2631579,16.8666667 L15.2631579,15.3333333 L19.8421053,15.3333333 Z M7.63157895,15.3333333 L7.63157895,16.8666667 L3.05263158,16.8666667 L3.05263158,15.3333333 L7.63157895,15.3333333 Z M54.9473684,12.2666667 L54.9473684,13.8 L50.3684211,13.8 L50.3684211,12.2666667 L54.9473684,12.2666667 Z M39.6842105,12.2666667 L39.6842105,13.8 L35.1052632,13.8 L35.1052632,12.2666667 L39.6842105,12.2666667 Z M49.2252679,12.2666667 L48.6284686,13.8 L41.4089474,13.8 L40.8168134,12.2666667 L49.2252679,12.2666667 Z M27.9773684,12.2666667 C28.5037637,12.6994848 28.9570701,13.2181697 29.3052632,13.8 L29.3052632,13.8 L15.2631579,13.8 L15.2631579,12.2666667 Z M7.63157895,12.2666667 L7.63157895,13.8 L3.05263158,13.8 L3.05263158,12.2666667 L7.63157895,12.2666667 Z M44.5987396,9.2 L45.0263158,10.4393515 L45.4535426,9.2 L54.9473684,9.2 L54.9473684,10.7333333 L50.3684211,10.7333333 L50.3684211,9.32433939 L49.8494737,10.7333333 L40.1878947,10.7333333 L39.6842105,9.3242 L39.6842105,10.7333333 L35.1052632,10.7333333 L35.1052632,9.2 L44.5987396,9.2 Z M7.63157895,9.2 L7.63157895,10.7333333 L3.05263158,10.7333333 L3.05263158,9.2 L7.63157895,9.2 Z M29.3052632,9.2 C28.9570701,9.7818303 28.5037637,10.3003758 27.9773684,10.7333333 L27.9773684,10.7333333 L15.2631579,10.7333333 L15.2631579,9.2 Z M54.9473684,6.13333333 L54.9473684,7.66666667 L45.9831118,7.66666667 L46.5234001,6.13333333 L54.9473684,6.13333333 Z M43.534302,6.13333333 L44.0745993,7.66666667 L35.1052632,7.66666667 L35.1052632,6.13333333 L43.534302,6.13333333 Z M30.0684211,6.13333333 C30.0684211,6.66414545 29.991899,7.17767273 29.8547368,7.66666667 L29.8547368,7.66666667 L24.4210526,7.66666667 L24.4210526,6.13333333 Z M19.8421053,6.13333333 L19.8421053,7.66666667 L15.2631579,7.66666667 L15.2631579,6.13333333 L19.8421053,6.13333333 Z M7.63157895,6.13333333 L7.63157895,7.66666667 L3.05263158,7.66666667 L3.05263158,6.13333333 L7.63157895,6.13333333 Z M42.4774196,3.06666667 L43.0079113,4.6 L32.0527757,4.6 L32.0526316,3.06666667 L42.4774196,3.06666667 Z M58,3.06666667 L58,4.6 L47.0390632,4.6 L47.5903678,3.06666667 L58,3.06666667 Z M29.4273684,3.06666667 C29.7105614,3.54004848 29.9306437,4.0548303 30.0684211,4.6 L30.0684211,4.6 L12.2105263,4.6 L12.2105263,3.06666667 Z M10.6842105,3.06666667 L10.6842105,4.6 L0,4.6 L0,3.06666667 L10.6842105,3.06666667 Z M41.4056725,0 L41.9462722,1.53333333 L32.05278,1.53333333 L32.0526316,0 L41.4056725,0 Z M58,0 L58,1.53333333 L48.1188427,1.53333333 L48.6466706,0 L58,0 Z M24.3905263,0 C25.9912083,0 27.4472798,0.581133333 28.5421053,1.53333333 L28.5421053,1.53333333 L12.2105263,1.53333333 L12.2105263,0 Z M10.6842105,0 L10.6842105,1.53333333 L0,1.53333333 L0,0 L10.6842105,0 Z" id="Combined-Shape"></path></g></g></svg>`;

let _$s = t => t,
  _t$t;
function _decorate$u(e, r, t, i) { var o = _getDecoratorsApi$u(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$u(s.d.map(_createElementDescriptor$u)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$u() { _getDecoratorsApi$u = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$u(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$u(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$u(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$u(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$u(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$u(e) { var r, t = _toPropertyKey$u(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$u(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$u(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$u(o.descriptor) || _isDataDescriptor$u(i.descriptor)) { if (_hasDecorators$u(o) || _hasDecorators$u(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$u(o)) { if (_hasDecorators$u(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$u(o, i); } } else r.push(o); } return r; }
function _hasDecorators$u(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$u(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$u(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$u(t) { var i = _toPrimitive$u(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$u(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$u(r) { return _arrayWithHoles$v(r) || _iterableToArray$u(r) || _unsupportedIterableToArray$v(r) || _nonIterableRest$v(); }
function _nonIterableRest$v() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$v(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$v(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$v(r, a) : void 0; } }
function _arrayLikeToArray$v(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$u(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$v(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$i,
  stablePrefix: c4dPrefix$u
} = settings;

/**
 * The IBM logo UI in masthead.
 *
 * @element c4d-masthead-logo
 */
let C4DMastheadLogo = _decorate$u([carbonElement(`${c4dPrefix$u}-masthead-logo`)], function (_initialize, _FocusMixin) {
  class C4DMastheadLogo extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadLogo,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_hasSearchActive",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventToggleSearch')],
      key: "_handleSearchToggle",
      value() {
        return event => {
          if (event.detail.active !== undefined) {
            this._hasSearchActive = event.detail.active;
          }
        };
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'hide-logo'
      })],
      key: "hideLogo",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value() {
        return this.constructor.hrefDefault;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'brand';
      }
    }, {
      kind: "method",
      key: "_renderInner",
      value:
      /**
       * Search bar opened flag.
       */

      /**
       * Handles toggle event from the search component.
       *
       * @param event The event.
       */

      /**
       * `true` to hide the logo at render
       */

      /**
       * Link `href`.
       */

      /**
       * The shadow slot this logo UI should be in.
       */

      // eslint-disable-next-line class-methods-use-this
      function _renderInner() {
        return x(_t$t || (_t$t = _$s` <slot>${0}</slot> `), svgResultIBMdotcomIcon());
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        const {
          _linkNode: linkNode
        } = this;
        if (changedProperties.has('hideLogo')) {
          this._hasSearchActive = this.hideLogo;
        }
        if (linkNode) {
          linkNode.setAttribute('aria-label', 'IBM logo');
          linkNode.classList.remove(`${prefix$i}--link`);
          linkNode.classList.toggle(`${c4dPrefix$u}-ce--header__logo--has-search-active`, this._hasSearchActive);
        }
      }

      /**
       * The default value to use for hrefs.
       */
    }, {
      kind: "get",
      static: true,
      key: "hrefDefault",
      value: function () {
        return 'https://www.ibm.com/';
      }

      /**
       * The name of the custom event fired after the seach is toggled.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggleSearch",
      value: function () {
        return `${c4dPrefix$u}-search-with-typeahead-toggled`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$u}--masthead-logo`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, FocusMixin(HostListenerMixin(StableSelectorMixin(CDSLink))));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$f = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 16 16">${children}${children}<path d="M5 8L10 3 10.7 3.7 6.4 8 10.7 12.3 10 13z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2022, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Navigation direction, associated with key symbols.
 */
const NAVIGATION_DIRECTION = {
  Left: -1,
  ArrowLeft: -1,
  Right: 1,
  ArrowRight: 1
};

/**
 * Button size.
 */
let CONTENT_SWITCHER_SIZE;
(function (CONTENT_SWITCHER_SIZE) {
  CONTENT_SWITCHER_SIZE["REGULAR"] = "";
  CONTENT_SWITCHER_SIZE["SMALL"] = "sm";
  CONTENT_SWITCHER_SIZE["LARGE"] = "lg";
  CONTENT_SWITCHER_SIZE["EXTRA_LARGE"] = "xl";
})(CONTENT_SWITCHER_SIZE || (CONTENT_SWITCHER_SIZE = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$7 = i$4([
  '.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm,:host(cds-content-switcher[size=sm]){--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg,:host(cds-content-switcher[size=lg]){--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--popover-container{display:inline-block}.cds--popover-container:not(.cds--popover--auto-align){position:relative}.cds--popover--high-contrast .cds--popover{--cds-popover-background-color:var(--cds-background-inverse, #393939);--cds-popover-text-color:var(--cds-text-inverse, #ffffff)}.cds--popover--drop-shadow .cds--popover{--cds-popover-drop-shadow:drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2))}.cds--popover--caret{--cds-popover-offset:0.625rem}.cds--popover{position:absolute;z-index:6000;filter:var(--cds-popover-drop-shadow, none);inset:0;pointer-events:none}.cds--popover-content{--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:6000;display:none;border-radius:var(--cds-popover-border-radius,2px);background-color:var(--cds-popover-background-color,var(--cds-layer));color:var(--cds-popover-text-color,var(--cds-text-primary,#161616));inline-size:-moz-max-content;inline-size:max-content;max-inline-size:23rem;pointer-events:auto}.cds--layout--size-sm .cds--popover-content,:host(cds-content-switcher[size=sm]) .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--popover-content,:host(cds-content-switcher[size=lg]) .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--popover-content *,.cds--popover-content ::after,.cds--popover-content ::before{box-sizing:inherit}.cds--popover--open>.cds--popover>.cds--popover-content{display:block}.cds--popover-content::before{position:absolute;display:none;content:""}.cds--popover--open>.cds--popover>.cds--popover-content::before{display:block}.cds--popover--auto-align.cds--popover-caret,.cds--popover-caret{position:absolute;z-index:6000;display:none;background-color:var(--cds-popover-background-color,var(--cds-layer));will-change:transform}.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-caret{display:block}.cds--popover--auto-align.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-content>.cds--popover-caret{display:block}.cds--popover--tab-tip>.cds--popover>.cds--popover-caret{display:none}.cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(100% + var(--cds-popover-offset,0)))}.cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--bottom-end>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-left>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-right>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-start>.cds--popover>.cds--popover-content::before,.cds--popover--bottom>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-start:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(-100%)}.cds--popover--bottom-end>.cds--popover>.cds--popover-caret,.cds--popover--bottom-left>.cds--popover>.cds--popover-caret,.cds--popover--bottom-right>.cds--popover>.cds--popover-caret,.cds--popover--bottom-start>.cds--popover>.cds--popover-caret,.cds--popover--bottom>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,var(--cds-popover-offset,0))}[dir=rtl] .cds--popover--bottom-end>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-left>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-right>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-start>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom>.cds--popover>.cds--popover-caret{transform:translate(50%,var(--cds-popover-offset,0))}.cds--popover--bottom-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(-100% - var(--cds-popover-offset,0)))}.cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--top-end>.cds--popover>.cds--popover-content::before,.cds--popover--top-left>.cds--popover>.cds--popover-content::before,.cds--popover--top-right>.cds--popover>.cds--popover-content::before,.cds--popover--top-start>.cds--popover>.cds--popover-content::before,.cds--popover--top>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-end:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--popover--top-end>.cds--popover>.cds--popover-caret,.cds--popover--top-left>.cds--popover>.cds--popover-caret,.cds--popover--top-right>.cds--popover>.cds--popover-caret,.cds--popover--top-start>.cds--popover>.cds--popover-caret,.cds--popover--top>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-1 * var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{transform:translate(50%,calc(-1 * var(--cds-popover-offset,0)))}.cds--popover--top-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),-50%)}.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) * -1 - 16px))}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--right-end>.cds--popover>.cds--popover-content::before,.cds--popover--right-start>.cds--popover>.cds--popover-content::before,.cds--popover--right-top>.cds--popover>.cds--popover-content::before,.cds--popover--right>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-start:0;transform:translateX(-100%)}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-start:100%;transform:translate(calc(var(--cds-popover-offset,0) - 100%),-50%)}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + .1px),-50%)}.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-.5 * var(--cds-popover-offset,0) - 16px))}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--left-end>.cds--popover>.cds--popover-content::before,.cds--popover--left-start>.cds--popover>.cds--popover-content::before,.cds--popover--left-top>.cds--popover>.cds--popover-content::before,.cds--popover--left>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-end:0;transform:translateX(100%)}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + 100%),-50%)}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--tab-tip>.cds--popover>.cds--popover-content{border-radius:0}.cds--popover--tab-tip .cds--popover{will-change:filter}.cds--popover--tab-tip__button{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;align-items:center;justify-content:center;block-size:2rem;inline-size:2rem}.cds--popover--tab-tip__button *,.cds--popover--tab-tip__button ::after,.cds--popover--tab-tip__button ::before{box-sizing:inherit}.cds--popover--tab-tip__button::-moz-focus-inner{border:0}.cds--popover--tab-tip__button:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--popover--tab-tip__button:focus{outline-style:dotted}}.cds--popover--tab-tip__button:hover{background-color:var(--cds-layer-hover)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button{background:var(--cds-layer);box-shadow:0 2px 2px rgba(0,0,0,.2)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after{position:absolute;z-index:6001;background:var(--cds-layer);block-size:2px;content:"";inline-size:100%;inset-block-end:0}.cds--popover--tab-tip__button svg{fill:var(--cds-icon-primary,#161616)}.cds--tooltip{--cds-popover-offset:12px}.cds--tooltip-content{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:var(--cds-tooltip-padding-block,1rem) var(--cds-tooltip-padding-inline,1rem);color:var(--cds-text-inverse,#fff);max-inline-size:18rem}.cds--icon-tooltip{--cds-tooltip-padding-block:0.125rem;--cds-popover-caret-width:0.5rem;--cds-popover-caret-height:0.25rem;--cds-popover-offset:0.5rem}.cds--icon-tooltip .cds--tooltip-content{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--definition-term{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;border-radius:0;border-block-end:1px dotted var(--cds-border-strong);color:var(--cds-text-primary,#161616)}.cds--definition-term *,.cds--definition-term ::after,.cds--definition-term ::before{box-sizing:inherit}.cds--definition-term::-moz-focus-inner{border:0}.cds--definition-term:focus{outline:1px solid var(--cds-focus,#0f62fe);border-block-end-color:var(--cds-border-interactive,#0f62fe)}@media screen and (prefers-contrast){.cds--definition-term:focus{outline-style:dotted}}.cds--definition-term:hover{border-block-end-color:var(--cds-border-interactive,#0f62fe)}.cds--definition-tooltip{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:.5rem 1rem;max-inline-size:11rem}.cds--btn{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));--temp-1lh:(\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );--temp-expressive-1lh:(\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );--temp-padding-block-max:calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:inline-flex;flex-shrink:0;justify-content:space-between;border-radius:0;margin:0;cursor:pointer;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:20rem;min-block-size:var(--cds-layout-size-height-local);outline:0;padding-block:min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - .0625rem,var(--temp-padding-block-max));padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - .0625rem);padding-inline-start:calc(var(--cds-layout-density-padding-inline-local) - .0625rem);text-align:start;text-decoration:none;transition:background 70ms cubic-bezier(0,0,.38,.9),box-shadow 70ms cubic-bezier(0,0,.38,.9),border-color 70ms cubic-bezier(0,0,.38,.9),outline 70ms cubic-bezier(0,0,.38,.9);vertical-align:top}.cds--btn *,.cds--btn ::after,.cds--btn ::before{box-sizing:inherit}.cds--btn.cds--btn--disabled,.cds--btn.cds--btn--disabled:focus,.cds--btn.cds--btn--disabled:hover,.cds--btn:disabled,.cds--btn:focus:disabled,.cds--btn:hover:disabled{border-color:var(--cds-button-disabled,#c6c6c6);background:var(--cds-button-disabled,#c6c6c6);box-shadow:none;color:var(--cds-text-on-color-disabled,#8d8d8d);cursor:not-allowed}.cds--btn .cds--btn__icon{position:absolute;flex-shrink:0;block-size:1rem;inline-size:1rem;inset-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max));inset-inline-end:var(--cds-layout-density-padding-inline-local);margin-block-start:.0625rem}.cds--btn::-moz-focus-inner{padding:0;border:0}.cds--btn--primary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-primary,#0f62fe);color:var(--cds-text-on-color,#fff)}.cds--btn--primary:hover{background-color:var(--cds-button-primary-hover,#0050e6)}.cds--btn--primary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--primary:active{background-color:var(--cds-button-primary-active,#002d9c)}.cds--btn--primary .cds--btn__icon,.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--primary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--secondary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-secondary,#393939);color:var(--cds-text-on-color,#fff)}.cds--btn--secondary:hover{background-color:var(--cds-button-secondary-hover,#474747)}.cds--btn--secondary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--secondary:active{background-color:var(--cds-button-secondary-active,#6f6f6f)}.cds--btn--secondary .cds--btn__icon,.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--secondary:focus,.cds--btn--secondary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-tertiary,#0f62fe);background-color:transparent;color:var(--cds-button-tertiary,#0f62fe)}.cds--btn--tertiary:hover{background-color:var(--cds-button-tertiary-hover,#0050e6)}.cds--btn--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--tertiary:active{background-color:var(--cds-button-tertiary-active,#002d9c)}.cds--btn--tertiary .cds--btn__icon,.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--tertiary:hover{color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:focus{background-color:var(--cds-button-tertiary,#0f62fe);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:active{border-color:transparent;background-color:var(--cds-button-tertiary-active,#002d9c);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary.cds--btn--disabled,.cds--btn--tertiary.cds--btn--disabled:focus,.cds--btn--tertiary.cds--btn--disabled:hover,.cds--btn--tertiary:disabled,.cds--btn--tertiary:focus:disabled,.cds--btn--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-link-primary,#0f62fe);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--ghost:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--btn--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost .cds--btn__icon,.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--ghost:active,.cds--btn--ghost:hover{color:var(--cds-link-primary-hover,#0043ce)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost.cds--btn--disabled,.cds--btn--ghost.cds--btn--disabled:focus,.cds--btn--ghost.cds--btn--disabled:hover,.cds--btn--ghost:disabled,.cds--btn--ghost:focus:disabled,.cds--btn--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost:not([disabled]) svg{fill:var(--cds-icon-primary,#161616)}.cds--btn--icon-only{justify-content:center;padding:0;block-size:var(--cds-layout-size-height-local);inline-size:var(--cds-layout-size-height-local);padding-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only>:first-child{margin-block-start:.0625rem;min-inline-size:1rem}.cds--btn--icon-only .cds--btn__icon{position:static}.cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon{margin:0}.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon{margin-block-start:0}.cds--btn--icon-only.cds--btn--selected{background:var(--cds-background-selected,rgba(141,141,141,.2))}.cds--btn path[data-icon-path=inner-path]{fill:none}.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:var(--cds-icon-primary,#161616)}.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn--ghost.cds--btn--icon-only[disabled]{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled]{pointer-events:none}.cds--btn--danger{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger .cds--btn__icon,.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-danger-secondary,#da1e28);background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28)}.cds--btn--danger--tertiary:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--tertiary:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--tertiary .cds--btn__icon,.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--tertiary:hover{border-color:var(--cds-button-danger-hover,#b81921);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:focus{background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:active{border-color:var(--cds-button-danger-active,#750e13);background-color:var(--cds-button-danger-active,#750e13);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary.cds--btn--disabled,.cds--btn--danger--tertiary.cds--btn--disabled:focus,.cds--btn--danger--tertiary.cds--btn--disabled:hover,.cds--btn--danger--tertiary:disabled,.cds--btn--danger--tertiary:focus:disabled,.cds--btn--danger--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--danger--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--danger--ghost:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--ghost:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--danger--ghost:active,.cds--btn--danger--ghost:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--ghost.cds--btn--disabled,.cds--btn--danger--ghost.cds--btn--disabled:focus,.cds--btn--danger--ghost.cds--btn--disabled:hover,.cds--btn--danger--ghost:disabled,.cds--btn--danger--ghost:focus:disabled,.cds--btn--danger--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--btn--expressive{font-size:var(--cds-body-compact-02-font-size,1rem);font-weight:var(--cds-body-compact-02-font-weight,400);line-height:var(--cds-body-compact-02-line-height,1.375);letter-spacing:var(--cds-body-compact-02-letter-spacing,0);padding-block:min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only.cds--btn--expressive{padding:12px 13px}.cds--btn.cds--btn--expressive .cds--btn__icon{block-size:1.25rem;inline-size:1.25rem}.cds--btn-set .cds--btn.cds--btn--expressive{max-inline-size:20rem}.cds--btn.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:9.375rem}.cds--btn.cds--skeleton:active,.cds--btn.cds--skeleton:focus,.cds--btn.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--btn.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--btn.cds--skeleton::before{animation:none}}.cds--btn-set{display:flex}.cds--btn-set--stacked{flex-direction:column}.cds--btn-set .cds--btn{inline-size:100%;max-inline-size:12.25rem}.cds--btn-set .cds--btn:not(:focus){box-shadow:-.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn:focus+.cds--btn{box-shadow:inherit}.cds--btn-set--stacked .cds--btn:not(:focus){box-shadow:0 -.0625rem 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn.cds--btn--disabled{box-shadow:-.0625rem 0 0 0 var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set--stacked .cds--btn.cds--btn--disabled{box-shadow:0 -.0625rem 0 0 var(--cds-layer-selected-disabled,#8d8d8d)}.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set .cds--btn.cds--btn--loading{border-color:transparent;background-color:transparent;box-shadow:none}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn:focus{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:ButtonText}}[dir=rtl] .cds--btn-set .cds--btn:not(:focus){box-shadow:.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--content-switcher,:host(cds-content-switcher){--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));display:flex;justify-content:space-evenly;block-size:var(--cds-layout-size-height-local);inline-size:100%}.cds--content-switcher-btn{font-family:\'IBM Plex Sans\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',sans-serif;outline:2px solid transparent;outline-offset:-2px;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:inline-flex;overflow:hidden;border:none;margin:0;background-color:transparent;border-block-end:.0625rem solid var(--cds-border-inverse,#161616);border-block-start:.0625rem solid var(--cds-border-inverse,#161616);color:var(--cds-text-secondary,#525252);text-align:start;text-decoration:none;transition:all 150ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}.cds--content-switcher-btn html{font-size:100%}.cds--content-switcher-btn body{font-weight:400;font-family:\'IBM Plex Sans\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--content-switcher-btn code{font-family:\'IBM Plex Mono\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',monospace}.cds--content-switcher-btn strong{font-weight:600}.cds--content-switcher-btn::after{position:absolute;display:block;background-color:var(--cds-layer-selected-inverse,#161616);block-size:100%;content:"";inline-size:100%;inset-block-start:0;inset-inline-start:0;transform:scaleY(0);transform-origin:bottom;transition:all 150ms cubic-bezier(.2,0,.38,.9)}@media (prefers-reduced-motion:reduce){.cds--content-switcher-btn::after{transition:none}}.cds--content-switcher-btn:disabled::after{display:none}.cds--content-switcher-btn:focus{z-index:3;border-color:var(--cds-focus,#0f62fe);box-shadow:inset 0 0 0 2px var(--cds-focus,#0f62fe),inset 0 0 0 3px var(--cds-focus-inset,#fff)}.cds--content-switcher-btn:focus::after{clip-path:inset(3px 3px 3px 3px)}.cds--content-switcher-btn:hover{color:var(--cds-text-primary,#161616);cursor:pointer}.cds--content-switcher-btn:active,.cds--content-switcher-btn:hover{z-index:3;background-color:var(--cds-layer-hover);color:var(--cds-text-primary,#161616)}.cds--content-switcher-btn:disabled{border-color:var(--cds-border-disabled,#c6c6c6);background-color:transparent;color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--content-switcher-btn:disabled:hover{cursor:not-allowed}.cds--content-switcher-btn:disabled:first-child,.cds--content-switcher-btn:disabled:last-child{border-color:var(--cds-border-disabled,#c6c6c6)}.cds--content-switcher:not(.cds--content-switcher--icon-only) .cds--content-switcher-btn,:not(.cds--content-switcher--icon-only):host(cds-content-switcher) .cds--content-switcher-btn{align-items:center;padding:.5rem var(--cds-layout-density-padding-inline-local);inline-size:100%}.cds--content-switcher:not(.cds--content-switcher--icon-only) .cds--content-switcher-btn:first-child,:not(.cds--content-switcher--icon-only):host(cds-content-switcher) .cds--content-switcher-btn:first-child{border-end-start-radius:.25rem;border-inline-start:.0625rem solid var(--cds-border-inverse,#161616);border-start-start-radius:.25rem}.cds--content-switcher:not(.cds--content-switcher--icon-only) .cds--content-switcher-btn:first-child:disabled,:not(.cds--content-switcher--icon-only):host(cds-content-switcher) .cds--content-switcher-btn:first-child:disabled{border-color:var(--cds-border-disabled,#c6c6c6);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--content-switcher:not(.cds--content-switcher--icon-only) .cds--content-switcher-btn:last-child,:not(.cds--content-switcher--icon-only):host(cds-content-switcher) .cds--content-switcher-btn:last-child{border-end-end-radius:.25rem;border-inline-end:.0625rem solid var(--cds-border-inverse,#161616);border-start-end-radius:.25rem}.cds--content-switcher:not(.cds--content-switcher--icon-only) .cds--content-switcher-btn:last-child:disabled,:not(.cds--content-switcher--icon-only):host(cds-content-switcher) .cds--content-switcher-btn:last-child:disabled{border-color:var(--cds-border-disabled,#c6c6c6);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--content-switcher .cds--content-switcher-btn.cds--content-switcher--selected,.cds--content-switcher .cds--content-switcher-btn.cds--content-switcher--selected:first-child,.cds--content-switcher .cds--content-switcher-btn.cds--content-switcher--selected:last-child,:host(cds-content-switcher) .cds--content-switcher-btn.cds--content-switcher--selected{border:0}.cds--content-switcher-btn::before{position:absolute;z-index:2;display:block;background-color:var(--cds-border-subtle);block-size:1rem;content:"";inline-size:.0625rem;inset-inline-start:0}.cds--content-switcher:not(.cds--content-switcher--icon-only) .cds--content-switcher-btn:first-of-type::before,:not(.cds--content-switcher--icon-only):host(cds-content-switcher) .cds--content-switcher-btn:first-of-type::before{display:none}.cds--content-switcher--selected+.cds--content-switcher-btn::before,.cds--content-switcher--selected::before,.cds--content-switcher-btn:focus+.cds--content-switcher-btn::before,.cds--content-switcher-btn:focus::before,.cds--content-switcher-btn:hover+.cds--content-switcher-btn::before,.cds--content-switcher-btn:hover::before{background-color:transparent}.cds--content-switcher-btn:disabled::before,.cds--content-switcher-btn:disabled:hover+.cds--content-switcher-btn:disabled::before{background-color:var(--cds-border-disabled,#c6c6c6)}.cds--content-switcher-btn.cds--content-switcher--selected:disabled+.cds--content-switcher-btn::before,.cds--content-switcher-btn.cds--content-switcher--selected:disabled:hover+.cds--content-switcher-btn::before{background-color:transparent}.cds--content-switcher__icon{fill:var(--cds-icon-secondary,#525252);transition:fill 70ms cubic-bezier(.2,0,.38,.9)}.cds--content-switcher__icon+span{margin-inline-start:.5rem}.cds--content-switcher__label{z-index:1;overflow:hidden;max-inline-size:100%;text-overflow:ellipsis;white-space:nowrap}.cds--content-switcher-btn:focus .cds--content-switcher__icon,.cds--content-switcher-btn:hover .cds--content-switcher__icon{fill:var(--cds-icon-primary,#161616)}.cds--content-switcher-btn.cds--content-switcher--selected{z-index:3;background-color:var(--cds-layer-selected-inverse,#161616);color:var(--cds-text-inverse,#fff)}.cds--content-switcher-btn.cds--content-switcher--selected:disabled{background-color:var(--cds-layer-selected-disabled,#8d8d8d);color:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--content-switcher-btn.cds--content-switcher--selected::after{transform:scaleY(1)}.cds--content-switcher-btn.cds--content-switcher--selected .cds--content-switcher__icon{fill:var(--cds-icon-inverse,#fff)}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--content-switcher-btn:focus{color:Highlight;outline:1px solid Highlight}}.cds--content-switcher--icon-only,:host(cds-content-switcher[icon]){justify-content:flex-start}.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:first-child .cds--content-switcher-btn,:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:first-child .cds--content-switcher-btn{border-end-start-radius:.25rem;border-inline-start:.0625rem solid var(--cds-border-inverse,#161616);border-start-start-radius:.25rem}.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:first-child .cds--content-switcher--selected[disabled],.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:last-child .cds--content-switcher--selected[disabled],:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:first-child .cds--content-switcher--selected[disabled],:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:last-child .cds--content-switcher--selected[disabled]{border-color:var(--cds-layer-selected-disabled,#8d8d8d)}.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:last-child .cds--content-switcher-btn,:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:last-child .cds--content-switcher-btn{border-end-end-radius:.25rem;border-inline-end:.0625rem solid var(--cds-border-inverse,#161616);border-start-end-radius:.25rem}.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:first-child .cds--content-switcher-btn.cds--content-switcher--selected,.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:last-child .cds--content-switcher-btn.cds--content-switcher--selected,:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:first-child .cds--content-switcher-btn.cds--content-switcher--selected,:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:last-child .cds--content-switcher-btn.cds--content-switcher--selected{border-color:var(--cds-background,#fff)}.cds--content-switcher--lg .cds--content-switcher-btn{padding-inline-end:.875rem;padding-inline-start:.875rem}.cds--content-switcher--lg .cds--content-switcher-btn svg{block-size:20px;inline-size:20px}.cds--content-switcher--icon-only .cds--content-switcher-btn svg,:host(cds-content-switcher[icon]) .cds--content-switcher-btn svg{fill:var(--cds-icon-primary,#161616)}.cds--content-switcher--icon-only .cds--content-switcher-btn.cds--content-switcher--selected svg,:host(cds-content-switcher[icon]) .cds--content-switcher-btn.cds--content-switcher--selected svg{z-index:1;fill:var(--cds-icon-inverse,#fff)}.cds--content-switcher--icon-only.cds--content-switcher--sm .cds--btn--sm{block-size:2rem}.cds--content-switcher--icon-only .cds--content-switcher-popover__wrapper:first-of-type .cds--content-switcher-btn::before,:host(cds-content-switcher[icon]) .cds--content-switcher-popover__wrapper:first-of-type .cds--content-switcher-btn::before{display:none}.cds--content-switcher--selected::before,.cds--content-switcher-btn:focus::before,.cds--content-switcher-btn:hover::before,.cds--content-switcher-popover--selected+.cds--content-switcher-popover__wrapper .cds--content-switcher-btn::before,.cds--content-switcher-popover__wrapper:focus-within+.cds--content-switcher-popover__wrapper .cds--content-switcher-btn::before,.cds--content-switcher-popover__wrapper:not(.cds--content-switcher-popover--disabled):hover+.cds--content-switcher-popover__wrapper .cds--content-switcher-btn::before{background-color:transparent}.cds--content-switcher--icon-only .cds--content-switcher-btn[disabled],:host(cds-content-switcher[icon]) .cds--content-switcher-btn[disabled]{border-color:var(--cds-border-inverse,#161616)}.cds--content-switcher--icon-only .cds--content-switcher-btn[disabled] svg,:host(cds-content-switcher[icon]) .cds--content-switcher-btn[disabled] svg{fill:var(--cds-icon-disabled,rgba(22,22,22,.25))}.cds--content-switcher--icon-only .cds--content-switcher-btn[disabled]:not(.cds--content-switcher--selected):hover,.cds--content-switcher--icon-only .cds--content-switcher-popover--selected+.cds--content-switcher-popover--disabled .cds--content-switcher-btn[disabled]:hover::before,:host(cds-content-switcher[icon]) .cds--content-switcher-btn[disabled]:not(.cds--content-switcher--selected):hover,:host(cds-content-switcher[icon]) .cds--content-switcher-popover--selected+.cds--content-switcher-popover--disabled .cds--content-switcher-btn[disabled]:hover::before{background-color:transparent}.cds--content-switcher--icon-only .cds--content-switcher-btn[disabled]:hover::before,:host(cds-content-switcher[icon]) .cds--content-switcher-btn[disabled]:hover::before{background-color:var(--cds-border-subtle)}:host(cds-content-switcher){--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}:host(cds-content-switcher-item){inline-size:100%;outline:0}:host(cds-content-switcher-item) .cds--content-switcher-btn{align-items:center;padding:.5rem var(--cds-layout-density-padding-inline-local);block-size:100%;inline-size:100%}:host(cds-content-switcher-item) .cds--content-switcher-btn:first-child,:host(cds-content-switcher-item) .cds--content-switcher-btn:last-child{border-radius:0;border-inline-end:none;border-inline-start:none}:host(cds-content-switcher-item) .cds--content-switcher-btn::before{position:absolute;z-index:2;display:block;background-color:var(--cds-border-subtle);block-size:1rem;content:"";inline-size:.0625rem;inset-inline-start:0}:host(cds-content-switcher-item) .cds--content-switcher-btn.cds--content-switcher--selected::before,:host(cds-content-switcher-item) .cds--content-switcher-btn:focus::before,:host(cds-content-switcher-item) .cds--content-switcher-btn:hover::before{background-color:transparent}:host(cds-content-switcher-item) .cds--content-switcher-btn:disabled{border-block-end-color:var(--cds-border-inverse,#161616);border-block-start-color:var(--cds-border-inverse,#161616)}:host(cds-content-switcher-item)[icon]{inline-size:initial}:host(cds-content-switcher-item)[icon] .cds--content-switcher-btn{block-size:2.5rem;padding-inline:.6875rem}:host(cds-content-switcher-item)[icon] .cds--content-switcher__label{display:flex;align-items:center}:host(cds-content-switcher-item[hide-divider]) .cds--content-switcher-btn::before{background-color:transparent}:host(cds-content-switcher-item:first-of-type) .cds--content-switcher-btn{border-end-start-radius:.25rem;border-inline-start:.0625rem solid var(--cds-border-inverse,#161616);border-start-start-radius:.25rem}:host(cds-content-switcher-item:first-of-type) .cds--content-switcher-btn::before{content:none}:host(cds-content-switcher-item:last-of-type) .cds--content-switcher-btn{border-end-end-radius:.25rem;border-inline-end:.0625rem solid var(--cds-border-inverse,#161616);border-start-end-radius:.25rem}',
]);

let _$r = t => t,
  _t$s;

/**
 * @param index The index
 * @param length The length of the array.
 * @returns The new index, adjusting overflow/underflow.
 */
const capIndex = (index, length) => {
  if (index < 0) {
    return length - 1;
  }
  if (index >= length) {
    return 0;
  }
  return index;
};

/**
 * Content switcher.
 *
 * @element cds-content-switcher
 * @fires cds-content-switcher-beingselected
 *   The custom event fired before a content switcher item is selected upon a user gesture.
 *   Cancellation of this event stops changing the user-initiated selection.
 * @fires cds-content-switcher-selected - The custom event fired after a a content switcher item is selected upon a user gesture.
 */
let CDSContentSwitcher = _decorate$Z([carbonElement(`${prefix$B}-content-switcher`)], function (_initialize, _LitElement) {
  class CDSContentSwitcher extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSContentSwitcher,
    d: [{
      kind: "method",
      key: "_handleHover",
      value:
      /**
       * Handles `mouseover`/`mouseout` events on `<slot>`.
       *
       * @param event The event.
       * @param event.target The event target.
       * @param event.type The event type.
       */
      function _handleHover({
        target,
        type
      }) {
        const {
          selectorItem
        } = this.constructor;
        const items = this.querySelectorAll(selectorItem);
        const index = type !== 'mouseover' ? -1 : indexOf$1(items, target.closest(selectorItem));
        const nextIndex = index < 0 ? index : index + 1;
        forEach$1(this.querySelectorAll(selectorItem), (elem, i) => {
          // Specifies child `<cds-content-switcher-item>` to hide its divider instead of using CSS,
          // until `:host-context()` gets supported in all major browsers
          elem.hideDivider = i === nextIndex;
        });
        const {
          selectorItemSelected
        } = this.constructor;
        const selectedItem = this.querySelector(selectorItemSelected);
        const nextItem = this._getNextItem(selectedItem, 1);
        nextItem.hideDivider = true;
      }

      /**
       * @param target The current event target.
       * @returns The item to be selected.
       */
    }, {
      kind: "method",
      key: "_getCurrentItem",
      value: function _getCurrentItem(target) {
        var _items$index;
        const items = this.querySelectorAll(this.constructor.selectorItemEnabled);
        const {
          selectorItem
        } = this.constructor;
        const containerItem = target.closest(selectorItem);
        const index = indexOf$1(items, containerItem);
        return (_items$index = items[index]) !== null && _items$index !== void 0 ? _items$index : null;
      }

      /**
       * @param currentItem The currently selected item.
       * @param direction The navigation direction.
       * @returns The item to be selected.
       */
    }, {
      kind: "method",
      key: "_getNextItem",
      value: function _getNextItem(currentItem, direction) {
        const items = this.querySelectorAll(this.constructor.selectorItemEnabled);
        const currentIndex = indexOf$1(items, currentItem);
        const nextIndex = capIndex(currentIndex + direction, items.length);
        return nextIndex === currentIndex ? null : items[nextIndex];
      }

      /**
       * Handles `click` event on content switcher item.
       *
       * @param event The event.
       * @param event.target The event target.
       */
    }, {
      kind: "method",
      key: "_handleClick",
      value: function _handleClick({
        target
      }) {
        const currentItem = this._getCurrentItem(target);
        this._handleUserInitiatedSelectItem(currentItem);
      }

      /**
       * Handles `keydown` event on the top-level element in the shadow DOM.
       *
       * @param event The event.
       * @param event.key The event key.
       */
    }, {
      kind: "method",
      key: "_handleKeydown",
      value: function _handleKeydown({
        key
      }) {
        if (key in NAVIGATION_DIRECTION) {
          this._navigate(NAVIGATION_DIRECTION[key]);
        }
      }

      /**
       * Handles user-initiated selection of a content switcher item.
       *
       * @param [item] The content switcher item user wants to select.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedSelectItem",
      value: function _handleUserInitiatedSelectItem(item) {
        if (!item.disabled && item.value !== this.value) {
          const init = {
            bubbles: true,
            composed: true,
            detail: {
              item
            }
          };
          const constructor = this.constructor;
          const beforeSelectEvent = new CustomEvent(constructor.eventBeforeSelect, _objectSpread2(_objectSpread2({}, init), {}, {
            cancelable: true
          }));
          if (this.dispatchEvent(beforeSelectEvent)) {
            this._selectionDidChange(item);
            const afterSelectEvent = new CustomEvent(constructor.eventSelect, init);
            this.dispatchEvent(afterSelectEvent);
          }
        }
      }

      /**
       * Navigates through content switcher items.
       *
       * @param direction `-1` to navigate backward, `1` to navigate forward.
       */
    }, {
      kind: "method",
      key: "_navigate",
      value: function _navigate(direction) {
        const {
          selectorItemSelected
        } = this.constructor;
        const nextItem = this._getNextItem(this.querySelector(selectorItemSelected), direction);
        if (nextItem) {
          this._handleUserInitiatedSelectItem(nextItem);
          this.requestUpdate();
        }
      }

      /**
       * A callback that runs after change in content switcher selection upon user interaction is confirmed.
       *
       * @param itemToSelect A content switcher item.
       */
    }, {
      kind: "method",
      key: "_selectionDidChange",
      value: function _selectionDidChange(itemToSelect) {
        this.value = itemToSelect.value;
        forEach$1(this.querySelectorAll(this.constructor.selectorItemSelected), item => {
          item.selected = false;
        });
        itemToSelect.selected = true;
        // Waits for rendering with the new state that updates `tabindex`
        Promise.resolve().then(() => {
          itemToSelect.focus();
          const {
            selectorItem
          } = this.constructor;
          const items = this.querySelectorAll(selectorItem);
          const index = indexOf$1(items, itemToSelect.closest(selectorItem));
          const nextIndex = index < 0 ? index : index + 1;
          forEach$1(this.querySelectorAll(selectorItem), (elem, i) => {
            // Specifies child `<cds-content-switcher-item>` to hide its divider instead of using CSS,
            // until `:host-context()` gets supported in all major browsers
            elem.hideDivider = i === nextIndex;
          });
        });
      }

      /**
       * The value of the selected item.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "value",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "size",
      value() {
        return CONTENT_SWITCHER_SIZE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'icon'
      })],
      key: "iconOnly",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "shouldUpdate",
      value:
      /**
       * Content switcher size.
       */
      /**
       * Icon only.
       */
      function shouldUpdate(changedProperties) {
        if (changedProperties.has('value')) {
          const {
            selectorItem
          } = this.constructor;
          forEach$1(this.querySelectorAll(selectorItem), elem => {
            elem.selected = elem.value === this.value;
          });
        }
        const {
          selectorIconItem
        } = this.constructor;
        if (this.querySelector(selectorIconItem)) {
          this.iconOnly = true;
        }
        return true;
      }
    }, {
      kind: "method",
      key: "_handleSlotchange",
      value: function _handleSlotchange() {
        const {
          selectorItemSelected
        } = this.constructor;
        const selectedItem = this.querySelector(selectorItemSelected);
        const nextItem = this._getNextItem(selectedItem, 1);

        // Specifies child `<cds-content-switcher-item>` to hide its divider instead of using CSS,
        // until `:host-context()` gets supported in all major browsers
        nextItem.hideDivider = true;
      }

      /**
       * A selector that will return content switcher items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${prefix$B}-content-switcher-item`;
      }

      /**
       * A selector that will return content switcher icon items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorIconItem",
      value: function () {
        return `${prefix$B}-content-switcher-item[icon]`;
      }

      /**
       * A selector that will return enabled content switcher items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemEnabled",
      value: function () {
        return `${prefix$B}-content-switcher-item:not([disabled])`;
      }

      /**
       * A selector that will return selected items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemSelected",
      value: function () {
        return `${prefix$B}-content-switcher-item[selected]`;
      }

      /**
       * The name of the custom event fired before a content switcher item is selected upon a user gesture.
       * Cancellation of this event stops changing the user-initiated selection.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeSelect",
      value: function () {
        return `${prefix$B}-content-switcher-beingselected`;
      }

      /**
       * The name of the custom event fired after a a content switcher item is selected upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelect",
      value: function () {
        return `${prefix$B}-content-switcher-selected`;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _handleHover: handleHover,
          _handleKeydown: handleKeydown,
          _handleSlotchange: handleSlotchange
        } = this;
        return x(_t$s || (_t$s = _$r`
      <slot
        @click="${0}"
        @keydown="${0}"
        @mouseover="${0}"
        @mouseout="${0}"
        @slotchange=${0}></slot>
    `), this._handleClick, handleKeydown, handleHover, handleHover, handleSlotchange);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$7;
      }
    }]
  };
}, s);

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The keyboard action categories for dropdown.
 */
let TABS_KEYBOARD_ACTION;

/**
 * Tabs types.
 */
(function (TABS_KEYBOARD_ACTION) {
  TABS_KEYBOARD_ACTION["NONE"] = "none";
  TABS_KEYBOARD_ACTION["NAVIGATING"] = "navigating";
  TABS_KEYBOARD_ACTION["HOME"] = "home";
  TABS_KEYBOARD_ACTION["END"] = "end";
})(TABS_KEYBOARD_ACTION || (TABS_KEYBOARD_ACTION = {}));
let TABS_TYPE;
(function (TABS_TYPE) {
  TABS_TYPE["REGULAR"] = "";
  TABS_TYPE["CONTAINER"] = "container";
  TABS_TYPE["CONTAINED"] = "contained";
})(TABS_TYPE || (TABS_TYPE = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$6 = i$4([
  '@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}.cds--popover-container{display:inline-block}.cds--popover-container:not(.cds--popover--auto-align){position:relative}.cds--popover--high-contrast .cds--popover{--cds-popover-background-color:var(--cds-background-inverse, #393939);--cds-popover-text-color:var(--cds-text-inverse, #ffffff)}.cds--popover--drop-shadow .cds--popover{--cds-popover-drop-shadow:drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2))}.cds--popover--caret{--cds-popover-offset:0.625rem}.cds--popover{position:absolute;z-index:6000;filter:var(--cds-popover-drop-shadow, none);inset:0;pointer-events:none}.cds--popover-content{--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:6000;display:none;border-radius:var(--cds-popover-border-radius,2px);background-color:var(--cds-popover-background-color,var(--cds-layer));color:var(--cds-popover-text-color,var(--cds-text-primary,#161616));inline-size:-moz-max-content;inline-size:max-content;max-inline-size:23rem;pointer-events:auto}.cds--layout--size-sm .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--popover-content *,.cds--popover-content ::after,.cds--popover-content ::before{box-sizing:inherit}.cds--popover--open>.cds--popover>.cds--popover-content{display:block}.cds--popover-content::before{position:absolute;display:none;content:""}.cds--popover--open>.cds--popover>.cds--popover-content::before{display:block}.cds--popover--auto-align.cds--popover-caret,.cds--popover-caret{position:absolute;z-index:6000;display:none;background-color:var(--cds-popover-background-color,var(--cds-layer));will-change:transform}.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-caret{display:block}.cds--popover--auto-align.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-content>.cds--popover-caret{display:block}.cds--popover--tab-tip>.cds--popover>.cds--popover-caret{display:none}.cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(100% + var(--cds-popover-offset,0)))}.cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--bottom-end>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-left>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-right>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-start>.cds--popover>.cds--popover-content::before,.cds--popover--bottom>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-start:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(-100%)}.cds--popover--bottom-end>.cds--popover>.cds--popover-caret,.cds--popover--bottom-left>.cds--popover>.cds--popover-caret,.cds--popover--bottom-right>.cds--popover>.cds--popover-caret,.cds--popover--bottom-start>.cds--popover>.cds--popover-caret,.cds--popover--bottom>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,var(--cds-popover-offset,0))}[dir=rtl] .cds--popover--bottom-end>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-left>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-right>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-start>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom>.cds--popover>.cds--popover-caret{transform:translate(50%,var(--cds-popover-offset,0))}.cds--popover--bottom-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(-100% - var(--cds-popover-offset,0)))}.cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--top-end>.cds--popover>.cds--popover-content::before,.cds--popover--top-left>.cds--popover>.cds--popover-content::before,.cds--popover--top-right>.cds--popover>.cds--popover-content::before,.cds--popover--top-start>.cds--popover>.cds--popover-content::before,.cds--popover--top>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-end:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--popover--top-end>.cds--popover>.cds--popover-caret,.cds--popover--top-left>.cds--popover>.cds--popover-caret,.cds--popover--top-right>.cds--popover>.cds--popover-caret,.cds--popover--top-start>.cds--popover>.cds--popover-caret,.cds--popover--top>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-1 * var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{transform:translate(50%,calc(-1 * var(--cds-popover-offset,0)))}.cds--popover--top-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),-50%)}.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) * -1 - 16px))}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--right-end>.cds--popover>.cds--popover-content::before,.cds--popover--right-start>.cds--popover>.cds--popover-content::before,.cds--popover--right-top>.cds--popover>.cds--popover-content::before,.cds--popover--right>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-start:0;transform:translateX(-100%)}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-start:100%;transform:translate(calc(var(--cds-popover-offset,0) - 100%),-50%)}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + .1px),-50%)}.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-.5 * var(--cds-popover-offset,0) - 16px))}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--left-end>.cds--popover>.cds--popover-content::before,.cds--popover--left-start>.cds--popover>.cds--popover-content::before,.cds--popover--left-top>.cds--popover>.cds--popover-content::before,.cds--popover--left>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-end:0;transform:translateX(100%)}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + 100%),-50%)}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--tab-tip>.cds--popover>.cds--popover-content{border-radius:0}.cds--popover--tab-tip .cds--popover{will-change:filter}.cds--popover--tab-tip__button{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;align-items:center;justify-content:center;block-size:2rem;inline-size:2rem}.cds--popover--tab-tip__button *,.cds--popover--tab-tip__button ::after,.cds--popover--tab-tip__button ::before{box-sizing:inherit}.cds--popover--tab-tip__button::-moz-focus-inner{border:0}.cds--popover--tab-tip__button:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--popover--tab-tip__button:focus{outline-style:dotted}}.cds--popover--tab-tip__button:hover{background-color:var(--cds-layer-hover)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button{background:var(--cds-layer);box-shadow:0 2px 2px rgba(0,0,0,.2)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after{position:absolute;z-index:6001;background:var(--cds-layer);block-size:2px;content:"";inline-size:100%;inset-block-end:0}.cds--popover--tab-tip__button svg{fill:var(--cds-icon-primary,#161616)}.cds--tooltip{--cds-popover-offset:12px}.cds--tooltip-content{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:var(--cds-tooltip-padding-block,1rem) var(--cds-tooltip-padding-inline,1rem);color:var(--cds-text-inverse,#fff);max-inline-size:18rem}.cds--icon-tooltip{--cds-tooltip-padding-block:0.125rem;--cds-popover-caret-width:0.5rem;--cds-popover-caret-height:0.25rem;--cds-popover-offset:0.5rem}.cds--icon-tooltip .cds--tooltip-content{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--definition-term{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;border-radius:0;border-block-end:1px dotted var(--cds-border-strong);color:var(--cds-text-primary,#161616)}.cds--definition-term *,.cds--definition-term ::after,.cds--definition-term ::before{box-sizing:inherit}.cds--definition-term::-moz-focus-inner{border:0}.cds--definition-term:focus{outline:1px solid var(--cds-focus,#0f62fe);border-block-end-color:var(--cds-border-interactive,#0f62fe)}@media screen and (prefers-contrast){.cds--definition-term:focus{outline-style:dotted}}.cds--definition-term:hover{border-block-end-color:var(--cds-border-interactive,#0f62fe)}.cds--definition-tooltip{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:.5rem 1rem;max-inline-size:11rem}.cds--btn{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));--temp-1lh:(\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );--temp-expressive-1lh:(\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );--temp-padding-block-max:calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:inline-flex;flex-shrink:0;justify-content:space-between;border-radius:0;margin:0;cursor:pointer;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:20rem;min-block-size:var(--cds-layout-size-height-local);outline:0;padding-block:min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - .0625rem,var(--temp-padding-block-max));padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - .0625rem);padding-inline-start:calc(var(--cds-layout-density-padding-inline-local) - .0625rem);text-align:start;text-decoration:none;transition:background 70ms cubic-bezier(0,0,.38,.9),box-shadow 70ms cubic-bezier(0,0,.38,.9),border-color 70ms cubic-bezier(0,0,.38,.9),outline 70ms cubic-bezier(0,0,.38,.9);vertical-align:top}.cds--btn *,.cds--btn ::after,.cds--btn ::before{box-sizing:inherit}.cds--btn.cds--btn--disabled,.cds--btn.cds--btn--disabled:focus,.cds--btn.cds--btn--disabled:hover,.cds--btn:disabled,.cds--btn:focus:disabled,.cds--btn:hover:disabled{border-color:var(--cds-button-disabled,#c6c6c6);background:var(--cds-button-disabled,#c6c6c6);box-shadow:none;color:var(--cds-text-on-color-disabled,#8d8d8d);cursor:not-allowed}.cds--btn .cds--btn__icon{position:absolute;flex-shrink:0;block-size:1rem;inline-size:1rem;inset-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max));inset-inline-end:var(--cds-layout-density-padding-inline-local);margin-block-start:.0625rem}.cds--btn::-moz-focus-inner{padding:0;border:0}.cds--btn--primary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-primary,#0f62fe);color:var(--cds-text-on-color,#fff)}.cds--btn--primary:hover{background-color:var(--cds-button-primary-hover,#0050e6)}.cds--btn--primary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--primary:active{background-color:var(--cds-button-primary-active,#002d9c)}.cds--btn--primary .cds--btn__icon,.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--primary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--secondary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-secondary,#393939);color:var(--cds-text-on-color,#fff)}.cds--btn--secondary:hover{background-color:var(--cds-button-secondary-hover,#474747)}.cds--btn--secondary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--secondary:active{background-color:var(--cds-button-secondary-active,#6f6f6f)}.cds--btn--secondary .cds--btn__icon,.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--secondary:focus,.cds--btn--secondary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-tertiary,#0f62fe);background-color:transparent;color:var(--cds-button-tertiary,#0f62fe)}.cds--btn--tertiary:hover{background-color:var(--cds-button-tertiary-hover,#0050e6)}.cds--btn--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--tertiary:active{background-color:var(--cds-button-tertiary-active,#002d9c)}.cds--btn--tertiary .cds--btn__icon,.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--tertiary:hover{color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:focus{background-color:var(--cds-button-tertiary,#0f62fe);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:active{border-color:transparent;background-color:var(--cds-button-tertiary-active,#002d9c);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary.cds--btn--disabled,.cds--btn--tertiary.cds--btn--disabled:focus,.cds--btn--tertiary.cds--btn--disabled:hover,.cds--btn--tertiary:disabled,.cds--btn--tertiary:focus:disabled,.cds--btn--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-link-primary,#0f62fe);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--ghost:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--btn--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost .cds--btn__icon,.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--ghost:active,.cds--btn--ghost:hover{color:var(--cds-link-primary-hover,#0043ce)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost.cds--btn--disabled,.cds--btn--ghost.cds--btn--disabled:focus,.cds--btn--ghost.cds--btn--disabled:hover,.cds--btn--ghost:disabled,.cds--btn--ghost:focus:disabled,.cds--btn--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost:not([disabled]) svg{fill:var(--cds-icon-primary,#161616)}.cds--btn--icon-only{justify-content:center;padding:0;block-size:var(--cds-layout-size-height-local);inline-size:var(--cds-layout-size-height-local);padding-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only>:first-child{margin-block-start:.0625rem;min-inline-size:1rem}.cds--btn--icon-only .cds--btn__icon{position:static}.cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon{margin:0}.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon{margin-block-start:0}.cds--btn--icon-only.cds--btn--selected{background:var(--cds-background-selected,rgba(141,141,141,.2))}.cds--btn path[data-icon-path=inner-path]{fill:none}.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:var(--cds-icon-primary,#161616)}.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn--ghost.cds--btn--icon-only[disabled]{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled]{pointer-events:none}.cds--btn--danger{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger .cds--btn__icon,.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-danger-secondary,#da1e28);background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28)}.cds--btn--danger--tertiary:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--tertiary:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--tertiary .cds--btn__icon,.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--tertiary:hover{border-color:var(--cds-button-danger-hover,#b81921);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:focus{background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:active{border-color:var(--cds-button-danger-active,#750e13);background-color:var(--cds-button-danger-active,#750e13);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary.cds--btn--disabled,.cds--btn--danger--tertiary.cds--btn--disabled:focus,.cds--btn--danger--tertiary.cds--btn--disabled:hover,.cds--btn--danger--tertiary:disabled,.cds--btn--danger--tertiary:focus:disabled,.cds--btn--danger--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--danger--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--danger--ghost:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--ghost:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--danger--ghost:active,.cds--btn--danger--ghost:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--ghost.cds--btn--disabled,.cds--btn--danger--ghost.cds--btn--disabled:focus,.cds--btn--danger--ghost.cds--btn--disabled:hover,.cds--btn--danger--ghost:disabled,.cds--btn--danger--ghost:focus:disabled,.cds--btn--danger--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--btn--expressive{font-size:var(--cds-body-compact-02-font-size,1rem);font-weight:var(--cds-body-compact-02-font-weight,400);line-height:var(--cds-body-compact-02-line-height,1.375);letter-spacing:var(--cds-body-compact-02-letter-spacing,0);padding-block:min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only.cds--btn--expressive{padding:12px 13px}.cds--btn.cds--btn--expressive .cds--btn__icon{block-size:1.25rem;inline-size:1.25rem}.cds--btn-set .cds--btn.cds--btn--expressive{max-inline-size:20rem}.cds--btn.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:9.375rem}.cds--btn.cds--skeleton:active,.cds--btn.cds--skeleton:focus,.cds--btn.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--btn.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--btn.cds--skeleton::before{animation:none}}.cds--btn-set{display:flex}.cds--btn-set--stacked{flex-direction:column}.cds--btn-set .cds--btn{inline-size:100%;max-inline-size:12.25rem}.cds--btn-set .cds--btn:not(:focus){box-shadow:-.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn:focus+.cds--btn{box-shadow:inherit}.cds--btn-set--stacked .cds--btn:not(:focus){box-shadow:0 -.0625rem 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn.cds--btn--disabled{box-shadow:-.0625rem 0 0 0 var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set--stacked .cds--btn.cds--btn--disabled{box-shadow:0 -.0625rem 0 0 var(--cds-layer-selected-disabled,#8d8d8d)}.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set .cds--btn.cds--btn--loading{border-color:transparent;background-color:transparent;box-shadow:none}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn:focus{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:ButtonText}}[dir=rtl] .cds--btn-set .cds--btn:not(:focus){box-shadow:.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--tabs.cds--tabs--contained.cds--tabs--full-width .cds--tab--list{display:grid;grid-template-columns:repeat(auto-fit,minmax(0,1fr));inline-size:100%}.cds--tabs.cds--tabs--contained.cds--tabs--full-width .cds--tab--list .cds--tabs__nav-link .cds--tabs__nav-item-label,.cds--tabs.cds--tabs--contained.cds--tabs--full-width .cds--tab--list .cds--tabs__nav-link .cds--tabs__nav-item-secondary-label{overflow:hidden;text-overflow:ellipsis}.cds--tabs.cds--tabs--contained.cds--tabs--full-width .cds--tab--list .cds--tabs__nav-link .cds--tabs__nav-item--icon{margin-inline-start:auto}.cds--tabs.cds--tabs--vertical .cds--tabs__nav-link .cds--tabs__nav-item-label{display:-webkit-box;overflow:hidden;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;white-space:normal}.cds--tab-content,.cds--tabs,:host(cds-tabs),:host(cds-tabs-skeleton){--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max))}.cds--tabs.cds--tabs--contained.cds--tabs--tall,.cds--tabs.cds--tabs--tall{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-lg)), var(--cds-layout-size-height, var(--cds-layout-size-height-xl)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-xl)))}.cds--tabs,:host(cds-tabs),:host(cds-tabs-skeleton){font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));position:relative;display:flex;block-size:auto;color:var(--cds-text-primary,#161616);inline-size:100%;max-block-size:var(--cds-layout-size-height-xl);min-block-size:var(--cds-layout-size-height-local);overflow-x:hidden}.cds--tabs html,:host(cds-tabs) html,:host(cds-tabs-skeleton) html{font-size:100%}.cds--tabs body,:host(cds-tabs) body,:host(cds-tabs-skeleton) body{font-weight:400;font-family:\'IBM Plex Sans\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--tabs code,:host(cds-tabs) code,:host(cds-tabs-skeleton) code{font-family:\'IBM Plex Mono\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',monospace}.cds--tabs strong,:host(cds-tabs) strong,:host(cds-tabs-skeleton) strong{font-weight:600}.cds--tabs.cds--tabs--contained{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-xl)))}.cds--tabs .cds--tab--list,:host(cds-tabs) .cds--tab--list,:host(cds-tabs-skeleton) .cds--tab--list{display:flex;inline-size:auto;overflow-x:auto;scroll-behavior:smooth;scrollbar-width:none;will-change:scroll-position}.cds--tabs .cds--tab--list::-webkit-scrollbar,:host(cds-tabs) .cds--tab--list::-webkit-scrollbar,:host(cds-tabs-skeleton) .cds--tab--list::-webkit-scrollbar{display:none}.cds--tabs.cds--tabs--vertical{background:var(--cds-layer);box-shadow:inset -1px 0 var(--cds-border-subtle);grid-column:span 2;max-block-size:none}@media (min-width:66rem){.cds--tabs.cds--tabs--vertical{grid-column:span 4}}.cds--tabs.cds--tabs--vertical .cds--tab--list{flex-direction:column;inline-size:100%;overflow-x:visible;overflow-y:auto}.cds--tabs.cds--tabs--vertical .cds--tab--list-gradient_bottom{position:absolute;background:linear-gradient(to bottom,transparent,var(--cds-layer));block-size:4rem;inset-block-end:0;inset-inline:0;pointer-events:none}.cds--tabs.cds--tabs--vertical .cds--tab--list-gradient_top{position:absolute;background:linear-gradient(to top,transparent,var(--cds-layer));block-size:4rem;inset-block-start:0;inset-inline:0;pointer-events:none}.cds--tabs .cds--tabs__nav,:host(cds-tabs) .cds--tabs__nav,:host(cds-tabs-skeleton) .cds--tabs__nav{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:flex}.cds--tabs .cds--tabs__nav *,.cds--tabs .cds--tabs__nav ::after,.cds--tabs .cds--tabs__nav ::before,:host(cds-tabs) .cds--tabs__nav *,:host(cds-tabs) .cds--tabs__nav ::after,:host(cds-tabs) .cds--tabs__nav ::before,:host(cds-tabs-skeleton) .cds--tabs__nav *,:host(cds-tabs-skeleton) .cds--tabs__nav ::after,:host(cds-tabs-skeleton) .cds--tabs__nav ::before{box-sizing:inherit}.cds--tabs .cds--tab--overflow-nav-button,:host(cds-tabs) .cds--tab--overflow-nav-button,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:flex;flex-shrink:0;align-items:center;justify-content:center;background-color:var(--cds-background,#fff);inline-size:2.5rem}.cds--tabs .cds--tab--overflow-nav-button *,.cds--tabs .cds--tab--overflow-nav-button ::after,.cds--tabs .cds--tab--overflow-nav-button ::before,:host(cds-tabs) .cds--tab--overflow-nav-button *,:host(cds-tabs) .cds--tab--overflow-nav-button ::after,:host(cds-tabs) .cds--tab--overflow-nav-button ::before,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button *,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button ::after,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button ::before{box-sizing:inherit}.cds--tabs .cds--tab--overflow-nav-button::-moz-focus-inner,:host(cds-tabs) .cds--tab--overflow-nav-button::-moz-focus-inner,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button::-moz-focus-inner{border:0}.cds--tabs .cds--tab--overflow-nav-button:focus,:host(cds-tabs) .cds--tab--overflow-nav-button:focus,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--tabs .cds--tab--overflow-nav-button:focus,:host(cds-tabs) .cds--tab--overflow-nav-button:focus,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button:focus{outline-style:dotted}}.cds--tabs .cds--tab--overflow-nav-button--hidden,:host(cds-tabs) .cds--tab--overflow-nav-button--hidden,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button--hidden{display:none}.cds--tabs.cds--tabs--contained .cds--tab--overflow-nav-button{margin:0;background-color:var(--cds-layer-accent);inline-size:3rem}.cds--tabs .cds--tab--overflow-nav-button svg,:host(cds-tabs) .cds--tab--overflow-nav-button svg,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button svg{z-index:2;fill:var(--cds-icon-primary,#161616)}.cds--tabs .cds--tab--overflow-nav-button--next,:host(cds-tabs) .cds--tab--overflow-nav-button--next,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button--next{position:absolute;inset-block-end:0;inset-block-start:0;inset-inline-end:0}.cds--tabs .cds--tab--overflow-nav-button--next::before,:host(cds-tabs) .cds--tab--overflow-nav-button--next::before,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button--next::before{position:absolute;z-index:1;background:linear-gradient(to right,rgba(255,255,255,0),var(--cds-background,#fff));block-size:100%;content:"";inline-size:.5rem;inset-inline-start:-.5rem}.cds--tabs.cds--tabs--contained .cds--tab--overflow-nav-button--next::before{background-image:linear-gradient(to right,rgba(255,255,255,0),var(--cds-layer-accent))}.cds--tabs .cds--tab--overflow-nav-button--previous,:host(cds-tabs) .cds--tab--overflow-nav-button--previous,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button--previous{position:absolute;inset-block-end:0;inset-block-start:0;inset-inline-start:0}.cds--tabs .cds--tab--overflow-nav-button--previous::before,:host(cds-tabs) .cds--tab--overflow-nav-button--previous::before,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button--previous::before{position:absolute;z-index:1;background:var(--cds-background,#fff);block-size:100%;content:"";inline-size:2.5rem;inset-inline-end:0}.cds--tabs.cds--tabs--contained .cds--tab--overflow-nav-button--previous::before{background:linear-gradient(to left,rgba(255,255,255,0),var(--cds-layer-accent))}.cds--tabs .cds--tabs--light .cds--tabs__overflow-indicator--left,:host(cds-tabs) .cds--tabs--light .cds--tabs__overflow-indicator--left,:host(cds-tabs-skeleton) .cds--tabs--light .cds--tabs__overflow-indicator--left{background-image:linear-gradient(to left,rgba(255,255,255,0),var(--cds-layer))}.cds--tabs .cds--tabs--light .cds--tabs__overflow-indicator--right,:host(cds-tabs) .cds--tabs--light .cds--tabs__overflow-indicator--right,:host(cds-tabs-skeleton) .cds--tabs--light .cds--tabs__overflow-indicator--right{background-image:linear-gradient(to right,rgba(255,255,255,0),var(--cds-layer))}.cds--tabs.cds--tabs--contained .cds--tabs__overflow-indicator--left{background-image:linear-gradient(to left,rgba(255,255,255,0),var(--cds-layer-accent))}.cds--tabs.cds--tabs--contained .cds--tabs__overflow-indicator--right{background-image:linear-gradient(to right,rgba(255,255,255,0),var(--cds-layer-accent))}@media not all and (resolution >= 0.001dpcm){@supports (-webkit-appearance:none) and (stroke-color:transparent){.cds--tabs .cds--tabs__overflow-indicator--left,:host(cds-tabs) .cds--tabs__overflow-indicator--left,:host(cds-tabs-skeleton) .cds--tabs__overflow-indicator--left{background-image:linear-gradient(to left,rgba(var(--cds-background,#fff),0),var(--cds-background,#fff))}.cds--tabs .cds--tabs__overflow-indicator--right,:host(cds-tabs) .cds--tabs__overflow-indicator--right,:host(cds-tabs-skeleton) .cds--tabs__overflow-indicator--right{background-image:linear-gradient(to right,rgba(var(--cds-background,#fff),0),var(--cds-background,#fff))}.cds--tabs.cds--tabs--contained .cds--tabs__overflow-indicator--left{background-image:linear-gradient(to left,rgba(var(--cds-layer-accent),0),var(--cds-layer-accent))}.cds--tabs.cds--tabs--contained .cds--tabs__overflow-indicator--right{background-image:linear-gradient(to right,rgba(var(--cds-layer-accent),0),var(--cds-layer-accent))}}}.cds--tabs .cds--tabs__nav-item-label-wrapper,:host(cds-tabs) .cds--tabs__nav-item-label-wrapper,:host(cds-tabs-skeleton) .cds--tabs__nav-item-label-wrapper{display:flex}.cds--tabs:not(.cds--tabs--contained) .cds--tabs__nav-item-label-wrapper,:not(.cds--tabs--contained):host(cds-tabs) .cds--tabs__nav-item-label-wrapper,:not(.cds--tabs--contained):host(cds-tabs-skeleton) .cds--tabs__nav-item-label-wrapper{position:relative;inset-block-start:.0625rem}.cds--tabs .cds--tabs__nav-item,:host(cds-tabs) .cds--tabs__nav-item,:host(cds-tabs-skeleton) .cds--tabs__nav-item{display:flex;flex:1 0 auto;padding:0;cursor:pointer;transition:background-color 70ms cubic-bezier(.2,0,.38,.9)}.cds--tabs .cds--tabs__nav-item html,:host(cds-tabs) .cds--tabs__nav-item html,:host(cds-tabs-skeleton) .cds--tabs__nav-item html{font-size:100%}.cds--tabs .cds--tabs__nav-item body,:host(cds-tabs) .cds--tabs__nav-item body,:host(cds-tabs-skeleton) .cds--tabs__nav-item body{font-weight:400;font-family:\'IBM Plex Sans\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility}.cds--tabs .cds--tabs__nav-item code,:host(cds-tabs) .cds--tabs__nav-item code,:host(cds-tabs-skeleton) .cds--tabs__nav-item code{font-family:\'IBM Plex Mono\',system-ui,-apple-system,BlinkMacSystemFont,\'.SFNSText-Regular\',monospace}.cds--tabs .cds--tabs__nav-item strong,:host(cds-tabs) .cds--tabs__nav-item strong,:host(cds-tabs-skeleton) .cds--tabs__nav-item strong{font-weight:600}.cds--tabs .cds--tabs__nav-item+.cds--tabs__nav-item,:host(cds-tabs) .cds--tabs__nav-item+.cds--tabs__nav-item,:host(cds-tabs-skeleton) .cds--tabs__nav-item+.cds--tabs__nav-item{margin-inline-start:.0625rem}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item{background-color:var(--cds-layer-accent);box-shadow:-.0625rem 0 0 0 var(--cds-border-strong);margin-inline-start:0}.cds--tabs.cds--tabs--vertical .cds--tabs__nav-item{flex:none;background-color:var(--cds-layer-01,#f4f4f4);block-size:4rem;border-block-end:1px solid var(--cds-border-subtle);border-inline-end:1px solid var(--cds-border-subtle);box-shadow:inset 3px 0 0 0 var(--cds-border-subtle);inline-size:100%;margin-inline-start:0}.cds--tabs.cds--tabs--contained:not(.cds--tabs--vertical) .cds--tabs__nav-item--selected+div+.cds--tabs__nav-item{box-shadow:-.0625rem 0 0 0 transparent}.cds--tabs .cds--tabs__nav-item .cds--tabs__nav-link,:host(cds-tabs) .cds--tabs__nav-item .cds--tabs__nav-link,:host(cds-tabs-skeleton) .cds--tabs__nav-item .cds--tabs__nav-link{transition:color 70ms cubic-bezier(.2,0,.38,.9),border-bottom-color 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9)}.cds--tabs.cds--tabs--dismissable .cds--tabs__nav-link{padding-inline-end:2.5rem}.cds--tabs.cds--tabs--dismissable.cds--tabs--contained .cds--tabs__nav-link{padding-inline-end:calc(3rem - 1px)}.cds--tabs .cds--tabs__nav-item--close,:host(cds-tabs) .cds--tabs__nav-item--close,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close{position:relative;display:flex;align-items:center;inset-inline-start:calc(-.75rem - 1px);margin-inline-start:calc(-1.5rem + 1px)}.cds--tabs:not(.cds--tabs--contained) .cds--tabs__nav-item--close--hidden,:not(.cds--tabs--contained):host(cds-tabs) .cds--tabs__nav-item--close--hidden,:not(.cds--tabs--contained):host(cds-tabs-skeleton) .cds--tabs__nav-item--close--hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap;position:static;inline-size:.1875rem}.cds--tabs.cds--tabs--contained.cds--tabs--full-width .cds--tabs__nav-item--close--hidden{display:none}.cds--tabs .cds--tabs__nav-item--close-icon,:host(cds-tabs) .cds--tabs__nav-item--close-icon,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;block-size:1.5rem;inline-size:1.5rem;padding-block:.25rem;padding-inline:.25rem;pointer-events:auto}.cds--tabs .cds--tabs__nav-item--close-icon *,.cds--tabs .cds--tabs__nav-item--close-icon ::after,.cds--tabs .cds--tabs__nav-item--close-icon ::before,:host(cds-tabs) .cds--tabs__nav-item--close-icon *,:host(cds-tabs) .cds--tabs__nav-item--close-icon ::after,:host(cds-tabs) .cds--tabs__nav-item--close-icon ::before,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon *,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon ::after,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon ::before{box-sizing:inherit}.cds--tabs .cds--tabs__nav-item--close-icon::-moz-focus-inner,:host(cds-tabs) .cds--tabs__nav-item--close-icon::-moz-focus-inner,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon::-moz-focus-inner{border:0}.cds--tabs .cds--tabs__nav-item--close-icon svg,:host(cds-tabs) .cds--tabs__nav-item--close-icon svg,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon svg{block-size:1rem;fill:var(--cds-text-secondary,#525252);inline-size:1rem}.cds--tabs .cds--tabs__nav-item--close-icon svg:hover,:host(cds-tabs) .cds--tabs__nav-item--close-icon svg:hover,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon svg:hover{fill:var(--cds-text-primary,#161616)}.cds--tabs .cds--tabs__nav-item--close-icon:hover,:host(cds-tabs) .cds--tabs__nav-item--close-icon:hover,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon:hover{background-color:var(--cds-layer-hover)}.cds--tabs .cds--tabs__nav-item--close-icon:active,.cds--tabs .cds--tabs__nav-item--close-icon:focus,:host(cds-tabs) .cds--tabs__nav-item--close-icon:active,:host(cds-tabs) .cds--tabs__nav-item--close-icon:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon:active,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--tabs .cds--tabs__nav-item--close-icon:active,.cds--tabs .cds--tabs__nav-item--close-icon:focus,:host(cds-tabs) .cds--tabs__nav-item--close-icon:active,:host(cds-tabs) .cds--tabs__nav-item--close-icon:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon:active,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon:focus{outline-style:dotted}}.cds--tabs .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon svg,:host(cds-tabs) .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon svg,:host(cds-tabs-skeleton) .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon svg{fill:var(--cds-text-primary,#161616)}.cds--tabs .cds--tabs__nav-item--close-icon--selected svg,:host(cds-tabs) .cds--tabs__nav-item--close-icon--selected svg,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon--selected svg{fill:var(--cds-text-primary,#161616)}.cds--tabs .cds--tabs__nav-item--close-icon--disabled,.cds--tabs .cds--tabs__nav-item--close-icon--disabled:hover,.cds--tabs .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon--disabled,:host(cds-tabs) .cds--tabs__nav-item--close-icon--disabled,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon--disabled{background-color:inherit;cursor:not-allowed}.cds--tabs .cds--tabs__nav-item--close-icon--disabled svg,.cds--tabs .cds--tabs__nav-item--close-icon--disabled:hover svg,.cds--tabs .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon--disabled svg,:host(cds-tabs) .cds--tabs__nav-item--close-icon--disabled svg,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon--disabled svg{fill:var(--cds-text-disabled,rgba(22,22,22,.25))}.cds--tabs .cds--tabs__nav-item--close-icon--disabled:active,.cds--tabs .cds--tabs__nav-item--close-icon--disabled:focus,.cds--tabs .cds--tabs__nav-item--close-icon--disabled:hover:active,.cds--tabs .cds--tabs__nav-item--close-icon--disabled:hover:focus,.cds--tabs .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon--disabled:active,.cds--tabs .cds--tabs__nav-item:hover+.cds--tabs__nav-item--close .cds--tabs__nav-item--close-icon--disabled:focus,:host(cds-tabs) .cds--tabs__nav-item--close-icon--disabled:active,:host(cds-tabs) .cds--tabs__nav-item--close-icon--disabled:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon--disabled:active,:host(cds-tabs-skeleton) .cds--tabs__nav-item--close-icon--disabled:focus{outline:2px solid transparent;outline-offset:-2px}.cds--tabs .cds--tabs__nav-item--icon,:host(cds-tabs) .cds--tabs__nav-item--icon,:host(cds-tabs-skeleton) .cds--tabs__nav-item--icon{display:flex;align-items:center;padding-inline-start:.5rem}.cds--tabs .cds--tabs__nav-item--icon-left,:host(cds-tabs) .cds--tabs__nav-item--icon-left,:host(cds-tabs-skeleton) .cds--tabs__nav-item--icon-left{display:flex;align-items:center;margin-block-start:-2px;padding-inline-end:.5rem}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--icon{padding-inline-start:var(--cds-layout-density-padding-inline-local)}.cds--tabs .cds--tabs__nav-link,:host(cds-tabs) .cds--tabs__nav-link,:host(cds-tabs-skeleton) .cds--tabs__nav-link{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;outline:2px solid transparent;outline-offset:-2px;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);overflow:hidden;border-block-end:2px solid var(--cds-border-subtle);color:var(--cds-text-secondary,#525252);padding-inline:var(--cds-layout-density-padding-inline-local);text-align:start;text-decoration:none;text-overflow:ellipsis;transition:border 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}.cds--tabs .cds--tabs__nav-link *,.cds--tabs .cds--tabs__nav-link ::after,.cds--tabs .cds--tabs__nav-link ::before,:host(cds-tabs) .cds--tabs__nav-link *,:host(cds-tabs) .cds--tabs__nav-link ::after,:host(cds-tabs) .cds--tabs__nav-link ::before,:host(cds-tabs-skeleton) .cds--tabs__nav-link *,:host(cds-tabs-skeleton) .cds--tabs__nav-link ::after,:host(cds-tabs-skeleton) .cds--tabs__nav-link ::before{box-sizing:inherit}.cds--tabs .cds--tabs__nav-link::-moz-focus-inner,:host(cds-tabs) .cds--tabs__nav-link::-moz-focus-inner,:host(cds-tabs-skeleton) .cds--tabs__nav-link::-moz-focus-inner{border:0}.cds--tabs .cds--tabs__nav-link:active,.cds--tabs .cds--tabs__nav-link:focus,:host(cds-tabs) .cds--tabs__nav-link:active,:host(cds-tabs) .cds--tabs__nav-link:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-link:active,:host(cds-tabs-skeleton) .cds--tabs__nav-link:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--tabs .cds--tabs__nav-link:active,.cds--tabs .cds--tabs__nav-link:focus,:host(cds-tabs) .cds--tabs__nav-link:active,:host(cds-tabs) .cds--tabs__nav-link:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-link:active,:host(cds-tabs-skeleton) .cds--tabs__nav-link:focus{outline-style:dotted}}.cds--tabs.cds--tabs--contained:not(.cds--tabs--vertical) .cds--tabs__nav-link{border-block-end:0;padding-inline:var(--cds-layout-density-padding-inline-local)}.cds--tabs.cds--tabs--contained:not(.cds--tabs--tall) .cds--tabs__nav-item-label{line-height:calc(3rem - .5rem * 2)}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item-secondary-label{font-size:var(--cds-label-01-font-size,.75rem);font-weight:var(--cds-label-01-font-weight,400);line-height:var(--cds-label-01-line-height,1.33333);letter-spacing:var(--cds-label-01-letter-spacing,.32px);min-block-size:1rem}.cds--tabs.cds--tabs--vertical:not(.cds--tabs--tall) .cds--tabs__nav-item-label{line-height:var(--cds-body-compact-01-line-height)}.cds--tabs.cds--tabs__icon--default .cds--tab--list,.cds--tabs.cds--tabs__icon--lg .cds--tab--list{overflow-x:visible}.cds--tabs .cds--tabs__nav-item--icon-only,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--icon-only,:host(cds-tabs) .cds--tabs__nav-item--icon-only,:host(cds-tabs-skeleton) .cds--tabs__nav-item--icon-only{display:flex;align-items:center;justify-content:center;padding:0;block-size:var(--cds-layout-size-height-local);inline-size:var(--cds-layout-size-height-local)}.cds--tabs .cds--tabs__nav-item--icon-only .cds--tabs__nav-item-label,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--icon-only .cds--tabs__nav-item-label,:host(cds-tabs) .cds--tabs__nav-item--icon-only .cds--tabs__nav-item-label,:host(cds-tabs-skeleton) .cds--tabs__nav-item--icon-only .cds--tabs__nav-item-label{line-height:0}.cds--tabs:not(.cds--tabs--contained) .cds--tabs__nav-item:not(.cds--tabs__nav-item--selected):not(.cds--tabs__nav-item--disabled):hover,:not(.cds--tabs--contained):host(cds-tabs) .cds--tabs__nav-item:not(.cds--tabs__nav-item--selected):not(.cds--tabs__nav-item--disabled):hover,:not(.cds--tabs--contained):host(cds-tabs-skeleton) .cds--tabs__nav-item:not(.cds--tabs__nav-item--selected):not(.cds--tabs__nav-item--disabled):hover{border-block-end:2px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616)}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item:not(.cds--tabs__nav-item--selected):not(.cds--tabs__nav-item--disabled):not(.cds--tabs__nav-item--hover-off):hover{background-color:var(--cds-layer-accent-hover);color:var(--cds-text-primary,#161616)}.cds--tabs.cds--tabs--vertical .cds--tabs__nav-item:not(.cds--tabs__nav-item--selected):not(.cds--tabs__nav-item--disabled):not(.cds--tabs__nav-item--hover-off):hover{background-color:var(--cds-layer-hover);box-shadow:inset 3px 0 0 0 var(--cds-border-strong)}.cds--tabs .cds--tabs__nav-item--selected,:host(cds-tabs) .cds--tabs__nav-item--selected,:host(cds-tabs-skeleton) .cds--tabs__nav-item--selected{border-block-end:2px solid var(--cds-border-interactive,#0f62fe);transition:color 70ms cubic-bezier(.2,0,.38,.9)}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected+.cds--tabs__nav-item{box-shadow:none}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item.cds--tabs__nav-item--selected{box-shadow:inset 0 2px 0 0 var(--cds-border-interactive,#0f62fe)}.cds--tabs.cds--tabs--vertical .cds--tabs__nav-item.cds--tabs__nav-item--selected{border-inline:none;box-shadow:inset 3px 0 0 0 var(--cds-border-interactive,#0f62fe)}.cds--tabs .cds--tabs__nav-item--selected,.cds--tabs .cds--tabs__nav-item--selected:active .cds--tabs__nav-link:active,.cds--tabs .cds--tabs__nav-item--selected:focus .cds--tabs__nav-link:focus,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected,:host(cds-tabs) .cds--tabs__nav-item--selected,:host(cds-tabs) .cds--tabs__nav-item--selected:active .cds--tabs__nav-link:active,:host(cds-tabs) .cds--tabs__nav-item--selected:focus .cds--tabs__nav-link:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-item--selected,:host(cds-tabs-skeleton) .cds--tabs__nav-item--selected:active .cds--tabs__nav-link:active,:host(cds-tabs-skeleton) .cds--tabs__nav-item--selected:focus .cds--tabs__nav-link:focus{font-size:var(--cds-heading-compact-01-font-size,.875rem);font-weight:var(--cds-heading-compact-01-font-weight,600);line-height:var(--cds-heading-compact-01-line-height,1.28572);letter-spacing:var(--cds-heading-compact-01-letter-spacing,.16px);color:var(--cds-text-primary,#161616)}.cds--tabs.cds--tabs--contained:not(.cds--tabs--tall) .cds--tabs__nav-item--selected,.cds--tabs.cds--tabs--contained:not(.cds--tabs--tall) .cds--tabs__nav-item--selected:hover{line-height:calc(3rem - .5rem * 2)}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected:hover{background-color:var(--cds-layer)}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected .cds--tabs__nav-link:active,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected .cds--tabs__nav-link:focus,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected:hover .cds--tabs__nav-link:active,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item--selected:hover .cds--tabs__nav-link:focus{box-shadow:none}.cds--tabs.cds--tabs--light.cds--tabs--contained .cds--tabs__nav-item--selected,.cds--tabs.cds--tabs--light.cds--tabs--contained .cds--tabs__nav-item--selected:hover{background-color:var(--cds-background,#fff)}.cds--tabs .cds--tabs__nav-item--disabled,:host(cds-tabs) .cds--tabs__nav-item--disabled,:host(cds-tabs-skeleton) .cds--tabs__nav-item--disabled{background-color:transparent;border-block-end:2px solid var(--cds-border-disabled,#c6c6c6);color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--tabs .cds--tabs__nav-item--disabled:hover,:host(cds-tabs) .cds--tabs__nav-item--disabled:hover,:host(cds-tabs-skeleton) .cds--tabs__nav-item--disabled:hover{border-block-end:2px solid var(--cds-border-disabled,#c6c6c6);color:var(--cds-text-disabled,rgba(22,22,22,.25));cursor:not-allowed}.cds--tabs.cds--tabs--contained .cds--tabs__nav-item.cds--tabs__nav-item--disabled,.cds--tabs.cds--tabs--contained .cds--tabs__nav-item.cds--tabs__nav-item--disabled:hover{background-color:var(--cds-button-disabled,#c6c6c6)}.cds--tabs.cds--tabs--vertical .cds--tabs__nav-item.cds--tabs__nav-item--disabled,.cds--tabs.cds--tabs--vertical .cds--tabs__nav-item.cds--tabs__nav-item--disabled:hover{background-color:var(--cds-layer);border-block-end:1px solid var(--cds-border-subtle)}.cds--tabs .cds--tabs__nav-item--disabled:active,.cds--tabs .cds--tabs__nav-item--disabled:focus,:host(cds-tabs) .cds--tabs__nav-item--disabled:active,:host(cds-tabs) .cds--tabs__nav-item--disabled:focus,:host(cds-tabs-skeleton) .cds--tabs__nav-item--disabled:active,:host(cds-tabs-skeleton) .cds--tabs__nav-item--disabled:focus{border-block-end:2px solid var(--cds-border-disabled,#c6c6c6);outline:0;pointer-events:none}.cds--tabs .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link,:host(cds-tabs) .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link,:host(cds-tabs-skeleton) .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link{border-block-end-color:var(--cds-border-subtle)}.cds--tabs .cds--tabs--light .cds--tabs__nav-item--disabled:hover .cds--tabs__nav-link,:host(cds-tabs) .cds--tabs--light .cds--tabs__nav-item--disabled:hover .cds--tabs__nav-link,:host(cds-tabs-skeleton) .cds--tabs--light .cds--tabs__nav-item--disabled:hover .cds--tabs__nav-link{border-block-end-color:var(--cds-border-subtle)}.cds--tabs .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link:active,.cds--tabs .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link:focus,:host(cds-tabs) .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link:active,:host(cds-tabs) .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link:focus,:host(cds-tabs-skeleton) .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link:active,:host(cds-tabs-skeleton) .cds--tabs--light .cds--tabs__nav-item--disabled .cds--tabs__nav-link:focus{border-block-end-color:var(--cds-border-subtle)}.cds--tabs.cds--tabs--contained:not(.cds--tabs--vertical) .cds--tabs__nav-item--disabled{border-block-end:none;color:var(--cds-text-on-color-disabled,#8d8d8d)}.cds--tab-content{padding:var(--cds-layout-density-padding-inline-local)}.cds--tab-content:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--tab-content:focus{outline-style:dotted}}.cds--tabs--contained~.cds--tab-content{background:var(--cds-layer)}.cds--tabs--vertical~.cds--tab-content{grid-column:3/-1;overflow-y:auto}.cds--tabs--vertical~.cds--tab-content .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,.cds--tabs--vertical~.cds--tab-content .cds--list-box__wrapper--fluid .cds--list-box,.cds--tabs--vertical~.cds--tab-content .cds--list-box__wrapper--fluid.cds--list-box__wrapper,.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid .cds--number__control-btn::after,.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid .cds--number__control-btn::before,.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid input[type=number],.cds--tabs--vertical~.cds--tab-content .cds--search--fluid .cds--search-input,.cds--tabs--vertical~.cds--tab-content .cds--select--fluid .cds--select-input,.cds--tabs--vertical~.cds--tab-content .cds--text-area--fluid .cds--text-area,.cds--tabs--vertical~.cds--tab-content .cds--text-area--fluid .cds--text-area__wrapper,.cds--tabs--vertical~.cds--tab-content .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider+.cds--form-requirement,.cds--tabs--vertical~.cds--tab-content .cds--text-input--fluid .cds--text-input{background-color:var(--cds-field-01,#f4f4f4)}.cds--tabs--vertical~.cds--tab-content .cds--list-box__wrapper--fluid .cds--list-box__menu{background-color:var(--cds-layer-01,#f4f4f4)}.cds--tabs--vertical~.cds--tab-content .cds--list-box__menu-item:hover{background-color:var(--cds-layer-hover-02,#e8e8e8)}.cds--tabs--vertical~.cds--tab-content .cds--list-box__menu-item--active{background-color:var(--cds-layer-selected-02,#e0e0e0)}.cds--tabs--vertical~.cds--tab-content .cds--list-box__menu-item--active:hover{background-color:var(--cds-layer-selected-hover-02,#d1d1d1)}.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid .cds--number__control-btn:hover::after,.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid .cds--number__control-btn:hover::before{background-color:var(--cds-field-hover)}.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid .cds--number__control-btn:focus::after,.cds--tabs--vertical~.cds--tab-content .cds--number-input--fluid .cds--number__control-btn:focus::before{border-inline-start:2px solid var(--cds-focus,#0f62fe)}@media (min-width:66rem){.cds--tabs--vertical~.cds--tab-content{grid-column:5/-1}}.cds--tab-content--interactive:focus{outline:0}.cds--tabs.cds--skeleton{cursor:default;pointer-events:none}.cds--skeleton.cds--tabs:not(.cds--tabs--contained) .cds--tabs__nav-link{border-block-end:2px solid var(--cds-skeleton-element,#c6c6c6)}.cds--tabs.cds--skeleton .cds--tabs__nav-link{display:flex;align-items:center;padding:0 var(--cds-layout-density-padding-inline-local);block-size:100%;inline-size:10rem}.cds--tabs.cds--skeleton .cds--tabs__nav-link span{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;display:block;block-size:.875rem;inline-size:100%}.cds--tabs.cds--skeleton .cds--tabs__nav-link span:active,.cds--tabs.cds--skeleton .cds--tabs__nav-link span:focus,.cds--tabs.cds--skeleton .cds--tabs__nav-link span:hover{border:none;cursor:default;outline:0}.cds--tabs.cds--skeleton .cds--tabs__nav-link span::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--tabs.cds--skeleton .cds--tabs__nav-link span::before{animation:none}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tabs__nav-item .cds--tabs__nav-item--selected .cds--tabs__nav-item--selected{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--tabs .cds--tabs__nav-item--disabled .cds--tabs__nav-link,:host(cds-tabs) .cds--tabs__nav-item--disabled .cds--tabs__nav-link,:host(cds-tabs-skeleton) .cds--tabs__nav-item--disabled .cds--tabs__nav-link{color:GrayText;fill:GrayText}}:host(cds-tabs) .cds--tabs-nav-content-container,:host(cds-tabs-skeleton) .cds--tabs-nav-content-container{position:relative;overflow:scroll;flex:1 1 0%;block-size:2.5rem;scrollbar-width:none}:host(cds-tabs) .cds--tabs-nav-content-container::-webkit-scrollbar,:host(cds-tabs-skeleton) .cds--tabs-nav-content-container::-webkit-scrollbar{display:none}:host(cds-tabs) :where(.cds--tabs-nav-content),:host(cds-tabs-skeleton) :where(.cds--tabs-nav-content){position:absolute;block-size:100%;inset-inline-start:0;transition:inset 110ms cubic-bezier(.2,0,.38,.9)}:host(cds-tabs) .cds--tabs-nav,:host(cds-tabs-skeleton) .cds--tabs-nav{position:absolute;display:block}:host(cds-tabs) .cds--tab--overflow-nav-button,:host(cds-tabs-skeleton) .cds--tab--overflow-nav-button{z-index:1}:host(cds-tabs){outline:2px solid transparent;outline-offset:-2px}:host(cds-tabs) .cds--tabs-trigger svg{block-size:auto;inline-size:auto}:host(cds-tabs:focus) .cds--tabs-trigger{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){:host(cds-tabs:focus) .cds--tabs-trigger{outline-style:dotted}}:host(cds-tab){display:flex;background:0 0;inline-size:100%;outline:0}:host(cds-tab) .cds--tabs__nav-link{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;outline:2px solid transparent;outline-offset:-2px;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);overflow:hidden;align-items:center;padding:.75rem 1rem .5rem;border-block-end:2px solid var(--cds-border-subtle);color:var(--cds-text-secondary,#525252);inline-size:100%;text-align:start;text-decoration:none;text-overflow:ellipsis;transition:border 70ms cubic-bezier(.2,0,.38,.9),outline 70ms cubic-bezier(.2,0,.38,.9);white-space:nowrap}:host(cds-tab) .cds--tabs__nav-link *,:host(cds-tab) .cds--tabs__nav-link ::after,:host(cds-tab) .cds--tabs__nav-link ::before{box-sizing:inherit}:host(cds-tab) .cds--tabs__nav-link::-moz-focus-inner{border:0}:host(cds-tab) .cds--tabs__nav-link:active,:host(cds-tab) .cds--tabs__nav-link:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){:host(cds-tab) .cds--tabs__nav-link:active,:host(cds-tab) .cds--tabs__nav-link:focus{outline-style:dotted}}:host(cds-tab[selected]){display:flex;background-color:transparent;transition:color 70ms cubic-bezier(.2,0,.38,.9)}:host(cds-tab[selected]) .cds--tabs__nav-link{font-size:var(--cds-heading-compact-01-font-size,.875rem);font-weight:var(--cds-heading-compact-01-font-weight,600);line-height:var(--cds-heading-compact-01-line-height,1.28572);letter-spacing:var(--cds-heading-compact-01-letter-spacing,.16px);border-block-end:.125rem solid var(--cds-border-interactive,#0f62fe)}:host(cds-tab[selected]) .cds--tabs__nav-link,:host(cds-tab[selected]) .cds--tabs__nav-link:active,:host(cds-tab[selected]) .cds--tabs__nav-link:focus{color:var(--cds-text-primary,#161616)}:host(cds-tab[selected]):hover{background-color:transparent}:host(cds-tab:hover){background-color:transparent;box-shadow:0 -1px 0 var(--cds-background-hover,rgba(141,141,141,.12))}:host(cds-tab:hover) a.cds--tabs__nav-link{border-block-end:2px solid var(--cds-border-strong);color:var(--cds-text-primary,#161616)}:host(cds-tabs[type=contained]) .cds--tabs-nav-content-container{block-size:3rem}:host(cds-tab[type=contained]){background-color:var(--cds-layer-accent-01,#e0e0e0)}:host(cds-tab[type=contained]) a.cds--tabs__nav-link{padding:.5rem 1rem;block-size:3rem;line-height:calc(3rem - .5rem * 2)}:host(cds-tab[type=contained]) a.cds--tabs__nav-link,:host(cds-tab[type=contained]:hover) a.cds--tabs__nav-link{border-block-end:none;box-shadow:-.0625rem 0 0 0 var(--cds-border-strong)}:host(cds-tab[type=contained][hide-divider]) a.cds--tabs__nav-link{box-shadow:-.0625rem 0 0 0 transparent}:host(cds-tab[disabled][role]),:host(cds-tab[disabled][role]:hover){background-color:transparent;box-shadow:none;cursor:not-allowed;outline:0}:host(cds-tab[disabled][role]) .cds--tabs__nav-link,:host(cds-tab[disabled][role]:hover) .cds--tabs__nav-link{border-block-end:2px solid var(--cds-border-disabled,#c6c6c6);color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0;pointer-events:none}:host(cds-tab[type=contained][disabled][role]) .cds--tabs__nav-link{background-color:var(--cds-button-disabled,#c6c6c6);border-block-end:none;color:var(--cds-text-on-color-disabled,#8d8d8d)}:host(cds-tab[type=contained][selected]),:host(cds-tab[type=contained][selected]:hover){background-color:var(--cds-layer-01,#f4f4f4)}:host(cds-tab[type=contained][selected]) .cds--tabs__nav-link,:host(cds-tab[type=contained][selected]:hover) .cds--tabs__nav-link{border-block-end:none;box-shadow:inset 0 .125rem 0 0 var(--cds-interactive,#0f62fe);line-height:calc(3rem - .5rem * 2)}:host(cds-tab[type=contained][selected]) .cds--tabs__nav-link:active,:host(cds-tab[type=contained][selected]) .cds--tabs__nav-link:focus,:host(cds-tab[type=contained][selected]:hover) .cds--tabs__nav-link:active,:host(cds-tab[type=contained][selected]:hover) .cds--tabs__nav-link:focus{box-shadow:none}:host(cds-tab[type=contained]:hover){background-color:var(--cds-layer-accent-hover)}:host(cds-tab[disabled][in-focus][selected]),:host(cds-tab[disabled][in-focus][selected]:hover),:host(cds-tab[disabled][selected]),:host(cds-tab[disabled][selected]:hover){display:flex;background-color:transparent;box-shadow:none;outline:2px solid transparent;outline-offset:-2px}:host(cds-tab[disabled][in-focus][selected]) .cds--tabs__nav-link,:host(cds-tab[disabled][in-focus][selected]:hover) .cds--tabs__nav-link,:host(cds-tab[disabled][selected]) .cds--tabs__nav-link,:host(cds-tab[disabled][selected]:hover) .cds--tabs__nav-link{font-size:var(--cds-body-short-01-font-size,.875rem);font-weight:var(--cds-body-short-01-font-weight,400);line-height:var(--cds-body-short-01-line-height,1.28572);letter-spacing:var(--cds-body-short-01-letter-spacing,.16px);border-block-end:2px solid var(--cds-border-disabled,#c6c6c6);color:var(--cds-text-disabled,rgba(22,22,22,.25))}:host(cds-tab[disabled][in-focus][selected]) .cds--tabs__nav-link:active,:host(cds-tab[disabled][in-focus][selected]) .cds--tabs__nav-link:focus,:host(cds-tab[disabled][in-focus][selected]:hover) .cds--tabs__nav-link:active,:host(cds-tab[disabled][in-focus][selected]:hover) .cds--tabs__nav-link:focus,:host(cds-tab[disabled][selected]) .cds--tabs__nav-link:active,:host(cds-tab[disabled][selected]) .cds--tabs__nav-link:focus,:host(cds-tab[disabled][selected]:hover) .cds--tabs__nav-link:active,:host(cds-tab[disabled][selected]:hover) .cds--tabs__nav-link:focus{border-block-end-width:3px}:host(cds-tabs-skeleton) .cds--tabs-trigger{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:6.25rem}:host(cds-tabs-skeleton) .cds--tabs-trigger:active,:host(cds-tabs-skeleton) .cds--tabs-trigger:focus,:host(cds-tabs-skeleton) .cds--tabs-trigger:hover{border:none;cursor:default;outline:0}:host(cds-tabs-skeleton) .cds--tabs-trigger::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){:host(cds-tabs-skeleton) .cds--tabs-trigger::before{animation:none}}:host(cds-tab-skeleton){margin-inline-start:.125rem}:host(cds-tab-skeleton) .cds--tabs__nav-link{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;block-size:.75rem;inline-size:4.6875rem}:host(cds-tab-skeleton) .cds--tabs__nav-link:active,:host(cds-tab-skeleton) .cds--tabs__nav-link:focus,:host(cds-tab-skeleton) .cds--tabs__nav-link:hover{border:none;cursor:default;outline:0}:host(cds-tab-skeleton) .cds--tabs__nav-link::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){:host(cds-tab-skeleton) .cds--tabs__nav-link::before{animation:none}}:host(cds-tab-skeleton:first-of-type){margin-inline-start:0}',
]);

let _2 = t => t,
  _t$r,
  _t2$d,
  _t3$6;
function _superPropGet$j(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Tabs.
 *
 * @element cds-tabs
 * @fires cds-tabs-beingselected
 *   The custom event fired before a tab is selected upon a user gesture.
 *   Cancellation of this event stops changing the user-initiated selection.
 * @fires cds-tabs-selected - The custom event fired after a a tab is selected upon a user gesture.
 */
let CDSTabs = _decorate$Z([carbonElement(`${prefix$B}-tabs`)], function (_initialize, _HostListenerMixin) {
  class CDSTabs extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSTabs,
    d: [{
      kind: "field",
      key: "_currentIndex",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      key: "_totalTabs",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      key: "_isScrollable",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "tablist",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "BUTTON_WIDTH",
      value() {
        return 44;
      }
    }, {
      kind: "method",
      key: "_navigate",
      value:
      /**
       * The latest status of this dropdown, for screen reader to accounce.
       */

      /**
       * The currently selected index
       */
      // @ts-ignore: TS thinks this method is not referred to

      /**
       * Total number of tabs in the component
       */

      /**
       * `true` if the tablist is scrollable
       */
      // @ts-ignore: TS thinks this method is not referred to

      /**
       * The DOM element for the tablist.
       */

      /**
       * The width of the overflow scroll buttons.
       */

      /**
       * Navigates through tabs.
       *
       * @param direction `-1` to navigate backward, `1` to navigate forward.
       * @param [options] The options.
       * @param [options.immediate]
       *   Defaults to `true`
       *   `true` to make it "immediate selection change" mode, which does:
       *
       *   Starts with the selected item
       *   Going prev/next item immediately changes the selection
       */
      function _navigate(direction, {
        immediate = true
      } = {}) {
        const {
          selectorItem,
          selectorItemHighlighted,
          selectorItemSelected
        } = this.constructor;
        const nextItem = this._getNextItem(this.querySelector(immediate ? selectorItemSelected : selectorItemHighlighted), direction);
        if (!nextItem) {
          return;
        }
        if (immediate) {
          this._handleUserInitiatedSelectItem(nextItem);
        } else {
          forEach$1(this.querySelectorAll(selectorItem), item => {
            item[immediate ? 'selected' : 'highlighted'] = nextItem === item;
          });
        }

        // Using `{ block: 'nearest' }` to prevent scrolling unless scrolling is absolutely necessary.
        // `scrollIntoViewOptions` seems to work in latest Safari despite of MDN/caniuse table.
        // IE falls back to the old behavior.
        nextItem.scrollIntoView({
          block: 'nearest',
          inline: 'nearest'
        });
        const nextItemText = nextItem.textContent;
        if (nextItemText) {
          this._assistiveStatusText = nextItemText;
        }
        this._currentIndex += direction;
        this.requestUpdate();
      }
    }, {
      kind: "method",
      decorators: [HostListener('click')],
      key: "_handleClick",
      value: function _handleClick(event) {
        _superPropGet$j(CDSTabs, "_handleClick", this, 3)([event]);
      }
    }, {
      kind: "method",
      decorators: [HostListener('keydown')],
      key: "_handleKeydown",
      value: function _handleKeydown(event) {
        const {
          key
        } = event;
        const action = this.constructor.getAction(key);
        const enabledTabs = this.querySelectorAll(`${prefix$B}-tab:not([disabled])`);
        switch (action) {
          case TABS_KEYBOARD_ACTION.HOME:
            {
              const [firstEnabledTab] = enabledTabs;
              firstEnabledTab.scrollIntoView({
                block: 'nearest',
                inline: 'nearest'
              });
              this._handleUserInitiatedSelectItem(firstEnabledTab);
              this.requestUpdate();
            }
            break;
          case TABS_KEYBOARD_ACTION.END:
            {
              const lastEnabledTab = enabledTabs[enabledTabs.length - 1];
              lastEnabledTab.scrollIntoView({
                block: 'nearest',
                inline: 'nearest'
              });
              this._handleUserInitiatedSelectItem(lastEnabledTab);
              this.requestUpdate();
            }
            break;
          case TABS_KEYBOARD_ACTION.NAVIGATING:
            {
              const direction = NAVIGATION_DIRECTION[key];
              if (direction) {
                this._navigate(direction);
              }
            }
            break;
        }
      }

      /**
       * Handles click on overflow scroll buttons.
       *
       * @param _ Event object
       * @param [options] The options.
       * @param [options.direction] `-1` to scroll forward, `1` to scroll backward.
       */
    }, {
      kind: "method",
      key: "_handleScrollButtonClick",
      value: function _handleScrollButtonClick(_, {
        direction
      }) {
        if (!this.tablist) {
          return;
        }
        const {
          scrollLeft,
          clientWidth,
          scrollWidth
        } = this._contentContainerNode;
        switch (direction) {
          case -1:
            this._contentContainerNode.scrollLeft = Math.max(scrollLeft - scrollWidth / this._totalTabs * 1.5, 0);
            break;
          case 1:
            this._contentContainerNode.scrollLeft = Math.min(scrollLeft + scrollWidth / this._totalTabs * 1.5, scrollWidth - clientWidth) + 1;
            break;
        }
      }
    }, {
      kind: "method",
      key: "_handleSlotchange",
      value: function _handleSlotchange() {
        const {
          selectorItemSelected
        } = this.constructor;
        const selectedItem = this.querySelector(selectorItemSelected);
        const nextItem = this._getNextItem(selectedItem, 1);

        // Specifies child `<cds-tab>` to hide its divider instead of using CSS,
        // until `:host-context()` gets supported in all major browsers
        nextItem.hideDivider = true;
      }
    }, {
      kind: "method",
      key: "_selectionDidChange",
      value: function _selectionDidChange(itemToSelect) {
        _superPropGet$j(CDSTabs, "_selectionDidChange", this, 3)([itemToSelect]);
        this._assistiveStatusText = this.selectedItemAssistiveText;
      }

      /**
       * The scrolling container.
       */
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$B}--tabs-nav-content-container`)],
      key: "_contentContainerNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$B}--tabs-nav-content`)],
      key: "_contentNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_currentScrollPosition",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$B}--sub-content-left`)],
      key: "_intersectionLeftSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$B}--sub-content-right`)],
      key: "_intersectionRightSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selecting-items-assistive-text'
      })],
      key: "selectingItemsAssistiveText",
      value() {
        return 'Selecting items. Use up and down arrow keys to navigate.';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-item-assistive-text'
      })],
      key: "selectedItemAssistiveText",
      value() {
        return 'Selected an item.';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'trigger-content'
      })],
      key: "triggerContent",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "type",
      value() {
        return TABS_TYPE.REGULAR;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_isIntersectionLeftTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_isIntersectionRightTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      key: "_observerIntersection",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_observeIntersectionContainer",
      value() {
        return records => {
          const {
            _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
            _intersectionRightSentinelNode: intersectionRightSentinelNode
          } = this;
          records.forEach(({
            isIntersecting,
            target
          }) => {
            if (target === intersectionLeftSentinelNode) {
              this._isIntersectionLeftTrackerInContent = isIntersecting;
            }
            if (target === intersectionRightSentinelNode) {
              this._isIntersectionRightTrackerInContent = isIntersecting;
            }
          });
        };
      }
    }, {
      kind: "method",
      key: "_cleanAndCreateIntersectionObserverContainer",
      value:
      /**
       * The scrolling content.
       */
      /**
       * The current scroll position.
       */
      /**
       * The left-hand sentinel to track intersection with the host element.
       * If they intersect, the left-hand paginator button should be hidden.
       */
      /**
       * The right-hand sentinel to track intersection with the host element.
       * If they intersect, the right-hand paginator button should be hidden.
       */
      /**
       * An assistive text for screen reader to announce, telling the open state.
       */
      /**
       * An assistive text for screen reader to announce, telling that an item is selected.
       */
      /**
       * The content of the trigger button for narrow mode.
       */
      /**
       * Tabs type.
       */
      /**
       * `true` if left-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the left-hand paginator button should be hidden.
       */
      /**
       * `true` if right-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the right-hand paginator button should be hidden.
       */
      /**
       * The observer for the intersection of left-side content edge.
       */
      /**
       * The intersection observer callback for the scrolling container.
       *
       * @param records The intersection observer records.
       */
      /**
       * Cleans-up and creates the intersection observer for the scrolling container.
       *
       * @param [options] The options.
       * @param [options.create] `true` to create the new intersection observer.
       */
      function _cleanAndCreateIntersectionObserverContainer({
        create
      } = {}) {
        const {
          _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
          _intersectionRightSentinelNode: intersectionRightSentinelNode
        } = this;
        if (this._observerIntersection) {
          this._observerIntersection.disconnect();
          this._observerIntersection = null;
        }
        if (create) {
          this._observerIntersection = new IntersectionObserver(this._observeIntersectionContainer, {
            root: this,
            threshold: 0
          });
          if (intersectionLeftSentinelNode) {
            this._observerIntersection.observe(intersectionLeftSentinelNode);
          }
          if (intersectionRightSentinelNode) {
            this._observerIntersection.observe(intersectionRightSentinelNode);
          }
        }
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this._cleanAndCreateIntersectionObserverContainer();
        _superPropGet$j(CDSTabs, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "shouldUpdate",
      value: function shouldUpdate(changedProperties) {
        _superPropGet$j(CDSTabs, "shouldUpdate", this, 3)([changedProperties]);
        if (this.tablist) {
          const {
            clientWidth,
            scrollWidth
          } = this.tablist;
          this._isScrollable = scrollWidth > clientWidth;
        }
        const {
          selectorItem
        } = this.constructor;
        if (changedProperties.has('type')) {
          forEach$1(this.querySelectorAll(selectorItem), elem => {
            this._totalTabs++;
            elem.type = this.type;
          });
        }
        return true;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        const {
          selectorTablist
        } = this.constructor;
        const tablist = this.shadowRoot.querySelector(selectorTablist);
        this.tablist = tablist;
        this._cleanAndCreateIntersectionObserverContainer({
          create: true
        });
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('value')) {
          const tab = this.querySelector(`${prefix$B}-tab[value="${this.value}"]`);
          if (tab) {
            var _tab$getBoundingClien, _tab$offsetLeft;
            const {
              width: tabWidth
            } = (_tab$getBoundingClien = tab === null || tab === void 0 ? void 0 : tab.getBoundingClientRect()) !== null && _tab$getBoundingClien !== void 0 ? _tab$getBoundingClien : {};
            const start = (_tab$offsetLeft = tab.offsetLeft) !== null && _tab$offsetLeft !== void 0 ? _tab$offsetLeft : 0;
            const end = tab.offsetLeft + tabWidth;

            // The start and end of the visible area of the tablist
            const visibleStart = this.tablist.scrollLeft + this.BUTTON_WIDTH;
            const visibleEnd = this.tablist.scrollLeft + this.tablist.clientWidth - this.BUTTON_WIDTH;

            // The beginning of the tab is clipped and not visible
            if (start < visibleStart) {
              this.tablist.scrollLeft = start - this.BUTTON_WIDTH;
            }

            // The end of the tab is clipped and not visible
            if (end > visibleEnd) {
              this.tablist.scrollLeft = end + this.BUTTON_WIDTH - this.tablist.clientWidth;
            }
          }
        }
        if (changedProperties.has('_currentScrollPosition')) {
          if (this._contentNode) {
            this._contentNode.style.insetInlineStart = `-${this._currentScrollPosition}px`;
          }
        }
      }

      /**
       * Render the previous button if tablist is wider than container.
       */
    }, {
      kind: "method",
      key: "renderPreviousButton",
      value: function renderPreviousButton() {
        const {
          _isIntersectionLeftTrackerInContent: isIntersectionLeftTrackerInContent
        } = this;
        const previousButtonClasses = o$2({
          [`${prefix$B}--tab--overflow-nav-button`]: true,
          [`${prefix$B}--tabs__nav-caret-left`]: true,
          [`${prefix$B}--tab--overflow-nav-button--previous`]: true,
          [`${prefix$B}--tab--overflow-nav-button--hidden`]: isIntersectionLeftTrackerInContent
        });
        return x(_t$r || (_t$r = _2`
      <button
        part="prev-button"
        tabindex="-1"
        aria-hidden="true"
        class="${0}"
        @click=${0}>
        ${0}
      </button>
    `), previousButtonClasses, _ => this._handleScrollButtonClick(_, {
          direction: NAVIGATION_DIRECTION.Left
        }), svgResultCarbonIcon$f());
      }

      /**
       * Render the next button if tablist is wider than container.
       */
    }, {
      kind: "method",
      key: "renderNextButton",
      value: function renderNextButton() {
        const {
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent
        } = this;
        const nextButtonClasses = o$2({
          [`${prefix$B}--tab--overflow-nav-button`]: true,
          [`${prefix$B}--tabs__nav-caret-right`]: true,
          [`${prefix$B}--tab--overflow-nav-button--next`]: true,
          [`${prefix$B}--tab--overflow-nav-button--hidden`]: isIntersectionRightTrackerInContent
        });
        return x(_t2$d || (_t2$d = _2`
      <button
        part="next-button"
        tabindex="-1"
        aria-hidden="true"
        class="${0}"
        @click=${0}>
        ${0}
      </button>
    `), nextButtonClasses, _ => this._handleScrollButtonClick(_, {
          direction: NAVIGATION_DIRECTION.Right
        }), svgResultCarbonIcon$k());
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _assistiveStatusText: assistiveStatusText,
          _handleSlotchange: handleSlotchange
        } = this;
        return x(_t3$6 || (_t3$6 = _2`
      ${0}
      <div class="${0}--tabs-nav-content-container">
        <div class="${0}--tabs-nav-content">
          <div class="${0}--tabs-nav">
            <div id="tablist" role="tablist" class="${0}--tab--list">
              <div class="${0}--sub-content-left"></div>
              <slot @slotchange=${0}></slot>
              <div class="${0}--sub-content-right"></div>
            </div>
          </div>
        </div>
      </div>
      ${0}
      <div
        class="${0}--assistive-text"
        role="status"
        aria-live="assertive"
        aria-relevant="additions text">
        ${0}
      </div>
    `), this.renderPreviousButton(), prefix$B, prefix$B, prefix$B, prefix$B, prefix$B, handleSlotchange, prefix$B, this.renderNextButton(), prefix$B, assistiveStatusText);
      }

      /**
       * Symbols of keys that triggers opening/closing menu and selecting/deselecting menu item.
       */
    }, {
      kind: "field",
      static: true,
      key: "TRIGGER_KEYS",
      value() {
        return new Set([' ', 'Enter']);
      }
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value:
      /**
       * A selector that will return tabs.
       */
      function () {
        return `${prefix$B}-tab`;
      }

      /**
       * A selector that will return enabled tabs.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemEnabled",
      value: function () {
        return `${prefix$B}-tab:not([disabled])`;
      }

      /**
       * A selector that will return highlighted tabs.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemHighlighted",
      value: function () {
        return `${prefix$B}-tab[highlighted]`;
      }

      /**
       * A selector that will return selected tabs.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemSelected",
      value: function () {
        return `${prefix$B}-tab[selected]`;
      }

      /**
       * A selector that returns the tablist
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTablist",
      value: function () {
        return `.${prefix$B}--tab--list`;
      }

      /**
       * The name of the custom event fired before a tab is selected upon a user gesture.
       * Cancellation of this event stops changing the user-initiated selection.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeSelect",
      value: function () {
        return `${prefix$B}-tabs-beingselected`;
      }

      /**
       * The name of the custom event fired after a a tab is selected upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelect",
      value: function () {
        return `${prefix$B}-tabs-selected`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$6;
      }
    }, {
      kind: "method",
      static: true,
      key: "getAction",
      value:
      /**
       * @param key The key symbol.
       * @returns A action for dropdown for the given key symbol.
       */
      function getAction(key) {
        if (key === 'Home') {
          return TABS_KEYBOARD_ACTION.HOME;
        }
        if (key === 'End') {
          return TABS_KEYBOARD_ACTION.END;
        }
        if (key in NAVIGATION_DIRECTION) {
          return TABS_KEYBOARD_ACTION.NAVIGATING;
        }
        return TABS_KEYBOARD_ACTION.NONE;
      }
    }]
  };
}, HostListenerMixin(CDSContentSwitcher));

function _decorate$t(e, r, t, i) { var o = _getDecoratorsApi$t(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$t(s.d.map(_createElementDescriptor$t)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$t() { _getDecoratorsApi$t = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$t(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$t(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$t(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$t(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$t(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$t(e) { var r, t = _toPropertyKey$t(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$t(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$t(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$t(o.descriptor) || _isDataDescriptor$t(i.descriptor)) { if (_hasDecorators$t(o) || _hasDecorators$t(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$t(o)) { if (_hasDecorators$t(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$t(o, i); } } else r.push(o); } return r; }
function _hasDecorators$t(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$t(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$t(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$t(t) { var i = _toPrimitive$t(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$t(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$t(r) { return _arrayWithHoles$u(r) || _iterableToArray$t(r) || _unsupportedIterableToArray$u(r) || _nonIterableRest$u(); }
function _nonIterableRest$u() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$u(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$u(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$u(r, a) : void 0; } }
function _arrayLikeToArray$u(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$t(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$u(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$t
} = settings;

/**
 * Megamenu Tabs.
 *
 * @element c4d-megamenu-tabs
 */
let C4DMegaMenuTabs = _decorate$t([carbonElement(`${c4dPrefix$t}-megamenu-tabs`)], function (_initialize, _CDSTabs) {
  class C4DMegaMenuTabs extends _CDSTabs {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuTabs,
    d: [{
      kind: "field",
      key: "_disableIntersectionObservers",
      value() {
        return true;
      }
    }, {
      kind: "method",
      key: "renderPreviousButton",
      value:
      /**
       * @inheritdoc
       */
      // eslint-disable-next-line class-methods-use-this
      function renderPreviousButton() {
        // Button is not desirable for our vertical tabs display.
        return null;
      }

      /**
       * @inheritdoc
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "renderNextButton",
      value: function renderNextButton() {
        // Button is not desirable for our vertical tabs display.
        return null;
      }

      /**
       * A selector that will return megamenu tabs.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${c4dPrefix$t}-megamenu-tab`;
      }

      /**
       * A selector that will return enabled tab items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemEnabled",
      value: function () {
        return `${c4dPrefix$t}-megamenu-tab:not([disabled])`;
      }

      /**
       * A selector that will return selected items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemSelected",
      value: function () {
        return `${c4dPrefix$t}-megamenu-tab[selected]`;
      }

      /**
       * The name of the custom event fired before a tab is selected upon a user gesture.
       * Cancellation of this event stops changing the user-initiated selection.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeSelect",
      value: function () {
        return `${c4dPrefix$t}-megamenu-tabs-beingselected`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, CDSTabs);

var megamenuTabs = /*#__PURE__*/Object.freeze({
  __proto__: null,
  'default': C4DMegaMenuTabs
});

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$5 = i$4([
  '@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}.cds--popover-container{display:inline-block}.cds--popover-container:not(.cds--popover--auto-align){position:relative}.cds--popover--high-contrast .cds--popover{--cds-popover-background-color:var(--cds-background-inverse, #393939);--cds-popover-text-color:var(--cds-text-inverse, #ffffff)}.cds--popover--drop-shadow .cds--popover{--cds-popover-drop-shadow:drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2))}.cds--popover--caret{--cds-popover-offset:0.625rem}.cds--popover{position:absolute;z-index:6000;filter:var(--cds-popover-drop-shadow, none);inset:0;pointer-events:none}.cds--popover-content{--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:6000;display:none;border-radius:var(--cds-popover-border-radius,2px);background-color:var(--cds-popover-background-color,var(--cds-layer));color:var(--cds-popover-text-color,var(--cds-text-primary,#161616));inline-size:-moz-max-content;inline-size:max-content;max-inline-size:23rem;pointer-events:auto}.cds--layout--size-sm .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--popover-content *,.cds--popover-content ::after,.cds--popover-content ::before{box-sizing:inherit}.cds--popover--open>.cds--popover>.cds--popover-content{display:block}.cds--popover-content::before{position:absolute;display:none;content:""}.cds--popover--open>.cds--popover>.cds--popover-content::before{display:block}.cds--popover--auto-align.cds--popover-caret,.cds--popover-caret{position:absolute;z-index:6000;display:none;background-color:var(--cds-popover-background-color,var(--cds-layer));will-change:transform}.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-caret{display:block}.cds--popover--auto-align.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-content>.cds--popover-caret{display:block}.cds--popover--tab-tip>.cds--popover>.cds--popover-caret{display:none}.cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(100% + var(--cds-popover-offset,0)))}.cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--bottom-end>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-left>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-right>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-start>.cds--popover>.cds--popover-content::before,.cds--popover--bottom>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-start:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(-100%)}.cds--popover--bottom-end>.cds--popover>.cds--popover-caret,.cds--popover--bottom-left>.cds--popover>.cds--popover-caret,.cds--popover--bottom-right>.cds--popover>.cds--popover-caret,.cds--popover--bottom-start>.cds--popover>.cds--popover-caret,.cds--popover--bottom>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,var(--cds-popover-offset,0))}[dir=rtl] .cds--popover--bottom-end>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-left>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-right>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-start>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom>.cds--popover>.cds--popover-caret{transform:translate(50%,var(--cds-popover-offset,0))}.cds--popover--bottom-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(-100% - var(--cds-popover-offset,0)))}.cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--top-end>.cds--popover>.cds--popover-content::before,.cds--popover--top-left>.cds--popover>.cds--popover-content::before,.cds--popover--top-right>.cds--popover>.cds--popover-content::before,.cds--popover--top-start>.cds--popover>.cds--popover-content::before,.cds--popover--top>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-end:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--popover--top-end>.cds--popover>.cds--popover-caret,.cds--popover--top-left>.cds--popover>.cds--popover-caret,.cds--popover--top-right>.cds--popover>.cds--popover-caret,.cds--popover--top-start>.cds--popover>.cds--popover-caret,.cds--popover--top>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-1 * var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{transform:translate(50%,calc(-1 * var(--cds-popover-offset,0)))}.cds--popover--top-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),-50%)}.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) * -1 - 16px))}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--right-end>.cds--popover>.cds--popover-content::before,.cds--popover--right-start>.cds--popover>.cds--popover-content::before,.cds--popover--right-top>.cds--popover>.cds--popover-content::before,.cds--popover--right>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-start:0;transform:translateX(-100%)}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-start:100%;transform:translate(calc(var(--cds-popover-offset,0) - 100%),-50%)}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + .1px),-50%)}.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-.5 * var(--cds-popover-offset,0) - 16px))}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--left-end>.cds--popover>.cds--popover-content::before,.cds--popover--left-start>.cds--popover>.cds--popover-content::before,.cds--popover--left-top>.cds--popover>.cds--popover-content::before,.cds--popover--left>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-end:0;transform:translateX(100%)}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + 100%),-50%)}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--tab-tip>.cds--popover>.cds--popover-content{border-radius:0}.cds--popover--tab-tip .cds--popover{will-change:filter}.cds--popover--tab-tip__button{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;align-items:center;justify-content:center;block-size:2rem;inline-size:2rem}.cds--popover--tab-tip__button *,.cds--popover--tab-tip__button ::after,.cds--popover--tab-tip__button ::before{box-sizing:inherit}.cds--popover--tab-tip__button::-moz-focus-inner{border:0}.cds--popover--tab-tip__button:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--popover--tab-tip__button:focus{outline-style:dotted}}.cds--popover--tab-tip__button:hover{background-color:var(--cds-layer-hover)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button{background:var(--cds-layer);box-shadow:0 2px 2px rgba(0,0,0,.2)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after{position:absolute;z-index:6001;background:var(--cds-layer);block-size:2px;content:"";inline-size:100%;inset-block-end:0}.cds--popover--tab-tip__button svg{fill:var(--cds-icon-primary,#161616)}.cds--tooltip{--cds-popover-offset:12px}.cds--tooltip-content{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:var(--cds-tooltip-padding-block,1rem) var(--cds-tooltip-padding-inline,1rem);color:var(--cds-text-inverse,#fff);max-inline-size:18rem}.cds--icon-tooltip{--cds-tooltip-padding-block:0.125rem;--cds-popover-caret-width:0.5rem;--cds-popover-caret-height:0.25rem;--cds-popover-offset:0.5rem}.cds--icon-tooltip .cds--tooltip-content{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--definition-term{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;border-radius:0;border-block-end:1px dotted var(--cds-border-strong);color:var(--cds-text-primary,#161616)}.cds--definition-term *,.cds--definition-term ::after,.cds--definition-term ::before{box-sizing:inherit}.cds--definition-term::-moz-focus-inner{border:0}.cds--definition-term:focus{outline:1px solid var(--cds-focus,#0f62fe);border-block-end-color:var(--cds-border-interactive,#0f62fe)}@media screen and (prefers-contrast){.cds--definition-term:focus{outline-style:dotted}}.cds--definition-term:hover{border-block-end-color:var(--cds-border-interactive,#0f62fe)}.cds--definition-tooltip{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:.5rem 1rem;max-inline-size:11rem}.cds--btn{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));--temp-1lh:(\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );--temp-expressive-1lh:(\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );--temp-padding-block-max:calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:inline-flex;flex-shrink:0;justify-content:space-between;border-radius:0;margin:0;cursor:pointer;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:20rem;min-block-size:var(--cds-layout-size-height-local);outline:0;padding-block:min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - .0625rem,var(--temp-padding-block-max));padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - .0625rem);padding-inline-start:calc(var(--cds-layout-density-padding-inline-local) - .0625rem);text-align:start;text-decoration:none;transition:background 70ms cubic-bezier(0,0,.38,.9),box-shadow 70ms cubic-bezier(0,0,.38,.9),border-color 70ms cubic-bezier(0,0,.38,.9),outline 70ms cubic-bezier(0,0,.38,.9);vertical-align:top}.cds--btn *,.cds--btn ::after,.cds--btn ::before{box-sizing:inherit}.cds--btn.cds--btn--disabled,.cds--btn.cds--btn--disabled:focus,.cds--btn.cds--btn--disabled:hover,.cds--btn:disabled,.cds--btn:focus:disabled,.cds--btn:hover:disabled{border-color:var(--cds-button-disabled,#c6c6c6);background:var(--cds-button-disabled,#c6c6c6);box-shadow:none;color:var(--cds-text-on-color-disabled,#8d8d8d);cursor:not-allowed}.cds--btn .cds--btn__icon{position:absolute;flex-shrink:0;block-size:1rem;inline-size:1rem;inset-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max));inset-inline-end:var(--cds-layout-density-padding-inline-local);margin-block-start:.0625rem}.cds--btn::-moz-focus-inner{padding:0;border:0}.cds--btn--primary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-primary,#0f62fe);color:var(--cds-text-on-color,#fff)}.cds--btn--primary:hover{background-color:var(--cds-button-primary-hover,#0050e6)}.cds--btn--primary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--primary:active{background-color:var(--cds-button-primary-active,#002d9c)}.cds--btn--primary .cds--btn__icon,.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--primary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--secondary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-secondary,#393939);color:var(--cds-text-on-color,#fff)}.cds--btn--secondary:hover{background-color:var(--cds-button-secondary-hover,#474747)}.cds--btn--secondary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--secondary:active{background-color:var(--cds-button-secondary-active,#6f6f6f)}.cds--btn--secondary .cds--btn__icon,.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--secondary:focus,.cds--btn--secondary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-tertiary,#0f62fe);background-color:transparent;color:var(--cds-button-tertiary,#0f62fe)}.cds--btn--tertiary:hover{background-color:var(--cds-button-tertiary-hover,#0050e6)}.cds--btn--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--tertiary:active{background-color:var(--cds-button-tertiary-active,#002d9c)}.cds--btn--tertiary .cds--btn__icon,.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--tertiary:hover{color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:focus{background-color:var(--cds-button-tertiary,#0f62fe);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:active{border-color:transparent;background-color:var(--cds-button-tertiary-active,#002d9c);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary.cds--btn--disabled,.cds--btn--tertiary.cds--btn--disabled:focus,.cds--btn--tertiary.cds--btn--disabled:hover,.cds--btn--tertiary:disabled,.cds--btn--tertiary:focus:disabled,.cds--btn--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-link-primary,#0f62fe);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--ghost:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--btn--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost .cds--btn__icon,.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--ghost:active,.cds--btn--ghost:hover{color:var(--cds-link-primary-hover,#0043ce)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost.cds--btn--disabled,.cds--btn--ghost.cds--btn--disabled:focus,.cds--btn--ghost.cds--btn--disabled:hover,.cds--btn--ghost:disabled,.cds--btn--ghost:focus:disabled,.cds--btn--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost:not([disabled]) svg{fill:var(--cds-icon-primary,#161616)}.cds--btn--icon-only{justify-content:center;padding:0;block-size:var(--cds-layout-size-height-local);inline-size:var(--cds-layout-size-height-local);padding-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only>:first-child{margin-block-start:.0625rem;min-inline-size:1rem}.cds--btn--icon-only .cds--btn__icon{position:static}.cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon{margin:0}.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon{margin-block-start:0}.cds--btn--icon-only.cds--btn--selected{background:var(--cds-background-selected,rgba(141,141,141,.2))}.cds--btn path[data-icon-path=inner-path]{fill:none}.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:var(--cds-icon-primary,#161616)}.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn--ghost.cds--btn--icon-only[disabled]{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled]{pointer-events:none}.cds--btn--danger{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger .cds--btn__icon,.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-danger-secondary,#da1e28);background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28)}.cds--btn--danger--tertiary:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--tertiary:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--tertiary .cds--btn__icon,.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--tertiary:hover{border-color:var(--cds-button-danger-hover,#b81921);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:focus{background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:active{border-color:var(--cds-button-danger-active,#750e13);background-color:var(--cds-button-danger-active,#750e13);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary.cds--btn--disabled,.cds--btn--danger--tertiary.cds--btn--disabled:focus,.cds--btn--danger--tertiary.cds--btn--disabled:hover,.cds--btn--danger--tertiary:disabled,.cds--btn--danger--tertiary:focus:disabled,.cds--btn--danger--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--danger--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--danger--ghost:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--ghost:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--danger--ghost:active,.cds--btn--danger--ghost:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--ghost.cds--btn--disabled,.cds--btn--danger--ghost.cds--btn--disabled:focus,.cds--btn--danger--ghost.cds--btn--disabled:hover,.cds--btn--danger--ghost:disabled,.cds--btn--danger--ghost:focus:disabled,.cds--btn--danger--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--btn--expressive{font-size:var(--cds-body-compact-02-font-size,1rem);font-weight:var(--cds-body-compact-02-font-weight,400);line-height:var(--cds-body-compact-02-line-height,1.375);letter-spacing:var(--cds-body-compact-02-letter-spacing,0);padding-block:min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only.cds--btn--expressive{padding:12px 13px}.cds--btn.cds--btn--expressive .cds--btn__icon{block-size:1.25rem;inline-size:1.25rem}.cds--btn-set .cds--btn.cds--btn--expressive{max-inline-size:20rem}.cds--btn.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:9.375rem}.cds--btn.cds--skeleton:active,.cds--btn.cds--skeleton:focus,.cds--btn.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--btn.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--btn.cds--skeleton::before{animation:none}}.cds--btn-set{display:flex}.cds--btn-set--stacked{flex-direction:column}.cds--btn-set .cds--btn{inline-size:100%;max-inline-size:12.25rem}.cds--btn-set .cds--btn:not(:focus){box-shadow:-.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn:focus+.cds--btn{box-shadow:inherit}.cds--btn-set--stacked .cds--btn:not(:focus){box-shadow:0 -.0625rem 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn.cds--btn--disabled{box-shadow:-.0625rem 0 0 0 var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set--stacked .cds--btn.cds--btn--disabled{box-shadow:0 -.0625rem 0 0 var(--cds-layer-selected-disabled,#8d8d8d)}.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set .cds--btn.cds--btn--loading{border-color:transparent;background-color:transparent;box-shadow:none}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn:focus{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:ButtonText}}[dir=rtl] .cds--btn-set .cds--btn:not(:focus){box-shadow:.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--header,:host(cds-header){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:fixed;z-index:8000;display:flex;align-items:center;background-color:var(--cds-background,#fff);block-size:3rem;border-block-end:1px solid var(--cds-border-subtle);inset-block-start:0;inset-inline-end:0;inset-inline-start:0}.cds--header *,.cds--header ::after,.cds--header ::before,:host(cds-header) *,:host(cds-header) ::after,:host(cds-header) ::before{box-sizing:inherit}.cds--header__action{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:inline-flex;border:.0625rem solid transparent;block-size:3rem;inline-size:3rem;transition:background-color 110ms,border-color 110ms}.cds--header__action *,.cds--header__action ::after,.cds--header__action ::before{box-sizing:inherit}.cds--header__action::-moz-focus-inner{border:0}@media (max-width:41.98rem){.cds--header__action{min-inline-size:3rem}}.cds--header__global .cds--popover,:host(cds-header) ::slotted(.cds--header__global) .cds--popover{z-index:8001}.cds--header__action>:first-child{margin-block-start:0}.cds--header__action--active>svg.cds--navigation-menu-panel-expand-icon,.cds--header__action>svg.cds--navigation-menu-panel-collapse-icon{display:none}.cds--header__action--active>svg.cds--navigation-menu-panel-collapse-icon{display:inline}.cds--header__action:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--header__action--active{background:var(--cds-layer);border-block-end:1px solid transparent;border-inline-end:1px solid var(--cds-border-subtle);border-inline-start:1px solid var(--cds-border-subtle)}.cds--header__action--active>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__action:focus{border-color:var(--cds-focus,#0f62fe);outline:0}.cds--header__action:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--header__action.cds--btn--icon-only{align-items:center;justify-content:center}.cds--btn.cds--btn--icon-only.cds--header__action svg{fill:var(--cds-icon-secondary,#525252)}.cds--btn.cds--btn--icon-only.cds--header__action--active svg,.cds--btn.cds--btn--icon-only.cds--header__action:active svg,.cds--btn.cds--btn--icon-only.cds--header__action:hover svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-trigger>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-trigger:hover>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-toggle{display:flex;align-items:center;justify-content:center}@media (min-width:66rem){.cds--header__menu-toggle__hidden{display:none}}a.cds--header__name{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;align-items:center;padding:0 2rem 0 1rem;border:.125rem solid transparent;block-size:100%;font-weight:600;letter-spacing:.1px;line-height:1.25rem;outline:0;text-decoration:none;transition:border-color 110ms;-webkit-user-select:none;-moz-user-select:none;user-select:none}@media (max-width:41.98rem){a.cds--header__name{padding:0 1rem}}a.cds--header__name:focus{border-color:var(--cds-focus,#0f62fe)}.cds--header__name--prefix{font-weight:400}a.cds--header__name,a.cds--header__name:hover{color:var(--cds-text-primary,#161616)}.cds--header__menu-toggle:not(.cds--header__menu-toggle__hidden)~.cds--header__name{padding-inline-start:.5rem}.cds--header__nav,:host(cds-header-nav){position:relative;display:none;block-size:100%;padding-inline-start:1rem}@media (min-width:66rem){.cds--header__nav,:host(cds-header-nav){display:block}}.cds--header__nav::before{position:absolute;display:block;background-color:var(--cds-border-subtle);block-size:1.5rem;content:"";inline-size:.0625rem;inset-block-start:50%;inset-inline-start:0;transform:translateY(-50%)}.cds--header__menu-bar{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:flex;padding:0;margin:0;block-size:100%;list-style:none}.cds--header__menu-bar *,.cds--header__menu-bar ::after,.cds--header__menu-bar ::before{box-sizing:inherit}a.cds--header__menu-item{position:relative;display:flex;align-items:center;padding:0 1rem;border:2px solid transparent;background-color:var(--cds-background,#fff);block-size:100%;color:var(--cds-text-secondary,#525252);font-size:.875rem;font-weight:400;letter-spacing:0;line-height:1.125rem;text-decoration:none;transition:background-color 110ms,border-color 110ms,color 110ms;-webkit-user-select:none;-moz-user-select:none;user-select:none}a.cds--header__menu-item:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}.cds--header__action:active,a.cds--header__menu-item:active{background-color:var(--cds-background-active,rgba(141,141,141,.5));color:var(--cds-text-primary,#161616)}a.cds--header__menu-item:focus{border-color:var(--cds-focus,#0f62fe);outline:0}a.cds--header__menu-item:active>svg,a.cds--header__menu-item:hover>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-item--current,a.cds--header__menu-item[aria-current=page]{color:var(--cds-text-primary,#161616)}.cds--header__menu-item--current::after,a.cds--header__menu-item[aria-current=page]::after{position:absolute;background-color:var(--cds-border-interactive,#0f62fe);block-size:3px;content:"";inline-size:calc(100% + 4px);inset-block-end:-2px;inset-inline-start:-2px}.cds--header__menu-item--current:focus::after,a.cds--header__menu-item[aria-current=page]:focus::after{border:0}.cds--header__submenu .cds--header__menu .cds--header__menu-item--current::after,.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]::after,:host(cds-header-menu) .cds--header__menu .cds--header__menu-item--current::after,:host(cds-header-menu) .cds--header__menu a.cds--header__menu-item[aria-current=page]::after{background-color:var(--cds-border-interactive,#0f62fe);block-size:calc(100% + 4px);inline-size:3px;inset-block-start:-2px;inset-inline-start:-2px}.cds--header__submenu .cds--header__menu .cds--header__menu-item--current:focus::after,.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after,:host(cds-header-menu) .cds--header__menu .cds--header__menu-item--current:focus::after,:host(cds-header-menu) .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after{background-color:var(--cds-border-interactive,#0f62fe);block-size:calc(100% + 4px);inline-size:5px;inset-block-start:-2px;inset-inline-start:-2px}a.cds--header__menu-item.cds--header__menu-item--current:focus,a.cds--header__menu-item[aria-current=page]:focus{border:2px solid var(--cds-focus,#0f62fe)}.cds--header__submenu,:host(cds-header-menu){position:relative}.cds--header__menu-title[aria-haspopup=true]{position:relative}.cds--header__menu-title[aria-expanded=true]{z-index:8002;background-color:var(--cds-layer);color:var(--cds-text-secondary,#525252)}.cds--header__menu-title[aria-expanded=true]>.cds--header__menu-arrow{transform:rotate(180deg)}.cds--header__menu{display:none;padding:0;margin:0;list-style:none}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu{position:absolute;z-index:8001;display:flex;flex-direction:column;background-color:var(--cds-layer);box-shadow:0 4px 8px 0 rgba(0,0,0,.5);inline-size:12.5rem;inset-block-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item{background-color:var(--cds-layer)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item:hover{background-color:var(--cds-layer-hover);color:var(--cds-text-primary,#161616)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item:active{background-color:var(--cds-layer-active);color:var(--cds-text-primary,#161616)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item.cds--header__menu-item--current{background-color:var(--cds-layer-selected)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item.cds--header__menu-item--current:hover{background-color:var(--cds-layer-selected-hover)}.cds--header__menu .cds--header__menu-item{block-size:3rem}.cds--header__menu-arrow{fill:var(--cds-icon-secondary,#525252);margin-inline-start:.5rem;transition:transform 110ms,fill 110ms}.cds--header__global,:host(cds-header) ::slotted(.cds--header__global){display:flex;flex:1 1 0%;justify-content:flex-end;block-size:100%}.cds--skip-to-content{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--skip-to-content:focus{z-index:9999;display:flex;align-items:center;padding:0 1rem;border:4px solid var(--cds-focus,#0f62fe);background-color:var(--cds-background,#fff);block-size:3rem;clip:auto;color:var(--cds-text-secondary,#525252);inline-size:auto;inset-block-start:0;inset-inline-start:0;outline:0}.cds--header-panel,:host(cds-header-panel){position:fixed;z-index:8000;overflow:hidden;border:none;background-color:var(--cds-layer);color:var(--cds-text-secondary,#525252);inline-size:0;inset-block-end:0;inset-block-start:3rem;inset-inline-end:0;transition:width 110ms cubic-bezier(.2,0,1,.9);will-change:width}.cds--header-panel--expanded,:host(cds-header-panel[expanded]){border-inline-end:1px solid var(--cds-border-subtle);border-inline-start:1px solid var(--cds-border-subtle);inline-size:16rem;overflow-y:auto}.cds--switcher,:host(cds-switcher){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:flex;flex-direction:column;align-items:center;justify-content:center;color:var(--cds-text-secondary,#525252)}.cds--switcher *,.cds--switcher ::after,.cds--switcher ::before,:host(cds-switcher) *,:host(cds-switcher) ::after,:host(cds-switcher) ::before{box-sizing:inherit}.cds--switcher__item,:host(cds-switcher-item){block-size:2rem;inline-size:100%}.cds--switcher__item:nth-child(1){margin-block-start:1rem}.cds--switcher__item--divider,:host(cds-switcher-divider){display:block;border:none;margin:.5rem 1rem;background:var(--cds-border-subtle);block-size:1px;inline-size:14rem}.cds--switcher__item-link{font-size:var(--cds-heading-compact-01-font-size,.875rem);font-weight:var(--cds-heading-compact-01-font-weight,600);line-height:var(--cds-heading-compact-01-line-height,1.28572);letter-spacing:var(--cds-heading-compact-01-letter-spacing,.16px);display:block;padding:.375rem 1rem;block-size:2rem;color:var(--cds-text-secondary,#525252);text-decoration:none}.cds--switcher__item-link:hover:not(.cds--switcher__item-link--selected){background:var(--cds-layer-hover);color:var(--cds-text-primary,#161616);cursor:pointer}.cds--switcher__item-link:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}.cds--switcher__item-link:active{background:var(--cds-layer-active);color:var(--cds-text-primary,#161616)}.cds--switcher__item-link--selected{background:var(--cds-layer-selected);color:var(--cds-text-primary,#161616)}:host(cds-header-nav) .cds-ce--header__divider{position:absolute;background-color:var(--cds-border-subtle);block-size:1.5rem;inline-size:.0625rem;inset-block-start:50%;inset-inline-start:0;transform:translateY(-50%)}:host(cds-header-nav-item){outline:0}:host(cds-header-menu){outline:0}:host(cds-header-menu-item){outline:0}:host(cds-header-menu-item) a.cds--header__menu-item{background-color:var(--cds-layer);block-size:3rem}:host(cds-header-menu-item) a.cds--header__menu-item:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}:host(cds-header-menu-item) a.cds--header__menu-item:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}:host(cds-header-menu-item) a.cds--header__menu-item--current{background-color:var(--cds-layer-selected)}:host(cds-header-menu-item) a.cds--header__menu-item--current:hover{background-color:var(--cds-layer-selected-hover)}:host(cds-header-menu-item) a.cds--header__menu-item--current::after{position:absolute;background-color:var(--cds-border-interactive,#0f62fe);block-size:100%;content:"";inline-size:3px;inset-block:-.125rem;inset-inline-start:-.125rem}:host(cds-header-global-action) ::slotted(svg){fill:var(--cds-icon-secondary,#525252)}:host(cds-header-global-action):hover ::slotted(svg){fill:var(--cds-icon-primary,#161616)}:host(cds-header-global-action) .cds--popover{z-index:8001}:host(cds-header-menu) a.cds--header__menu-item,:host(cds-header-nav-item) a.cds--header__menu-item{box-sizing:border-box}:host(cds-header-menu-button){display:content;outline:0}@media (min-width:66rem){:host(cds-header-menu-button){display:none}}:host(cds-header-menu-button[collapse-mode=fixed]){display:none}@media (min-width:66rem){:host(cds-header-menu-button[collapse-mode=rail]){display:block}}:host(cds-header-name){display:content;block-size:100%}:host(cds-header-name) a{box-sizing:border-box}:host(cds-switcher-item) a{box-sizing:border-box}:host(cds-switcher-item:nth-child(1)){margin-block-start:1rem}',
]);

let _$q = t => t,
  _t$q;
function _superPropGet$i(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Header menu.
 *
 * @element cds-header-menu
 * @csspart trigger The trigger button.
 * @csspart trigger-icon The trigger button icon.
 * @csspart menu-body The menu body.
 */
let CDSHeaderMenu = _decorate$Z([carbonElement(`${prefix$B}-header-menu`)], function (_initialize, _HostListenerMixin) {
  class CDSHeaderMenu extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSHeaderMenu,
    d: [{
      kind: "field",
      decorators: [i$1('[part="trigger"]')],
      key: "_topMenuItem",
      value: void 0
    }, {
      kind: "field",
      key: "_hasActiveChildren",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "_handleClick",
      value:
      /**
       * The trigger button.
       */

      /**
       * keeps track if header menu has any active submenus
       */

      /**
       * Handles `click` event handler on this element.
       */
      function _handleClick() {
        this._handleUserInitiatedToggle();
      }

      /**
       * Handler for the `keydown` event on the trigger button.
       */
    }, {
      kind: "method",
      decorators: [HostListener('keydown')],
      key: "_handleKeydownTrigger",
      value: function _handleKeydownTrigger({
        key
      }) {
        if (key === 'Esc' || key === 'Escape') {
          this._handleUserInitiatedToggle(false);
        }
      }

      /**
       * Handles user-initiated toggling the open state.
       *
       * @param [force] If specified, forces the open state to the given one.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedToggle",
      value: function _handleUserInitiatedToggle(force = !this.expanded) {
        this.expanded = force;
        if (!force) {
          this._topMenuItem.focus();
        }
      }

      /**
       * Handles `blur` event handler on this element.
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusout')],
      key: "_handleBlur",
      value: function _handleBlur({
        relatedTarget
      }) {
        if (!this.contains(relatedTarget)) {
          this.expanded = false;
        }
      }

      /**
       * `true` if the menu should be expanded.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "expanded",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'is-active',
        reflect: true
      })],
      key: "isActive",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'trigger-content'
      })],
      key: "triggerContent",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-label'
      })],
      key: "menuLabel",
      value: void 0
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * Applies selected styles to the item if a user sets this to true and `aria-current !== 'page'`.
       */
      /**
       * The content of the trigger button.
       */
      /**
       * The `aria-label` attribute for the menu UI.
       */
      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'listitem');
        }
        const {
          selectorItem
        } = this.constructor;
        forEach$1(this.querySelectorAll(selectorItem), elem => {
          if (elem.isActive === true) {
            this._hasActiveChildren = true;
          }
        });
        _superPropGet$i(CDSHeaderMenu, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('expanded')) {
          const {
            selectorItem
          } = this.constructor;
          const {
            expanded
          } = this;
          forEach$1(this.querySelectorAll(selectorItem), elem => {
            elem.tabIndex = expanded ? 0 : -1;
          });
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          expanded,
          isActive,
          triggerContent,
          menuLabel,
          _hasActiveChildren,
          _handleClick: handleClick
        } = this;
        const linkClasses = o$2({
          [`${prefix$B}--header__menu-item`]: true,
          [`${prefix$B}--header__menu-title`]: true,
          [`${prefix$B}--header__menu-item--current`]: isActive || _hasActiveChildren && !expanded
        });
        return x(_t$q || (_t$q = _$q`
      <a
        part="trigger"
        role="button"
        tabindex="0"
        class="${0}"
        href="javascript:void 0"
        aria-haspopup="menu"
        aria-expanded="${0}"
        @click=${0}>
        ${0}${0}
      </a>
      <ul
        part="menu-body"
        class="${0}--header__menu"
        aria-label="${0}">
        <slot></slot>
      </ul>
    `), linkClasses, String(Boolean(expanded)), handleClick, triggerContent, svgResultCarbonIcon$H({
          part: 'trigger-icon',
          class: `${prefix$B}--header__menu-arrow`
        }), prefix$B, l(menuLabel));
      }

      /**
       * A selector that will return the menu items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${prefix$B}-header-menu-item`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$5;
      }
    }]
  };
}, HostListenerMixin(FocusMixin(s)));

function _decorate$s(e, r, t, i) { var o = _getDecoratorsApi$s(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$s(s.d.map(_createElementDescriptor$s)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$s() { _getDecoratorsApi$s = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$s(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$s(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$s(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$s(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$s(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$s(e) { var r, t = _toPropertyKey$s(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$s(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$s(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$s(o.descriptor) || _isDataDescriptor$s(i.descriptor)) { if (_hasDecorators$s(o) || _hasDecorators$s(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$s(o)) { if (_hasDecorators$s(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$s(o, i); } } else r.push(o); } return r; }
function _hasDecorators$s(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$s(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$s(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$s(t) { var i = _toPrimitive$s(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$s(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$s(r) { return _arrayWithHoles$t(r) || _iterableToArray$s(r) || _unsupportedIterableToArray$t(r) || _nonIterableRest$t(); }
function _nonIterableRest$t() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$t(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$t(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$t(r, a) : void 0; } }
function _arrayLikeToArray$t(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$s(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$t(r) { if (Array.isArray(r)) return r; }
function _superPropGet$h(t, e, r, o) { var p = _get$e(_getPrototypeOf$e(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$e() { return _get$e = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$e(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$e.apply(null, arguments); }
function _superPropBase$e(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$e(t));); return t; }
function _getPrototypeOf$e(t) { return _getPrototypeOf$e = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$e(t); }
const {
  stablePrefix: c4dPrefix$s
} = settings;

/**
 * Masthead top nav submenu.
 *
 * @element c4d-top-nav-menu
 */
let C4DTopNavMenu = _decorate$s([carbonElement(`${c4dPrefix$s}-top-nav-menu`)], function (_initialize, _CDSHeaderMenu) {
  class C4DTopNavMenu extends _CDSHeaderMenu {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavMenu,
    d: [{
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * `true` if this submenu should be in its active state.
       */

      function updated(changedProperties) {
        var _this$shadowRoot;
        _superPropGet$h(C4DTopNavMenu, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('active')) {
          const {
            active,
            _topMenuItem: triggerNode
          } = this;
          if (triggerNode) {
            triggerNode.setAttribute('data-selected', String(Boolean(active)));
          }
        }
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet$h(C4DTopNavMenu, "connectedCallback", this, 3)([]);
        this.removeAttribute('role');
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, CDSHeaderMenu);

function _decorate$r(e, r, t, i) { var o = _getDecoratorsApi$r(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$r(s.d.map(_createElementDescriptor$r)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$r() { _getDecoratorsApi$r = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$r(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$r(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$r(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$r(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$r(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$r(e) { var r, t = _toPropertyKey$r(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$r(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$r(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$r(o.descriptor) || _isDataDescriptor$r(i.descriptor)) { if (_hasDecorators$r(o) || _hasDecorators$r(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$r(o)) { if (_hasDecorators$r(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$r(o, i); } } else r.push(o); } return r; }
function _hasDecorators$r(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$r(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$r(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$r(t) { var i = _toPrimitive$r(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$r(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$r(r) { return _arrayWithHoles$s(r) || _iterableToArray$r(r) || _unsupportedIterableToArray$s(r) || _nonIterableRest$s(); }
function _nonIterableRest$s() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$s(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$s(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$s(r, a) : void 0; } }
function _arrayLikeToArray$s(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$r(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$s(r) { if (Array.isArray(r)) return r; }
function _superPropGet$g(t, e, r, o) { var p = _get$d(_getPrototypeOf$d(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$d() { return _get$d = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$d(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$d.apply(null, arguments); }
function _superPropBase$d(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$d(t));); return t; }
function _getPrototypeOf$d(t) { return _getPrototypeOf$d = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$d(t); }
const {
  prefix: prefix$h,
  stablePrefix: c4dPrefix$r
} = settings;

/**
 * Megamenu top nav menu.
 *
 * @element c4d-megamenu-top-nav-menu
 */
let C4DMegaMenuTopNavMenu = _decorate$r([carbonElement(`${c4dPrefix$r}-megamenu-top-nav-menu`)], function (_initialize, _C4DTopNavMenu) {
  class C4DMegaMenuTopNavMenu extends _C4DTopNavMenu {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuTopNavMenu,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "megaMenu",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$h}--header__menu`)],
      key: "_menuNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_scrollBarWidth",
      value() {
        return this.ownerDocument.defaultView.innerWidth - this.ownerDocument.body.offsetWidth;
      }
    }, {
      kind: "field",
      key: "_observerResizeRoot",
      value() {
        return null;
      }
    }, {
      kind: "method",
      key: "_cleanAndCreateObserverResize",
      value:
      /**
       * The megamenu component
       */

      /**
       * The menu ul node.
       */

      /**
       * scrollbar width.
       */

      /**
       * Identifier for this menu's position in a series.
       */

      /**
       * The observer for the resize of the viewport.
       */
      // TODO: Wait for `.d.ts` update to support `ResizeObserver`

      /**
       * Cleans-up and creats the resize observer for the scrolling container.
       *
       * @param [options] The options.
       * @param [options.create] `true` to create the new resize observer.
       */
      function _cleanAndCreateObserverResize({
        create
      } = {}) {
        if (this._observerResizeRoot) {
          this._observerResizeRoot.disconnect();
          this._observerResizeRoot = null;
        }
        if (create) {
          // TODO: Wait for `.d.ts` update to support `ResizeObserver`
          // @ts-ignore
          this._observerResizeRoot = new ResizeObserver(this._observeResizeRoot);
          this._observerResizeRoot.observe(this.ownerDocument.documentElement);
        }
      }

      /**
       * The observer for the resize of the viewport.
       */
    }, {
      kind: "field",
      key: "_observeResizeRoot",
      value() {
        return records => {
          const {
            contentRect
          } = records[records.length - 1];
          // A workaround for Safari bug where `100vw` in Shadow DOM causes delayed rendering
          // https://github.com/carbon-design-system/carbon-for-ibm-dotcom/issues/4493
          const {
            customPropertyViewportWidth
          } = this.constructor;
          this.style.setProperty(customPropertyViewportWidth, `${contentRect.width}px`);
        };
      }
    }, {
      kind: "method",
      key: "_requestMegaMenuRenderUpdate",
      value: async function _requestMegaMenuRenderUpdate() {
        return new Promise(resolve => {
          const {
            eventMegaMenuToggled
          } = this.constructor;
          this.dispatchEvent(new CustomEvent(eventMegaMenuToggled, {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: {
              active: this.expanded,
              index: this.menuIndex,
              resolveFn: resolve
            }
          }));
          setTimeout(() => {
            resolve();
          }, 5000);
        });
      }
    }, {
      kind: "method",
      key: "_setAnalyticsAttributes",
      value: function _setAnalyticsAttributes() {
        const {
          _topMenuItem: trigger
        } = this;
        trigger.setAttribute('data-attribute1', 'headerNav');
        trigger.setAttribute('data-attribute2', 'L0');
        trigger.setAttribute('data-attribute3', this.menuLabel);
      }

      /**
       * Sets inline styles on an element to accommodate any scrollbars that push it
       * out of Carbon grid alignment.
       *
       * @private
       */
    }, {
      kind: "method",
      key: "_handleScrollbarOffset",
      value: function _handleScrollbarOffset(element) {
        element.style.marginInlineEnd = this.expanded ? `${this._scrollBarWidth}px` : `0px`;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet$g(C4DMegaMenuTopNavMenu, "connectedCallback", this, 3)([]);
        this._cleanAndCreateObserverResize({
          create: true
        });
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this._cleanAndCreateObserverResize();
        _superPropGet$g(C4DMegaMenuTopNavMenu, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        this._menuNode.removeAttribute('role');
        this._cleanAndCreateObserverResize({
          create: true
        });
        this._setAnalyticsAttributes();
        if (this.hasAttribute('role') && this.getAttribute('role') === 'listitem') {
          this.removeAttribute('role');
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: async function updated(changedProperties) {
        _superPropGet$g(C4DMegaMenuTopNavMenu, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('expanded')) {
          var _masthead$shadowRoot;
          const doc = this.ownerDocument;
          const rootNode = this.getRootNode();
          const masthead = rootNode.querySelector('c4d-masthead');

          // Find overlay and update its state.
          const overlays = rootNode.querySelectorAll(this.constructor.selectorOverlay);
          overlays.forEach(item => {
            item.active = this.expanded;
          });

          // Collect elements that should have offsets applied to accommodate any
          // scrollbars when they appear in the layout.
          const elementsToAdjust = [doc.body, masthead === null || masthead === void 0 || (_masthead$shadowRoot = masthead.shadowRoot) === null || _masthead$shadowRoot === void 0 ? void 0 : _masthead$shadowRoot.querySelector(`.${prefix$h}--masthead__l0`), masthead === null || masthead === void 0 ? void 0 : masthead.querySelector(`${c4dPrefix$r}-masthead-l1`)].filter(element => element instanceof HTMLElement);
          if (this.expanded) {
            var _this$parentElement;
            // Import needed subcomponents on first expansion
            if (!((_this$parentElement = this.parentElement) !== null && _this$parentElement !== void 0 && _this$parentElement.importedMegamenu)) {
              await Promise.all([import('./megamenu-left-navigation-dba059eb.js'), import('./megamenu-category-link-d1712222.js'), import('./megamenu-category-link-group-ba6e3528.js'), import('./megamenu-category-group-768aa48a.js'), import('./megamenu-category-group-copy-0036630c.js'), import('./megamenu-category-heading-25325ce1.js'), Promise.resolve().then(function () { return megamenuLinkWithIcon; }), import('./megamenu-overlay-899719ba.js'), import('./megamenu-tab-1835d1a2.js'), Promise.resolve().then(function () { return megamenuTabs; })]);
              this.parentElement.importedMegamenu = true;
            }

            // Ask masthead-composite to render megamenu.
            // Pause further execution until the render is complete.
            await this._requestMegaMenuRenderUpdate();

            // Lock document to prevent scrolling while menu is open.
            doc.body.style.overflow = `hidden`;

            // Set scrollbar adjustments.
            elementsToAdjust.forEach(element => this._handleScrollbarOffset(element));
          } else {
            /**
             * Return focus to topMenuItem only when expanded explicitly equals false.
             * On load, when expanded is undefined, avoid taking control of focus.
             * This is deliberately in a 0ms timeout to put the check at the end of
             * the event loop to avoid interrupting the browser's focus handoff.
             */
            if (changedProperties.get('expanded') === false) {
              setTimeout(() => {
                const {
                  activeElement
                } = document;
                if (activeElement === null || activeElement.tagName.toLowerCase() === 'body') {
                  this._topMenuItem.focus();
                }
              }, 0);
            }

            // Ask masthead-composite to un-render megamenu.
            // Wait long enough for the transition to end.
            setTimeout(() => {
              this._requestMegaMenuRenderUpdate();
            }, 500);

            // Unlock document to enable scrolling once menu is closed.
            doc.body.style.overflow = '';

            // Unset scrollbar adjustments.
            elementsToAdjust.forEach(element => this._handleScrollbarOffset(element));
          }
        }
        if (changedProperties.has('menuLabel')) {
          this._setAnalyticsAttributes();
        }
      }

      /**
       * The CSS custom property name for the live viewport width.
       */
    }, {
      kind: "get",
      static: true,
      key: "customPropertyViewportWidth",
      value: function () {
        return `--${c4dPrefix$r}-ce--viewport-width`;
      }

      /**
       * A selector that will return the overlays.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorOverlay",
      value: function () {
        return `${c4dPrefix$r}-megamenu-overlay`;
      }

      /**
       * The custom event name for when a megamenu is toggled.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventMegaMenuToggled",
      value: function () {
        return `${c4dPrefix$r}-megamenu-top-nav-menu-toggle`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, C4DTopNavMenu);

var styles$4 = i$4(["/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n* Copyright IBM Corp. 2016, 2021\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n.cds--masthead__l1,\n:host(c4d-masthead-l1) {\n  /* stylelint-disable-next-line length-zero-no-unit */\n  --page-width: calc(100vw - var(--scrollbar-width, 0px));\n  --grid-width: var(--page-width);\n  --column-width: var(--page-width);\n  --gutter-width: 1rem;\n  --column-width: calc(var(--grid-width) / 4);\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: relative;\n  overflow: visible;\n  background-color: var(--cds-layer-02, #ffffff);\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media (min-width: 42rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --grid-width: calc(var(--page-width) - 2rem);\n    --column-width: calc(var(--grid-width) / 8);\n  }\n}\n@media (min-width: 66rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --column-width: calc(var(--grid-width) / 16);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --grid-width: calc(99rem - 3rem);\n  }\n}\n\n@media screen and (width <= 799px) {\n  .cds--masthead__l1-inner-container {\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    background-color: transparent;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    color: var(--cds-text-primary, #161616);\n    gap: 1.5rem;\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-title:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--masthead__l1-title:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  .cds--masthead__l1-title:active, .cds--masthead__l1-title:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-title:disabled {\n    border-block-end-color: var(--cds-border-disabled, #c6c6c6);\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-title[active] {\n    border-block-end: 3px solid var(--cds-focus, #0f62fe);\n  }\n  .cds--masthead__l1-title.is-open svg {\n    transform: rotateX(180deg);\n  }\n  .cds--masthead__l1-title svg {\n    color: var(--cds-icon-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown {\n    position: absolute;\n    background-color: var(--cds-background, #ffffff);\n    color: var(--cds-text-secondary, #525252);\n    inset-block-start: 100%;\n    inset-inline: 0;\n    max-block-size: calc(100vh - 98px - 4rem - 3rem);\n    overflow-y: auto;\n  }\n  .cds--masthead__l1-dropdown.is-open {\n    box-shadow: 0 2px 6px 0 var(--cds-shadow, rgba(0, 0, 0, 0.3));\n    /* stylelint-disable-next-line declaration-no-important */\n    inline-size: 100vw !important;\n  }\n  .cds--masthead__l1-dropdown:not(.is-open) {\n    display: none;\n  }\n  .cds--masthead__l1-dropdown:last-child > a,\n  .cds--masthead__l1-dropdown:last-child > button {\n    border-block-end: initial;\n  }\n  .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    background-color: transparent;\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active, .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item:disabled {\n    border-block-end-color: var(--cds-border-disabled, #c6c6c6);\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-dropdown-item[active] {\n    position: relative;\n  }\n  .cds--masthead__l1-dropdown-item[active]::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-focus, #0f62fe);\n    content: \"\";\n    inline-size: 3px;\n    inset-block: 0;\n    inset-inline-start: 0;\n  }\n  .cds--masthead__l1-dropdown-item.is-open {\n    background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item.is-open svg {\n    color: var(--cds-icon-primary, #161616);\n    transform: rotateX(180deg);\n  }\n  .cds--masthead__l1-dropdown-item svg {\n    color: var(--cds-icon-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-subsection {\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 2rem;\n  }\n  .cds--masthead__l1-dropdown-subsection:not(.is-open) {\n    display: none;\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item {\n    border-block-end: none;\n    color: var(--cds-text-secondary, #525252);\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item:hover, .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item:active {\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-viewall {\n    margin-block-start: 2rem;\n  }\n  .cds--masthead__l1-dropdown-announcement {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem 0;\n    margin: 0 1rem 1rem;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-dropdown-heading {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading.cds--masthead__l1-dropdown-heading--no-link {\n    inline-size: 100%;\n    min-block-size: 2rem;\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    justify-content: flex-start;\n    color: inherit;\n    gap: 0.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item svg {\n    fill: var(--cds-icon-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading:not(:nth-of-type(1)) {\n    margin-block-start: 2rem;\n  }\n  .cds--masthead__l1-dropdown-viewall {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: flex-start;\n    padding: 1rem;\n    background-color: transparent;\n    gap: 0.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n  }\n  .cds--masthead__l1-dropdown-viewall:focus {\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active, .cds--masthead__l1-dropdown-viewall:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-login {\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    color: var(--cds-button-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-login:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-login svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown-login:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  .cds--masthead__l1-dropdown-login:focus-visible {\n    color: var(--cds-button-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-login:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-button-primary-active, #002d9c);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta {\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    background-color: var(--cds-background-brand, #0f62fe);\n    border-block-end: initial;\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta svg {\n    color: inherit;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:hover {\n    background-color: var(--cds-button-primary-hover, #0050e6);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:focus-visible {\n    outline-color: var(--cds-layer-02, #ffffff);\n    outline-offset: calc(-1 * 0.25rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:active {\n    background-color: var(--cds-button-primary-active, #002d9c);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:disabled {\n    background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n}\n@media screen and (width >= 800px) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    display: block;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-inner-container {\n    position: relative;\n    z-index: 1;\n    display: grid;\n    margin: 0 auto;\n    block-size: 4rem;\n    grid-template-areas: \"padding platform menu spacer login cta\";\n    grid-template-columns: 1rem auto minmax(1px, 1fr) 2.5rem auto auto;\n    inline-size: 100%;\n    max-inline-size: 98rem;\n  }\n  .cds--masthead__l1-inner-container > * {\n    position: relative;\n    z-index: 1;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask {\n    position: absolute;\n    z-index: 2;\n    display: block;\n    background-color: var(--cds-background, #ffffff);\n    content: \"\";\n    inset-block: 0;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask--start {\n    inset-inline: -50vw 100%;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask--end {\n    inset-inline: 100% -50vw;\n  }\n  .cds--masthead__l1-inner-container::before, .cds--masthead__l1-inner-container::after {\n    position: relative;\n    z-index: 1;\n    display: block;\n    background-color: var(--cds-background, #ffffff);\n    content: \"\";\n  }\n  .cds--masthead__l1-inner-container::before {\n    grid-area: padding;\n  }\n  .cds--masthead__l1-inner-container::after {\n    grid-area: spacer;\n  }\n  .cds--masthead__background-wrapper {\n    background-color: var(--cds-background, #ffffff);\n  }\n  .cds--masthead__l1-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background, #ffffff);\n    block-size: 100%;\n    border-block-end: 3px solid transparent;\n    color: var(--cds-text-primary, #161616);\n    grid-area: platform;\n    padding-block-end: calc(1rem - 0.125rem);\n  }\n  .cds--masthead__l1-title[active] {\n    border-block-end-color: var(--cds-focus, #0f62fe);\n  }\n  .cds--masthead__l1-title:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--masthead__l1-title:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  .cds--masthead__l1-title:active, .cds--masthead__l1-title:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-menu-container-outer {\n    z-index: 0;\n    display: flex;\n    grid-area: menu;\n  }\n  .cds--masthead__l1-menu-container-scroller {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    z-index: 1;\n    padding: 0;\n    background-color: var(--cds-background, #ffffff);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner {\n    display: inline-flex;\n    flex-shrink: 0;\n    align-items: flex-end;\n    padding: 1rem 0.5rem;\n    background-color: var(--cds-background, #ffffff);\n    block-size: 100%;\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:active, .cds--masthead__l1-menu-container-scroller-inner:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner[hidden] {\n    /* stylelint-disable-next-line declaration-no-important */\n    display: none !important;\n  }\n  .cds--masthead__l1-menu-container-inner {\n    z-index: 0;\n    flex-grow: 1;\n    flex-shrink: 1;\n    block-size: 100%;\n  }\n  .cds--masthead__l1-menu {\n    position: absolute;\n    display: flex;\n    block-size: 100%;\n    transition: translate 95ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  }\n  .cds--masthead__l1-menu > li {\n    position: relative;\n  }\n  .cds--masthead__l1-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-flex;\n    align-items: flex-end;\n    border: 1px solid transparent;\n    background-color: var(--cds-background, #ffffff);\n    border-block-start: none;\n    color: var(--cds-text-secondary, #525252);\n    white-space: nowrap;\n  }\n  .cds--masthead__l1-item[active]::after {\n    position: absolute;\n    background-color: var(--cds-focus, #0f62fe);\n    block-size: 3px;\n    content: \"\";\n    inset-block-end: 0;\n    inset-inline: 0;\n  }\n  .cds--masthead__l1-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-item:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-item:active, .cds--masthead__l1-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-item:is([disabled], .is-disabled) {\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-item.is-open {\n    border-color: #c6c6c6;\n    block-size: calc(100% + 3px);\n    box-shadow: 0 0 6px #c6c6c6;\n    clip-path: polygon(calc(0% - 6px) calc(0% - 6px), calc(100% + 6px) calc(0% - 6px), calc(100% + 6px) 100%, calc(0% - 6px) 100%);\n    padding-block-end: calc(1rem + 3px);\n  }\n  .cds--masthead__l1-item.is-open svg {\n    rotate: 180deg;\n  }\n  .cds--masthead__l1-item svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown {\n    position: absolute;\n    padding: 1rem 0 0;\n    border: 1px solid #c6c6c6;\n    background-color: var(--cds-background, #ffffff);\n    border-block-start: none;\n    box-shadow: 0 0 6px #c6c6c6;\n    clip-path: polygon(calc(0% - 6px) 0%, calc(100% + 6px) 0%, calc(100% + 6px) calc(100% + 6px), calc(0% - 6px) calc(100% + 6px));\n    inline-size: 320;\n    inset-block-start: calc(100% + 1px);\n    inset-inline-start: 0;\n    max-inline-size: calc(100vw - 2 * 1rem);\n    overflow-y: auto;\n    visibility: hidden;\n  }\n  .cds--masthead__l1-dropdown.is-open {\n    visibility: visible;\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__1-col {\n    inline-size: calc(2 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__2-col {\n    inline-size: calc(4 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__3-col {\n    inline-size: calc(6 * var(--column-width));\n  }\n}\n@media screen and (width >= 800px) and (width >= 66rem) {\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__1-col {\n    inline-size: calc(4 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__2-col {\n    inline-size: calc(8 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__3-col {\n    inline-size: calc(12 * var(--column-width));\n  }\n}\n@media screen and (width >= 800px) {\n  .cds--masthead__l1-dropdown-links {\n    -moz-column-rule: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n         column-rule: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 2.5rem;\n  }\n  .cds--masthead__l1-dropdown__2-col .cds--masthead__l1-dropdown-links {\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 0;\n         column-gap: 0;\n  }\n  .cds--masthead__l1-dropdown__3-col .cds--masthead__l1-dropdown-links {\n    -moz-column-count: 3;\n         column-count: 3;\n    -moz-column-gap: 0;\n         column-gap: 0;\n  }\n  .cds--masthead__l1-dropdown-links > * {\n    -moz-column-break-inside: avoid;\n         break-inside: avoid;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide {\n    display: grid;\n    grid-template-columns: repeat(3, 1fr);\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide .cds--masthead__l1-dropdown-column-wide {\n    grid-column: span 2;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide .cds--masthead__l1-dropdown-column-wide .cds--masthead__l1-dropdown-menu-items {\n    -moz-column-gap: 0;\n         column-gap: 0;\n    -moz-columns: 2;\n         columns: 2;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide > *:nth-child(2) {\n    border-inline-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-dropdown-announcement {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    margin: 0 1rem 1rem;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 1rem;\n  }\n  .cds--masthead__l1-dropdown-announcement :is(h1, h2, h3, h4, h5, h6, strong, b) {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  }\n  .cds--masthead__l1-dropdown-announcement :focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-menu-items {\n    padding-block-end: 1.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading {\n    font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n    font-weight: var(--cds-productive-heading-03-font-weight, 400);\n    line-height: var(--cds-productive-heading-03-line-height, 1.4);\n    letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n    font-weight: var(--cds-productive-heading-03-font-weight, 400);\n    line-height: var(--cds-productive-heading-03-line-height, 1.4);\n    letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    padding: 0.5rem 1rem;\n    color: inherit;\n    margin-block-end: 0.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item svg {\n    position: relative;\n    inset-block-end: 0.125rem;\n    margin-inline-start: 0.5rem;\n    vertical-align: middle;\n  }\n  .cds--masthead__l1-dropdown-heading.cds--masthead__l1-dropdown-heading--no-link {\n    padding: 0.5rem 1rem;\n    margin-block-end: 0.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading-desc {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: block;\n    padding: 0 1rem;\n    margin: calc(-1 * 0.5rem) 0 0.5rem;\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-block;\n    padding: 0.5rem 1rem;\n    color: var(--cds-text-secondary, #525252);\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-dropdown-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active {\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item:active, .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown-item .cds--masthead__l1-dropdown-item-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    display: block;\n  }\n  .cds--masthead__l1-dropdown-item .cds--masthead__l1-dropdown-item-description {\n    display: block;\n    color: var(--cds-text-secondary, #525252);\n    white-space: break-spaces;\n  }\n  .cds--masthead__l1-dropdown-viewall {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    align-content: center;\n    padding: 1rem;\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    color: var(--cds-link-primary, #0f62fe);\n    gap: 0.5rem;\n    text-decoration: none;\n  }\n  .cds--masthead__l1-dropdown-viewall:hover {\n    color: var(--cds-link-primary-hover, #0043ce);\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active, .cds--masthead__l1-dropdown-viewall:active:visited, .cds--masthead__l1-dropdown-viewall:active:visited:hover {\n    color: var(--cds-text-primary, #161616);\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-viewall:visited {\n    color: var(--cds-link-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-viewall:visited:hover {\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  :host(c4d-masthead-l1-cta) {\n    position: relative;\n    z-index: 1;\n    grid-area: cta;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background-brand, #0f62fe);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta svg {\n    color: inherit;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:hover {\n    background-color: var(--cds-button-primary-hover, #0050e6);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:focus-visible {\n    outline: 0.125rem solid var(--cds-layer-02, #ffffff);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:active {\n    background-color: var(--cds-button-primary-active, #002d9c);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:disabled {\n    background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta-inner {\n    display: inline-flex;\n    align-items: center;\n    gap: 0.5rem;\n  }\n  .cds--masthead__l1-login {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background, #ffffff);\n    color: var(--cds-button-primary, #0f62fe);\n    grid-area: login;\n  }\n  .cds--masthead__l1-login svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-login:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  .cds--masthead__l1-login:focus-visible {\n    color: var(--cds-button-primary, #0f62fe);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-login:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-button-primary-active, #002d9c);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n}"]);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$e = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M20 24L10 16 20 8z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$d = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M12 8L22 16 12 24z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

// Magic Number: 799px matches masthead.scss's `$breakpoint--desktop-nav`.
const mastheadBreakpoint = window.matchMedia(`(max-width: 799px)`);

let _$p = t => t,
  _t$p,
  _t2$c,
  _t3$5,
  _t4$4,
  _t5$4,
  _t6$3,
  _t7$3,
  _t8$3,
  _t9$2,
  _t10$2,
  _t11$2,
  _t12$2,
  _t13$2,
  _t14$2,
  _t15$1,
  _t16$1,
  _t17$1,
  _t18$1,
  _t19$1,
  _t20$1,
  _t21$1,
  _t22$1,
  _t23$1,
  _t24$1,
  _t25$1,
  _t26$1,
  _t27$1,
  _t28$1,
  _t29$1,
  _t30$1,
  _t31$1,
  _t32$1,
  _t33$1,
  _t34$1,
  _t35$1,
  _t36$1,
  _t37$1,
  _t38$1,
  _t39$1,
  _t40,
  _t41,
  _t42,
  _t43,
  _t44;
function _decorate$q(e, r, t, i) { var o = _getDecoratorsApi$q(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$q(s.d.map(_createElementDescriptor$q)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$q() { _getDecoratorsApi$q = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$q(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$q(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$q(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$q(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$q(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$q(e) { var r, t = _toPropertyKey$q(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$q(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$q(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$q(o.descriptor) || _isDataDescriptor$q(i.descriptor)) { if (_hasDecorators$q(o) || _hasDecorators$q(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$q(o)) { if (_hasDecorators$q(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$q(o, i); } } else r.push(o); } return r; }
function _hasDecorators$q(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$q(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$q(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$q(t) { var i = _toPrimitive$q(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$q(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$q(r) { return _arrayWithHoles$r(r) || _iterableToArray$q(r) || _unsupportedIterableToArray$r(r) || _nonIterableRest$r(); }
function _nonIterableRest$r() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$r(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$r(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$r(r, a) : void 0; } }
function _arrayLikeToArray$r(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$q(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$r(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$g,
  stablePrefix: c4dPrefix$q
} = settings;
function handleDropdownClose(event) {
  var _target$querySelector;
  const {
    currentTarget
  } = event;
  const target = currentTarget;
  const openDropdowns = Array.from((_target$querySelector = target === null || target === void 0 ? void 0 : target.querySelectorAll('.is-open')) !== null && _target$querySelector !== void 0 ? _target$querySelector : []);
  if (openDropdowns.length) {
    switch (event.type) {
      case 'keydown':
        {
          const {
            code
          } = event;
          if (code === 'Escape') {
            var _target$firstElementC;
            openDropdowns.forEach(el => {
              el.classList.remove('is-open');
            });
            target === null || target === void 0 || (_target$firstElementC = target.firstElementChild) === null || _target$firstElementC === void 0 || _target$firstElementC.focus();
          }
          break;
        }
      case 'focusout':
        {
          const {
            relatedTarget
          } = event;
          const hasUnknownTargets = !relatedTarget || !currentTarget;
          let focusHasEscaped = false;
          if (!hasUnknownTargets) {
            const comparison = relatedTarget.compareDocumentPosition(currentTarget);
            focusHasEscaped = !(comparison & 8) &&
            // relatedTarget is not ancestor of currentTarget
            relatedTarget !== currentTarget;
          }
          if (hasUnknownTargets || focusHasEscaped) {
            openDropdowns.forEach(el => {
              el.classList.remove('is-open');
            });
          }
          break;
        }
    }
  }
}

/**
 * Masthead.
 *
 * @element c4d-masthead-l1
 * @csspart l1-menu-container-inner - The container that wraps the L1 menu items for scrolling purposes. Usage: `c4d-masthead-l1::part(l1-menu-container-inner)`
 * @csspart masthead-l1-menu - The container element for the L1 menu items. Usage: `c4d-masthead-l1::part(masthead-l1-menu)`
 * @csspart l1-menu-first-item - The first item in the L1 menu. Usage: `c4d-masthead-l1::part(l1-menu-first-item)`
 * @csspart l1-menu-last-item - The last item in the L1 menu. Usage: `c4d-masthead-l1::part(l1-menu-last-item)`
 * @csspart l1-menu-container-scroller - The buttons used for scrolling the L1 menu items. Usage: `c4d-masthead-l1::part(l1-menu-container-scroller)`
 * @csspart l1-title-button - The title button in the L1 masthead. Usage: `c4d-masthead-l1::part(l1-title-button)`
 * @csspart l1-dropdown - The dropdown items in the L1 masthead. Usage: `c4d-masthead-l1::part(l1-dropdown)`
 * @csspart l1-dropdown-viewall - The "view all" link in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-viewall)`
 * @csspart l1-dropdown-announcement - The announcement in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-announcement)`
 * @csspart l1-dropdown-section - The sections in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-section)`
 * @csspart l1-dropdown-menu-items - The menu items in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-menu-items)`
 * @csspart l1-dropdown-menu-item - A single menu item in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-menu-item)`
 * @csspart l1-dropdown-item-ul - The item list in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item-ul)`
 * @csspart l1-dropdown-item-li - The list item in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item-li)`
 * @csspart l1-dropdown-item-link - The item link in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item-link)`
 * @csspart l1-dropdown-item-link--heading - The item link in the L1 dropdown that wraps headings. Usage: `c4d-masthead-l1::part(l1-dropdown-item-link--heading)`
 * @csspart l1-dropdown-subsection - The subsection in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-subsection)`
 * @csspart l1-dropdown-item - The dropdown item in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-item)`
 * @csspart l1-dropdown-login-link - The login link in the L1 dropdown. Usage: `c4d-masthead-l1::part(l1-dropdown-login-link)`
 * @csspart l1-dropdown-links - A group of l1 dropdown links. Usage: `c4d-masthead-l1::part(l1-dropdown-links)`
 * @csspart dropdown-item-li - The li element for the dropdown item. Usage: `c4d-masthead-l1::part(dropdown-item-li)`
 * @csspart dropdown-login-link-li - The li element for the login link. Usage: `c4d-masthead-l1::part(dropdown-login-link-li)`
 * @csspart cta-li - The li element for the cta. Usage: `c4d-masthead-l1::part(cta-li)`
 * @csspart dropdown-item-link-li - The li element for the dropdown item link. Usage: `c4d-masthead-l1::part(dropdown-item-link-li)`
 * @csspart dropdown-item-span-li - The li element for the dropdown item span. Usage: `c4d-masthead-l1::part(dropdown-item-span-li)`
 * @csspart dropdown-item-button-li - The li element for the dropdown item button. Usage: `c4d-masthead-l1::part(dropdown-item-button-li)`
 * @csspart dropdown-column - The dropdown column container. Usage: `c4d-masthead-l1::part(dropdown-column)
 * @csspart dropdown-column--narrow - The dropdown column narrow modifier. Usage: `c4d-masthead-l1::part(dropdown-column--narrow)
 * @csspart dropdown-column--wide - The dropdown column wide modifier. Usage: `c4d-masthead-l1::part(dropdown-column--wide)
 * @slot brand - The left hand area.
 * @slot nav - The nav content.
 * @slot profile - The right hand area.
 */
let C4DMastheadL1 = _decorate$q([carbonElement(`${c4dPrefix$q}-masthead-l1`)], function (_initialize, _StableSelectorMixin) {
  class C4DMastheadL1 extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadL1,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'active',
        reflect: true,
        type: Boolean
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "l1Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "currentUrlPath",
      value() {
        var _root$location;
        return (_root$location = lib.location) === null || _root$location === void 0 ? void 0 : _root$location.href;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "isMobileVersion",
      value() {
        return mastheadBreakpoint.matches;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "selectedElements",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'overview-text'
      })],
      key: "overviewText",
      value() {
        return 'Overview';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "direction",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$g}--masthead__l1-menu-container-inner`)],
      key: "menuContainerInner",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$g}--masthead__l1-menu`)],
      key: "menu",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$g}--masthead__l1-menu > *:first-child`)],
      key: "menuFirstItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$g}--masthead__l1-menu > *:last-child`)],
      key: "menuLastItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [e$2(`.${prefix$g}--masthead__l1-menu-container-scroller`)],
      key: "menuScrollerButtons",
      value: void 0
    }, {
      kind: "get",
      key: "Arrow16",
      value:
      /**
       * Whether an L1 menu is open or not.
       */

      /**
       * The L1 menu data, passed from the masthead-composite.
       */

      /**
       * The URL path of the current document root.
       */

      /**
       * The English title of the selected nav item.
       */

      /**
       * Whether the current viewport is below 800px or not
       */

      /**
       * Elements that are currently selected.
       */

      /**
       * The translated label for the overview links visible on mobile
       */

      /**
       * The writing direction of the page
       */

      /**
       * The x-scrolling element wrapping the L1 top-level items
       */

      /**
       * The first top-level menu items
       */

      /**
       * The last top-level menu items
       */

      /**
       * The buttons that scroll the top-level menu items
       */

      function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? svgResultCarbonIcon$h : svgResultCarbonIcon$i;
      }
    }, {
      kind: "get",
      key: "Arrow20",
      value: function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? svgResultCarbonIcon$B : svgResultCarbonIcon$D;
      }

      /**
       * Resize Observer responsible for show/hiding the scrolling buttons.
       */

      /**
       * Prevents resize observer from blocking main thread.
       */
    }, {
      kind: "method",
      key: "toggleScrollButtons",
      value:
      /**
       * ResizeObserver callback method
       */
      function toggleScrollButtons() {
        // Resize events happen rapidly. We need to throttle this functionality.
        if (!this.scrollObserverThrottler) {
          var _this$l1Data$menuItem, _this$l1Data;
          const {
            menu,
            menuContainerInner,
            menuFirstItem,
            menuLastItem,
            menuScrollerButtons
          } = this;

          // Only act if all the needed elements are present.
          const menuItems = (_this$l1Data$menuItem = (_this$l1Data = this.l1Data) === null || _this$l1Data === void 0 ? void 0 : _this$l1Data.menuItems) !== null && _this$l1Data$menuItem !== void 0 ? _this$l1Data$menuItem : [];
          if (menuItems.length === 0) {
            menuScrollerButtons === null || menuScrollerButtons === void 0 || menuScrollerButtons.forEach(button => {
              button.setAttribute('hidden', '');
            });
          } else if (menuFirstItem && menuLastItem && menuContainerInner && menuScrollerButtons) {
            // Find first & last items, calculate width between outer boundaries.
            const firstItemBox = menuFirstItem.getBoundingClientRect();
            const lastItemBox = menuLastItem.getBoundingClientRect();
            const menuLeft = Math.min(firstItemBox.left, lastItemBox.left);
            const menuRight = Math.max(firstItemBox.right, lastItemBox.right);
            const menuWidth = menuRight - menuLeft;
            const containerWidth = menuContainerInner === null || menuContainerInner === void 0 ? void 0 : menuContainerInner.getBoundingClientRect().width;

            // If we overflow the container, show buttons.
            if (menuWidth > containerWidth) {
              menuScrollerButtons.forEach(button => {
                button.removeAttribute('hidden');
              });
              if (menu !== null && menu !== void 0 && menu.style.translate) {
                const currentScroll = parseInt(menu.style.translate);
                const maxScroll = containerWidth - menuWidth;
                menu.style.translate = `${Math.max(currentScroll, maxScroll)}px`;
              }
            }
            // If we don't, hide the buttons.
            else {
              menuScrollerButtons.forEach(button => {
                button.setAttribute('hidden', '');
              });

              // Remove any translations we've used to mimic scrolling.
              if (menu) {
                menu.style.translate = '';
              }
            }
          }

          // Prevent this functionality from running again until the time threshold has passed.
          this.scrollObserverThrottler = setTimeout(() => {
            this.scrollObserverThrottler = undefined;
          }, 100);
        }
      }

      /**
       * Creates resize observer on load/update when above mobile breakpoint.
       */
    }, {
      kind: "method",
      key: "_createScrollObserver",
      value: function _createScrollObserver() {
        const {
          menuContainerInner,
          toggleScrollButtons
        } = this;
        this.scrollObserver = new ResizeObserver(toggleScrollButtons.bind(this));
        if (menuContainerInner) {
          this.scrollObserver.observe(menuContainerInner);
        }
      }

      /**
       * Scrolls the menu inner container on click.
       *
       * @param event The button click
       */
    }, {
      kind: "method",
      key: "_scrollL1TopNav",
      value: function _scrollL1TopNav(event) {
        const {
          currentTarget
        } = event;
        const {
          menuContainerInner,
          menu,
          direction
        } = this;
        if (!menu || !menuContainerInner) {
          return;
        }

        // Valid translations will exist between 0 and a some negative value.
        const minTranslationValue = (menu.clientWidth - menuContainerInner.clientWidth) * -1;
        const maxTranslationValue = 0;

        // Use a 1/-1 multiplier to account for correct button
        let buttonDirMultiplier;
        switch (currentTarget.id) {
          // "Next" button should pull menu toward 0
          case 'scroll-next':
            buttonDirMultiplier = -1;
            break;
          // "Prev" button should push menu away from 0
          case 'scroll-prev':
            buttonDirMultiplier = 1;
            break;
          default:
            buttonDirMultiplier = 0;
            break;
        }

        // Use a 1/-1 multiplier to account for writing direction
        let writingDirMultiplier;
        switch (direction) {
          // LTR is inline with x-axis
          case 'ltr':
            writingDirMultiplier = 1;
            break;
          // RTL must invert x-axis
          case 'rtl':
            writingDirMultiplier = -1;
            break;
          default:
            writingDirMultiplier = 0;
            break;
        }

        // Get current translation value
        const computedScroll = parseInt(window.getComputedStyle(menu).translate);
        const currentScroll = !Number.isNaN(computedScroll) ? computedScroll : 0;

        // Adjust translation value by adding/subtracting the width of the visible menu
        const newScroll = currentScroll + menuContainerInner.clientWidth * buttonDirMultiplier * writingDirMultiplier;

        // Cap the value to avoid over-translation to either side
        const cappedValue = Math.max(minTranslationValue, Math.min(maxTranslationValue, newScroll));
        menu.style.translate = `${cappedValue}px`;
      }

      /**
       * Renders the L1 CTA.
       *
       * @returns {_TemplateResult} A template fragment representing the L1 CTA
       */
    }, {
      kind: "method",
      key: "_renderCta",
      value: function _renderCta() {
        return x(_t$p || (_t$p = _$p`<slot name="l1-cta"></slot>`));
      }

      /**
       * Renders L1 for desktop screensizes
       *
       * @returns {_TemplateResult} L1 for desktop screensizes
       */
    }, {
      kind: "method",
      key: "_renderL1TopNav",
      value: function _renderL1TopNav() {
        const {
          l1Data,
          direction,
          _scrollL1TopNav: scrollL1TopNav
        } = this;
        const {
          url,
          title,
          actions,
          menuItems
        } = l1Data !== null && l1Data !== void 0 ? l1Data : {};
        const {
          login
        } = actions !== null && actions !== void 0 ? actions : {};
        return x(_t2$c || (_t2$c = _$p`
      <div
        part="masthead-l1-menu-container-mask"
        class="${0}--masthead__l1-menu-container-mask ${0}--masthead__l1-menu-container-mask--start"></div>
      ${0}
      <div
        part="masthead-l1-menu-container-outer"
        class="${0}--masthead__l1-menu-container-outer">
        <button
          part="l1-menu-container-scroller-button"
          class="${0}--masthead__l1-menu-container-scroller"
          id="scroll-prev"
          @click=${0}>
          <div
            part="l1-menu-container-scroller-inner"
            class="${0}--masthead__l1-menu-container-scroller-inner">
            ${0}
          </div>
        </button>
        <div
          part="l1-menu-container-inner"
          class="${0}--masthead__l1-menu-container-inner">
          <ul part="l1-menu" class="${0}--masthead__l1-menu">
            ${0}
          </ul>
        </div>
        <button
          part="l1-menu-container-scroller"
          class="${0}--masthead__l1-menu-container-scroller"
          id="scroll-next"
          @click=${0}>
          <div
            part="l1-menu-container-scroller-inner"
            class="${0}--masthead__l1-menu-container-scroller-inner">
            ${0}
          </div>
        </button>
      </div>
      ${0}
      ${0}
      <div
        part="masthead-l1-menu-container-mask"
        class="${0}--masthead__l1-menu-container-mask ${0}--masthead__l1-menu-container-mask--end"></div>
    `), prefix$g, prefix$g, !title || !url ? undefined : x(_t3$5 || (_t3$5 = _$p`
            <div
              part="masthead-background-wrapper"
              class="${0}--masthead__background-wrapper">
              <a
                part="masthead-l1-title"
                class="${0}--masthead__l1-title"
                href="${0}"
                >${0}</a
              >
            </div>
          `), prefix$g, prefix$g, url, title), prefix$g, prefix$g, scrollL1TopNav, prefix$g, direction === 'ltr' ? svgResultCarbonIcon$e() : svgResultCarbonIcon$d(), prefix$g, prefix$g, (menuItems !== null && menuItems !== void 0 ? menuItems : []).map(menuItem => this._renderL1TopNavDropDowns(menuItem)), prefix$g, scrollL1TopNav, prefix$g, direction === 'ltr' ? svgResultCarbonIcon$d() : svgResultCarbonIcon$e(), login && login.url && login.title ? x(_t4$4 || (_t4$4 = _$p`
            <div
              part="masthead-background-wrapper"
              class="${0}--masthead__background-wrapper">
              <a
                part="masthead-l1-login"
                class="${0}--masthead__l1-login"
                href="${0}"
                >${0}</a
              >
            </div>
          `), prefix$g, prefix$g, l(login.url), login.title) : '', this._renderCta(), prefix$g, prefix$g);
      }

      /**
       * Renders L1MenuItems with subsections containing announcements, headings, links, and footers.
       *
       * @param {_L1MenuItem} menuItem Array of menu items containing subnavs
       * @returns {_TemplateResult} rendered output
       */
    }, {
      kind: "method",
      key: "_renderL1TopNavDropDowns",
      value: function _renderL1TopNavDropDowns(menuItem) {
        const {
          _toggleSubsection: toggleSubsection,
          _handleTopNavFocusIn: handleTopNavFocusIn
        } = this;
        const {
          title,
          url,
          target,
          submenu
        } = menuItem;
        if (!submenu && url) {
          return x(_t5$4 || (_t5$4 = _$p`
        <li part="masthead-l1-item">
          <a
            part="masthead-l1-item-link"
            class="${0}--masthead__l1-item"
            href="${0}"
            target="${0}"
            @focusin=${0}
            >${0}</a
          >
        </li>
      `), prefix$g, url, target, handleTopNavFocusIn, title);
        } else if (!submenu) {
          return x(_t6$3 || (_t6$3 = _$p`
        <li part="masthead-l1-item">
          <span
            part="masthead-l1-item-span"
            class="${0}--masthead__l1-item"
            @focusin=${0}
            >${0}</span
          >
        </li>
      `), prefix$g, handleTopNavFocusIn, title);
        }
        const {
          announcement,
          menuSections,
          footer,
          columns
        } = submenu !== null && submenu !== void 0 ? submenu : {};

        // 3-column dropdown has option for 33/66 split.
        const hasWideColumn = columns === 3 ? menuSections.some(section => section.span > 1) : false;

        // Split can be 33/66 or 66/33.
        const wideColumnFirst = menuSections[0].span > 1;
        const wideColumns = menuSections.filter(section => section.span > 1);
        const normalColumns = menuSections.filter(section => !(section.span > 1));
        const dropdownClasses = o$2({
          [`${prefix$g}--masthead__l1-dropdown-links`]: true,
          [`${prefix$g}--masthead__l1-dropdown--has-column-wide`]: hasWideColumn
        });
        return x(_t7$3 || (_t7$3 = _$p`
      <li
        part="masthead-l1-item"
        @focusout=${0}
        @keydown=${0}
        tabindex="-1">
        <button
          part="masthead-l1-item-button"
          class="${0}--masthead__l1-item"
          @click=${0}
          @focusin=${0}>
          ${0}${0}
        </button>
        <div
          part="l1-dropdown"
          data-dropdown-target
          class="${0}--masthead__l1-dropdown ${0}--masthead__l1-dropdown__${0}-col">
          ${0}
          <div part="l1-dropdown-links" class="${0}">
            ${0}
            ${0}
            ${0}
          </div>
          ${0}
        </div>
      </li>
    `), handleDropdownClose, handleDropdownClose, prefix$g, toggleSubsection, handleTopNavFocusIn, title, svgResultCarbonIcon$H(), prefix$g, prefix$g, columns, announcement ? x(_t8$3 || (_t8$3 = _$p`<div
                part="l1-dropdown-announcement"
                class="${0}--masthead__l1-dropdown-announcement">
                ${0}
              </div>`), prefix$g, o$1(announcement)) : '', dropdownClasses, hasWideColumn && wideColumnFirst ? this._renderL1DropdownSections(wideColumns, hasWideColumn, true) : '', this._renderL1DropdownSections(normalColumns, hasWideColumn, false), hasWideColumn && !wideColumnFirst ? this._renderL1DropdownSections(wideColumns, hasWideColumn, true) : '', footer ? x(_t9$2 || (_t9$2 = _$p`<a
                part="l1-dropdown-viewall"
                class="${0}--masthead__l1-dropdown-viewall"
                href="${0}"
                >${0}${0}</a
              >`), prefix$g, footer.url, footer.title, this.Arrow16()) : '');
      }

      /**
       *
       * @param {_L1SubmenuSection[]} sections the sections to render.
       * @param {boolean} hasWide if this column will be rendered as or next to a wide column.
       * @param {boolean} isWide if this column will be rendered as a wide column.
       * @returns rendered markup
       */
    }, {
      kind: "method",
      key: "_renderL1DropdownSections",
      value: function _renderL1DropdownSections(sections, hasWide, isWide) {
        const renderedSections = sections.map(section => {
          const {
            heading,
            items
          } = section;
          return x(_t10$2 || (_t10$2 = _$p`
        <div
          part="l1-dropdown-section"
          class="${0}--masthead__l1-dropdown-section">
          ${0}
          ${0}
        </div>
      `), prefix$g, heading ? x(_t11$2 || (_t11$2 = _$p`${0}`), this._renderL1SubSectionHeading(heading)) : '', items ? x(_t12$2 || (_t12$2 = _$p` <ul
                part="l1-dropdown-menu-items"
                class="${0}--masthead__l1-dropdown-menu-items">
                ${0}
              </ul>`), prefix$g, items.map(item => {
            const {
              title,
              url,
              target,
              description
            } = item;
            const linkContents = description ? x(_t13$2 || (_t13$2 = _$p`
                        <span
                          part="l1-dropdown-item-title-span"
                          class="${0}--masthead__l1-dropdown-item-title"
                          >${0}</span
                        >
                        <span
                          part="l1-dropdown-item-description-span"
                          class="${0}--masthead__l1-dropdown-item-description"
                          >${0}</span
                        >
                      `), prefix$g, title, prefix$g, description) : x(_t14$2 || (_t14$2 = _$p` ${0} `), title);
            return x(_t15$1 || (_t15$1 = _$p`
                    <li part="l1-dropdown-menu-item">
                      <a
                        part="l1-dropdown-item-link"
                        class="${0}--masthead__l1-dropdown-item"
                        href="${0}"
                        target="${0}">
                        ${0}
                      </a>
                    </li>
                  `), prefix$g, url, target, linkContents);
          })) : '');
        });
        const classes = o$2({
          [`${prefix$g}--masthead__l1-dropdown-column-narrow`]: hasWide && !isWide,
          [`${prefix$g}--masthead__l1-dropdown-column-wide`]: hasWide && isWide
        });
        return hasWide ? x(_t16$1 || (_t16$1 = _$p`<div
          class=${0}
          part="dropdown-column${0}">
          ${0}
        </div>`), classes, hasWide && !isWide ? ' dropdown-column--narrow' : hasWide && isWide ? ' dropdown-column--wide' : '', renderedSections) : x(_t17$1 || (_t17$1 = _$p`${0}`), renderedSections);
      }

      /**
       * Renders L1 for mobile screensizes.
       *
       * @returns {_TemplateResult} L1 for mobile screensizes.
       */
    }, {
      kind: "method",
      key: "_renderL1MobileNav",
      value: function _renderL1MobileNav() {
        const {
          l1Data,
          overviewText
        } = this;
        const {
          url,
          title,
          actions,
          menuItems
        } = l1Data !== null && l1Data !== void 0 ? l1Data : {};
        const {
          cta,
          login
        } = actions !== null && actions !== void 0 ? actions : {};
        const {
          _toggleSubsection: toggleSubsection
        } = this;
        return x(_t18$1 || (_t18$1 = _$p`
      <button
        part="l1-title-button"
        class="${0}--masthead__l1-title"
        @click=${0}>
        ${0}${0}
      </button>
      <ul
        part="l1-dropdown"
        data-dropdown-target
        class="${0}--masthead__l1-dropdown">
        ${0}
        ${0}
        ${0}
        ${0}
      </ul>
    `), prefix$g, toggleSubsection, title, svgResultCarbonIcon$H(), prefix$g, url ? x(_t19$1 || (_t19$1 = _$p` <li part="dropdown-item-li">
              <a
                part="l1-dropdown-item"
                class="${0}--masthead__l1-dropdown-item"
                href="${0}">
                ${0}
              </a>
            </li>`), prefix$g, url, overviewText) : '', menuItems === null || menuItems === void 0 ? void 0 : menuItems.map(menuItem => this._renderL1MobileSubnav(menuItem)), login && login.url && login.title ? x(_t20$1 || (_t20$1 = _$p` <li part="dropdown-login-link-li">
              <a
                part="l1-dropdown-login-link"
                class="${0}--masthead__l1-dropdown-login"
                href="${0}">
                ${0}${0}
              </a>
            </li>`), prefix$g, l(login.url), login.title, this.Arrow16()) : '', cta ? x(_t21$1 || (_t21$1 = _$p`<li part="cta-li">${0}</li>`), this._renderCta()) : '');
      }

      /**
       * Renders L1MenuItems with subsections containing announcements, headings, links, and footers.
       *
       * @param {_L1MenuItem} menuItem Array of menu items containing subnavs
       * @returns {_TemplateResult} rendered output
       */
    }, {
      kind: "method",
      key: "_renderL1MobileSubnav",
      value: function _renderL1MobileSubnav(menuItem) {
        const {
          _toggleSubsection: toggleSubsection
        } = this;
        const {
          title,
          target,
          url,
          submenu
        } = menuItem;
        if (!submenu && url) {
          return x(_t22$1 || (_t22$1 = _$p`
        <li part="dropdown-item-link-li">
          <a
            part="l1-dropdown-item-link"
            class="${0}--masthead__l1-dropdown-item"
            target="${0}"
            href="${0}"
            >${0}</a
          >
        </li>
      `), prefix$g, target, url, title);
        } else if (!submenu) {
          return x(_t23$1 || (_t23$1 = _$p`
        <li part="dropdown-item-span-li">
          <span
            part="l1-dropdown-item-span"
            class="${0}--masthead__l1-dropdown-item"
            >${0}</span
          >
        </li>
      `), prefix$g, title);
        }
        const {
          announcement,
          menuSections,
          footer
        } = submenu !== null && submenu !== void 0 ? submenu : {};
        return x(_t24$1 || (_t24$1 = _$p`
      <li part="dropdown-item-button-li">
        <button
          part="l1-dropdown-item-button"
          class="${0}--masthead__l1-dropdown-item"
          @click=${0}>
          ${0}${0}
        </button>
        <div
          part="l1-dropdown-subsection"
          data-dropdown-target
          class="${0}--masthead__l1-dropdown-subsection">
          ${0}
          ${0}
          ${0}
        </div>
      </li>
    `), prefix$g, toggleSubsection, title, svgResultCarbonIcon$H(), prefix$g, announcement ? x(_t25$1 || (_t25$1 = _$p`<div
                part="l1-dropdown-announcement"
                class="${0}--masthead__l1-dropdown-announcement">
                ${0}
              </div>`), prefix$g, o$1(announcement)) : '', menuSections ? menuSections.map(section => {
          const {
            heading,
            items
          } = section;
          return x(_t26$1 || (_t26$1 = _$p`
                  ${0}
                  ${0}
                `), heading ? x(_t27$1 || (_t27$1 = _$p`${0}`), this._renderL1SubSectionHeading(heading)) : '', items ? x(_t28$1 || (_t28$1 = _$p` <ul part="l1-dropdown-item-ul">
                        ${0}
                      </ul>`), items.map(item => {
            const {
              title,
              url,
              target
            } = item;
            return x(_t29$1 || (_t29$1 = _$p` <li part="l1-dropdown-item-li">
                            <a
                              part="l1-dropdown-item-link"
                              class="${0}--masthead__l1-dropdown-item"
                              target="${0}"
                              href="${0}">
                              ${0}
                            </a>
                          </li>`), prefix$g, target, url, title);
          })) : '');
        }) : '', footer ? x(_t30$1 || (_t30$1 = _$p`
                <a part="l1-dropdown-viewall"
                  class="${0}--masthead__l1-dropdown-viewall"
                  href="${0}"
                >
                  ${0}${0}
                </li>`), prefix$g, footer.url, footer.title, this.Arrow16()) : '');
      }

      /**
       * Toggles the mobile navigation subsection.
       *
       * @param {PointerEvent} event The click event from the user
       */
    }, {
      kind: "method",
      key: "_toggleSubsection",
      value: function _toggleSubsection(event) {
        var _button$parentNode;
        const {
          isMobileVersion
        } = this;
        const {
          dropDownToggleEvent
        } = this.constructor;
        const {
          currentTarget
        } = event;
        const button = currentTarget;
        const dropdown = (_button$parentNode = button.parentNode) === null || _button$parentNode === void 0 ? void 0 : _button$parentNode.querySelector('[data-dropdown-target]');
        const isOpen = dropdown === null || dropdown === void 0 ? void 0 : dropdown.classList.contains('is-open');
        if (!isMobileVersion && dropdown && !isOpen) {
          // Get Button & Dropdown locations & widths
          const buttonRect = button.getBoundingClientRect().toJSON();
          const dropdownRect = dropdown.getBoundingClientRect().toJSON();
          const viewportWidth = window.innerWidth;
          const isLTR = window.getComputedStyle(this).direction.toUpperCase() === 'LTR';
          const dirMultiplier = isLTR ? -1 : 1;

          // Set logical bounding client rect properties
          buttonRect.inlineStart = isLTR ? buttonRect.left : viewportWidth - buttonRect.right;
          buttonRect.inlineEnd = isLTR ? buttonRect.right : viewportWidth - buttonRect.left;
          dropdownRect.inlineStart = isLTR ? dropdownRect.left : viewportWidth - dropdownRect.right;
          dropdownRect.inlineEnd = isLTR ? dropdownRect.right : viewportWidth - dropdownRect.left;

          // What would the left/right boundaries be if we centered the dropdown?
          const startBoundaryIfCentered = (viewportWidth - dropdownRect.width) / 2;
          const endBoundaryIfCentered = startBoundaryIfCentered + dropdownRect.width;

          // If start-aligning to button doesn't overflow viewport.
          if (buttonRect.inlineStart + dropdownRect.width < viewportWidth) ;

          // If center-aligning to viewport fully intersects with button.
          else if (startBoundaryIfCentered < buttonRect.inlineStart && endBoundaryIfCentered > buttonRect.inlineEnd) {
            const translationAmount = (buttonRect.inlineStart - startBoundaryIfCentered) * dirMultiplier;
            dropdown.style.translate = `${translationAmount}px`;
          }

          // Fallback: right align to button.
          else {
            const translationAmount = (dropdownRect.width - buttonRect.width) * dirMultiplier;
            dropdown.style.translate = `${translationAmount}px`;
          }

          // Ensure dropdown doesn't overflow viewport vertically.
          const viewportHeight = window.innerHeight;
          const maxHeight = viewportHeight - dropdownRect.top;
          dropdown.style.maxHeight = `calc(${maxHeight}px - 4rem)`;
        }
        this.dispatchEvent(new CustomEvent(dropDownToggleEvent, {
          bubbles: true,
          composed: true,
          cancelable: false,
          detail: {
            isOpen: !isOpen
          }
        }));
        this.active = !isOpen;
        button.classList.toggle('is-open', !isOpen);
        dropdown.classList.toggle('is-open', !isOpen);
      }

      /**
       * "Scrolls" the top nav in cases where elements are focused but not fully visible.
       *
       * @param event The focus event
       */
    }, {
      kind: "method",
      key: "_handleTopNavFocusIn",
      value: function _handleTopNavFocusIn(event) {
        const {
          menuContainerInner,
          menu
        } = this;
        const {
          target
        } = event;
        const containerBox = menuContainerInner.getBoundingClientRect();
        const buttonBox = target.getBoundingClientRect();
        const leftOverflow = Math.max(containerBox.left - buttonBox.left, 0);
        const rightOverflow = Math.max(buttonBox.right - containerBox.right, 0);
        if (leftOverflow || rightOverflow) {
          const computedScroll = parseInt(window.getComputedStyle(menu).translate);
          const currentScroll = !Number.isNaN(computedScroll) ? computedScroll : 0;
          let newScroll = currentScroll;
          if (rightOverflow) {
            newScroll = currentScroll - rightOverflow;
          }
          if (leftOverflow) {
            newScroll = currentScroll + leftOverflow;
          }
          menu.style.translate = `${newScroll}px`;
        }
      }

      /**
       * Sets active menu item styles.
       */
    }, {
      kind: "method",
      key: "_handleSelectedMenuItem",
      value: function _handleSelectedMenuItem() {
        const {
          selectedMenuItem,
          currentUrlPath
        } = this;
        const menuItems = Array.from(this.shadowRoot.querySelectorAll(`.${prefix$g}--masthead__l1-item, .${prefix$g}--masthead__l1-dropdown-item`));
        const allLinks = Array.from(this.shadowRoot.querySelectorAll('a'));

        // Reset all selected elements.
        Array.from(this.shadowRoot.querySelectorAll('[active]')).forEach(el => el === null || el === void 0 ? void 0 : el.removeAttribute('active'));
        this.selectedElements = [];

        // Check for manually set selected item.
        if (selectedMenuItem) {
          this.selectedElements = [...menuItems, ...allLinks].filter(el => {
            var _el$textContent;
            return ((_el$textContent = el.textContent) === null || _el$textContent === void 0 || (_el$textContent = _el$textContent.trim()) === null || _el$textContent === void 0 ? void 0 : _el$textContent.toLowerCase()) === selectedMenuItem.trim().toLowerCase();
          });
        }
        // Fall back to automated selection based on URL.
        else {
          this.selectedElements = allLinks.filter(el => {
            try {
              const elURL = new URL(el.href);
              const currURL = new URL(currentUrlPath || '');
              if (el.href.includes('#')) {
                return false;
              }
              // Compare url without query params.
              return elURL.host === currURL.host && elURL.pathname === currURL.pathname;
            } catch (_error) {
              return false;
            }
          });
        }
        if (this.selectedElements.length) {
          // Set active on nearest menu item.
          this.selectedElements.forEach(element => {
            var _element$closest, _parentMenuItem$class;
            const parentMenuItem = (_element$closest = element.closest(`.${prefix$g}--masthead__l1-dropdown, .${prefix$g}--masthead__l1-dropdown-subsection`)) === null || _element$closest === void 0 ? void 0 : _element$closest.previousElementSibling;

            // Set on parent item as long as it's not the dropdown toggle.
            if (parentMenuItem && !(parentMenuItem !== null && parentMenuItem !== void 0 && (_parentMenuItem$class = parentMenuItem.classList) !== null && _parentMenuItem$class !== void 0 && _parentMenuItem$class.contains(`bx--masthead__l1-title`))) {
              parentMenuItem === null || parentMenuItem === void 0 || parentMenuItem.setAttribute('active', '');
            } else {
              element.setAttribute('active', '');
            }
          });
        } else {
          var _this$shadowRoot;
          // Should default to active section name if no menu links are selected.
          const l1Title = (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector(`.${prefix$g}--masthead__l1-title`);
          l1Title.setAttribute('active', '');
          this.selectedElements.push(l1Title);
        }
      }

      /**
       * Renders a heading object in the proper <H#> element.
       *
       * @param heading The heading object to be rendered.
       * @returns {_TemplateResult} Rendered heading.
       */
    }, {
      kind: "method",
      key: "_renderL1SubSectionHeading",
      value: function _renderL1SubSectionHeading(heading) {
        const {
          isMobileVersion
        } = this;
        const headingDesc = !isMobileVersion && heading.description ? x(_t31$1 || (_t31$1 = _$p`<span class="${0}--masthead__l1-dropdown-heading-desc"
            >${0}</span
          >`), prefix$g, heading.description) : '';
        const headingContent = heading.url ? x(_t32$1 || (_t32$1 = _$p`
          <a
            part="l1-dropdown-item-link l1-dropdown-item-link--heading"
            class="${0}--masthead__l1-dropdown-item"
            href="${0}">
            ${0}${0}
          </a>
        `), prefix$g, heading.url, heading.title, isMobileVersion ? this.Arrow16() : this.Arrow20()) : x(_t33$1 || (_t33$1 = _$p` ${0} `), heading.title);
        const headingClasses = o$2({
          [`${prefix$g}--masthead__l1-dropdown-heading`]: true,
          [`${prefix$g}--masthead__l1-dropdown-heading--no-link`]: Boolean(heading.url) === false
        });
        let renderedHeading = headingContent;
        switch (heading.headingLevel) {
          case 2:
            renderedHeading = x(_t34$1 || (_t34$1 = _$p`
          <h2 part="masthead-l1-h2-heading" class=${0}>
            ${0}
          </h2>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 3:
            renderedHeading = x(_t35$1 || (_t35$1 = _$p`
          <h3 part="masthead-l1-h3-heading" class=${0}>
            ${0}
          </h3>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 4:
            renderedHeading = x(_t36$1 || (_t36$1 = _$p`
          <h4 part="masthead-l1-h4-heading" class=${0}>
            ${0}
          </h4>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 5:
            renderedHeading = x(_t37$1 || (_t37$1 = _$p`
          <h5 part="masthead-l1-h5-heading" class=${0}>
            ${0}
          </h5>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          case 6:
            renderedHeading = x(_t38$1 || (_t38$1 = _$p`
          <h6 part="masthead-l1-h6-heading" class=${0}>
            ${0}
          </h6>
          ${0}
        `), headingClasses, headingContent, headingDesc);
            break;
          default:
            renderedHeading = headingContent;
        }
        return renderedHeading;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        this.style.setProperty('--scrollbarWidth', window.innerWidth - document.documentElement.clientWidth + 'px');

        // Allows component conditions on breakpoint change
        mastheadBreakpoint.addEventListener('change', () => {
          this.isMobileVersion = mastheadBreakpoint.matches;
        });
        if (this.isMobileVersion) {
          this._createScrollObserver();
        }
        this.direction = window.getComputedStyle(this).direction;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('selectedMenuItem')) {
          this._handleSelectedMenuItem();
        }
        if (changedProperties.has('isMobileVersion')) {
          if (this.isMobileVersion) {
            var _this$scrollObserver;
            // Stop observing, delete the observer.
            (_this$scrollObserver = this.scrollObserver) === null || _this$scrollObserver === void 0 || _this$scrollObserver.disconnect();
            this.scrollObserver = undefined;
          } else {
            // Creat observer, start observing.
            this._createScrollObserver();
          }
          this._handleSelectedMenuItem();
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          isMobileVersion
        } = this;
        return x(_t39$1 || (_t39$1 = _$p`
      <div
        part="masthead-l1-inner-container"
        class="${0}--masthead__l1-inner-container">
        ${0}
      </div>
    `), prefix$g, isMobileVersion ? x(_t40 || (_t40 = _$p` ${0} `), this._renderL1MobileNav()) : x(_t41 || (_t41 = _$p` ${0} `), this._renderL1TopNav()));
      }

      /**
       * Creates CTA markup and slots it into the L1.
       *
       * @param {L1CtaLink} cta L1 CTA data object
       * @returns A template fragment representing an L1 CTA or an empty string.
       */
    }, {
      kind: "method",
      static: true,
      key: "renderL1Cta",
      value: function renderL1Cta(cta) {
        const {
          url,
          ctaType
        } = cta;
        const slottedText = x(_t42 || (_t42 = _$p`<span slot="cta-text">${0}</span>`), cta === null || cta === void 0 ? void 0 : cta.title);
        if (ctaType) {
          return x(_t43 || (_t43 = _$p`
        <c4d-masthead-l1-cta slot="l1-cta" type="${0}">
          ${0}
        </c4d-masthead-l1-cta>
      `), ctaType, slottedText);
        }
        if (url) {
          return x(_t44 || (_t44 = _$p`
        <c4d-masthead-l1-cta slot="l1-cta" href="${0}">
          ${0}
        </c4d-masthead-l1-cta>
      `), url, slottedText);
        }
        return '';
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$q}--masthead__l1`;
      }
    }, {
      kind: "get",
      static: true,
      key: "dropDownToggleEvent",
      value: function () {
        return `${c4dPrefix$q}-masthead-l1-dropdown-toggle`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$4;
      }
    }]
  };
}, StableSelectorMixin(s));

let _$o = t => t,
  _t$o;
function _decorate$p(e, r, t, i) { var o = _getDecoratorsApi$p(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$p(s.d.map(_createElementDescriptor$p)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$p() { _getDecoratorsApi$p = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$p(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$p(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$p(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$p(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$p(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$p(e) { var r, t = _toPropertyKey$p(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$p(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$p(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$p(o.descriptor) || _isDataDescriptor$p(i.descriptor)) { if (_hasDecorators$p(o) || _hasDecorators$p(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$p(o)) { if (_hasDecorators$p(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$p(o, i); } } else r.push(o); } return r; }
function _hasDecorators$p(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$p(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$p(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$p(t) { var i = _toPrimitive$p(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$p(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$p(r) { return _arrayWithHoles$q(r) || _iterableToArray$p(r) || _unsupportedIterableToArray$q(r) || _nonIterableRest$q(); }
function _nonIterableRest$q() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$q(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$q(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$q(r, a) : void 0; } }
function _arrayLikeToArray$q(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$p(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$q(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$f,
  stablePrefix: c4dPrefix$p
} = settings;

/**
 * Masthead.
 *
 * @element c4d-masthead
 * @csspart l0 - The Masthead L0. Usage: `c4d-masthead::part(l0)`
 * @csspart header - The header. Usage: `c4d-masthead::part(header)`
 * @csspart header-search - The header search. Usage: `c4d-masthead::part(header-search)`
 * @csspart header-nav-container - The header nav container. Usage: `c4d-masthead::part(header-nav-container)`
 * @slot brand - The left hand area.
 * @slot nav - The nav content.
 * @slot profile - The right hand area.
 */
_decorate$p([carbonElement(`${c4dPrefix$p}-masthead`)], function (_initialize, _StableSelectorMixin) {
  class C4DMasthead extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMasthead,
    d: [{
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        StickyHeader.global.masthead = this;
      }

      /**
       * Re-initializes masthead component with StickyHeader class in case of L1 addition/removal.
       */
    }, {
      kind: "method",
      key: "handleL1Change",
      value: function handleL1Change({
        target
      }) {
        const L1Navs = target.assignedElements().filter(element => element.tagName.toLowerCase() === `${c4dPrefix$p}-masthead-l1`);
        if (L1Navs.length) {
          StickyHeader.global.masthead = this;
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$o || (_t$o = _$o`
      <div part="l0" class="${0}--masthead__l0">
        <div part="header" class="${0}--header">
          <slot name="brand"></slot>
          <div part="header-search" class="${0}--header__search">
            <div
              part="header-nav-container"
              class="${0}--header__nav-container">
              <slot></slot>
            </div>
            <slot name="search"></slot>
          </div>
          <slot name="profile"></slot>
        </div>
      </div>
      <slot name="masthead-l1" @slotchange=${0}></slot>
    `), prefix$f, prefix$f, prefix$f, prefix$f, this.handleL1Change);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$p}--masthead`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(s));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$c = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}${children}<path d="M26,4h-4V2h-2v2h-8V2h-2v2H6C4.9,4,4,4.9,4,6v20c0,1.1,0.9,2,2,2h20c1.1,0,2-0.9,2-2V6C28,4.9,27.1,4,26,4z M26,26H6V12h20	V26z M26,10H6V6h4v2h2V6h8v2h2V6h4V10z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$b = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}<path d="M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"></path><path d="M8 10H24V12H8zM8 16H18V18H8z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$a = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}<path d="M20 2L20 14 30 8 20 2z"></path><path d="m28,14v8H4V6h10v-2H4c-1.1045,0-2,.8955-2,2v16c0,1.1045.8955,2,2,2h8v4h-4v2h16v-2h-4v-4h8c1.1046,0,2-.8955,2-2v-8h-2Zm-10,14h-4v-4h4v4Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$9 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}<path d="M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$8 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}<path d="M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$7 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="16" height="16" viewBox="0 0 32 32">${children}<path d="M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"></path><path d="M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"></path></svg>`;

let _$n = t => t,
  _t$n,
  _t2$b,
  _t3$4,
  _t4$3,
  _t5$3;
function _decorate$o(e, r, t, i) { var o = _getDecoratorsApi$o(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$o(s.d.map(_createElementDescriptor$o)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$o() { _getDecoratorsApi$o = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$o(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$o(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$o(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$o(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$o(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$o(e) { var r, t = _toPropertyKey$o(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$o(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$o(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$o(o.descriptor) || _isDataDescriptor$o(i.descriptor)) { if (_hasDecorators$o(o) || _hasDecorators$o(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$o(o)) { if (_hasDecorators$o(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$o(o, i); } } else r.push(o); } return r; }
function _hasDecorators$o(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$o(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$o(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$o(t) { var i = _toPrimitive$o(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$o(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$o(r) { return _arrayWithHoles$p(r) || _iterableToArray$o(r) || _unsupportedIterableToArray$p(r) || _nonIterableRest$p(); }
function _nonIterableRest$p() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$p(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$p(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$p(r, a) : void 0; } }
function _arrayLikeToArray$p(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$o(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$p(r) { if (Array.isArray(r)) return r; }
function _superPropGet$f(t, e, r, o) { var p = _get$c(_getPrototypeOf$c(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$c() { return _get$c = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$c(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$c.apply(null, arguments); }
function _superPropBase$c(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$c(t));); return t; }
function _getPrototypeOf$c(t) { return _getPrototypeOf$c = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$c(t); }
const {
  prefix: prefix$e,
  stablePrefix: c4dPrefix$o
} = settings;

/**
 * Masthead L1 CTA.
 *
 * @element c4d-masthead-l1-cta
 * @slot cta-text - The CTA text
 * @csspart inner-wrapper-desktop - The inner wrapper for the desktop view. Usage: `c4d-masthead-l1-cta::part(inner-wrapper-desktop)`
 * @csspart l1-button - The button element for CTA. Usage: `c4d-masthead-l1-cta::part(l1-button)`
 * @csspart l1-link - The link element for CTA. Usage: `c4d-masthead-l1-cta::part(l1-link)`
 */
_decorate$o([carbonElement(`${c4dPrefix$o}-masthead-l1-cta`)], function (_initialize, _StableSelectorMixin) {
  class C4DMastheadL1Cta extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadL1Cta,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "isMobileVersion",
      value() {
        return mastheadBreakpoint.matches;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "type",
      value() {
        return L1_CTA_TYPES.NONE;
      }
    }, {
      kind: "method",
      key: "setCMAppAttributes",
      value:
      /**
       * Whether the current viewport is below 800px or not
       */

      /**
       * Sets attributes that enable integration with the global Contact Module app.
       *
       * @returns void
       */
      function setCMAppAttributes() {
        const {
          type
        } = this;
        if (type) {
          var _this$shadowRoot;
          this.setAttribute('data-ibm-contact', `${type}-link`);
          const textSlot = this === null || this === void 0 || (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector('slot[name="cta-text"]');
          if (textSlot) {
            var _assignedElements;
            (_assignedElements = textSlot.assignedElements()) === null || _assignedElements === void 0 || _assignedElements.forEach(element => {
              element.setAttribute('data-ibm-contact', `${type}-text`);
            });
          }
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        // Allows component conditions on breakpoint change
        mastheadBreakpoint.addEventListener('change', () => {
          this.isMobileVersion = mastheadBreakpoint.matches;
        });
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet$f(C4DMastheadL1Cta, "connectedCallback", this, 3)([]);
        this.setCMAppAttributes();
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet$f(C4DMastheadL1Cta, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('type')) {
          this.setCMAppAttributes();
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          isMobileVersion,
          href,
          type
        } = this;
        const classname = isMobileVersion ? `${prefix$e}--masthead__l1-dropdown-cta` : `${prefix$e}--masthead__l1-cta`;

        // Adds inner wrapper markup in desktop displays.
        const desktopWrapper = markup => {
          if (!isMobileVersion) {
            return x(_t$n || (_t$n = _$n`
          <div part="inner-wrapper-desktop" class="${0}-inner">
            ${0}
          </div>
        `), classname, markup);
          }
          return markup;
        };

        /**
         * Maps L1_CTA_TYPES values to CMApp CTA options.
         *
         * @see https://github.ibm.com/live-advisor/cm-app/blob/master/docs/cm-doc.md#calls-to-action
         */
        const iconMap = new Map([[L1_CTA_TYPES.CONTACT_US, svgResultCarbonIcon$b()], [L1_CTA_TYPES.CHAT_NOW, svgResultCarbonIcon$b()], [L1_CTA_TYPES.EMAIL_US, svgResultCarbonIcon$9()], [L1_CTA_TYPES.CALL_US, svgResultCarbonIcon$8()], [L1_CTA_TYPES.BOOK_A_CONSULTATION, svgResultCarbonIcon$c()], [L1_CTA_TYPES.REQUEST_A_DEMO, svgResultCarbonIcon$a()], [L1_CTA_TYPES.REQUEST_A_QUOTE, svgResultCarbonIcon$7()]]);
        if (type && iconMap.has(type)) {
          const icon = iconMap.get(type);
          return x(_t2$b || (_t2$b = _$n`
        <button
          part="l1-button"
          class="${0}"
          data-ibm-contact="${0}-link">
          ${0}
        </button>
      `), classname, type, desktopWrapper(x(_t3$4 || (_t3$4 = _$n`
            <slot name="cta-text"></slot>
            ${0}
          `), icon)));
        }
        if (href) {
          const isRTL = document.dir.toLowerCase() === 'rtl';
          const ArrowIcon = isRTL ? svgResultCarbonIcon$h : svgResultCarbonIcon$i;
          const icon = isMobileVersion ? ArrowIcon() : '';
          return x(_t4$3 || (_t4$3 = _$n`
        <a part="l1-link" class="${0}" href="${0}">
          ${0}
        </a>
      `), classname, href, desktopWrapper(x(_t5$3 || (_t5$3 = _$n`<slot name="cta-text"></slot>${0}`), icon)));
        }
        return '';
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$4;
      }
    }]
  };
}, StableSelectorMixin(s));

let _$m = t => t,
  _t$m;
function _decorate$n(e, r, t, i) { var o = _getDecoratorsApi$n(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$n(s.d.map(_createElementDescriptor$n)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$n() { _getDecoratorsApi$n = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$n(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$n(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$n(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$n(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$n(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$n(e) { var r, t = _toPropertyKey$n(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$n(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$n(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$n(o.descriptor) || _isDataDescriptor$n(i.descriptor)) { if (_hasDecorators$n(o) || _hasDecorators$n(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$n(o)) { if (_hasDecorators$n(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$n(o, i); } } else r.push(o); } return r; }
function _hasDecorators$n(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$n(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$n(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$n(t) { var i = _toPrimitive$n(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$n(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$n(r) { return _arrayWithHoles$o(r) || _iterableToArray$n(r) || _unsupportedIterableToArray$o(r) || _nonIterableRest$o(); }
function _nonIterableRest$o() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$o(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$o(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$o(r, a) : void 0; } }
function _arrayLikeToArray$o(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$n(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$o(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$d,
  stablePrefix: c4dPrefix$n
} = settings;

/**
 * Masthead.
 *
 * @element c4d-masthead-l1-name
 * @csspart l1-name-title - The title element. Usage: `c4d-masthead-l1-name::part(l1-name-title)`
 * @csspart l1-name-link - The link element. Usage: `c4d-masthead-l1-name::part(l1-name-link)`
 */
_decorate$n([carbonElement(`${c4dPrefix$n}-masthead-l1-name`)], function (_initialize, _StableSelectorMixin) {
  class C4DMastheadL1Name extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadL1Name,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'name';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "url",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "title",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * slot name for this component in the masthead l1
       */

      function render() {
        return x(_t$m || (_t$m = _$m`
      <span part="l1-name-title" class="${0}--masthead__l1-name-title">
        <a part="l1-name-link" href="${0}">${0}</a>
      </span>
    `), prefix$d, this.url, this.title);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$n}--masthead__l1-name`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(s));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$6 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 20 20">${children}${children}<path d="M2 14.8H18V16H2zM2 11.2H18V12.399999999999999H2zM2 7.6H18V8.799999999999999H2zM2 4H18V5.2H2z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Collapse modes of side nav.
 */
let SIDE_NAV_COLLAPSE_MODE;

/**
 * The usage purpose of side nav.
 */
(function (SIDE_NAV_COLLAPSE_MODE) {
  SIDE_NAV_COLLAPSE_MODE["FIXED"] = "fixed";
  SIDE_NAV_COLLAPSE_MODE["RAIL"] = "rail";
  SIDE_NAV_COLLAPSE_MODE["RESPONSIVE"] = "responsive";
})(SIDE_NAV_COLLAPSE_MODE || (SIDE_NAV_COLLAPSE_MODE = {}));
let SIDE_NAV_USAGE_MODE;
(function (SIDE_NAV_USAGE_MODE) {
  SIDE_NAV_USAGE_MODE["REGULAR"] = "";
  SIDE_NAV_USAGE_MODE["HEADER_NAV"] = "header-nav";
})(SIDE_NAV_USAGE_MODE || (SIDE_NAV_USAGE_MODE = {}));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$3 = i$4([
  ':root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}.cds--side-nav{position:fixed;z-index:8000;overflow:hidden;background-color:var(--cds-background,#fff);color:var(--cds-text-secondary,#525252);inline-size:3rem;inset-block-end:0;inset-block-start:0;inset-inline-start:0;max-inline-size:16rem;transition:inline-size .11s cubic-bezier(.2,0,1,.9),transform .11s cubic-bezier(.2,0,1,.9);will-change:inline-size}.cds--side-nav--ux{inline-size:16rem;inset-block-start:3rem}@media (max-width:65.98rem){.cds--side-nav--ux{inline-size:0}}.cds--side-nav--rail{inline-size:3rem}.cds--side-nav--hidden{inline-size:0}.cds--side-nav--expanded{inline-size:16rem}.cds--side-nav__overlay{position:fixed;background-color:transparent;block-size:0;inline-size:0;inset-block-start:3rem;inset-inline-start:0;opacity:0;transition:opacity .3s cubic-bezier(.5,0,.1,1),background-color .3s cubic-bezier(.5,0,.1,1)}@media (max-width:65.98rem){.cds--side-nav__overlay-active{z-index:6000;background-color:var(--cds-overlay,rgba(22,22,22,.5));block-size:100vh;inline-size:100vw;opacity:1;transition:opacity .3s cubic-bezier(.5,0,.1,1),background-color .3s cubic-bezier(.5,0,.1,1)}}.cds--header~.cds--side-nav{block-size:calc(100% - 48px);inset-block-start:3rem}.cds--side-nav--fixed{inline-size:16rem}.cds--side-nav--collapsed{inline-size:16rem;transform:translateX(-16rem)}.cds--side-nav__navigation{display:flex;flex-direction:column}.cds--side-nav__items,:host(cds-side-nav-items){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;overflow:hidden;flex:1 1 0%;padding:1rem 0 0}.cds--side-nav__items *,.cds--side-nav__items ::after,.cds--side-nav__items ::before,:host(cds-side-nav-items) *,:host(cds-side-nav-items) ::after,:host(cds-side-nav-items) ::before{box-sizing:inherit}.cds--side-nav--expanded .cds--side-nav__items,.cds--side-nav--expanded :host(cds-side-nav-items),.cds--side-nav--fixed .cds--side-nav__items,.cds--side-nav--fixed :host(cds-side-nav-items),.cds--side-nav:hover .cds--side-nav__items,.cds--side-nav:hover :host(cds-side-nav-items){overflow-y:auto}.cds--side-nav--ux .cds--side-nav__items,.cds--side-nav--ux :host(cds-side-nav-items){overflow-y:auto}.cds--side-nav__item,:host(cds-side-nav-link),:host(cds-side-nav-menu){overflow:hidden;block-size:auto;inline-size:auto}.cds--side-nav--ux .cds--side-nav__item,.cds--side-nav--ux :host(cds-side-nav-link),.cds--side-nav--ux :host(cds-side-nav-menu){block-size:auto;inline-size:auto}.cds--side-nav .cds--header__menu-title[aria-expanded=true]:hover,.cds--side-nav a.cds--header__menu-item:hover,.cds--side-nav__item:not(.cds--side-nav__item--active):hover .cds--side-nav__item:not(.cds--side-nav__item--active)>.cds--side-nav__submenu:hover,.cds--side-nav__item:not(.cds--side-nav__item--active):hover :not(.cds--side-nav__item--active):host(cds-side-nav-link)>.cds--side-nav__submenu:hover,.cds--side-nav__item:not(.cds--side-nav__item--active):hover :not(.cds--side-nav__item--active):host(cds-side-nav-menu)>.cds--side-nav__submenu:hover,.cds--side-nav__item:not(.cds--side-nav__item--active)>.cds--side-nav__link:hover,.cds--side-nav__menu a.cds--side-nav__link:not(.cds--side-nav__link--current):not([aria-current=page]):hover,:not(.cds--side-nav__item--active):host(cds-side-nav-link)>.cds--side-nav__link:hover,:not(.cds--side-nav__item--active):host(cds-side-nav-menu)>.cds--side-nav__link:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}.cds--side-nav__item:not(.cds--side-nav__item--active) .cds--side-nav__menu-item>.cds--side-nav__link:hover>span,.cds--side-nav__item:not(.cds--side-nav__item--active) :host(cds-side-nav-menu-item)>.cds--side-nav__link:hover>span,.cds--side-nav__item:not(.cds--side-nav__item--active)>.cds--side-nav__link:hover>span,:not(.cds--side-nav__item--active):host(cds-side-nav-link) .cds--side-nav__menu-item>.cds--side-nav__link:hover>span,:not(.cds--side-nav__item--active):host(cds-side-nav-link) :host(cds-side-nav-menu-item)>.cds--side-nav__link:hover>span,:not(.cds--side-nav__item--active):host(cds-side-nav-link)>.cds--side-nav__link:hover>span,:not(.cds--side-nav__item--active):host(cds-side-nav-menu) .cds--side-nav__menu-item>.cds--side-nav__link:hover>span,:not(.cds--side-nav__item--active):host(cds-side-nav-menu) :host(cds-side-nav-menu-item)>.cds--side-nav__link:hover>span,:not(.cds--side-nav__item--active):host(cds-side-nav-menu)>.cds--side-nav__link:hover>span{color:var(--cds-text-primary,#161616)}.cds--side-nav__item--large,:host(cds-side-nav-link[large]),:host(cds-side-nav-menu[large]){block-size:auto}.cds--side-nav__divider,:host(cds-side-nav-divider){margin:.5rem 1rem;background-color:var(--cds-border-subtle);block-size:1px;list-style-type:none}.cds--side-nav__divider hr,:host(cds-side-nav-divider) hr{border:none}.cds--side-nav__submenu{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;font-size:var(--cds-heading-compact-01-font-size,.875rem);font-weight:var(--cds-heading-compact-01-font-weight,600);line-height:var(--cds-heading-compact-01-line-height,1.28572);letter-spacing:var(--cds-heading-compact-01-letter-spacing,.16px);outline:2px solid transparent;outline-offset:-2px;display:flex;align-items:center;padding:0 1rem;block-size:2rem;color:var(--cds-text-secondary,#525252);transition:color 110ms,background-color 110ms,outline 110ms;-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--side-nav__submenu *,.cds--side-nav__submenu ::after,.cds--side-nav__submenu ::before{box-sizing:inherit}.cds--side-nav__submenu::-moz-focus-inner{border:0}.cds--side-nav__submenu:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}.cds--side-nav__submenu:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--side-nav__submenu:focus{outline-style:dotted}}.cds--side-nav__submenu-title{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;text-align:start}.cds--side-nav__icon.cds--side-nav__submenu-chevron{display:flex;flex:1;justify-content:flex-end}.cds--side-nav__submenu-chevron>svg{block-size:1rem;inline-size:1rem;transition:transform 110ms}.cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron>svg{transform:rotate(180deg)}.cds--side-nav__item--large .cds--side-nav__submenu,:host(cds-side-nav-link[large]) .cds--side-nav__submenu,:host(cds-side-nav-menu[large]) .cds--side-nav__submenu{block-size:3rem}.cds--side-nav__item--active .cds--side-nav__submenu:hover,:host(cds-side-nav-menu[active]) .cds--side-nav__submenu:hover{background-color:var(--cds-background-selected,rgba(141,141,141,.2));color:var(--cds-text-primary,#161616)}.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false],:host(cds-side-nav-menu[active]) .cds--side-nav__submenu[aria-expanded=false]{position:relative;background-color:var(--cds-background-selected,rgba(141,141,141,.2));color:var(--cds-text-primary,#161616)}.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false]::before,:host(cds-side-nav-menu[active]) .cds--side-nav__submenu[aria-expanded=false]::before{position:absolute;background-color:var(--cds-border-interactive,#0f62fe);content:"";inline-size:3px;inset-block-end:0;inset-block-start:0;inset-inline-start:0}.cds--side-nav__item--active .cds--side-nav__submenu-title,:host(cds-side-nav-menu[active]) .cds--side-nav__submenu-title{color:var(--cds-text-primary,#161616);font-weight:600}.cds--side-nav__item--active .cds--side-nav__icon>svg,:host(cds-side-nav-menu[active]) .cds--side-nav__icon>svg{fill:var(--cds-icon-primary,#161616)}.cds--side-nav__menu{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:block;max-block-size:0;visibility:hidden}.cds--side-nav__menu *,.cds--side-nav__menu ::after,.cds--side-nav__menu ::before{box-sizing:inherit}.cds--side-nav__submenu[aria-expanded=true]+.cds--side-nav__menu{max-block-size:93.75rem;visibility:inherit}.cds--side-nav__menu a.cds--side-nav__link{block-size:2rem;font-weight:400;min-block-size:2rem;padding-inline-start:2rem}.cds--side-nav__item.cds--side-nav__item--icon a.cds--side-nav__link,:host(cds-side-nav-menu):host(cds-side-nav-menu[has-icon]) a.cds--side-nav__link{padding-inline-start:4.5rem}.cds--side-nav__menu a.cds--side-nav__link--current,.cds--side-nav__menu a.cds--side-nav__link[aria-current=page],a.cds--side-nav__link--current{background-color:var(--cds-background-selected,rgba(141,141,141,.2))}.cds--side-nav__menu a.cds--side-nav__link--current>span,.cds--side-nav__menu a.cds--side-nav__link[aria-current=page]>span,a.cds--side-nav__link--current>span{color:var(--cds-text-primary,#161616);font-weight:600}.cds--side-nav .cds--header__menu-title[aria-expanded=true]+.cds--header__menu,.cds--side-nav a.cds--header__menu-item,a.cds--side-nav__link{outline:2px solid transparent;outline-offset:-2px;font-size:var(--cds-heading-compact-01-font-size,.875rem);font-weight:var(--cds-heading-compact-01-font-weight,600);line-height:var(--cds-heading-compact-01-line-height,1.28572);letter-spacing:var(--cds-heading-compact-01-letter-spacing,.16px);position:relative;display:flex;align-items:center;padding:0 1rem;min-block-size:2rem;text-decoration:none;transition:color 110ms,background-color 110ms,outline 110ms}.cds--side-nav__item--large a.cds--side-nav__link,:host(cds-side-nav-link[large]) a.cds--side-nav__link,:host(cds-side-nav-menu[large]) a.cds--side-nav__link{block-size:3rem}.cds--side-nav a.cds--header__menu-item .cds--text-truncate-end,a.cds--side-nav__link>.cds--side-nav__link-text{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;color:var(--cds-text-secondary,#525252);font-size:.875rem;letter-spacing:.1px;line-height:1.25rem;-webkit-user-select:none;-moz-user-select:none;user-select:none}.cds--side-nav a.cds--header__menu-item:focus,a.cds--side-nav__link:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--side-nav a.cds--header__menu-item:focus,a.cds--side-nav__link:focus{outline-style:dotted}}a.cds--side-nav__link--current,a.cds--side-nav__link[aria-current=page]{background-color:var(--cds-background-selected,rgba(141,141,141,.2));font-weight:600}a.cds--side-nav__link--current .cds--side-nav__link-text,a.cds--side-nav__link[aria-current=page] .cds--side-nav__link-text{color:var(--cds-text-primary,#161616)}a.cds--side-nav__link--current::before,a.cds--side-nav__link[aria-current=page]::before{position:absolute;background-color:var(--cds-border-interactive,#0f62fe);content:"";inline-size:3px;inset-block-end:0;inset-block-start:0;inset-inline-start:0}.cds--side-nav__icon{display:flex;flex:0 0 1rem;align-items:center;justify-content:center}.cds--side-nav__icon:not(.cds--side-nav__submenu-chevron){margin-inline-end:1.5rem}.cds--side-nav__icon>svg{block-size:1rem;fill:var(--cds-icon-secondary,#525252);inline-size:1rem}.cds--side-nav__icon>svg.cds--side-nav-collapse-icon{display:none}.cds--side-nav--expanded .cds--side-nav__icon>svg.cds--side-nav-expand-icon{display:none}.cds--side-nav--expanded .cds--side-nav__icon>svg.cds--side-nav-collapse-icon{display:block}.cds--side-nav--fixed .cds--side-nav__submenu,.cds--side-nav--fixed a.cds--side-nav__link{padding-inline-start:1rem}.cds--side-nav--fixed .cds--side-nav__item:not(.cds--side-nav__item--icon) .cds--side-nav__menu a.cds--side-nav__link,.cds--side-nav--fixed :not(.cds--side-nav__item--icon):host(cds-side-nav-link) .cds--side-nav__menu a.cds--side-nav__link,.cds--side-nav--fixed :not(.cds--side-nav__item--icon):host(cds-side-nav-menu) .cds--side-nav__menu a.cds--side-nav__link{padding-inline-start:2rem}@media (max-width:65.98rem){.cds--side-nav .cds--header__nav{display:block}}.cds--side-nav__header-navigation,:host(cds-header-side-nav-items){box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:none}.cds--side-nav__header-navigation *,.cds--side-nav__header-navigation ::after,.cds--side-nav__header-navigation ::before,:host(cds-header-side-nav-items) *,:host(cds-header-side-nav-items) ::after,:host(cds-header-side-nav-items) ::before{box-sizing:inherit}@media (max-width:65.98rem){.cds--side-nav__header-navigation,:host(cds-header-side-nav-items){position:relative;display:block;margin-block-end:2rem}}.cds--side-nav__header-divider::after{position:absolute;background:var(--cds-border-subtle);block-size:.0625rem;content:"";inline-size:calc(100% - 32px);inset-block-end:-1rem;inset-inline-start:1rem}.cds--side-nav a.cds--header__menu-item{justify-content:space-between;color:var(--cds-text-secondary,#525252);white-space:nowrap}.cds--side-nav a.cds--header__menu-item[aria-expanded=true]{background-color:transparent}.cds--side-nav .cds--header__menu-title[aria-expanded=true]+.cds--header__menu{padding:0;background-color:transparent;box-shadow:none;inline-size:100%;inset-block-end:inherit;transform:none}.cds--side-nav .cds--header__menu-title[aria-expanded=true]+.cds--header__menu li{inline-size:100%}.cds--side-nav .cds--header__menu-title[aria-expanded=true]+.cds--header__menu a.cds--header__menu-item{font-weight:400;padding-inline-start:4.25rem}.cds--side-nav .cds--header__menu-title[aria-expanded=true]+.cds--header__menu a.cds--header__menu-item:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}.cds--side-nav .cds--header__menu-title[aria-expanded=true]+.cds--header__menu a.cds--header__menu-item--current:hover{background-color:var(--cds-layer-selected-hover)}.cds--side-nav .cds--side-nav__header-navigation .cds--header__menu-item--current::after,.cds--side-nav .cds--side-nav__header-navigation a.cds--header__menu-item[aria-current=page]::after,.cds--side-nav :host(cds-header-side-nav-items) .cds--header__menu-item--current::after,.cds--side-nav :host(cds-header-side-nav-items) a.cds--header__menu-item[aria-current=page]::after{block-size:calc(100% + 4px);inline-size:3px}.cds--side-nav .cds--header__menu a.cds--header__menu-item{block-size:inherit}.cds--side-nav .cds--header__menu-arrow,.cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,.cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow{fill:var(--cds-icon-secondary,#525252)}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--side-nav .cds--header__menu-arrow,.cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,.cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,.cds--side-nav__icon>svg{fill:ButtonText}}:host(cds-side-nav[expanded]) ::slotted(cds-side-nav-items){overflow-y:auto}:host(cds-side-nav-link){display:block;block-size:auto;inline-size:auto;outline:0}:host(cds-side-nav-link) .cds--side-nav__icon{color:var(--cds-text-primary,#161616)}:host(cds-side-nav-link) .cds--side-nav__icon[hidden]{display:none}:host(cds-side-nav-divider){display:block}:host(cds-side-nav-menu){display:block}:host(cds-side-nav-menu) .cds--side-nav__icon[hidden]{display:none}:host(cds-side-nav-menu) .cds--side-nav__menu{padding:0;margin:0}:host(cds-side-nav-menu) .cds--side-nav__submenu[aria-expanded=true]+.cds--side-nav__menu{max-block-size:none}:host(cds-side-nav-menu[active]){position:relative;color:var(--cds-text-primary,#161616)}:host(cds-side-nav-menu[active])::before{position:absolute;background-color:var(--cds-border-interactive,#0f62fe);content:"";inline-size:.25rem;inset-block:0;inset-inline-start:0}:host(cds-side-nav-menu[active][expanded]){position:inherit;background-color:inherit;color:inherit}:host(cds-side-nav-menu[active][expanded])::before{content:none}:host(cds-side-nav-menu-item){display:block;block-size:auto;inline-size:auto;outline:0}:host(cds-side-nav-menu-item) a.cds--side-nav__link{block-size:2rem;font-weight:400;min-block-size:2rem;padding-inline-start:2rem}:host(cds-side-nav-menu-item[parent-has-icon]) a.cds--side-nav__link{padding-inline-start:4.5rem}:host(cds-side-nav-item) .cds--side-nav__link:hover,:host(cds-side-nav-menu) .cds--side-nav__submenu:hover,:host(cds-side-nav-menu-item) .cds--side-nav__link:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}',
]);

let _$l = t => t,
  _t$l,
  _t2$a;
function _superPropGet$e(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Side nav.
 *
 * @element cds-side-nav
 * @fires cds-header-menu-button-toggled
 *   The name of the custom event fired after the header menu button in the document is toggled upon a user gesture.
 */
let CDSSideNav = _decorate$Z([carbonElement(`${prefix$B}-side-nav`)], function (_initialize, _HostListenerMixin) {
  class CDSSideNav extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSSideNav,
    d: [{
      kind: "field",
      key: "_hovered",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "_hTransition",
      value() {
        return null;
      }
    }, {
      kind: "method",
      key: "_cleanHTransition",
      value:
      /**
       * `true` if this side nav is hovered.
       */

      /**
       * The handle for `transitionend` event listener.
       */

      /**
       * Cleans the handle for `transitionend` event listener.
       */
      function _cleanHTransition() {
        if (this._hTransition) {
          this._hTransition = this._hTransition.release();
        }
      }

      /**
       * Handles `${prefix}-header-menu-button-toggle` event on the document.
       */
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventButtonToggle')],
      key: "_handleButtonToggle",
      value() {
        return async event => {
          this.expanded = event.detail.active;
        };
      }
    }, {
      kind: "method",
      key: "_updatedSideNavMenuForceCollapsedState",
      value:
      /**
       * Force child side nav menus collapsed upon the hover/expanded state of this side nav.
       */
      function _updatedSideNavMenuForceCollapsedState() {
        const {
          expanded,
          _hovered: hovered
        } = this;
        forEach$1(this.querySelectorAll(this.constructor.selectorMenu), item => {
          item.forceCollapsed = !expanded && !hovered;
        });
      }

      /**
       * Collapse mode of the side nav.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'collapse-mode'
      })],
      key: "collapseMode",
      value() {
        return SIDE_NAV_COLLAPSE_MODE.RESPONSIVE;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "expanded",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'is-not-child-of-header'
      })],
      key: "isNotChildOfHeader",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'is-not-persistent'
      })],
      key: "isNotPersistent",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * `true` to expand the side nav.
       */
      /**
       * If `true` will style the side nav to sit below the header
       */
      /**
       * Specify if the side-nav will be persistent above the lg breakpoint
       */
      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'navigation');
        }
        _superPropGet$e(CDSSideNav, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this._cleanHTransition();
        _superPropGet$e(CDSSideNav, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        const doc = this.getRootNode();
        if (changedProperties.has('collapseMode')) {
          forEach$1(doc.querySelectorAll(this.constructor.selectorButtonToggle), item => {
            item.collapseMode = this.collapseMode;
          });
        }
        if (changedProperties.has('expanded')) {
          const headerItems = doc.querySelectorAll(this.constructor.selectorHeaderItems);
          forEach$1(doc.querySelectorAll(this.constructor.selectorButtonToggle), item => {
            item.active = this.expanded;
          });
          if (this.expanded) {
            var _this$querySelector;
            forEach$1(headerItems, item => {
              item.setAttribute('tabindex', '-1');
            });
            (_this$querySelector = this.querySelector(this.constructor.selectorNavItems)) === null || _this$querySelector === void 0 || _this$querySelector.focus();
          } else {
            forEach$1(headerItems, item => {
              item.removeAttribute('tabindex');
            });
          }
        }
        if (changedProperties.has('isNotChildOfHeader')) {
          forEach$1(doc.querySelectorAll(this.constructor.selectorButtonToggle), item => {
            item.isNotChildOfHeader = this.isNotChildOfHeader;
          });
        }
      }

      /**
       * Handles `blur` event handler on this element.
       *
       * @param event The event.
       * @param event.relatedTarget The event relatedTarget.
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusout')],
      key: "_handleFocusOut",
      value: function _handleFocusOut({
        relatedTarget
      }) {
        const {
          collapseMode
        } = this;
        if (collapseMode !== SIDE_NAV_COLLAPSE_MODE.FIXED) {
          if (!this.contains(relatedTarget)) {
            this.expanded = false;
          }
        }
      }

      /**
       * Handles `focus` event handler on this element.
       *
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusin')],
      key: "_handleFocusIn",
      value: function _handleFocusIn() {
        const {
          collapseMode
        } = this;
        if (collapseMode !== SIDE_NAV_COLLAPSE_MODE.FIXED) {
          this.expanded = true;
        }
      }

      /**
       * Handles the `mouseover` event for the side nav in rail mode.
       *
       */
    }, {
      kind: "method",
      key: "_handleNavMouseOver",
      value: function _handleNavMouseOver() {
        const {
          collapseMode
        } = this;
        if (collapseMode === SIDE_NAV_COLLAPSE_MODE.RAIL) {
          this.expanded = true;
          this._hovered = true;
          this._updatedSideNavMenuForceCollapsedState();
        }
      }

      /**
       * Handles the `mouseout` event for the side nav in rail mode.
       *
       */
    }, {
      kind: "method",
      key: "_handleNavMouseOut",
      value: function _handleNavMouseOut() {
        const {
          collapseMode
        } = this;
        if (collapseMode === SIDE_NAV_COLLAPSE_MODE.RAIL) {
          this.expanded = false;
          this._hovered = false;
          this._updatedSideNavMenuForceCollapsedState();
        }
      }

      /**
       * Handles the `click` event for the side nav overlay.
       *
       */
    }, {
      kind: "method",
      key: "_onOverlayClick",
      value: function _onOverlayClick() {
        this.expanded = false;
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          collapseMode,
          expanded,
          isNotChildOfHeader,
          isNotPersistent
        } = this;
        const classes = o$2({
          [`${prefix$B}--side-nav__navigation`]: true,
          [`${prefix$B}--side-nav`]: true,
          [`${prefix$B}--side-nav--expanded`]: expanded,
          [`${prefix$B}--side-nav--collapsed`]: !expanded && collapseMode === SIDE_NAV_COLLAPSE_MODE.FIXED,
          [`${prefix$B}--side-nav--rail`]: collapseMode === SIDE_NAV_COLLAPSE_MODE.RAIL,
          [`${prefix$B}--side-nav--ux`]: !isNotChildOfHeader,
          [`${prefix$B}--side-nav--hidden`]: isNotPersistent
        });
        const overlayClasses = o$2({
          [`${prefix$B}--side-nav__overlay`]: true,
          [`${prefix$B}--side-nav__overlay-active`]: expanded
        });
        return x(_t$l || (_t$l = _$l`${0}
      <div
        class="${0}"
        @mouseover="${0}"
        @mouseout="${0}">
        <slot></slot>
      </div>`), this.collapseMode === SIDE_NAV_COLLAPSE_MODE.FIXED ? null : x(_t2$a || (_t2$a = _$l`<div
            class="${0}"
            @click=${0}></div>`), overlayClasses, this._onOverlayClick), classes, this._handleNavMouseOver, this._handleNavMouseOut);
      }

      /**
       * A selector that will return the toggle buttons.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorButtonToggle",
      value: function () {
        return `${prefix$B}-header-menu-button`;
      }

      /**
       * A selector that will return the header name + global action elements.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorHeaderItems",
      value: function () {
        return `${prefix$B}-header-name, ${prefix$B}-header-global-action`;
      }

      /**
       * A selector that will return side nav focusable items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorNavItems",
      value: function () {
        return `${prefix$B}-side-nav-menu, ${prefix$B}-side-nav-menu-item, ${prefix$B}-side-nav-link`;
      }

      /**
       * A selector that will return side nav menus.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorMenu",
      value: function () {
        return `${prefix$B}-side-nav-menu`;
      }

      /**
       * The name of the custom event fired after the header menu button in the document is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventButtonToggle",
      value: function () {
        return `${prefix$B}-header-menu-button-toggled`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$3;
      }
    }]
  };
}, HostListenerMixin(s));

let _$k = t => t,
  _t$k;

/**
 * The trigger button for side nav in header nav.
 *
 * @element cds-header-menu-button
 * @csspart button The button.
 * @csspart toggle-icon The toggle icon.
 * @fires cds-header-menu-button-toggled - The custom event fired after this header menu button is toggled upon a user gesture.
 */
let CDSHeaderMenuButton = _decorate$Z([carbonElement(`${prefix$B}-header-menu-button`)], function (_initialize, _FocusMixin) {
  class CDSHeaderMenuButton extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSHeaderMenuButton,
    d: [{
      kind: "method",
      key: "_handleClick",
      value: function _handleClick() {
        const active = !this.active;
        this.active = active;
        this.dispatchEvent(new CustomEvent(this.constructor.eventToggle, {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            active
          }
        }));
      }

      /**
       * `true` if the button should represent its active state.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'button-label-active'
      })],
      key: "buttonLabelActive",
      value() {
        return 'Close navigation menu';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'button-label-inactive'
      })],
      key: "buttonLabelInactive",
      value() {
        return 'Open navigation menu';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'collapse-mode'
      })],
      key: "collapseMode",
      value() {
        return SIDE_NAV_COLLAPSE_MODE.RESPONSIVE;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "disabled",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'is-not-child-of-header'
      })],
      key: "isNotChildOfHeader",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The `aria-label` attribute for the button in its active state.
       */
      /**
       * The `aria-label` attribute for the button in its inactive state.
       */
      /**
       * Collapse mode of the side nav.
       */
      /**
       * `true` if the button should be disabled.
       */
      /**
       * If `true` will style the side nav to sit below the header
       */
      function render() {
        const {
          active,
          buttonLabelActive,
          buttonLabelInactive,
          disabled,
          _handleClick: handleClick
        } = this;
        const buttonLabel = active ? buttonLabelActive : buttonLabelInactive;
        const classes = o$2({
          [`${prefix$B}--header__action`]: true,
          [`${prefix$B}--header__menu-trigger`]: true,
          [`${prefix$B}--header__menu-toggle`]: true,
          [`${prefix$B}--header__action--active`]: active
        });
        return x(_t$k || (_t$k = _$k`
      <button
        part="button"
        class="${0}"
        ?disabled=${0}
        aria-label="${0}"
        @click=${0}>
        ${0}
      </button>
    `), classes, disabled, l(buttonLabel), handleClick, (active ? svgResultCarbonIcon$z : svgResultCarbonIcon$6)({
          slot: 'toggle-icon'
        }));
      }

      /**
       * The name of the custom event fired after this header menu button is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggle",
      value: function () {
        return `${prefix$B}-header-menu-button-toggled`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$5;
      }
    }]
  };
}, FocusMixin(s));

/**
 * Copyright IBM Corp. 2018, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 *
 * @param {*} element
 * @param  {...any} args
 * @returns {Event} The event
 */

function on(element) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  element.addEventListener.apply(element, args);
  return {
    release: function release() {
      element.removeEventListener.apply(element, args);
      return null;
    }
  };
}

function _slicedToArray(r, e) { return _arrayWithHoles$n(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray$n(r, e) || _nonIterableRest$n(); }
function _nonIterableRest$n() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$n(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$n(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$n(r, a) : void 0; } }
function _arrayLikeToArray$n(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles$n(r) { if (Array.isArray(r)) return r; }

/**
 * Fires the given event if focus goes out of the given element.
 *
 * @param {Element} element The element to monitor the focus on.
 * @param {Element[]} sentinelNodes
 *   The focus sentinel nodes.
 *   If these nodes gets focus, we see it as focus went out of the `element`.
 * @param {string} [eventRequestFocusWrap=cds-request-focus-wrap] The event name.
 * @returns {Function} The handle to remove the event handler.
 */
function focuswrap(element, sentinelNodes) {
  var eventRequestFocusWrap = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'cds-request-focus-wrap';
  return on(element, 'focusout', function handleFocusout(event) {
    var _event$currentTarget$, _event$currentTarget$2;
    var target = event.target,
      relatedTarget = event.relatedTarget;
    var _sentinelNodes = _slicedToArray(sentinelNodes, 2),
      startSentinelNode = _sentinelNodes[0],
      endSentinelNode = _sentinelNodes[1];
    var oldContains = target && target !== this && (event.currentTarget.contains(target) || ((_event$currentTarget$ = event.currentTarget.host) === null || _event$currentTarget$ === void 0 ? void 0 : _event$currentTarget$.contains(target))) && sentinelNodes.indexOf(target) < 0;
    var currentContains = relatedTarget && relatedTarget !== this && (event.currentTarget.contains(relatedTarget) || ((_event$currentTarget$2 = event.currentTarget.host) === null || _event$currentTarget$2 === void 0 ? void 0 : _event$currentTarget$2.contains(relatedTarget))) && sentinelNodes.indexOf(relatedTarget) < 0;
    // FF fires `focusout` event even if the page itself is losing focus (e.g. upon following outside link).
    // In such case, we do nothing.
    if (oldContains && !currentContains && relatedTarget) {
      var comparisonResult = target.compareDocumentPosition(relatedTarget);
      if (relatedTarget === startSentinelNode) {
        comparisonResult = Node.DOCUMENT_POSITION_PRECEDING;
      } else if (relatedTarget === endSentinelNode) {
        comparisonResult = Node.DOCUMENT_POSITION_FOLLOWING;
      } else {
        comparisonResult = -1;
      }
      element.dispatchEvent(new CustomEvent(eventRequestFocusWrap, {
        bubbles: true,
        cancelable: false,
        composed: true,
        detail: {
          comparisonResult: comparisonResult
        }
      }));
    }
  });
}

let _$j = t => t,
  _t$j,
  _t2$9;
function _decorate$m(e, r, t, i) { var o = _getDecoratorsApi$m(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$m(s.d.map(_createElementDescriptor$m)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$m() { _getDecoratorsApi$m = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$m(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$m(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$m(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$m(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$m(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$m(e) { var r, t = _toPropertyKey$m(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$m(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$m(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$m(o.descriptor) || _isDataDescriptor$m(i.descriptor)) { if (_hasDecorators$m(o) || _hasDecorators$m(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$m(o)) { if (_hasDecorators$m(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$m(o, i); } } else r.push(o); } return r; }
function _hasDecorators$m(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$m(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$m(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$m(t) { var i = _toPrimitive$m(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$m(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$m(r) { return _arrayWithHoles$m(r) || _iterableToArray$m(r) || _unsupportedIterableToArray$m(r) || _nonIterableRest$m(); }
function _nonIterableRest$m() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$m(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$m(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$m(r, a) : void 0; } }
function _arrayLikeToArray$m(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$m(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$m(r) { if (Array.isArray(r)) return r; }
function _superPropGet$d(t, e, r, o) { var p = _get$b(_getPrototypeOf$b(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$b() { return _get$b = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$b(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$b.apply(null, arguments); }
function _superPropBase$b(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$b(t));); return t; }
function _getPrototypeOf$b(t) { return _getPrototypeOf$b = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$b(t); }
const {
  prefix: prefix$c,
  stablePrefix: c4dPrefix$m
} = settings;

/**
 * Toggle button for masthead left nav.
 *
 * @element c4d-masthead-menu-button
 * @csspart sentinel-button - The sentinel button for managing focus.
 * @csspart ce-header-menu-trigger-container - Container for the menu trigger button.
 * @csspart sentinel-button--start - The start sentinel button for managing focus. Usage: `c4d-masthead-menu-button::part(sentinel-button--start)`
 * @csspart sentinel-button--end - The end sentinel button for managing focus. Usage: `c4d-masthead-menu-button::part(sentinel-button--end)`
 */
let C4DMastheadMenuButton = _decorate$m([carbonElement(`${c4dPrefix$m}-masthead-menu-button`)], function (_initialize, _HostListenerMixin) {
  class C4DMastheadMenuButton extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadMenuButton,
    d: [{
      kind: "field",
      key: "_hFocusWrap",
      value() {
        return null;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_hasSearchActive",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventToggleSearch')],
      key: "_handleSearchToggle",
      value() {
        return event => {
          if (event.detail.active !== undefined) {
            this._hasSearchActive = event.detail.active;
            this.hideMenuButton = event.detail.active;
          }
        };
      }
    }, {
      kind: "field",
      decorators: [i$1('#start-sentinel')],
      key: "_startSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('#end-sentinel')],
      key: "_endSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$c}--header__menu-trigger`)],
      key: "_buttonNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'brand';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'hide-menu-button'
      })],
      key: "hideMenuButton",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "focus",
      value:
      /**
       * The handle for focus wrapping.
       */

      /**
       * Search bar opened flag.
       */

      /**
       * Handles toggle event from the search component.
       *
       * @param event The event.
       */

      /**
       * Node to track focus going outside of modal content.
       */

      /**
       * Node to track focus going outside of modal content.
       */

      /**
       * The `<button>`.
       */

      /**
       * The shadow slot this toggle button should be in.
       */

      /**
       * `true` to hide the logo at render
       */

      function focus() {
        const {
          _buttonNode: buttonNode
        } = this;
        if (buttonNode) {
          buttonNode.focus();
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        const boundHideButton = this.hideButtonIfNoNavItemsFound.bind(this);
        window.addEventListener(`load`, () => {
          boundHideButton();
        });
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('active')) {
          const {
            active,
            _startSentinelNode: startSentinelNode,
            _endSentinelNode: endSentinelNode
          } = this;
          if (active) {
            this._hFocusWrap = focuswrap(this.shadowRoot, [startSentinelNode, endSentinelNode]);
          } else if (this._hFocusWrap) {
            this._hFocusWrap = this._hFocusWrap.release();
          }
        }
        if (changedProperties.has('hideMenuButton')) {
          this._hasSearchActive = this.hideMenuButton;
        }
        this.hideButtonIfNoNavItemsFound();
      }
    }, {
      kind: "method",
      key: "hideButtonIfNoNavItemsFound",
      value: function hideButtonIfNoNavItemsFound() {
        var _this$closest;
        const NavMenuItems = (_this$closest = this.closest(`${c4dPrefix$m}-masthead-container`)) === null || _this$closest === void 0 ? void 0 : _this$closest.querySelectorAll(`${c4dPrefix$m}-left-nav-menu`);
        if (!(NavMenuItems !== null && NavMenuItems !== void 0 && NavMenuItems.length)) {
          this.hideMenuButton = true;
          this.style.display = 'none';
        } else if (this.style.display == 'none') {
          this.hideMenuButton = false;
          this.style.display = '';
        }
      }
    }, {
      kind: "field",
      key: "_renderSentinel",
      value() {
        return side => {
          return x(_t$j || (_t$j = _$j`
      <button
        part="sentinel-button sentinel-button--${0}"
        id="${0}-sentinel"
        type="button"
        class="${0}--visually-hidden"></button>
    `), side, side, prefix$c);
        };
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          active,
          _hasSearchActive: hasSearchActive,
          _renderSentinel: renderSentinel
        } = this;
        const classes = o$2({
          [`${c4dPrefix$m}-ce--header__menu-trigger__container`]: true,
          [`${c4dPrefix$m}-ce--header__menu-trigger__container--has-search-active`]: hasSearchActive
        });
        const startSentinel = active ? renderSentinel('start') : '';
        const endSentinel = active ? renderSentinel('end') : '';
        return x(_t2$9 || (_t2$9 = _$j`
      <div part="ce-header-menu-trigger-container" class="${0}">
        ${0}${0}${0}
      </div>
    `), classes, startSentinel, _superPropGet$d(C4DMastheadMenuButton, "render", this, 3)([]), endSentinel);
      }

      /**
       * The name of the custom event fired after the seach is toggled.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggleSearch",
      value: function () {
        return `${c4dPrefix$m}-search-with-typeahead-toggled`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, HostListenerMixin(CDSHeaderMenuButton));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$5 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2zM26 30H24V25a5 5 0 00-5-5H13a5 5 0 00-5 5v5H6V25a7 7 0 017-7h6a7 7 0 017 7z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$4 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<circle cx="26" cy="16" r="4"></circle><path d="M22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"></path></svg>`;

let _$i = t => t,
  _t$i;
function ownKeys$3(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$3(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$3(Object(t), !0).forEach(function (r) { _defineProperty$3(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$3(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$3(e, r, t) { return (r = _toPropertyKey$l(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$l(e, r, t, i) { var o = _getDecoratorsApi$l(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$l(s.d.map(_createElementDescriptor$l)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$l() { _getDecoratorsApi$l = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$l(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$l(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$l(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$l(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$l(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$l(e) { var r, t = _toPropertyKey$l(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$l(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$l(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$l(o.descriptor) || _isDataDescriptor$l(i.descriptor)) { if (_hasDecorators$l(o) || _hasDecorators$l(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$l(o)) { if (_hasDecorators$l(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$l(o, i); } } else r.push(o); } return r; }
function _hasDecorators$l(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$l(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$l(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$l(t) { var i = _toPrimitive$l(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$l(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$l(r) { return _arrayWithHoles$l(r) || _iterableToArray$l(r) || _unsupportedIterableToArray$l(r) || _nonIterableRest$l(); }
function _nonIterableRest$l() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$l(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$l(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$l(r, a) : void 0; } }
function _arrayLikeToArray$l(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$l(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$l(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$b,
  stablePrefix: c4dPrefix$l
} = settings;

/**
 * The profile menu UI in the masthead.
 *
 * @element c4d-masthead-profile
 * @csspart profile-link - The masthead contact link. Usage: `c4d-masthead-contact::part(profile-link)`
 * @csspart header-menu - The header menu element. Usage: `c4d-masthead-contact::part(header-menu)`
 */
let C4DMastheadProfile = _decorate$l([carbonElement(`${c4dPrefix$l}-masthead-profile`)], function (_initialize, _HostListenerMixin) {
  class C4DMastheadProfile extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadProfile,
    d: [{
      kind: "field",
      decorators: [i$1('a')],
      key: "_trigger",
      value: void 0
    }, {
      kind: "method",
      key: "_handleClick",
      value:
      /**
       * The trigger button.
       */

      /**
       * Handles `click` event handler on this element.
       */
      function _handleClick() {
        this._handleUserInitiatedToggle();
      }

      /**
       * Handles user-initiated toggling the open state.
       *
       * @param [force] If specified, forces the open state to the given one.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedToggle",
      value: function _handleUserInitiatedToggle(force = !this.expanded) {
        this.expanded = force;
        if (!force) {
          this._trigger.focus();
        }
      }

      /**
       * Handles `blur` event handler on this element.
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusout')],
      key: "_handleBlur",
      value: function _handleBlur({
        relatedTarget
      }) {
        if (!this.contains(relatedTarget)) {
          this.expanded = false;
        }
      }

      /**
       * Handler for the `keydown` event.
       */
    }, {
      kind: "method",
      decorators: [HostListener('keydown')],
      key: "_handleKeydown",
      value: function _handleKeydown({
        key
      }) {
        if (key === 'Esc' || key === 'Escape') {
          this._handleUserInitiatedToggle(false);
        }
      }

      /**
       * `true` if the trigger button should show the UI of the authenticated state.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "authenticated",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "expanded",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-label'
      })],
      key: "menuLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'trigger-label'
      })],
      key: "triggerLabel",
      value() {
        return 'User profile';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * `true` if the menu should be expanded.
       */
      /**
       * The `aria-label` attribute for the menu UI.
       */
      /**
       * The `aria-label` attribute for the trigger button.
       */
      function render() {
        const {
          authenticated,
          expanded,
          menuLabel,
          triggerLabel,
          _handleClick: handleClick
        } = this;
        return x(_t$i || (_t$i = _$i`
      <a
        part="profile-link"
        role="button"
        tabindex="0"
        class="${0}--header__menu-item ${0}--header__menu-title"
        href="javascript:void 0"
        aria-expanded="${0}"
        aria-label="${0}"
        @click=${0}>
        ${0}
      </a>
      <ul
        class="${0}--header__menu"
        aria-label="${0}"
        part="header-menu">
        <slot></slot>
      </ul>
    `), prefix$b, prefix$b, String(Boolean(expanded)), l(triggerLabel), handleClick, authenticated ? svgResultCarbonIcon$4() : svgResultCarbonIcon$5(), prefix$b, l(menuLabel));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$l}--masthead-profile`;
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread$3(_objectSpread$3({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, HostListenerMixin(FocusMixin(StableSelectorMixin(s))));

let _$h = t => t,
  _t$h;
function _decorate$k(e, r, t, i) { var o = _getDecoratorsApi$k(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$k(s.d.map(_createElementDescriptor$k)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$k() { _getDecoratorsApi$k = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$k(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$k(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$k(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$k(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$k(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$k(e) { var r, t = _toPropertyKey$k(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$k(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$k(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$k(o.descriptor) || _isDataDescriptor$k(i.descriptor)) { if (_hasDecorators$k(o) || _hasDecorators$k(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$k(o)) { if (_hasDecorators$k(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$k(o, i); } } else r.push(o); } return r; }
function _hasDecorators$k(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$k(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$k(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$k(t) { var i = _toPrimitive$k(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$k(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$k(r) { return _arrayWithHoles$k(r) || _iterableToArray$k(r) || _unsupportedIterableToArray$k(r) || _nonIterableRest$k(); }
function _nonIterableRest$k() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$k(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$k(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$k(r, a) : void 0; } }
function _arrayLikeToArray$k(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$k(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$k(r) { if (Array.isArray(r)) return r; }
const {
  prefix: prefix$a,
  stablePrefix: c4dPrefix$k
} = settings;

/**
 * The contact button UI in the masthead.
 *
 * @element c4d-masthead-contact
 * @csspart contact-link -The masthead contact link. Usage `c4d-masthead-contact::part(contact-link)`
 */
_decorate$k([carbonElement(`${c4dPrefix$k}-masthead-contact`)], function (_initialize, _C4DMastheadProfile) {
  class C4DMastheadContact extends _C4DMastheadProfile {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadContact,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'trigger-label'
      })],
      key: "triggerLabel",
      value() {
        return 'Contact';
      }
    }, {
      kind: "field",
      decorators: [HostListener('document:cm-app-pane-displayed')],
      key: "_handleCMAppDisplayed",
      value() {
        return _event => {
          this.triggerLabel = 'Close contact window';
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener('document:cm-app-pane-hidden')],
      key: "_handleCMAppHidden",
      value() {
        return _event => {
          this.triggerLabel = 'Show contact window';
        };
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * The `aria-label` attribute for the trigger button.
       */

      /**
       * Handles cm-app-pane-displayed event fired by CM_APP.
       *
       * @see DOCUMENT_EVENTS live-advisor/cm-app/js/helpers/otherConstants.js
       *   - https://github.ibm.com/live-advisor/cm-app/blob/master/js/helpers/otherConstants.js
       */

      /**
       * Handles cm-app-pane-hidden event fired by CM_APP.
       *
       * @see DOCUMENT_EVENTS live-advisor/cm-app/js/helpers/otherConstants.js
       *   - https://github.ibm.com/live-advisor/cm-app/blob/master/js/helpers/otherConstants.js
       */

      function render() {
        const {
          triggerLabel,
          _handleClick: handleClick
        } = this;
        return x(_t$h || (_t$h = _$h`
      <a
        part="contact-link"
        href="javascript:void 0"
        class="${0}--header__menu-item ${0}--header__menu-title"
        aria-label="${0}"
        @click=${0}>
        ${0}
      </a>
    `), prefix$a, prefix$a, l(triggerLabel), handleClick, svgResultCarbonIcon$o());
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, C4DMastheadProfile);

let _$g = t => t,
  _t$g;
function _decorate$j(e, r, t, i) { var o = _getDecoratorsApi$j(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$j(s.d.map(_createElementDescriptor$j)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$j() { _getDecoratorsApi$j = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$j(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$j(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$j(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$j(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$j(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$j(e) { var r, t = _toPropertyKey$j(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$j(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$j(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$j(o.descriptor) || _isDataDescriptor$j(i.descriptor)) { if (_hasDecorators$j(o) || _hasDecorators$j(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$j(o)) { if (_hasDecorators$j(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$j(o, i); } } else r.push(o); } return r; }
function _hasDecorators$j(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$j(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$j(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$j(t) { var i = _toPrimitive$j(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$j(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$j(r) { return _arrayWithHoles$j(r) || _iterableToArray$j(r) || _unsupportedIterableToArray$j(r) || _nonIterableRest$j(); }
function _nonIterableRest$j() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$j(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$j(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$j(r, a) : void 0; } }
function _arrayLikeToArray$j(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$j(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$j(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$j
} = settings;

/**
 * The action bar in masthead.
 *
 * @element c4d-masthead-global-bar
 * @csspart container -The ce header global container. Usage `c4d-masthead-global-bar::part(container)`
 */
_decorate$j([carbonElement(`${c4dPrefix$j}-masthead-global-bar`)], function (_initialize, _FocusMixin) {
  class C4DMastheadGlobalBar extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadGlobalBar,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'has-search-active',
        type: Boolean,
        reflect: true
      })],
      key: "_hasSearchActive",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventToggleSearch')],
      key: "_handleSearchToggle",
      value() {
        return event => {
          if (event.detail.active !== undefined) {
            this._hasSearchActive = event.detail.active;
          }
        };
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'profile';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Search bar opened flag.
       */

      /**
       * Handles toggle event from the search component.
       *
       * @param event The event.
       */

      /**
       * The shadow slot this action bar should be in.
       */

      function render() {
        const {
          _hasSearchActive: hasSearchActive
        } = this;
        const classes = o$2({
          [`${c4dPrefix$j}-ce--header__global__container`]: true,
          [`${c4dPrefix$j}-ce--header__global__container--has-search-active`]: hasSearchActive
        });
        return x(_t$g || (_t$g = _$g`
      <div part="container" class="${0}">
        <slot></slot>
      </div>
    `), classes);
      }

      /**
       * The name of the custom event fired after the seach is toggled.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggleSearch",
      value: function () {
        return `${c4dPrefix$j}-search-with-typeahead-toggled`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$j}--masthead-global-bar`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, FocusMixin(HostListenerMixin(StableSelectorMixin(s))));

let _$f = t => t,
  _t$f;

/**
 * Header nav item.
 *
 * @element cds-header-nav-item
 * @csspart link The link.
 * @csspart title The title.
 */
let CDSHeaderNavItem = _decorate$Z([carbonElement(`${prefix$B}-header-nav-item`)], function (_initialize, _FocusMixin) {
  class CDSHeaderNavItem extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSHeaderNavItem,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "rel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "target",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "title",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'is-active'
      })],
      key: "isActive",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        attribute: 'aria-current'
      })],
      key: "ariaCurrent",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "role",
      value() {
        return 'listitem';
      }
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Link `href`.
       */

      /**
       * The link type.
       */

      /**
       * The link target.
       */

      /**
       * The title.
       */

      /**
       * Applies selected styles to the item if a user sets this to true and `aria-current !== 'page'`.
       */

      /**
       * indicates that this element represents the current item
       */

      /**
       * As child of <ul>, this element must have role of listitem
       */

      function render() {
        const {
          ariaCurrent,
          href,
          isActive,
          title,
          rel,
          target
        } = this;
        const linkClass = o$2({
          [`${prefix$B}--header__menu-item`]: true,
          [`${prefix$B}--header__menu-item--current`]: isActive && ariaCurrent !== 'page'
        });
        return x(_t$f || (_t$f = _$f`
      <a
        part="link"
        class="${0}"
        tabindex="0"
        href="${0}"
        rel="${0}"
        target="${0}">
        <span part="title" class="${0}--text-truncate--end"
          ><slot>${0}</slot></span
        >
      </a>
    `), linkClass, l(href), l(rel), l(target), prefix$B, title);
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$5;
      }
    }]
  };
}, FocusMixin(s));

/**
 * Header submenu item.
 *
 * @element cds-header-menu-item
 */
let CDSHeaderMenuItem = _decorate$Z([carbonElement(`${prefix$B}-header-menu-item`)], function (_initialize, _CDSHeaderNavItem) {
  class CDSHeaderMenuItem extends _CDSHeaderNavItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSHeaderMenuItem,
    d: []
  };
}, CDSHeaderNavItem);

function _decorate$i(e, r, t, i) { var o = _getDecoratorsApi$i(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$i(s.d.map(_createElementDescriptor$i)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$i() { _getDecoratorsApi$i = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$i(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$i(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$i(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$i(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$i(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$i(e) { var r, t = _toPropertyKey$i(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$i(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$i(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$i(o.descriptor) || _isDataDescriptor$i(i.descriptor)) { if (_hasDecorators$i(o) || _hasDecorators$i(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$i(o)) { if (_hasDecorators$i(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$i(o, i); } } else r.push(o); } return r; }
function _hasDecorators$i(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$i(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$i(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$i(t) { var i = _toPrimitive$i(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$i(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$i(r) { return _arrayWithHoles$i(r) || _iterableToArray$i(r) || _unsupportedIterableToArray$i(r) || _nonIterableRest$i(); }
function _nonIterableRest$i() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$i(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$i(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$i(r, a) : void 0; } }
function _arrayLikeToArray$i(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$i(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$i(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$i
} = settings;

/**
 * Profile menu item in masthead.
 *
 * @element c4d-masthead-profile-item
 */
_decorate$i([carbonElement(`${c4dPrefix$i}-masthead-profile-item`)], function (_initialize, _CDSHeaderMenuItem) {
  class C4DMastheadProfileItem extends _CDSHeaderMenuItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadProfileItem,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$shadowRoot;
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
      }
    }]
  };
}, CDSHeaderMenuItem);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$3 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<circle cx="10" cy="28" r="2"></circle><circle cx="24" cy="28" r="2"></circle><path d="M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"></path></svg>`;

var _cookieName = 'activeCartId';
var SAPCommerceAPI = /*#__PURE__*/function () {
  function SAPCommerceAPI() {
    _classCallCheck$2(this, SAPCommerceAPI);
  }
  return _createClass$2(SAPCommerceAPI, null, [{
    key: "hasActiveCart",
    value:
    /**
     * Check if the user has an active cart by looking for the non-empty cookie.
     *
     * @returns {boolean}
     */
    function hasActiveCart() {
      var activeCartId = SAPCommerceAPI.getActiveCartId();
      // Return true if the activeCartId cookie is non-empty.
      return activeCartId !== '';
    }

    /**
     * Returns the active cart id.
     *
     * @returns {string}
     *   The active cart id if there is one, otherwise empty string.
     */
  }, {
    key: "getActiveCartId",
    value: function getActiveCartId() {
      var activeCartId = Cookies.get(_cookieName);
      return activeCartId && typeof activeCartId === 'string' ? activeCartId.trim() : '';
    }

    /**
     * Set the active cart id.
     *
     * @param {string} activeCartId
     *   The active cart id.
     */
  }, {
    key: "setActiveCartId",
    value: function setActiveCartId(activeCartId) {
      Cookies.set(_cookieName, activeCartId.trim());
    }

    /**
     * Remove the active cart id.
     */
  }, {
    key: "removeActiveCartId",
    value: function removeActiveCartId() {
      Cookies.remove(_cookieName);
    }
  }]);
}();

let _$e = t => t,
  _t$e;
function _decorate$h(e, r, t, i) { var o = _getDecoratorsApi$h(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$h(s.d.map(_createElementDescriptor$h)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$h() { _getDecoratorsApi$h = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$h(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$h(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$h(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$h(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$h(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$h(e) { var r, t = _toPropertyKey$h(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$h(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$h(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$h(o.descriptor) || _isDataDescriptor$h(i.descriptor)) { if (_hasDecorators$h(o) || _hasDecorators$h(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$h(o)) { if (_hasDecorators$h(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$h(o, i); } } else r.push(o); } return r; }
function _hasDecorators$h(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$h(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$h(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$h(t) { var i = _toPrimitive$h(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$h(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$h(r) { return _arrayWithHoles$h(r) || _iterableToArray$h(r) || _unsupportedIterableToArray$h(r) || _nonIterableRest$h(); }
function _nonIterableRest$h() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$h(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$h(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$h(r, a) : void 0; } }
function _arrayLikeToArray$h(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$h(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$h(r) { if (Array.isArray(r)) return r; }
function _superPropGet$c(t, e, r, o) { var p = _get$a(_getPrototypeOf$a(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$a() { return _get$a = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$a(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$a.apply(null, arguments); }
function _superPropBase$a(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$a(t));); return t; }
function _getPrototypeOf$a(t) { return _getPrototypeOf$a = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$a(t); }
const {
  prefix: prefix$9,
  stablePrefix: c4dPrefix$h
} = settings;

/**
 * The Cart icon in the masthead.
 *
 * @element c4d-masthead-cart
 * @csspart cart-link - The masthead cart link. Usage: `c4d-masthead-cart::part(cart-link)`
 */
_decorate$h([carbonElement(`${c4dPrefix$h}-masthead-cart`)], function (_initialize, _StableSelectorMixin) {
  class C4DMastheadCart extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadCart,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'link-label'
      })],
      key: "linkLabel",
      value() {
        return 'Cart';
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "hasActiveCart",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "locale",
      value() {
        return {
          lc: 'en',
          cc: 'us'
        };
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The `aria-label` attribute for the link.
       */

      /**
       * Tracks whether the user has an active cart to control the display.
       */

      /**
       * Store the locale. Defaults to en-us.
       */

      function connectedCallback() {
        _superPropGet$c(C4DMastheadCart, "connectedCallback", this, 3)([]);
        // Check the relevant cookie for whether the user has an active cart.
        this.hasActiveCart = SAPCommerceAPI.hasActiveCart();
        // Fetch the locale for the page.
        LocaleAPI.getLocale().then(locale => {
          this.locale = locale;
        });
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet$c(C4DMastheadCart, "updated", this, 3)([changedProperties]);
        const {
          hasActiveCart
        } = this;
        if (changedProperties.has('hasActiveCart')) {
          this.hidden = !hasActiveCart;
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          linkLabel,
          locale: {
            cc,
            lc
          }
        } = this;
        return x(_t$e || (_t$e = _$e`
      <a
        part="cart-link"
        href="/store/${0}/${0}/checkout"
        class="${0}--header__menu-item ${0}--header__menu-title"
        aria-label="${0}"
        >${0}</a
      >
    `), lc, cc, prefix$9, prefix$9, linkLabel, svgResultCarbonIcon$3());
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$h}--masthead-cart`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(s));

let _$d = t => t,
  _t$d;
function ownKeys$2(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$2(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$2(Object(t), !0).forEach(function (r) { _defineProperty$2(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$2(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$2(e, r, t) { return (r = _toPropertyKey$g(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$g(e, r, t, i) { var o = _getDecoratorsApi$g(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$g(s.d.map(_createElementDescriptor$g)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$g() { _getDecoratorsApi$g = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$g(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$g(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$g(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$g(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$g(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$g(e) { var r, t = _toPropertyKey$g(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$g(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$g(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$g(o.descriptor) || _isDataDescriptor$g(i.descriptor)) { if (_hasDecorators$g(o) || _hasDecorators$g(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$g(o)) { if (_hasDecorators$g(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$g(o, i); } } else r.push(o); } return r; }
function _hasDecorators$g(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$g(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$g(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$g(t) { var i = _toPrimitive$g(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$g(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$g(r) { return _arrayWithHoles$g(r) || _iterableToArray$g(r) || _unsupportedIterableToArray$g(r) || _nonIterableRest$g(); }
function _nonIterableRest$g() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$g(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$g(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$g(r, a) : void 0; } }
function _arrayLikeToArray$g(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$g(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$g(r) { if (Array.isArray(r)) return r; }
function _superPropGet$b(t, e, r, o) { var p = _get$9(_getPrototypeOf$9(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$9() { return _get$9 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$9(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$9.apply(null, arguments); }
function _superPropBase$9(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$9(t));); return t; }
function _getPrototypeOf$9(t) { return _getPrototypeOf$9 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$9(t); }
const {
  prefix: prefix$8,
  stablePrefix: c4dPrefix$g
} = settings;

/**
 * MegaMenu
 *
 * @element c4d-megamenu
 * @csspart container - The masthead megamenu container. Usage: c4d-megamenu::part(container)
 * @csspart container-row - The masthead megamenu container row. Usage: c4d-megamenu::part(container-row)
 */
let C4DMegaMenu = _decorate$g([carbonElement(`${c4dPrefix$g}-megamenu`)], function (_initialize, _StableSelectorMixin) {
  class C4DMegaMenu extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenu,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "layout",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        type: Boolean
      })],
      key: "overflowing",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "mutationObserver",
      value() {
        return new MutationObserver(this._setOverflowing.bind(this));
      }
    }, {
      kind: "field",
      key: "resizeObserver",
      value() {
        return new ResizeObserver(this._setOverflowing.bind(this));
      }
    }, {
      kind: "method",
      key: "_setOverflowing",
      value:
      /**
       * Determine if any navigation columns are taller than megamenu.
       */
      function _setOverflowing() {
        const {
          navLeftSelector,
          navRightSelector,
          navColumnInnerSelector
        } = this.constructor;
        const navColumns = this.querySelectorAll(`
      ${navLeftSelector},
      ${this.layout === MEGAMENU_LAYOUT_SCHEME.TAB ? `[role="tabpanel"] > ${navRightSelector}` : navRightSelector}
    `);
        const columnHeights = [];
        navColumns.forEach(column => {
          var _column$shadowRoot;
          const height = navColumnInnerSelector ? (_column$shadowRoot = column.shadowRoot) === null || _column$shadowRoot === void 0 || (_column$shadowRoot = _column$shadowRoot.querySelector(navColumnInnerSelector)) === null || _column$shadowRoot === void 0 ? void 0 : _column$shadowRoot.scrollHeight : column.scrollHeight;
          columnHeights.push(height);
        });
        this.overflowing = columnHeights.some(height => height ? height > this.scrollHeight : false);
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        const sharedOptions = {
          childList: true,
          subtree: true,
          attributes: true
        };
        const options = this.layout === MEGAMENU_LAYOUT_SCHEME.TAB ? _objectSpread$2(_objectSpread$2({}, sharedOptions), {}, {
          attributeFilter: ['selected']
        }) : sharedOptions;
        this.mutationObserver.observe(this, options);
        this.resizeObserver.observe(this);
        _superPropGet$b(C4DMegaMenu, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.mutationObserver.disconnect();
        this.resizeObserver.disconnect();
        _superPropGet$b(C4DMegaMenu, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$d || (_t$d = _$d`
      <div part="container" class="${0}--masthead__megamenu__container">
        <div
          part="container-row"
          class="${0}--masthead__megamenu__container--row ${0}--masthead__megamenu__container--row--${0}">
          <slot></slot>
        </div>
      </div>
    `), prefix$8, prefix$8, prefix$8, this.layout);
      }
    }, {
      kind: "get",
      static: true,
      key: "navLeftSelector",
      value: function () {
        return `${c4dPrefix$g}-megamenu-left-navigation`;
      }
    }, {
      kind: "get",
      static: true,
      key: "navRightSelector",
      value: function () {
        return `${c4dPrefix$g}-megamenu-right-navigation`;
      }
    }, {
      kind: "get",
      static: true,
      key: "navColumnInnerSelector",
      value: function () {
        return `.${prefix$8}--masthead__megamenu-container-inner`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$g}--masthead__megamenu`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(s));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$2 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="24" height="24" viewBox="0 0 24 24">${children}<path d="M14 4L12.9 5.1 18.9 11.2 2 11.2 2 12.8 18.9 12.8 12.9 18.9 14 20 22 12z"></path></svg>`;

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon$1 = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="24" height="24" viewBox="0 0 32 32">${children}<path d="M14 26L15.41 24.59 7.83 17 28 17 28 15 7.83 15 15.41 7.41 14 6 4 16 14 26z"></path></svg>`;

let _$c = t => t,
  _t$c,
  _t2$8,
  _t3$3,
  _t4$2,
  _t5$2,
  _t6$2,
  _t7$2,
  _t8$2;
function _decorate$f(e, r, t, i) { var o = _getDecoratorsApi$f(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$f(s.d.map(_createElementDescriptor$f)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$f() { _getDecoratorsApi$f = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$f(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$f(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$f(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$f(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$f(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$f(e) { var r, t = _toPropertyKey$f(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$f(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$f(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$f(o.descriptor) || _isDataDescriptor$f(i.descriptor)) { if (_hasDecorators$f(o) || _hasDecorators$f(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$f(o)) { if (_hasDecorators$f(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$f(o, i); } } else r.push(o); } return r; }
function _hasDecorators$f(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$f(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$f(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$f(t) { var i = _toPrimitive$f(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$f(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$f(r) { return _arrayWithHoles$f(r) || _iterableToArray$f(r) || _unsupportedIterableToArray$f(r) || _nonIterableRest$f(); }
function _nonIterableRest$f() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$f(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$f(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$f(r, a) : void 0; } }
function _arrayLikeToArray$f(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$f(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$f(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$f
} = settings;

/**
 * MegaMenu Heading.
 *
 * @element c4d-megamenu-heading
 * @csspart heading-link - The link element of the megamenu heading. Usage: `c4d-megamenu-heading::part(heading-link)`
 * @csspart heading-h2 - The h2 element of the megamenu heading. Usage: `c4d-megamenu-heading::part(heading-h2)`
 * @csspart heading-h3 - The h3 element of the megamenu heading. Usage: `c4d-megamenu-heading::part(heading-h3)`
 * @csspart heading-h4 - The h4 element of the megamenu heading. Usage: `c4d-megamenu-heading::part(heading-h4)`
 * @csspart heading-h5 - The h5 element of the megamenu heading. Usage: `c4d-megamenu-heading::part(heading-h5)`
 * @csspart heading-h6 - The h6 element of the megamenu heading. Usage: `c4d-megamenu-heading::part(heading-h6)`
 * @csspart heading-span - The span element containing slotted content. Usage: `c4d-megamenu-heading::part(heading-span)`
 * @csspart l0-heading-arrow -  Targets the heading arrow icon. Usage: `c4d-megamenu-heading::part(l0-heading-arrow)`
 */
let C4DMegaMenuHeading = _decorate$f([carbonElement(`${c4dPrefix$f}-megamenu-heading`)], function (_initialize, _HostListenerMixin) {
  class C4DMegaMenuHeading extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMegaMenuHeading,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "href",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "title",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        type: Number,
        attribute: 'heading-level'
      })],
      key: "headingLevel",
      value() {
        return 2;
      }
    }, {
      kind: "get",
      key: "_arrowIcon",
      value:
      /**
       * Megamenu heading href.
       */

      /**
       * Megamenu heading text.
       */

      /**
       * Arrow icon to use when presented as link.
       */
      function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? svgResultCarbonIcon$1({
          part: 'l0-heading-arrow'
        }) : svgResultCarbonIcon$2({
          part: 'l0-heading-arrow'
        });
      }

      /**
       * Render heading as link.
       */
    }, {
      kind: "method",
      key: "renderLink",
      value: function renderLink() {
        const {
          _arrowIcon
        } = this;
        return x(_t$c || (_t$c = _$c`
      <a
        part="heading-link"
        href="${0}"
        data-attribute1="headerNav"
        data-attribute2="FlatHdline"
        data-attribute3="${0}">
        ${0} ${0}
      </a>
    `), this.href, this.title, this.title, _arrowIcon);
      }

      /**
       * Render heading as plain text.
       */
    }, {
      kind: "method",
      key: "renderPlain",
      value: function renderPlain() {
        return x(_t2$8 || (_t2$8 = _$c` ${0} `), this.title);
      }

      /**
       * Render heading markup.
       */
    }, {
      kind: "method",
      key: "renderHeading",
      value: function renderHeading() {
        const {
          headingLevel
        } = this;
        const hasHref = Boolean(this.href);
        switch (headingLevel) {
          case 3:
            return x(_t3$3 || (_t3$3 = _$c`
          <h3 part="heading-h3" ?data-has-href="${0}">
            ${0}
          </h3>
        `), hasHref, this.renderHeadingInner());
          case 4:
            return x(_t4$2 || (_t4$2 = _$c`
          <h4 part="heading-h4" ?data-has-href="${0}">
            ${0}
          </h4>
        `), hasHref, this.renderHeadingInner());
          case 5:
            return x(_t5$2 || (_t5$2 = _$c`
          <h5 part="heading-h5" ?data-has-href="${0}">
            ${0}
          </h5>
        `), hasHref, this.renderHeadingInner());
          case 6:
            return x(_t6$2 || (_t6$2 = _$c`
          <h6 part="heading-h6" ?data-has-href="${0}">
            ${0}
          </h6>
        `), hasHref, this.renderHeadingInner());
          default:
            return x(_t7$2 || (_t7$2 = _$c`
          <h2 part="heading-h2" ?data-has-href="${0}">
            ${0}
          </h2>
        `), hasHref, this.renderHeadingInner());
        }
      }

      /**
       * Render inner heading contents as link or plain text.
       */
    }, {
      kind: "method",
      key: "renderHeadingInner",
      value: function renderHeadingInner() {
        return this.href ? this.renderLink() : this.renderPlain();
      }
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange(event) {
        const hasContent = event.target.assignedNodes().filter(child => {
          var _child$textContent;
          return child === null || child === void 0 || (_child$textContent = child.textContent) === null || _child$textContent === void 0 ? void 0 : _child$textContent.trim();
        }).length > 0;
        this.classList.toggle('has-content', hasContent);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t8$2 || (_t8$2 = _$c`
      ${0}
      <span part="heading-span">
        <slot @slotchange=${0}></slot>
      </span>
    `), this.renderHeading(), this._handleSlotChange);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, HostListenerMixin(s));

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var styles$2 = i$4([
  '.cds--layout--size-xs{--cds-layout-size-height-context:var(--cds-layout-size-height-xs, 1.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xs{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem))}.cds--layout-constraint--size__min-xs{--cds-layout-size-height-min:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout-constraint--size__max-xs{--cds-layout-size-height-max:var(--cds-layout-size-height-xs, 1.5rem)}.cds--layout--size-sm{--cds-layout-size-height-context:var(--cds-layout-size-height-sm, 2rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-sm{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem))}.cds--layout-constraint--size__min-sm{--cds-layout-size-height-min:var(--cds-layout-size-height-sm, 2rem)}.cds--layout-constraint--size__max-sm{--cds-layout-size-height-max:var(--cds-layout-size-height-sm, 2rem)}.cds--layout--size-md{--cds-layout-size-height-context:var(--cds-layout-size-height-md, 2.5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-md{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem))}.cds--layout-constraint--size__min-md{--cds-layout-size-height-min:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout-constraint--size__max-md{--cds-layout-size-height-max:var(--cds-layout-size-height-md, 2.5rem)}.cds--layout--size-lg{--cds-layout-size-height-context:var(--cds-layout-size-height-lg, 3rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-lg{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem))}.cds--layout-constraint--size__min-lg{--cds-layout-size-height-min:var(--cds-layout-size-height-lg, 3rem)}.cds--layout-constraint--size__max-lg{--cds-layout-size-height-max:var(--cds-layout-size-height-lg, 3rem)}.cds--layout--size-xl{--cds-layout-size-height-context:var(--cds-layout-size-height-xl, 4rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem))}.cds--layout-constraint--size__min-xl{--cds-layout-size-height-min:var(--cds-layout-size-height-xl, 4rem)}.cds--layout-constraint--size__max-xl{--cds-layout-size-height-max:var(--cds-layout-size-height-xl, 4rem)}.cds--layout--size-2xl{--cds-layout-size-height-context:var(--cds-layout-size-height-2xl, 5rem);--cds-layout-size-height:var(--cds-layout-size-height-context)}.cds--layout-constraint--size__default-2xl{--cds-layout-size-height:var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem))}.cds--layout-constraint--size__min-2xl{--cds-layout-size-height-min:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout-constraint--size__max-2xl{--cds-layout-size-height-max:var(--cds-layout-size-height-2xl, 5rem)}.cds--layout--density-condensed{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-condensed, 0.5rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-condensed{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem))}.cds--layout-constraint--density__min-condensed{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout-constraint--density__max-condensed{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-condensed, 0.5rem)}.cds--layout--density-normal{--cds-layout-density-padding-inline-context:var(--cds-layout-density-padding-inline-normal, 1rem);--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context)}.cds--layout-constraint--density__default-normal{--cds-layout-density-padding-inline:var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem))}.cds--layout-constraint--density__min-normal{--cds-layout-density-padding-inline-min:var(--cds-layout-density-padding-inline-normal, 1rem)}.cds--layout-constraint--density__max-normal{--cds-layout-density-padding-inline-max:var(--cds-layout-density-padding-inline-normal, 1rem)}:root{--cds-layout-size-height-xs:1.5rem;--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;--cds-layout-size-height-xl:4rem;--cds-layout-size-height-2xl:5rem;--cds-layout-size-height-min:0px;--cds-layout-size-height-max:999999999px;--cds-layout-density-padding-inline-condensed:0.5rem;--cds-layout-density-padding-inline-normal:1rem;--cds-layout-density-padding-inline-min:0px;--cds-layout-density-padding-inline-max:999999999px}:root{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-one{--cds-layer:var(--cds-layer-01, #f4f4f4);--cds-layer-active:var(--cds-layer-active-01, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-01, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-01, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-01, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-01, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-01, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-01, #a8a8a8);--cds-field:var(--cds-field-01, #f4f4f4);--cds-field-hover:var(--cds-field-hover-01, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-00, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-01, #c6c6c6);--cds-border-strong:var(--cds-border-strong-01, #8d8d8d);--cds-border-tile:var(--cds-border-tile-01, #c6c6c6)}.cds--layer-two{--cds-layer:var(--cds-layer-02, #ffffff);--cds-layer-active:var(--cds-layer-active-02, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-02, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-02, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-02, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-02, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-02, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-02, #a8a8a8);--cds-field:var(--cds-field-02, #ffffff);--cds-field-hover:var(--cds-field-hover-02, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-01, #c6c6c6);--cds-border-subtle-selected:var(--cds-border-subtle-selected-02, #c6c6c6);--cds-border-strong:var(--cds-border-strong-02, #8d8d8d);--cds-border-tile:var(--cds-border-tile-02, #a8a8a8)}.cds--layer-three{--cds-layer:var(--cds-layer-03, #f4f4f4);--cds-layer-active:var(--cds-layer-active-03, #c6c6c6);--cds-layer-hover:var(--cds-layer-hover-03, #e8e8e8);--cds-layer-selected:var(--cds-layer-selected-03, #e0e0e0);--cds-layer-selected-hover:var(--cds-layer-selected-hover-03, #d1d1d1);--cds-layer-accent:var(--cds-layer-accent-03, #e0e0e0);--cds-layer-accent-hover:var(--cds-layer-accent-hover-03, #d1d1d1);--cds-layer-accent-active:var(--cds-layer-accent-active-03, #a8a8a8);--cds-field:var(--cds-field-03, #f4f4f4);--cds-field-hover:var(--cds-field-hover-03, #e8e8e8);--cds-border-subtle:var(--cds-border-subtle-02, #e0e0e0);--cds-border-subtle-selected:var(--cds-border-subtle-selected-03, #c6c6c6);--cds-border-strong:var(--cds-border-strong-03, #8d8d8d);--cds-border-tile:var(--cds-border-tile-03, #c6c6c6)}@keyframes cds--hide-feedback{0%{opacity:1;visibility:inherit}100%{opacity:0;visibility:hidden}}@keyframes cds--show-feedback{0%{opacity:0;visibility:hidden}100%{opacity:1;visibility:inherit}}@keyframes cds--skeleton{0%{opacity:.3;transform:scaleX(0);transform-origin:left}20%{opacity:1;transform:scaleX(1);transform-origin:left}28%{transform:scaleX(1);transform-origin:right}51%{transform:scaleX(0);transform-origin:right}58%{transform:scaleX(0);transform-origin:right}82%{transform:scaleX(1);transform-origin:right}83%{transform:scaleX(1);transform-origin:left}96%{transform:scaleX(0);transform-origin:left}100%{opacity:.3;transform:scaleX(0);transform-origin:left}}.cds--assistive-text,.cds--visually-hidden{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--popover-container{display:inline-block}.cds--popover-container:not(.cds--popover--auto-align){position:relative}.cds--popover--high-contrast .cds--popover{--cds-popover-background-color:var(--cds-background-inverse, #393939);--cds-popover-text-color:var(--cds-text-inverse, #ffffff)}.cds--popover--drop-shadow .cds--popover{--cds-popover-drop-shadow:drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2))}.cds--popover--caret{--cds-popover-offset:0.625rem}.cds--popover{position:absolute;z-index:6000;filter:var(--cds-popover-drop-shadow, none);inset:0;pointer-events:none}.cds--popover-content{--cds-layout-size-height-sm:2rem;--cds-layout-size-height-md:2.5rem;--cds-layout-size-height-lg:3rem;box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:absolute;z-index:6000;display:none;border-radius:var(--cds-popover-border-radius,2px);background-color:var(--cds-popover-background-color,var(--cds-layer));color:var(--cds-popover-text-color,var(--cds-text-primary,#161616));inline-size:-moz-max-content;inline-size:max-content;max-inline-size:23rem;pointer-events:auto}.cds--layout--size-sm .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-sm)}.cds--layout--size-md .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-md)}.cds--layout--size-lg .cds--popover-content{--cds-layout-size-height:var(--cds-layout-size-height-lg)}.cds--popover-content *,.cds--popover-content ::after,.cds--popover-content ::before{box-sizing:inherit}.cds--popover--open>.cds--popover>.cds--popover-content{display:block}.cds--popover-content::before{position:absolute;display:none;content:""}.cds--popover--open>.cds--popover>.cds--popover-content::before{display:block}.cds--popover--auto-align.cds--popover-caret,.cds--popover-caret{position:absolute;z-index:6000;display:none;background-color:var(--cds-popover-background-color,var(--cds-layer));will-change:transform}.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-caret{display:block}.cds--popover--auto-align.cds--popover--caret.cds--popover--open>.cds--popover>.cds--popover-content>.cds--popover-caret{display:block}.cds--popover--tab-tip>.cds--popover>.cds--popover-caret{display:none}.cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(100% + var(--cds-popover-offset,0)))}.cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(100% + var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--bottom-end>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-left>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-right>.cds--popover>.cds--popover-content::before,.cds--popover--bottom-start>.cds--popover>.cds--popover-content::before,.cds--popover--bottom>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-start:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(-100%)}.cds--popover--bottom-end>.cds--popover>.cds--popover-caret,.cds--popover--bottom-left>.cds--popover>.cds--popover-caret,.cds--popover--bottom-right>.cds--popover>.cds--popover-caret,.cds--popover--bottom-start>.cds--popover>.cds--popover-caret,.cds--popover--bottom>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-end:0;inset-inline-start:50%;transform:translate(-50%,var(--cds-popover-offset,0))}[dir=rtl] .cds--popover--bottom-end>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-left>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-right>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom-start>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--bottom>.cds--popover>.cds--popover-caret{transform:translate(50%,var(--cds-popover-offset,0))}.cds--popover--bottom-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 100%,50% 0,100% 100%);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{transform:translate(50%,calc(-100% - var(--cds-popover-offset,0)))}.cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-start:0;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:0;inset-inline-start:initial}.cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:0;inset-inline-end:0;transform:translate(var(--cds-popover-offset,0),calc(-100% - var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-start:0}.cds--popover--top-end>.cds--popover>.cds--popover-content::before,.cds--popover--top-left>.cds--popover>.cds--popover-content::before,.cds--popover--top-right>.cds--popover>.cds--popover-content::before,.cds--popover--top-start>.cds--popover>.cds--popover-content::before,.cds--popover--top>.cds--popover>.cds--popover-content::before{block-size:var(--cds-popover-offset,0);inset-block-end:0;inset-inline-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--popover--top-end>.cds--popover>.cds--popover-caret,.cds--popover--top-left>.cds--popover>.cds--popover-caret,.cds--popover--top-right>.cds--popover>.cds--popover-caret,.cds--popover--top-start>.cds--popover>.cds--popover-caret,.cds--popover--top>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem);inset-block-start:0;inset-inline-start:50%;transform:translate(-50%,calc(-1 * var(--cds-popover-offset,0)))}[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{transform:translate(50%,calc(-1 * var(--cds-popover-offset,0)))}.cds--popover--top-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-height,.375rem);clip-path:polygon(0 0,50% 100%,100% 0);inline-size:var(--cds-popover-caret-width,.75rem)}.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),-50%)}.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) * -1 - 16px))}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-start:100%;transform:translate(var(--cds-popover-offset,0),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--right-end>.cds--popover>.cds--popover-content::before,.cds--popover--right-start>.cds--popover>.cds--popover-content::before,.cds--popover--right-top>.cds--popover>.cds--popover-content::before,.cds--popover--right>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-start:0;transform:translateX(-100%)}.cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-start:100%;transform:translate(calc(var(--cds-popover-offset,0) - 100%),-50%)}[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:100%;inset-inline-start:initial}.cds--popover--right-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--right.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 50%,100% 0,100% 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + .1px),-50%)}.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(-.5 * var(--cds-popover-offset,0) - 16px))}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-block-end:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0)),calc(.5 * var(--cds-popover-offset,0) + 16px))}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-content{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom>.cds--popover>.cds--popover-content::before,.cds--popover--left-end>.cds--popover>.cds--popover-content::before,.cds--popover--left-start>.cds--popover>.cds--popover-content::before,.cds--popover--left-top>.cds--popover>.cds--popover-content::before,.cds--popover--left>.cds--popover>.cds--popover-content::before{inline-size:var(--cds-popover-offset,0);inset-block-end:0;inset-block-start:0;inset-inline-end:0;transform:translateX(100%)}.cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,.cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem);inset-block-start:50%;inset-inline-end:100%;transform:translate(calc(-1 * var(--cds-popover-offset,0) + 100%),-50%)}[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret,[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align)>.cds--popover>.cds--popover-caret{inset-inline-end:initial;inset-inline-start:100%}.cds--popover--left-bottom.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-end.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-start.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left-top.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret,.cds--popover--left.cds--popover--auto-align>.cds--popover>.cds--popover-content>.cds--popover-caret{block-size:var(--cds-popover-caret-width,.75rem);clip-path:polygon(0 0,100% 50%,0 100%);inline-size:var(--cds-popover-caret-height,.375rem)}.cds--popover--tab-tip>.cds--popover>.cds--popover-content{border-radius:0}.cds--popover--tab-tip .cds--popover{will-change:filter}.cds--popover--tab-tip__button{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;position:relative;display:inline-flex;align-items:center;justify-content:center;block-size:2rem;inline-size:2rem}.cds--popover--tab-tip__button *,.cds--popover--tab-tip__button ::after,.cds--popover--tab-tip__button ::before{box-sizing:inherit}.cds--popover--tab-tip__button::-moz-focus-inner{border:0}.cds--popover--tab-tip__button:focus{outline:2px solid var(--cds-focus,#0f62fe);outline-offset:-2px}@media screen and (prefers-contrast){.cds--popover--tab-tip__button:focus{outline-style:dotted}}.cds--popover--tab-tip__button:hover{background-color:var(--cds-layer-hover)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button{background:var(--cds-layer);box-shadow:0 2px 2px rgba(0,0,0,.2)}.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after{position:absolute;z-index:6001;background:var(--cds-layer);block-size:2px;content:"";inline-size:100%;inset-block-end:0}.cds--popover--tab-tip__button svg{fill:var(--cds-icon-primary,#161616)}.cds--tooltip{--cds-popover-offset:12px}.cds--tooltip-content{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:var(--cds-tooltip-padding-block,1rem) var(--cds-tooltip-padding-inline,1rem);color:var(--cds-text-inverse,#fff);max-inline-size:18rem}.cds--icon-tooltip{--cds-tooltip-padding-block:0.125rem;--cds-popover-caret-width:0.5rem;--cds-popover-caret-height:0.25rem;--cds-popover-offset:0.5rem}.cds--icon-tooltip .cds--tooltip-content{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px)}.cds--definition-term{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;border-radius:0;border-block-end:1px dotted var(--cds-border-strong);color:var(--cds-text-primary,#161616)}.cds--definition-term *,.cds--definition-term ::after,.cds--definition-term ::before{box-sizing:inherit}.cds--definition-term::-moz-focus-inner{border:0}.cds--definition-term:focus{outline:1px solid var(--cds-focus,#0f62fe);border-block-end-color:var(--cds-border-interactive,#0f62fe)}@media screen and (prefers-contrast){.cds--definition-term:focus{outline-style:dotted}}.cds--definition-term:hover{border-block-end-color:var(--cds-border-interactive,#0f62fe)}.cds--definition-tooltip{font-size:var(--cds-body-01-font-size,.875rem);font-weight:var(--cds-body-01-font-weight,400);line-height:var(--cds-body-01-line-height,1.42857);letter-spacing:var(--cds-body-01-letter-spacing,.16px);padding:.5rem 1rem;max-inline-size:11rem}.cds--btn{--cds-layout-size-height-local:clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));--cds-layout-density-padding-inline-local:clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));--temp-1lh:(\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );--temp-expressive-1lh:(\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );--temp-padding-block-max:calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);position:relative;display:inline-flex;flex-shrink:0;justify-content:space-between;border-radius:0;margin:0;cursor:pointer;inline-size:-moz-max-content;inline-size:max-content;max-inline-size:20rem;min-block-size:var(--cds-layout-size-height-local);outline:0;padding-block:min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - .0625rem,var(--temp-padding-block-max));padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - .0625rem);padding-inline-start:calc(var(--cds-layout-density-padding-inline-local) - .0625rem);text-align:start;text-decoration:none;transition:background 70ms cubic-bezier(0,0,.38,.9),box-shadow 70ms cubic-bezier(0,0,.38,.9),border-color 70ms cubic-bezier(0,0,.38,.9),outline 70ms cubic-bezier(0,0,.38,.9);vertical-align:top}.cds--btn *,.cds--btn ::after,.cds--btn ::before{box-sizing:inherit}.cds--btn.cds--btn--disabled,.cds--btn.cds--btn--disabled:focus,.cds--btn.cds--btn--disabled:hover,.cds--btn:disabled,.cds--btn:focus:disabled,.cds--btn:hover:disabled{border-color:var(--cds-button-disabled,#c6c6c6);background:var(--cds-button-disabled,#c6c6c6);box-shadow:none;color:var(--cds-text-on-color-disabled,#8d8d8d);cursor:not-allowed}.cds--btn .cds--btn__icon{position:absolute;flex-shrink:0;block-size:1rem;inline-size:1rem;inset-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max));inset-inline-end:var(--cds-layout-density-padding-inline-local);margin-block-start:.0625rem}.cds--btn::-moz-focus-inner{padding:0;border:0}.cds--btn--primary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-primary,#0f62fe);color:var(--cds-text-on-color,#fff)}.cds--btn--primary:hover{background-color:var(--cds-button-primary-hover,#0050e6)}.cds--btn--primary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--primary:active{background-color:var(--cds-button-primary-active,#002d9c)}.cds--btn--primary .cds--btn__icon,.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--primary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--secondary{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-secondary,#393939);color:var(--cds-text-on-color,#fff)}.cds--btn--secondary:hover{background-color:var(--cds-button-secondary-hover,#474747)}.cds--btn--secondary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--secondary:active{background-color:var(--cds-button-secondary-active,#6f6f6f)}.cds--btn--secondary .cds--btn__icon,.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--secondary:focus,.cds--btn--secondary:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-tertiary,#0f62fe);background-color:transparent;color:var(--cds-button-tertiary,#0f62fe)}.cds--btn--tertiary:hover{background-color:var(--cds-button-tertiary-hover,#0050e6)}.cds--btn--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--tertiary:active{background-color:var(--cds-button-tertiary-active,#002d9c)}.cds--btn--tertiary .cds--btn__icon,.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--tertiary:hover{color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:focus{background-color:var(--cds-button-tertiary,#0f62fe);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary:active{border-color:transparent;background-color:var(--cds-button-tertiary-active,#002d9c);color:var(--cds-text-inverse,#fff)}.cds--btn--tertiary.cds--btn--disabled,.cds--btn--tertiary.cds--btn--disabled:focus,.cds--btn--tertiary.cds--btn--disabled:hover,.cds--btn--tertiary:disabled,.cds--btn--tertiary:focus:disabled,.cds--btn--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-link-primary,#0f62fe);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--ghost:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--btn--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost .cds--btn__icon,.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--ghost:active,.cds--btn--ghost:hover{color:var(--cds-link-primary-hover,#0043ce)}.cds--btn--ghost:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--btn--ghost.cds--btn--disabled,.cds--btn--ghost.cds--btn--disabled:focus,.cds--btn--ghost.cds--btn--disabled:hover,.cds--btn--ghost:disabled,.cds--btn--ghost:focus:disabled,.cds--btn--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--ghost:not([disabled]) svg{fill:var(--cds-icon-primary,#161616)}.cds--btn--icon-only{justify-content:center;padding:0;block-size:var(--cds-layout-size-height-local);inline-size:var(--cds-layout-size-height-local);padding-block-start:min((var(--cds-layout-size-height-local) - 1rem) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only>:first-child{margin-block-start:.0625rem;min-inline-size:1rem}.cds--btn--icon-only .cds--btn__icon{position:static}.cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon{margin:0}.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon{margin-block-start:0}.cds--btn--icon-only.cds--btn--selected{background:var(--cds-background-selected,rgba(141,141,141,.2))}.cds--btn path[data-icon-path=inner-path]{fill:none}.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:var(--cds-icon-primary,#161616)}.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon{fill:var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn--ghost.cds--btn--icon-only[disabled]{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper{cursor:not-allowed}.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled]{pointer-events:none}.cds--btn--danger{border-width:1px;border-style:solid;border-color:transparent;background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger .cds--btn__icon,.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary{border-width:1px;border-style:solid;border-color:var(--cds-button-danger-secondary,#da1e28);background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28)}.cds--btn--danger--tertiary:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--tertiary:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--tertiary:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--tertiary .cds--btn__icon,.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--tertiary:hover{border-color:var(--cds-button-danger-hover,#b81921);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:focus{background-color:var(--cds-button-danger-primary,#da1e28);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary:active{border-color:var(--cds-button-danger-active,#750e13);background-color:var(--cds-button-danger-active,#750e13);color:var(--cds-text-on-color,#fff)}.cds--btn--danger--tertiary.cds--btn--disabled,.cds--btn--danger--tertiary.cds--btn--disabled:focus,.cds--btn--danger--tertiary.cds--btn--disabled:hover,.cds--btn--danger--tertiary:disabled,.cds--btn--danger--tertiary:focus:disabled,.cds--btn--danger--tertiary:hover:disabled{background:0 0;color:var(--cds-text-on-color-disabled,#8d8d8d);outline:0}.cds--btn--danger--ghost{border-width:1px;border-style:solid;border-color:transparent;background-color:transparent;color:var(--cds-button-danger-secondary,#da1e28);padding-inline-end:calc(var(--cds-layout-density-padding-inline-local) - .0625rem)}.cds--btn--danger--ghost:hover{background-color:var(--cds-button-danger-hover,#b81921)}.cds--btn--danger--ghost:focus{border-color:var(--cds-button-focus-color,var(--cds-focus,#0f62fe));box-shadow:inset 0 0 0 1px var(--cds-button-focus-color,var(--cds-focus,#0f62fe)),inset 0 0 0 2px var(--cds-background,#fff)}.cds--btn--danger--ghost:active{background-color:var(--cds-button-danger-active,#750e13)}.cds--btn--danger--ghost .cds--btn__icon,.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:currentColor}.cds--btn--danger--ghost .cds--btn__icon{position:static;margin-inline-start:.5rem}.cds--btn--danger--ghost:active,.cds--btn--danger--ghost:hover{color:var(--cds-text-on-color,#fff)}.cds--btn--danger--ghost.cds--btn--disabled,.cds--btn--danger--ghost.cds--btn--disabled:focus,.cds--btn--danger--ghost.cds--btn--disabled:hover,.cds--btn--danger--ghost:disabled,.cds--btn--danger--ghost:focus:disabled,.cds--btn--danger--ghost:hover:disabled{border-color:transparent;background:0 0;color:var(--cds-text-disabled,rgba(22,22,22,.25));outline:0}.cds--btn--expressive{font-size:var(--cds-body-compact-02-font-size,1rem);font-weight:var(--cds-body-compact-02-font-weight,400);line-height:var(--cds-body-compact-02-line-height,1.375);letter-spacing:var(--cds-body-compact-02-letter-spacing,0);padding-block:min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - .0625rem,var(--temp-padding-block-max))}.cds--btn--icon-only.cds--btn--expressive{padding:12px 13px}.cds--btn.cds--btn--expressive .cds--btn__icon{block-size:1.25rem;inline-size:1.25rem}.cds--btn-set .cds--btn.cds--btn--expressive{max-inline-size:20rem}.cds--btn.cds--skeleton{position:relative;padding:0;border:none;background:var(--cds-skeleton-background,#e8e8e8);box-shadow:none;pointer-events:none;inline-size:9.375rem}.cds--btn.cds--skeleton:active,.cds--btn.cds--skeleton:focus,.cds--btn.cds--skeleton:hover{border:none;cursor:default;outline:0}.cds--btn.cds--skeleton::before{position:absolute;animation:3s ease-in-out cds--skeleton infinite;background:var(--cds-skeleton-element,#c6c6c6);block-size:100%;content:"";inline-size:100%;will-change:transform-origin,transform,opacity}@media (prefers-reduced-motion:reduce){.cds--btn.cds--skeleton::before{animation:none}}.cds--btn-set{display:flex}.cds--btn-set--stacked{flex-direction:column}.cds--btn-set .cds--btn{inline-size:100%;max-inline-size:12.25rem}.cds--btn-set .cds--btn:not(:focus){box-shadow:-.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn:focus+.cds--btn{box-shadow:inherit}.cds--btn-set--stacked .cds--btn:not(:focus){box-shadow:0 -.0625rem 0 0 var(--cds-button-separator,#e0e0e0)}.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus){box-shadow:inherit}.cds--btn-set .cds--btn.cds--btn--disabled{box-shadow:-.0625rem 0 0 0 var(--cds-icon-on-color-disabled,#8d8d8d)}.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set--stacked .cds--btn.cds--btn--disabled{box-shadow:0 -.0625rem 0 0 var(--cds-layer-selected-disabled,#8d8d8d)}.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type{box-shadow:none}.cds--btn-set .cds--btn.cds--btn--loading{border-color:transparent;background-color:transparent;box-shadow:none}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn:focus{color:Highlight;outline:1px solid Highlight}}@media screen and (-ms-high-contrast:active),(forced-colors:active){.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]){fill:ButtonText}}[dir=rtl] .cds--btn-set .cds--btn:not(:focus){box-shadow:.0625rem 0 0 0 var(--cds-button-separator,#e0e0e0)}.cds--header{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;position:fixed;z-index:8000;display:flex;align-items:center;background-color:var(--cds-background,#fff);block-size:3rem;border-block-end:1px solid var(--cds-border-subtle);inset-block-start:0;inset-inline-end:0;inset-inline-start:0}.cds--header *,.cds--header ::after,.cds--header ::before{box-sizing:inherit}.cds--header__action{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:inline-block;padding:0;border:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;background:0 0;cursor:pointer;text-align:start;inline-size:100%;display:inline-flex;border:.0625rem solid transparent;block-size:3rem;inline-size:3rem;transition:background-color 110ms,border-color 110ms}.cds--header__action *,.cds--header__action ::after,.cds--header__action ::before{box-sizing:inherit}.cds--header__action::-moz-focus-inner{border:0}@media (max-width:41.98rem){.cds--header__action{min-inline-size:3rem}}.cds--header__global .cds--popover{z-index:8001}.cds--header__action>:first-child{margin-block-start:0}.cds--header__action--active>svg.cds--navigation-menu-panel-expand-icon,.cds--header__action>svg.cds--navigation-menu-panel-collapse-icon{display:none}.cds--header__action--active>svg.cds--navigation-menu-panel-collapse-icon{display:inline}.cds--header__action:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12))}.cds--header__action--active{background:var(--cds-layer);border-block-end:1px solid transparent;border-inline-end:1px solid var(--cds-border-subtle);border-inline-start:1px solid var(--cds-border-subtle)}.cds--header__action--active>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__action:focus{border-color:var(--cds-focus,#0f62fe);outline:0}.cds--header__action:active{background-color:var(--cds-background-active,rgba(141,141,141,.5))}.cds--header__action.cds--btn--icon-only{align-items:center;justify-content:center}.cds--btn.cds--btn--icon-only.cds--header__action svg{fill:var(--cds-icon-secondary,#525252)}.cds--btn.cds--btn--icon-only.cds--header__action--active svg,.cds--btn.cds--btn--icon-only.cds--header__action:active svg,.cds--btn.cds--btn--icon-only.cds--header__action:hover svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-trigger>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-trigger:hover>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-toggle{display:flex;align-items:center;justify-content:center}@media (min-width:66rem){.cds--header__menu-toggle__hidden{display:none}}a.cds--header__name{font-size:var(--cds-body-compact-01-font-size,.875rem);font-weight:var(--cds-body-compact-01-font-weight,400);line-height:var(--cds-body-compact-01-line-height,1.28572);letter-spacing:var(--cds-body-compact-01-letter-spacing,.16px);display:flex;align-items:center;padding:0 2rem 0 1rem;border:.125rem solid transparent;block-size:100%;font-weight:600;letter-spacing:.1px;line-height:1.25rem;outline:0;text-decoration:none;transition:border-color 110ms;-webkit-user-select:none;-moz-user-select:none;user-select:none}@media (max-width:41.98rem){a.cds--header__name{padding:0 1rem}}a.cds--header__name:focus{border-color:var(--cds-focus,#0f62fe)}.cds--header__name--prefix{font-weight:400}a.cds--header__name,a.cds--header__name:hover{color:var(--cds-text-primary,#161616)}.cds--header__menu-toggle:not(.cds--header__menu-toggle__hidden)~.cds--header__name{padding-inline-start:.5rem}.cds--header__nav{position:relative;display:none;block-size:100%;padding-inline-start:1rem}@media (min-width:66rem){.cds--header__nav{display:block}}.cds--header__nav::before{position:absolute;display:block;background-color:var(--cds-border-subtle);block-size:1.5rem;content:"";inline-size:.0625rem;inset-block-start:50%;inset-inline-start:0;transform:translateY(-50%)}.cds--header__menu-bar{box-sizing:border-box;padding:0;border:0;margin:0;font-family:inherit;font-size:100%;vertical-align:baseline;display:flex;padding:0;margin:0;block-size:100%;list-style:none}.cds--header__menu-bar *,.cds--header__menu-bar ::after,.cds--header__menu-bar ::before{box-sizing:inherit}a.cds--header__menu-item{position:relative;display:flex;align-items:center;padding:0 1rem;border:2px solid transparent;background-color:var(--cds-background,#fff);block-size:100%;color:var(--cds-text-secondary,#525252);font-size:.875rem;font-weight:400;letter-spacing:0;line-height:1.125rem;text-decoration:none;transition:background-color 110ms,border-color 110ms,color 110ms;-webkit-user-select:none;-moz-user-select:none;user-select:none}a.cds--header__menu-item:hover{background-color:var(--cds-background-hover,rgba(141,141,141,.12));color:var(--cds-text-primary,#161616)}.cds--header__action:active,a.cds--header__menu-item:active{background-color:var(--cds-background-active,rgba(141,141,141,.5));color:var(--cds-text-primary,#161616)}a.cds--header__menu-item:focus{border-color:var(--cds-focus,#0f62fe);outline:0}a.cds--header__menu-item:active>svg,a.cds--header__menu-item:hover>svg{fill:var(--cds-icon-primary,#161616)}.cds--header__menu-item--current,a.cds--header__menu-item[aria-current=page]{color:var(--cds-text-primary,#161616)}.cds--header__menu-item--current::after,a.cds--header__menu-item[aria-current=page]::after{position:absolute;background-color:var(--cds-border-interactive,#0f62fe);block-size:3px;content:"";inline-size:calc(100% + 4px);inset-block-end:-2px;inset-inline-start:-2px}.cds--header__menu-item--current:focus::after,a.cds--header__menu-item[aria-current=page]:focus::after{border:0}.cds--header__submenu .cds--header__menu .cds--header__menu-item--current::after,.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]::after{background-color:var(--cds-border-interactive,#0f62fe);block-size:calc(100% + 4px);inline-size:3px;inset-block-start:-2px;inset-inline-start:-2px}.cds--header__submenu .cds--header__menu .cds--header__menu-item--current:focus::after,.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after{background-color:var(--cds-border-interactive,#0f62fe);block-size:calc(100% + 4px);inline-size:5px;inset-block-start:-2px;inset-inline-start:-2px}a.cds--header__menu-item.cds--header__menu-item--current:focus,a.cds--header__menu-item[aria-current=page]:focus{border:2px solid var(--cds-focus,#0f62fe)}.cds--header__submenu{position:relative}.cds--header__menu-title[aria-haspopup=true]{position:relative}.cds--header__menu-title[aria-expanded=true]{z-index:8002;background-color:var(--cds-layer);color:var(--cds-text-secondary,#525252)}.cds--header__menu-title[aria-expanded=true]>.cds--header__menu-arrow{transform:rotate(180deg)}.cds--header__menu{display:none;padding:0;margin:0;list-style:none}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu{position:absolute;z-index:8001;display:flex;flex-direction:column;background-color:var(--cds-layer);box-shadow:0 4px 8px 0 rgba(0,0,0,.5);inline-size:12.5rem;inset-block-end:0;inset-inline-start:0;transform:translateY(100%)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item{background-color:var(--cds-layer)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item:hover{background-color:var(--cds-layer-hover);color:var(--cds-text-primary,#161616)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item:active{background-color:var(--cds-layer-active);color:var(--cds-text-primary,#161616)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item.cds--header__menu-item--current{background-color:var(--cds-layer-selected)}.cds--header__menu-title[aria-expanded=true]+.cds--header__menu .cds--header__menu-item.cds--header__menu-item--current:hover{background-color:var(--cds-layer-selected-hover)}.cds--header__menu .cds--header__menu-item{block-size:3rem}.cds--header__menu-arrow{fill:var(--cds-icon-secondary,#525252);margin-inline-start:.5rem;transition:transform 110ms,fill 110ms}.cds--header__global{display:flex;flex:1 1 0%;justify-content:flex-end;block-size:100%}.cds--skip-to-content{position:absolute;overflow:hidden;padding:0;border:0;margin:-1px;block-size:1px;clip:rect(0,0,0,0);inline-size:1px;visibility:inherit;white-space:nowrap}.cds--skip-to-content:focus{z-index:9999;display:flex;align-items:center;padding:0 1rem;border:4px solid var(--cds-focus,#0f62fe);background-color:var(--cds-background,#fff);block-size:3rem;clip:auto;color:var(--cds-text-secondary,#525252);inline-size:auto;inset-block-start:0;inset-inline-start:0;outline:0}:host(cds-skip-to-content){display:block}',
]);

let _$b = t => t,
  _t$b;
function _superPropGet$a(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Skip-to-content link.
 *
 * @element cds-skip-to-content
 */
let CDSSkipToContent = _decorate$Z([carbonElement(`${prefix$B}-skip-to-content`)], function (_initialize, _FocusMixin) {
  class CDSSkipToContent extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSSkipToContent,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'link-assistive-text'
      })],
      key: "linkAssisstiveText",
      value() {
        return 'Skip to main content';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value: void 0
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The assistive text for the link,
       */

      /**
       * The skip link href.
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'navigation');
        }
        _superPropGet$a(CDSSkipToContent, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          linkAssisstiveText
        } = this;
        return x(_t$b || (_t$b = _$b`
      <a class="${0}--skip-to-content" href="${0}"
        ><slot>${0}</slot></a
      >
    `), prefix$B, l(this.href), linkAssisstiveText);
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('linkAssisstiveText')) {
          const {
            linkAssisstiveText
          } = this;
          this.setAttribute('aria-label', linkAssisstiveText);
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$2;
      }
    }]
  };
}, FocusMixin(s));

function _decorate$e(e, r, t, i) { var o = _getDecoratorsApi$e(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$e(s.d.map(_createElementDescriptor$e)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$e() { _getDecoratorsApi$e = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$e(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$e(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$e(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$e(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$e(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$e(e) { var r, t = _toPropertyKey$e(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$e(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$e(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$e(o.descriptor) || _isDataDescriptor$e(i.descriptor)) { if (_hasDecorators$e(o) || _hasDecorators$e(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$e(o)) { if (_hasDecorators$e(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$e(o, i); } } else r.push(o); } return r; }
function _hasDecorators$e(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$e(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$e(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$e(t) { var i = _toPrimitive$e(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$e(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$e(r) { return _arrayWithHoles$e(r) || _iterableToArray$e(r) || _unsupportedIterableToArray$e(r) || _nonIterableRest$e(); }
function _nonIterableRest$e() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$e(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$e(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$e(r, a) : void 0; } }
function _arrayLikeToArray$e(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$e(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$e(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$e
} = settings;

/**
 * Skip to content button in masthead.
 *
 * @element c4d-masthead-skip-to-content
 */
_decorate$e([carbonElement(`${c4dPrefix$e}-skip-to-content`)], function (_initialize, _CDSSkipToContent) {
  class C4DSkipToContent extends _CDSSkipToContent {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DSkipToContent,
    d: [{
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'brand';
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, CDSSkipToContent);

let _$a = t => t,
  _t$a;
function _superPropGet$9(t, e, r, o) { var p = _get$h(_getPrototypeOf$h(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }

/**
 * Header.
 *
 * @element cds-header-nav
 * @csspart menu-body The menu body.
 * @csspart divider The divider.
 */ /**
     * Header.
     *
     * @element cds-header-nav
     * @csspart menu-body The menu body.
     * @csspart divider The divider.
     */
let CDSHeaderNav = _decorate$Z([carbonElement(`${prefix$B}-header-nav`)], function (_initialize, _LitElement) {
  class CDSHeaderNav extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSHeaderNav,
    d: [{
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-bar-label'
      })],
      key: "menuBarLabel",
      value: void 0
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * The `aria-label` attribute for the menu bar UI.
       */

      function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'navigation');
        }
        _superPropGet$9(CDSHeaderNav, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          menuBarLabel
        } = this;
        return x(_t$a || (_t$a = _$a`
      <div part="divider" class="${0}-ce--header__divider"></div>
      <ul
        part="menu-body"
        class="${0}--header__menu-bar"
        aria-label="${0}">
        <slot></slot>
      </ul>
    `), prefix$B, prefix$B, menuBarLabel);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$5;
      }
    }]
  };
}, s);

let _$9 = t => t,
  _t$9,
  _t2$7,
  _t3$2;
function _decorate$d(e, r, t, i) { var o = _getDecoratorsApi$d(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$d(s.d.map(_createElementDescriptor$d)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$d() { _getDecoratorsApi$d = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$d(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$d(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$d(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$d(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$d(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$d(e) { var r, t = _toPropertyKey$d(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$d(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$d(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$d(o.descriptor) || _isDataDescriptor$d(i.descriptor)) { if (_hasDecorators$d(o) || _hasDecorators$d(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$d(o)) { if (_hasDecorators$d(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$d(o, i); } } else r.push(o); } return r; }
function _hasDecorators$d(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$d(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$d(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$d(t) { var i = _toPrimitive$d(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$d(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$d(r) { return _arrayWithHoles$d(r) || _iterableToArray$d(r) || _unsupportedIterableToArray$d(r) || _nonIterableRest$d(); }
function _nonIterableRest$d() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$d(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$d(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$d(r, a) : void 0; } }
function _arrayLikeToArray$d(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$d(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$d(r) { if (Array.isArray(r)) return r; }
function _superPropGet$8(t, e, r, o) { var p = _get$8(_getPrototypeOf$8(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$8() { return _get$8 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$8(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$8.apply(null, arguments); }
function _superPropBase$8(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$8(t));); return t; }
function _getPrototypeOf$8(t) { return _getPrototypeOf$8 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$8(t); }
const {
  prefix: prefix$7,
  stablePrefix: c4dPrefix$d
} = settings;

// button gradient width size
const buttonGradientWidth = 8;

/**
 * @param a An array.
 * @param predicate The callback function.
 * @param [thisObject] The context object for the given callback function.
 * @returns The index of the last item in the given array where `predicate` returns `true`. `-1` if no such item is found.
 */
function findLastIndex$1(a, predicate, thisObject) {
  for (let i = a.length - 1; i >= 0; --i) {
    if (predicate(a[i], i, thisObject)) {
      return i;
    }
  }
  return -1;
}

/**
 * Masthead top nav.
 *
 * @element c4d-top-nav
 * @csspart nav - The element containing the menu bar. Usage: `c4d-top-nav::part(nav)`
 * @csspart menubar - The menu bar. Usage: `c4d-top-nav::part(menubar)`
 * @csspart prev-button - The button to go to the previous page. Usage: `c4d-top-nav::part(prev-button)`
 * @csspart next-button - The button to go to the next page. Usage: `c4d-top-nav::part(next-button)`
 * @csspart header-nav-caret-left-container - The header nav caret left container. Usage: `c4d-top-nav::part(header-nav-caret-left-container)`
 * @csspart header-nav-caret-left-gradient - The header nav caret left gradient. Usage: `c4d-top-nav::part(header-nav-caret-left-gradient)`
 * @csspart header-nav-caret-right-container - The header nav caret right container. Usage: `c4d-top-nav::part(header-nav-caret-right-container)`
 * @csspart ce-header-nav-content-container - The ce header nav content container. Usage: `c4d-top-nav::part(ce-header-nav-content-container)`
 * @csspart header-nav-content-container - The header nav content container. Usage: `c4d-top-nav::part(header-nav-content)`
 * @csspart header-nav-content - The header nav content. Usage: `c4d-top-nav::part(header-nav-content)`
 * @csspart sub-content-right - The right sub content. Usage: `c4d-top-nav::part(sub-content-right)`
 * @csspart sub-content-left - The left sub content. Usage: `c4d-top-nav::part(sub-content-left)`
 */
let C4DTopNav = _decorate$d([carbonElement(`${c4dPrefix$d}-top-nav`)], function (_initialize, _StableSelectorMixin) {
  class C4DTopNav extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNav,
    d: [{
      kind: "field",
      decorators: [i$1(`.${prefix$7}--header__nav-caret-left`)],
      key: "_caretLeftNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$7}--header__nav-caret-right`)],
      key: "_caretRightNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$7}--header__nav`)],
      key: "_navNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${c4dPrefix$d}-ce--header__nav-content-container`)],
      key: "_contentContainerNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$7}--header__nav-content`)],
      key: "_contentNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_currentScrollPosition",
      value() {
        return 0;
      }
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$7}--sub-content-left`)],
      key: "_intersectionLeftSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$7}--sub-content-right`)],
      key: "_intersectionRightSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "hideNav",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "importedMegamenu",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'nav-label'
      })],
      key: "navLabel",
      value() {
        return 'Primary navigation';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      key: "_childItems",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_isIntersectionLeftTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_isIntersectionRightTrackerInContent",
      value() {
        return true;
      }
    }, {
      kind: "field",
      key: "_observerIntersection",
      value() {
        return null;
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_pageIsRTL",
      value() {
        return this.ownerDocument.documentElement.dir === 'rtl';
      }
    }, {
      kind: "field",
      decorators: [i$1('slot')],
      key: "_slotNode",
      value: void 0
    }, {
      kind: "method",
      key: "_cleanAndCreateIntersectionObserverContainer",
      value:
      /**
       * The left-hand paginator button.
       */

      /**
       * The right-hand paginator button.
       */

      /**
       * The `<nav>`.
       */

      /**
       * The scrolling container.
       */

      /**
       * The scrolling content.
       */

      /**
       * The current scroll position.
       */

      /**
       * The left-hand sentinel to track intersection with the host element.
       * If they intersect, the left-hand paginator button should be hidden.
       */

      /**
       * The right-hand sentinel to track intersection with the host element.
       * If they intersect, the right-hand paginator button should be hidden.
       */

      /**
       * `true` if the search is open and nav should be hidden
       */

      /**
       * `true` if the megamenu has been opened once and thus imported.
       *
       * Used for lazy loading the megamenu.
       */

      /**
       * The `aria-label` attribute for the nav element.
       */

      /**
       * The English title of the selected nav item.
       */

      /**
       * Array to hold the card-heading elements within child items.
       */

      /**
       * `true` if left-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the left-hand paginator button should be hidden.
       */

      /**
       * `true` if right-hand scroll intersection sentinel intersects with the host element.
       * In this condition, the right-hand paginator button should be hidden.
       */

      /**
       * The observer for the intersection of left-side content edge.
       */

      /**
       * Boolean checking if page is RTL
       */

      /**
       * Cleans-up and creats the intersection observer for the scrolling container.
       *
       * @param [options] The options.
       * @param [options.create] `true` to create the new intersection observer.
       */
      function _cleanAndCreateIntersectionObserverContainer({
        create
      } = {}) {
        const {
          _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
          _intersectionRightSentinelNode: intersectionRightSentinelNode
        } = this;
        if (this._observerIntersection) {
          this._observerIntersection.disconnect();
          this._observerIntersection = null;
        }
        if (create) {
          this._observerIntersection = new IntersectionObserver(this._observeIntersectionContainer, {
            root: this,
            threshold: 0
          });
          if (intersectionLeftSentinelNode) {
            this._observerIntersection.observe(intersectionLeftSentinelNode);
          }
          if (intersectionRightSentinelNode) {
            this._observerIntersection.observe(intersectionRightSentinelNode);
          }
        }
      }

      /**
       * Handles `slotchange` event on the default `<slot>`.
       */
    }, {
      kind: "method",
      key: "_handleSlotChange",
      value: function _handleSlotChange(event) {
        this._childItems = event.target.assignedNodes().filter(elem => {
          var _matches, _ref;
          return (_matches = (_ref = elem).matches) === null || _matches === void 0 ? void 0 : _matches.call(_ref, 'c4d-megamenu-top-nav-menu');
        });
        this._paginateRight({
          onLoad: true
        });
      }

      /**
       * The intersection observer callback for the scrolling container.
       *
       * @param records The intersection observer records.
       */
    }, {
      kind: "field",
      key: "_observeIntersectionContainer",
      value() {
        return records => {
          const {
            _intersectionLeftSentinelNode: intersectionLeftSentinelNode,
            _intersectionRightSentinelNode: intersectionRightSentinelNode
          } = this;
          records.forEach(({
            isIntersecting,
            target
          }) => {
            if (target === intersectionLeftSentinelNode) {
              this._isIntersectionLeftTrackerInContent = isIntersecting;
            }
            if (target === intersectionRightSentinelNode) {
              this._isIntersectionRightTrackerInContent = isIntersecting;
            }
          });
        };
      }
    }, {
      kind: "method",
      key: "_paginateLeft",
      value:
      /**
       * Handles `click` event on the left-hand paginator button.
       */
      function _paginateLeft() {
        const {
          _caretLeftNode: caretLeftNode,
          _caretRightNode: caretRightNode,
          _contentContainerNode: contentContainerNode,
          _currentScrollPosition: currentScrollPosition,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _navNode: navNode,
          _pageIsRTL: pageIsRTL,
          _slotNode: slotNode
        } = this;
        // If the right-side intersection sentinel is in the view, it means that right-side caret button is hidden.
        // Given scrolling to left makes it shown,
        // `contentContainerNode!.offsetWidth` will shrink as we scroll and we need to adjust for it.

        const elems = slotNode === null || slotNode === void 0 ? void 0 : slotNode.assignedElements();
        if (elems) {
          if (pageIsRTL) {
            const caretLeftNodeWidthAdjustment = this._isIntersectionLeftTrackerInContent ? caretLeftNode.offsetWidth : 0;
            const navRight = navNode.getBoundingClientRect().right;
            const lastVisibleElementIndex = elems.findIndex(elem => elem.getBoundingClientRect().left < navRight - currentScrollPosition - caretRightNode.offsetWidth);
            if (lastVisibleElementIndex >= 0) {
              this._currentScrollPosition = Math.max(navRight - elems[lastVisibleElementIndex].getBoundingClientRect().left - contentContainerNode.offsetWidth + caretLeftNodeWidthAdjustment + caretRightNode.offsetWidth + buttonGradientWidth, 0);
            }
          } else {
            const caretRightNodeWidthAdjustment = isIntersectionRightTrackerInContent ? caretRightNode.offsetWidth + buttonGradientWidth : buttonGradientWidth;
            const caretLeftNodeWidthAdjustment = this._isIntersectionLeftTrackerInContent ? caretLeftNode.offsetWidth + buttonGradientWidth : 0;
            const navLeft = navNode.getBoundingClientRect().left;
            const lastVisibleElementIndex = findLastIndex$1(elems, elem => elem.getBoundingClientRect().left - navLeft < currentScrollPosition);
            if (lastVisibleElementIndex >= 0) {
              const lastVisibleElementRight = elems[lastVisibleElementIndex].getBoundingClientRect().right - navLeft;
              const newScrollPosition = lastVisibleElementRight - (contentContainerNode.offsetWidth + caretLeftNodeWidthAdjustment - caretRightNodeWidthAdjustment);
              // If the new scroll position is less than the width of the left caret button,
              // it means that hiding the left caret button reveals the whole of the left-most nav item.
              // Snaps the left-most nav item to the left edge of nav container in this case.
              this._currentScrollPosition = newScrollPosition <= caretLeftNode.offsetWidth ? 0 : newScrollPosition;
            }
          }
        }
      }

      /**
       * Handles `click` event on the right-hand paginator button.
       */
    }, {
      kind: "method",
      key: "_paginateRight",
      value: async function _paginateRight({
        onLoad
      } = {}) {
        const {
          _caretLeftNode: caretLeftNode,
          _caretRightNode: caretRightNode,
          _contentContainerNode: contentContainerNode,
          _contentNode: contentNode,
          _currentScrollPosition: currentScrollPosition,
          _isIntersectionLeftTrackerInContent: isIntersectionLeftTrackerInContent,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _navNode: navNode,
          _pageIsRTL: pageIsRTL,
          _slotNode: slotNode
        } = this;
        await this.updateComplete;
        const elems = (slotNode === null || slotNode === void 0 ? void 0 : slotNode.assignedElements()) || this._childItems;
        if (elems && contentContainerNode) {
          const interimLeft = currentScrollPosition + contentContainerNode.offsetWidth;
          if (pageIsRTL) {
            const caretLeftNodeWidthAdjustment = isIntersectionLeftTrackerInContent ? caretLeftNode.offsetWidth : 0;
            const navRight = navNode.getBoundingClientRect().right;
            const firstVisibleElementIndex = onLoad ? elems.findIndex(elem => navRight - elem.getBoundingClientRect().left > interimLeft - caretLeftNode.offsetWidth - buttonGradientWidth && elem.hasAttribute('active')) : elems.findIndex(elem => navRight - elem.getBoundingClientRect().left > interimLeft - caretLeftNode.offsetWidth - buttonGradientWidth);
            if (firstVisibleElementIndex > 0) {
              const firstVisibleElementLeft = Math.abs(elems[firstVisibleElementIndex].getBoundingClientRect().right - navRight + caretLeftNode.offsetWidth + buttonGradientWidth);
              const maxLeft = contentNode.scrollWidth - contentContainerNode.offsetWidth + caretLeftNodeWidthAdjustment;
              this._currentScrollPosition = Math.min(firstVisibleElementLeft, maxLeft);
            }
          } else {
            const caretLeftNodeWidthAdjustment = isIntersectionLeftTrackerInContent ? 0 : caretLeftNode.offsetWidth;
            const caretRightNodeWidthAdjustment = isIntersectionRightTrackerInContent ? caretRightNode.offsetWidth : 0;
            const navLeft = navNode.getBoundingClientRect().left;
            const firstVisibleElementIndex = onLoad ? elems.findIndex(elem => elem.getBoundingClientRect().right - navLeft > interimLeft && elem.hasAttribute('active')) : elems.findIndex(elem => elem.getBoundingClientRect().right - navLeft > interimLeft);
            if (firstVisibleElementIndex > 0) {
              const firstVisibleElementLeft = elems[firstVisibleElementIndex].getBoundingClientRect().left - navLeft - buttonGradientWidth;
              // Ensures that is there is no blank area at the right hand side in scroll area
              // if we see the right remainder nav items can be contained in a page
              const maxLeft = contentNode.scrollWidth - (contentContainerNode.offsetWidth - caretRightNodeWidthAdjustment + caretLeftNodeWidthAdjustment);
              this._currentScrollPosition = Math.min(firstVisibleElementLeft, maxLeft);
            }
          }
        }
      }
    }, {
      kind: "method",
      key: "_handleOnKeyDown",
      value: function _handleOnKeyDown(event) {
        const target = event.target;
        const {
          _pageIsRTL: pageIsRTL,
          _navNode: navNode,
          _currentScrollPosition: currentScrollPosition,
          _contentContainerNode: contentContainerNode,
          _caretRightNode: caretRightNode
        } = this;
        if (target) {
          if (pageIsRTL) {
            if (event.key === 'Tab') {
              if (event.shiftKey) {
                if (target.previousElementSibling && caretRightNode && target.previousElementSibling.getBoundingClientRect().right + currentScrollPosition > navNode.getBoundingClientRect().right - caretRightNode.offsetWidth) {
                  this._paginateLeft();
                }
              } else if (target.nextElementSibling && caretRightNode && navNode.getBoundingClientRect().right - target.nextElementSibling.getBoundingClientRect().left > currentScrollPosition + contentContainerNode.offsetWidth - caretRightNode.offsetWidth) {
                this._paginateRight();
              }
            }
          } else if (event.key === 'Tab') {
            if (event.shiftKey) {
              if (target.previousElementSibling && target.previousElementSibling.parentElement === this && target.previousElementSibling.getBoundingClientRect().left - navNode.getBoundingClientRect().left < currentScrollPosition) {
                this._paginateLeft();
              }
            } else if (target.nextElementSibling && target.nextElementSibling.parentElement === this && Math.floor(target.nextElementSibling.getBoundingClientRect().right - navNode.getBoundingClientRect().left) > currentScrollPosition + contentContainerNode.offsetWidth) {
              this._paginateRight();
            }
          }
        }
      }

      /**
       * Handles toggle event from the search component.
       *
       * @param event The event.
       */
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventToggleSearch')],
      key: "_handleSearchToggle",
      value() {
        return event => {
          if (event.detail.active !== undefined) {
            this.hideNav = event.detail.active;
          }
        };
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'hide-divider'
      })],
      key: "hideDivider",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * `true` to hide the divider.
       */
      function connectedCallback() {
        _superPropGet$8(C4DTopNav, "connectedCallback", this, 3)([]);
        this._cleanAndCreateIntersectionObserverContainer({
          create: true
        });
        this.removeAttribute('role');
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this._cleanAndCreateIntersectionObserverContainer();
        _superPropGet$8(C4DTopNav, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        if (changedProperties.has('selectedMenuItem')) {
          this._paginateRight({
            onLoad: true
          });
        }
      }
    }, {
      kind: "method",
      key: "shouldUpdate",
      value: function shouldUpdate(changedProperties) {
        if (changedProperties.has('hideNav')) {
          this._cleanAndCreateIntersectionObserverContainer();
        }
        return true;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('hideNav')) {
          this._cleanAndCreateIntersectionObserverContainer({
            create: true
          });
        }
        if (changedProperties.has('_currentScrollPosition')) {
          if (this._contentNode) {
            this._contentNode.style.insetInlineStart = `-${this._currentScrollPosition}px`;
          }
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _isIntersectionLeftTrackerInContent: isIntersectionLeftTrackerInContent,
          _isIntersectionRightTrackerInContent: isIntersectionRightTrackerInContent,
          _handleSlotChange: handleSlotChange,
          _paginateLeft: paginateLeft,
          _paginateRight: paginateRight,
          _pageIsRTL: pageIsRTL,
          _handleOnKeyDown: handleOnKeyDown
        } = this;
        const caretLeftContainerClasses = o$2({
          [`${prefix$7}--header__nav-caret-left-container`]: true,
          [`${c4dPrefix$d}-ce--header__nav-caret-container--hidden`]: isIntersectionLeftTrackerInContent
        });
        const caretRightContainerClasses = o$2({
          [`${prefix$7}--header__nav-caret-right-container`]: true,
          [`${c4dPrefix$d}-ce--header__nav-caret-container--hidden`]: isIntersectionRightTrackerInContent
        });
        return this.hideNav ? undefined : x(_t$9 || (_t$9 = _$9`
          ${0}
        `), pageIsRTL ? x(_t2$7 || (_t2$7 = _$9`
                <div
                  part="header-nav-caret-left-container"
                  class="${0}">
                  <div
                    part="header_nav-caret-left-gradient"
                    class="${0}--header__nav-caret-right-gradient"></div>
                  <button
                    part="next-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-right"
                    @click="${0}">
                    ${0}
                  </button>
                </div>
                <div
                  part="ce-header-nav-content-container"
                  class="${0}-ce--header__nav-content-container">
                  <div
                    part="header-nav-content"
                    class="${0}--header__nav-content">
                    <nav
                      part="nav"
                      class="${0}--header__nav"
                      aria-label="${0}">
                      <div
                        part="sub-content-right"
                        class="${0}--sub-content-right"></div>
                      <div
                        part="menubar"
                        class="${0}--header__menu-bar"
                        aria-label="${0}">
                        <slot
                          @slotchange=${0}
                          @keydown="${0}"></slot>
                      </div>
                      <div
                        part="sub-content-left"
                        class="${0}--sub-content-left"></div>
                    </nav>
                  </div>
                </div>
                <div
                  part="header-nav-caret-left-container"
                  class="${0}">
                  <button
                    part="prev-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-left"
                    @click="${0}">
                    ${0}
                  </button>
                  <div
                    part="header-nav-caret-left-gradient"
                    class="${0}--header__nav-caret-left-gradient"></div>
                </div>
              `), caretRightContainerClasses, prefix$7, prefix$7, paginateRight, svgResultCarbonIcon$e(), c4dPrefix$d, prefix$7, prefix$7, l(this.navLabel), prefix$7, prefix$7, l(this.menuBarLabel), handleSlotChange, handleOnKeyDown, prefix$7, caretLeftContainerClasses, prefix$7, paginateLeft, svgResultCarbonIcon$d(), prefix$7) : x(_t3$2 || (_t3$2 = _$9`
                <div
                  part="header-nav-caret-left-container"
                  class="${0}">
                  <button
                    part="prev-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-left"
                    @click="${0}">
                    ${0}
                  </button>
                  <div
                    part="header_nav-caret-left-gradient"
                    class="${0}--header__nav-caret-left-gradient"></div>
                </div>
                <div
                  part="ce-header-nav-content-container"
                  class="${0}-ce--header__nav-content-container">
                  <div
                    part="header-nav-content"
                    class="${0}--header__nav-content">
                    <nav
                      part="nav"
                      class="${0}--header__nav"
                      aria-label="${0}">
                      <div
                        part="sub-content-left"
                        class="${0}--sub-content-left"></div>
                      <div
                        part="menubar"
                        class="${0}--header__menu-bar"
                        aria-label="${0}">
                        <slot
                          @slotchange=${0}
                          @keydown="${0}"></slot>
                      </div>
                      <div
                        part="sub-content-right"
                        class="${0}--sub-content-right"></div>
                    </nav>
                  </div>
                </div>
                <div
                  part="header-nav-caret-right-container"
                  class="${0}">
                  <div
                    part="header-nav-caret-right-gradient"
                    class="${0}--header__nav-caret-right-gradient"></div>
                  <button
                    part="next-button"
                    tabindex="-1"
                    aria-hidden="true"
                    class="${0}--header__nav-caret-right"
                    @click="${0}">
                    ${0}
                  </button>
                </div>
              `), caretLeftContainerClasses, prefix$7, paginateLeft, svgResultCarbonIcon$e(), prefix$7, c4dPrefix$d, prefix$7, prefix$7, l(this.navLabel), prefix$7, prefix$7, l(this.menuBarLabel), handleSlotChange, handleOnKeyDown, prefix$7, caretRightContainerClasses, prefix$7, prefix$7, paginateRight, svgResultCarbonIcon$d()));
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$d}--masthead__l0-nav`;
      }

      /**
       * The name of the custom event fired after the search is toggled.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggleSearch",
      value: function () {
        return `${c4dPrefix$d}-search-with-typeahead-toggled`; // TODO hook up the new event
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(HostListenerMixin(CDSHeaderNav)));

function _decorate$c(e, r, t, i) { var o = _getDecoratorsApi$c(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$c(s.d.map(_createElementDescriptor$c)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$c() { _getDecoratorsApi$c = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$c(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$c(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$c(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$c(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$c(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$c(e) { var r, t = _toPropertyKey$c(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$c(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$c(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$c(o.descriptor) || _isDataDescriptor$c(i.descriptor)) { if (_hasDecorators$c(o) || _hasDecorators$c(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$c(o)) { if (_hasDecorators$c(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$c(o, i); } } else r.push(o); } return r; }
function _hasDecorators$c(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$c(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$c(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$c(t) { var i = _toPrimitive$c(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$c(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$c(r) { return _arrayWithHoles$c(r) || _iterableToArray$c(r) || _unsupportedIterableToArray$c(r) || _nonIterableRest$c(); }
function _nonIterableRest$c() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$c(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$c(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$c(r, a) : void 0; } }
function _arrayLikeToArray$c(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$c(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$c(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$c
} = settings;

/**
 * Masthead top nav for L1.
 *
 * @element c4d-top-nav-l1
 */
_decorate$c([carbonElement(`${c4dPrefix$c}-top-nav-l1`)], function (_initialize, _C4DTopNav) {
  class C4DTopNavL1 extends _C4DTopNav {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavL1,
    d: [{
      kind: "field",
      key: "_handleSearchToggle",
      value() {
        return () => {
          // Do nothing
        };
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'hide-divider'
      })],
      key: "hideDivider",
      value() {
        return true;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value:
      // eslint-disable-next-line class-methods-use-this

      /**
       * `true` to hide the divider.
       */

      function () {
        return `${c4dPrefix$c}--masthead__l1-nav`;
      }
    }]
  };
}, C4DTopNav);

let _$8 = t => t,
  _t$8,
  _t2$6;

/**
 * The product name UI in header nav.
 *
 * @element cds-header-name
 * @csspart link The link.
 * @csspart prefix The prefix content.
 */
let CDSHeaderName = _decorate$Z([carbonElement(`${prefix$B}-header-name`)], function (_initialize, _FocusMixin) {
  class CDSHeaderName extends _FocusMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: CDSHeaderName,
    d: [{
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "prefix",
      value: void 0
    }, {
      kind: "method",
      key: "render",
      value:
      /**
       * Link `href`.
       */

      /**
       * The product name prefix.
       */

      function render() {
        const {
          href,
          prefix: namePrefix
        } = this;
        const namePrefixPart = !namePrefix ? undefined : x(_t$8 || (_t$8 = _$8`
          <span part="prefix" class="${0}--header__name--prefix"
            >${0}</span
          >
        `), prefix$B, namePrefix);
        return x(_t2$6 || (_t2$6 = _$8`
      <a part="link" class="${0}--header__name" href="${0}"
        >${0}&nbsp;<slot></slot
      ></a>
    `), prefix$B, l(href), namePrefixPart);
      }
    }, {
      kind: "field",
      static: true,
      key: "shadowRootOptions",
      value() {
        return _objectSpread2(_objectSpread2({}, s.shadowRootOptions), {}, {
          delegatesFocus: true
        });
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$5;
      }
    }]
  };
}, FocusMixin(s));

/**
 * Creates a `_.find` or `_.findLast` function.
 *
 * @private
 * @param {Function} findIndexFunc The function to find the collection index.
 * @returns {Function} Returns the new find function.
 */
function createFind(findIndexFunc) {
  return function(collection, predicate, fromIndex) {
    var iterable = Object(collection);
    if (!isArrayLike(collection)) {
      var iteratee = baseIteratee(predicate);
      collection = keys(collection);
      predicate = function(key) { return iteratee(iterable[key], key, iterable); };
    }
    var index = findIndexFunc(collection, predicate, fromIndex);
    return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
  };
}

/**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);

  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0,
    MAX_INTEGER = 1.7976931348623157e+308;

/**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 */
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = (value < 0 ? -1 : 1);
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}

/**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 */
function toInteger(value) {
  var result = toFinite(value),
      remainder = result % 1;

  return result === result ? (remainder ? result - remainder : result) : 0;
}

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max,
    nativeMin = Math.min;

/**
 * This method is like `_.findIndex` except that it iterates over elements
 * of `collection` from right to left.
 *
 * @static
 * @memberOf _
 * @since 2.0.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=array.length-1] The index to search from.
 * @returns {number} Returns the index of the found element, else `-1`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'active': true },
 *   { 'user': 'fred',    'active': false },
 *   { 'user': 'pebbles', 'active': false }
 * ];
 *
 * _.findLastIndex(users, function(o) { return o.user == 'pebbles'; });
 * // => 2
 *
 * // The `_.matches` iteratee shorthand.
 * _.findLastIndex(users, { 'user': 'barney', 'active': true });
 * // => 0
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.findLastIndex(users, ['active', false]);
 * // => 2
 *
 * // The `_.property` iteratee shorthand.
 * _.findLastIndex(users, 'active');
 * // => 0
 */
function findLastIndex(array, predicate, fromIndex) {
  var length = array == null ? 0 : array.length;
  if (!length) {
    return -1;
  }
  var index = length - 1;
  if (fromIndex !== undefined) {
    index = toInteger(fromIndex);
    index = fromIndex < 0
      ? nativeMax(length + index, 0)
      : nativeMin(index, length - 1);
  }
  return baseFindIndex(array, baseIteratee(predicate), index, true);
}

/**
 * This method is like `_.find` except that it iterates over elements of
 * `collection` from right to left.
 *
 * @static
 * @memberOf _
 * @since 2.0.0
 * @category Collection
 * @param {Array|Object} collection The collection to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=collection.length-1] The index to search from.
 * @returns {*} Returns the matched element, else `undefined`.
 * @example
 *
 * _.findLast([1, 2, 3, 4], function(n) {
 *   return n % 2 == 1;
 * });
 * // => 3
 */
var findLast = createFind(findLastIndex);

var findLast$1 = findLast;

let _$7 = t => t,
  _t$7,
  _t2$5;
function _decorate$b(e, r, t, i) { var o = _getDecoratorsApi$b(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$b(s.d.map(_createElementDescriptor$b)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$b() { _getDecoratorsApi$b = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$b(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$b(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$b(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$b(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$b(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$b(e) { var r, t = _toPropertyKey$b(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$b(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$b(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$b(o.descriptor) || _isDataDescriptor$b(i.descriptor)) { if (_hasDecorators$b(o) || _hasDecorators$b(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$b(o)) { if (_hasDecorators$b(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$b(o, i); } } else r.push(o); } return r; }
function _hasDecorators$b(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$b(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$b(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$b(t) { var i = _toPrimitive$b(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$b(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$b(r) { return _arrayWithHoles$b(r) || _iterableToArray$b(r) || _unsupportedIterableToArray$b(r) || _nonIterableRest$b(); }
function _nonIterableRest$b() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$b(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$b(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$b(r, a) : void 0; } }
function _arrayLikeToArray$b(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$b(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$b(r) { if (Array.isArray(r)) return r; }
function _superPropGet$7(t, e, r, o) { var p = _get$7(_getPrototypeOf$7(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$7() { return _get$7 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$7(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$7.apply(null, arguments); }
function _superPropBase$7(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$7(t));); return t; }
function _getPrototypeOf$7(t) { return _getPrototypeOf$7 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$7(t); }
const {
  prefix: prefix$6,
  stablePrefix: c4dPrefix$b
} = settings;

// eslint-disable-next-line no-bitwise
const PRECEDING = Node.DOCUMENT_POSITION_PRECEDING | Node.DOCUMENT_POSITION_CONTAINS;
// eslint-disable-next-line no-bitwise
const FOLLOWING = Node.DOCUMENT_POSITION_FOLLOWING | Node.DOCUMENT_POSITION_CONTAINED_BY;

/**
 * Masthead left nav.
 *
 * @element c4d-left-nav
 * @csspart side-nav-wrapper - The wrapper element for the side nav. Usage: `c4d-left-nav::part(side-nav-wrapper)`
 * @csspart platform-name - The element containing the platform name slot. Usage: `c4d-left-nav::part(platform-name)`
 * @csspart menu-sections - The element containing the menu sections slot. Usage: `c4d-left-nav::part(menu-sections)`
 */
let C4DLeftNav = _decorate$b([carbonElement(`${c4dPrefix$b}-left-nav`)], function (_initialize, _StableSelectorMixin) {
  class C4DLeftNav extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeftNav,
    d: [{
      kind: "field",
      key: "_hFocusWrap",
      value() {
        return null;
      }
    }, {
      kind: "field",
      decorators: [i$1('#start-sentinel')],
      key: "_startSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1('#end-sentinel')],
      key: "_endSentinelNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean
      })],
      key: "_importedSideNav",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventButtonToggle')],
      key: "_handleButtonToggle",
      value() {
        return async event => {
          if (!this._importedSideNav) {
            await Promise.all([Promise.resolve().then(function () { return leftNavName; }), import('./left-nav-menu-ee66480f.js'), import('./left-nav-menu-section-620f3e39.js'), import('./left-nav-menu-item-62b3aeb4.js'), import('./left-nav-menu-category-heading-907c5870.js'), import('./left-nav-overlay-4aa89969.js')]);
            this._importedSideNav = true;
          }
          this.expanded = event.detail.active;
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener('document:cds-request-focus-wrap')],
      key: "_handleRequestMenuButtonFocusWrap",
      value() {
        return event => {
          const {
            selectorButtonToggle
          } = this.constructor;
          /**
           * If focus leaves this element, send focus to the menu toggle.
           * Else if focus leaves the menu toggle, bring it back to this element.
           */
          if (event.target === this) {
            const toggle = this.getRootNode().querySelector(selectorButtonToggle);
            if (toggle) {
              toggle.focus();
            }
          } else if (event.composedPath()[1].tagName === selectorButtonToggle.toUpperCase()) {
            const {
              comparisonResult
            } = event.detail;
            const {
              selectorExpandedMenuSection,
              selectorTabbable: selectorTabbableForLeftnav
            } = this.constructor;
            const expandedMenuSection = this.querySelector(selectorExpandedMenuSection);

            // focus on first tabbable element when expanding left-nav
            if (comparisonResult === -1) {
              const tabbable = find(this.querySelectorAll(selectorTabbableForLeftnav), elem => Boolean(elem.offsetParent));
              if (tabbable) {
                tabbable.focus();
              }
            }
            // wrap focus to last tabbable element focusing out of first tabbable element
            // eslint-disable-next-line no-bitwise
            else if (comparisonResult & PRECEDING) {
              const tabbable = findLast$1(expandedMenuSection === null || expandedMenuSection === void 0 ? void 0 : expandedMenuSection.querySelectorAll(selectorTabbableForLeftnav), elem => Boolean(elem.offsetParent));
              if (tabbable) {
                tabbable.focus();
              }
            }
            // wrap focus to first tabbable element focusing out of last tabbable element
            // eslint-disable-next-line no-bitwise
            else if (comparisonResult & FOLLOWING) {
              var _expandedMenuSection$;
              const allTabbable = [...Array.from((expandedMenuSection === null || expandedMenuSection === void 0 || (_expandedMenuSection$ = expandedMenuSection.shadowRoot) === null || _expandedMenuSection$ === void 0 ? void 0 : _expandedMenuSection$.querySelectorAll(selectorTabbableForLeftnav)) || []), ...Array.from((expandedMenuSection === null || expandedMenuSection === void 0 ? void 0 : expandedMenuSection.querySelectorAll(selectorTabbableForLeftnav)) || [])];
              if (allTabbable.length) {
                allTabbable[0].focus();
              }
            }
          }
        };
      }
    }, {
      kind: "method",
      key: "_handleClickOut",
      value:
      /**
       * The handle for focus wrapping.
       */

      /**
       * Node to track focus going outside of modal content.
       */

      /**
       * Node to track focus going outside of modal content.
       */

      /**
       * Handles `${prefix}-header-menu-button-toggle` event on the document.
       */

      /**
       * Handles `cds-request-focus-wrap` event on the document dispatched from focuswrap.
       *
       * @param event The event.
       */

      function _handleClickOut(event) {
        const {
          selectorButtonToggle
        } = this.constructor;
        const toggleButton = this.getRootNode().querySelector(selectorButtonToggle);

        // TODO: check why `target` returns `c4d-masthead-container` (parent) in Lit v2
        if (this.expanded && event.composedPath()[0].tagName === 'C4D-LEFT-NAV-OVERLAY') {
          this.expanded = false;
          toggleButton === null || toggleButton === void 0 || toggleButton.focus();
        }
      }
    }, {
      kind: "method",
      decorators: [HostListener('keydown')],
      key: "_handleKeydown",
      value: function _handleKeydown(event) {
        const {
          selectorButtonToggle
        } = this.constructor;
        const toggleButton = this.getRootNode().querySelector(selectorButtonToggle);
        if (event.key === 'Escape') {
          this.expanded = false;
          toggleButton === null || toggleButton === void 0 || toggleButton.focus();
        }
      }
    }, {
      kind: "field",
      decorators: [HostListener('parentRoot:eventToggle')],
      key: "_handleContentStateChangeDocument",
      value() {
        return event => {
          const {
            selectorMenuSections
          } = this.constructor;
          const {
            panelId
          } = event.detail;
          const menuSections = Array.from(this.querySelectorAll(selectorMenuSections));
          const expandedSection = menuSections.filter(section => section.matches('[expanded]')).shift();
          const requestedSection = menuSections.filter(section => section.matches(`[section-id="${panelId}"]`)).shift();
          if (expandedSection !== undefined && requestedSection !== undefined && expandedSection !== requestedSection) {
            const id = panelId.split(', ');
            requestedSection.expanded = true;
            requestedSection.ariaHidden = 'false';
            requestedSection.transition = false;
            expandedSection.expanded = false;
            expandedSection.ariaHidden = 'true';

            /**
             * if next menu section expanded is a level 2 menu section and current expanded
             * menu section is a level 1 menu section, add transition attribute for proper animation
             */
            if (id[0] !== '-1' && id[1] !== '-1' && !requestedSection.matches('[section-id*=" -1"]')) {
              expandedSection.transition = true;
            }
          }
        };
      }
    }, {
      kind: "method",
      key: "_handleFocusOut",
      value: //TODO: Remove this override when upstream bug is fixed.
      //@ts-ignore: Overriding the Focus Out Function
      function _handleFocusOut({
        relatedTarget
      }) {
        const {
          collapseMode
        } = this;
        if (collapseMode !== this.collapseMode) {
          if (!this.contains(relatedTarget)) {
            this.expanded = false;
          }
        }
      }

      /**
       * Usage mode of the side nav.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'usage-mode'
      })],
      key: "usageMode",
      value() {
        return SIDE_NAV_USAGE_MODE.HEADER_NAV;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet$7(C4DLeftNav, "connectedCallback", this, 3)([]);
        document.addEventListener('click', this._handleClickOut.bind(this));
      }
    }, {
      kind: "method",
      key: "updated",
      value: async function updated(changedProperties) {
        _superPropGet$7(C4DLeftNav, "updated", this, 3)([changedProperties]);
        const {
          usageMode
        } = this;
        if (changedProperties.has('usageMode') && usageMode !== SIDE_NAV_USAGE_MODE.HEADER_NAV) {
          // eslint-disable-next-line no-console
          console.warn('c4d-left-nav supports only `header-nav` for its `usage-mode` attribute or `usageMode` property. The value is ignored:', usageMode);
        }
        if (changedProperties.has('expanded')) {
          var _doc$querySelector;
          const doc = this.getRootNode();
          forEach(doc.querySelectorAll(this.constructor.selectorOverlay), item => {
            item.active = this.expanded;
          });
          const {
            expanded,
            _startSentinelNode: startSentinelNode,
            _endSentinelNode: endSentinelNode
          } = this;
          const masthead = doc === null || doc === void 0 || (_doc$querySelector = doc.querySelector(`${c4dPrefix$b}-masthead-container,
          ${c4dPrefix$b}-masthead-composite`)) === null || _doc$querySelector === void 0 ? void 0 : _doc$querySelector.querySelector(`${c4dPrefix$b}-masthead`);
          if (expanded && masthead) {
            var _doc$body;
            this._hFocusWrap = focuswrap(this.shadowRoot, [startSentinelNode, endSentinelNode]);
            if ((_doc$body = doc.body) !== null && _doc$body !== void 0 && _doc$body.style) {
              doc.body.style.overflow = `hidden`;
            }

            // TODO: remove this logic once masthead can account for banners.
            // set masthead position to `fixed` when left-nav is open for cloud-mastead
            if (masthead) {
              masthead.style.position = 'fixed';
            }
          } else {
            const {
              selectorMenuSections,
              selectorFirstMenuSection
            } = this.constructor;

            // TODO: remove this logic once masthead can account for banners.
            // remove set position from mastead when left-nav is closed for cloud-mastead
            if (masthead) {
              document.body.style.overflow = 'auto';
              masthead.style.position = '';
            }
            this.querySelectorAll(selectorMenuSections).forEach(c4dLeftNavMenuSection => {
              c4dLeftNavMenuSection.expanded = false;
              c4dLeftNavMenuSection.transition = false;
            });

            // reset to first menu section
            this.querySelectorAll(selectorFirstMenuSection).forEach(c4dLeftNavMenuSection => {
              c4dLeftNavMenuSection.expanded = true;
            });
            if (this._hFocusWrap) {
              this._hFocusWrap = this._hFocusWrap.release();
            }
          }
        }
      }
    }, {
      kind: "field",
      key: "_renderSentinel",
      value() {
        return side => {
          return x(_t$7 || (_t$7 = _$7`
      <button
        id="${0}-sentinel"
        type="button"
        class="${0}--visually-hidden"></button>
    `), side, prefix$6);
        };
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _renderSentinel: renderSentinel
        } = this;
        return x(_t2$5 || (_t2$5 = _$7`
      <div class="${0}--side-nav__wrapper" part="side-nav-wrapper">
        ${0}
        <div class="${0}--side-nav__platform-name" part="platform-name">
          <slot name="platform-id"></slot>
        </div>
        <div class="${0}--side-nav__menu-sections" part="menu-sections">
          <slot></slot>
        </div>
        ${0}
      </div>
    `), prefix$6, renderSentinel('start'), prefix$6, prefix$6, renderSentinel('end'));
      }

      /**
       * A selector that will return the toggle buttons.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorButtonToggle",
      value: function () {
        return `${c4dPrefix$b}-masthead-menu-button`;
      }

      /**
       * A selector that will return side nav focusable items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorNavItems",
      value: function () {
        return [`${c4dPrefix$b}-left-nav-menu`, `${c4dPrefix$b}-left-nav-menu-item`, `${c4dPrefix$b}-left-nav-name`].join(', ');
      }

      /**
       * A selector that will return menu sections.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorMenuSections",
      value: function () {
        return `${c4dPrefix$b}-left-nav-menu-section`;
      }

      /**
       * A selector that will return expanded menu section.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorExpandedMenuSection",
      value: function () {
        return `${c4dPrefix$b}-left-nav-menu-section[expanded]`;
      }

      /**
       * A selector that will return first main visible menu section.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorFirstMenuSection",
      value: function () {
        return `${c4dPrefix$b}-left-nav-menu-section[section-id='-1, -1']`;
      }

      /**
       * A selector selecting tabbable nodes.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTabbable",
      value: function () {
        return [selectorTabbable, `${c4dPrefix$b}-left-nav-menu`, `${c4dPrefix$b}-left-nav-menu-item`, `${c4dPrefix$b}-left-nav-name`].join(', ');
      }

      /**
       * A selector that will return the overlays.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorOverlay",
      value: function () {
        return `${c4dPrefix$b}-left-nav-overlay`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$b}--masthead__l0-sidenav`;
      }

      /**
       * The name of the custom event fired after this side nav menu is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggle",
      value: function () {
        return `${c4dPrefix$b}-left-nav-menu-toggled`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, StableSelectorMixin(CDSSideNav));

let _$6 = t => t,
  _t$6,
  _t2$4;
function _decorate$a(e, r, t, i) { var o = _getDecoratorsApi$a(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$a(s.d.map(_createElementDescriptor$a)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$a() { _getDecoratorsApi$a = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$a(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$a(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$a(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$a(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$a(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$a(e) { var r, t = _toPropertyKey$a(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$a(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$a(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$a(o.descriptor) || _isDataDescriptor$a(i.descriptor)) { if (_hasDecorators$a(o) || _hasDecorators$a(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$a(o)) { if (_hasDecorators$a(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$a(o, i); } } else r.push(o); } return r; }
function _hasDecorators$a(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$a(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$a(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$a(t) { var i = _toPrimitive$a(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$a(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$a(r) { return _arrayWithHoles$a(r) || _iterableToArray$a(r) || _unsupportedIterableToArray$a(r) || _nonIterableRest$a(); }
function _nonIterableRest$a() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$a(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$a(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$a(r, a) : void 0; } }
function _arrayLikeToArray$a(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$a(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$a(r) { if (Array.isArray(r)) return r; }
function _superPropGet$6(t, e, r, o) { var p = _get$6(_getPrototypeOf$6(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$6() { return _get$6 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$6(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$6.apply(null, arguments); }
function _superPropBase$6(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$6(t));); return t; }
function _getPrototypeOf$6(t) { return _getPrototypeOf$6 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$6(t); }
const {
  prefix: prefix$5,
  stablePrefix: c4dPrefix$a
} = settings;

/**
 * The brand name UI in left nav.
 *
 * @element c4d-left-nav-name
 * @csspart side-nav-submenu - The side navigation submenu. Usage: `c4d-left-nav-name::part(side-nav-submenu)`
 * @csspart side-nav-name-prefix - The prefix for the side navigation name. Usage: `c4d-left-nav-name::part(side-nav-name-prefix)`
 */
let C4DLeftNavName = _decorate$a([carbonElement(`${c4dPrefix$a}-left-nav-name`)], function (_initialize, _CDSHeaderName) {
  class C4DLeftNavName extends _CDSHeaderName {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DLeftNavName,
    d: [{
      kind: "field",
      decorators: [n$1({
        type: String,
        attribute: 'slot',
        reflect: true
      })],
      key: "slot",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value:
      /**
       * Set slot name property.
       */

      function connectedCallback() {
        _superPropGet$6(C4DLeftNavName, "connectedCallback", this, 3)([]);
        if (this.parentElement instanceof C4DLeftNav) {
          this.slot = 'platform-id';
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          href,
          prefix: namePrefix
        } = this;
        const namePrefixPart = !namePrefix ? undefined : x(_t$6 || (_t$6 = _$6`
          <span
            class="${0}--header__name--prefix"
            part="side-nav-name-prefix"
            >${0}</span
          >&nbsp;
        `), prefix$5, namePrefix);
        return x(_t2$4 || (_t2$4 = _$6`
      <a
        part="side-nav-submenu"
        class="${0}--side-nav__submenu ${0}--side-nav__submenu-platform"
        href="${0}">
        ${0}
        <slot></slot>
      </a>
    `), prefix$5, prefix$5, l(href), namePrefixPart);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, CDSHeaderName);

var leftNavName = /*#__PURE__*/Object.freeze({
  __proto__: null,
  'default': C4DLeftNavName
});

let _$5 = t => t,
  _t$5,
  _t2$3;
function _decorate$9(e, r, t, i) { var o = _getDecoratorsApi$9(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$9(s.d.map(_createElementDescriptor$9)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$9() { _getDecoratorsApi$9 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$9(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$9(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$9(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$9(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$9(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$9(e) { var r, t = _toPropertyKey$9(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$9(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$9(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$9(o.descriptor) || _isDataDescriptor$9(i.descriptor)) { if (_hasDecorators$9(o) || _hasDecorators$9(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$9(o)) { if (_hasDecorators$9(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$9(o, i); } } else r.push(o); } return r; }
function _hasDecorators$9(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$9(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$9(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$9(t) { var i = _toPrimitive$9(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$9(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$9(r) { return _arrayWithHoles$9(r) || _iterableToArray$9(r) || _unsupportedIterableToArray$9(r) || _nonIterableRest$9(); }
function _nonIterableRest$9() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$9(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$9(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$9(r, a) : void 0; } }
function _arrayLikeToArray$9(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$9(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$9(r) { if (Array.isArray(r)) return r; }
function _superPropGet$5(t, e, r, o) { var p = _get$5(_getPrototypeOf$5(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$5() { return _get$5 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$5(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$5.apply(null, arguments); }
function _superPropBase$5(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$5(t));); return t; }
function _getPrototypeOf$5(t) { return _getPrototypeOf$5 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$5(t); }
const {
  prefix: prefix$4,
  stablePrefix: c4dPrefix$9
} = settings;

/**
 * The brand name UI in top nav.
 *
 * @element c4d-top-nav-name
 * @csspart name-prefix - The header name prefix. Usage: `c4d-top-nav-name::part(name-prefix)`
 * @csspart name-link - The header name prefix. Usage: `c4d-top-nav-name::part(name-link)`
 */
_decorate$9([carbonElement(`${c4dPrefix$9}-top-nav-name`)], function (_initialize, _C4DLeftNavName) {
  class C4DTopNavName extends _C4DLeftNavName {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavName,
    d: [{
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        _superPropGet$5(C4DTopNavName, "connectedCallback", this, 3)([]);
        const {
          selectorTopNav
        } = this.constructor;
        const {
          nextElementSibling
        } = this;
        if (nextElementSibling && nextElementSibling.matches(selectorTopNav)) {
          nextElementSibling.hideDivider = true;
        }
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        const {
          selectorTopNav
        } = this.constructor;
        const {
          nextElementSibling
        } = this;
        if (nextElementSibling && nextElementSibling.matches(selectorTopNav)) {
          nextElementSibling.hideDivider = false;
        }
        _superPropGet$5(C4DTopNavName, "disconnectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          href,
          prefix: namePrefix
        } = this;
        const namePrefixPart = !namePrefix ? undefined : x(_t$5 || (_t$5 = _$5`
          <span part="name-prefix" class="${0}--header__name--prefix"
            >${0}</span
          >&nbsp;
        `), prefix$4, namePrefix);
        return x(_t2$3 || (_t2$3 = _$5`
      <a
        part="name-link"
        class="${0}--header__name"
        href="${0}"
        >${0}<slot></slot
      ></a>
    `), prefix$4, l(href), namePrefixPart);
      }

      /**
       * A selector that will return the nav bar.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorTopNav",
      value: function () {
        return `${c4dPrefix$9}-top-nav`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$9}--masthead__platform-name`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, C4DLeftNavName);

function _decorate$8(e, r, t, i) { var o = _getDecoratorsApi$8(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$8(s.d.map(_createElementDescriptor$8)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$8() { _getDecoratorsApi$8 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$8(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$8(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$8(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$8(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$8(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$8(e) { var r, t = _toPropertyKey$8(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$8(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$8(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$8(o.descriptor) || _isDataDescriptor$8(i.descriptor)) { if (_hasDecorators$8(o) || _hasDecorators$8(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$8(o)) { if (_hasDecorators$8(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$8(o, i); } } else r.push(o); } return r; }
function _hasDecorators$8(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$8(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$8(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$8(t) { var i = _toPrimitive$8(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$8(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$8(r) { return _arrayWithHoles$8(r) || _iterableToArray$8(r) || _unsupportedIterableToArray$8(r) || _nonIterableRest$8(); }
function _nonIterableRest$8() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$8(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$8(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$8(r, a) : void 0; } }
function _arrayLikeToArray$8(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$8(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$8(r) { if (Array.isArray(r)) return r; }
function _superPropGet$4(t, e, r, o) { var p = _get$4(_getPrototypeOf$4(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$4() { return _get$4 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$4(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$4.apply(null, arguments); }
function _superPropBase$4(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$4(t));); return t; }
function _getPrototypeOf$4(t) { return _getPrototypeOf$4 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$4(t); }
const {
  stablePrefix: c4dPrefix$8
} = settings;

/**
 * Masthead top nav item.
 *
 * @element c4d-top-nav-item
 */
_decorate$8([carbonElement(`${c4dPrefix$8}-top-nav-item`)], function (_initialize, _CDSHeaderNavItem) {
  class C4DTopNavItem extends _CDSHeaderNavItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavItem,
    d: [{
      kind: "field",
      decorators: [i$1('[part="link"]')],
      key: "_linkNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "method",
      key: "updated",
      value:
      /**
       * The `<a>`.
       */

      /**
       * `true` if this nav item should be in its active state.
       */

      function updated(changedProperties) {
        _superPropGet$4(C4DTopNavItem, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('active')) {
          const {
            active,
            _linkNode: linkNode
          } = this;
          if (linkNode) {
            linkNode.setAttribute('data-selected', String(Boolean(active)));
          }
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$shadowRoot;
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
        if (this.hasAttribute('role') && this.getAttribute('role') === 'listitem') {
          this.removeAttribute('role');
        }
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, CDSHeaderNavItem);

function _decorate$7(e, r, t, i) { var o = _getDecoratorsApi$7(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$7(s.d.map(_createElementDescriptor$7)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$7() { _getDecoratorsApi$7 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$7(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$7(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$7(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$7(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$7(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$7(e) { var r, t = _toPropertyKey$7(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$7(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$7(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$7(o.descriptor) || _isDataDescriptor$7(i.descriptor)) { if (_hasDecorators$7(o) || _hasDecorators$7(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$7(o)) { if (_hasDecorators$7(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$7(o, i); } } else r.push(o); } return r; }
function _hasDecorators$7(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$7(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$7(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$7(t) { var i = _toPrimitive$7(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$7(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$7(r) { return _arrayWithHoles$7(r) || _iterableToArray$7(r) || _unsupportedIterableToArray$7(r) || _nonIterableRest$7(); }
function _nonIterableRest$7() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$7(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$7(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$7(r, a) : void 0; } }
function _arrayLikeToArray$7(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$7(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$7(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$7
} = settings;

/**
 * Masthead top nav submenu item.
 *
 * @element c4d-top-nav-menu-item
 */
_decorate$7([carbonElement(`${c4dPrefix$7}-top-nav-menu-item`)], function (_initialize, _CDSHeaderMenuItem) {
  class C4DTopNavMenuItem extends _CDSHeaderMenuItem {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DTopNavMenuItem,
    d: [{
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value:
      // `styles` here is a `CSSResult` generated by custom WebPack loader

      function firstUpdated() {
        var _this$shadowRoot;
        (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll('[role="menuitem"]').forEach(menuItem => menuItem.removeAttribute('role'));
      }
    }]
  };
}, CDSHeaderMenuItem);

/**
 * @license
 *
 * Copyright IBM Corp. 2019, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const svgResultCarbonIcon = ({ children, ...attrs } = {}) =>
  b`<svg focusable="false" preserveAspectRatio="xMidYMid meet" xmlns="http://www.w3.org/2000/svg" fill="currentColor" ...="${spread(
    attrs
  )}" aria-hidden="true" width="20" height="20" viewBox="0 0 32 32">${children}<path d="M29,27.5859l-7.5521-7.5521a11.0177,11.0177,0,1,0-1.4141,1.4141L27.5859,29ZM4,13a9,9,0,1,1,9,9A9.01,9.01,0,0,1,4,13Z"></path></svg>`;

/**
 * @constant {string | string} Host for the API calls
 * @private
 */
var _host = process && process.env.SEARCH_TYPEAHEAD_API || 'https://www-api.ibm.com';
/**
 * @constant {string | string} API version
 * @private
 */
var _version = process && process.env.SEARCH_TYPEAHEAD_VERSION || 'v1';
/**
 * SearchTypeahead endpoint
 *
 * @type {string}
 * @private
 */
var _endpoint = "".concat(_host, "/search/typeahead/").concat(_version);
/**
 * SearchTypeahead API class with methods of fetching search results for
 * ibm.com
 */
var SearchTypeaheadAPI = /*#__PURE__*/function () {
  function SearchTypeaheadAPI() {
    _classCallCheck$2(this, SearchTypeaheadAPI);
  }
  return _createClass$2(SearchTypeaheadAPI, null, [{
    key: "getResults",
    value: (
    /**
     * Gets search results
     *
     * @param {string} query Query string to pass to the service
     * @returns {Promise<any>} Response data from ibm search
     * @example
     * import { SearchTypeaheadAPI } from '@carbon/ibmdotcom-services';
     *
     * async function getResults(query) {
     *   const response = await SearchTypeaheadAPI.getResults(query);
     *   return response;
     * }
     */
    function () {
      var _getResults = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(query) {
        var appid,
          lang,
          urlQuery,
          url,
          _args = arguments;
        return regenerator.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              appid = _args.length > 1 && _args[1] !== undefined ? _args[1] : '';
              _context.next = 3;
              return LocaleAPI.getLang();
            case 3:
              lang = _context.sent;
              urlQuery = ["lang=".concat(lang.lc).concat(lang.cc ? "&cc=".concat(lang.cc) : ''), "query=".concat(encodeURIComponent(query)), "".concat(appid ? "appid=".concat(appid) : '')].filter(function (item) {
                return item;
              }).join('&');
              url = "".concat(_endpoint, "?").concat(urlQuery);
              _context.next = 8;
              return axios$1.get(url, {
                headers: {
                  'Content-Type': 'application/json; charset=utf-8'
                }
              }).then(function (response) {
                return response.data.response;
              });
            case 8:
              return _context.abrupt("return", _context.sent);
            case 9:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function getResults(_x) {
        return _getResults.apply(this, arguments);
      }
      return getResults;
    }())
  }]);
}();

var styles$1 = i$4(["/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n*/\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--header {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: fixed;\n  z-index: 8000;\n  display: flex;\n  align-items: center;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: 1px solid var(--cds-border-subtle);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n}\n.cds--header *,\n.cds--header *::before,\n.cds--header *::after {\n  box-sizing: inherit;\n}\n\n.cds--header__action {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: inline-flex;\n  border: 0.0625rem solid transparent;\n  block-size: 3rem;\n  inline-size: 3rem;\n  transition: background-color 110ms, border-color 110ms;\n}\n.cds--header__action *,\n.cds--header__action *::before,\n.cds--header__action *::after {\n  box-sizing: inherit;\n}\n.cds--header__action::-moz-focus-inner {\n  border: 0;\n}\n@media (max-width: 41.98rem) {\n  .cds--header__action {\n    min-inline-size: 3rem;\n  }\n}\n\n.cds--header__global .cds--popover {\n  z-index: 8001;\n}\n\n.cds--header__action > :first-child {\n  margin-block-start: 0;\n}\n\n.cds--header__action > svg.cds--navigation-menu-panel-collapse-icon,\n.cds--header__action--active > svg.cds--navigation-menu-panel-expand-icon {\n  display: none;\n}\n\n.cds--header__action--active > svg.cds--navigation-menu-panel-collapse-icon {\n  display: inline;\n}\n\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__action--active {\n  background: var(--cds-layer);\n  border-block-end: 1px solid transparent;\n  border-inline-end: 1px solid var(--cds-border-subtle);\n  border-inline-start: 1px solid var(--cds-border-subtle);\n}\n\n.cds--header__action--active > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__action:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--header__action:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n\n.cds--header__action.cds--btn--icon-only {\n  align-items: center;\n  justify-content: center;\n}\n\n.cds--btn.cds--btn--icon-only.cds--header__action svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--btn.cds--btn--icon-only.cds--header__action:hover svg,\n.cds--btn.cds--btn--icon-only.cds--header__action:active svg,\n.cds--btn.cds--btn--icon-only.cds--header__action--active svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-trigger > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-trigger:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-toggle {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n@media (min-width: 66rem) {\n  .cds--header__menu-toggle__hidden {\n    display: none;\n  }\n}\n\na.cds--header__name {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  padding: 0 2rem 0 1rem;\n  border: 0.125rem solid transparent;\n  block-size: 100%;\n  font-weight: 600;\n  letter-spacing: 0.1px;\n  line-height: 1.25rem;\n  outline: none;\n  text-decoration: none;\n  transition: border-color 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n@media (max-width: 41.98rem) {\n  a.cds--header__name {\n    padding: 0 1rem;\n  }\n}\n\na.cds--header__name:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--header__name--prefix {\n  font-weight: 400;\n}\n\na.cds--header__name,\na.cds--header__name:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-toggle:not(.cds--header__menu-toggle__hidden) ~ .cds--header__name {\n  padding-inline-start: 0.5rem;\n}\n\n.cds--header__nav {\n  position: relative;\n  display: none;\n  block-size: 100%;\n  padding-inline-start: 1rem;\n}\n@media (min-width: 66rem) {\n  .cds--header__nav {\n    display: block;\n  }\n}\n.cds--header__nav::before {\n  position: absolute;\n  display: block;\n  background-color: var(--cds-border-subtle);\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__menu-bar {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: flex;\n  padding: 0;\n  margin: 0;\n  block-size: 100%;\n  list-style: none;\n}\n.cds--header__menu-bar *,\n.cds--header__menu-bar *::before,\n.cds--header__menu-bar *::after {\n  box-sizing: inherit;\n}\n\na.cds--header__menu-item {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: 2px solid transparent;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  color: var(--cds-text-secondary, #525252);\n  font-size: 0.875rem;\n  font-weight: 400;\n  letter-spacing: 0;\n  line-height: 1.125rem;\n  text-decoration: none;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\na.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__action:active,\na.cds--header__menu-item:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--header__menu-item:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\na.cds--header__menu-item:hover > svg,\na.cds--header__menu-item:active > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\na.cds--header__menu-item[aria-current=page],\n.cds--header__menu-item--current {\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--header__menu-item[aria-current=page]::after,\n.cds--header__menu-item--current::after {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: 3px;\n  content: \"\";\n  inline-size: calc(100% + 4px);\n  inset-block-end: -2px;\n  inset-inline-start: -2px;\n}\n\na.cds--header__menu-item[aria-current=page]:focus::after,\n.cds--header__menu-item--current:focus::after {\n  border: 0;\n}\n\n.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]::after,\n.cds--header__submenu .cds--header__menu .cds--header__menu-item--current::after {\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: calc(100% + 4px);\n  inline-size: 3px;\n  inset-block-start: -2px;\n  inset-inline-start: -2px;\n}\n.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after,\n.cds--header__submenu .cds--header__menu .cds--header__menu-item--current:focus::after {\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: calc(100% + 4px);\n  inline-size: 5px;\n  inset-block-start: -2px;\n  inset-inline-start: -2px;\n}\n\na.cds--header__menu-item[aria-current=page]:focus,\na.cds--header__menu-item.cds--header__menu-item--current:focus {\n  border: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--header__submenu {\n  position: relative;\n}\n\n.cds--header__menu-title[aria-haspopup=true] {\n  position: relative;\n}\n\n.cds--header__menu-title[aria-expanded=true] {\n  z-index: 8002;\n  background-color: var(--cds-layer);\n  color: var(--cds-text-secondary, #525252);\n}\n\n.cds--header__menu-title[aria-expanded=true] > .cds--header__menu-arrow {\n  transform: rotate(180deg);\n}\n\n.cds--header__menu {\n  display: none;\n  padding: 0;\n  margin: 0;\n  list-style: none;\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  position: absolute;\n  z-index: 8001;\n  display: flex;\n  flex-direction: column;\n  background-color: var(--cds-layer);\n  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.5);\n  inline-size: 12.5rem;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item {\n  background-color: var(--cds-layer);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:active {\n  background-color: var(--cds-layer-active);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item.cds--header__menu-item--current {\n  background-color: var(--cds-layer-selected);\n}\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n\n.cds--header__menu .cds--header__menu-item {\n  block-size: 3rem;\n}\n\n.cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n  margin-inline-start: 0.5rem;\n  transition: transform 110ms, fill 110ms;\n}\n\n.cds--header__global {\n  display: flex;\n  flex: 1 1 0%;\n  justify-content: flex-end;\n  block-size: 100%;\n}\n\n.cds--skip-to-content {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--skip-to-content:focus {\n  z-index: 9999;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: 4px solid var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  clip: auto;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: auto;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  outline: none;\n}\n\n.cds--side-nav {\n  position: fixed;\n  z-index: 8000;\n  overflow: hidden;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 3rem;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  max-inline-size: 16rem;\n  transition: inline-size 0.11s cubic-bezier(0.2, 0, 1, 0.9), transform 0.11s cubic-bezier(0.2, 0, 1, 0.9);\n  will-change: inline-size;\n}\n\n.cds--side-nav--ux {\n  inline-size: 16rem;\n  inset-block-start: 3rem;\n}\n@media (max-width: 65.98rem) {\n  .cds--side-nav--ux {\n    inline-size: 0;\n  }\n}\n\n.cds--side-nav--rail {\n  inline-size: 3rem;\n}\n\n.cds--side-nav--hidden {\n  inline-size: 0;\n}\n\n.cds--side-nav--expanded {\n  inline-size: 16rem;\n}\n\n.cds--side-nav__overlay {\n  position: fixed;\n  background-color: transparent;\n  block-size: 0;\n  inline-size: 0;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n}\n\n@media (max-width: 65.98rem) {\n  .cds--side-nav__overlay-active {\n    z-index: 6000;\n    background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n    block-size: 100vh;\n    inline-size: 100vw;\n    opacity: 1;\n    transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  }\n}\n\n.cds--header ~ .cds--side-nav {\n  block-size: calc(100% - 48px);\n  inset-block-start: 3rem;\n}\n\n.cds--side-nav--fixed {\n  inline-size: 16rem;\n}\n\n.cds--side-nav--collapsed {\n  inline-size: 16rem;\n  transform: translateX(-16rem);\n}\n\n.cds--side-nav__navigation {\n  display: flex;\n  flex-direction: column;\n}\n\n.cds--side-nav__items {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  overflow: hidden;\n  flex: 1 1 0%;\n  padding: 1rem 0 0;\n}\n.cds--side-nav__items *,\n.cds--side-nav__items *::before,\n.cds--side-nav__items *::after {\n  box-sizing: inherit;\n}\n.cds--side-nav:hover .cds--side-nav__items, .cds--side-nav--fixed .cds--side-nav__items, .cds--side-nav--expanded .cds--side-nav__items {\n  overflow-y: auto;\n}\n\n.cds--side-nav--ux .cds--side-nav__items {\n  overflow-y: auto;\n}\n\n.cds--side-nav__item {\n  overflow: hidden;\n  block-size: auto;\n  inline-size: auto;\n}\n\n.cds--side-nav--ux .cds--side-nav__item {\n  block-size: auto;\n  inline-size: auto;\n}\n\n.cds--side-nav__item:not(.cds--side-nav__item--active):hover .cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__submenu:hover,\n.cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__link:hover,\n.cds--side-nav__menu a.cds--side-nav__link:not(.cds--side-nav__link--current):not([aria-current=page]):hover,\n.cds--side-nav a.cds--header__menu-item:hover,\n.cds--side-nav .cds--header__menu-title[aria-expanded=true]:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__link:hover > span,\n.cds--side-nav__item:not(.cds--side-nav__item--active) .cds--side-nav__menu-item > .cds--side-nav__link:hover > span {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item--large {\n  block-size: auto;\n}\n\n.cds--side-nav__divider {\n  margin: 0.5rem 1rem;\n  background-color: var(--cds-border-subtle);\n  block-size: 1px;\n  list-style-type: none;\n}\n\n.cds--side-nav__divider hr {\n  border: none;\n}\n\n.cds--side-nav__submenu {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  block-size: 2rem;\n  color: var(--cds-text-secondary, #525252);\n  transition: color 110ms, background-color 110ms, outline 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--side-nav__submenu *,\n.cds--side-nav__submenu *::before,\n.cds--side-nav__submenu *::after {\n  box-sizing: inherit;\n}\n.cds--side-nav__submenu::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--side-nav__submenu:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__submenu:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--side-nav__submenu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--side-nav__submenu-title {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  text-align: start;\n}\n\n.cds--side-nav__icon.cds--side-nav__submenu-chevron {\n  display: flex;\n  flex: 1;\n  justify-content: flex-end;\n}\n\n.cds--side-nav__submenu-chevron > svg {\n  block-size: 1rem;\n  inline-size: 1rem;\n  transition: transform 110ms;\n}\n\n.cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  transform: rotate(180deg);\n}\n\n.cds--side-nav__item--large .cds--side-nav__submenu {\n  block-size: 3rem;\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu:hover {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false] {\n  position: relative;\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false]::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 3px;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu-title {\n  color: var(--cds-text-primary, #161616);\n  font-weight: 600;\n}\n\n.cds--side-nav__item--active .cds--side-nav__icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--side-nav__menu {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: block;\n  max-block-size: 0;\n  visibility: hidden;\n}\n.cds--side-nav__menu *,\n.cds--side-nav__menu *::before,\n.cds--side-nav__menu *::after {\n  box-sizing: inherit;\n}\n\n.cds--side-nav__submenu[aria-expanded=true] + .cds--side-nav__menu {\n  max-block-size: 93.75rem;\n  visibility: inherit;\n}\n\n.cds--side-nav__menu a.cds--side-nav__link {\n  block-size: 2rem;\n  font-weight: 400;\n  min-block-size: 2rem;\n  padding-inline-start: 2rem;\n}\n\n.cds--side-nav__item.cds--side-nav__item--icon a.cds--side-nav__link {\n  padding-inline-start: 4.5rem;\n}\n\n.cds--side-nav__menu a.cds--side-nav__link--current,\n.cds--side-nav__menu a.cds--side-nav__link[aria-current=page],\na.cds--side-nav__link--current {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n.cds--side-nav__menu a.cds--side-nav__link--current > span,\n.cds--side-nav__menu a.cds--side-nav__link[aria-current=page] > span,\na.cds--side-nav__link--current > span {\n  color: var(--cds-text-primary, #161616);\n  font-weight: 600;\n}\n\na.cds--side-nav__link,\n.cds--side-nav a.cds--header__menu-item,\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  min-block-size: 2rem;\n  text-decoration: none;\n  transition: color 110ms, background-color 110ms, outline 110ms;\n}\n\n.cds--side-nav__item--large a.cds--side-nav__link {\n  block-size: 3rem;\n}\n\na.cds--side-nav__link > .cds--side-nav__link-text,\n.cds--side-nav a.cds--header__menu-item .cds--text-truncate-end {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  color: var(--cds-text-secondary, #525252);\n  font-size: 0.875rem;\n  letter-spacing: 0.1px;\n  line-height: 1.25rem;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\na.cds--side-nav__link:focus,\n.cds--side-nav a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  a.cds--side-nav__link:focus,\n  .cds--side-nav a.cds--header__menu-item:focus {\n    outline-style: dotted;\n  }\n}\n\na.cds--side-nav__link[aria-current=page],\na.cds--side-nav__link--current {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  font-weight: 600;\n}\n\na.cds--side-nav__link[aria-current=page] .cds--side-nav__link-text,\na.cds--side-nav__link--current .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--side-nav__link[aria-current=page]::before,\na.cds--side-nav__link--current::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 3px;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--side-nav__icon {\n  display: flex;\n  flex: 0 0 1rem;\n  align-items: center;\n  justify-content: center;\n}\n\n.cds--side-nav__icon:not(.cds--side-nav__submenu-chevron) {\n  margin-inline-end: 1.5rem;\n}\n\n.cds--side-nav__icon > svg {\n  block-size: 1rem;\n  fill: var(--cds-icon-secondary, #525252);\n  inline-size: 1rem;\n}\n\n.cds--side-nav__icon > svg.cds--side-nav-collapse-icon {\n  display: none;\n}\n\n.cds--side-nav--expanded .cds--side-nav__icon > svg.cds--side-nav-expand-icon {\n  display: none;\n}\n\n.cds--side-nav--expanded .cds--side-nav__icon > svg.cds--side-nav-collapse-icon {\n  display: block;\n}\n\n.cds--side-nav--fixed a.cds--side-nav__link,\n.cds--side-nav--fixed .cds--side-nav__submenu {\n  padding-inline-start: 1rem;\n}\n\n.cds--side-nav--fixed .cds--side-nav__item:not(.cds--side-nav__item--icon) .cds--side-nav__menu a.cds--side-nav__link {\n  padding-inline-start: 2rem;\n}\n\n@media (max-width: 65.98rem) {\n  .cds--side-nav .cds--header__nav {\n    display: block;\n  }\n}\n\n.cds--side-nav__header-navigation {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: none;\n}\n.cds--side-nav__header-navigation *,\n.cds--side-nav__header-navigation *::before,\n.cds--side-nav__header-navigation *::after {\n  box-sizing: inherit;\n}\n@media (max-width: 65.98rem) {\n  .cds--side-nav__header-navigation {\n    position: relative;\n    display: block;\n    margin-block-end: 2rem;\n  }\n}\n\n.cds--side-nav__header-divider::after {\n  position: absolute;\n  background: var(--cds-border-subtle);\n  block-size: 0.0625rem;\n  content: \"\";\n  inline-size: calc(100% - 32px);\n  inset-block-end: -1rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--side-nav a.cds--header__menu-item {\n  justify-content: space-between;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n}\n.cds--side-nav a.cds--header__menu-item[aria-expanded=true] {\n  background-color: transparent;\n}\n\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  padding: 0;\n  background-color: transparent;\n  box-shadow: none;\n  inline-size: 100%;\n  inset-block-end: inherit;\n  transform: none;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li {\n  inline-size: 100%;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item {\n  font-weight: 400;\n  padding-inline-start: 4.25rem;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n\n.cds--side-nav .cds--side-nav__header-navigation a.cds--header__menu-item[aria-current=page]::after,\n.cds--side-nav .cds--side-nav__header-navigation .cds--header__menu-item--current::after {\n  block-size: calc(100% + 4px);\n  inline-size: 3px;\n}\n\n.cds--side-nav .cds--header__menu a.cds--header__menu-item {\n  block-size: inherit;\n}\n\n.cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,\n.cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,\n.cds--side-nav .cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--side-nav__icon > svg,\n  .cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,\n  .cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,\n  .cds--side-nav .cds--header__menu-arrow {\n    fill: ButtonText;\n  }\n}\n\ninput:-webkit-autofill,\ninput:-webkit-autofill:hover,\ninput:-webkit-autofill:focus,\ntextarea:-webkit-autofill,\ntextarea:-webkit-autofill:hover,\ntextarea:-webkit-autofill:focus {\n  box-shadow: 0 0 0 1000px var(--cds-field) inset;\n  -webkit-text-fill-color: var(--cds-text-primary, #161616);\n}\n\n.cds--fieldset {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n.cds--fieldset *,\n.cds--fieldset *::before,\n.cds--fieldset *::after {\n  box-sizing: inherit;\n}\n\n.cds--form-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n}\n\n.cds--label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: inline-block;\n  color: var(--cds-text-secondary, #525252);\n  font-weight: 400;\n  line-height: 1rem;\n  margin-block-end: 0.5rem;\n  vertical-align: baseline;\n}\n.cds--label html {\n  font-size: 100%;\n}\n.cds--label body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--label code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--label strong {\n  font-weight: 600;\n}\n\n.cds--label .cds--toggletip-label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n\n.cds--label--no-margin {\n  margin-block-end: 0;\n}\n\n.cds--label + .cds--tooltip {\n  position: relative;\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger *,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::before,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::after {\n  box-sizing: inherit;\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg :hover {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--label + .cds--toggletip {\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 0.875rem;\n  inline-size: 4.6875rem;\n}\n.cds--label.cds--skeleton:hover, .cds--label.cds--skeleton:focus, .cds--label.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--label.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--label.cds--skeleton::before {\n    animation: none;\n  }\n}\n\ninput[type=number] {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n}\n\ninput[data-invalid]:not(:focus),\n.cds--number[data-invalid] input[type=number]:not(:focus),\n.cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n.cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n.cds--combo-box--invalid--focused),\n.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  input[data-invalid]:not(:focus),\n  .cds--number[data-invalid] input[type=number]:not(:focus),\n  .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n  .cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n  .cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n  .cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n  .cds--combo-box--invalid--focused),\n  .cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--number__input-wrapper--warning ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--warn ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--time-picker--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning > .cds--text-input ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper--warn ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select--warning .cds--select-input__wrapper ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement,\n.cds--list-box--warning ~ .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid],\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  display: block;\n}\n\n.cds--form--fluid input[data-invalid] {\n  outline: none;\n}\n\n.cds--form--fluid .cds--form-requirement {\n  padding: 0.5rem 2.5rem 0.5rem 1rem;\n  margin: 0;\n}\n\ninput:not(output, [data-invalid]):-moz-ui-invalid {\n  box-shadow: none;\n}\n\n.cds--form-requirement {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: none;\n  overflow: hidden;\n  margin: 0.25rem 0 0;\n  max-block-size: 0;\n}\n.cds--form-requirement html {\n  font-size: 100%;\n}\n.cds--form-requirement body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--form-requirement code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--form-requirement strong {\n  font-weight: 600;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-start: 0;\n}\n\n.cds--form__helper-text {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n  z-index: 0;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  margin-block-start: 0.25rem;\n  opacity: 1;\n}\n\n.cds--label--disabled,\n.cds--form__helper-text--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\nfieldset[disabled] .cds--label,\nfieldset[disabled] .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input *,\n.cds--text-input *::before,\n.cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--text-input:focus, .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input:focus, .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n\n.cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n\n.cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n\n.cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n\n.cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--text-input--password__visibility:hover::before, .cds--text-input--password__visibility:hover::after, .cds--text-input--password__visibility:focus::before, .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n\n.cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n\n.cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n\n.cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--text-input--invalid,\n.cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n\n.cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n\n.cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--skeleton.cds--text-input:hover, .cds--skeleton.cds--text-input:focus, .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n\n.cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n\n.cds--text-input__divider,\n.cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n\n.cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n\n.cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n\n.cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n\n.cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n\n.cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n\n.cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n\n.cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n\n.cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n\n.cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\n.cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid:has(~ .cds--slug),\n.cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid ~ .cds--slug,\n.cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n\n.cds--tag {\n  --cds-layout-size-height-xs: 1.125rem;\n  --cds-layout-size-height-sm: 1.125rem;\n  --cds-layout-size-height-md: 1.5rem;\n  --cds-layout-size-height-lg: 2rem;\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 1rem;\n  margin: 0.25rem;\n  cursor: default;\n  max-inline-size: 13rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  min-inline-size: 2rem;\n  padding-inline: 0.5rem;\n  vertical-align: middle;\n  word-break: break-word;\n}\n.cds--layout--size-xs .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-xs);\n}\n.cds--layout--size-sm .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--tag.cds--tag--operational {\n  border: 1px solid var(--cds-tag-background-gray, #e0e0e0);\n}\n.cds--tag.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag.cds--tag--lg {\n  padding-inline-start: 0.75rem;\n}\n.cds--tag:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.25rem;\n}\n.cds--tag.cds--tag--lg:not(.cds--tag--filter) {\n  padding-inline: 0.75rem;\n}\n.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.5rem;\n}\n.cds--tag:not(.cds--tag--selectable) {\n  border: 0;\n}\n.cds--tag:not(:first-child) {\n  margin-inline-start: 0;\n}\n\n.cds--tag--operational > span,\n.cds--tag--selectable > span,\n.cds--tag__label {\n  display: block;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--tag--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--filter {\n  padding-block-end: 0;\n  padding-block-start: 0;\n  padding-inline-end: 0;\n}\n.cds--tag--filter:hover {\n  outline: none;\n}\n\n.cds--tag--selectable {\n  border: 1px solid var(--cds-border-inverse, #161616);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--tag--selectable:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--tag--selectable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--selectable-selected {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--selectable-selected:hover {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  cursor: pointer;\n}\n.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n  outline: none;\n}\n.cds--tag--operational:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--red {\n  background-color: var(--cds-tag-background-red, #ffd7d9);\n  color: var(--cds-tag-color-red, #a2191f);\n}\n.cds--tag--red.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-red, #ff8389);\n}\n.cds--tag--red.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n.cds--tag--red .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n\n.cds--tag--magenta {\n  background-color: var(--cds-tag-background-magenta, #ffd6e8);\n  color: var(--cds-tag-color-magenta, #9f1853);\n}\n.cds--tag--magenta.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-magenta, #ff7eb6);\n}\n.cds--tag--magenta.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n.cds--tag--magenta .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n\n.cds--tag--purple {\n  background-color: var(--cds-tag-background-purple, #e8daff);\n  color: var(--cds-tag-color-purple, #6929c4);\n}\n.cds--tag--purple.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-purple, #be95ff);\n}\n.cds--tag--purple.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n.cds--tag--purple .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n\n.cds--tag--blue {\n  background-color: var(--cds-tag-background-blue, #d0e2ff);\n  color: var(--cds-tag-color-blue, #0043ce);\n}\n.cds--tag--blue.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-blue, #78a9ff);\n}\n.cds--tag--blue.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n.cds--tag--blue .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n\n.cds--tag--cyan {\n  background-color: var(--cds-tag-background-cyan, #bae6ff);\n  color: var(--cds-tag-color-cyan, #00539a);\n}\n.cds--tag--cyan.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cyan, #33b1ff);\n}\n.cds--tag--cyan.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n.cds--tag--cyan .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n\n.cds--tag--teal {\n  background-color: var(--cds-tag-background-teal, #9ef0f0);\n  color: var(--cds-tag-color-teal, #005d5d);\n}\n.cds--tag--teal.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-teal, #08bdba);\n}\n.cds--tag--teal.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n.cds--tag--teal .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n\n.cds--tag--green {\n  background-color: var(--cds-tag-background-green, #a7f0ba);\n  color: var(--cds-tag-color-green, #0e6027);\n}\n.cds--tag--green.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-green, #42be65);\n}\n.cds--tag--green.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n.cds--tag--green .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n\n.cds--tag--gray {\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n}\n.cds--tag--gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n}\n.cds--tag--gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag--gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n\n.cds--tag--cool-gray {\n  background-color: var(--cds-tag-background-cool-gray, #dde1e6);\n  color: var(--cds-tag-color-cool-gray, #121619);\n}\n.cds--tag--cool-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cool-gray, #a2a9b0);\n}\n.cds--tag--cool-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n.cds--tag--cool-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n\n.cds--tag--warm-gray {\n  background-color: var(--cds-tag-background-warm-gray, #e5e0df);\n  color: var(--cds-tag-color-warm-gray, #171414);\n}\n.cds--tag--warm-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-warm-gray, #ada8a8);\n}\n.cds--tag--warm-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n.cds--tag--warm-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n\n.cds--tag--high-contrast:not(.cds--tag--operational) {\n  background-color: var(--cds-background-inverse, #393939);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational {\n  border: 1px solid var(--cds-background-inverse, #393939);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  outline: 1px solid var(--cds-background-inverse, #393939);\n  outline-offset: -1px;\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational {\n  border: 1px solid var(--cds-background, #ffffff);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--tag--disabled:not(.cds--tag--operational),\n.cds--tag--filter.cds--tag--disabled,\n.cds--tag--interactive.cds--tag--disabled {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  box-shadow: none;\n  outline: none;\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational {\n  border: 1px solid var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational):hover,\n.cds--tag--filter.cds--tag--disabled:hover,\n.cds--tag--interactive.cds--tag--disabled:hover {\n  cursor: not-allowed;\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,\n.cds--tag--filter.cds--tag--disabled .cds--tag__label,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__label {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--selectable.cds--tag--disabled,\n.cds--tag--operational.cds--tag--disabled {\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--tag--selectable.cds--tag--disabled:hover,\n.cds--tag--operational.cds--tag--disabled:hover {\n  background-color: var(--cds-layer);\n  cursor: not-allowed;\n}\n\n.cds--tag--interactive {\n  transition: background-color 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--tag__close-icon {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: 50%;\n  margin: 0 0 0 0.125rem;\n  background-color: transparent;\n  block-size: var(--cds-layout-size-height-local);\n  color: currentColor;\n  cursor: pointer;\n  inline-size: var(--cds-layout-size-height-local);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tag__close-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag__custom-icon {\n  flex-shrink: 0;\n  padding: 0;\n  border: 0;\n  background-color: transparent;\n  block-size: 1rem;\n  color: currentColor;\n  inline-size: 1rem;\n  margin-inline-end: 0.25rem;\n  outline: none;\n}\n.cds--tag__custom-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag--disabled .cds--tag__close-icon {\n  cursor: not-allowed;\n}\n\n.cds--tag__close-icon:focus {\n  z-index: 99999;\n  border-radius: 50%;\n  box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--tag--high-contrast .cds--tag__close-icon:focus {\n  box-shadow: inset 0 0 0 1px var(--cds-focus-inverse, #ffffff);\n}\n\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: transparent;\n}\n\n.cds--tag--filter.cds--tag--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--sm.cds--tag--filter {\n  padding-inline-end: 0;\n}\n\n.cds--tag--sm .cds--tag__close-icon {\n  margin-inline-start: 0.3125rem;\n}\n\n.cds--tag.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n  color: var(--cds-text-primary, #161616);\n  overflow: hidden;\n  inline-size: 3.75rem;\n}\n.cds--tag.cds--skeleton:hover, .cds--tag.cds--skeleton:focus, .cds--tag.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--tag.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--tag.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--tag.cds--skeleton.cds--tag--operational {\n  border: 1px solid var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton.cds--tag--operational:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton .cds--tag__close-icon:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n@media not all and (min-resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tag.cds--skeleton {\n      transform: translateZ(0);\n    }\n  }\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline {\n  color: currentColor;\n  margin-inline-start: 0.0625rem;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before {\n  background-color: currentColor;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline:hover {\n  border-color: currentColor;\n}\n\n/* stylelint-disable */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon svg,\n  .cds--tag__custom-icon svg {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n.cds--tag-label-tooltip {\n  max-inline-size: -webkit-fill-available;\n}\n\n.cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 11rem;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 9.875rem;\n}\n\n/* stylelint-enable */\n.cds--interactive--tag-children {\n  display: inline-flex;\n  max-inline-size: 12.5rem;\n  place-items: center;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + span > .cds--interactive--tag-children {\n  max-inline-size: 11.5rem;\n}\n\n.cds--tag .cds--definition-term {\n  border-block-end: none;\n  cursor: default;\n  max-inline-size: 12rem;\n}\n\n.cds--tag .cds--tag__custom-icon + span > .cds--definition-term {\n  max-inline-size: 11rem;\n}\n\n.cds--tag > .cds--popover-container {\n  display: flex;\n}\n\n.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled) {\n  pointer-events: none;\n}\n\n.cds--list-box__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0.25rem;\n  grid-template: auto auto/auto auto;\n}\n.cds--list-box__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--list-box__wrapper--inline .cds--label,\n.cds--list-box__wrapper--inline .cds--form__helper-text,\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--list-box__wrapper--inline .cds--form__helper-text {\n  max-inline-size: none;\n}\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--list-box {\n  position: relative;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  max-block-size: 2.5rem;\n  transition: all 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box html {\n  font-size: 100%;\n}\n.cds--list-box body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--list-box code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--list-box strong {\n  font-weight: 600;\n}\n.cds--list-box:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--list-box--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box--expanded:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--expanded:hover.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box .cds--text-input {\n  block-size: 100%;\n  min-inline-size: 0;\n}\n\n.cds--list-box__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--list-box__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--list-box.cds--list-box--warning .cds--list-box__field {\n  border-block-end: 0;\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field,\n.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--list-box--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--list-box--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--light .cds--list-box__menu {\n  background: var(--cds-layer);\n}\n\n.cds--list-box--light .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle);\n}\n\n.cds--list-box--light.cds--list-box--expanded {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box--disabled:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--light.cds--list-box--disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__field:focus {\n  border-block-end-color: transparent;\n  outline: none;\n}\n\n.cds--list-box--disabled .cds--list-box__label,\n.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled .cds--list-box__menu-icon > svg,\n.cds--list-box--disabled .cds--list-box__selection > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item,\n.cds--list-box--disabled .cds--list-box__menu-item:hover,\n.cds--list-box--disabled .cds--list-box__menu-item--highlighted {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  text-decoration: none;\n}\n\n.cds--list-box--disabled .cds--list-box__selection:hover {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 2rem;\n}\n\n.cds--list-box.cds--list-box--inline {\n  border-width: 0;\n  background-color: transparent;\n}\n.cds--list-box.cds--list-box--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded {\n  border-block-end-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true] {\n  border-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover,\n.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover {\n  background-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__field {\n  padding: 0 2rem 0 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--inline .cds--list-box__field {\n  block-size: 100%;\n}\n\n.cds--dropdown--inline .cds--list-box__field {\n  max-inline-size: 30rem;\n}\n\n.cds--dropdown--inline .cds--list-box__menu {\n  max-inline-size: 30rem;\n  min-inline-size: 18rem;\n}\n\n.cds--list-box__field {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  overflow: hidden;\n  align-items: center;\n  block-size: calc(100% + 1px);\n  cursor: pointer;\n  outline: none;\n  padding-block: 0;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  vertical-align: top;\n  white-space: nowrap;\n}\n.cds--list-box__field *,\n.cds--list-box__field *::before,\n.cds--list-box__field *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__field::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__field:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__field:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__field[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--list-box__field .cds--text-input {\n  padding-inline-end: 5rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input,\n.cds--list-box--warning .cds--list-box__field .cds--text-input {\n  padding-inline-end: 6.5625rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon {\n  inset-inline-end: 5.125rem;\n}\n\n.cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--list-box__label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  overflow: hidden;\n  color: var(--cds-text-primary, #161616);\n  text-overflow: ellipsis;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n}\n\n.cds--list-box__menu-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-inline-end: 0.75rem;\n  outline: none;\n  transition: transform 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu-icon *,\n.cds--list-box__menu-icon *::before,\n.cds--list-box__menu-icon *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-icon::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__menu-icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box__menu-icon--open {\n  justify-content: center;\n  inline-size: 1.5rem;\n  transform: rotate(180deg);\n}\n\n.cds--list-box__selection {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-block-start: 50%;\n  /* to preserve .5rem space between icons according to spec top/transform used to center the combobox clear selection icon in IE11 */\n  inset-inline-end: 2.8125rem;\n  transform: translateY(-50%);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__selection *,\n.cds--list-box__selection *::before,\n.cds--list-box__selection *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__selection::-moz-focus-inner {\n  border: 0;\n}\n.cds--list-box__selection:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__selection:focus:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__selection > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__selection:focus {\n  outline: none;\n}\n\n.cds--list-box__selection--multi {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  position: static;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding: 0.5rem;\n  border-radius: 0.75rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: 1.5rem;\n  color: var(--cds-text-inverse, #ffffff);\n  inline-size: auto;\n  inset-block-start: auto;\n  line-height: 0;\n  margin-inline-end: 0.625rem;\n  padding-inline-end: 0.125rem;\n  transform: none;\n}\n\n.cds--list-box__selection--multi > svg {\n  padding: 0.125rem;\n  block-size: 1.25rem;\n  fill: var(--cds-icon-inverse, #ffffff);\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n.cds--list-box__selection--multi > svg:hover {\n  border-radius: 50%;\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n\n.cds--list-box--disabled .cds--list-box__selection--multi {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  color: var(--cds-layer);\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational {\n  border: 1px solid var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg:hover {\n  background-color: initial;\n}\n\n.cds--list-box__selection--multi:hover {\n  outline: none;\n}\n\n.cds--list-box__menu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  position: absolute;\n  z-index: 9100;\n  display: none;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu {\n  display: none;\n  max-block-size: 0;\n  visibility: hidden;\n}\n\n.cds--list-box--expanded .cds--list-box__menu {\n  display: block;\n  max-block-size: 13.75rem;\n}\n\n.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu {\n  max-block-size: 16.5rem;\n}\n\n.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu {\n  max-block-size: 11rem;\n}\n\n.cds--list-box__menu-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  block-size: 2.5rem;\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  transition: background 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--light .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item {\n  block-size: 2rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item {\n  block-size: 3rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover {\n  background-color: transparent;\n}\n\n.cds--list-box--light .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item:hover .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item__option {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-end: 1px solid transparent;\n  border-block-start: 1px solid transparent;\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  padding-inline-end: 1.5rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  transition: border-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  white-space: nowrap;\n}\n.cds--list-box__menu-item__option *,\n.cds--list-box__menu-item__option *::before,\n.cds--list-box__menu-item__option *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-item__option:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  border-color: transparent;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item__option:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__menu-item__option:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item__option {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item__option {\n  block-size: 3rem;\n  padding-block-end: 0.9375rem;\n  padding-block-start: 0.9375rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,\n.cds--list-box--disabled .cds--list-box__menu-item__option {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled],\n.cds--list-box__menu-item[disabled] *,\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  outline: none;\n}\n\n.cds--list-box__menu-item[disabled]:hover {\n  background-color: revert;\n}\n\n.cds--list-box__menu-item[disabled] .cds--checkbox-label::before {\n  border-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-two .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-three .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option {\n  margin: 0 0.5rem;\n}\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus {\n  margin: 0;\n  padding-inline-end: 0.5rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--list-box__menu-item--highlighted {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item--highlighted {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,\n.cds--list-box__menu-item--highlighted + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--light .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n}\n\n.cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover);\n  border-block-end-color: var(--cds-layer-selected-hover);\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item > .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item__selected-icon {\n  position: absolute;\n  display: none;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box--inline .cds--list-box__menu-item__selected-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label {\n  inline-size: 100%;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label-text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--list-box--up .cds--list-box__menu {\n  inset-block-end: 2.5rem;\n}\n\n.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--sm .cds--list-box__menu {\n  inset-block-end: 2rem;\n}\n\n.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--lg .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n\n.cds--list-box input[role=combobox],\n.cds--list-box input[type=text] {\n  background-color: inherit;\n  min-inline-size: 0;\n  text-overflow: ellipsis;\n}\n\n.cds--list-box__wrapper--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 9px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after,\n.cds--list-box__wrapper--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box input[role=combobox] {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 8.8125rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning {\n  inset-inline-end: 5.1875rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before {\n  display: block;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug {\n  inset-inline-end: calc(4rem + 18px);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon {\n  inset-inline-end: 7.25rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field,\n  .cds--list-box__menu,\n  .cds--multi-select .cds--tag--filter {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field:focus,\n  .cds--multi-select .cds--tag__close-icon:focus,\n  .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-icon > svg,\n  .cds--list-box__selection > svg,\n  .cds--list-box__selection--multi > svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-start: 2.0625rem;\n}\n\n.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,\n.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-end: 2.0625rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--dropdown__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0 1.5rem;\n  grid-template: auto auto/auto min-content;\n}\n.cds--dropdown__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--dropdown__wrapper--inline .cds--label,\n.cds--dropdown__wrapper--inline .cds--form__helper-text,\n.cds--dropdown__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--dropdown__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--dropdown {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: relative;\n  display: block;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  list-style: none;\n  outline: 2px solid transparent;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--dropdown html {\n  font-size: 100%;\n}\n.cds--dropdown body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--dropdown code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--dropdown strong {\n  font-weight: 600;\n}\n.cds--dropdown:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--dropdown .cds--list-box__field {\n  text-align: start;\n}\n\n.cds--dropdown--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--dropdown--lg .cds--dropdown__arrow {\n  inset-block-start: 1rem;\n}\n\n.cds--dropdown--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--dropdown--sm .cds--dropdown__arrow {\n  inset-block-start: 0.5rem;\n}\n\n.cds--dropdown--open {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--dropdown--open .cds--list-box__field {\n  outline: none;\n}\n\n.cds--dropdown--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--dropdown--invalid .cds--dropdown-text {\n  padding-inline-end: 3.5rem;\n}\n.cds--dropdown--invalid + .cds--form-requirement {\n  display: inline-block;\n  color: var(--cds-text-error, #da1e28);\n  max-block-size: 12.5rem;\n}\n\n.cds--dropdown__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--dropdown--open:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--dropdown--open:focus {\n  outline: 1px solid transparent;\n}\n\n.cds--dropdown--open .cds--dropdown-list {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  max-block-size: 13.75rem;\n  transition: max-height 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--dropdown--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--dropdown--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--dropdown--up .cds--dropdown-list {\n  inset-block-end: 2rem;\n}\n\n.cds--dropdown__arrow {\n  position: absolute;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0.8125rem;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n  transform-origin: 50% 45%;\n  transition: transform 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\nbutton.cds--dropdown-text {\n  border: none;\n  background: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  text-align: start;\n}\nbutton.cds--dropdown-text:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  button.cds--dropdown-text:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-text {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: block;\n  overflow: hidden;\n  block-size: calc(100% + 1px);\n  padding-inline-end: 2.625rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--dropdown-list {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: absolute;\n  z-index: 9100;\n  display: flex;\n  flex-direction: column;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  list-style: none;\n  max-block-size: 0;\n  overflow-x: hidden;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--dropdown-list html {\n  font-size: 100%;\n}\n.cds--dropdown-list body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--dropdown-list code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--dropdown-list strong {\n  font-weight: 600;\n}\n\n.cds--dropdown--light .cds--dropdown-list {\n  background-color: var(--cds-layer);\n}\n\n.cds--dropdown:not(.cds--dropdown--open) .cds--dropdown-item {\n  visibility: hidden;\n}\n\n.cds--dropdown-item {\n  position: relative;\n  opacity: 0;\n  transition: visibility 70ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9), background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n.cds--dropdown-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--dropdown-item:hover + .cds--dropdown-item .cds--dropdown-link {\n  border-color: transparent;\n}\n.cds--dropdown-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--dropdown-item:first-of-type .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n\n.cds--dropdown-item:last-of-type .cds--dropdown-link {\n  border-block-end: none;\n}\n\n.cds--dropdown-link {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  border: 1px solid transparent;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-start-color: var(--cds-border-subtle);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n.cds--dropdown-link:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--dropdown--light .cds--dropdown-link {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--dropdown--sm .cds--dropdown-link {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--dropdown--focused,\n.cds--dropdown-link:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown--focused,\n  .cds--dropdown-link:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown-link:focus {\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  outline: none;\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown-item:active {\n  background-color: inherit;\n}\n\n.cds--dropdown-item:hover .cds--dropdown-link {\n  border-block-end-color: var(--cds-layer-hover);\n}\n\n.cds--dropdown--open .cds--dropdown__arrow {\n  transform: rotate(-180deg);\n}\n\n.cds--dropdown--open.cds--dropdown--sm .cds--dropdown-list {\n  max-block-size: 11rem;\n}\n\n.cds--dropdown--open .cds--dropdown-item {\n  opacity: 1;\n}\n\n.cds--dropdown--disabled {\n  border-block-end-color: transparent;\n}\n.cds--dropdown--disabled:hover {\n  background-color: var(--cds-field);\n}\n.cds--dropdown--disabled:focus {\n  outline: none;\n}\n.cds--dropdown--disabled .cds--dropdown-text,\n.cds--dropdown--disabled .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--dropdown--disabled .cds--dropdown__arrow,\n.cds--dropdown--disabled .cds--list-box__menu-icon svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--dropdown--disabled.cds--dropdown--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--dropdown--disabled .cds--list-box__field,\n.cds--dropdown--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--dropdown--auto-width {\n  inline-size: auto;\n  max-inline-size: 25rem;\n}\n\n.cds--dropdown--inline {\n  display: inline-block;\n  background-color: transparent;\n  border-block-end-color: transparent;\n  inline-size: auto;\n  justify-self: start;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n.cds--dropdown--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--dropdown--inline.cds--dropdown--disabled {\n  background-color: transparent;\n}\n.cds--dropdown--inline .cds--dropdown__arrow {\n  inset-block-start: 0.5rem;\n  inset-inline-end: 0.5rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--open {\n  background-color: transparent;\n}\n\n.cds--dropdown--inline .cds--dropdown-text {\n  display: inline-block;\n  overflow: visible;\n  padding: 0.4375rem 2rem 0.4375rem 0.75rem;\n  block-size: 2rem;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--dropdown--inline.cds--dropdown--disabled .cds--dropdown-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--dropdown--inline.cds--dropdown--disabled:focus .cds--dropdown-text {\n  outline: 0;\n}\n\n.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown-text {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--open:focus .cds--dropdown-list {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n}\n\n.cds--dropdown--inline .cds--dropdown-link {\n  font-weight: normal;\n}\n\n.cds--dropdown--show-selected .cds--dropdown--selected {\n  display: block;\n  background-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--dropdown--show-selected .cds--dropdown--selected:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n.cds--dropdown--show-selected .cds--dropdown--selected .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n.cds--dropdown--show-selected .cds--dropdown--selected + .cds--dropdown-item .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n.cds--dropdown--show-selected .cds--dropdown--selected .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--dropdown-v2.cds--skeleton,\n.cds--dropdown.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--dropdown-v2.cds--skeleton:hover, .cds--dropdown-v2.cds--skeleton:focus, .cds--dropdown-v2.cds--skeleton:active,\n.cds--dropdown.cds--skeleton:hover,\n.cds--dropdown.cds--skeleton:focus,\n.cds--dropdown.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--dropdown-v2.cds--skeleton::before,\n.cds--dropdown.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--dropdown-v2.cds--skeleton::before,\n  .cds--dropdown.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--dropdown .cds--list-box__field {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-item__option {\n    outline: none;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-item__selected-icon {\n    fill: ButtonText;\n  }\n}\n\n.cds--dropdown--readonly,\n.cds--dropdown--readonly:hover {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--dropdown--inline.cds--dropdown--readonly {\n  border-block-end-color: transparent;\n}\n\n.cds--dropdown--readonly .cds--list-box__field,\n.cds--dropdown--readonly .cds--list-box__menu-icon {\n  cursor: default;\n}\n\n.cds--dropdown--readonly .cds--list-box__menu-icon svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--select *,\n.cds--select *::before,\n.cds--select *::after {\n  box-sizing: inherit;\n}\n\n.cds--select-input__wrapper {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--select-input {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  border: none;\n  border-radius: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  font-family: inherit;\n  inline-size: 100%;\n  opacity: 1;\n  padding-block: 0;\n  padding-inline: 1rem 3rem;\n  text-overflow: ellipsis;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select-input::-ms-expand {\n  display: none;\n}\n@-moz-document url-prefix() {\n  .cds--select-input:-moz-focusring, .cds--select-input::-moz-focus-inner {\n    background-image: none;\n    color: transparent;\n    text-shadow: 0 0 0 #000000;\n  }\n}\n.cds--select-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--select-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--select-input:disabled, .cds--select-input:hover:disabled {\n  background-color: var(--cds-field);\n  border-block-end-color: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select-input--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--select-input--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--select--disabled .cds--label,\n.cds--select--disabled .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input,\n.cds--select--warning .cds--select-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--select-input:disabled ~ .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--light .cds--select-input {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--select--light .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select--light .cds--select-input:disabled, .cds--select--light .cds--select-input:hover:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select__arrow {\n  position: absolute;\n  block-size: 100%;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--select__arrow path {\n    fill: ButtonText;\n  }\n}\n\n.cds--select__invalid-icon {\n  position: absolute;\n  inset-inline-end: 2.5rem;\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon {\n  fill: var(--cds-support-error, #da1e28);\n}\n\n.cds--select__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--select__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\noptgroup.cds--select-optgroup,\n.cds--select-option {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\noptgroup.cds--select-optgroup:disabled,\n.cds--select-option:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--inline {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n\n.cds--select--inline.cds--select--invalid .cds--label,\n.cds--select--inline.cds--select--invalid .cds--form__helper-text {\n  align-self: flex-start;\n  margin-block-start: 0.8125rem;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-end: 0;\n  margin-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--label {\n  margin: 0 0.5rem 0 0;\n  white-space: nowrap;\n}\n\n.cds--select--inline .cds--select-input {\n  background-color: transparent;\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: auto;\n  padding-inline-end: 2rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--select-input:focus,\n.cds--select--inline .cds--select-input:focus option,\n.cds--select--inline .cds--select-input:focus optgroup {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.cds--select--inline .cds--select-input[disabled],\n.cds--select--inline .cds--select-input[disabled]:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--select--inline .cds--select__arrow {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--select--inline .cds--select-input:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--select--inline .cds--select-input:disabled ~ * {\n  cursor: not-allowed;\n}\n\n.cds--select--readonly .cds--select-input {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n  cursor: default;\n}\n\n.cds--select--readonly .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 2.5rem;\n  inline-size: 100%;\n}\n.cds--select.cds--skeleton:hover, .cds--select.cds--skeleton:focus, .cds--select.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--select.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--select.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--select.cds--skeleton .cds--select-input {\n  display: none;\n}\n\n.cds--select--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 8px + 1px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--select--slug .cds--slug::after,\n.cds--select--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--select--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--select--slug .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 4rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  padding-inline-end: 6rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before {\n  display: block;\n}\n\n.cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon,\n.cds--select--slug .cds--select-input__wrapper .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--select__arrow {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n* Copyright IBM Corp. 2016, 2021\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n:host(c4d-search-with-typeahead-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-search-with-typeahead-item) span {\n  font-weight: 600;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead-item):hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n:host(c4d-search-with-typeahead-item):hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-highlight-class:not(:hover), :host(c4d-search-with-typeahead-item):focus, :host(c4d-search-with-typeahead-item):active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead-item):last-of-type .cds--container-class {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead-item) span {\n  white-space: pre;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle] {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  color: var(--cds-text-helper, #6f6f6f);\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:active {\n  outline: none;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:hover {\n  background: none;\n  cursor: auto;\n}\n:host(c4d-search-with-typeahead-item)[lastBeforeGroup] .cds--container-class {\n  border-block-end-color: var(--cds-toggle-off, #8d8d8d);\n}\n\n:host(c4d-search-with-typeahead-item[alternate]) {\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n}\n\n:host(c4d-scoped-search-dropdown),\n:host(c4d-scoped-search-dropdown-mobile) {\n  display: flex;\n  border-inline-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box {\n  block-size: 3rem;\n  max-block-size: none;\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__field:focus,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box__field:focus {\n  outline: none;\n}\n\n@media (max-width: 65.98rem) {\n  :host(c4d-scoped-search-dropdown) {\n    display: none;\n  }\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__menu {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-scoped-search-dropdown-mobile) {\n  inline-size: 3rem;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select-input {\n  padding: 0;\n  color: transparent;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select__arrow {\n  position: absolute;\n  inset-inline: 0;\n  margin-inline: auto;\n  text-align: center;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--form__helper-text {\n  inline-size: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-scoped-search-dropdown-mobile) {\n    display: none;\n  }\n}\n\n:host(c4d-top-nav),\n.cds--header__search {\n  position: relative;\n  display: flex;\n  flex: 1;\n  align-items: center;\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav,\n.cds--header__search.cds--masthead__platform .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav::before,\n.cds--header__search.cds--masthead__platform .cds--header__nav::before {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--masthead__platform-name,\n.cds--header__search.cds--masthead__platform .cds--masthead__platform-name {\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active .cds--header__nav-container,\n.cds--header__search.cds--masthead__header--search-active .cds--header__nav-container {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n.cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n  .cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n    display: flex;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--header__search:not(.cds--masthead__header--search-active) {\n    overflow-x: visible;\n  }\n}\n\n.cds--header__action {\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border: 0.125rem solid transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__action > svg {\n  position: relative;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__action:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__action:focus, .cds--header__action:active {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__search--actions {\n  position: absolute;\n  display: flex;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--header__search--actions .cds--header__search--search,\n.cds--header__search--actions .cds--header__search--close {\n  padding: 0;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-icon-secondary, #525252);\n}\n.cds--header__search--actions .cds--header__search--search:hover,\n.cds--header__search--actions .cds--header__search--close:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__search--actions .cds--header__search--search:hover svg[focusable=false][aria-hidden=true],\n.cds--header__search--actions .cds--header__search--close:hover svg[focusable=false][aria-hidden=true] {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text, .cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text {\n  display: none;\n}\n\n.cds--header__profile .cds--header__action:focus,\n.cds--header__search--actions .cds--btn.cds--btn--icon-only.cds--tooltip__trigger:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\nbutton.cds--header__search--close.cds--header__action[part=close-button] {\n  display: none;\n  overflow: hidden;\n  border: none;\n  inline-size: 0;\n}\nbutton.cds--header__search--close.cds--header__action[part=close-button] svg {\n  position: relative;\n}\n\n.cds--header__search--search {\n  inline-size: 3rem;\n  outline: none;\n}\n\n:host(c4d-search-with-typeahead) {\n  position: relative;\n  display: block;\n  block-size: 3rem;\n  margin-inline-start: 3rem;\n  outline: none;\n}\n:host(c4d-search-with-typeahead) .c4d-ce__search__list {\n  overflow: hidden;\n  margin: 0;\n  block-size: 0;\n}\n:host(c4d-search-with-typeahead)[open] .c4d-ce__search__list {\n  padding: 0;\n  block-size: auto;\n}\n:host(c4d-search-with-typeahead)[active] {\n  z-index: 999;\n  inline-size: 100%;\n  margin-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action[part=close-button] {\n  display: inline-flex;\n  min-inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action.cds--header__search--hide {\n  display: none;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--actions {\n  z-index: 10001;\n}\n:host(c4d-search-with-typeahead)[active] .react-autosuggest__container::after {\n  position: absolute;\n  z-index: 10002;\n  display: block;\n  block-size: 0.125rem;\n  border-block-end: 0.125rem solid var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input {\n  z-index: 10000;\n  display: flex;\n  flex: 1;\n  padding: 0 1rem;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close {\n  display: inline-flex;\n  inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search {\n  border: 0.125rem solid transparent;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close:focus, :host(c4d-search-with-typeahead)[active] .cds--header__search--close:active,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:focus,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:active {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__action {\n  background-color: var(--cds-layer-01, #f4f4f4);\n  transition-delay: 380ms;\n  transition-duration: 112ms;\n  transition-property: width;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-search-with-typeahead)[scope-value] .react-autosuggest__suggestions-container {\n    inline-size: calc(100% - 3rem);\n    inset-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] {\n    background: var(--cds-layer-01, #f4f4f4);\n    inset-block-start: 0;\n    outline: 0.125rem solid transparent;\n    transition: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n    border-block-end: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n    outline: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n    display: flex;\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n    inline-size: 100%;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n    position: absolute;\n    z-index: 2;\n    fill: var(--cds-icon-secondary, #525252);\n    inset-block-start: 50%;\n    inset-inline-start: 1rem;\n    pointer-events: none;\n    transform: translateY(-50%);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n    content: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: calc(3rem + 2px);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n    border-block-end: none;\n    color: var(--cds-text-primary, #161616);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] {\n  background: var(--cds-layer-01, #f4f4f4);\n  inset-block-start: 0;\n  outline: 0.125rem solid transparent;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), top 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n  outline: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n  display: flex;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  inline-size: 100%;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n  position: absolute;\n  z-index: 2;\n  fill: var(--cds-icon-secondary, #525252);\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n  content: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n  inset-block-start: calc(3rem + 2px);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n  inset-block-start: 3.125rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[sticky-search] {\n  inset-block-start: 5rem;\n}\n:host(c4d-search-with-typeahead)[theme-sticky] {\n  inset-block-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 2rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 3rem;\n  }\n}\n\n.react-autosuggest__container {\n  position: relative;\n  display: flex;\n  justify-content: flex-end;\n  block-size: 3rem;\n}\n\n.react-autosuggest__suggestions-container {\n  position: absolute;\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inline-size: 100%;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  max-block-size: 80vh;\n  overflow-y: auto;\n}\n\n.react-autosuggest__suggestions-list {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.react-autosuggest__section-title {\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: solid 1px var(--cds-layer-01, #f4f4f4);\n  border-block-start: solid 1px var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-secondary, #525252);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.react-autosuggest__suggestion {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n.react-autosuggest__suggestion span {\n  font-weight: 600;\n}\n.react-autosuggest__suggestion .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n.react-autosuggest__suggestion .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .react-autosuggest__suggestion:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n.react-autosuggest__suggestion:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n.react-autosuggest__suggestion .cds--container-highlight-class:not(:hover), .react-autosuggest__suggestion:focus, .react-autosuggest__suggestion:active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.react-autosuggest__suggestion:last-of-type .cds--container-class {\n  border-block-end: none;\n}\n\n.cds--header__search--input {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  padding: 0;\n  border: none;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  font-size: 1rem;\n  inline-size: 0;\n  line-height: 1.375rem;\n  transition: 120ms;\n}\n.cds--header__search--input::-moz-placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n.cds--header__search--input::placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}"]);

let _$4 = t => t,
  _t$4,
  _t2$2;
function _decorate$6(e, r, t, i) { var o = _getDecoratorsApi$6(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$6(s.d.map(_createElementDescriptor$6)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$6() { _getDecoratorsApi$6 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$6(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$6(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$6(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$6(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$6(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$6(e) { var r, t = _toPropertyKey$6(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$6(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$6(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$6(o.descriptor) || _isDataDescriptor$6(i.descriptor)) { if (_hasDecorators$6(o) || _hasDecorators$6(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$6(o)) { if (_hasDecorators$6(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$6(o, i); } } else r.push(o); } return r; }
function _hasDecorators$6(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$6(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$6(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$6(t) { var i = _toPrimitive$6(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$6(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$6(r) { return _arrayWithHoles$6(r) || _iterableToArray$6(r) || _unsupportedIterableToArray$6(r) || _nonIterableRest$6(); }
function _nonIterableRest$6() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$6(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$6(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$6(r, a) : void 0; } }
function _arrayLikeToArray$6(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$6(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$6(r) { if (Array.isArray(r)) return r; }
function _superPropGet$3(t, e, r, o) { var p = _get$3(_getPrototypeOf$3(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$3() { return _get$3 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$3(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$3.apply(null, arguments); }
function _superPropBase$3(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$3(t));); return t; }
function _getPrototypeOf$3(t) { return _getPrototypeOf$3 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$3(t); }
const {
  prefix: prefix$3,
  stablePrefix: c4dPrefix$6
} = settings;

/**
 * Search result item in masthead.
 *
 * @element c4d-search-with-typeahead-item
 * @csspart item item-highlighted - The highlighted item. Usage `c4d-search-with-typeahead-item::part(item item-highlighted)`
 * @csspart item-container - The item container. Usage `c4d-search-with-typeahead-item::part(item-container)`
 */
let C4DSearchWithTypeaheadItem = _decorate$6([carbonElement(`${c4dPrefix$6}-search-with-typeahead-item`)], function (_initialize, _LitElement) {
  class C4DSearchWithTypeaheadItem extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DSearchWithTypeaheadItem,
    d: [{
      kind: "field",
      decorators: [t$2()],
      key: "_pageIsRTL",
      value() {
        return this.ownerDocument.documentElement.dir === 'rtl';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "href",
      value() {
        return '';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "highlighted",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "text",
      value() {
        return '';
      }
    }, {
      kind: "method",
      key: "_getCurrentQuery",
      value:
      /**
       * The the search result to be shown.
       */

      /**
       * Boolean checking if page is RTL
       */

      /**
       * The optional href to redirect the user to.
       */

      /**
       * `true` if this dropdown item should be highlighted.
       * If `true`, parent `<c4d-search-with-typeahead>` selects/deselects this dropdown item upon keyboard interaction.
       *
       * @private
       */

      /**
       * The search result text.
       */

      /**
       * Retrieves the current search query string from the parent element.
       */
      function _getCurrentQuery() {
        const parent = this.getRootNode().host;
        const {
          searchQueryString
        } = parent !== null && parent !== void 0 ? parent : {};
        return searchQueryString === null || searchQueryString === void 0 ? void 0 : searchQueryString.toLowerCase();
      }

      /**
       * Returns this element's text content with the portion that matches the current
       * search query highlighted.
       */
    }, {
      kind: "method",
      key: "_getHighlightedText",
      value: function _getHighlightedText() {
        const {
          text
        } = this;
        let searchQueryString = this._getCurrentQuery();
        const lowerCaseText = text.toLowerCase();
        if (lowerCaseText.includes(searchQueryString)) {
          const startingIndex = lowerCaseText.indexOf(searchQueryString);
          searchQueryString = text.substring(startingIndex, startingIndex + searchQueryString.length);
        }
        const highlightedResult = x(_t$4 || (_t$4 = _$4`<span
      class="${0}-ce--search-with-typeahead-item__highlighted"
      part="item item-highlighted"
      >${0}</span
    >`), c4dPrefix$6, searchQueryString);
        const content = text.split(new RegExp(searchQueryString, 'i')).reduce((acc, item) => {
          acc.push(item.replace(/^\s/, '\xa0').replace(/\s$/, '\xa0'));
          acc.push(highlightedResult);
          return acc;
        }, []);
        content.pop();
        if (this._pageIsRTL) {
          content.reverse();
        }
        return content;
      }
    }, {
      kind: "method",
      key: "connectedCallback",
      value: function connectedCallback() {
        if (!this.hasAttribute('role')) {
          this.setAttribute('role', 'option');
        }
        _superPropGet$3(C4DSearchWithTypeaheadItem, "connectedCallback", this, 3)([]);
      }
    }, {
      kind: "method",
      key: "shouldUpdate",
      value: function shouldUpdate(changedProperties) {
        const result = _superPropGet$3(C4DSearchWithTypeaheadItem, "shouldUpdate", this, 3)([changedProperties]);
        if (changedProperties.has('text')) {
          const {
            text
          } = this;
          const searchQueryString = this._getCurrentQuery();
          this._content = !searchQueryString || this.hasAttribute('groupTitle') ? text : this._getHighlightedText();
        }
        return result;
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet$3(C4DSearchWithTypeaheadItem, "updated", this, 3)([changedProperties]);
        if (changedProperties.has('highlighted')) {
          this.setAttribute('aria-selected', String(Boolean(this.highlighted)));
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          highlighted,
          _content: content
        } = this;
        const containerClasses = o$2({
          [`${prefix$3}--container-class`]: true,
          [`${prefix$3}--container-highlight-class`]: highlighted
        });
        return x(_t2$2 || (_t2$2 = _$4`
      <div class="${0}" part="item-container" tabindex="-1">
        ${0}
      </div>
    `), containerClasses, content);
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$1;
      }
    }]
  };
}, s);

let _$3 = t => t,
  _t$3,
  _t2$1,
  _t3$1,
  _t4$1,
  _t5$1,
  _t6$1,
  _t7$1,
  _t8$1,
  _t9$1,
  _t10$1,
  _t11$1,
  _t12$1,
  _t13$1,
  _t14$1;
function _decorate$5(e, r, t, i) { var o = _getDecoratorsApi$5(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$5(s.d.map(_createElementDescriptor$5)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$5() { _getDecoratorsApi$5 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$5(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$5(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$5(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$5(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$5(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$5(e) { var r, t = _toPropertyKey$5(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$5(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$5(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$5(o.descriptor) || _isDataDescriptor$5(i.descriptor)) { if (_hasDecorators$5(o) || _hasDecorators$5(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$5(o)) { if (_hasDecorators$5(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$5(o, i); } } else r.push(o); } return r; }
function _hasDecorators$5(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$5(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$5(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$5(t) { var i = _toPrimitive$5(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$5(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$5(r) { return _arrayWithHoles$5(r) || _iterableToArray$5(r) || _unsupportedIterableToArray$5(r) || _nonIterableRest$5(); }
function _nonIterableRest$5() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$5(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$5(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$5(r, a) : void 0; } }
function _arrayLikeToArray$5(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$5(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$5(r) { if (Array.isArray(r)) return r; }
function _superPropGet$2(t, e, r, o) { var p = _get$2(_getPrototypeOf$2(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$2() { return _get$2 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$2(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$2.apply(null, arguments); }
function _superPropBase$2(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$2(t));); return t; }
function _getPrototypeOf$2(t) { return _getPrototypeOf$2 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$2(t); }
const {
  prefix: prefix$2,
  stablePrefix: c4dPrefix$5
} = settings;
const gridBreakpoint = parseFloat(breakpoints.lg.width) * baseFontSize;

/**
 * Search with Typeahead
 *
 * @element c4d-search-with-typeahead
 * @csspart search-input - The input box for search. Usage `c4d-search-with-typeahead::part(search-input)`
 * @csspart search-form - The search form. Usage `c4d-search-with-typeahead::part(search-form)`
 * @csspart container - The search form container. Usage `c4d-search-with-typeahead::part(container)`
 * @csspart dropdown - The search dropdown. Usage `c4d-search-with-typeahead::part(dropdown)`
 * @csspart dropdown-item - The dropdown item. Usage `c4d-search-with-typeahead::part(dropdown-item)`
 * @csspart dropdown-mobile - The search dropdown for mobile. Usage `c4d-search-with-typeahead::part(dropdown-mobile)`
 * @csspart select-item - The item selector. Usage `c4d-search-with-typeahead::part(select-item)`
 * @csspart suggestions-container - The suggestions container. Usage `c4d-search-with-typeahead::part(suggestions-container)`
 * @csspart suggestions-list - The suggestions list. Usage `c4d-search-with-typeahead::part(suggestions-list)`
 * @csspart search-with-typeahead-item - The search item. Usage `c4d-search-with-typeahead::part(search-with-typeahead-item)`
 * @csspart open-button - The button to show the search box. Usage `c4d-search-with-typeahead::part(open-button)`
 * @csspart close-button - The button to hide the search box. Usage `c4d-search-with-typeahead::part(close-button)`
 * @csspart header-search-actions - The container for the search bar. Usage `c4d-search-with-typeahead::part(header-search-actions)`
 * @csspart suggestion-item - The search item. Usage `c4d-search-with-typeahead::part(suggestion-item)`
 * @fires c4d-search-with-typeahead-beingredirected
 *   The custom event fired before the page is being redirected to the search result page.
 *   Cancellation of this event stops the user-initiated action of redirection.
 * @fires c4d-search-with-typeahead-input
 *   The name of the custom event fired after the search content is changed upon a user gesture.
 * @fires c4d-search-with-typeahead-toggled
 *   The name of the custom event fired after this search box is toggled upon a user gesture.
 */
_decorate$5([carbonElement(`${c4dPrefix$5}-search-with-typeahead`)], function (_initialize, _HostListenerMixin) {
  class C4DSearchWithTypeahead extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DSearchWithTypeahead,
    d: [{
      kind: "method",
      key: "getResults",
      value:
      // eslint-disable-next-line class-methods-use-this
      async function getResults(searchQuery) {
        const response = await SearchTypeaheadAPI.getResults(searchQuery, this.appId);
        return response.map(res => res[0]);
      }

      /**
       * The formatter for the placeholder text on the search box.
       * Should be changed upon the locale the UI is rendered with.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "placeholderFormatter",
      value() {
        return ({
          appId
        }) => `Search in ${appId}`;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'leadspace-search',
        type: Boolean
      })],
      key: "leadspaceSearch",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'custom-typeahead-api',
        type: Boolean
      })],
      key: "customTypeaheadAPI",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "currentSearchResults",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "searchResults",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "groupedResults",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'initial-search-term',
        reflect: true
      })],
      key: "initialSearchTerm",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'scope-parameters'
      })],
      key: "scopeParameters",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'should-remain-open',
        type: Boolean
      })],
      key: "shouldRemainOpen",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'appid',
        reflect: true
      })],
      key: "appId",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'scope-label',
        reflect: true
      })],
      key: "scopeLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'scope-value',
        reflect: true
      })],
      key: "scopeValue",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "userHasInputSearch",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$2}--header__search--search`)],
      key: "_searchButtonNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$2}--header__search--close`)],
      key: "_closeButtonNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.${prefix$2}--header__search--input`)],
      key: "_searchInputNode",
      value: void 0
    }, {
      kind: "field",
      decorators: [i$1(`.react-autosuggest__suggestions-list`)],
      key: "_searchSuggestions",
      value: void 0
    }, {
      kind: "field",
      decorators: [HostListener('shadowRoot:focusin')],
      key: "_handleFocus",
      value() {
        return async ({
          target
        }) => {
          if (!this._searchSuggestions) {
            return;
          }
          if (target === this._searchInputNode) {
            this._searchSuggestions.removeAttribute('hidden');
          } else if (target === (this._searchButtonNode || this._closeButtonNode)) {
            this._searchSuggestions.setAttribute('hidden', '');
          }
          if (target === this._closeButtonNode) {
            this.setAttribute('unfocused', '');
          } else {
            this.removeAttribute('unfocused');
          }
        };
      }
    }, {
      kind: "method",
      key: "_handleClickCloseButton",
      value:
      /**
       * The `<button>` to open the search box.
       */
      /**
       * The `<button>` to open the search box.
       */
      /**
       * The `<input>` of the search box.
       */
      /**
       * The `<ul>` containing the search suggestions.
       */
      /**
       * Handles hiding search suggestions if focusing on other buttons.
       *
       * @param event The event.
       * @param event.target The event target.
       */
      /**
       * Handles `click` event on the close button.
       */
      async function _handleClickCloseButton() {
        if (this.leadspaceSearch) {
          var _this$_closeButtonNod;
          (_this$_closeButtonNod = this._closeButtonNode) === null || _this$_closeButtonNod === void 0 || _this$_closeButtonNod.classList.add(`${prefix$2}--header__search--hide`);
        }
        this._handleUserInitiatedToggleActiveState(false);
      }

      /**
       * @inheritdoc
       */
    }, {
      kind: "method",
      key: "_handleClickInner",
      value: function _handleClickInner(event) {
        if (event.target.closest('.cds--header__search--input') === event.target) {
          this._handleUserInitiatedToggle();
          if (this.searchQueryString && this.leadspaceSearch) {
            var _this$_closeButtonNod2;
            (_this$_closeButtonNod2 = this._closeButtonNode) === null || _this$_closeButtonNod2 === void 0 || _this$_closeButtonNod2.classList.remove(`${prefix$2}--header__search--hide`);
          }
        } else {
          const item = event.target.closest(this.constructor.selectorItem);
          if (this.shadowRoot.contains(item) && !item.hasAttribute('groupTitle')) {
            this._handleUserInitiatedSelectItem(item);
          }
        }
      }

      /**
       * Handles `click` event on the search button.
       */
    }, {
      kind: "method",
      key: "_handleClickSearchButton",
      value: async function _handleClickSearchButton() {
        const {
          active
        } = this;
        if (active) {
          if (this.searchQueryString) {
            this._handleUserInitiatedRedirect();
          }
        } else {
          this._handleUserInitiatedToggleActiveState(true);
        }
      }

      /**
       * Handles user-initiated toggling of activated state of the search box.
       *
       * @param active `true` to activate the search box.
       * @param moveFocus
       *   `true` to move focus upon toggling, to the input box when activated, to the trigger button when deactivated.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedToggleActiveState",
      value: async function _handleUserInitiatedToggleActiveState(active, moveFocus = true) {
        if (active === this.active) {
          return;
        }
        const {
          _searchInputNode: searchInputNode
        } = this;
        const {
          eventInput,
          eventToggle
        } = this.constructor;
        if (!active && searchInputNode.value) {
          searchInputNode.value = '';
          this.dispatchEvent(new CustomEvent(eventInput, {
            bubbles: true,
            composed: true,
            cancelable: false,
            detail: {
              value: ''
            }
          }));
        }
        this.active = this.shouldRemainOpen ? true : !this.active;
        this.searchResults = [];
        this.groupedResults = [];
        this.dispatchEvent(new CustomEvent(eventToggle, {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            active
          }
        }));
        await this.updateComplete;
        if (moveFocus) {
          // Does not reuse destructed `searchInputNode` given it's `null` before expanded
          (this.active ? this._searchInputNode : this._searchButtonNode).focus();
        }
      }

      /**
       * Prevents key types in the `<input>` causing other keyboard shortcuts in application UI.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleKeyInput",
      value: function _handleKeyInput(event) {
        if (this.constructor.getAction(event.key) === DROPDOWN_KEYBOARD_ACTION.NONE) {
          event.stopPropagation();
        }
      }

      /**
       * Builds a redirect href string with appropriate query params. Emulates what
       * would be generated by the form action.
       *
       * @param targetQuery An optional query string value.
       * @returns {string} An href string.
       */
    }, {
      kind: "method",
      key: "_buildRedirect",
      value: function _buildRedirect(targetQuery = this.searchQueryString) {
        const [primary, country] = this.language.split('-');
        const tokens = this.redirectUrl.split('?');
        const base = tokens.shift();
        const searchParams = new URLSearchParams(tokens.join('?'));
        // Setting `this.searchQueryString` as the default value of `targetQuery` seems to cause a Babel bug
        searchParams.append('q', targetQuery);
        searchParams.append('lang', primary);
        searchParams.append('cc', country);
        if (this.appId) {
          searchParams.append('scope-domain', 'scope');
          searchParams.append('scope-value', this.scopeValue);
          searchParams.append('scope-type', this.appId);
          if (this.scopeLabel) {
            var _this$scopeLabel;
            searchParams.append('scope-label', (_this$scopeLabel = this.scopeLabel) !== null && _this$scopeLabel !== void 0 ? _this$scopeLabel : '');
          }
        }
        return `${base}?${searchParams.toString()}`;
      }

      /**
       * Handles user-initiated redirect to the search query page.
       *
       * @param [options] The options.
       * @param [options.targetQuery] The query string the search query page should be of.
       * @param [options.targetHref] The href string to be redirected to.
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedRedirect",
      value: function _handleUserInitiatedRedirect({
        targetQuery,
        targetHref
      } = {}) {
        const {
          eventBeforeRedirect,
          eventInput
        } = this.constructor;
        this.dispatchEvent(new CustomEvent(eventInput, {
          bubbles: true,
          composed: true,
          cancelable: false,
          detail: {
            value: targetQuery
          }
        }));
        const query = targetQuery !== null && targetQuery !== void 0 ? targetQuery : this.searchQueryString;
        const redirectUrlWithSearch = targetHref || this._buildRedirect(query);
        if (this.dispatchEvent(new CustomEvent(eventBeforeRedirect, {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            redirectUrl: redirectUrlWithSearch,
            searchQueryString: query
          }
        }))) {
          this._redirect(redirectUrlWithSearch);
        }
      }

      /**
       * @inheritdoc
       */
    }, {
      kind: "method",
      decorators: [HostListener('focusout')],
      key: "_handleFocusOut",
      value: function _handleFocusOut(event) {
        _superPropGet$2(C4DSearchWithTypeahead, "_handleFocusOut", this, 3)([event]);
      }

      /**
       * Handles search results when using a custom API.
       *
       * @param event The event.
       */
    }, {
      kind: "field",
      decorators: [HostListener('document:eventCustomResults')],
      key: "_handleCustomResults",
      value() {
        return event => {
          if (this.customTypeaheadAPI) {
            [this.searchResults] = event.detail;
            this.groupedResults = event.detail.slice(1);
          }
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener('document:eventSelectScope')],
      key: "_handleScopeSelect",
      value() {
        return event => {
          var _targetScope, _targetScope$label;
          this.appId = event.detail.appId;
          let targetScope;
          this.scopeParameters.forEach(scope => {
            if (scope.appId === this.appId) {
              targetScope = scope;
            }
          });
          this.scopeValue = Array.isArray((_targetScope = targetScope) === null || _targetScope === void 0 ? void 0 : _targetScope.value) ? `[${targetScope.value.toString().split(',').map(word => `"${word.trim()}"`).join(',')}]` : targetScope.value;
          this.scopeLabel = (_targetScope$label = targetScope.label) !== null && _targetScope$label !== void 0 ? _targetScope$label : '';
        };
      }
    }, {
      kind: "method",
      key: "_handleInput",
      value:
      /**
       * Queries scoped search suggestions.
       *
       * @param event The event.
       */
      /**
       * Handles `input` event in the search input.
       */
      function _handleInput(event) {
        const {
          userHasInputSearch
        } = this;
        const {
          target
        } = event;
        const {
          value
        } = target;
        this.removeAttribute('unfocused');
        const items = this.shadowRoot.querySelectorAll(this.constructor.selectorItem);
        items.forEach(e => {
          if (this.leadspaceSearch) {
            e.setAttribute('alternate', '');
          }
          if (e.hasAttribute('highlighted')) {
            this.setAttribute('unfocused', '');
          }
        });
        this.dispatchEvent(new CustomEvent(this.constructor.eventInput, {
          bubbles: true,
          composed: true,
          cancelable: false,
          detail: {
            value
          }
        }));
        this.value = value;
        if (!this.customTypeaheadAPI) {
          this.getResults(value).then(res => {
            this.searchResults = res;
          });
        }
        if (value) {
          this.open = true;
          if (this.leadspaceSearch) {
            var _this$_closeButtonNod3;
            (_this$_closeButtonNod3 = this._closeButtonNode) === null || _this$_closeButtonNod3 === void 0 || _this$_closeButtonNod3.classList.remove(`${prefix$2}--header__search--hide`);
          }
        }
        if (!userHasInputSearch) {
          this.userHasInputSearch = true;
        }

        // accomodate search results box's width with the scope dropdown
        if (gridBreakpoint < document.body.clientWidth && this._searchSuggestions && this.scopeParameters) {
          var _this$shadowRoot, _this$_searchSuggesti;
          const scopeBarWidth = ((_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector('c4d-scoped-search-dropdown')).offsetWidth;
          (_this$_searchSuggesti = this._searchSuggestions) === null || _this$_searchSuggesti === void 0 || (_this$_searchSuggesti = _this$_searchSuggesti.parentElement) === null || _this$_searchSuggesti === void 0 || _this$_searchSuggesti.setAttribute('style', `left: ${scopeBarWidth}px; width: calc(100% - ${scopeBarWidth}px);`);
        } else {
          var _this$_searchSuggesti2;
          (_this$_searchSuggesti2 = this._searchSuggestions) === null || _this$_searchSuggesti2 === void 0 || (_this$_searchSuggesti2 = _this$_searchSuggesti2.parentElement) === null || _this$_searchSuggesti2 === void 0 || _this$_searchSuggesti2.removeAttribute('style');
        }
      }

      /**
       * Handles search form submission and cancels event execution in circumstances
       * where user action is handled elsewhere.
       *
       * @param event The form submission event.
       */
    }, {
      kind: "method",
      key: "_handleSubmit",
      value: function _handleSubmit(event) {
        const {
          searchQueryString,
          redirectUrl
        } = this;
        const {
          eventBeforeRedirect
        } = this.constructor;
        const {
          selectorItemHighlighted
        } = this.constructor;
        const highlightedItem = this.shadowRoot.querySelector(selectorItemHighlighted);

        // Prevents form submission in certain circumstances. In the case where there
        // is a highlighted item, `._handleUserInitiatedRedirect()` should have navigated
        // the user to the search result page.
        // Otherwise, gives users an opportunity to react to the event before
        // executing the form's action.
        if (highlightedItem || !searchQueryString) {
          event.preventDefault();
        } else if (!this.dispatchEvent(new CustomEvent(eventBeforeRedirect, {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            redirectUrl,
            searchQueryString
          }
        }))) {
          event.preventDefault();
        }
      }

      /**
       * @inheritdoc
       */
    }, {
      kind: "method",
      key: "_handleUserInitiatedSelectItem",
      value: function _handleUserInitiatedSelectItem(item) {
        if (item && item instanceof C4DSearchWithTypeaheadItem) {
          this._searchInputNode.value = item.text;
          this._handleUserInitiatedRedirect({
            targetQuery: item.text,
            targetHref: item.href
          });
        }
      }

      /**
       * @inheritdoc
       */
    }, {
      kind: "method",
      key: "_handleKeypressInner",
      value: function _handleKeypressInner(event) {
        const {
          key
        } = event;
        const action = this.constructor.getAction(key);
        if (!this.open) {
          switch (action) {
            case DROPDOWN_KEYBOARD_ACTION.TRIGGERING:
              this._handleUserInitiatedToggle(true);
              break;
          }
        } else {
          switch (action) {
            case DROPDOWN_KEYBOARD_ACTION.TRIGGERING:
              {
                const {
                  selectorItemHighlighted
                } = this.constructor;
                const highlightedItem = this.shadowRoot.querySelector(selectorItemHighlighted);
                if (highlightedItem) {
                  this._handleUserInitiatedSelectItem(highlightedItem);
                } else {
                  this._handleUserInitiatedToggle(false);
                }
              }
              break;
          }
        }
      }

      /**
       * Redirects the page to the given target.
       *
       * @param target The target URL.
       */
    }, {
      kind: "method",
      key: "_redirect",
      value: function _redirect(target) {
        this.ownerDocument.defaultView.location.assign(target);
      }

      /**
       * Navigate through dropdown items.
       *
       * @param direction `-1` to navigate backward, `1` to navigate forward.
       */
    }, {
      kind: "method",
      key: "_navigate",
      value: function _navigate(direction) {
        const constructor = this.constructor;
        const items = this.shadowRoot.querySelectorAll(constructor.selectorItem);
        const highlightedItem = this.shadowRoot.querySelector(constructor.selectorItemHighlighted);
        const highlightedIndex = indexOf(items, highlightedItem);
        let nextIndex = highlightedIndex + direction;
        if (items[nextIndex] && items[nextIndex].hasAttribute('groupTitle')) {
          nextIndex += direction;
        }
        if (nextIndex < 0) {
          nextIndex = items.length - 1;
        }
        if (nextIndex >= items.length) {
          nextIndex = 0;
        }
        forEach(items, (item, i) => {
          item.highlighted = i === nextIndex;
        });
        this.setAttribute('unfocused', '');
        const nextItem = items[nextIndex];
        // Using `{ block: 'nearest' }` to prevent scrolling unless scrolling is absolutely necessary.
        // `scrollIntoViewOptions` seems to work in latest Safari despite of MDN/caniuse table.
        // IE falls back to the old behavior.
        nextItem.scrollIntoView({
          block: 'nearest'
        });
        this.requestUpdate();
      }

      /**
       * @returns The main content of the trigger button.
       */
    }, {
      kind: "method",
      key: "_renderTriggerContent",
      value: function _renderTriggerContent() {
        const {
          initialSearchTerm,
          searchPlaceholder,
          searchLabel,
          userHasInputSearch,
          _handleInput: handleInput,
          _handleKeyInput: handleKeyInput
        } = this;
        return x(_t$3 || (_t$3 = _$3`
      <input
        type="text"
        part="search-input"
        class="${0}--header__search--input"
        name="q"
        placeholder="${0}"
        value="${0}"
        autocomplete="off"
        aria-controls="result-list"
        aria-autocomplete="list"
        aria-label="${0}"
        @input="${0}"
        @keydown="${0}"
        @keypress="${0}" />
    `), prefix$2, searchPlaceholder, !userHasInputSearch ? initialSearchTerm : '', l(searchLabel), handleInput, handleKeyInput, handleKeyInput);
      }

      /**
       * Handles `click` event to redirect based on selected item.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      key: "_handleClickItem",
      value: function _handleClickItem(event) {
        const {
          selectorItem
        } = this.constructor;
        const item = event.target.closest(selectorItem);
        if (this.shadowRoot.contains(item)) {
          this._handleUserInitiatedSelectItem(item);
        }
      }

      /**
       * @returns The content of the search box.
       */
    }, {
      kind: "method",
      key: "_renderForm",
      value: function _renderForm() {
        const {
          active,
          language,
          open,
          redirectUrl,
          searchLabel,
          _handleClickInner: handleClickInner,
          _handleKeydownInner: handleKeydownInner,
          _handleKeypressInner: handleKeypressInner,
          _handleSubmit: handleSubmit
        } = this;
        if (!active) {
          return undefined;
        }
        const [primary, country] = language.split('-');
        const classes = o$2({
          'react-autosuggest__container': true,
          'react-autosuggest__suggestions-container--open': open
        });
        return x(_t2$1 || (_t2$1 = _$3`
      <form
        role="search"
        part="search-form"
        method="get"
        action="${0}"
        @submit="${0}">
        <input type="hidden" name="lang" value="${0}" />
        <input type="hidden" name="cc" value="${0}" />
        <input type="hidden" name="lnk" value="mhsrch" />
        ${0}
        <div
          role="combobox"
          class="${0}"
          part="container"
          aria-haspopup="listbox"
          aria-owns="result-list"
          aria-expanded="${0}"
          aria-label="${0}"
          @click=${0}
          @keydown="${0}"
          @keypress="${0}">
          ${0}
          ${0}
          ${0}
        </div>
      </form>
    `), redirectUrl, handleSubmit, primary, country, this.scopeParameters ? x(_t3$1 || (_t3$1 = _$3`
              <input type="hidden" name="scope-domain" value="scope" />
              <input type="hidden" name="scope-type" value="${0}" />
              <input
                type="hidden"
                name="scope-value"
                value="${0}" />
              <input
                type="hidden"
                name="scope-label"
                value="${0}" />
            `), this.appId, this.scopeValue, this.scopeLabel) : '', classes, Boolean(this.active), l(searchLabel), handleClickInner, handleKeydownInner, handleKeypressInner, this.scopeParameters ? x(_t4$1 || (_t4$1 = _$3`
                <c4d-scoped-search-dropdown
                  part="dropdown"
                  value="${0}">
                  ${0}
                </c4d-scoped-search-dropdown>
                <c4d-scoped-search-dropdown-mobile
                  part="dropdown-mobile"
                  value="${0}">
                  ${0}
                </c4d-scoped-search-dropdown-mobile>
              `), this.appId, this.scopeParameters.map(scope => x(_t5$1 || (_t5$1 = _$3`
                      <cds-dropdown-item
                        part="dropdown-item"
                        value="${0}"
                        >${0}</cds-dropdown-item
                      >
                    `), scope.appId, scope.name)), this.appId, this.scopeParameters.map(scope => x(_t6$1 || (_t6$1 = _$3`
                      <cds-select-item
                        part="select-item"
                        label="${0}"
                        value="${0}"
                        >${0}</cds-select-item
                      >
                    `), scope.name, scope.appId, scope.name))) : ``, this._renderTriggerContent(), !this.leadspaceSearch ? x(_t7$1 || (_t7$1 = _$3`
                <div
                  id="result-list"
                  class="react-autosuggest__suggestions-container"
                  part="suggestions-container">
                  <ul
                    role="listbox"
                    class="${0}-ce__search__list react-autosuggest__suggestions-list"
                    part="suggestions-list">
                    ${0}
                    ${0}
                  </ul>
                </div>
              `), c4dPrefix$5, this.searchResults && this.searchResults.map(item => x(_t8$1 || (_t8$1 = _$3`
                          <c4d-search-with-typeahead-item
                            part="suggestion-item"
                            text="${0}"></c4d-search-with-typeahead-item>
                        `), item)), this.groupedResults && this.groupedResults.map(group => x(_t9$1 || (_t9$1 = _$3`
                          <c4d-search-with-typeahead-item
                            part="suggestion-item"
                            groupTitle
                            text="${0}"></c4d-search-with-typeahead-item>
                          ${0}
                        `), group.title, group.items.map(item => x(_t10$1 || (_t10$1 = _$3`
                                <c4d-search-with-typeahead-item
                                  part="suggestion-item"
                                  text="${0}"
                                  href="${0}"></c4d-search-with-typeahead-item>
                              `), item.name, item.href))))) : ``);
      }

      /**
       * @returns `true` if the selection of this dropdown should change if the given item is selected upon user interaction.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_selectionShouldChange",
      value: function _selectionShouldChange() {
        return true;
      }

      /**
       * `true` if this the search box should represent its active state.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true
      })],
      key: "active",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'close-search-button-assistive-text'
      })],
      key: "closeSearchButtonAssistiveText",
      value() {
        return 'Clear input';
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "language",
      value() {
        return 'en-US';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'open-search-button-assistive-text'
      })],
      key: "openSearchButtonAssistiveText",
      value() {
        return 'Open IBM search field';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'perform-search-button-assistive-text'
      })],
      key: "performSearchButtonAssistiveText",
      value() {
        return 'Search all of IBM';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'placeholder',
        reflect: true
      })],
      key: "searchPlaceholder",
      value() {
        return 'Search all of IBM';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'redirect-url'
      })],
      key: "redirectUrl",
      value() {
        return 'https://www.ibm.com/search?lnk=mhsrch';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'search-label'
      })],
      key: "searchLabel",
      value() {
        return 'IBM search field';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true
      })],
      key: "slot",
      value() {
        return 'search';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'search-open-on-load'
      })],
      key: "searchOpenOnload",
      value() {
        return false;
      }
    }, {
      kind: "get",
      key: "searchQueryString",
      value:
      /**
       * The assistive text for the button to close the search box.
       */
      /**
       * The language embedded in the inner form.
       */
      /**
       * The assistive text for the button to open the search box.
       */
      /**
       * The assistive text for the button to perform search.
       */
      /**
       * Value to display when the input has an empty `value`.
       */
      /**
       * The redirect URL when a user selects a search suggestion.
       */
      /**
       * The `aria-label` attribute for the search input.
       */
      /**
       * The shadow slot this search UI should be in.
       */
      /**
       * `true` to activate the search box on page load.
       */
      /**
       * The input value.
       */
      function () {
        var _this$_searchInputNod, _this$_searchInputNod2;
        return (_this$_searchInputNod = (_this$_searchInputNod2 = this._searchInputNode) === null || _this$_searchInputNod2 === void 0 ? void 0 : _this$_searchInputNod2.value) !== null && _this$_searchInputNod !== void 0 ? _this$_searchInputNod : '';
      }

      /**
       * Returns query param `q` for search input if exists. Only available when searchOpenOnload is `true`
       */
    }, {
      kind: "method",
      key: "_setSearchParam",
      value: function _setSearchParam() {
        const {
          _searchInputNode: searchInputNode
        } = this;
        const URLParams = new URLSearchParams(this.ownerDocument.defaultView.location.search);
        const searchParam = this.searchOpenOnload ? URLParams.get('q') : '';
        if (searchParam) {
          searchInputNode.value = searchParam;
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        this._setSearchParam();
        if (this.leadspaceSearch) {
          this.setAttribute('should-remain-open', '');
          this.setAttribute('active', '');
        }
        if (!this.appId && this.scopeParameters) {
          this.appId = 'all';
          this.redirectUrl = 'https://www.ibm.com/search/scoped';
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('searchResults')) {
          var _this$shadowRoot2;
          const titleElements = (_this$shadowRoot2 = this.shadowRoot) === null || _this$shadowRoot2 === void 0 ? void 0 : _this$shadowRoot2.querySelectorAll('c4d-search-with-typeahead-item[groupTitle]');
          titleElements === null || titleElements === void 0 || titleElements.forEach(e => {
            var _e$previousElementSib;
            (_e$previousElementSib = e.previousElementSibling) === null || _e$previousElementSib === void 0 || _e$previousElementSib.setAttribute('lastBeforeGroup', '');
          });
        }
        if (changedProperties.has('appId')) {
          var _this$scopeParameters;
          if (gridBreakpoint < document.body.clientWidth && this._searchSuggestions && this.scopeParameters) {
            var _this$shadowRoot3, _this$_searchSuggesti3;
            const scopeBarWidth = ((_this$shadowRoot3 = this.shadowRoot) === null || _this$shadowRoot3 === void 0 ? void 0 : _this$shadowRoot3.querySelector('c4d-scoped-search-dropdown')).offsetWidth;
            (_this$_searchSuggesti3 = this._searchSuggestions) === null || _this$_searchSuggesti3 === void 0 || (_this$_searchSuggesti3 = _this$_searchSuggesti3.parentElement) === null || _this$_searchSuggesti3 === void 0 || _this$_searchSuggesti3.setAttribute('style', `left: ${scopeBarWidth}px; width: calc(100% - ${scopeBarWidth}px);`);
          } else {
            var _this$_searchSuggesti4;
            (_this$_searchSuggesti4 = this._searchSuggestions) === null || _this$_searchSuggesti4 === void 0 || (_this$_searchSuggesti4 = _this$_searchSuggesti4.parentElement) === null || _this$_searchSuggesti4 === void 0 || _this$_searchSuggesti4.removeAttribute('style');
          }
          if (!this.customTypeaheadAPI) {
            this.getResults(this.value).then(res => {
              this.searchResults = res;
            });
          }
          const newPlaceholder = this.placeholderFormatter({
            appId: (_this$scopeParameters = this.scopeParameters.filter(e => e.value === `${this.appId}`)[0]) === null || _this$scopeParameters === void 0 ? void 0 : _this$scopeParameters.name
          });
          this.setAttribute('placeholder', newPlaceholder);
          this.performSearchButtonAssistiveText = newPlaceholder;
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          active,
          closeSearchButtonAssistiveText,
          openSearchButtonAssistiveText,
          performSearchButtonAssistiveText,
          _handleClickCloseButton: handleClickCloseButton,
          _handleClickSearchButton: handleClickSearchButton,
          _handleClickItem: handleClickItem
        } = this;
        const searchButtonAssistiveText = !active ? openSearchButtonAssistiveText : performSearchButtonAssistiveText;
        return x(_t11$1 || (_t11$1 = _$3`
      ${0}
    `), !this.leadspaceSearch ? x(_t12$1 || (_t12$1 = _$3`
            ${0}
            <div
              part="header-search-actions"
              class="${0}--header__search--actions">
              <button
                type="button"
                part="open-button"
                class="${0}--header__action ${0}--header__search--search"
                aria-label="${0}"
                @click="${0}">
                ${0}
              </button>
              <button
                type="button"
                part="close-button"
                class="${0}--header__action ${0}--header__search--close"
                aria-label="${0}"
                @click="${0}">
                ${0}
              </button>
            </div>
          `), this._renderForm(), prefix$2, prefix$2, prefix$2, searchButtonAssistiveText, handleClickSearchButton, svgResultCarbonIcon(), prefix$2, prefix$2, closeSearchButtonAssistiveText, handleClickCloseButton, svgResultCarbonIcon$z()) : x(_t13$1 || (_t13$1 = _$3`
            <div
              part="header-search-actions"
              class="${0}--header__search--actions">
              ${0}
              ${0}
              <button
                type="button"
                part="close-button"
                class="${0}--header__action ${0}--header__search--close ${0}"
                aria-label="${0}"
                @click="${0}">
                ${0}
              </button>
            </div>
            <div
              id="result-list"
              class="react-autosuggest__suggestions-container"
              part="suggestions-container">
              <ul
                role="listbox"
                class="${0}-ce__search__list react-autosuggest__suggestions-list"
                part="suggestions-list">
                ${0}
              </ul>
            </div>
          `), prefix$2, svgResultCarbonIcon({
          part: 'search-icon',
          class: `${prefix$2}--search-magnifier-icon`,
          role: 'img'
        }), this._renderForm(), prefix$2, prefix$2, this.value.length === 0 ? `${prefix$2}--header__search--hide` : '', closeSearchButtonAssistiveText, handleClickCloseButton, svgResultCarbonIcon$z(), c4dPrefix$5, this.searchResults && this.searchResults.map(item => x(_t14$1 || (_t14$1 = _$3`
                      <c4d-search-with-typeahead-item
                        part="suggestion-item"
                        text="${0}"
                        @click=${0}></c4d-search-with-typeahead-item>
                    `), item, handleClickItem))));
      }

      /**
       * A selector that will return highlighted search result items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItemHighlighted",
      value: function () {
        return `${c4dPrefix$5}-search-with-typeahead-item[highlighted]`;
      }

      /**
       * A selector that will return search result items.
       */
    }, {
      kind: "get",
      static: true,
      key: "selectorItem",
      value: function () {
        return `${c4dPrefix$5}-search-with-typeahead-item`;
      }

      /**
       * The name of the custom event fired before the page is being redirected to the search result page.
       * Cancellation of this event stops the user-initiated action of redirection.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventBeforeRedirect",
      value: function () {
        return `${c4dPrefix$5}-search-with-typeahead-beingredirected`;
      }

      /**
       * The name of the custom event fired after the search content is changed upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventInput",
      value: function () {
        return `${c4dPrefix$5}-search-with-typeahead-input`;
      }

      /**
       * The name of the custom event captured to retrieve the new search scope.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventSelectScope",
      value: function () {
        return `${prefix$2}-select-selected`;
      }

      /**
       * The name of the custom event captured to retrieve the custom typeahead API results.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventCustomResults",
      value: function () {
        return `${c4dPrefix$5}-custom-typeahead-api-results`;
      }

      /**
       * The name of the custom event fired after this search box is toggled upon a user gesture.
       */
    }, {
      kind: "get",
      static: true,
      key: "eventToggle",
      value: function () {
        return `${c4dPrefix$5}-search-with-typeahead-toggled`;
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$5}--search-with-typeahead`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$1;
      }
    }]
  };
}, HostListenerMixin(StableSelectorMixin(CDSDropdown)));

let _$2 = t => t,
  _t$2,
  _t2,
  _t3,
  _t4,
  _t5,
  _t6,
  _t7,
  _t8,
  _t9,
  _t10,
  _t11,
  _t12,
  _t13,
  _t14,
  _t15,
  _t16,
  _t17,
  _t18,
  _t19,
  _t20,
  _t21,
  _t22,
  _t23,
  _t24,
  _t25,
  _t26,
  _t27,
  _t28,
  _t29,
  _t30,
  _t31,
  _t32,
  _t33,
  _t34,
  _t35,
  _t36,
  _t37,
  _t38,
  _t39;
function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty$1(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty$1(e, r, t) { return (r = _toPropertyKey$4(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _decorate$4(e, r, t, i) { var o = _getDecoratorsApi$4(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$4(s.d.map(_createElementDescriptor$4)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$4() { _getDecoratorsApi$4 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$4(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$4(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$4(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$4(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$4(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$4(e) { var r, t = _toPropertyKey$4(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$4(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$4(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$4(o.descriptor) || _isDataDescriptor$4(i.descriptor)) { if (_hasDecorators$4(o) || _hasDecorators$4(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$4(o)) { if (_hasDecorators$4(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$4(o, i); } } else r.push(o); } return r; }
function _hasDecorators$4(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$4(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$4(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$4(t) { var i = _toPrimitive$4(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$4(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$4(r) { return _arrayWithHoles$4(r) || _iterableToArray$4(r) || _unsupportedIterableToArray$4(r) || _nonIterableRest$4(); }
function _nonIterableRest$4() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$4(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$4(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$4(r, a) : void 0; } }
function _arrayLikeToArray$4(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$4(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$4(r) { if (Array.isArray(r)) return r; }
function _superPropGet$1(t, e, r, o) { var p = _get$1(_getPrototypeOf$1(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get$1() { return _get$1 = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase$1(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get$1.apply(null, arguments); }
function _superPropBase$1(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$1(t));); return t; }
function _getPrototypeOf$1(t) { return _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf$1(t); }
const {
  stablePrefix: c4dPrefix$4,
  prefix: prefix$1
} = settings;

/**
 * Globally-scoped Contact Module variable.
 *
 * @see https://github.ibm.com/live-advisor/cm-app
 */
/**
 * Component that renders masthead from links, etc. data.
 *
 * @element c4d-masthead-composite
 * @csspart view-all -  Targets all view-all elements. Usage: `c4d-masthead-composite::part(view-all)`
 * @csspart view-all-left -  Targets the view all left. Usage: `c4d-masthead-composite::part(view-all-left)`
 * @csspart view-all-right -  Targets the view all right. Usage: `c4d-masthead-composite::part(view-all-right)`
 * @csspart view-all-bottom -  Targets the view all bottom. Usage: `c4d-masthead-composite::part(view-all-bottom)`
 * @csspart l0-view-all-products-arrow -  Targets the view all products arrow icon. Usage: `c4d-masthead-composite::part(l0-view-all-products-arrow)`
 */
let C4DMastheadComposite = _decorate$4([carbonElement(`${c4dPrefix$4}-masthead-composite`)], function (_initialize, _HostListenerMixin) {
  class C4DMastheadComposite extends _HostListenerMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadComposite,
    d: [{
      kind: "method",
      key: "_renderL1",
      value:
      /**
       * Renders L1 menu based on l1Data & screen width.
       *
       * @returns {TemplateResult | undefined}
       */
      function _renderL1() {
        const {
          l1Data,
          selectedMenuItemL1
        } = this;
        const {
          cta
        } = (l1Data === null || l1Data === void 0 ? void 0 : l1Data.actions) || {};
        return !l1Data ? undefined : x(_t$2 || (_t$2 = _$2`
          <c4d-masthead-l1
            slot="masthead-l1"
            .l1Data=${0}
            selected-menu-item=${0}>
            ${0}
          </c4d-masthead-l1>
        `), l1Data, selectedMenuItemL1 || '', cta ? C4DMastheadL1.renderL1Cta(cta) : '');
      }

      /**
       * Renders masthead logo
       *
       * @returns {TemplateResult} A template fragment representing the logo.
       */
    }, {
      kind: "method",
      key: "_renderLogo",
      value: function _renderLogo() {
        if (!this.logoData) {
          return x(_t2 || (_t2 = _$2`
        <c4d-masthead-logo
          ?hide-logo="${0}"></c4d-masthead-logo>
      `), this.activateSearch);
        }
        const useAlternateLogo = MastheadLogoAPI.setMastheadLogo(this.logoData);
        const {
          tooltip,
          svg,
          href
        } = this.logoData;
        return x(_t3 || (_t3 = _$2`
      <c4d-masthead-logo
        ?hide-logo="${0}"
        ?hasTooltip="${0}"
        aria-label="${0}"
        href="${0}"
        >${0}</c4d-masthead-logo
      >
    `), this.activateSearch, tooltip, l(tooltip), href || C4DMastheadLogo.hrefDefault, useAlternateLogo ? o(svg) : '');
      }

      /**
       * Render MegaMenu content
       *
       * @param menu megamenu data object
       * @param _parentKey parent key
       * @param layout layout selection to render the megamenu with
       * @returns {TemplateResult} A template fragment representing a megamenu.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderMegaMenu",
      value: function _renderMegaMenu(menu, _parentKey, layout = MEGAMENU_LAYOUT_SCHEME.LIST) {
        const {
          _megamenuRenderMap
        } = this;
        if (_megamenuRenderMap.has(layout)) {
          return _megamenuRenderMap.get(layout)(menu, _parentKey);
        }
        return this._renderMegaMenuListing(menu, _parentKey);
      }
    }, {
      kind: "get",
      key: "ArrowIcon",
      value: function () {
        const isRTL = document.dir.toLowerCase() === 'rtl';
        return isRTL ? svgResultCarbonIcon$h : svgResultCarbonIcon$i;
      }

      /**
       *  Render MegaMenu content in tabbed layout.
       *
       * @param menu megamenu data object
       * @param _parentKey key that identifies parent nav item
       * @returns {TemplateResult} A template fragment representing a tabbed megamenu.
       */
    }, {
      kind: "method",
      key: "_renderMegaMenuTabbed",
      value: function _renderMegaMenuTabbed(menu, _parentKey) {
        var _activeMenuItem$headi;
        const {
          viewAll,
          sections
        } = menu;
        const sortedMenuItems = [];
        sections.forEach((section, i) => {
          return sortedMenuItems.push(_objectSpread$1(_objectSpread$1({}, section), {}, {
            itemKey: `${_parentKey}-${i}`
          }));
        });
        const activeMenuItem = this._activeMegamenuTabKey ? sortedMenuItems.find(item => item.itemKey === this._activeMegamenuTabKey) : sortedMenuItems[0];
        return x(_t4 || (_t4 = _$2`
      <c4d-megamenu layout="${0}">
        <c4d-megamenu-left-navigation>
          <c4d-megamenu-tabs
            value="${0}">
            ${0}
          </c4d-megamenu-tabs>
          ${0}
        </c4d-megamenu-left-navigation>
        ${0}
      </c4d-megamenu>
    `), MEGAMENU_LAYOUT_SCHEME.TAB, ifNonEmpty(activeMenuItem === null || activeMenuItem === void 0 || (_activeMenuItem$headi = activeMenuItem.heading) === null || _activeMenuItem$headi === void 0 ? void 0 : _activeMenuItem$headi.title), sortedMenuItems.map(item => {
          var _item$heading;
          return item !== null && item !== void 0 && (_item$heading = item.heading) !== null && _item$heading !== void 0 && _item$heading.title ? x(_t5 || (_t5 = _$2`
                    <c4d-megamenu-tab
                      id="tab-${0}"
                      target="panel-${0}"
                      value="${0}">
                      ${0}
                    </c4d-megamenu-tab>
                  `), item.itemKey, item.itemKey, item.heading.title, item.heading.title) : '';
        }), viewAll !== null && viewAll !== void 0 && viewAll.url && viewAll !== null && viewAll !== void 0 && viewAll.title ? x(_t6 || (_t6 = _$2`
                <c4d-megamenu-link-with-icon
                  href="${0}"
                  part="view-all view-all-left"
                  slot="view-all">
                  <span>${0}</span>${0}
                </c4d-megamenu-link-with-icon>
              `), viewAll.url, viewAll.title, this.ArrowIcon({
          slot: 'icon',
          part: 'l0-view-all-products-arrow'
        })) : null, this._renderMegamenuTabPanel(activeMenuItem));
      }

      /**
       * Render individual tabpanel in a tabbed megamenu.
       *
       * @param menuItem menuItem data object
       * @returns {TemplateResult} A template fragment representing a megamenu tabpanel.
       */
    }, {
      kind: "method",
      key: "_renderMegamenuTabPanel",
      value: function _renderMegamenuTabPanel(menuItem) {
        const {
          itemKey,
          groups,
          heading,
          viewAll: itemViewAll
        } = menuItem;
        return x(_t7 || (_t7 = _$2`
      <div
        id="panel-${0}"
        role="tabpanel"
        aria-labelledby="tab-${0}">
        <c4d-megamenu-right-navigation
          class="${0}--masthead__tabpanel-child"
          style-scheme="${0}">
          ${0}
          ${0}
          ${0}
        </c4d-megamenu-right-navigation>
      </div>
    `), itemKey, itemKey, c4dPrefix$4, MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.HAS_SIDEBAR, heading !== null && heading !== void 0 && heading.title ? x(_t8 || (_t8 = _$2`
                <c4d-megamenu-heading
                  href="${0}"
                  title="${0}"
                  slot="heading">
                  ${0}
                </c4d-megamenu-heading>
              `), ifNonEmpty(heading === null || heading === void 0 ? void 0 : heading.url), heading === null || heading === void 0 ? void 0 : heading.title, heading === null || heading === void 0 ? void 0 : heading.description) : '', groups ? groups.map((group, i) => this._renderMegapanelLinkGroup(group, {
          autoid: `panel-${itemKey}-${i}`
        })) : '', itemViewAll !== null && itemViewAll !== void 0 && itemViewAll.url && itemViewAll !== null && itemViewAll !== void 0 && itemViewAll.title ? x(_t9 || (_t9 = _$2`
                <c4d-megamenu-link-with-icon
                  href="${0}"
                  part="view-all view-all-right"
                  slot="view-all">
                  <span>${0}</span>${0}
                </c4d-megamenu-link-with-icon>
              `), itemViewAll.url, itemViewAll.title, this.ArrowIcon({
          slot: 'icon'
        })) : null);
      }

      /**
       * Render MegaMenu content in listing layout.
       *
       * @param menu megamenu data object
       * @param _parentKey key that identifies parent nav item
       * @returns {TemplateResult} A template fragment representing a listing megamenu.
       */
      // eslint-disable-next-line
    }, {
      kind: "method",
      key: "_renderMegaMenuListing",
      value: function _renderMegaMenuListing(menu, _parentKey) {
        const megapanel = menu.sections[0];
        const {
          heading
        } = megapanel;
        const {
          viewAll,
          highlights
        } = menu;
        return x(_t10 || (_t10 = _$2`
      <c4d-megamenu layout="${0}">
        ${0}
        <c4d-megamenu-right-navigation
          style-scheme="${0}">
          ${0}
          ${0}
          ${0}
        </c4d-megamenu-right-navigation>
        ${0}
      </c4d-megamenu>
    `), MEGAMENU_LAYOUT_SCHEME.LIST, highlights ? x(_t11 || (_t11 = _$2`
              <c4d-megamenu-left-navigation>
                ${0}
              </c4d-megamenu-left-navigation>
            `), highlights.map((group, i) => this._renderMegapanelLinkGroup(group, {
          headingLevel: 2,
          autoid: `${c4dPrefix$4}--masthead__l0-nav-list${i}`
        }))) : null, highlights ? MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.HAS_SIDEBAR : MEGAMENU_RIGHT_NAVIGATION_STYLE_SCHEME.FULL, heading && !highlights ? x(_t12 || (_t12 = _$2`
                <c4d-megamenu-heading
                  href="${0}"
                  title="${0}"
                  slot="heading">
                  ${0}
                </c4d-megamenu-heading>
              `), ifNonEmpty(heading.url), ifNonEmpty(heading.title), heading.description) : '', megapanel.groups.map((group, i) => this._renderMegapanelLinkGroup(group, {
          headingLevel: heading ? 3 : 2,
          autoid: `${c4dPrefix$4}--masthead__l0-nav-list${i + (highlights ? highlights.length : 0)}`
        })), viewAll !== null && viewAll !== void 0 && viewAll.url && viewAll !== null && viewAll !== void 0 && viewAll.title ? x(_t13 || (_t13 = _$2`
                <c4d-megamenu-link-with-icon
                  href="${0}"
                  part="view-all view-all-right"
                  slot="view-all">
                  <span>${0}</span>${0}
                </c4d-megamenu-link-with-icon>
              `), viewAll.url, viewAll.title, this.ArrowIcon({
          slot: 'icon'
        })) : null, viewAll !== null && viewAll !== void 0 && viewAll.url && viewAll !== null && viewAll !== void 0 && viewAll.title ? x(_t14 || (_t14 = _$2`
              <c4d-megamenu-link-with-icon
                href="${0}"
                part="view-all view-all-bottom">
                <span>${0}</span>${0}
              </c4d-megamenu-link-with-icon>
            `), viewAll.url, viewAll.title, this.ArrowIcon({
          slot: 'icon'
        })) : null);
      }

      /**
       * Render a Megapanel link group.
       *
       * @param group megamenu link group
       * @returns {TemplateResult} A template fragment representing a megapanel link group.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderMegapanelLinkGroup",
      value: function _renderMegapanelLinkGroup(group, options = {
        headingLevel: 3
      }) {
        const {
          links,
          heading
        } = group;
        const {
          headingLevel,
          autoid
        } = options;
        return x(_t15 || (_t15 = _$2`
      <c4d-megamenu-category-group data-autoid="${0}">
        ${0}
        ${0}
      </c4d-megamenu-category-group>
    `), ifNonEmpty(autoid), heading !== null && heading !== void 0 && heading.title ? x(_t16 || (_t16 = _$2`
              <c4d-megamenu-category-heading
                title="${0}"
                href="${0}"
                slot="heading"
                heading-level="${0}">
                ${0}
              </c4d-megamenu-category-heading>
            `), heading.title, ifNonEmpty(heading === null || heading === void 0 ? void 0 : heading.url), ifNonEmpty(headingLevel), heading === null || heading === void 0 ? void 0 : heading.description) : '', links && links.map((link, i) => {
          const linkAutoId = autoid ? `${autoid}-item${i}` : null;
          if (link !== null && link !== void 0 && link.description) {
            return x(_t17 || (_t17 = _$2`
              <c4d-megamenu-category-link
                title="${0}"
                href="${0}"
                data-autoid="${0}">
                ${0}
              </c4d-megamenu-category-link>
            `), link === null || link === void 0 ? void 0 : link.title, ifNonEmpty(link === null || link === void 0 ? void 0 : link.url), ifNonEmpty(linkAutoId), link === null || link === void 0 ? void 0 : link.description);
          }
          return x(_t18 || (_t18 = _$2`
            <c4d-megamenu-category-link
              href="${0}"
              data-autoid="${0}">
              ${0}
            </c4d-megamenu-category-link>
          `), ifNonEmpty(link === null || link === void 0 ? void 0 : link.url), ifNonEmpty(linkAutoId), link === null || link === void 0 ? void 0 : link.title);
        }));
      }

      /**
       * Renders the left nav menus sections
       *
       * @param object heading heading of menu section
       * @param object.menuItems menu items
       * @param object.heading heading heading of menu section
       * @param object.isSubmenu determines whether menu section is a submenu section
       * @param object.showBackButton Determines whether to show back button
       * @param object.sectionTitle title of menu section
       * @param object.sectionUrl section title url of menu section
       * @param object.sectionId id of menu section
       * @returns {TemplateResult} A template fragment representing the left nav menu
       *   sections.
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_renderLeftNavMenuSections",
      value: function _renderLeftNavMenuSections({
        menuItems,
        heading,
        isSubmenu = false,
        showBackButton = false,
        sectionTitle = '',
        sectionUrl = '',
        sectionId = ''
      }) {
        const items = menuItems === null || menuItems === void 0 ? void 0 : menuItems.map(elem => {
          var _elem$isHeading, _elem$isViewAll;
          if (elem.menu) {
            return x(_t19 || (_t19 = _$2`
          <c4d-left-nav-menu
            ?last-highlighted=${0}
            panel-id=${0}
            ?active="${0}"
            title="${0}"
            data-autoid="${0}">
          </c4d-left-nav-menu>
        `), elem.lastHighlightedItem, elem.panelId, elem.selected, elem.title, elem.autoid);
          }
          return x(_t20 || (_t20 = _$2`
        <c4d-left-nav-menu-item
          ?last-highlighted=${0}
          ?active="${0}"
          href="${0}"
          title="${0}"
          data-autoid="${0}"
          .isHeading=${0}
          .isViewAll=${0}></c4d-left-nav-menu-item>
      `), elem.lastHighlightedItem, elem.selected, elem.url, elem.title, elem.autoid, (_elem$isHeading = elem.isHeading) !== null && _elem$isHeading !== void 0 ? _elem$isHeading : false, (_elem$isViewAll = elem.isViewAll) !== null && _elem$isViewAll !== void 0 ? _elem$isViewAll : false);
        });
        if (heading) {
          if (typeof heading === 'string') {
            items.unshift(x(_t21 || (_t21 = _$2`
            <c4d-left-nav-menu-category-heading
              title="${0}"></c4d-left-nav-menu-category-heading>
          `), heading));
          } else {
            const {
              title,
              description,
              url
            } = heading;
            items.unshift(x(_t22 || (_t22 = _$2`
            <c4d-left-nav-menu-category-heading
              .boostSize=${0}
              title="${0}"
              url="${0}">
              ${0}
            </c4d-left-nav-menu-category-heading>
          `), true, title, l(url), description !== null && description !== void 0 ? description : ''));
          }
        }
        return x(_t23 || (_t23 = _$2`
      <c4d-left-nav-menu-section
        section-id="${0}"
        ?is-submenu=${0}
        title=${0}
        titleUrl=${0}
        ?show-back-button=${0}>
        ${0}
      </c4d-left-nav-menu-section>
    `), sectionId, l(isSubmenu), l(sectionTitle), l(sectionUrl), l(showBackButton), items);
      }

      /**
       * checks if menu item's children url match the current url path, if so return the menu item and its children
       *
       * @returns {object} selectedItems
       */
      // eslint-disable-next-line class-methods-use-this
    }, {
      kind: "method",
      key: "_selectedLeftNavItems",
      value: function _selectedLeftNavItems() {
        const {
          currentUrlPath
        } = this;
        let matchFound = false;
        const selectedItems = {
          level0: '',
          level1: '',
          level2: ''
        };
        return ({
          menu: _menu = [{
            url: '',
            megapanelContent: {
              quickLinks: {
                links: [{
                  url: ''
                }]
              }
            }
          }],
          key: _key = '',
          parentItemUrl: _parentItemUrl = ''
        }) => {
          if (!matchFound) {
            if (_parentItemUrl === currentUrlPath) {
              selectedItems.level0 = `${_key}`;
              matchFound = true;
            }
            // check if child url matches current url path
            else {
              for (let i = 0; i < (_menu === null || _menu === void 0 ? void 0 : _menu.length); i++) {
                var _menu$i;
                if (((_menu$i = _menu[i]) === null || _menu$i === void 0 ? void 0 : _menu$i.url) === currentUrlPath) {
                  selectedItems.level0 = `${_key}`;
                  selectedItems.level1 = `${_key}-${i}`;
                  matchFound = true;
                  break;
                } else {
                  var _menu$i2;
                  const links = (_menu$i2 = _menu[i]) === null || _menu$i2 === void 0 || (_menu$i2 = _menu$i2.megapanelContent) === null || _menu$i2 === void 0 || (_menu$i2 = _menu$i2.quickLinks) === null || _menu$i2 === void 0 ? void 0 : _menu$i2.links;
                  for (let k = 0; k < (links === null || links === void 0 ? void 0 : links.length); k++) {
                    var _links$k;
                    if (((_links$k = links[k]) === null || _links$k === void 0 ? void 0 : _links$k.url) === currentUrlPath) {
                      selectedItems.level0 = `${_key}`;
                      selectedItems.level1 = `${_key}-${i}`;
                      selectedItems.level2 = `${_key}-${i}-${k}`;
                      matchFound = true;
                      break;
                    }
                  }
                }
              }
            }
            this._hasAutoSelectedItems = matchFound;
            return selectedItems;
          }
          return selectedItems;
        };
      }

      /**
       * Renders the left nav menus
       *
       * @param menuItems The options.
       * @param autoid Base autoid to be applied to the menu items
       * @returns {TemplateResult} A template fragment representing the left nav.
       */
    }, {
      kind: "method",
      key: "_renderLeftNav",
      value: function _renderLeftNav() {
        const {
          platform
        } = this;
        const menu = [];
        const menuItems = this.getL0Data();
        const autoid = `${c4dPrefix$4}--masthead__l0`;
        const level0Items = menuItems === null || menuItems === void 0 ? void 0 : menuItems.map((elem, i) => {
          // Instantiate bucket for first level submenus.
          const level1Items = [];

          // If it's a "simple" menu, no megapanels.
          if ((elem === null || elem === void 0 ? void 0 : elem.submenu) instanceof Array) {
            elem.submenu.forEach((link, j) => {
              level1Items.push({
                title: link.title,
                url: link.url,
                autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                lastHighlightedItem: false,
                panelId: `${i}, ${j}`,
                menu: false,
                selected: false
              });
            });
            if (level1Items.length !== 0) {
              menu.push(this._renderLeftNavMenuSections({
                menuItems: level1Items,
                isSubmenu: true,
                showBackButton: true,
                sectionTitle: elem.title,
                sectionUrl: elem.url,
                sectionId: `${i}, -1`,
                heading: elem.title
              }));
            }
          }

          // If it's a megapanel.
          const submenu = elem.submenu;
          if (submenu !== null && submenu !== void 0 && submenu.sections) {
            // Check if other types of links exist.
            const highlightedItems = (submenu === null || submenu === void 0 ? void 0 : submenu.highlights) || [];
            const viewAll = submenu === null || submenu === void 0 ? void 0 : submenu.viewAll;

            // 1. Add highlighted items to top of menu.
            if (highlightedItems.length !== 0) {
              highlightedItems.forEach((highlight, j) => {
                const {
                  heading,
                  links
                } = highlight;
                const lastHighlighted = j + 1 === highlightedItems.length;
                if (heading) {
                  level1Items.push({
                    title: heading.title,
                    url: heading.url,
                    autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                    lastHighlightedItem: lastHighlighted,
                    panelId: `${i}, ${j}`,
                    menu: false,
                    selected: false,
                    isHeading: true
                  });
                }
                if (links) {
                  links.forEach((link, k) => {
                    level1Items.push({
                      title: link.title,
                      url: link.url,
                      autoid: `${autoid}--sidenav--nav${i}-list${j}-item${k}`,
                      lastHighlightedItem: lastHighlighted,
                      panelId: `${i}, ${j}`,
                      menu: false,
                      selected: false
                    });
                  });
                }
              });
            }

            /**
             * 2. Add megamenu links to menu.
             *
             * `sections`' length implies a tabbed or listing megamenu, which must
             * be handled in different ways and have slightly different content
             * requirements.
             */
            if (submenu.sections.length > 1) {
              submenu.sections.map((item, j) => {
                const {
                  heading,
                  groups
                } = item;
                const lastHighlighted = j + 1 === highlightedItems.length;
                const level2Items = [];
                groups.forEach((linkGroup, k) => {
                  const {
                    heading: groupHeading,
                    links
                  } = linkGroup;
                  if (groupHeading) {
                    level2Items.push({
                      title: groupHeading.title,
                      url: groupHeading.url,
                      autoid: `${autoid}--sidenav--nav${i}-list${j}-heading${k}`,
                      selected: false,
                      isHeading: true
                    });
                  }
                  if (links) {
                    links.forEach((link, l) => {
                      level2Items.push({
                        title: link.title,
                        url: link.url,
                        autoid: `${autoid}--sidenav--nav${i}-list${j}-heading${k}-item${l}`,
                        selected: false
                      });
                    });
                  }
                });
                if (level2Items.length !== 0) {
                  menu.push(this._renderLeftNavMenuSections({
                    menuItems: level2Items,
                    isSubmenu: true,
                    showBackButton: true,
                    sectionTitle: heading === null || heading === void 0 ? void 0 : heading.title,
                    sectionUrl: heading === null || heading === void 0 ? void 0 : heading.url,
                    sectionId: `${i}, ${j}`,
                    heading
                  }));
                }
                return level1Items.push({
                  title: heading.title,
                  // headings are required in tabbed layout
                  url: heading === null || heading === void 0 ? void 0 : heading.url,
                  autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                  lastHighlightedItem: lastHighlighted,
                  panelId: `${i}, ${j}`,
                  selected: false,
                  menu: groups && groups.length !== 0
                });
              });
            } else {
              submenu.sections[0].groups.forEach((group, j) => {
                const {
                  heading,
                  links
                } = group;
                const lastHighlighted = j + 1 === highlightedItems.length;
                if (heading) {
                  level1Items.push({
                    title: heading.title,
                    url: heading.url,
                    lastHighlightedItem: lastHighlighted,
                    panelId: `${i}, ${j}`,
                    autoid: `${autoid}--sidenav--nav${i}-list${j}`,
                    menu: false,
                    selected: false,
                    isHeading: true
                  });
                }
                if (links) {
                  links.forEach((link, k) => {
                    level1Items.push({
                      title: link.title,
                      url: link.url,
                      lastHighlightedItem: lastHighlighted,
                      panelId: `${i}, ${j}, ${k}`,
                      autoid: `${autoid}--sidenav--nav${i}-list${j}-item${k}`,
                      menu: false,
                      selected: false
                    });
                  });
                }
              });
            }

            // 3. Add view all link to bottom of menu.
            if (viewAll) {
              level1Items.push({
                title: viewAll.title,
                url: viewAll.url,
                lastHighlightedItem: false,
                panelId: `${i}`,
                autoid: `${autoid}--sidenav--nav${i}-list${level1Items.length}`,
                menu: false,
                selected: false,
                isViewAll: true
              });
            }
            if (level1Items.length !== 0) {
              const isNotFaceted = submenu.sections.length === 1;
              const megapanelHeading = submenu.sections[0].heading;
              const heading = isNotFaceted && !!megapanelHeading ? megapanelHeading : elem.title;
              menu.push(this._renderLeftNavMenuSections({
                menuItems: level1Items,
                isSubmenu: true,
                showBackButton: true,
                sectionTitle: elem.title,
                sectionUrl: elem.url,
                sectionId: `${i}, -1`,
                heading
              }));
            }
          }
          return {
            title: elem.title,
            titleEnglish: elem.titleEnglish,
            url: elem === null || elem === void 0 ? void 0 : elem.url,
            menu: Boolean(elem === null || elem === void 0 ? void 0 : elem.submenu),
            panelId: `${i}, -1`,
            autoid: `${autoid}--sidenav--nav${i}`,
            selected: false
          };
        });
        return x(_t24 || (_t24 = _$2`
      <c4d-left-nav-overlay></c4d-left-nav-overlay>
      <c4d-left-nav>
        ${0}
        ${0}
        ${0}
      </c4d-left-nav>
    `), !platform ? undefined : x(_t25 || (_t25 = _$2`
              <c4d-left-nav-name href="${0}">
                ${0}
              </c4d-left-nav-name>
            `), ifNonEmpty(this._getPlatformUrl()), platform), this._renderLeftNavMenuSections({
          menuItems: level0Items,
          sectionId: '-1, -1',
          heading: false
        }), menu);
      }

      /**
       * Renders the mobile menu button.
       *
       * @returns {TemplateResult} A template fragment representing the menu button.
       */
    }, {
      kind: "method",
      key: "_renderMenuButton",
      value: function _renderMenuButton() {
        const {
          activateSearch,
          menuButtonAssistiveTextActive,
          menuButtonAssistiveTextInactive
        } = this;
        return x(_t26 || (_t26 = _$2`
      <c4d-masthead-menu-button
        button-label-active="${0}"
        button-label-inactive="${0}"
        ?hide-menu-button="${0}">
      </c4d-masthead-menu-button>
    `), ifNonEmpty(menuButtonAssistiveTextActive), ifNonEmpty(menuButtonAssistiveTextInactive), activateSearch);
      }

      /**
       * Checks if there is a child item in the menu section that matches current
       * url and returns true for first valid result.
       *
       * @param menuItem a top level L0 menu item
       * @returns boolean
       */
    }, {
      kind: "method",
      key: "_isActiveMenuItem",
      value: function _isActiveMenuItem(menuItem) {
        const {
          currentUrlPath
        } = this;
        const {
          submenu
        } = menuItem;
        let matchFound = false;
        if (!submenu) {
          matchFound = (menuItem === null || menuItem === void 0 ? void 0 : menuItem.url) === currentUrlPath;
        } else if (submenu instanceof Array) {
          matchFound = Boolean(submenu.find(link => link.url === currentUrlPath));
        } else if (submenu.sections) {
          const {
            highlights,
            viewAll,
            sections
          } = submenu;
          const flattenedLinks = [];
          const flattenLinkGroup = group => {
            const links = [];
            if (group.heading) {
              links.push(group.heading);
            }
            if (group.links) {
              group.links.forEach(link => {
                links.push(link);
              });
            }
            return links;
          };

          // Flatten all data into array of BasicLinks.
          if (highlights) {
            highlights.forEach(highlight => {
              flattenedLinks.push(...flattenLinkGroup(highlight));
            });
          }
          if (sections.length > 0) {
            sections.forEach(section => {
              if (section.heading) {
                flattenedLinks.push(section.heading);
              }
              section.groups.forEach(group => {
                flattenedLinks.push(...flattenLinkGroup(group));
              });
            });
          }
          if (viewAll) {
            flattenedLinks.push(viewAll);
          }

          // Check flattened list for matching URL.
          matchFound = Boolean(flattenedLinks.find(link => link.url === currentUrlPath));
        }
        return matchFound;
      }

      /**
       * Renders the top navigation bar.
       *
       * @returns {TemplateResult} A template fragment representing the top nav.
       */
    }, {
      kind: "method",
      key: "_renderTopNav",
      value: function _renderTopNav() {
        const {
          selectedMenuItem,
          menuBarAssistiveText,
          activateSearch
        } = this;
        return !this.getL0Data() ? undefined : x(_t27 || (_t27 = _$2`
          <c4d-top-nav
            selected-menu-item=${0}
            menu-bar-label="${0}"
            ?hideNav="${0}">
            ${0}
          </c4d-top-nav>
        `), selectedMenuItem, ifNonEmpty(menuBarAssistiveText), activateSearch, this.getL0Data().map((link, i) => {
          return this._renderNavItem(link, i, `${c4dPrefix$4}--masthead__l0`);
        }));
      }

      /**
       * Renders a nav item.
       *
       * @param item The item to render
       * @param i The index of the item in a series
       * @param autoid The unique id to assign to the item
       * @returns {TemplateResult} A template fragment representing a nav item.
       */
    }, {
      kind: "method",
      key: "_renderNavItem",
      value: function _renderNavItem(item, i, autoid) {
        const {
          selectedMenuItem,
          currentUrlPath,
          _activeMegamenuIndex
        } = this;
        const {
          submenu,
          title,
          titleEnglish,
          url
        } = item;
        let selected;
        if (selectedMenuItem) {
          var _titleEnglish$trim, _selectedMenuItem$tri;
          selected = (titleEnglish === null || titleEnglish === void 0 || (_titleEnglish$trim = titleEnglish.trim()) === null || _titleEnglish$trim === void 0 ? void 0 : _titleEnglish$trim.toLowerCase()) === (selectedMenuItem === null || selectedMenuItem === void 0 || (_selectedMenuItem$tri = selectedMenuItem.trim()) === null || _selectedMenuItem$tri === void 0 ? void 0 : _selectedMenuItem$tri.toLowerCase());
        } else {
          selected = this._isActiveMenuItem(item);
        }
        if (submenu instanceof Array) {
          return x(_t28 || (_t28 = _$2`
        <c4d-top-nav-menu
          ?active="${0}"
          menu-label="${0}"
          trigger-content="${0}"
          data-autoid="${0}-nav--nav${0}">
          ${0}
        </c4d-top-nav-menu>
      `), selected, title, title, autoid, i, submenu.map(({
            title: linkTitle,
            url: linkUrl
          }, j) => x(_t29 || (_t29 = _$2`
                <c4d-top-nav-menu-item
                  ?active="${0}"
                  href="${0}"
                  title="${0}"
                  data-autoid="${0}-nav--subnav-col${0}-item${0}"></c4d-top-nav-menu-item>
              `), selectedMenuItem ? selected : linkUrl === currentUrlPath, l(linkUrl), linkTitle, autoid, i, j)));
        }
        if (submenu !== null && submenu !== void 0 && submenu.sections) {
          const layout = submenu.sections.length > 1 ? MEGAMENU_LAYOUT_SCHEME.TAB : MEGAMENU_LAYOUT_SCHEME.LIST;

          // Render nav menu, but only render megamenu if it is active.
          return x(_t30 || (_t30 = _$2`
        <c4d-megamenu-top-nav-menu
          ?active="${0}"
          menu-label="${0}"
          trigger-content="${0}"
          data-autoid="${0}-nav--nav${0}"
          .menuIndex=${0}>
          ${0}
        </c4d-megamenu-top-nav-menu>
      `), selected, title, title, autoid, i, i, _activeMegamenuIndex === i ? this._renderMegaMenu(submenu, i, layout) : null);
        }

        // Fallback render as simple link.
        return x(_t31 || (_t31 = _$2`
      <c4d-top-nav-item
        ?active="${0}"
        href="${0}"
        title="${0}"
        data-autoid="${0}-nav--nav${0}"></c4d-top-nav-item>
    `), selectedMenuItem ? selected : url === currentUrlPath, l(url), title, autoid, i);
      }

      /**
       * Sets the active megamenu upon user interaction.
       *
       * @param event The event.
       */
    }, {
      kind: "field",
      decorators: [HostListener(C4DMegaMenuTopNavMenu.eventMegaMenuToggled)],
      key: "_loadMegamenu",
      value() {
        return event => {
          const {
            detail: {
              active,
              resolveFn,
              index: menuIndex
            }
          } = event;

          // Open a megamenu by updating state to trigger a re-render. This also closes
          // any previously opened megamenu.
          if (active && menuIndex !== undefined) {
            var _this$contactModuleAp;
            this._activeMegamenuIndex = menuIndex;

            // Close the Contact Module upon opening megamenu.
            (_this$contactModuleAp = this.contactModuleApp) === null || _this$contactModuleAp === void 0 || _this$contactModuleAp.minimize();

            // Set positioning property upon opening megamenu.
            this._setCustomPropertyL0BottomEdge();
          }

          // If clicking the same nav item to close megamenu, reset state to prune its
          // markup from the DOM.
          if (!active && menuIndex === this._activeMegamenuIndex) {
            this._activeMegamenuIndex = undefined;
          }

          // Reset active tab when closing any megamenu.
          if (!active && this._activeMegamenuTabKey) {
            this._activeMegamenuTabKey = undefined;
          }
          resolveFn();
        };
      }
    }, {
      kind: "method",
      decorators: [HostListener(C4DMastheadL1.dropDownToggleEvent)],
      key: "_handleL1DropdownToggle",
      value: function _handleL1DropdownToggle({
        detail
      }) {
        const {
          isOpen
        } = detail;
        if (isOpen) {
          var _this$contactModuleAp2;
          (_this$contactModuleAp2 = this.contactModuleApp) === null || _this$contactModuleAp2 === void 0 || _this$contactModuleAp2.minimize();
        }
      }

      /**
       * Sets the active megamenu tabpanel upon user interaction.
       *
       * @param event The event.
       */
    }, {
      kind: "method",
      decorators: [HostListener(C4DMegaMenuTabs.eventBeforeSelect)],
      key: "_loadMegamenuTabPanel",
      value: function _loadMegamenuTabPanel(event) {
        const {
          detail
        } = event;
        const panelId = detail.item.id.split('tab-')[1];
        this._activeMegamenuTabKey = panelId;
      }

      /**
       * Stores a reference of the globally-scoped CM_APP object within the masthead.
       */
    }, {
      kind: "field",
      decorators: [HostListener('document:cm-app-ready')],
      key: "_getContactModuleReference",
      value() {
        return () => {
          // @ts-ignore: CM_APP will definitely exist if this event is fired
          this.contactModuleApp = window.CM_APP;
        };
      }
    }, {
      kind: "field",
      decorators: [HostListener(C4DMastheadMenuButton.eventToggle)],
      key: "_handleMenuButtonToggle",
      value() {
        return event => {
          var _event$detail;
          if ((_event$detail = event.detail) !== null && _event$detail !== void 0 && _event$detail.active) {
            this._setCustomPropertyL0BottomEdge();
          }
        };
      }
    }, {
      kind: "method",
      key: "_setCustomPropertyL0BottomEdge",
      value:
      /**
       * Performs actions on left nav button toggle.
       */
      /**
       * Sets a CSS value for the position of the L0's bottom edge.
       */
      function _setCustomPropertyL0BottomEdge() {
        var _this$mastheadRef;
        const mastheadL0 = (_this$mastheadRef = this.mastheadRef) === null || _this$mastheadRef === void 0 ? void 0 : _this$mastheadRef.shadowRoot.querySelector(`.${prefix$1}--masthead__l0`);
        if (mastheadL0) {
          this.style.setProperty(this.constructor.customPropertyL0BottomEdge, `${mastheadL0.getBoundingClientRect().bottom}px`);
        }
      }

      /**
       * Gets localized platform URL.
       *
       * @returns {string} A URL.
       */
    }, {
      kind: "method",
      key: "_getPlatformUrl",
      value: function _getPlatformUrl() {
        const {
          language,
          platformUrl
        } = this;
        const formattedLang = language === null || language === void 0 ? void 0 : language.toLowerCase().replace(/-(.*)/, m => m.toUpperCase());
        let url = platformUrl;
        if (platformUrl && formattedLang) {
          if (typeof platformUrl === 'object' && Object.prototype.hasOwnProperty.call(platformUrl, formattedLang)) {
            url = platformUrl[formattedLang].url || platformUrl;
          }
        }
        return url;
      }

      /**
       * Renders the platform title.
       *
       * @returns {TemplateResult} A template fragment representing the platform title.
       */
    }, {
      kind: "method",
      key: "_renderPlatformTitle",
      value: function _renderPlatformTitle() {
        const {
          l1Data,
          platform
        } = this;
        return !platform || l1Data ? undefined : x(_t32 || (_t32 = _$2`
          <c4d-top-nav-name href="${0}">
            ${0}
          </c4d-top-nav-name>
        `), l(this._getPlatformUrl()), platform);
      }

      /**
       * Renders the masthead search.
       *
       * @returns {TemplateResult} A template fragment representing the search bar.
       */
    }, {
      kind: "method",
      key: "_renderSearch",
      value: function _renderSearch() {
        const {
          activateSearch,
          currentSearchResults,
          customTypeaheadAPI,
          hasSearch,
          initialSearchTerm,
          inputTimeout,
          language,
          openSearchDropdown,
          scopeParameters,
          searchPlaceholder
        } = this;
        return hasSearch === 'false' ? '' : x(_t33 || (_t33 = _$2`
          <c4d-search-with-typeahead
            ?active="${0}"
            .currentSearchResults="${0}"
            ?custom-typeahead-api="${0}"
            initial-search-term="${0}"
            input-timeout="${0}"
            language="${0}"
            ?open="${0}"
            placeholder="${0}"
            .scopeParameters="${0}"
            ?searchOpenOnload="${0}"></c4d-search-with-typeahead>
        `), activateSearch, l(currentSearchResults), l(customTypeaheadAPI), l(initialSearchTerm), inputTimeout, l(language), openSearchDropdown, l(searchPlaceholder), l(scopeParameters), activateSearch);
      }

      /**
       * Renders the contact button.
       *
       * @returns {TemplateResult} A template fragment representing the contact button.
       */
    }, {
      kind: "method",
      key: "_renderContact",
      value: function _renderContact() {
        const {
          contactUsButton,
          hasContact
        } = this;
        return hasContact === 'false' ? undefined : x(_t34 || (_t34 = _$2`
          <c4d-masthead-contact
            data-ibm-contact="contact-link"
            trigger-label="${0}"></c4d-masthead-contact>
        `), l(contactUsButton === null || contactUsButton === void 0 ? void 0 : contactUsButton.title));
      }
    }, {
      kind: "method",
      key: "_renderLanguageSelector",
      value: function _renderLanguageSelector() {
        const {
          hasLanguageSelector
        } = this;
        return hasLanguageSelector === 'false' ? undefined : x(_t35 || (_t35 = _$2`
          <div class="earth-language-icon" part="earth-l0-icon">
            ${0}
          </div>
        `), svgResultCarbonIcon$g({
          part: 'earth-l0-svg'
        }));
      }
    }, {
      kind: "method",
      key: "_renderCart",
      value: function _renderCart() {
        const {
          hasCart,
          cartLabel
        } = this;
        return hasCart ? x(_t36 || (_t36 = _$2`<c4d-masthead-cart link-label="${0}"></c4d-masthead-cart>`), cartLabel) : undefined;
      }

      /**
       * Gets the appropriate profile items for the current masthead state.
       *
       * @returns An array of profile items or undefined.
       */
    }, {
      kind: "method",
      key: "_getProfileItems",
      value: function _getProfileItems() {
        const {
          customProfileLogin,
          userIsAuthenticated,
          authenticatedProfileItems,
          unauthenticatedProfileItems
        } = this;
        let profileItems;
        if (C4D_CUSTOM_PROFILE_LOGIN && customProfileLogin && !userIsAuthenticated) {
          profileItems = unauthenticatedProfileItems === null || unauthenticatedProfileItems === void 0 ? void 0 : unauthenticatedProfileItems.map(item => {
            if ((item === null || item === void 0 ? void 0 : item.id) === 'signin') {
              return _objectSpread$1(_objectSpread$1({}, item), {}, {
                url: customProfileLogin
              });
            }
            return item;
          });
        } else {
          profileItems = userIsAuthenticated ? authenticatedProfileItems : unauthenticatedProfileItems;
        }
        return profileItems;
      }

      /**
       * Renders the profile menu.
       *
       * @returns {TemplateResult} A template fragment representing the profile menu.
       */
    }, {
      kind: "method",
      key: "_renderProfileMenu",
      value: function _renderProfileMenu() {
        var _this$_getProfileItem;
        const {
          hasProfile,
          userIsAuthenticated
        } = this;
        return hasProfile === 'false' ? '' : x(_t37 || (_t37 = _$2`
          <c4d-masthead-profile ?authenticated="${0}">
            ${0}
          </c4d-masthead-profile>
        `), userIsAuthenticated, (_this$_getProfileItem = this._getProfileItems()) === null || _this$_getProfileItem === void 0 ? void 0 : _this$_getProfileItem.map(({
          title,
          url
        }) => x(_t38 || (_t38 = _$2`
                  <c4d-masthead-profile-item href="${0}">
                    ${0}
                  </c4d-masthead-profile-item>
                `), l(url), title)));
      }

      /**
       * Whether or not a nav item has automatically been designated as "selected".
       *
       * @internal
       */
    }, {
      kind: "field",
      key: "_hasAutoSelectedItems",
      value() {
        return false;
      }
    }, {
      kind: "field",
      key: "_isMobileVersion",
      value() {
        return mastheadBreakpoint.matches;
      }
    }, {
      kind: "field",
      key: "_megamenuRenderMap",
      value() {
        return new Map([[MEGAMENU_LAYOUT_SCHEME.LIST, this._renderMegaMenuListing.bind(this)], [MEGAMENU_LAYOUT_SCHEME.TAB, this._renderMegaMenuTabbed.bind(this)]]);
      }
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_activeMegamenuIndex",
      value: void 0
    }, {
      kind: "field",
      decorators: [t$2()],
      key: "_activeMegamenuTabKey",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true,
        attribute: 'has-profile'
      })],
      key: "hasProfile",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true,
        attribute: 'has-search'
      })],
      key: "hasSearch",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'activate-search'
      })],
      key: "activateSearch",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'search-open-on-load'
      })],
      key: "searchOpenOnload",
      value() {
        return this.activateSearch;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'initial-search-term',
        reflect: true
      })],
      key: "initialSearchTerm",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "authenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "contactUsButton",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "platform",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "platformUrl",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "currentSearchResults",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "currentUrlPath",
      value() {
        var _root$location;
        return (_root$location = lib.location) === null || _root$location === void 0 ? void 0 : _root$location.href;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'custom-profile-login'
      })],
      key: "customProfileLogin",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'custom-typeahead-api',
        type: Boolean
      })],
      key: "customTypeaheadAPI",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'masthead-assistive-text'
      })],
      key: "mastheadAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-bar-assistive-text'
      })],
      key: "menuBarAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'skip-to-content-text'
      })],
      key: "skipToContentText",
      value() {
        return 'Skip to content';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'skip-to-content-href'
      })],
      key: "skipToContentHref",
      value() {
        return '#main-content';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-button-assistive-text-active'
      })],
      key: "menuButtonAssistiveTextActive",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-button-assistive-text-inactive'
      })],
      key: "menuButtonAssistiveTextInactive",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "scopeParameters",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-menu-item-l1'
      })],
      key: "selectedMenuItemL1",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "unauthenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'data-endpoint'
      })],
      key: "dataEndpoint",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Number,
        attribute: 'input-timeout'
      })],
      key: "inputTimeout",
      value() {
        return 200;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "logoData",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "navLinks",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "l0Data",
      value: void 0
    }, {
      kind: "method",
      key: "getL0Data",
      value:
      /**
       * Whether the nav should load as `left-nav` or `top-nav`
       */
      /**
       * The placeholder for `loadTranslation()` Redux action that will be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `loadUserStatus()` Redux action that will be mixed in.
       *
       * @internal
       */
      /**
       * The placeholder for `setLanguage()` Redux action that will be mixed in.
       *
       * @internal
       */
      /**
       * Map of megamenu layout options to corresponding render methods.
       *
       * @internal
       */
      /**
       * The index of a megamenu that should be visible.
       */
      /**
       * The index of a megamenu's tabpanel that should be visible.
       */
      /**
       * `true` if there is a profile.
       */
      /**
       * `true` if there is a search.
       */
      /**
       * `true` to activate the search box.
       */
      /**
       * `true` sets search to active when page loads.
       */
      /**
       * Sets a default query in the masthead's search input.
       */
      /**
       * The profile items for authenticated state.
       */
      /**
       * Text for Contact us button
       */
      /**
       * The platform name.
       */
      /**
       * The platform url. Accepts both a string or an object with a specific URL for each locale.
       */
      /**
       * The search results to show in the UI.
       */
      /**
       * The custom profile login link.
       */
      /**
       * The boolean to use a custom search API.
       */
      /**
       * The `aria-label` attribute for the top-level container.
       */
      /**
       * The `aria-label` attribute for the menu bar UI.
       */
      /**
       * The skip-to-content link text.
       */
      /**
       * The skip-to-content href.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state.
       */
      /**
       * The parameters passed to the search-with-typeahead for search scope
       */
      /**
       * The English title of the selected nav item.
       */
      /**
       * The English title of the selected nav item in the L1.
       */
      /**
       * The profile items for unauthenticated state.
       */
      /**
       * Specify translation endpoint if not using default c4d endpoint.
       */
      /**
       * The throttle timeout to run query upon user input.
       */
      /**
       * The language used for query.
       */
      /**
       * Logo data
       */
      /**
       * The navigation links.
       *
       * @deprecated This property name is ambiguous. Use the l0Data prop instead.
       */
      /**
       * Data for l0.
       */
      /**
       * Temporary getter to fetch data until navLinks prop is phased out.
       */
      function getL0Data() {
        const {
          l0Data,
          navLinks
        } = this;
        if (navLinks) {
          console.warn(`Warning: ${c4dPrefix$4}-masthead's "navLinks" property is deprecated. Use "l0Data" property instead.`);
        }
        return l0Data || navLinks;
      }

      /**
       * Data for l1.
       */
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "l1Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'open-search-dropdown'
      })],
      key: "openSearchDropdown",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "searchPlaceholder",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true,
        attribute: 'has-contact'
      })],
      key: "hasContact",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true,
        attribute: 'has-language-selector'
      })],
      key: "hasLanguageSelector",
      value() {
        return 'true';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'has-cart'
      })],
      key: "hasCart",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: String,
        reflect: true,
        attribute: 'cart-label'
      })],
      key: "cartLabel",
      value() {
        return 'Cart';
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'auth-method'
      })],
      key: "authMethod",
      value() {
        return MASTHEAD_AUTH_METHOD.DEFAULT;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'user-status'
      })],
      key: "userStatus",
      value() {
        return this.authMethod === MASTHEAD_AUTH_METHOD.DEFAULT ? UNAUTHENTICATED_STATUS : CLOUD_UNAUTHENTICATED_STATUS;
      }
    }, {
      kind: "get",
      key: "userIsAuthenticated",
      value:
      /**
       * `true` to open the search dropdown.
       */
      /**
       * Value to display when the input has an empty `value`.
       */
      /**
       * `true` if Contact us should be shown.
       */
      /**
       * `true` if Language Selector should be shown.
       */
      /**
       * `true` if Cart should be shown.
       */
      /**
       * Label for the cart icon.
       */
      /**
       * The selected authentication method, either `profile-api` (default), `cookie`, or `docs-api`.
       */
      /**
       * The user authentication status.
       */
      function () {
        const {
          userStatus
        } = this;
        return userStatus !== UNAUTHENTICATED_STATUS && userStatus !== CLOUD_UNAUTHENTICATED_STATUS;
      }

      /**
       * A reference to the c4d-masthead element.
       */
    }, {
      kind: "field",
      decorators: [i$1(`${c4dPrefix$4}-masthead`)],
      key: "mastheadRef",
      value: void 0
    }, {
      kind: "field",
      key: "_heightResizeObserver",
      value() {
        return new ResizeObserver(this._resizeObserverCallback.bind(this));
      }
    }, {
      kind: "method",
      key: "_resizeObserverCallback",
      value:
      /**
       * Resize observer to trigger container height recalculations.
       *
       * @private
       */
      /**
       * Prevents resize observer from blocking main thread.
       */
      /**
       * Throttled callback for _heightResizeObserver.
       */
      function _resizeObserverCallback() {
        clearTimeout(this._resizeObserverThrottle);
        this._resizeObserverThrottle = setTimeout(this._setContainerHeight.bind(this), 100);
      }

      /**
       * Sets root element's height equal to the height of the fixed masthead elements.
       */
    }, {
      kind: "method",
      key: "_setContainerHeight",
      value: function _setContainerHeight() {
        const {
          mastheadRef
        } = this;
        if (mastheadRef) {
          this.style.display = 'block';
          this.style.height = `${mastheadRef.getBoundingClientRect().height}px`;
        }
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value: function firstUpdated() {
        var _this$_loadTranslatio;
        const {
          language,
          dataEndpoint
        } = this;
        globalInit();
        if (language) {
          var _this$_setLanguage;
          (_this$_setLanguage = this._setLanguage) === null || _this$_setLanguage === void 0 || _this$_setLanguage.call(this, language);
        }
        (_this$_loadTranslatio = this._loadTranslation) === null || _this$_loadTranslatio === void 0 || _this$_loadTranslatio.call(this, language, dataEndpoint).catch(() => {}); // The error is logged in the Redux store
        if (this.userStatus === UNAUTHENTICATED_STATUS) {
          var _this$_loadUserStatus;
          (_this$_loadUserStatus = this._loadUserStatus) === null || _this$_loadUserStatus === void 0 || _this$_loadUserStatus.call(this, this.authMethod);
        }

        // This is a temp fix until we figure out why we can't set styles to the :host(c4d-masthead-container) in stylesheets
        this.style.zIndex = '900';
        this.style.position = 'relative';

        // Allows conditional rendering of left/top navs.
        mastheadBreakpoint.addEventListener('change', () => {
          this._isMobileVersion = mastheadBreakpoint.matches;
          this.requestUpdate();
        });

        // Keep render root's height in sync with c4d-masthead.
        this._heightResizeObserver.observe(this.mastheadRef);
        const mastheadHasLanguageSelector = this.querySelector('c4d-masthead[has-language-selector]');
        if (mastheadHasLanguageSelector) {
          this.hasLanguageSelector = 'true';
        } else {
          this.hasLanguageSelector = 'false';
        }
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        if (changedProperties.has('language') || changedProperties.has('dataEndpoint')) {
          const {
            language,
            dataEndpoint
          } = this;
          if (language) {
            var _this$_setLanguage2, _this$_loadTranslatio2;
            (_this$_setLanguage2 = this._setLanguage) === null || _this$_setLanguage2 === void 0 || _this$_setLanguage2.call(this, language);
            (_this$_loadTranslatio2 = this._loadTranslation) === null || _this$_loadTranslatio2 === void 0 || _this$_loadTranslatio2.call(this, language, dataEndpoint).catch(() => {}); // The error is logged in the Redux store
          }
        }
      }
    }, {
      kind: "method",
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        _superPropGet$1(C4DMastheadComposite, "disconnectedCallback", this, 3)([]);
        this._heightResizeObserver.disconnect();
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        const {
          _isMobileVersion: isMobileVersion,
          activateSearch,
          mastheadAssistiveText,
          skipToContentText,
          skipToContentHref
        } = this;
        return x(_t39 || (_t39 = _$2`
      ${0}
      <c4d-masthead
        has-language-selector
        ?has-l1=${0}
        aria-label="${0}">
        <c4d-skip-to-content
          href="${0}"
          link-assistive-text="${0}"></c4d-skip-to-content>
        ${0} ${0}
        ${0}
        ${0} ${0}
        <c4d-masthead-global-bar ?has-search-active=${0}>
          ${0}
          ${0}${0}
          ${0}
        </c4d-masthead-global-bar>
        ${0}
        <c4d-megamenu-overlay></c4d-megamenu-overlay>
      </c4d-masthead>
    `), isMobileVersion ? this._renderLeftNav() : '', this.l1Data, ifNonEmpty(mastheadAssistiveText), skipToContentHref, skipToContentText, isMobileVersion ? this._renderMenuButton() : '', this._renderLogo(), this._renderPlatformTitle(), !isMobileVersion ? this._renderTopNav() : '', this._renderSearch(), activateSearch, this._renderContact(), this._renderCart(), this._renderLanguageSelector(), this._renderProfileMenu(), this._renderL1());
      }
    }, {
      kind: "method",
      key: "createRenderRoot",
      value: function createRenderRoot() {
        return this;
      }

      /**
       * The name of the CSS custom property to track bottom edge position.
       */
    }, {
      kind: "get",
      static: true,
      key: "customPropertyL0BottomEdge",
      value: function () {
        return `--${c4dPrefix$4}-masthead-l0-bottom-edge`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles$8;
      }
    }]
  };
}, HostListenerMixin(s));

function _decorate$3(e, r, t, i) { var o = _getDecoratorsApi$3(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$3(s.d.map(_createElementDescriptor$3)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$3() { _getDecoratorsApi$3 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$3(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$3(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$3(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$3(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$3(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$3(e) { var r, t = _toPropertyKey$3(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$3(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$3(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$3(o.descriptor) || _isDataDescriptor$3(i.descriptor)) { if (_hasDecorators$3(o) || _hasDecorators$3(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$3(o)) { if (_hasDecorators$3(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$3(o, i); } } else r.push(o); } return r; }
function _hasDecorators$3(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$3(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$3(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$3(t) { var i = _toPrimitive$3(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$3(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$3(r) { return _arrayWithHoles$3(r) || _iterableToArray$3(r) || _unsupportedIterableToArray$3(r) || _nonIterableRest$3(); }
function _nonIterableRest$3() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$3(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$3(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$3(r, a) : void 0; } }
function _arrayLikeToArray$3(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$3(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$3(r) { if (Array.isArray(r)) return r; }
const {
  stablePrefix: c4dPrefix$3
} = settings;

/**
 * The Redux state used for `<c4d-masthead-container>`.
 */

/**
 * The properties for `<c4d-masthead-container>` from Redux state.
 */

/**
 * The Redux actions used for `<c4d-masthead-container>.
 */

/**
 * @param state The Redux state for masthead.
 * @param self A reference to the masthead composite instance.
 * @returns The converted version of the given state, tailored for `<c4d-masthead-container>`.
 */
function mapStateToProps$1(state, self) {
  var _translations$languag7, _translations$languag8;
  const {
    localeAPI,
    translateAPI,
    profileAPI
  } = state;
  const {
    language
  } = localeAPI !== null && localeAPI !== void 0 ? localeAPI : {};
  const {
    translations
  } = translateAPI !== null && translateAPI !== void 0 ? translateAPI : {};
  const {
    request
  } = profileAPI !== null && profileAPI !== void 0 ? profileAPI : {};
  const getUserL0Data = self.getL0Data.bind(self);

  // Attempt to collect data from current/new and deprecated locations.
  let endpointl0Data;
  let profileItems;
  if (language) {
    var _translations$languag, _translations$languag2, _translations$languag3, _translations$languag4, _translations$languag5, _translations$languag6;
    endpointl0Data = {
      current: translations === null || translations === void 0 || (_translations$languag = translations[language]) === null || _translations$languag === void 0 || (_translations$languag = _translations$languag.masthead) === null || _translations$languag === void 0 ? void 0 : _translations$languag.nav,
      deprecated: translations === null || translations === void 0 || (_translations$languag2 = translations[language]) === null || _translations$languag2 === void 0 || (_translations$languag2 = _translations$languag2.mastheadNav) === null || _translations$languag2 === void 0 ? void 0 : _translations$languag2.links
    };
    profileItems = {
      authenticated: {
        current: translations === null || translations === void 0 || (_translations$languag3 = translations[language]) === null || _translations$languag3 === void 0 || (_translations$languag3 = _translations$languag3.masthead) === null || _translations$languag3 === void 0 || (_translations$languag3 = _translations$languag3.profileMenu) === null || _translations$languag3 === void 0 ? void 0 : _translations$languag3.authenticated,
        deprecated: translations === null || translations === void 0 || (_translations$languag4 = translations[language]) === null || _translations$languag4 === void 0 || (_translations$languag4 = _translations$languag4.profileMenu) === null || _translations$languag4 === void 0 ? void 0 : _translations$languag4.signedin
      },
      unauthenticated: {
        current: translations === null || translations === void 0 || (_translations$languag5 = translations[language]) === null || _translations$languag5 === void 0 || (_translations$languag5 = _translations$languag5.masthead) === null || _translations$languag5 === void 0 || (_translations$languag5 = _translations$languag5.profileMenu) === null || _translations$languag5 === void 0 ? void 0 : _translations$languag5.unauthenticated,
        deprecated: translations === null || translations === void 0 || (_translations$languag6 = translations[language]) === null || _translations$languag6 === void 0 || (_translations$languag6 = _translations$languag6.profileMenu) === null || _translations$languag6 === void 0 ? void 0 : _translations$languag6.signedout
      }
    };
  }
  return pickBy({
    // Respect user-set L0 data. Otherwise, progressively enhance to new shape.
    l0Data: !language || getUserL0Data() ? undefined : endpointl0Data.current || endpointl0Data.deprecated,
    // Progressively enhance to new profile items shape.
    authenticatedProfileItems: !language ? undefined : profileItems.authenticated.current || profileItems.authenticated.deprecated,
    unauthenticatedProfileItems: !language ? undefined : profileItems.unauthenticated.current || profileItems.unauthenticated.deprecated,
    contactUsButton: !language ? undefined : translations === null || translations === void 0 || (_translations$languag7 = translations[language]) === null || _translations$languag7 === void 0 || (_translations$languag7 = _translations$languag7.masthead) === null || _translations$languag7 === void 0 ? void 0 : _translations$languag7.contact,
    logoData: !language ? undefined : translations === null || translations === void 0 || (_translations$languag8 = translations[language]) === null || _translations$languag8 === void 0 || (_translations$languag8 = _translations$languag8.masthead) === null || _translations$languag8 === void 0 ? void 0 : _translations$languag8.logo,
    userStatus: request === null || request === void 0 ? void 0 : request.user,
    language
  }, value => value !== undefined);
}

/**
 * @param dispatch The Redux `dispatch()` API.
 * @returns The methods in `<c4d-masthead-container>` to dispatch Redux actions.
 */
function mapDispatchToProps$1(dispatch) {
  return bindActionCreators({
    _loadLanguage: loadLanguage,
    _setLanguage: setLanguage,
    _loadTranslation: loadTranslation,
    _loadUserStatus: loadUserStatus
  }, dispatch // TS definition of `bindActionCreators()` seems to have no templated `Dispatch`
  );
}

/**
 * Container component for masthead.
 *
 * @element c4d-masthead-container
 */
_decorate$3([carbonElement(`${c4dPrefix$3}-masthead-container`)], function (_initialize, _ConnectMixin) {
  class C4DMastheadContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DMastheadContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps$1, mapDispatchToProps$1)(C4DMastheadComposite));

var styles = i$4(["/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2021\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-grid-gutter: 2rem;\n  --cds-grid-columns: 4;\n  --cds-grid-margin: 0;\n}\n@media (min-width: 42rem) {\n  :root {\n    --cds-grid-columns: 8;\n    --cds-grid-margin: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :root {\n    --cds-grid-columns: 16;\n  }\n}\n@media (min-width: 99rem) {\n  :root {\n    --cds-grid-margin: 1.5rem;\n  }\n}\n\n.cds--css-grid {\n  --cds-grid-gutter-start: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-gutter-end: calc(var(--cds-grid-gutter) / 2);\n  --cds-grid-column-hang: calc(var(--cds-grid-gutter) / 2);\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  inline-size: 100%;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: var(--cds-grid-margin);\n}\n\n.cds--css-grid--full-width {\n  max-inline-size: 100%;\n}\n\n.cds--css-grid-column {\n  --cds-grid-mode-start: var(--cds-grid-gutter-start);\n  --cds-grid-mode-end: var(--cds-grid-gutter-end);\n  margin-inline: var(--cds-grid-gutter-start) var(--cds-grid-gutter-end);\n}\n[dir=rtl] .cds--css-grid-column {\n  margin-inline: var(--cds-grid-gutter-end) var(--cds-grid-gutter-start);\n}\n\n.cds--css-grid--narrow {\n  --cds-grid-gutter-start: 0;\n}\n\n.cds--css-grid--condensed {\n  --cds-grid-gutter: 0.0625rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--subgrid {\n  display: grid;\n  grid-template-columns: repeat(var(--cds-grid-columns), minmax(0, 1fr));\n  margin-inline: calc(var(--cds-grid-mode-start) * -1) calc(var(--cds-grid-mode-end) * -1);\n}\n[dir=rtl] .cds--subgrid {\n  margin-inline: calc(var(--cds-grid-mode-end) * -1) calc(var(--cds-grid-mode-start) * -1);\n}\n\n.cds--subgrid--wide {\n  --cds-grid-gutter-start: 1rem;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 0;\n}\n\n.cds--subgrid--narrow {\n  --cds-grid-gutter-start: 0;\n  --cds-grid-gutter-end: 1rem;\n  --cds-grid-column-hang: 1rem;\n}\n\n.cds--subgrid--condensed {\n  --cds-grid-gutter-start: 0.03125rem;\n  --cds-grid-gutter-end: 0.03125rem;\n  --cds-grid-column-hang: 0.96875rem;\n}\n\n.cds--grid-column-hang {\n  margin-inline-start: var(--cds-grid-column-hang);\n}\n[dir=rtl] .cds--grid-column-hang {\n  margin-inline: initial var(--cds-grid-column-hang);\n}\n\n.cds--col-span-0 {\n  display: none;\n}\n\n.cds--col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--col-span-5 {\n  --cds-grid-columns: 5;\n  display: block;\n  grid-column: span 5/span 5;\n}\n\n.cds--col-span-6 {\n  --cds-grid-columns: 6;\n  display: block;\n  grid-column: span 6/span 6;\n}\n\n.cds--col-span-7 {\n  --cds-grid-columns: 7;\n  display: block;\n  grid-column: span 7/span 7;\n}\n\n.cds--col-span-8 {\n  --cds-grid-columns: 8;\n  display: block;\n  grid-column: span 8/span 8;\n}\n\n.cds--col-span-9 {\n  --cds-grid-columns: 9;\n  display: block;\n  grid-column: span 9/span 9;\n}\n\n.cds--col-span-10 {\n  --cds-grid-columns: 10;\n  display: block;\n  grid-column: span 10/span 10;\n}\n\n.cds--col-span-11 {\n  --cds-grid-columns: 11;\n  display: block;\n  grid-column: span 11/span 11;\n}\n\n.cds--col-span-12 {\n  --cds-grid-columns: 12;\n  display: block;\n  grid-column: span 12/span 12;\n}\n\n.cds--col-span-13 {\n  --cds-grid-columns: 13;\n  display: block;\n  grid-column: span 13/span 13;\n}\n\n.cds--col-span-14 {\n  --cds-grid-columns: 14;\n  display: block;\n  grid-column: span 14/span 14;\n}\n\n.cds--col-span-15 {\n  --cds-grid-columns: 15;\n  display: block;\n  grid-column: span 15/span 15;\n}\n\n.cds--col-span-16 {\n  --cds-grid-columns: 16;\n  display: block;\n  grid-column: span 16/span 16;\n}\n\n.cds--sm\\:col-span-0 {\n  display: none;\n}\n\n.cds--sm\\:col-span-1 {\n  --cds-grid-columns: 1;\n  display: block;\n  grid-column: span 1/span 1;\n}\n\n.cds--sm\\:col-span-2 {\n  --cds-grid-columns: 2;\n  display: block;\n  grid-column: span 2/span 2;\n}\n\n.cds--sm\\:col-span-3 {\n  --cds-grid-columns: 3;\n  display: block;\n  grid-column: span 3/span 3;\n}\n\n.cds--sm\\:col-span-4 {\n  --cds-grid-columns: 4;\n  display: block;\n  grid-column: span 4/span 4;\n}\n\n.cds--sm\\:col-span-auto {\n  grid-column: auto;\n}\n\n.cds--sm\\:col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--sm\\:col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n\n.cds--sm\\:col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n\n.cds--sm\\:col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--md\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--md\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--md\\:col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n  .cds--md\\:col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n  .cds--md\\:col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--lg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--lg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--lg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--lg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--xlg\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--xlg\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--xlg\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--xlg\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-0 {\n    display: none;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-1 {\n    --cds-grid-columns: 1;\n    display: block;\n    grid-column: span 1/span 1;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-2 {\n    --cds-grid-columns: 2;\n    display: block;\n    grid-column: span 2/span 2;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-3 {\n    --cds-grid-columns: 3;\n    display: block;\n    grid-column: span 3/span 3;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-4 {\n    --cds-grid-columns: 4;\n    display: block;\n    grid-column: span 4/span 4;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-5 {\n    --cds-grid-columns: 5;\n    display: block;\n    grid-column: span 5/span 5;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-6 {\n    --cds-grid-columns: 6;\n    display: block;\n    grid-column: span 6/span 6;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-7 {\n    --cds-grid-columns: 7;\n    display: block;\n    grid-column: span 7/span 7;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-8 {\n    --cds-grid-columns: 8;\n    display: block;\n    grid-column: span 8/span 8;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-9 {\n    --cds-grid-columns: 9;\n    display: block;\n    grid-column: span 9/span 9;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-10 {\n    --cds-grid-columns: 10;\n    display: block;\n    grid-column: span 10/span 10;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-11 {\n    --cds-grid-columns: 11;\n    display: block;\n    grid-column: span 11/span 11;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-12 {\n    --cds-grid-columns: 12;\n    display: block;\n    grid-column: span 12/span 12;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-13 {\n    --cds-grid-columns: 13;\n    display: block;\n    grid-column: span 13/span 13;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-14 {\n    --cds-grid-columns: 14;\n    display: block;\n    grid-column: span 14/span 14;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-15 {\n    --cds-grid-columns: 15;\n    display: block;\n    grid-column: span 15/span 15;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-16 {\n    --cds-grid-columns: 16;\n    display: block;\n    grid-column: span 16/span 16;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-span-auto {\n    grid-column: auto;\n  }\n  .cds--max\\:col-span-100 {\n    grid-column: 1/-1;\n  }\n  .cds--max\\:col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n  .cds--max\\:col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n  .cds--max\\:col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n.cds--col-span-auto {\n  grid-column: auto;\n}\n\n.cds--col-span-100 {\n  grid-column: 1/-1;\n}\n\n.cds--col-span-75 {\n  --cds-grid-columns: 3;\n  grid-column: span 3 / span 3;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 6;\n    grid-column: span 6 / span 6;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-75 {\n    --cds-grid-columns: 12;\n    grid-column: span 12 / span 12;\n  }\n}\n\n.cds--col-span-50 {\n  --cds-grid-columns: 2;\n  grid-column: span 2 / span 2;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-50 {\n    --cds-grid-columns: 8;\n    grid-column: span 8 / span 8;\n  }\n}\n\n.cds--col-span-25 {\n  --cds-grid-columns: 1;\n  grid-column: span 1 / span 1;\n}\n@media (min-width: 42rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 2;\n    grid-column: span 2 / span 2;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--col-span-25 {\n    --cds-grid-columns: 4;\n    grid-column: span 4 / span 4;\n  }\n}\n\n.cds--col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--col-end-auto {\n  grid-column-end: auto;\n}\n\n.cds--sm\\:col-start-1 {\n  grid-column-start: 1;\n}\n\n.cds--sm\\:col-start-2 {\n  grid-column-start: 2;\n}\n\n.cds--sm\\:col-start-3 {\n  grid-column-start: 3;\n}\n\n.cds--sm\\:col-start-4 {\n  grid-column-start: 4;\n}\n\n.cds--sm\\:col-start-5 {\n  grid-column-start: 5;\n}\n\n.cds--sm\\:col-start-6 {\n  grid-column-start: 6;\n}\n\n.cds--sm\\:col-start-7 {\n  grid-column-start: 7;\n}\n\n.cds--sm\\:col-start-8 {\n  grid-column-start: 8;\n}\n\n.cds--sm\\:col-start-9 {\n  grid-column-start: 9;\n}\n\n.cds--sm\\:col-start-10 {\n  grid-column-start: 10;\n}\n\n.cds--sm\\:col-start-11 {\n  grid-column-start: 11;\n}\n\n.cds--sm\\:col-start-12 {\n  grid-column-start: 12;\n}\n\n.cds--sm\\:col-start-13 {\n  grid-column-start: 13;\n}\n\n.cds--sm\\:col-start-14 {\n  grid-column-start: 14;\n}\n\n.cds--sm\\:col-start-15 {\n  grid-column-start: 15;\n}\n\n.cds--sm\\:col-start-16 {\n  grid-column-start: 16;\n}\n\n.cds--sm\\:col-end-2 {\n  grid-column-end: 2;\n}\n\n.cds--sm\\:col-end-3 {\n  grid-column-end: 3;\n}\n\n.cds--sm\\:col-end-4 {\n  grid-column-end: 4;\n}\n\n.cds--sm\\:col-end-5 {\n  grid-column-end: 5;\n}\n\n.cds--sm\\:col-end-6 {\n  grid-column-end: 6;\n}\n\n.cds--sm\\:col-end-7 {\n  grid-column-end: 7;\n}\n\n.cds--sm\\:col-end-8 {\n  grid-column-end: 8;\n}\n\n.cds--sm\\:col-end-9 {\n  grid-column-end: 9;\n}\n\n.cds--sm\\:col-end-10 {\n  grid-column-end: 10;\n}\n\n.cds--sm\\:col-end-11 {\n  grid-column-end: 11;\n}\n\n.cds--sm\\:col-end-12 {\n  grid-column-end: 12;\n}\n\n.cds--sm\\:col-end-13 {\n  grid-column-end: 13;\n}\n\n.cds--sm\\:col-end-14 {\n  grid-column-end: 14;\n}\n\n.cds--sm\\:col-end-15 {\n  grid-column-end: 15;\n}\n\n.cds--sm\\:col-end-16 {\n  grid-column-end: 16;\n}\n\n.cds--sm\\:col-end-17 {\n  grid-column-end: 17;\n}\n\n.cds--sm\\:col-start-auto {\n  grid-column-start: auto;\n}\n\n.cds--sm\\:col-end-auto {\n  grid-column-end: auto;\n}\n\n@media (min-width: 42rem) {\n  .cds--md\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--md\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--md\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--md\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--md\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--md\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--md\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--md\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--md\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--md\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--md\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--md\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--md\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--md\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--md\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--md\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--md\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--md\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--md\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--md\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--md\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--md\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--md\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--md\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--md\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--md\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--md\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--md\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--md\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--md\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--md\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--md\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--md\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--md\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--lg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--lg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--lg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--lg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--lg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--lg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--lg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--lg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--lg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--lg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--lg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--lg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--lg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--lg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--lg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--lg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--lg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--lg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--lg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--lg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--lg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--lg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--lg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--lg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--lg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--lg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--lg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--lg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--lg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--lg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--lg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--lg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--lg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--lg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--xlg\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--xlg\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--xlg\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--xlg\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--xlg\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--xlg\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--xlg\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--xlg\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--xlg\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--xlg\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--xlg\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--xlg\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--xlg\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--xlg\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--xlg\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--xlg\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--xlg\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--xlg\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--xlg\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--xlg\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--xlg\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--xlg\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--xlg\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--xlg\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--xlg\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--xlg\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--xlg\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--xlg\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--xlg\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--xlg\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--xlg\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--xlg\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--xlg\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--xlg\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--max\\:col-start-1 {\n    grid-column-start: 1;\n  }\n  .cds--max\\:col-start-2 {\n    grid-column-start: 2;\n  }\n  .cds--max\\:col-start-3 {\n    grid-column-start: 3;\n  }\n  .cds--max\\:col-start-4 {\n    grid-column-start: 4;\n  }\n  .cds--max\\:col-start-5 {\n    grid-column-start: 5;\n  }\n  .cds--max\\:col-start-6 {\n    grid-column-start: 6;\n  }\n  .cds--max\\:col-start-7 {\n    grid-column-start: 7;\n  }\n  .cds--max\\:col-start-8 {\n    grid-column-start: 8;\n  }\n  .cds--max\\:col-start-9 {\n    grid-column-start: 9;\n  }\n  .cds--max\\:col-start-10 {\n    grid-column-start: 10;\n  }\n  .cds--max\\:col-start-11 {\n    grid-column-start: 11;\n  }\n  .cds--max\\:col-start-12 {\n    grid-column-start: 12;\n  }\n  .cds--max\\:col-start-13 {\n    grid-column-start: 13;\n  }\n  .cds--max\\:col-start-14 {\n    grid-column-start: 14;\n  }\n  .cds--max\\:col-start-15 {\n    grid-column-start: 15;\n  }\n  .cds--max\\:col-start-16 {\n    grid-column-start: 16;\n  }\n  .cds--max\\:col-end-2 {\n    grid-column-end: 2;\n  }\n  .cds--max\\:col-end-3 {\n    grid-column-end: 3;\n  }\n  .cds--max\\:col-end-4 {\n    grid-column-end: 4;\n  }\n  .cds--max\\:col-end-5 {\n    grid-column-end: 5;\n  }\n  .cds--max\\:col-end-6 {\n    grid-column-end: 6;\n  }\n  .cds--max\\:col-end-7 {\n    grid-column-end: 7;\n  }\n  .cds--max\\:col-end-8 {\n    grid-column-end: 8;\n  }\n  .cds--max\\:col-end-9 {\n    grid-column-end: 9;\n  }\n  .cds--max\\:col-end-10 {\n    grid-column-end: 10;\n  }\n  .cds--max\\:col-end-11 {\n    grid-column-end: 11;\n  }\n  .cds--max\\:col-end-12 {\n    grid-column-end: 12;\n  }\n  .cds--max\\:col-end-13 {\n    grid-column-end: 13;\n  }\n  .cds--max\\:col-end-14 {\n    grid-column-end: 14;\n  }\n  .cds--max\\:col-end-15 {\n    grid-column-end: 15;\n  }\n  .cds--max\\:col-end-16 {\n    grid-column-end: 16;\n  }\n  .cds--max\\:col-end-17 {\n    grid-column-end: 17;\n  }\n  .cds--max\\:col-start-auto {\n    grid-column-start: auto;\n  }\n  .cds--max\\:col-end-auto {\n    grid-column-end: auto;\n  }\n}\n@keyframes cds--hide-feedback {\n  0% {\n    opacity: 1;\n    visibility: inherit;\n  }\n  100% {\n    opacity: 0;\n    visibility: hidden;\n  }\n}\n@keyframes cds--show-feedback {\n  0% {\n    opacity: 0;\n    visibility: hidden;\n  }\n  100% {\n    opacity: 1;\n    visibility: inherit;\n  }\n}\n@keyframes cds--skeleton {\n  0% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  20% {\n    opacity: 1;\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  28% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  51% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  58% {\n    transform: scaleX(0);\n    transform-origin: right;\n  }\n  82% {\n    transform: scaleX(1);\n    transform-origin: right;\n  }\n  83% {\n    transform: scaleX(1);\n    transform-origin: left;\n  }\n  96% {\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n  100% {\n    opacity: 0.3;\n    transform: scaleX(0);\n    transform-origin: left;\n  }\n}\n.cds--layout--size-xs {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xs, 1.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xs {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xs, 1.5rem));\n}\n\n.cds--layout-constraint--size__min-xs {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout-constraint--size__max-xs {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xs, 1.5rem);\n}\n\n.cds--layout--size-sm {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-sm, 2rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-sm {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-sm, 2rem));\n}\n\n.cds--layout-constraint--size__min-sm {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout-constraint--size__max-sm {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-sm, 2rem);\n}\n\n.cds--layout--size-md {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-md, 2.5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-md {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-md, 2.5rem));\n}\n\n.cds--layout-constraint--size__min-md {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout-constraint--size__max-md {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-md, 2.5rem);\n}\n\n.cds--layout--size-lg {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-lg, 3rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-lg {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-lg, 3rem));\n}\n\n.cds--layout-constraint--size__min-lg {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout-constraint--size__max-lg {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-lg, 3rem);\n}\n\n.cds--layout--size-xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-xl, 4rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-xl, 4rem));\n}\n\n.cds--layout-constraint--size__min-xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout-constraint--size__max-xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-xl, 4rem);\n}\n\n.cds--layout--size-2xl {\n  --cds-layout-size-height-context: var(--cds-layout-size-height-2xl, 5rem);\n  --cds-layout-size-height: var(--cds-layout-size-height-context);\n}\n\n.cds--layout-constraint--size__default-2xl {\n  --cds-layout-size-height: var(--cds-layout-size-height-context, var(--cds-layout-size-height-2xl, 5rem));\n}\n\n.cds--layout-constraint--size__min-2xl {\n  --cds-layout-size-height-min: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout-constraint--size__max-2xl {\n  --cds-layout-size-height-max: var(--cds-layout-size-height-2xl, 5rem);\n}\n\n.cds--layout--density-condensed {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-condensed {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-condensed, 0.5rem));\n}\n\n.cds--layout-constraint--density__min-condensed {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout-constraint--density__max-condensed {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-condensed, 0.5rem);\n}\n\n.cds--layout--density-normal {\n  --cds-layout-density-padding-inline-context: var(--cds-layout-density-padding-inline-normal, 1rem);\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context);\n}\n\n.cds--layout-constraint--density__default-normal {\n  --cds-layout-density-padding-inline: var(--cds-layout-density-padding-inline-context, var(--cds-layout-density-padding-inline-normal, 1rem));\n}\n\n.cds--layout-constraint--density__min-normal {\n  --cds-layout-density-padding-inline-min: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n.cds--layout-constraint--density__max-normal {\n  --cds-layout-density-padding-inline-max: var(--cds-layout-density-padding-inline-normal, 1rem);\n}\n\n:root {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n\n.cds--assistive-text,\n.cds--visually-hidden {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n\nbutton,\nselect,\ninput,\ntextarea {\n  border-radius: 0;\n  font-family: inherit;\n}\n\n/* HTML5 display-role reset for older browsers */\narticle,\naside,\ndetails,\nfigcaption,\nfigure,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\nsection {\n  display: block;\n}\n\nbody {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  line-height: 1;\n}\n\nol,\nul {\n  list-style: none;\n}\n\nblockquote,\nq {\n  quotes: none;\n}\n\nblockquote::before,\nblockquote::after,\nq::before,\nq::after {\n  content: \"\";\n  content: none;\n}\n\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\n\nhtml {\n  box-sizing: border-box;\n}\n\n*,\n*::before,\n*::after {\n  box-sizing: inherit;\n}\n\nhtml {\n  font-size: 100%;\n}\n\nbody {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n\ncode {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n\nstrong {\n  font-weight: 600;\n}\n\n@media screen and (-ms-high-contrast: active) {\n  svg {\n    fill: ButtonText;\n  }\n}\nh1 {\n  font-size: var(--cds-heading-06-font-size, 2.625rem);\n  font-weight: var(--cds-heading-06-font-weight, 300);\n  line-height: var(--cds-heading-06-line-height, 1.199);\n  letter-spacing: var(--cds-heading-06-letter-spacing, 0);\n}\n\nh2 {\n  font-size: var(--cds-heading-05-font-size, 2rem);\n  font-weight: var(--cds-heading-05-font-weight, 400);\n  line-height: var(--cds-heading-05-line-height, 1.25);\n  letter-spacing: var(--cds-heading-05-letter-spacing, 0);\n}\n\nh3 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\nh4 {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\nh5 {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n\nh6 {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n}\n\np {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\na {\n  color: var(--cds-link-primary, #0062fe);\n}\n\nem {\n  font-style: italic;\n}\n\n/**\n * Copyright IBM Corp. 2020, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n* Copyright IBM Corp. 2016, 2023\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:root {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-one {\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n\n.cds--layer-two {\n  --cds-layer: var(--cds-layer-02, #ffffff);\n  --cds-layer-active: var(--cds-layer-active-02, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-02, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-02, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-02, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-02, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-02, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-02, #a8a8a8);\n  --cds-field: var(--cds-field-02, #ffffff);\n  --cds-field-hover: var(--cds-field-hover-02, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-01, #c6c6c6);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-02, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-02, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-02, #a8a8a8);\n}\n\n.cds--layer-three {\n  --cds-layer: var(--cds-layer-03, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-03, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-03, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-03, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-03, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-03, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-03, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-03, #a8a8a8);\n  --cds-field: var(--cds-field-03, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-03, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-02, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-03, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-03, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-03, #c6c6c6);\n}\n\n.cds--accordion {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion *,\n.cds--accordion *::before,\n.cds--accordion *::after {\n  box-sizing: inherit;\n}\n.cds--accordion {\n  inline-size: 100%;\n  list-style: none;\n}\n\n.cds--accordion__item {\n  display: list-item;\n  overflow: visible;\n  border-block-start: 1px solid var(--cds-border-subtle);\n  transition: border-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n.cds--accordion__item:last-child {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n\n.cds--accordion__item:not(.cds--accordion__item--active):hover, .cds--accordion__item:not(.cds--accordion__item--active):hover + .cds--accordion__item {\n  border-block-start-color: var(--cds-layer-hover);\n}\n.cds--accordion__item:not(.cds--accordion__item--active):last-child:hover {\n  border-block-end-color: var(--cds-layer-hover);\n}\n\n.cds--accordion__heading {\n  transition: background-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion__heading *,\n.cds--accordion__heading *::before,\n.cds--accordion__heading *::after {\n  box-sizing: inherit;\n}\n.cds--accordion__heading::-moz-focus-inner {\n  border: 0;\n}\n.cds--accordion__heading {\n  position: relative;\n  display: flex;\n  flex-direction: row-reverse;\n  align-items: center;\n  justify-content: flex-start;\n  margin: 0;\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  min-block-size: var(--cds-layout-size-height-local);\n  padding-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--accordion__heading:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--accordion__heading:focus {\n  position: relative;\n  z-index: 2;\n  box-shadow: 0 -1px 0 0 var(--cds-focus, #0f62fe), inset 0 1px 0 0 var(--cds-focus, #0f62fe), inset 2px 0 0 0 var(--cds-focus, #0f62fe), 0 1px 0 0 var(--cds-focus, #0f62fe), inset 0 -1px 0 0 var(--cds-focus, #0f62fe), inset -2px 0 0 0 var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--accordion__heading[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--accordion__heading[disabled] .cds--accordion__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--accordion__heading[disabled]:hover::before {\n  background-color: transparent;\n}\n\n.cds--accordion__item--disabled,\n.cds--accordion__item--disabled + .cds--accordion__item {\n  border-block-start: 1px solid var(--cds-border-subtle);\n}\n\nli.cds--accordion__item--disabled:last-of-type {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n\n.cds--accordion__arrow {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  transition: all 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion__arrow {\n  flex: 0 0 1rem;\n  block-size: 1rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1rem;\n  transform: rotate(-270deg) /*rtl:ignore*/;\n}\n\n.cds--accordion__title {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n.cds--accordion__title {\n  z-index: 1;\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n  text-align: start;\n}\n\n.cds--accordion__wrapper {\n  overflow: hidden;\n  padding: 0;\n  max-block-size: 0;\n  opacity: 0;\n  transition: all 110ms cubic-bezier(0, 0, 0.38, 0.9);\n  writing-mode: horizontal-tb;\n}\n\n.cds--accordion__content {\n  padding-inline: var(--cds-layout-density-padding-inline-local);\n}\n@media (min-width: 480px) {\n  .cds--accordion__content {\n    padding-inline-end: 3rem;\n  }\n}\n@media (min-width: 640px) {\n  .cds--accordion__content {\n    padding-inline-end: 25%;\n  }\n}\n.cds--accordion__content > p {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n\n.cds--accordion--start .cds--accordion__heading {\n  flex-direction: row;\n}\n\n.cds--accordion--start .cds--accordion__arrow {\n  margin: 2px 0 0 var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 1rem;\n}\n\n.cds--accordion--start .cds--accordion__content {\n  margin-inline-start: calc(var(--cds-layout-density-padding-inline-local) + 1rem);\n}\n\n.cds--accordion__item--collapsing .cds--accordion__content,\n.cds--accordion__item--expanding .cds--accordion__content {\n  display: block;\n}\n\n.cds--accordion__item--active, :host(c4d-footer-nav-group[open]) {\n  overflow: visible;\n}\n.cds--accordion__item--active > .cds--accordion__wrapper, :host(c4d-footer-nav-group[open]) > .cds--accordion__wrapper {\n  overflow: visible;\n  max-block-size: -moz-fit-content;\n  max-block-size: fit-content;\n  opacity: 1;\n  padding-block: 0.5rem;\n  padding-block-end: 1.5rem;\n}\n.cds--accordion__item--active > .cds--accordion__heading > .cds--accordion__arrow, :host(c4d-footer-nav-group[open]) > .cds--accordion__heading > .cds--accordion__arrow {\n  fill: var(--cds-icon-primary, #161616);\n  transform: rotate(-90deg) /*rtl:ignore*/;\n}\n\n.cds--accordion--flush .cds--accordion__item {\n  position: relative;\n  border-color: transparent;\n}\n.cds--accordion--flush .cds--accordion__item:last-child, .cds--accordion--flush .cds--accordion__item:hover, .cds--accordion--flush .cds--accordion__item:last-child:hover, .cds--accordion--flush .cds--accordion__item:hover + .cds--accordion__item {\n  border-color: transparent;\n}\n.cds--accordion--flush .cds--accordion__item::before, .cds--accordion--flush .cds--accordion__item::after {\n  position: absolute;\n  display: block;\n  block-size: 1px;\n  content: \"\";\n  inline-size: calc(100% - 1rem - 1rem);\n  margin-inline-start: 1rem;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--accordion--flush .cds--accordion__item::before, .cds--accordion--flush .cds--accordion__item::after {\n    transition: none;\n  }\n}\n.cds--accordion--flush .cds--accordion__item::before {\n  background: var(--cds-border-subtle);\n  inset-block-start: -1px;\n}\n.cds--accordion--flush .cds--accordion__item:last-child::after {\n  background: var(--cds-border-subtle);\n  inset-block-end: -1px;\n}\n\n.cds--accordion--flush .cds--accordion__heading:hover {\n  position: relative;\n  z-index: 1;\n}\n.cds--accordion--flush .cds--accordion__heading:hover::before, .cds--accordion--flush .cds--accordion__heading:hover::after {\n  position: absolute;\n  display: block;\n  background: var(--cds-layer-hover);\n  block-size: 1px;\n  content: \"\";\n  inline-size: 100%;\n  inset-inline-start: 0;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--accordion--flush .cds--accordion__heading:hover::before, .cds--accordion--flush .cds--accordion__heading:hover::after {\n    transition: none;\n  }\n}\n.cds--accordion--flush .cds--accordion__heading:hover::before {\n  inset-block-start: -1px;\n}\n.cds--accordion--flush .cds--accordion__heading:hover::after {\n  inset-block-end: -1px;\n}\n.cds--accordion--flush .cds--accordion__heading:hover:focus::after, .cds--accordion--flush .cds--accordion__heading:hover:focus::before {\n  background: none;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__heading,\n.cds--accordion.cds--skeleton .cds--accordion__button {\n  cursor: default;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__arrow {\n  cursor: default;\n  fill: var(--cds-icon-primary, #161616);\n  pointer-events: none;\n}\n.cds--accordion.cds--skeleton .cds--accordion__arrow:hover, .cds--accordion.cds--skeleton .cds--accordion__arrow:focus, .cds--accordion.cds--skeleton .cds--accordion__arrow:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__heading:hover::before,\n.cds--accordion.cds--skeleton .cds--accordion__heading:hover {\n  background-color: transparent;\n}\n\n.cds--accordion--end.cds--skeleton .cds--accordion__arrow {\n  margin-inline-start: 1rem;\n}\n\n.cds--skeleton .cds--accordion__heading:focus .cds--accordion__arrow {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n\n.cds--accordion__title.cds--skeleton__text {\n  margin-block-end: 0;\n}\n\n.cds--accordion.cds--skeleton .cds--accordion__title {\n  margin-inline-start: 1rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--accordion__arrow,\n  .cds--accordion__item--active .cds--accordion__arrow {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--accordion--start .cds--accordion__heading {\n  padding-inline-end: 0;\n  padding-inline-start: var(--cds-layout-density-padding-inline-local);\n}\n\n[dir=rtl] .cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 0;\n  padding-inline-start: 0;\n}\n\ninput:-webkit-autofill,\ninput:-webkit-autofill:hover,\ninput:-webkit-autofill:focus,\ntextarea:-webkit-autofill,\ntextarea:-webkit-autofill:hover,\ntextarea:-webkit-autofill:focus {\n  box-shadow: 0 0 0 1000px var(--cds-field) inset;\n  -webkit-text-fill-color: var(--cds-text-primary, #161616);\n}\n\n.cds--fieldset {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n}\n.cds--fieldset *,\n.cds--fieldset *::before,\n.cds--fieldset *::after {\n  box-sizing: inherit;\n}\n\n.cds--form-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n}\n\n.cds--label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: inline-block;\n  color: var(--cds-text-secondary, #525252);\n  font-weight: 400;\n  line-height: 1rem;\n  margin-block-end: 0.5rem;\n  vertical-align: baseline;\n}\n.cds--label html {\n  font-size: 100%;\n}\n.cds--label body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--label code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--label strong {\n  font-weight: 600;\n}\n\n.cds--label .cds--toggletip-label {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n\n.cds--label--no-margin {\n  margin-block-end: 0;\n}\n\n.cds--label + .cds--tooltip {\n  position: relative;\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger *,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::before,\n.cds--label + .cds--tooltip .cds--tooltip__trigger *::after {\n  box-sizing: inherit;\n}\n.cds--label + .cds--tooltip .cds--tooltip__trigger::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--label + .cds--tooltip .cds--tooltip__trigger svg :hover {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--label + .cds--toggletip {\n  inset-block-start: 0.2rem;\n  inset-inline-start: 0.5rem;\n}\n\n.cds--label.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 0.875rem;\n  inline-size: 4.6875rem;\n}\n.cds--label.cds--skeleton:hover, .cds--label.cds--skeleton:focus, .cds--label.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--label.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--label.cds--skeleton::before {\n    animation: none;\n  }\n}\n\ninput[type=number] {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n}\n\ninput[data-invalid]:not(:focus),\n.cds--number[data-invalid] input[type=number]:not(:focus),\n.cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n.cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n.cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n.cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n.cds--combo-box--invalid--focused),\n.cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  input[data-invalid]:not(:focus),\n  .cds--number[data-invalid] input[type=number]:not(:focus),\n  .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:not(:focus),\n  .cds--text-area__wrapper[data-invalid] > .cds--text-area--invalid:not(:focus),\n  .cds--select-input__wrapper[data-invalid] .cds--select-input:not(:focus),\n  .cds--list-box[data-invalid]:not(.cds--multi-select--invalid--focused,\n  .cds--combo-box--invalid--focused),\n  .cds--combo-box[data-invalid]:not(.cds--multi-select--selected) .cds--text-input:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--number__input-wrapper--warning ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--warn ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--time-picker--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning ~ .cds--form-requirement,\n.cds--text-input__field-wrapper--warning > .cds--text-input ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper--warn ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select--warning .cds--select-input__wrapper ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement,\n.cds--list-box--warning ~ .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\ninput[data-invalid] ~ .cds--form-requirement,\n.cds--number[data-invalid] .cds--number__input-wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper ~ .cds--form-requirement,\n.cds--date-picker-input__wrapper--invalid ~ .cds--form-requirement,\n.cds--time-picker--invalid ~ .cds--form-requirement,\n.cds--text-input__field-wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--text-area__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--select-input__wrapper[data-invalid] ~ .cds--form-requirement,\n.cds--time-picker[data-invalid] ~ .cds--form-requirement,\n.cds--list-box[data-invalid] ~ .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid],\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  display: block;\n}\n\n.cds--form--fluid input[data-invalid] {\n  outline: none;\n}\n\n.cds--form--fluid .cds--form-requirement {\n  padding: 0.5rem 2.5rem 0.5rem 1rem;\n  margin: 0;\n}\n\ninput:not(output, [data-invalid]):-moz-ui-invalid {\n  box-shadow: none;\n}\n\n.cds--form-requirement {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  display: none;\n  overflow: hidden;\n  margin: 0.25rem 0 0;\n  max-block-size: 0;\n}\n.cds--form-requirement html {\n  font-size: 100%;\n}\n.cds--form-requirement body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--form-requirement code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--form-requirement strong {\n  font-weight: 600;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-start: 0;\n}\n\n.cds--form__helper-text {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n  z-index: 0;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  margin-block-start: 0.25rem;\n  opacity: 1;\n}\n\n.cds--label--disabled,\n.cds--form__helper-text--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\nfieldset[disabled] .cds--label,\nfieldset[disabled] .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input *,\n.cds--text-input *::before,\n.cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--text-input:focus, .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input:focus, .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n\n.cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n\n.cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n\n.cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n\n.cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n\n.cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--text-input--password__visibility::after,\n  .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--text-input--password__visibility:hover::before, .cds--text-input--password__visibility:hover::after, .cds--text-input--password__visibility:focus::before, .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--text-input--password__visibility::before, .cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--text-input--password__visibility::after,\n.cds--text-input--password__visibility .cds--assistive-text,\n.cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n\n.cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n\n.cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n\n.cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--text-input--invalid,\n.cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n\n.cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n\n.cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n\n.cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--skeleton.cds--text-input:hover, .cds--skeleton.cds--text-input:focus, .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n\n.cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n\n.cds--text-input__divider,\n.cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n\n.cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n\n.cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n\n.cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n\n.cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n\n.cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n\n.cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n\n.cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n\n.cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n\n.cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n\n.cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n\n.cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n\n.cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n\n.cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n\n.cds--text-input--invalid:has(~ .cds--slug),\n.cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n\n.cds--text-input--invalid ~ .cds--slug,\n.cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n\n.cds--tag {\n  --cds-layout-size-height-xs: 1.125rem;\n  --cds-layout-size-height-sm: 1.125rem;\n  --cds-layout-size-height-md: 1.5rem;\n  --cds-layout-size-height-lg: 2rem;\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 1rem;\n  margin: 0.25rem;\n  cursor: default;\n  max-inline-size: 13rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  min-inline-size: 2rem;\n  padding-inline: 0.5rem;\n  vertical-align: middle;\n  word-break: break-word;\n}\n.cds--layout--size-xs .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-xs);\n}\n.cds--layout--size-sm .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--tag {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--tag.cds--tag--operational {\n  border: 1px solid var(--cds-tag-background-gray, #e0e0e0);\n}\n.cds--tag.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag.cds--tag--lg {\n  padding-inline-start: 0.75rem;\n}\n.cds--tag:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.25rem;\n}\n.cds--tag.cds--tag--lg:not(.cds--tag--filter) {\n  padding-inline: 0.75rem;\n}\n.cds--tag.cds--tag--lg:has(.cds--tag__custom-icon) {\n  padding-inline-start: 0.5rem;\n}\n.cds--tag:not(.cds--tag--selectable) {\n  border: 0;\n}\n.cds--tag:not(:first-child) {\n  margin-inline-start: 0;\n}\n\n.cds--tag--operational > span,\n.cds--tag--selectable > span,\n.cds--tag__label {\n  display: block;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--tag--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--filter {\n  padding-block-end: 0;\n  padding-block-start: 0;\n  padding-inline-end: 0;\n}\n.cds--tag--filter:hover {\n  outline: none;\n}\n\n.cds--tag--selectable {\n  border: 1px solid var(--cds-border-inverse, #161616);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--tag--selectable:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n.cds--tag--selectable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--selectable-selected {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--selectable-selected:hover {\n  background-color: var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n  cursor: pointer;\n}\n.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n  outline: none;\n}\n.cds--tag--operational:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n\n.cds--tag--red {\n  background-color: var(--cds-tag-background-red, #ffd7d9);\n  color: var(--cds-tag-color-red, #a2191f);\n}\n.cds--tag--red.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-red, #ff8389);\n}\n.cds--tag--red.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n.cds--tag--red .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-red, #ffc2c5);\n}\n\n.cds--tag--magenta {\n  background-color: var(--cds-tag-background-magenta, #ffd6e8);\n  color: var(--cds-tag-color-magenta, #9f1853);\n}\n.cds--tag--magenta.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-magenta, #ff7eb6);\n}\n.cds--tag--magenta.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n.cds--tag--magenta .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-magenta, #ffbdda);\n}\n\n.cds--tag--purple {\n  background-color: var(--cds-tag-background-purple, #e8daff);\n  color: var(--cds-tag-color-purple, #6929c4);\n}\n.cds--tag--purple.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-purple, #be95ff);\n}\n.cds--tag--purple.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n.cds--tag--purple .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-purple, #dcc7ff);\n}\n\n.cds--tag--blue {\n  background-color: var(--cds-tag-background-blue, #d0e2ff);\n  color: var(--cds-tag-color-blue, #0043ce);\n}\n.cds--tag--blue.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-blue, #78a9ff);\n}\n.cds--tag--blue.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n.cds--tag--blue .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-blue, #b8d3ff);\n}\n\n.cds--tag--cyan {\n  background-color: var(--cds-tag-background-cyan, #bae6ff);\n  color: var(--cds-tag-color-cyan, #00539a);\n}\n.cds--tag--cyan.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cyan, #33b1ff);\n}\n.cds--tag--cyan.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n.cds--tag--cyan .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cyan, #99daff);\n}\n\n.cds--tag--teal {\n  background-color: var(--cds-tag-background-teal, #9ef0f0);\n  color: var(--cds-tag-color-teal, #005d5d);\n}\n.cds--tag--teal.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-teal, #08bdba);\n}\n.cds--tag--teal.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n.cds--tag--teal .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-teal, #57e5e5);\n}\n\n.cds--tag--green {\n  background-color: var(--cds-tag-background-green, #a7f0ba);\n  color: var(--cds-tag-color-green, #0e6027);\n}\n.cds--tag--green.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-green, #42be65);\n}\n.cds--tag--green.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n.cds--tag--green .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-green, #74e792);\n}\n\n.cds--tag--gray {\n  background-color: var(--cds-tag-background-gray, #e0e0e0);\n  color: var(--cds-tag-color-gray, #161616);\n}\n.cds--tag--gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-gray, #a8a8a8);\n}\n.cds--tag--gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n.cds--tag--gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-gray, #d1d1d1);\n}\n\n.cds--tag--cool-gray {\n  background-color: var(--cds-tag-background-cool-gray, #dde1e6);\n  color: var(--cds-tag-color-cool-gray, #121619);\n}\n.cds--tag--cool-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-cool-gray, #a2a9b0);\n}\n.cds--tag--cool-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n.cds--tag--cool-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-cool-gray, #cdd3da);\n}\n\n.cds--tag--warm-gray {\n  background-color: var(--cds-tag-background-warm-gray, #e5e0df);\n  color: var(--cds-tag-color-warm-gray, #171414);\n}\n.cds--tag--warm-gray.cds--tag--operational {\n  border: 1px solid var(--cds-tag-border-warm-gray, #ada8a8);\n}\n.cds--tag--warm-gray.cds--tag--operational:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n.cds--tag--warm-gray .cds--tag__close-icon:hover {\n  background-color: var(--cds-tag-hover-warm-gray, #d8d0cf);\n}\n\n.cds--tag--high-contrast:not(.cds--tag--operational) {\n  background-color: var(--cds-background-inverse, #393939);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational {\n  border: 1px solid var(--cds-background-inverse, #393939);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational).cds--tag--operational:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n.cds--tag--high-contrast:not(.cds--tag--operational) .cds--tag__close-icon:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  outline: 1px solid var(--cds-background-inverse, #393939);\n  outline-offset: -1px;\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational {\n  border: 1px solid var(--cds-background, #ffffff);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]).cds--tag--operational:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--tag--outline:not(.cds--tag--operational):not(span):not([disabled]) .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--tag--disabled:not(.cds--tag--operational),\n.cds--tag--filter.cds--tag--disabled,\n.cds--tag--interactive.cds--tag--disabled {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  box-shadow: none;\n  outline: none;\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational {\n  border: 1px solid var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational).cds--tag--operational:hover,\n.cds--tag--filter.cds--tag--disabled.cds--tag--operational:hover,\n.cds--tag--interactive.cds--tag--disabled.cds--tag--operational:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__close-icon:hover,\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tag--disabled:not(.cds--tag--operational):hover,\n.cds--tag--filter.cds--tag--disabled:hover,\n.cds--tag--interactive.cds--tag--disabled:hover {\n  cursor: not-allowed;\n}\n.cds--tag--disabled:not(.cds--tag--operational) .cds--tag__label,\n.cds--tag--filter.cds--tag--disabled .cds--tag__label,\n.cds--tag--interactive.cds--tag--disabled .cds--tag__label {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--selectable.cds--tag--disabled,\n.cds--tag--operational.cds--tag--disabled {\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--tag--selectable.cds--tag--disabled:hover,\n.cds--tag--operational.cds--tag--disabled:hover {\n  background-color: var(--cds-layer);\n  cursor: not-allowed;\n}\n\n.cds--tag--interactive {\n  transition: background-color 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--tag__close-icon {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  border-radius: 50%;\n  margin: 0 0 0 0.125rem;\n  background-color: transparent;\n  block-size: var(--cds-layout-size-height-local);\n  color: currentColor;\n  cursor: pointer;\n  inline-size: var(--cds-layout-size-height-local);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tag__close-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag__custom-icon {\n  flex-shrink: 0;\n  padding: 0;\n  border: 0;\n  background-color: transparent;\n  block-size: 1rem;\n  color: currentColor;\n  inline-size: 1rem;\n  margin-inline-end: 0.25rem;\n  outline: none;\n}\n.cds--tag__custom-icon svg {\n  fill: currentColor;\n}\n\n.cds--tag--disabled .cds--tag__close-icon {\n  cursor: not-allowed;\n}\n\n.cds--tag__close-icon:focus {\n  z-index: 99999;\n  border-radius: 50%;\n  box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--tag--high-contrast .cds--tag__close-icon:focus {\n  box-shadow: inset 0 0 0 1px var(--cds-focus-inverse, #ffffff);\n}\n\n.cds--tag--filter.cds--tag--disabled .cds--tag__close-icon:hover {\n  background-color: transparent;\n}\n\n.cds--tag--filter.cds--tag--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tag--sm.cds--tag--filter {\n  padding-inline-end: 0;\n}\n\n.cds--tag--sm .cds--tag__close-icon {\n  margin-inline-start: 0.3125rem;\n}\n\n.cds--tag.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n  color: var(--cds-text-primary, #161616);\n  overflow: hidden;\n  inline-size: 3.75rem;\n}\n.cds--tag.cds--skeleton:hover, .cds--tag.cds--skeleton:focus, .cds--tag.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--tag.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--tag.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--tag.cds--skeleton.cds--tag--operational {\n  border: 1px solid var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton.cds--tag--operational:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n.cds--tag.cds--skeleton .cds--tag__close-icon:hover {\n  background-color: var(--cds-skeleton-background, #e8e8e8);\n}\n@media not all and (min-resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tag.cds--skeleton {\n      transform: translateZ(0);\n    }\n  }\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline {\n  color: currentColor;\n  margin-inline-start: 0.0625rem;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline .cds--slug__text::before {\n  background-color: currentColor;\n}\n\n.cds--tag .cds--slug .cds--slug__button--inline:hover {\n  border-color: currentColor;\n}\n\n/* stylelint-disable */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon svg,\n  .cds--tag__custom-icon svg {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tag__close-icon:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n.cds--tag-label-tooltip {\n  max-inline-size: -webkit-fill-available;\n}\n\n.cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 11rem;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + .cds--tag-label-tooltip {\n  max-inline-size: 9.875rem;\n}\n\n/* stylelint-enable */\n.cds--interactive--tag-children {\n  display: inline-flex;\n  max-inline-size: 12.5rem;\n  place-items: center;\n}\n\n.cds--tag--filter .cds--tag__custom-icon + span > .cds--interactive--tag-children {\n  max-inline-size: 11.5rem;\n}\n\n.cds--tag .cds--definition-term {\n  border-block-end: none;\n  cursor: default;\n  max-inline-size: 12rem;\n}\n\n.cds--tag .cds--tag__custom-icon + span > .cds--definition-term {\n  max-inline-size: 11rem;\n}\n\n.cds--tag > .cds--popover-container {\n  display: flex;\n}\n\n.cds--toggletip-button:has(.cds--tag--operational.cds--tag--disabled) {\n  pointer-events: none;\n}\n\n.cds--list-box__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0.25rem;\n  grid-template: auto auto/auto auto;\n}\n.cds--list-box__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--list-box__wrapper--inline .cds--label,\n.cds--list-box__wrapper--inline .cds--form__helper-text,\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--list-box__wrapper--inline .cds--form__helper-text {\n  max-inline-size: none;\n}\n.cds--list-box__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--list-box {\n  position: relative;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  max-block-size: 2.5rem;\n  transition: all 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box html {\n  font-size: 100%;\n}\n.cds--list-box body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--list-box code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--list-box strong {\n  font-weight: 600;\n}\n.cds--list-box:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--list-box--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box--expanded:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--expanded:hover.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box .cds--text-input {\n  block-size: 100%;\n  min-inline-size: 0;\n}\n\n.cds--list-box__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--list-box__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--list-box.cds--list-box--warning .cds--list-box__field {\n  border-block-end: 0;\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field,\n.cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--list-box--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--list-box--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--list-box--light .cds--list-box__menu {\n  background: var(--cds-layer);\n}\n\n.cds--list-box--light .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle);\n}\n\n.cds--list-box--light.cds--list-box--expanded {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box--disabled:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--list-box--light.cds--list-box--disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__field:focus {\n  border-block-end-color: transparent;\n  outline: none;\n}\n\n.cds--list-box--disabled .cds--list-box__label,\n.cds--list-box--disabled.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled .cds--list-box__menu-icon > svg,\n.cds--list-box--disabled .cds--list-box__selection > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box--disabled,\n.cds--list-box--disabled .cds--list-box__field,\n.cds--list-box--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item,\n.cds--list-box--disabled .cds--list-box__menu-item:hover,\n.cds--list-box--disabled .cds--list-box__menu-item--highlighted {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  text-decoration: none;\n}\n\n.cds--list-box--disabled .cds--list-box__selection:hover {\n  cursor: not-allowed;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 2rem;\n}\n\n.cds--list-box.cds--list-box--inline {\n  border-width: 0;\n  background-color: transparent;\n}\n.cds--list-box.cds--list-box--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded {\n  border-block-end-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true] {\n  border-width: 0;\n}\n\n.cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover,\n.cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover {\n  background-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__field {\n  padding: 0 2rem 0 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--inline .cds--list-box__field {\n  block-size: 100%;\n}\n\n.cds--dropdown--inline .cds--list-box__field {\n  max-inline-size: 30rem;\n}\n\n.cds--dropdown--inline .cds--list-box__menu {\n  max-inline-size: 30rem;\n  min-inline-size: 18rem;\n}\n\n.cds--list-box__field {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  overflow: hidden;\n  align-items: center;\n  block-size: calc(100% + 1px);\n  cursor: pointer;\n  outline: none;\n  padding-block: 0;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  vertical-align: top;\n  white-space: nowrap;\n}\n.cds--list-box__field *,\n.cds--list-box__field *::before,\n.cds--list-box__field *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__field::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__field:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__field:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__field[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--list-box__field .cds--text-input {\n  padding-inline-end: 5rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input,\n.cds--list-box--warning .cds--list-box__field .cds--text-input {\n  padding-inline-end: 6.5625rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon {\n  inset-inline-end: 5.125rem;\n}\n\n.cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 3rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box--warning .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--list-box__label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  overflow: hidden;\n  color: var(--cds-text-primary, #161616);\n  text-overflow: ellipsis;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n}\n\n.cds--list-box__menu-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-inline-end: 0.75rem;\n  outline: none;\n  transition: transform 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu-icon *,\n.cds--list-box__menu-icon *::before,\n.cds--list-box__menu-icon *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-icon::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--list-box__menu-icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box__menu-icon--open {\n  justify-content: center;\n  inline-size: 1.5rem;\n  transform: rotate(180deg);\n}\n\n.cds--list-box__selection {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-block-start: 50%;\n  /* to preserve .5rem space between icons according to spec top/transform used to center the combobox clear selection icon in IE11 */\n  inset-inline-end: 2.8125rem;\n  transform: translateY(-50%);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__selection *,\n.cds--list-box__selection *::before,\n.cds--list-box__selection *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__selection::-moz-focus-inner {\n  border: 0;\n}\n.cds--list-box__selection:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__selection:focus:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__selection:focus:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__selection > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__selection:focus {\n  outline: none;\n}\n\n.cds--list-box__selection--multi {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  position: static;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding: 0.5rem;\n  border-radius: 0.75rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: 1.5rem;\n  color: var(--cds-text-inverse, #ffffff);\n  inline-size: auto;\n  inset-block-start: auto;\n  line-height: 0;\n  margin-inline-end: 0.625rem;\n  padding-inline-end: 0.125rem;\n  transform: none;\n}\n\n.cds--list-box__selection--multi > svg {\n  padding: 0.125rem;\n  block-size: 1.25rem;\n  fill: var(--cds-icon-inverse, #ffffff);\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n.cds--list-box__selection--multi > svg:hover {\n  border-radius: 50%;\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n\n.cds--list-box--disabled .cds--list-box__selection--multi {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  color: var(--cds-layer);\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational {\n  border: 1px solid var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--list-box--disabled .cds--list-box__selection--multi > svg:hover {\n  background-color: initial;\n}\n\n.cds--list-box__selection--multi:hover {\n  outline: none;\n}\n\n.cds--list-box__menu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  position: absolute;\n  z-index: 9100;\n  display: none;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--list-box__menu:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu {\n  display: none;\n  max-block-size: 0;\n  visibility: hidden;\n}\n\n.cds--list-box--expanded .cds--list-box__menu {\n  display: block;\n  max-block-size: 13.75rem;\n}\n\n.cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu {\n  max-block-size: 16.5rem;\n}\n\n.cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu {\n  max-block-size: 11rem;\n}\n\n.cds--list-box__menu-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  block-size: 2.5rem;\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  transition: background 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--light .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item {\n  block-size: 2rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item {\n  block-size: 3rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover {\n  background-color: transparent;\n}\n\n.cds--list-box--light .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item:hover .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item__option {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-end: 1px solid transparent;\n  border-block-start: 1px solid transparent;\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  padding-inline-end: 1.5rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  transition: border-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  white-space: nowrap;\n}\n.cds--list-box__menu-item__option *,\n.cds--list-box__menu-item__option *::before,\n.cds--list-box__menu-item__option *::after {\n  box-sizing: inherit;\n}\n.cds--list-box__menu-item__option:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  border-color: transparent;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item__option:focus {\n    outline-style: dotted;\n  }\n}\n.cds--list-box__menu-item__option:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--sm .cds--list-box__menu-item__option {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--list-box--lg .cds--list-box__menu-item__option {\n  block-size: 3rem;\n  padding-block-end: 0.9375rem;\n  padding-block-start: 0.9375rem;\n}\n\n.cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,\n.cds--list-box--disabled .cds--list-box__menu-item__option {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled],\n.cds--list-box__menu-item[disabled] *,\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  outline: none;\n}\n\n.cds--list-box__menu-item[disabled]:hover {\n  background-color: revert;\n}\n\n.cds--list-box__menu-item[disabled] .cds--checkbox-label::before {\n  border-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n\n.cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-two .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--layer-three .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option {\n  margin: 0 0.5rem;\n}\n.cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus {\n  margin: 0;\n  padding-inline-end: 0.5rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--list-box__menu-item--highlighted {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--list-box__menu-item--highlighted {\n    outline-style: dotted;\n  }\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,\n.cds--list-box__menu-item--highlighted + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box--light .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n}\n\n.cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover);\n  border-block-end-color: var(--cds-layer-selected-hover);\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--list-box__menu-item--active + .cds--list-box__menu-item > .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n\n.cds--list-box__menu-item__selected-icon {\n  position: absolute;\n  display: none;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box--inline .cds--list-box__menu-item__selected-icon {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label {\n  inline-size: 100%;\n}\n\n.cds--list-box__menu-item .cds--checkbox-label-text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--list-box--up .cds--list-box__menu {\n  inset-block-end: 2.5rem;\n}\n\n.cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--sm .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--sm .cds--list-box__menu {\n  inset-block-end: 2rem;\n}\n\n.cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,\n.cds--list-box--up.cds--list-box--lg .cds--list-box__menu,\n.cds--list-box--up .cds--list-box--lg .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n\n.cds--list-box input[role=combobox],\n.cds--list-box input[type=text] {\n  background-color: inherit;\n  min-inline-size: 0;\n  text-overflow: ellipsis;\n}\n\n.cds--list-box__wrapper--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 9px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after,\n.cds--list-box__wrapper--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: -0.5625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box input[role=combobox] {\n  border-block-end-color: transparent;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n\n.cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field {\n  padding-inline-end: 6rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 8.8125rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning {\n  inset-inline-end: 5.1875rem;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before {\n  display: block;\n}\n\n.cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug {\n  inset-inline-end: calc(4rem + 18px);\n}\n\n.cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,\n.cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon {\n  inset-inline-end: 7.25rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field,\n  .cds--list-box__menu,\n  .cds--multi-select .cds--tag--filter {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__field:focus,\n  .cds--multi-select .cds--tag__close-icon:focus,\n  .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-icon > svg,\n  .cds--list-box__selection > svg,\n  .cds--list-box__selection--multi > svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-start: 2.0625rem;\n}\n\n.cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,\n.cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-end: 2.0625rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n\n.cds--combo-box:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--combo-box.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--combo-box .cds--text-input::-ms-clear {\n  display: none;\n}\n\n.cds--combo-box.cds--list-box--expanded .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--combo-box--input--focus.cds--text-input {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--combo-box--input--focus.cds--text-input {\n    outline-style: dotted;\n  }\n}\n\n.cds--combo-box.cds--list-box--expanded:has(input[aria-activedescendant]:not([aria-activedescendant=\"\"])) .cds--combo-box--input--focus.cds--text-input {\n  outline-offset: -0.0625rem;\n  outline-width: 0.0625rem;\n}\n\n.cds--combo-box .cds--list-box__field,\n.cds--combo-box.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--combo-box.cds--list-box--warning .cds--list-box__field,\n.cds--combo-box.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--combo-box.cds--list-box--disabled.cds--list-box--warning .cds--list-box__field {\n  padding: 0;\n}\n\n.cds--combo-box--readonly,\n.cds--combo-box--readonly:hover {\n  background-color: transparent;\n}\n\n.cds--combo-box--readonly .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--combo-box--readonly .cds--list-box__menu-icon,\n.cds--combo-box--readonly .cds--list-box__selection {\n  cursor: default;\n}\n\n.cds--combo-box--readonly .cds--list-box__menu-icon svg,\n.cds--combo-box--readonly .cds--list-box__selection svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--select *,\n.cds--select *::before,\n.cds--select *::after {\n  box-sizing: inherit;\n}\n\n.cds--select-input__wrapper {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--select-input {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  border: none;\n  border-radius: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  font-family: inherit;\n  inline-size: 100%;\n  opacity: 1;\n  padding-block: 0;\n  padding-inline: 1rem 3rem;\n  text-overflow: ellipsis;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select-input::-ms-expand {\n  display: none;\n}\n@-moz-document url-prefix() {\n  .cds--select-input:-moz-focusring, .cds--select-input::-moz-focus-inner {\n    background-image: none;\n    color: transparent;\n    text-shadow: 0 0 0 #000000;\n  }\n}\n.cds--select-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--select-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--select-input:disabled, .cds--select-input:hover:disabled {\n  background-color: var(--cds-field);\n  border-block-end-color: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select-input--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--select-input--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--select--disabled .cds--label,\n.cds--select--disabled .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input,\n.cds--select--warning .cds--select-input {\n  padding-inline-end: 4rem;\n}\n\n.cds--select-input:disabled ~ .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--light .cds--select-input {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--select--light .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--select--light .cds--select-input:disabled, .cds--select--light .cds--select-input:hover:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--select__arrow {\n  position: absolute;\n  block-size: 100%;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--select__arrow path {\n    fill: ButtonText;\n  }\n}\n\n.cds--select__invalid-icon {\n  position: absolute;\n  inset-inline-end: 2.5rem;\n}\n\n.cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon {\n  fill: var(--cds-support-error, #da1e28);\n}\n\n.cds--select__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n\n.cds--select__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n\noptgroup.cds--select-optgroup,\n.cds--select-option {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\noptgroup.cds--select-optgroup:disabled,\n.cds--select-option:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select--inline {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n\n.cds--select--inline.cds--select--invalid .cds--label,\n.cds--select--inline.cds--select--invalid .cds--form__helper-text {\n  align-self: flex-start;\n  margin-block-start: 0.8125rem;\n}\n\n.cds--select--inline .cds--form__helper-text {\n  margin-block-end: 0;\n  margin-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--label {\n  margin: 0 0.5rem 0 0;\n  white-space: nowrap;\n}\n\n.cds--select--inline .cds--select-input {\n  background-color: transparent;\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: auto;\n  padding-inline-end: 2rem;\n  padding-inline-start: 0.5rem;\n}\n\n.cds--select--inline .cds--select-input:focus,\n.cds--select--inline .cds--select-input:focus option,\n.cds--select--inline .cds--select-input:focus optgroup {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.cds--select--inline .cds--select-input[disabled],\n.cds--select--inline .cds--select-input[disabled]:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--select--inline .cds--select__arrow {\n  inset-inline-end: 0.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--select--inline.cds--select--invalid .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--select--inline .cds--select-input:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--select--inline .cds--select-input:disabled ~ * {\n  cursor: not-allowed;\n}\n\n.cds--select--readonly .cds--select-input {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n  cursor: default;\n}\n\n.cds--select--readonly .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--select.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 2.5rem;\n  inline-size: 100%;\n}\n.cds--select.cds--skeleton:hover, .cds--select.cds--skeleton:focus, .cds--select.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--select.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--select.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--select.cds--skeleton .cds--select-input {\n  display: none;\n}\n\n.cds--select--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 8px + 1px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n\n.cds--select--slug .cds--slug::after,\n.cds--select--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n\n.cds--select--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: calc(-0.5rem - 1px);\n}\n\n.cds--select--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n\n.cds--select--slug .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 4rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  padding-inline-end: 6rem;\n}\n\n.cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before {\n  display: block;\n}\n\n.cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon,\n.cds--select--slug .cds--select-input__wrapper .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--select__arrow {\n    fill: ButtonText;\n  }\n}\n\n.cds--link {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline: none;\n  text-decoration: none;\n  transition: color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--link *,\n.cds--link *::before,\n.cds--link *::after {\n  box-sizing: inherit;\n}\n.cds--link:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n  text-decoration: underline;\n}\n.cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:active, .cds--link:active:visited, .cds--link:active:visited:hover {\n    outline-style: dotted;\n  }\n}\n.cds--link:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-color: var(--cds-link-focus-text-color, var(--cds-focus, #0f62fe));\n  text-decoration: underline;\n}\n@media screen and (prefers-contrast) {\n  .cds--link:focus {\n    outline-style: dotted;\n  }\n}\n.cds--link:visited {\n  color: var(--cds-link-text-color, var(--cds-link-primary, #0f62fe));\n}\n.cds--link:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link--disabled,\n.cds--link--disabled:hover {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  font-weight: 400;\n  text-decoration: none;\n}\n.cds--link--disabled *,\n.cds--link--disabled *::before,\n.cds--link--disabled *::after,\n.cds--link--disabled:hover *,\n.cds--link--disabled:hover *::before,\n.cds--link--disabled:hover *::after {\n  box-sizing: inherit;\n}\n\n.cds--link.cds--link--visited:visited {\n  color: var(--cds-link-visited-text-color, var(--cds-link-visited, #8a3ffc));\n}\n\n.cds--link.cds--link--visited:visited:hover {\n  color: var(--cds-link-hover-text-color, var(--cds-link-primary-hover, #0043ce));\n}\n\n.cds--link.cds--link--inline {\n  display: inline;\n  text-decoration: underline;\n}\n\n.cds--link--disabled.cds--link--inline {\n  text-decoration: underline;\n}\n\n.cds--link--sm,\n.cds--link--sm.cds--link--disabled:hover {\n  font-size: var(--cds-helper-text-01-font-size, 0.75rem);\n  line-height: var(--cds-helper-text-01-line-height, 1.33333);\n  letter-spacing: var(--cds-helper-text-01-letter-spacing, 0.32px);\n}\n\n.cds--link--lg,\n.cds--link--lg.cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n\n.cds--link__icon {\n  display: inline-flex;\n  align-self: center;\n  margin-inline-start: 0.5rem;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--tile-group html {\n  font-size: 100%;\n}\n.cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--tile-group strong {\n  font-weight: 600;\n}\n\n.cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--clickable,\n.cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--clickable *,\n.cds--tile--clickable *::before,\n.cds--tile--clickable *::after,\n.cds--tile--selectable *,\n.cds--tile--selectable *::before,\n.cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--tile--clickable:hover,\n.cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--tile--clickable:hover .cds--tile__checkmark, .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--tile--clickable:hover,\n.cds--tile--clickable:active,\n.cds--tile--clickable:visited,\n.cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n\n.cds--tile--clickable.cds--link--disabled,\n.cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--clickable .cds--tile--icon,\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n\n.cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n\n.cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n}\n\n.cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 0;\n}\n.cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n\n.cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--tile__chevron--interactive *,\n.cds--tile__chevron--interactive *::before,\n.cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n\n.cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n\n.cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n\n.cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n\n.cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n\n.cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n\n.cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n\n.cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n.cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n\n.cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n\n.cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n\n.cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n\n.cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--tile > .cds--slug,\n.cds--tile--expandable > div > .cds--slug,\n.cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n\n.cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n\n.cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n\n.cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--selectable::after,\n.cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--tile--slug.cds--tile--selectable::before,\n.cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable:focus,\n.cds--tile--slug.cds--tile--clickable:focus,\n.cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n\n.cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n\n.cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n\n.cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n\n.cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n\n.cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n\n.cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n\n.cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tile--slug-rounded,\n.cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n\n.cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--tile__chevron svg,\n  .cds--tile__checkmark svg,\n  .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-video-player-container) {\n  display: block;\n}\n\n:host(c4d-video-player),\n.c4d--video-player {\n  color: var(--c4d--video-caption--color, var(--cds-text-secondary, #525252));\n}\n:host(c4d-video-player) .c4d--image__img,\n.c4d--video-player .c4d--image__img {\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image,\n.c4d--video-player c4d-image {\n  padding-block-start: 0;\n}\n\n:host(c4d-video-player[background-mode]),\n.c4d--video-player[background-mode] {\n  /**\n   * These styles mock `object-fit: cover;` and `object-position: center`.\n   *   - Aspect ratio forces the shape of the element.\n   *   - Min-width/height force the element to cover the entire parent footprint.\n   *   - inset/translate combine to ensure the element is centered over the parent footprint.\n   */\n  /**\n   * overwriting inset property so the video player is centered in the container when in RTL mode\n   */\n}\n:host(c4d-video-player[background-mode]) .c4d--video-player__video-container,\n.c4d--video-player[background-mode] .c4d--video-player__video-container {\n  padding: 0;\n  block-size: 100%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video,\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video),\n.c4d--video-player[background-mode] .c4d--video-player__video {\n  aspect-ratio: var(--native-file-aspect-ratio, 16/9);\n  inset: 50% 0 0 50%;\n  min-block-size: 100%;\n  min-inline-size: 100%;\n  translate: -50% -50%;\n}\n:host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n:host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n.c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n.c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n  inset: 50% -50% 0 50%;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-video-player[background-mode]) ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  :host(c4d-video-player[background-mode]) .c4d--video-player__video[dir-mode=rtl],\n  .c4d--video-player[background-mode] ::slotted(.c4d--video-player__video[dir-mode=rtl]),\n  .c4d--video-player[background-mode] .c4d--video-player__video[dir-mode=rtl] {\n    inset: 50% -67% 0 50%;\n  }\n}\n\n.c4d--video-player .c4d--video-player__image-overlay:focus::before {\n  position: absolute;\n  z-index: 1;\n  border: 1px solid var(--cds-focus-inverse, #ffffff);\n  content: \" \";\n  inset: 0.125rem;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player) c4d-image,\n.c4d--video-player .c4d--image {\n  position: relative;\n  block-size: 100%;\n  inline-size: 100%;\n}\n:host(c4d-video-player) c4d-image::before,\n.c4d--video-player .c4d--image::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-border-inverse, #161616);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-video-player) c4d-image::before,\n  .c4d--video-player .c4d--image::before {\n    transition: none;\n  }\n}\n:host(c4d-video-player) c4d-image:hover::before,\n.c4d--video-player .c4d--image:hover::before {\n  opacity: 0.08;\n}\n\n.c4d--video-player__video-container {\n  position: relative;\n  display: inline-block;\n  inline-size: 100%;\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n}\n.c4d--video-player__video-container:focus {\n  outline: none;\n}\n.c4d--video-player__video-container ::slotted(.c4d--video-player__video),\n.c4d--video-player__video-container .c4d--video-player__video {\n  position: absolute;\n  inset: 0;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--16x9 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 56.25%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--9x16 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 177.7777777778%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--2x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 50%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x2 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 200%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--4x3 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 75%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--3x4 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 133.3333333333%;\n  overflow: visible;\n}\n.c4d--video-player__video-container.c4d--video-player__aspect-ratio--1x1 {\n  position: relative;\n  overflow: hidden;\n  block-size: 0;\n  padding-block-start: 100%;\n  overflow: visible;\n}\n\n.c4d--video-player__video-caption {\n  font-size: var(--cds-caption-02-font-size, 0.875rem);\n  font-weight: var(--cds-caption-02-font-weight, 400);\n  line-height: var(--cds-caption-02-line-height, 1.28572);\n  letter-spacing: var(--cds-caption-02-letter-spacing, 0.32px);\n  max-inline-size: 90%;\n  padding-block-start: var(--c4d--video-caption--padding, 0.5rem);\n}\n\n.c4d--video-player__image-overlay {\n  padding: 0;\n  border: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 100%;\n}\n.c4d--video-player__image-overlay:focus {\n  outline: 3px solid var(--cds-focus, #0f62fe);\n  outline-offset: 1px;\n}\n.c4d--video-player__image-overlay:hover svg circle, .c4d--video-player__image-overlay:active svg circle {\n  fill: #161616;\n  opacity: 0.9;\n}\n.c4d--video-player__image-overlay:hover svg path, .c4d--video-player__image-overlay:active svg path {\n  fill: var(--cds-icon-on-color, #ffffff);\n}\n.c4d--video-player__image-overlay svg {\n  position: absolute;\n  inset-block-start: calc(50% - 2rem);\n  inset-inline-end: calc(50% - 2rem);\n}\n.c4d--video-player__image-overlay svg circle,\n.c4d--video-player__image-overlay svg path {\n  transition: fill 150ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .c4d--video-player__image-overlay svg circle,\n  .c4d--video-player__image-overlay svg path {\n    transition: none;\n  }\n}\n.c4d--video-player__image-overlay svg circle {\n  opacity: 0.8;\n}\n\n:host(c4d-video-player) .c4d--video-player__image-overlay:active c4d-image::before,\n:host(c4d-video-player) .c4d--video-player__image-overlay:active .c4d--image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active c4d-image::before,\n.c4d--video-player .c4d--video-player__image-overlay:active .c4d--image::before {\n  opacity: 0.12;\n}\n\n.c4d--video-player__toggle-playback {\n  position: absolute;\n  z-index: 100;\n  padding: 0.875rem;\n  border: 0;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 3rem;\n  color: #ffffff;\n  inline-size: 3rem;\n  /* stylelint-disable-next-line caem/require-color-with-bg */\n}\n.c4d--video-player__toggle-playback--top-left {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback--top-right {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-right {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.c4d--video-player__toggle-playback--bottom-left {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.c4d--video-player__toggle-playback:hover {\n  background-color: rgba(22, 22, 22, 0.9);\n  cursor: pointer;\n}\n.c4d--video-player__toggle-playback:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n:host(c4d-video-player[intersection-mode]) ::slotted(.c4d--video-player__video) {\n  pointer-events: none;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--popover-container {\n  display: inline-block;\n}\n\n.cds--popover-container:not(.cds--popover--auto-align) {\n  position: relative;\n}\n\n.cds--popover--high-contrast .cds--popover {\n  --cds-popover-background-color: var(--cds-background-inverse, #393939);\n  --cds-popover-text-color: var(--cds-text-inverse, #ffffff);\n}\n\n.cds--popover--drop-shadow .cds--popover {\n  --cds-popover-drop-shadow: drop-shadow(0 2px 2px rgba(0, 0, 0, 0.2));\n}\n\n.cds--popover--caret {\n  --cds-popover-offset: 0.625rem;\n}\n\n.cds--popover {\n  position: absolute;\n  z-index: 6000;\n  filter: var(--cds-popover-drop-shadow, none);\n  inset: 0;\n  pointer-events: none;\n}\n\n.cds--popover-content {\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  border-radius: var(--cds-popover-border-radius, 2px);\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  color: var(--cds-popover-text-color, var(--cds-text-primary, #161616));\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 23rem;\n  pointer-events: auto;\n}\n.cds--layout--size-sm .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-sm);\n}\n.cds--layout--size-md .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-md);\n}\n.cds--layout--size-lg .cds--popover-content {\n  --cds-layout-size-height: var(--cds-layout-size-height-lg);\n}\n.cds--popover-content *,\n.cds--popover-content *::before,\n.cds--popover-content *::after {\n  box-sizing: inherit;\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content {\n  display: block;\n}\n\n.cds--popover-content::before {\n  position: absolute;\n  display: none;\n  content: \"\";\n}\n\n.cds--popover--open > .cds--popover > .cds--popover-content::before {\n  display: block;\n}\n\n.cds--popover-caret,\n.cds--popover--auto-align.cds--popover-caret {\n  position: absolute;\n  z-index: 6000;\n  display: none;\n  background-color: var(--cds-popover-background-color, var(--cds-layer));\n  will-change: transform;\n}\n\n.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--auto-align.cds--popover--caret.cds--popover--open > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  display: block;\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-caret {\n  display: none;\n}\n\n.cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(100% + var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--bottom-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--bottom-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(-100%);\n}\n\n.cds--popover--bottom > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n.cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, var(--cds-popover-offset, 0rem));\n}\n\n[dir=rtl] .cds--popover--bottom > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-left > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-start > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-right > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--bottom-end > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, var(--cds-popover-offset, 0rem));\n}\n\n.cds--popover--bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--bottom-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 100%, 50% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  transform: translate(50%, calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 0;\n  inset-inline-start: initial;\n}\n\n.cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(-100% - var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-start: 0;\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-left > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-right > .cds--popover > .cds--popover-content::before,\n.cds--popover--top-end > .cds--popover > .cds--popover-content::before {\n  block-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--popover--top > .cds--popover > .cds--popover-caret,\n.cds--popover--top-left > .cds--popover > .cds--popover-caret,\n.cds--popover--top-start > .cds--popover > .cds--popover-caret,\n.cds--popover--top-right > .cds--popover > .cds--popover-caret,\n.cds--popover--top-end > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n  inset-block-start: 0;\n  inset-inline-start: 50%;\n  transform: translate(-50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n[dir=rtl] .cds--popover--top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--top-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  transform: translate(50%, calc(-1 * var(--cds-popover-offset, 0rem)));\n}\n\n.cds--popover--top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--top-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-height, 0.375rem);\n  clip-path: polygon(0% 0%, 50% 100%, 100% 0%);\n  inline-size: var(--cds-popover-caret-width, 0.75rem);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), -50%);\n}\n\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) * -1 - 16px));\n}\n\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-start: 100%;\n  transform: translate(var(--cds-popover-offset, 0rem), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--right-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transform: translateX(-100%);\n}\n\n.cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-start: 100%;\n  transform: translate(calc(var(--cds-popover-offset, 0rem) - 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--right:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--right-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: 100%;\n  inset-inline-start: initial;\n}\n\n.cds--popover--right.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--right-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 50%, 100% 0%, 100% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 0.1px), -50%);\n}\n\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(-0.5 * var(--cds-popover-offset, 0rem) - 16px));\n}\n\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-block-end: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem)), calc(0.5 * var(--cds-popover-offset, 0rem) + 16px));\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-content {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-top > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-start > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-bottom > .cds--popover > .cds--popover-content::before,\n.cds--popover--left-end > .cds--popover > .cds--popover-content::before {\n  inline-size: var(--cds-popover-offset, 0rem);\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  transform: translateX(100%);\n}\n\n.cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n.cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n  inset-block-start: 50%;\n  inset-inline-end: 100%;\n  transform: translate(calc(-1 * var(--cds-popover-offset, 0rem) + 100%), -50%);\n}\n\n[dir=rtl] .cds--popover--left:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-top:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-start:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-bottom:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret,\n[dir=rtl] .cds--popover--left-end:not(.cds--popover--auto-align) > .cds--popover > .cds--popover-caret {\n  inset-inline-end: initial;\n  inset-inline-start: 100%;\n}\n\n.cds--popover--left.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-top.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-start.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-bottom.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret,\n.cds--popover--left-end.cds--popover--auto-align > .cds--popover > .cds--popover-content > .cds--popover-caret {\n  block-size: var(--cds-popover-caret-width, 0.75rem);\n  clip-path: polygon(0% 0%, 100% 50%, 0% 100%);\n  inline-size: var(--cds-popover-caret-height, 0.375rem);\n}\n\n.cds--popover--tab-tip > .cds--popover > .cds--popover-content {\n  border-radius: 0;\n}\n\n.cds--popover--tab-tip .cds--popover {\n  will-change: filter;\n}\n\n.cds--popover--tab-tip__button {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--popover--tab-tip__button *,\n.cds--popover--tab-tip__button *::before,\n.cds--popover--tab-tip__button *::after {\n  box-sizing: inherit;\n}\n.cds--popover--tab-tip__button::-moz-focus-inner {\n  border: 0;\n}\n.cds--popover--tab-tip__button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--popover--tab-tip__button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--popover--tab-tip__button:hover {\n  background-color: var(--cds-layer-hover);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button {\n  background: var(--cds-layer);\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);\n}\n\n.cds--popover--tab-tip.cds--popover--open .cds--popover--tab-tip__button:not(:focus)::after {\n  position: absolute;\n  z-index: 6001;\n  background: var(--cds-layer);\n  block-size: 2px;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n}\n\n.cds--popover--tab-tip__button svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--tooltip {\n  --cds-popover-offset: 12px;\n}\n\n.cds--tooltip-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: var(--cds-tooltip-padding-block, 1rem) var(--cds-tooltip-padding-inline, 1rem);\n  color: var(--cds-text-inverse, #ffffff);\n  max-inline-size: 18rem;\n}\n\n.cds--icon-tooltip {\n  --cds-tooltip-padding-block: 0.125rem;\n  --cds-popover-caret-width: 0.5rem;\n  --cds-popover-caret-height: 0.25rem;\n  --cds-popover-offset: 0.5rem;\n}\n\n.cds--icon-tooltip .cds--tooltip-content {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.cds--definition-term {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  border-radius: 0;\n  border-block-end: 1px dotted var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--definition-term *,\n.cds--definition-term *::before,\n.cds--definition-term *::after {\n  box-sizing: inherit;\n}\n.cds--definition-term::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--definition-term:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--definition-term:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--definition-term:hover {\n  border-block-end-color: var(--cds-border-interactive, #0f62fe);\n}\n\n.cds--definition-tooltip {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding: 0.5rem 1rem;\n  max-inline-size: 11rem;\n}\n\n.cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n.cds--btn *,\n.cds--btn *::before,\n.cds--btn *::after {\n  box-sizing: inherit;\n}\n.cds--btn:disabled, .cds--btn:hover:disabled, .cds--btn:focus:disabled, .cds--btn.cds--btn--disabled, .cds--btn.cds--btn--disabled:hover, .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n.cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n\n.cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n\n.cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n.cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n.cds--btn--primary .cds--btn__icon,\n.cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n.cds--btn--secondary .cds--btn__icon,\n.cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--secondary:hover, .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n\n.cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n.cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n.cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n.cds--btn--tertiary .cds--btn__icon,\n.cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n.cds--btn--tertiary:disabled, .cds--btn--tertiary:hover:disabled, .cds--btn--tertiary:focus:disabled, .cds--btn--tertiary.cds--btn--disabled, .cds--btn--tertiary.cds--btn--disabled:hover, .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n\n.cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost .cds--btn__icon,\n.cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--ghost:hover, .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n.cds--btn--ghost:disabled, .cds--btn--ghost:hover:disabled, .cds--btn--ghost:focus:disabled, .cds--btn--ghost.cds--btn--disabled, .cds--btn--ghost.cds--btn--disabled:hover, .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n.cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n.cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n.cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n\n.cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n\n.cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n\n.cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n\n.cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n\n.cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger .cds--btn__icon,\n.cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n.cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--tertiary .cds--btn__icon,\n.cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--tertiary:disabled, .cds--btn--danger--tertiary:hover:disabled, .cds--btn--danger--tertiary:focus:disabled, .cds--btn--danger--tertiary.cds--btn--disabled, .cds--btn--danger--tertiary.cds--btn--disabled:hover, .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n.cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n.cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n.cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n.cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n.cds--btn--danger--ghost .cds--btn__icon,\n.cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n.cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n.cds--btn--danger--ghost:hover, .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n.cds--btn--danger--ghost:disabled, .cds--btn--danger--ghost:hover:disabled, .cds--btn--danger--ghost:focus:disabled, .cds--btn--danger--ghost.cds--btn--disabled, .cds--btn--danger--ghost.cds--btn--disabled:hover, .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n\n.cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n\n.cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n\n.cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n\n.cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n\n.cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n.cds--btn.cds--skeleton:hover, .cds--btn.cds--skeleton:focus, .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n.cds--btn-set {\n  display: flex;\n}\n\n.cds--btn-set--stacked {\n  flex-direction: column;\n}\n\n.cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n.cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n\n.cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n\n.cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n.cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n.cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n\n.cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n\n[dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n\n.cds--modal, :host(c4d-locale-modal), :host(c4d-expressive-modal) {\n  position: fixed;\n  z-index: 9000;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 240ms cubic-bezier(0.4, 0.14, 1, 1), visibility 0ms linear 240ms;\n  visibility: hidden;\n}\n.cds--modal.is-visible {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--modal.is-visible {\n    transition: none;\n  }\n}\n.cds--modal .cds--text-input--fluid .cds--text-input, :host(c4d-locale-modal) .cds--text-input--fluid .cds--text-input, :host(c4d-expressive-modal) .cds--text-input--fluid .cds--text-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper,\n.cds--modal .cds--text-area--fluid .cds--text-area,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area,\n.cds--modal .cds--search--fluid .cds--search-input,\n:host(c4d-locale-modal) .cds--search--fluid .cds--search-input,\n:host(c4d-expressive-modal) .cds--search--fluid .cds--search-input,\n.cds--modal .cds--select--fluid .cds--select-input,\n:host(c4d-locale-modal) .cds--select--fluid .cds--select-input,\n:host(c4d-expressive-modal) .cds--select--fluid .cds--select-input,\n.cds--modal .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-locale-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n:host(c4d-expressive-modal) .cds--text-area--fluid .cds--text-area__wrapper[data-invalid] .cds--text-area__divider + .cds--form-requirement,\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-locale-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box,\n.cds--modal .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-locale-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n:host(c4d-expressive-modal) .cds--list-box__wrapper--fluid.cds--list-box__wrapper,\n.cds--modal .cds--number-input--fluid input[type=number],\n:host(c4d-locale-modal) .cds--number-input--fluid input[type=number],\n:host(c4d-expressive-modal) .cds--number-input--fluid input[type=number],\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn::after,\n.cds--modal .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-locale-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input,\n:host(c4d-expressive-modal) .cds--date-picker--fluid .ccdsds--date-picker-input__wrapper .cds--date-picker__input {\n  background-color: var(--cds-field-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-locale-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu, :host(c4d-expressive-modal) .cds--list-box__wrapper--fluid .cds--list-box__menu {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--modal .cds--list-box__menu-item:hover, :host(c4d-locale-modal) .cds--list-box__menu-item:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover-02, #e8e8e8);\n}\n.cds--modal .cds--list-box__menu-item--active, :host(c4d-locale-modal) .cds--list-box__menu-item--active, :host(c4d-expressive-modal) .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected-02, #e0e0e0);\n}\n.cds--modal .cds--list-box__menu-item--active:hover, :host(c4d-locale-modal) .cds--list-box__menu-item--active:hover, :host(c4d-expressive-modal) .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover-02, #d1d1d1);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:hover::after {\n  background-color: var(--cds-field-hover);\n}\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before, :host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::before,\n.cds--modal .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-locale-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after,\n:host(c4d-expressive-modal) .cds--number-input--fluid .cds--number__control-btn:focus::after {\n  border-inline-start: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--modal.is-visible .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n\n.cds--modal-container {\n  position: fixed;\n  display: grid;\n  background-color: var(--cds-layer);\n  block-size: 100%;\n  grid-template-columns: 100%;\n  grid-template-rows: auto 1fr auto;\n  inline-size: 100%;\n  inset-block-start: 0;\n  max-block-size: 100%;\n  outline: 3px solid transparent;\n  outline-offset: -3px;\n  transform: translate3d(0, -24px, 0);\n  transform-origin: top center;\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n@media (min-width: 42rem) {\n  .cds--modal-container {\n    position: static;\n    block-size: auto;\n    inline-size: 84%;\n    max-block-size: 90%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container {\n    inline-size: 60%;\n    max-block-size: 84%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container {\n    inline-size: 48%;\n  }\n}\n.cds--modal-container .cds--modal-container-body {\n  display: contents;\n}\n\n.cds--modal-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  position: relative;\n  color: var(--cds-text-primary, #161616);\n  font-weight: 400;\n  grid-column: 1/-1;\n  grid-row: 2/-2;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  padding-block-start: 0.5rem;\n  padding-inline-end: 1rem;\n  padding-inline-start: 1rem;\n}\n.cds--modal-content:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--modal-content:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--modal-content .cds--form--fluid {\n  margin-inline-end: -1rem;\n  margin-inline-start: -1rem;\n}\n\n.cds--modal-content > p,\n.cds--modal-content__regular-content {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  padding-inline-end: calc(20% - 2rem);\n}\n\n.cds--modal-content--with-form {\n  padding-inline-end: 1rem;\n}\n\n.cds--modal-header {\n  grid-column: 1/-1;\n  grid-row: 1/1;\n  margin-block-end: 0.5rem;\n  padding-block-start: 1rem;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--modal-header__label {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.25rem;\n}\n.cds--modal-header__label *,\n.cds--modal-header__label *::before,\n.cds--modal-header__label *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-header__heading {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  padding-inline-end: calc(20% - 3rem);\n}\n.cds--modal-header__heading *,\n.cds--modal-header__heading *::before,\n.cds--modal-header__heading *::after {\n  box-sizing: inherit;\n}\n\n.cds--modal-container--xs .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--xs .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--xs {\n    inline-size: 48%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--xs {\n    inline-size: 32%;\n    max-block-size: 48%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--xs {\n    inline-size: 24%;\n  }\n}\n\n.cds--modal-container--sm .cds--modal-content__regular-content {\n  padding-inline-end: 1rem;\n}\n.cds--modal-container--sm .cds--modal-content > p {\n  padding-inline-end: 0;\n}\n@media (min-width: 42rem) {\n  .cds--modal-container--sm {\n    inline-size: 60%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--sm {\n    inline-size: 42%;\n    max-block-size: 72%;\n  }\n  .cds--modal-container--sm .cds--modal-content > p,\n  .cds--modal-container--sm .cds--modal-content__regular-content {\n    padding-inline-end: 20%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--sm {\n    inline-size: 36%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--modal-container--lg {\n    inline-size: 96%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--modal-container--lg {\n    inline-size: 84%;\n    max-block-size: 96%;\n  }\n}\n@media (min-width: 82rem) {\n  .cds--modal-container--lg {\n    inline-size: 72%;\n  }\n}\n\n.cds--modal-scroll-content {\n  border-block-end: 2px solid transparent;\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-scroll-content:has(.cds--autoalign) {\n  -webkit-mask-image: none;\n          mask-image: none;\n}\n\n.cds--modal-scroll-content > *:last-child {\n  margin-block-end: 1.5rem;\n}\n\n.cds--modal-footer {\n  display: flex;\n  justify-content: flex-end;\n  block-size: 4rem;\n  grid-column: 1/-1;\n  grid-row: -1/-1;\n  margin-block-start: auto;\n}\n\n.cds--modal-footer .cds--btn {\n  flex: 0 1 50%;\n  align-items: baseline;\n  margin: 0;\n  block-size: 4rem;\n  max-inline-size: none;\n  padding-block-end: 2rem;\n  padding-block-start: 0.875rem;\n}\n\n.cds--modal-footer--three-button .cds--btn {\n  flex: 0 1 25%;\n  align-items: flex-start;\n}\n\n.cds--modal-close-button, :host(c4d-expressive-modal-close-button) {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n.cds--modal-close {\n  padding: 0.75rem;\n  border: 2px solid transparent;\n  background-color: transparent;\n  block-size: 3rem;\n  cursor: pointer;\n  inline-size: 3rem;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--modal-close:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--modal-close:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--modal-close::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--modal-close__icon {\n  block-size: 1.25rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1.25rem;\n}\n\n.cds--body--with-modal-open {\n  overflow: hidden;\n}\n\n.cds--body--with-modal-open .cds--modal .cds--tooltip, .cds--body--with-modal-open :host(c4d-locale-modal) .cds--tooltip, .cds--body--with-modal-open :host(c4d-expressive-modal) .cds--tooltip,\n.cds--body--with-modal-open .cds--modal .cds--overflow-menu-options,\n.cds--body--with-modal-open .cds--overflow-menu-options {\n  z-index: 9000;\n}\n\n.cds--modal-container--full-width .cds--modal-content {\n  padding: 0;\n  margin: 0;\n}\n\n.cds--modal--slug.cds--modal {\n  background-color: var(--cds-ai-overlay, rgba(0, 17, 65, 0.5));\n}\n\n.cds--modal--slug .cds--modal-container {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  background-color: var(--cds-layer);\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-container:has(.cds--modal-footer) {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) calc(0% + 64px), var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) calc(0% + 64px), 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  box-shadow: inset 0 -80px 0 -16px var(--cds-layer), inset 0 -160px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 24px 40px -24px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n\n.cds--modal--slug .cds--modal-content.cds--modal-scroll-content {\n  -webkit-mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n          mask-image: linear-gradient(to bottom, var(--cds-layer) calc(100% - 80px), transparent calc(100% - 48px), transparent 100%), linear-gradient(to left, var(--cds-layer) 0, 16px, transparent 16px), linear-gradient(to right, var(--cds-layer) 0, 2px, transparent 2px), linear-gradient(to top, var(--cds-layer) 0, 2px, transparent 2px);\n}\n\n.cds--modal-header > .cds--slug:has(+ .cds--modal-close-button, + :host(c4d-expressive-modal-close-button)),\n.cds--modal-header > .cds--modal-close-button ~ .cds--slug,\n.cds--modal-header > :host(c4d-expressive-modal-close-button) ~ .cds--slug,\n.cds--modal--slug .cds--modal-container-body > .cds--slug {\n  position: absolute;\n  inset-block-start: 0.625rem;\n  inset-inline-end: 3rem;\n}\n\n.cds--modal--slug .cds--modal-content--overflow-indicator::before,\n.cds--modal--slug .cds--modal-content--overflow-indicator {\n  display: none;\n}\n\n/* stylelint-disable no-duplicate-selectors */\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close__icon {\n    fill: ButtonText;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--modal-close:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n\n/* stylelint-enable no-duplicate-selectors */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-expressive-modal) .cds--modal-container {\n  padding: 1rem;\n  grid-template-rows: 1fr;\n  min-block-size: 5.25rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal) .cds--modal-container {\n    padding: 2rem;\n  }\n}\n:host(c4d-expressive-modal) .cds--modal-content {\n  display: grid;\n  grid-template-rows: auto 1fr auto;\n  padding-block-end: 0;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__header--with-body {\n  margin-block-end: 1rem;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body {\n  inline-size: 100%;\n}\n:host(c4d-expressive-modal) .c4d-ce--modal__body--with-footer {\n  margin-block-end: 3rem;\n}\n\n:host(c4d-expressive-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-expressive-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-expressive-modal[open]) {\n    transition: none;\n  }\n}\n\n:host(c4d-expressive-modal-footer) .cds--modal-footer {\n  justify-content: flex-start;\n  block-size: 3rem;\n}\n\n:host(c4d-expressive-modal-close-button) .cds--modal-close {\n  position: fixed;\n  z-index: 2;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n\n:host(c4d-expressive-modal-heading),\n.cds--modal--expressive .cds--modal-content h1 {\n  font-size: var(--cds-heading-04-font-size, 1.75rem);\n  font-weight: var(--cds-heading-04-font-weight, 400);\n  line-height: var(--cds-heading-04-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-04-letter-spacing, 0);\n}\n\n:host(c4d-expressive-modal-header) {\n  display: block;\n  padding: 0;\n}\n\n:host(c4d-expressive-modal-body),\n:host(c4d-lightbox-media-viewer-body) {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container,\n  .cds--modal--expressive--fullwidth .cds--modal-container {\n    block-size: calc(100% - 2rem);\n    inline-size: calc(100% - 2rem);\n    max-block-size: none;\n    max-inline-size: 96rem;\n  }\n}\n\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-container {\n  padding: 0;\n}\n:host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n  padding: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-expressive-modal)[expressive-size=full-width] .cds--modal-content {\n    padding: 2rem;\n  }\n}\n\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-expressive-modal-body),\n:host(c4d-expressive-modal[size=full-width]) ::slotted(c4d-lightbox-media-viewer-body),\n.cds--modal--expressive--fullwidth .cds--modal-content {\n  block-size: auto;\n  min-block-size: 31.25rem;\n  padding-inline-end: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--card,\n:host(c4d-card),\n:host(c4d-region-item) .cds--link,\n:host(c4d-card-cta),\n:host(c4d-card-in-card),\n:host(c4d-card-group-item),\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-content-group-cards-item),\n:host(c4d-content-group-cards-item) .cds--card {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  padding: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 100%;\n  inline-size: 100%;\n  text-decoration: none;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile-group html,\n:host(c4d-card) .cds--tile-group html,\n:host(c4d-region-item) .cds--link .cds--tile-group html,\n:host(c4d-card-cta) .cds--tile-group html,\n:host(c4d-card-in-card) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--tile-group html,\n:host(c4d-card-group-item) .cds--card .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--tile-group html,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group html {\n  font-size: 100%;\n}\n.cds--card .cds--tile-group body,\n:host(c4d-card) .cds--tile-group body,\n:host(c4d-region-item) .cds--link .cds--tile-group body,\n:host(c4d-card-cta) .cds--tile-group body,\n:host(c4d-card-in-card) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--tile-group body,\n:host(c4d-card-group-item) .cds--card .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--tile-group body,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--card .cds--tile-group code,\n:host(c4d-card) .cds--tile-group code,\n:host(c4d-region-item) .cds--link .cds--tile-group code,\n:host(c4d-card-cta) .cds--tile-group code,\n:host(c4d-card-in-card) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--tile-group code,\n:host(c4d-card-group-item) .cds--card .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--tile-group code,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--card .cds--tile-group strong,\n:host(c4d-card) .cds--tile-group strong,\n:host(c4d-region-item) .cds--link .cds--tile-group strong,\n:host(c4d-card-cta) .cds--tile-group strong,\n:host(c4d-card-in-card) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--tile-group strong,\n:host(c4d-card-group-item) .cds--card .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--tile-group strong,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-group strong {\n  font-weight: 600;\n}\n.cds--card .cds--tile,\n:host(c4d-card) .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile,\n:host(c4d-card-cta) .cds--tile,\n:host(c4d-card-in-card) .cds--tile,\n:host(c4d-card-group-item) .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  position: relative;\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  min-block-size: 4rem;\n  min-inline-size: 8rem;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n}\n.cds--card .cds--tile:focus,\n:host(c4d-card) .cds--tile:focus,\n:host(c4d-region-item) .cds--link .cds--tile:focus,\n:host(c4d-card-cta) .cds--tile:focus,\n:host(c4d-card-in-card) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--tile:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--tile:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile:focus,\n  :host(c4d-card) .cds--tile:focus,\n  :host(c4d-region-item) .cds--link .cds--tile:focus,\n  :host(c4d-card-cta) .cds--tile:focus,\n  :host(c4d-card-in-card) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--tile:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--tile:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--light,\n:host(c4d-card) .cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--light,\n:host(c4d-card-cta) .cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--clickable,\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  padding: var(--cds-layout-density-padding-inline-local);\n  cursor: pointer;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--clickable *,\n.cds--card .cds--tile--clickable *::before,\n.cds--card .cds--tile--clickable *::after,\n.cds--card .cds--tile--selectable *,\n.cds--card .cds--tile--selectable *::before,\n.cds--card .cds--tile--selectable *::after,\n:host(c4d-card) .cds--tile--clickable *,\n:host(c4d-card) .cds--tile--clickable *::before,\n:host(c4d-card) .cds--tile--clickable *::after,\n:host(c4d-card) .cds--tile--selectable *,\n:host(c4d-card) .cds--tile--selectable *::before,\n:host(c4d-card) .cds--tile--selectable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--clickable *::after,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::before,\n:host(c4d-region-item) .cds--link .cds--tile--selectable *::after,\n:host(c4d-card-cta) .cds--tile--clickable *,\n:host(c4d-card-cta) .cds--tile--clickable *::before,\n:host(c4d-card-cta) .cds--tile--clickable *::after,\n:host(c4d-card-cta) .cds--tile--selectable *,\n:host(c4d-card-cta) .cds--tile--selectable *::before,\n:host(c4d-card-cta) .cds--tile--selectable *::after,\n:host(c4d-card-in-card) .cds--tile--clickable *,\n:host(c4d-card-in-card) .cds--tile--clickable *::before,\n:host(c4d-card-in-card) .cds--tile--clickable *::after,\n:host(c4d-card-in-card) .cds--tile--selectable *,\n:host(c4d-card-in-card) .cds--tile--selectable *::before,\n:host(c4d-card-in-card) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--tile--selectable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--tile--selectable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--selectable:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--selectable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--selectable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--selectable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--selectable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--selectable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--clickable,\n:host(c4d-card) .cds--tile--clickable,\n:host(c4d-region-item) .cds--link .cds--tile--clickable,\n:host(c4d-card-cta) .cds--tile--clickable,\n:host(c4d-card-in-card) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  text-decoration: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--clickable:focus,\n  :host(c4d-card) .cds--tile--clickable:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--clickable:focus,\n  :host(c4d-card-cta) .cds--tile--clickable:focus,\n  :host(c4d-card-in-card) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--tile--clickable:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--clickable:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--clickable:hover .cds--tile__checkmark, .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:focus .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:focus .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile--expandable::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile--clickable:hover,\n.cds--card .cds--tile--clickable:active,\n.cds--card .cds--tile--clickable:visited,\n.cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-card) .cds--tile--clickable:hover,\n:host(c4d-card) .cds--tile--clickable:active,\n:host(c4d-card) .cds--tile--clickable:visited,\n:host(c4d-card) .cds--tile--clickable:visited:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:active,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:visited:hover,\n:host(c4d-card-cta) .cds--tile--clickable:hover,\n:host(c4d-card-cta) .cds--tile--clickable:active,\n:host(c4d-card-cta) .cds--tile--clickable:visited,\n:host(c4d-card-cta) .cds--tile--clickable:visited:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:hover,\n:host(c4d-card-in-card) .cds--tile--clickable:active,\n:host(c4d-card-in-card) .cds--tile--clickable:visited,\n:host(c4d-card-in-card) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--tile--clickable:visited:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:visited:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:active,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:visited:hover {\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--card .cds--tile--clickable.cds--link--disabled,\n.cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled,\n:host(c4d-region-item) .cds--link .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-cta) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-in-card) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--tile--clickable:hover.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable:hover.cds--link--disabled {\n  display: block;\n  padding: var(--cds-layout-density-padding-inline-local);\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  position: absolute;\n  inset-block-end: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n.cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--icon {\n  fill: var(--cds-icon-interactive, #0f62fe);\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--disabled-icon {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-region-item) .cds--link .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-cta) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-in-card) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--tile--clickable.cds--link--disabled .cds--tile--icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable.cds--link--disabled .cds--tile--icon {\n  display: none;\n}\n.cds--card .cds--tile--selectable,\n:host(c4d-card) .cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--selectable {\n  border: 1px solid transparent;\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile__checkmark,\n:host(c4d-card) .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark {\n  position: absolute;\n  border: none;\n  background: transparent;\n  block-size: 1rem;\n  inset-block-start: var(--cds-layout-density-padding-inline-local);\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  opacity: 1;\n}\n.cds--card .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg {\n  border-radius: 50%;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--card .cds--tile__checkmark:focus,\n:host(c4d-card) .cds--tile__checkmark:focus,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n:host(c4d-card-cta) .cds--tile__checkmark:focus,\n:host(c4d-card-in-card) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--tile__checkmark:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-card) .cds--tile__checkmark:focus,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark:focus,\n  :host(c4d-card-cta) .cds--tile__checkmark:focus,\n  :host(c4d-card-in-card) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--tile__checkmark:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile__checkmark--persistent,\n:host(c4d-card) .cds--tile__checkmark--persistent,\n:host(c4d-region-item) .cds--link .cds--tile__checkmark--persistent,\n:host(c4d-card-cta) .cds--tile__checkmark--persistent,\n:host(c4d-card-in-card) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--tile__checkmark--persistent,\n:host(c4d-card-group-item) .cds--card .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--tile__checkmark--persistent,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark--persistent {\n  opacity: 1;\n}\n.cds--card .cds--tile__chevron,\n:host(c4d-card) .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron {\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n}\n.cds--card .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n  fill: var(--cds-icon-primary, #161616);\n  transform-origin: center;\n  transition: 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    transition: none;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile__chevron--interactive,\n:host(c4d-card) .cds--tile__chevron--interactive,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive,\n:host(c4d-card-cta) .cds--tile__chevron--interactive,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inline-size: calc(var(--cds-layout-density-padding-inline-local) * 2 + 1rem);\n  inset-block-end: 0;\n  inset-inline-end: 0;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile__chevron--interactive *,\n.cds--card .cds--tile__chevron--interactive *::before,\n.cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-card) .cds--tile__chevron--interactive *,\n:host(c4d-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::before,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive *::after,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-cta) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive *::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive *::after {\n  box-sizing: inherit;\n}\n.cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-cta) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive::-moz-focus-inner,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive::-moz-focus-inner {\n  border: 0;\n}\n.cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:focus,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile__chevron--interactive:hover,\n:host(c4d-card-cta) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-in-card) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile__chevron--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron--interactive:hover {\n  background-color: var(--cds-layer-hover);\n  cursor: pointer;\n}\n.cds--card .cds--tile--expandable,\n:host(c4d-card) .cds--tile--expandable,\n:host(c4d-region-item) .cds--link .cds--tile--expandable,\n:host(c4d-card-cta) .cds--tile--expandable,\n:host(c4d-card-in-card) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--tile--expandable,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--tile--expandable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable {\n  position: relative;\n  overflow: hidden;\n  border: 0;\n  color: inherit;\n  cursor: pointer;\n  font-family: inherit;\n  font-size: inherit;\n  inline-size: 100%;\n  text-align: start;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  border: 1px solid var(--cds-border-tile);\n}\n.cds--card .cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:hover {\n  background: var(--cds-layer-hover);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive {\n  border: none;\n  cursor: default;\n  transition: max-height 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:hover {\n  background-color: var(--cds-layer);\n}\n.cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable.cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable.cds--tile--expandable--interactive:focus {\n  outline: none;\n}\n.cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n:host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-region-item) .cds--link .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-cta) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-in-card) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-card-group-item) .cds--card .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--tile--expandable--interactive:focus,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable--interactive:focus {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content__below-the-fold {\n  display: block;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: hidden;\n}\n.cds--card .cds--tile--is-expanded,\n:host(c4d-card) .cds--tile--is-expanded,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded,\n:host(c4d-card-cta) .cds--tile--is-expanded,\n:host(c4d-card-in-card) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--tile--is-expanded,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded {\n  overflow: visible;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile__chevron svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile__chevron svg {\n  transform: rotate(180deg);\n}\n.cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), visibility 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n@media not all and (resolution >= 0.001dpcm) {\n  @supports (-webkit-appearance: none) and (stroke-color: transparent) {\n    .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-region-item) .cds--link .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-cta) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-in-card) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-card-group-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--tile--is-expanded .cds--tile-content__below-the-fold,\n    :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-expanded .cds--tile-content__below-the-fold {\n      overflow-y: auto;\n    }\n  }\n}\n.cds--card .cds--tile--is-selected,\n:host(c4d-card) .cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected {\n  border: 1px solid var(--cds-layer-selected-inverse, #161616);\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark {\n  opacity: 1;\n}\n.cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card .cds--tile-content,\n:host(c4d-card) .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile-content,\n:host(c4d-card-cta) .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-content {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--card .cds--tile-input,\n:host(c4d-card) .cds--tile-input,\n:host(c4d-region-item) .cds--link .cds--tile-input,\n:host(c4d-card-cta) .cds--tile-input,\n:host(c4d-card-in-card) .cds--tile-input,\n:host(c4d-card-group-item) .cds--tile-input,\n:host(c4d-card-group-item) .cds--card .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--tile-input,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n.cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-cta) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile {\n    outline-style: dotted;\n  }\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable {\n  background-color: var(--cds-layer);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  border: 1px solid var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--selectable.cds--tile--light,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--selectable.cds--tile--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n.cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--disabled.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled.cds--tile--is-selected {\n  border-color: var(--cds-border-disabled, #c6c6c6);\n}\n.cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-region-item) .cds--link .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-cta) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-in-card) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-card-group-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--tile--disabled .cds--tile__checkmark svg,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--disabled .cds--tile__checkmark svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--card .cds--tile > .cds--slug,\n.cds--card .cds--tile--expandable > div > .cds--slug,\n.cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card) .cds--tile > .cds--slug,\n:host(c4d-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-region-item) .cds--link .cds--tile > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--expandable > div > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-cta) .cds--tile > .cds--slug,\n:host(c4d-card-cta) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-in-card) .cds--tile > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-card-group-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable > div > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon {\n  position: absolute;\n  inset-block-start: 1rem;\n  inset-inline-end: 1rem;\n}\n.cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio > .cds--slug {\n  inset-inline-end: 1rem;\n  transition: inset-inline-end 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--selectable.cds--tile--radio.cds--tile--is-selected > .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n.cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-cta) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile.cds--tile--clickable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile.cds--tile--clickable > .cds--slug {\n  pointer-events: none;\n}\n.cds--card .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n  border: 1px solid transparent;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--expandable:hover,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--expandable:hover {\n  background: linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)) 0%, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-layer, var(--cds-ai-popover-background, #ffffff)), var(--cds-layer, var(--cds-ai-popover-background, #ffffff))) border-box;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  position: absolute;\n  display: block;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::before,\n.cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable::before {\n  background: linear-gradient(to top, var(--cds-ai-aura-hover-start, rgba(69, 137, 255, 0.32)) 0%, 15%, var(--cds-ai-aura-hover-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) padding-box, linear-gradient(to bottom, var(--cds-ai-border-start, rgba(166, 200, 255, 0.64)), var(--cds-ai-border-end, #78a9ff)) border-box, linear-gradient(to top, var(--cds-ai-aura-hover-background, #edf5ff), var(--cds-ai-aura-hover-background, #edf5ff)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 10px 2px var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n.cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:hover::before {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:focus,\n.cds--card .cds--tile--slug.cds--tile--clickable:focus,\n.cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-region-item) .cds--link .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-cta) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-in-card) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-card-group-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--tile-input:focus + .cds--tile--slug.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable:focus,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile-input:focus + .cds--tile--slug.cds--tile {\n  outline-offset: -1px;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable::after {\n  background: linear-gradient(to top, var(--cds-ai-aura-start, rgba(69, 137, 255, 0.1)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%) padding-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) padding-box, linear-gradient(to bottom, var(--cds-border-inverse, #161616), var(--cds-border-inverse, #161616)) border-box, linear-gradient(to top, var(--cds-layer), var(--cds-layer)) border-box;\n  box-shadow: inset 0 -80px 70px -65px var(--cds-ai-inner-shadow, rgba(69, 137, 255, 0.1)), 0 4px 8px 0 var(--cds-ai-drop-shadow, rgba(15, 98, 254, 0.1));\n}\n.cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable:hover::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable:hover::after {\n  opacity: 0;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected::after {\n  opacity: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected {\n  border-color: var(--cds-border-inverse, #161616);\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content {\n  position: relative;\n  cursor: pointer;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n.cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--is-selected .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--clickable .cds--tile-content,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--is-selected .cds--slug {\n  z-index: 1;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable .cds--slug:has(> .cds--popover--open) {\n  z-index: 2;\n}\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n.cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-region-item) .cds--link .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-cta) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-in-card) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--slug,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug.cds--tile--selectable > .cds--tile__checkmark {\n  z-index: 1;\n}\n.cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-region-item) .cds--link .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-cta) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-in-card) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-card-group-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--tile--expandable:has(.cds--slug > .cds--popover--open),\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--expandable:has(.cds--slug > .cds--popover--open) {\n  overflow: visible;\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon rect,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon rect {\n  stroke: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-region-item) .cds--link .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-cta) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-in-card) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-card-group-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--tile--clickable .cds--tile--slug-icon path,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--clickable .cds--tile--slug-icon path {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--card .cds--tile--slug-rounded,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n.cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n.cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card) .cds--tile--slug-rounded,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-cta) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-in-card) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded.cds--tile--clickable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--selectable::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded.cds--tile--clickable::before {\n  border-radius: 0.5rem;\n}\n.cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-region-item) .cds--link .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-cta) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-in-card) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-card-group-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--tile--slug-rounded .cds--tile__chevron,\n:host(c4d-content-group-cards-item) .cds--card .cds--tile--slug-rounded .cds--tile__chevron {\n  border-end-end-radius: 0.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--card .cds--tile__chevron svg,\n  .cds--card .cds--tile__checkmark svg,\n  .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile__chevron svg,\n  :host(c4d-card) .cds--tile__checkmark svg,\n  :host(c4d-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile__chevron svg,\n  :host(c4d-region-item) .cds--link .cds--tile__checkmark svg,\n  :host(c4d-region-item) .cds--link .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile__chevron svg,\n  :host(c4d-card-cta) .cds--tile__checkmark svg,\n  :host(c4d-card-cta) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile__chevron svg,\n  :host(c4d-card-in-card) .cds--tile__checkmark svg,\n  :host(c4d-card-in-card) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-card-group-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--tile--is-selected .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__chevron svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile__checkmark svg,\n  :host(c4d-content-group-cards-item) .cds--card .cds--tile--is-selected .cds--tile__checkmark svg {\n    fill: ButtonText;\n  }\n}\n.cds--card:focus-within .cds--tile--clickable,\n:host(c4d-card):focus-within .cds--tile--clickable,\n:host(c4d-region-item) .cds--link:focus-within .cds--tile--clickable,\n:host(c4d-card-cta):focus-within .cds--tile--clickable,\n:host(c4d-card-in-card):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item):focus-within .cds--tile--clickable,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item):focus-within .cds--tile--clickable,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--tile--clickable {\n  position: relative;\n  z-index: 2;\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--card:focus-within ::slotted(c4d-image),\n.cds--card:focus-within ::slotted(c4d-card-cta-image),\n.cds--card:focus-within .cds--card__img,\n.cds--card:focus-within .cds--image,\n:host(c4d-card):focus-within ::slotted(c4d-image),\n:host(c4d-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card):focus-within .cds--card__img,\n:host(c4d-card):focus-within .cds--image,\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link:focus-within .cds--card__img,\n:host(c4d-region-item) .cds--link:focus-within .cds--image,\n:host(c4d-card-cta):focus-within ::slotted(c4d-image),\n:host(c4d-card-cta):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta):focus-within .cds--card__img,\n:host(c4d-card-cta):focus-within .cds--image,\n:host(c4d-card-in-card):focus-within ::slotted(c4d-image),\n:host(c4d-card-in-card):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card):focus-within .cds--card__img,\n:host(c4d-card-in-card):focus-within .cds--image,\n:host(c4d-card-group-item):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item):focus-within .cds--card__img,\n:host(c4d-card-group-item):focus-within .cds--image,\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-card-group-item) .cds--card:focus-within .cds--image,\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item):focus-within .cds--card__img,\n:host(c4d-content-group-cards-item):focus-within .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card:focus-within .cds--image {\n  z-index: -1;\n}\n.cds--card:focus, .cds--card:visited, .cds--card:active,\n:host(c4d-card):focus,\n:host(c4d-card):visited,\n:host(c4d-card):active,\n:host(c4d-region-item) .cds--link:focus,\n:host(c4d-region-item) .cds--link:visited,\n:host(c4d-region-item) .cds--link:active,\n:host(c4d-card-cta):focus,\n:host(c4d-card-cta):visited,\n:host(c4d-card-cta):active,\n:host(c4d-card-in-card):focus,\n:host(c4d-card-in-card):visited,\n:host(c4d-card-in-card):active,\n:host(c4d-card-group-item):focus,\n:host(c4d-card-group-item):visited,\n:host(c4d-card-group-item):active,\n:host(c4d-card-group-item) .cds--card:focus,\n:host(c4d-card-group-item) .cds--card:visited,\n:host(c4d-card-group-item) .cds--card:active,\n:host(c4d-content-group-cards-item):focus,\n:host(c4d-content-group-cards-item):visited,\n:host(c4d-content-group-cards-item):active,\n:host(c4d-content-group-cards-item) .cds--card:focus,\n:host(c4d-content-group-cards-item) .cds--card:visited,\n:host(c4d-content-group-cards-item) .cds--card:active {\n  position: relative;\n  z-index: 2;\n  text-decoration: none;\n}\n.cds--card:focus ::slotted(c4d-image),\n.cds--card:focus .cds--image, .cds--card:visited ::slotted(c4d-image),\n.cds--card:visited .cds--image, .cds--card:active ::slotted(c4d-image),\n.cds--card:active .cds--image,\n:host(c4d-card):focus ::slotted(c4d-image),\n:host(c4d-card):focus .cds--image,\n:host(c4d-card):visited ::slotted(c4d-image),\n:host(c4d-card):visited .cds--image,\n:host(c4d-card):active ::slotted(c4d-image),\n:host(c4d-card):active .cds--image,\n:host(c4d-region-item) .cds--link:focus ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:focus .cds--image,\n:host(c4d-region-item) .cds--link:visited ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:visited .cds--image,\n:host(c4d-region-item) .cds--link:active ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link:active .cds--image,\n:host(c4d-card-cta):focus ::slotted(c4d-image),\n:host(c4d-card-cta):focus .cds--image,\n:host(c4d-card-cta):visited ::slotted(c4d-image),\n:host(c4d-card-cta):visited .cds--image,\n:host(c4d-card-cta):active ::slotted(c4d-image),\n:host(c4d-card-cta):active .cds--image,\n:host(c4d-card-in-card):focus ::slotted(c4d-image),\n:host(c4d-card-in-card):focus .cds--image,\n:host(c4d-card-in-card):visited ::slotted(c4d-image),\n:host(c4d-card-in-card):visited .cds--image,\n:host(c4d-card-in-card):active ::slotted(c4d-image),\n:host(c4d-card-in-card):active .cds--image,\n:host(c4d-card-group-item):focus ::slotted(c4d-image),\n:host(c4d-card-group-item):focus .cds--image,\n:host(c4d-card-group-item):visited ::slotted(c4d-image),\n:host(c4d-card-group-item):visited .cds--image,\n:host(c4d-card-group-item):active ::slotted(c4d-image),\n:host(c4d-card-group-item):active .cds--image,\n:host(c4d-card-group-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:focus .cds--image,\n:host(c4d-card-group-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:visited .cds--image,\n:host(c4d-card-group-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card:active .cds--image,\n:host(c4d-content-group-cards-item):focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):focus .cds--image,\n:host(c4d-content-group-cards-item):visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):visited .cds--image,\n:host(c4d-content-group-cards-item):active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item):active .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:focus ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:focus .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:visited ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:visited .cds--image,\n:host(c4d-content-group-cards-item) .cds--card:active ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card:active .cds--image {\n  z-index: -1;\n}\n.cds--card ::slotted(c4d-image),\n.cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-card) ::slotted(c4d-image),\n:host(c4d-card) ::slotted(c4d-card-cta-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-image),\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image),\n:host(c4d-card-cta) ::slotted(c4d-image),\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n:host(c4d-card-in-card) ::slotted(c4d-image),\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) ::slotted(c4d-image),\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image),\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image),\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image) {\n  position: relative;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--card ::slotted(c4d-image)::before,\n  .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card) ::slotted(c4d-image)::before,\n  :host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n  :host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-image)::before,\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-image)::before,\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n  :host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n    position: absolute;\n    background-color: var(--cds-border-inverse, #161616);\n    content: \"\";\n    inset: 0;\n    opacity: 0;\n    transition: none;\n  }\n}\n.cds--card ::slotted(c4d-image)::before,\n.cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card) ::slotted(c4d-image)::before,\n:host(c4d-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-image)::before,\n:host(c4d-region-item) .cds--link ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-image)::before,\n:host(c4d-card-cta) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-image)::before,\n:host(c4d-card-in-card) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-card-group-item) .cds--card ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-image)::before,\n:host(c4d-content-group-cards-item) .cds--card ::slotted(c4d-card-cta-image)::before {\n  position: absolute;\n  background-color: var(--cds-border-inverse, #161616);\n  content: \"\";\n  inset: 0;\n  opacity: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile {\n  padding: 0;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n.cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-region-item) .cds--link:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-cta):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-in-card):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item):not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover c4d-image::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-content-group-cards-item) .cds--card:not([disabled]) .cds--card.cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  position: absolute;\n  background: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  opacity: 16%;\n}\n.cds--card .cds--card,\n:host(c4d-card) .cds--card,\n:host(c4d-region-item) .cds--link .cds--card,\n:host(c4d-card-cta) .cds--card,\n:host(c4d-card-in-card) .cds--card,\n:host(c4d-card-group-item) .cds--card,\n:host(c4d-card-group-item) .cds--card .cds--card,\n:host(c4d-content-group-cards-item) .cds--card,\n:host(c4d-content-group-cards-item) .cds--card .cds--card {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n.cds--card .cds--card__wrapper,\n:host(c4d-card) .cds--card__wrapper,\n:host(c4d-region-item) .cds--link .cds--card__wrapper,\n:host(c4d-card-cta) .cds--card__wrapper,\n:host(c4d-card-in-card) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card__wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card__wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper {\n  display: flex;\n  flex: 1;\n  justify-content: space-between;\n  min-block-size: 10rem;\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  display: flex;\n}\n.cds--card .cds--card__wrapper::before,\n:host(c4d-card) .cds--card__wrapper::before,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::before,\n:host(c4d-card-cta) .cds--card__wrapper::before,\n:host(c4d-card-in-card) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card__wrapper::before,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::before,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 50%;\n}\n.cds--card .cds--card__wrapper::after,\n:host(c4d-card) .cds--card__wrapper::after,\n:host(c4d-region-item) .cds--link .cds--card__wrapper::after,\n:host(c4d-card-cta) .cds--card__wrapper::after,\n:host(c4d-card-in-card) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card__wrapper::after,\n:host(c4d-card-group-item) .cds--card .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card__wrapper::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n.cds--card .cds--card__content,\n:host(c4d-card) .cds--card__content,\n:host(c4d-region-item) .cds--link .cds--card__content,\n:host(c4d-card-cta) .cds--card__content,\n:host(c4d-card-in-card) .cds--card__content,\n:host(c4d-card-group-item) .cds--card__content,\n:host(c4d-card-group-item) .cds--card .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card__content,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__content {\n  display: flex;\n  flex-direction: column;\n  padding: 1rem;\n  inline-size: 100%;\n}\n.cds--card .cds--card__heading,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n  margin-block-end: 4rem;\n}\n@media (min-width: 82rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card .cds--card__heading,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n.cds--card .cds--card__heading,\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__heading,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__heading,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__heading,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__heading,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__heading,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__heading,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  color: var(--cds-text-primary, #161616);\n  max-inline-size: 40rem;\n  padding-inline-end: 10%;\n}\n@media (min-width: 42rem) {\n  .cds--card .cds--card__heading,\n  .cds--card .cds--card__copy,\n  :host(c4d-card) .cds--card__heading,\n  :host(c4d-card) .cds--card__copy,\n  :host(c4d-region-item) .cds--link .cds--card__heading,\n  :host(c4d-region-item) .cds--link .cds--card__copy,\n  :host(c4d-card-cta) .cds--card__heading,\n  :host(c4d-card-cta) .cds--card__copy,\n  :host(c4d-card-in-card) .cds--card__heading,\n  :host(c4d-card-in-card) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card__copy,\n  :host(c4d-card-group-item) .cds--card .cds--card__heading,\n  :host(c4d-card-group-item) .cds--card .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card__copy,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__heading,\n  :host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n    padding-inline-end: 2rem;\n  }\n}\n.cds--card .cds--card__copy,\n:host(c4d-card) .cds--card__copy,\n:host(c4d-region-item) .cds--link .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-group-item) .cds--card .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card__copy,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__copy {\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n  margin-block-end: 2rem;\n}\n.cds--card .cds--card__img,\n:host(c4d-card) .cds--card__img,\n:host(c4d-region-item) .cds--link .cds--card__img,\n:host(c4d-card-cta) .cds--card__img,\n:host(c4d-card-in-card) .cds--card__img,\n:host(c4d-card-group-item) .cds--card__img,\n:host(c4d-card-group-item) .cds--card .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card__img,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__img {\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--card .cds--card__link::after,\n:host(c4d-card) .cds--card__link::after,\n:host(c4d-region-item) .cds--link .cds--card__link::after,\n:host(c4d-card-cta) .cds--card__link::after,\n:host(c4d-card-in-card) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card__link::after,\n:host(c4d-card-group-item) .cds--card .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card__link::after,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__link::after {\n  position: absolute;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer-wrapper,\n:host(c4d-card) .cds--card__footer-wrapper,\n:host(c4d-region-item) .cds--link .cds--card__footer-wrapper,\n:host(c4d-card-cta) .cds--card__footer-wrapper,\n:host(c4d-card-in-card) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card__footer-wrapper,\n:host(c4d-card-group-item) .cds--card .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card__footer-wrapper,\n:host(c4d-content-group-cards-item) .cds--card .cds--card__footer-wrapper {\n  margin-block-start: auto;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-content-group-cards-item) {\n    inline-size: auto;\n    margin-inline: 1rem;\n  }\n}\n\n:host(c4d-card-group-item),\n:host(c4d-card-in-card),\n:host(c4d-card-cta),\n:host(c4d-card) {\n  outline: none;\n}\n:host(c4d-card-group-item) .cds--card__pictogram,\n:host(c4d-card-in-card) .cds--card__pictogram,\n:host(c4d-card-cta) .cds--card__pictogram,\n:host(c4d-card) .cds--card__pictogram {\n  display: flex;\n}\n:host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n:host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n  margin-block-end: 0;\n  padding-block-start: 2rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card-cta) .cds--card__pictogram ::slotted(c4d-card-heading),\n  :host(c4d-card) .cds--card__pictogram ::slotted(c4d-card-heading) {\n    display: flex;\n    flex: 1;\n    padding-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item) .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card) .cds--card__pictogram-wrapper,\n:host(c4d-card-cta) .cds--card__pictogram-wrapper,\n:host(c4d-card) .cds--card__pictogram-wrapper {\n  display: flex;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram] .cds--card ::slotted(c4d-card-heading) {\n  padding-block-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-inline-start: 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram] .cds--card .cds--card__content {\n  position: relative;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram] .cds--card .cds--card__copy {\n  margin-block: 2rem 0;\n}\n:host(c4d-card-group-item)[pictogram] .cds--card svg,\n:host(c4d-card-in-card)[pictogram] .cds--card svg,\n:host(c4d-card-cta)[pictogram] .cds--card svg,\n:host(c4d-card)[pictogram] .cds--card svg {\n  position: absolute;\n  color: var(--cds-link-primary, #0f62fe);\n  inset-block-end: 1rem;\n  inset-inline-end: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-end;\n  margin-block: auto 0;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card .cds--card__copy {\n  margin-block-start: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=top] .cds--card ::slotted(svg[slot=pictogram]) {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(c4d-card-heading) {\n  align-items: flex-start;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__content {\n  padding-block-end: 4rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__pictogram-wrapper {\n  position: absolute;\n  inset-block-end: 1rem;\n  inset-inline-start: 1rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy,\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card .cds--card__copy {\n  margin-block-end: 2rem;\n}\n:host(c4d-card-group-item)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[pictogram][pictogram-placement=bottom] .cds--card ::slotted(svg[slot=pictogram]) {\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n:host(c4d-card) ::slotted(svg[slot=pictogram]) {\n  fill: currentColor;\n  margin-inline-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-group-item) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta) ::slotted(svg[slot=pictogram]),\n  :host(c4d-card) ::slotted(svg[slot=pictogram]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-card-group-item)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-in-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-in-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card-cta)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card-cta)[color-scheme=inverse] ::slotted(svg[slot=pictogram]),\n:host(c4d-card)[color-scheme=inverse] .cds--card svg,\n:host(c4d-card)[color-scheme=inverse] ::slotted(svg[slot=pictogram]) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n:host(c4d-card-group-item) .cds--card__copy,\n:host(c4d-card-in-card) .cds--card__copy,\n:host(c4d-card-cta) .cds--card__copy,\n:host(c4d-card) .cds--card__copy {\n  display: flex;\n  flex-direction: column;\n  gap: 1rem;\n}\n:host(c4d-card-group-item) .cds--card__copy[hidden],\n:host(c4d-card-in-card) .cds--card__copy[hidden],\n:host(c4d-card-cta) .cds--card__copy[hidden],\n:host(c4d-card) .cds--card__copy[hidden] {\n  /* stylelint-disable declaration-no-important */\n  display: none !important;\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    padding-block-start: 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    /* stylelint-disable value-no-vendor-prefix, property-no-vendor-prefix */\n    display: -webkit-box;\n    /* stylelint-enable value-no-vendor-prefix, property-no-vendor-prefix */\n    overflow: hidden;\n    -webkit-box-orient: vertical;\n    -webkit-line-clamp: 3;\n    max-inline-size: calc(100% - 4rem);\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9) 0.25s;\n  }\n}\n@media (pointer: fine) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block: 2rem 0;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 0;\n    opacity: 0;\n    transform: translate3d(0, -16px, 0);\n    transition: all 240ms cubic-bezier(0.2, 0, 0.38, 0.9);\n    visibility: hidden;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading), :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion ::slotted(c4d-card-heading) {\n    opacity: 0;\n    transform: translate3d(0, 16px, 0);\n    transition-delay: 0s;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy, :host(c4d-card-group-item)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card:focus .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:hover .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=bottom] .cds--card:focus .cds--card__motion .cds--card__copy {\n    display: block;\n    overflow: hidden;\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n    transition-delay: 0.2s;\n    visibility: visible;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(c4d-card-heading) {\n    position: absolute;\n    display: flow-root;\n    inset-block-end: 1rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy,\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion .cds--card__copy {\n    margin-block-start: 2rem;\n  }\n}\n@media (pointer: fine) and (min-width: 42rem) {\n  :host(c4d-card-group-item)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-in-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card-cta)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]),\n  :host(c4d-card)[pictogram-placement=top] .cds--card .cds--card__motion ::slotted(svg[slot=pictogram]) {\n    margin-block-end: 0;\n  }\n}\n\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 100%;\n}\n:host(c4d-card[aspect-ratio=\"1:1\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 66.6666666667%;\n}\n:host(c4d-card[aspect-ratio=\"3:2\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 75%;\n}\n:host(c4d-card[aspect-ratio=\"4:3\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper {\n  display: flex;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::before {\n  block-size: 0;\n  content: \"\";\n  float: inline-start;\n  inline-size: 1px;\n  margin-inline-start: -1px;\n  padding-block-start: 56.25%;\n}\n:host(c4d-card[aspect-ratio=\"16:9\"]) .cds--card__wrapper::after {\n  display: table;\n  clear: both;\n  content: \"\";\n}\n\n.cds--card.cds--card--light {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n.cds--card--border {\n  border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n.cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n  font-size: 1.25rem;\n  font-weight: 400;\n  line-height: 1.4;\n  letter-spacing: 0;\n  font-size: calc(1.25rem + 0 * (100vw - 20rem) / 62);\n}\n@media (min-width: 82rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.25rem;\n    line-height: 1.4;\n    font-size: calc(1.25rem + 0.25 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--card__CTA.cds--card__CardCTA .cds--card__heading {\n    font-size: 1.5rem;\n    line-height: 1.334;\n    font-size: 1.5rem;\n  }\n}\n\n:host(c4d-card):not([href]) .cds--card .cds--card__copy,\n:host(c4d-card-group-item):not([href]) .cds--card .cds--card__copy {\n  margin-block-end: 0.125rem;\n}\n:host(c4d-card):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after,\n:host(c4d-card-group-item):not([href]) .cds--card.cds--tile ::slotted(c4d-image)::after {\n  display: none;\n}\n:host(c4d-card):not([href]):focus-within ::slotted(c4d-image),\n:host(c4d-card-group-item):not([href]):focus-within ::slotted(c4d-image) {\n  z-index: 0;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-heading),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-heading) {\n  margin-block-end: auto;\n  padding-block-end: 4rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer),\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer) {\n  display: inline-flex;\n  margin-block-start: 2rem;\n}\n:host(c4d-card):not([href]) ::slotted(c4d-card-footer)::after,\n:host(c4d-card-group-item):not([href]) ::slotted(c4d-card-footer)::after {\n  position: relative;\n}\n:host(c4d-card)[color-scheme=light] .cds--card__wrapper, :host(c4d-card)[color-scheme=light]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light] .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n  transition: 150ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n:host(c4d-card)[color-scheme=light][href] :hover .cds--card__wrapper,\n:host(c4d-card-group-item)[color-scheme=light][href] :hover .cds--card__wrapper {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-card)[color-scheme=light][href]:active,\n:host(c4d-card)[color-scheme=light][href] a:active,\n:host(c4d-card-group-item)[color-scheme=light][href]:active,\n:host(c4d-card-group-item)[color-scheme=light][href] a:active {\n  outline: none;\n}\n:host(c4d-card)[logo] .cds--card,\n:host(c4d-card-group-item)[logo] .cds--card {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo] .cds--card__copy,\n:host(c4d-card-group-item)[logo] .cds--card__copy {\n  margin-block-end: 1rem;\n}\n:host(c4d-card)[logo]:hover,\n:host(c4d-card-group-item)[logo]:hover {\n  border-color: var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-card)[logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n:host(c4d-card)[logo]:active,\n:host(c4d-card-group-item)[logo]:active {\n  border-color: var(--cds-border-inverse, #161616);\n}\n:host(c4d-card)[logo] ::slotted(c4d-card-footer),\n:host(c4d-card-group-item)[logo] ::slotted(c4d-card-footer) {\n  block-size: 0;\n}\n:host(c4d-card)[href][logo]:hover .cds--card__wrapper,\n:host(c4d-card-group-item)[href][logo]:hover .cds--card__wrapper {\n  background-color: var(--cds-layer-02, #ffffff);\n}\n\n:host(c4d-card[link]) ::slotted(c4d-card-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n:host(c4d-card[link]) .cds--card .cds--card__copy {\n  margin-block-start: 0;\n}\n\n:host(c4d-card-cta),\n:host(c4d-card-link-cta),\n:host(c4d-card-link) {\n  outline: none;\n}\n\n:host(c4d-card-eyebrow),\n.cds--card__eyebrow {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n  color: var(--cds-text-secondary, #525252);\n  margin-block-end: 0.5rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-eyebrow),\n  .cds--card__eyebrow {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-footer),\n:host(c4d-card-cta-footer),\n:host(c4d-card-in-card-footer),\n:host(c4d-feature-card-footer),\n:host(c4d-feature-cta-footer) {\n  display: flex;\n  align-items: flex-end;\n  margin-block-start: auto;\n}\n:host(c4d-card-footer):focus-visible,\n:host(c4d-card-cta-footer):focus-visible,\n:host(c4d-card-in-card-footer):focus-visible,\n:host(c4d-feature-card-footer):focus-visible,\n:host(c4d-feature-cta-footer):focus-visible {\n  outline: none;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: block;\n}\n\n.cds--card .cds--card__footer,\n:host(c4d-card-footer) a,\n:host(c4d-card-cta-footer) a,\n:host(c4d-card-in-card-footer) a,\n:host(c4d-feature-card-footer) a,\n:host(c4d-feature-cta-footer) a {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer:focus,\n:host(c4d-card-footer) a:focus,\n:host(c4d-card-cta-footer) a:focus,\n:host(c4d-card-in-card-footer) a:focus,\n:host(c4d-feature-card-footer) a:focus,\n:host(c4d-feature-cta-footer) a:focus {\n  outline: none;\n}\n.cds--card .cds--card__footer:hover,\n:host(c4d-card-footer) a:hover,\n:host(c4d-card-cta-footer) a:hover,\n:host(c4d-card-in-card-footer) a:hover,\n:host(c4d-feature-card-footer) a:hover,\n:host(c4d-feature-cta-footer) a:hover {\n  text-decoration: none;\n}\n.cds--card .cds--card__footer span,\n:host(c4d-card-footer) a span,\n:host(c4d-card-cta-footer) a span,\n:host(c4d-card-in-card-footer) a span,\n:host(c4d-feature-card-footer) a span,\n:host(c4d-feature-cta-footer) a span {\n  flex: none;\n}\n.cds--card .cds--card__footer::after,\n:host(c4d-card-footer) a::after,\n:host(c4d-card-cta-footer) a::after,\n:host(c4d-card-in-card-footer) a::after,\n:host(c4d-feature-card-footer) a::after,\n:host(c4d-feature-cta-footer) a::after {\n  position: absolute;\n  z-index: 1;\n  content: \"\";\n  inset: 0;\n}\n.cds--card .cds--card__footer .cds--card__cta__copy,\n:host(c4d-card-footer) a .cds--card__cta__copy,\n:host(c4d-card-cta-footer) a .cds--card__cta__copy,\n:host(c4d-card-in-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-card-footer) a .cds--card__cta__copy,\n:host(c4d-feature-cta-footer) a .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n  max-inline-size: calc(100% - 20px - 0.5rem);\n  font-size: var(--cds-body-02-font-size, 1rem);\n  font-weight: var(--cds-body-02-font-weight, 400);\n  line-height: var(--cds-body-02-line-height, 1.5);\n  letter-spacing: var(--cds-body-02-letter-spacing, 0);\n}\n.cds--card .cds--card__footer .cds--card__footer__copy,\n:host(c4d-card-footer) a .cds--card__footer__copy,\n:host(c4d-card-cta-footer) a .cds--card__footer__copy,\n:host(c4d-card-in-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-card-footer) a .cds--card__footer__copy,\n:host(c4d-feature-cta-footer) a .cds--card__footer__copy {\n  margin-block-end: -0.125rem;\n  max-inline-size: calc(100% - 20px);\n}\n.cds--card .cds--card__footer svg,\n.cds--card .cds--card__footer ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) a svg,\n:host(c4d-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) a svg,\n:host(c4d-card-cta-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-card-in-card-footer) a svg,\n:host(c4d-card-in-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-card-footer) a svg,\n:host(c4d-feature-card-footer) a ::slotted(svg[slot=icon]),\n:host(c4d-feature-cta-footer) a svg,\n:host(c4d-feature-cta-footer) a ::slotted(svg[slot=icon]) {\n  display: block;\n  margin-inline-start: 0;\n  min-inline-size: 20px;\n}\n\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n  inline-size: 100%;\n}\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled),\n:host(c4d-card-cta-footer)[color-scheme=inverse] .cds--link-with-icon.cds--link-with-icon--inline-icon:not(.cds--link--disabled) {\n  color: var(--cds-link-inverse, #78a9ff);\n}\n\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer {\n  justify-content: flex-start;\n  inline-size: auto;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:active, :host(c4d-card-footer):not([parent-href]) .cds--card__footer:hover {\n  text-decoration: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer::after {\n  content: none;\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__footer:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-card-footer):not([parent-href]) .cds--card__cta__copy {\n  margin-inline-end: 0.5rem;\n}\n\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile {\n  border-color: var(--cds-background-inverse, #393939);\n  background-color: var(--cds-background-inverse, #393939);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover .c4d-image::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-image)::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--tile:hover ::slotted(c4d-card-cta-image)::after {\n  display: none;\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__wrapper:hover {\n  background-color: var(--cds-background-inverse-hover, #474747);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__copy,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__heading,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__copy {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]) .cds--card__eyebrow {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n}\n:host(c4d-card)[color-scheme=inverse]:not([disabled]):focus-within::after,\n:host(c4d-card-group-item)[color-scheme=inverse]:not([disabled]):focus-within::after {\n  position: absolute;\n  z-index: 2;\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  content: \"\";\n  inset: 0;\n  outline: 1px solid var(--cds-focus-inset, #ffffff);\n  outline-offset: -3px;\n  pointer-events: none;\n}\n\n:host(c4d-card-heading),\n:host(c4d-card-link-heading) {\n  display: block;\n  inline-size: 90%;\n  max-inline-size: 40rem;\n  color: var(--cds-text-primary, #161616);\n  margin-block-end: 4rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-card-heading),\n  :host(c4d-card-link-heading) {\n    inline-size: calc(100% - 2rem);\n  }\n}\n\n:host(c4d-card-heading) {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n}\n\n:host(c4d-card-link-heading) {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  margin-block-end: 0;\n}\n\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-card-group-item)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-eyebrow),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-heading),\n:host(c4d-feature-section-card-link)[color-scheme=inverse] ::slotted(c4d-card-link-heading),\n.cds--card-group__card ::slotted(c4d-card-eyebrow),\n.cds--card-group__card ::slotted(c4d-card-heading),\n.cds--card-group__card ::slotted(c4d-card-link-heading) {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-card-group-item)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-image),\n:host(c4d-feature-section-card-link)[color-scheme=inverse]:hover ::slotted(c4d-card-cta-image),\n.cds--card-group__card:hover ::slotted(c4d-image),\n.cds--card-group__card:hover ::slotted(c4d-card-cta-image) {\n  filter: brightness(108%);\n}\n\n@media print {\n  :host(c4d-card),\n  :host(c4d-card-group-item),\n  :host(c4d-card-cta),\n  :host(c4d-card-in-card),\n  :host(c4d-content-group-cards-item) {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  :host(c4d-card) .cds--card,\n  :host(c4d-card-group-item) .cds--card,\n  :host(c4d-card-cta) .cds--card,\n  :host(c4d-card-in-card) .cds--card,\n  :host(c4d-content-group-cards-item) .cds--card {\n    border: none;\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-card) ::slotted(c4d-image),\n  :host(c4d-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card) .cds--image,\n  :host(c4d-card-group-item) ::slotted(c4d-image),\n  :host(c4d-card-group-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-group-item) .cds--image,\n  :host(c4d-card-cta) ::slotted(c4d-image),\n  :host(c4d-card-cta) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-cta) .cds--image,\n  :host(c4d-card-in-card) ::slotted(c4d-image),\n  :host(c4d-card-in-card) ::slotted(c4d-card-cta-image),\n  :host(c4d-card-in-card) .cds--image,\n  :host(c4d-content-group-cards-item) ::slotted(c4d-image),\n  :host(c4d-content-group-cards-item) ::slotted(c4d-card-cta-image),\n  :host(c4d-content-group-cards-item) .cds--image {\n    display: none;\n  }\n  .cds--card {\n    border: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    background-color: var(--cds-layer-02, #ffffff);\n  }\n  .cds--card .cds--card__img,\n  .cds--card .cds--card__image_img,\n  .cds--card .cds--image,\n  .cds--card .cds--card__video-thumbnail {\n    display: none;\n  }\n}\n:host(c4d-card[disabled]) .cds--card,\n:host(c4d-region-item[disabled]) .cds--card {\n  cursor: not-allowed;\n}\n:host(c4d-card[disabled]) .cds--card__copy,\n:host(c4d-card[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-card[disabled]) ::slotted(c4d-card-heading),\n:host(c4d-region-item[disabled]) .cds--card__copy,\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-eyebrow),\n:host(c4d-region-item[disabled]) ::slotted(c4d-card-heading) {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n:host(c4d-card-cta-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer[cta-type=video]) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  justify-content: space-between;\n}\n\n:host(c4d-card-footer[href])::after {\n  position: relative;\n}\n\n.cds--search {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n\n.cds--search .cds--label {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--search-input {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  order: 1;\n  padding: 0 2.5rem;\n  border: none;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  text-overflow: ellipsis;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search-input *,\n.cds--search-input *::before,\n.cds--search-input *::after {\n  box-sizing: inherit;\n}\n.cds--search-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--search-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--search-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--search-input::-ms-clear {\n  display: none;\n}\n\n.cds--search-input[disabled] {\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--search-input[disabled]::-moz-placeholder {\n  color: var(--cds-field);\n}\n.cds--search-input[disabled]::placeholder {\n  color: var(--cds-field);\n}\n\n.cds--search--light .cds--search-input {\n  background: var(--cds-field-02, #ffffff);\n}\n\n.cds--search--light .cds--search-close::before {\n  background: var(--cds-field-02, #ffffff);\n}\n\n.cds--search--sm .cds--search-input,\n.cds--search--sm.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 2rem;\n  block-size: 2rem;\n}\n\n.cds--search--sm .cds--search-magnifier-icon {\n  inset-inline-start: 0.5rem;\n}\n\n.cds--search--md .cds--search-input,\n.cds--search--md.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 2.5rem;\n  block-size: 2.5rem;\n}\n\n.cds--search--md .cds--search-magnifier-icon {\n  inset-inline-start: 0.75rem;\n}\n\n.cds--search--lg .cds--search-input,\n.cds--search--lg.cds--search--expandable.cds--search--expanded .cds--search-input {\n  padding: 0 3rem;\n  block-size: 3rem;\n}\n\n.cds--search-magnifier-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: absolute;\n  z-index: 2;\n  block-size: 1rem;\n  fill: var(--cds-icon-secondary, #525252);\n  inline-size: 1rem;\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n.cds--search-magnifier-icon *,\n.cds--search-magnifier-icon *::before,\n.cds--search-magnifier-icon *::after {\n  box-sizing: inherit;\n}\n\n.cds--search-close {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--search-close *,\n.cds--search-close *::before,\n.cds--search-close *::after {\n  box-sizing: inherit;\n}\n.cds--search-close::-moz-focus-inner {\n  border: 0;\n}\n.cds--search-close::before {\n  position: absolute;\n  display: block;\n  background-color: var(--cds-field);\n  block-size: calc(100% - 2px);\n  content: \"\";\n  inline-size: 2px;\n  inset-block-start: 0.0625rem;\n  inset-inline-start: 0;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--search-close::before {\n    transition: none;\n  }\n}\n.cds--search-close:hover {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n.cds--search-close:hover::before {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--search-button {\n  flex-shrink: 0;\n  background-color: var(--cds-field);\n  margin-inline-start: 0.125rem;\n}\n.cds--search-button svg {\n  fill: currentColor;\n  vertical-align: middle;\n}\n\n.cds--search-close svg {\n  fill: inherit;\n}\n\n.cds--search-close,\n.cds--search-button {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border-width: 1px 0;\n  border-style: solid;\n  border-color: transparent;\n  block-size: 2.5rem;\n  cursor: pointer;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 2.5rem;\n  opacity: 1;\n  transition: opacity 110ms cubic-bezier(0.2, 0, 0.38, 0.9), background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), border 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n.cds--search-close:hover,\n.cds--search-button:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--search-close:focus,\n.cds--search-button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-close:focus,\n  .cds--search-button:focus {\n    outline-style: dotted;\n  }\n}\n.cds--search-close:active,\n.cds--search-button:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n@media screen and (prefers-contrast) {\n  .cds--search-close:active,\n  .cds--search-button:active {\n    outline-style: dotted;\n  }\n}\n\n.cds--search--disabled .cds--search-close,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier {\n  cursor: not-allowed;\n  outline: none;\n}\n.cds--search--disabled .cds--search-close:hover,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover {\n  background-color: transparent;\n  border-block-end-color: transparent;\n}\n.cds--search--disabled .cds--search-close:hover::before,\n.cds--search--disabled.cds--search--expandable .cds--search-magnifier:hover::before {\n  background-color: transparent;\n}\n\n.cds--search--disabled svg {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n\n.cds--search-close:focus::before,\n.cds--search-close:active::before {\n  background-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--search-input:focus ~ .cds--search-close:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--search-input:focus ~ .cds--search-close:hover {\n    outline-style: dotted;\n  }\n}\n\n.cds--search--sm .cds--search-close,\n.cds--search--sm ~ .cds--search-button, .cds--search--sm.cds--search--expandable, .cds--search--sm.cds--search--expandable .cds--search-magnifier {\n  block-size: 2rem;\n  inline-size: 2rem;\n}\n.cds--search--sm.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 2rem;\n}\n.cds--search--sm.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 2rem;\n}\n\n.cds--search--md .cds--search-close,\n.cds--search--md ~ .cds--search-button, .cds--search--md.cds--search--expandable, .cds--search--md.cds--search--expandable .cds--search-magnifier {\n  block-size: 2.5rem;\n  inline-size: 2.5rem;\n}\n.cds--search--md.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 2.5rem;\n}\n.cds--search--md.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 2.5rem;\n}\n\n.cds--search--lg .cds--search-close,\n.cds--search--lg ~ .cds--search-button, .cds--search--lg.cds--search--expandable, .cds--search--lg.cds--search--expandable .cds--search-magnifier {\n  block-size: 3rem;\n  inline-size: 3rem;\n}\n.cds--search--lg.cds--search--expandable .cds--search-input::-moz-placeholder {\n  padding: 0 3rem;\n}\n.cds--search--lg.cds--search--expandable .cds--search-input::placeholder {\n  padding: 0 3rem;\n}\n\n.cds--search-close--hidden {\n  opacity: 0;\n  visibility: hidden;\n}\n\n.cds--search--lg.cds--skeleton .cds--search-input,\n.cds--search--md.cds--skeleton .cds--search-input,\n.cds--search--sm.cds--skeleton .cds--search-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 100%;\n}\n.cds--search--lg.cds--skeleton .cds--search-input:hover, .cds--search--lg.cds--skeleton .cds--search-input:focus, .cds--search--lg.cds--skeleton .cds--search-input:active,\n.cds--search--md.cds--skeleton .cds--search-input:hover,\n.cds--search--md.cds--skeleton .cds--search-input:focus,\n.cds--search--md.cds--skeleton .cds--search-input:active,\n.cds--search--sm.cds--skeleton .cds--search-input:hover,\n.cds--search--sm.cds--skeleton .cds--search-input:focus,\n.cds--search--sm.cds--skeleton .cds--search-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--search--lg.cds--skeleton .cds--search-input::before,\n.cds--search--md.cds--skeleton .cds--search-input::before,\n.cds--search--sm.cds--skeleton .cds--search-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--search--lg.cds--skeleton .cds--search-input::before,\n  .cds--search--md.cds--skeleton .cds--search-input::before,\n  .cds--search--sm.cds--skeleton .cds--search-input::before {\n    animation: none;\n  }\n}\n.cds--search--lg.cds--skeleton .cds--search-input::-moz-placeholder, .cds--search--md.cds--skeleton .cds--search-input::-moz-placeholder, .cds--search--sm.cds--skeleton .cds--search-input::-moz-placeholder {\n  color: transparent;\n}\n.cds--search--lg.cds--skeleton .cds--search-input::placeholder,\n.cds--search--md.cds--skeleton .cds--search-input::placeholder,\n.cds--search--sm.cds--skeleton .cds--search-input::placeholder {\n  color: transparent;\n}\n\n.cds--search--expandable {\n  transition: width 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--search--expandable.cds--search--expanded {\n  inline-size: 100%;\n}\n\n.cds--search--expandable .cds--search-input {\n  padding: 0;\n  inline-size: 0;\n  transition: padding 70ms cubic-bezier(0.2, 0, 0.38, 0.9), width 0s linear 70ms;\n}\n.cds--search--expandable .cds--search-input::-moz-placeholder {\n  position: relative;\n  opacity: 0;\n  transition-duration: 70ms;\n  -moz-transition-property: padding, opacity;\n  transition-property: padding, opacity;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search--expandable .cds--search-input::placeholder {\n  position: relative;\n  opacity: 0;\n  transition-duration: 70ms;\n  transition-property: padding, opacity;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-input {\n  inline-size: 100%;\n  transition: padding 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--search--expandable.cds--search--expanded .cds--search-input::-moz-placeholder {\n  position: relative;\n  padding: 0;\n  opacity: 1;\n}\n.cds--search--expandable.cds--search--expanded .cds--search-input::placeholder {\n  position: relative;\n  padding: 0;\n  opacity: 1;\n}\n\n.cds--search--expandable .cds--search-magnifier {\n  position: absolute;\n  cursor: pointer;\n}\n.cds--search--expandable .cds--search-magnifier:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--search--expandable .cds--search-magnifier:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-magnifier {\n  pointer-events: none;\n}\n\n.cds--search--expandable .cds--search-magnifier-icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--search--expandable.cds--search--expanded .cds--search-magnifier-icon {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--search--expandable.cds--search--disabled svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--search-close svg,\n  .cds--search-magnifier-icon {\n    fill: ButtonText;\n  }\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-locale-modal) {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-locale-modal) .cds--modal-container {\n  padding: 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: calc(100% - 2rem);\n  min-block-size: 80%;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-locale-modal) .cds--modal-container {\n    inline-size: -moz-fit-content;\n    inline-size: fit-content;\n  }\n}\n:host(c4d-locale-modal) .cds--modal-container .cds--modal-content {\n  display: grid;\n  padding: 0;\n  margin: 0;\n  grid-template-rows: auto 1fr auto;\n}\n@media (max-height: 28.125rem) {\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__filtering .c4d--locale-modal__filter {\n    overflow-y: initial;\n  }\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__filtering .c4d--locale-modal__filter .c4d--locale-modal__list {\n    overflow-y: initial;\n  }\n  :host(c4d-locale-modal) .cds--modal-container .c4d--locale-modal__search {\n    position: relative;\n  }\n}\n:host(c4d-locale-modal) .c4d--locale-modal {\n  display: flex;\n  margin-block: 2rem 0;\n  padding-inline-start: 1rem;\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-modal) .c4d--locale-modal.cds--modal-content {\n  margin-block-start: 2rem;\n  padding-block-start: 0.5rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-modal) .c4d--locale-modal.cds--modal-content {\n    margin-block-start: auto;\n  }\n}\n:host(c4d-locale-modal) .c4d--locale-modal__locales.c4d--locale-modal__locales-hidden {\n  display: none;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label {\n  display: inline-flex;\n  padding: 0;\n  border: none;\n  background-color: transparent;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label:hover,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label:hover {\n  color: var(--cds-background-brand, #0f62fe);\n  cursor: pointer;\n  text-decoration: underline;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label:focus,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label:focus {\n  outline-color: var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n:host(c4d-locale-modal) button.cds--modal-header__label svg,\n:host(c4d-locale-modal) .c4d--locale-modal__back .cds--modal-header__label svg {\n  fill: currentColor;\n}\n:host(c4d-locale-modal) .c4d--locale-modal__filter {\n  z-index: -1;\n  display: none;\n  inset-block-start: 3rem;\n  opacity: 0;\n  transform: translate3d(0, -24px, 0);\n  transition: transform 240ms cubic-bezier(0.4, 0.14, 1, 1);\n}\n:host(c4d-locale-modal) .cds--modal-header {\n  padding-block-start: 1rem;\n  padding-inline-start: 2rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__label {\n  display: flex;\n  align-items: center;\n  color: var(--cds-text-primary, #161616);\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-modal) .cds--modal-header__label .c4d--locale-modal__label-globe {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__label .c4d--locale-modal__label-arrow {\n  margin-inline-end: 0.5rem;\n}\n:host(c4d-locale-modal) .cds--modal-header__heading {\n  font-size: 1.75rem;\n  font-weight: 400;\n  line-height: 1.28572;\n  letter-spacing: 0;\n  font-size: calc(1.75rem + 0.25 * (100vw - 20rem) / 62);\n  padding: 0;\n  margin-block-start: 0.75rem;\n}\n@media (min-width: 82rem) {\n  :host(c4d-locale-modal) .cds--modal-header__heading {\n    font-size: 2rem;\n    line-height: 1.25;\n    font-weight: 400;\n    font-size: calc(2rem + 0 * (100vw - 82rem) / 17);\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-locale-modal) .cds--modal-header__heading {\n    font-size: 2rem;\n    font-weight: 400;\n    font-size: 2rem;\n  }\n}\n:host(c4d-locale-modal) .cds--modal-header__heading:focus {\n  outline: none;\n}\n:host(c4d-locale-modal) c4d-expressive-modal-header {\n  padding: 3px 20% 0 1rem;\n  margin-block-end: 0.5rem;\n}\n\n:host(c4d-locale-modal[open]) {\n  opacity: 1;\n  transition: opacity 240ms cubic-bezier(0, 0, 0.3, 1), visibility 0ms linear;\n  visibility: inherit;\n}\n:host(c4d-locale-modal[open]) .cds--modal-container {\n  transform: translate3d(0, 0, 0);\n  transition: transform 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-locale-modal[open]) {\n    transition: none;\n  }\n}\n\n.c4d--locale-modal-container .c4d--locale-modal__regions {\n  inline-size: 100%;\n  margin-block-start: auto;\n}\n.c4d--locale-modal-container .c4d--locale-modal__regions > .cds--row {\n  margin-inline: 0;\n}\n\n:host(c4d-region-item) .cds--link {\n  display: flex;\n  align-items: stretch;\n  block-size: 100%;\n  inline-size: 100%;\n  max-inline-size: none;\n  outline: 1px solid var(--cds-layer-02, #ffffff);\n  outline-offset: -1px;\n  text-align: inherit;\n}\n:host(c4d-region-item) .cds--link:hover.cds--link--disabled {\n  display: flex;\n}\n:host(c4d-region-item) .cds--link:focus-within {\n  outline-color: var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-region-item) .cds--link {\n    min-block-size: 6rem;\n  }\n}\n\n:host(c4d-region-item) .cds--card.cds--tile {\n  border-block-end: transparent;\n}\n\n:host(c4d-region-item:last-of-type) .cds--card.cds--tile {\n  border-block-end: 1px solid var(--cds-border-tile);\n}\n\n@media (min-width: 66rem) {\n  :host(c4d-region-item) .cds--card.cds--tile {\n    border-block-end: 1px solid var(--cds-border-tile);\n  }\n  :host(c4d-region-item:first-of-type) .cds--card.cds--tile {\n    border-inline-end: transparent;\n  }\n  :host(c4d-region-item:nth-of-type(3)) .cds--card.cds--tile {\n    border-block-start: transparent;\n    border-inline-end: transparent;\n  }\n  :host(c4d-region-item:last-of-type) .cds--card.cds--tile {\n    border-block-start: transparent;\n  }\n}\n:host(c4d-region-item) svg.cds--card__cta,\n.cds--modal-container svg.cds--card__cta {\n  color: var(--cds-border-inverse, #161616);\n}\n\n:host(c4d-regions) {\n  display: flex;\n  flex-wrap: wrap;\n}\n\n:host(c4d-locale-item) a.cds--link {\n  display: flex;\n  border: 0.125rem solid transparent;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  min-block-size: 3rem;\n  text-decoration: none;\n  transition: background-color 110ms cubic-bezier(0.4, 0.14, 0.3, 1), border 110ms cubic-bezier(0.4, 0.14, 0.3, 1);\n}\n:host(c4d-locale-item) a.cds--link:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-locale-item) a.cds--link:active, :host(c4d-locale-item) a.cds--link:focus {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n:host(c4d-locale-item) .c4d--locale-modal__locales__name {\n  padding: 0.75rem 1rem;\n  color: var(--cds-text-helper, #6f6f6f);\n  inline-size: 50%;\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n:host(c4d-locale-item) .c4d--locale-modal__locales__name:first-of-type {\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-locale-search) {\n  display: flex;\n  overflow: hidden;\n  flex-direction: column;\n  margin-block-start: 2rem;\n  padding-block-start: 0.5rem;\n}\n:host(c4d-locale-search) cds-search::part(input)::-moz-placeholder {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-locale-search) cds-search::part(input)::placeholder {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-locale-search) .c4d--locale-modal__filter {\n  z-index: 1;\n  display: flex;\n  overflow: hidden;\n  flex: 1;\n  flex-direction: column;\n  opacity: 1;\n  transform: translate3d(0, 0, 0);\n  transition: 240ms cubic-bezier(0, 0, 0.3, 1);\n}\n:host(c4d-locale-search) .c4d--locale-modal__regions {\n  z-index: -1;\n  display: none;\n  opacity: 0;\n  transition: 240ms cubic-bezier(0, 0, 0.3, 1);\n  visibility: hidden;\n}\n:host(c4d-locale-search) .c4d--locale-modal__search {\n  position: sticky;\n  background-color: var(--cds-background, #ffffff);\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  inset-block-start: 0;\n}\n:host(c4d-locale-search) .c4d--locale-modal__search-text {\n  padding: 2rem 1rem 1rem;\n  margin: 0;\n  font-size: var(--cds-label-02-font-size, 0.875rem);\n  font-weight: var(--cds-label-02-font-weight, 400);\n  line-height: var(--cds-label-02-line-height, 1.28572);\n  letter-spacing: var(--cds-label-02-letter-spacing, 0.16px);\n}\n:host(c4d-locale-search) .c4d--locale-modal__list {\n  flex: 1;\n  overflow-y: auto;\n}\n\n:host(c4d-locale-modal) c4d-expressive-modal-heading {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-region-item) {\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-region-item) {\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n  }\n}\n:host(c4d-region-item) .cds--card__wrapper {\n  block-size: 100%;\n}\n:host(c4d-region-item) ::slotted(div.c4d--region-item-footer) {\n  display: flex;\n  justify-content: flex-end;\n  color: var(--cds-border-inverse, #161616);\n  inline-size: 100%;\n  /* stylelint-disable declaration-no-important */\n  margin-block-start: auto !important;\n}\n:host(c4d-region-item) ::slotted(div.c4d--region-item-footer[disabled]) {\n  color: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-footer) {\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  padding-block: 3rem;\n  padding-block-start: 3rem;\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-footer) .cds--modal-content .cds--link, :host(c4d-footer) .cds--modal-content .cds--link:visited {\n  color: var(--cds-icon-inverse, #ffffff);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer) ::slotted([slot=brand]) {\n    margin-block-end: 3rem;\n  }\n}\n\n:host(c4d-footer[size=short]) .cds--footer__logo-container {\n  inline-size: 100%;\n}\n:host(c4d-footer[size=short]) .cds--language-selector__container {\n  margin-block-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=short]) .cds--language-selector__container {\n    margin-block-start: 0;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-footer[size=short]) .cds--language-selector__container {\n    margin-inline-start: 62.5%;\n  }\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer[size=short]) ::slotted([slot=brand]) {\n    margin-block-end: 0;\n  }\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=micro]) {\n    padding-block: 0;\n  }\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer[size=micro]) ::slotted([slot=locale-button]) {\n    margin-block-start: 0;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=micro]) .cds--footer__logo-container {\n    display: none;\n  }\n}\n:host(c4d-footer[size=micro]) .cds--language-selector__container {\n  padding: 0;\n}\n:host(c4d-footer[size=micro]) .cds--locale-btn__container {\n  flex-basis: auto;\n}\n:host(c4d-footer[size=micro]) .cds--locale-btn__container button {\n  border: none;\n}\n:host(c4d-footer[size=micro]) .cds--legal-nav {\n  border-block-start: 0;\n}\n\n:host(c4d-footer-nav-item),\n:host(c4d-legal-nav-item),\n:host(c4d-legal-nav-cookie-preferences-placeholder) {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: list-item;\n  outline: none;\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link, :host(c4d-footer-nav-item) .cds--footer__link.cds--link:visited,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:visited,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:visited {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link:focus,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:focus,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:focus {\n  outline-color: var(--cds-focus, #0f62fe);\n  outline-offset: -1px;\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link:active,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:active,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-footer-nav-item) .cds--footer__link.cds--link:hover, :host(c4d-footer-nav-item) .cds--footer__link.cds--link:visited:hover,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:hover,\n:host(c4d-legal-nav-item) .cds--footer__link.cds--link:visited:hover,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:hover,\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link:visited:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n:host(c4d-legal-nav-cookie-preferences-placeholder) .cds--footer__link.cds--link {\n  cursor: pointer;\n}\n\n:host(c4d-legal-nav) {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n:host(c4d-legal-nav) .cds--legal-nav__list .cds--legal-nav__list-item .cds--link {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-legal-nav) .cds--legal-nav__list .cds--legal-nav__list-item .cds--link:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--footer__main {\n  box-sizing: border-box;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n}\n@media (min-width: 42rem) {\n  .cds--footer__main {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--footer__main {\n    padding-inline: 2.5rem;\n  }\n}\n\n.cds--footer__main-container {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n  flex-direction: column;\n}\n:host(c4d-footer[size=short]) .cds--footer__main-container, .cds--footer--short .cds--footer__main-container {\n  flex-direction: row;\n}\n@media (min-width: 66rem) {\n  .cds--footer__main-container {\n    flex-direction: row;\n  }\n}\n\n.cds--footer__logo-container {\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n  margin-inline: 0;\n}\n@media (min-width: 42rem) {\n  .cds--footer__logo-container {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--footer__logo-container {\n    padding-inline: 2.5rem;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--footer__logo-container {\n    margin-block-end: 0;\n    padding-inline: 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--footer__logo-container {\n    inline-size: 100%;\n    margin-inline: auto;\n  }\n}\n.cds--footer__logo-container .cds--footer__logo-row {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n  justify-content: space-between;\n}\n\n@media print {\n  :host(c4d-footer),\n  .cds--footer {\n    /* stylelint-disable declaration-no-important */\n    display: none !important;\n    /* stylelint-enable declaration-no-important */\n  }\n}\n:host(c4d-footer),\n:host(c4d-legal-nav) {\n  display: block;\n}\n:host(c4d-footer) .c4d--adjunct-links__container,\n:host(c4d-legal-nav) .c4d--adjunct-links__container {\n  list-style: none;\n  margin-block-start: 2rem;\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-footer) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav) .c4d--adjunct-links__container {\n    margin-inline: auto;\n    max-inline-size: 99rem;\n    padding-inline: 1rem;\n  }\n}\n@media (max-width: 41.98rem) and (min-width: 42rem) {\n  :host(c4d-footer) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav) .c4d--adjunct-links__container {\n    padding-inline: 2rem;\n  }\n}\n@media (max-width: 41.98rem) and (min-width: 99rem) {\n  :host(c4d-footer) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav) .c4d--adjunct-links__container {\n    padding-inline: 2.5rem;\n  }\n}\n:host(c4d-footer) .c4d--adjunct-links__container--hidden,\n:host(c4d-legal-nav) .c4d--adjunct-links__container--hidden {\n  display: none;\n}\n\n:host(c4d-footer-nav-group[open]) .cds--accordion__content {\n  display: block;\n  padding-block-start: 0;\n}\n\n:host(c4d-footer-nav-group) .cds--accordion__heading {\n  align-items: center;\n  padding: 0;\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  min-block-size: 3rem;\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-footer-nav-group:last-of-type) {\n    border-block-end: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  }\n}\n\n:host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container,\n:host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list {\n  padding-block: 0;\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list {\n    padding-block-start: 0.5rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list {\n    margin-inline-start: 25%;\n  }\n}\n:host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container > ul,\n:host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list > ul {\n  inline-size: 100%;\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container > ul,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list > ul {\n    display: block;\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 2rem;\n         column-gap: 2rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav):not([size=micro]) .c4d--adjunct-links__container > ul,\n  :host(c4d-legal-nav):not([size=micro]) .c4d--legal-nav__list > ul {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav[size=micro]) ::slotted(c4d-legal-nav-item),\n  :host(c4d-legal-nav[size=micro]) ::slotted(c4d-legal-nav-cookie-preferences-placeholder) {\n    display: flex;\n    align-items: center;\n    padding: 0;\n    min-block-size: 3rem;\n  }\n}\n:host(c4d-legal-nav[size=micro]) .c4d--adjunct-links__container {\n  display: none;\n}\n:host(c4d-legal-nav[size=micro]) .c4d--legal-nav {\n  display: block;\n  border-block-start: 0;\n}\n:host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list {\n  inline-size: 100%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div {\n    display: flex;\n  }\n}\n:host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n  padding: 0 1rem;\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n    padding-block-start: 0.5rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n    display: flex;\n    -moz-column-count: inherit;\n         column-count: inherit;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-legal-nav[size=micro]) .c4d--legal-nav__list div > ul {\n    padding: 0 1rem 0 2rem;\n    border-block-start: none;\n  }\n}\n\n@media (min-width: 42rem) {\n  :host(c4d-locale-button[size=micro]) {\n    flex-shrink: 1;\n    padding: 0;\n    margin: 0;\n    margin-inline-start: 50%;\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary {\n    border: none;\n    margin: 0;\n    background-color: var(--cds-background, #ffffff);\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  }\n}\n@media (min-width: 42rem) and (min-width: 42rem) {\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary {\n    align-self: flex-end;\n    border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  }\n}\n@media (min-width: 42rem) and (min-width: 66rem) {\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary {\n    margin: 0 -1rem 0 0;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary:hover, :host(c4d-locale-button[size=micro]) .cds--btn--tertiary:focus {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--btn--tertiary,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input {\n    background-color: var(--cds-background, #ffffff);\n    max-inline-size: 100%;\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--btn--tertiary:hover,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box:hover,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--btn--tertiary:active,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box:active,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select {\n    max-inline-size: 100%;\n  }\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--text-input,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--list-box,\n  :host(c4d-locale-button[size=micro]) .cds--btn--tertiary .cds--select-input {\n    border-block-end: none;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-button[size=micro]) {\n    margin-inline-start: 0;\n  }\n}\n:host(c4d-locale-button[size=micro]) .cds--btn {\n  padding-block: 0.75rem;\n}\n:host(c4d-locale-button[size=micro]) .cds--locale-btn {\n  max-inline-size: 100%;\n}\n\n:host(c4d-language-selector-desktop),\n:host(c4d-language-selector-mobile) {\n  position: relative;\n  padding: 0 1rem;\n  margin-block: 3rem;\n  max-block-size: 3rem;\n  outline: none;\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n}\n:host(c4d-language-selector-desktop) .cds--list-box__field,\n:host(c4d-language-selector-mobile) .cds--list-box__field {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-language-selector-desktop) .cds--combo-box,\n:host(c4d-language-selector-mobile) .cds--combo-box {\n  inset-block-end: 1rem;\n}\n:host(c4d-language-selector-desktop) .cds--list-box__menu,\n:host(c4d-language-selector-mobile) .cds--list-box__menu {\n  position: absolute;\n  inset-block: auto 47px;\n  max-block-size: 13.5rem;\n}\n:host(c4d-language-selector-desktop) .cds--text-input,\n:host(c4d-language-selector-mobile) .cds--text-input {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n}\n@media (min-width: 42rem) {\n  :host(c4d-language-selector-desktop),\n  :host(c4d-language-selector-mobile) {\n    padding: 0;\n    margin-block-start: 0;\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-inline-start: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-language-selector-desktop),\n  :host(c4d-language-selector-mobile) {\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: 62.5%;\n    order: 1;\n    min-inline-size: 13.5rem;\n  }\n}\n\n:host(c4d-language-selector-desktop) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n:host(c4d-language-selector-desktop) .cds--list-box__selection {\n  inset-inline-end: 2.25rem;\n}\n:host(c4d-language-selector-desktop) .cds--label-visually-hidden {\n  block-size: 0;\n  visibility: hidden;\n}\n\n:host(c4d-language-selector-desktop[size=micro]) {\n  align-self: flex-end;\n  padding: 0;\n  margin: 0;\n  border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  inline-size: 100%;\n  margin-block-end: 0;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown {\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown .cds--list-box__field {\n  background-color: var(--cds-background, #ffffff);\n  block-size: inherit;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--dropdown,\n:host(c4d-language-selector-desktop[size=micro]) .cds--text-input {\n  border-block-end: none;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--select-input__wrapper {\n  block-size: 100%;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--select-input {\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  border-block-end: none;\n}\n:host(c4d-language-selector-desktop[size=micro]) .cds--select-input:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n@media (min-width: 42rem) {\n  :host(c4d-language-selector-desktop[size=micro]) {\n    border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n    max-inline-size: 50%;\n  }\n}\n\n:host(c4d-language-selector-mobile[size=micro]) {\n  align-self: flex-end;\n  border-inline-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n  inline-size: 100%;\n  margin-block-start: 0;\n}\n:host(c4d-language-selector-mobile[size=micro]) .cds--select {\n  display: block;\n}\n:host(c4d-language-selector-mobile[size=micro]) .cds--select-input {\n  block-size: 100%;\n  inline-size: 100%;\n  max-inline-size: 100%;\n}\n:host(c4d-language-selector-mobile[size=micro]) .cds--select-input:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n@media (min-width: 42rem) {\n  :host(c4d-language-selector-mobile[size=micro]) {\n    padding: 0;\n    margin: 0;\n    max-inline-size: 50%;\n  }\n  :host(c4d-language-selector-mobile[size=micro]) .cds--select-input {\n    background-color: var(--cds-background, #ffffff);\n    border-block-end: none;\n  }\n}\n\n:host(c4d-language-selector-mobile) .cds--select-input__wrapper {\n  block-size: 3rem;\n  margin-block-start: -1rem;\n}\n\n:host(c4d-footer-logo),\n.cds--footer-logo {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: block;\n  flex: 0 0 50%;\n  max-inline-size: 50%;\n}\n:host(c4d-footer-logo):focus-visible,\n.cds--footer-logo:focus-visible {\n  outline: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-logo),\n  .cds--footer-logo {\n    margin-block-end: 3rem;\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-logo),\n  .cds--footer-logo {\n    display: block;\n    flex: 0 0 12.5%;\n    max-inline-size: 12.5%;\n  }\n}\n\n.c4d--footer-logo__link {\n  display: inline-block;\n  color: var(--cds-text-on-color, #ffffff);\n  inline-size: auto;\n  padding-inline-start: 1rem;\n  inline-size: 100%;\n  padding-inline: 1rem;\n}\n.cds--row--condensed .c4d--footer-logo__link, .cds--grid--condensed .c4d--footer-logo__link {\n  padding-inline: 0.03125rem;\n}\n.cds--row--narrow .c4d--footer-logo__link, .cds--grid--narrow .c4d--footer-logo__link {\n  padding-inline: 0 1rem;\n}\n.c4d--footer-logo__link:focus {\n  box-shadow: inset 0 0 0 0.125rem var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.c4d--footer-logo__logo {\n  display: inline-block;\n  fill: currentColor;\n  inline-size: 128px;\n}\n\n:host(c4d-footer-logo[size=micro]) {\n  position: relative;\n  align-self: center;\n  margin: 0;\n}\n:host(c4d-footer-logo[size=micro]) .c4d--footer-logo__link {\n  position: absolute;\n  inset-block-start: -2.21875rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-logo[size=micro]) .c4d--footer-logo__link {\n    position: relative;\n    inset-block-start: 0;\n  }\n}\n\n@media (min-width: 42rem) and (max-width: 66rem) {\n  :host(c4d-footer-logo[size=micro][disable-locale-button]) {\n    background-color: var(--cds-background, #ffffff);\n    block-size: 3rem;\n    inline-size: 100%;\n  }\n  :host(c4d-footer-logo[size=micro][disable-locale-button]) .c4d--footer-logo__link {\n    inset-block-start: 0.78125rem;\n  }\n}\n:host(c4d-footer-nav) {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  inline-size: 100%;\n  padding-inline: 1rem;\n  order: 1;\n  padding: 0;\n}\n:host(c4d-footer-nav) .cds--accordion {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion *,\n:host(c4d-footer-nav) .cds--accordion *::before,\n:host(c4d-footer-nav) .cds--accordion *::after {\n  box-sizing: inherit;\n}\n:host(c4d-footer-nav) .cds--accordion {\n  inline-size: 100%;\n  list-style: none;\n}\n:host(c4d-footer-nav) .cds--accordion__item {\n  display: list-item;\n  overflow: visible;\n  border-block-start: 1px solid var(--cds-border-subtle);\n  transition: border-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n:host(c4d-footer-nav) .cds--accordion__item:last-child {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n:host(c4d-footer-nav) .cds--accordion__item:not(.cds--accordion__item--active):hover, :host(c4d-footer-nav) .cds--accordion__item:not(.cds--accordion__item--active):hover + .cds--accordion__item {\n  border-block-start-color: var(--cds-layer-hover);\n}\n:host(c4d-footer-nav) .cds--accordion__item:not(.cds--accordion__item--active):last-child:hover {\n  border-block-end-color: var(--cds-layer-hover);\n}\n:host(c4d-footer-nav) .cds--accordion__heading {\n  transition: background-color cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion__heading *,\n:host(c4d-footer-nav) .cds--accordion__heading *::before,\n:host(c4d-footer-nav) .cds--accordion__heading *::after {\n  box-sizing: inherit;\n}\n:host(c4d-footer-nav) .cds--accordion__heading::-moz-focus-inner {\n  border: 0;\n}\n:host(c4d-footer-nav) .cds--accordion__heading {\n  position: relative;\n  display: flex;\n  flex-direction: row-reverse;\n  align-items: center;\n  justify-content: flex-start;\n  margin: 0;\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  min-block-size: var(--cds-layout-size-height-local);\n  padding-inline-end: var(--cds-layout-density-padding-inline-local);\n}\n:host(c4d-footer-nav) .cds--accordion__heading:hover {\n  background-color: var(--cds-layer-hover);\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion__heading:focus {\n  position: relative;\n  z-index: 2;\n  box-shadow: 0 -1px 0 0 var(--cds-focus, #0f62fe), inset 0 1px 0 0 var(--cds-focus, #0f62fe), inset 2px 0 0 0 var(--cds-focus, #0f62fe), 0 1px 0 0 var(--cds-focus, #0f62fe), inset 0 -1px 0 0 var(--cds-focus, #0f62fe), inset -2px 0 0 0 var(--cds-focus, #0f62fe);\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion__heading[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n:host(c4d-footer-nav) .cds--accordion__heading[disabled] .cds--accordion__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n:host(c4d-footer-nav) .cds--accordion__heading[disabled]:hover::before {\n  background-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion__item--disabled,\n:host(c4d-footer-nav) .cds--accordion__item--disabled + .cds--accordion__item {\n  border-block-start: 1px solid var(--cds-border-subtle);\n}\n:host(c4d-footer-nav) li.cds--accordion__item--disabled:last-of-type {\n  border-block-end: 1px solid var(--cds-border-subtle);\n}\n:host(c4d-footer-nav) .cds--accordion__arrow {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  transition: all 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion__arrow {\n  flex: 0 0 1rem;\n  block-size: 1rem;\n  fill: var(--cds-icon-primary, #161616);\n  inline-size: 1rem;\n  transform: rotate(-270deg) /*rtl:ignore*/;\n}\n:host(c4d-footer-nav) .cds--accordion__title {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  /* stylelint-disable-next-line scss/selector-no-redundant-nesting-selector, no-duplicate-selectors */\n}\n:host(c4d-footer-nav) .cds--accordion__title {\n  z-index: 1;\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n  text-align: start;\n}\n:host(c4d-footer-nav) .cds--accordion__wrapper {\n  overflow: hidden;\n  padding: 0;\n  max-block-size: 0;\n  opacity: 0;\n  transition: all 110ms cubic-bezier(0, 0, 0.38, 0.9);\n  writing-mode: horizontal-tb;\n}\n:host(c4d-footer-nav) .cds--accordion__content {\n  padding-inline: var(--cds-layout-density-padding-inline-local);\n}\n@media (min-width: 480px) {\n  :host(c4d-footer-nav) .cds--accordion__content {\n    padding-inline-end: 3rem;\n  }\n}\n@media (min-width: 640px) {\n  :host(c4d-footer-nav) .cds--accordion__content {\n    padding-inline-end: 25%;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion__content > p {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__heading {\n  flex-direction: row;\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__arrow {\n  margin: 2px 0 0 var(--cds-layout-density-padding-inline-local);\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 1rem;\n}\n:host(c4d-footer-nav) .cds--accordion--start .cds--accordion__content {\n  margin-inline-start: calc(var(--cds-layout-density-padding-inline-local) + 1rem);\n}\n:host(c4d-footer-nav) .cds--accordion__item--collapsing .cds--accordion__content,\n:host(c4d-footer-nav) .cds--accordion__item--expanding .cds--accordion__content {\n  display: block;\n}\n:host(c4d-footer-nav) .cds--accordion__item--active, :host(c4d-footer-nav) :host(c4d-footer-nav-group[open]) {\n  overflow: visible;\n}\n:host(c4d-footer-nav) .cds--accordion__item--active > .cds--accordion__wrapper, :host(c4d-footer-nav) :host(c4d-footer-nav-group[open]) > .cds--accordion__wrapper {\n  overflow: visible;\n  max-block-size: -moz-fit-content;\n  max-block-size: fit-content;\n  opacity: 1;\n  padding-block: 0.5rem;\n  padding-block-end: 1.5rem;\n}\n:host(c4d-footer-nav) .cds--accordion__item--active > .cds--accordion__heading > .cds--accordion__arrow, :host(c4d-footer-nav) :host(c4d-footer-nav-group[open]) > .cds--accordion__heading > .cds--accordion__arrow {\n  fill: var(--cds-icon-primary, #161616);\n  transform: rotate(-90deg) /*rtl:ignore*/;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item {\n  position: relative;\n  border-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:last-child, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:hover, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:last-child:hover, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:hover + .cds--accordion__item {\n  border-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::after {\n  position: absolute;\n  display: block;\n  block-size: 1px;\n  content: \"\";\n  inline-size: calc(100% - 1rem - 1rem);\n  margin-inline-start: 1rem;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::after {\n    transition: none;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item::before {\n  background: var(--cds-border-subtle);\n  inset-block-start: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__item:last-child::after {\n  background: var(--cds-border-subtle);\n  inset-block-end: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover {\n  position: relative;\n  z-index: 1;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::after {\n  position: absolute;\n  display: block;\n  background: var(--cds-layer-hover);\n  block-size: 1px;\n  content: \"\";\n  inline-size: 100%;\n  inset-inline-start: 0;\n  transition: background cubic-bezier(0.2, 0, 0.38, 0.9) 110ms;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::before, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::after {\n    transition: none;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::before {\n  inset-block-start: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover::after {\n  inset-block-end: -1px;\n}\n:host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover:focus::after, :host(c4d-footer-nav) .cds--accordion--flush .cds--accordion__heading:hover:focus::before {\n  background: none;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__heading,\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__button {\n  cursor: default;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow {\n  cursor: default;\n  fill: var(--cds-icon-primary, #161616);\n  pointer-events: none;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow:hover, :host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow:focus, :host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__arrow:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__heading:hover::before,\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__heading:hover {\n  background-color: transparent;\n}\n:host(c4d-footer-nav) .cds--accordion--end.cds--skeleton .cds--accordion__arrow {\n  margin-inline-start: 1rem;\n}\n:host(c4d-footer-nav) .cds--skeleton .cds--accordion__heading:focus .cds--accordion__arrow {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n:host(c4d-footer-nav) .cds--accordion__title.cds--skeleton__text {\n  margin-block-end: 0;\n}\n:host(c4d-footer-nav) .cds--accordion.cds--skeleton .cds--accordion__title {\n  margin-inline-start: 1rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  :host(c4d-footer-nav) .cds--accordion__arrow,\n  :host(c4d-footer-nav) .cds--accordion__item--active .cds--accordion__arrow {\n    fill: ButtonText;\n  }\n}\n:host(c4d-footer-nav) [dir=rtl] .cds--accordion--start .cds--accordion__heading {\n  padding-inline-end: 0;\n  padding-inline-start: var(--cds-layout-density-padding-inline-local);\n}\n:host(c4d-footer-nav) [dir=rtl] .cds--accordion--start .cds--accordion__title {\n  margin-inline-end: 0;\n  padding-inline-start: 0;\n}\n.cds--row--condensed :host(c4d-footer-nav), .cds--grid--condensed :host(c4d-footer-nav) {\n  padding-inline: 0.03125rem;\n}\n.cds--row--narrow :host(c4d-footer-nav), .cds--grid--narrow :host(c4d-footer-nav) {\n  padding-inline: 0 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-nav) {\n    padding: 0 1rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-nav) {\n    display: block;\n    flex: 0 0 75%;\n    max-inline-size: 75%;\n  }\n}\n:host(c4d-footer-nav) .cds--accordion__heading {\n  display: flex;\n  align-items: center;\n  padding: 0;\n  min-block-size: 3rem;\n}\n:host(c4d-footer-nav) ::slotted([slot=locale-button]),\n:host(c4d-footer-nav) ::slotted([slot=language-selector]) {\n  display: inline-block;\n  inline-size: 100%;\n  margin-inline-start: 0;\n  max-inline-size: 100%;\n}\n\n:host(c4d-footer-nav[disable-locale-button]),\nnav.cds--footer-nav__locale-button--disabled {\n  border-block-start: none;\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer-nav[disable-locale-button]),\n  nav.cds--footer-nav__locale-button--disabled {\n    padding-block-start: 0;\n    margin-inline-start: 12.5%;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--footer-nav__container {\n    display: flex;\n    flex-wrap: wrap;\n    margin-inline: -1rem;\n    display: block;\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 2rem;\n         column-gap: 2rem;\n    margin-inline: 0;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--footer-nav__container {\n    -moz-column-count: 3;\n         column-count: 3;\n    -moz-column-gap: 2rem;\n         column-gap: 2rem;\n  }\n}\n\n:host(c4d-footer[size=short]) ::slotted(c4d-footer-nav),\n.cds--footer--short .cds--footer-nav {\n  display: none;\n}\n\n:host(c4d-footer-nav-group),\n.cds--footer-nav-group,\n.cds--footer-nav-group.cds--accordion__item {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: block;\n  padding-inline-start: 0;\n}\n:host(c4d-footer-nav-group):last-child,\n.cds--footer-nav-group:last-child,\n.cds--footer-nav-group.cds--accordion__item:last-child {\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  margin-block-end: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-nav-group):last-child,\n  .cds--footer-nav-group:last-child,\n  .cds--footer-nav-group.cds--accordion__item:last-child {\n    border-block-end: none;\n  }\n}\n:host(c4d-footer-nav-group) .cds--accordion__content,\n.cds--footer-nav-group .cds--accordion__content,\n.cds--footer-nav-group.cds--accordion__item .cds--accordion__content {\n  padding-inline: 0;\n}\n:host(c4d-footer-nav-group) .cds--accordion__content ul,\n.cds--footer-nav-group .cds--accordion__content ul,\n.cds--footer-nav-group.cds--accordion__item .cds--accordion__content ul {\n  margin: 0;\n  list-style: none;\n  padding-inline-start: 0;\n}\n:host(c4d-footer-nav-group) .cds--accordion__arrow,\n.cds--footer-nav-group .cds--accordion__arrow,\n.cds--footer-nav-group.cds--accordion__item .cds--accordion__arrow {\n  margin: 2px 1rem 0 0;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer-nav-group),\n  .cds--footer-nav-group,\n  .cds--footer-nav-group.cds--accordion__item {\n    inline-size: 100%;\n    padding-inline: 1rem;\n    display: inline-block;\n    margin-block-end: 3rem;\n    padding-inline-start: 0;\n  }\n  .cds--row--condensed :host(c4d-footer-nav-group), .cds--grid--condensed :host(c4d-footer-nav-group),\n  .cds--row--condensed .cds--footer-nav-group,\n  .cds--grid--condensed .cds--footer-nav-group,\n  .cds--row--condensed .cds--footer-nav-group.cds--accordion__item,\n  .cds--grid--condensed .cds--footer-nav-group.cds--accordion__item {\n    padding-inline: 0.03125rem;\n  }\n  .cds--row--narrow :host(c4d-footer-nav-group), .cds--grid--narrow :host(c4d-footer-nav-group),\n  .cds--row--narrow .cds--footer-nav-group,\n  .cds--grid--narrow .cds--footer-nav-group,\n  .cds--row--narrow .cds--footer-nav-group.cds--accordion__item,\n  .cds--grid--narrow .cds--footer-nav-group.cds--accordion__item {\n    padding-inline: 0 1rem;\n  }\n  :host(c4d-footer-nav-group).cds--accordion__item,\n  .cds--footer-nav-group.cds--accordion__item,\n  .cds--footer-nav-group.cds--accordion__item.cds--accordion__item {\n    border-block-start: 0 transparent;\n  }\n  :host(c4d-footer-nav-group) .cds--accordion__heading,\n  .cds--footer-nav-group .cds--accordion__heading,\n  .cds--footer-nav-group.cds--accordion__item .cds--accordion__heading {\n    display: none;\n  }\n  :host(c4d-footer-nav-group) .cds--accordion__content,\n  .cds--footer-nav-group .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item .cds--accordion__content {\n    display: block;\n    block-size: auto;\n    opacity: 1;\n    visibility: visible;\n  }\n  :host(c4d-footer-nav-group) .cds--accordion__content, :host(c4d-footer-nav-group).cds--accordion__item--active .cds--accordion__content,\n  .cds--footer-nav-group .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item--active .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item .cds--accordion__content,\n  .cds--footer-nav-group.cds--accordion__item.cds--accordion__item--active .cds--accordion__content {\n    padding: 0;\n  }\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-footer-nav-group:not([open])) .cds--accordion__content {\n    display: none;\n  }\n}\n\n@media (max-width: 41.98rem) {\n  :host(c4d-footer-nav-item) .cds--link,\n  .cds--footer-nav-group .cds--link {\n    display: block;\n    padding: 1rem;\n    margin-block-start: 0;\n  }\n  :host(c4d-footer-nav-item) .cds--link:hover, :host(c4d-footer-nav-item) .cds--link:active,\n  .cds--footer-nav-group .cds--link:hover,\n  .cds--footer-nav-group .cds--link:active {\n    text-decoration: none;\n  }\n  :host(c4d-footer-nav-item) .cds--link:hover,\n  .cds--footer-nav-group .cds--link:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  :host(c4d-footer-nav-item) .cds--link:active,\n  .cds--footer-nav-group .cds--link:active {\n    background-color: var(--cds-layer-active-01, #c6c6c6);\n  }\n  :host(c4d-footer-nav-item) .cds--link:focus,\n  .cds--footer-nav-group .cds--link:focus {\n    box-shadow: inset 0 0 0 1px var(--cds-focus, #0f62fe);\n    outline-width: 0;\n  }\n}\n\n.cds--footer-nav-group__title {\n  font-size: var(--cds-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-01-font-weight, 600);\n  line-height: var(--cds-heading-01-line-height, 1.42857);\n  letter-spacing: var(--cds-heading-01-letter-spacing, 0.16px);\n  display: none;\n}\n\n.cds--footer-nav-group__link {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n\n@media (min-width: 42rem) {\n  .cds--footer-nav-group__title {\n    display: block;\n    margin: 0;\n  }\n  :host(c4d-footer-nav-item),\n  .cds--footer-nav-group__item {\n    margin-block-start: 0.5rem;\n  }\n}\n.cds--language-selector__container {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  order: 0;\n  margin: 3rem 0;\n  padding-inline: 0;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--language-selector__container .cds--combo-box:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--combo-box.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--combo-box .cds--text-input::-ms-clear {\n  display: none;\n}\n.cds--language-selector__container .cds--combo-box.cds--list-box--expanded .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--combo-box--input--focus.cds--text-input {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--combo-box--input--focus.cds--text-input {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--combo-box.cds--list-box--expanded:has(input[aria-activedescendant]:not([aria-activedescendant=\"\"])) .cds--combo-box--input--focus.cds--text-input {\n  outline-offset: -0.0625rem;\n  outline-width: 0.0625rem;\n}\n.cds--language-selector__container .cds--combo-box .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box--warning .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--combo-box.cds--list-box--disabled.cds--list-box--warning .cds--list-box__field {\n  padding: 0;\n}\n.cds--language-selector__container .cds--combo-box--readonly,\n.cds--language-selector__container .cds--combo-box--readonly:hover {\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--combo-box--readonly .cds--text-input {\n  border-block-end-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__menu-icon,\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__selection {\n  cursor: default;\n}\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__menu-icon svg,\n.cds--language-selector__container .cds--combo-box--readonly .cds--list-box__selection svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0.25rem;\n  grid-template: auto auto/auto auto;\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--label,\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form__helper-text,\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form__helper-text {\n  max-inline-size: none;\n}\n.cds--language-selector__container .cds--list-box__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n.cds--language-selector__container .cds--list-box {\n  position: relative;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  max-block-size: 2.5rem;\n  transition: all 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--list-box html {\n  font-size: 100%;\n}\n.cds--language-selector__container .cds--list-box body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--language-selector__container .cds--list-box code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--language-selector__container .cds--list-box strong {\n  font-weight: 600;\n}\n.cds--language-selector__container .cds--list-box:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--list-box--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n.cds--language-selector__container .cds--list-box--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n.cds--language-selector__container .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box--expanded {\n  border-block-end-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box--expanded:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--list-box--expanded:hover.cds--list-box--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--list-box .cds--text-input {\n  block-size: 100%;\n  min-inline-size: 0;\n}\n.cds--language-selector__container .cds--list-box__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--list-box__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n.cds--language-selector__container .cds--list-box__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--list-box.cds--list-box--warning .cds--list-box__field {\n  border-block-end: 0;\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field,\n.cds--language-selector__container .cds--list-box.cds--list-box--warning.cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 3.5rem;\n}\n.cds--language-selector__container .cds--list-box--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--list-box--light:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu {\n  background: var(--cds-layer);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--list-box--light.cds--list-box--expanded {\n  border-block-end-color: transparent;\n}\n.cds--language-selector__container .cds--list-box--disabled:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--list-box--light.cds--list-box--disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--list-box--disabled,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__field,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__field:focus {\n  border-block-end-color: transparent;\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__label,\n.cds--language-selector__container .cds--list-box--disabled.cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-icon > svg,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__field,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item--highlighted {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  text-decoration: none;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection:hover {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--list-box--disabled.cds--list-box[data-invalid] .cds--list-box__field {\n  padding-inline-end: 3rem;\n}\n.cds--language-selector__container .cds--list-box--disabled.cds--list-box[data-invalid].cds--list-box--inline .cds--list-box__field {\n  padding-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline {\n  border-width: 0;\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--expanded {\n  border-block-end-width: 0;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--expanded .cds--list-box__field[aria-expanded=true] {\n  border-width: 0;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--expanded:hover,\n.cds--language-selector__container .cds--list-box.cds--list-box--inline.cds--list-box--disabled:hover {\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__field {\n  padding: 0 2rem 0 0.5rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__menu-icon {\n  inset-inline-end: 0.5rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__invalid-icon {\n  inset-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--list-box--inline .cds--list-box__label {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--inline .cds--list-box__field {\n  block-size: 100%;\n}\n.cds--language-selector__container .cds--dropdown--inline .cds--list-box__field {\n  max-inline-size: 30rem;\n}\n.cds--language-selector__container .cds--dropdown--inline .cds--list-box__menu {\n  max-inline-size: 30rem;\n  min-inline-size: 18rem;\n}\n.cds--language-selector__container .cds--list-box__field {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  position: relative;\n  display: inline-flex;\n  overflow: hidden;\n  align-items: center;\n  block-size: calc(100% + 1px);\n  cursor: pointer;\n  outline: none;\n  padding-block: 0;\n  padding-inline-end: 3rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  vertical-align: top;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box__field *,\n.cds--language-selector__container .cds--list-box__field *::before,\n.cds--language-selector__container .cds--list-box__field *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__field::-moz-focus-inner {\n  border: 0;\n}\n.cds--language-selector__container .cds--list-box__field:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__field:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__field[disabled] {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__field .cds--text-input {\n  padding-inline-end: 5rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input {\n  padding-inline-end: 6.5625rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input + .cds--list-box__invalid-icon {\n  inset-inline-end: 5.125rem;\n}\n.cds--language-selector__container .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 3rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--list-box[data-invalid] .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field .cds--text-input--empty + .cds--list-box__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--list-box__label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  overflow: hidden;\n  color: var(--cds-text-primary, #161616);\n  text-overflow: ellipsis;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box__menu-icon {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-inline-end: 0.75rem;\n  outline: none;\n  transition: transform 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--list-box__menu-icon *,\n.cds--language-selector__container .cds--list-box__menu-icon *::before,\n.cds--language-selector__container .cds--list-box__menu-icon *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__menu-icon::-moz-focus-inner {\n  border: 0;\n}\n.cds--language-selector__container .cds--list-box__menu-icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box__menu-icon--open {\n  justify-content: center;\n  inline-size: 1.5rem;\n  transform: rotate(180deg);\n}\n.cds--language-selector__container .cds--list-box__selection {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  block-size: 1.5rem;\n  cursor: pointer;\n  inline-size: 1.5rem;\n  inset-block-start: 50%;\n  /* to preserve .5rem space between icons according to spec top/transform used to center the combobox clear selection icon in IE11 */\n  inset-inline-end: 2.8125rem;\n  transform: translateY(-50%);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--language-selector__container .cds--list-box__selection *,\n.cds--language-selector__container .cds--list-box__selection *::before,\n.cds--language-selector__container .cds--list-box__selection *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__selection::-moz-focus-inner {\n  border: 0;\n}\n.cds--language-selector__container .cds--list-box__selection:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__selection:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__selection:focus:hover {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__selection:focus:hover {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__selection > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection:focus {\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__selection--multi {\n  font-size: var(--cds-label-01-font-size, 0.75rem);\n  font-weight: var(--cds-label-01-font-weight, 400);\n  line-height: var(--cds-label-01-line-height, 1.33333);\n  letter-spacing: var(--cds-label-01-letter-spacing, 0.32px);\n  position: static;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding: 0.5rem;\n  border-radius: 0.75rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: 1.5rem;\n  color: var(--cds-text-inverse, #ffffff);\n  inline-size: auto;\n  inset-block-start: auto;\n  line-height: 0;\n  margin-inline-end: 0.625rem;\n  padding-inline-end: 0.125rem;\n  transform: none;\n}\n.cds--language-selector__container .cds--list-box__selection--multi > svg {\n  padding: 0.125rem;\n  block-size: 1.25rem;\n  fill: var(--cds-icon-inverse, #ffffff);\n  inline-size: 1.25rem;\n  margin-inline-start: 0.25rem;\n}\n.cds--language-selector__container .cds--list-box__selection--multi > svg:hover {\n  border-radius: 50%;\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  color: var(--cds-layer);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational {\n  border: 1px solid var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi.cds--tag--operational:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi .cds--tag__close-icon:hover {\n  background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi > svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__selection--multi > svg:hover {\n  background-color: initial;\n}\n.cds--language-selector__container .cds--list-box__selection--multi:hover {\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__menu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  position: absolute;\n  z-index: 9100;\n  display: none;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--list-box__menu:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__menu:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box .cds--list-box__field[aria-expanded=false] .cds--list-box__menu {\n  display: none;\n  max-block-size: 0;\n  visibility: hidden;\n}\n.cds--language-selector__container .cds--list-box--expanded .cds--list-box__menu {\n  display: block;\n  max-block-size: 13.75rem;\n}\n.cds--language-selector__container .cds--list-box--expanded.cds--list-box--lg .cds--list-box__menu {\n  max-block-size: 16.5rem;\n}\n.cds--language-selector__container .cds--list-box--expanded.cds--list-box--sm .cds--list-box__menu {\n  max-block-size: 11rem;\n}\n.cds--language-selector__container .cds--list-box__menu-item {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  block-size: 2.5rem;\n  color: var(--cds-text-secondary, #525252);\n  cursor: pointer;\n  transition: background 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--language-selector__container .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--language-selector__container .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--language-selector__container .cds--list-box--sm .cds--list-box__menu-item {\n  block-size: 2rem;\n}\n.cds--language-selector__container .cds--list-box--lg .cds--list-box__menu-item {\n  block-size: 3rem;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover {\n  background-color: transparent;\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item__option:hover {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box__menu-item:first-of-type .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__menu-item:hover .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box--disabled .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box__menu-item__option {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-end: 1px solid transparent;\n  border-block-start: 1px solid transparent;\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  padding-inline-end: 1.5rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  transition: border-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box__menu-item__option *,\n.cds--language-selector__container .cds--list-box__menu-item__option *::before,\n.cds--language-selector__container .cds--list-box__menu-item__option *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--list-box__menu-item__option:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  border-color: transparent;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__menu-item__option:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__menu-item__option:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--sm .cds--list-box__menu-item__option {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n.cds--language-selector__container .cds--list-box--lg .cds--list-box__menu-item__option {\n  block-size: 3rem;\n  padding-block-end: 0.9375rem;\n  padding-block-start: 0.9375rem;\n}\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item:hover .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box--disabled .cds--list-box__menu-item__option {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled],\n.cds--language-selector__container .cds--list-box__menu-item[disabled] *,\n.cds--language-selector__container .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item[disabled]:hover {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  outline: none;\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled]:hover {\n  background-color: revert;\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled] .cds--checkbox-label::before {\n  border-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-01, #c6c6c6);\n}\n.cds--language-selector__container .cds--layer-two .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--layer-two .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n.cds--language-selector__container .cds--layer-three .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--layer-three .cds--list-box__menu-item[disabled]:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: var(--cds-border-subtle-03, #c6c6c6);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active + .cds--list-box__menu-item[disabled] .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item:hover + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option {\n  margin: 0 0.5rem;\n}\n.cds--language-selector__container .cds--list-box.cds--list-box--inline .cds--list-box__menu-item__option:focus {\n  margin: 0;\n  padding-inline-end: 0.5rem;\n  padding-inline-start: 0.5rem;\n}\n.cds--language-selector__container .cds--list-box__menu-item--highlighted {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--list-box__menu-item--highlighted {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option,\n.cds--language-selector__container .cds--list-box__menu-item--highlighted + .cds--list-box__menu-item .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box--light .cds--list-box__menu-item--active {\n  background-color: var(--cds-layer-selected);\n  border-block-end-color: var(--cds-layer-selected);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active:hover {\n  background-color: var(--cds-layer-selected-hover);\n  border-block-end-color: var(--cds-layer-selected-hover);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active .cds--list-box__menu-item__option {\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container .cds--list-box__menu-item--active + .cds--list-box__menu-item > .cds--list-box__menu-item__option {\n  border-block-start-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__menu-item__selected-icon {\n  position: absolute;\n  display: none;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--list-box--inline .cds--list-box__menu-item__selected-icon {\n  inset-inline-end: 0.5rem;\n}\n.cds--language-selector__container .cds--list-box__menu-item--active .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n.cds--language-selector__container .cds--list-box__menu-item .cds--checkbox-label {\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--list-box__menu-item .cds--checkbox-label-text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--list-box--up .cds--list-box__menu {\n  inset-block-end: 2.5rem;\n}\n.cds--language-selector__container .cds--list-box--up.cds--dropdown--sm .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up.cds--list-box--sm .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up .cds--list-box--sm .cds--list-box__menu {\n  inset-block-end: 2rem;\n}\n.cds--language-selector__container .cds--list-box--up.cds--dropdown--lg .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up.cds--list-box--lg .cds--list-box__menu,\n.cds--language-selector__container .cds--list-box--up .cds--list-box--lg .cds--list-box__menu {\n  inset-block-end: 3rem;\n}\n.cds--language-selector__container .cds--list-box input[role=combobox],\n.cds--language-selector__container .cds--list-box input[type=text] {\n  background-color: inherit;\n  min-inline-size: 0;\n  text-overflow: ellipsis;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 9px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::after,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: -0.5625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: -0.5625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box:not(:has(.cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box input[role=combobox] {\n  border-block-end-color: transparent;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box__field,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--text-input--empty {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 6rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__field,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input--empty,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field {\n  padding-inline-end: 6rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input:not(.cds--text-input--empty),\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--text-input:not(.cds--text-input--empty) {\n  padding-inline-end: 8.8125rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--text-input--empty + .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__invalid-icon.cds--list-box__invalid-icon--warning {\n  inset-inline-end: 5.1875rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid[data-invalid] .cds--slug::before,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--slug::before {\n  display: block;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) ~ .cds--slug {\n  inset-inline-end: calc(4rem + 18px);\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--invalid .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon,\n.cds--language-selector__container .cds--list-box__wrapper--slug .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__selection) .cds--list-box__invalid-icon {\n  inset-inline-end: 7.25rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--list-box__field,\n  .cds--language-selector__container .cds--list-box__menu,\n  .cds--language-selector__container .cds--multi-select .cds--tag--filter {\n    outline: 1px solid transparent;\n  }\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--list-box__field:focus,\n  .cds--language-selector__container .cds--multi-select .cds--tag__close-icon:focus,\n  .cds--language-selector__container .cds--list-box__menu-item--highlighted .cds--list-box__menu-item__option {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--list-box__menu-icon > svg,\n  .cds--language-selector__container .cds--list-box__selection > svg,\n  .cds--language-selector__container .cds--list-box__selection--multi > svg {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::after {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-start: 2.0625rem;\n}\n.cds--language-selector__container .cds--list-box--warning .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before,\n.cds--language-selector__container .cds--list-box--invalid[data-invalid] .cds--list-box__field:has(.cds--list-box__menu-icon) .cds--list-box__selection::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  margin-inline-end: 2.0625rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug:has(.cds--multi-select) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n.cds--language-selector__container .cds--list-box__wrapper--slug:has(.cds--dropdown) .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n.cds--language-selector__container .cds--select {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select *,\n.cds--language-selector__container .cds--select *::before,\n.cds--language-selector__container .cds--select *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--select-input__wrapper {\n  position: relative;\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select-input {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  border: none;\n  border-radius: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  font-family: inherit;\n  inline-size: 100%;\n  opacity: 1;\n  padding-block: 0;\n  padding-inline: 1rem 3rem;\n  text-overflow: ellipsis;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--select-input::-ms-expand {\n  display: none;\n}\n@-moz-document url-prefix() {\n  .cds--language-selector__container .cds--select-input:-moz-focusring, .cds--language-selector__container .cds--select-input::-moz-focus-inner {\n    background-image: none;\n    color: transparent;\n    text-shadow: 0 0 0 #000000;\n  }\n}\n.cds--language-selector__container .cds--select-input:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  color: var(--cds-text-primary, #161616);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--select-input:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--select-input:disabled, .cds--language-selector__container .cds--select-input:hover:disabled {\n  background-color: var(--cds-field);\n  border-block-end-color: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select-input--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n.cds--language-selector__container .cds--select-input--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n.cds--language-selector__container .cds--select--disabled .cds--label,\n.cds--language-selector__container .cds--select--disabled .cds--form__helper-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select-input__wrapper[data-invalid] .cds--select-input,\n.cds--language-selector__container .cds--select--warning .cds--select-input {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--select-input:disabled ~ .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select--light .cds--select-input {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--select--light .cds--select-input:hover {\n  background-color: var(--cds-field-hover);\n}\n.cds--language-selector__container .cds--select--light .cds--select-input:disabled, .cds--language-selector__container .cds--select--light .cds--select-input:hover:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select__arrow {\n  position: absolute;\n  block-size: 100%;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--select__arrow path {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--select__invalid-icon {\n  position: absolute;\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon {\n  fill: var(--cds-support-error, #da1e28);\n}\n.cds--language-selector__container .cds--select__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n.cds--language-selector__container .cds--select__invalid-icon--warning path[fill] {\n  fill: #000000;\n  opacity: 1;\n}\n.cds--language-selector__container optgroup.cds--select-optgroup,\n.cds--language-selector__container .cds--select-option {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--language-selector__container optgroup.cds--select-optgroup:disabled,\n.cds--language-selector__container .cds--select-option:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select--inline {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n}\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--label,\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--form__helper-text {\n  align-self: flex-start;\n  margin-block-start: 0.8125rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--form__helper-text {\n  margin-block-end: 0;\n  margin-inline-start: 0.5rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--label {\n  margin: 0 0.5rem 0 0;\n  white-space: nowrap;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input {\n  background-color: transparent;\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: auto;\n  padding-inline-end: 2rem;\n  padding-inline-start: 0.5rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input:focus,\n.cds--language-selector__container .cds--select--inline .cds--select-input:focus option,\n.cds--language-selector__container .cds--select--inline .cds--select-input:focus optgroup {\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input[disabled],\n.cds--language-selector__container .cds--select--inline .cds--select-input[disabled]:hover {\n  background-color: var(--cds-field);\n}\n.cds--language-selector__container .cds--select--inline .cds--select__arrow {\n  inset-inline-end: 0.5rem;\n}\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--select-input {\n  padding-inline-end: 3.5rem;\n}\n.cds--language-selector__container .cds--select--inline.cds--select--invalid .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input:disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select--inline .cds--select-input:disabled ~ * {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--select--readonly .cds--select-input {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n  cursor: default;\n}\n.cds--language-selector__container .cds--select--readonly .cds--select__arrow {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--select.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  block-size: 2.5rem;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select.cds--skeleton:hover, .cds--language-selector__container .cds--select.cds--skeleton:focus, .cds--language-selector__container .cds--select.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--language-selector__container .cds--select.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--language-selector__container .cds--select.cds--skeleton::before {\n    animation: none;\n  }\n}\n.cds--language-selector__container .cds--select.cds--skeleton .cds--select-input {\n  display: none;\n}\n.cds--language-selector__container .cds--select--slug .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: calc(2.5rem + 8px + 1px);\n  margin-block-start: 0.03125rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--select--slug .cds--slug::after,\n.cds--language-selector__container .cds--select--slug .cds--slug::before {\n  position: absolute;\n  background-color: var(--cds-border-subtle-01, #c6c6c6);\n  block-size: 1rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n}\n.cds--language-selector__container .cds--select--slug .cds--slug::before {\n  display: none;\n  inset-inline-start: calc(-0.5rem - 1px);\n}\n.cds--language-selector__container .cds--select--slug .cds--slug::after {\n  display: block;\n  inset-inline-end: calc(-0.5rem - 1px);\n}\n.cds--language-selector__container .cds--select--slug .cds--slug--revert::after {\n  inset-block-start: 0.5rem;\n  inset-inline-end: -0.0625rem;\n}\n.cds--language-selector__container .cds--select--slug .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--select--slug:has(.cds--select__invalid-icon) .cds--select-input:not(:has(~ .cds--slug--revert)) {\n  padding-inline-end: 6rem;\n}\n.cds--language-selector__container .cds--select--slug:has(.cds--select__invalid-icon) .cds--slug::before {\n  display: block;\n}\n.cds--language-selector__container .cds--select--slug .cds--select-input__wrapper[data-invalid] .cds--select-input ~ .cds--select__invalid-icon,\n.cds--language-selector__container .cds--select--slug .cds--select-input__wrapper .cds--select-input ~ .cds--select__invalid-icon {\n  inset-inline-end: 5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--select__arrow {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--text-input {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-md)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-lg)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  padding: 0 var(--cds-layout-density-padding-inline-local);\n  border: none;\n  background-color: var(--cds-field);\n  block-size: var(--cds-layout-size-height-local);\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  font-family: inherit;\n  inline-size: 100%;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--text-input *,\n.cds--language-selector__container .cds--text-input *::before,\n.cds--language-selector__container .cds--text-input *::after {\n  box-sizing: inherit;\n}\n.cds--language-selector__container .cds--text-input:focus, .cds--language-selector__container .cds--text-input:active {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input:focus, .cds--language-selector__container .cds--text-input:active {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input-wrapper svg[hidden] {\n  display: none;\n}\n.cds--language-selector__container .cds--password-input {\n  padding-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--sm.cds--password-input {\n  padding-inline-end: 2rem;\n}\n.cds--language-selector__container .cds--text-input--lg.cds--password-input {\n  padding-inline-end: 3rem;\n}\n.cds--language-selector__container .cds--text-input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--text-input__field-wrapper {\n  position: relative;\n  display: flex;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--text-input__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--text-input__invalid-icon--warning {\n  fill: var(--cds-support-warning, #f1c21b);\n}\n.cds--language-selector__container .cds--text-input__invalid-icon--warning path:first-of-type {\n  fill: #000000;\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input--password__visibility {\n  position: relative;\n  display: inline-flex;\n  overflow: visible;\n  align-items: center;\n  cursor: pointer;\n}\n.cds--language-selector__container .cds--text-input--password__visibility:focus {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--password__visibility:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility:focus {\n  outline: 1px solid transparent;\n}\n.cds--language-selector__container .cds--text-input--password__visibility:focus svg {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--password__visibility:focus svg {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  position: absolute;\n  z-index: 6000;\n  display: flex;\n  align-items: center;\n  opacity: 0;\n  pointer-events: none;\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    display: inline-block;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after {\n  transition: opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after {\n    transition: none;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--a11y::before, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  transition: none;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before {\n  border-style: solid;\n  block-size: 0;\n  content: \"\";\n  inline-size: 0;\n}\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  box-sizing: content-box;\n  color: inherit;\n  opacity: 1;\n  white-space: normal;\n  word-break: break-word;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  z-index: 6000;\n  padding: 0.1875rem 1rem;\n  border-radius: 0.125rem;\n  background-color: var(--cds-background-inverse, #393939);\n  block-size: auto;\n  color: var(--cds-text-inverse, #ffffff);\n  font-weight: 400;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 13rem;\n  min-inline-size: 1.5rem;\n  text-align: start;\n  transform: translateX(-50%);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-accelerator: true) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@supports (-ms-ime-align: auto) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    inline-size: auto;\n  }\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--password__visibility::after,\n  .cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n  .cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n    border: 1px solid transparent;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility::after {\n  content: attr(aria-label);\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--a11y::after {\n  content: none;\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible::before, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible::after, .cds--language-selector__container .cds--text-input--password__visibility:hover::before, .cds--language-selector__container .cds--text-input--password__visibility:hover::after, .cds--language-selector__container .cds--text-input--password__visibility:focus::before, .cds--language-selector__container .cds--text-input--password__visibility:focus::after {\n  opacity: 1;\n}\n@keyframes cds--tooltip-fade {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:focus + .cds--assistive-text {\n  overflow: visible;\n  margin: auto;\n  clip: auto;\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--visible.cds--tooltip--a11y::before, .cds--language-selector__container .cds--text-input--password__visibility:hover .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:hover + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:hover.cds--tooltip--a11y::before, .cds--language-selector__container .cds--text-input--password__visibility:focus .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility:focus + .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility:focus.cds--tooltip--a11y::before {\n  animation: cds--tooltip-fade 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--hidden .cds--assistive-text, .cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--hidden + .cds--assistive-text {\n  overflow: hidden;\n  margin: -1px;\n  clip: rect(0, 0, 0, 0);\n}\n.cds--language-selector__container .cds--text-input--password__visibility.cds--tooltip--hidden.cds--tooltip--a11y::before {\n  animation: none;\n  opacity: 0;\n}\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text::after {\n  position: absolute;\n  display: block;\n  content: \"\";\n  block-size: 0.75rem;\n  inline-size: 100%;\n  inset-inline-start: 0;\n  inset-block-start: -0.75rem;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before, .cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: 0;\n  inset-inline-start: 50%;\n}\n.cds--language-selector__container .cds--text-input--password__visibility::before {\n  border-width: 0 0.25rem 0.3125rem 0.25rem;\n  border-color: transparent transparent var(--cds-background-inverse, #393939) transparent;\n  inset-block-end: -0.5rem;\n  transform: translate(-50%, 100%);\n}\n.cds--language-selector__container .cds--text-input--password__visibility::after,\n.cds--language-selector__container .cds--text-input--password__visibility .cds--assistive-text,\n.cds--language-selector__container .cds--text-input--password__visibility + .cds--assistive-text {\n  inset-block-end: -0.8125rem;\n  transform: translate(-50%, 100%);\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding: 0;\n  border: 0;\n  background: none;\n  block-size: 100%;\n  cursor: pointer;\n  inline-size: 2.5rem;\n  inset-inline-end: 0;\n  min-block-size: auto;\n  transition: outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--toggle-password-tooltip .cds--popover {\n  inset-inline-start: -2.5rem;\n}\n.cds--language-selector__container .cds--toggle-password-tooltip .cds--popover-content {\n  min-inline-size: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--sm + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 2rem;\n}\n.cds--language-selector__container .cds--text-input--lg + .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  inline-size: 3rem;\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-secondary, #525252);\n  transition: fill 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media screen and (-ms-high-contrast: active), screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg,\n.cds--language-selector__container .cds--btn.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:focus svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--language-selector__container .cds--text-input--invalid,\n.cds--language-selector__container .cds--text-input--warning {\n  padding-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--invalid.cds--password-input {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--text-input--invalid + .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 1rem;\n}\n.cds--language-selector__container .cds--password-input-wrapper .cds--text-input__invalid-icon {\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger {\n  cursor: not-allowed;\n}\n.cds--language-selector__container .cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input:disabled ~ .cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg:hover {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger {\n  cursor: default;\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover {\n  cursor: default;\n}\n.cds--language-selector__container .cds--text-input--password__visibility__toggle:disabled.cds--tooltip__trigger:hover svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input__counter-alert {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n}\n.cds--language-selector__container .cds--text-input:disabled {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  background-color: var(--cds-field);\n  border-block-end: 1px solid transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  cursor: not-allowed;\n  -webkit-text-fill-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--language-selector__container .cds--text-input--light:disabled {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--language-selector__container .cds--text-input:disabled::-moz-placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input:disabled::placeholder {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  opacity: 1;\n}\n.cds--language-selector__container .cds--text-input--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n  box-shadow: none;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--text-input--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--text-input--invalid .cds--text-input--password__visibility__toggle {\n  inset-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--skeleton.cds--text-input {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--language-selector__container .cds--skeleton.cds--text-input:hover, .cds--language-selector__container .cds--skeleton.cds--text-input:focus, .cds--language-selector__container .cds--skeleton.cds--text-input:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--language-selector__container .cds--skeleton.cds--text-input::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--language-selector__container .cds--skeleton.cds--text-input::before {\n    animation: none;\n  }\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input-wrapper {\n  position: relative;\n  background: var(--cds-field);\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--language-selector__container .cds--form--fluid .cds--label {\n  position: absolute;\n  z-index: 1;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  block-size: 1rem;\n  inset-block-start: 0.8125rem;\n  inset-inline-start: 1rem;\n}\n.cds--language-selector__container .cds--form--fluid .cds--form__helper-text {\n  display: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input {\n  padding: 2rem 1rem 0.8125rem;\n  min-block-size: 4rem;\n}\n.cds--language-selector__container .cds--text-input__divider,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__divider {\n  display: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input--invalid,\n.cds--language-selector__container .cds--form--fluid .cds--text-input--warning {\n  border-block-end: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input--invalid + .cds--text-input__divider,\n.cds--language-selector__container .cds--form--fluid .cds--text-input--warning + .cds--text-input__divider {\n  display: block;\n  border-style: solid;\n  border-color: var(--cds-border-subtle);\n  margin: 0 1rem;\n  border-block-end: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__invalid-icon {\n  inset-block-start: 5rem;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning {\n  outline: none;\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning {\n  border-block-end: 1px solid var(--cds-border-strong);\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:not(:focus) {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid]:focus-within,\n  .cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning:focus-within {\n    outline-style: dotted;\n  }\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper[data-invalid] > .cds--text-input--invalid:focus,\n.cds--language-selector__container .cds--form--fluid .cds--text-input__field-wrapper--warning > .cds--text-input--warning:focus {\n  outline: none;\n}\n.cds--language-selector__container .cds--text-input-wrapper.cds--text-input-wrapper--inline {\n  flex-flow: row wrap;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--label--inline {\n  flex: 1;\n  margin: 0.8125rem 0 0 0;\n  overflow-wrap: break-word;\n  word-break: break-word;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--label--inline--sm {\n  margin-block-start: 0.5625rem;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--label--inline--lg {\n  margin-block-start: 1.0625rem;\n}\n.cds--language-selector__container .cds--text-input__label-helper-wrapper {\n  flex: 2;\n  flex-direction: column;\n  margin-inline-end: 1.5rem;\n  max-inline-size: 8rem;\n  overflow-wrap: break-word;\n}\n.cds--language-selector__container .cds--text-input-wrapper .cds--form__helper-text--inline {\n  margin-block-start: 0.125rem;\n}\n.cds--language-selector__container .cds--text-input__field-outer-wrapper {\n  display: flex;\n  flex: 1 1 auto;\n  flex-direction: column;\n  align-items: flex-start;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--text-input__field-outer-wrapper--inline {\n  flex: 8;\n  flex-direction: column;\n}\n.cds--language-selector__container .cds--text-input-wrapper--inline .cds--form-requirement {\n  display: block;\n  overflow: visible;\n  font-weight: 400;\n  max-block-size: 12.5rem;\n}\n.cds--language-selector__container .cds--text-input-wrapper--inline--invalid .cds--form-requirement {\n  color: var(--cds-text-error, #da1e28);\n}\n.cds--language-selector__container .cds--form--fluid .cds--text-input-wrapper--readonly,\n.cds--language-selector__container .cds--text-input-wrapper--readonly .cds--text-input {\n  background: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n.cds--language-selector__container .cds--text-input__field-wrapper .cds--slug {\n  position: absolute;\n  inset-block-start: 50%;\n  inset-inline-end: 1rem;\n  transform: translateY(-50%);\n}\n.cds--language-selector__container .cds--text-input__field-wrapper--slug .cds--text-input:not(:has(~ .cds--slug--revert)) {\n  background-image: linear-gradient(0deg, var(--cds-ai-aura-start-sm, rgba(69, 137, 255, 0.16)) 0%, 15%, var(--cds-ai-aura-end, rgba(255, 255, 255, 0)) 50%, transparent 100%);\n  border-block-end-color: var(--cds-ai-border-strong, #4589ff);\n  padding-inline-end: 2.5rem;\n}\n.cds--language-selector__container .cds--text-input--invalid:has(~ .cds--slug),\n.cds--language-selector__container .cds--text-input--warning:has(~ .cds--slug) {\n  padding-inline-end: 4rem;\n}\n.cds--language-selector__container .cds--text-input--invalid ~ .cds--slug,\n.cds--language-selector__container .cds--text-input--warning ~ .cds--slug {\n  inset-inline-end: 2.5rem;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--language-selector__container .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger svg,\n  .cds--language-selector__container .cds--btn.cds--btn--icon-only.cds--text-input--password__visibility__toggle.cds--tooltip__trigger:hover svg {\n    fill: ButtonText;\n  }\n}\n.cds--language-selector__container .cds--text-input__label-wrapper {\n  display: flex;\n  justify-content: space-between;\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--text-input__label-wrapper .cds--text-input__label-counter {\n  align-self: end;\n}\n@media (max-width: 41.98rem) {\n  .cds--language-selector__container {\n    inline-size: 100%;\n    padding-inline: 1rem;\n  }\n  .cds--row--condensed .cds--language-selector__container, .cds--grid--condensed .cds--language-selector__container {\n    padding-inline: 0.03125rem;\n  }\n  .cds--row--narrow .cds--language-selector__container, .cds--grid--narrow .cds--language-selector__container {\n    padding-inline: 0 1rem;\n  }\n}\n@media (min-width: 42rem) {\n  .cds--language-selector__container {\n    margin-block-start: 0;\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-inline-start: 25%;\n  }\n}\n.cds--language-selector__container .cds--language-selector {\n  block-size: 3rem;\n  inline-size: 100%;\n  margin-inline-end: 0;\n  max-inline-size: 100%;\n}\n.cds--language-selector__container .cds--language-selector .cds--list-box__menu-icon {\n  inset-inline-end: 0.75rem;\n}\n.cds--language-selector__container .cds--language-selector .cds--list-box__selection {\n  inset-inline-end: 2.25rem;\n}\n.cds--language-selector__container .cds--language-selector .cds--list-box__field {\n  block-size: inherit;\n}\n@media (min-width: 42rem) {\n  .cds--language-selector__container .cds--language-selector {\n    min-inline-size: 13.5rem;\n  }\n  .cds--footer--short .cds--language-selector__container .cds--language-selector {\n    float: inline-end;\n  }\n}\n.cds--language-selector__container .cds--language-selector .cds--text-input,\n.cds--language-selector__container .cds--language-selector .cds--list-box__menu-item__option {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--footer--short .cds--language-selector__container {\n  margin-block-start: 0;\n}\n@media (min-width: 42rem) {\n  .cds--language-selector__container {\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-block-end: 1rem;\n  }\n  .cds--footer--short .cds--language-selector__container {\n    margin-inline-start: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--language-selector__container {\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: 62.5%;\n    order: 1;\n  }\n  .cds--footer--short .cds--language-selector__container {\n    margin-inline-start: 62.5%;\n  }\n}\n@media (min-width: 99rem) {\n  .cds--footer--short .cds--language-selector__container {\n    margin-inline-start: 68.75%;\n  }\n}\n.cds--language-selector__container .cds--list-box--up .cds--list-box__menu {\n  z-index: 1;\n  inset-block-end: 2.9375rem;\n}\n.cds--language-selector__container .cds--select-input__wrapper {\n  inline-size: 100%;\n}\n.cds--language-selector__container .cds--select-input__wrapper .cds--select-input {\n  block-size: 3rem;\n  inline-size: 100%;\n  max-inline-size: 100%;\n}\n.cds--language-selector__container .cds--form-item {\n  display: block;\n}\n@media (min-width: 66rem) {\n  .cds--language-selector__container .cds--form-item {\n    display: none;\n  }\n}\n.cds--language-selector__container .cds--list-box__wrapper {\n  display: none;\n}\n@media (min-width: 66rem) {\n  .cds--language-selector__container .cds--list-box__wrapper {\n    display: block;\n  }\n}\n.cds--language-selector__container .cds--label {\n  display: block;\n  padding: 0;\n  margin: 0;\n  block-size: 0;\n  visibility: hidden;\n}\n\n:host(c4d-legal-nav) {\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-legal-nav) {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-legal-nav) {\n    padding-inline: 2.5rem;\n  }\n}\n\n.c4d--legal-nav {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n}\n@media (max-width: 41.98rem) {\n  .cds--footer:not(.cds--footer--short) .c4d--legal-nav {\n    border-block-start: 0;\n  }\n}\n\n.c4d--adjunct-links__container,\n.c4d--legal-nav__list {\n  inline-size: 100%;\n  padding-inline-start: 1rem;\n}\n.c4d--adjunct-links__container ul,\n.c4d--legal-nav__list ul {\n  padding: 0;\n  margin: 0;\n  list-style: none;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container,\n  .c4d--legal-nav__list {\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container,\n  .c4d--legal-nav__list {\n    margin-inline-start: 25%;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro,\n.c4d--legal-nav__list.c4d--legal-nav__micro {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  display: flex;\n  flex-direction: column-reverse;\n  margin-inline-end: 0;\n  padding-block-end: 0;\n  padding-inline-start: 0;\n}\n@media (max-width: 41.98rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro ::slotted([slot=locale]),\n  .c4d--adjunct-links__container.c4d--legal-nav__micro ::slotted([slot=brand]),\n  .c4d--legal-nav__list.c4d--legal-nav__micro ::slotted([slot=locale]),\n  .c4d--legal-nav__list.c4d--legal-nav__micro ::slotted([slot=brand]) {\n    display: none;\n  }\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro,\n  .c4d--legal-nav__list.c4d--legal-nav__micro {\n    padding-inline-start: 0;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro,\n  .c4d--legal-nav__list.c4d--legal-nav__micro {\n    flex-direction: row;\n    justify-content: space-between;\n    margin-inline-start: 0;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder {\n  padding: 0 1rem;\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  -moz-column-count: inherit;\n       column-count: inherit;\n  margin-inline-start: 0;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder {\n    display: flex;\n    align-items: center;\n    padding: 0 1rem 0;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder {\n    border-block-start: none;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item {\n  display: flex;\n  align-items: center;\n  block-size: 3rem;\n  margin-inline-end: 0;\n  padding-block-start: 0;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item {\n    margin-inline-end: 2rem;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item a,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--legal-nav__holder .cds--legal-nav__list-item a {\n  display: flex;\n  align-items: center;\n  inline-size: 100%;\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container {\n  margin: 0;\n}\n@media (min-width: 42rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container {\n    align-self: flex-end;\n    border-inline-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    inline-size: 50%;\n  }\n}\n@media (min-width: 66rem) {\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container,\n  .c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container {\n    margin: 0;\n  }\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input {\n  background-color: var(--cds-background, #ffffff);\n  max-inline-size: 100%;\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:hover,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:hover,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:active,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--btn--secondary:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--btn--secondary:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box:active,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input:active {\n  background-color: var(--cds-layer-active-01, #c6c6c6);\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select {\n  max-inline-size: 100%;\n}\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--text-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--text-input,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--adjunct-links__container.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--text-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--locale-btn__container .cds--select-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--text-input,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--list-box,\n.c4d--legal-nav__list.c4d--legal-nav__micro .cds--language-selector__container .cds--select-input {\n  border-block-end: none;\n}\n\n.cds--legal-nav__holder {\n  margin-inline-start: 0;\n  padding-block-start: 0;\n}\n@media (min-width: 42rem) {\n  .cds--legal-nav__holder {\n    -moz-column-count: 2;\n         column-count: 2;\n    padding-block-start: 0.5rem;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--legal-nav__holder {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n\n.cds--adjunct-links__holder {\n  padding: 0 3rem 0 1rem;\n  inline-size: 100%;\n  margin-block-start: 3rem;\n  margin-inline-start: 0;\n}\n@media (min-width: 42rem) {\n  .cds--adjunct-links__holder {\n    inline-size: 50%;\n  }\n}\n@media (min-width: 66rem) {\n  .cds--adjunct-links__holder {\n    inline-size: 25%;\n    margin-inline-start: 25%;\n  }\n}\n.cds--adjunct-links__holder .cds--legal-nav__list-item {\n  margin-inline-end: 0;\n  padding-block-start: 0;\n}\n.cds--adjunct-links__holder .cds--legal-nav__list-item:not(:first-of-type) {\n  padding-block-start: 0.5rem;\n}\n\n:host(c4d-legal-nav-item),\n:host(c4d-legal-nav-cookie-preferences-placeholder),\n.cds--legal-nav__list-item {\n  padding: 0.5rem 0 0 0;\n  margin-inline-end: 2rem;\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n}\n@media (max-width: 41.98rem) {\n  :host(c4d-legal-nav-item):first-child,\n  :host(c4d-legal-nav-cookie-preferences-placeholder):first-child,\n  .cds--legal-nav__list-item:first-child {\n    padding-block-start: 0;\n  }\n}\n:host(c4d-legal-nav-item):last-child,\n:host(c4d-legal-nav-cookie-preferences-placeholder):last-child,\n.cds--legal-nav__list-item:last-child {\n  margin-inline-end: 0;\n}\n\n:host(c4d-locale-button),\n.cds--locale-btn__container {\n  --cds-ai-aura-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-background: #333333;\n  --cds-ai-aura-hover-end: rgba(0, 0, 0, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.4);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #4589ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.36);\n  --cds-ai-border-strong: #78a9ff;\n  --cds-ai-drop-shadow: rgba(0, 0, 0, 0.28);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.16);\n  --cds-ai-overlay: rgba(0, 0, 0, 0.5);\n  --cds-ai-popover-background: #161616;\n  --cds-ai-popover-caret-bottom: #4589ff;\n  --cds-ai-popover-caret-bottom-background: #202d45;\n  --cds-ai-popover-caret-bottom-background-actions: #1e283a;\n  --cds-ai-popover-caret-center: #4870b5;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 0, 0, 0.12);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.08);\n  --cds-ai-skeleton-background: rgba(120, 169, 255, 0.5);\n  --cds-ai-skeleton-element-background: rgba(120, 169, 255, 0.3);\n  --cds-background: #161616;\n  --cds-background-active: rgba(141, 141, 141, 0.4);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.16);\n  --cds-background-inverse: #f4f4f4;\n  --cds-background-inverse-hover: #e8e8e8;\n  --cds-background-selected: rgba(141, 141, 141, 0.24);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: rgba(141, 141, 141, 0.5);\n  --cds-border-interactive: #4589ff;\n  --cds-border-inverse: #f4f4f4;\n  --cds-border-strong-01: #6f6f6f;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #a8a8a8;\n  --cds-border-subtle-00: #393939;\n  --cds-border-subtle-01: #525252;\n  --cds-border-subtle-02: #6f6f6f;\n  --cds-border-subtle-03: #6f6f6f;\n  --cds-border-subtle-selected-01: #6f6f6f;\n  --cds-border-subtle-selected-02: #8d8d8d;\n  --cds-border-subtle-selected-03: #8d8d8d;\n  --cds-border-tile-01: #525252;\n  --cds-border-tile-02: #6f6f6f;\n  --cds-border-tile-03: #8d8d8d;\n  --cds-chat-avatar-agent: #c6c6c6;\n  --cds-chat-avatar-bot: #8d8d8d;\n  --cds-chat-avatar-user: #4589ff;\n  --cds-chat-bubble-agent: #262626;\n  --cds-chat-bubble-border: #525252;\n  --cds-chat-bubble-user: #393939;\n  --cds-chat-button: #78a9ff;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.4);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.16);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.24);\n  --cds-chat-button-text-hover: #a6c8ff;\n  --cds-chat-button-text-selected: #c6c6c6;\n  --cds-chat-header-background: #262626;\n  --cds-chat-prompt-background: #161616;\n  --cds-chat-prompt-border-end: rgba(38, 38, 38, 0);\n  --cds-chat-prompt-border-start: #262626;\n  --cds-chat-shell-background: #262626;\n  --cds-field-01: #262626;\n  --cds-field-02: #393939;\n  --cds-field-03: #525252;\n  --cds-field-hover-01: #333333;\n  --cds-field-hover-02: #474747;\n  --cds-field-hover-03: #636363;\n  --cds-focus: #ffffff;\n  --cds-focus-inset: #161616;\n  --cds-focus-inverse: #0f62fe;\n  --cds-highlight: #001d6c;\n  --cds-icon-disabled: rgba(244, 244, 244, 0.25);\n  --cds-icon-interactive: #ffffff;\n  --cds-icon-inverse: #161616;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-icon-primary: #f4f4f4;\n  --cds-icon-secondary: #c6c6c6;\n  --cds-interactive: #4589ff;\n  --cds-layer-01: #262626;\n  --cds-layer-02: #393939;\n  --cds-layer-03: #525252;\n  --cds-layer-accent-01: #393939;\n  --cds-layer-accent-02: #525252;\n  --cds-layer-accent-03: #6f6f6f;\n  --cds-layer-accent-active-01: #6f6f6f;\n  --cds-layer-accent-active-02: #8d8d8d;\n  --cds-layer-accent-active-03: #393939;\n  --cds-layer-accent-hover-01: #474747;\n  --cds-layer-accent-hover-02: #636363;\n  --cds-layer-accent-hover-03: #5e5e5e;\n  --cds-layer-active-01: #525252;\n  --cds-layer-active-02: #6f6f6f;\n  --cds-layer-active-03: #8d8d8d;\n  --cds-layer-hover-01: #333333;\n  --cds-layer-hover-02: #474747;\n  --cds-layer-hover-03: #636363;\n  --cds-layer-selected-01: #393939;\n  --cds-layer-selected-02: #525252;\n  --cds-layer-selected-03: #6f6f6f;\n  --cds-layer-selected-disabled: #a8a8a8;\n  --cds-layer-selected-hover-01: #474747;\n  --cds-layer-selected-hover-02: #636363;\n  --cds-layer-selected-hover-03: #5e5e5e;\n  --cds-layer-selected-inverse: #f4f4f4;\n  --cds-link-inverse: #0f62fe;\n  --cds-link-inverse-active: #161616;\n  --cds-link-inverse-hover: #0043ce;\n  --cds-link-inverse-visited: #8a3ffc;\n  --cds-link-primary: #78a9ff;\n  --cds-link-primary-hover: #a6c8ff;\n  --cds-link-secondary: #a6c8ff;\n  --cds-link-visited: #be95ff;\n  --cds-overlay: rgba(0, 0, 0, 0.65);\n  --cds-shadow: rgba(0, 0, 0, 0.8);\n  --cds-skeleton-background: #292929;\n  --cds-skeleton-element: #393939;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #a56eff;\n  --cds-support-error: #fa4d56;\n  --cds-support-error-inverse: #da1e28;\n  --cds-support-info: #4589ff;\n  --cds-support-info-inverse: #0043ce;\n  --cds-support-success: #42be65;\n  --cds-support-success-inverse: #24a148;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(244, 244, 244, 0.25);\n  --cds-text-error: #ff8389;\n  --cds-text-helper: #a8a8a8;\n  --cds-text-inverse: #161616;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: rgba(255, 255, 255, 0.25);\n  --cds-text-placeholder: rgba(244, 244, 244, 0.4);\n  --cds-text-primary: #f4f4f4;\n  --cds-text-secondary: #c6c6c6;\n  --cds-toggle-off: #6f6f6f;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-feature-flag-enabled(\"enable-css-custom-properties\"): ;\n  --cds-tag-background-red: #a2191f;\n  --cds-tag-color-red: #ffd7d9;\n  --cds-tag-hover-red: #c21e25;\n  --cds-tag-background-magenta: #9f1853;\n  --cds-tag-color-magenta: #ffd6e8;\n  --cds-tag-hover-magenta: #bf1d63;\n  --cds-tag-background-purple: #6929c4;\n  --cds-tag-color-purple: #e8daff;\n  --cds-tag-hover-purple: #7c3dd6;\n  --cds-tag-background-blue: #0043ce;\n  --cds-tag-color-blue: #d0e2ff;\n  --cds-tag-hover-blue: #0053ff;\n  --cds-tag-background-cyan: #00539a;\n  --cds-tag-color-cyan: #bae6ff;\n  --cds-tag-hover-cyan: #0066bd;\n  --cds-tag-background-teal: #005d5d;\n  --cds-tag-color-teal: #9ef0f0;\n  --cds-tag-hover-teal: #007070;\n  --cds-tag-background-green: #0e6027;\n  --cds-tag-color-green: #a7f0ba;\n  --cds-tag-hover-green: #11742f;\n  --cds-tag-background-gray: #525252;\n  --cds-tag-color-gray: #f4f4f4;\n  --cds-tag-hover-gray: #636363;\n  --cds-tag-border-red: #fa4d56;\n  --cds-tag-border-blue: #4589ff;\n  --cds-tag-border-cyan: #1192e8;\n  --cds-tag-border-teal: #009d9a;\n  --cds-tag-border-green: #24a148;\n  --cds-tag-border-magenta: #ee5396;\n  --cds-tag-border-purple: #a56eff;\n  --cds-tag-border-gray: #8d8d8d;\n  --cds-tag-border-cool-gray: #878d96;\n  --cds-tag-border-warm-gray: #8f8b8b;\n  --cds-tag-background-cool-gray: #4d5358;\n  --cds-tag-color-cool-gray: #f2f4f8;\n  --cds-tag-hover-cool-gray: #5d646a;\n  --cds-tag-background-warm-gray: #565151;\n  --cds-tag-color-warm-gray: #f7f3f2;\n  --cds-tag-hover-warm-gray: #696363;\n  --cds-button-separator: #161616;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #6f6f6f;\n  --cds-button-tertiary: #ffffff;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #fa4d56;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #393939;\n  --cds-button-tertiary-active: #c6c6c6;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #5e5e5e;\n  --cds-button-tertiary-hover: #f4f4f4;\n  --cds-button-disabled: rgba(141, 141, 141, 0.3);\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  inline-size: 100%;\n  padding-inline: 1rem;\n  display: block;\n  flex: 0 0 100%;\n  max-inline-size: 100%;\n  margin: 3rem 0;\n}\n:host(c4d-locale-button) .cds--btn,\n.cds--locale-btn__container .cds--btn {\n  --cds-layout-size-height-local: clamp(max(var(--cds-layout-size-height-min), var(--cds-layout-size-height-sm)), var(--cds-layout-size-height, var(--cds-layout-size-height-lg)), min(var(--cds-layout-size-height-max), var(--cds-layout-size-height-2xl)));\n  --cds-layout-density-padding-inline-local: clamp(var(--cds-layout-density-padding-inline-min), var(--cds-layout-density-padding-inline, var(--cds-layout-density-padding-inline-normal)), var(--cds-layout-density-padding-inline-max));\n  --temp-1lh: (\n    var(--cds-body-compact-01-line-height, 1.28572) * 1em\n  );\n  --temp-expressive-1lh: (\n    var(--cds-body-compact-02-line-height, 1.375) * 1em\n  );\n  --temp-padding-block-max: calc(\n    (var(--cds-layout-size-height-lg) - var(--temp-1lh)) / 2 -\n      0.0625rem\n  );\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: inline-flex;\n  flex-shrink: 0;\n  justify-content: space-between;\n  border-radius: 0;\n  margin: 0;\n  cursor: pointer;\n  inline-size: -moz-max-content;\n  inline-size: max-content;\n  max-inline-size: 20rem;\n  min-block-size: var(--cds-layout-size-height-local);\n  outline: none;\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) * 3 + 1rem - 0.0625rem);\n  padding-inline-start: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n  text-align: start;\n  text-decoration: none;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9), box-shadow 70ms cubic-bezier(0, 0, 0.38, 0.9), border-color 70ms cubic-bezier(0, 0, 0.38, 0.9), outline 70ms cubic-bezier(0, 0, 0.38, 0.9);\n  vertical-align: top;\n}\n:host(c4d-locale-button) .cds--btn *,\n:host(c4d-locale-button) .cds--btn *::before,\n:host(c4d-locale-button) .cds--btn *::after,\n.cds--locale-btn__container .cds--btn *,\n.cds--locale-btn__container .cds--btn *::before,\n.cds--locale-btn__container .cds--btn *::after {\n  box-sizing: inherit;\n}\n:host(c4d-locale-button) .cds--btn:disabled, :host(c4d-locale-button) .cds--btn:hover:disabled, :host(c4d-locale-button) .cds--btn:focus:disabled, :host(c4d-locale-button) .cds--btn.cds--btn--disabled, :host(c4d-locale-button) .cds--btn.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn:disabled,\n.cds--locale-btn__container .cds--btn:hover:disabled,\n.cds--locale-btn__container .cds--btn:focus:disabled,\n.cds--locale-btn__container .cds--btn.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn.cds--btn--disabled:focus {\n  border-color: var(--cds-button-disabled, #c6c6c6);\n  background: var(--cds-button-disabled, #c6c6c6);\n  box-shadow: none;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  cursor: not-allowed;\n}\n:host(c4d-locale-button) .cds--btn .cds--btn__icon,\n.cds--locale-btn__container .cds--btn .cds--btn__icon {\n  position: absolute;\n  flex-shrink: 0;\n  block-size: 1rem;\n  inline-size: 1rem;\n  inset-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n  inset-inline-end: var(--cds-layout-density-padding-inline-local);\n  margin-block-start: 0.0625rem;\n}\n:host(c4d-locale-button) .cds--btn::-moz-focus-inner,\n.cds--locale-btn__container .cds--btn::-moz-focus-inner {\n  padding: 0;\n  border: 0;\n}\n:host(c4d-locale-button) .cds--btn--primary,\n.cds--locale-btn__container .cds--btn--primary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-primary, #0f62fe);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--primary:hover,\n.cds--locale-btn__container .cds--btn--primary:hover {\n  background-color: var(--cds-button-primary-hover, #0050e6);\n}\n:host(c4d-locale-button) .cds--btn--primary:focus,\n.cds--locale-btn__container .cds--btn--primary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--primary:active,\n.cds--locale-btn__container .cds--btn--primary:active {\n  background-color: var(--cds-button-primary-active, #002d9c);\n}\n:host(c4d-locale-button) .cds--btn--primary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--primary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--primary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--primary:hover,\n.cds--locale-btn__container .cds--btn--primary:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--secondary,\n.cds--locale-btn__container .cds--btn--secondary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-secondary, #393939);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--secondary:hover,\n.cds--locale-btn__container .cds--btn--secondary:hover {\n  background-color: var(--cds-button-secondary-hover, #474747);\n}\n:host(c4d-locale-button) .cds--btn--secondary:focus,\n.cds--locale-btn__container .cds--btn--secondary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--secondary:active,\n.cds--locale-btn__container .cds--btn--secondary:active {\n  background-color: var(--cds-button-secondary-active, #6f6f6f);\n}\n:host(c4d-locale-button) .cds--btn--secondary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--secondary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--secondary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--secondary:hover, :host(c4d-locale-button) .cds--btn--secondary:focus,\n.cds--locale-btn__container .cds--btn--secondary:hover,\n.cds--locale-btn__container .cds--btn--secondary:focus {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary,\n.cds--locale-btn__container .cds--btn--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-tertiary, #0f62fe);\n  background-color: transparent;\n  color: var(--cds-button-tertiary, #0f62fe);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:hover,\n.cds--locale-btn__container .cds--btn--tertiary:hover {\n  background-color: var(--cds-button-tertiary-hover, #0050e6);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:focus,\n.cds--locale-btn__container .cds--btn--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:active,\n.cds--locale-btn__container .cds--btn--tertiary:active {\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n}\n:host(c4d-locale-button) .cds--btn--tertiary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--tertiary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--tertiary:hover,\n.cds--locale-btn__container .cds--btn--tertiary:hover {\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:focus,\n.cds--locale-btn__container .cds--btn--tertiary:focus {\n  background-color: var(--cds-button-tertiary, #0f62fe);\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:active,\n.cds--locale-btn__container .cds--btn--tertiary:active {\n  border-color: transparent;\n  background-color: var(--cds-button-tertiary-active, #002d9c);\n  color: var(--cds-text-inverse, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--tertiary:disabled, :host(c4d-locale-button) .cds--btn--tertiary:hover:disabled, :host(c4d-locale-button) .cds--btn--tertiary:focus:disabled, :host(c4d-locale-button) .cds--btn--tertiary.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--tertiary.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--tertiary.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--tertiary:disabled,\n.cds--locale-btn__container .cds--btn--tertiary:hover:disabled,\n.cds--locale-btn__container .cds--btn--tertiary:focus:disabled,\n.cds--locale-btn__container .cds--btn--tertiary.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--tertiary.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--ghost,\n.cds--locale-btn__container .cds--btn--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-link-primary, #0f62fe);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n:host(c4d-locale-button) .cds--btn--ghost:hover,\n.cds--locale-btn__container .cds--btn--ghost:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n:host(c4d-locale-button) .cds--btn--ghost:focus,\n.cds--locale-btn__container .cds--btn--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--ghost:active,\n.cds--locale-btn__container .cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n:host(c4d-locale-button) .cds--btn--ghost .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n:host(c4d-locale-button) .cds--btn--ghost:hover, :host(c4d-locale-button) .cds--btn--ghost:active,\n.cds--locale-btn__container .cds--btn--ghost:hover,\n.cds--locale-btn__container .cds--btn--ghost:active {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-locale-button) .cds--btn--ghost:active,\n.cds--locale-btn__container .cds--btn--ghost:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n:host(c4d-locale-button) .cds--btn--ghost:disabled, :host(c4d-locale-button) .cds--btn--ghost:hover:disabled, :host(c4d-locale-button) .cds--btn--ghost:focus:disabled, :host(c4d-locale-button) .cds--btn--ghost.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--ghost.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--ghost.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--ghost:disabled,\n.cds--locale-btn__container .cds--btn--ghost:hover:disabled,\n.cds--locale-btn__container .cds--btn--ghost:focus:disabled,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--ghost:not([disabled]) svg,\n.cds--locale-btn__container .cds--btn--ghost:not([disabled]) svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-locale-button) .cds--btn--icon-only,\n.cds--locale-btn__container .cds--btn--icon-only {\n  justify-content: center;\n  padding: 0;\n  block-size: var(--cds-layout-size-height-local);\n  inline-size: var(--cds-layout-size-height-local);\n  padding-block-start: min((var(--cds-layout-size-height-local) - 1rem) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n:host(c4d-locale-button) .cds--btn--icon-only > :first-child,\n.cds--locale-btn__container .cds--btn--icon-only > :first-child {\n  margin-block-start: 0.0625rem;\n  min-inline-size: 1rem;\n}\n:host(c4d-locale-button) .cds--btn--icon-only .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--icon-only .cds--btn__icon {\n  position: static;\n}\n:host(c4d-locale-button) .cds--btn--icon-only.cds--btn--ghost .cds--btn__icon, :host(c4d-locale-button) .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--danger--ghost .cds--btn__icon {\n  margin: 0;\n}\n:host(c4d-locale-button) .cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--sm:not(.cds--btn--icon-only) .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--md:not(.cds--btn--icon-only) .cds--btn__icon {\n  margin-block-start: 0;\n}\n:host(c4d-locale-button) .cds--btn--icon-only.cds--btn--selected,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--selected {\n  background: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n:host(c4d-locale-button) .cds--btn path[data-icon-path=inner-path],\n.cds--locale-btn__container .cds--btn path[data-icon-path=inner-path] {\n  fill: none;\n}\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only[disabled] .cds--btn__icon,\n.cds--locale-btn__container .cds--btn.cds--btn--icon-only.cds--btn--ghost[disabled]:hover .cds--btn__icon {\n  fill: var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n:host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only[disabled],\n.cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only[disabled] {\n  cursor: not-allowed;\n}\n:host(c4d-locale-button) .cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper,\n.cds--locale-btn__container .cds--icon-tooltip--disabled .cds--tooltip-trigger__wrapper {\n  cursor: not-allowed;\n}\n:host(c4d-locale-button) .cds--icon-tooltip--disabled .cds--btn--icon-only[disabled],\n.cds--locale-btn__container .cds--icon-tooltip--disabled .cds--btn--icon-only[disabled] {\n  pointer-events: none;\n}\n:host(c4d-locale-button) .cds--btn--danger,\n.cds--locale-btn__container .cds--btn--danger {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger:hover,\n.cds--locale-btn__container .cds--btn--danger:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n:host(c4d-locale-button) .cds--btn--danger:focus,\n.cds--locale-btn__container .cds--btn--danger:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger:active,\n.cds--locale-btn__container .cds--btn--danger:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n:host(c4d-locale-button) .cds--btn--danger .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--danger .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--danger:hover,\n.cds--locale-btn__container .cds--btn--danger:hover {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary,\n.cds--locale-btn__container .cds--btn--danger--tertiary {\n  border-width: 1px;\n  border-style: solid;\n  border-color: var(--cds-button-danger-secondary, #da1e28);\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:hover,\n.cds--locale-btn__container .cds--btn--danger--tertiary:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:focus,\n.cds--locale-btn__container .cds--btn--danger--tertiary:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:active,\n.cds--locale-btn__container .cds--btn--danger--tertiary:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--danger--tertiary .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger--tertiary .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:hover,\n.cds--locale-btn__container .cds--btn--danger--tertiary:hover {\n  border-color: var(--cds-button-danger-hover, #b81921);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:focus,\n.cds--locale-btn__container .cds--btn--danger--tertiary:focus {\n  background-color: var(--cds-button-danger-primary, #da1e28);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:active,\n.cds--locale-btn__container .cds--btn--danger--tertiary:active {\n  border-color: var(--cds-button-danger-active, #750e13);\n  background-color: var(--cds-button-danger-active, #750e13);\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--tertiary:disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary:hover:disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary:focus:disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--danger--tertiary.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--danger--tertiary.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--danger--tertiary:disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary:hover:disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary:focus:disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--danger--tertiary.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--danger--tertiary.cds--btn--disabled:focus {\n  background: transparent;\n  color: var(--cds-text-on-color-disabled, #8d8d8d);\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost,\n.cds--locale-btn__container .cds--btn--danger--ghost {\n  border-width: 1px;\n  border-style: solid;\n  border-color: transparent;\n  background-color: transparent;\n  color: var(--cds-button-danger-secondary, #da1e28);\n  padding-inline-end: calc(var(--cds-layout-density-padding-inline-local) - 0.0625rem);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:hover,\n.cds--locale-btn__container .cds--btn--danger--ghost:hover {\n  background-color: var(--cds-button-danger-hover, #b81921);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:focus,\n.cds--locale-btn__container .cds--btn--danger--ghost:focus {\n  border-color: var(--cds-button-focus-color, var(--cds-focus, #0f62fe));\n  box-shadow: inset 0 0 0 1px var(--cds-button-focus-color, var(--cds-focus, #0f62fe)), inset 0 0 0 2px var(--cds-background, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:active,\n.cds--locale-btn__container .cds--btn--danger--ghost:active {\n  background-color: var(--cds-button-danger-active, #750e13);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost .cds--btn__icon,\n:host(c4d-locale-button) .cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n.cds--locale-btn__container .cds--btn--danger--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger--ghost .cds--btn__icon path:not([data-icon-path]):not([fill=none]) {\n  fill: currentColor;\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost .cds--btn__icon,\n.cds--locale-btn__container .cds--btn--danger--ghost .cds--btn__icon {\n  position: static;\n  margin-inline-start: 0.5rem;\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:hover, :host(c4d-locale-button) .cds--btn--danger--ghost:active,\n.cds--locale-btn__container .cds--btn--danger--ghost:hover,\n.cds--locale-btn__container .cds--btn--danger--ghost:active {\n  color: var(--cds-text-on-color, #ffffff);\n}\n:host(c4d-locale-button) .cds--btn--danger--ghost:disabled, :host(c4d-locale-button) .cds--btn--danger--ghost:hover:disabled, :host(c4d-locale-button) .cds--btn--danger--ghost:focus:disabled, :host(c4d-locale-button) .cds--btn--danger--ghost.cds--btn--disabled, :host(c4d-locale-button) .cds--btn--danger--ghost.cds--btn--disabled:hover, :host(c4d-locale-button) .cds--btn--danger--ghost.cds--btn--disabled:focus,\n.cds--locale-btn__container .cds--btn--danger--ghost:disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost:hover:disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost:focus:disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn--danger--ghost.cds--btn--disabled:hover,\n.cds--locale-btn__container .cds--btn--danger--ghost.cds--btn--disabled:focus {\n  border-color: transparent;\n  background: transparent;\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn--expressive,\n.cds--locale-btn__container .cds--btn--expressive {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding-block: min((var(--cds-layout-size-height-local) - var(--temp-expressive-1lh)) / 2 - 0.0625rem, var(--temp-padding-block-max));\n}\n:host(c4d-locale-button) .cds--btn--icon-only.cds--btn--expressive,\n.cds--locale-btn__container .cds--btn--icon-only.cds--btn--expressive {\n  padding: 12px 13px;\n}\n:host(c4d-locale-button) .cds--btn.cds--btn--expressive .cds--btn__icon,\n.cds--locale-btn__container .cds--btn.cds--btn--expressive .cds--btn__icon {\n  block-size: 1.25rem;\n  inline-size: 1.25rem;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--expressive,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--expressive {\n  max-inline-size: 20rem;\n}\n:host(c4d-locale-button) .cds--btn.cds--skeleton,\n.cds--locale-btn__container .cds--btn.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n  inline-size: 9.375rem;\n}\n:host(c4d-locale-button) .cds--btn.cds--skeleton:hover, :host(c4d-locale-button) .cds--btn.cds--skeleton:focus, :host(c4d-locale-button) .cds--btn.cds--skeleton:active,\n.cds--locale-btn__container .cds--btn.cds--skeleton:hover,\n.cds--locale-btn__container .cds--btn.cds--skeleton:focus,\n.cds--locale-btn__container .cds--btn.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n:host(c4d-locale-button) .cds--btn.cds--skeleton::before,\n.cds--locale-btn__container .cds--btn.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  :host(c4d-locale-button) .cds--btn.cds--skeleton::before,\n  .cds--locale-btn__container .cds--btn.cds--skeleton::before {\n    animation: none;\n  }\n}\n:host(c4d-locale-button) .cds--btn-set,\n.cds--locale-btn__container .cds--btn-set {\n  display: flex;\n}\n:host(c4d-locale-button) .cds--btn-set--stacked,\n.cds--locale-btn__container .cds--btn-set--stacked {\n  flex-direction: column;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn,\n.cds--locale-btn__container .cds--btn-set .cds--btn {\n  inline-size: 100%;\n  max-inline-size: 12.25rem;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn:not(:focus),\n.cds--locale-btn__container .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn:first-of-type:not(:focus),\n.cds--locale-btn__container .cds--btn-set .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn:focus + .cds--btn,\n.cds--locale-btn__container .cds--btn-set .cds--btn:focus + .cds--btn {\n  box-shadow: inherit;\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn:not(:focus),\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn:not(:focus) {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-button-separator, #e0e0e0);\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn:first-of-type:not(:focus),\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn:first-of-type:not(:focus) {\n  box-shadow: inherit;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--disabled {\n  box-shadow: -0.0625rem 0 0 0 var(--cds-icon-on-color-disabled, #8d8d8d);\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--disabled:first-of-type,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn.cds--btn--disabled,\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn.cds--btn--disabled {\n  box-shadow: 0 -0.0625rem 0 0 var(--cds-layer-selected-disabled, #8d8d8d);\n}\n:host(c4d-locale-button) .cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type,\n.cds--locale-btn__container .cds--btn-set--stacked .cds--btn.cds--btn--disabled:first-of-type {\n  box-shadow: none;\n}\n:host(c4d-locale-button) .cds--btn-set .cds--btn.cds--btn--loading,\n.cds--locale-btn__container .cds--btn-set .cds--btn.cds--btn--loading {\n  border-color: transparent;\n  background-color: transparent;\n  box-shadow: none;\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  :host(c4d-locale-button) .cds--btn:focus,\n  .cds--locale-btn__container .cds--btn:focus {\n    color: Highlight;\n    outline: 1px solid Highlight;\n  }\n}\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  :host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  :host(c4d-locale-button) .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon,\n  .cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon path:not([data-icon-path]):not([fill=none]),\n  .cds--locale-btn__container .cds--btn--ghost.cds--btn--icon-only .cds--btn__icon {\n    fill: ButtonText;\n  }\n}\n:host(c4d-locale-button) [dir=rtl] .cds--btn-set .cds--btn:not(:focus),\n.cds--locale-btn__container [dir=rtl] .cds--btn-set .cds--btn:not(:focus) {\n  box-shadow: 0.0625rem 0 0 0 var(--cds-button-separator, #e0e0e0);\n}\n.cds--row--condensed :host(c4d-locale-button), .cds--grid--condensed :host(c4d-locale-button),\n.cds--row--condensed .cds--locale-btn__container,\n.cds--grid--condensed .cds--locale-btn__container {\n  padding-inline: 0.03125rem;\n}\n.cds--row--narrow :host(c4d-locale-button), .cds--grid--narrow :host(c4d-locale-button),\n.cds--row--narrow .cds--locale-btn__container,\n.cds--grid--narrow .cds--locale-btn__container {\n  padding-inline: 0 1rem;\n}\n:host(c4d-locale-button) .c4d--locale-btn,\n.cds--locale-btn__container .c4d--locale-btn {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n  align-items: center;\n  inline-size: 100%;\n  max-inline-size: 100%;\n  padding-inline-end: 0.75rem;\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n@media (min-width: 42rem) {\n  :host(c4d-locale-button) .c4d--locale-btn,\n  .cds--locale-btn__container .c4d--locale-btn {\n    min-inline-size: 13.5rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-locale-button),\n  .cds--locale-btn__container {\n    align-self: end;\n    margin-block: 0 4rem;\n    padding-inline: 0;\n    display: block;\n    flex: 0 0 50%;\n    max-inline-size: 50%;\n    margin-inline-start: 25%;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-locale-button),\n  .cds--locale-btn__container {\n    display: block;\n    flex: 0 0 25%;\n    max-inline-size: 25%;\n    margin-inline-start: 62.5%;\n  }\n}\n\n:host(c4d-footer[size=short]) ::slotted(c4d-locale-button),\n.cds--footer--short .cds--locale-btn__container {\n  margin-block-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-footer[size=short]) ::slotted(c4d-locale-button),\n  .cds--footer--short .cds--locale-btn__container {\n    margin-block-start: 0;\n    margin-inline-start: 25%;\n  }\n  :host(c4d-footer[size=short]) ::slotted(c4d-locale-button) .cds--locale-btn,\n  .cds--footer--short .cds--locale-btn__container .cds--locale-btn {\n    float: inline-end;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-footer[size=short]) ::slotted(c4d-locale-button),\n  .cds--footer--short .cds--locale-btn__container {\n    margin-inline-start: 62.5%;\n  }\n}\n\n.cds--footer--micro .cds--locale-btn__container {\n  padding: 0;\n}\n.cds--footer--micro .cds--locale-btn__container .cds--btn--tertiary:hover, .cds--footer--micro .cds--locale-btn__container .cds--btn--tertiary:focus {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--side-nav {\n  position: fixed;\n  z-index: 8000;\n  overflow: hidden;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 3rem;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  max-inline-size: 16rem;\n  transition: inline-size 0.11s cubic-bezier(0.2, 0, 1, 0.9), transform 0.11s cubic-bezier(0.2, 0, 1, 0.9);\n  will-change: inline-size;\n}\n\n.cds--side-nav--ux {\n  inline-size: 16rem;\n  inset-block-start: 3rem;\n}\n@media (max-width: 65.98rem) {\n  .cds--side-nav--ux {\n    inline-size: 0;\n  }\n}\n\n.cds--side-nav--rail {\n  inline-size: 3rem;\n}\n\n.cds--side-nav--hidden {\n  inline-size: 0;\n}\n\n.cds--side-nav--expanded {\n  inline-size: 16rem;\n}\n\n.cds--side-nav__overlay {\n  position: fixed;\n  background-color: transparent;\n  block-size: 0;\n  inline-size: 0;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n}\n\n@media (max-width: 65.98rem) {\n  .cds--side-nav__overlay-active {\n    z-index: 6000;\n    background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n    block-size: 100vh;\n    inline-size: 100vw;\n    opacity: 1;\n    transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  }\n}\n\n.cds--header ~ .cds--side-nav {\n  block-size: calc(100% - 48px);\n  inset-block-start: 3rem;\n}\n\n.cds--side-nav--fixed {\n  inline-size: 16rem;\n}\n\n.cds--side-nav--collapsed {\n  inline-size: 16rem;\n  transform: translateX(-16rem);\n}\n\n.cds--side-nav__navigation {\n  display: flex;\n  flex-direction: column;\n}\n\n.cds--side-nav__items {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  overflow: hidden;\n  flex: 1 1 0%;\n  padding: 1rem 0 0;\n}\n.cds--side-nav__items *,\n.cds--side-nav__items *::before,\n.cds--side-nav__items *::after {\n  box-sizing: inherit;\n}\n.cds--side-nav:hover .cds--side-nav__items, .cds--side-nav--fixed .cds--side-nav__items, .cds--side-nav--expanded .cds--side-nav__items {\n  overflow-y: auto;\n}\n\n.cds--side-nav--ux .cds--side-nav__items {\n  overflow-y: auto;\n}\n\n.cds--side-nav__item {\n  overflow: hidden;\n  block-size: auto;\n  inline-size: auto;\n}\n\n.cds--side-nav--ux .cds--side-nav__item {\n  block-size: auto;\n  inline-size: auto;\n}\n\n.cds--side-nav__item:not(.cds--side-nav__item--active):hover .cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__submenu:hover,\n.cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__link:hover,\n.cds--side-nav__menu a.cds--side-nav__link:not(.cds--side-nav__link--current):not([aria-current=page]):hover,\n.cds--side-nav a.cds--header__menu-item:hover,\n.cds--side-nav .cds--header__menu-title[aria-expanded=true]:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item:not(.cds--side-nav__item--active) > .cds--side-nav__link:hover > span,\n.cds--side-nav__item:not(.cds--side-nav__item--active) .cds--side-nav__menu-item > .cds--side-nav__link:hover > span {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item--large {\n  block-size: auto;\n}\n\n.cds--side-nav__divider {\n  margin: 0.5rem 1rem;\n  background-color: var(--cds-border-subtle);\n  block-size: 1px;\n  list-style-type: none;\n}\n\n.cds--side-nav__divider hr {\n  border: none;\n}\n\n.cds--side-nav__submenu {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  block-size: 2rem;\n  color: var(--cds-text-secondary, #525252);\n  transition: color 110ms, background-color 110ms, outline 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n.cds--side-nav__submenu *,\n.cds--side-nav__submenu *::before,\n.cds--side-nav__submenu *::after {\n  box-sizing: inherit;\n}\n.cds--side-nav__submenu::-moz-focus-inner {\n  border: 0;\n}\n\n.cds--side-nav__submenu:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__submenu:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--side-nav__submenu:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--side-nav__submenu-title {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  text-align: start;\n}\n\n.cds--side-nav__icon.cds--side-nav__submenu-chevron {\n  display: flex;\n  flex: 1;\n  justify-content: flex-end;\n}\n\n.cds--side-nav__submenu-chevron > svg {\n  block-size: 1rem;\n  inline-size: 1rem;\n  transition: transform 110ms;\n}\n\n.cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  transform: rotate(180deg);\n}\n\n.cds--side-nav__item--large .cds--side-nav__submenu {\n  block-size: 3rem;\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu:hover {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false] {\n  position: relative;\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  color: var(--cds-text-primary, #161616);\n}\n.cds--side-nav__item--active .cds--side-nav__submenu[aria-expanded=false]::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 3px;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--side-nav__item--active .cds--side-nav__submenu-title {\n  color: var(--cds-text-primary, #161616);\n  font-weight: 600;\n}\n\n.cds--side-nav__item--active .cds--side-nav__icon > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--side-nav__menu {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: block;\n  max-block-size: 0;\n  visibility: hidden;\n}\n.cds--side-nav__menu *,\n.cds--side-nav__menu *::before,\n.cds--side-nav__menu *::after {\n  box-sizing: inherit;\n}\n\n.cds--side-nav__submenu[aria-expanded=true] + .cds--side-nav__menu {\n  max-block-size: 93.75rem;\n  visibility: inherit;\n}\n\n.cds--side-nav__menu a.cds--side-nav__link {\n  block-size: 2rem;\n  font-weight: 400;\n  min-block-size: 2rem;\n  padding-inline-start: 2rem;\n}\n\n.cds--side-nav__item.cds--side-nav__item--icon a.cds--side-nav__link {\n  padding-inline-start: 4.5rem;\n}\n\n.cds--side-nav__menu a.cds--side-nav__link--current,\n.cds--side-nav__menu a.cds--side-nav__link[aria-current=page],\na.cds--side-nav__link--current {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n.cds--side-nav__menu a.cds--side-nav__link--current > span,\n.cds--side-nav__menu a.cds--side-nav__link[aria-current=page] > span,\na.cds--side-nav__link--current > span {\n  color: var(--cds-text-primary, #161616);\n  font-weight: 600;\n}\n\na.cds--side-nav__link,\n.cds--side-nav a.cds--header__menu-item,\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  min-block-size: 2rem;\n  text-decoration: none;\n  transition: color 110ms, background-color 110ms, outline 110ms;\n}\n\n.cds--side-nav__item--large a.cds--side-nav__link {\n  block-size: 3rem;\n}\n\na.cds--side-nav__link > .cds--side-nav__link-text,\n.cds--side-nav a.cds--header__menu-item .cds--text-truncate-end {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  color: var(--cds-text-secondary, #525252);\n  font-size: 0.875rem;\n  letter-spacing: 0.1px;\n  line-height: 1.25rem;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\na.cds--side-nav__link:focus,\n.cds--side-nav a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  a.cds--side-nav__link:focus,\n  .cds--side-nav a.cds--header__menu-item:focus {\n    outline-style: dotted;\n  }\n}\n\na.cds--side-nav__link[aria-current=page],\na.cds--side-nav__link--current {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n  font-weight: 600;\n}\n\na.cds--side-nav__link[aria-current=page] .cds--side-nav__link-text,\na.cds--side-nav__link--current .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--side-nav__link[aria-current=page]::before,\na.cds--side-nav__link--current::before {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 3px;\n  inset-block-end: 0;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--side-nav__icon {\n  display: flex;\n  flex: 0 0 1rem;\n  align-items: center;\n  justify-content: center;\n}\n\n.cds--side-nav__icon:not(.cds--side-nav__submenu-chevron) {\n  margin-inline-end: 1.5rem;\n}\n\n.cds--side-nav__icon > svg {\n  block-size: 1rem;\n  fill: var(--cds-icon-secondary, #525252);\n  inline-size: 1rem;\n}\n\n.cds--side-nav__icon > svg.cds--side-nav-collapse-icon {\n  display: none;\n}\n\n.cds--side-nav--expanded .cds--side-nav__icon > svg.cds--side-nav-expand-icon {\n  display: none;\n}\n\n.cds--side-nav--expanded .cds--side-nav__icon > svg.cds--side-nav-collapse-icon {\n  display: block;\n}\n\n.cds--side-nav--fixed a.cds--side-nav__link,\n.cds--side-nav--fixed .cds--side-nav__submenu {\n  padding-inline-start: 1rem;\n}\n\n.cds--side-nav--fixed .cds--side-nav__item:not(.cds--side-nav__item--icon) .cds--side-nav__menu a.cds--side-nav__link {\n  padding-inline-start: 2rem;\n}\n\n@media (max-width: 65.98rem) {\n  .cds--side-nav .cds--header__nav {\n    display: block;\n  }\n}\n\n.cds--side-nav__header-navigation {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: none;\n}\n.cds--side-nav__header-navigation *,\n.cds--side-nav__header-navigation *::before,\n.cds--side-nav__header-navigation *::after {\n  box-sizing: inherit;\n}\n@media (max-width: 65.98rem) {\n  .cds--side-nav__header-navigation {\n    position: relative;\n    display: block;\n    margin-block-end: 2rem;\n  }\n}\n\n.cds--side-nav__header-divider::after {\n  position: absolute;\n  background: var(--cds-border-subtle);\n  block-size: 0.0625rem;\n  content: \"\";\n  inline-size: calc(100% - 32px);\n  inset-block-end: -1rem;\n  inset-inline-start: 1rem;\n}\n\n.cds--side-nav a.cds--header__menu-item {\n  justify-content: space-between;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n}\n.cds--side-nav a.cds--header__menu-item[aria-expanded=true] {\n  background-color: transparent;\n}\n\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  padding: 0;\n  background-color: transparent;\n  box-shadow: none;\n  inline-size: 100%;\n  inset-block-end: inherit;\n  transform: none;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li {\n  inline-size: 100%;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item {\n  font-weight: 400;\n  padding-inline-start: 4.25rem;\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n.cds--side-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu a.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n\n.cds--side-nav .cds--side-nav__header-navigation a.cds--header__menu-item[aria-current=page]::after,\n.cds--side-nav .cds--side-nav__header-navigation .cds--header__menu-item--current::after {\n  block-size: calc(100% + 4px);\n  inline-size: 3px;\n}\n\n.cds--side-nav .cds--header__menu a.cds--header__menu-item {\n  block-size: inherit;\n}\n\n.cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,\n.cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,\n.cds--side-nav .cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--side-nav__icon > svg,\n  .cds--side-nav a.cds--header__menu-item:hover .cds--header__menu-arrow,\n  .cds--side-nav a.cds--header__menu-item:focus .cds--header__menu-arrow,\n  .cds--side-nav .cds--header__menu-arrow {\n    fill: ButtonText;\n  }\n}\n\n.cds--content {\n  padding: 2rem;\n  color: var(--cds-text-primary, #161616);\n  will-change: margin-left;\n}\n\n.cds--header ~ .cds--content,\ndiv:has(.cds--header) ~ .cds--content {\n  margin-block-start: 3rem;\n}\n\n.cds--side-nav ~ .cds--content {\n  margin-inline-start: 3rem;\n}\n\n.cds--side-nav.cds--side-nav--expanded ~ .cds--content {\n  margin-inline-start: 16rem;\n}\n\n.cds--header {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  position: fixed;\n  z-index: 8000;\n  display: flex;\n  align-items: center;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: 1px solid var(--cds-border-subtle);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n  inset-inline-start: 0;\n}\n.cds--header *,\n.cds--header *::before,\n.cds--header *::after {\n  box-sizing: inherit;\n}\n\n.cds--header__action {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: inline-block;\n  padding: 0;\n  border: 0;\n  -webkit-appearance: none;\n     -moz-appearance: none;\n          appearance: none;\n  background: none;\n  cursor: pointer;\n  text-align: start;\n  inline-size: 100%;\n  display: inline-flex;\n  border: 0.0625rem solid transparent;\n  block-size: 3rem;\n  inline-size: 3rem;\n  transition: background-color 110ms, border-color 110ms;\n}\n.cds--header__action *,\n.cds--header__action *::before,\n.cds--header__action *::after {\n  box-sizing: inherit;\n}\n.cds--header__action::-moz-focus-inner {\n  border: 0;\n}\n@media (max-width: 41.98rem) {\n  .cds--header__action {\n    min-inline-size: 3rem;\n  }\n}\n\n.cds--header__global .cds--popover {\n  z-index: 8001;\n}\n\n.cds--header__action > :first-child {\n  margin-block-start: 0;\n}\n\n.cds--header__action > svg.cds--navigation-menu-panel-collapse-icon,\n.cds--header__action--active > svg.cds--navigation-menu-panel-expand-icon {\n  display: none;\n}\n\n.cds--header__action--active > svg.cds--navigation-menu-panel-collapse-icon {\n  display: inline;\n}\n\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__action--active {\n  background: var(--cds-layer);\n  border-block-end: 1px solid transparent;\n  border-inline-end: 1px solid var(--cds-border-subtle);\n  border-inline-start: 1px solid var(--cds-border-subtle);\n}\n\n.cds--header__action--active > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__action:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\n.cds--header__action:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n}\n\n.cds--header__action.cds--btn--icon-only {\n  align-items: center;\n  justify-content: center;\n}\n\n.cds--btn.cds--btn--icon-only.cds--header__action svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--btn.cds--btn--icon-only.cds--header__action:hover svg,\n.cds--btn.cds--btn--icon-only.cds--header__action:active svg,\n.cds--btn.cds--btn--icon-only.cds--header__action--active svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-trigger > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-trigger:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\n.cds--header__menu-toggle {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n@media (min-width: 66rem) {\n  .cds--header__menu-toggle__hidden {\n    display: none;\n  }\n}\n\na.cds--header__name {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  padding: 0 2rem 0 1rem;\n  border: 0.125rem solid transparent;\n  block-size: 100%;\n  font-weight: 600;\n  letter-spacing: 0.1px;\n  line-height: 1.25rem;\n  outline: none;\n  text-decoration: none;\n  transition: border-color 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n@media (max-width: 41.98rem) {\n  a.cds--header__name {\n    padding: 0 1rem;\n  }\n}\n\na.cds--header__name:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--header__name--prefix {\n  font-weight: 400;\n}\n\na.cds--header__name,\na.cds--header__name:hover {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-toggle:not(.cds--header__menu-toggle__hidden) ~ .cds--header__name {\n  padding-inline-start: 0.5rem;\n}\n\n.cds--header__nav {\n  position: relative;\n  display: none;\n  block-size: 100%;\n  padding-inline-start: 1rem;\n}\n@media (min-width: 66rem) {\n  .cds--header__nav {\n    display: block;\n  }\n}\n.cds--header__nav::before {\n  position: absolute;\n  display: block;\n  background-color: var(--cds-border-subtle);\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__menu-bar {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: flex;\n  padding: 0;\n  margin: 0;\n  block-size: 100%;\n  list-style: none;\n}\n.cds--header__menu-bar *,\n.cds--header__menu-bar *::before,\n.cds--header__menu-bar *::after {\n  box-sizing: inherit;\n}\n\na.cds--header__menu-item {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: 2px solid transparent;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  color: var(--cds-text-secondary, #525252);\n  font-size: 0.875rem;\n  font-weight: 400;\n  letter-spacing: 0;\n  line-height: 1.125rem;\n  text-decoration: none;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\na.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__action:active,\na.cds--header__menu-item:active {\n  background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--header__menu-item:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  outline: none;\n}\n\na.cds--header__menu-item:hover > svg,\na.cds--header__menu-item:active > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n\na.cds--header__menu-item[aria-current=page],\n.cds--header__menu-item--current {\n  color: var(--cds-text-primary, #161616);\n}\n\na.cds--header__menu-item[aria-current=page]::after,\n.cds--header__menu-item--current::after {\n  position: absolute;\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: 3px;\n  content: \"\";\n  inline-size: calc(100% + 4px);\n  inset-block-end: -2px;\n  inset-inline-start: -2px;\n}\n\na.cds--header__menu-item[aria-current=page]:focus::after,\n.cds--header__menu-item--current:focus::after {\n  border: 0;\n}\n\n.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]::after,\n.cds--header__submenu .cds--header__menu .cds--header__menu-item--current::after {\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: calc(100% + 4px);\n  inline-size: 3px;\n  inset-block-start: -2px;\n  inset-inline-start: -2px;\n}\n.cds--header__submenu .cds--header__menu a.cds--header__menu-item[aria-current=page]:focus::after,\n.cds--header__submenu .cds--header__menu .cds--header__menu-item--current:focus::after {\n  background-color: var(--cds-border-interactive, #0f62fe);\n  block-size: calc(100% + 4px);\n  inline-size: 5px;\n  inset-block-start: -2px;\n  inset-inline-start: -2px;\n}\n\na.cds--header__menu-item[aria-current=page]:focus,\na.cds--header__menu-item.cds--header__menu-item--current:focus {\n  border: 2px solid var(--cds-focus, #0f62fe);\n}\n\n.cds--header__submenu {\n  position: relative;\n}\n\n.cds--header__menu-title[aria-haspopup=true] {\n  position: relative;\n}\n\n.cds--header__menu-title[aria-expanded=true] {\n  z-index: 8002;\n  background-color: var(--cds-layer);\n  color: var(--cds-text-secondary, #525252);\n}\n\n.cds--header__menu-title[aria-expanded=true] > .cds--header__menu-arrow {\n  transform: rotate(180deg);\n}\n\n.cds--header__menu {\n  display: none;\n  padding: 0;\n  margin: 0;\n  list-style: none;\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  position: absolute;\n  z-index: 8001;\n  display: flex;\n  flex-direction: column;\n  background-color: var(--cds-layer);\n  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.5);\n  inline-size: 12.5rem;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n  transform: translateY(100%);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item {\n  background-color: var(--cds-layer);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover {\n  background-color: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:active {\n  background-color: var(--cds-layer-active);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item.cds--header__menu-item--current {\n  background-color: var(--cds-layer-selected);\n}\n.cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item.cds--header__menu-item--current:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n\n.cds--header__menu .cds--header__menu-item {\n  block-size: 3rem;\n}\n\n.cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n  margin-inline-start: 0.5rem;\n  transition: transform 110ms, fill 110ms;\n}\n\n.cds--header__global {\n  display: flex;\n  flex: 1 1 0%;\n  justify-content: flex-end;\n  block-size: 100%;\n}\n\n.cds--skip-to-content {\n  position: absolute;\n  overflow: hidden;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  block-size: 1px;\n  clip: rect(0, 0, 0, 0);\n  inline-size: 1px;\n  visibility: inherit;\n  white-space: nowrap;\n}\n\n.cds--skip-to-content:focus {\n  z-index: 9999;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: 4px solid var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  clip: auto;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: auto;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  outline: none;\n}\n\n.cds--header-panel {\n  position: fixed;\n  z-index: 8000;\n  overflow: hidden;\n  border: none;\n  background-color: var(--cds-layer);\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 0;\n  inset-block-end: 0;\n  inset-block-start: 3rem;\n  inset-inline-end: 0;\n  transition: width 110ms cubic-bezier(0.2, 0, 1, 0.9);\n  will-change: width;\n}\n\n.cds--header-panel--expanded {\n  border-inline-end: 1px solid var(--cds-border-subtle);\n  border-inline-start: 1px solid var(--cds-border-subtle);\n  inline-size: 16rem;\n  overflow-y: auto;\n}\n\n.cds--switcher {\n  box-sizing: border-box;\n  padding: 0;\n  border: 0;\n  margin: 0;\n  font-family: inherit;\n  font-size: 100%;\n  vertical-align: baseline;\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  color: var(--cds-text-secondary, #525252);\n}\n.cds--switcher *,\n.cds--switcher *::before,\n.cds--switcher *::after {\n  box-sizing: inherit;\n}\n\n.cds--switcher__item {\n  block-size: 2rem;\n  inline-size: 100%;\n}\n\n.cds--switcher__item:nth-child(1) {\n  margin-block-start: 1rem;\n}\n\n.cds--switcher__item--divider {\n  display: block;\n  border: none;\n  margin: 0.5rem 1rem;\n  background: var(--cds-border-subtle);\n  block-size: 1px;\n  inline-size: 14rem;\n}\n\n.cds--switcher__item-link {\n  font-size: var(--cds-heading-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-heading-compact-01-font-weight, 600);\n  line-height: var(--cds-heading-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-heading-compact-01-letter-spacing, 0.16px);\n  display: block;\n  padding: 0.375rem 1rem;\n  block-size: 2rem;\n  color: var(--cds-text-secondary, #525252);\n  text-decoration: none;\n}\n.cds--switcher__item-link:hover:not(.cds--switcher__item-link--selected) {\n  background: var(--cds-layer-hover);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n}\n.cds--switcher__item-link:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--switcher__item-link:active {\n  background: var(--cds-layer-active);\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--switcher__item-link--selected {\n  background: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n.cds--link-with-icon span,\n:host(c4d-link-with-icon) span,\n:host(c4d-link-list-item) span,\n:host(c4d-link-list-item-cta) span,\n:host(c4d-text-cta) span {\n  flex: 1;\n  align-self: center;\n  vertical-align: middle;\n}\n.cds--link-with-icon svg,\n.cds--link-with-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) svg,\n:host(c4d-link-with-icon) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) svg,\n:host(c4d-link-list-item) ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) svg,\n:host(c4d-link-list-item-cta) ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) svg,\n:host(c4d-text-cta) ::slotted(svg[slot=icon]) {\n  display: inline;\n  align-self: middle;\n  fill: currentColor;\n  margin-inline-start: 0.5rem;\n}\n.cds--link-with-icon.cds--link--visited,\n:host(c4d-link-with-icon).cds--link--visited,\n:host(c4d-link-list-item).cds--link--visited,\n:host(c4d-link-list-item-cta).cds--link--visited,\n:host(c4d-text-cta).cds--link--visited {\n  color: var(--cds-link-visited, #8a3ffc);\n}\n.cds--link-with-icon.cds--link--disabled:hover,\n:host(c4d-link-with-icon).cds--link--disabled:hover,\n:host(c4d-link-list-item).cds--link--disabled:hover,\n:host(c4d-link-list-item-cta).cds--link--disabled:hover,\n:host(c4d-text-cta).cds--link--disabled:hover {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n}\n.cds--link-with-icon .cds--link--disabled,\n:host(c4d-link-with-icon) .cds--link--disabled,\n:host(c4d-link-list-item) .cds--link--disabled,\n:host(c4d-link-list-item-cta) .cds--link--disabled,\n:host(c4d-text-cta) .cds--link--disabled {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left,\n:host(c4d-text-cta).cds--link-with-icon__icon-left,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left {\n  display: flex;\n  flex-direction: row-reverse;\n  justify-content: flex-end;\n}\n.cds--link-with-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n.cds--link-with-icon .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta).cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta).cds--link-with-icon__icon-left ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon.cds--link-with-icon__icon-left ::slotted(svg[slot=icon]) {\n  position: relative;\n  align-self: start;\n  inset-block-start: 1px;\n  margin-inline: 0 0.5rem;\n}\n\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon {\n  display: inline-block;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon:hover {\n  text-underline-position: under;\n}\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n.cds--link-with-icon__container .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-callout-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-cta-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-card-footer) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-with-icon) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-link-list-item-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon svg,\n:host(c4d-text-cta) .cds--link-with-icon.cds--link-with-icon--inline-icon ::slotted(svg[slot=icon]) {\n  display: inline;\n  vertical-align: middle;\n  white-space: nowrap;\n}\n\n:host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n  display: none;\n}\n@media (min-width: 66rem) {\n  :host(c4d-card-cta-footer)[mode=link-list][cta-type=video] .cds--link-with-icon.cds--link-with-icon--inline-icon span {\n    display: inline;\n  }\n}\n\n.cds--link-with-icon:not(:first-of-type),\n:host(c4d-link-with-icon):not(:first-of-type),\n:host(c4d-text-cta):not(:first-of-type) {\n  margin-inline-start: 2rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-left::slotted(svg[slot=icon]) {\n  margin-inline: 0 0.5rem;\n}\n.cds--link-with-icon .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-link-with-icon) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]),\n:host(c4d-text-cta) .cds--link-with-icon__icon-right::slotted(svg[slot=icon]) {\n  margin-inline: 0.5rem 0;\n}\n.cds--link-with-icon:focus,\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.cds--link-with-icon:active,\n:host(c4d-link-with-icon):active,\n:host(c4d-text-cta):active {\n  text-decoration: none;\n}\n\n:host(c4d-link-with-icon):focus,\n:host(c4d-text-cta):focus {\n  outline: none;\n}\n\n:host(c4d-link-with-icon),\n.cds--link-with-icon__container {\n  display: table;\n}\n\n/**\n* Copyright IBM Corp. 2016, 2021\n*\n* This source code is licensed under the Apache-2.0 license found in the\n* LICENSE file in the root directory of this source tree.\n*/\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2025\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n*/\n.cds--dropdown__wrapper--inline {\n  display: inline-grid;\n  align-items: center;\n  grid-gap: 0 1.5rem;\n  grid-template: auto auto/auto min-content;\n}\n.cds--dropdown__wrapper--inline .cds--label {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n.cds--dropdown__wrapper--inline .cds--label,\n.cds--dropdown__wrapper--inline .cds--form__helper-text,\n.cds--dropdown__wrapper--inline .cds--form-requirement {\n  margin: 0;\n}\n.cds--dropdown__wrapper--inline .cds--form-requirement {\n  grid-column: 2;\n}\n\n.cds--dropdown {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  position: relative;\n  display: block;\n  border: none;\n  background-color: var(--cds-field);\n  block-size: 2.5rem;\n  border-block-end: 1px solid var(--cds-border-strong);\n  color: var(--cds-text-primary, #161616);\n  cursor: pointer;\n  inline-size: 100%;\n  list-style: none;\n  outline: 2px solid transparent;\n  transition: background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--dropdown html {\n  font-size: 100%;\n}\n.cds--dropdown body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--dropdown code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--dropdown strong {\n  font-weight: 600;\n}\n.cds--dropdown:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--dropdown .cds--list-box__field {\n  text-align: start;\n}\n\n.cds--dropdown--lg {\n  block-size: 3rem;\n  max-block-size: 3rem;\n}\n\n.cds--dropdown--lg .cds--dropdown__arrow {\n  inset-block-start: 1rem;\n}\n\n.cds--dropdown--sm {\n  block-size: 2rem;\n  max-block-size: 2rem;\n}\n\n.cds--dropdown--sm .cds--dropdown__arrow {\n  inset-block-start: 0.5rem;\n}\n\n.cds--dropdown--open {\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--dropdown--open .cds--list-box__field {\n  outline: none;\n}\n\n.cds--dropdown--invalid {\n  outline: 2px solid var(--cds-support-error, #da1e28);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown--invalid {\n    outline-style: dotted;\n  }\n}\n.cds--dropdown--invalid .cds--dropdown-text {\n  padding-inline-end: 3.5rem;\n}\n.cds--dropdown--invalid + .cds--form-requirement {\n  display: inline-block;\n  color: var(--cds-text-error, #da1e28);\n  max-block-size: 12.5rem;\n}\n\n.cds--dropdown__invalid-icon {\n  position: absolute;\n  fill: var(--cds-support-error, #da1e28);\n  inset-block-start: 50%;\n  inset-inline-end: 2.5rem;\n  transform: translateY(-50%);\n}\n\n.cds--dropdown--open:hover {\n  background-color: var(--cds-field);\n}\n\n.cds--dropdown--open:focus {\n  outline: 1px solid transparent;\n}\n\n.cds--dropdown--open .cds--dropdown-list {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  max-block-size: 13.75rem;\n  transition: max-height 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n\n.cds--dropdown--light {\n  background-color: var(--cds-field-02, #ffffff);\n}\n.cds--dropdown--light:hover {\n  background-color: var(--cds-field-hover);\n}\n\n.cds--dropdown--up .cds--dropdown-list {\n  inset-block-end: 2rem;\n}\n\n.cds--dropdown__arrow {\n  position: absolute;\n  fill: var(--cds-icon-primary, #161616);\n  inset-block-start: 0.8125rem;\n  inset-inline-end: 1rem;\n  pointer-events: none;\n  transform-origin: 50% 45%;\n  transition: transform 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\nbutton.cds--dropdown-text {\n  border: none;\n  background: none;\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n  text-align: start;\n}\nbutton.cds--dropdown-text:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n@media screen and (prefers-contrast) {\n  button.cds--dropdown-text:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-text {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  display: block;\n  overflow: hidden;\n  block-size: calc(100% + 1px);\n  padding-inline-end: 2.625rem;\n  padding-inline-start: 1rem;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.cds--dropdown-list {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  position: absolute;\n  z-index: 9100;\n  display: flex;\n  flex-direction: column;\n  background-color: var(--cds-layer);\n  inline-size: 100%;\n  list-style: none;\n  max-block-size: 0;\n  overflow-x: hidden;\n  overflow-y: auto;\n  transition: max-height 110ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--dropdown-list html {\n  font-size: 100%;\n}\n.cds--dropdown-list body {\n  font-weight: 400;\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  text-rendering: optimizeLegibility;\n}\n.cds--dropdown-list code {\n  font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n}\n.cds--dropdown-list strong {\n  font-weight: 600;\n}\n\n.cds--dropdown--light .cds--dropdown-list {\n  background-color: var(--cds-layer);\n}\n\n.cds--dropdown:not(.cds--dropdown--open) .cds--dropdown-item {\n  visibility: hidden;\n}\n\n.cds--dropdown-item {\n  position: relative;\n  opacity: 0;\n  transition: visibility 70ms cubic-bezier(0.2, 0, 0.38, 0.9), opacity 70ms cubic-bezier(0.2, 0, 0.38, 0.9), background-color 70ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  visibility: inherit;\n}\n.cds--dropdown-item:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--dropdown-item:hover + .cds--dropdown-item .cds--dropdown-link {\n  border-color: transparent;\n}\n.cds--dropdown-item:active {\n  background-color: var(--cds-layer-selected);\n}\n.cds--dropdown-item:first-of-type .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n\n.cds--dropdown-item:last-of-type .cds--dropdown-link {\n  border-block-end: none;\n}\n\n.cds--dropdown-link {\n  outline: 2px solid transparent;\n  outline-offset: -2px;\n  display: block;\n  overflow: hidden;\n  padding: 0.6875rem 0;\n  border: 1px solid transparent;\n  margin: 0 1rem;\n  block-size: 2.5rem;\n  border-block-start-color: var(--cds-border-subtle);\n  color: var(--cds-text-secondary, #525252);\n  font-weight: normal;\n  line-height: 1rem;\n  text-decoration: none;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n.cds--dropdown-link:hover {\n  border-color: transparent;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--dropdown--light .cds--dropdown-link {\n  border-block-start-color: var(--cds-border-subtle-02, #e0e0e0);\n}\n\n.cds--dropdown--sm .cds--dropdown-link {\n  block-size: 2rem;\n  padding-block-end: 0.4375rem;\n  padding-block-start: 0.4375rem;\n}\n\n.cds--dropdown--focused,\n.cds--dropdown-link:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown--focused,\n  .cds--dropdown-link:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown-link:focus {\n  padding: 0.6875rem 0;\n  margin: 0 1rem;\n  outline: none;\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n  padding: 0.6875rem 1rem;\n  margin: 0;\n}\n@media screen and (prefers-contrast) {\n  .cds--dropdown-list[aria-activedescendant] .cds--dropdown--focused:focus {\n    outline-style: dotted;\n  }\n}\n\n.cds--dropdown-list[aria-activedescendant] .cds--dropdown-item:active {\n  background-color: inherit;\n}\n\n.cds--dropdown-item:hover .cds--dropdown-link {\n  border-block-end-color: var(--cds-layer-hover);\n}\n\n.cds--dropdown--open .cds--dropdown__arrow {\n  transform: rotate(-180deg);\n}\n\n.cds--dropdown--open.cds--dropdown--sm .cds--dropdown-list {\n  max-block-size: 11rem;\n}\n\n.cds--dropdown--open .cds--dropdown-item {\n  opacity: 1;\n}\n\n.cds--dropdown--disabled {\n  border-block-end-color: transparent;\n}\n.cds--dropdown--disabled:hover {\n  background-color: var(--cds-field);\n}\n.cds--dropdown--disabled:focus {\n  outline: none;\n}\n.cds--dropdown--disabled .cds--dropdown-text,\n.cds--dropdown--disabled .cds--list-box__label {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--dropdown--disabled .cds--dropdown__arrow,\n.cds--dropdown--disabled .cds--list-box__menu-icon svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n.cds--dropdown--disabled.cds--dropdown--light:hover {\n  background-color: var(--cds-field-02, #ffffff);\n}\n\n.cds--dropdown--disabled .cds--list-box__field,\n.cds--dropdown--disabled .cds--list-box__menu-icon {\n  cursor: not-allowed;\n}\n\n.cds--dropdown--auto-width {\n  inline-size: auto;\n  max-inline-size: 25rem;\n}\n\n.cds--dropdown--inline {\n  display: inline-block;\n  background-color: transparent;\n  border-block-end-color: transparent;\n  inline-size: auto;\n  justify-self: start;\n  transition: background 70ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n.cds--dropdown--inline:hover {\n  background-color: var(--cds-layer-hover);\n}\n.cds--dropdown--inline.cds--dropdown--disabled {\n  background-color: transparent;\n}\n.cds--dropdown--inline .cds--dropdown__arrow {\n  inset-block-start: 0.5rem;\n  inset-inline-end: 0.5rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--open {\n  background-color: transparent;\n}\n\n.cds--dropdown--inline .cds--dropdown-text {\n  display: inline-block;\n  overflow: visible;\n  padding: 0.4375rem 2rem 0.4375rem 0.75rem;\n  block-size: 2rem;\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--dropdown--inline.cds--dropdown--disabled .cds--dropdown-text {\n  color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n}\n\n.cds--dropdown--inline.cds--dropdown--disabled:focus .cds--dropdown-text {\n  outline: 0;\n}\n\n.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown__invalid-icon {\n  inset-inline-end: 2rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--invalid .cds--dropdown-text {\n  padding-inline-end: 3.5rem;\n}\n\n.cds--dropdown--inline.cds--dropdown--open:focus .cds--dropdown-list {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n}\n\n.cds--dropdown--inline .cds--dropdown-link {\n  font-weight: normal;\n}\n\n.cds--dropdown--show-selected .cds--dropdown--selected {\n  display: block;\n  background-color: var(--cds-layer-selected);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--dropdown--show-selected .cds--dropdown--selected:hover {\n  background-color: var(--cds-layer-selected-hover);\n}\n.cds--dropdown--show-selected .cds--dropdown--selected .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n.cds--dropdown--show-selected .cds--dropdown--selected + .cds--dropdown-item .cds--dropdown-link {\n  border-block-start-color: transparent;\n}\n.cds--dropdown--show-selected .cds--dropdown--selected .cds--list-box__menu-item__selected-icon {\n  display: block;\n}\n\n.cds--dropdown-v2.cds--skeleton,\n.cds--dropdown.cds--skeleton {\n  position: relative;\n  padding: 0;\n  border: none;\n  background: var(--cds-skeleton-background, #e8e8e8);\n  box-shadow: none;\n  pointer-events: none;\n}\n.cds--dropdown-v2.cds--skeleton:hover, .cds--dropdown-v2.cds--skeleton:focus, .cds--dropdown-v2.cds--skeleton:active,\n.cds--dropdown.cds--skeleton:hover,\n.cds--dropdown.cds--skeleton:focus,\n.cds--dropdown.cds--skeleton:active {\n  border: none;\n  cursor: default;\n  outline: none;\n}\n.cds--dropdown-v2.cds--skeleton::before,\n.cds--dropdown.cds--skeleton::before {\n  position: absolute;\n  animation: 3000ms ease-in-out cds--skeleton infinite;\n  background: var(--cds-skeleton-element, #c6c6c6);\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  will-change: transform-origin, transform, opacity;\n}\n@media (prefers-reduced-motion: reduce) {\n  .cds--dropdown-v2.cds--skeleton::before,\n  .cds--dropdown.cds--skeleton::before {\n    animation: none;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--dropdown .cds--list-box__field {\n    outline: 1px solid transparent;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-item__option {\n    outline: none;\n  }\n}\n\n@media screen and (-ms-high-contrast: active), (forced-colors: active) {\n  .cds--list-box__menu-item__selected-icon {\n    fill: ButtonText;\n  }\n}\n\n.cds--dropdown--readonly,\n.cds--dropdown--readonly:hover {\n  background-color: transparent;\n  border-block-end-color: var(--cds-border-subtle);\n}\n\n.cds--dropdown--inline.cds--dropdown--readonly {\n  border-block-end-color: transparent;\n}\n\n.cds--dropdown--readonly .cds--list-box__field,\n.cds--dropdown--readonly .cds--list-box__menu-icon {\n  cursor: default;\n}\n\n.cds--dropdown--readonly .cds--list-box__menu-icon svg {\n  fill: var(--cds-icon-disabled, rgba(22, 22, 22, 0.25));\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n:host(c4d-search-with-typeahead-item) {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-search-with-typeahead-item) span {\n  font-weight: 600;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead-item) .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead-item):hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n:host(c4d-search-with-typeahead-item):hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n:host(c4d-search-with-typeahead-item) .cds--container-highlight-class:not(:hover), :host(c4d-search-with-typeahead-item):focus, :host(c4d-search-with-typeahead-item):active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead-item):last-of-type .cds--container-class {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead-item) span {\n  white-space: pre;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle] {\n  font-size: var(--cds-body-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-01-font-weight, 400);\n  line-height: var(--cds-body-01-line-height, 1.42857);\n  letter-spacing: var(--cds-body-01-letter-spacing, 0.16px);\n  color: var(--cds-text-helper, #6f6f6f);\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:active {\n  outline: none;\n}\n:host(c4d-search-with-typeahead-item)[groupTitle]:hover {\n  background: none;\n  cursor: auto;\n}\n:host(c4d-search-with-typeahead-item)[lastBeforeGroup] .cds--container-class {\n  border-block-end-color: var(--cds-toggle-off, #8d8d8d);\n}\n\n:host(c4d-search-with-typeahead-item[alternate]) {\n  border-block-start: 1px solid var(--cds-border-subtle-01, #c6c6c6);\n}\n\n:host(c4d-scoped-search-dropdown),\n:host(c4d-scoped-search-dropdown-mobile) {\n  display: flex;\n  border-inline-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box {\n  block-size: 3rem;\n  max-block-size: none;\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__field:focus,\n:host(c4d-scoped-search-dropdown-mobile) .cds--list-box__field:focus {\n  outline: none;\n}\n\n@media (max-width: 65.98rem) {\n  :host(c4d-scoped-search-dropdown) {\n    display: none;\n  }\n}\n:host(c4d-scoped-search-dropdown) .cds--list-box__menu {\n  inline-size: -moz-fit-content;\n  inline-size: fit-content;\n}\n\n:host(c4d-scoped-search-dropdown-mobile) {\n  inline-size: 3rem;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select-input {\n  padding: 0;\n  color: transparent;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--select__arrow {\n  position: absolute;\n  inset-inline: 0;\n  margin-inline: auto;\n  text-align: center;\n}\n:host(c4d-scoped-search-dropdown-mobile) .cds--form__helper-text {\n  inline-size: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-scoped-search-dropdown-mobile) {\n    display: none;\n  }\n}\n\n:host(c4d-top-nav),\n.cds--header__search {\n  position: relative;\n  display: flex;\n  flex: 1;\n  align-items: center;\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav,\n.cds--header__search.cds--masthead__platform .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav::before,\n.cds--header__search.cds--masthead__platform .cds--header__nav::before {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--masthead__platform-name,\n.cds--header__search.cds--masthead__platform .cds--masthead__platform-name {\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active .cds--header__nav-container,\n.cds--header__search.cds--masthead__header--search-active .cds--header__nav-container {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n.cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n  .cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n    display: flex;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--header__search:not(.cds--masthead__header--search-active) {\n    overflow-x: visible;\n  }\n}\n\n.cds--header__action {\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border: 0.125rem solid transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__action > svg {\n  position: relative;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__action:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__action:focus, .cds--header__action:active {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n\n.cds--header__search--actions {\n  position: absolute;\n  display: flex;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--header__search--actions .cds--header__search--search,\n.cds--header__search--actions .cds--header__search--close {\n  padding: 0;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-icon-secondary, #525252);\n}\n.cds--header__search--actions .cds--header__search--search:hover,\n.cds--header__search--actions .cds--header__search--close:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__search--actions .cds--header__search--search:hover svg[focusable=false][aria-hidden=true],\n.cds--header__search--actions .cds--header__search--close:hover svg[focusable=false][aria-hidden=true] {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text, .cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text {\n  display: none;\n}\n\n.cds--header__profile .cds--header__action:focus,\n.cds--header__search--actions .cds--btn.cds--btn--icon-only.cds--tooltip__trigger:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\nbutton.cds--header__search--close.cds--header__action[part=close-button] {\n  display: none;\n  overflow: hidden;\n  border: none;\n  inline-size: 0;\n}\nbutton.cds--header__search--close.cds--header__action[part=close-button] svg {\n  position: relative;\n}\n\n.cds--header__search--search {\n  inline-size: 3rem;\n  outline: none;\n}\n\n:host(c4d-search-with-typeahead) {\n  position: relative;\n  display: block;\n  block-size: 3rem;\n  margin-inline-start: 3rem;\n  outline: none;\n}\n:host(c4d-search-with-typeahead) .c4d-ce__search__list {\n  overflow: hidden;\n  margin: 0;\n  block-size: 0;\n}\n:host(c4d-search-with-typeahead)[open] .c4d-ce__search__list {\n  padding: 0;\n  block-size: auto;\n}\n:host(c4d-search-with-typeahead)[active] {\n  z-index: 999;\n  inline-size: 100%;\n  margin-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action[part=close-button] {\n  display: inline-flex;\n  min-inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] button.cds--header__search--close.cds--header__action.cds--header__search--hide {\n  display: none;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--actions {\n  z-index: 10001;\n}\n:host(c4d-search-with-typeahead)[active] .react-autosuggest__container::after {\n  position: absolute;\n  z-index: 10002;\n  display: block;\n  block-size: 0.125rem;\n  border-block-end: 0.125rem solid var(--cds-border-interactive, #0f62fe);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input {\n  z-index: 10000;\n  display: flex;\n  flex: 1;\n  padding: 0 1rem;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close {\n  display: inline-flex;\n  inline-size: 3rem;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search {\n  border: 0.125rem solid transparent;\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__search--close:focus, :host(c4d-search-with-typeahead)[active] .cds--header__search--close:active,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:focus,\n:host(c4d-search-with-typeahead)[active] .cds--header__search--search:active {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[active] .cds--header__action {\n  background-color: var(--cds-layer-01, #f4f4f4);\n  transition-delay: 380ms;\n  transition-duration: 112ms;\n  transition-property: width;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-search-with-typeahead)[scope-value] .react-autosuggest__suggestions-container {\n    inline-size: calc(100% - 3rem);\n    inset-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] {\n    background: var(--cds-layer-01, #f4f4f4);\n    inset-block-start: 0;\n    outline: 0.125rem solid transparent;\n    transition: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n    border-block-end: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n    outline: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n    display: flex;\n    border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n    inline-size: 100%;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n    position: absolute;\n    z-index: 2;\n    fill: var(--cds-icon-secondary, #525252);\n    inset-block-start: 50%;\n    inset-inline-start: 1rem;\n    pointer-events: none;\n    transform: translateY(-50%);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n    content: none;\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: calc(3rem + 2px);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n  :host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n    border-block-end: none;\n    color: var(--cds-text-primary, #161616);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    inline-size: 100%;\n    padding-inline-start: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] {\n  background: var(--cds-layer-01, #f4f4f4);\n  inset-block-start: 0;\n  outline: 0.125rem solid transparent;\n  transition: background-color 110ms cubic-bezier(0.2, 0, 0.38, 0.9), outline 110ms cubic-bezier(0.2, 0, 0.38, 0.9), top 110ms cubic-bezier(0, 0, 0.38, 0.9);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n:host(c4d-search-with-typeahead)[leadspace-search]:focus .cds--header__search--actions {\n  border-block-end: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] {\n  outline: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search][unfocused] .cds--header__search--actions {\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--actions {\n  display: flex;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  inline-size: 100%;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--search-magnifier-icon {\n  position: absolute;\n  z-index: 2;\n  fill: var(--cds-icon-secondary, #525252);\n  inset-block-start: 50%;\n  inset-inline-start: 1rem;\n  pointer-events: none;\n  transform: translateY(-50%);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__container::after {\n  content: none;\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n  inset-block-start: calc(3rem + 2px);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-container {\n    inset-block-start: 4.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .react-autosuggest__suggestions-list {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-search-with-typeahead)[leadspace-search] .cds--header__search--input {\n  border-block-end: none;\n  color: var(--cds-text-primary, #161616);\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] form {\n  inline-size: 100%;\n  padding-inline-start: 3rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] form {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--input {\n    block-size: 3rem;\n  }\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .cds--header__search--close {\n    block-size: 3rem;\n  }\n}\n:host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n  inset-block-start: 3.125rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[leadspace-search][large] .react-autosuggest__suggestions-container {\n    inset-block-start: 3.125rem;\n  }\n}\n:host(c4d-search-with-typeahead)[sticky-search] {\n  inset-block-start: 5rem;\n}\n:host(c4d-search-with-typeahead)[theme-sticky] {\n  inset-block-start: 1rem;\n}\n@media (min-width: 42rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 2rem;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-search-with-typeahead)[theme-sticky] {\n    inset-block-start: 3rem;\n  }\n}\n\n.react-autosuggest__container {\n  position: relative;\n  display: flex;\n  justify-content: flex-end;\n  block-size: 3rem;\n}\n\n.react-autosuggest__suggestions-container {\n  position: absolute;\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inline-size: 100%;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n  max-block-size: 80vh;\n  overflow-y: auto;\n}\n\n.react-autosuggest__suggestions-list {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.react-autosuggest__section-title {\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: solid 1px var(--cds-layer-01, #f4f4f4);\n  border-block-start: solid 1px var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-secondary, #525252);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.react-autosuggest__suggestion {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n.react-autosuggest__suggestion span {\n  font-weight: 600;\n}\n.react-autosuggest__suggestion .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n.react-autosuggest__suggestion .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .react-autosuggest__suggestion:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n.react-autosuggest__suggestion:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n.react-autosuggest__suggestion .cds--container-highlight-class:not(:hover), .react-autosuggest__suggestion:focus, .react-autosuggest__suggestion:active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.react-autosuggest__suggestion:last-of-type .cds--container-class {\n  border-block-end: none;\n}\n\n.cds--header__search--input {\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  padding: 0;\n  border: none;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  font-size: 1rem;\n  inline-size: 0;\n  line-height: 1.375rem;\n  transition: 120ms;\n}\n.cds--header__search--input::-moz-placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n.cds--header__search--input::placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2024\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * Copyright IBM Corp. 2016, 2020\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n/**\n * This locks the scroll on the body element when the megamenu is expanded.\n * When using the megamenu web component, adopters will need to load this file in their application for\n * the scroll locking to work.\n */\n/**\n * Copyright IBM Corp. 2016, 2023\n *\n * This source code is licensed under the Apache-2.0 license found in the\n * LICENSE file in the root directory of this source tree.\n */\n* {\n  box-sizing: border-box;\n}\n\n:host(c4d-masthead-composite),\n:host(c4d-masthead-container) {\n  --cds-layout-size-height-xs: 1.5rem;\n  --cds-layout-size-height-sm: 2rem;\n  --cds-layout-size-height-md: 2.5rem;\n  --cds-layout-size-height-lg: 3rem;\n  --cds-layout-size-height-xl: 4rem;\n  --cds-layout-size-height-2xl: 5rem;\n  --cds-layout-size-height-min: 0px;\n  --cds-layout-size-height-max: 999999999px;\n  --cds-layout-density-padding-inline-condensed: 0.5rem;\n  --cds-layout-density-padding-inline-normal: 1rem;\n  --cds-layout-density-padding-inline-min: 0px;\n  --cds-layout-density-padding-inline-max: 999999999px;\n  position: relative;\n  z-index: 900;\n  display: block;\n  padding-block-start: 3rem;\n}\n\n.cds--masthead,\n:host(c4d-masthead) {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  font-family: 'IBM Plex Sans', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', sans-serif;\n  position: fixed;\n  z-index: 99;\n  background-color: var(--cds-background, #ffffff);\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  transition-delay: 200ms;\n  transition-duration: 300ms;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--masthead[with-banner],\n:host(c4d-masthead)[with-banner] {\n  inset-block-start: 10rem;\n}\n.cds--masthead[has-l1],\n:host(c4d-masthead)[has-l1] {\n  --c4d-active-l0-border-color: var(--cds-layer-accent-01, #e0e0e0);\n}\n.cds--masthead ::slotted([slot=profile]),\n:host(c4d-masthead) ::slotted([slot=profile]) {\n  background-color: var(--cds-background, #ffffff);\n}\n\n:host(c4d-megamenu-overlay),\n.cds--masthead__overlay {\n  position: fixed;\n  z-index: -1;\n  background-color: none;\n  block-size: 100%;\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n  opacity: 0;\n  transition: opacity 300ms cubic-bezier(0.5, 0, 0.1, 1), visibility 300ms cubic-bezier(0.5, 0, 0.1, 1), background-color 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  visibility: hidden;\n}\n\n:host(c4d-megamenu-overlay)[active],\n.cds--masthead__overlay-show {\n  background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  block-size: 100vh;\n  opacity: 1;\n  visibility: visible;\n}\n\n.cds--masthead--sticky.cds--masthead--sticky__l1 {\n  inset-block-start: -98px;\n}\n@media (min-width: 800px) {\n  .cds--masthead--sticky.cds--masthead--sticky__l1 {\n    inset-block-start: -3rem;\n  }\n}\n\n.cds--masthead--sticky__l1 + .cds--dotcom-shell .cds--tableofcontents__sidebar {\n  inset-block-start: 98px;\n}\n\n.cds--masthead--sticky__l1.cds--masthead--sticky + .cds--dotcom-shell .cds--tableofcontents__sidebar {\n  inset-block-start: 0;\n}\n@media (min-width: 800px) {\n  .cds--masthead--sticky__l1.cds--masthead--sticky + .cds--dotcom-shell .cds--tableofcontents__sidebar {\n    inset-block-start: 3rem;\n  }\n}\n\n.cds--masthead__l0 {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: relative;\n  background: var(--cds-background, #ffffff);\n}\n.cds--masthead__l0::after {\n  position: absolute;\n  background-color: var(--cds-layer-accent-01, #e0e0e0);\n  block-size: 1px;\n  content: \"\";\n  inline-size: 100vw;\n  inset-block-end: -1px;\n  inset-inline-start: 0;\n}\n\n.cds--header,\n.cds--masthead__l0 cds-header {\n  position: relative;\n  z-index: 5999;\n  border: none;\n  background: var(--cds-background, #ffffff);\n  margin-block-end: 1px;\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n.cds--header::before,\n.cds--masthead__l0 cds-header::before {\n  position: absolute;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  content: \"\";\n  inset-inline: calc(-50vw + 50%) 100%;\n}\n.cds--header::after,\n.cds--masthead__l0 cds-header::after {\n  position: absolute;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  content: \"\";\n  inset-inline: 100% calc(-50vw + 50%);\n}\n.cds--header .cds--header__menu-arrow,\n.cds--masthead__l0 cds-header .cds--header__menu-arrow {\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header .cds--header__menu-arrow:hover,\n.cds--masthead__l0 cds-header .cds--header__menu-arrow:hover {\n  fill: var(--cds-icon-secondary, #525252);\n}\n\n.cds--skip-to-content:focus {\n  block-size: 3.0625rem;\n}\n\n.cds--header__logo {\n  z-index: 2;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--header__logo a {\n    position: relative;\n    display: flex;\n    align-items: center;\n    padding: 0 2rem;\n    border: solid 0.125rem transparent;\n    block-size: 100%;\n    outline: none;\n    transition: none;\n  }\n  .cds--header__logo a:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--header__logo a:active, .cds--header__logo a:focus {\n    border-color: var(--cds-focus, #0f62fe);\n    background-color: var(--cds-layer-01, #f4f4f4);\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 99rem) {\n  .cds--header__logo a {\n    padding: 0 2.5rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (max-width: 81.98rem) {\n  .cds--header__logo a {\n    padding: 0 2rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (max-width: 65.98rem) {\n  .cds--header__logo a {\n    padding: 0 1rem;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .cds--header__logo a svg {\n    block-size: 23px;\n    inline-size: 58px;\n  }\n  .cds--header__logo a svg g,\n  .cds--header__logo a svg path {\n    fill: var(--cds-layer-selected-inverse, #161616);\n    /* stylelint-disable-next-line media-feature-name-no-unknown */\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (prefers-contrast: more) {\n  .cds--header__logo a svg g,\n  .cds--header__logo a svg path {\n    fill: ButtonText;\n  }\n}\n@media screen and (prefers-reduced-motion: reduce) and (min-width: 800px) {\n  .cds--header__logo a::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-layer-accent-01, #e0e0e0);\n    block-size: 1.5rem;\n    content: \"\";\n    inline-size: 0.0625rem;\n    inset-block-start: 50%;\n    inset-inline-end: -0.1875rem;\n    transform: translateY(-50%);\n  }\n}\n.cds--header__logo a {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 2rem;\n  border: solid 0.125rem transparent;\n  block-size: 100%;\n  outline: none;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n}\n.cds--header__logo a:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__logo a:active, .cds--header__logo a:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n@media (min-width: 99rem) {\n  .cds--header__logo a {\n    padding: 0 2.5rem;\n  }\n}\n@media (max-width: 81.98rem) {\n  .cds--header__logo a {\n    padding: 0 2rem;\n  }\n}\n@media (max-width: 65.98rem) {\n  .cds--header__logo a {\n    padding: 0 1rem;\n  }\n}\n.cds--header__logo a svg {\n  block-size: 23px;\n  inline-size: 58px;\n}\n.cds--header__logo a svg g,\n.cds--header__logo a svg path {\n  fill: var(--cds-layer-selected-inverse, #161616);\n  /* stylelint-disable-next-line media-feature-name-no-unknown */\n}\n@media (prefers-contrast: more) {\n  .cds--header__logo a svg g,\n  .cds--header__logo a svg path {\n    fill: ButtonText;\n  }\n}\n@media (min-width: 800px) {\n  .cds--header__logo a::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-layer-accent-01, #e0e0e0);\n    block-size: 1.5rem;\n    content: \"\";\n    inline-size: 0.0625rem;\n    inset-block-start: 50%;\n    inset-inline-end: -0.1875rem;\n    transform: translateY(-50%);\n  }\n}\n.cds--header__logo .cds--tooltip__trigger.cds--tooltip__trigger--definition,\n.cds--header__logo .cds--tooltip--definition {\n  border: none;\n}\n.cds--header__logo .cds--tooltip__trigger.cds--tooltip__trigger--definition .cds--tooltip__trigger,\n.cds--header__logo .cds--tooltip--definition .cds--tooltip__trigger {\n  border: none;\n}\n.cds--header__logo .cds--tooltip__trigger.cds--tooltip__trigger--definition.cds--tooltip--a11y,\n.cds--header__logo .cds--tooltip--definition.cds--tooltip--a11y {\n  block-size: 100%;\n}\n.cds--header__logo.cds--search-active {\n  display: none;\n}\n@media (min-width: 42rem) {\n  .cds--header__logo.cds--search-active {\n    display: block;\n  }\n}\n\n.cds--header__global {\n  flex: 0;\n}\n\n.cds--header__nav-container {\n  position: relative;\n  display: flex;\n  flex: 1;\n  block-size: 100%;\n  overflow-x: visible;\n}\n\n/* Set to zero-slecificity so it can be overridden by dynamic stylesheet */\n/* stylelint-disable-next-line selector-pseudo-class-no-unknown */\n:where(.cds--header__nav-content) {\n  position: absolute;\n  block-size: 100%;\n  inset-inline-start: 0;\n  transition: inset 250ms cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n\n.cds--header__submenu .cds--text-truncate--end,\n:host(c4d-top-nav-menu-item) .cds--text-truncate--end {\n  white-space: normal;\n}\n\n:host(c4d-top-nav-item) a.cds--header__menu-item,\n:host(c4d-top-nav-menu) a.cds--header__menu-item,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item,\n.cds--header__nav a.cds--header__menu-item {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  padding: 0.8125rem 1rem;\n  border: none;\n  color: var(--cds-text-secondary, #525252);\n  white-space: nowrap;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item > svg,\n.cds--header__nav a.cds--header__menu-item > svg {\n  fill: var(--cds-icon-secondary, #525252);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n.cds--header__nav a.cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n.cds--header__nav a.cds--header__menu-item:active {\n  background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active, :host(c4d-top-nav-item) a.cds--header__menu-item:hover,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover,\n.cds--header__nav a.cds--header__menu-item:active,\n.cds--header__nav a.cds--header__menu-item:hover {\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active > svg, :host(c4d-top-nav-item) a.cds--header__menu-item:hover > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active > svg,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:hover > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active > svg,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:hover > svg,\n.cds--header__nav a.cds--header__menu-item:active > svg,\n.cds--header__nav a.cds--header__menu-item:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:active, :host(c4d-top-nav-item) a.cds--header__menu-item:focus,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus,\n.cds--header__nav a.cds--header__menu-item:active,\n.cds--header__nav a.cds--header__menu-item:focus {\n  outline: 2px solid var(--cds-button-primary, #0f62fe);\n  outline-offset: -2px;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:focus[data-selected=true], :host(c4d-top-nav-item) a.cds--header__menu-item:active[data-selected=true],\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus[data-selected=true],\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active[data-selected=true],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus[data-selected=true],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active[data-selected=true],\n.cds--header__nav a.cds--header__menu-item:focus[data-selected=true],\n.cds--header__nav a.cds--header__menu-item:active[data-selected=true] {\n  border-block-end-color: transparent;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item:focus::after, :host(c4d-top-nav-item) a.cds--header__menu-item:active::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:focus::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item:active::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:focus::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item:active::after,\n.cds--header__nav a.cds--header__menu-item:focus::after,\n.cds--header__nav a.cds--header__menu-item:active::after {\n  background-color: var(--cds-focus, #0f62fe);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false], :host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false],\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false],\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false],\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false],\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false] {\n  border-block-end-color: transparent;\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after, :host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after,\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:focus[data-selected=true][aria-expanded=false]::after,\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title:active[data-selected=true][aria-expanded=false]::after {\n  background-color: var(--cds-focus, #0f62fe);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item[data-selected=true],\n:host(c4d-top-nav-menu) a.cds--header__menu-item[data-selected=true],\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item[data-selected=true],\n.cds--header__nav a.cds--header__menu-item[data-selected=true] {\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-top-nav-item) a.cds--header__menu-item[data-selected=true]::after,\n:host(c4d-top-nav-item) a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item[data-selected=true]::after,\n:host(c4d-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item[data-selected=true]::after,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after,\n.cds--header__nav a.cds--header__menu-item[data-selected=true]::after,\n.cds--header__nav a.cds--header__menu-item.cds--header__menu-title[data-selected=true][aria-expanded=false]::after {\n  position: absolute;\n  display: block;\n  box-sizing: border-box;\n  background-color: var(--c4d-active-l0-border-color, var(--cds-link-primary, #0f62fe));\n  block-size: 0.1875rem;\n  content: \"\";\n  inset-block-end: 0;\n  inset-inline: 0;\n}\n\n:host(c4d-top-nav-menu) a.cds--header__menu-item,\n:host(c4d-megamenu-top-nav-menu) a.cds--header__menu-item {\n  padding: 0.8125rem 1rem 0.6875rem;\n  border-block-end: 0.125rem solid transparent;\n}\n\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true],\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] {\n  z-index: 0;\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  background-color: var(--cds-layer-02, #ffffff);\n  box-shadow: 0 0.125rem 6px 0 rgba(0, 0, 0, 0.3);\n  inline-size: 16rem;\n  inset-block-end: -1px;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li {\n  position: relative;\n  block-size: 100%;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li::before {\n  position: absolute;\n  block-size: 100%;\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:first-of-type::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:first-of-type::before {\n  border-block-start: none;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover::before {\n  border-block-start: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover + li::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:hover + li::before {\n  border-block-start: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:focus::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu li:focus::before {\n  box-sizing: border-box;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item {\n  position: relative;\n  border: none;\n  block-size: 100%;\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:focus::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item:focus::before {\n  box-sizing: border-box;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n}\n:host(c4d-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item::before,\n.cds--header__nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--header__menu-item::before {\n  position: absolute;\n  block-size: 100%;\n  content: \"\";\n  inline-size: 100%;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n:host(c4d-top-nav-menu) .cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n:host(c4d-top-nav-menu) .cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inline-size: 100%;\n}\n:host(c4d-top-nav-menu)::before,\n.cds--header__nav::before {\n  display: none;\n}\n\n.cds--header__action {\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  border: 0.125rem solid transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__action:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__action:hover > svg {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__action:focus, .cds--header__action:active {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__action > svg {\n  position: relative;\n  fill: var(--cds-icon-secondary, #525252);\n}\n.cds--header__action .cds--overflow-menu {\n  block-size: 100%;\n  inline-size: 100%;\n}\n.cds--header__action .cds--overflow-menu.cds--overflow-menu--open {\n  box-shadow: none;\n  outline: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  outline-offset: 0;\n}\n.cds--header__action .cds--overflow-menu:hover {\n  background: none;\n}\n.cds--header__action .cds--overflow-menu:focus {\n  box-shadow: none;\n  outline: none;\n}\n\n.cds--sub-content-left {\n  position: absolute;\n  block-size: 100%;\n  inline-size: 1px;\n  inset-block-start: 0;\n  inset-inline-start: 0;\n}\n\n.cds--sub-content-right {\n  position: absolute;\n  block-size: 100%;\n  inline-size: 1px;\n  inset-block-start: 0;\n  inset-inline-end: 1px;\n}\n\n.cds--header__nav-caret-left,\n.cds--header__nav-caret-right {\n  position: absolute;\n  display: none;\n  border: none;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  inline-size: 2.5rem;\n  inset-block-start: 0;\n}\n.cds--header__nav-caret-left > svg,\n.cds--header__nav-caret-right > svg {\n  position: absolute;\n  fill: currentColor;\n  inset-block-start: 50%;\n  inset-inline-start: 50%;\n  transform: translateX(-50%) translateY(-50%);\n}\n.cds--header__nav-caret-left:hover,\n.cds--header__nav-caret-right:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  transition-duration: 95ms;\n}\n.cds--header__nav-caret-left:hover > svg,\n.cds--header__nav-caret-right:hover > svg {\n  fill: var(--cds-text-primary, #161616);\n}\n.cds--header__nav-caret-left:focus, .cds--header__nav-caret-left:active,\n.cds--header__nav-caret-right:focus,\n.cds--header__nav-caret-right:active {\n  display: block;\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  outline: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  outline-offset: -0.125rem;\n}\n.cds--header__nav-caret-left:focus::before, .cds--header__nav-caret-left:focus::after, .cds--header__nav-caret-left:active::before, .cds--header__nav-caret-left:active::after,\n.cds--header__nav-caret-right:focus::before,\n.cds--header__nav-caret-right:focus::after,\n.cds--header__nav-caret-right:active::before,\n.cds--header__nav-caret-right:active::after {\n  display: none;\n}\n@media (width >= 800px) {\n  .cds--header__nav-caret-left,\n  .cds--header__nav-caret-right {\n    display: block;\n  }\n}\n\n.cds--header__nav-caret-left-container[hidden],\n.cds--header__nav-caret-right-container[hidden] {\n  display: none;\n}\n\n.cds--header__nav-caret-left {\n  inset-inline-start: 0;\n}\n.cds--header__nav-caret-left::before {\n  position: absolute;\n  display: block;\n  background-color: #dcdcdc;\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__nav-caret-left-gradient {\n  position: absolute;\n  z-index: 1;\n  display: block;\n  background: linear-gradient(to right, var(--cds-background, #ffffff), rgba(255, 255, 255, 0));\n  block-size: 100%;\n  inline-size: 0.5rem;\n  inset-block-start: 0;\n  inset-inline-start: 2.5rem;\n}\n\n.cds--header__nav-caret-right {\n  inset-inline-end: 0;\n}\n.cds--header__nav-caret-right::after {\n  position: absolute;\n  display: block;\n  background-color: #dcdcdc;\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-end: 0;\n  transform: translateY(-50%);\n}\n\n.cds--header__nav-caret-right-gradient {\n  position: absolute;\n  display: block;\n  background: linear-gradient(to left, var(--cds-background, #ffffff), rgba(255, 255, 255, 0));\n  block-size: 100%;\n  inline-size: 0.5rem;\n  inset-block-start: 0;\n  inset-inline-end: 2.5rem;\n}\n\n.cds--header__action--active {\n  position: relative;\n  border: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  z-index: 6001;\n  inset-block-start: 0;\n}\n\n.cds--header__menu li:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n.cds--header__menu li:last-of-type .cds--header__menu-item::after {\n  display: none;\n}\n.cds--header__menu .cds--header__menu-item {\n  position: relative;\n}\n\nbutton.cds--header__search--close.cds--header__action[part=close-button] {\n  display: none;\n  overflow: hidden;\n  border: none;\n  inline-size: 0;\n}\nbutton.cds--header__search--close.cds--header__action[part=close-button] svg {\n  position: relative;\n}\n\n.cds--header__search--search {\n  inline-size: 3rem;\n  outline: none;\n}\n\n.cds--overflow-menu-options {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: fixed;\n  z-index: 99999;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--overflow-menu-options:focus {\n  outline: none;\n}\n.cds--overflow-menu-options::after {\n  display: none;\n}\n\n.cds--overflow-menu-options__btn {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n}\n.cds--overflow-menu-options__btn:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n\n.cds--overflow-menu-options__option {\n  block-size: 3rem;\n}\n.cds--overflow-menu-options__option:hover {\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n\n.cds--overflow-menu.cds--overflow-menu--open {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  box-shadow: none;\n}\n\n.cds--header__action.cds--overflow-menu {\n  block-size: 3rem;\n}\n\n@media (min-width: 800px) {\n  .cds--header__menu-toggle__hidden {\n    display: none;\n  }\n  .cds--header__nav {\n    display: block;\n  }\n}\n@media print {\n  :host(c4d-masthead),\n  .cds--masthead {\n    display: none;\n  }\n}\n.cds--masthead__l1,\n:host(c4d-masthead-l1) {\n  /* stylelint-disable-next-line length-zero-no-unit */\n  --page-width: calc(100vw - var(--scrollbar-width, 0px));\n  --grid-width: var(--page-width);\n  --column-width: var(--page-width);\n  --gutter-width: 1rem;\n  --column-width: calc(var(--grid-width) / 4);\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: relative;\n  overflow: visible;\n  background-color: var(--cds-layer-02, #ffffff);\n  transition-timing-function: cubic-bezier(0.2, 0, 0.38, 0.9);\n}\n@media (min-width: 42rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --grid-width: calc(var(--page-width) - 2rem);\n    --column-width: calc(var(--grid-width) / 8);\n  }\n}\n@media (min-width: 66rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --column-width: calc(var(--grid-width) / 16);\n  }\n}\n@media (min-width: 99rem) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    --grid-width: calc(99rem - 3rem);\n  }\n}\n\n@media screen and (width <= 799px) {\n  .cds--masthead__l1-inner-container {\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    background-color: transparent;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    color: var(--cds-text-primary, #161616);\n    gap: 1.5rem;\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-title:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--masthead__l1-title:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  .cds--masthead__l1-title:active, .cds--masthead__l1-title:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-title:disabled {\n    border-block-end-color: var(--cds-border-disabled, #c6c6c6);\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-title[active] {\n    border-block-end: 3px solid var(--cds-focus, #0f62fe);\n  }\n  .cds--masthead__l1-title.is-open svg {\n    transform: rotateX(180deg);\n  }\n  .cds--masthead__l1-title svg {\n    color: var(--cds-icon-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown {\n    position: absolute;\n    background-color: var(--cds-background, #ffffff);\n    color: var(--cds-text-secondary, #525252);\n    inset-block-start: 100%;\n    inset-inline: 0;\n    max-block-size: calc(100vh - 98px - 4rem - 3rem);\n    overflow-y: auto;\n  }\n  .cds--masthead__l1-dropdown.is-open {\n    box-shadow: 0 2px 6px 0 var(--cds-shadow, rgba(0, 0, 0, 0.3));\n    /* stylelint-disable-next-line declaration-no-important */\n    inline-size: 100vw !important;\n  }\n  .cds--masthead__l1-dropdown:not(.is-open) {\n    display: none;\n  }\n  .cds--masthead__l1-dropdown:last-child > a,\n  .cds--masthead__l1-dropdown:last-child > button {\n    border-block-end: initial;\n  }\n  .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    background-color: transparent;\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active, .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item:disabled {\n    border-block-end-color: var(--cds-border-disabled, #c6c6c6);\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-dropdown-item[active] {\n    position: relative;\n  }\n  .cds--masthead__l1-dropdown-item[active]::after {\n    position: absolute;\n    display: block;\n    background-color: var(--cds-focus, #0f62fe);\n    content: \"\";\n    inline-size: 3px;\n    inset-block: 0;\n    inset-inline-start: 0;\n  }\n  .cds--masthead__l1-dropdown-item.is-open {\n    background-color: var(--cds-background-selected, rgba(141, 141, 141, 0.2));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item.is-open svg {\n    color: var(--cds-icon-primary, #161616);\n    transform: rotateX(180deg);\n  }\n  .cds--masthead__l1-dropdown-item svg {\n    color: var(--cds-icon-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-subsection {\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 2rem;\n  }\n  .cds--masthead__l1-dropdown-subsection:not(.is-open) {\n    display: none;\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item {\n    border-block-end: none;\n    color: var(--cds-text-secondary, #525252);\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item:hover, .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-item:active {\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-subsection .cds--masthead__l1-dropdown-viewall {\n    margin-block-start: 2rem;\n  }\n  .cds--masthead__l1-dropdown-announcement {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem 0;\n    margin: 0 1rem 1rem;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-dropdown-heading {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading.cds--masthead__l1-dropdown-heading--no-link {\n    inline-size: 100%;\n    min-block-size: 2rem;\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    justify-content: flex-start;\n    color: inherit;\n    gap: 0.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    padding-block: 0.75rem;\n    padding-inline: 1rem 2.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item svg {\n    fill: var(--cds-icon-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading:not(:nth-of-type(1)) {\n    margin-block-start: 2rem;\n  }\n  .cds--masthead__l1-dropdown-viewall {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    justify-content: flex-start;\n    padding: 1rem;\n    background-color: transparent;\n    gap: 0.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n  }\n  .cds--masthead__l1-dropdown-viewall:focus {\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active, .cds--masthead__l1-dropdown-viewall:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-login {\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    color: var(--cds-button-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-login:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-login svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown-login:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  .cds--masthead__l1-dropdown-login:focus-visible {\n    color: var(--cds-button-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-login:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-button-primary-active, #002d9c);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta {\n    display: flex;\n    justify-content: space-between;\n    padding: 1rem;\n    border: none;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    gap: 1.5rem;\n    inline-size: 100%;\n    min-block-size: 2rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    background-color: var(--cds-background-brand, #0f62fe);\n    border-block-end: initial;\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta svg {\n    color: inherit;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:hover {\n    background-color: var(--cds-button-primary-hover, #0050e6);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:focus-visible {\n    outline-color: var(--cds-layer-02, #ffffff);\n    outline-offset: calc(-1 * 0.25rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:active {\n    background-color: var(--cds-button-primary-active, #002d9c);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-dropdown-cta:disabled {\n    background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n}\n@media screen and (width >= 800px) {\n  .cds--masthead__l1,\n  :host(c4d-masthead-l1) {\n    display: block;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-inner-container {\n    position: relative;\n    z-index: 1;\n    display: grid;\n    margin: 0 auto;\n    block-size: 4rem;\n    grid-template-areas: \"padding platform menu spacer login cta\";\n    grid-template-columns: 1rem auto minmax(1px, 1fr) 2.5rem auto auto;\n    inline-size: 100%;\n    max-inline-size: 98rem;\n  }\n  .cds--masthead__l1-inner-container > * {\n    position: relative;\n    z-index: 1;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask {\n    position: absolute;\n    z-index: 2;\n    display: block;\n    background-color: var(--cds-background, #ffffff);\n    content: \"\";\n    inset-block: 0;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask--start {\n    inset-inline: -50vw 100%;\n  }\n  .cds--masthead__l1-inner-container > .cds--masthead__l1-menu-container-mask--end {\n    inset-inline: 100% -50vw;\n  }\n  .cds--masthead__l1-inner-container::before, .cds--masthead__l1-inner-container::after {\n    position: relative;\n    z-index: 1;\n    display: block;\n    background-color: var(--cds-background, #ffffff);\n    content: \"\";\n  }\n  .cds--masthead__l1-inner-container::before {\n    grid-area: padding;\n  }\n  .cds--masthead__l1-inner-container::after {\n    grid-area: spacer;\n  }\n  .cds--masthead__background-wrapper {\n    background-color: var(--cds-background, #ffffff);\n  }\n  .cds--masthead__l1-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background, #ffffff);\n    block-size: 100%;\n    border-block-end: 3px solid transparent;\n    color: var(--cds-text-primary, #161616);\n    grid-area: platform;\n    padding-block-end: calc(1rem - 0.125rem);\n  }\n  .cds--masthead__l1-title[active] {\n    border-block-end-color: var(--cds-focus, #0f62fe);\n  }\n  .cds--masthead__l1-title:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  }\n  .cds--masthead__l1-title:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n  }\n  .cds--masthead__l1-title:active, .cds--masthead__l1-title:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-menu-container-outer {\n    z-index: 0;\n    display: flex;\n    grid-area: menu;\n  }\n  .cds--masthead__l1-menu-container-scroller {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    z-index: 1;\n    padding: 0;\n    background-color: var(--cds-background, #ffffff);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner {\n    display: inline-flex;\n    flex-shrink: 0;\n    align-items: flex-end;\n    padding: 1rem 0.5rem;\n    background-color: var(--cds-background, #ffffff);\n    block-size: 100%;\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner:active, .cds--masthead__l1-menu-container-scroller-inner:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-menu-container-scroller-inner[hidden] {\n    /* stylelint-disable-next-line declaration-no-important */\n    display: none !important;\n  }\n  .cds--masthead__l1-menu-container-inner {\n    z-index: 0;\n    flex-grow: 1;\n    flex-shrink: 1;\n    block-size: 100%;\n  }\n  .cds--masthead__l1-menu {\n    position: absolute;\n    display: flex;\n    block-size: 100%;\n    transition: translate 95ms cubic-bezier(0.2, 0, 0.38, 0.9);\n  }\n  .cds--masthead__l1-menu > li {\n    position: relative;\n  }\n  .cds--masthead__l1-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-flex;\n    align-items: flex-end;\n    border: 1px solid transparent;\n    background-color: var(--cds-background, #ffffff);\n    border-block-start: none;\n    color: var(--cds-text-secondary, #525252);\n    white-space: nowrap;\n  }\n  .cds--masthead__l1-item[active]::after {\n    position: absolute;\n    background-color: var(--cds-focus, #0f62fe);\n    block-size: 3px;\n    content: \"\";\n    inset-block-end: 0;\n    inset-inline: 0;\n  }\n  .cds--masthead__l1-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-item:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-item:active, .cds--masthead__l1-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-item:is([disabled], .is-disabled) {\n    color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  .cds--masthead__l1-item.is-open {\n    border-color: #c6c6c6;\n    block-size: calc(100% + 3px);\n    box-shadow: 0 0 6px #c6c6c6;\n    clip-path: polygon(calc(0% - 6px) calc(0% - 6px), calc(100% + 6px) calc(0% - 6px), calc(100% + 6px) 100%, calc(0% - 6px) 100%);\n    padding-block-end: calc(1rem + 3px);\n  }\n  .cds--masthead__l1-item.is-open svg {\n    rotate: 180deg;\n  }\n  .cds--masthead__l1-item svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown {\n    position: absolute;\n    padding: 1rem 0 0;\n    border: 1px solid #c6c6c6;\n    background-color: var(--cds-background, #ffffff);\n    border-block-start: none;\n    box-shadow: 0 0 6px #c6c6c6;\n    clip-path: polygon(calc(0% - 6px) 0%, calc(100% + 6px) 0%, calc(100% + 6px) calc(100% + 6px), calc(0% - 6px) calc(100% + 6px));\n    inline-size: 320;\n    inset-block-start: calc(100% + 1px);\n    inset-inline-start: 0;\n    max-inline-size: calc(100vw - 2 * 1rem);\n    overflow-y: auto;\n    visibility: hidden;\n  }\n  .cds--masthead__l1-dropdown.is-open {\n    visibility: visible;\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__1-col {\n    inline-size: calc(2 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__2-col {\n    inline-size: calc(4 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__3-col {\n    inline-size: calc(6 * var(--column-width));\n  }\n}\n@media screen and (width >= 800px) and (width >= 66rem) {\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__1-col {\n    inline-size: calc(4 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__2-col {\n    inline-size: calc(8 * var(--column-width));\n  }\n  .cds--masthead__l1-dropdown.cds--masthead__l1-dropdown__3-col {\n    inline-size: calc(12 * var(--column-width));\n  }\n}\n@media screen and (width >= 800px) {\n  .cds--masthead__l1-dropdown-links {\n    -moz-column-rule: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n         column-rule: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 2.5rem;\n  }\n  .cds--masthead__l1-dropdown__2-col .cds--masthead__l1-dropdown-links {\n    -moz-column-count: 2;\n         column-count: 2;\n    -moz-column-gap: 0;\n         column-gap: 0;\n  }\n  .cds--masthead__l1-dropdown__3-col .cds--masthead__l1-dropdown-links {\n    -moz-column-count: 3;\n         column-count: 3;\n    -moz-column-gap: 0;\n         column-gap: 0;\n  }\n  .cds--masthead__l1-dropdown-links > * {\n    -moz-column-break-inside: avoid;\n         break-inside: avoid;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide {\n    display: grid;\n    grid-template-columns: repeat(3, 1fr);\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide .cds--masthead__l1-dropdown-column-wide {\n    grid-column: span 2;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide .cds--masthead__l1-dropdown-column-wide .cds--masthead__l1-dropdown-menu-items {\n    -moz-column-gap: 0;\n         column-gap: 0;\n    -moz-columns: 2;\n         columns: 2;\n  }\n  .cds--masthead__l1-dropdown-links.cds--masthead__l1-dropdown--has-column-wide > *:nth-child(2) {\n    border-inline-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  }\n  .cds--masthead__l1-dropdown-announcement {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    margin: 0 1rem 1rem;\n    border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    padding-block-end: 1rem;\n  }\n  .cds--masthead__l1-dropdown-announcement :is(h1, h2, h3, h4, h5, h6, strong, b) {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  }\n  .cds--masthead__l1-dropdown-announcement :focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-menu-items {\n    padding-block-end: 1.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading {\n    font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n    font-weight: var(--cds-productive-heading-03-font-weight, 400);\n    line-height: var(--cds-productive-heading-03-line-height, 1.4);\n    letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n    font-weight: var(--cds-productive-heading-03-font-weight, 400);\n    line-height: var(--cds-productive-heading-03-line-height, 1.4);\n    letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    padding: 0.5rem 1rem;\n    color: inherit;\n    margin-block-end: 0.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading .cds--masthead__l1-dropdown-item svg {\n    position: relative;\n    inset-block-end: 0.125rem;\n    margin-inline-start: 0.5rem;\n    vertical-align: middle;\n  }\n  .cds--masthead__l1-dropdown-heading.cds--masthead__l1-dropdown-heading--no-link {\n    padding: 0.5rem 1rem;\n    margin-block-end: 0.5rem;\n  }\n  .cds--masthead__l1-dropdown-heading-desc {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: block;\n    padding: 0 1rem;\n    margin: calc(-1 * 0.5rem) 0 0.5rem;\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    display: inline-block;\n    padding: 0.5rem 1rem;\n    color: var(--cds-text-secondary, #525252);\n    inline-size: 100%;\n  }\n  .cds--masthead__l1-dropdown-item:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-text-primary, #161616);\n  }\n  .cds--masthead__l1-dropdown-item:active {\n    color: var(--cds-text-secondary, #525252);\n  }\n  .cds--masthead__l1-dropdown-item:active, .cds--masthead__l1-dropdown-item:focus-visible {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-item svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-dropdown-item .cds--masthead__l1-dropdown-item-title {\n    font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n    font-weight: var(--cds-productive-heading-01-font-weight, 600);\n    line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n    letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n    display: block;\n  }\n  .cds--masthead__l1-dropdown-item .cds--masthead__l1-dropdown-item-description {\n    display: block;\n    color: var(--cds-text-secondary, #525252);\n    white-space: break-spaces;\n  }\n  .cds--masthead__l1-dropdown-viewall {\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: flex;\n    align-content: center;\n    padding: 1rem;\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    color: var(--cds-link-primary, #0f62fe);\n    gap: 0.5rem;\n    text-decoration: none;\n  }\n  .cds--masthead__l1-dropdown-viewall:hover {\n    color: var(--cds-link-primary-hover, #0043ce);\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:active, .cds--masthead__l1-dropdown-viewall:active:visited, .cds--masthead__l1-dropdown-viewall:active:visited:hover {\n    color: var(--cds-text-primary, #161616);\n    text-decoration: underline;\n  }\n  .cds--masthead__l1-dropdown-viewall:focus {\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-dropdown-viewall:visited {\n    color: var(--cds-link-primary, #0f62fe);\n  }\n  .cds--masthead__l1-dropdown-viewall:visited:hover {\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  :host(c4d-masthead-l1-cta) {\n    position: relative;\n    z-index: 1;\n    grid-area: cta;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background-brand, #0f62fe);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta svg {\n    color: inherit;\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:hover {\n    background-color: var(--cds-button-primary-hover, #0050e6);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:focus-visible {\n    outline: 0.125rem solid var(--cds-layer-02, #ffffff);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:active {\n    background-color: var(--cds-button-primary-active, #002d9c);\n    color: var(--cds-layer-02, #ffffff);\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta:disabled {\n    background-color: var(--cds-text-disabled, rgba(22, 22, 22, 0.25));\n  }\n  :host(c4d-masthead-l1-cta) .cds--masthead__l1-cta-inner {\n    display: inline-flex;\n    align-items: center;\n    gap: 0.5rem;\n  }\n  .cds--masthead__l1-login {\n    padding: 1rem;\n    border: none;\n    -webkit-appearance: none;\n       -moz-appearance: none;\n            appearance: none;\n    background: transparent;\n    block-size: 100%;\n    -moz-column-gap: 0.5rem;\n         column-gap: 0.5rem;\n    text-decoration: none;\n    font-size: var(--cds-body-short-01-font-size, 0.875rem);\n    font-weight: var(--cds-body-short-01-font-weight, 400);\n    line-height: var(--cds-body-short-01-line-height, 1.28572);\n    letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n    display: inline-flex;\n    align-items: flex-end;\n    background-color: var(--cds-background, #ffffff);\n    color: var(--cds-button-primary, #0f62fe);\n    grid-area: login;\n  }\n  .cds--masthead__l1-login svg {\n    color: inherit;\n  }\n  .cds--masthead__l1-login:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    color: var(--cds-link-primary-hover, #0043ce);\n  }\n  .cds--masthead__l1-login:focus-visible {\n    color: var(--cds-button-primary, #0f62fe);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n  .cds--masthead__l1-login:active {\n    background-color: var(--cds-background-active, rgba(141, 141, 141, 0.5));\n    color: var(--cds-button-primary-active, #002d9c);\n    outline: 0.125rem solid var(--cds-focus, #0f62fe);\n    outline-offset: calc(-1 * 0.125rem);\n  }\n}\n:host(c4d-top-nav),\n.cds--header__search {\n  position: relative;\n  display: flex;\n  flex: 1;\n  align-items: center;\n  block-size: 100%;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav,\n.cds--header__search.cds--masthead__platform .cds--header__nav {\n  padding-inline-start: 0;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--header__nav::before,\n.cds--header__search.cds--masthead__platform .cds--header__nav::before {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__platform .cds--masthead__platform-name,\n.cds--header__search.cds--masthead__platform .cds--masthead__platform-name {\n  z-index: 1;\n  background: var(--cds-background, #ffffff);\n  block-size: 100%;\n}\n:host(c4d-top-nav) a.cds--header__name,\n.cds--header__search a.cds--header__name {\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n  position: relative;\n  z-index: 1;\n  border: solid 0.125rem transparent;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-text-primary, #161616);\n  padding-inline: 1rem;\n  transition: background-color 110ms, border-color 110ms, color 110ms;\n  white-space: nowrap;\n}\n@media (min-width: 66rem) {\n  :host(c4d-top-nav) a.cds--header__name,\n  .cds--header__search a.cds--header__name {\n    margin-inline-start: 1rem;\n  }\n}\n:host(c4d-top-nav) a.cds--header__name:hover,\n.cds--header__search a.cds--header__name:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  color: var(--cds-text-primary, #161616);\n}\n:host(c4d-top-nav) a.cds--header__name:active, :host(c4d-top-nav) a.cds--header__name:focus,\n.cds--header__search a.cds--header__name:active,\n.cds--header__search a.cds--header__name:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-layer-01, #f4f4f4);\n}\n:host(c4d-top-nav) a.cds--header__name::before,\n.cds--header__search a.cds--header__name::before {\n  position: absolute;\n  display: block;\n  background-color: #dcdcdc;\n  block-size: 1.5rem;\n  content: \"\";\n  inline-size: 0.0625rem;\n  inset-block-start: 50%;\n  inset-inline-start: -0.875rem;\n  transform: translateY(-50%);\n}\n@media (max-width: 800px) {\n  :host(c4d-top-nav) a.cds--header__name,\n  .cds--header__search a.cds--header__name {\n    display: none;\n  }\n}\n:host(c4d-top-nav).cds--masthead__header--search-active .cds--header__nav-container,\n.cds--header__search.cds--masthead__header--search-active .cds--header__nav-container {\n  display: none;\n}\n:host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n.cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n  display: none;\n}\n@media (min-width: 42rem) {\n  :host(c4d-top-nav).cds--masthead__header--search-active + .cds--header__profile,\n  .cds--header__search.cds--masthead__header--search-active + .cds--header__profile {\n    display: flex;\n  }\n}\n\n@media (min-width: 42rem) {\n  .cds--header__search:not(.cds--masthead__header--search-active) {\n    overflow-x: visible;\n  }\n}\n\n.cds--header__search--actions {\n  position: absolute;\n  inset-block-start: 0;\n  inset-inline-end: 0;\n}\n.cds--header__search--actions .cds--header__search--search,\n.cds--header__search--actions .cds--header__search--close {\n  padding: 0;\n  background-color: var(--cds-background, #ffffff);\n  color: var(--cds-icon-secondary, #525252);\n}\n.cds--header__search--actions .cds--header__search--search:hover,\n.cds--header__search--actions .cds--header__search--close:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__search--actions .cds--header__search--search:hover svg[focusable=false][aria-hidden=true],\n.cds--header__search--actions .cds--header__search--close:hover svg[focusable=false][aria-hidden=true] {\n  fill: var(--cds-icon-primary, #161616);\n}\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text, .cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--search.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--visible .cds--assistive-text,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger::before,\n.cds--header__search--actions .cds--header__search--close.cds--btn--icon-only.cds--tooltip--a11y.cds--tooltip__trigger .cds--assistive-text {\n  display: none;\n}\n\n.cds--header__profile .cds--header__action:focus,\n.cds--header__search--actions .cds--btn.cds--btn--icon-only.cds--tooltip__trigger:focus {\n  border-color: var(--cds-focus, #0f62fe);\n}\n\n.cds--masthead__search,\n:host(c4d-masthead-search) {\n  block-size: 3rem;\n  margin-inline-start: 3rem;\n}\n.cds--masthead__search.cds--masthead__search--active, .cds--masthead__search[active],\n:host(c4d-masthead-search).cds--masthead__search--active,\n:host(c4d-masthead-search)[active] {\n  z-index: 999;\n  inline-size: 100%;\n  margin-inline-start: 0;\n}\n.cds--masthead__search.cds--masthead__search--active button.cds--header__search--close.cds--header__action[part=close-button], .cds--masthead__search[active] button.cds--header__search--close.cds--header__action[part=close-button],\n:host(c4d-masthead-search).cds--masthead__search--active button.cds--header__search--close.cds--header__action[part=close-button],\n:host(c4d-masthead-search)[active] button.cds--header__search--close.cds--header__action[part=close-button] {\n  display: inline-flex;\n  inline-size: 3rem;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--actions, .cds--masthead__search[active] .cds--header__search--actions,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--actions,\n:host(c4d-masthead-search)[active] .cds--header__search--actions {\n  z-index: 10001;\n}\n.cds--masthead__search.cds--masthead__search--active .react-autosuggest__container::after, .cds--masthead__search[active] .react-autosuggest__container::after,\n:host(c4d-masthead-search).cds--masthead__search--active .react-autosuggest__container::after,\n:host(c4d-masthead-search)[active] .react-autosuggest__container::after {\n  position: absolute;\n  z-index: 10002;\n  display: block;\n  block-size: 0.125rem;\n  border-block-end: 0.125rem solid var(--cds-background-brand, #0f62fe);\n  content: \"\";\n  inline-size: 100%;\n  inset-block-end: 0;\n  inset-inline-start: 0;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--input, .cds--masthead__search[active] .cds--header__search--input,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--input,\n:host(c4d-masthead-search)[active] .cds--header__search--input {\n  z-index: 10000;\n  display: flex;\n  flex: 1;\n  padding: 0 1rem;\n  background-color: var(--cds-layer-01, #f4f4f4);\n  block-size: 3rem;\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--input::-moz-placeholder, .cds--masthead__search[active] .cds--header__search--input::-moz-placeholder, :host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--input::-moz-placeholder, :host(c4d-masthead-search)[active] .cds--header__search--input::-moz-placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--input::placeholder, .cds--masthead__search[active] .cds--header__search--input::placeholder,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--input::placeholder,\n:host(c4d-masthead-search)[active] .cds--header__search--input::placeholder {\n  color: var(--cds-text-placeholder, rgba(22, 22, 22, 0.4));\n  inset-inline-start: 0;\n  opacity: 1;\n  transition-delay: 200ms;\n  transition-duration: 112ms;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--close,\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--search, .cds--masthead__search[active] .cds--header__search--close,\n.cds--masthead__search[active] .cds--header__search--search,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--close,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--search,\n:host(c4d-masthead-search)[active] .cds--header__search--close,\n:host(c4d-masthead-search)[active] .cds--header__search--search {\n  border: 0.125rem solid transparent;\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--close:focus, .cds--masthead__search.cds--masthead__search--active .cds--header__search--close:active,\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--search:focus,\n.cds--masthead__search.cds--masthead__search--active .cds--header__search--search:active, .cds--masthead__search[active] .cds--header__search--close:focus, .cds--masthead__search[active] .cds--header__search--close:active,\n.cds--masthead__search[active] .cds--header__search--search:focus,\n.cds--masthead__search[active] .cds--header__search--search:active,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--close:focus,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--close:active,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--search:focus,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__search--search:active,\n:host(c4d-masthead-search)[active] .cds--header__search--close:focus,\n:host(c4d-masthead-search)[active] .cds--header__search--close:active,\n:host(c4d-masthead-search)[active] .cds--header__search--search:focus,\n:host(c4d-masthead-search)[active] .cds--header__search--search:active {\n  border: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.cds--masthead__search.cds--masthead__search--active .cds--header__action, .cds--masthead__search[active] .cds--header__action,\n:host(c4d-masthead-search).cds--masthead__search--active .cds--header__action,\n:host(c4d-masthead-search)[active] .cds--header__action {\n  background-color: var(--cds-layer-01, #f4f4f4);\n  transition-delay: 380ms;\n  transition-duration: 112ms;\n  transition-property: width;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead__search.cds--masthead__search--active,\n  :host(c4d-masthead-search).cds--masthead__search--active {\n    position: absolute;\n    inline-size: 100vw;\n  }\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead__search[active],\n  :host(c4d-masthead-search)[active] {\n    inline-size: 100vw;\n    inset-inline-end: 0;\n  }\n}\n\n.react-autosuggest__container {\n  position: relative;\n  display: flex;\n  justify-content: flex-end;\n  block-size: 3rem;\n}\n\n.react-autosuggest__suggestions-container {\n  position: absolute;\n  box-shadow: 0 0.25rem 0.5rem 0 rgba(0, 0, 0, 0.5);\n  inline-size: 100%;\n  inset-block-start: 3rem;\n  inset-inline-start: 0;\n}\n\n.react-autosuggest__suggestions-list {\n  background-color: var(--cds-background, #ffffff);\n}\n\n.react-autosuggest__section-title {\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 3rem;\n  border-block-end: solid 1px var(--cds-layer-01, #f4f4f4);\n  border-block-start: solid 1px var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-secondary, #525252);\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n}\n\n.react-autosuggest__suggestion {\n  display: flex;\n  block-size: 3rem;\n  color: var(--cds-text-primary, #161616);\n}\n.react-autosuggest__suggestion span {\n  font-weight: 600;\n}\n.react-autosuggest__suggestion .cds--container-class {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  padding: 0 1rem;\n  border-block-end: 1px solid var(--cds-layer-01, #f4f4f4);\n}\n.react-autosuggest__suggestion .cds--container-class:focus {\n  outline: none;\n}\n@media screen and (prefers-reduced-motion: reduce) {\n  .react-autosuggest__suggestion:hover {\n    background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n    cursor: pointer;\n    transition: none;\n  }\n}\n.react-autosuggest__suggestion:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  cursor: pointer;\n  transition: 95ms;\n}\n.react-autosuggest__suggestion .cds--container-highlight-class:not(:hover), .react-autosuggest__suggestion:focus, .react-autosuggest__suggestion:active {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n}\n.react-autosuggest__suggestion:last-of-type .cds--container-class {\n  border-block-end: none;\n}\n\n.cds--header__search--input {\n  padding: 0;\n  border: none;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  font-size: 1rem;\n  inline-size: 0;\n  line-height: 1.375rem;\n  transition: 120ms;\n}\n.cds--header__search--input::-moz-placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n.cds--header__search--input::placeholder {\n  position: relative;\n  inset-inline-start: 5rem;\n  opacity: 0;\n}\n\n.cds--masthead__focus {\n  position: absolute;\n  border: none;\n  opacity: 0;\n}\n\n.cds--masthead .cds--side-nav__navigation {\n  block-size: calc(100% - 3rem);\n}\n.cds--masthead .cds--side-nav__navigation > nav {\n  block-size: 100%;\n}\n@media (min-width: 800px) {\n  .cds--masthead .cds--side-nav__navigation {\n    display: none;\n  }\n}\n\n.cds--header__menu-trigger {\n  margin-inline-end: 0;\n}\n.cds--header__menu-trigger .cds--side-nav__close {\n  display: none;\n}\n.cds--header__menu-trigger.cds--header__action--active {\n  border-color: transparent;\n  background-color: var(--cds-background, #ffffff);\n}\n.cds--header__menu-trigger.cds--header__action--active:focus {\n  border-color: var(--cds-focus, #0f62fe);\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--header__menu-trigger.cds--header__action--active + .cds--header__logo {\n  z-index: 6001;\n  margin-inline-start: 3rem;\n}\n.cds--header__menu-trigger.cds--header__action--active .cds--side-nav__close {\n  display: inline;\n}\n.cds--header__menu-trigger.cds--header__action--active .cds--side-nav__open {\n  display: none;\n}\n@media (max-width: 41.98rem) {\n  .cds--header__menu-trigger.cds--masthead__header--search-active {\n    display: none;\n  }\n}\n@media (min-width: 42rem) and (max-width: 66rem) {\n  .cds--header__menu-trigger + .cds--header__logo a {\n    padding: 0 1rem;\n  }\n}\n\n.cds--side-nav__header-navigation {\n  block-size: 100%;\n  margin-block-end: 0;\n}\n\n.cds--masthead .cds--side-nav {\n  inset-inline-start: -100vw;\n  transform: translateZ(0.0001px);\n  /* stylelint-disable-next-line  time-min-milliseconds */\n  transition: visibility 1ms cubic-bezier(0.2, 0, 1, 0.9) 110ms, inset-inline-start 110ms cubic-bezier(0.2, 0, 1, 0.9) 1ms;\n  visibility: hidden;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead .cds--side-nav:not(.cds--side-nav--fixed):hover {\n    inline-size: 100vw;\n    max-inline-size: 100vw;\n  }\n}\n.cds--masthead .cds--side-nav .cds--header__logo {\n  block-size: 3rem;\n  padding-inline-start: 3rem;\n}\n.cds--masthead .cds--side-nav,\n.cds--masthead .cds--side-nav--expanded {\n  inline-size: 16rem;\n  max-inline-size: 16rem;\n}\n.cds--masthead .cds--side-nav__items {\n  block-size: 100%;\n  padding-block-start: 0;\n}\n.cds--masthead .cds--side-nav__item {\n  block-size: auto;\n  min-block-size: 3rem;\n}\n.cds--masthead .cds--side-nav__item .cds--side-nav__submenu {\n  block-size: 100%;\n}\n.cds--masthead .cds--side-nav__overlay {\n  z-index: 1000;\n  inset-block-start: 0;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead .cds--side-nav__overlay {\n    background-color: var(--cds-background, #ffffff);\n  }\n}\n.cds--masthead .cds--side-nav__overlay-active {\n  display: none;\n}\n@media (max-width: 800px) {\n  .cds--masthead .cds--side-nav__overlay-active {\n    display: block;\n    background-color: var(--cds-overlay, rgba(22, 22, 22, 0.5));\n  }\n}\n.cds--masthead .cds--side-nav--expanded {\n  inset-inline-start: 0;\n  overflow-y: auto;\n  transform: translateZ(0.0001px);\n  /* stylelint-disable-next-line time-min-milliseconds */\n  transition: visibility 1ms cubic-bezier(0.2, 0, 1, 0.9) 0ms, inset-inline-start 110ms cubic-bezier(0.2, 0, 1, 0.9) 1ms;\n  visibility: visible;\n}\n@media (max-width: 41.98rem) {\n  .cds--masthead .cds--side-nav--ux,\n  .cds--masthead .cds--side-nav,\n  .cds--masthead .cds--side-nav--expanded {\n    border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n    inline-size: 100vw;\n    max-inline-size: 100vw;\n  }\n}\n\n:host(c4d-left-nav-menu-section),\n.cds--side-nav__menu-section {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n  position: absolute;\n  z-index: 0;\n  background-color: var(--cds-background, #ffffff);\n  block-size: 100%;\n  inline-size: 100%;\n  inset-inline-start: -100%;\n  overflow-y: auto;\n  padding-block-end: 3rem;\n  transform: translateZ(0.0001px);\n  transition: inset-inline-start 150ms cubic-bezier(0.2, 0, 1, 0.9);\n}\n:host(c4d-left-nav-menu-section) a,\n.cds--side-nav__menu-section a {\n  font-size: var(--cds-body-compact-02-font-size, 1rem);\n  font-weight: var(--cds-body-compact-02-font-weight, 400);\n  line-height: var(--cds-body-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-body-compact-02-letter-spacing, 0);\n  block-size: 3rem;\n  padding-inline-start: 1rem;\n}\n:host(c4d-left-nav-menu-section) a:hover,\n.cds--side-nav__menu-section a:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  text-decoration: none;\n}\n:host(c4d-left-nav-menu-section) .cds--masthead__side-nav--submemu-title,\n.cds--side-nav__menu-section .cds--masthead__side-nav--submemu-title {\n  font-size: var(--cds-heading-compact-02-font-size, 1rem);\n  font-weight: var(--cds-heading-compact-02-font-weight, 600);\n  line-height: var(--cds-heading-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-heading-compact-02-letter-spacing, 0);\n  display: flex;\n  align-items: center;\n  padding: 0.8rem 1rem;\n  block-size: auto;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-primary, #161616);\n  min-block-size: 3rem;\n  text-decoration: none;\n}\n:host(c4d-left-nav-menu-section) .cds--masthead__side-nav--submemu-title:focus,\n.cds--side-nav__menu-section .cds--masthead__side-nav--submemu-title:focus {\n  outline: 0.125rem solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n}\n:host(c4d-left-nav-menu-section) .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title,\n.cds--side-nav__menu-section .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title {\n  padding: 0;\n  block-size: auto;\n  min-block-size: 3rem;\n}\n:host(c4d-left-nav-menu-section) .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title span,\n.cds--side-nav__menu-section .cds--side-nav__item .cds--masthead__side-nav--submemu-section-title span {\n  font-size: var(--cds-heading-compact-02-font-size, 1rem);\n  font-weight: var(--cds-heading-compact-02-font-weight, 600);\n  line-height: var(--cds-heading-compact-02-line-height, 1.375);\n  letter-spacing: var(--cds-heading-compact-02-letter-spacing, 0);\n  display: flex;\n  padding: 0.8rem 1rem;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  color: var(--cds-text-primary, #161616);\n  inline-size: 100%;\n}\n:host(c4d-left-nav-menu-section) .cds--masthead__side-nav--submemu-section-title__icon,\n.cds--side-nav__menu-section .cds--masthead__side-nav--submemu-section-title__icon {\n  display: flex;\n  flex: 1;\n  align-items: center;\n  align-self: flex-start;\n  justify-content: flex-end;\n  margin-block-start: 0.125rem;\n}\n\na.cds--side-nav__link,\nbutton.cds--side-nav__link {\n  block-size: 3rem;\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n}\na.cds--side-nav__link > .cds--side-nav__link-text,\nbutton.cds--side-nav__link > .cds--side-nav__link-text {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  block-size: 100%;\n  color: var(--cds-text-secondary, #525252);\n  inline-size: 100%;\n  text-overflow: ellipsis;\n}\na.cds--side-nav__link:hover > .cds--side-nav__link-text, a.cds--side-nav__link:focus > .cds--side-nav__link-text,\nbutton.cds--side-nav__link:hover > .cds--side-nav__link-text,\nbutton.cds--side-nav__link:focus > .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\na.cds--side-nav__link--current,\nbutton.cds--side-nav__link--current {\n  background-color: var(--cds-background, #ffffff);\n}\na.cds--side-nav__link--current > .cds--side-nav__link-text,\nbutton.cds--side-nav__link--current > .cds--side-nav__link-text {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--masthead__side-nav--submemu-back {\n  position: sticky;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  inset-block-start: 0;\n}\n.cds--masthead__side-nav--submemu-back button {\n  position: relative;\n  display: flex;\n  align-items: center;\n  padding: 0 1rem;\n  border: none;\n  background-color: var(--cds-background, #ffffff);\n  cursor: pointer;\n  inline-size: 100%;\n  min-block-size: 2rem;\n  outline: 0.125rem solid transparent;\n  outline-offset: -0.125rem;\n}\n.cds--masthead__side-nav--submemu-back button:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n}\n.cds--masthead__side-nav--submemu-back button:hover > .cds--side-nav__link-text {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n.cds--masthead__side-nav--submemu-back button:focus {\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--masthead__side-nav--submemu-back button:focus > .cds--side-nav__link-text {\n  color: var(--cds-link-primary, #0f62fe);\n}\n.cds--masthead__side-nav--submemu-back button > .cds--side-nav__link-text {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: flex;\n  align-items: center;\n  border-block-end: none;\n  color: var(--cds-link-primary, #0f62fe);\n}\n.cds--masthead__side-nav--submemu-back button svg {\n  margin-inline-end: 5px;\n}\n.cds--masthead__side-nav--submemu-back button svg path {\n  fill: currentColor;\n}\n:host([dir=rtl]) .cds--masthead__side-nav--submemu-back button svg {\n  transform: rotate(180deg);\n}\n\n:host(c4d-left-nav-menu-section)[expanded],\n.cds--side-nav__menu-section--expanded {\n  z-index: 1;\n  inset-inline-start: 0;\n}\n\n:host(c4d-left-nav-menu-section)[is-submenu],\n.cds--side-nav__menu-section-submenu {\n  inset-inline-start: 100%;\n}\n\n:host(c4d-left-nav-menu-section)[is-submenu][expanded],\n.cds--side-nav__menu-section-submenu.cds--side-nav__menu-section--expanded {\n  inset-inline-start: 0;\n}\n\n:host(c4d-left-nav-menu-section)[is-submenu][transition],\n.cds--side-nav__menu-section-submenu--expanded {\n  inset-inline-start: -100%;\n}\n\n.cds--side-nav__menu {\n  transform: translateX(100%);\n}\n\n.cds--side-nav__menu--hasactivechildren {\n  overflow: hidden;\n}\n\n.cds--side-nav__submenu {\n  --cds-ai-aura-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-background: #edf5ff;\n  --cds-ai-aura-hover-end: rgba(255, 255, 255, 0);\n  --cds-ai-aura-hover-start: rgba(69, 137, 255, 0.32);\n  --cds-ai-aura-start: rgba(69, 137, 255, 0.1);\n  --cds-ai-aura-start-sm: rgba(69, 137, 255, 0.16);\n  --cds-ai-border-end: #78a9ff;\n  --cds-ai-border-start: rgba(166, 200, 255, 0.64);\n  --cds-ai-border-strong: #4589ff;\n  --cds-ai-drop-shadow: rgba(15, 98, 254, 0.1);\n  --cds-ai-inner-shadow: rgba(69, 137, 255, 0.1);\n  --cds-ai-overlay: rgba(0, 17, 65, 0.5);\n  --cds-ai-popover-background: #ffffff;\n  --cds-ai-popover-caret-bottom: #78a9ff;\n  --cds-ai-popover-caret-bottom-background: #eaf1ff;\n  --cds-ai-popover-caret-bottom-background-actions: #e9effa;\n  --cds-ai-popover-caret-center: #a0c3ff;\n  --cds-ai-popover-shadow-outer-01: rgba(0, 67, 206, 0.06);\n  --cds-ai-popover-shadow-outer-02: rgba(0, 0, 0, 0.04);\n  --cds-ai-skeleton-background: #d0e2ff;\n  --cds-ai-skeleton-element-background: #4589ff;\n  --cds-background: #ffffff;\n  --cds-background-active: rgba(141, 141, 141, 0.5);\n  --cds-background-brand: #0f62fe;\n  --cds-background-hover: rgba(141, 141, 141, 0.12);\n  --cds-background-inverse: #393939;\n  --cds-background-inverse-hover: #474747;\n  --cds-background-selected: rgba(141, 141, 141, 0.2);\n  --cds-background-selected-hover: rgba(141, 141, 141, 0.32);\n  --cds-border-disabled: #c6c6c6;\n  --cds-border-interactive: #0f62fe;\n  --cds-border-inverse: #161616;\n  --cds-border-strong-01: #8d8d8d;\n  --cds-border-strong-02: #8d8d8d;\n  --cds-border-strong-03: #8d8d8d;\n  --cds-border-subtle-00: #e0e0e0;\n  --cds-border-subtle-01: #c6c6c6;\n  --cds-border-subtle-02: #e0e0e0;\n  --cds-border-subtle-03: #c6c6c6;\n  --cds-border-subtle-selected-01: #c6c6c6;\n  --cds-border-subtle-selected-02: #c6c6c6;\n  --cds-border-subtle-selected-03: #c6c6c6;\n  --cds-border-tile-01: #c6c6c6;\n  --cds-border-tile-02: #a8a8a8;\n  --cds-border-tile-03: #c6c6c6;\n  --cds-chat-avatar-agent: #393939;\n  --cds-chat-avatar-bot: #6f6f6f;\n  --cds-chat-avatar-user: #0f62fe;\n  --cds-chat-bubble-agent: #ffffff;\n  --cds-chat-bubble-border: #e0e0e0;\n  --cds-chat-bubble-user: #e0e0e0;\n  --cds-chat-button: #0f62fe;\n  --cds-chat-button-active: rgba(141, 141, 141, 0.5);\n  --cds-chat-button-hover: rgba(141, 141, 141, 0.12);\n  --cds-chat-button-selected: rgba(141, 141, 141, 0.2);\n  --cds-chat-button-text-hover: #0043ce;\n  --cds-chat-button-text-selected: #525252;\n  --cds-chat-header-background: #ffffff;\n  --cds-chat-prompt-background: #ffffff;\n  --cds-chat-prompt-border-end: rgba(244, 244, 244, 0);\n  --cds-chat-prompt-border-start: #f4f4f4;\n  --cds-chat-shell-background: #ffffff;\n  --cds-field-01: #f4f4f4;\n  --cds-field-02: #ffffff;\n  --cds-field-03: #f4f4f4;\n  --cds-field-hover-01: #e8e8e8;\n  --cds-field-hover-02: #e8e8e8;\n  --cds-field-hover-03: #e8e8e8;\n  --cds-focus: #0f62fe;\n  --cds-focus-inset: #ffffff;\n  --cds-focus-inverse: #ffffff;\n  --cds-highlight: #d0e2ff;\n  --cds-icon-disabled: rgba(22, 22, 22, 0.25);\n  --cds-icon-interactive: #0f62fe;\n  --cds-icon-inverse: #ffffff;\n  --cds-icon-on-color: #ffffff;\n  --cds-icon-on-color-disabled: #8d8d8d;\n  --cds-icon-primary: #161616;\n  --cds-icon-secondary: #525252;\n  --cds-interactive: #0f62fe;\n  --cds-layer-01: #f4f4f4;\n  --cds-layer-02: #ffffff;\n  --cds-layer-03: #f4f4f4;\n  --cds-layer-accent-01: #e0e0e0;\n  --cds-layer-accent-02: #e0e0e0;\n  --cds-layer-accent-03: #e0e0e0;\n  --cds-layer-accent-active-01: #a8a8a8;\n  --cds-layer-accent-active-02: #a8a8a8;\n  --cds-layer-accent-active-03: #a8a8a8;\n  --cds-layer-accent-hover-01: #d1d1d1;\n  --cds-layer-accent-hover-02: #d1d1d1;\n  --cds-layer-accent-hover-03: #d1d1d1;\n  --cds-layer-active-01: #c6c6c6;\n  --cds-layer-active-02: #c6c6c6;\n  --cds-layer-active-03: #c6c6c6;\n  --cds-layer-hover-01: #e8e8e8;\n  --cds-layer-hover-02: #e8e8e8;\n  --cds-layer-hover-03: #e8e8e8;\n  --cds-layer-selected-01: #e0e0e0;\n  --cds-layer-selected-02: #e0e0e0;\n  --cds-layer-selected-03: #e0e0e0;\n  --cds-layer-selected-disabled: #8d8d8d;\n  --cds-layer-selected-hover-01: #d1d1d1;\n  --cds-layer-selected-hover-02: #d1d1d1;\n  --cds-layer-selected-hover-03: #d1d1d1;\n  --cds-layer-selected-inverse: #161616;\n  --cds-link-inverse: #78a9ff;\n  --cds-link-inverse-active: #f4f4f4;\n  --cds-link-inverse-hover: #a6c8ff;\n  --cds-link-inverse-visited: #be95ff;\n  --cds-link-primary: #0f62fe;\n  --cds-link-primary-hover: #0043ce;\n  --cds-link-secondary: #0043ce;\n  --cds-link-visited: #8a3ffc;\n  --cds-overlay: rgba(22, 22, 22, 0.5);\n  --cds-shadow: rgba(0, 0, 0, 0.3);\n  --cds-skeleton-background: #e8e8e8;\n  --cds-skeleton-element: #c6c6c6;\n  --cds-support-caution-major: #ff832b;\n  --cds-support-caution-minor: #f1c21b;\n  --cds-support-caution-undefined: #8a3ffc;\n  --cds-support-error: #da1e28;\n  --cds-support-error-inverse: #fa4d56;\n  --cds-support-info: #0043ce;\n  --cds-support-info-inverse: #4589ff;\n  --cds-support-success: #24a148;\n  --cds-support-success-inverse: #42be65;\n  --cds-support-warning: #f1c21b;\n  --cds-support-warning-inverse: #f1c21b;\n  --cds-text-disabled: rgba(22, 22, 22, 0.25);\n  --cds-text-error: #da1e28;\n  --cds-text-helper: #6f6f6f;\n  --cds-text-inverse: #ffffff;\n  --cds-text-on-color: #ffffff;\n  --cds-text-on-color-disabled: #8d8d8d;\n  --cds-text-placeholder: rgba(22, 22, 22, 0.4);\n  --cds-text-primary: #161616;\n  --cds-text-secondary: #525252;\n  --cds-toggle-off: #8d8d8d;\n  --cds-spacing-01: 0.125rem;\n  --cds-spacing-02: 0.25rem;\n  --cds-spacing-03: 0.5rem;\n  --cds-spacing-04: 0.75rem;\n  --cds-spacing-05: 1rem;\n  --cds-spacing-06: 1.5rem;\n  --cds-spacing-07: 2rem;\n  --cds-spacing-08: 2.5rem;\n  --cds-spacing-09: 3rem;\n  --cds-spacing-10: 4rem;\n  --cds-spacing-11: 5rem;\n  --cds-spacing-12: 6rem;\n  --cds-spacing-13: 10rem;\n  --cds-fluid-spacing-01: 0;\n  --cds-fluid-spacing-02: 2vw;\n  --cds-fluid-spacing-03: 5vw;\n  --cds-fluid-spacing-04: 10vw;\n  --cds-caption-01-font-size: 0.75rem;\n  --cds-caption-01-font-weight: 400;\n  --cds-caption-01-line-height: 1.33333;\n  --cds-caption-01-letter-spacing: 0.32px;\n  --cds-caption-02-font-size: 0.875rem;\n  --cds-caption-02-font-weight: 400;\n  --cds-caption-02-line-height: 1.28572;\n  --cds-caption-02-letter-spacing: 0.32px;\n  --cds-label-01-font-size: 0.75rem;\n  --cds-label-01-font-weight: 400;\n  --cds-label-01-line-height: 1.33333;\n  --cds-label-01-letter-spacing: 0.32px;\n  --cds-label-02-font-size: 0.875rem;\n  --cds-label-02-font-weight: 400;\n  --cds-label-02-line-height: 1.28572;\n  --cds-label-02-letter-spacing: 0.16px;\n  --cds-helper-text-01-font-size: 0.75rem;\n  --cds-helper-text-01-line-height: 1.33333;\n  --cds-helper-text-01-letter-spacing: 0.32px;\n  --cds-helper-text-02-font-size: 0.875rem;\n  --cds-helper-text-02-font-weight: 400;\n  --cds-helper-text-02-line-height: 1.28572;\n  --cds-helper-text-02-letter-spacing: 0.16px;\n  --cds-body-short-01-font-size: 0.875rem;\n  --cds-body-short-01-font-weight: 400;\n  --cds-body-short-01-line-height: 1.28572;\n  --cds-body-short-01-letter-spacing: 0.16px;\n  --cds-body-short-02-font-size: 1rem;\n  --cds-body-short-02-font-weight: 400;\n  --cds-body-short-02-line-height: 1.375;\n  --cds-body-short-02-letter-spacing: 0;\n  --cds-body-long-01-font-size: 0.875rem;\n  --cds-body-long-01-font-weight: 400;\n  --cds-body-long-01-line-height: 1.42857;\n  --cds-body-long-01-letter-spacing: 0.16px;\n  --cds-body-long-02-font-size: 1rem;\n  --cds-body-long-02-font-weight: 400;\n  --cds-body-long-02-line-height: 1.5;\n  --cds-body-long-02-letter-spacing: 0;\n  --cds-code-01-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-01-font-size: 0.75rem;\n  --cds-code-01-font-weight: 400;\n  --cds-code-01-line-height: 1.33333;\n  --cds-code-01-letter-spacing: 0.32px;\n  --cds-code-02-font-family: 'IBM Plex Mono', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', monospace;\n  --cds-code-02-font-size: 0.875rem;\n  --cds-code-02-font-weight: 400;\n  --cds-code-02-line-height: 1.42857;\n  --cds-code-02-letter-spacing: 0.32px;\n  --cds-heading-01-font-size: 0.875rem;\n  --cds-heading-01-font-weight: 600;\n  --cds-heading-01-line-height: 1.42857;\n  --cds-heading-01-letter-spacing: 0.16px;\n  --cds-heading-02-font-size: 1rem;\n  --cds-heading-02-font-weight: 600;\n  --cds-heading-02-line-height: 1.5;\n  --cds-heading-02-letter-spacing: 0;\n  --cds-productive-heading-01-font-size: 0.875rem;\n  --cds-productive-heading-01-font-weight: 600;\n  --cds-productive-heading-01-line-height: 1.28572;\n  --cds-productive-heading-01-letter-spacing: 0.16px;\n  --cds-productive-heading-02-font-size: 1rem;\n  --cds-productive-heading-02-font-weight: 600;\n  --cds-productive-heading-02-line-height: 1.375;\n  --cds-productive-heading-02-letter-spacing: 0;\n  --cds-productive-heading-03-font-size: 1.25rem;\n  --cds-productive-heading-03-font-weight: 400;\n  --cds-productive-heading-03-line-height: 1.4;\n  --cds-productive-heading-03-letter-spacing: 0;\n  --cds-productive-heading-04-font-size: 1.75rem;\n  --cds-productive-heading-04-font-weight: 400;\n  --cds-productive-heading-04-line-height: 1.28572;\n  --cds-productive-heading-04-letter-spacing: 0;\n  --cds-productive-heading-05-font-size: 2rem;\n  --cds-productive-heading-05-font-weight: 400;\n  --cds-productive-heading-05-line-height: 1.25;\n  --cds-productive-heading-05-letter-spacing: 0;\n  --cds-productive-heading-06-font-size: 2.625rem;\n  --cds-productive-heading-06-font-weight: 300;\n  --cds-productive-heading-06-line-height: 1.199;\n  --cds-productive-heading-06-letter-spacing: 0;\n  --cds-productive-heading-07-font-size: 3.375rem;\n  --cds-productive-heading-07-font-weight: 300;\n  --cds-productive-heading-07-line-height: 1.19;\n  --cds-productive-heading-07-letter-spacing: 0;\n  --cds-expressive-paragraph-01-font-size: 1.5rem;\n  --cds-expressive-paragraph-01-font-weight: 300;\n  --cds-expressive-paragraph-01-line-height: 1.334;\n  --cds-expressive-paragraph-01-letter-spacing: 0;\n  --cds-expressive-heading-01-font-size: 0.875rem;\n  --cds-expressive-heading-01-font-weight: 600;\n  --cds-expressive-heading-01-line-height: 1.42857;\n  --cds-expressive-heading-01-letter-spacing: 0.16px;\n  --cds-expressive-heading-02-font-size: 1rem;\n  --cds-expressive-heading-02-font-weight: 600;\n  --cds-expressive-heading-02-line-height: 1.5;\n  --cds-expressive-heading-02-letter-spacing: 0;\n  --cds-expressive-heading-03-font-size: 1.25rem;\n  --cds-expressive-heading-03-font-weight: 400;\n  --cds-expressive-heading-03-line-height: 1.4;\n  --cds-expressive-heading-03-letter-spacing: 0;\n  --cds-expressive-heading-04-font-size: 1.75rem;\n  --cds-expressive-heading-04-font-weight: 400;\n  --cds-expressive-heading-04-line-height: 1.28572;\n  --cds-expressive-heading-04-letter-spacing: 0;\n  --cds-expressive-heading-05-font-size: 2rem;\n  --cds-expressive-heading-05-font-weight: 400;\n  --cds-expressive-heading-05-line-height: 1.25;\n  --cds-expressive-heading-05-letter-spacing: 0;\n  --cds-expressive-heading-06-font-size: 2rem;\n  --cds-expressive-heading-06-font-weight: 600;\n  --cds-expressive-heading-06-line-height: 1.25;\n  --cds-expressive-heading-06-letter-spacing: 0;\n  --cds-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-01-font-size: 1.25rem;\n  --cds-quotation-01-font-weight: 400;\n  --cds-quotation-01-line-height: 1.3;\n  --cds-quotation-01-letter-spacing: 0;\n  --cds-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-quotation-02-font-size: 2rem;\n  --cds-quotation-02-font-weight: 300;\n  --cds-quotation-02-line-height: 1.25;\n  --cds-quotation-02-letter-spacing: 0;\n  --cds-display-01-font-size: 2.625rem;\n  --cds-display-01-font-weight: 300;\n  --cds-display-01-line-height: 1.19;\n  --cds-display-01-letter-spacing: 0;\n  --cds-display-02-font-size: 2.625rem;\n  --cds-display-02-font-weight: 600;\n  --cds-display-02-line-height: 1.19;\n  --cds-display-02-letter-spacing: 0;\n  --cds-display-03-font-size: 2.625rem;\n  --cds-display-03-font-weight: 300;\n  --cds-display-03-line-height: 1.19;\n  --cds-display-03-letter-spacing: 0;\n  --cds-display-04-font-size: 2.625rem;\n  --cds-display-04-font-weight: 300;\n  --cds-display-04-line-height: 1.19;\n  --cds-display-04-letter-spacing: 0;\n  --cds-legal-01-font-size: 0.75rem;\n  --cds-legal-01-font-weight: 400;\n  --cds-legal-01-line-height: 1.33333;\n  --cds-legal-01-letter-spacing: 0.32px;\n  --cds-legal-02-font-size: 0.875rem;\n  --cds-legal-02-font-weight: 400;\n  --cds-legal-02-line-height: 1.28572;\n  --cds-legal-02-letter-spacing: 0.16px;\n  --cds-body-compact-01-font-size: 0.875rem;\n  --cds-body-compact-01-font-weight: 400;\n  --cds-body-compact-01-line-height: 1.28572;\n  --cds-body-compact-01-letter-spacing: 0.16px;\n  --cds-body-compact-02-font-size: 1rem;\n  --cds-body-compact-02-font-weight: 400;\n  --cds-body-compact-02-line-height: 1.375;\n  --cds-body-compact-02-letter-spacing: 0;\n  --cds-heading-compact-01-font-size: 0.875rem;\n  --cds-heading-compact-01-font-weight: 600;\n  --cds-heading-compact-01-line-height: 1.28572;\n  --cds-heading-compact-01-letter-spacing: 0.16px;\n  --cds-heading-compact-02-font-size: 1rem;\n  --cds-heading-compact-02-font-weight: 600;\n  --cds-heading-compact-02-line-height: 1.375;\n  --cds-heading-compact-02-letter-spacing: 0;\n  --cds-body-01-font-size: 0.875rem;\n  --cds-body-01-font-weight: 400;\n  --cds-body-01-line-height: 1.42857;\n  --cds-body-01-letter-spacing: 0.16px;\n  --cds-body-02-font-size: 1rem;\n  --cds-body-02-font-weight: 400;\n  --cds-body-02-line-height: 1.5;\n  --cds-body-02-letter-spacing: 0;\n  --cds-heading-03-font-size: 1.25rem;\n  --cds-heading-03-font-weight: 400;\n  --cds-heading-03-line-height: 1.4;\n  --cds-heading-03-letter-spacing: 0;\n  --cds-heading-04-font-size: 1.75rem;\n  --cds-heading-04-font-weight: 400;\n  --cds-heading-04-line-height: 1.28572;\n  --cds-heading-04-letter-spacing: 0;\n  --cds-heading-05-font-size: 2rem;\n  --cds-heading-05-font-weight: 400;\n  --cds-heading-05-line-height: 1.25;\n  --cds-heading-05-letter-spacing: 0;\n  --cds-heading-06-font-size: 2.625rem;\n  --cds-heading-06-font-weight: 300;\n  --cds-heading-06-line-height: 1.199;\n  --cds-heading-06-letter-spacing: 0;\n  --cds-heading-07-font-size: 3.375rem;\n  --cds-heading-07-font-weight: 300;\n  --cds-heading-07-line-height: 1.19;\n  --cds-heading-07-letter-spacing: 0;\n  --cds-fluid-heading-03-font-size: 1.25rem;\n  --cds-fluid-heading-03-font-weight: 400;\n  --cds-fluid-heading-03-line-height: 1.4;\n  --cds-fluid-heading-03-letter-spacing: 0;\n  --cds-fluid-heading-04-font-size: 1.75rem;\n  --cds-fluid-heading-04-font-weight: 400;\n  --cds-fluid-heading-04-line-height: 1.28572;\n  --cds-fluid-heading-04-letter-spacing: 0;\n  --cds-fluid-heading-05-font-size: 2rem;\n  --cds-fluid-heading-05-font-weight: 400;\n  --cds-fluid-heading-05-line-height: 1.25;\n  --cds-fluid-heading-05-letter-spacing: 0;\n  --cds-fluid-heading-06-font-size: 2rem;\n  --cds-fluid-heading-06-font-weight: 600;\n  --cds-fluid-heading-06-line-height: 1.25;\n  --cds-fluid-heading-06-letter-spacing: 0;\n  --cds-fluid-paragraph-01-font-size: 1.5rem;\n  --cds-fluid-paragraph-01-font-weight: 300;\n  --cds-fluid-paragraph-01-line-height: 1.334;\n  --cds-fluid-paragraph-01-letter-spacing: 0;\n  --cds-fluid-quotation-01-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-01-font-size: 1.25rem;\n  --cds-fluid-quotation-01-font-weight: 400;\n  --cds-fluid-quotation-01-line-height: 1.3;\n  --cds-fluid-quotation-01-letter-spacing: 0;\n  --cds-fluid-quotation-02-font-family: 'IBM Plex Serif', system-ui, -apple-system, BlinkMacSystemFont, '.SFNSText-Regular', serif;\n  --cds-fluid-quotation-02-font-size: 2rem;\n  --cds-fluid-quotation-02-font-weight: 300;\n  --cds-fluid-quotation-02-line-height: 1.25;\n  --cds-fluid-quotation-02-letter-spacing: 0;\n  --cds-fluid-display-01-font-size: 2.625rem;\n  --cds-fluid-display-01-font-weight: 300;\n  --cds-fluid-display-01-line-height: 1.19;\n  --cds-fluid-display-01-letter-spacing: 0;\n  --cds-fluid-display-02-font-size: 2.625rem;\n  --cds-fluid-display-02-font-weight: 600;\n  --cds-fluid-display-02-line-height: 1.19;\n  --cds-fluid-display-02-letter-spacing: 0;\n  --cds-fluid-display-03-font-size: 2.625rem;\n  --cds-fluid-display-03-font-weight: 300;\n  --cds-fluid-display-03-line-height: 1.19;\n  --cds-fluid-display-03-letter-spacing: 0;\n  --cds-fluid-display-04-font-size: 2.625rem;\n  --cds-fluid-display-04-font-weight: 300;\n  --cds-fluid-display-04-line-height: 1.19;\n  --cds-fluid-display-04-letter-spacing: 0;\n  --cds-true: ;\n  --cds-tag-background-red: #ffd7d9;\n  --cds-tag-color-red: #a2191f;\n  --cds-tag-hover-red: #ffc2c5;\n  --cds-tag-background-magenta: #ffd6e8;\n  --cds-tag-color-magenta: #9f1853;\n  --cds-tag-hover-magenta: #ffbdda;\n  --cds-tag-background-purple: #e8daff;\n  --cds-tag-color-purple: #6929c4;\n  --cds-tag-hover-purple: #dcc7ff;\n  --cds-tag-background-blue: #d0e2ff;\n  --cds-tag-color-blue: #0043ce;\n  --cds-tag-hover-blue: #b8d3ff;\n  --cds-tag-background-cyan: #bae6ff;\n  --cds-tag-color-cyan: #00539a;\n  --cds-tag-hover-cyan: #99daff;\n  --cds-tag-background-teal: #9ef0f0;\n  --cds-tag-color-teal: #005d5d;\n  --cds-tag-hover-teal: #57e5e5;\n  --cds-tag-background-green: #a7f0ba;\n  --cds-tag-color-green: #0e6027;\n  --cds-tag-hover-green: #74e792;\n  --cds-tag-background-gray: #e0e0e0;\n  --cds-tag-color-gray: #161616;\n  --cds-tag-hover-gray: #d1d1d1;\n  --cds-tag-border-red: #ff8389;\n  --cds-tag-border-blue: #78a9ff;\n  --cds-tag-border-cyan: #33b1ff;\n  --cds-tag-border-teal: #08bdba;\n  --cds-tag-border-green: #42be65;\n  --cds-tag-border-magenta: #ff7eb6;\n  --cds-tag-border-purple: #be95ff;\n  --cds-tag-border-gray: #a8a8a8;\n  --cds-tag-border-cool-gray: #a2a9b0;\n  --cds-tag-border-warm-gray: #ada8a8;\n  --cds-tag-background-cool-gray: #dde1e6;\n  --cds-tag-color-cool-gray: #121619;\n  --cds-tag-hover-cool-gray: #cdd3da;\n  --cds-tag-background-warm-gray: #e5e0df;\n  --cds-tag-color-warm-gray: #171414;\n  --cds-tag-hover-warm-gray: #d8d0cf;\n  --cds-button-separator: #e0e0e0;\n  --cds-button-primary: #0f62fe;\n  --cds-button-secondary: #393939;\n  --cds-button-tertiary: #0f62fe;\n  --cds-button-danger-primary: #da1e28;\n  --cds-button-danger-secondary: #da1e28;\n  --cds-button-danger-active: #750e13;\n  --cds-button-primary-active: #002d9c;\n  --cds-button-secondary-active: #6f6f6f;\n  --cds-button-tertiary-active: #002d9c;\n  --cds-button-danger-hover: #b81921;\n  --cds-button-primary-hover: #0050e6;\n  --cds-button-secondary-hover: #474747;\n  --cds-button-tertiary-hover: #0050e6;\n  --cds-button-disabled: #c6c6c6;\n  --cds-layer: var(--cds-layer-01, #f4f4f4);\n  --cds-layer-active: var(--cds-layer-active-01, #c6c6c6);\n  --cds-layer-hover: var(--cds-layer-hover-01, #e8e8e8);\n  --cds-layer-selected: var(--cds-layer-selected-01, #e0e0e0);\n  --cds-layer-selected-hover: var(--cds-layer-selected-hover-01, #d1d1d1);\n  --cds-layer-accent: var(--cds-layer-accent-01, #e0e0e0);\n  --cds-layer-accent-hover: var(--cds-layer-accent-hover-01, #d1d1d1);\n  --cds-layer-accent-active: var(--cds-layer-accent-active-01, #a8a8a8);\n  --cds-field: var(--cds-field-01, #f4f4f4);\n  --cds-field-hover: var(--cds-field-hover-01, #e8e8e8);\n  --cds-border-subtle: var(--cds-border-subtle-00, #e0e0e0);\n  --cds-border-subtle-selected: var(--cds-border-subtle-selected-01, #c6c6c6);\n  --cds-border-strong: var(--cds-border-strong-01, #8d8d8d);\n  --cds-border-tile: var(--cds-border-tile-01, #c6c6c6);\n}\n.cds--side-nav__submenu .cds--side-nav__submenu-content {\n  display: flex;\n  block-size: auto;\n  inline-size: 100%;\n  min-block-size: 3rem;\n}\n.cds--side-nav__submenu .cds--side-nav__submenu-title {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  align-self: center;\n  color: var(--cds-text-secondary, #525252);\n}\n.cds--side-nav__submenu[aria-haspopup=true] {\n  block-size: 3rem;\n}\n.cds--side-nav__submenu[aria-haspopup=true].cds--side-nav__submenu-platform {\n  block-size: 3rem;\n  border-block-end: 1px solid var(--cds-toggle-off, #8d8d8d);\n  border-block-start: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n  color: var(--cds-text-primary, #161616);\n  text-decoration: none;\n  font-size: var(--cds-heading-02-font-size, 1rem);\n  font-weight: var(--cds-heading-02-font-weight, 600);\n  line-height: var(--cds-heading-02-line-height, 1.5);\n  letter-spacing: var(--cds-heading-02-letter-spacing, 0);\n}\n.cds--side-nav__submenu:hover .cds--side-nav__submenu-title, .cds--side-nav__submenu:focus .cds--side-nav__submenu-title {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--side-nav__submenu-title,\na.cds--side-nav__link > .cds--side-nav__link-text,\nbutton.cds--side-nav__link > .cds--side-nav__link-text {\n  padding: 0.8rem 0;\n  text-overflow: initial;\n  white-space: normal;\n}\n\n.cds--masthead__side-nav--submemu-heading,\n:host(c4d-left-nav-menu-category-heading) {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  color: var(--cds-text-secondary, #525252);\n}\n.cds--masthead__side-nav--submemu-heading:is(.cds--left-nav-menu-category__heading-large),\n:host(c4d-left-nav-menu-category-heading):is(.cds--left-nav-menu-category__heading-large) {\n  margin: 0.5rem 0 1.5rem;\n}\n.cds--masthead__side-nav--submemu-heading:is(.cds--left-nav-menu-category__heading-large) .cds--side-nav__heading,\n:host(c4d-left-nav-menu-category-heading):is(.cds--left-nav-menu-category__heading-large) .cds--side-nav__heading {\n  padding: 0;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading {\n  padding: 1rem 0;\n  block-size: auto;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title {\n  display: block;\n  padding: 0 1rem;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title:where(a),\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title:where(a) {\n  display: inline-flex;\n  align-items: center;\n  color: inherit;\n  gap: 0.5rem;\n  text-decoration: none;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title:where(a):hover,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title:where(a):hover {\n  text-decoration: underline;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-title:where(a):focus,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-title:where(a):focus {\n  color: var(--cds-text-primary, #161616);\n  outline: 2px solid var(--cds-focus, #0f62fe);\n  outline-offset: -2px;\n}\n.cds--masthead__side-nav--submemu-heading .cds--side-nav__heading-description,\n:host(c4d-left-nav-menu-category-heading) .cds--side-nav__heading-description {\n  padding: 0 1rem;\n}\n.cds--masthead__side-nav--submemu-heading ::slotted(:first-child),\n:host(c4d-left-nav-menu-category-heading) ::slotted(:first-child) {\n  padding-block-start: 0.5rem;\n}\n.cds--masthead__side-nav--submemu-heading h2,\n:host(c4d-left-nav-menu-category-heading) h2 {\n  font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-productive-heading-01-font-weight, 600);\n  line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n  letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  color: var(--cds-text-primary, #161616);\n}\n.cds--masthead__side-nav--submemu-heading h2.cds--side-nav__menu-section-title,\n:host(c4d-left-nav-menu-category-heading) h2.cds--side-nav__menu-section-title {\n  font-size: var(--cds-productive-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-productive-heading-03-font-weight, 400);\n  line-height: var(--cds-productive-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-productive-heading-03-letter-spacing, 0);\n}\n.cds--masthead__side-nav--submemu-heading h2.cds--side-nav__menu-section-title + .cds--side-nav__heading-description,\n:host(c4d-left-nav-menu-category-heading) h2.cds--side-nav__menu-section-title + .cds--side-nav__heading-description {\n  margin-block-start: 0.5rem;\n}\n\n/* stylelint-disable selector-pseudo-class-parentheses-space-inside */\n:host(c4d-left-nav-menu-category-heading):not(.cds--left-nav-menu-category__heading-large),\n:host(c4d-left-nav-menu),\n:host(c4d-left-nav-menu-item) {\n  display: block;\n  border-block-end: 1px solid var(--cds-layer-accent-01, #e0e0e0);\n}\n\n/* stylelint-enable selector-pseudo-class-parentheses-space-inside */\n:host(c4d-left-nav-menu-item) .cds--side-nav__link {\n  display: flex;\n  align-items: center;\n  block-size: auto;\n  inline-size: 100%;\n  min-block-size: 3rem;\n  padding-inline-start: 1rem;\n}\n:host(c4d-left-nav-menu-item) .cds--side-nav__link:not(:is(a)):hover {\n  background-color: transparent;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-header:not(:first-of-type) {\n  margin-block-start: 2rem;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-header .cds--side-nav__link-text {\n  font-size: var(--cds-productive-heading-01-font-size, 0.875rem);\n  font-weight: var(--cds-productive-heading-01-font-weight, 600);\n  line-height: var(--cds-productive-heading-01-line-height, 1.28572);\n  letter-spacing: var(--cds-productive-heading-01-letter-spacing, 0.16px);\n  display: inline-flex;\n  align-items: center;\n  justify-content: space-between;\n  color: var(--cds-text-primary, #161616);\n  gap: 0.5rem;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-header .cds--side-nav__link-text svg {\n  color: var(--cds-icon-primary, #161616);\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-view-all:hover .cds--side-nav__link-text {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-view-all .cds--side-nav__link-text {\n  display: inline-flex;\n  align-items: center;\n  justify-content: space-between;\n  color: var(--cds-button-primary, #0f62fe);\n  gap: 0.5rem;\n}\n:host(c4d-left-nav-menu-item).cds--side-nav__group-view-all .cds--side-nav__link-text svg {\n  color: var(--cds-button-primary, #0f62fe);\n}\n\n.cds--masthead__side-nav--submemu--selected {\n  border-inline-start: 3px solid var(--cds-background-brand, #0f62fe);\n}\n.cds--masthead__side-nav--submemu--selected .cds--side-nav__submenu-title, .cds--masthead__side-nav--submemu--selected.cds--side-nav__link .cds--side-nav__link-text {\n  font-weight: carbon--font-weight(\"semibold\");\n}\n\n.cds--side-nav__submenu-chevron > svg,\n.cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  fill: var(--cds-text-primary, #161616);\n  transform: rotate(-90deg);\n}\n:host([dir=rtl]) .cds--side-nav__submenu-chevron > svg,\n:host([dir=rtl]) .cds--side-nav__submenu[aria-expanded=true] .cds--side-nav__submenu-chevron > svg {\n  transform: rotate(90deg) scale(1.25);\n}\n\n.cds--side-nav__item .cds--side-nav__link,\n.cds--side-nav__menu-item .cds--side-nav__link:not([isbackbutton=true]),\n:host(c4d-left-nav-item-highlighted) a.cds--side-nav__link,\n:host(c4d-left-nav-menu-item-highlighted) a.cds--side-nav__link,\n:host(c4d-left-nav-item) a.cds--side-nav__link {\n  display: flex;\n  block-size: auto;\n  inline-size: 100%;\n  min-block-size: 3rem;\n  padding-inline-start: 1rem;\n}\n\n.cds--side-nav__submenu-platform {\n  flex-direction: row;\n}\n.cds--side-nav__submenu-platform::after {\n  content: none;\n}\n\n@keyframes expand {\n  0% {\n    max-block-size: 0;\n    overflow-y: hidden;\n  }\n  100% {\n    max-block-size: 100%;\n  }\n}\n@keyframes collapse {\n  0% {\n    max-block-size: 100vh;\n  }\n  100% {\n    max-block-size: 0;\n  }\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--header__nav .cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  background-color: transparent;\n  box-shadow: none;\n  inset-block-end: 0;\n}\n\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu {\n  position: fixed;\n  display: block;\n  inline-size: 100vw;\n  inset-inline-start: 0;\n  margin-block-end: 4rem;\n  transform: translateZ(0.0001px);\n  transition: visibility 300ms cubic-bezier(0.5, 0, 0.1, 1);\n  visibility: hidden;\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=false] + .cds--header__menu ::slotted(c4d-megamenu),\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=false] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=false] + .cds--header__menu .cds--masthead__megamenu {\n  animation: 300ms cubic-bezier(0.4, 0.14, 0.3, 1) collapse;\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  position: fixed;\n  block-size: calc(100vh - 4rem - 3rem);\n  inline-size: var(--c4d-ce--viewport-width, 100vw);\n  inset-inline-start: 0;\n  margin-block-end: 4rem;\n  min-block-size: 320px;\n  transform: translateZ(0);\n  visibility: visible;\n}\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu ::slotted(c4d-megamenu),\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--masthead__megamenu,\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu ::slotted(c4d-megamenu),\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu .cds--masthead__megamenu {\n  animation: 300ms cubic-bezier(0.4, 0.14, 0.3, 1) expand;\n}\n\n:host(c4d-megamenu-top-nav-menu) .cds--header__menu-title[aria-expanded=true] + .cds--header__menu,\n.cds--masthead__megamenu__l0-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inset-block-start: var(--c4d-masthead-l0-bottom-edge, 3rem);\n}\n\n.cds--masthead__megamenu__l1-nav .cds--header__menu-title[aria-expanded=true] + .cds--header__menu {\n  inset-block-start: 6.125rem;\n}\n\n:host(c4d-megamenu),\n.cds--masthead__megamenu {\n  box-shadow: 0 2px 6px var(--cds-shadow, rgba(0, 0, 0, 0.3));\n  --c4d-masthead-max-height: calc(\n    100vh - var(--cds-spacing-09, 3rem) - var(--cds-layout-05, 4rem)\n  );\n  --c4d-masthead-overflow: auto;\n  display: block;\n  overflow: hidden auto;\n  background-color: var(--cds-background, #ffffff);\n}\n:host(c4d-megamenu):focus,\n.cds--masthead__megamenu:focus {\n  outline: none;\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container,\n.cds--masthead__megamenu .cds--masthead__megamenu__container {\n  margin-inline: auto;\n  max-inline-size: 99rem;\n  padding-inline: 1rem;\n  inline-size: 100vw;\n}\n@media (min-width: 42rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container {\n    padding-inline: 2rem;\n  }\n}\n@media (min-width: 99rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container {\n    padding-inline: 2.5rem;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row,\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row {\n  background-color: var(--cds-layer-accent-01, #e0e0e0);\n  /**\n   * Faceted (tab) and Simple (list) megamenus have different layouts between\n   * 'md' and 'lg' breakpoints. This requires us to apply identical styles at\n   * different breakpoints, and we must also leverage custom properties to assign\n   * values across shadow roots. The concept is that these upper shadow roots have\n   * the stateful information needed to dictate how elements in the lower shadow\n   * roots should appear, and we can pass that information down via custom props.\n   */\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab,\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab {\n  display: flex;\n  flex-wrap: wrap;\n  margin-inline: -1rem;\n  flex-wrap: nowrap;\n  gap: 1px;\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab ::slotted(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--tab ::slotted(c4d-megamenu-right-navigation) {\n  --c4d-right-nav-padding: 1rem;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list {\n    overflow: var(--c4d-masthead-overflow);\n    max-block-size: var(--c4d-masthead-max-height);\n    --c4d-view-all-inset: calc(1rem * -1);\n    --c4d-view-all-container-position: initial;\n    --c4d-view-all-container-transform: initial;\n    position: relative;\n    z-index: 1;\n    margin-inline: calc(3rem * -1);\n    transform: rotate(0deg);\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list {\n    display: flex;\n    flex-wrap: wrap;\n    margin-inline: -1rem;\n    flex-wrap: nowrap;\n    gap: 1px;\n  }\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n    --c4d-view-all-padding: 1rem;\n    --c4d-masthead-max-height: initial;\n    --c4d-masthead-overflow: initial;\n    overflow: initial;\n    border-block-end: 0.0625rem solid var(--cds-layer-accent-01, #e0e0e0);\n    inline-size: 100%;\n    margin-inline: initial;\n    max-block-size: initial;\n    max-inline-size: initial;\n    padding-inline: 2rem;\n  }\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container,\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container,\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container {\n    overflow: initial;\n    max-block-size: initial;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) {\n  --c4d-left-nav-columns: 2;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-left-navigation) {\n    --c4d-left-nav-columns: initial;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n  --c4d-right-nav-padding: 0;\n}\n@media (max-width: 65.98rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n    --c4d-view-all-display: none;\n    border-block-end: none;\n  }\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted(c4d-megamenu-right-navigation) {\n    --c4d-right-nav-padding: 1rem;\n  }\n}\n:host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]),\n.cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]) {\n  --c4d-view-all-padding: 3rem;\n  position: sticky;\n  z-index: 1;\n  background-color: var(--cds-background, #ffffff);\n  border-block-start: 0.0625rem solid var(--cds-layer-accent-01, #e0e0e0);\n  inset-block-end: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu) .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]),\n  .cds--masthead__megamenu .cds--masthead__megamenu__container--row.cds--masthead__megamenu__container--row--list ::slotted([part*=view-all]) {\n    display: none;\n  }\n}\n:host(c4d-megamenu) ::slotted([role=tabpanel]),\n.cds--masthead__megamenu ::slotted([role=tabpanel]) {\n  inline-size: 100%;\n}\n\n:host(c4d-megamenu-left-navigation),\n.cds--masthead__megamenu__highlight-section,\n:host(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu__categories-section {\n  position: relative;\n  display: block;\n  background-color: var(--cds-background, #ffffff);\n  padding-block-start: 1.5rem;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container {\n  overflow: var(--c4d-masthead-overflow);\n  max-block-size: var(--c4d-masthead-max-height);\n  position: var(--c4d-view-all-container-position, relative);\n  z-index: 1;\n  block-size: 100%;\n  transform: var(--c4d-view-all-container-transform, rotate(0deg));\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu-container-inner {\n  overflow: overlay;\n  max-block-size: 100%;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all {\n  position: relative;\n  display: var(--c4d-view-all-display, inherit);\n  background-color: var(--cds-background, #ffffff);\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border,\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container.cds--masthead__megamenu-container--has-view-all-link .cds--masthead__megamenu__view-all__border {\n  position: absolute;\n  background: var(--cds-layer-accent-01, #e0e0e0);\n  block-size: 0.0625rem;\n  inset-block-start: 0;\n}\n\n:host(c4d-megamenu-left-navigation),\n.cds--masthead__megamenu__highlight-section {\n  display: block;\n  flex: 0 0 25%;\n  max-inline-size: 25%;\n  margin-inline-start: calc(1rem * -1);\n  min-block-size: 100%;\n  padding-inline-start: 1rem;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu__categories {\n  -moz-columns: var(--c4d-left-nav-columns, \"initial\");\n       columns: var(--c4d-left-nav-columns, \"initial\");\n  gap: 0;\n}\n:host(c4d-megamenu-left-navigation) .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__highlight-section .cds--masthead__megamenu__view-all__border {\n  inset-inline: 0;\n}\n\n:host(c4d-megamenu-right-navigation),\n.cds--masthead__megamenu__categories-section {\n  display: block;\n  inline-size: 100%;\n}\n:host(c4d-megamenu-right-navigation).c4d--masthead__tabpanel-child,\n.cds--masthead__megamenu__categories-section.c4d--masthead__tabpanel-child {\n  block-size: 100%;\n}\n:host(c4d-megamenu-right-navigation)[style-scheme=has-sidebar] .cds--masthead__megamenu__heading,\n:host(c4d-megamenu-right-navigation)[style-scheme=has-sidebar] .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section[style-scheme=has-sidebar] .cds--masthead__megamenu__heading,\n.cds--masthead__megamenu__categories-section[style-scheme=has-sidebar] .cds--masthead__megamenu__categories {\n  padding-inline-start: var(--c4d-right-nav-padding, 1rem);\n}\n:host(c4d-megamenu-right-navigation) ::slotted(c4d-megamenu-heading),\n.cds--masthead__megamenu__categories-section ::slotted(c4d-megamenu-heading) {\n  --heading-description-column-count: 2;\n  --heading-description-column-count-lg: 4;\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu--has-view-all-link .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu--has-view-all-link .cds--masthead__megamenu__categories {\n  padding-block-end: 0;\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container--has-sidebar ::slotted(c4d-megamenu-heading),\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container--has-sidebar ::slotted(c4d-megamenu-heading) {\n  --heading-description-column-count: 2;\n  --heading-description-column-count-lg: 3;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-right-navigation) .cds--masthead__megamenu-container--has-sidebar .cds--masthead__megamenu__categories,\n  .cds--masthead__megamenu__categories-section .cds--masthead__megamenu-container--has-sidebar .cds--masthead__megamenu__categories {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu__categories {\n  -moz-column-count: 2;\n       column-count: 2;\n  -moz-column-gap: 0;\n       column-gap: 0;\n  padding-block-end: 2rem;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-right-navigation) .cds--masthead__megamenu__categories,\n  .cds--masthead__megamenu__categories-section .cds--masthead__megamenu__categories {\n    -moz-column-count: 4;\n         column-count: 4;\n  }\n}\n:host(c4d-megamenu-right-navigation) .cds--masthead__megamenu__view-all__border,\n.cds--masthead__megamenu__categories-section .cds--masthead__megamenu__view-all__border {\n  inset-inline: 0;\n}\n:host(c4d-megamenu-right-navigation)[data-child-count=\"1\"] .cds--masthead__megamenu__categories,\n.cds--masthead__megamenu__categories-section[data-child-count=\"1\"] .cds--masthead__megamenu__categories {\n  -moz-column-count: initial;\n       column-count: initial;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-right-navigation)[data-child-count=\"1\"] .cds--masthead__megamenu__categories,\n  .cds--masthead__megamenu__categories-section[data-child-count=\"1\"] .cds--masthead__megamenu__categories {\n    -moz-column-count: initial;\n         column-count: initial;\n  }\n}\n\n.cds--masthead__megamenu__heading span,\n:host(c4d-megamenu-heading) span {\n  display: block;\n  max-inline-size: calc(1 / var(--heading-description-column-count, 2) * 100%);\n}\n@media (min-width: 66rem) {\n  .cds--masthead__megamenu__heading span,\n  :host(c4d-megamenu-heading) span {\n    max-inline-size: calc(1 / var(--heading-description-column-count-lg, 4) * 100%);\n  }\n}\n\n.cds--masthead__megamenu__copy,\n:host(c4d-megamenu-category-group-copy) {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  margin: 0.375rem 1rem 0.625rem;\n  color: var(--cds-text-secondary, #525252);\n  max-inline-size: 17rem;\n}\n\n:host(c4d-megamenu-category-group),\n.cds--masthead__megamenu__category-group {\n  display: block;\n}\n:host(c4d-megamenu-category-group).only-child,\n.cds--masthead__megamenu__category-group.only-child {\n  /**\n   * Necessary to accommodate Safari issue with columns.\n   *\n   * Container height is calculated before breaking into specified number\n   * of columns, which causes extra blank whitespace beneath column content.\n   */\n}\n:host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-content-wrapper,\n.cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-content-wrapper {\n  display: inline;\n}\n:host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-heading,\n.cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-heading {\n  display: block;\n  flex: 0 0 50%;\n  max-inline-size: 50%;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-heading,\n  .cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-heading {\n    display: block;\n    flex: 0 0 33.3333333333%;\n    max-inline-size: 33.3333333333%;\n  }\n}\n:host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-content,\n.cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-content {\n  -moz-column-count: 2;\n       column-count: 2;\n  -moz-column-gap: 0;\n       column-gap: 0;\n}\n@media (min-width: 66rem) {\n  :host(c4d-megamenu-category-group).only-child .cds--masthead__megamenu__category-group-content,\n  .cds--masthead__megamenu__category-group.only-child .cds--masthead__megamenu__category-group-content {\n    -moz-column-count: 3;\n         column-count: 3;\n  }\n}\n:host(c4d-megamenu-category-group).only-child ::slotted(c4d-megamenu-category-link),\n.cds--masthead__megamenu__category-group.only-child ::slotted(c4d-megamenu-category-link) {\n  display: block;\n  -moz-column-break-inside: avoid;\n       break-inside: avoid;\n}\n:host(c4d-megamenu-category-group) .cds--masthead__megamenu__category-group-content-wrapper,\n.cds--masthead__megamenu__category-group .cds--masthead__megamenu__category-group-content-wrapper {\n  display: inline-block;\n  inline-size: 100%;\n  padding-block-end: 1.5rem;\n}\n:host(c4d-megamenu-category-group) .cds--masthead__megamenu__copy,\n:host(c4d-megamenu-category-group) ::slotted(c4d-megamenu-category-group-copy),\n.cds--masthead__megamenu__category-group .cds--masthead__megamenu__copy,\n.cds--masthead__megamenu__category-group ::slotted(c4d-megamenu-category-group-copy) {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  margin: -0.375rem 1rem 1.5rem;\n  color: var(--cds-text-secondary, #525252);\n}\n\n:host(c4d-megamenu-link-with-icon) span {\n  flex: inherit;\n}\n:host(c4d-megamenu-link-with-icon) ::slotted([slot=icon]) {\n  transform: none;\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /* !rtl:raw:\n  transform: scaleX(-1);\n  */\n}\n\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] {\n  inline-size: 100%;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] p,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] a,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] .cds--link-with-icon {\n  padding: 0.375rem 1rem;\n  inline-size: 100%;\n  margin-block-end: 1.5rem;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] p,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] a,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] .cds--link-with-icon,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] ::slotted(span),\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] span {\n  font-size: var(--cds-heading-03-font-size, 1.25rem);\n  font-weight: var(--cds-heading-03-font-weight, 400);\n  line-height: var(--cds-heading-03-line-height, 1.4);\n  letter-spacing: var(--cds-heading-03-letter-spacing, 0);\n  color: var(--cds-text-secondary, #525252);\n  text-decoration: none;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] ::slotted(span),\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] span {\n  flex: inherit;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] ::slotted(svg),\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline] svg {\n  fill: var(--cds-text-secondary, #525252);\n  min-inline-size: 1rem;\n}\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-headline]:visited, :host(c4d-megamenu-link-with-icon)[style-scheme=category-headline]:hover {\n  color: var(--cds-text-secondary, #525252);\n}\n\n:host(c4d-megamenu-category-link) a,\n.cds--masthead__megamenu__category-sublink {\n  font-size: var(--cds-body-short-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-short-01-font-weight, 400);\n  line-height: var(--cds-body-short-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-short-01-letter-spacing, 0.16px);\n  display: block;\n  padding: 0.375rem 1rem;\n  color: var(--cds-text-secondary, #525252);\n  text-decoration: none;\n}\n:host(c4d-megamenu-category-link) a:visited,\n.cds--masthead__megamenu__category-sublink:visited {\n  color: var(--cds-text-secondary, #525252);\n}\n:host(c4d-megamenu-category-link) a:hover, :host(c4d-megamenu-category-link) a:active, :host(c4d-megamenu-category-link) a:hover:visited,\n.cds--masthead__megamenu__category-sublink:hover,\n.cds--masthead__megamenu__category-sublink:active,\n.cds--masthead__megamenu__category-sublink:hover:visited {\n  color: var(--cds-text-primary, #161616);\n}\n\n.cds--masthead__megamenu__category-sublink--highlighted,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-sublink] {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  inline-size: 100%;\n}\n.cds--masthead__megamenu__category-sublink--highlighted a,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-sublink] a {\n  padding: 0.4375rem 1rem;\n  inline-size: 100%;\n}\n.cds--masthead__megamenu__category-sublink--highlighted span,\n:host(c4d-megamenu-link-with-icon)[style-scheme=category-sublink] span {\n  flex: inherit;\n}\n\n:host(c4d-megamenu-link-with-icon)[part*=view-all],\n.cds--masthead__megamenu__view-all-cta {\n  display: flex;\n  inline-size: 100%;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all][part*=view-all-left] [part=link],\n.cds--masthead__megamenu__view-all-cta[part*=view-all-left] [part=link] {\n  padding-inline-start: 1rem;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] [part=link],\n.cds--masthead__megamenu__view-all-cta [part=link] {\n  block-size: 3rem;\n  inline-size: 100%;\n  padding-inline: var(--c4d-view-all-padding, 2rem) 1rem;\n  text-decoration: none;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] [part=link]:hover,\n.cds--masthead__megamenu__view-all-cta [part=link]:hover {\n  color: var(--cds-link-primary-hover, #0043ce);\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] ::slotted(span),\n.cds--masthead__megamenu__view-all-cta ::slotted(span) {\n  align-self: center;\n  vertical-align: middle;\n}\n:host(c4d-megamenu-link-with-icon)[part*=view-all] span,\n.cds--masthead__megamenu__view-all-cta span {\n  font-size: var(--cds-body-compact-01-font-size, 0.875rem);\n  font-weight: var(--cds-body-compact-01-font-weight, 400);\n  line-height: var(--cds-body-compact-01-line-height, 1.28572);\n  letter-spacing: var(--cds-body-compact-01-letter-spacing, 0.16px);\n  flex: inherit;\n}\n\n:host(c4d-megamenu-category-link) a:focus, :host(c4d-megamenu-category-link) a:active,\n:host(c4d-megamenu-link-with-icon) a:focus,\n:host(c4d-megamenu-link-with-icon) a:active,\n.cds--masthead__megamenu__category-sublink--highlighted:focus,\n.cds--masthead__megamenu__category-sublink--highlighted:active,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:focus,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:active,\n.cds--masthead__megamenu__category-sublink:focus,\n.cds--masthead__megamenu__category-sublink:active {\n  outline: 1px solid var(--cds-focus, #0f62fe);\n  outline-offset: -0.125rem;\n  outline-width: 0.125rem;\n}\n@media screen and (prefers-contrast) {\n  :host(c4d-megamenu-category-link) a:focus, :host(c4d-megamenu-category-link) a:active,\n  :host(c4d-megamenu-link-with-icon) a:focus,\n  :host(c4d-megamenu-link-with-icon) a:active,\n  .cds--masthead__megamenu__category-sublink--highlighted:focus,\n  .cds--masthead__megamenu__category-sublink--highlighted:active,\n  .cds--masthead__megamenu__view-all-cta .cds--link-with-icon:focus,\n  .cds--masthead__megamenu__view-all-cta .cds--link-with-icon:active,\n  .cds--masthead__megamenu__category-sublink:focus,\n  .cds--masthead__megamenu__category-sublink:active {\n    outline-style: dotted;\n  }\n}\n:host(c4d-megamenu-category-link) a:active, :host(c4d-megamenu-category-link) a:hover,\n:host(c4d-megamenu-link-with-icon) a:active,\n:host(c4d-megamenu-link-with-icon) a:hover,\n.cds--masthead__megamenu__category-sublink--highlighted:active,\n.cds--masthead__megamenu__category-sublink--highlighted:hover,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:active,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon:hover,\n.cds--masthead__megamenu__category-sublink:active,\n.cds--masthead__megamenu__category-sublink:hover {\n  background-color: var(--cds-background-hover, rgba(141, 141, 141, 0.12));\n  text-decoration: none;\n}\n:host(c4d-megamenu-category-link) a svg,\n:host(c4d-megamenu-link-with-icon) a svg,\n.cds--masthead__megamenu__category-sublink--highlighted svg,\n.cds--masthead__megamenu__view-all-cta .cds--link-with-icon svg,\n.cds--masthead__megamenu__category-sublink svg {\n  transform: none;\n  /* stylelint-disable-next-line comment-whitespace-inside */\n  /* !rtl:raw:\n  transform: scaleX(-1);\n  */\n}\n\n.cds--body__lock-scroll {\n  position: relative;\n  overflow: hidden;\n}\n\n:host(c4d-dotcom-shell),\n.cds--dotcom-shell {\n  display: flex;\n  flex-direction: column;\n  inline-size: 100%;\n  padding-block-start: 3rem;\n}\n:host(c4d-dotcom-shell) .cds--tableofcontents__sidebar,\n.cds--dotcom-shell .cds--tableofcontents__sidebar {\n  inset-block-start: 3rem;\n}\n\n.cds--dotcom-shell__content {\n  flex: 1;\n  margin: auto;\n  inline-size: 100%;\n  max-inline-size: 99rem;\n}\n\n:host(c4d-dotcom-shell-container),\n:host(c4d-dotcom-shell-composite) {\n  display: contents;\n}"]);

let _$1 = t => t,
  _t$1;
function _decorate$2(e, r, t, i) { var o = _getDecoratorsApi$2(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$2(s.d.map(_createElementDescriptor$2)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$2() { _getDecoratorsApi$2 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$2(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$2(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$2(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$2(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$2(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$2(e) { var r, t = _toPropertyKey$2(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$2(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$2(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$2(o.descriptor) || _isDataDescriptor$2(i.descriptor)) { if (_hasDecorators$2(o) || _hasDecorators$2(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$2(o)) { if (_hasDecorators$2(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$2(o, i); } } else r.push(o); } return r; }
function _hasDecorators$2(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$2(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$2(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$2(t) { var i = _toPrimitive$2(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$2(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$2(r) { return _arrayWithHoles$2(r) || _iterableToArray$2(r) || _unsupportedIterableToArray$2(r) || _nonIterableRest$2(); }
function _nonIterableRest$2() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$2(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$2(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$2(r, a) : void 0; } }
function _arrayLikeToArray$2(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$2(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$2(r) { if (Array.isArray(r)) return r; }
const {
  prefix,
  stablePrefix: c4dPrefix$2
} = settings;

/**
 * Dotcom shell.
 *
 * @element c4d-dotcom-shell
 * @csspart content - The content. Usage: `c4d-dotcom-shell::part(content)`
 */
_decorate$2([carbonElement(`${c4dPrefix$2}-dotcom-shell`)], function (_initialize, _StableSelectorMixin) {
  class C4DDotcomShell extends _StableSelectorMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DDotcomShell,
    d: [{
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t$1 || (_t$1 = _$1`
      <div class="${0}--dotcom-shell__content" part="content">
        <slot></slot>
      </div>
    `), prefix);
      }
    }, {
      kind: "get",
      static: true,
      key: "stableSelector",
      value: function () {
        return `${c4dPrefix$2}--dotcom-shell`;
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, StableSelectorMixin(s));

let _ = t => t,
  _t;
function _decorate$1(e, r, t, i) { var o = _getDecoratorsApi$1(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements$1(s.d.map(_createElementDescriptor$1)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi$1() { _getDecoratorsApi$1 = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators$1(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray$1(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey$1(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty$1(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty$1(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor$1(e) { var r, t = _toPropertyKey$1(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter$1(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements$1(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor$1(o.descriptor) || _isDataDescriptor$1(i.descriptor)) { if (_hasDecorators$1(o) || _hasDecorators$1(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators$1(o)) { if (_hasDecorators$1(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter$1(o, i); } } else r.push(o); } return r; }
function _hasDecorators$1(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor$1(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty$1(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toPropertyKey$1(t) { var i = _toPrimitive$1(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive$1(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toArray$1(r) { return _arrayWithHoles$1(r) || _iterableToArray$1(r) || _unsupportedIterableToArray$1(r) || _nonIterableRest$1(); }
function _nonIterableRest$1() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray$1(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray$1(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$1(r, a) : void 0; } }
function _arrayLikeToArray$1(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray$1(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles$1(r) { if (Array.isArray(r)) return r; }
function _superPropGet(t, e, r, o) { var p = _get(_getPrototypeOf(1 & o ? t.prototype : t), e, r); return 2 & o ? function (t) { return p.apply(r, t); } : p; }
function _get() { return _get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, _get.apply(null, arguments); }
function _superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf(t));); return t; }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
const {
  stablePrefix: c4dPrefix$1
} = settings;

/**
 * Component that renders dotcom shell from links, etc. data.
 *
 * @element c4d-dotcom-shell-composite
 * @csspart shell - The root element of the dotcom shell. Usage: `c4d-dotcom-shell-composite::part(shell)`
 */
let C4DDotcomShellComposite = _decorate$1([carbonElement(`${c4dPrefix$1}-dotcom-shell-composite`)], function (_initialize, _LitElement) {
  class C4DDotcomShellComposite extends _LitElement {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DDotcomShellComposite,
    d: [{
      kind: "field",
      key: "_footerRenderRoot",
      value() {
        return null;
      }
    }, {
      kind: "field",
      key: "_mastheadRenderRoot",
      value() {
        return null;
      }
    }, {
      kind: "method",
      key: "_createFooterRenderRoot",
      value:
      /**
       * The render target of the footer contents.
       */

      /**
       * The render target of the masthead contents.
       */

      /**
       * The masthead element.
       */

      /**
       * @returns The render root of the footer contents.
       */
      function _createFooterRenderRoot() {
        var _this$parentNode;
        const footer = this.ownerDocument.createElement(`${c4dPrefix$1}-footer-composite`);
        (_this$parentNode = this.parentNode) === null || _this$parentNode === void 0 || _this$parentNode.insertBefore(footer, this.nextSibling);
        return footer;
      }

      /**
       * @returns The render root of the masthead contents.
       */
    }, {
      kind: "method",
      key: "_createMastheadRenderRoot",
      value: function _createMastheadRenderRoot() {
        var _this$parentNode2;
        const masthead = this.ownerDocument.createElement(`${c4dPrefix$1}-masthead-container`);
        (_this$parentNode2 = this.parentNode) === null || _this$parentNode2 === void 0 || _this$parentNode2.insertBefore(masthead, this);
        return masthead;
      }

      /**
       * The placeholder for `loadLocaleList()` Redux action that may be mixed in. This goes to footer.
       *
       * @internal
       */

      /**
       * The placeholder for `loadSearchResults()` Redux action that may be mixed in. This goes to masthead.
       *
       * @internal
       */

      /**
       * The placeholder for `loadTranslation()` Redux action that will be mixed in. This goes to masthead and footer.
       *
       * @internal
       */

      /**
       * The placeholder for `loadUserStatus()` Redux action that will be mixed in. This goes to masthead.
       *
       * @internal
       */

      /**
       * The placeholder for `setLanguage()` Redux action that will be mixed in. This goes to masthead.
       *
       * @internal
       */
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'has-profile'
      })],
      key: "hasProfile",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'has-search'
      })],
      key: "hasSearch",
      value() {
        return true;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'has-banner'
      })],
      key: "hasBanner",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'activate-search'
      })],
      key: "activateSearch",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "authenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'custom-typeahead-api',
        type: Boolean
      })],
      key: "customTypeaheadAPI",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'platform'
      })],
      key: "platform",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'platform-url'
      })],
      key: "platformUrl",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'clear-selection-label'
      })],
      key: "clearSelectionLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "collatorCountryName",
      value() {
        return new Intl.Collator();
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "currentSearchResults",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        attribute: 'disable-locale-button'
      })],
      key: "disableLocaleButton",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        type: Number,
        attribute: 'input-timeout'
      })],
      key: "inputTimeout",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "footerLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'lang-display'
      })],
      key: "langDisplay",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'language-selector-label'
      })],
      key: "languageSelectorLabel",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-language'
      })],
      key: "selectedLanguage",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "language",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "langList",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "legalLinks",
      value() {
        return [];
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "localeList",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'masthead-assistive-text'
      })],
      key: "mastheadAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-bar-assistive-text'
      })],
      key: "menuBarAssistiveText",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-button-assistive-text-active'
      })],
      key: "menuButtonAssistiveTextActive",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'menu-button-assistive-text-inactive'
      })],
      key: "menuButtonAssistiveTextInactive",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'selected-menu-item'
      })],
      key: "selectedMenuItem",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        reflect: true,
        attribute: 'footer-size'
      })],
      key: "footerSize",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        type: Boolean,
        reflect: true,
        attribute: 'open-search-dropdown'
      })],
      key: "openSearchDropdown",
      value() {
        return false;
      }
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "unauthenticatedProfileItems",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "l1Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "navLinks",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: false
      })],
      key: "l0Data",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "scopeParameters",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1()],
      key: "searchPlaceholder",
      value: void 0
    }, {
      kind: "field",
      decorators: [n$1({
        attribute: 'user-status'
      })],
      key: "userStatus",
      value() {
        return UNAUTHENTICATED_STATUS;
      }
    }, {
      kind: "method",
      key: "firstUpdated",
      value:
      /**
       * `true` if there is a profile.
       */
      /**
       * `true` if there is a search.
       */
      /**
       * `true` if there is a global banner.
       */
      /**
       * `true` to activate the search box. This goes to masthead.
       */
      /**
       * The profile items for authenticated state. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The boolean to enable custom typeahead API.
       */
      /**
       * The platform name. This goes to masthead.
       */
      /**
       * The platform url.
       */
      /**
       * The clear button label for language selector.
       *
       * @internal
       */
      /**
       * The g11n collator to use for sorting contry names. This goes to footer.
       */
      /**
       * The search results to show in the UI. This goes to masthead.
       * The data typically comes from our search service and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * `true` to omit the locale switcher button.
       */
      /**
       * The throttle timeout to run query upon user input. This goes to masthead.
       */
      /**
       * The footer links. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The language to show in the UI. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The placeholder label for language selector.
       *
       * @internal
       */
      /**
       * The initial selected language in the selector.
       *
       * @internal
       */
      /**
       * The language used for query. This goes to masthead and footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * Placeholder list of languages to populate language selector
       *
       * @internal
       */
      /**
       * The legal nav links. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The locale list. This goes to footer.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The `aria-label` attribute for the top-level container. This goes to masthead.
       */
      /**
       * The `aria-label` attribute for the menu bar UI. This goes to masthead.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state. This goes to masthead.
       */
      /**
       * The `aria-label` attribute for the header menu button in its active state. This goes to masthead.
       */
      /**
       * The English title of the selected nav item.
       */
      /**
       * Footer size. This goes to footer.
       */
      /**
       * `true` to open the search dropdown.. This goes to masthead.
       * The data typically comes from our search service and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The profile items for unauthenticated state. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * Data for l1.
       */
      /**
       * The navigation links. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       *
       * @deprecated Use l0Data instead.
       */
      /**
       * The navigation links. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      /**
       * The parameters passed to the search-with-typeahead for search scope
       */
      /**
       * Value to display when the input has an empty `value`.
       */
      /**
       * The user authentication status. This goes to masthead.
       * The data typically comes from `@carbon/ibmdotcom-services` and thus you don't need to set this property by default,
       * but if you need an alternate way of integration (e.g. rendering Web Components tags in server-side) this property helps.
       */
      // eslint-disable-next-line class-methods-use-this
      function firstUpdated() {
        globalInit();
      }
    }, {
      kind: "method",
      key: "update",
      value: function update(changedProperties) {
        _superPropGet(C4DDotcomShellComposite, "update", this, 3)([changedProperties]);
        if (!this._mastheadRenderRoot) {
          this._mastheadRenderRoot = this._createMastheadRenderRoot();
        }
        const {
          activateSearch,
          authenticatedProfileItems,
          platform,
          platformUrl,
          collatorCountryName,
          currentSearchResults,
          customTypeaheadAPI,
          clearSelectionLabel,
          disableLocaleButton,
          mastheadAssistiveText,
          menuBarAssistiveText,
          menuButtonAssistiveTextActive,
          menuButtonAssistiveTextInactive,
          unauthenticatedProfileItems,
          inputTimeout,
          l1Data,
          language,
          languageSelectorLabel,
          langDisplay,
          langList,
          legalLinks,
          localeList,
          footerLinks,
          footerSize,
          openSearchDropdown,
          navLinks,
          l0Data,
          hasProfile,
          hasSearch,
          searchPlaceholder,
          scopeParameters,
          selectedLanguage,
          selectedMenuItem,
          userStatus,
          _setLanguage,
          _loadLocaleList,
          _loadTranslation,
          _loadUserStatus,
          _loadSearchResults
        } = this;
        Object.assign(this._mastheadRenderRoot, pickBy({
          activateSearch,
          authenticatedProfileItems,
          platform,
          platformUrl,
          currentSearchResults,
          customTypeaheadAPI,
          mastheadAssistiveText,
          menuBarAssistiveText,
          menuButtonAssistiveTextActive,
          menuButtonAssistiveTextInactive,
          unauthenticatedProfileItems,
          inputTimeout,
          l1Data,
          language,
          navLinks,
          l0Data,
          hasProfile,
          hasSearch,
          searchPlaceholder,
          scopeParameters,
          openSearchDropdown,
          selectedMenuItem,
          userStatus,
          _loadSearchResults,
          _loadTranslation,
          _loadUserStatus,
          _setLanguage
        }, value => value !== undefined));
        if (!this._footerRenderRoot) {
          this._footerRenderRoot = this._createFooterRenderRoot();
        }
        Object.assign(this._footerRenderRoot, pickBy({
          clearSelectionLabel,
          collatorCountryName,
          disableLocaleButton,
          language,
          languageSelectorLabel,
          langDisplay,
          langList,
          legalLinks,
          links: footerLinks,
          localeList,
          selectedLanguage,
          size: footerSize,
          _loadLocaleList,
          _loadTranslation,
          _setLanguage
        }, value => value !== undefined));
      }
    }, {
      kind: "method",
      key: "updated",
      value: function updated(changedProperties) {
        _superPropGet(C4DDotcomShellComposite, "updated", this, 3)([changedProperties]);

        // moving global banner outside of dotcom shell if placed within
        if (this.querySelector(`${c4dPrefix$1}-global-banner`)) {
          var _this$ownerDocument$q;
          (_this$ownerDocument$q = this.ownerDocument.querySelector(`${c4dPrefix$1}-masthead-container`)) === null || _this$ownerDocument$q === void 0 || _this$ownerDocument$q.before(this.querySelector(`${c4dPrefix$1}-global-banner`));
        }
        if (this.ownerDocument.querySelector(`${c4dPrefix$1}-global-banner`)) {
          var _this$_masthead;
          this.hasBanner = true;
          (_this$_masthead = this._masthead) === null || _this$_masthead === void 0 || _this$_masthead.setAttribute('with-banner', '');
        }
      }
    }, {
      kind: "method",
      key: "render",
      value: function render() {
        return x(_t || (_t = _`
      <c4d-dotcom-shell part="shell">
        <slot></slot>
      </c4d-dotcom-shell>
    `));
      }
    }, {
      kind: "field",
      static: true,
      key: "styles",
      value() {
        return styles;
      }
    }]
  };
}, s);

function _decorate(e, r, t, i) { var o = _getDecoratorsApi(); if (i) for (var n = 0; n < i.length; n++) o = i[n](o); var s = r(function (e) { o.initializeInstanceElements(e, a.elements); }, t), a = o.decorateClass(_coalesceClassElements(s.d.map(_createElementDescriptor)), e); return o.initializeClassElements(s.F, a.elements), o.runClassFinishers(s.F, a.finishers); }
function _getDecoratorsApi() { _getDecoratorsApi = function () { return e; }; var e = { elementsDefinitionOrder: [["method"], ["field"]], initializeInstanceElements: function (e, r) { ["method", "field"].forEach(function (t) { r.forEach(function (r) { r.kind === t && "own" === r.placement && this.defineClassElement(e, r); }, this); }, this); }, initializeClassElements: function (e, r) { var t = e.prototype; ["method", "field"].forEach(function (i) { r.forEach(function (r) { var o = r.placement; if (r.kind === i && ("static" === o || "prototype" === o)) { var n = "static" === o ? e : t; this.defineClassElement(n, r); } }, this); }, this); }, defineClassElement: function (e, r) { var t = r.descriptor; if ("field" === r.kind) { var i = r.initializer; t = { enumerable: t.enumerable, writable: t.writable, configurable: t.configurable, value: void 0 === i ? void 0 : i.call(e) }; } Object.defineProperty(e, r.key, t); }, decorateClass: function (e, r) { var t = [], i = [], o = { static: [], prototype: [], own: [] }; if (e.forEach(function (e) { this.addElementPlacement(e, o); }, this), e.forEach(function (e) { if (!_hasDecorators(e)) return t.push(e); var r = this.decorateElement(e, o); t.push(r.element), t.push.apply(t, r.extras), i.push.apply(i, r.finishers); }, this), !r) return { elements: t, finishers: i }; var n = this.decorateConstructor(t, r); return i.push.apply(i, n.finishers), n.finishers = i, n; }, addElementPlacement: function (e, r, t) { var i = r[e.placement]; if (!t && -1 !== i.indexOf(e.key)) throw new TypeError("Duplicated element (" + e.key + ")"); i.push(e.key); }, decorateElement: function (e, r) { for (var t = [], i = [], o = e.decorators, n = o.length - 1; n >= 0; n--) { var s = r[e.placement]; s.splice(s.indexOf(e.key), 1); var a = this.fromElementDescriptor(e), l = this.toElementFinisherExtras((0, o[n])(a) || a); e = l.element, this.addElementPlacement(e, r), l.finisher && i.push(l.finisher); var c = l.extras; if (c) { for (var p = 0; p < c.length; p++) this.addElementPlacement(c[p], r); t.push.apply(t, c); } } return { element: e, finishers: i, extras: t }; }, decorateConstructor: function (e, r) { for (var t = [], i = r.length - 1; i >= 0; i--) { var o = this.fromClassDescriptor(e), n = this.toClassDescriptor((0, r[i])(o) || o); if (void 0 !== n.finisher && t.push(n.finisher), void 0 !== n.elements) { e = n.elements; for (var s = 0; s < e.length - 1; s++) for (var a = s + 1; a < e.length; a++) if (e[s].key === e[a].key && e[s].placement === e[a].placement) throw new TypeError("Duplicated element (" + e[s].key + ")"); } } return { elements: e, finishers: t }; }, fromElementDescriptor: function (e) { var r = { kind: e.kind, key: e.key, placement: e.placement, descriptor: e.descriptor }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), "field" === e.kind && (r.initializer = e.initializer), r; }, toElementDescriptors: function (e) { if (void 0 !== e) return _toArray(e).map(function (e) { var r = this.toElementDescriptor(e); return this.disallowProperty(e, "finisher", "An element descriptor"), this.disallowProperty(e, "extras", "An element descriptor"), r; }, this); }, toElementDescriptor: function (e) { var r = e.kind + ""; if ("method" !== r && "field" !== r) throw new TypeError('An element descriptor\'s .kind property must be either "method" or "field", but a decorator created an element descriptor with .kind "' + r + '"'); var t = _toPropertyKey(e.key), i = e.placement + ""; if ("static" !== i && "prototype" !== i && "own" !== i) throw new TypeError('An element descriptor\'s .placement property must be one of "static", "prototype" or "own", but a decorator created an element descriptor with .placement "' + i + '"'); var o = e.descriptor; this.disallowProperty(e, "elements", "An element descriptor"); var n = { kind: r, key: t, placement: i, descriptor: Object.assign({}, o) }; return "field" !== r ? this.disallowProperty(e, "initializer", "A method descriptor") : (this.disallowProperty(o, "get", "The property descriptor of a field descriptor"), this.disallowProperty(o, "set", "The property descriptor of a field descriptor"), this.disallowProperty(o, "value", "The property descriptor of a field descriptor"), n.initializer = e.initializer), n; }, toElementFinisherExtras: function (e) { return { element: this.toElementDescriptor(e), finisher: _optionalCallableProperty(e, "finisher"), extras: this.toElementDescriptors(e.extras) }; }, fromClassDescriptor: function (e) { var r = { kind: "class", elements: e.map(this.fromElementDescriptor, this) }; return Object.defineProperty(r, Symbol.toStringTag, { value: "Descriptor", configurable: !0 }), r; }, toClassDescriptor: function (e) { var r = e.kind + ""; if ("class" !== r) throw new TypeError('A class descriptor\'s .kind property must be "class", but a decorator created a class descriptor with .kind "' + r + '"'); this.disallowProperty(e, "key", "A class descriptor"), this.disallowProperty(e, "placement", "A class descriptor"), this.disallowProperty(e, "descriptor", "A class descriptor"), this.disallowProperty(e, "initializer", "A class descriptor"), this.disallowProperty(e, "extras", "A class descriptor"); var t = _optionalCallableProperty(e, "finisher"); return { elements: this.toElementDescriptors(e.elements), finisher: t }; }, runClassFinishers: function (e, r) { for (var t = 0; t < r.length; t++) { var i = (0, r[t])(e); if (void 0 !== i) { if ("function" != typeof i) throw new TypeError("Finishers must return a constructor."); e = i; } } return e; }, disallowProperty: function (e, r, t) { if (void 0 !== e[r]) throw new TypeError(t + " can't have a ." + r + " property."); } }; return e; }
function _createElementDescriptor(e) { var r, t = _toPropertyKey(e.key); "method" === e.kind ? r = { value: e.value, writable: !0, configurable: !0, enumerable: !1 } : "get" === e.kind ? r = { get: e.value, configurable: !0, enumerable: !1 } : "set" === e.kind ? r = { set: e.value, configurable: !0, enumerable: !1 } : "field" === e.kind && (r = { configurable: !0, writable: !0, enumerable: !0 }); var i = { kind: "field" === e.kind ? "field" : "method", key: t, placement: e.static ? "static" : "field" === e.kind ? "own" : "prototype", descriptor: r }; return e.decorators && (i.decorators = e.decorators), "field" === e.kind && (i.initializer = e.value), i; }
function _coalesceGetterSetter(e, r) { void 0 !== e.descriptor.get ? r.descriptor.get = e.descriptor.get : r.descriptor.set = e.descriptor.set; }
function _coalesceClassElements(e) { for (var r = [], isSameElement = function isSameElement(e) { return "method" === e.kind && e.key === o.key && e.placement === o.placement; }, t = 0; t < e.length; t++) { var i, o = e[t]; if ("method" === o.kind && (i = r.find(isSameElement))) { if (_isDataDescriptor(o.descriptor) || _isDataDescriptor(i.descriptor)) { if (_hasDecorators(o) || _hasDecorators(i)) throw new ReferenceError("Duplicated methods (" + o.key + ") can't be decorated."); i.descriptor = o.descriptor; } else { if (_hasDecorators(o)) { if (_hasDecorators(i)) throw new ReferenceError("Decorators can't be placed on different accessors with for the same property (" + o.key + ")."); i.decorators = o.decorators; } _coalesceGetterSetter(o, i); } } else r.push(o); } return r; }
function _hasDecorators(e) { return e.decorators && e.decorators.length; }
function _isDataDescriptor(e) { return void 0 !== e && !(void 0 === e.value && void 0 === e.writable); }
function _optionalCallableProperty(e, r) { var t = e[r]; if (void 0 !== t && "function" != typeof t) throw new TypeError("Expected '" + r + "' to be a function"); return t; }
function _toArray(r) { return _arrayWithHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
const {
  stablePrefix: c4dPrefix
} = settings;

/**
 * The Redux state used for `<c4d-dotcom-shell-container>`.
 */

/**
 * The properties for `<c4d-dotcom-shell-container>` from Redux state.
 */

/**
 * The Redux actions used for `<c4d-dotcom-shell-container>`.
 */

/**
 * @param state The Redux state for dotcom shell.
 * @returns The converted version of the given state, tailored for `<c4d-dotcomshell-container>`.
 */
function mapStateToProps(state, self) {
  const footerProps = mapStateToProps$2(state);
  return _objectSpread(_objectSpread({}, mapStateToProps$1(state, self)), Object.keys(footerProps).reduce((acc, key) => {
    acc[key !== 'links' ? key : 'footerLinks'] = footerProps[key];
    return acc;
  }, {}));
}

/**
 * @param dispatch The Redux `dispatch()` API.
 * @returns The methods in `<c4d-dotcomshell-container>` to dispatch Redux actions.
 */
function mapDispatchToProps(dispatch) {
  return _objectSpread(_objectSpread({}, mapDispatchToProps$1(dispatch)), mapDispatchToProps$2(dispatch));
}

/**
 * Container component for dotcom shell.
 *
 * @element c4d-dotcom-shell-container
 */
_decorate([carbonElement(`${c4dPrefix}-dotcom-shell-container`)], function (_initialize, _ConnectMixin) {
  class C4DDotcomShellContainer extends _ConnectMixin {
    constructor(...args) {
      super(...args);
      _initialize(this);
    }
  }
  return {
    F: C4DDotcomShellContainer,
    d: []
  };
}, ConnectMixin(store, mapStateToProps, mapDispatchToProps)(C4DDotcomShellComposite));

export { selectorTabbable as A, styles$3 as B, C4DMegaMenuRightNavigation as C, svgResultCarbonIcon$h as D, svgResultCarbonIcon$i as E, FocusMixin as F, t$2 as G, HostListenerMixin as H, TABS_TYPE as T, _decorate$Z as _, settings as a, b, carbonElement as c, spread as d, CDSLink as e, C4DMegaMenu as f, s as g, C4DMegaMenuHeading as h, ifNonEmpty as i, svgResultCarbonIcon$B as j, svgResultCarbonIcon$D as k, _objectSpread2 as l, styles$7 as m, n$1 as n, l as o, prefix$B as p, o$2 as q, styles$6 as r, styles$8 as s, _get$h as t, _getPrototypeOf$h as u, svgResultCarbonIcon$H as v, HostListener as w, x, C4DLeftNav as y, svgResultCarbonIcon$f as z };
